/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/buffer","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","fs/promises","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],I=0,A=se.length;I<A;I++)e[I]=le[se[I]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const N=new Map,j=new Map,D=new Map,R=new Map;function P(u,f){u.has(f.detail)||u.set(f.detail,-f.timestamp)}function d(u,f){const b=u.get(f.detail);b&&(b>=0||u.set(f.detail,b+f.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((u,f)=>u.timestamp-f.timestamp));for(const u of C)switch(u.type){case 10:P(N,u);break;case 11:case 12:d(N,u);break;case 21:P(j,u);break;case 22:d(j,u);break;case 33:P(D,u);break;case 34:d(D,u);break;case 31:P(R,u);break;case 32:d(R,u);break}let v=0;D.forEach(u=>v+=u);function w(u){const f=[];return u.forEach((b,m)=>f.push([m,b])),f}return{amdLoad:w(N),amdInvoke:w(j),nodeRequire:w(D),nodeEval:w(R),nodeRequireTotal:v}}static toMarkdownTable(N,j){let D="";const R=[];return N.forEach((P,d)=>{R[d]=P.length}),j.forEach(P=>{P.forEach((d,C)=>{typeof d>"u"&&(d=P[C]="-");const v=d.toString().length;R[C]=Math.max(v,R[C])})}),N.forEach((P,d)=>{D+=`| ${P+" ".repeat(R[d]-P.toString().length)} `}),D+=`|
`,N.forEach((P,d)=>{D+=`| ${"-".repeat(R[d])} `}),D+=`|
`,j.forEach(P=>{P.forEach((d,C)=>{typeof d<"u"&&(D+=`| ${d+" ".repeat(R[C]-d.toString().length)} `)}),D+=`|
`}),D}}e.$U=I}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=I,e.$gb=A,e.$hb=N,e.$ib=j,e.$jb=D,e.$kb=R,e.$lb=P,e.$nb=C,e.$ob=v,e.$pb=w,e.$qb=u,e.$rb=f;function I(b,m,h){const g=A(b,m);if(g!==-1)return b[g]}function A(b,m,h=b.length-1){for(let g=h;g>=0;g--){const l=b[g];if(m(l))return g}return-1}function N(b,m){const h=j(b,m);return h===-1?void 0:b[h]}function j(b,m,h=0,g=b.length){let l=h,c=g;for(;l<c;){const $=Math.floor((l+c)/2);m(b[$])?l=$+1:c=$}return l-1}function D(b,m){const h=R(b,m);return h===b.length?void 0:b[h]}function R(b,m,h=0,g=b.length){let l=h,c=g;for(;l<c;){const $=Math.floor((l+c)/2);m(b[$])?c=$:l=$+1}return l}function P(b,m,h=0,g=b.length){const l=R(b,m,h,g);return l===b.length?-1:l}class d{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(d.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!m(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const h=j(this.e,m,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=d;function C(b,m){if(b.length===0)return;let h=b[0];for(let g=1;g<b.length;g++){const l=b[g];m(l,h)>0&&(h=l)}return h}function v(b,m){if(b.length===0)return;let h=b[0];for(let g=1;g<b.length;g++){const l=b[g];m(l,h)>=0&&(h=l)}return h}function w(b,m){return C(b,(h,g)=>-m(h,g))}function u(b,m){if(b.length===0)return-1;let h=0;for(let g=1;g<b.length;g++){const l=b[g];m(l,b[h])>0&&(h=g)}return h}function f(b,m){for(const h of b){const g=m(h);if(g!==void 0)return g}}}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=I,e.$L=A,e.$M=N,e.$N=j;function I(D,R){const P=Object.create(null);for(const d of D){const C=R(d);let v=P[C];v||(v=P[C]=[]),v.push(d)}return P}function A(D,R){const P=[],d=[];for(const C of D)R.has(C)||P.push(C);for(const C of R)D.has(C)||d.push(C);return{removed:P,added:d}}function N(D,R){const P=[],d=[];for(const[C,v]of D)R.has(C)||P.push(v);for(const[C,v]of R)D.has(C)||d.push(v);return{removed:P,added:d}}function j(D,R){const P=new Set;for(const d of R)D.has(d)&&P.add(d);return P}}),define(le[84],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=A,e.$Mh=N,e.$Nh=j;function I(D){return(R,P,d)=>{let C=null,v=null;if(typeof d.value=="function"?(C="value",v=d.value):typeof d.get=="function"&&(C="get",v=d.get),!v)throw new Error("not supported");d[C]=D(v,P)}}function A(D,R,P){let d=null,C=null;if(typeof P.value=="function"?(d="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(d="get",C=P.get),!C)throw new Error("not supported");const v=`$memoize$${R}`;P[d]=function(...w){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[v]}}function N(D,R,P){return I((d,C)=>{const v=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...u){this[w]||(this[w]=P?P():void 0),clearTimeout(this[v]),R&&(this[w]=R(this[w],...u),u=[this[w]]),this[v]=setTimeout(()=>{d.apply(this,u),this[w]=P?P():void 0},D)}})}function j(D,R,P){return I((d,C)=>{const v=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,u=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...b){if(this[w]||(this[w]=P?P():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...b)),this[f])return;const m=this[u]+D;m<=Date.now()?(this[u]=Date.now(),d.apply(this,[this[w]]),this[w]=P?P():void 0):(this[f]=!0,this[v]=setTimeout(()=>{this[f]=!1,this[u]=Date.now(),d.apply(this,[this[w]]),this[w]=P?P():void 0},m-Date.now()))}})}}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=A,e.$Z=N,e.$1=j,e.$2=D,e.$3=R,e.$4=d,e.$6=v,e.$7=w,e.$8=u,e.$0=b;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=I,e.$X=new I;function A($){e.$X.setUnexpectedErrorHandler($)}function N($){if(!$||typeof $!="object")return!1;const i=$;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function j($){d($)||e.$X.onUnexpectedError($)}function D($){d($)||e.$X.onUnexpectedExternalError($)}function R($){if($ instanceof Error){const{name:i,message:o}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:l.isErrorNoTelemetry($)}}return $}const P="Canceled";function d($){return $ instanceof C?!0:$ instanceof Error&&$.name===P&&$.message===P}class C extends Error{constructor(){super(P),this.name=this.message}}e.$5=C;function v(){const $=new Error(P);return $.name=$.message,$}function w($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function u($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class f extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=f;function b($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=m;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const o=new l;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=N,e.$tb=j,e.$ub=D,e.$vb=R,e.$wb=P,e.$xb=d,e.$yb=C,e.$zb=v,e.$Ab=w,e.$Bb=u,e.$Cb=f,e.$Db=b,e.$Eb=m,e.top=h,e.$Gb=g,e.$Hb=c,e.$Ib=$,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=y,e.$Rb=E,e.$Sb=k,e.$Tb=S,e.$Ub=p,e.$Vb=O,e.$Wb=U,e.$Xb=F,e.$Yb=M,e.$Zb=x,e.$1b=J,e.$2b=Z,e.$3b=W,e.$4b=K,e.$5b=V,e.$6b=B,e.$7b=te,e.$8b=ce,e.$$b=L;function N(G,ee=0){return G[G.length-(1+ee)]}function j(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}function D(G,ee,_=(X,ne)=>X===ne){if(G===ee)return!0;if(!G||!ee||G.length!==ee.length)return!1;for(let X=0,ne=G.length;X<ne;X++)if(!_(G[X],ee[X]))return!1;return!0}function R(G,ee){const _=G.length-1;ee<_&&(G[ee]=G[_]),G.pop()}function P(G,ee,_){return d(G.length,X=>_(G[X],ee))}function d(G,ee){let _=0,X=G-1;for(;_<=X;){const ne=(_+X)/2|0,re=ee(ne);if(re<0)_=ne+1;else if(re>0)X=ne-1;else return ne}return-(_+1)}function C(G,ee,_){if(G=G|0,G>=ee.length)throw new TypeError("invalid index");const X=ee[Math.floor(ee.length*Math.random())],ne=[],re=[],ue=[];for(const de of ee){const $e=_(de,X);$e<0?ne.push(de):$e>0?re.push(de):ue.push(de)}return G<ne.length?C(G,ne,_):G<ne.length+ue.length?ue[0]:C(G-(ne.length+ue.length),re,_)}function v(G,ee){const _=[];let X;for(const ne of G.slice(0).sort(ee))!X||ee(X[0],ne)!==0?(X=[ne],_.push(X)):X.push(ne);return _}function*w(G,ee){let _,X;for(const ne of G)X!==void 0&&ee(X,ne)?_.push(ne):(_&&(yield _),_=[ne]),X=ne;_&&(yield _)}function u(G,ee){for(let _=0;_<=G.length;_++)ee(_===0?void 0:G[_-1],_===G.length?void 0:G[_])}function f(G,ee){for(let _=0;_<G.length;_++)ee(_===0?void 0:G[_-1],G[_],_+1===G.length?void 0:G[_+1])}function b(G,ee,_){const X=[];function ne(de,$e,ye){if($e===0&&ye.length===0)return;const Se=X[X.length-1];Se&&Se.start+Se.deleteCount===de?(Se.deleteCount+=$e,Se.toInsert.push(...ye)):X.push({start:de,deleteCount:$e,toInsert:ye})}let re=0,ue=0;for(;;){if(re===G.length){ne(re,0,ee.slice(ue));break}if(ue===ee.length){ne(re,G.length-re,[]);break}const de=G[re],$e=ee[ue],ye=_(de,$e);ye===0?(re+=1,ue+=1):ye<0?(ne(re,1,[]),re+=1):ye>0&&(ne(re,0,[$e]),ue+=1)}return X}function m(G,ee,_){const X=b(G,ee,_),ne=[],re=[];for(const ue of X)ne.push(...G.slice(ue.start,ue.start+ue.deleteCount)),re.push(...ue.toInsert);return{removed:ne,added:re}}function h(G,ee,_){if(_===0)return[];const X=G.slice(0,_).sort(ee);return l(G,ee,X,_,G.length),X}function g(G,ee,_,X,ne){return _===0?Promise.resolve([]):new Promise((re,ue)=>{(async()=>{const de=G.length,$e=G.slice(0,_).sort(ee);for(let ye=_,Se=Math.min(_+X,de);ye<de;ye=Se,Se=Math.min(Se+X,de)){if(ye>_&&await new Promise(Ie=>setTimeout(Ie)),ne&&ne.isCancellationRequested)throw new I.$5;l(G,ee,$e,ye,Se)}return $e})().then(re,ue)})}function l(G,ee,_,X,ne){for(const re=_.length;X<ne;X++){const ue=G[X];if(ee(ue,_[re-1])<0){_.pop();const de=(0,A.$kb)(_,$e=>ee(ue,$e)<0);_.splice(de,0,ue)}}}function c(G){return G.filter(ee=>!!ee)}function $(G){let ee=0;for(let _=0;_<G.length;_++)G[_]&&(G[ee]=G[_],ee+=1);G.length=ee}function i(G,ee,_){G.splice(_,0,G.splice(ee,1)[0])}function o(G){return!Array.isArray(G)||G.length===0}function n(G){return Array.isArray(G)&&G.length>0}function s(G,ee=_=>_){const _=new Set;return G.filter(X=>{const ne=ee(X);return _.has(ne)?!1:(_.add(ne),!0)})}function t(G){const ee=new Set;return _=>{const X=G(_);return ee.has(X)?!1:(ee.add(X),!0)}}function r(G,ee){return G.length>0?G[0]:ee}function a(G,ee){return G.length>0?G[G.length-1]:ee}function y(G,ee,_=(X,ne)=>X===ne){let X=0;for(let ne=0,re=Math.min(G.length,ee.length);ne<re&&_(G[ne],ee[ne]);ne++)X++;return X}function E(G){return[].concat(...G)}function k(G,ee){let _=typeof ee=="number"?G:0;typeof ee=="number"?_=G:(_=0,ee=G);const X=[];if(_<=ee)for(let ne=_;ne<ee;ne++)X.push(ne);else for(let ne=_;ne>ee;ne--)X.push(ne);return X}function S(G,ee,_){return G.reduce((X,ne)=>(X[ee(ne)]=_?_(ne):ne,X),Object.create(null))}function p(G,ee){return G.push(ee),()=>O(G,ee)}function O(G,ee){const _=G.indexOf(ee);if(_>-1)return G.splice(_,1),ee}function U(G,ee,_){const X=G.slice(0,ee),ne=G.slice(ee);return X.concat(_,ne)}function F(G,ee){let _;if(typeof ee=="number"){let X=ee;_=()=>{const ne=Math.sin(X++)*179426549;return ne-Math.floor(ne)}}else _=Math.random;for(let X=G.length-1;X>0;X-=1){const ne=Math.floor(_()*(X+1)),re=G[X];G[X]=G[ne],G[ne]=re}}function M(G,ee){const _=G.indexOf(ee);_>-1&&(G.splice(_,1),G.unshift(ee))}function x(G,ee){const _=G.indexOf(ee);_>-1&&(G.splice(_,1),G.push(ee))}function J(G,ee){for(const _ of ee)G.push(_)}function Z(G,ee){return Array.isArray(G)?G.map(ee):ee(G)}function W(G){return Array.isArray(G)?G:[G]}function K(G){return G[Math.floor(Math.random()*G.length)]}function V(G,ee,_){const X=ie(G,ee),ne=G.length,re=_.length;G.length=ne+re;for(let ue=ne-1;ue>=X;ue--)G[ue+re]=G[ue];for(let ue=0;ue<re;ue++)G[ue+X]=_[ue]}function B(G,ee,_,X){const ne=ie(G,ee);let re=G.splice(ne,_);return re===void 0&&(re=[]),V(G,ne,X),re}function ie(G,ee){return ee<0?Math.max(ee+G.length,0):Math.min(ee,G.length)}var oe;(function(G){function ee(re){return re<0}G.isLessThan=ee;function _(re){return re<=0}G.isLessThanOrEqual=_;function X(re){return re>0}G.isGreaterThan=X;function ne(re){return re===0}G.isNeitherLessOrGreaterThan=ne,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function te(G,ee){return(_,X)=>ee(G(_),G(X))}function ce(...G){return(ee,_)=>{for(const X of G){const ne=X(ee,_);if(!oe.isNeitherLessOrGreaterThan(ne))return ne}return oe.neitherLessOrGreaterThan}}const H=(G,ee)=>G-ee;e.$9b=H;const q=(G,ee)=>(0,e.$9b)(G?1:0,ee?1:0);e.$0b=q;function L(G){return(ee,_)=>-G(ee,_)}class T{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const X=_===this.c?null:this.g.slice(this.c,_);return this.c=_,X}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const X=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=T;class z{static{this.empty=new z(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new z(_=>this.iterate(X=>ee(X)?_(X):!0))}map(ee){return new z(_=>this.iterate(X=>_(ee(X))))}some(ee){let _=!1;return this.iterate(X=>(_=ee(X),!_)),_}findFirst(ee){let _;return this.iterate(X=>ee(X)?(_=X,!1):!0),_}findLast(ee){let _;return this.iterate(X=>(ee(X)&&(_=X),!0)),_}findLastMaxBy(ee){let _,X=!0;return this.iterate(ne=>((X||oe.isGreaterThan(ee(ne,_)))&&(X=!1,_=ne),!0)),_}}e.$ac=z;class Y{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const X=Array.from(ee.keys()).sort((ne,re)=>_(ee[ne],ee[re]));return new Y(X)}apply(ee){return ee.map((_,X)=>ee[this.c[X]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new Y(ee)}}e.$bc=Y}),define(le[127],he([0,1,7]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=A,e.$0c=N,e.$$c=j,e.$_c=D,e.$ad=R,e.$bd=P;function A(d,C){if(!d)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function N(d,C="Unreachable"){throw new Error(C)}function j(d){if(!d)throw new I.$cb("Assertion Failed")}function D(d){d||(0,I.$1)(new I.$cb("Soft Assertion Failed"))}function R(d){if(!d()){debugger;d(),(0,I.$1)(new I.$cb("Assertion Failed"))}}function P(d,C){let v=0;for(;v<d.length-1;){const w=d[v],u=d[v+1];if(!C(w,u))return!1;v++}return!0}}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=I;function I(A,N){const j=this;let D=!1,R;return function(){if(D)return R;if(D=!0,N)try{R=A.apply(j,arguments)}finally{N()}else R=A.apply(j,arguments);return R}}}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(A){function N(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=N;const j=Object.freeze([]);function D(){return j}A.empty=D;function*R(i){yield i}A.single=R;function P(i){return N(i)?i:R(i)}A.wrap=P;function d(i){return i||j}A.from=d;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}A.reverse=C;function v(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=v;function w(i){return i[Symbol.iterator]().next().value}A.first=w;function u(i,o){for(const n of i)if(o(n))return!0;return!1}A.some=u;function f(i,o){for(const n of i)if(o(n))return n}A.find=f;function*b(i,o){for(const n of i)o(n)&&(yield n)}A.filter=b;function*m(i,o){let n=0;for(const s of i)yield o(s,n++)}A.map=m;function*h(...i){for(const o of i)yield*o}A.concat=h;function g(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}A.reduce=g;function*l(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}A.slice=l;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,A.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}A.consume=c;async function $(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}A.asyncToArray=$})(I||(e.Iterable=I={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=D,e.$tn=v,e.$un=w,e.$vn=u,e.$wn=f,e.$xn=b,e.$yn=m,e.$zn=h,e.$An=g,e.$Bn=l,e.$Cn=c,e.$Dn=$;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var N;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var j;(function(i){i.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function D(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,y=0;function E(M){let x=0,J=0;for(;x<M;){const Z=i.charCodeAt(n);if(Z>=48&&Z<=57)J=J*16+Z-48;else if(Z>=65&&Z<=70)J=J*16+Z-65+10;else if(Z>=97&&Z<=102)J=J*16+Z-97+10;else break;n++,x++}return x<M&&(J=-1),J}function k(M){n=M,t="",r=0,a=16,y=0}function S(){const M=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&d(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&d(i.charCodeAt(n)))for(n++;n<i.length&&d(i.charCodeAt(n));)n++;else return y=3,i.substring(M,n);let x=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&d(i.charCodeAt(n))){for(n++;n<i.length&&d(i.charCodeAt(n));)n++;x=n}else y=3;return i.substring(M,x)}function p(){let M="",x=n;for(;;){if(n>=s){M+=i.substring(x,n),y=2;break}const J=i.charCodeAt(n);if(J===34){M+=i.substring(x,n),n++;break}if(J===92){if(M+=i.substring(x,n),n++,n>=s){y=2;break}switch(i.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const W=E(4);W>=0?M+=String.fromCharCode(W):y=4;break}default:y=5}x=n;continue}if(J>=0&&J<=31)if(P(J)){M+=i.substring(x,n),y=2;break}else y=6;n++}return M}function O(){if(t="",y=0,r=n,n>=s)return r=s,a=17;let M=i.charCodeAt(n);if(R(M)){do n++,t+=String.fromCharCode(M),M=i.charCodeAt(n);while(R(M));return a=15}if(P(M))return n++,t+=String.fromCharCode(M),M===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(M){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=p(),a=10;case 47:{const x=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(i.charCodeAt(n));)n++;return t=i.substring(x,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const J=s-1;let Z=!1;for(;n<J;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Z=!0;break}n++}return Z||(n++,y=1),t=i.substring(x,n),a=13}return t+=String.fromCharCode(M),n++,a=16}case 45:if(t+=String.fromCharCode(M),n++,n===s||!d(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=S(),a=11;default:for(;n<s&&U(M);)n++,M=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(M),n++,a=16}}function U(M){if(R(M)||P(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:k,getPosition:()=>n,scan:o?F:O,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>y}}function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function d(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function v(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(E,k,S,p){r.value=E,r.offset=k,r.length=S,r.type=p,r.colonOffset=void 0,t=r}try{l(i,{onObjectBegin:(E,k)=>{if(o<=E)throw s;t=void 0,a=o>E,n.push("")},onObjectProperty:(E,k,S)=>{if(o<k||(y(E,k,S,"property"),n[n.length-1]=E,o<=k+S))throw s},onObjectEnd:(E,k)=>{if(o<=E)throw s;t=void 0,n.pop()},onArrayBegin:(E,k)=>{if(o<=E)throw s;t=void 0,n.push(0)},onArrayEnd:(E,k)=>{if(o<=E)throw s;t=void 0,n.pop()},onLiteralValue:(E,k,S)=>{if(o<k||(y(E,k,S,$(E)),o<=k+S))throw s},onSeparator:(E,k,S)=>{if(o<=k)throw s;if(E===":"&&t&&t.type==="property")t.colonOffset=k,a=!1,t=void 0;else if(E===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(E){if(E!==s)throw E}return{path:n,previousNode:t,isAtPropertyKey:a,matches:E=>{let k=0;for(let S=0;k<E.length&&S<n.length;S++)if(E[k]===n[S]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}function w(i,o=[],n=j.DEFAULT){let s=null,t=[];const r=[];function a(E){Array.isArray(t)?t.push(E):s!==null&&(t[s]=E)}return l(i,{onObjectBegin:()=>{const E={};a(E),r.push(t),t=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const E=[];a(E),r.push(t),t=E,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(E,k,S)=>{o.push({error:E,offset:k,length:S})}},n),t[0]}function u(i,o=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function r(E){return s.children.push(E),E}l(i,{onObjectBegin:E=>{s=r({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,k,S)=>{s=r({type:"property",offset:k,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:k,length:S,parent:s})},onObjectEnd:(E,k)=>{s.length=E+k-s.offset,s=s.parent,t(E+k)},onArrayBegin:(E,k)=>{s=r({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,k)=>{s.length=E+k-s.offset,s=s.parent,t(E+k)},onLiteralValue:(E,k,S)=>{r({type:$(E),offset:k,length:S,parent:s,value:E}),t(k+S)},onSeparator:(E,k,S)=>{s.type==="property"&&(E===":"?s.colonOffset=k:E===","&&t(k))},onError:(E,k,S)=>{o.push({error:E,offset:k,length:S})}},n);const y=s.children[0];return y&&delete y.parent,y}function f(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=m(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function h(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function g(i,o,n=!1){if(h(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=g(s[t],o,n);if(r)return r}return i}}function l(i,o,n=j.DEFAULT){const s=D(i,!1);function t(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(te){return te?ce=>te(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),y=r(o.onObjectProperty),E=t(o.onObjectEnd),k=t(o.onArrayBegin),S=t(o.onArrayEnd),p=r(o.onLiteralValue),O=r(o.onSeparator),U=t(o.onComment),F=r(o.onError),M=n&&n.disallowComments,x=n&&n.allowTrailingComma;function J(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:M||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(te){case 12:case 13:M?Z(10):U();break;case 16:Z(1);break;case 15:case 14:break;default:return te}}}function Z(te,ce=[],H=[]){if(F(te),ce.length+H.length>0){let q=s.getToken();for(;q!==17;){if(ce.indexOf(q)!==-1){J();break}else if(H.indexOf(q)!==-1)break;q=J()}}}function W(te){const ce=s.getTokenValue();return te?p(ce):y(ce),J(),!0}function K(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(Z(2),te=0)}catch{Z(2)}p(te);break}case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return J(),!0}function V(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(O(":"),J(),oe()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function B(){a(),J();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||Z(4,[],[]),O(","),J(),s.getToken()===2&&x)break}else te&&Z(6,[],[]);V()||Z(4,[],[2,5]),te=!0}return E(),s.getToken()!==2?Z(7,[2],[]):J(),!0}function ie(){k(),J();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||Z(4,[],[]),O(","),J(),s.getToken()===4&&x)break}else te&&Z(6,[],[]);oe()||Z(4,[],[4,5]),te=!0}return S(),s.getToken()!==4?Z(8,[4],[]):J(),!0}function oe(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return W(!0);default:return K()}}return J(),s.getToken()===17?n.allowEmptyContent?!0:(Z(4,[],[]),!1):oe()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}function c(i,o){const n=D(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function $(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[42],he([0,1,34]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=A,e.$Fn=N,e.$Gn=R,e.$Hn=P;function A(d,C,v){let w,u,f,b,m;if(C){for(b=C.offset,m=b+C.length,f=b;f>0&&!P(d,f-1);)f--;let a=m;for(;a<d.length&&!P(d,a);)a++;u=d.substring(f,a),w=D(u,v)}else u=d,w=0,f=0,b=0,m=d.length;const h=R(v,d);let g=!1,l=0,c;v.insertSpaces?c=j(" ",v.tabSize||4):c="	";const $=(0,I.$sn)(u,!1);let i=!1;function o(){return h+j(c,w+l)}function n(){let a=$.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=$.scan();return i=a===16||$.getTokenError()!==0,a}const s=[];function t(a,y,E){!i&&y<m&&E>b&&d.substring(y,E)!==a&&s.push({offset:y,length:E-y,content:a})}let r=n();if(r!==17){const a=$.getTokenOffset()+f,y=j(c,w);t(y,f,a)}for(;r!==17;){let a=$.getTokenOffset()+$.getTokenLength()+f,y=n(),E="";for(;!g&&(y===12||y===13);){const S=$.getTokenOffset()+f;t(" ",a,S),a=$.getTokenOffset()+$.getTokenLength()+f,E=y===12?o():"",y=n()}if(y===2)r!==1&&(l--,E=o());else if(y===4)r!==3&&(l--,E=o());else{switch(r){case 3:case 1:l++,E=o();break;case 5:case 12:E=o();break;case 13:g?E=o():E=" ";break;case 6:E=" ";break;case 10:if(y===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?E=" ":y!==5&&y!==17&&(i=!0);break;case 16:i=!0;break}g&&(y===12||y===13)&&(E=o())}const k=$.getTokenOffset()+f;t(E,a,k),r=y}return s}function N(d,C){const v=JSON.stringify(d,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?v.replace(/\r\n|\r|\n/g,C.eol):v}function j(d,C){let v="";for(let w=0;w<C;w++)v+=d;return v}function D(d,C){let v=0,w=0;const u=C.tabSize||4;for(;v<d.length;){const f=d.charAt(v);if(f===" ")w++;else if(f==="	")w+=u;else break;v++}return Math.floor(w/u)}function R(d,C){for(let v=0;v<C.length;v++){const w=C.charAt(v);if(w==="\r")return v+1<C.length&&C.charAt(v+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return d&&d.eol||`
`}function P(d,C){return`\r
`.indexOf(d.charAt(C))!==-1}}),define(le[62],he([0,1,34,42]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=N,e.$Jn=j,e.$Kn=D,e.$Ln=R,e.$Mn=P;function N(d,C,v){return j(d,C,void 0,v)}function j(d,C,v,w,u){const f=C.slice(),b=[],m=(0,I.$vn)(d,b);let h,g;for(;f.length>0&&(g=f.pop(),h=(0,I.$wn)(m,f),h===void 0&&v!==void 0);)typeof g=="string"?v={[g]:v}:v=[v];if(h)if(h.type==="object"&&typeof g=="string"&&Array.isArray(h.children)){const l=(0,I.$wn)(h,[g]);if(l!==void 0)if(v===void 0){if(!l.parent)throw new Error("Malformed AST");const c=h.children.indexOf(l.parent);let $,i=l.parent.offset+l.parent.length;if(c>0){const o=h.children[c-1];$=o.offset+o.length}else $=h.offset+1,h.children.length>1&&(i=h.children[1].offset);return D(d,{offset:$,length:i-$,content:""},w)}else return D(d,{offset:l.offset,length:l.length,content:JSON.stringify(v)},w);else{if(v===void 0)return[];const c=`${JSON.stringify(g)}: ${JSON.stringify(v)}`,$=u?u(h.children.map(o=>o.children[0].value)):h.children.length;let i;if($>0){const o=h.children[$-1];i={offset:o.offset+o.length,length:0,content:","+c}}else h.children.length===0?i={offset:h.offset+1,length:0,content:c}:i={offset:h.offset+1,length:0,content:c+","};return D(d,i,w)}}else if(h.type==="array"&&typeof g=="number"&&Array.isArray(h.children))if(v!==void 0){const l=`${JSON.stringify(v)}`;let c;if(h.children.length===0||g===0)c={offset:h.offset+1,length:0,content:h.children.length===0?l:l+","};else{const $=g===-1||g>h.children.length?h.children.length:g,i=h.children[$-1];c={offset:i.offset+i.length,length:0,content:","+l}}return D(d,c,w)}else{const l=g,c=h.children[l];let $;if(h.children.length===1)$={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===l){const i=h.children[l-1],o=i.offset+i.length,n=h.offset+h.length;$={offset:o,length:n-2-o,content:""}}else $={offset:c.offset,length:h.children[l+1].offset-c.offset,content:""};return D(d,$,w)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${h.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(d,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},w)}}function D(d,C,v){let w=R(d,C),u=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;u>0&&!(0,A.$Hn)(w,u-1);)u--;for(;f<w.length&&!(0,A.$Hn)(w,f);)f++}const b=(0,A.$En)(w,{offset:u,length:f-u},v);for(let h=b.length-1;h>=0;h--){const g=b[h];w=R(w,g),u=Math.min(u,g.offset),f=Math.max(f,g.offset+g.length),f+=g.content.length-g.length}const m=d.length-(w.length-f)-u;return[{offset:u,length:m,content:w.substring(u,f)}]}function R(d,C){return d.substring(0,C.offset)+C.content+d.substring(C.offset+C.length)}function P(d,C){const v=C.slice(0).sort((u,f)=>{const b=u.offset-f.offset;return b===0?u.length-f.length:b});let w=d.length;for(let u=v.length-1;u>=0;u--){const f=v[u];if(f.offset+f.length<=w)d=R(d,f);else throw new Error("Overlapping edit");w=f.offset}return d}}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(j){this.element=j,this.next=I.Undefined,this.prev=I.Undefined}}class A{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let j=this.a;for(;j!==I.Undefined;){const D=j.next;j.prev=I.Undefined,j.next=I.Undefined,j=D}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,D){const R=new I(j);if(this.a===I.Undefined)this.a=R,this.b=R;else if(D){const d=this.b;this.b=R,R.prev=d,d.next=R}else{const d=this.a;this.a=R,R.next=d,d.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==I.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==I.Undefined&&j.next!==I.Undefined){const D=j.prev;D.next=j.next,j.next.prev=D}else j.prev===I.Undefined&&j.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):j.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):j.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==I.Undefined;)yield j.element,j=j.next}}e.$5c=A}),define(le[35],he([0,1]),function(se,e){"use strict";var I,A,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=j,e.$zc=D,e.$Ac=R,e.$Ic=g;function j(l,c,$){let i=l.get(c);return i===void 0&&(i=$,l.set(c,i)),i}function D(l){const c=[];return l.forEach(($,i)=>{c.push(`${i} => ${$}`)}),`Map(${l.size}) {${c.join(", ")}}`}function R(l){const c=[];return l.forEach($=>{c.push($)}),`Set(${l.size}) {${c.join(", ")}}`}class P{constructor(c,$){this.uri=c,this.value=$}}function d(l){return Array.isArray(l)}class C{static{this.c=c=>c.toString()}constructor(c,$){if(this[I]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=$??C.c;else if(d(c)){this.d=new Map,this.e=$??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,$){return this.d.set(this.e(c),new P(c,$)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,$){typeof $<"u"&&(c=c.bind($));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Bc=C;class v{constructor(c,$){this[A]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C($),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,$){this.c.forEach((i,o)=>c.call($,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=v;var w;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class u{constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,$=0){const i=this.c.get(c);if(i)return $!==0&&this.l(i,$),i.value}set(c,$,i=0){let o=this.c.get(c);if(o)o.value=$,i!==0&&this.l(o,i);else{switch(o={key:c,value:$,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const $=this.c.get(c);if($)return this.c.delete(c),this.k($),this.f--,$.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,$){const i=this.g;let o=this.d;for(;o;){if($?c.bind($)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,$=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==$)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,$=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==$)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,$=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==$)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let $=this.d,i=this.size;for(;$&&i>c;)this.c.delete($.key),$=$.next,i--;this.d=$,this.f=i,$&&($.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const $=c.next,i=c.previous;if(!$||!i)throw new Error("Invalid list");$.previous=i,i.next=$}c.next=void 0,c.previous=void 0,this.g++}l(c,$){if(!this.d||!this.e)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if($===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach(($,i)=>{c.push([i,$])}),c}fromJSON(c){this.clear();for(const[$,i]of c)this.set($,i)}}e.$Dc=u;class f extends u{constructor(c,$=1){super(),this.m=c,this.n=Math.min(Math.max(0,$),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,$=2){return super.get(c,$)}peek(c){return super.get(c,0)}set(c,$){return super.set(c,$,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=f;class b{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let $=this.c.get(c)||0;return $===0?!1:($--,$===0?this.c.delete(c):this.c.set(c,$),!0)}has(c){return this.c.has(c)}}e.$Fc=b;class m{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[$,i]of c)this.set($,i)}clear(){this.c.clear(),this.d.clear()}set(c,$){this.c.set(c,$),this.d.set($,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const $=this.c.get(c);return $===void 0?!1:(this.c.delete(c),this.d.delete($),!0)}forEach(c,$){this.c.forEach((i,o)=>{c.call($,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class h{constructor(){this.c=new Map}add(c,$){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add($)}delete(c,$){const i=this.c.get(c);i&&(i.delete($),i.size===0&&this.c.delete(c))}forEach(c,$){const i=this.c.get(c);i&&i.forEach($)}get(c){const $=this.c.get(c);return $||new Set}}e.$Hc=h;function g(l,c){if(l===c)return!0;if(l.size!==c.size)return!1;for(const[$,i]of l)if(!c.has($)||c.get($)!==i)return!1;for(const[$]of c)if(!l.has($))return!1;return!0}}),define(le[2],he([0,1,17,126,35,85,61]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=C,e.$Lc=v,e.$Mc=w,e.$Nc=b,e.$Oc=m,e.$Pc=h,e.$Qc=g,e.$Rc=l,e.$Sc=c,e.$3c=E;const R=!1;let P=null;class d{constructor(){this.b=new Map}static{this.a=0}c(p){let O=this.b.get(p);return O||(O={parent:null,source:null,isSingleton:!1,value:p,idx:d.a++},this.b.set(p,O)),O}trackDisposable(p){const O=this.c(p);O.source||(O.source=new Error().stack)}setParent(p,O){const U=this.c(p);U.parent=O}markAsDisposed(p){this.b.delete(p)}markAsSingleton(p){this.c(p).isSingleton=!0}f(p,O){const U=O.get(p);if(U)return U;const F=p.parent?this.f(this.c(p.parent),O):p;return O.set(p,F),F}getTrackedDisposables(){const p=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,p).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(p=10,O){let U;if(O)U=O;else{const Z=new Map,W=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,Z).isSingleton);if(W.length===0)return;const K=new Set(W.map(V=>V.value));if(U=W.filter(V=>!(V.parent&&K.has(V.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(Z){function W(V,B){for(;V.length>0&&B.some(ie=>typeof ie=="string"?ie===V[0]:V[0].match(ie));)V.shift()}const K=Z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return W(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const M=new N.$Hc;for(const Z of U){const W=F(Z);for(let K=0;K<=W.length;K++)M.add(W.slice(0,K).join(`
`),Z)}U.sort((0,I.$7b)(Z=>Z.idx,I.$9b));let x="",J=0;for(const Z of U.slice(0,p)){J++;const W=F(Z),K=[];for(let V=0;V<W.length;V++){let B=W[V];B=`(shared with ${M.get(W.slice(0,V+1).join(`
`)).size}/${U.length} leaks) at ${B}`;const oe=M.get(W.slice(0,V).join(`
`)),te=(0,A.$K)([...oe].map(ce=>F(ce)[V]),ce=>ce);delete te[W[V]];for(const[ce,H]of Object.entries(te))K.unshift(`    - stacktraces of ${H.length} other leaks continue with ${ce}`);K.unshift(B)}x+=`


==================== Leaking disposable ${J}/${U.length}: ${Z.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return U.length>p&&(x+=`


... and ${U.length-p} more leaking disposables

`),{leaks:U,details:x}}}e.$Jc=d;function C(S){P=S}if(R){const S="__is_disposable_tracked__";C(new class{trackDisposable(p){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[S]||console.log(O)},3e3)}setParent(p,O){if(p&&p!==i.None)try{p[S]=!0}catch{}}markAsDisposed(p){if(p&&p!==i.None)try{p[S]=!0}catch{}}markAsSingleton(p){}})}function v(S){return P?.trackDisposable(S),S}function w(S){P?.markAsDisposed(S)}function u(S,p){P?.setParent(S,p)}function f(S,p){if(P)for(const O of S)P.setParent(O,p)}function b(S){return P?.markAsSingleton(S),S}function m(S){return typeof S.dispose=="function"&&S.dispose.length===0}function h(S){if(D.Iterable.is(S)){const p=[];for(const O of S)if(O)try{O.dispose()}catch(U){p.push(U)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function g(S){for(const p of S)m(p)&&p.dispose();return[]}function l(...S){const p=c(()=>h(S));return f(S,p),p}function c(S){const p=v({dispose:(0,j.$db)(()=>{w(p),S()})});return p}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return u(p,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(p),p.dispose()}}deleteAndLeak(p){p&&this.f.has(p)&&(this.f.delete(p),u(p,null))}}e.$Tc=$;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,v(this),u(this.q,this)}dispose(){w(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}e.$Uc=i;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&u(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&u(p,null),p}}e.$Vc=o;class n{constructor(p){this.a=new o,this.b=!1,this.a.value=p}get value(){return this.a.value}set value(p){this.b||p===this.a.value||(this.a.value=p)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(p){let O=p;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,w(this))},this}}e.$Yc=t;class r{constructor(){this.a=new Map}acquire(p,...O){let U=this.a.get(p);U||(U={counter:0,object:this.b(p,...O)},this.a.set(p,U));const{object:F}=U,M=(0,j.$db)(()=>{--U.counter===0&&(this.c(p,U.object),this.a.delete(p))});return U.counter++,{object:F,dispose:M}}}e.$Zc=r;class a{constructor(p){this.a=p}async acquire(p,...O){const U=this.a.acquire(p,...O);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$1c=a;class y{constructor(p){this.object=p}dispose(){}}e.$2c=y;function E(S){const p=new $;try{S(p)}finally{p.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get size(){return this.a.size}get(p){return this.a.get(p)}set(p,O,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(p)?.dispose(),this.a.set(p,O)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),define(le[87],he([0,1,35]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=void 0,e.$Yl=N,e.$Zl=D;const A=new I.$Ec(1e4);function N(d){return P(d,"NFC",A)}const j=new I.$Ec(1e4);function D(d){return P(d,"NFD",j)}const R=/[^\u0000-\u0080]/;function P(d,C,v){if(!d)return d;const w=v.get(d);if(w)return w;let u;return R.test(d)?u=d.normalize(C):u=d,v.set(d,u),u}e.$1l=function(){const d=/[\u0300-\u036f]/g;return function(C){return D(C).replace(d,"")}}()}),function(){function se(N){const j=[];typeof N=="number"&&j.push("code/timeOrigin",N);function D(P){j.push(P,Date.now())}function R(){const P=[];for(let d=0;d<j.length;d+=2)P.push({name:j[d],startTime:j[d+1]});return P}return{mark:D,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const D of performance.getEntriesByType("mark"))j.push({name:D.name,startTime:Math.round(N+D.startTime)});return j}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function I(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=I(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var A in I)(typeof exports=="object"?exports:se)[A]=I[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function I(A){if(e[A])return e[A].exports;var N=e[A]={i:A,l:!1,exports:{}};return se[A].call(N.exports,N,N.exports,I),N.l=!0,N.exports}return I.m=se,I.c=e,I.d=function(A,N,j){I.o(A,N)||Object.defineProperty(A,N,{enumerable:!0,get:j})},I.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},I.t=function(A,N){if(1&N&&(A=I(A)),8&N||4&N&&typeof A=="object"&&A&&A.__esModule)return A;var j=Object.create(null);if(I.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:A}),2&N&&typeof A!="string")for(var D in A)I.d(j,D,function(R){return A[R]}.bind(null,D));return j},I.n=function(A){var N=A&&A.__esModule?function(){return A.default}:function(){return A};return I.d(N,"a",N),N},I.o=function(A,N){return Object.prototype.hasOwnProperty.call(A,N)},I.p="",I(I.s=0)}([function(se,e,I){(function(A){var N;e=se.exports=H,N=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],d=0,C=d++;P[C]="0|[1-9]\\d*";var v=d++;P[v]="[0-9]+";var w=d++;P[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=d++;P[u]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var f=d++;P[f]="("+P[v]+")\\.("+P[v]+")\\.("+P[v]+")";var b=d++;P[b]="(?:"+P[C]+"|"+P[w]+")";var m=d++;P[m]="(?:"+P[v]+"|"+P[w]+")";var h=d++;P[h]="(?:-("+P[b]+"(?:\\."+P[b]+")*))";var g=d++;P[g]="(?:-?("+P[m]+"(?:\\."+P[m]+")*))";var l=d++;P[l]="[0-9A-Za-z-]+";var c=d++;P[c]="(?:\\+("+P[l]+"(?:\\."+P[l]+")*))";var $=d++,i="v?"+P[u]+P[h]+"?"+P[c]+"?";P[$]="^"+i+"$";var o="[v=\\s]*"+P[f]+P[g]+"?"+P[c]+"?",n=d++;P[n]="^"+o+"$";var s=d++;P[s]="((?:<|>)?=?)";var t=d++;P[t]=P[v]+"|x|X|\\*";var r=d++;P[r]=P[C]+"|x|X|\\*";var a=d++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[h]+")?"+P[c]+"?)?)?";var y=d++;P[y]="[v=\\s]*("+P[t]+")(?:\\.("+P[t]+")(?:\\.("+P[t]+")(?:"+P[g]+")?"+P[c]+"?)?)?";var E=d++;P[E]="^"+P[s]+"\\s*"+P[a]+"$";var k=d++;P[k]="^"+P[s]+"\\s*"+P[y]+"$";var S=d++;P[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var p=d++;P[p]="(?:~>?)";var O=d++;P[O]="(\\s*)"+P[p]+"\\s+",R[O]=new RegExp(P[O],"g");var U=d++;P[U]="^"+P[p]+P[a]+"$";var F=d++;P[F]="^"+P[p]+P[y]+"$";var M=d++;P[M]="(?:\\^)";var x=d++;P[x]="(\\s*)"+P[M]+"\\s+",R[x]=new RegExp(P[x],"g");var J=d++;P[J]="^"+P[M]+P[a]+"$";var Z=d++;P[Z]="^"+P[M]+P[y]+"$";var W=d++;P[W]="^"+P[s]+"\\s*("+o+")$|^$";var K=d++;P[K]="^"+P[s]+"\\s*("+i+")$|^$";var V=d++;P[V]="(\\s*)"+P[s]+"\\s*("+o+"|"+P[a]+")",R[V]=new RegExp(P[V],"g");var B=d++;P[B]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=d++;P[ie]="^\\s*("+P[y]+")\\s+-\\s+("+P[y]+")\\s*$";var oe=d++;P[oe]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)N(te,P[te]),R[te]||(R[te]=new RegExp(P[te]));function ce(fe,me){if(fe instanceof H)return fe;if(typeof fe!="string"||fe.length>j||!(me?R[n]:R[$]).test(fe))return null;try{return new H(fe,me)}catch{return null}}function H(fe,me){if(fe instanceof H){if(fe.loose===me)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof H))return new H(fe,me);N("SemVer",fe,me),this.loose=me;var we=fe.trim().match(me?R[n]:R[$]);if(!we)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Re=+Ce;if(Re>=0&&Re<D)return Re}return Ce}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ce,e.valid=function(fe,me){var we=ce(fe,me);return we?we.version:null},e.clean=function(fe,me){var we=ce(fe.trim().replace(/^[=v]+/,""),me);return we?we.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(fe){return N("SemVer.compare",this.version,this.loose,fe),fe instanceof H||(fe=new H(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},H.prototype.compareMain=function(fe){return fe instanceof H||(fe=new H(fe,this.loose)),L(this.major,fe.major)||L(this.minor,fe.minor)||L(this.patch,fe.patch)},H.prototype.comparePre=function(fe){if(fe instanceof H||(fe=new H(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var me=0;do{var we=this.prerelease[me],Ce=fe.prerelease[me];if(N("prerelease compare",me,we,Ce),we===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(we===void 0)return-1;if(we!==Ce)return L(we,Ce)}while(++me)},H.prototype.inc=function(fe,me){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,me,we,Ce){typeof we=="string"&&(Ce=we,we=void 0);try{return new H(fe,we).inc(me,Ce).version}catch{return null}},e.diff=function(fe,me){if(G(fe,me))return null;var we=ce(fe),Ce=ce(me);if(we.prerelease.length||Ce.prerelease.length){for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return"pre"+Re;return"prerelease"}for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return Re},e.compareIdentifiers=L;var q=/^[0-9]+$/;function L(fe,me){var we=q.test(fe),Ce=q.test(me);return we&&Ce&&(fe=+fe,me=+me),we&&!Ce?-1:Ce&&!we?1:fe<me?-1:fe>me?1:0}function T(fe,me,we){return new H(fe,we).compare(new H(me,we))}function z(fe,me,we){return T(fe,me,we)>0}function Y(fe,me,we){return T(fe,me,we)<0}function G(fe,me,we){return T(fe,me,we)===0}function ee(fe,me,we){return T(fe,me,we)!==0}function _(fe,me,we){return T(fe,me,we)>=0}function X(fe,me,we){return T(fe,me,we)<=0}function ne(fe,me,we,Ce){var Re;switch(me){case"===":typeof fe=="object"&&(fe=fe.version),typeof we=="object"&&(we=we.version),Re=fe===we;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof we=="object"&&(we=we.version),Re=fe!==we;break;case"":case"=":case"==":Re=G(fe,we,Ce);break;case"!=":Re=ee(fe,we,Ce);break;case">":Re=z(fe,we,Ce);break;case">=":Re=_(fe,we,Ce);break;case"<":Re=Y(fe,we,Ce);break;case"<=":Re=X(fe,we,Ce);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function re(fe,me){if(fe instanceof re){if(fe.loose===me)return fe;fe=fe.value}if(!(this instanceof re))return new re(fe,me);N("comparator",fe,me),this.loose=me,this.parse(fe),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(fe,me){return L(me,fe)},e.major=function(fe,me){return new H(fe,me).major},e.minor=function(fe,me){return new H(fe,me).minor},e.patch=function(fe,me){return new H(fe,me).patch},e.compare=T,e.compareLoose=function(fe,me){return T(fe,me,!0)},e.rcompare=function(fe,me,we){return T(me,fe,we)},e.sort=function(fe,me){return fe.sort(function(we,Ce){return e.compare(we,Ce,me)})},e.rsort=function(fe,me){return fe.sort(function(we,Ce){return e.rcompare(we,Ce,me)})},e.gt=z,e.lt=Y,e.eq=G,e.neq=ee,e.gte=_,e.lte=X,e.cmp=ne,e.Comparator=re;var ue={};function de(fe,me){if(fe instanceof de)return fe.loose===me?fe:new de(fe.raw,me);if(fe instanceof re)return new de(fe.value,me);if(!(this instanceof de))return new de(fe,me);if(this.loose=me,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function $e(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function ye(fe,me,we,Ce,Re,Ue,De,qe,Te,Me,ze,je,ae){return((me=$e(we)?"":$e(Ce)?">="+we+".0.0":$e(Re)?">="+we+"."+Ce+".0":">="+me)+" "+(qe=$e(Te)?"":$e(Me)?"<"+(+Te+1)+".0.0":$e(ze)?"<"+Te+"."+(+Me+1)+".0":je?"<="+Te+"."+Me+"."+ze+"-"+je:"<="+qe)).trim()}function Se(fe,me){for(var we=0;we<fe.length;we++)if(!fe[we].test(me))return!1;if(me.prerelease.length){for(we=0;we<fe.length;we++)if(N(fe[we].semver),fe[we].semver!==ue&&fe[we].semver.prerelease.length>0){var Ce=fe[we].semver;if(Ce.major===me.major&&Ce.minor===me.minor&&Ce.patch===me.patch)return!0}return!1}return!0}function Ie(fe,me,we){try{me=new de(me,we)}catch{return!1}return me.test(fe)}function Le(fe,me,we,Ce){var Re,Ue,De,qe,Te;switch(fe=new H(fe,Ce),me=new de(me,Ce),we){case">":Re=z,Ue=X,De=Y,qe=">",Te=">=";break;case"<":Re=Y,Ue=_,De=z,qe="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(fe,me,Ce))return!1;for(var Me=0;Me<me.set.length;++Me){var ze=me.set[Me],je=null,ae=null;if(ze.forEach(function(ge){ge.semver===ue&&(ge=new re(">=0.0.0")),je=je||ge,ae=ae||ge,Re(ge.semver,je.semver,Ce)?je=ge:De(ge.semver,ae.semver,Ce)&&(ae=ge)}),je.operator===qe||je.operator===Te||(!ae.operator||ae.operator===qe)&&Ue(fe,ae.semver)||ae.operator===Te&&De(fe,ae.semver))return!1}return!0}re.prototype.parse=function(fe){var me=this.loose?R[W]:R[K],we=fe.match(me);if(!we)throw new TypeError("Invalid comparator: "+fe);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new H(we[2],this.loose):this.semver=ue},re.prototype.toString=function(){return this.value},re.prototype.test=function(fe){return N("Comparator.test",fe,this.loose),this.semver===ue||(typeof fe=="string"&&(fe=new H(fe,this.loose)),ne(fe,this.operator,this.semver,this.loose))},re.prototype.intersects=function(fe,me){if(!(fe instanceof re))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new de(fe.value,me),Ie(this.value,we,me);if(fe.operator==="")return we=new de(this.value,me),Ie(fe.semver,we,me);var Ce=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),Ue=this.semver.version===fe.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),qe=ne(this.semver,"<",fe.semver,me)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),Te=ne(this.semver,">",fe.semver,me)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return Ce||Re||Ue&&De||qe||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(fe){var me=this.loose;fe=fe.trim(),N("range",fe,me);var we=me?R[ie]:R[B];fe=fe.replace(we,ye),N("hyphen replace",fe),fe=fe.replace(R[V],"$1$2$3"),N("comparator trim",fe,R[V]),fe=(fe=(fe=fe.replace(R[O],"$1~")).replace(R[x],"$1^")).split(/\s+/).join(" ");var Ce=me?R[W]:R[K],Re=fe.split(" ").map(function(Ue){return function(De,qe){return N("comp",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(ze){return function(je,ae){N("caret",je,ae);var ge=ae?R[Z]:R[J];return je.replace(ge,function(be,pe,Ee,Pe,Oe){var Ae;return N("caret",je,be,pe,Ee,Pe,Oe),$e(pe)?Ae="":$e(Ee)?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":$e(Pe)?Ae=pe==="0"?">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+".0 <"+(+pe+1)+".0.0":Oe?(N("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ae=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Pe+Oe+" <"+pe+"."+Ee+"."+(+Pe+1):">="+pe+"."+Ee+"."+Pe+Oe+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Pe+Oe+" <"+(+pe+1)+".0.0"):(N("no pr"),Ae=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Pe+" <"+pe+"."+Ee+"."+(+Pe+1):">="+pe+"."+Ee+"."+Pe+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Pe+" <"+(+pe+1)+".0.0"),N("caret return",Ae),Ae})}(ze,Me)}).join(" ")}(De,qe),N("caret",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(ze){return function(je,ae){var ge=ae?R[F]:R[U];return je.replace(ge,function(be,pe,Ee,Pe,Oe){var Ae;return N("tilde",je,be,pe,Ee,Pe,Oe),$e(pe)?Ae="":$e(Ee)?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":$e(Pe)?Ae=">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":Oe?(N("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ae=">="+pe+"."+Ee+"."+Pe+Oe+" <"+pe+"."+(+Ee+1)+".0"):Ae=">="+pe+"."+Ee+"."+Pe+" <"+pe+"."+(+Ee+1)+".0",N("tilde return",Ae),Ae})}(ze,Me)}).join(" ")}(De,qe),N("tildes",De),De=function(Te,Me){return N("replaceXRanges",Te,Me),Te.split(/\s+/).map(function(ze){return function(je,ae){je=je.trim();var ge=ae?R[k]:R[E];return je.replace(ge,function(be,pe,Ee,Pe,Oe,Ae){N("xRange",je,be,pe,Ee,Pe,Oe,Ae);var We=$e(Ee),Be=We||$e(Pe),Fe=Be||$e(Oe);return pe==="="&&Fe&&(pe=""),We?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Fe?(Be&&(Pe=0),Fe&&(Oe=0),pe===">"?(pe=">=",Be?(Ee=+Ee+1,Pe=0,Oe=0):Fe&&(Pe=+Pe+1,Oe=0)):pe==="<="&&(pe="<",Be?Ee=+Ee+1:Pe=+Pe+1),be=pe+Ee+"."+Pe+"."+Oe):Be?be=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Fe&&(be=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),N("xRange return",be),be})}(ze,Me)}).join(" ")}(De,qe),N("xrange",De),De=function(Te,Me){return N("replaceStars",Te,Me),Te.trim().replace(R[oe],"")}(De,qe),N("stars",De),De}(Ue,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ue){return!!Ue.match(Ce)})),Re=Re.map(function(Ue){return new re(Ue,me)})},de.prototype.intersects=function(fe,me){if(!(fe instanceof de))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ce){return fe.set.some(function(Re){return Re.every(function(Ue){return Ce.intersects(Ue,me)})})})})},e.toComparators=function(fe,me){return new de(fe,me).set.map(function(we){return we.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new H(fe,this.loose));for(var me=0;me<this.set.length;me++)if(Se(this.set[me],fe))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(fe,me,we){var Ce=null,Re=null;try{var Ue=new de(me,we)}catch{return null}return fe.forEach(function(De){Ue.test(De)&&(Ce&&Re.compare(De)!==-1||(Re=new H(Ce=De,we)))}),Ce},e.minSatisfying=function(fe,me,we){var Ce=null,Re=null;try{var Ue=new de(me,we)}catch{return null}return fe.forEach(function(De){Ue.test(De)&&(Ce&&Re.compare(De)!==1||(Re=new H(Ce=De,we)))}),Ce},e.validRange=function(fe,me){try{return new de(fe,me).range||"*"}catch{return null}},e.ltr=function(fe,me,we){return Le(fe,me,"<",we)},e.gtr=function(fe,me,we){return Le(fe,me,">",we)},e.outside=Le,e.prerelease=function(fe,me){var we=ce(fe,me);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(fe,me,we){return fe=new de(fe,we),me=new de(me,we),fe.intersects(me)},e.coerce=function(fe){if(fe instanceof H)return fe;if(typeof fe!="string")return null;var me=fe.match(R[S]);return me==null?null:ce((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,I(1))},function(se,e){var I,A,N=se.exports={};function j(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(m){if(I===setTimeout)return setTimeout(m,0);if((I===j||!I)&&setTimeout)return I=setTimeout,setTimeout(m,0);try{return I(m,0)}catch{try{return I.call(null,m,0)}catch{return I.call(this,m,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:j}catch{I=j}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var P,d=[],C=!1,v=-1;function w(){C&&P&&(C=!1,P.length?d=P.concat(d):v=-1,d.length&&u())}function u(){if(!C){var m=R(w);C=!0;for(var h=d.length;h;){for(P=d,d=[];++v<h;)P&&P[v].run();v=-1,h=d.length}P=null,C=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(m)}}function f(m,h){this.fun=m,this.array=h}function b(){}N.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];d.push(new f(m,h)),d.length!==1||C||R(u)},f.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=b,N.addListener=b,N.once=b,N.off=b,N.removeListener=b,N.removeAllListeners=b,N.emit=b,N.prependListener=b,N.prependOnceListener=b,N.listeners=function(m){return[]},N.binding=function(m){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(m){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class A{constructor(R,P,d){this.level=R,this.key=P,this.value=d,this.forward=[]}}const N=void 0;class j{constructor(R,P=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new A(this.c,N,N)}get size(){return this.f}clear(){this.e=new A(this.c,N,N),this.f=0}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,P){return j.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=j.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let d=this.e.forward[0];for(;d;)R.call(P,d.value,d.key,this),d=d.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,d){let C=R.e;for(let v=R.d-1;v>=0;v--)for(;C.forward[v]&&d(C.forward[v].key,P)<0;)C=C.forward[v];if(C=C.forward[0],C&&d(C.key,P)===0)return C}static h(R,P,d,C){const v=[];let w=R.e;for(let u=R.d-1;u>=0;u--){for(;w.forward[u]&&C(w.forward[u].key,P)<0;)w=w.forward[u];v[u]=w}if(w=w.forward[0],w&&C(w.key,P)===0)return w.value=d,!1;{const u=j.j(R);if(u>R.d){for(let f=R.d;f<u;f++)v[f]=R.e;R.d=u}w=new A(u,P,d);for(let f=0;f<u;f++)w.forward[f]=v[f].forward[f],v[f].forward[f]=w;return!0}}static j(R,P=.5){let d=1;for(;Math.random()<P&&d<R.c;)d+=1;return d}static k(R,P,d){const C=[];let v=R.e;for(let w=R.d-1;w>=0;w--){for(;v.forward[w]&&d(v.forward[w].key,P)<0;)v=v.forward[w];C[w]=v}if(v=v.forward[0],!v||d(v.key,P)!==0)return!1;for(let w=0;w<R.d&&C[w].forward[w]===v;w++)C[w].forward[w]=v.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===N;)R.d-=1;return!0}}e.$hs=j}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(j){return new A(j)}constructor(j){this.c=I&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=A}),define(le[3],he([0,1,7,85,2,86,63]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=u;const R=!1,P=!1,d=!1;var C;(function(S){S.None=()=>N.$Uc.None;function p(re){if(d){const{onDidAddListener:ue}=re,de=b.create();let $e=0;re.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ue?.()}}}function O(re,ue){return B(re,()=>{},0,void 0,!0,void 0,ue)}S.defer=O;function U(re){return(ue,de=null,$e)=>{let ye=!1,Se;return Se=re(Ie=>{if(!ye)return Se?Se.dispose():ye=!0,ue.call(de,Ie)},null,$e),ye&&Se.dispose(),Se}}S.once=U;function F(re,ue,de){return K(($e,ye=null,Se)=>re(Ie=>$e.call(ye,ue(Ie)),null,Se),de)}S.map=F;function M(re,ue,de){return K(($e,ye=null,Se)=>re(Ie=>{ue(Ie),$e.call(ye,Ie)},null,Se),de)}S.forEach=M;function x(re,ue,de){return K(($e,ye=null,Se)=>re(Ie=>ue(Ie)&&$e.call(ye,Ie),null,Se),de)}S.filter=x;function J(re){return re}S.signal=J;function Z(...re){return(ue,de=null,$e)=>{const ye=(0,N.$Rc)(...re.map(Se=>Se(Ie=>ue.call(de,Ie))));return V(ye,$e)}}S.any=Z;function W(re,ue,de,$e){let ye=de;return F(re,Se=>(ye=ue(ye,Se),ye),$e)}S.reduce=W;function K(re,ue){let de;const $e={onWillAddFirstListener(){de=re(ye.fire,ye)},onDidRemoveLastListener(){de?.dispose()}};ue||p($e);const ye=new $($e);return ue?.add(ye),ye.event}function V(re,ue){return ue instanceof Array?ue.push(re):ue&&ue.add(re),re}function B(re,ue,de=100,$e=!1,ye=!1,Se,Ie){let Le,fe,me,we=0,Ce;const Re={leakWarningThreshold:Se,onWillAddFirstListener(){Le=re(De=>{we++,fe=ue(fe,De),$e&&!me&&(Ue.fire(fe),fe=void 0),Ce=()=>{const qe=fe;fe=void 0,me=void 0,(!$e||we>1)&&Ue.fire(qe),we=0},typeof de=="number"?(clearTimeout(me),me=setTimeout(Ce,de)):me===void 0&&(me=0,queueMicrotask(Ce))})},onWillRemoveListener(){ye&&we>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,Le.dispose()}};Ie||p(Re);const Ue=new $(Re);return Ie?.add(Ue),Ue.event}S.debounce=B;function ie(re,ue=0,de){return S.debounce(re,($e,ye)=>$e?($e.push(ye),$e):[ye],ue,void 0,!0,void 0,de)}S.accumulate=ie;function oe(re,ue=($e,ye)=>$e===ye,de){let $e=!0,ye;return x(re,Se=>{const Ie=$e||!ue(Se,ye);return $e=!1,ye=Se,Ie},de)}S.latch=oe;function te(re,ue,de){return[S.filter(re,ue,de),S.filter(re,$e=>!ue($e),de)]}S.split=te;function ce(re,ue=!1,de=[],$e){let ye=de.slice(),Se=re(fe=>{ye?ye.push(fe):Le.fire(fe)});$e&&$e.add(Se);const Ie=()=>{ye?.forEach(fe=>Le.fire(fe)),ye=null},Le=new $({onWillAddFirstListener(){Se||(Se=re(fe=>Le.fire(fe)),$e&&$e.add(Se))},onDidAddFirstListener(){ye&&(ue?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return $e&&$e.add(Le),Le.event}S.buffer=ce;function H(re,ue){return($e,ye,Se)=>{const Ie=ue(new L);return re(function(Le){const fe=Ie.evaluate(Le);fe!==q&&$e.call(ye,fe)},void 0,Se)}}S.chain=H;const q=Symbol("HaltChainable");class L{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(de=>(ue(de),de)),this}filter(ue){return this.f.push(de=>ue(de)?de:q),this}reduce(ue,de){let $e=de;return this.f.push(ye=>($e=ue($e,ye),$e)),this}latch(ue=(de,$e)=>de===$e){let de=!0,$e;return this.f.push(ye=>{const Se=de||!ue(ye,$e);return de=!1,$e=ye,Se?ye:q}),this}evaluate(ue){for(const de of this.f)if(ue=de(ue),ue===q)break;return ue}}function T(re,ue,de=$e=>$e){const $e=(...Le)=>Ie.fire(de(...Le)),ye=()=>re.on(ue,$e),Se=()=>re.removeListener(ue,$e),Ie=new $({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Ie.event}S.fromNodeEventEmitter=T;function z(re,ue,de=$e=>$e){const $e=(...Le)=>Ie.fire(de(...Le)),ye=()=>re.addEventListener(ue,$e),Se=()=>re.removeEventListener(ue,$e),Ie=new $({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Ie.event}S.fromDOMEventEmitter=z;function Y(re){return new Promise(ue=>U(re)(ue))}S.toPromise=Y;function G(re){const ue=new $;return re.then(de=>{ue.fire(de)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}S.fromPromise=G;function ee(re,ue,de){return ue(de),re($e=>ue($e))}S.runAndSubscribe=ee;class _{constructor(ue,de){this._observable=ue,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};de||p($e),this.emitter=new $($e),de&&de.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,de){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(re,ue){return new _(re,ue).emitter.event}S.fromObservable=X;function ne(re){return(ue,de,$e)=>{let ye=0,Se=!1;const Ie={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(re.reportChanges(),Se&&(Se=!1,ue.call(de)))},handlePossibleChange(){},handleChange(){Se=!0}};re.addObserver(Ie),re.reportChanges();const Le={dispose(){re.removeObserver(Ie)}};return $e instanceof N.$Tc?$e.add(Le):Array.isArray($e)&&$e.push(Le),Le}}S.fromObservableLight=ne})(C||(e.Event=C={}));class v{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${v.f++}`,v.all.add(this)}start(p){this.g=new D.$3d,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$5d=v;let w=-1;function u(S){const p=w;return w=S,{dispose(){w=p}}}class f{constructor(p,O=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=O,this.g=0}dispose(){this.f?.clear()}check(p,O){const U=this.threshold;if(U<=0||O<U)return;this.f||(this.f=new Map);const F=this.f.get(p.value)||0;if(this.f.set(p.value,F+1),this.g-=1,this.g<=0){this.g=U*.5;let M,x=0;for(const[J,Z]of this.f)(!M||x<Z)&&(M=J,x=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${x}):`),console.warn(M)}return()=>{const M=this.f.get(p.value)||0;this.f.set(p.value,M-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class h{constructor(p){this.value=p,this.id=m++}}const g=2,l=(S,p)=>{if(S instanceof h)p(S);else for(let O=0;O<S.length;O++){const U=S[O];U&&p(U)}},c=R?new FinalizationRegistry(S=>{typeof S=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(S))}):void 0;class ${constructor(p){this.w=0,this.f=p,this.g=w>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const p=this.t;queueMicrotask(()=>{l(p,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,O,U)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),N.$Uc.None;if(this.m)return N.$Uc.None;O&&(p=p.bind(O));const F=new h(p);let M,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=b.create(),M=this.g.check(F.stack,this.w+1)),P&&(F.stack=x??b.create()),this.t?this.t instanceof h?(this.u??=new o,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,N.$Sc)(()=>{c?.unregister(J),M?.(),this.x(F)});if(U instanceof N.$Tc?U.add(J):Array.isArray(U)&&U.push(J),c){const Z=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(J,Z,J)}return J},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,U=O.indexOf(p);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[U]=void 0;const F=this.u.current===this;if(this.w*g<=O.length){let M=0;for(let x=0;x<O.length;x++)O[x]?O[M++]=O[x]:F&&(this.u.end--,M<this.u.i&&this.u.i--);O.length=M}}y(p,O){if(!p)return;const U=this.f?.onListenerError||I.$1;if(!U){p.value(O);return}try{p.value(O)}catch(F){U(F)}}z(p){const O=p.current.t;for(;p.i<p.end;)this.y(O[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,p);else{const O=this.u;O.enqueue(this,p,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=$;const i=()=>new o;e.$8d=i;class o{constructor(){this.i=-1,this.end=0}enqueue(p,O,U){this.i=0,this.end=U,this.current=p,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(p,O,U){if(this.t)for(this.h||(this.h=new j.$5c),l(this.t,F=>this.h.push([F.value,p]));this.h.size>0&&!O.isCancellationRequested;){const[F,M]=this.h.shift(),x=[],J={...M,token:O,waitUntil:Z=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");U&&(Z=U(Z,F)),x.push(Z)}};try{F(J)}catch(Z){(0,I.$1)(Z);continue}Object.freeze(x),await Promise.allSettled(x).then(Z=>{for(const W of Z)W.status==="rejected"&&(0,I.$1)(W.reason)})}}}e.$9d=n;class s extends ${get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new j.$5c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$0d=s;class t extends s{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$$d=t;class r extends ${constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}e.$_d=r;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const O={event:p,listener:null};this.h.push(O),this.g&&this.m(O);const U=()=>{this.g&&this.o(O);const F=this.h.indexOf(O);this.h.splice(F,1)};return(0,N.$Sc)((0,A.$db)(U))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(O=>this.f.fire(O))}o(p){p.listener?.dispose(),p.listener=null}dispose(){this.f.dispose();for(const p of this.h)p.listener?.dispose();this.h=[]}}e.$ae=a;class y{constructor(p,O,U,F){this.f=new N.$Tc;const M=this.f.add(new a),x=this.f.add(new N.$4c);function J(Z){x.set(Z,M.add(F(Z)))}for(const Z of p)J(Z);this.f.add(O(Z=>{J(Z)})),this.f.add(U(Z=>{x.deleteAndDispose(Z)})),this.event=M.event}dispose(){this.f.dispose()}}e.$be=y;class E{constructor(){this.f=[]}wrapEvent(p){return(O,U,F)=>p(M=>{const x=this.f[this.f.length-1];x?x.push(()=>O.call(U,M)):O.call(U,M)},void 0,F)}bufferEvents(p){const O=[];this.f.push(O);const U=p();return this.f.pop(),O.forEach(F=>F()),U}}e.$ce=E;class k{constructor(){this.f=!1,this.g=C.None,this.h=N.$Uc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=k}),define(le[26],he([0,1,3]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const A=Object.freeze(function(R,P){const d=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(d)}}});var N;(function(R){function P(d){return d===R.None||d===R.Cancelled||d instanceof j?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(N||(e.CancellationToken=N={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new I.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=N.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=N.None}}e.$ee=D}),define(le[129],he([0,1,26]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$ee,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Pe=A;class N{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.$Qe=N;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.$Re=j}),define(le[49],he([0,1,7,2]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=N,e.$ge=j,e.$he=D,e.$ie=R,e.$je=d,e.$ke=C,e.$le=v,e.$me=w,e.$ne=u,e.$oe=f,e.$pe=b,e.$qe=m,e.$re=h,e.$se=g,e.$te=l;function N(c){const $=c;return $?typeof $.read=="function":!1}function j(c){const $=c;return $?[$.on,$.pause,$.resume,$.destroy].every(i=>typeof i=="function"):!1}function D(c){const $=c;return $?j($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function R(c,$){return new P(c,$)}class P{constructor($,i){this.e=$,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(i=>i($))}h($){this.c.error.length===0?(0,I.$1)($):this.c.error.slice(0).forEach(i=>i($))}i(){this.c.end.slice(0).forEach($=>$())}on($,i){if(!this.a.destroyed)switch($){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener($,i){if(this.a.destroyed)return;let o;switch($){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(c,$){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return $(i)}function C(c,$,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?$(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function v(c,$){return new Promise((i,o)=>{const n=[];w(c,{onData:s=>{$&&n.push(s)},onError:s=>{$?o(s):i(void 0)},onEnd:()=>{i($?$(n):void 0)}})})}function w(c,$,i){c.on("error",o=>{i?.isCancellationRequested||$.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||$.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||$.onData(o)})}function u(c,$){return new Promise((i,o)=>{const n=new A.$Tc,s=[],t=y=>{if(s.push(y),s.length>$)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=y=>(n.dispose(),o(y)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,A.$Sc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,A.$Sc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,A.$Sc)(()=>c.removeListener("data",t))),c.on("data",t)})}function f(c,$){const i=R($);return i.end(c),i}function b(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}function m(c){let $=!1;return{read:()=>$?null:($=!0,c)}}function h(c,$,i){const o=R(i);return w(c,{onData:n=>o.write($.data(n)),onError:n=>o.error($.error?$.error(n):n),onEnd:()=>o.end()}),o}function g(c,$,i){let o=!1;return{read:()=>{const n=$.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function l(c,$,i){let o=!1;const n=R(i);return w($,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(le[14],he([0,1,53,49]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=d,e.$we=C,e.$xe=v,e.$ye=w,e.$ze=u,e.$Ae=f,e.$Be=b,e.$Ce=m,e.$De=h,e.$Ee=g,e.$Fe=l,e.$Ge=c,e.$He=$,e.$Ie=i,e.$Je=o,e.$Ke=n,e.$Le=s,e.$Me=t,e.$Ne=r,e.$Oe=E;const N=typeof Buffer<"u",j=new I.$V(()=>new Uint8Array(256));let D,R;class P{static alloc(S){return N?new P(Buffer.allocUnsafe(S)):new P(new Uint8Array(S))}static wrap(S){return N&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new P(S)}static fromString(S,p){return!(p?.dontUseNodeBuffer||!1)&&N?new P(Buffer.from(S)):(D||(D=new TextEncoder),new P(D.encode(S)))}static fromByteArray(S){const p=P.alloc(S.length);for(let O=0,U=S.length;O<U;O++)p.buffer[O]=S[O];return p}static concat(S,p){if(typeof p>"u"){p=0;for(let F=0,M=S.length;F<M;F++)p+=S[F].byteLength}const O=P.alloc(p);let U=0;for(let F=0,M=S.length;F<M;F++){const x=S[F];O.set(x,U),U+=x.byteLength}return O}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=P.alloc(this.byteLength);return S.set(this),S}toString(){return N?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(S,p){return new P(this.buffer.subarray(S,p))}set(S,p){if(S instanceof P)this.buffer.set(S.buffer,p);else if(S instanceof Uint8Array)this.buffer.set(S,p);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),p);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return w(this.buffer,S)}writeUInt32BE(S,p){u(this.buffer,S,p)}readUInt32LE(S){return f(this.buffer,S)}writeUInt32LE(S,p){b(this.buffer,S,p)}readUInt8(S){return m(this.buffer,S)}writeUInt8(S,p){h(this.buffer,S,p)}indexOf(S,p=0){return d(this.buffer,S instanceof P?S.buffer:S,p)}}e.$ue=P;function d(k,S,p=0){const O=S.byteLength,U=k.byteLength;if(O===0)return 0;if(O===1)return k.indexOf(S[0]);if(O>U-p)return-1;const F=j.value;F.fill(S.length);for(let Z=0;Z<S.length;Z++)F[S[Z]]=S.length-Z-1;let M=p+S.length-1,x=M,J=-1;for(;M<U;)if(k[M]===S[x]){if(x===0){J=M;break}M--,x--}else M+=Math.max(S.length-x,F[k[M]]),x=S.length-1;return J}function C(k,S){return k[S+0]<<0>>>0|k[S+1]<<8>>>0}function v(k,S,p){k[p+0]=S&255,S=S>>>8,k[p+1]=S&255}function w(k,S){return k[S]*2**24+k[S+1]*2**16+k[S+2]*2**8+k[S+3]}function u(k,S,p){k[p+3]=S,S=S>>>8,k[p+2]=S,S=S>>>8,k[p+1]=S,S=S>>>8,k[p]=S}function f(k,S){return k[S+0]<<0>>>0|k[S+1]<<8>>>0|k[S+2]<<16>>>0|k[S+3]<<24>>>0}function b(k,S,p){k[p+0]=S&255,S=S>>>8,k[p+1]=S&255,S=S>>>8,k[p+2]=S&255,S=S>>>8,k[p+3]=S&255}function m(k,S){return k[S]}function h(k,S,p){k[p]=S}function g(k){return A.$je(k,S=>P.concat(S))}function l(k){return A.$qe(k)}function c(k){return A.$le(k,S=>P.concat(S))}async function $(k){return k.ended?P.concat(k.buffer):P.concat([...k.buffer,await c(k.stream)])}function i(k){return A.$oe(k,S=>P.concat(S))}function o(k){return A.$re(k,{data:S=>typeof S=="string"?P.fromString(S):P.wrap(S)},S=>P.concat(S))}function n(k){return A.$ie(S=>P.concat(S),k)}function s(k,S){return A.$se(k,S,p=>P.concat(p))}function t(k,S){return A.$te(k,S,p=>P.concat(p))}function r(k){let S=0,p=0,O=0;const U=new Uint8Array(Math.floor(k.length/4*3)),F=x=>{switch(p){case 3:U[O++]=S|x,p=0;break;case 2:U[O++]=S|x>>>2,S=x<<6,p=3;break;case 1:U[O++]=S|x>>>4,S=x<<4,p=2;break;default:S=x<<2,p=1}};for(let x=0;x<k.length;x++){const J=k.charCodeAt(x);if(J>=65&&J<=90)F(J-65);else if(J>=97&&J<=122)F(J-97+26);else if(J>=48&&J<=57)F(J-48+52);else if(J===43||J===45)F(62);else if(J===47||J===95)F(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${k[x]}`)}}const M=O;for(;p>0;)F(0);return P.wrap(U).slice(0,M)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:k},S=!0,p=!1){const O=p?y:a;let U="";const F=k.byteLength%3;let M=0;for(;M<k.byteLength-F;M+=3){const x=k[M+0],J=k[M+1],Z=k[M+2];U+=O[x>>>2],U+=O[(x<<4|J>>>4)&63],U+=O[(J<<2|Z>>>6)&63],U+=O[Z&63]}if(F===1){const x=k[M+0];U+=O[x>>>2],U+=O[x<<4&63],S&&(U+="==")}else if(F===2){const x=k[M+0],J=k[M+1];U+=O[x>>>2],U+=O[(x<<4|J>>>4)&63],U+=O[J<<2&63],S&&(U+="=")}return U}}),define(le[27],he([0,1,129,53]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.GraphemeBreakType=e.$Hf=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=N,e.$Ve=D,e.$We=P,e.$Xe=d,e.$Ye=C,e.$Ze=v,e.$1e=w,e.$2e=u,e.$3e=f,e.$4e=b,e.$5e=m,e.$6e=h,e.$7e=g,e.$8e=l,e.$9e=c,e.$0e=$,e.$$e=i,e.$_e=o,e.$af=n,e.$bf=s,e.$cf=t,e.$df=r,e.$ef=a,e.$ff=y,e.$gf=E,e.$hf=k,e.$if=S,e.$jf=p,e.$kf=O,e.$lf=U,e.$mf=F,e.$nf=M,e.$of=x,e.$pf=J,e.$qf=Z,e.$rf=W,e.$sf=K,e.$vf=oe,e.$wf=te,e.$xf=ce,e.$yf=H,e.$zf=T,e.$Af=Y,e.$Cf=G,e.$Df=ee,e.$Ef=_,e.$Ff=X,e.$Gf=ue,e.$If=de,e.$Jf=$e,e.$Kf=ye,e.$Lf=Se,e.$Mf=Ie,e.$Nf=Le,e.$Of=fe,e.$Pf=me,e.$Qf=De;function N(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}const j=/{(\d+)}/g;function D(ae,...ge){return ge.length===0?ae:ae.replace(j,function(be,pe){const Ee=parseInt(pe,10);return isNaN(Ee)||Ee<0||Ee>=ge.length?be:ge[Ee]})}const R=/{([^}]+)}/g;function P(ae,ge){return Object.keys(ge).length===0?ae:ae.replace(R,(be,pe)=>ge[pe]??be)}function d(ae){return ae.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function C(ae){return ae.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function v(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(ae,ge){let be=0;const pe=ge.charCodeAt(0);for(let Ee=ae.length-1;Ee>=0;Ee--)ae.charCodeAt(Ee)===pe&&be++;return be}function u(ae,ge,be="\u2026"){return ae.length<=ge?ae:`${ae.substr(0,ge)}${be}`}function f(ae,ge,be="\u2026"){if(ae.length<=ge)return ae;const pe=Math.ceil(ge/2)-be.length/2,Ee=Math.floor(ge/2)-be.length/2;return`${ae.substr(0,pe)}${be}${ae.substr(ae.length-Ee)}`}function b(ae,ge=" "){const be=m(ae,ge);return h(be,ge)}function m(ae,ge){if(!ae||!ge)return ae;const be=ge.length;if(be===0||ae.length===0)return ae;let pe=0;for(;ae.indexOf(ge,pe)===pe;)pe=pe+be;return ae.substring(pe)}function h(ae,ge){if(!ae||!ge)return ae;const be=ge.length,pe=ae.length;if(be===0||pe===0)return ae;let Ee=pe,Pe=-1;for(;Pe=ae.lastIndexOf(ge,Ee-1),!(Pe===-1||Pe+be!==Ee);){if(Pe===0)return"";Ee=Pe}return ae.substring(0,Ee)}function g(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(ae){return ae.replace(/\*/g,"")}function c(ae,ge,be={}){if(!ae)throw new Error("Cannot create regex from empty string");ge||(ae=v(ae)),be.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let pe="";return be.global&&(pe+="g"),be.matchCase||(pe+="i"),be.multiline&&(pe+="m"),be.unicode&&(pe+="u"),new RegExp(ae,pe)}function $(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}function i(ae){return ae.split(/\r\n|\r|\n/)}function o(ae){const ge=[],be=ae.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(be.length/2);pe++)ge.push(be[2*pe]+(be[2*pe+1]??""));return ge}function n(ae){for(let ge=0,be=ae.length;ge<be;ge++){const pe=ae.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}function s(ae,ge=0,be=ae.length){for(let pe=ge;pe<be;pe++){const Ee=ae.charCodeAt(pe);if(Ee!==32&&Ee!==9)return ae.substring(ge,pe)}return ae.substring(ge,be)}function t(ae,ge=ae.length-1){for(let be=ge;be>=0;be--){const pe=ae.charCodeAt(be);if(pe!==32&&pe!==9)return be}return-1}function r(ae,ge,be){const pe=[];let Ee=0;for(const Pe of ae.matchAll(ge)){if(pe.push(ae.slice(Ee,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Ee=Pe.index+Pe[0].length,pe.push(be(Pe[0],...Pe.slice(1),Pe.index,ae,Pe.groups))}return pe.push(ae.slice(Ee)),Promise.all(pe).then(Pe=>Pe.join(""))}function a(ae,ge){return ae<ge?-1:ae>ge?1:0}function y(ae,ge,be=0,pe=ae.length,Ee=0,Pe=ge.length){for(;be<pe&&Ee<Pe;be++,Ee++){const We=ae.charCodeAt(be),Be=ge.charCodeAt(Ee);if(We<Be)return-1;if(We>Be)return 1}const Oe=pe-be,Ae=Pe-Ee;return Oe<Ae?-1:Oe>Ae?1:0}function E(ae,ge){return k(ae,ge,0,ae.length,0,ge.length)}function k(ae,ge,be=0,pe=ae.length,Ee=0,Pe=ge.length){for(;be<pe&&Ee<Pe;be++,Ee++){let We=ae.charCodeAt(be),Be=ge.charCodeAt(Ee);if(We===Be)continue;if(We>=128||Be>=128)return y(ae.toLowerCase(),ge.toLowerCase(),be,pe,Ee,Pe);p(We)&&(We-=32),p(Be)&&(Be-=32);const Fe=We-Be;if(Fe!==0)return Fe}const Oe=pe-be,Ae=Pe-Ee;return Oe<Ae?-1:Oe>Ae?1:0}function S(ae){return ae>=48&&ae<=57}function p(ae){return ae>=97&&ae<=122}function O(ae){return ae>=65&&ae<=90}function U(ae,ge){return ae.length===ge.length&&k(ae,ge)===0}function F(ae,ge){const be=ge.length;return ge.length>ae.length?!1:k(ae,ge,0,be)===0}function M(ae,ge){const be=Math.min(ae.length,ge.length);let pe;for(pe=0;pe<be;pe++)if(ae.charCodeAt(pe)!==ge.charCodeAt(pe))return pe;return be}function x(ae,ge){const be=Math.min(ae.length,ge.length);let pe;const Ee=ae.length-1,Pe=ge.length-1;for(pe=0;pe<be;pe++)if(ae.charCodeAt(Ee-pe)!==ge.charCodeAt(Pe-pe))return pe;return be}function J(ae){return 55296<=ae&&ae<=56319}function Z(ae){return 56320<=ae&&ae<=57343}function W(ae,ge){return(ae-55296<<10)+(ge-56320)+65536}function K(ae,ge,be){const pe=ae.charCodeAt(be);if(J(pe)&&be+1<ge){const Ee=ae.charCodeAt(be+1);if(Z(Ee))return W(pe,Ee)}return pe}function V(ae,ge){const be=ae.charCodeAt(ge-1);if(Z(be)&&ge>1){const pe=ae.charCodeAt(ge-2);if(J(pe))return W(pe,be)}return be}class B{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=V(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=K(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$tf=B;class ie{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new B(ge,be)}nextGraphemeLength(){const ge=Re.getInstance(),be=this.c,pe=be.offset;let Ee=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Pe=be.offset,Oe=ge.getGraphemeBreakType(be.nextCodePoint());if(we(Ee,Oe)){be.setOffset(Pe);break}Ee=Oe}return be.offset-pe}prevGraphemeLength(){const ge=Re.getInstance(),be=this.c,pe=be.offset;let Ee=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Pe=be.offset,Oe=ge.getGraphemeBreakType(be.prevCodePoint());if(we(Oe,Ee)){be.setOffset(Pe);break}Ee=Oe}return pe-be.offset}eol(){return this.c.eol()}}e.$uf=ie;function oe(ae,ge){return new ie(ae,ge).nextGraphemeLength()}function te(ae,ge){return new ie(ae,ge).prevGraphemeLength()}function ce(ae,ge){ge>0&&Z(ae.charCodeAt(ge))&&ge--;const be=ge+oe(ae,ge);return[be-te(ae,be),be]}function H(ae){const ge=new ie(ae);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}let q;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(ae){return q||(q=L()),q.test(ae)}const z=/^[\t\n\r\x20-\x7E]*$/;function Y(ae){return z.test(ae)}e.$Bf=/[\u2028\u2029]/;function G(ae){return e.$Bf.test(ae)}function ee(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}function _(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}function X(ae,ge,be=""){const pe=ae.trimStart();if(pe.length<ge)return pe;const Ee=/\b/g;let Pe=0;for(;Ee.test(pe)&&!(pe.length-Ee.lastIndex<ge);)Pe=Ee.lastIndex,Ee.lastIndex+=1;return Pe===0?pe:be+pe.substring(Pe).trimStart()}const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ue(ae){return ae&&(ae=ae.replace(ne,"").replace(re,"")),ae}e.$Hf="\uFEFF";function de(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}function $e(ae){return de(ae)?ae.substr(1):ae}function ye(ae,ge){if(!ae||!ge||ae.length<ge.length)return!1;const be=ge.length,pe=ae.toLowerCase();let Ee=0,Pe=-1;for(;Ee<be;){const Oe=pe.indexOf(ge[Ee],Pe+1);if(Oe<0)return!1;Pe=Oe,Ee++}return!0}function Se(ae,ge=!1){return ae?(ge&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}function Ie(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}function Le(ae,ge=1){if(ge===0)return"";let be=-1;do be=ae.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?ae:(ae[be-1]==="\r"&&be--,ae.substr(0,be))}function fe(ae){return ae=ae%(2*26),ae<26?String.fromCharCode(97+ae):String.fromCharCode(65+ae-26)}function me(ae){return Re.getInstance().getGraphemeBreakType(ae)}function we(ae,ge){return ae===0?ge!==5&&ge!==7:ae===2&&ge===3?!1:ae===4||ae===2||ae===3||ge===4||ge===2||ge===3?!0:!(ae===8&&(ge===8||ge===9||ge===11||ge===12)||(ae===11||ae===9)&&(ge===9||ge===10)||(ae===12||ae===10)&&ge===10||ge===5||ge===13||ge===7||ae===1||ae===13&&ge===14||ae===6&&ge===6)}var Ce;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Ue()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this.d,pe=be.length/3;let Ee=1;for(;Ee<=pe;)if(ge<be[3*Ee])Ee=2*Ee;else if(ge>be[3*Ee+1])Ee=2*Ee+1;else return be[3*Ee+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ae,ge){if(ae===0)return 0;const be=qe(ae,ge);if(be!==void 0)return be;const pe=new B(ge,ae);return pe.prevCodePoint(),pe.offset}function qe(ae,ge){const be=new B(ge,ae);let pe=be.prevCodePoint();for(;Te(pe)||pe===65039||pe===8419;){if(be.offset===0)return;pe=be.prevCodePoint()}if(!_(pe))return;let Ee=be.offset;return Ee>0&&be.prevCodePoint()===8205&&(Ee=be.offset),Ee}function Te(ae){return 127995<=ae&&ae<=127999}var Me;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$Rf="\xA0";class ze{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Qe(ge=>{function be(Fe){const Ke=new Map;for(let Ge=0;Ge<Fe.length;Ge+=2)Ke.set(Fe[Ge],Fe[Ge+1]);return Ke}function pe(Fe,Ke){const Ge=new Map(Fe);for(const[_e,tt]of Ke)Ge.set(_e,tt);return Ge}function Ee(Fe,Ke){if(!Fe)return Ke;const Ge=new Map;for(const[_e,tt]of Fe)Ke.has(_e)&&Ge.set(_e,tt);return Ge}const Pe=this.c.value;let Oe=ge.filter(Fe=>!Fe.startsWith("_")&&Fe in Pe);Oe.length===0&&(Oe=["_default"]);let Ae;for(const Fe of Oe){const Ke=be(Pe[Fe]);Ae=Ee(Ae,Ke)}const We=be(Pe._common),Be=pe(We,Ae);return new ze(Be)})}static getInstance(ge){return ze.d.get(Array.from(ge))}static{this.e=new A.$V(()=>Object.keys(ze.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return ze.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Sf=ze;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ge){return je.e().has(ge)}static get codePoints(){return je.e()}}e.$Tf=je}),define(le[54],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=A,e.$9i=N,e.$0i=j,e.$$i=R,e.$aj=b;function A(h){return N(h,0)}function N(h,g){switch(typeof h){case"object":return h===null?j(349,g):Array.isArray(h)?P(h,g):d(h,g);case"string":return R(h,g);case"boolean":return D(h,g);case"number":return j(h,g);case"undefined":return j(937,g);default:return j(617,g)}}function j(h,g){return(g<<5)-g+h|0}function D(h,g){return j(h?433:863,g)}function R(h,g){g=j(149417,g);for(let l=0,c=h.length;l<c;l++)g=j(h.charCodeAt(l),g);return g}function P(h,g){return g=j(104579,g),h.reduce((l,c)=>N(c,l),g)}function d(h,g){return g=j(181387,g),Object.keys(h).sort().reduce((l,c)=>(l=R(c,l),N(h[c],l)),g)}class C{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=N(g,this.g),this.g}}e.$_i=C;var v;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function w(h,g,l=32){const c=l-g,$=~((1<<c)-1);return(h<<g|($&h)>>>c)>>>0}function u(h,g=0,l=h.byteLength,c=0){for(let $=0;$<l;$++)h[g+$]=c}function f(h,g,l="0"){for(;h.length<g;)h=l+h;return h}function b(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(l=>l.toString(16).padStart(2,"0")).join(""):f((h>>>0).toString(16),g/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const l=g.length;if(l===0)return;const c=this.p;let $=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=g.charCodeAt(0),n=0);;){let s=o;if(I.$pf(o))if(n+1<l){const t=g.charCodeAt(n+1);I.$qf(t)?(n++,s=I.$rf(o,t)):s=65533}else{i=o;break}else I.$qf(o)&&(s=65533);if($=this.w(c,$,s),n++,n<l)o=g.charCodeAt(n);else break}this.r=$,this.u=i}w(g,l,c){return c<128?g[l++]=c:c<2048?(g[l++]=192|(c&1984)>>>6,g[l++]=128|(c&63)>>>0):c<65536?(g[l++]=224|(c&61440)>>>12,g[l++]=128|(c&4032)>>>6,g[l++]=128|(c&63)>>>0):(g[l++]=240|(c&1835008)>>>18,g[l++]=128|(c&258048)>>>12,g[l++]=128|(c&4032)>>>6,g[l++]=128|(c&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=m.g,l=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,w(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let c=this.h,$=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=$&i|~$&o,t=1518500249):a<40?(s=$^i^o,t=1859775393):a<60?(s=$&i|$&o|i&o,t=2400959708):(s=$^i^o,t=3395469782),r=w(c,5)+s+n+t+g.getUint32(a*4,!1)&4294967295,n=o,o=i,i=w($,30),$=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+$&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$bj=m}),define(le[88],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(A||(A={})),function(N){const j="error",D="warning",R="warn",P="info",d="ignore";function C(w){return w?I.$lf(j,w)?N.Error:I.$lf(D,w)||I.$lf(R,w)?N.Warning:I.$lf(P,w)?N.Info:N.Ignore:N.Ignore}N.fromValue=C;function v(w){switch(w){case N.Error:return j;case N.Warning:return D;case N.Info:return P;default:return d}}N.toString=v}(A||(A={})),e.default=A}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(le[50],he([0,1,17,27]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class N{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const f=u.charCodeAt(0),b=this.b.charCodeAt(this.c);return f-b}value(){return this.b[this.c]}}e.$ji=N;class j{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,A.$ff)(u,this.b,0,u.length,this.c,this.d):(0,A.$hf)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=j;class D{constructor(u=!0,f=!0){this.f=u,this.g=f}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let f=u.length-1;f>=0;f--,this.c--){const b=this.b.charCodeAt(f);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,A.$ff)(u,this.b,0,u.length,this.d,this.e):(0,A.$hf)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=D;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(u,f){this.f=u,this.g=f,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,A.$gf)(u,this.c.scheme);if(this.d[this.e]===2)return(0,A.$gf)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,A.$ef)(u,this.c.query);if(this.d[this.e]===5)return(0,A.$ef)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=P;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class v{static forUris(u=()=>!1,f=()=>!1){return new v(new P(u,f))}static forPaths(u=!1){return new v(new D(void 0,!u))}static forStrings(){return new v(new N)}static forConfigKeys(){return new v(new j)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,f){if(f){const b=f.slice(0);(0,I.$Xb)(b);for(const m of b)this.set(m,u)}else{const b=u.slice(0);(0,I.$Xb)(b);for(const m of b)this.set(m[0],m[1])}}set(u,f){const b=this.b.reset(u);let m;this.c||(this.c=new d,this.c.segment=b.value());const h=[];for(m=this.c;;){const l=b.cmp(m.segment);if(l>0)m.left||(m.left=new d,m.left.segment=b.value()),h.push([-1,m]),m=m.left;else if(l<0)m.right||(m.right=new d,m.right.segment=b.value()),h.push([1,m]),m=m.right;else if(b.hasNext())b.next(),m.mid||(m.mid=new d,m.mid.segment=b.value()),h.push([0,m]),m=m.mid;else break}const g=m.value;m.value=f,m.key=u;for(let l=h.length-1;l>=0;l--){const c=h[l][1];c.updateHeight();const $=c.balanceFactor();if($<-1||$>1){const i=h[l][0],o=h[l+1][0];if(i===1&&o===1)h[l][1]=c.rotateLeft();else if(i===-1&&o===-1)h[l][1]=c.rotateRight();else if(i===1&&o===-1)c.right=h[l+1][1]=h[l+1][1].rotateRight(),h[l][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=h[l+1][1]=h[l+1][1].rotateLeft(),h[l][1]=c.rotateRight();else throw new Error;if(l>0)switch(h[l-1][0]){case-1:h[l-1][1].left=h[l][1];break;case 1:h[l-1][1].right=h[l][1];break;case 0:h[l-1][1].mid=h[l][1];break}else this.c=h[0][1]}}return g}get(u){return this.d(u)?.value}d(u){const f=this.b.reset(u);let b=this.c;for(;b;){const m=f.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(f.hasNext())f.next(),b=b.mid;else break}return b}has(u){const f=this.d(u);return!(f?.value===void 0&&f?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,f){const b=this.b.reset(u),m=[];let h=this.c;for(;h;){const g=b.cmp(h.segment);if(g>0)m.push([-1,h]),h=h.left;else if(g<0)m.push([1,h]),h=h.right;else if(b.hasNext())b.next(),m.push([0,h]),h=h.mid;else break}if(h){if(f?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:l,value:c,segment:$}=g;this.e(g.key,!1),h.key=l,h.value=c,h.segment=$}}else{const g=h.left??h.right;if(m.length>0){const[l,c]=m[m.length-1];switch(l){case-1:c.left=g;break;case 0:c.mid=g;break;case 1:c.right=g;break}}else this.c=g}for(let g=m.length-1;g>=0;g--){const l=m[g][1];l.updateHeight();const c=l.balanceFactor();if(c>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),m[g][1]=l.rotateLeft()):c<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),m[g][1]=l.rotateRight()),g>0)switch(m[g-1][0]){case-1:m[g-1][1].left=m[g][1];break;case 1:m[g-1][1].right=m[g][1];break;case 0:m[g-1][1].mid=m[g][1];break}else this.c=m[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const f=this.b.reset(u);let b=this.c,m;for(;b;){const h=f.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if(f.hasNext())f.next(),m=b.value||m,b=b.mid;else break}return b&&b.value||m}findSuperstr(u){return this.g(u,!1)}g(u,f){const b=this.b.reset(u);let m=this.c;for(;m;){const h=b.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(b.hasNext())b.next(),m=m.mid;else return m.mid?this.h(m.mid):f?m.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[f,b]of this)u(b,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const f=[];return this.j(u,f),f[Symbol.iterator]()}j(u,f){u&&(u.left&&this.j(u.left,f),u.value&&f.push([u.key,u.value]),u.mid&&this.j(u.mid,f),u.right&&this.j(u.right,f))}_isBalanced(){const u=f=>{if(!f)return!0;const b=f.balanceFactor();return b<-1||b>1?!1:u(f.left)&&u(f.right)};return u(this.c)}}e.$ni=v}),define(le[13],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=I,e.$Vf=A,e.$Wf=N,e.$Xf=j,e.$Yf=D,e.$Zf=R,e.$1f=P,e.$2f=d,e.$3f=C,e.$4f=v,e.$5f=w,e.$6f=u,e.$7f=f,e.$8f=m,e.$9f=h,e.$0f=g,e.$$f=l,e.$_f=c;function I($){return typeof $=="string"}function A($){return Array.isArray($)&&$.every(i=>I(i))}function N($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function j($){const i=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof i}function D($){return typeof $=="number"&&!isNaN($)}function R($){return!!$&&typeof $[Symbol.iterator]=="function"}function P($){return $===!0||$===!1}function d($){return typeof $>"u"}function C($){return!v($)}function v($){return d($)||$===null}function w($,i){if(!$)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function u($){if(v($))throw new Error("Assertion Failed: argument is undefined or null");return $}function f(...$){const i=[];for(let o=0;o<$.length;o++){const n=$[o];if(v(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const b=Object.prototype.hasOwnProperty;function m($){if(!N($))return!1;for(const i in $)if(b.call($,i))return!1;return!0}function h($){return typeof $=="function"}function g(...$){return $.length>0&&$.every(h)}function l($,i){const o=Math.min($.length,i.length);for(let n=0;n<o;n++)c($[n],i[n])}function c($,i){if(I(i)){if(typeof $!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if($ instanceof i)return}catch{}if(!v($)&&$.constructor===i||i.length===1&&i.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=A,e.$On=N,e.$Pn=D,e.$Qn=P,e.$Rn=d,e.$Sn=C,e.$Tn=v,e.$Un=w,e.$Vn=u,e.$Wn=f,e.$Xn=b,e.$Yn=m;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([l,c])=>{g[l]=c&&typeof c=="object"?A(c):c}),g}function N(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const l=g.shift();Object.freeze(l);for(const c in l)if(j.call(l,c)){const $=l[c];typeof $=="object"&&!Object.isFrozen($)&&!(0,I.$Xf)($)&&g.push($)}}return h}const j=Object.prototype.hasOwnProperty;function D(h,g){return R(h,g,new Set)}function R(h,g,l){if((0,I.$4f)(h))return h;const c=g(h);if(typeof c<"u")return c;if(Array.isArray(h)){const $=[];for(const i of h)$.push(R(i,g,l));return $}if((0,I.$Wf)(h)){if(l.has(h))throw new Error("Cannot clone recursive data-structure");l.add(h);const $={};for(const i in h)j.call(h,i)&&($[i]=R(h[i],g,l));return l.delete(h),$}return h}function P(h,g,l=!0){return(0,I.$Wf)(h)?((0,I.$Wf)(g)&&Object.keys(g).forEach(c=>{c in h?l&&((0,I.$Wf)(h[c])&&(0,I.$Wf)(g[c])?P(h[c],g[c],l):h[c]=g[c]):h[c]=g[c]}),h):g}function d(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let l,c;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(l=0;l<h.length;l++)if(!d(h[l],g[l]))return!1}else{const $=[];for(c in h)$.push(c);$.sort();const i=[];for(c in g)i.push(c);if(i.sort(),!d($,i))return!1;for(l=0;l<$.length;l++)if(!d(h[$[l]],g[$[l]]))return!1}return!0}function C(h){const g=new Set;return JSON.stringify(h,(l,c)=>{if((0,I.$Wf)(c)||Array.isArray(c)){if(g.has(c))return"[Circular]";g.add(c)}return c})}function v(h,g){const l=Object.create(null);return!h||!g||Object.keys(g).forEach($=>{const i=h[$],o=g[$];d(i,o)||(l[$]=o)}),l}function w(h,g){const l=g.toLowerCase(),c=Object.keys(h).find($=>$.toLowerCase()===l);return c?h[c]:h[g]}function u(h,g){const l=Object.create(null);for(const[c,$]of Object.entries(h))g(c,$)&&(l[c]=$);return l}function f(h){let g=[];for(;Object.prototype!==h;)g=g.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return g}function b(h){const g=[];for(const l of f(h))typeof h[l]=="function"&&g.push(l);return g}function m(h,g){const l=$=>function(){const i=Array.prototype.slice.call(arguments,0);return g($,i)},c={};for(const $ of h)c[$]=l($);return c}}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=A;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(N){return I.test(N)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),D=[];for(let R=0;R<256;R++)D.push(R.toString(16).padStart(2,"0"));return function(){N(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let P=0,d="";return d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d}}()}),define(le[131],he([0,1,37]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=j;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(D){const R=D.replace(/\-/g,":").toLowerCase();return!A.has(R)}function j(){const D=(0,I.networkInterfaces)();for(const R in D){const P=D[R];if(P){for(const{mac:d}of P)if(N(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[132],he([0,1,271,14]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VV=void 0;class N extends I.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const R=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(D,R,P){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let d=0;for(;d<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,A.$ve)(this.a,this.b,d);if(C===-1)break;this.push(this.a.slice(d,C+this.c)),d=C+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),P()}_flush(D){this.a&&this.push(this.a),D()}}e.$VV=N}),define(le[133],he([0,1,64]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=void 0,e.$Fg=A,e.$Hg=j;function A(R,P,d,C=1){let v=!1;return new Promise(w=>{const u=setTimeout(()=>{if(!v)return v=!0,w(0)},d);N(R,P,C,f=>{if(!v)return v=!0,clearTimeout(u),w(f)})})}function N(R,P,d,C){if(P===0)return C(0);const v=new I.Socket;v.once("connect",()=>(D(v),N(R+d,P-1,d,C))),v.once("data",()=>{}),v.once("error",w=>(D(v),w.code!=="ECONNREFUSED"?N(R+d,P-1,d,C):C(R))),v.connect(R,"127.0.0.1")}e.$Gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,P,d,C="127.0.0.1"){let v=!1,w,u=1;const f=I.createServer({pauseOnConnect:!0});function b(m,h){v||(v=!0,f.removeAllListeners(),f.close(),w&&clearTimeout(w),h(m))}return new Promise(m=>{w=setTimeout(()=>{b(0,m)},d),f.on("listening",()=>{b(R,m)}),f.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<P?(R++,u++,f.listen(R,C)):b(0,m)}),f.on("close",()=>{b(0,m)}),f.listen(R,C)})}function D(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_V=I;function I(A){return!!A.parentPort}}),define(le[135],he([11,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=d,e.$Nm=C,e.$Om=v;const A=60,N=A*60,j=N*24,D=j*7,R=j*30,P=j*365;function d(w,u,f,b){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,I.localize)(0,null,d(new Date().getTime()+m*1e3,!1));if(!b&&m<30)return(0,I.localize)(1,null);let h;return m<A?(h=m,u?h===1?f?(0,I.localize)(2,null,h):(0,I.localize)(3,null,h):f?(0,I.localize)(4,null,h):(0,I.localize)(5,null,h):h===1?f?(0,I.localize)(6,null,h):(0,I.localize)(7,null,h):f?(0,I.localize)(8,null,h):(0,I.localize)(9,null,h)):m<N?(h=Math.floor(m/A),u?h===1?f?(0,I.localize)(10,null,h):(0,I.localize)(11,null,h):f?(0,I.localize)(12,null,h):(0,I.localize)(13,null,h):h===1?f?(0,I.localize)(14,null,h):(0,I.localize)(15,null,h):f?(0,I.localize)(16,null,h):(0,I.localize)(17,null,h)):m<j?(h=Math.floor(m/N),u?h===1?f?(0,I.localize)(18,null,h):(0,I.localize)(19,null,h):f?(0,I.localize)(20,null,h):(0,I.localize)(21,null,h):h===1?f?(0,I.localize)(22,null,h):(0,I.localize)(23,null,h):f?(0,I.localize)(24,null,h):(0,I.localize)(25,null,h)):m<D?(h=Math.floor(m/j),u?h===1?(0,I.localize)(26,null,h):(0,I.localize)(27,null,h):h===1?(0,I.localize)(28,null,h):(0,I.localize)(29,null,h)):m<R?(h=Math.floor(m/D),u?h===1?f?(0,I.localize)(30,null,h):(0,I.localize)(31,null,h):f?(0,I.localize)(32,null,h):(0,I.localize)(33,null,h):h===1?f?(0,I.localize)(34,null,h):(0,I.localize)(35,null,h):f?(0,I.localize)(36,null,h):(0,I.localize)(37,null,h)):m<P?(h=Math.floor(m/R),u?h===1?f?(0,I.localize)(38,null,h):(0,I.localize)(39,null,h):f?(0,I.localize)(40,null,h):(0,I.localize)(41,null,h):h===1?f?(0,I.localize)(42,null,h):(0,I.localize)(43,null,h):f?(0,I.localize)(44,null,h):(0,I.localize)(45,null,h)):(h=Math.floor(m/P),u?h===1?f?(0,I.localize)(46,null,h):(0,I.localize)(47,null,h):f?(0,I.localize)(48,null,h):(0,I.localize)(49,null,h):h===1?f?(0,I.localize)(50,null,h):(0,I.localize)(51,null,h):f?(0,I.localize)(52,null,h):(0,I.localize)(53,null,h))}function C(w,u){const f=Math.abs(w/1e3);return f<1?u?(0,I.localize)(54,null,w):(0,I.localize)(55,null,w):f<A?u?(0,I.localize)(56,null,Math.round(w)/1e3):(0,I.localize)(57,null,Math.round(w)/1e3):f<N?u?(0,I.localize)(58,null,Math.round(w/(1e3*A))):(0,I.localize)(59,null,Math.round(w/(1e3*A))):f<j?u?(0,I.localize)(60,null,Math.round(w/(1e3*N))):(0,I.localize)(61,null,Math.round(w/(1e3*N))):(0,I.localize)(62,null,Math.round(w/(1e3*j)))}function v(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[136],he([11,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,13,136]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=P,e.$6i=d,e.$7i=C;function j(v,w){return w&&(v.stack||v.stacktrace)?N.localize(0,null,R(v),D(v.stack)||D(v.stacktrace)):R(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function R(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?N.localize(1,null,v.message):v.message||N.localize(2,null)}function P(v=null,w=!1){if(!v)return N.localize(3,null);if(Array.isArray(v)){const u=I.$Hb(v),f=P(u[0],w);return u.length>1?N.localize(4,null,f,u.length):f}if(A.$Uf(v))return v;if(v.detail){const u=v.detail;if(u.error)return j(u.error,w);if(u.exception)return j(u.exception,w)}return v.stack?j(v,w):v.message?v.message:N.localize(5,null)}function d(v){const w=v;return w instanceof Error&&Array.isArray(w.actions)}function C(v,w){let u;return typeof v=="string"?u=new Error(v):u=v,u.actions=w,u}}),define(le[137],he([11,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=A;function A(N){switch(N){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}}),define(le[139],he([11,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=y,e.$J=E,e.$g="en";let A=!1,N=!1,j=!1,D=!1,R=!1,P=!1,d=!1,C=!1,v=!1,w=!1,u,f=e.$g,b=e.$g,m,h;const g=globalThis;let l;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?l=g.vscode.process:typeof process<"u"&&(l=process);const c=typeof l?.versions?.electron=="string",$=c&&l?.type==="renderer";if(typeof l=="object"){A=l.platform==="win32",N=l.platform==="darwin",j=l.platform==="linux",D=j&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,d=c,v=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$g,f=e.$g;const k=l.env.VSCODE_NLS_CONFIG;if(k)try{const S=JSON.parse(k),p=S.availableLanguages["*"];u=S.locale,b=S.osLocale,f=p||e.$g,m=S._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!$?(h=navigator.userAgent,A=h.indexOf("Windows")>=0,N=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=h.indexOf("Linux")>=0,w=h?.indexOf("Mobi")>=0,P=!0,u=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,f=u,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;N?n=1:A?n=3:j&&(n=2),e.$i=A,e.$j=N,e.$k=j,e.$l=D,e.$m=R,e.$n=d,e.$o=P,e.$p=P&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=C,e.$s=w,e.$t=v,e.$u=n,e.$v=h,e.$w=f;var s;(function(k){function S(){return e.$w}k.value=S;function p(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=p;function O(){return e.$w==="en"}k.isDefault=O})(s||(e.Language=s={})),e.$x=u,e.$y=b,e.$z=m,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const k=[];g.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let O=0,U=k.length;O<U;O++){const F=k[O];if(F.id===p.data.vscodeScheduleAsyncWork){k.splice(O,1),F.callback();return}}});let S=0;return p=>{const O=++S;k.push({id:O,callback:p}),g.postMessage({vscodeScheduleAsyncWork:O},"*")}}return k=>setTimeout(k)})();var t;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=N||C?2:A?1:3;let r=!0,a=!1;function y(){if(!a){a=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,r=new Uint16Array(k.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function E(k){return parseFloat(k)>=20}}),define(le[36],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let A;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const j=N.process;A={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$ec=A.platform,e.$fc=A.arch}),define(le[140],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CV=D;var A;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(A||(A={}));const N="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function D(){const R=I.env[N];if(R){const d=R.split(":").map(C=>C.trim()).filter(C=>C.length>0);for(const C of d)switch(C){case"Unity":{const v=I.env.DESKTOP_SESSION;return v&&v.includes("gnome-fallback")?A.GNOME:A.UNITY}case"Deepin":return A.DEEPIN;case"GNOME":return A.GNOME;case"X-Cinnamon":return A.CINNAMON;case"KDE":{const v=I.env[j];return v==="5"?A.KDE5:v==="6"?A.KDE6:A.KDE4}case"Pantheon":return A.PANTHEON;case"XFCE":return A.XFCE;case"UKUI":return A.UKUI;case"LXQt":return A.LXQT}}const P=I.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return A.DEEPIN;case"gnome":case"mate":return A.GNOME;case"kde4":case"kde-plasma":return A.KDE4;case"kde":return j in I.env?A.KDE4:A.KDE3;case"xfce":case"xubuntu":return A.XFCE;case"ukui":return A.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?A.GNOME:"KDE_FULL_SESSION"in I.env?j in I.env?A.KDE4:A.KDE3:A.UNKNOWN}}),define(le[15],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const A=65,N=97,j=90,D=122,R=46,P=47,d=92,C=58,v=63;class w extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,o){if(i===null||typeof i!="object")throw new w(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new w(o,"string",i)}const b=I.$ec==="win32";function m(i){return i===P||i===d}function h(i){return i===P}function g(i){return i>=A&&i<=j||i>=N&&i<=D}function l(i,o,n,s){let t="",r=0,a=-1,y=0,E=0;for(let k=0;k<=i.length;++k){if(k<i.length)E=i.charCodeAt(k);else{if(s(E))break;E=P}if(s(E)){if(!(a===k-1||y===1))if(y===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const S=t.lastIndexOf(n);S===-1?(t="",r=0):(t=t.slice(0,S),r=t.length-1-t.lastIndexOf(n)),a=k,y=0;continue}else if(t.length!==0){t="",r=0,a=k,y=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,k)}`:t=i.slice(a+1,k),r=k-a-1;a=k,y=0}else E===R&&y!==-1?++y:y=-1}return t}function c(i,o){u(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$gc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],f(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${o}\\`));const a=r.length;let y=0,E="",k=!1;const S=r.charCodeAt(0);if(a===1)m(S)&&(y=1,k=!0);else if(m(S))if(k=!0,m(r.charCodeAt(1))){let p=2,O=p;for(;p<a&&!m(r.charCodeAt(p));)p++;if(p<a&&p!==O){const U=r.slice(O,p);for(O=p;p<a&&m(r.charCodeAt(p));)p++;if(p<a&&p!==O){for(O=p;p<a&&!m(r.charCodeAt(p));)p++;(p===a||p!==O)&&(E=`\\\\${U}\\${r.slice(O,p)}`,y=p)}}}else y=1;else g(S)&&r.charCodeAt(1)===C&&(E=r.slice(0,2),y=2,a>2&&m(r.charCodeAt(2))&&(k=!0,y=3));if(E.length>0)if(o.length>0){if(E.toLowerCase()!==o.toLowerCase())continue}else o=E;if(s){if(o.length>0)break}else if(n=`${r.slice(y)}\\${n}`,s=k,k&&o.length>0)break}return n=l(n,!s,"\\",m),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return h(r)?"\\":i;if(m(r))if(t=!0,m(i.charCodeAt(1))){let y=2,E=y;for(;y<o&&!m(i.charCodeAt(y));)y++;if(y<o&&y!==E){const k=i.slice(E,y);for(E=y;y<o&&m(i.charCodeAt(y));)y++;if(y<o&&y!==E){for(E=y;y<o&&!m(i.charCodeAt(y));)y++;if(y===o)return`\\\\${k}\\${i.slice(E)}\\`;y!==E&&(s=`\\\\${k}\\${i.slice(E,y)}`,n=y)}}}else n=1;else g(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&m(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?l(i.slice(n),!t,"\\",m):"";return a.length===0&&!t&&(a="."),a.length>0&&m(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return m(n)||o>2&&g(n)&&i.charCodeAt(1)===C&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];f(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&m(n.charCodeAt(0))){++t;const r=n.length;r>1&&m(n.charCodeAt(1))&&(++t,r>2&&(m(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&m(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$gc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const n=e.$gc.resolve(i),s=e.$gc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===d;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===d;)r--;const a=r-t;let y=0;for(;y<o.length&&o.charCodeAt(y)===d;)y++;let E=o.length;for(;E-1>y&&o.charCodeAt(E-1)===d;)E--;const k=E-y,S=a<k?a:k;let p=-1,O=0;for(;O<S;O++){const F=i.charCodeAt(t+O);if(F!==o.charCodeAt(y+O))break;F===d&&(p=O)}if(O!==S){if(p===-1)return s}else{if(k>S){if(o.charCodeAt(y+O)===d)return s.slice(y+O+1);if(O===2)return s.slice(y+O)}a>S&&(i.charCodeAt(t+O)===d?p=O:O===2&&(p=3)),p===-1&&(p=0)}let U="";for(O=t+p+1;O<=r;++O)(O===r||i.charCodeAt(O)===d)&&(U+=U.length===0?"..":"\\..");return y+=p,U.length>0?`${U}${s.slice(y,E)}`:(s.charCodeAt(y)===d&&++y,s.slice(y,E))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$gc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===d){if(o.charCodeAt(1)===d){const n=o.charCodeAt(2);if(n!==v&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===d)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return m(t)?i:".";if(m(t)){if(n=s=1,m(i.charCodeAt(1))){let y=2,E=y;for(;y<o&&!m(i.charCodeAt(y));)y++;if(y<o&&y!==E){for(E=y;y<o&&m(i.charCodeAt(y));)y++;if(y<o&&y!==E){for(E=y;y<o&&!m(i.charCodeAt(y));)y++;if(y===o)return i;y!==E&&(n=s=y+1)}}}}else g(t)&&i.charCodeAt(1)===C&&(n=o>2&&m(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let y=o-1;y>=s;--y)if(m(i.charCodeAt(y))){if(!a){r=y;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=n;--r){const E=i.charCodeAt(r);if(m(E)){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(E===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(m(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&g(i.charCodeAt(0))&&(o=s=2);for(let y=i.length-1;y>=o;--y){const E=i.charCodeAt(y);if(m(E)){if(!r){s=y+1;break}continue}t===-1&&(r=!1,t=y+1),E===R?n===-1?n=y:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return m(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(m(t)){if(s=1,m(i.charCodeAt(1))){let p=2,O=p;for(;p<n&&!m(i.charCodeAt(p));)p++;if(p<n&&p!==O){for(O=p;p<n&&m(i.charCodeAt(p));)p++;if(p<n&&p!==O){for(O=p;p<n&&!m(i.charCodeAt(p));)p++;p===n?s=p:p!==O&&(s=p+1)}}}}else if(g(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,m(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,y=-1,E=!0,k=i.length-1,S=0;for(;k>=s;--k){if(t=i.charCodeAt(k),m(t)){if(!E){a=k+1;break}continue}y===-1&&(E=!1,y=k+1),t===R?r===-1?r=k:S!==1&&(S=1):r!==-1&&(S=-1)}return y!==-1&&(r===-1||S===0||S===1&&r===y-1&&r===a+1?o.base=o.name=i.slice(a,y):(o.name=i.slice(a,r),o.base=i.slice(a,y),o.ext=i.slice(r,y))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(b){const i=/\\/g;return()=>{const o=I.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$hc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:$();f(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===P)}return o=l(o,!n,"/",h),n?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P,n=i.charCodeAt(i.length-1)===P;return i=l(i,!o,"/",h),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];f(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$hc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$hc.resolve(i),o=e.$hc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,y=t<a?t:a;let E=-1,k=0;for(;k<y;k++){const p=i.charCodeAt(n+k);if(p!==o.charCodeAt(r+k))break;p===P&&(E=k)}if(k===y)if(a>y){if(o.charCodeAt(r+k)===P)return o.slice(r+k+1);if(k===0)return o.slice(r+k)}else t>y&&(i.charCodeAt(n+k)===P?E=k:k===0&&(E=0));let S="";for(k=n+E+1;k<=s;++k)(k===s||i.charCodeAt(k)===P)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(r+E)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===P){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=0;--r){const E=i.charCodeAt(r);if(E===P){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(E===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===P){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const y=i.charCodeAt(a);if(y===P){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),y===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===P;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,y=!0,E=i.length-1,k=0;for(;E>=s;--E){const S=i.charCodeAt(E);if(S===P){if(!y){r=E+1;break}continue}a===-1&&(y=!1,a=E+1),S===R?t===-1?t=E:k!==1&&(k=1):t!==-1&&(k=-1)}if(a!==-1){const S=r===0&&n?1:r;t===-1||k===0||k===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(S,a):(o.name=i.slice(S,t),o.base=i.slice(S,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=b?e.$gc.normalize:e.$hc.normalize,e.$jc=b?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=b?e.$gc.join:e.$hc.join,e.$lc=b?e.$gc.resolve:e.$hc.resolve,e.$mc=b?e.$gc.relative:e.$hc.relative,e.$nc=b?e.$gc.dirname:e.$hc.dirname,e.$oc=b?e.$gc.basename:e.$hc.basename,e.$pc=b?e.$gc.extname:e.$hc.extname,e.$qc=b?e.$gc.format:e.$hc.format,e.$rc=b?e.$gc.parse:e.$hc.parse,e.$sc=b?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=b?e.$gc.sep:e.$hc.sep,e.$uc=b?e.$gc.delimiter:e.$hc.delimiter}),define(le[51],he([0,1,15,5,27,13]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=D,e.$bg=R,e.$cg=P,e.$dg=d,e.$eg=C,e.$fg=f,e.$gg=b,e.$hg=m,e.$ig=h,e.$jg=g,e.$kg=l,e.$lg=c,e.$mg=$,e.$ng=i,e.$og=o,e.$pg=t;function D(r){return r===47||r===92}function R(r){return r.replace(/[\\/]/g,I.$hc.sep)}function P(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function d(r,a=I.$hc.sep){if(!r)return"";const y=r.length,E=r.charCodeAt(0);if(D(E)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let S=3;const p=S;for(;S<y&&!D(r.charCodeAt(S));S++);if(p!==S&&!D(r.charCodeAt(S+1))){for(S+=1;S<y;S++)if(D(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(h(E)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let k=r.indexOf("://");if(k!==-1){for(k+=3;k<y;k++)if(D(r.charCodeAt(k)))return r.slice(0,k+1)}return""}function C(r){if(!A.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let y=2;const E=y;for(;y<r.length&&(a=r.charCodeAt(y),a!==92);y++);return!(E===y||(a=r.charCodeAt(y+1),isNaN(a)||a===92))}const v=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=A.$i){const y=a?v:w;return!(!r||r.length===0||/^\s+$/.test(r)||(y.lastIndex=0,y.test(r))||a&&u.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function b(r,a,y){const E=r===a;return!y||E?E:!r||!a?!1:(0,N.$lf)(r,a)}function m(r,a,y,E=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(y){if(!(0,N.$mf)(r,a))return!1;if(a.length===r.length)return!0;let S=a.length;return a.charAt(a.length-1)===E&&S--,r.charAt(S)===E}return a.charAt(a.length-1)!==E&&(a+=E),r.indexOf(a)===0}function h(r){return r>=65&&r<=90||r>=97&&r<=122}function g(r,a){return A.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$jc)(r)||(r=(0,I.$kc)(a,r)),r=(0,I.$ic)(r),A.$i?(r=(0,N.$6e)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,N.$6e)(r,I.sep),r||(r=I.sep)),r}function l(r){const a=(0,I.$ic)(r);return A.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$hc.sep}function c(r,a=A.$i){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function $(r,a=A.$i){return c(r,a)?r[0]:void 0}function i(r,a,y){return a.length>r.length?-1:r===a?0:(y&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let y,E,k;for(const S of a){const p=Number(S);(0,j.$Yf)(p)?E===void 0?E=p:k===void 0&&(k=p):y=y?[y,S].join(":"):S}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,y=8){let E="";for(let S=0;S<y;S++){let p;S===0&&A.$i&&!a&&(y===3||y===4)?p=s:p=n,E+=p.charAt(Math.floor(Math.random()*p.length))}let k;return a?k=`${a}-${E}`:k=E,r?(0,I.$kc)(r,k):k}}),define(le[141],he([0,1,15]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0,e.$zs=j,e.$As=D,e.$Bs=R,e.$Cs=d,e.$ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const v=(0,I.$pc)(C),w=A[v.toLowerCase()];return w!==void 0?w:D(C)}function D(C){const v=(0,I.$pc)(C);return N[v.toLowerCase()]}function R(C){for(const v in N)if(N[v]===C)return v}const P=/^(.+)\/(.+?)(;.+)?$/;function d(C,v){const w=P.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:v?void 0:C}}),define(le[89],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=j,e.$$l=D;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A||(e.Source=A={}));var N;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function j(R,...P){const d=P.reduce((w,u)=>(w[u]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!d[w]).forEach(w=>{for(let u=0;u<C.length;u++)if(w.search(C[u])!==-1){delete R[w];break}})}function D(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}}),define(le[8],he([0,1,15,5]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=f,e.$xc=c;const N=/^\w[\w\d+.-]*$/,j=/^\//,D=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!N.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,t){return!s&&!t?"file":s}function d(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==v&&(t=v+t):t=v;break}return t}const C="",v="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(t){return t instanceof u?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,y,E,k=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=P(t,k),this.authority=r||C,this.path=d(this.scheme,a||C),this.query=y||C,this.fragment=E||C,R(this,k))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:y,query:E,fragment:k}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),y===void 0?y=this.path:y===null&&(y=C),E===void 0?E=this.query:E===null&&(E=C),k===void 0?k=this.fragment:k===null&&(k=C),r===this.scheme&&a===this.authority&&y===this.path&&E===this.query&&k===this.fragment?this:new m(r,a,y,E,k)}static parse(t,r=!1){const a=w.exec(t);return a?new m(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new m(C,C,C,C,C)}static file(t){let r=C;if(A.$i&&(t=t.replace(/\\/g,v)),t[0]===v&&t[1]===v){const a=t.indexOf(v,2);a===-1?(r=t.substring(2),t=v):(r=t.substring(2,a),t=t.substring(a)||v)}return new m("file",r,t,C,C)}static from(t,r){return new m(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.$i&&t.scheme==="file"?a=u.file(I.$gc.join(c(t,!0),...r)).path:a=I.$hc.join(t.path,...r),t.with({path:a})}toString(t=!1){return $(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof u)return t;{const r=new m(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=u;function f(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const b=A.$i?1:void 0;class m extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(s,t,r){let a,y=-1;for(let E=0;E<s.length;E++){const k=s.charCodeAt(E);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||t&&k===47||r&&k===91||r&&k===93||r&&k===58)y!==-1&&(a+=encodeURIComponent(s.substring(y,E)),y=-1),a!==void 0&&(a+=s.charAt(E));else{a===void 0&&(a=s.substr(0,E));const S=h[k];S!==void 0?(y!==-1&&(a+=encodeURIComponent(s.substring(y,E)),y=-1),a+=S):y===-1&&(y=E)}}return y!==-1&&(a+=encodeURIComponent(s.substring(y))),a!==void 0?a:s}function l(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=h[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.$i&&(r=r.replace(/\//g,"\\")),r}function $(s,t){const r=t?l:g;let a="",{scheme:y,authority:E,path:k,query:S,fragment:p}=s;if(y&&(a+=y,a+=":"),(E||y==="file")&&(a+=v,a+=v),E){let O=E.indexOf("@");if(O!==-1){const U=E.substr(0,O);E=E.substr(O+1),O=U.lastIndexOf(":"),O===-1?a+=r(U,!1,!1):(a+=r(U.substr(0,O),!1,!1),a+=":",a+=r(U.substr(O+1),!1,!0)),a+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?a+=r(E,!1,!0):(a+=r(E.substr(0,O),!1,!0),a+=E.substr(O))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const O=k.charCodeAt(1);O>=65&&O<=90&&(k=`/${String.fromCharCode(O+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const O=k.charCodeAt(0);O>=65&&O<=90&&(k=`${String.fromCharCode(O+32)}:${k.substr(2)}`)}a+=r(k,!0,!1)}return S&&(a+="?",a+=r(S,!1,!1)),p&&(a+="#",a+=t?p:g(p,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],he([0,1,8]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=A,e.$Fq=N,e.$Gq=j,e.log=R;function A(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function N(d){const C=[];let v;try{const w=JSON.parse(d.arguments),u=w[w.length-1];u&&u.__$stack&&(w.pop(),v=u.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:v}}function j(d){if(typeof d!="string")return j(N(d).stack);const C=d;if(C){const v=D(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(w&&w.length===4)return{uri:I.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function D(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function R(d,C){const{args:v,stack:w}=N(d),u=typeof v[0]=="string"&&v.length===1;let f=D(w);f&&(f=`(${f.trim()})`);let b=[];if(typeof v[0]=="string"?f&&u?b=[`%c[${C}] %c${v[0]} %c${f}`,P("blue"),P(""),P("grey")]:b=[`%c[${C}] %c${v[0]}`,P("blue"),P(""),...v.slice(1)]:b=[`%c[${C}]%`,P("blue"),...v],f&&!u&&b.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,b)}function P(d){return`color: ${d}`}}),define(le[66],he([0,1,14,8]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=N,e.$Ph=j,e.$Qh=R;function N(P){return JSON.stringify(P,D)}function j(P){let d=JSON.parse(P);return d=R(d),d}function D(P,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function R(P,d=0){if(!P||d>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return A.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof I.$ue||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=R(P[C],d+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=R(P[C],d+1))}return P}}),define(le[23],he([0,1,7,5,27,8,15]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=P,e.$rg=d,e.$vg=v;var R;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.codeSetting="code-setting"})(R||(e.Schemas=R={}));function P(f,b){return j.URI.isUri(f)?(0,N.$lf)(f.scheme,b):(0,N.$mf)(f,b+":")}function d(f,...b){return b.some(m=>P(f,m))}e.$sg="vscode-tkn",e.$tg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,m){this.f=v(b,m)}getServerRootPath(){return this.f}get g(){return D.$hc.join(this.f,R.vscodeRemoteResource)}set(b,m,h){this.a[b]=m,this.b[b]=h}setConnectionToken(b,m){this.c[b]=m}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch($){return I.$1($),b}const m=b.authority;let h=this.a[m];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this.b[m],l=this.c[m];let c=`path=${encodeURIComponent(b.path)}`;return typeof l=="string"&&(c+=`&${e.$tg}=${encodeURIComponent(l)}`),j.URI.from({scheme:A.$o?this.d:R.vscodeRemoteResource,authority:`${h}:${g}`,path:this.g,query:c})}}e.$ug=new C;function v(f,b){return D.$hc.join(b??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class w{static{this.a=e.$Ag}asBrowserUri(b){const m=this.b(b,se);return this.uriToBrowserUri(m)}uriToBrowserUri(b){return b.scheme===R.vscodeRemote?e.$ug.rewrite(b):b.scheme===R.file&&(A.$m||A.$q===`${R.vscodeFileResource}://${w.a}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||w.a,query:null,fragment:null}):b}asFileUri(b){const m=this.b(b,se);return this.uriToFileUri(m)}uriToFileUri(b){return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==w.a?b.authority:null,query:null,fragment:null}):b}b(b,m){return j.URI.isUri(b)?b:j.URI.parse(m.toUrl(b))}}e.$Bg=new w;var u;(function(f){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(b.get("3"));const m="vscode-coi";function h(l){let c;typeof l=="string"?c=new URL(l).searchParams:l instanceof URL?c=l.searchParams:j.URI.isUri(l)&&(c=new URL(l.toString(!0)).searchParams);const $=c?.get(m);if($)return b.get($)}f.getHeadersFromQuery=h;function g(l,c,$){if(!globalThis.crossOriginIsolated)return;const i=c&&$?"3":$?"2":"1";l instanceof URLSearchParams?l.set(m,i):l[m]=i}f.addSearchParam=g})(u||(e.COI=u={}))}),define(le[143],he([0,1,124,23,5,8]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DD=C;class D{constructor(w,u,f){this.id=w,this.dependencies=u,this.callback=f}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,u,f)=>{typeof w!="string"&&(f=u,u=w,w=null),(typeof u!="object"||!Array.isArray(u))&&(f=u,u=null),this.c.push(new D(w,u,f))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const u=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!u)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(w){return new Promise((u,f)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const m=()=>{b.removeEventListener("load",h),b.removeEventListener("error",g)},h=l=>{m(),u(this.c.pop())},g=l=>{m(),f(l)};b.addEventListener("load",h),b.addEventListener("error",g),this.f&&(w=this.f.createScriptURL(w)),b.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(w){return new Promise((u,f)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),u(this.c.pop())}catch(b){f(b)}})}async j(w){try{const u=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,m=j.URI.parse(w).fsPath,h=u.readFileSync(m).toString(),g=b.wrap(h.replace(/^#!.*/,""));return new f.Script(g).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const P=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function C(v,w,u){if(I.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[v]&&(v=d[v]);const f=`${v}/${w}`;if(P.has(f))return P.get(f);let b;if(/^\w[\w\d+.-]*:\/\//.test(f))b=f;else{const l=`${u&&!N.$o?A.$yg:A.$xg}/${f}`;b=A.$Bg.asBrowserUri(l).toString(!0)}const m=R.INSTANCE.load(b);return P.set(f,m),m}else return await new Promise((f,b)=>{se([v],f,b)})}}),define(le[20],he([0,1,51,23,15,5,27,8]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=P,e.$4g=C,e.$5g=w;function P(u){return(0,R.$xc)(u,!0)}class d{constructor(f){this.a=f}compare(f,b,m=!1){return f===b?0:(0,D.$ef)(this.getComparisonKey(f,m),this.getComparisonKey(b,m))}isEqual(f,b,m=!1){return f===b?!0:!f||!b?!1:this.getComparisonKey(f,m)===this.getComparisonKey(b,m)}getComparisonKey(f,b=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,b,m=!1){if(f.scheme===b.scheme){if(f.scheme===A.Schemas.file)return I.$hg(P(f),P(b),this.a(f))&&f.query===b.query&&(m||f.fragment===b.fragment);if((0,e.$Zg)(f.authority,b.authority))return I.$hg(f.path,b.path,this.a(f),"/")&&f.query===b.query&&(m||f.fragment===b.fragment)}return!1}joinPath(f,...b){return R.URI.joinPath(f,...b)}basenameOrAuthority(f){return(0,e.$Rg)(f)||f.authority}basename(f){return N.$hc.basename(f.path)}extname(f){return N.$hc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let b;return f.scheme===A.Schemas.file?b=R.URI.file(N.$nc(P(f))).path:(b=N.$hc.dirname(f.path),f.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),b="/")),f.with({path:b})}normalizePath(f){if(!f.path.length)return f;let b;return f.scheme===A.Schemas.file?b=R.URI.file(N.$ic(P(f))).path:b=N.$hc.normalize(f.path),f.with({path:b})}relativePath(f,b){if(f.scheme!==b.scheme||!(0,e.$Zg)(f.authority,b.authority))return;if(f.scheme===A.Schemas.file){const g=N.$mc(P(f),P(b));return j.$i?I.$bg(g):g}let m=f.path||"/";const h=b.path||"/";if(this.a(f)){let g=0;for(const l=Math.min(m.length,h.length);g<l&&!(m.charCodeAt(g)!==h.charCodeAt(g)&&m.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);m=h.substr(0,g)+m.substr(g)}return N.$hc.relative(m,h)}resolvePath(f,b){if(f.scheme===A.Schemas.file){const m=R.URI.file(N.$lc(P(f),b));return f.with({authority:m.authority,path:m.path})}return b=I.$cg(b),f.with({path:N.$hc.resolve(f.path,b)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,b){return f===b||f!==void 0&&b!==void 0&&(0,D.$lf)(f,b)}hasTrailingPathSeparator(f,b=N.sep){if(f.scheme===A.Schemas.file){const m=P(f);return m.length>I.$dg(m).length&&m[m.length-1]===b}else{const m=f.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,b=N.sep){return(0,e.$1g)(f,b)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,b=N.sep){let m=!1;if(f.scheme===A.Schemas.file){const h=P(f);m=h!==void 0&&h.length===I.$dg(h).length&&h[h.length-1]===b}else{b="/";const h=f.path;m=h.length===1&&h.charCodeAt(h.length-1)===47}return!m&&!(0,e.$1g)(f,b)?f.with({path:f.path+"/"}):f}}e.$Jg=d,e.$Kg=new d(()=>!1),e.$Lg=new d(u=>u.scheme===A.Schemas.file?!j.$k:!0),e.$Mg=new d(u=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function C(u,f){const b=[];for(let m=0;m<u.length;m++){const h=f(u[m]);u.some((g,l)=>l===m?!1:(0,e.$Og)(h,f(g)))||b.push(u[m])}return b}var v;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function f(b){const m=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,$]=l.split(":");c&&$&&m.set(c,$)});const g=b.path.substring(0,b.path.indexOf(";"));return g&&m.set(u.META_DATA_MIME,g),m}u.parseMetaData=f})(v||(e.DataUri=v={}));function w(u,f,b){if(f){let m=u.path;return m&&m[0]!==N.$hc.sep&&(m=N.$hc.sep+m),u.with({scheme:b,authority:f,path:m})}return u.with({scheme:b})}}),define(le[6],he([0,1,26,7,3,2,20,5,130,53]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=C,e.$7g=v,e.$8g=w,e.$9g=u,e.$0g=f,e.$$g=b,e.$_g=m,e.$ah=h,e.$ih=r,e.$jh=a,e.$kh=y,e.$lh=E,e.$mh=k,e.$Bh=B,e.$Jh=G;function C(_){return!!_&&typeof _.then=="function"}function v(_){const X=new I.$ee,ne=_(X.token),re=new Promise((ue,de)=>{const $e=X.token.onCancellationRequested(()=>{$e.dispose(),de(new A.$5)});Promise.resolve(ne).then(ye=>{$e.dispose(),X.dispose(),ue(ye)},ye=>{$e.dispose(),X.dispose(),de(ye)})});return new class{cancel(){X.cancel(),X.dispose()}then(ue,de){return re.then(ue,de)}catch(ue){return this.then(void 0,ue)}finally(ue){return re.finally(ue)}}}function w(_,X,ne){return new Promise((re,ue)=>{const de=X.onCancellationRequested(()=>{de.dispose(),re(ne)});_.then(re,ue).finally(()=>de.dispose())})}function u(_,X){return new Promise((ne,re)=>{const ue=X.onCancellationRequested(()=>{ue.dispose(),re(new A.$5)});_.then(ne,re).finally(()=>ue.dispose())})}async function f(_){let X=-1;const ne=_.map((re,ue)=>re.then(de=>(X=ue,de)));try{return await Promise.race(ne)}finally{_.forEach((re,ue)=>{ue!==X&&re.cancel()})}}function b(_,X,ne){let re;const ue=setTimeout(()=>{re?.(void 0),ne?.()},X);return Promise.race([_.finally(()=>clearTimeout(ue)),new Promise(de=>re=de)])}function m(_){return new Promise((X,ne)=>{const re=_();C(re)?re.then(X,ne):X(re)})}function h(){let _,X;return{promise:new Promise((re,ue)=>{_=re,X=ue}),resolve:_,reject:X}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const ne=()=>{if(this.b=null,this.f)return;const re=this.queue(this.d);return this.d=null,re};this.b=new Promise(re=>{this.a.then(ne,ne).then(re)})}return new Promise((ne,re)=>{this.b.then(ne,re)})}return this.a=X(),new Promise((ne,re)=>{this.a.then(ue=>{this.a=null,ne(ue)},ue=>{this.a=null,re(ue)})})}dispose(){this.f=!0}}e.$bh=g;class l{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$ch=l;class c{constructor(){this.a=new Map}queue(X,ne){const ue=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(X)===ue&&this.a.delete(X)});return this.a.set(X,ue),ue}}e.$dh=c;const $=(_,X)=>{let ne=!0;const re=setTimeout(()=>{ne=!1,X()},_);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(re),ne=!1}}},i=_=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,_())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class o{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,ne=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((ue,de)=>{this.d=ue,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const re=()=>{this.a=null,this.d?.(null)};return this.a=ne===P.$4d?i(re):$(ne,re),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=o;class n{constructor(X){this.a=new o(X),this.b=new g}trigger(X,ne){return this.a.trigger(()=>this.b.queue(X),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=n;class s{constructor(){this.a=!1,this.b=new Promise((X,ne)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=s;class t extends s{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$hh=t;function r(_,X){return X?new Promise((ne,re)=>{const ue=setTimeout(()=>{de.dispose(),ne()},_),de=X.onCancellationRequested(()=>{clearTimeout(ue),de.dispose(),re(new A.$5)})}):v(ne=>r(_,ne))}function a(_,X=0,ne){const re=setTimeout(()=>{_(),ne&&ue.dispose()},X),ue=(0,j.$Sc)(()=>{clearTimeout(re),ne?.deleteAndLeak(ue)});return ne?.add(ue),ue}function y(_){const X=[];let ne=0;const re=_.length;function ue(){return ne<re?_[ne++]():null}function de($e){$e!=null&&X.push($e);const ye=ue();return ye?ye.then(de):Promise.resolve(X)}return Promise.resolve(null).then(de)}function E(_,X=re=>!!re,ne=null){let re=0;const ue=_.length,de=()=>{if(re>=ue)return Promise.resolve(ne);const $e=_[re++];return Promise.resolve($e()).then(Se=>X(Se)?Promise.resolve(Se):de())};return de()}function k(_,X=re=>!!re,ne=null){if(_.length===0)return Promise.resolve(ne);let re=_.length;const ue=()=>{re=-1;for(const de of _)de.cancel?.()};return new Promise((de,$e)=>{for(const ye of _)ye.then(Se=>{--re>=0&&X(Se)?(ue(),de(Se)):re===0&&de(ne)}).catch(Se=>{--re>=0&&(ue(),$e(Se))})})}class S{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new N.$7d}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,re)=>{this.g.push({factory:X,c:ne,e:re}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const ne=X.factory();ne.then(X.c,X.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=S;class p extends S{constructor(){super(1)}}e.$oh=p;class O{constructor(){this.a=new ie,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$ph=O;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ce;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,ne=D.$Kg){const re=ne.getComparisonKey(X);return this.a.get(re)?.size??0}queueFor(X,ne,re=D.$Kg){const ue=re.getComparisonKey(X);let de=this.a.get(ue);if(!de){de=new p;const $e=this.f++,ye=N.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$4c),this.d.set($e,ye),this.a.set(ue,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=U;class F{constructor(X,ne){this.a=-1,typeof X=="function"&&typeof ne=="number"&&this.setIfNotSet(X,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},ne)}setIfNotSet(X,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},ne))}}e.$rh=F;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,ne,re=globalThis){this.cancel();const ue=re.setInterval(()=>{X()},ne);this.d=(0,j.$Sc)(()=>{re.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$sh=M;class x{constructor(X,ne){this.b=-1,this.a=X,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=x;class J{constructor(X,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=X,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=J;class Z extends x{constructor(X,ne){super(X,ne),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$vh=Z;class W extends j.$Uc{constructor(X,ne){super(),this.g=X,this.h=ne,this.a=[],this.b=this.B(new j.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of X)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(_,X)=>{(0,R.$B)(()=>{if(ne)return;const re=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$yh=(_,X,ne)=>{const re=_.requestIdleCallback(X,typeof ne=="number"?{timeout:ne}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,_.cancelIdleCallback(re))}}},e.$xh=_=>(0,e.$yh)(globalThis,_)}();class K{constructor(X,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(re){this.l=re}finally{this.g=!0}},this.f=(0,e.$yh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=K;class V extends K{constructor(X){super(globalThis,X)}}e.$Ah=V;async function B(_,X,ne){let re;for(let ue=0;ue<ne;ue++)try{return await _()}catch(de){re=de,await r(X)}throw re}class ie{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,ne,re){return this.a={taskId:X,cancel:()=>re?.(),promise:ne},ne.then(()=>this.d(X),()=>this.d(X)),ne}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:ne,resolve:re,reject:ue}=h();this.b={run:X,promise:ne,promiseResolve:re,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=ie;class oe{constructor(X,ne=()=>Date.now()){this.d=X,this.f=ne,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Dh=oe;var te;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(te||(te={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((X,ne)=>{this.a=X,this.b=ne})}complete(X){return new Promise(ne=>{this.a(X),this.d={outcome:0,value:X},ne()})}error(X){return new Promise(ne=>{this.b(X),this.d={outcome:1,value:X},ne()})}cancel(){return this.error(new A.$5)}}e.$Eh=ce;var H;(function(_){async function X(re){let ue;const de=await Promise.all(re.map($e=>$e.then(ye=>ye,ye=>{ue||(ue=ye)})));if(typeof ue<"u")throw ue;return de}_.settled=X;function ne(re){return new Promise(async(ue,de)=>{try{await re(ue,de)}catch($e){de($e)}})}_.withAsyncBody=ne})(H||(e.Promises=H={}));class q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=q;class L{constructor(X){this.b=X,this.a=new d.$V(()=>new q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=L;var T;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(T||(T={}));class z{static fromArray(X){return new z(ne=>{ne.emitMany(X)})}static fromPromise(X){return new z(async ne=>{ne.emitMany(await X)})}static fromPromises(X){return new z(async ne=>{await Promise.all(X.map(async re=>ne.emitOne(await re)))})}static merge(X){return new z(async ne=>{await Promise.all(X.map(async re=>{for await(const ue of re)ne.emitOne(ue)}))})}static{this.EMPTY=z.fromArray([])}constructor(X){this.a=0,this.b=[],this.d=null,this.f=new N.$7d,queueMicrotask(async()=>{const ne={emitOne:re=>this.g(re),emitMany:re=>this.h(re),reject:re=>this.k(re)};try{await Promise.resolve(X(ne)),this.j()}catch(re){this.k(re)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await N.Event.toPromise(this.f.event)}while(!0)}}}static map(X,ne){return new z(async re=>{for await(const ue of X)re.emitOne(ne(ue))})}map(X){return z.map(this,X)}static filter(X,ne){return new z(async re=>{for await(const ue of X)ne(ue)&&re.emitOne(ue)})}filter(X){return z.filter(this,X)}static coalesce(X){return z.filter(X,ne=>!!ne)}coalesce(){return z.coalesce(this)}static async toPromise(X){const ne=[];for await(const re of X)ne.push(re);return ne}toPromise(){return z.toPromise(this)}g(X){this.a===0&&(this.b.push(X),this.f.fire())}h(X){this.a===0&&(this.b=this.b.concat(X),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(X){this.a===0&&(this.a=2,this.d=X,this.f.fire())}}e.$Hh=z;class Y extends z{constructor(X,ne){super(ne),this.l=X}cancel(){this.l.cancel()}}e.$Ih=Y;function G(_){const X=new I.$ee,ne=_(X.token);return new Y(X,async re=>{const ue=X.token.onCancellationRequested(()=>{ue.dispose(),X.dispose(),re.reject(new A.$5)});try{for await(const de of ne){if(X.token.isCancellationRequested)return;re.emitOne(de)}ue.dispose(),X.dispose()}catch(de){ue.dispose(),X.dispose(),re.reject(de)}})}class ee{constructor(){this.a=new ce,this.b=new z(re=>{if(X){re.reject(X);return}return ne&&re.emitMany(ne),this.d=ue=>re.reject(ue),this.f=ue=>re.emitOne(ue),this.a.p});let X,ne;this.f=re=>{ne||(ne=[]),ne.push(re)},this.d=re=>{X||(X=re)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$Kh=ee}),define(le[90],he([0,1,17,6,51,35,15,5,27]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=d,e.$_j=f,e.$ak=p,e.$bk=O,e.$ck=U,e.$dk=F,e.$ek=M,e.$fk=W;function d(){return Object.create(null)}e.$0j="**",e.$$j="/";const C="[/\\\\]",v="[^/\\\\]",w=/\//g;function u(K,V){switch(K){case 0:return"";case 1:return`${v}*?`;default:return`(?:${C}|${v}+${C}${V?`|${C}${v}+`:""})*?`}}function f(K,V){if(!K)return[];const B=[];let ie=!1,oe=!1,te="";for(const ce of K){switch(ce){case V:if(!ie&&!oe){B.push(te),te="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}te+=ce}return te&&B.push(te),B}function b(K){if(!K)return"";let V="";const B=f(K,e.$$j);if(B.every(ie=>ie===e.$0j))V=".*";else{let ie=!1;B.forEach((oe,te)=>{if(oe===e.$0j){if(ie)return;V+=u(2,te===B.length-1)}else{let ce=!1,H="",q=!1,L="";for(const T of oe){if(T!=="}"&&ce){H+=T;continue}if(q&&(T!=="]"||!L)){let z;T==="-"?z=T:(T==="^"||T==="!")&&!L?z="^":T===e.$$j?z="":z=(0,P.$Ze)(T),L+=z;continue}switch(T){case"{":ce=!0;continue;case"[":q=!0;continue;case"}":{const Y=`(?:${f(H,",").map(G=>b(G)).join("|")})`;V+=Y,ce=!1,H="";break}case"]":{V+="["+L+"]",q=!1,L="";break}case"?":V+=v;continue;case"*":V+=u(1);continue;default:V+=(0,P.$Ze)(T)}}te<B.length-1&&(B[te+1]!==e.$0j||te+2<B.length)&&(V+=C)}ie=oe===e.$0j})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new j.$Ec(1e4),o=function(){return!1},n=function(){return null};function s(K,V){if(!K)return n;let B;typeof K!="string"?B=K.pattern:B=K,B=B.trim();const ie=`${B}_${!!V.trimForExclusions}`;let oe=i.get(ie);if(oe)return t(oe,K);let te;return m.test(B)?oe=a(B.substr(4),B):(te=h.exec(r(B,V)))?oe=y(te[1],B):(V.trimForExclusions?l:g).test(B)?oe=E(B,V):(te=c.exec(r(B,V)))?oe=k(te[1].substr(1),B,!0):(te=$.exec(r(B,V)))?oe=k(te[1],B,!1):oe=S(B),i.set(ie,oe),t(oe,K)}function t(K,V){if(typeof V=="string")return K;const B=function(ie,oe){return(0,N.$hg)(ie,V.base,!R.$k)?K((0,P.$5e)(ie.substr(V.base.length),D.sep),oe):null};return B.allBasenames=K.allBasenames,B.allPaths=K.allPaths,B.basenames=K.basenames,B.patterns=K.patterns,B}function r(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,V){return function(B,ie){return typeof B=="string"&&B.endsWith(K)?V:null}}function y(K,V){const B=`/${K}`,ie=`\\${K}`,oe=function(ce,H){return typeof ce!="string"?null:H?H===K?V:null:ce===K||ce.endsWith(B)||ce.endsWith(ie)?V:null},te=[K];return oe.basenames=te,oe.patterns=[V],oe.allBasenames=te,oe}function E(K,V){const B=Z(K.slice(1,-1).split(",").map(H=>s(H,V)).filter(H=>H!==n),K),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const oe=function(H,q){for(let L=0,T=B.length;L<T;L++)if(B[L](H,q))return K;return null},te=B.find(H=>!!H.allBasenames);te&&(oe.allBasenames=te.allBasenames);const ce=B.reduce((H,q)=>q.allPaths?H.concat(q.allPaths):H,[]);return ce.length&&(oe.allPaths=ce),oe}function k(K,V,B){const ie=D.sep===D.$hc.sep,oe=ie?K:K.replace(w,D.sep),te=D.sep+oe,ce=D.$hc.sep+K;let H;return B?H=function(q,L){return typeof q=="string"&&(q===oe||q.endsWith(te)||!ie&&(q===K||q.endsWith(ce)))?V:null}:H=function(q,L){return typeof q=="string"&&(q===oe||!ie&&q===K)?V:null},H.allPaths=[(B?"*/":"./")+K],H}function S(K){try{const V=new RegExp(`^${b(K)}$`);return function(B){return V.lastIndex=0,typeof B=="string"&&V.test(B)?K:null}}catch{return n}}function p(K,V,B){return!K||typeof V!="string"?!1:O(K)(V,void 0,B)}function O(K,V={}){if(!K)return o;if(typeof K=="string"||U(K)){const B=s(K,V);if(B===n)return o;const ie=function(oe,te){return!!B(oe,te)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return x(K,V)}function U(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function F(K){return K.allBasenames||[]}function M(K){return K.allPaths||[]}function x(K,V){const B=Z(Object.getOwnPropertyNames(K).map(H=>J(H,K[H],V)).filter(H=>H!==n)),ie=B.length;if(!ie)return n;if(!B.some(H=>!!H.requiresSiblings)){if(ie===1)return B[0];const H=function(T,z){let Y;for(let G=0,ee=B.length;G<ee;G++){const _=B[G](T,z);if(typeof _=="string")return _;(0,A.$6g)(_)&&(Y||(Y=[]),Y.push(_))}return Y?(async()=>{for(const G of Y){const ee=await G;if(typeof ee=="string")return ee}return null})():null},q=B.find(T=>!!T.allBasenames);q&&(H.allBasenames=q.allBasenames);const L=B.reduce((T,z)=>z.allPaths?T.concat(z.allPaths):T,[]);return L.length&&(H.allPaths=L),H}const oe=function(H,q,L){let T,z;for(let Y=0,G=B.length;Y<G;Y++){const ee=B[Y];ee.requiresSiblings&&L&&(q||(q=(0,D.$oc)(H)),T||(T=q.substr(0,q.length-(0,D.$pc)(H).length)));const _=ee(H,q,T,L);if(typeof _=="string")return _;(0,A.$6g)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const Y of z){const G=await Y;if(typeof G=="string")return G}return null})():null},te=B.find(H=>!!H.allBasenames);te&&(oe.allBasenames=te.allBasenames);const ce=B.reduce((H,q)=>q.allPaths?H.concat(q.allPaths):H,[]);return ce.length&&(oe.allPaths=ce),oe}function J(K,V,B){if(V===!1)return n;const ie=s(K,B);if(ie===n)return n;if(typeof V=="boolean")return ie;if(V){const oe=V.when;if(typeof oe=="string"){const te=(ce,H,q,L)=>{if(!L||!ie(ce,H))return null;const T=oe.replace("$(basename)",()=>q),z=L(T);return(0,A.$6g)(z)?z.then(Y=>Y?K:null):z?K:null};return te.requiresSiblings=!0,te}}return ie}function Z(K,V){const B=K.filter(H=>!!H.basenames);if(B.length<2)return K;const ie=B.reduce((H,q)=>{const L=q.basenames;return L?H.concat(L):H},[]);let oe;if(V){oe=[];for(let H=0,q=ie.length;H<q;H++)oe.push(V)}else oe=B.reduce((H,q)=>{const L=q.patterns;return L?H.concat(L):H},[]);const te=function(H,q){if(typeof H!="string")return null;if(!q){let T;for(T=H.length;T>0;T--){const z=H.charCodeAt(T-1);if(z===47||z===92)break}q=H.substr(T)}const L=ie.indexOf(q);return L!==-1?oe[L]:null};te.basenames=ie,te.patterns=oe,te.allBasenames=ie;const ce=K.filter(H=>!H.basenames);return ce.push(te),ce}function W(K,V){return(0,I.$ub)(K,V,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(le[91],he([0,1,14,8]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=R,e.$mn=d,e.$nn=C;function N(v){return v.toJSON()}class j{constructor(w){this.a=w}transformIncoming(w){const u=this.a.transformIncoming(w);return u===w?w:N(A.URI.from(u))}transformOutgoing(w){const u=this.a.transformOutgoing(w);return u===w?w:N(A.URI.from(u))}transformOutgoingURI(w){const u=this.a.transformOutgoing(w);return u===w?w:A.URI.from(u)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$jn=j,e.$kn=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,w,u){if(!v||u>200)return null;if(typeof v=="object"){if(v instanceof A.URI)return w.transformOutgoing(v);for(const f in v)if(Object.hasOwnProperty.call(v,f)){const b=D(v[f],w,u+1);b!==null&&(v[f]=b)}}return null}function R(v,w){const u=D(v,w,0);return u===null?v:u}function P(v,w,u,f){if(!v||f>200)return null;if(typeof v=="object"){if(v.$mid===1)return u?A.URI.revive(w.transformIncoming(v)):w.transformIncoming(v);if(v instanceof I.$ue)return null;for(const b in v)if(Object.hasOwnProperty.call(v,b)){const m=P(v[b],w,u,f+1);m!==null&&(v[b]=m)}}return null}function d(v,w){const u=P(v,w,!1,0);return u===null?v:u}function C(v,w){const u=P(v,w,!0,0);return u===null?v:u}}),define(le[144],he([0,1,37,50,32,131,5]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$qn=P,e.$rn=v,e.$pn=new class{c(w){return this.a||(this.a=A.$ni.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,u=0;const f=(0,I.networkInterfaces)();for(const b in f){const m=f[b];if(m)for(const{mac:h,internal:g}of m)g||(u+=1,this.c(h.toUpperCase())&&(w+=1))}this.b=u>0?w/u:0}return this.b}};let R;async function P(w){return R||(R=(async()=>await d(w)||N.$Dg())()),R}async function d(w){try{const u=await new Promise((b,m)=>{se(["crypto"],b,m)}),f=(0,j.$on)();return u.createHash("sha256").update(f,"utf8").digest("hex")}catch(u){w(u);return}}const C="Software\\Microsoft\\SQMClient";async function v(w){if(D.$i){const u=await new Promise((f,b)=>{se(["@vscode/windows-registry"],f,b)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(f){return w(f),""}}return""}}),define(le[145],he([0,1,43,272,273,5]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=D;async function D(R){if(j.$j||j.$i)return;let P;for(const d of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,A.open)(d,I.constants.R_OK);break}catch{}if(!P){R("Unable to retrieve release information from known identifier paths.");return}try{const d=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const v of(0,N.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const w=v.split("=")[0].toUpperCase().trim();if(d.has(w)){const u=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?C.id=u:w==="ID_LIKE"?C.id_like=u:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(C.version_id=u)}}return C}catch(d){R(d)}}}),define(le[31],he([0,1,43,37,274,6,51,87,15,5,20,8]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=l,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=y;var w;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function u(J,Z=w.UNLINK,W){if((0,D.$kg)(J))throw new Error("rimraf - will refuse to recursively delete root");return Z===w.UNLINK?b(J):f(J,W)}async function f(J,Z=(0,D.$pg)((0,A.tmpdir)())){try{try{await I.promises.rename(J,Z)}catch(W){return W.code==="ENOENT"?void 0:b(J)}b(Z).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function b(J){return(0,N.promisify)(I.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function m(J){if((0,D.$kg)(J))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}async function h(J,Z){return c(await(Z?g(J):(0,N.promisify)(I.readdir)(J)))}async function g(J){try{return await(0,N.promisify)(I.readdir)(J,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Z=[],W=await h(J);for(const K of W){let V=!1,B=!1,ie=!1;try{const oe=await e.Promises.lstat((0,P.$kc)(J,K));V=oe.isFile(),B=oe.isDirectory(),ie=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}Z.push({name:K,isFile:()=>V,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Z}function l(J){return c(I.readdirSync(J))}function c(J){return J.map(Z=>typeof Z=="string"?d.$j?(0,R.$Yl)(Z):Z:(Z.name=d.$j?(0,R.$Yl)(Z.name):Z.name,Z))}async function $(J){const Z=await h(J),W=[];for(const K of Z)await o.existsDirectory((0,P.$kc)(J,K))&&W.push(K);return W}function i(J,Z=1e3){return new Promise(W=>{let K=!1;const V=setInterval(()=>{K||(K=!0,I.access(J,B=>{K=!1,B&&(clearInterval(V),W(void 0))}))},Z)})}var o;(function(J){async function Z(V){let B;try{if(B=await e.Promises.lstat(V),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(d.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw oe}throw ie}}J.stat=Z;async function W(V){try{const{stat:B,symbolicLink:ie}=await J.stat(V);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}J.existsFile=W;async function K(V){try{const{stat:B,symbolicLink:ie}=await J.stat(V);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}J.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const n=new j.$qh;function s(J,Z,W){return n.queueFor(v.URI.file(J),()=>{const K=E(W);return new Promise((V,B)=>a(J,Z,K,ie=>ie?B(ie):V()))},C.$Lg)}let t=!0;function r(J){t=J}function a(J,Z,W,K){if(!t)return I.writeFile(J,Z,{mode:W.mode,flag:W.flag},K);I.open(J,W.flag,W.mode,(V,B)=>{if(V)return K(V);I.writeFile(B,Z,ie=>{if(ie)return I.close(B,()=>K(ie));I.fdatasync(B,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),I.close(B,te=>K(te))))})})}function y(J,Z,W){const K=E(W);if(!t)return I.writeFileSync(J,Z,{mode:K.mode,flag:K.flag});const V=I.openSync(J,K.flag,K.mode);try{I.writeFileSync(V,Z);try{I.fdatasyncSync(V)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{I.closeSync(V)}}function E(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function k(J,Z,W=6e4){if(J!==Z)try{d.$i&&typeof W=="number"?await S(J,Z,Date.now(),W):await(0,N.promisify)(I.rename)(J,Z)}catch(K){if(J.toLowerCase()!==Z.toLowerCase()&&K.code==="EXDEV"||J.endsWith("."))await p(J,Z,{preserveSymlinks:!1}),await u(J,w.MOVE);else throw K}}async function S(J,Z,W,K,V=0){try{return await(0,N.promisify)(I.rename)(J,Z)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=K)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${B}`),B;if(V===0){let ie=!1;try{const{stat:oe}=await o.stat(Z);oe.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,j.$ih)(Math.min(100,V*10)),S(J,Z,W,K,V+1)}}async function p(J,Z,W){return U(J,Z,{root:{source:J,target:Z},options:W,handledSourcePaths:new Set})}const O=511;async function U(J,Z,W){if(W.handledSourcePaths.has(J))return;W.handledSourcePaths.add(J);const{stat:K,symbolicLink:V}=await o.stat(J);if(V){if(W.options.preserveSymlinks)try{return await x(J,Z,W)}catch{}if(V.dangling)return}return K.isDirectory()?F(J,Z,K.mode&O,W):M(J,Z,K.mode&O)}async function F(J,Z,W,K){await e.Promises.mkdir(Z,{recursive:!0,mode:W});const V=await h(J);for(const B of V)await U((0,P.$kc)(J,B),(0,P.$kc)(Z,B),K)}async function M(J,Z,W){await e.Promises.copyFile(J,Z),await e.Promises.chmod(Z,W)}async function x(J,Z,W){let K=await e.Promises.readlink(J);(0,D.$hg)(K,W.root.source,!d.$k)&&(K=(0,P.$kc)(W.root.target,K.substr(W.root.source.length+1))),await e.Promises.symlink(K,Z)}e.Promises=new class{get access(){return(0,N.promisify)(I.access)}get stat(){return(0,N.promisify)(I.stat)}get lstat(){return(0,N.promisify)(I.lstat)}get utimes(){return(0,N.promisify)(I.utimes)}get read(){return(J,Z,W,K,V)=>new Promise((B,ie)=>{I.read(J,Z,W,K,V,(oe,te,ce)=>oe?ie(oe):B({bytesRead:te,buffer:ce}))})}get readFile(){return(0,N.promisify)(I.readFile)}get write(){return(J,Z,W,K,V)=>new Promise((B,ie)=>{I.write(J,Z,W,K,V,(oe,te,ce)=>oe?ie(oe):B({bytesWritten:te,buffer:ce}))})}get appendFile(){return(0,N.promisify)(I.appendFile)}get fdatasync(){return(0,N.promisify)(I.fdatasync)}get truncate(){return(0,N.promisify)(I.truncate)}get copyFile(){return(0,N.promisify)(I.copyFile)}get open(){return(0,N.promisify)(I.open)}get close(){return(0,N.promisify)(I.close)}get symlink(){return(0,N.promisify)(I.symlink)}get readlink(){return(0,N.promisify)(I.readlink)}get chmod(){return(0,N.promisify)(I.chmod)}get mkdir(){return(0,N.promisify)(I.mkdir)}get unlink(){return(0,N.promisify)(I.unlink)}get rmdir(){return(0,N.promisify)(I.rmdir)}get realpath(){return(0,N.promisify)(I.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return u}get rename(){return k}get copy(){return p}}}),define(le[146],he([0,1,43,15,5,27,31]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=R,e.$Nq=P,e.$Oq=d,e.$Pq=C;function R(w){if(N.$k)return w;const u=(0,A.$nc)(w);if(w===u)return w;const f=((0,A.$oc)(w)||w).toLowerCase();try{const m=(0,D.readdirSync)(u).filter(h=>h.toLowerCase()===f);if(m.length===1){const h=R(u);if(h)return(0,A.$kc)(h,m[0])}else if(m.length>1){const h=m.indexOf(f);if(h>=0){const g=R(u);if(g)return(0,A.$kc)(g,m[h])}}}catch{}return null}async function P(w){if(N.$k)return w;const u=(0,A.$nc)(w);if(w===u)return w;const f=((0,A.$oc)(w)||w).toLowerCase();try{const m=(await D.Promises.readdir(u)).filter(h=>h.toLowerCase()===f);if(m.length===1){const h=await P(u);if(h)return(0,A.$kc)(h,m[0])}else if(m.length>1){const h=m.indexOf(f);if(h>=0){const g=await P(u);if(g)return(0,A.$kc)(g,m[h])}}}catch{}return null}async function d(w){try{return await D.Promises.realpath(w)}catch{const f=v(w);return await D.Promises.access(f,I.constants.R_OK),f}}function C(w){try{return I.realpathSync(w)}catch{const f=v(w);return I.accessSync(f,I.constants.R_OK),f}}function v(w){return(0,j.$6e)((0,A.$ic)(w),A.sep)}}),define(le[147],he([0,1,15,5,36,89,13,31]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=P,e.$am=d,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function P(v=N.env){return v.comspec||"cmd.exe"}function d(v){let w=[],u=!1;const f=function(b){if(u){w.push(b);return}(!v.send(b,h=>{if(h&&console.error(h),u=!1,w.length>0){const g=w.slice(0);w=[],g.forEach(l=>f(l))}})||A.$i)&&(u=!0)};return{send:f}}var C;(function(v){async function w(u,f,b){if(I.$jc(u))return u;if(f===void 0&&(f=N.cwd()),I.$nc(u)!=="."||(b===void 0&&D.$Uf(N.env.PATH)&&(b=N.env.PATH.split(I.$uc)),b===void 0||b.length===0))return I.$kc(f,u);async function h(g){if(await R.Promises.exists(g)){let l;try{l=await R.Promises.stat(g)}catch(c){c.message.startsWith("EACCES")&&(l=await R.Promises.lstat(g))}return l?!l.isDirectory():!1}return!1}for(const g of b){let l;if(I.$jc(g)?l=I.$kc(g,u):l=I.$kc(f,g,u),await h(l))return l;let c=l+".com";if(await h(c)||(c=l+".exe",await h(c)))return c}return I.$kc(f,u)}v.findExecutable=w})(C||(e.win32=C={}))}),define(le[148],he([0,1,67,23]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=N;function N(D){return new Promise((R,P)=>{let d;const C=new Map;function v(u,f,b,m,h){const g=C.get(f);if(u===D||g){const l={name:w(b),cmd:b,pid:u,ppid:f,load:m,mem:h};C.set(u,l),u===D&&(d=l),g&&(g.children||(g.children=[]),g.children.push(l),g.children.length>1&&(g.children=g.children.sort((c,$)=>c.pid-$.pid)))}}function w(u){const f=/--utility-sub-type=network/i,b=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(b.exec(u))return"electron-crash-reporter";if(m.exec(u))return"winpty-agent";if(h.exec(u))return"conpty-agent";let l=g.exec(u);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?f.exec(u)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const c=/[a-zA-Z-]+\.js/g;let $="";do l=c.exec(u),l&&($+=l+" ");while(l);return $&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${$})`:u}if(process.platform==="win32"){const u=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,b)=>{se(["@vscode/windows-process-tree"],f,b)}).then(f=>{f.getProcessList(D,b=>{if(!b){P(new Error(`Root process ${D} not found`));return}f.getProcessCpuUsage(b,m=>{const h=new Map;m.forEach(g=>{const l=u(g.commandLine||"");h.set(g.pid,{name:w(l),cmd:l,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),d=h.get(D),d?(h.forEach(g=>{const l=h.get(g.ppid);l&&(l.children||(l.children=[]),l.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((l,c)=>l.pid-c.pid))}),R(d)):P(new Error(`Root process ${D} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let u=function(){let f=[d];const b=[];for(;f.length;){const h=f.shift();h&&(b.push(h.pid),h.children&&(f=f.concat(h.children)))}let m=JSON.stringify(A.$Bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+b.join(" "),(0,I.exec)(m,{},(h,g,l)=>{if(h||l)P(h||new Error(l.toString()));else{const c=g.toString().split(`
`);for(let $=0;$<b.length;$++){const i=C.get(b[$]);i.load=parseFloat(c[$])}if(!d){P(new Error(`Root process ${D} not found`));return}R(d)}})};(0,I.exec)("which ps",{},(f,b,m)=>{if(f||m)if(process.platform!=="linux")P(f||new Error(m.toString()));else{const h=JSON.stringify(A.$Bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(h,{},(g,l,c)=>{g||c?P(g||new Error(c.toString())):(j(l,v),u())})}else{const h=b.toString().trim();(0,I.exec)(`${h} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,$)=>{l||$&&!$.includes("screen size is bogus")?P(l||new Error($.toString())):(j(c,v),process.platform==="linux"?u():d?R(d):P(new Error(`Root process ${D} not found`)))})}})}})}function j(D,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const C of d){const v=P.exec(C.trim());v&&v.length===6&&R(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}});var ve=this&&this.__decorate||function(se,e,I,A){var N=arguments.length,j=N<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,I):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(se,e,I,A);else for(var R=se.length-1;R>=0;R--)(D=se[R])&&(j=(N<3?D(j):N>3?D(e,I,j):D(e,I))||j);return N>3&&j&&Object.defineProperty(e,I,j),j};define(le[40],he([0,1,17,6,14,26,84,7,3,2,66,27,13]),function(se,e,I,A,N,j,D,R,P,d,C,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=r,e.$Uh=a,e.$Zh=O,e.$1h=U;var u;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(u||(u={}));function f(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(b||(b={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));function g(V){let B=0;for(let ie=0;;ie+=7){const oe=V.read(1);if(B|=(oe.buffer[0]&127)<<ie,!(oe.buffer[0]&128))return B}}const l=n(0);function c(V,B){if(B===0){V.write(l);return}let ie=0;for(let te=B;te!==0;te=te>>>7)ie++;const oe=N.$ue.alloc(ie);for(let te=0;B!==0;te++)oe.buffer[te]=B&127,B=B>>>7,B>0&&(oe.buffer[te]|=128);V.write(oe)}class ${constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$Rh=$;class i{constructor(){this.a=[]}get buffer(){return N.$ue.concat(this.a)}write(B){this.a.push(B)}}e.$Sh=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const B=N.$ue.alloc(1);return B.writeUInt8(V,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(V,B){if(typeof B>"u")V.write(s.Undefined);else if(typeof B=="string"){const ie=N.$ue.fromString(B);V.write(s.String),c(V,ie.byteLength),V.write(ie)}else if(t&&Buffer.isBuffer(B)){const ie=N.$ue.wrap(B);V.write(s.Buffer),c(V,ie.byteLength),V.write(ie)}else if(B instanceof N.$ue)V.write(s.VSBuffer),c(V,B.byteLength),V.write(B);else if(Array.isArray(B)){V.write(s.Array),c(V,B.length);for(const ie of B)r(V,ie)}else if(typeof B=="number"&&(B|0)===B)V.write(s.Uint),c(V,B);else{const ie=N.$ue.fromString(JSON.stringify(B));V.write(s.Object),c(V,ie.byteLength),V.write(ie)}}function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(g(V)).toString();case o.Buffer:return V.read(g(V)).buffer;case o.VSBuffer:return V.read(g(V));case o.Array:{const ie=g(V),oe=[];for(let te=0;te<ie;te++)oe.push(a(V));return oe}case o.Object:return JSON.parse(V.read(g(V)).toString());case o.Int:return g(V)}}class y{constructor(B,ie,oe=null,te=1e3){this.h=B,this.j=ie,this.k=oe,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,m(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,m(B.type),B.data);return}}}o(B,ie=void 0){const oe=new i;return r(oe,B),r(oe,ie),this.p(oe.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new $(B),oe=a(ie),te=a(ie),ce=oe[0];switch(ce){case 100:return this.k?.logIncoming(B.byteLength,oe[1],1,`${f(ce)}: ${oe[2]}.${oe[3]}`,te),this.s({type:ce,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 102:return this.k?.logIncoming(B.byteLength,oe[1],1,`${f(ce)}: ${oe[2]}.${oe[3]}`,te),this.t({type:ce,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 101:return this.k?.logIncoming(B.byteLength,oe[1],1,`${f(ce)}`),this.u({type:ce,id:oe[1]});case 103:return this.k?.logIncoming(B.byteLength,oe[1],1,`${f(ce)}`),this.u({type:ce,id:oe[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const oe=new j.$ee;let te;try{te=ie.call(this.j,B.name,B.arg,oe.token)}catch(q){te=Promise.reject(q)}const ce=B.id;te.then(q=>{this.m({id:ce,data:q,type:201})},q=>{q instanceof Error?this.m({id:ce,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ce,data:q,type:203})}).finally(()=>{H.dispose(),this.d.delete(B.id)});const H=(0,d.$Sc)(()=>oe.cancel());this.d.set(B.id,H)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const oe=B.id,ce=ie.listen(this.j,B.name,B.arg)(H=>this.m({id:oe,data:H,type:204}));this.d.set(B.id,ce)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const oe=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:oe})}w(B){const ie=this.g.get(B);if(ie){for(const oe of ie)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=y;var E;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class k{constructor(B,ie=null){this.l=B,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ie}getChannel(B){const ie=this;return{call(oe,te,ce){return ie.a?Promise.reject(new R.$5):ie.m(B,oe,te,ce)},listen(oe,te){return ie.a?P.Event.None:ie.o(B,oe,te)}}}m(B,ie,oe,te=j.CancellationToken.None){const ce=this.g++,q={id:ce,type:100,channelName:B,name:ie,arg:oe};if(te.isCancellationRequested)return Promise.reject(new R.$5);let L;return new Promise((z,Y)=>{if(te.isCancellationRequested)return Y(new R.$5);const G=()=>{const ne=re=>{switch(re.type){case 201:this.f.delete(ce),z(re.data);break;case 202:{this.f.delete(ce);const ue=new Error(re.data.message);ue.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,ue.name=re.data.name,Y(ue);break}case 203:this.f.delete(ce),Y(re.data);break}};this.f.set(ce,ne),this.p(q)};let ee=null;this.b===h.Idle?G():(ee=(0,A.$7g)(ne=>this.u()),ee.then(()=>{ee=null,G()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:ce,type:101}),Y(new R.$5)},X=te.onCancellationRequested(_);L=(0,d.$Rc)((0,d.$Sc)(_),X),this.d.add(L)}).finally(()=>{L.dispose(),this.d.delete(L)})}o(B,ie,oe){const te=this.g++,H={id:te,type:102,channelName:B,name:ie,arg:oe};let q=null;const L=new P.$7d({onWillAddFirstListener:()=>{q=(0,A.$7g)(z=>this.u()),q.then(()=>{q=null,this.d.add(L),this.p(H)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(L),this.p({id:te,type:103}))}}),T=z=>L.fire(z.data);return this.f.set(te,T),L.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${f(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,f(B.type));return}}}q(B,ie=void 0){const oe=new i;return r(oe,B),r(oe,ie),this.r(oe.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new $(B),oe=a(ie),te=a(ie),ce=oe[0];switch(ce){case 200:return this.j?.logIncoming(B.byteLength,0,0,m(ce)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,oe[1],0,m(ce),te),this.t({type:oe[0],id:oe[1],data:te})}}t(B){if(B.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=k,ve([D.$Lh],k.prototype,"onDidInitializePromise",null);class S{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new P.$7d,this.onDidAddConnection=this.g.event,this.h=new P.$7d,this.onDidRemoveConnection=this.h.event,this.j=new d.$Tc,this.j.add(B(({protocol:ie,onDidClientDisconnect:oe})=>{const te=P.Event.once(ie.onMessage);this.j.add(te(ce=>{const H=new $(ce),q=a(H),L=new y(ie,q),T=new k(ie);this.a.forEach((Y,G)=>L.registerChannel(G,Y));const z={channelServer:L,channelClient:T,ctx:q};this.f.add(z),this.g.fire(z),this.j.add(oe(()=>{L.dispose(),T.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(B,ie){const oe=this;return{call(te,ce,H){let q;if((0,w.$9f)(ie)){const T=(0,I.$4b)(oe.connections.filter(ie));q=T?Promise.resolve(T):P.Event.toPromise(P.Event.filter(oe.onDidAddConnection,ie))}else q=ie.routeCall(oe,te,ce);const L=q.then(T=>T.channelClient.getChannel(B));return O(L).call(te,ce,H)},listen(te,ce){if((0,w.$9f)(ie))return oe.k(B,ie,te,ce);const H=ie.routeEvent(oe,te,ce).then(q=>q.channelClient.getChannel(B));return O(H).listen(te,ce)}}}k(B,ie,oe,te){const ce=this;let H;const q=new P.$7d({onWillAddFirstListener:()=>{H=new d.$Tc;const L=new P.$ae,T=new Map,z=G=>{const _=G.channelClient.getChannel(B).listen(oe,te),X=L.add(_);T.set(G,X)},Y=G=>{const ee=T.get(G);ee&&(ee.dispose(),T.delete(G))};ce.connections.filter(ie).forEach(z),P.Event.filter(ce.onDidAddConnection,ie)(z,void 0,H),ce.onDidRemoveConnection(Y,void 0,H),L.event(q.fire,q,H),H.add(L)},onDidRemoveLastListener:()=>{H?.dispose(),H=void 0}});return q.event}registerChannel(B,ie){this.a.set(B,ie);for(const oe of this.f)oe.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=S;class p{constructor(B,ie,oe=null){const te=new i;r(te,ie),B.send(te.buffer),this.a=new k(B,oe),this.d=new y(B,ie,oe)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=p;function O(V){return{call(B,ie,oe){return V.then(te=>te.call(B,ie,oe))},listen(B,ie){const oe=new P.$de;return V.then(te=>oe.input=te.listen(B,ie)),oe.event}}}function U(V){let B=!1;return{call(ie,oe,te){return B?V.call(ie,oe,te):(0,A.$ih)(0).then(()=>B=!0).then(()=>V.call(ie,oe,te))},listen(ie,oe){if(B)return V.listen(ie,oe);const te=new P.$de;return(0,A.$ih)(0).then(()=>B=!0).then(()=>te.input=V.listen(ie,oe)),te.event}}}class F{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$2h=F;var M;(function(V){function B(ce,H,q){const L=ce,T=q&&q.disableMarshalling,z=new Map;for(const Y in L)oe(Y)&&z.set(Y,P.Event.buffer(L[Y],!0,void 0,H));return new class{listen(Y,G,ee){const _=z.get(G);if(_)return _;const X=L[G];if(typeof X=="function"){if(te(G))return X.call(L,ee);if(oe(G))return z.set(G,P.Event.buffer(L[G],!0,void 0,H)),z.get(G)}throw new R.$bb(`Event not found: ${G}`)}call(Y,G,ee){const _=L[G];if(typeof _=="function"){if(!T&&Array.isArray(ee))for(let ne=0;ne<ee.length;ne++)ee[ne]=(0,C.$Qh)(ee[ne]);let X=_.apply(L,ee);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new R.$bb(`Method not found: ${G}`)}}}V.fromService=B;function ie(ce,H){const q=H&&H.disableMarshalling;return new Proxy({},{get(L,T){if(typeof T=="string")return H?.properties?.has(T)?H.properties.get(T):te(T)?function(z){return ce.listen(T,z)}:oe(T)?ce.listen(T):async function(...z){let Y;H&&!(0,w.$4f)(H.context)?Y=[H.context,...z]:Y=z;const G=await ce.call(T,Y);return q?G:(0,C.$Qh)(G)};throw new R.$bb(`Property not found: ${String(T)}`)}})}V.toService=ie;function oe(ce){return ce[0]==="o"&&ce[1]==="n"&&v.$kf(ce.charCodeAt(2))}function te(ce){return/^onDynamic/.test(ce)&&v.$kf(ce.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const B=V.toString();if(B!=="[object Object]")return B}return V}function Z(V){return Array.isArray(V)?V.map(J):J(V)}function W(V,B,ie,oe,te,ce,H){H=Z(H);const q=x[te],L=q[oe%q.length];let T=[`%c[${V}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(ce)?(T=T.concat(H),T.push(")")):T.push(H),console.log.apply(console,T)}class K{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,oe,te,ce){this.b+=B,W(this.d,this.b,B,ie,oe,te,ce)}logIncoming(B,ie,oe,te,ce){this.a+=B,W(this.f,this.a,B,ie,oe,te,ce)}}e.$3h=K}),define(le[68],he([0,1,14,3,2,40]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.ProtocolConstants=e.$4h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(E,k){if(!t.has(E)){const S=String(++r);t.set(E,S)}return t.get(E)}function y(E,k,S,p){if(!s.enableDiagnostics)return;const O=a(E,k);if(p instanceof I.$ue||p instanceof Uint8Array||p instanceof ArrayBuffer||ArrayBuffer.isView(p)){const U=I.$ue.alloc(p.byteLength);U.set(p),s.records.push({timestamp:Date.now(),id:O,label:k,type:S,buff:U})}else s.records.push({timestamp:Date.now(),id:O,label:k,type:S,data:p})}s.traceSocketEvent=y})(R||(e.SocketDiagnostics=R={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let d=null;function C(){return d||(d=I.$ue.alloc(0)),d}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const k=this.a[0];return r&&(this.a.shift(),this.b-=t),k}if(this.a[0].byteLength>t){const k=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),k}const a=I.$ue.alloc(t);let y=0,E=0;for(;t>0;){const k=this.a[E];if(k.byteLength>t){const S=k.slice(0,t);a.set(S,y),y+=t,r&&(this.a[E]=k.slice(t),this.b-=t),t-=t}else a.set(k,y),y+=k.byteLength,r?(this.a.shift(),this.b-=k.byteLength):E++,t-=k.byteLength}return a}}e.$4h=v;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function u(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class b{constructor(t,r,a,y){this.type=t,this.id=r,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends N.$Uc{constructor(t){super(),this.f=this.B(new A.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new v,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,y=this.g.id,E=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,y,E,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$ue.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=I.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class g extends N.$Uc{constructor(t){super(),this.f=new A.$7d,this.onMessage=this.f.event,this.g=new A.$7d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$5h=g;class l extends j.$Yh{static fromSocket(t,r){return new l(new g(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$6h=l;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$7h=c;class ${constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new $(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let y=0;y<o.a;y++)t-this.c[y]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Tc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,C());this.p.write(t)}sendResume(){const t=new b(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new N.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(r>=2e4&&a>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const E=Math.max(2e4-r,2e4-a,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},E)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,C());this.p.write(t)}}e.$8h=n}),define(le[92],he([0,1,67,6,14,26,142,7,3,2,30,147,89,40]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class f extends u.$Vh{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>N.$ue.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Iq=f;class b{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new P.$7d,this.onDidProcessExit=this.h.event;const l=g&&g.timeout?g.timeout:6e4;this.b=new A.$eh(l),this.d=null,this.f=null}getChannel(h){const g=this;return{call(l,c,$){return g.k(h,l,c,$)},listen(l,c){return g.l(h,l,c)}}}k(h,g,l,c=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const $=this.n(h),i=(0,A.$7g)(s=>$.call(g,l,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,d.$Sc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(h,g,l){if(!this.b)return P.Event.None;this.b.cancel();let c;const $=new P.$7d({onWillAddFirstListener:()=>{c=this.n(h).listen(g,l)($.fire,$),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,C.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,w.$$l)(g.env),this.d=(0,I.fork)(this.i,h,g);const l=new P.$7d;P.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,D.$Eq)(t)){(0,D.log)(t,`IPC Library: ${this.j.serverName}`);return}l.fire(N.$ue.wrap(Buffer.from(t,"base64")))});const $=this.j.useQueue?(0,v.$am)(this.d):this.d,i=t=>this.d&&this.d.connected&&$.send(t.buffer.toString("base64")),o=l.event,n={send:i,onMessage:o};this.f=new u.$Wh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,d.$Pc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jq=b}),define(le[149],he([0,1,134,14,40,3,13,17]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aW=void 0,e.$bW=C;class P{constructor(w){this.a=w,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",u=>u.data?A.$ue.wrap(u.data):A.$ue.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class d extends N.$Xh{static b(w){(0,D.$5f)((0,I.$_V)(process),"Electron Utility Process");const u=new j.$7d;return process.parentPort.on("message",f=>{if(w?.handledClientConnection(f))return;const b=(0,R.$Ob)(f.ports);b&&u.fire(b)}),j.Event.map(u.event,f=>({protocol:new P(f),onDidClientDisconnect:j.Event.fromNodeEventEmitter(f,"close")}))}constructor(w){super(d.b(w))}}e.$aW=d;function C(v,w,u){const f=b=>{b.data===w&&(v.removeListener("message",f),u())};v.on("message",f)}}),define(le[69],he([0,1,6,3,2,66,13]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=P;var R;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function P(w){const u=w;return u?.changed instanceof Map||u?.deleted instanceof Set}var d;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(d||(e.StorageState=d={}));class C extends N.$Uc{static{this.a=100}constructor(u,f=Object.create(null)){super(),this.r=u,this.s=f,this.b=this.B(new A.$0d),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new I.$fh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((f,b)=>this.w(b,f)),u.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(u,f){if(this.c===d.Closed)return;let b=!1;(0,D.$4f)(f)?b=this.f.delete(u):this.f.get(u)!==f&&(this.f.set(u,f),b=!0),b&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,f){const b=this.f.get(u);return(0,D.$4f)(b)?f:b}getBoolean(u,f){const b=this.get(u);return(0,D.$4f)(b)?f:b==="true"}getNumber(u,f){const b=this.get(u);return(0,D.$4f)(b)?f:parseInt(b,10)}getObject(u,f){const b=this.get(u);return(0,D.$4f)(b)?f:(0,j.$Ph)(b)}async set(u,f,b=!1){if(this.c===d.Closed)return;if((0,D.$4f)(f))return this.delete(u,b);const m=(0,D.$Wf)(f)||Array.isArray(f)?(0,j.$Oh)(f):String(f);if(this.f.get(u)!==m)return this.f.set(u,m),this.j.set(u,m),this.h.delete(u),this.b.fire({key:u,external:b}),this.D()}async delete(u,f=!1){if(!(this.c===d.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:f}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Hp=C;class v{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((f,b)=>this.a.set(b,f)),u.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$Ip=v}),define(le[150],he([11,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,43,6,15,13,31,150]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0,e.zip=m,e.$6p=h,e.$7p=l,e.$3p="end of central directory record signature not found";const P=new RegExp(e.$3p);class d extends Error{constructor($,i){let o=i.message;switch($){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=$,this.cause=i}}e.$4p=d;function C(c){const $=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>$&i).reduce((i,o)=>i+o,$&61440)}function v(c){if(c instanceof d)return c;let $;return P.test(c.message)&&($="CorruptZip"),new d($,c)}function w(c,$,i,o,n,s){const t=N.$nc($),r=N.$kc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,$)));const a=N.$kc(o,$);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(D.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((E,k)=>{if(!s.isCancellationRequested)try{y=(0,I.createWriteStream)(a,{mode:i}),y.once("close",()=>E()),y.once("error",k),c.once("error",k),c.pipe(y)}catch(S){k(S)}}))}function u(c,$,i,o){let n=(0,A.$7g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const y=new A.$ch,E=k=>{k.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new d("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",k=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){E(o);return}const S=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(S)){const U=N.$kc($,S);n=(0,A.$7g)(F=>D.Promises.mkdir(U,{recursive:!0}).then(()=>E(F)).then(void 0,a));return}const p=b(c,k),O=C(k);n=(0,A.$7g)(U=>y.queue(()=>p.then(F=>w(F,S,O,$,i,U).then(()=>E(U)))).then(null,a))})}).finally(()=>t.dispose())}async function f(c,$=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,$?{lazyEntries:!0}:void 0,(s,t)=>{s?n(v(s)):o((0,j.$6f)(t))})})}function b(c,$){return new Promise((i,o)=>{c.openReadStream($,(n,s)=>{n?o(v(n)):i((0,j.$6f)(s))})})}async function m(c,$){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;$.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,I.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function h(c,$,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=f(c,!0);return i.overwrite&&(s=s.then(t=>D.Promises.rm($).then(()=>t))),s.then(t=>u(t,$,{sourcePathRegex:n},o))}function g(c,$){return f(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===$&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,$))))}))}function l(c,$){return g(c,$).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(le[151],he([11,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[152],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[153],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[154],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[155],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[156],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[157],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[158],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[159],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[160],he([11,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[161],he([11,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[162],he([11,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[163],he([11,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[164],he([11,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[165],he([11,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[166],he([11,10]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[167],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[168],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[169],he([11,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[170],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[171],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[172],he([11,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[173],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[174],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[175],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[176],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[177],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[178],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[179],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[180],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[181],he([11,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[182],he([0,1,7,153]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var N;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(N||(e.TokenType=N={}));function j(...d){switch(d.length){case 1:return(0,A.localize)(0,null,d[0]);case 2:return(0,A.localize)(1,null,d[0],d[1]);case 3:return(0,A.localize)(2,null,d[0],d[1],d[2]);default:return}}const D=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const v=this.d,w=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:w};this.g.push({offset:v,lexeme:w,additionalInfo:C}),this.f.push(u)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const v=this.c.substring(this.d,this.e),w=P.b.get(v);w?this.k(w):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,v=!1,w=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const f=this.c.charCodeAt(C);if(v)v=!1;else if(f===47&&!w){C++;break}else f===91?w=!0:f===92?v=!0:f===93&&(w=!1);C++}for(;C<this.c.length&&P.a.has(this.c.charCodeAt(C));)C++;this.e=C;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=P}),define(le[183],he([0,1,65,84,23,15,36,20,8]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Rm=C,e.$Sm=v,e.$Pm=/^([^.]+\..+)[:=](.+)$/;class d{get appRoot(){return(0,j.$nc)(N.$Bg.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,j.$kc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,I.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$kc)(this.userDataPath,"logs",u)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Ug)(P.URI.file((0,j.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?P.URI.file((0,j.$kc)(u,"argv.json")):(0,R.$Ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,j.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,j.$lc)(u):(0,j.$ic)((0,j.$kc)(N.$Bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?P.URI.file((0,j.$lc)(u)):P.URI.file((0,j.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,j.$lc)(u);const f=D.env.VSCODE_EXTENSIONS;if(f)return f;const b=D.env.VSCODE_PORTABLE;return b?(0,j.$kc)(b,"extensions"):(0,R.$Ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(f=>/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,j.$ic)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?P.URI.parse(u):P.URI.file((0,j.$ic)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$Pm.test(u))}get extensionLogLevel(){const u=[];for(const f of this.args.log||[]){const b=e.$Pm.exec(f);b&&b[1]&&b[2]&&u.push([b[1],b[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,R.$Ug)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?P.URI.file((0,j.$kc)(u,"policy.json")):(0,R.$Ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,f,b){this.a=u,this.b=f,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Qm=d,ve([A.$Lh],d.prototype,"appRoot",null),ve([A.$Lh],d.prototype,"userHome",null),ve([A.$Lh],d.prototype,"userDataPath",null),ve([A.$Lh],d.prototype,"appSettingsHome",null),ve([A.$Lh],d.prototype,"tmpDir",null),ve([A.$Lh],d.prototype,"cacheHome",null),ve([A.$Lh],d.prototype,"stateResource",null),ve([A.$Lh],d.prototype,"userRoamingDataHome",null),ve([A.$Lh],d.prototype,"userDataSyncHome",null),ve([A.$Lh],d.prototype,"sync",null),ve([A.$Lh],d.prototype,"machineSettingsResource",null),ve([A.$Lh],d.prototype,"workspaceStorageHome",null),ve([A.$Lh],d.prototype,"localHistoryHome",null),ve([A.$Lh],d.prototype,"keyboardLayoutResource",null),ve([A.$Lh],d.prototype,"argvResource",null),ve([A.$Lh],d.prototype,"isExtensionDevelopment",null),ve([A.$Lh],d.prototype,"untitledWorkspacesHome",null),ve([A.$Lh],d.prototype,"builtinExtensionsPath",null),ve([A.$Lh],d.prototype,"extensionsPath",null),ve([A.$Lh],d.prototype,"extensionDevelopmentLocationURI",null),ve([A.$Lh],d.prototype,"extensionDevelopmentKind",null),ve([A.$Lh],d.prototype,"extensionTestsLocationURI",null),ve([A.$Lh],d.prototype,"debugExtensionHost",null),ve([A.$Lh],d.prototype,"logLevel",null),ve([A.$Lh],d.prototype,"extensionLogLevel",null),ve([A.$Lh],d.prototype,"serviceMachineIdResource",null),ve([A.$Lh],d.prototype,"disableTelemetry",null),ve([A.$Lh],d.prototype,"disableWorkspaceTrust",null),ve([A.$Lh],d.prototype,"useInMemorySecretStorage",null),ve([A.$Lh],d.prototype,"policyFile",null);function C(w,u){return v(w["inspect-extensions"],w["inspect-brk-extensions"],5870,u,w.debugId,w.extensionEnvironment)}function v(w,u,f,b,m,h){const l=Number(u||w)||(b?null:f),c=l?!!u:!1;let $;if(h)try{$=JSON.parse(h)}catch{}return{port:l,break:c,debugId:m,env:$}}}),function(){"use strict";function se(e,I,A){function N(D,R){const P=j(D,R),d=[P];return e.isAbsolute(P)||d.unshift(A),e.resolve(...d)}function j(D,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,R);const C=D["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(v,"AppData","Roaming")}break;case"darwin":d=e.join(I.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,R)}return{getUserDataPath:N}}if(typeof define=="function")define(le[184],he([275,37,36]),function(e,I,A){return se(e,I,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=se(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[185],he([0,1,37,183,184]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0,e.$Um=D,e.$Vm=R;class j extends A.$Qm{constructor(d,C){super(d,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,N.getUserDataPath)(d,C.nameShort)},C)}}e.$Tm=j;function D(P,d){return(0,A.$Sm)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,d,P.extensionEnvironment)}function R(P,d){return(0,A.$Sm)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,d,P.extensionEnvironment)}}),define(le[186],he([0,1,13,156]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=N;function N(D,R,P,d){try{j(D,R,P,d)}catch(C){D.error(C?.message??C)}return R}function j(D,R,P,d){const C=(v,w,u)=>{const f=v[w];if((0,I.$Uf)(f)){const b=f,m=b.length;if(m>1&&b[0]==="%"&&b[m-1]==="%"){const h=b.substr(1,m-2);let g=P[h];g===void 0&&d&&(g=d[h]);const l=typeof g=="string"?g:g?.message,c=d?.[h],$=typeof c=="string"?c:c?.message;if(!l){$||D.warn(`[${R.name}]: ${(0,A.localize)(0,null,h)}`);return}if(u&&(w==="title"||w==="category")&&$&&$!==l){const i={value:l,original:$};v[w]=i}else v[w]=l}}else if((0,I.$Wf)(f))for(const b in f)f.hasOwnProperty(b)&&(b==="commands"?C(f,b,!0):C(f,b,u));else if(Array.isArray(f))for(let b=0;b<f.length;b++)C(f,b,u)};for(const v in R)R.hasOwnProperty(v)&&C(R,v)}}),define(le[187],he([0,1,70,159]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=N;function N(j){return(0,I.$7p)(j,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}}),define(le[188],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;class I{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$wcc=I;class A{constructor(j){this.a=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,R){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${D}`)}}e.$xcc=A}),define(le[71],he([0,1,20,88,160,55]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=P,e.$sp=d,e.$tp=C,e.$up=v,e.$vp=w,e.$wp=u,e.$xp=f;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(h){return h=h.trim(),h==="*"||D.test(h)}function d(h){if(!P(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(D);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function C(h){if(!h)return null;const g=h.majorBase,l=h.majorMustEqual,c=h.minorBase;let $=h.minorMustEqual;const i=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(g===0||($=!1),o=!1);let n=0;if(h.preRelease){const s=R.exec(h.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:g,majorMustEqual:l,minorBase:c,minorMustEqual:$,patchBase:i,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:n}}function v(h,g,l){let c;typeof h=="string"?c=C(d(h)):c=h;let $;g instanceof Date?$=g.getTime():typeof g=="string"&&($=new Date(g).getTime());let i;if(typeof l=="string"?i=C(d(l)):i=l,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const y=i.notBefore;let E=i.majorMustEqual,k=i.minorMustEqual,S=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||$&&$<y?!1:s>=a:(o===1&&t===0&&(!E||!k||!S)&&(t=1,r=0,a=0,E=!0,k=!1,S=!1),o<t?!1:o>t?!E:n<r?!1:n>r?!k:s<a?!1:s>a?!S:!($&&$<y))}function w(h,g,l,c,$){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([A.default.Error,N.localize(0,null)]),i;if(typeof c.name!="string")return i.push([A.default.Error,N.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([A.default.Error,N.localize(2,null,"version")]),i;if(!c.engines)return i.push([A.default.Error,N.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([A.default.Error,N.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!m(c.extensionDependencies))return i.push([A.default.Error,N.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!m(c.activationEvents))return i.push([A.default.Error,N.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([A.default.Error,N.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([A.default.Warning,N.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([A.default.Error,N.localize(9,null,"main")]),i;{const s=(0,I.$Ug)(l,c.main);(0,I.$Og)(s,l)||i.push([A.default.Warning,N.localize(10,null,s.path,l.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([A.default.Error,N.localize(11,null,"browser")]),i;{const s=(0,I.$Ug)(l,c.browser);(0,I.$Og)(s,l)||i.push([A.default.Warning,N.localize(12,null,s.path,l.path)])}}if(!j.valid(c.version))return i.push([A.default.Error,N.localize(13,null)]),i;const o=[];if(!u(h,g,c,$,o))for(const s of o)i.push([A.default.Error,s]);return i}function u(h,g,l,c,$){return c||typeof l.main>"u"&&typeof l.browser>"u"?!0:b(h,g,l.engines.vscode,$)}function f(h,g,l){return h==="*"||b(g,l,h)}function b(h,g,l,c=[]){const $=C(d(l));if(!$)return c.push(N.localize(14,null,l)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return c.push(N.localize(15,null,l)),!1}else if(!$.majorMustEqual)return c.push(N.localize(16,null,l)),!1;return v(h,g,$)?!0:(c.push(N.localize(17,null,h,l)),!1)}function m(h){if(!Array.isArray(h))return!1;for(let g=0,l=h.length;g<l;g++)if(typeof h[g]!="string")return!1;return!0}}),define(le[44],he([0,1,14,32]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=N;async function N(j,D,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await D.readFile(j.serviceMachineIdResource)).value.toString();P=(0,A.$Cg)(C)?C:null}catch{P=null}if(!P){P=(0,A.$Dg)();try{await D.writeFile(j.serviceMachineIdResource,I.$ue.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class I{constructor(N,j=[],D=!1){this.ctor=N,this.staticArguments=j,this.supportsDelayedInstantiation=D}}e.$ei=I}),define(le[189],he([0,1,72]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$fs=j,e.$gs=D;const A=[];var N;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function j(R,P,d){P instanceof I.$ei||(P=new I.$ei(P,[],!!d)),A.push([R,P])}function D(){return A}}),define(le[190],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;class I{constructor(j,D){this.key=j,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Vq=I;class A{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const D of this.a.values())D.outgoing.size===0&&j.push(D);return j}insertEdge(j,D){const R=this.lookupOrInsertNode(j),P=this.lookupOrInsertNode(D);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(j){const D=this.b(j);this.a.delete(D);for(const R of this.a.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(j){const D=this.b(j);let R=this.a.get(D);return R||(R=new I(D,j),this.a.set(D,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[D,R]of this.a)j.push(`${D}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,D]of this.a){const R=new Set([j]),P=this.c(D,R);if(P)return P}}c(j,D){for(const[R,P]of j.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const d=this.c(P,D);if(d)return d;D.delete(R)}}}e.$Wq=A}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=N,e.$ii=j;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=R})(I||(e._util=I={})),e.$gi=N("instantiationService");function A(D,R,P){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:D,index:P}):(R[I.DI_DEPENDENCIES]=[{id:D,index:P}],R[I.DI_TARGET]=R)}function N(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const R=function(P,d,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,P,C)};return R.toString=()=>D,I.serviceIds.set(D,R),R}function j(D){return D}}),define(le[191],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0,e.$9bc=(0,I.$hi)("checksumService")}),define(le[21],he([0,1,13,8,4]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=j,e.$Pi=D,e.$Qi=P,e.$Ri=d,e.$Si=C,e.$Ti=v,e.$Ui=w,e.$Vi=f,e.$Wi=b,e.$Xi=m,e.$Ni=(0,N.$hi)("configurationService");function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof A.URI)}function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof A.URI)}var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function P(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function d(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function C(h,g){const l=Object.create(null);for(const c in h)v(l,c,h[c],g);return l}function v(h,g,l,c){const $=g.split("."),i=$.pop();let o=h;for(let n=0;n<$.length;n++){const s=$[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${g} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=l}catch{c(`Ignoring ${g} as ${$.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${g} as ${$.join(".")} is ${JSON.stringify(o)}`)}function w(h,g){const l=g.split(".");u(h,l)}function u(h,g){const l=g.shift();if(g.length===0){delete h[l];return}if(Object.keys(h).indexOf(l)!==-1){const c=h[l];typeof c=="object"&&!Array.isArray(c)&&(u(c,g),Object.keys(c).length===0&&delete h[l])}}function f(h,g,l){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const $=g.split("."),i=c(h,$);return typeof i>"u"?l:i}function b(h,g,l){Object.keys(g).forEach(c=>{c!=="__proto__"&&(c in h?I.$Wf(h[c])&&I.$Wf(g[c])?b(h[c],g[c],l):l&&(h[c]=g[c]):h[c]=g[c])})}function m(h){return h.replace(/[\[\]]/g,"")}}),define(le[93],he([0,1,5,27,182,4,152,7]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=d,e.$gj=o,e.$hj=n,e.$Aj=te;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",I.$j),P.set("isLinux",I.$k),P.set("isWindows",I.$i),P.set("isWeb",I.$o),P.set("isMacNative",I.$j&&!I.$o),P.set("isEdge",I.$H),P.set("isFirefox",I.$F),P.set("isChrome",I.$E),P.set("isSafari",I.$G);function d(q,L){if(P.get(q)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(q,L)}const C=Object.prototype.hasOwnProperty;var v;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const w={regexParsingWithErrorRecovery:!0},u=(0,D.localize)(0,null),f=(0,D.localize)(1,null),b=(0,D.localize)(2,null),m=(0,D.localize)(3,null),h=(0,D.localize)(4,null),g=(0,D.localize)(5,null),l=(0,D.localize)(6,null),c=(0,D.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=w){this.k=L,this.d=new N.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const z=this.D(),Y=z.type===17?g:void 0;throw this.h.push({message:h,offset:z.offset,lexeme:N.$cj.getLexeme(z),additionalInfo:Y}),$.c}return T}catch(T){if(T!==$.c)throw T;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const T=this.o();L.push(T)}return L.length===1?L[0]:i.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const T=this.s();L.push(T)}return L.length===1?L[0]:i.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,m),T?.negate()}case 17:return this.z(),p.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,m),T}case 17:{const T=L.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const G=Y.lexeme,ee=G.lastIndexOf("/"),_=ee===G.length-1?void 0:this.w(G.substring(ee+1));let X;try{X=new RegExp(G.substring(1,ee),_)}catch{throw this.B("REGEX",Y)}return J.create(T,X)}switch(Y.type){case 10:case 19:{const G=[Y.lexeme];this.z();let ee=this.D(),_=0;for(let de=0;de<Y.lexeme.length;de++)Y.lexeme.charCodeAt(de)===40?_++:Y.lexeme.charCodeAt(de)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let de=0;de<ee.lexeme.length;de++)ee.lexeme.charCodeAt(de)===40?_++:Y.lexeme.charCodeAt(de)===41&&_--}if(_<0)break;G.push(N.$cj.getLexeme(ee)),this.z(),ee=this.D()}const X=G.join(""),ne=X.lastIndexOf("/"),re=ne===X.length-1?void 0:this.w(X.substring(ne+1));let ue;try{ue=new RegExp(X.substring(1,ne),re)}catch{throw this.B("REGEX",Y)}return i.regex(T,ue)}case 18:{const G=Y.lexeme;this.z();let ee=null;if(!(0,A.$Ue)(G)){const _=G.indexOf("/"),X=G.lastIndexOf("/");if(_!==X&&_>=0){const ne=G.slice(_+1,X),re=G[X+1]==="i"?"i":"";try{ee=new RegExp(ne,re)}catch{throw this.B("REGEX",Y)}}}if(ee===null)throw this.B("REGEX",Y);return J.create(T,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const Y=this.u();return i.notIn(T,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return i.equals(T,Y);switch(Y){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return i.notEquals(T,Y);switch(Y){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,Y)}}case 5:return this.z(),M.create(T,this.u());case 6:return this.z(),x.create(T,this.u());case 7:return this.z(),U.create(T,this.u());case 8:return this.z(),F.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:l,offset:L.offset,lexeme:"",additionalInfo:c}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,T){if(this.C(L))return this.z();throw this.B(T,this.D())}B(L,T,z){const Y=(0,D.localize)(8,null,L,N.$cj.getLexeme(T)),G=T.offset,ee=N.$cj.getLexeme(T);return this.h.push({message:Y,offset:G,lexeme:ee,additionalInfo:z}),$.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=$;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(L){return a.create(L)}static equals(L,T){return y.create(L,T)}static notEquals(L,T){return S.create(L,T)}static regex(L,T){return J.create(L,T)}static in(L,T){return E.create(L,T)}static notIn(L,T){return k.create(L,T)}static not(L){return p.create(L)}static and(...L){return K.create(L,null,!0)}static or(...L){return V.create(L,null,!0)}static greater(L,T){return U.create(L,T)}static greaterEquals(L,T){return F.create(L,T)}static smaller(L,T){return M.create(L,T)}static smallerEquals(L,T){return x.create(L,T)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$fj=i;function o(q){const L=new $({regexParsingWithErrorRecovery:!1});return q.map(T=>(L.parse(T),L.lexingErrors.length>0?L.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,D.localize)(9,null,z.additionalInfo):(0,D.localize)(10,null),offset:z.offset,length:z.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(q,L){const T=q?q.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!T&&!z?!0:!T||!z?!1:T.equals(z)}function s(q,L){return q.cmp(L)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return r.INSTANCE}}e.$ij=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return t.INSTANCE}}e.$jj=r;class a{static create(L,T=null){const z=P.get(L);return typeof z=="boolean"?z?r.INSTANCE:t.INSTANCE:new a(L,T)}constructor(L,T){this.key=L,this.c=T,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?r.INSTANCE:t.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.$kj=a;class y{static create(L,T,z=null){if(typeof T=="boolean")return T?a.create(L,z):p.create(L,z);const Y=P.get(L);return typeof Y=="boolean"?T===(Y?"true":"false")?r.INSTANCE:t.INSTANCE:new y(L,T,z)}constructor(L,T,z){this.c=L,this.d=T,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=P.get(this.c);if(typeof L=="boolean"){const T=L?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$lj=y;class E{static create(L,T){return new E(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const T=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(T)?T.includes(z):typeof z=="string"&&typeof T=="object"&&T!==null?C.call(T,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$mj=E;class k{static create(L,T){return new k(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=11,this.c=E.create(L,T)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=k;class S{static create(L,T,z=null){if(typeof T=="boolean")return T?p.create(L,z):a.create(L,z);const Y=P.get(L);return typeof Y=="boolean"?T===(Y?"true":"false")?t.INSTANCE:r.INSTANCE:new S(L,T,z)}constructor(L,T,z){this.c=L,this.d=T,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=P.get(this.c);if(typeof L=="boolean"){const T=L?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$oj=S;class p{static create(L,T=null){const z=P.get(L);return typeof z=="boolean"?z?t.INSTANCE:r.INSTANCE:new p(L,T)}constructor(L,T){this.c=L,this.d=T,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=P.get(this.c);return typeof L=="boolean"?L?t.INSTANCE:r.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$pj=p;function O(q,L){if(typeof q=="string"){const T=parseFloat(q);isNaN(T)||(q=T)}return typeof q=="string"||typeof q=="number"?L(q):t.INSTANCE}class U{static create(L,T,z=null){return O(T,Y=>new U(L,Y,z))}constructor(L,T,z){this.c=L,this.d=T,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$qj=U;class F{static create(L,T,z=null){return O(T,Y=>new F(L,Y,z))}constructor(L,T,z){this.c=L,this.d=T,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$rj=F;class M{static create(L,T,z=null){return O(T,Y=>new M(L,Y,z))}constructor(L,T,z){this.c=L,this.d=T,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$sj=M;class x{static create(L,T,z=null){return O(T,Y=>new x(L,Y,z))}constructor(L,T,z){this.c=L,this.d=T,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$tj=x;class J{static create(L,T){return new J(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const T=this.f?this.f.source:"",z=L.f?L.f.source:"";return T<z?-1:T>z?1:0}equals(L){if(L.type===this.type){const T=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&T===z}return!1}substituteConstants(){return this}evaluate(L){const T=L.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$uj=J;class Z{static create(L){return new Z(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new Z(this.c.map(L))}negate(){return this.c}}e.$vj=Z;function W(q){let L=null;for(let T=0,z=q.length;T<z;T++){const Y=q[T].substituteConstants();if(q[T]!==Y&&L===null){L=[];for(let G=0;G<T;G++)L[G]=q[G]}L!==null&&(L[T]=Y)}return L===null?q:L}class K{static create(L,T,z){return K.d(L,T,z)}constructor(L,T){this.expr=L,this.c=T,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let T=0,z=this.expr.length;T<z;T++){const Y=s(this.expr[T],L.expr[T]);if(Y!==0)return Y}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let T=0,z=this.expr.length;T<z;T++)if(!this.expr[T].equals(L.expr[T]))return!1;return!0}return!1}substituteConstants(){const L=W(this.expr);return L===this.expr?this:K.create(L,this.c,!1)}evaluate(L){for(let T=0,z=this.expr.length;T<z;T++)if(!this.expr[T].evaluate(L))return!1;return!0}static d(L,T,z){const Y=[];let G=!1;for(const ee of L)if(ee){if(ee.type===1){G=!0;continue}if(ee.type===0)return t.INSTANCE;if(ee.type===6){Y.push(...ee.expr);continue}Y.push(ee)}if(Y.length===0&&G)return r.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(s);for(let ee=1;ee<Y.length;ee++)Y[ee-1].equals(Y[ee])&&(Y.splice(ee,1),ee--);if(Y.length===1)return Y[0];for(;Y.length>1;){const ee=Y[Y.length-1];if(ee.type!==9)break;Y.pop();const _=Y.pop(),X=Y.length===0,ne=V.create(ee.expr.map(re=>K.create([re,_],null,z)),null,X);ne&&(Y.push(ne),Y.sort(s))}if(Y.length===1)return Y[0];if(z){for(let ee=0;ee<Y.length;ee++)for(let _=ee+1;_<Y.length;_++)if(Y[ee].negate().equals(Y[_]))return t.INSTANCE;if(Y.length===1)return Y[0]}return new K(Y,T)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const T of this.expr)L.push(...T.keys());return L}map(L){return new K(this.expr.map(T=>T.map(L)),null)}negate(){if(!this.c){const L=[];for(const T of this.expr)L.push(T.negate());this.c=V.create(L,this,!0)}return this.c}}e.$wj=K;class V{static create(L,T,z){return V.d(L,T,z)}constructor(L,T){this.expr=L,this.c=T,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let T=0,z=this.expr.length;T<z;T++){const Y=s(this.expr[T],L.expr[T]);if(Y!==0)return Y}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let T=0,z=this.expr.length;T<z;T++)if(!this.expr[T].equals(L.expr[T]))return!1;return!0}return!1}substituteConstants(){const L=W(this.expr);return L===this.expr?this:V.create(L,this.c,!1)}evaluate(L){for(let T=0,z=this.expr.length;T<z;T++)if(this.expr[T].evaluate(L))return!0;return!1}static d(L,T,z){let Y=[],G=!1;if(L){for(let ee=0,_=L.length;ee<_;ee++){const X=L[ee];if(X){if(X.type===0){G=!0;continue}if(X.type===1)return r.INSTANCE;if(X.type===9){Y=Y.concat(X.expr);continue}Y.push(X)}}if(Y.length===0&&G)return t.INSTANCE;Y.sort(s)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let ee=1;ee<Y.length;ee++)Y[ee-1].equals(Y[ee])&&(Y.splice(ee,1),ee--);if(Y.length===1)return Y[0];if(z){for(let ee=0;ee<Y.length;ee++)for(let _=ee+1;_<Y.length;_++)if(Y[ee].negate().equals(Y[_]))return r.INSTANCE;if(Y.length===1)return Y[0]}return new V(Y,T)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const T of this.expr)L.push(...T.keys());return L}map(L){return new V(this.expr.map(T=>T.map(L)),null)}negate(){if(!this.c){const L=[];for(const T of this.expr)L.push(T.negate());for(;L.length>1;){const T=L.shift(),z=L.shift(),Y=[];for(const G of H(T))for(const ee of H(z))Y.push(K.create([G,ee],null,!1));L.unshift(V.create(Y,null,!1))}this.c=V.create(L,this,!0)}return this.c}}e.$xj=V;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(L,T,z){super(L,null),this.f=T,typeof z=="object"?B.d.push({...z,key:L}):z!==!0&&B.d.push({key:L,description:z,type:T!=null?typeof T:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return y.create(this.key,L)}notEqualsTo(L){return S.create(this.key,L)}}e.$yj=B,e.$zj=(0,j.$hi)("contextKeyService");function ie(q,L){return q<L?-1:q>L?1:0}function oe(q,L,T,z){return q<T?-1:q>T?1:L<z?-1:L>z?1:0}function te(q,L){if(q.type===0||L.type===1)return!0;if(q.type===9)return L.type===9?ce(q.expr,L.expr):!1;if(L.type===9){for(const T of L.expr)if(te(q,T))return!0;return!1}if(q.type===6){if(L.type===6)return ce(L.expr,q.expr);for(const T of q.expr)if(te(T,L))return!0;return!1}return q.equals(L)}function ce(q,L){let T=0,z=0;for(;T<q.length&&z<L.length;){const Y=q[T].cmp(L[z]);if(Y<0)return!1;Y===0&&T++,z++}return T===q.length}function H(q){return q.type===9?q.expr:[q]}}),define(le[94],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$1m=e.ID=void 0,e.$2m=A,e.ID="diagnosticsService",e.$1m=(0,I.$hi)(e.ID);function A(j){return!!j.hostName&&!!j.errorMessage}class N{async getPerformanceInfo(D,R){return{}}async getSystemInfo(D,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,R){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$3m=N}),define(le[95],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,e.$vo=(0,I.$hi)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,I.$hi)("environmentService"),e.$pi=(0,I.$ii)(e.$oi)}),define(le[29],he([0,1,155,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=N,e.$Lo=j,e.$Mo=D,e.$No=R,e.$Oo=P,e.$Po=d,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function N(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function D(l,c){switch(l){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(l,c){return c==="web"&&!l.includes("web")}function P(l,c,$){return R(c,$)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===$}function d(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var v;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var w;(function(l){l.Install="install",l.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var u;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$Qo=(0,A.$hi)("extensionGalleryService");var f;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var b;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class m extends Error{constructor(c,$){super(c),this.code=$,this.name=$}}e.$Ro=m;var h;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(h||(e.ExtensionGalleryErrorCode=h={}));class g extends Error{constructor(c,$){super(c),this.code=$,this.name=$}}e.$So=g,e.$To=(0,A.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,A.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,A.$hi)("IExtensionTipsService"),e.$Yo=(0,I.localize2)(0,"Extensions"),e.$Zo=(0,I.localize2)(1,"Preferences")}),define(le[192],he([0,1,3,2,30,8,91,29]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=void 0;function P(m,h){return m?j.URI.revive(h?h.transformIncoming(m):m):void 0}function d(m,h){return h?h.transformOutgoingURI(m):m}function C(m,h){h=h||D.$kn;const g=m.manifest;return{...(0,D.$nn)({...m,manifest:void 0},h),manifest:g}}function v(m,h){return m?.profileLocation?(0,D.$nn)(m,h??D.$kn):m}function w(m,h){return h?(0,N.$Pn)(m,g=>g instanceof j.URI?h.transformOutgoingURI(g):void 0):m}class u{constructor(h,g){this.a=h,this.b=g,this.onInstallExtension=I.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,g){const l=this.b(h);switch(g){case"onInstallExtension":return I.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?d(c.profileLocation,l):c.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,c=>c.map($=>({...$,local:$.local?w($.local,l):$.local,profileLocation:$.profileLocation?d($.profileLocation,l):$.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?d(c.profileLocation,l):c.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?d(c.profileLocation,l):c.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,c=>w(c,l))}throw new Error("Invalid listen")}async call(h,g,l){const c=this.b(h);switch(g){case"zip":{const $=C(l[0],c),i=await this.a.zip($);return d(i,c)}case"unzip":return this.a.unzip(P(l[0],c));case"install":return this.a.install(P(l[0],c),v(l[1],c));case"installFromLocation":return this.a.installFromLocation(P(l[0],c),P(l[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],P(l[1],c),P(l[2],c));case"getManifest":return this.a.getManifest(P(l[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],v(l[1],c));case"installGalleryExtensions":{const $=l[0];return this.a.installGalleryExtensions($.map(({extension:i,options:o})=>({extension:i,options:v(o,c)??{}})))}case"uninstall":return this.a.uninstall(C(l[0],c),v(l[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(l[0],c));case"getInstalled":return(await this.a.getInstalled(l[0],P(l[1],c),l[2])).map(i=>w(i,c));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(C(l[0],c),P(l[1],c));return w($,c)}case"copyExtensions":return this.a.copyExtensions(P(l[0],c),P(l[1],c));case"updateMetadata":{const $=await this.a.updateMetadata(C(l[0],c),l[1],P(l[2],c));return w($,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Zp=u;class f extends A.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new I.$7d),this.f=this.B(new I.$7d),this.g=this.B(new I.$7d),this.h=this.B(new I.$7d),this.j=this.B(new I.$7d),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?j.URI.revive(g.source):g.source,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(l=>({...l,local:l.local?C(l.local,null):l.local,source:this.r(l.source)?j.URI.revive(l.source):l.source,profileLocation:j.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(C(g,null))))}n(h,g){h.fire(g)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const g=await this.getTargetPlatform();return h.allTargetPlatforms.some(l=>(0,R.$Oo)(l,h.allTargetPlatforms,g))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(g=>j.URI.revive(g)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,g){return Promise.resolve(this.m.call("install",[h,g])).then(l=>C(l,null))}installFromLocation(h,g){return Promise.resolve(this.m.call("installFromLocation",[h,g])).then(l=>C(l,null))}async installExtensionsFromProfile(h,g,l){return(await this.m.call("installExtensionsFromProfile",[h,g,l])).map($=>C($,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,g){return Promise.resolve(this.m.call("installFromGallery",[h,g])).then(l=>C(l,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(l=>({...l,local:l.local?C(l.local,null):l.local,source:this.r(l.source)?j.URI.revive(l.source):l.source,profileLocation:j.URI.revive(l.profileLocation)}))}uninstall(h,g){if(h.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[h,g]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(g=>C(g,null))}getInstalled(h=null,g,l){return Promise.resolve(this.m.call("getInstalled",[h,g,l])).then(c=>c.map($=>C($,null)))}updateMetadata(h,g,l){return Promise.resolve(this.m.call("updateMetadata",[h,g,l])).then(c=>C(c,null))}toggleAppliationScope(h,g){return this.m.call("toggleAppliationScope",[h,g]).then(l=>C(l,null))}copyExtensions(h,g){return this.m.call("copyExtensions",[h,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,g,l){const c=await this.m.call("download",[h,g,l]);return j.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$1p=f;class b{constructor(h){this.a=h}listen(h,g){throw new Error("Invalid listen")}call(h,g,l){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$2p=b}),define(le[96],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t2b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$s2b=N;var A;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function N(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var j;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$t2b=(0,I.$hi)("IExtensionRecommendationNotificationService")}),define(le[12],he([0,1,50,15,27,13,8,162,4,5,23,53]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=w,e.$Pk=b,e.$Qk=h,e.$Rk=g,e.$Sk=l,e.$Tk=c,e.$Uk=$,e.$Vk=i,e.$Wk=o,e.$Xk=n,e.$Yk=s,e.$1k=a,e.$2k=y,e.$3k=E,e.$4k=k,e.$5k=S,e.$8k=M,e.$hl=V,e.$il=B,e.$kl=oe,e.$Nk=(0,P.$hi)("fileService");function w(te){return te.create===!0}var u;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var f;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function b(te){const ce=te;return!!ce&&typeof ce.onDidChange=="function"}var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function h(te){return!!(te.capabilities&2)}function g(te){return!!(te.capabilities&8)}function l(te){return!!(te.capabilities&131072)}function c(te){return!!(te.capabilities&4)}function $(te){return!!(te.capabilities&16)}function i(te){return h(te)?!!(te.capabilities&16384):!1}function o(te){return h(te)?!!(te.capabilities&32768):!1}function n(te){return!!(te.capabilities&65536)}function s(te){return!!(te.capabilities&2048)}var t;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ce,H){const q=new r(ce.toString(),H);return E(q,H),q}constructor(ce,H){super(ce),this.code=H}}e.$Zk=r;function a(te,ce){return r.create(te,ce)}function y(te){return te||a((0,R.localize)(0,null),t.Unknown)}function E(te,ce){return te.name=ce?`${ce} (FileSystemError)`:"FileSystemError",te}function k(te){if(!te)return t.Unknown;if(te instanceof r)return te.code;const ce=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ce)return t.Unknown;switch(ce[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function S(te){if(te instanceof x)return te.fileOperationResult;switch(k(te)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var p;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(p||(e.FileOperation=p={}));class O{constructor(ce,H,q){this.resource=ce,this.operation=H,this.target=q}isOperation(ce){return this.operation===ce}}e.$6k=O;var U;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class F{static{this.a=null}constructor(ce,H){this.c=H,this.b=void 0,this.d=new v.$V(()=>{const q=I.$ni.forUris(()=>this.c);return q.fill(this.rawAdded.map(L=>[L,!0])),q}),this.f=new v.$V(()=>{const q=I.$ni.forUris(()=>this.c);return q.fill(this.rawUpdated.map(L=>[L,!0])),q}),this.g=new v.$V(()=>{const q=I.$ni.forUris(()=>this.c);return q.fill(this.rawDeleted.map(L=>[L,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ce){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==F.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...H){return this.h(ce,{includeChildren:!1},...H)}affects(ce,...H){return this.h(ce,{includeChildren:!0},...H)}h(ce,H,...q){if(!ce)return!1;const L=q.length>0;return!!((!L||q.includes(1))&&(this.d.value.get(ce)||H.includeChildren&&this.d.value.findSuperstr(ce))||(!L||q.includes(0))&&(this.f.value.get(ce)||H.includeChildren&&this.f.value.findSuperstr(ce))||(!L||q.includes(2))&&(this.g.value.findSubstr(ce)||H.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$7k=F;function M(te,ce,H){return!te||!ce||te===ce||ce.length>te.length?!1:(ce.charAt(ce.length-1)!==A.sep&&(ce+=A.sep),H?(0,N.$mf)(te,ce):te.indexOf(ce)===0)}class x extends Error{constructor(ce,H,q){super(ce),this.fileOperationResult=H,this.options=q}}e.$9k=x;class J extends x{constructor(ce,H,q,L){super(ce,H,L),this.fileOperationResult=H,this.size=q}}e.$0k=J;class Z extends x{constructor(ce,H,q){super(ce,2,q),this.stat=H}}e.$$k=Z;var W;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var K;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$gl="";function V(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function B(te,ce){if(!ce.hasProvider(D.URI.from({scheme:te.scheme})))return new Promise(H=>{const q=ce.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===te.scheme&&L.added&&(q.dispose(),H())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ce){return(0,j.$Yf)(ce)||(ce=0),ce<ie.KB?(0,R.localize)(1,null,ce.toFixed(0)):ce<ie.MB?(0,R.localize)(2,null,(ce/ie.KB).toFixed(2)):ce<ie.GB?(0,R.localize)(3,null,(ce/ie.MB).toFixed(2)):ce<ie.TB?(0,R.localize)(4,null,(ce/ie.GB).toFixed(2)):(0,R.localize)(5,null,(ce/ie.TB).toFixed(2))}}e.$jl=ie;function oe(te){const ce=typeof te=="string"||te?.scheme===C.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===C.Schemas.file?1024*ie.MB:ce?10*ie.MB:d.$o?50*ie.MB:1024*ie.MB}});var Q=this&&this.__param||function(se,e){return function(I,A){e(I,A,se)}};define(le[193],he([0,1,73,49,12]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((d,C)=>{const v=(0,I.createHash)("sha256");(0,A.$me)(P,{onData:w=>v.update(w.buffer),onError:w=>C(w),onEnd:()=>d(v.digest("base64").replace(/=+$/,""))})})}};e.$0bc=j,e.$0bc=j=ve([Q(0,N.$Nk)],j)}),define(le[97],he([0,1,14,7,163,12]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=D;async function D(C,v,w,u,f,b){let m;try{await R(C,v,w,u,f,b)}catch(h){m=h}finally{m&&f.errorTransformer&&(m=f.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}async function R(C,v,w,u,f,b){P(b);const m=await C.open(v,{create:!1});try{P(b);let h=0,g=0,l=f&&typeof f.length=="number"?f.length:void 0,c=I.$ue.alloc(Math.min(f.bufferSize,typeof l=="number"?l:f.bufferSize)),$=f&&typeof f.position=="number"?f.position:0,i=0;do g=await C.read(m,$,c.buffer,i,c.byteLength-i),$+=g,i+=g,h+=g,typeof l=="number"&&(l-=g),i===c.byteLength&&(await w.write(u(c)),c=I.$ue.alloc(Math.min(f.bufferSize,typeof l=="number"?l:f.bufferSize)),i=0);while(g>0&&(typeof l!="number"||l>0)&&P(b)&&d(h,f));if(i>0){let o=i;typeof l=="number"&&(o=Math.min(i,l)),w.write(u(c.slice(0,o)))}}catch(h){throw(0,j.$2k)(h)}finally{await C.close(m)}}function P(C){if(C.isCancellationRequested)throw(0,A.$6)();return!0}function d(C,v){if(typeof v?.limits?.size=="number"&&C>v.limits.size)throw(0,j.$1k)((0,N.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[45],he([0,1,90,2,15,5,8,12]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=void 0,e.$uq=P,e.$vq=d,e.$zq=u,e.$Aq=f,e.$Bq=b,e.$Cq=m;function P(g){return typeof g.correlationId=="number"}function d(g){return g.recursive===!0}class C extends A.$Uc{static{this.a=5}constructor(l,c,$,i){super(),this.h=l,this.j=c,this.m=$,this.n=i,this.c=this.B(new A.$Vc),this.f=void 0,this.g=0}s(){const l=new A.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(c=>this.h(c))),l.add(this.b.onDidLogMessage(c=>this.j(c))),l.add(this.b.onDidError(c=>this.t(c)))}t(l){this.n.restartOnError?this.g<C.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wq=C;class v extends C{constructor(l,c,$){super(l,c,$,{type:"node.js",restartOnError:!1})}}e.$xq=v;class w extends C{constructor(l,c,$){super(l,c,$,{type:"universal",restartOnError:!0})}}e.$yq=w;function u(g){return g.map(l=>({type:l.type,resource:D.URI.revive(l.resource),cId:l.cId}))}function f(g){const l=new h;for(const c of g)l.processEvent(c);return l.coalesce()}function b(g,l){return typeof l=="string"&&!l.startsWith(I.$0j)&&!(0,N.$jc)(l)?{base:g,pattern:l}:l}function m(g,l){const c=[];for(const $ of l)c.push((0,I.$bk)(b(g,$)));return c}class h{constructor(){this.a=new Set,this.b=new Map}c(l){return j.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const c=this.b.get(this.c(l));let $=!1;if(c){const i=c.type,o=l.type;c.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?$=!0:i===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(c)):i===2&&o===1?c.type=0:i===1&&o===0||(c.type=o)}else $=!0;$&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],c=[];return Array.from(this.a).filter($=>$.type!==2?(l.push($),!1):!0).sort(($,i)=>$.resource.fsPath.length-i.resource.fsPath.length).filter($=>c.some(i=>(0,R.$8k)($.resource.fsPath,i,!j.$k))?!1:(c.push($.resource.fsPath),!0)).concat(l)}}}),define(le[194],he([0,1,14,38,7,3,2,49,32,12,45]),function(se,e,I,A,N,j,D,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=e.$IP=void 0,e.$IP="localFilesystem";class v extends D.$Uc{constructor(u,f){super(),this.a=u,this.b=f,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$7d),this.onDidWatchError=this.g.event,this.h=(0,P.$Dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,f){const{buffer:b}=await this.a.call("readFile",[u,f]);return b}readFileStream(u,f,b){const m=(0,R.$ie)(g=>I.$ue.concat(g.map(l=>I.$ue.wrap(l))).buffer),h=new D.$Tc;return h.add(this.a.listen("readFileStream",[u,f])(g=>{if(g instanceof I.$ue)m.write(g.buffer);else{if(g==="end")m.end();else{let l;if(g instanceof Error)l=g;else{const c=g;l=(0,d.$1k)(c.message??(0,A.$5i)(c),c.code??d.FileSystemProviderErrorCode.Unknown)}m.error(l),m.end()}h.dispose()}})),h.add(b.onCancellationRequested(()=>{m.error((0,N.$6)()),m.end(),h.dispose()})),m}writeFile(u,f,b){return this.a.call("writeFile",[u,I.$ue.wrap(f),b])}open(u,f){return this.a.call("open",[u,f])}close(u){return this.a.call("close",[u])}async read(u,f,b,m,h){const[g,l]=await this.a.call("read",[u,f,h]);return b.set(g.buffer.slice(0,l),m),l}write(u,f,b,m,h){return this.a.call("write",[u,f,I.$ue.wrap(b),m,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,f){return this.a.call("delete",[u,f])}rename(u,f,b){return this.a.call("rename",[u,f,b])}copy(u,f,b){return this.a.call("copy",[u,f,b])}cloneFile(u,f){return this.a.call("cloneFile",[u,f])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const f=u;this.f.fire((0,C.$zq)(f))}else{const f=u;this.g.fire(f)}}))}watch(u,f){const b=(0,P.$Dg)();return this.a.call("watch",[this.h,b,u,f]),(0,D.$Sc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$JP=v}),define(le[195],he([0,1,43,2,45,3,8]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class R extends A.$Uc{constructor(){super(),this.a=this.B(new j.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new A.$4c),this.m=5007,this.B(this.f(d=>this.n(d)))}n(d){this.r(d)&&this.t(d)}r(d){return(0,N.$uq)(d)}async watch(d){this.h.clear(),this.g.clear();for(const C of d)this.r(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||this.j.deleteAndDispose(C);return this.s()}s(){return this.C([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}t(d){if(this.j.has(d.correlationId))return;const C=new A.$Tc;this.j.set(d.correlationId,C),this.w(d,C),this.s()}u(d){this.j.deleteAndDispose(d.correlationId),this.s()}w(d,C){const v=D.URI.file(d.path),w=this;let u=!1;const f=(b,m)=>{if(C.isDisposed)return;const h=this.y(b),g=this.y(m),l=u;if(u=h,g&&!h||l&&!h&&!g){this.D(`fs.watchFile() detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const c={resource:v,type:1,cId:d.correlationId};w.a.fire([c]),this.z(c,d),this.u(d)}};this.D(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,I.watchFile)(d.path,{persistent:!1,interval:this.m},f)}catch(b){this.F(`fs.watchFile() failed with error ${b} on path ${d.path} (correlationId: ${d.correlationId})`)}C.add((0,A.$Sc)(()=>{this.D(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,I.unwatchFile)(d.path,f)}catch(b){this.F(`fs.unwatchFile() failed with error ${b} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}y(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll()}z(d,C){const v=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.D(typeof C.correlationId=="number"?`${v} (correlationId: ${C.correlationId})`:v)}}e.$Lq=R}),define(le[196],he([0,1,43,6,26,51,2,87,15,5,20,8,146,31,45]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,e.$Rq=m;class b extends D.$Uc{static{this.a=100}static{this.b=75}constructor(g,l,c,$,i){super(),this.m=g,this.n=l,this.r=c,this.s=$,this.t=i,this.c=this.B(new A.$wh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.n(o))),this.f=this.B(new A.$vh(o=>this.D(o),b.b)),this.g=(0,f.$Cq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,f.$Cq)(this.m.path,this.m.includes):void 0,this.j=new N.$ee,this.ready=this.u()}async u(){try{const g=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const l=await u.Promises.stat(g);this.B(await this.y(g,l.isDirectory()))}catch(g){g.code!=="ENOENT"?this.G(g):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${g})`),this.r?.()}}async w(g){let l=g.path;try{l=await u.Promises.realpath(g.path),g.path===l&&(l=await(0,w.$Nq)(g.path)??g.path),g.path!==l&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${l})`)}catch{}return l}async y(g,l){if(d.$j&&(0,j.$hg)(g,"/Volumes/",!0))return this.G(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Uc.None;const c=new N.$ee(this.j.token),$=new D.$Tc;try{const i=v.URI.file(this.m.path),o=(0,P.$oc)(g),n=(0,I.watch)(g);$.add((0,D.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.I(`Started watching: '${g}'`);const s=new Set;if(l)try{for(const r of await u.Promises.readdir(g))s.add(r)}catch(r){this.G(r)}const t=new Map;$.add((0,D.$Sc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.G(`Failed to watch ${g} for changes using fs.watch() (${r}, ${a})`),this.r?.()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.I(`[raw] ["${r}"] ${a}`);let y="";if(a&&(y=a.toString(),d.$j&&(y=(0,R.$Yl)(y))),!(!y||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){t.get(y)?.dispose();const E=setTimeout(async()=>{if(t.delete(y),y===o&&!await u.Promises.exists(g)){this.z(i);return}const k=await this.F((0,P.$kc)(g,y));if(c.token.isCancellationRequested)return;let S;k?s.has(y)?S=0:(S=1,s.add(y)):(s.delete(y),S=2),this.C({resource:(0,C.$Ug)(i,y),type:S,cId:this.m.correlationId})},b.a);t.set(y,(0,D.$Sc)(()=>clearTimeout(E)))}else{let E;s.has(y)?E=0:(E=1,s.add(y)),this.C({resource:(0,C.$Ug)(i,y),type:E,cId:this.m.correlationId})}else if(r==="rename"||y!==o){const E=setTimeout(async()=>{const k=await u.Promises.exists(g);c.token.isCancellationRequested||(k?(this.C({resource:i,type:0,cId:this.m.correlationId},!0),$.add(await this.y(g,!1))):this.z(i))},b.a);$.clear(),$.add((0,D.$Sc)(()=>clearTimeout(E)))}else this.C({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){return!c.token.isCancellationRequested&&await u.Promises.exists(g)&&this.G(`Failed to watch ${g} for changes using fs.watch() (${i.toString()})`),this.r?.(),D.$Uc.None}return(0,D.$Sc)(()=>{c.dispose(!0),$.dispose()})}z(g){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:g,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(g,l=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!l&&this.g.some(c=>c(g.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${g.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(c=>c(g.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}D(g){const l=(0,f.$Aq)(g);if(l.length>0){if(this.t)for(const $ of l)this.I(` >> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(g){if(d.$k)return u.Promises.exists(g);try{const l=(0,P.$oc)(g);return(await u.Promises.readdir((0,P.$nc)(g))).some($=>$===l)}catch(l){return this.I(l),!1}}setVerboseLogging(g){this.t=g}G(g){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}H(g){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}I(g){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.I(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Qq=b;async function m(h,g,l,c,$=512){const i=await u.Promises.open(h,"r"),o=Buffer.allocUnsafe($),n=new N.$ee(c);let s,t=!1;const r={path:h,excludes:[],recursive:!1},a=new b(r,y=>{(async()=>{for(const{type:E}of y)if(E===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:k}=await u.Promises.read(i,o,0,$,null);if(!k||n.token.isCancellationRequested)break;g(o.slice(0,k))}}catch(k){s=new Error(k),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,l(),new Promise((y,E)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await u.Promises.close(i)}catch(k){s=new Error(k)}s?E(s):y()})})}}),define(le[197],he([0,1,3,90,195,5,196]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class R extends N.$Lq{constructor(){super(...arguments),this.onDidError=I.Event.None,this.G=new Map,this.H=!1}async C(d){const C=this.M(d),v=C.filter(u=>{const f=this.G.get(u.path);return f?!(0,A.$fk)(f.request.excludes,u.excludes)||!(0,A.$fk)(f.request.includes,u.includes):!0}),w=Array.from(this.G.values()).filter(({request:u})=>!C.find(f=>f.path===u.path&&(0,A.$fk)(f.excludes,u.excludes)&&(0,A.$fk)(f.includes,u.includes))).map(({request:u})=>u.path);v.length&&this.D(`Request to start watching: ${v.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),w.length&&this.D(`Request to stop watching: ${w.join(",")}`);for(const u of w)this.L(u);for(const u of v)this.J(u)}J(d){const C=new D.$Qq(d,w=>this.a.fire(w),()=>this.c.fire(d),w=>this.b.fire(w),this.H),v={request:d,instance:C};this.G.set(d.path,v)}async stop(){await super.stop();for(const[d]of this.G)this.L(d);this.G.clear()}L(d){const C=this.G.get(d);C&&(this.G.delete(d),C.instance.dispose())}M(d){const C=new Map;for(const v of d){const w=j.$k?v.path:v.path.toLowerCase();let u=C.get(v.correlationId);u||(u=new Map,C.set(v.correlationId,u)),u.set(w,v)}return Array.from(C.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(d){this.H=d;for(const[,C]of this.G)C.instance.setVerboseLogging(d)}D(d){this.H&&this.b.fire({type:"trace",message:this.P(d)})}F(d){this.b.fire({type:"warn",message:this.P(d)})}P(d){return`[File Watcher (node.js)] ${d}`}}e.$Sq=R}),define(le[198],he([0,1,45,197]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class N extends I.$xq{constructor(D,R,P){super(D,R,P),this.s()}r(D){return D.add(new A.$Sq)}}e.$Tq=N}),define(le[199],he([0,1,23,40,92,45]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class D extends j.$yq{constructor(P,d,C){super(P,d,C),this.s()}r(P){const d=P.add(new N.$Jq(I.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(d.onDidProcessExit(({code:C,signal:v})=>this.t(`terminated by itself with code ${C}, signal: ${v}`))),A.ProxyChannel.toService((0,A.$1h)(d.getChannel("watcher")))}}e.$Kq=D}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class I{constructor(...N){this.a=new Map;for(const[j,D]of N)this.set(j,D)}set(N,j){const D=this.a.get(N);return this.a.set(N,j),D}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$fi=I}),define(le[200],he([0,1,6,7,2,72,190,4,74,86]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;const C=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new P.$fi,h=!1,g,l=C){this.f=m,this.g=h,this.h=g,this.i=l,this.o=new Set,this.f.set(R.$gi,this),this._globalGraph=l?g?._globalGraph??new D.$Wq(c=>c):void 0}createChild(m){return new w(m,this.g,this,this.i)}invokeFunction(m,...h){const g=f.traceInvocation(this.i,m);let l=!1;try{return m({get:$=>{if(l)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m($,g);if(!i)throw new Error(`[invokeFunction] unknown service '${$}'`);return i}},...h)}finally{l=!0,g.stop()}}createInstance(m,...h){let g,l;return m instanceof j.$ei?(g=f.traceCreation(this.i,m.ctor),l=this.j(m.ctor,m.staticArguments.concat(h),g)):(g=f.traceCreation(this.i,m),l=this.j(m,h,g)),g.stop(),l}j(m,h=[],g){const l=R._util.getServiceDependencies(m).sort((i,o)=>i.index-o.index),c=[];for(const i of l){const o=this.m(i.id,g);o||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const $=l.length>0?l[0].index:h.length;if(h.length!==$){console.trace(`[createInstance] First service dependency of ${m.name} at position ${$+1} conflicts with ${h.length} static arguments`);const i=$-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,$)}return Reflect.construct(m,h.concat(c))}k(m,h){if(this.f.get(m)instanceof j.$ei)this.f.set(m,h);else if(this.h)this.h.k(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const h=this.f.get(m);return!h&&this.h?this.h.l(m):h}m(m,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const g=this.l(m);return g instanceof j.$ei?this.q(m,g,h.branch(m,!0)):(h.branch(m,!1),g)}q(m,h,g){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,h,g)}finally{this.o.delete(m)}}r(m,h,g){const l=new D.$Wq(i=>i.id.toString());let c=0;const $=[{id:m,desc:h,_trace:g}];for(;$.length;){const i=$.pop();if(l.lookupOrInsertNode(i),c++>1e3)throw new v(l);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof j.$ei){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};l.insertEdge(i,s),$.push(s)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new v(l);break}for(const{data:o}of i){if(this.l(o.id)instanceof j.$ei){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}l.removeNode(o)}}return this.l(m)}s(m,h,g=[],l,c){if(this.f.get(m)instanceof j.$ei)return this.t(m,h,g,l,c);if(this.h)return this.h.s(m,h,g,l,c);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(m,h,g=[],l,c){if(l){const $=new w(void 0,this.g,this,this.i);$.c=String(m);const i=new Map,o=new I.$Ah(()=>{const n=$.j(h,g,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new d.$5c,i.set(s,a)),(E,k,S)=>{if(o.isInitialized)return o.value[s](E,k,S);{const p={listener:[E,k,S],disposable:void 0},O=a.push(p);return(0,N.$Sc)(()=>{O(),p.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,g,c)}u(m,h){if(h&&console.warn(m),this.g)throw new Error(m)}}e.$Xq=w;var u;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(u||(u={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,h){return m?new f(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(m,h){return m?new f(1,h.name):f.c}static{this.f=0}constructor(m,h){this.type=m,this.name=h,this.g=Date.now(),this.h=[]}branch(m,h){const g=new f(3,m.toString());return this.h.push([m,h,g]),g}stop(){const m=Date.now()-this.g;f.f+=m;let h=!1;function g(c,$){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of $.h)if(s&&t){h=!0,i.push(`${o}CREATES -> ${n}`);const r=g(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(m>2||h)&&f.all.add(l.join(`
`))}}e.$Yq=f}),define(le[56],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=void 0,e.$Ebc=(0,I.$hi)("mainProcessService");class A{constructor(j,D){this.a=j,this.b=D}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,D){this.a.registerChannel(j,D)}}e.$Fbc=A}),define(le[75],he([0,1,26,2,5,165,29,4]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0,e.$zr=P;function P(C){return C.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Ar=(0,R.$hi)("languagePackService");let d=class extends A.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new I.$ee;setTimeout(()=>v.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const f=w.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(m=>m.startsWith("lp-"))).map(b=>{const m=b.properties.localizedLanguages?.[0],h=P(b);return{...this.f(h,m,b),extensionId:b.identifier.id,galleryExtension:b}});return f.push(this.f("en","English")),f}f(v,w,u){const f=w??v;let b;if(f!==v&&(b=`(${v})`),v.toLowerCase()===N.$w.toLowerCase()&&(b??="",b+=(0,j.localize)(0,null)),u?.installCount){b??="";const m=u.installCount;let h;m>1e6?h=`${Math.floor(m/1e5)/10}M`:m>1e3?h=`${Math.floor(m/1e3)}K`:h=String(m),b+=` $(cloud-download) ${h}`}return{id:v,label:f,description:b}}};e.$Br=d,e.$Br=d=ve([Q(0,D.$Qo)],d)}),define(le[201],he([0,1,2,75]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;let N=class extends I.$Uc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$6bc=N,e.$6bc=N=ve([Q(0,A.$Ar)],N)}),define(le[9],he([0,1,166,38,3,54,2,35,5,20,13,8,93,4]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=b,e.log=h,e.$2j=a,e.$3j=y,e.$4j=E,e.$5j=k,e.$Nj=(0,u.$hi)("logService"),e.$Oj=(0,u.$hi)("loggerService");function f(){return new Date().toISOString()}function b(S){return(0,C.$Yf)(S)}var m;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Qj=m.Info;function h(S,p,O){switch(p){case m.Trace:S.trace(O);break;case m.Debug:S.debug(O);break;case m.Info:S.info(O);break;case m.Warning:S.warn(O);break;case m.Error:S.error(O);break;case m.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function g(S,p=!1){let O="";for(let U=0;U<S.length;U++){let F=S[U];if(F instanceof Error&&(F=(0,A.$5i)(F,p)),typeof F=="object")try{F=JSON.stringify(F)}catch{}O+=(U>0?" ":"")+F}return O}class l extends D.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new N.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==m.Off&&this.b<=p}}e.$Sj=l;class c extends l{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...O){this.f(m.Trace)&&this.g(m.Trace,g([p,...O],!0))}debug(p,...O){this.f(m.Debug)&&this.g(m.Debug,g([p,...O]))}info(p,...O){this.f(m.Info)&&this.g(m.Info,g([p,...O]))}warn(p,...O){this.f(m.Warning)&&this.g(m.Warning,g([p,...O]))}error(p,...O){if(this.f(m.Error))if(p instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=p.stack,this.g(m.Error,g(U))}else this.g(m.Error,g([p,...O]))}flush(){}}e.$Tj=c;class $ extends l{constructor(p=e.$Qj){super(),this.setLevel(p),this.g=!P.$i}trace(p,...O){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...O):console.log(`[main ${f()}]`,p,...O))}debug(p,...O){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...O):console.log(`[main ${f()}]`,p,...O))}info(p,...O){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...O):console.log(`[main ${f()}]`,p,...O))}warn(p,...O){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,p,...O):console.warn(`[main ${f()}]`,p,...O))}error(p,...O){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,p,...O):console.error(`[main ${f()}]`,p,...O))}flush(){}}e.$Uj=$;class i extends l{constructor(p=e.$Qj,O=!0){super(),this.g=O,this.setLevel(p)}trace(p,...O){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...O):console.log(p,...O))}debug(p,...O){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...O):console.log(p,...O))}info(p,...O){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...O):console.log(p,...O))}warn(p,...O){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...O):console.log(p,...O))}error(p,...O){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...O):console.error(p,...O))}flush(){}}e.$Vj=i;class o extends l{constructor(p,O=e.$Qj){super(),this.g=p,this.setLevel(O)}trace(p,...O){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(p),...O])}debug(p,...O){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(p),...O])}info(p,...O){this.f(m.Info)&&this.g.log(m.Info,[this.h(p),...O])}warn(p,...O){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(p),...O])}error(p,...O){this.f(m.Error)&&this.g.log(m.Error,[this.h(p),...O])}h(p){return typeof p=="string"?p:(0,A.$5i)(p,this.f(m.Trace))}flush(){}}e.$Wj=o;class n extends l{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const O of this.g)O.setLevel(p);super.setLevel(p)}trace(p,...O){for(const U of this.g)U.trace(p,...O)}debug(p,...O){for(const U of this.g)U.debug(p,...O)}info(p,...O){for(const U of this.g)U.info(p,...O)}warn(p,...O){for(const U of this.g)U.warn(p,...O)}error(p,...O){for(const U of this.g)U.error(p,...O)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose();super.dispose()}}e.$Xj=n;class s extends D.$Uc{constructor(p,O,U){if(super(),this.h=p,this.j=O,this.b=new R.$Bc,this.c=this.B(new N.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$7d),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(p){return(0,C.$Uf)(p)?[...this.b.values()].find(O=>O.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,O){const U=this.n(p),F=(0,C.$Uf)(p)?p:O?.id??(0,j.$8i)(U.toString()).toString(16);let M=this.b.get(U)?.logger;const x=O?.logLevel==="always"?m.Trace:O?.logLevel;M||(M=this.s(U,x??this.getLogLevel(U)??this.h,{...O,id:F}));const J={logger:M,info:{resource:U,id:F,logLevel:x,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(J.info),this.b.set(U,J),M}n(p){return(0,C.$Uf)(p)?(0,d.$Ug)(this.j,`${p}.log`):p}setLogLevel(p,O){if(v.URI.isUri(p)){const U=p,F=O,M=this.b.get(U);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([U,F]))}else{this.h=p;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,O){const U=this.m(p);U&&O!==!U.info.hidden&&(U.info.hidden=!O,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,O]))}getLogLevel(p){let O;return p&&(O=this.b.get(p)?.info.logLevel),O??this.h}registerLogger(p){const O=this.b.get(p.resource);O?O.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const O=this.b.get(p);O&&(O.logger&&O.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=s;class t{constructor(){this.onDidChangeLogLevel=new N.$7d().event}setLevel(p){}getLevel(){return m.Info}trace(p,...O){}debug(p,...O){}info(p,...O){}warn(p,...O){}error(p,...O){}critical(p,...O){}dispose(){}flush(){}}e.$Zj=t;class r extends t{}e.$1j=r;function a(S){if(S.verbose)return m.Trace;if(typeof S.logLevel=="string"){const p=k(S.logLevel.toLowerCase());if(p!==void 0)return p}return e.$Qj}function y(S){switch(S){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function E(S){switch(S){case m.Trace:return{original:"Trace",value:I.localize(0,null)};case m.Debug:return{original:"Debug",value:I.localize(1,null)};case m.Info:return{original:"Info",value:I.localize(2,null)};case m.Warning:return{original:"Warning",value:I.localize(3,null)};case m.Error:return{original:"Error",value:I.localize(4,null)};case m.Off:return{original:"Off",value:I.localize(5,null)}}}function k(S){switch(S){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$6j=new w.$yj("logLevel",y(m.Info))}),define(le[202],he([0,1,6,7,2,23,15,20,31,16,9]),function(se,e,I,A,N,j,D,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;let v=class extends N.$Uc{constructor(u,f){super(),this.a=u,this.b=f,this.B(new I.$th(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const u=(0,R.$Rg)(this.a.logsHome),f=(0,R.$Tg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,h=(await P.Promises.readdir(f)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==u),g=h.slice(0,Math.max(0,h.length-9));g.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(l=>P.Promises.rm((0,D.$kc)(f,l)))))}catch(u){(0,A.$1)(u)}}};e.$7bc=v,e.$7bc=v=ve([Q(0,d.$oi),Q(1,C.$Nj)],v)}),define(le[98],he([0,1,7,4,9]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Wp=(0,A.$hi)("IExtensionSignatureVerificationService");let j=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,P)=>se(["@vscode/vsce-sign"],async d=>R(d),P))),this.a}async verify(R,P,d){let C;try{C=await this.c()}catch(v){return this.b.error("Could not load vsce-sign module",(0,I.$0)(v)),!1}return C.verify(R,P,d)}};e.$Xp=j,e.$Xp=j=ve([Q(0,N.$Nj)],j)}),define(le[203],he([0,1,17,6,7,3,2,15,45,9]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class C extends D.$Uc{constructor(w,u){super(),this.a=w,this.b=u,this.c=this.B(new j.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$fh(0)),this.w=[],this.y=this.B(new A.$fh(0))}watch(w,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(w,u):this.z(w,u)}n(w,u){const f={path:this.H(w),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},b=(0,I.$Ub)(this.j,f);return this.r(),(0,D.$Sc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,N.$1)(w))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,P.$zq)(u)),u=>this.G(u),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const u of this.j)(0,P.$vq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const u of this.j)(0,P.$vq)(u)&&w.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,u){const f={path:this.H(w),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},b=(0,I.$Ub)(this.w,f);return this.C(),(0,D.$Sc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,N.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,P.$zq)(w)),w=>this.G(w),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,R.$ic)(w.fsPath)}}e.$Dq=C}),define(le[204],he([0,1,17,6,14,26,3,54,61,2,50,23,99,20,49,161,12,97,9,7]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let $=class extends d.$Uc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$7d),this.Y=this.B(new D.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$qh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${o}`);const s=new d.$Tc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new m.$7k(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,d.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,d.$Pc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await A.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,u.$Yg)(o))throw new m.$9k((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new l.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,m.$Tk)(n)||(0,m.$Qk)(n)||(0,m.$Uk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,m.$Tk)(n)||(0,m.$Qk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,m.$4k)(s)===m.FileSystemProviderErrorCode.FileNotFound?new m.$9k((0,b.localize)(2,null,this.sb(o)),1):(0,m.$2k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,y=n?.resolveMetadata,E=await s.stat(o);let k;return this.t(s,o,E,void 0,!!y,(S,p)=>(k||(k=C.$ni.forUris(()=>!t),k.set(o,!0),r&&k.fill(!0,r)),k.get(S.resource)||k.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?p===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:y}=this.R(o),E={resource:n,name:y.basename(n),isFile:(s.type&m.FileType.File)!==0,isDirectory:(s.type&m.FileType.Directory)!==0,isSymbolicLink:(s.type&m.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&m.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&m.FilePermission.Locked),etag:(0,m.$hl)({mtime:s.mtime,size:s.size}),children:void 0};if(E.isDirectory&&a(E,t)){try{const k=await o.readdir(n),S=await A.Promises.settled(k.map(async([p,O])=>{try{const U=y.joinPath(n,p),F=r?await o.stat(U):{type:O};return await this.t(o,U,F,k.length,r,a)}catch(U){return this.b.trace(U),null}}));E.children=(0,I.$Hb)(S)}catch(k){this.b.trace(k),E.children=[]}return E}return E}async resolveAll(o){return A.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new m.$9k((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=N.$ue.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new m.$6k(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,m.$Wk)(t)&&!a?.atomic){const y=t.enforceAtomicWriteFile?.(o);y&&(a={...s,atomic:y})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let E;if((0,m.$Qk)(t)&&!(n instanceof N.$ue))if((0,f.$ge)(n)){const k=await(0,f.$ne)(n,3);k.ended?E=N.$ue.concat(k.buffer):E=k}else E=(0,f.$ke)(n,k=>N.$ue.concat(k),3);else E=n;!(0,m.$Tk)(t)||(0,m.$Qk)(t)&&E instanceof N.$ue||(0,m.$Qk)(t)&&(0,m.$Wk)(t)&&a?.atomic?await this.hb(t,o,a,E):await this.db(t,o,a,E instanceof N.$ue?(0,N.$Fe)(E):E),this.r.fire(new m.$6k(o,4))}catch(y){throw new m.$9k((0,b.localize)(4,null,this.sb(o),(0,m.$2k)(y).toString()),(0,m.$5k)(y),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&m.FileType.Directory)throw new m.$9k((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==m.$gl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,m.$hl)({mtime:s.mtime,size:a.size}))throw new m.$9k((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const y=await this.C(o,n,s,t);r(y)}catch(y){a(y)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,N.$Ge)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new j.$ee(t);let a=s;(0,m.$Vk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const y=this.J(n,a).then(k=>k,k=>{throw r.dispose(!0),k});let E;try{return typeof a?.etag=="string"&&a.etag!==m.$gl&&await y,a?.atomic&&(0,m.$Vk)(o)||!((0,m.$Tk)(o)||(0,m.$Uk)(o))||(0,m.$Qk)(o)&&a?.preferUnbuffered?E=this.I(o,n,a):(0,m.$Uk)(o)?E=this.G(o,n,r.token,a):E=this.H(o,n,r.token,a),E.on("end",()=>r.dispose()),E.on("error",()=>r.dispose()),{...await y,value:E}}catch(k){throw E&&await(0,f.$le)(E),this.F(k,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,m.$2k)(o).toString());return o instanceof m.$$k?new m.$$k(t,o.stat,s):o instanceof m.$0k?new m.$0k(t,o.fileOperationResult,o.size,o.options):new m.$9k(t,(0,m.$5k)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,f.$re)(r,{data:a=>a instanceof N.$ue?a:N.$ue.wrap(a),error:a=>this.F(a,n,t)},a=>N.$ue.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,N.$Ke)();return(0,h.$sq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,f.$ie)(r=>N.$ue.concat(r));return(async()=>{try{let r;s?.atomic&&(0,m.$Vk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(N.$ue.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new m.$9k((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==m.$gl&&n.etag===s.etag)throw new m.$$k((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new m.$0k((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new m.$6k(o,a==="move"?2:3,y)),y}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new m.$6k(o,a==="copy"?3:2,y)),y}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:y,isSameResourceWithDifferentPathCase:E}=await this.Q(o,n,s,t,r,a);if(y&&!E&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,m.$Rk)(o))await o.copy(n,t,{overwrite:a});else{const k=await this.resolve(n);k.isDirectory?await this.P(o,k,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,m.$Tk)(o)&&(0,m.$Tk)(s))return this.jb(o,n,s,t);if((0,m.$Tk)(o)&&(0,m.$Qk)(s))return this.pb(o,n,s,t);if((0,m.$Qk)(o)&&(0,m.$Tk)(s))return this.nb(o,n,s,t);if((0,m.$Qk)(o)&&(0,m.$Qk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let y=!1;if(o===s){const{providerExtUri:k,isPathCaseSensitive:S}=this.R(o);if(S||(y=k.isEqual(n,t)),y&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!y&&k.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const E=await this.exists(t);if(E&&!y){if(!a)throw new m.$9k((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:E,isSameResourceWithDifferentPathCase:y}}R(o){const n=this.S(o);return{providerExtUri:n?u.$Kg:u.$Mg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$6k(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&m.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,m.$4k)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,m.$4k)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new m.$9k((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const E=await this.resolve(o);if(E.isDirectory&&Array.isArray(E.children)&&E.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,m.$Xk)(s)&&!t?.atomic){const E=s.enforceAtomicDelete?.(o);E&&(t={...n,atomic:E})}const r=!!t?.useTrash,a=!!t?.recursive,y=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:y}),this.r.fire(new m.$6k(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,m.$Sk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,m.$Rk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new d.$Tc;let t=!1,r=()=>{t=!0};s.add((0,d.$Sc)(()=>r())),(async()=>{try{const y=await this.bb(o,n);t?(0,d.$Pc)(y):r=()=>(0,d.$Pc)(y)}catch(y){this.b.error(y)}})();const a=n.correlationId;if(typeof a=="number"){const y=s.add(new D.$7d);return s.add(this.X.event(k=>{k.correlates(a)&&y.fire(k)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$8i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,d.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Pc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,d.$Pc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,f.$ge)(t)||(0,f.$he)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,m.$2k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,f.$he)(s)){if(s.buffer.length>0){const a=N.$ue.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,y)=>{(0,f.$me)(r,{onData:async E=>{r.pause();try{await this.gb(o,n,E,E.byteLength,t,0)}catch(k){return y(k)}t+=E.byteLength,setTimeout(()=>r.resume())},onError:E=>y(E),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let y=0;for(;y<t;){const E=await o.write(n,r+y,s.buffer,a+y,t-y);y+=E}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof N.$ue?r=t:(0,f.$ge)(t)?r=await(0,N.$Ge)(t):(0,f.$he)(t)?r=await(0,N.$He)(t):r=(0,N.$Ee)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const y=N.$ue.alloc(this.a);let E=0,k=0,S=0;do S=await o.read(r,E,y.buffer,k,y.byteLength-k),await this.gb(s,a,y,S,E,k),E+=S,k+=S,k===y.byteLength&&(k=0);while(S>0)}catch(y){throw(0,m.$2k)(y)}finally{await A.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,N.$ue.wrap(a),a.byteLength,0,0)}catch(a){throw(0,m.$2k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,N.$Ge)(this.H(o,n,j.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new m.$9k((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&m.FilePermission.Readonly)throw new m.$9k((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$tq=$,e.$tq=$=c=ve([Q(0,g.$Nj)],$)}),define(le[205],he([0,1,43,276,6,35,14,3,51,2,15,5,20,49,31,164,12,97,203,38,199,198]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0,(()=>{try{(0,A.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$5i)(o)}`)}})();class i extends g.$Dq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new j.$Bc(t=>w.$Lg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await f.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:m.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await f.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,w.$Ug)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=m.FileType.Unknown:n.isFile()?t=m.FileType.File:n.isDirectory()?t=m.FileType.Directory:t=m.FileType.Unknown,s&&(t|=m.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new N.$gh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,d.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await f.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,u.$ie)(a=>D.$ue.concat(a.map(y=>D.$ue.wrap(y))).buffer);return(0,h.$sq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,w.$Ug)((0,w.$Tg)(n),`${(0,w.$Rg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await f.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new d.$Tc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(y){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const y=this.H(n);if(!t.create||!t.overwrite){if(await f.Promises.exists(y)){if(!t.overwrite)throw(0,m.$1k)((0,b.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,m.$1k)((0,b.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(y){throw await this.gb(n,y)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,m.$Ok)(s)&&!t&&(a=await this.O(n));let y;try{if((0,m.$Ok)(s)&&s.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(r);k.mode&128||await f.Promises.chmod(r,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let E;if((0,m.$Ok)(s)){if(v.$i)try{await f.Promises.truncate(r,0),E="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}E||(E="w")}else E="r";y=await f.Promises.open(r,E)}catch(E){throw a?.dispose(),(0,m.$Ok)(s)?await this.gb(n,E):this.fb(E)}if(this.U.set(y,0),(0,m.$Ok)(s)&&this.X.set(y,n),a){const E=this.W.get(y);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${r})`),this.W.set(y,a),E&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${r})`),E.dispose())}return y}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await f.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await f.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const y=this.Z(n,s);let E=null;try{E=(await f.Promises.read(n,t,r,a,y)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(n,y,E)}return E}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,N.$Bh)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const y=this.Z(n,s);let E=null;try{E=(await f.Promises.write(n,t,r,a,y)).bytesWritten}catch(k){throw await this.gb(this.X.get(n),k)}finally{this.$(n,y,E)}return E}async mkdir(n){try{await f.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$kc)((0,C.$nc)(t),`${(0,C.$oc)(t)}${s.atomic.postfix}`)),await f.Promises.rm(t,f.RimRafMode.MOVE,r)}else try{await f.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:y,symbolicLink:E}=await f.SymlinkSupport.stat(t);a=y.isDirectory()&&!E}catch{}if(a)await f.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await f.Promises.rename(r,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,b.localize)(2,null,(0,C.$oc)(r),(0,C.$oc)((0,C.$nc)(a)),y.toString()))),this.fb(y)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await f.Promises.copy(r,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,b.localize)(3,null,(0,C.$oc)(r),(0,C.$oc)((0,C.$nc)(a)),y.toString()))),this.fb(y)}}async bb(n,s,t,r){const a=this.H(n),y=this.H(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,P.$gg)(a,y,!0)),E){if(t==="copy")throw(0,m.$1k)((0,b.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const S=await this.L(n);if(!S)throw(0,m.$1k)((0,b.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const p=await this.L(s);if(p){if(!r)throw(0,m.$1k)((0,b.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);S.type&m.FileType.File&&p.type&m.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),y=!!(this.capabilities&1024);if((0,P.$gg)(r,a,!y))return;const E=new d.$Tc;try{E.add(await this.O(n)),E.add(await this.O(s)),t&&await f.Promises.mkdir((0,C.$nc)(a),{recursive:!0}),await f.Promises.copyFile(r,a)}catch(k){if(k.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(k)}finally{E.dispose()}}t(n,s,t){return new c.$Kq(r=>n(r),r=>s(r),t)}F(n,s,t){return new $.$Tq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof m.$Zk)return n;let s=n,t;switch(n.code){case"ENOENT":t=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=m.FileSystemProviderErrorCode.Unknown;break;default:t=m.FileSystemProviderErrorCode.Unknown}return(0,m.$1k)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await f.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,m.$1k)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Uq=i}),define(le[100],he([0,1,3,2,4,9]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0,e.$tcc=(0,N.$hi)("sharedProcessLifecycleService");let D=class extends A.$Uc{constructor(P){super(),this.b=P,this.a=this.B(new I.$7d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$ucc=D,e.$ucc=D=ve([Q(0,j.$Nj)],D)}),define(le[206],he([0,1,8,3,9,2]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=e.$Tr=void 0;class D extends N.$Yj{constructor(v,w,u,f,b){super(w,u,f),this.r=v,this.t=b,this.B(b.listen("onDidChangeLogLevel",v)(m=>{(0,N.$Pj)(m)?super.setLogLevel(m):super.setLogLevel(I.URI.revive(m[0]),m[1])})),this.B(b.listen("onDidChangeVisibility",v)(([m,h])=>super.setVisibility(I.URI.revive(m),h))),this.B(b.listen("onDidChangeLoggers",v)(({added:m,removed:h})=>{for(const g of m)super.registerLogger({...g,resource:I.URI.revive(g.resource)});for(const g of h)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new N.$Wj({log:(v,w)=>{this.t.call("consoleLog",[v,w])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,w){super.setLogLevel(v,w),this.t.call("setLogLevel",[v,w])}setVisibility(v,w){super.setVisibility(v,w),this.t.call("setVisibility",[this.n(v),w])}s(v,w,u){return new R(this.t,v,w,u,this.r)}static setLogLevel(v,w,u){return v.call("setLogLevel",[w,u])}}e.$Tr=D;class R extends N.$Tj{constructor(v,w,u,f,b){super(f?.logLevel==="always"),this.r=v,this.s=w,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[w,f,b]).then(()=>{this.u(this.n),this.m=!0})}g(v,w){const u=[[v,w]];this.m?this.u(u):this.n.push(...u)}u(v){this.r.call("log",[this.s,v])}}class P{constructor(v,w){this.a=v,this.b=w}listen(v,w){const u=this.b(v);switch(w){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(b=>this.c(b,u)),removed:[...f.removed].map(b=>this.c(b,u))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,f=>[u.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,f=>(0,N.$Pj)(f)?f:[u.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${w}`)}async call(v,w,u){const f=this.b(v);switch(w){case"setLogLevel":return(0,N.$Pj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(I.URI.revive(f.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,f)))}throw new Error(`Call not found: ${w}`)}c(v,w){return{...v,resource:w.transformOutgoingURI(v.resource)}}}e.$Ur=P;class d extends j.$Uc{constructor(v,w){super(),w.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(u=>w.call("setLogLevel",[u]))),w.call("getRegisteredLoggers").then(u=>{for(const f of u)v.registerLogger({...f,resource:I.URI.revive(f.resource)})}),this.B(w.listen("onDidChangeVisibility")(([u,f])=>v.setVisibility(I.URI.revive(u),f))),this.B(w.listen("onDidChangeLoggers")(({added:u,removed:f})=>{for(const b of u)v.registerLogger({...b,resource:I.URI.revive(b.resource)});for(const b of f)v.deregisterLogger(b.resource)}))}}e.$Vr=d}),define(le[207],he([0,1,2,9]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;class N extends I.$Uc{constructor(D,R=[]){super(),this.a=new A.$Xj([D,...R]),this.B(D.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...R){this.a.trace(D,...R)}debug(D,...R){this.a.debug(D,...R)}info(D,...R){this.a.info(D,...R)}warn(D,...R){this.a.warn(D,...R)}error(D,...R){this.a.error(D,...R)}flush(){this.a.flush()}}e.$1P=N}),define(le[57],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0,e.$pac=(0,I.$hi)("nativeHostService")}),define(le[208],he([0,1,40,56]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;let N=class{constructor(D,R){return this.windowId=D,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:D,properties:(()=>{const P=new Map;return P.set("windowId",D),P})()})}};e.$Kbc=N,e.$Kbc=N=ve([Q(1,A.$Ebc)],N)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=void 0,e.$2n=(0,j.$hi)("policy");class D extends N.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const C=Object.keys(this.f).length;return this.f={...d,...this.f},C!==Object.keys(this.f).length&&await this.j(d),A.Iterable.reduce(this.g.entries(),(v,[w,u])=>({...v,[w]:u}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(d,[C,v])=>({...d,[C]:{definition:v,value:this.g.get(C)}}),{})}}e.$3n=D;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$4n=R}),define(le[209],he([0,1,3,2,58]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=e.$abc=void 0;class j{constructor(P){this.b=P,this.a=new A.$Tc}listen(P,d){switch(d){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((v,w)=>({...v,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(P,d,C){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$abc=j;class D extends N.$3n{constructor(P,d){super(),this.a=d;for(const C in P){const{definition:v,value:w}=P[C];this.f[C]=v,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const v in C){const w=C[v];w===null?this.g.delete(v):this.g.set(v,w)}this.h.fire(Object.keys(C))})}async j(P){const d=await this.a.call("updatePolicyDefinitions",P);for(const C in d)this.g.set(C,d[C])}}e.$bbc=D}),define(le[101],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const j=N.context.configuration();if(j)A=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:j.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(le[24],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,I.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"}),define(le[210],he([0,1,6,7,2,15,31,9,24]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;let d=class extends N.$Uc{constructor(v,w,u){super(),this.b=w,this.c=u,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this.B(new I.$th(()=>{this.f(v)},3e4)).schedule()}async f(v){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),u=(0,j.$nc)(v),f=(0,j.$oc)(v),b=await D.Promises.readdir(u);await Promise.all(b.map(async m=>{if(m===f)return;const h=(0,j.$kc)(u,m),g=await D.Promises.stat(h);if(g.isDirectory()&&w-g.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${m}.`),D.Promises.rm(h)}))}catch(w){(0,A.$1)(w)}}};e.$4bc=d,e.$4bc=d=ve([Q(1,P.$7j),Q(2,R.$Nj)],d)}),define(le[211],he([0,1,6,7,2,15,31,16,9,24]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;let C=class extends N.$Uc{constructor(w,u,f){super(),this.b=w,this.c=u,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$th(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),u=JSON.parse(await D.Promises.readFile((0,j.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(u)){const l=u[g];w[`${l.hash}.${g}`]=!0}const f=(0,j.$kc)(this.b.userDataPath,"clp");if(!await D.Promises.exists(f))return;const m=await D.Promises.readdir(f);for(const g of m){if(w[g]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await D.Promises.rm((0,j.$kc)(f,g))}const h=Date.now();for(const g of Object.keys(w)){const l=(0,j.$kc)(f,g),c=await D.Promises.readdir(l);for(const $ of c){if($==="tcf.json")continue;const i=(0,j.$kc)(l,$),o=await D.Promises.stat(i);o.isDirectory()&&h-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$kc)(g,$)}`),await D.Promises.rm(i))}}}catch(w){(0,A.$1)(w)}}};e.$5bc=C,e.$5bc=C=ve([Q(0,R.$pi),Q(1,P.$Nj),Q(2,d.$7j)],C)}),define(le[212],he([0,1,15,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$MF=void 0,e.$MF=(0,A.$hi)("IV8InspectProfilingService");var N;(function(j){function D(P){return!!(P.samples&&P.timeDeltas)}j.isValidProfile=D;function R(P,d="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,I.$jc)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$kc)(d,(0,I.$oc)(C.callFrame.url)));return P}j.rewriteAbsolutePaths=R})(N||(e.Utils=N={}))}),define(le[213],he([0,1,32]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class A{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((d,C)=>{se(["v8-inspect-profiler"],d,C)})).startProfiling({port:j.port,checkForPaused:!0}),P=(0,I.$Dg)();return this.a.set(P,R),P}async stopProfiling(j){const D=this.a.get(j);if(!D)throw new Error(`UNKNOWN session '${j}'`);const R=await D.stop();return this.a.delete(j),R.profile}}e.$jcc=A}),define(le[41],he([0,1,127,13]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class N{constructor(){this.a=new Map}add(D,R){I.ok(A.$Uf(D)),I.ok(A.$Wf(R)),I.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,R)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Zn=new N}),define(le[102],he([0,1,3,41]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function N(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new I.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,d){this.a[N(P)]=d,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const D=new j;A.$Zn.add(e.$1n.JSONContribution,D)}),define(le[46],he([0,1,17,3,13,151,21,102,41]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=b,e.$eo=m,e.$fo=h,e.$go=l,e.$ho=c;var d;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$5n={Configuration:"base.contributions.configuration"};var C;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const v=P.$Zn.as(R.$1n.JSONContribution);class w{constructor(){this.h=new Set,this.i=new A.$7d,this.onDidSchemaChange=this.i.event,this.j=new A.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),v.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),v.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),v.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$co.test(r)){const a=this.a.get(r),y=a?.valuesSources??new Map;if(t)for(const p of Object.keys(s[r]))y.set(p,t);const E={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:E,valuesSources:y});const k=(0,D.$Xi)(r),S={type:"object",default:E,description:j.localize(1,null,k),$ref:e.$_n,defaultDefaultValue:E,source:N.$Uf(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=S,this.b.properties[r]=S}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=N.$Uf(s)?s:s?.id,y=N.$Uf(r?.source)?r?.source:r?.source?.id;if(a===y)if(o.add(t),this.a.delete(t),e.$co.test(t))delete this.d[t],delete this.b.properties[t];else{const E=this.d[t];E&&(this.w(t,E),this.r(t,E))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=N.$4f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const E in a){const k=a[E];if(o&&l(E,k)){delete a[E];continue}if(k.source=n,k.defaultDefaultValue=a[E].default,this.w(E,k),e.$co.test(E)?k.scope=void 0:(k.scope=N.$4f(k.scope)?t:k.scope,k.restricted=N.$4f(k.restricted)?!!s?.includes(E):k.restricted),a[E].hasOwnProperty("included")&&!a[E].included){this.f[E]=a[E],delete a[E];continue}else this.d[E]=a[E],a[E].policy?.name&&this.e.set(a[E].policy.name,E);!a[E].deprecationMessage&&a[E].markdownDeprecationMessage&&(a[E].deprecationMessage=a[E].markdownDeprecationMessage),r.add(E)}const y=i.allOf;if(y)for(const E of y)this.p(E,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$6n.properties[i]=o,o.scope){case 1:e.$7n.properties[i]=o;break;case 2:e.$8n.properties[i]=o;break;case 6:e.$9n.properties[i]=o;break;case 3:e.$0n.properties[i]=o;break;case 4:e.$$n.properties[i]=o;break;case 5:e.$$n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$6n.properties[i],o.scope){case 1:delete e.$7n.properties[i];break;case 2:delete e.$8n.properties[i];break;case 6:delete e.$9n.properties[i];break;case 3:delete e.$0n.properties[i];break;case 4:case 5:delete e.$$n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$_n};this.w(o,n),e.$6n.properties[o]=n,e.$7n.properties[o]=n,e.$8n.properties[o]=n,e.$9n.properties[o]=n,e.$0n.properties[o]=n,e.$$n.properties[o]=n}}v(){const i={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=i,e.$7n.patternProperties[e.$bo]=i,e.$8n.patternProperties[e.$bo]=i,e.$9n.patternProperties[e.$bo]=i,e.$0n.patternProperties[e.$bo]=i,e.$$n.patternProperties[e.$bo]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;N.$2f(s)&&(s=o.defaultDefaultValue,t=void 0),N.$2f(s)&&(s=h(o.type)),o.default=s,o.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",f=new RegExp(u,"g");e.$bo=`^(${u})+$`,e.$co=new RegExp(e.$bo);function b($){const i=[];if(e.$co.test($)){let o=f.exec($);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=f.exec($)}}return(0,I.$Mb)(i)}function m($){return $.reduce((i,o)=>`${i}[${o}]`,"")}function h($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new w;P.$Zn.add(e.$5n.Configuration,g);function l($,i){return $.trim()?e.$co.test($)?j.localize(7,null,$):g.getConfigurationProperties()[$]!==void 0?j.localize(8,null,$):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?j.localize(9,null,$,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:j.localize(6,null)}function c(){const $=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))$.push([o,i[o].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(le[76],he([0,1,17,3,34,2,35,30,13,8,21,46,41]),function(se,e,I,A,N,j,D,R,P,d,C,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=l;function u(o){return Object.isFrozen(o)?o:R.$On(o)}class f{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof f)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Vi)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return u(t.rawConfiguration.getValue(n))},get override(){return s?u(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return u(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:y,keys:E}of t.rawConfiguration.overrides){const k=new f(a,E).getValue(n);k!==void 0&&r.push({identifiers:y,value:k})}return r.length?u(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Vi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return I.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Nn(this.contents),t=R.$Nn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const y of n)if(a.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(s,y.contents);for(const E of y.overrides){const[k]=t.filter(S=>I.$ub(S.identifiers,E.identifiers));k?(this.h(k.contents,E.contents),k.keys.push(...E.keys),k.keys=I.$Mb(k.keys)):t.push(R.$Nn(E))}for(const E of y.keys)r.indexOf(E)===-1&&r.push(E)}return new f(s,r,t,a.every(y=>y instanceof f)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const y=s[r];y&&(typeof a=="object"&&typeof y=="object"?(a=R.$Nn(a),this.h(a,y)):a=y),t[r]=a}return new f(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&P.$Wf(n[t])&&P.$Wf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Nn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Nn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Ui)(this.contents,n),v.$co.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,v.$do)(n))),1))}j(n,s,t){(0,C.$Ti)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),v.$co.test(n)&&this.overrides.push({identifiers:(0,v.$do)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Si)(this.contents[n],r=>console.error(r))})}}e.$io=f;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!P.$4f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:y,hasExcludedProperties:E}=this.h(n,s);this.b=new f(t,r,a,E?[n]:void 0),this.c=y||[]}g(n){let s={},t=null,r=[];const a=[],y=[];function E(S){Array.isArray(r)?r.push(S):t!==null&&(r[t]=S)}const k={onObjectBegin:()=>{const S={};E(S),a.push(r),r=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];E(S),a.push(r),r=S,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:E,onError:(S,p,O)=>{y.push({error:S,offset:p,length:O})}};if(n)try{N.$Bn(n,k),s=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return s}h(n,s){const t=w.$Zn.as(v.$5n.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Si)(n,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),y=Object.keys(n),E=this.j(n,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:a,keys:y,overrides:E,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const y={},E=[];for(const k in n)if(v.$co.test(k)&&t){const S=this.i(n[k],s,!1,r);y[k]=S.raw,a=a||S.hasExcludedProperties,E.push(...S.restricted)}else{const S=s[k],p=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&E.push(k),!r.exclude?.includes(k)&&(r.include?.includes(k)||(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&!(r.skipRestricted&&S?.restricted))?y[k]=n[k]:a=!0}return{raw:y,restricted:E,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(v.$co.test(r)){const a={};for(const y in n[r])a[y]=n[r][y];t.push({identifiers:(0,v.$do)(r),keys:Object.keys(a),contents:(0,C.$Si)(a,s)})}return t}}e.$jo=b;class m extends j.$Uc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new A.$7d),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new f}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=m;class h{constructor(n,s,t,r,a,y,E,k,S,p,O,U,F){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=y,this.g=E,this.h=k,this.i=S,this.j=p,this.k=O,this.l=U,this.m=F}get value(){return u(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(n,s,t,r,a=new f,y=new f,E=new D.$Bc,k=new f,S=new D.$Bc){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=y,this.j=E,this.l=k,this.m=S,this.a=null,this.b=new D.$Bc,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new f,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),y=s.resource?this.m.get(s.resource)||this.l:this.l,E=new Set;for(const k of r.overrides)for(const S of k.identifiers)r.getOverrideValue(n,S)!==void 0&&E.add(S);return new h(n,s,r.getValue(n),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,y)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:y}=$(this.c,n);s=[...r,...a,...y]}for(const r of s)for(const a of(0,v.$do)(r)){const y=this.c.getKeysForOverrideIdentifier(a),E=n.getKeysForOverrideIdentifier(a),k=[...E.filter(S=>y.indexOf(S)===-1),...y.filter(S=>E.indexOf(S)===-1),...y.filter(S=>!R.$Rn(this.c.override(a).getValue(S),n.override(a).getValue(S)))];t.push([a,k])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=$(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.applicationConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateApplicationConfiguration(n),{keys:y,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.localUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateLocalUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.remoteUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateRemoteUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.workspaceConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateWorkspaceConfiguration(n),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:y,overrides:E}=$(t,s),k=[...r,...a,...y];return(k.length||!t)&&this.updateFolderConfiguration(n,s),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:y}=$(s,void 0);return{keys:[...t,...r,...a],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),y=this.w(n.workspace),E=n.folders.reduce((k,S)=>(k.set(d.URI.revive(S[0]),this.w(S[1])),k),new D.$Bc);return new g(s,t,r,a,new f,y,E,new f,new D.$Bc)}static w(n){return new f(n.contents,n.keys,n.overrides)}}e.$lo=g;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,y])=>{const E=(0,D.$yc)(s,a,new Set);y.forEach(k=>E.add(k))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const y of a)this.affectedKeys.add(y);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const y=this.d.charCodeAt(a);if(y!==this.b&&y!==this.c)return!1;if(s){const E=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,k=this.g.getValue(n,s,this.h);return!R.$Rn(E,k)}return!0}}e.$no=c;function $(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],y=o?.getAllOverrideIdentifiers()||[],E=n?.getAllOverrideIdentifiers()||[];if(n){const k=E.filter(S=>!y.includes(S));for(const S of k)a.push([S,n.getKeysForOverrideIdentifier(S)])}if(o){const k=y.filter(S=>!E.includes(S));for(const S of k)a.push([S,o.getKeysForOverrideIdentifier(S)])}if(n&&o){for(const k of y)if(E.includes(k)){const S=i({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});a.push([k,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const y=(0,C.$Vi)(n.contents,a),E=(0,C.$Vi)(o.contents,a);R.$Rn(y,E)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[214],he([0,1,17,3,2,30,13,76,46,9,58,41]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0;class w extends N.$Uc{constructor(){super(...arguments),this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$io}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Zn.as(P.$5n.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:h})=>this.c(Array.from(m),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,h){this.h(m,v.$Zn.as(P.$5n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new R.$io;const m=v.$Zn.as(P.$5n.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,h){const g=this.f();for(const l of m){const c=g[l],$=h[l];c!==void 0?this.b.addValue(l,c):$?this.b.addValue(l,$.default):this.b.removeValue(l)}}}e.$oo=w;class u{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.$io}async initialize(){return this.configurationModel}}e.$po=u;let f=class extends N.$Uc{get configurationModel(){return this.b}constructor(m,h,g){super(),this.c=m,this.f=h,this.g=g,this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$io}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const h={},g=[],l=v.$Zn.as(P.$5n.Configuration).getConfigurationProperties();for(const c of m){const $=l[c];if(!$){g.push(c);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}g.push(c),h[$.policy.name]={type:$.type}}}return(0,D.$8f)(h)||await this.f.updatePolicyDefinitions(h),g}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const h=v.$Zn.as(P.$5n.Configuration).getPolicyConfigurations(),g=(0,I.$Hb)(m.map(l=>h.get(l)));this.m(g,!0)}m(m,h){this.g.trace("PolicyConfiguration#update",m);const g=v.$Zn.as(P.$5n.Configuration).getConfigurationProperties(),l=[],c=this.b.isEmpty();for(const $ of m){const i=g[$]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,j.$Rn)(this.b.getValue($),o))&&l.push([$,o])}else this.b.getValue($)!==void 0&&l.push([$,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const $=this.b;this.b=new R.$io;for(const i of $.keys)this.b.setValue(i,$.getValue(i));for(const[i,o]of l)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);h&&this.a.fire(this.b)}}};e.$qo=f,e.$qo=f=ve([Q(1,C.$2n),Q(2,d.$Nj)],f)}),define(le[215],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,46,214,58]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0;class h extends P.$Uc{constructor(c,$,i,o){super(),this.m=c,this.h=this.B(new j.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$oo),this.c=i instanceof m.$4n?new b.$po:this.B(new b.$qo(this.b,i,o)),this.f=this.B(new u.$ko(this.m,{},v.$Lg,$)),this.a=new u.$lo(this.b.configurationModel,this.c.configurationModel,new u.$io,new u.$io),this.j=new g(c,$,this),this.g=this.B(new A.$th(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,$,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$lo(c,$,new u.$io,i)}getConfigurationData(){return this.a.toData()}getValue(c,$){const i=typeof c=="string"?c:void 0,o=(0,w.$Oi)(c)?c:(0,w.$Oi)($)?$:{};return this.a.getValue(i,o,void 0)}async updateValue(c,$,i,o,n){const s=(0,w.$Pi)(i)?i:(0,w.$Oi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,I.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,d.$Rn)($,r.defaultValue)&&($=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const y=s.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(k=>(0,I.$ub)([...k.identifiers].sort(),y));E&&(s.overrideIdentifiers=E.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,f.$eo)(s.overrideIdentifiers),c]:[c];await this.j.write(a,$),await this.reloadConfiguration()}inspect(c,$={}){return this.a.inspect(c,$,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const $=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,$,2)}r(c,$){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,$);this.t(o,i,7)}s(c){const $=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,$,7)}t(c,$,i){const o=new u.$no(c,{data:$},this.a);o.source=i,this.h.fire(o)}}e.$ro=h;class g{constructor(c,$,i){this.b=c,this.c=$,this.d=i,this.a=new A.$oh}write(c,$){return this.a.queue(()=>this.e(c,$))}async e(c,$){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,D.$un)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,$);i=(0,R.$Mn)(i,n),await this.c.writeFile(this.b,N.$ue.fromString(i))}f(c,$,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!$.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$Jn)(c,$,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const $=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});$&&typeof $=="string"&&$!=="auto"&&(c=$),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[216],he([0,1,14,3,2,68]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2tb=e.$Ztb=e.$Ytb=void 0,e.$1tb=R;const D=(d,C,v)=>{const w=new Uint8Array(16);for(let b=0;b<16;b++)w[b]=Math.round(Math.random()*256);const u=(0,I.$Oe)(I.$ue.wrap(w));return[`GET ws://localhost${d}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`].join(`\r
`)+`\r
\r
`};e.$Ytb=D,e.$Ztb=I.$ue.fromString(`\r
\r
`);async function R(d,C,v,w,u){d.write(I.$ue.fromString((0,e.$Ytb)(C,v,w)));const f=new N.$Tc;try{return await new Promise((b,m)=>{let h;f.add(d.onData(g=>{h?h=I.$ue.concat([h,g],h.byteLength+g.byteLength):h=g;const l=h.indexOf(e.$Ztb);if(l===-1)return;b(d),d.pauseData();const c=h.slice(l+e.$Ztb.byteLength);c.byteLength&&u.onData.fire(c)})),f.add(d.onClose(g=>m(g??new Error("socket closed")))),f.add(d.onEnd(()=>m(new Error("socket ended"))))})}catch(b){throw d.dispose(),b}finally{f.dispose()}}class P extends N.$Uc{constructor(C,v){super(),this.g=C,this.a=this.B(new A.$0d),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new A.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(v.onData),this.B(v.onData.event(w=>this.a.fire(w))),this.onClose=this.B(v.onClose).event,this.onEnd=this.B(v.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,v){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,v)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$2tb=P}),define(le[217],he([0,1,7,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=d,e.$sl=(0,A.$hi)("remoteAuthorityResolverService");var N;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class j{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=j;class D{constructor(v,w){this.host=v,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=D;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class P extends I.$bb{static isNotAvailable(v){return v instanceof P&&v._code===R.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof P&&v._code===R.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof P&&v._code===R.NoResolverFound}static isInvalidAuthority(v){return v instanceof P&&v._code===R.InvalidAuthority}static isHandled(v){return v instanceof P&&v.isHandled}constructor(v,w=R.Unknown,u){super(v),this._message=v,this._code=w,this._detail=u,this.isHandled=w===R.NotAvailable&&u===!0,Object.setPrototypeOf(this,P.prototype)}}e.$vl=P;function d(C){const v=C.indexOf("+");return v===-1?C:C.substring(0,v)}}),define(le[218],he([0,1,6,14,26,7,3,2,23,99,63,32,68,217]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Bl=y,e.$Cl=E,e.$Dl=S;const f=30*1e3;var b;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function m(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const L=new N.$ee;return setTimeout(()=>L.cancel(),q),L.token}function g(q,L){if(q.isCancellationRequested||L.isCancellationRequested)return N.CancellationToken.Cancelled;const T=new N.$ee;return q.onCancellationRequested(()=>T.cancel()),L.onCancellationRequested(()=>T.cancel()),T.token}class l{get didTimeout(){return this.c==="timedout"}constructor(L){this.c="pending",this.d=new R.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$ah)(),L.isCancellationRequested?this.h():this.d.add(L.onCancellationRequested(()=>this.h()))}registerDisposable(L){this.c==="pending"?this.d.add(L):L.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(L))}reject(L){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(L))}}function c(q,L){const T=new l(L);return T.registerDisposable(q.onControlMessage(z=>{const Y=JSON.parse(z.toString()),G=B(Y);G?T.reject(G):T.resolve(Y)})),T.promise}function $(q,L,T,z,Y,G,ee,_){const X=new l(_),ne=C.$3d.create(!1);return q.info(`Creating a socket (${ee})...`),d.mark(`code/willCreateSocket/${G}`),L.connect(T,z,Y,ee).then(re=>{X.didTimeout?(d.mark(`code/didCreateSocketError/${G}`),q.info(`Creating a socket (${ee}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(d.mark(`code/didCreateSocketOK/${G}`),q.info(`Creating a socket (${ee}) was successful after ${ne.elapsed()} ms.`),X.resolve(re))},re=>{d.mark(`code/didCreateSocketError/${G}`),q.info(`Creating a socket (${ee}) returned an error after ${ne.elapsed()} ms.`),q.error(re),X.reject(re)}),X.promise}function i(q,L){const T=new l(L);return q.then(z=>{T.didTimeout||T.resolve(z)},z=>{T.didTimeout||T.reject(z)}),T.promise}async function o(q,L,T,z){const Y=ce(q,L);q.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let G;try{G=await $(q.logService,q.remoteSocketFactoryService,q.connectTo,P.$ug.getServerRootPath(),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,m(L),`renderer-${m(L)}-${q.reconnectionToken}`,z)}catch(re){throw q.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),q.logService.error(re),re}q.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let ee,_;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(G,null),ee=q.reconnectionProtocol,_=!1):(ee=new w.$8h({socket:G}),_=!0),q.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const X=await i(q.signService.createNewMessage((0,v.$Dg)()),z),ne={type:"auth",auth:q.connectionToken||"00000000000000000000",data:X.data};ee.sendControl(A.$ue.fromString(JSON.stringify(ne)));try{const re=await c(ee,g(z,h(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(q.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await i(q.signService.validate(X,re.signedData),z)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const de=await i(q.signService.sign(re.data),z),$e={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:L};return T&&($e.args=T),q.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(A.$ue.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(q.logService.error(`${Y} the handshake timed out. Error:`),q.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${Y} received error control message when negotiating connection. Error:`),q.logService.error(re)),_&&V(ee),re}}async function n(q,L,T,z){const Y=Date.now(),G=ce(q,L),{protocol:ee,ownsProtocol:_}=await o(q,L,T,z),X=new l(z);return X.registerDisposable(ee.onControlMessage(ne=>{const re=JSON.parse(ne.toString()),ue=B(re);ue?(q.logService.error(`${G} received error control message when negotiating connection. Error:`),q.logService.error(ue),_&&V(ee),X.reject(ue)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${H(Y)}!`),X.resolve({protocol:ee,firstMessage:re}))})),X.promise}async function s(q,L){const{protocol:T}=await n(q,1,void 0,L);return{protocol:T}}async function t(q,L,T){const{protocol:z,firstMessage:Y}=await n(q,2,L,T),G=Y&&Y.debugPort;return{protocol:z,debugPort:G}}async function r(q,L,T){const z=Date.now(),Y=ce(q,3),{protocol:G}=await o(q,3,L,T);return q.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${H(z)}!`),G}async function a(q,L,T){const{connectTo:z,connectionToken:Y}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:z,connectionToken:Y,reconnectionToken:L,reconnectionProtocol:T,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function y(q,L,T){return k(q,async z=>{const{protocol:Y}=await s(z,N.CancellationToken.None);return new W(q,L,T,z.reconnectionToken,Y)})}async function E(q,L){return k(q,async T=>{const{protocol:z,debugPort:Y}=await t(T,L,N.CancellationToken.None);return new K(q,L,T.reconnectionToken,z,Y)})}async function k(q,L){for(let z=1;;z++)try{const Y=(0,v.$Dg)(),G=await a(q,Y,null);return await L(G)}catch(Y){if(z<5)q.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(Y);else throw q.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(Y),Z.triggerPermanentFailure(0,0,u.$vl.isHandled(Y)),Y}}async function S(q,L,T){const z=await a(q,(0,v.$Dg)(),null);return await r(z,{host:L,port:T},N.CancellationToken.None)}function p(q){return(0,I.$7g)(L=>new Promise((T,z)=>{const Y=setTimeout(T,q*1e3);L.onCancellationRequested(()=>{clearTimeout(Y),T()})}))}var O;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class U{constructor(L,T){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.type=0}}e.$El=U;class F{constructor(L,T,z,Y){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.durationSeconds=z,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.$Fl=F;class M{constructor(L,T,z){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=z,this.type=2}}e.$Gl=M;class x{constructor(L,T,z){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=z,this.type=4}}e.$Hl=x;class J{constructor(L,T,z,Y){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=z,this.handled=Y,this.type=3}}e.$Il=J;class Z extends R.$Uc{static triggerPermanentFailure(L,T,z){this._permanentFailure=!0,this.f=L,this.g=T,this.h=z,this.j.forEach(Y=>Y.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(L=>L.y())}static debugPauseSocketWriting(){this.j.forEach(L=>L.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Z._permanentFailure}constructor(L,T,z,Y,G){super(),this.t=L,this.u=T,this.reconnectionToken=z,this.protocol=Y,this.w=G,this.m=this.B(new D.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new x(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(ee=>{const _=te(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(Y.onSocketTimeout(ee=>{const _=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Z.j.push(this),this.B((0,R.$Sc)(()=>{const ee=Z.j.indexOf(this);ee>=0&&Z.j.splice(ee,1)})),this.n&&this.D(Z.f,Z.g,Z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const L=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const Y=z<T.length?T[z]:T[T.length-1];try{if(Y>0){const ee=p(Y);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,ee)),this.u.logService.info(`${L} waiting for ${Y} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${L} resolving connection...`);const G=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${L} connecting to ${G.connectTo}...`),await this.G(G,h(f)),this.u.logService.info(`${L} reconnected!`),this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(u.$vl.isTemporarilyNotAvailable(G)){this.u.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this.u.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if((0,j.$4)(G)){this.u.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if(G instanceof u.$vl){this.u.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,u.$vl.isHandled(G));break}this.u.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(L,T,z){this.w?Z.triggerPermanentFailure(L,T,z):this.D(L,T,z)}D(L,T,z){this.m.fire(new J(this.reconnectionToken,L,T,z)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Jl=Z;class W extends Z{constructor(L,T,z,Y,G){super(1,L,Y,G,!0),this.client=this.B(new w.$6h(G,{remoteAuthority:T,clientId:z},L.ipcLogger))}async G(L,T){await s(L,T)}}e.$Kl=W;class K extends Z{constructor(L,T,z,Y,G){super(2,L,z,Y,!1),this.H=T,this.debugPort=G}async G(L,T){await t(L,this.H,T)}}e.$Ll=K;function V(q){try{q.acceptDisconnect();const L=q.getSocket();q.dispose(),L.dispose()}catch(L){(0,j.$1)(L)}}function B(q){if(q&&q.type==="error"){const L=new Error(`Connection error: ${q.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function ie(q,L){for(;q.length<L;)q+=" ";return q}function oe(q,L){return`[remote-connection][${ie(m(q),13)}][${L.substr(0,5)}\u2026]`}function te(q,L,T){return`${oe(q,L)}[${T?"reconnect":"initial"}]`}function ce(q,L){return`${te(L,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function H(q){return`${Date.now()-q} ms`}}),define(le[103],he([0,1,23]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=A,e.$tm=N,e.$um=j,e.$vm=D;function A(P){return P.scheme===I.Schemas.vscodeRemote?P.authority:void 0}function N(P){if(!P)return;const d=P.indexOf("+");return d<0?P:P.substr(0,d)}function j(P){const{host:d,port:C}=R(P);if(typeof C>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:d,port:C}}function D(P,d){let{host:C,port:v}=R(P);return typeof v>"u"&&(v=d),{host:C,port:v}}function R(P){const d=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(d)return{host:d[1],port:parseInt(d[2],10)};const C=P.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const v=P.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:P,port:void 0}}}),define(le[47],he([0,1,27,4,103]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=j,e.$Fm=v,e.$Gm=w,e.$Hm=u,e.$Im=f,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function j(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class P{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,h){if(typeof m>"u"||m===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof m=="string"||typeof h=="string"){const g=typeof m=="string"?m:m.value,l=typeof h=="string"?h:h.value;return I.$lf(g,l)}return m._lower===h._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Cm=P;class d{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const h of m)this.add(h)}add(m){this.c.add(P.toKey(m))}delete(m){return this.c.delete(P.toKey(m))}has(m){return this.c.has(P.toKey(m))}}e.$Dm=d;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(P.toKey(m))}get(m){return this.c.get(P.toKey(m))}has(m){return this.c.has(P.toKey(m))}set(m,h){this.c.set(P.toKey(m),h)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=C;function v(b){return w(b)}function w(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function u(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,m){if(m){const h=`onResolveRemoteAuthority:${(0,N.$tm)(m)}`;return!!b.activationEvents?.includes(h)}return!1}e.$Jm=(0,A.$hi)("IBuiltinExtensionsScannerService")}),define(le[219],he([0,1,2,47,12]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class j extends I.$Uc{constructor(R,P,d,C,v){super(),this.a=R,this.b=P,this.c=d,this.f=v,this.B(C.onDidInstallExtensions(w=>this.g(w))),this.B(C.onDidUninstallExtension(w=>this.h(w)))}g(R){for(const P of R)P.local&&this.invalidate(P.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,R)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,A.$wm))}catch(P){(0,N.$5k)(P)!==1&&this.f.error(P)}}}e.$mq=j}),define(le[104],he([0,1,2,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0,e.$xl=(0,A.$hi)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(D,R){return this.a[D]??=[],this.a[D].push(R),(0,I.$Sc)(()=>{const P=this.a[D]?.indexOf(R);typeof P=="number"&&P>=0&&this.a[D]?.splice(P,1)})}b(D){return(this.a[D.type]||[]).find(P=>P.supports(D))}connect(D,R,P,d){const C=this.b(D);if(!C)throw new Error(`No socket factory found for ${D}`);return C.connect(D,R,P,d)}}e.$yl=N}),define(le[220],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0,e.$gcc=(0,I.$hi)("sharedProcessTunnelService"),e.$hcc="sharedProcessTunnel"}),define(le[105],he([0,1,4,167]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=e.$qcc=e.$pcc=e.$occ=e.$ncc=e.TunnelStates=e.$mcc=e.$lcc=void 0,e.$lcc=(0,I.$hi)("IRemoteTunnelService"),e.$mcc={active:!1};var N;(function(j){j.disconnected=D=>({type:"disconnected",onTokenFailed:D}),j.connected=(D,R)=>({type:"connected",info:D,serviceInstallFailed:R}),j.connecting=D=>({type:"connecting",progress:D}),j.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$ncc="remote.tunnels.access",e.$occ=e.$ncc+".hostNameOverride",e.$pcc=e.$ncc+".preventSleep",e.$qcc="remoteTunnelService",e.$rcc=(0,A.localize)(0,null)}),define(le[59],he([0,1,14,7,2,169,46,4,9,41]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=void 0,e.$Ap=w,e.$Bp=u,e.$Cp=f,e.$Dp=b,e.$Ep=m,e.$Fp=h,e.$yp=(0,R.$hi)("requestService");class C{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?$[i]="*****":$[i]=this.b[i];this.a=$}return this.a}}class v extends N.$Uc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,j.localize)(0,null),when:P.$6j.isEqualTo((0,P.$3j)(P.LogLevel.Trace)).serialize()})}async c($,i,o){const n=`${$} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,A.$0)(s)),s}}}e.$zp=v;function w(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function u(c){return c.res.statusCode===204}async function f(c){return u(c)?null:(await(0,I.$Ge)(c.stream)).toString()}async function b(c){if(!w(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}async function m(c){if(!w(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const i=(await(0,I.$Ge)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function h(c){l(c)}let g;function l(c){const $=d.$Zn.as(D.$5n.Configuration),i=g;g={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[g],remove:i?[i]:[]})}l(1)}),define(le[221],he([0,1,26,23,12,59]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=void 0;let D=class{constructor(P,d){this.a=P,this.b=d}async download(P,d,C=I.CancellationToken.None){if(P.scheme===A.Schemas.file||P.scheme===A.Schemas.vscodeRemote){await this.b.copy(P,d);return}const v={type:"GET",url:P.toString(!0)},w=await this.a.request(v,C);if(w.res.statusCode===200)await this.b.writeFile(d,w.stream);else{const u=await(0,j.$Dp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${u}`)}}};e.$dQ=D,e.$dQ=D=ve([Q(0,j.$yp),Q(1,N.$Nk)],D)}),define(le[222],he([0,1,14,26]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=void 0;class N{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,d,C=A.CancellationToken.None){switch(P){case"request":return this.a.request(d[0],C).then(async({res:v,stream:w})=>{const u=await(0,I.$Ge)(w);return[{statusCode:v.statusCode,headers:v.headers},u]});case"resolveProxy":return this.a.resolveProxy(d[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Dr=N;class j{constructor(R){this.a=R}async request(R,P){const[d,C]=await this.a.call("request",[R],P);return{res:d,stream:(0,I.$Ie)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Er=j}),define(le[223],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=e.$Lac=e.$Kac=void 0,e.$Kac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Lac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Mac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[224],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const j=await this.c();if(j){const D=String(I.a++);return this.b.set(D,j),{id:D,data:j.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,j){if(!N.id)return!0;const D=this.b.get(N.id);if(!D)return!1;this.b.delete(N.id);try{return D.validate(j)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$E9b=I}),define(le[106],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0,e.$zl="signService",e.$Al=(0,I.$hi)(e.$zl)}),define(le[225],he([0,1,224]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class A extends I.$E9b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(D=>new D.signer().sign(j))}h(){return new Promise((j,D)=>se(["vsda"],j,D))}}e.$Abc=A}),define(le[77],he([0,1,3,2]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uIb=e.$tIb=e.$sIb=e.$rIb=void 0;class N extends A.$Uc{constructor(v,w,u){super(),this.a=v,this.b=w,this.c=u}async getItems(){const v={profile:this.b,workspace:this.c},w=await this.a.call("getItems",v);return new Map(w)}updateItems(v){const w={profile:this.b,workspace:this.c};return v.insert&&(w.insert=Array.from(v.insert.entries())),v.delete&&(w.delete=Array.from(v.delete.values())),this.a.call("updateItems",w)}optimize(){const v={profile:this.b,workspace:this.c};return this.a.call("optimize",v)}}class j extends N{constructor(v,w){super(v,w,void 0),this.f=this.B(new I.$7d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(v=>this.h(v)))}h(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this.f.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}}class D extends j{constructor(v){super(v,void 0)}async close(){this.dispose()}}e.$rIb=D;class R extends j{constructor(v,w){super(v,w)}async close(){this.dispose()}}e.$sIb=R;class P extends N{constructor(v,w){super(v,void 0,w),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$tIb=P;class d{constructor(v){this.a=v}isUsed(v){const w={payload:v,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$uIb=d}),define(le[107],he([0,1,5,36,32]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=D,e.$2o=R;function j(P){if(I.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function D(P,d,C,v,w,u,f,b,m){const h=Object.create(null);h["common.machineId"]=u,h["common.sqmId"]=f,h.sessionID=(0,N.$Dg)()+Date.now(),h.commitHash=v,h.version=w,h["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,I.$h)(I.$u),h["common.nodePlatform"]=A.$ec,h["common.nodeArch"]=C,h["common.product"]=m||"desktop",b&&(h["common.msftInternal"]=b);let g=0;const l=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),I.$l&&(h["common.snap"]="true");const c=j(d);return c&&(h["common.platformDetail"]=c),h}function R(P){const d=A.env.USERDNSDOMAIN;if(!d)return!1;const C=d.toLowerCase();return P.some(v=>C===v)}}),define(le[22],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,I.$hi)("telemetryService"),e.$Nl=(0,I.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var A;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var N;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(le[226],he([0,1,37,6,34,23,15,5,8,144,31,148,94,12,24,22]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,e.$ms=h,e.$ns=l,e.$os=c;const m=new Map;async function h(i,o){const n=`${i}::${o.join(":")}`,s=m.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,y=2e4;function E(S,p,O,U){const F=p.substring(S.length+1);return A.Promises.withAsyncBody(async M=>{let x;try{x=await C.Promises.readdir(p,{withFileTypes:!0})}catch{M();return}if(U.count>=y){U.count+=x.length,U.maxReached=!0,M();return}let J=x.length;if(J===0){M();return}let Z=x;U.count+x.length>y&&(U.maxReached=!0,J=y-U.count,Z=x.slice(0,J)),U.count+=x.length;for(const W of Z)if(W.isDirectory()){if(O.includes(W.name)||await E(S,(0,D.$kc)(p,W.name),O,U),--J===0){M();return}}else{const K=W.name.lastIndexOf(".");if(K>=0){const V=W.name.substring(K+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(F)!==!1&&V.filePattern.test(W.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--J===0){M();return}}})}const k=A.Promises.withAsyncBody(async S=>{const p={count:0,maxReached:!1};await E(i,i,o,p);const O=await c(i);S({configFiles:g(a),fileTypes:g(r),fileCount:p.count,maxFilesReached:p.maxReached,launchConfigFiles:O})});return m.set(n,k),k}function g(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function l(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/u.$jl.GB).toFixed(2)}GB (${(I.freemem()/u.$jl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$pn.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,D.$kc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,N.$un)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,N.$Dn)(r)==="object"&&r.configurations)for(const a of r.configurations){const y=a.type;y&&(o.has(y)?o.set(y,o.get(y)+1):o.set(y,1))}return g(o)}catch{return[]}}let $=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/u.$jl.GB).toFixed(2)}GB (${(I.freemem()/u.$jl.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$pn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,v.$ls)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(y=>{if((0,w.$2m)(y))a+=`
${y.errorMessage}`,r+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.m(o,y.processes)}`),y.workspaceMetadata){r+=`
|  Remote: ${y.hostName}`;for(const E of Object.keys(y.workspaceMetadata)){const k=y.workspaceMetadata[E];let S=`${k.fileCount} files`;k.maxFilesReached&&(S=`more than ${S}`),r+=`|    Folder (${E}): ${S}`,r+=this.h(k)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=l(),y={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(y.load=`${I.loadavg().map(E=>Math.round(E)).join(", ")}`),R.$k&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(o,n){const s=[];return(0,v.$ls)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,w.$2m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const y=r.workspaceMetadata[a];let E=`${y.fileCount} files`;y.maxFilesReached&&(E=`more than ${E}`),s.push(`Folder (${a}): ${E}`),s.push(this.h(y))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(k,S)=>{const p=` ${k}(${S})`;t+p.length>60?(n.push(a),a="|                 ",t=a.length):t+=p.length,a+=p};let a="|      File types:";const y=10,E=o.fileTypes.length>y?y:o.fileTypes.length;for(let k=0;k<E;k++){const S=o.fileTypes[k];r(S.name,S.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(k=>{r(k.name,k.count)}),n.push(a)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(S=>{const p=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;k+=p}),n.push(k)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===j.Schemas.file){const y=a.fsPath;s.push(h(y,["node_modules",".git"]).then(E=>{let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),n.push(`|    Folder (${(0,D.$oc)(y)}): ${k}`),n.push(this.h(E))}).catch(E=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${E.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let y;a?y=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?y=n.get(t.pid):y=`${"  ".repeat(r)} ${t.name}`;const E=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(E/u.$jl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(t.children)&&t.children.forEach(k=>this.n(o,n,s,k,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=P.URI.revive(s);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=P.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const t=s.fsPath;try{const r=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$ps=$,e.$ps=$=ve([Q(0,b.$Ml),Q(1,f.$7j)],$)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=e.$Pac=void 0;class I{constructor(j){this.b=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,{eventName:R,data:P}){return this.b.forEach(d=>d.log(R,P)),Promise.resolve(null)}}e.$Pac=I;class A{constructor(j){this.b=j}log(j,D){return this.b.call("log",{eventName:j,data:D}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Qac=A}),define(le[48],he([0,1,30,13,103,107,22]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=C,e.$$o=v,e.$_o=w,e.$ap=u,e.$bp=b,e.$cp=h,e.$dp=g,e.$ep=$;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$3o=R;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=P,e.$5o=new P;class d{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$6o=d,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function v(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function w(i){const o=i.getValue(D.$Ul),n=i.getValue(D.$Vl);if(i.getValue(D.$Wl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function u(i){const o={},n={},s={};m(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,N.$tm)(i);return f.has(o)?o:"other"}function m(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,I.$Sn)(r):r instanceof Date?o[a]=r.toISOString():(0,A.$Wf)(r)?n<2?m(r,o,n+1,a+"."):o[a]=(0,I.$Sn)(r):o[a]=r}}function h(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,j.$2o)(n)||s}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function l(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const y of o)for(;;){const E=y.exec(i);if(!E)break;s.push([E.index,y.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const y=r.exec(i);if(!y)break;const E=s.some(([k,S])=>y.index<S&&k<r.lastIndex);!t.test(y[0])&&!E&&(n+=i.substring(a,y.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function $(i,o){return(0,I.$Pn)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=l(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(le[33],he([0,1,27,29,47,5,8,7,36,48]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=C,e.$hp=f,e.$ip=b,e.$jp=m,e.$kp=h,e.$lp=g,e.$mp=l,e.$np=c,e.$pp=$,e.$qp=o;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$gf)(n.id,s.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,t,r)}static parse(s){const t=v.exec(s);return t&&t[1]&&t[2]?new w({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$gp=w;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const s=u.exec(n);return s&&s[1]?[m(s[1]),s[2]]:[m(n),void 0]}function b(n,s){return`${n}.${s}`}function m(n){return n.toLowerCase()}function h(n,s){return m(b(n??N.$ym,s))}function g(n,s){const t=[],r=a=>{for(const y of t)if(y.some(E=>C(s(E),s(a))))return y;return null};for(const a of n){const y=r(a);y?y.push(a):t.push([a])}return t}function l(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new d.$3o(n.identifier.id),name:new d.$3o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$op=new N.$Cm("pprice.better-merge");function $(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(y=>!C(y.identifier,{id:a}))){const y=n.filter(E=>C(E.identifier,{id:a}));y.length===1&&(t.push(y[0]),r.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!j.$k)return!1;let t;try{t=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,A.$Mo)(t?"alpine":j.$u,P.$fc);return s.debug("ComputeTargetPlatform:",r),r}}),define(le[227],he([0,1,17,2,20,8,12,24,6,3,15,5,36,33]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=e.$N$b=void 0;let f=class extends A.$Uc{constructor(l,c){super(),this.b=l,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(l){return this.f(l)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(l){const c=[];for(const[$,i]of this.a)if(!(i.configScheme&&i.configScheme!==l.scheme))try{const o=(await this.b.readFile((0,N.$Ug)(l,$))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$N$b=f,e.$N$b=f=ve([Q(0,D.$Nk),Q(1,R.$7j)],f);const b="extensionTips/promptedExecutableTips",m="extensionTips/lastPromptedMediumImpExeTime";class h extends f{constructor(l,c,$,i,o,n,s,t){super(s,t),this.r=l,this.s=c,this.t=$,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const y=[],E=[],k=[];Object.entries(a.recommendations).forEach(([S,p])=>{p.important?a.important?y.push({extensionId:S,extensionName:p.name,isExtensionPack:!!p.isExtensionPack}):E.push({extensionId:S,extensionName:p.name,isExtensionPack:!!p.isExtensionPack}):k.push({extensionId:S,extensionName:p.name,isExtensionPack:!!p.isExtensionPack})}),y.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),E.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),k.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:k})}),(0,P.$jh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const l=await this.O(this.g),c=await this.O(this.h);return[...l,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const l=await this.O(this.g),c=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(l,$),this.n=this.D(c,$)}D(l,c){const $=new Map;l.forEach(t=>$.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...$.keys()],c);for(const t of i){const r=$.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=$.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=$.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[l,c]=[...this.m.entries()][0];this.H(c).then($=>{switch($){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(l);break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new A.$Vc);i.value=(0,P.$jh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const l=this.I(),c=Date.now()-l,$=7*24*60*60*1e3;if(c<$){const n=this.B(new A.$Vc);n.value=(0,P.$jh)(()=>{n.dispose(),this.G()},$-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new A.$Vc);s.value=(0,P.$jh)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new A.$Vc);s.value=(0,P.$jh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(l){const c=await this.u.getInstalled(1),$=l.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,u.$fp)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:l[0].exeFriendlyName,searchValue:`@exe:"${l[0].exeName}"`})}I(){let l=this.w.getNumber(m,-1);return l||(l=Date.now(),this.J(l)),l}J(l){this.w.store(m,l,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(l,c){const $=this.L();$[l]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify($),-1,0)}N(l,c){const $=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return l.forEach(n=>{o.has(n.toLowerCase())?$.push(n):i.push(n)}),{installed:$,uninstalled:i}}async O(l){const c=[],$=new Map;for(const i of l.keys()){const o=l.get(i);if(!o||!(0,I.$Lb)(o.recommendations))continue;const n=[];v.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,C.$kc)("/usr/local/bin",i)),n.push((0,C.$kc)("/usr/bin",i)),n.push((0,C.$kc)(this.r.fsPath,i)));for(const s of n){let t=$.get(s);if(t===void 0&&(t=await this.b.exists(j.URI.file(s)),$.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:y,whenNotInstalled:E}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:y,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:E})}}return c}}e.$O$b=h}),define(le[228],he([0,1,26,33]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J2b=N;async function N(j,D,R,P,d){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const v=await j.getInstalled(1);for(const[w,u]of Object.entries(C.deprecated)){if(!u?.extension)continue;const{id:f,autoMigrate:b,preRelease:m}=u.extension;if(!b)continue;const h=v.find(l=>(0,A.$fp)(l.identifier,{id:w}));if(!h)continue;const g=(await D.getExtensions([{id:f,preRelease:m}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!g){d.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{d.info(`Migrating '${h.identifier.id}' extension to '${f}' extension...`);const l=!P.getDisabledExtensions().some($=>(0,A.$fp)($,h.identifier));await j.uninstall(h),d.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let c=v.find($=>(0,A.$fp)($.identifier,{id:f}));(!c||!c.isPreReleaseVersion&&l)&&(c=await j.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${c.identifier.id}'`),l||(await P.disableExtension(c.identifier),d.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),b.storage&&(R.addToMigrationList((0,A.$ip)(h.manifest.publisher,h.manifest.name),(0,A.$ip)(c.manifest.publisher,c.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${h.identifier.id}' extension to '${f}' extension.`)}catch(l){d.error(l)}}}catch(C){d.error(C)}}}),define(le[229],he([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,98,12,9]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;let c=class extends N.$Uc{static{l=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,D.$Ug)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new f.$Ro(r.message,f.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===g.LogLevel.Trace)}catch(a){const y=a;if(t=y.code,y.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${y.output}`),t===f.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===f.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(E){this.r.error(E)}throw new f.$Ro(v.$3p,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,P.$1f)(o)?o:!0}async u(i){await this.g;const o=(0,D.$Ug)(this.extensionsDownloadDir,`${this.z(i)}${l.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new f.$Ro(n.message,f.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const s=(0,D.$Ug)(this.extensionsDownloadDir,`.${(0,d.$Dg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(l.c))s.push(a.resource);else{const y=b.$gp.parse(a.name);y&&n.push([y,a])}const t=(0,b.$lp)(n,([a])=>a),r=[];for(const a of t)a.sort((y,E)=>R.rcompare(y[0].version,E[0].version)),o.push(...a.slice(1).map(y=>y[1].resource)),r.push(a[0][1]);r.sort((a,y)=>a.mtime-y.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await I.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$gp.create(i).toString().toLowerCase():(0,d.$Dg)()}};e.$jq=c,e.$jq=c=l=ve([Q(0,u.$pi),Q(1,h.$Nk),Q(2,f.$Qo),Q(3,w.$Ni),Q(4,m.$Wp),Q(5,g.$Nj)],c)}),define(le[230],he([0,1,3,2,35,33,47]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class R extends A.$Uc{constructor(d,C,v,w,u,f,b){super(),this.f=d,this.g=C,this.h=v,this.j=w,this.m=u,this.n=f,this.r=b,this.a=this.B(new I.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$4c),this.s().then(null,m=>b.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(C=>(this.c.set(C.id,(0,A.$Rc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(d){for(const C of d.extensions)this.I(this.L(C.identifier,C.version),d.profileLocation)}async y(d){for(const C of d.extensions){const v=this.L(C.identifier,C.version);d.error?this.J(v,d.profileLocation):this.I(v,d.profileLocation)}}async z(d){for(const C of d.extensions)this.J(this.L(C.identifier,C.version),d.profileLocation)}async C(d){const C=[],v=[];for(const w of d.extensions){const u=this.L(w.identifier,w.version);d.error?this.I(u,d.profileLocation):(this.J(u,d.profileLocation),this.b.has(u)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),v.push(this.f.scanInstalledExtensionAtLocation(w.location).then(f=>{f?C.push(f):this.r.info("Extension not found at the location",w.location.toString())},f=>this.r.error(f)))))}try{await Promise.all(v),C.length&&await this.H(C)}catch(w){this.r.error(w)}}D(d){for(const C of this.h.profiles)d.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(d){const C=[],v=[],w=await this.j.scanProfileExtensions(d),u=new Set,f=new Set;for(const[b,m]of this.b)m.has(d)&&f.add(b);for(const b of w){const m=this.L(b.identifier,b.version);u.add(m),f.has(m)||(C.push(b.identifier),this.I(m,d))}for(const b of f)if(!u.has(b)){const m=this.M(b);m&&(v.push(m.identifier),this.J(b,d))}(C.length||v.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:d}:void 0,removed:v.length?{extensions:v,profileLocation:d}:void 0})}async G(d){const C=await this.j.scanProfileExtensions(d);for(const v of C)this.I(this.L(v.identifier,v.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,C){let v=this.b.get(d);v||this.b.set(d,v=new N.$Cc(w=>this.m.extUri.getComparisonKey(w))),v.add(C)}J(d,C){const v=this.b.get(d);v&&v.delete(C),v?.size||this.b.delete(d)}L(d,C){return`${D.$Cm.toKey(d.id)}@${C}`}M(d){const[C,v]=(0,j.$hp)(d);return v?{identifier:{id:C},version:v}:void 0}}e.$nq=R}),define(le[231],he([0,1,44,48]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=N;async function N(j,D,R,P,d,C,v){const w={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${D.nameShort})`};if((0,A.$0o)(D,R)&&(0,A.$_o)(P)===3){const u=await(0,I.$Rp)(R,d,C);w["X-Market-User-Id"]=u,w["VSCode-SessionId"]=v.machineId||u}return w}}),define(le[232],he([0,1,73,17,6,2,23,15,31,16,29,33,9,75,8]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;let b=class extends u.$Br{constructor(l,c,$,i){super($),this.h=l,this.j=i,this.g=this.B(new m(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(l,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[l];return o?f.URI.file(o):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),c=Object.keys(l).map($=>{const i=l[$];return{...this.f($,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort(($,i)=>$.label.localeCompare(i.label)),c}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const c=await this.g.getLanguagePacks();Object.keys(c).some($=>c[$]&&c[$].extensions.some(i=>(0,v.$fp)(i.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(c);return!(0,A.$ub)(Object.keys(l),Object.keys($))}};e.$Cr=b,e.$Cr=b=ve([Q(0,C.$To),Q(1,d.$pi),Q(2,C.$Qo),Q(3,w.$Nj)],b);let m=class extends j.$Uc{constructor(l,c){super(),this.j=c,this.c={},this.f=(0,R.$kc)(l.userDataPath,"languagepacks.json"),this.g=new N.$oh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s(c=>{Object.keys(c).forEach($=>delete c[$]),this.m(c,...l)}).then(()=>this.c)}m(l,...c){for(const $ of c)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(l,$);Object.keys(l).forEach($=>this.r(l[$]))}n(l,c){const $=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===D.Schemas.file&&h(o)){let n=l[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},l[o.languageId]=n);const s=n.extensions.filter(t=>(0,v.$fp)(t.extensionIdentifier,$))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:$,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$kc)(c.location.fsPath,t.path)}}r(l){if(l){const c=(0,I.createHash)("md5");for(const $ of l.extensions)c.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);l.hash=c.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let c=null;return P.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(c=l($),$)).then($=>{for(const o of Object.keys($))$[o]||delete $[o];this.c=$,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),P.Promises.writeFile(this.f,i)}).then(()=>c,$=>this.j.error($))})}};m=ve([Q(0,d.$pi),Q(1,w.$Nj)],m);function h(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const l of g.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(le[233],he([0,1,143,7,30,48]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function P(C,v,w){const u=await(0,I.$DD)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,I.$DD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new u.AppInsightsCore,m=new f.PostChannel,h={instrumentationKey:C,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(w){h.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};h.extensionConfig[m.identifier]=g}return b.initialize(h,[]),b.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),b}class d{constructor(v,w,u,f,b){this.e=v,this.f=w,this.g=u,this.h=b,this.c=D,this.d=R,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{v(w)},w=>{(0,A.$1)(w),console.error(w)})}}log(v,w){if(!this.a)return;w=(0,N.$Qn)(w,this.g),w=(0,j.$ap)(w);const u=this.f+"/"+v;try{this.i(f=>{f.pluginVersionString=w?.properties.version??"Unknown",f.track({name:u,baseData:{name:u,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$NP=d}),define(le[109],he([0,1,2,170,16,9,24,48]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;let P=class extends I.$Uc{constructor(C,v,w,u,f=""){super(),this.b=f;const b=v.getLogger(R.$7o);if(b)this.a=this.B(b);else{const h=(0,R.$$o)(u,w)?" (Not Sent)":"",g=()=>(0,R.$0o)(u,w)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(v.createLogger(R.$7o,{name:(0,A.localize)(0,null,h),hidden:!g()})),this.B(C.onDidChangeLogLevel(()=>v.setVisibility(R.$7o,g()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,v){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$ap)(v))}};e.$b$b=P,e.$b$b=P=ve([Q(0,j.$Nj),Q(1,j.$Oj),Q(2,N.$oi),Q(3,D.$7j)],P)}),define(le[110],he([0,1,2,30,5,27,171,21,46,101,24,41,22,48]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,g,l){this.k=g,this.l=l,this.d={},this.i=new I.$Tc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,j.$Ze)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ze)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(w.$Ul)||c.affectsConfiguration(w.$Wl)||c.affectsConfiguration(w.$Vl))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,u.$_o)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const l=g.usage?3:g.error?2:0;h=Math.min(h,l)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,g,l){this.g<g||(l=(0,A.$Qn)(l,this.d),l=(0,u.$ep)(l,this.j),l=(0,A.$Qn)(l,this.c),this.b.forEach(c=>c.log(h,l)))}publicLog(h,g){this.n(h,3,g)}publicLog2(h,g){this.publicLog(h,g)}publicLogError(h,g){this.h&&this.n(h,2,g)}publicLogError2(h,g){this.publicLogError(h,g)}};e.$Ir=f,e.$Ir=f=ve([Q(1,R.$Ni),Q(2,C.$7j)],f);function b(){const m=(0,D.localize)(0,null,d.default.nameLong),h=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=N.$o?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),c=(0,D.localize)(5,null),$=(0,D.localize)(6,null),i=(0,D.localize)(7,null),o=`
|       | ${l} | ${c} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${m} ${h} ${g}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}v.$Zn.as(P.$5n.Configuration).registerConfiguration({id:w.$Tl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[w.$Ul]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Zn.as(P.$5n.Configuration).registerConfiguration({id:w.$Tl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[w.$Wl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${w.$Ul}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[234],he([0,1,14,26,277,233]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;async function D(C,v){const w=await v.request(C,A.CancellationToken.None),u=(await(0,I.$Ge)(w.stream)).toString(),f=w.res.statusCode??200;return{headers:w.res.headers,statusCode:f,responseData:u}}async function R(C){const v={method:C.type,headers:C.headers};return new Promise((u,f)=>{const b=N.request(C.url??"",v,m=>{m.on("data",function(h){u({headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()})}),m.on("error",function(h){f(h)})});b.write(C.data,m=>{m&&f(m)}),b.end()})}async function P(C,v,w){const u=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),f={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:u};try{const b=C?await D(f,C):await R(f);w(b.statusCode,b.headers,b.responseData)}catch{w(0,{})}}class d extends j.$NP{constructor(v,w,u,f,b){const m={sendPOST:(h,g)=>{P(v,h,g)}};super(w,u,f,b,m)}}e.$OP=d}),define(le[235],he([0,1,23,92,21,16,9,24,22,108,109,110]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;let w=class{constructor(f,b,m,h,g,l){this.b=f,this.c=b,this.d=m,this.e=h,this.f=g,this.g=l,this.a=new Map}h(f){if(!this.a.has(f.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const m=[f.id,JSON.stringify(b),f.aiKey],g=new A.$Jq(I.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new d.$Qac(g),new C.$b$b(this.d,this.e,this.f,this.g,`[${f.id}] `)];this.a.set(f.id,new v.$Ir({appenders:l,sendErrorTelemetry:f.sendErrorTelemetry},this.b,this.g))}return this.a.get(f.id)}publicLog(f,b,m){this.h(f).publicLog(b,m)}publicLogError(f,b,m){this.h(f).publicLogError(b,m)}};e.$$bc=w,e.$$bc=w=ve([Q(0,N.$Ni),Q(1,P.$Ml),Q(2,D.$Nj),Q(3,D.$Oj),Q(4,j.$oi),Q(5,R.$7j)],w)}),define(le[78],he([0,1,3,8,21,4,9]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$3v=e.$1v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wv=e.$Vv=void 0,e.$Xv=d,e.$Yv=v,e.$Zv=w,e.$2v=u,e.$4v=f,e.$5v=b,e.$Vv=(0,j.$hi)("tunnelService"),e.$Wv=(0,j.$hi)("sharedTunnelsService");var R;(function(g){g.Http="http",g.Https="https"})(R||(e.TunnelProtocol=R={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(g){return!!g.forwardPort}var C;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function v(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(l)return{address:l[1],port:+l[2]}}function w(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const l=g.query.split("&");for(const c of l){const $=c.split("=")[1];if(/^https?:/.exec($)){const i=v(A.URI.parse($));if(i)return i}}}e.$1v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function u(g){return e.$1v.indexOf(g)>=0}e.$3v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(g){return e.$3v.indexOf(g)>=0}function b(g,l,c,$){if(c===1)return!1;if(c===2&&f(l)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(i?.length===4&&parseInt(i[1])>=18)return!1}return g<1024}class m{constructor(l,c,$){this.remoteAddress=l,this.localAddress=c,this.b=$,this.a=new I.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6v=m;let h=class{constructor(l,c){this.k=l,this.l=c,this.a=new I.$7d,this.onTunnelOpened=this.a.event,this.b=new I.$7d,this.onTunnelClosed=this.b.event,this.c=new I.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],c=Array.from(this.e.values());for(const $ of c){const i=Array.from($.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&l.push(n)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:c}of l.values())await c.then($=>typeof $!="string"?$?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,c,$,i,o){this.q(l,c,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:c,localAddress:$,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,c){(f(l)||u(l))&&(l=e.$1v[0]);const $=this.s(l,c);if($)return++$.refcount,$.value}openTunnel(l,c,$,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${$} on local port ${o}.`);const r=this.f??l;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,$,i,o,n,s,t);return a?a.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,$),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&y.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this.e.get(l.tunnelRemoteHost);if(c){const $=c.get(l.tunnelRemotePort);$&&($.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,$))}}}}async p(l,c,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const i=$.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(c),i}}async closeTunnel(l,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const $=this.e.get(l);if($&&$.has(c)){const i=$.get(c);i.refcount=0,await this.p(l,c,i)}}q(l,c,$){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(c,{refcount:1,value:$})}async r(l,c){const $=this.e.get(l);if($){const i=$.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&$.delete(c),$.size===0&&this.e.delete(l)}}s(l,c){const $=[l];u(l)?($.push(...e.$1v),$.push(...e.$3v)):f(l)&&$.push(...e.$3v);const i=$.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(l){return!!v(l)}u(l,c,$,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${$} on local port ${i}.`);const t=$;this.j.add(t);const r=i===void 0?$:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},y={remoteAddress:{host:c,port:$},localAddressPort:i,privacy:n,public:n?n!==P.Private:void 0,protocol:s},E=l.forwardPort(y,a);return E?(this.q(c,$,E),E.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),E}};e.$7v=h,e.$7v=h=ve([Q(0,D.$Nj),Q(1,N.$Ni)],h)}),define(le[236],he([0,1,9,78,2,7,6]),function(se,e,I,A,N,j,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class P extends N.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$Eh),this.b.p)}setAddress(v){this.a=v,this.b&&(this.b.complete(v),this.b=null)}setTunnel(v){this.B(v)}}let d=class extends N.$Uc{static{R=this}static{this.a=0}constructor(v,w){super(),this.f=v,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(v=>v.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(v,w,u,f,b,m,h){const g=new P,l=await Promise.resolve(this.f.openTunnel(v,g,u,f,b,m,h));if(!l||typeof l=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${u}:${f} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),g.dispose(),await l.dispose(),(0,j.$6)();return g.setTunnel(l),this.b.set(w,g),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${l.localAddress} (local) to ${u}:${f} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(v,w){const u=this.b.get(v);u&&u.setAddress(w)}async destroyTunnel(v){const w=this.b.get(v);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${v}.`),this.b.delete(v),await w.dispose();return}this.c.add(v)}};e.$icc=d,e.$icc=d=R=ve([Q(0,A.$Wv),Q(1,I.$Nj)],d)}),define(le[28],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,I.$hi)("IUriIdentityService")}),define(le[237],he([0,1,28,189,12,20,128,3,2]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class d{static{this._clock=0}constructor(w){this.uri=w,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let C=class{constructor(w){this.g=w,this.c=new P.$Tc,this.f=2**16;const u=new Map,f=b=>{let m=u.get(b.scheme);return m===void 0&&(m=w.hasProvider(b)&&!this.g.hasCapability(b,1024),u.set(b.scheme,m)),m};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(b=>{u.delete(b.scheme)})),this.extUri=new j.$Jg(f),this.d=new D.$hs((b,m)=>this.extUri.compare(b,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,j.$Vg)(w));const u=this.d.get(w);return u?u.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new d(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((f,b)=>f[1].time<b[1].time?1:f[1].time>b[1].time?-1:0);d._clock=0,this.d.clear();const u=this.f*.5;for(let f=0;f<u;f++)this.d.set(w[f][0],w[f][1].touch())}};e.$is=C,e.$is=C=ve([Q(0,N.$Nk)],C),(0,A.$fs)(I.$ll,C,1)}),define(le[238],he([0,1,3,2,12,50,35]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;class R extends A.$Uc{constructor(d,C,v,w,u,f){super(),this.f=d,this.g=C,this.h=v,this.j=w,this.m=u,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$7d),this.onDidChangeFile=this.a.event,this.b=j.$ni.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Cc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,C){return this.g.open(this.t(d),C)}close(d){return this.g.close(d)}read(d,C,v,w,u){return this.g.read(d,C,v,w,u)}write(d,C,v,w,u){return this.g.write(d,C,v,w,u)}watch(d,C){this.b.set(d,d);const v=this.g.watch(this.t(d),C);return(0,A.$Sc)(()=>{this.b.delete(d),v.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,C,v){return this.g.rename(this.t(d),this.t(C),v)}readFile(d,C){return this.g.readFile(this.t(d),C)}readFileStream(d,C,v){return this.g.readFileStream(this.t(d),C,v)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,C,v){return this.g.writeFile(this.t(d),C,v)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,C){return this.g.delete(this.t(d),C)}copy(d,C,v){if((0,N.$Rk)(this.g))return this.g.copy(this.t(d),this.t(C),v);throw new Error("copy not supported")}cloneFile(d,C){if((0,N.$Sk)(this.g))return this.g.cloneFile(this.t(d),this.t(C));throw new Error("clone not supported")}s(d){const C=[];for(const v of d){if(v.resource.scheme!==this.f)continue;const w=this.u(v.resource);this.b.findSubstr(w)&&C.push({resource:w,type:v.type,cId:v.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$Dbc=R}),define(le[79],he([0,1,62]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=A,e.$0Hb=N,e.$$Hb=j;function A(D,R,P,d){const C=(0,I.$Jn)(D,R,P,d)[0];return C&&(D=D.substring(0,C.offset)+C.content+D.substring(C.offset+C.length)),D}function N(D,R,P){let d=P;for(;d>=0;){if(D.charAt(d)===R.charAt(R.length-1)&&R.length===1)return d+1;if(d--,R.length===2&&d>=0&&D.charAt(d)===R.charAt(0))return d+2}return 0}function j(D,R,P){let d=P;for(;d>=0;)if(D.charAt(d)===R.charAt(R.length-1)&&R.length===1||(d++,R.length===2&&d>=0&&D.charAt(d)===R.charAt(1)))return d;return D.length-1}}),define(le[239],he([0,1,30,55,13]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=j;function j(u,f,b,m,h,g){const l=[],c=[],$=[];if(!f){const M=u.filter(({identifier:x})=>h.every(J=>J.toLowerCase()!==x.id.toLowerCase()));return{local:{added:l,removed:c,updated:$},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}u=u.map(v),f=f.map(v),b=b?b.map(v):null;const i=new Map,o=M=>{M.uuid&&i.set(M.id.toLowerCase(),M.uuid)};u.forEach(({identifier:M})=>o(M)),f.forEach(({identifier:M})=>o(M)),b?.forEach(({identifier:M})=>o(M)),m?.forEach(({identifier:M})=>o(M)),g?.forEach(M=>o(M));const n=M=>{const x=M.identifier.uuid||i.get(M.identifier.id.toLowerCase());return x?`uuid:${x}`:`id:${M.identifier.id.toLowerCase()}`},s=(M,x)=>(M.set(n(x),x),M),t=u.reduce(s,new Map),r=f.reduce(s,new Map),a=f.reduce((M,x)=>s(M,(0,I.$Nn)(x)),new Map),y=b?b.reduce(s,new Map):null,E=m.reduce(s,new Map),k=h.reduce((M,x)=>{const J=i.get(x.toLowerCase());return M.add(J?`uuid:${J}`:`id:${x.toLowerCase()}`)},new Set),S=g?g.reduce((M,{id:x,uuid:J})=>(J=J??i.get(x.toLowerCase()),M.add(J?`uuid:${J}`:`id:${x.toLowerCase()}`)),new Set):null,p=D(t,r,k,!1);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const M=D(y,t,k,!1),x=D(y,r,k,!0),J=(Z,W,K,V)=>{let B,ie,oe;return W.installed?(B=V.pinned,oe=V.preRelease,B&&(ie=V.version)):(B=K.pinned,oe=K.preRelease,B&&(ie=K.version)),B===void 0&&(B=W.pinned,B&&(ie=W.version)),oe===void 0&&(oe=W.preRelease),{...V,installed:W.installed||K.installed,pinned:B,preRelease:oe,version:ie??(K.version&&(!W.installed||A.gt(K.version,W.version))?K.version:W.version),state:P(W,K,y?.get(Z))}};for(const Z of x.removed.values()){const W=t.get(Z);if(!W)continue;const K=(0,N.$6f)(y?.get(Z)),V=S&&!S.has(Z)&&K.installed;W.installed&&V?c.push(W.identifier):a.set(Z,W)}for(const Z of x.added.values()){const W=(0,N.$6f)(r.get(Z)),K=t.get(Z);if(K){if(p.updated.has(Z)){const V=J(Z,K,W,W);R(K,W,!1,!1)||$.push(w(V,Z)),a.set(Z,V)}}else W.installed&&l.push(w(W,Z))}for(const Z of x.updated.values()){const W=(0,N.$6f)(r.get(Z)),K=(0,N.$6f)(y?.get(Z)),V=t.get(Z);if(V)if(S&&!S.has(Z)&&K.installed&&V.installed&&!W.installed)c.push(V.identifier);else{const ie=J(Z,V,W,W);$.push(w(ie,Z)),a.set(Z,ie)}else W.installed&&l.push(w(W,Z))}for(const Z of M.added.values())x.added.has(Z)||a.set(Z,(0,N.$6f)(t.get(Z)));for(const Z of M.updated.values()){if(x.removed.has(Z)||x.updated.has(Z))continue;const W=(0,N.$6f)(t.get(Z)),K=(0,N.$6f)(r.get(Z));a.set(Z,J(Z,W,K,W))}for(const Z of M.removed.values())x.updated.has(Z)||x.removed.has(Z)||E.has(Z)||(0,N.$6f)(r.get(Z)).installed&&S&&(S.has(Z)||!(0,N.$6f)(y?.get(Z)).installed||a.delete(Z))}const O=[],U=D(r,a,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&a.forEach((M,x)=>O.push(w(M,x))),{local:{added:l,removed:c,updated:$},remote:F?{added:[...U.added].map(M=>a.get(M)),updated:[...U.updated].map(M=>a.get(M)),removed:[...U.removed].map(M=>r.get(M)),all:O}:null}}function D(u,f,b,m){const h=u?[...u.keys()].filter(i=>!b.has(i)):[],g=[...f.keys()].filter(i=>!b.has(i)),l=g.filter(i=>!h.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=h.filter(i=>!g.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),$=new Set;for(const i of h){if(c.has(i))continue;const o=u.get(i),n=f.get(i);(!n||!R(o,n,m,!0))&&$.add(i)}return{added:l,removed:c,updated:$}}function R(u,f,b,m){return!(u.disabled!==f.disabled||!!u.isApplicationScoped!=!!f.isApplicationScoped||m&&u.installed!==f.installed||u.installed&&f.installed&&(u.preRelease!==f.preRelease||u.pinned!==f.pinned||f.pinned&&u.version!==f.version)||!C(u.state,f.state)||b&&u.version!==f.version)}function P(u,f,b){const m=u.state,h=f.state,g=b?.state;if(!f.version||m&&A.gt(u.version,f.version))return m;if(h&&A.gt(f.version,u.version)||!m)return h;if(!h)return m;const l=(0,I.$Nn)(m),c=g?d(g,h):{added:Object.keys(h).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},$=g?d(g,m):{added:Object.keys(m).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])l[i]=h[i];for(const i of c.removed.values())$.updated.has(i)||delete l[i];return l}function d(u,f){const b=Object.keys(u),m=Object.keys(f),h=m.filter(c=>!b.includes(c)).reduce((c,$)=>(c.add($),c),new Set),g=b.filter(c=>!m.includes(c)).reduce((c,$)=>(c.add($),c),new Set),l=new Set;for(const c of b){if(g.has(c))continue;const $=u[c],i=f[c];(0,I.$Rn)($,i)||l.add(c)}return{added:h,removed:g,updated:l}}function C(u={},f={}){const{added:b,removed:m,updated:h}=d(u,f);return b.size===0&&m.size===0&&h.size===0}function v(u){return{...u,disabled:!!u.disabled,installed:!!u.installed}}function w(u,f){const b={...u,identifier:{id:u.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!u.preRelease,pinned:!!u.pinned};return u.disabled||delete b.disabled,u.installed||delete b.installed,u.state||delete b.state,u.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fKb=e.$eKb=void 0,e.$eKb=(0,N.$hi)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==R&&C!==`-${R}`),P&&d.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(R,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==R&&C!==`-${R}`),P&&d.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(R){const P=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),d=this.b().map(w=>w.toLowerCase()),C=[],v=[];if(Array.isArray(d))for(const w of d)w.startsWith("-")?v.push(w.substring(1)):C.push(w);return(0,I.$Mb)([...P,...C].filter(w=>!v.includes(w)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$fKb=j,e.$fKb=j=ve([Q(0,A.$Ni)],j)}),define(le[240],he([0,1,17,34,30,93,79]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=P;function R(c){return(0,A.$un)(c)||[]}async function P(c,$,i,o,n){const s=R(c),t=R($),r=i?R(i):null,a=[...s,...t,...r||[]].map(J=>J.key),y=await n.resolveUserBindings(a),E=C(s,t,r,y);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const k=w(s),S=w(t),p=r?w(r):null,O=f(k,S,y),U=p?f(p,k,y):{added:[...k.keys()].reduce((J,Z)=>(J.add(Z),J),new Set),removed:new Set,updated:new Set},F=p?f(p,S,y):{added:[...S.keys()].reduce((J,Z)=>(J.add(Z),J),new Set),removed:new Set,updated:new Set},M=d(O,U,F);let x=c;for(const J of M.removed.values())M.conflicts.has(J)||(x=g(x,J,o));for(const J of M.added.values()){if(M.conflicts.has(J))continue;const Z=S.get(J);if(Z.some(W=>W.command!==`-${J}`&&E.conflicts.has(y[W.key]))){M.conflicts.add(J);continue}x=h(x,Z,o)}for(const J of M.updated.values()){if(M.conflicts.has(J))continue;const Z=S.get(J);if(Z.some(W=>W.command!==`-${J}`&&E.conflicts.has(y[W.key]))){M.conflicts.add(J);continue}x=l(x,J,Z,o)}return{mergeContent:x,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function d(c,$,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of $.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||($.updated.has(r)?t.add(r):n.add(r));for(const r of $.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||($.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of $.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||($.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,$,i,o){const n=new Set,s=v(c,o),t=v($,o),r=i?v(i,o):null,a=u(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const y=r?u(r,s):{added:[...s.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const E=r?u(r,t):{added:[...t.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:k,removed:S,updated:p,conflicts:O}=d(a,y,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:S,updated:p,conflicts:O}}function v(c,$){const i=new Map;for(const o of c){const n=$[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function w(c){const $=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=$.get(o);n||(n=[],$.set(o,n)),n.push(i)}return $}function u(c,$){const i=[...c.keys()],o=[...$.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(E=>({...E,key:r})),y=$.get(r).map(E=>({...E,key:r}));(0,I.$ub)(a,y,(E,k)=>m(E,k))||t.add(r)}return{added:n,removed:s,updated:t}}function f(c,$,i){const o=[...c.keys()],n=[...$.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const y=c.get(a).map(k=>({...k,key:i[k.key]})),E=$.get(a).map(k=>({...k,key:i[k.key]}));b(y,E)||r.add(a)}return{added:s,removed:t,updated:r}}function b(c,$){return!(!(0,I.$ub)(c.filter(({command:i})=>i[0]!=="-"),$.filter(({command:i})=>i[0]!=="-"),(i,o)=>m(i,o))||!(0,I.$ub)(c.filter(({command:i})=>i[0]==="-"),$.filter(({command:i})=>i[0]==="-"),(i,o)=>m(i,o)))}function m(c,$){if(c.command!==$.command||c.key!==$.key)return!1;const i=j.$fj.deserialize(c.when),o=j.$fj.deserialize($.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!N.$Rn(c.args,$.args))}function h(c,$,i){for(const o of $)c=D.edit(c,[-1],o,i);return c}function g(c,$,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===$||o[n].command===`-${$}`)&&(c=D.edit(c,[n],void 0,i));return c}function l(c,$,i,o){const n=R(c),s=n.findIndex(t=>t.command===$||t.command===`-${$}`);for(let t=n.length-1;t>=0;t--)(n[t].command===$||n[t].command===`-${$}`)&&(c=D.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=D.edit(c,[s],i[t],o);return c}}),define(le[241],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=I,e.$69b=N;function I(j,D,R){const P={},d={},C=new Set;if(!D)return{local:{added:P,updated:d,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const v=A(j,D);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:P,updated:d,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=A(R,j),u=A(R,D),f={},b={},m=new Set,h=new Set;for(const g of w.removed.values())u.updated.has(g)?P[g]=D[g]:m.add(g);for(const g of u.removed.values())h.has(g)||(w.updated.has(g)?h.add(g):C.add(g));for(const g of w.updated.values())h.has(g)||(u.updated.has(g)?v.updated.has(g)&&h.add(g):b[g]=j[g]);for(const g of u.updated.values())h.has(g)||(w.updated.has(g)?v.updated.has(g)&&h.add(g):j[g]!==void 0&&(d[g]=D[g]));for(const g of w.added.values())h.has(g)||(u.added.has(g)?v.updated.has(g)&&h.add(g):f[g]=j[g]);for(const g of u.added.values())h.has(g)||(w.added.has(g)?v.updated.has(g)&&h.add(g):P[g]=D[g]);return{local:{added:P,removed:[...C.values()],updated:d},remote:{added:f,removed:[...m.values()],updated:b},conflicts:[...h.values()]}}function A(j,D){const R=j?Object.keys(j):[],P=D?Object.keys(D):[],d=P.filter(w=>!R.includes(w)).reduce((w,u)=>(w.add(u),w),new Set),C=R.filter(w=>!P.includes(w)).reduce((w,u)=>(w.add(u),w),new Set),v=new Set;for(const w of R){if(C.has(w))continue;const u=j[w],f=D[w];u!==f&&v.add(w)}return{added:d,removed:C,updated:v}}function N(j,D){const{added:R,removed:P,updated:d}=A(j,D);return R.size===0&&P.size===0&&d.size===0}}),define(le[242],he([0,1,30]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=A;function A(j,D,R,P){const d={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!D){const w=j.filter(({id:u})=>!P.includes(u));return w.length?C.added=w:C=null,{local:d,remote:C}}const v=N(j,D,P);if(v.added.length>0||v.removed.length>0||v.updated.length>0){const w=N(R,j,P),u=N(R,D,P);for(const f of u.removed){const b=j.find(m=>m.id===f);b&&d.removed.push(b)}for(const f of u.added){const b=D.find(m=>m.id===f);w.added.includes(f)?v.updated.includes(f)&&d.updated.push(b):d.added.push(b)}for(const f of u.updated)d.updated.push(D.find(b=>b.id===f));for(const f of w.added)u.added.includes(f)||C.added.push(j.find(b=>b.id===f));for(const f of w.updated)u.removed.includes(f)||u.updated.includes(f)||C.updated.push(j.find(b=>b.id===f));for(const f of w.removed){const b=D.find(m=>m.id===f);b&&C.removed.push(b)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:d,remote:C}}function N(j,D,R){j=j?j.filter(({id:u})=>!R.includes(u)):[],D=D.filter(({id:u})=>!R.includes(u));const P=j.map(({id:u})=>u),d=D.map(({id:u})=>u),C=d.filter(u=>!P.includes(u)),v=P.filter(u=>!d.includes(u)),w=[];for(const{id:u,name:f,shortName:b,icon:m,useDefaultFlags:h}of j){if(v.includes(u))continue;const g=D.find(l=>l.id===u);(!g||g.name!==f||g.shortName!==b||g.icon!==m||!(0,I.$Rn)(g.useDefaultFlags,h))&&w.push(u)}return{added:C,removed:v,updated:w}}}),define(le[25],he([0,1,17,13,177,46,29,4,102,41]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpb=e.$Wpb=e.$Vpb=e.$Upb=e.$Tpb=e.$Spb=e.$Rpb=e.$Qpb=e.$Ppb=e.$Npb=e.MergeState=e.Change=e.SyncStatus=e.$Mpb=e.$Lpb=e.$Kpb=e.UserDataSyncErrorCode=e.$Ipb=e.$Hpb=e.$Gpb=e.$Fpb=e.$Epb=e.$Bpb=e.SyncResource=e.$ypb=e.$xpb=void 0,e.$vpb=C,e.$wpb=v,e.$zpb=w,e.$Apb=u,e.$Cpb=b,e.$Dpb=m,e.$Jpb=h,e.$Opb=s;function C(){const t=d.$Zn.as(j.$5n.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function v(){const t=d.$Zn.as(j.$5n.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(E=>!!t[E].ignoreSync),a=Object.keys(t).filter(E=>t[E].scope===2||t[E].scope===6),y=C();return(0,I.$Mb)([...r,...a,...y])}e.$xpb="settingsSync",e.$ypb="settingsSync.keybindingsPerPlatform";function w(){const t="vscode://schemas/ignoredSettings",r=d.$Zn.as(j.$5n.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$ypb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:D.$Eo,errorMessage:(0,N.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=d.$Zn.as(P.$1n.JSONContribution),y=()=>{const E=C(),k=v(),S=Object.keys(j.$6n.properties).filter(U=>!k.includes(U)),p=k.filter(U=>!E.includes(U)),O={items:{type:"string",enum:[...S,...p.map(U=>`-${U}`)]}};a.registerSchema(t,O)};return r.onDidUpdateConfiguration(()=>y())}function u(t){return t&&(0,A.$Wf)(t)&&(0,A.$Uf)(t.id)&&Array.isArray(t.scopes)}var f;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.$Bpb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}function m(t,r,a,y){return y.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$Epb=(0,R.$hi)("IUserDataSyncStoreManagementService"),e.$Fpb=(0,R.$hi)("IUserDataSyncStoreService"),e.$Gpb=(0,R.$hi)("IUserDataSyncLocalStoreService"),e.$Hpb="x-operation-id",e.$Ipb="X-Execution-Id";function h(t){const r={};return r[e.$Ipb]=t,r}var g;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(g||(e.UserDataSyncErrorCode=g={}));class l extends Error{constructor(r,a,y,E){super(r),this.code=a,this.resource=y,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Kpb=l;class c extends l{constructor(r,a,y,E,k){super(r,y,void 0,k),this.url=a,this.serverCode=E}}e.$Lpb=c;class $ extends l{constructor(r,a){super(r,a)}}e.$Mpb=$,function(t){function r(a){if(a instanceof t)return a;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(y&&y[1]){const E=y[2]==="unknown"?void 0:y[2],k=y[3]==="unknown"?void 0:y[3];return new t(a.message,y[1],E,k)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(l||(e.$Kpb=l={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Npb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Ppb=(0,R.$hi)("IUserDataSyncEnablementService"),e.$Qpb=(0,R.$hi)("IUserDataSyncService"),e.$Rpb=(0,R.$hi)("IUserDataSyncResourceProviderService"),e.$Spb=(0,R.$hi)("IUserDataAutoSyncService"),e.$Tpb=(0,R.$hi)("IUserDataSyncUtilService"),e.$Upb=(0,R.$hi)("IUserDataSyncLogService"),e.$Vpb="userDataSync",e.$Wpb="vscode-userdata-sync",e.$Xpb="preview"}),define(le[243],he([0,1,30,25]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJb=N;function N(D,R,P,d,C){if(!R)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const v=j(D,R);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=P?j(P,R):{added:Object.keys(R).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},u=P?j(P,D):{added:Object.keys(D).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},b=I.$Nn(R),m=!P;for(const g of u.added.values())g!==A.$Npb&&m&&w.added.has(g)||(b[g]=D[g]);for(const g of u.updated.values())b[g]=D[g];for(const g of u.removed.values())d.unregistered.includes(g)||delete b[g];for(const g of w.added.values()){const l=R[g];if(d.machine.includes(g)){C.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(P&&u.added.has(g))continue;const c=D[g];c&&c.value===l.value||g===A.$Npb&&m&&u.added.has(g)||(c?f.updated[g]=l:f.added[g]=l)}for(const g of w.updated.values()){const l=R[g];if(d.machine.includes(g)){C.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(g)||u.removed.has(g))continue;const c=D[g];c&&c.value===l.value||(f.updated[g]=l)}for(const g of w.removed.values()){if(d.machine.includes(g)){C.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}u.updated.has(g)||u.removed.has(g)||f.removed.push(g)}const h=j(R,b);return{local:f,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:b}}}function j(D,R){const P=Object.keys(D),d=Object.keys(R),C=d.filter(u=>!P.includes(u)).reduce((u,f)=>(u.add(f),u),new Set),v=P.filter(u=>!d.includes(u)).reduce((u,f)=>(u.add(f),u),new Set),w=new Set;for(const u of P){if(v.has(u))continue;const f=D[u],b=R[u];I.$Rn(f,b)||w.add(u)}return{added:C,removed:v,updated:w}}}),define(le[244],he([0,1,17,34,62,42,30,79,25]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Hb=d,e.$aIb=w,e.$bIb=u,e.$cIb=f,e.$dIb=m,e.$eIb=g;function d(a,y,E){let k=[];E?k=v(E):k=C(y);const S=[],p=[...(0,P.$vpb)()];if(Array.isArray(k))for(const O of k)O.startsWith("-")?p.push(O.substring(1)):S.push(O);return(0,I.$Mb)([...a,...S].filter(O=>!p.includes(O)))}function C(a){let y=a.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=a.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:a.getValue("settingsSync.ignoredSettings")||[]}function v(a){const y=(0,A.$un)(a);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function w(a,y){const E=(0,A.$un)(a)||{};let k="{}";for(const S of Object.keys(E)){const p=(0,N.$Jn)(k,[S],E[S],y);k=(0,N.$Mn)(k,p)}return k}function u(a,y,E,k){if(E.length){const S=r(y),p=(0,A.$un)(y)||{},O=(0,A.$un)(a);if(!O)return a;const U=[];for(const F of E){const M=p[F],x=O[F];M===void 0?a=R.edit(a,[F],void 0,k):x!==void 0?a=R.edit(a,[F],M,k):U.push(i(F,S))}U.sort((F,M)=>F.startOffset-M.startOffset),U.forEach(F=>a=g(F.setting.key,y,a,k))}return a}function f(a,y,E,k,S,p){const O=u(a,y,k,p),U=E!==O,F=E!==y;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:u(y,a,k,p),remoteContent:null,hasConflicts:!1};if(E===null&&m(a)){const T=b(a,y,k)?null:u(y,a,k,p);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let M=a,x=y;const J=(0,A.$un)(a),Z=(0,A.$un)(y),W=E?(0,A.$un)(E):null,K=k.reduce((T,z)=>(T.add(z),T),new Set),V=h(J,Z,K),B=h(W,J,K),ie=h(W,Z,K),oe=new Map,te=new Set,ce=T=>{te.add(T);const z=S.filter(({key:Y})=>Y===T)[0];z?(M=R.edit(M,[T],z.value,p),x=R.edit(x,[T],z.value,p)):oe.set(T,{key:T,localValue:J[T],remoteValue:Z[T]})};for(const T of B.removed.values())ie.updated.has(T)?ce(T):x=R.edit(x,[T],void 0,p);for(const T of ie.removed.values())te.has(T)||(B.updated.has(T)?ce(T):M=R.edit(M,[T],void 0,p));for(const T of B.updated.values())te.has(T)||(ie.updated.has(T)?V.updated.has(T)&&ce(T):x=R.edit(x,[T],J[T],p));for(const T of ie.updated.values())te.has(T)||(B.updated.has(T)?V.updated.has(T)&&ce(T):M=R.edit(M,[T],Z[T],p));for(const T of B.added.values())te.has(T)||(ie.added.has(T)?V.updated.has(T)&&ce(T):x=g(T,M,x,p));for(const T of ie.added.values())te.has(T)||(B.added.has(T)?V.updated.has(T)&&ce(T):M=g(T,x,M,p));const H=oe.size>0||!b(M,x,k),q=H||!b(M,a,[]),L=H||!b(x,y,[]);return{localContent:q?M:null,remoteContent:L?x:null,conflictsSettings:[...oe.values()],hasConflicts:H}}function b(a,y,E){if(a===y)return!0;const k=(0,A.$un)(a),S=(0,A.$un)(y),p=E.reduce((F,M)=>(F.add(M),F),new Set),O=r(a).filter(F=>!(F.setting&&p.has(F.setting.key))),U=r(y).filter(F=>!(F.setting&&p.has(F.setting.key)));if(O.length!==U.length)return!1;for(let F=0;F<O.length;F++){const M=O[F],x=U[F];if(M.setting&&x.setting){if(M.setting.key!==x.setting.key||!D.$Rn(k[M.setting.key],S[M.setting.key]))return!1}else if(!M.setting&&!x.setting){if(M.value!==x.value)return!1}else return!1}return!0}function m(a){return a?r(a).length===0:!0}function h(a,y,E){const k=a?Object.keys(a).filter(F=>!E.has(F)):[],S=Object.keys(y).filter(F=>!E.has(F)),p=S.filter(F=>!k.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),O=k.filter(F=>!S.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),U=new Set;if(a)for(const F of k){if(O.has(F))continue;const M=a[F],x=y[F];D.$Rn(M,x)||U.add(F)}return{added:p,removed:O,updated:U}}function g(a,y,E,k){const S=(0,A.$un)(y),p=r(y),O=r(E),U=l(a,p,O);return c(E,a,S[a],U,O,k)}function l(a,y,E){const k=y.findIndex(p=>p.setting?.key===a),S=y[k-1];if(S){if(S.setting){const O=i(S.setting.key,E);if(O)return{index:E.indexOf(O),insertAfter:!0}}else{const O=o(k,y);if(O){const U=i(O.setting.key,E);if(U){const F=n(E.indexOf(U),E),M=s(y,O,y[k]);if(F){const x=s(E,U,F),J=t(M,x);return J?{index:E.indexOf(J),insertAfter:!0}:{index:E.indexOf(F),insertAfter:!1}}else{const x=s(E,U,E[E.length-1]),J=t(M,x);return J?{index:E.indexOf(J),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const p=y[k+1];if(p)if(p.setting){const O=i(p.setting.key,E);if(O)return{index:E.indexOf(O),insertAfter:!1}}else{const O=n(k,y);if(O){const U=i(O.setting.key,E);if(U){const F=o(E.indexOf(U),E),M=s(y,y[k],O);if(F){const x=s(E,F,U),J=t(M.reverse(),x.reverse());return J?{index:E.indexOf(J),insertAfter:!1}:{index:E.indexOf(F),insertAfter:!0}}else{const x=s(E,E[0],U),J=t(M.reverse(),x.reverse());return J?{index:E.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function c(a,y,E,k,S,p){let O;return k.index===-1?O=(0,N.$Jn)(a,[y],E,p):O=$(a,y,E,k,S,p).map(U=>(0,N.$Kn)(a,U,p)[0]),(0,N.$Mn)(a,O)}function $(a,y,E,k,S,p){const O=`${JSON.stringify(y)}: ${JSON.stringify(E)}`,U=(0,j.$Gn)(p,a),F=S[k.index];if(k.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+O});else{const x=n(k.index,S),J=o(k.index,S),Z=J?.setting?.commaOffset;J&&Z===void 0&&M.push({offset:J.endOffset,length:0,content:","});const W=Z!==void 0&&Z>F.endOffset;M.push({offset:W?Z+1:F.endOffset,length:0,content:x?U+O+",":U+O})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:O+","}];const M=(S[k.index-1]&&!S[k.index-1].setting?U:"")+O+(n(k.index,S)?",":"")+U;return[{offset:F.startOffset,length:0,content:M}]}}function i(a,y){return y.filter(E=>E.setting?.key===a)[0]}function o(a,y){for(let E=a-1;E>=0;E--)if(y[E].setting)return y[E]}function n(a,y){for(let E=a+1;E<y.length;E++)if(y[E].setting)return y[E]}function s(a,y,E){const k=a.indexOf(y),S=a.indexOf(E);return a.filter((p,O)=>k<O&&O<S)}function t(a,y){if(a.length&&y.length){let E=0;for(;E<y.length&&E<a.length;E++)if(a[E].value!==y[E].value)return y[E-1];return y[E-1]}}function r(a){const y=[];let E=-1,k,S;const p={onObjectBegin:O=>{E++},onObjectProperty:(O,U,F)=>{E===0&&(k=U,S=O)},onObjectEnd:(O,U)=>{E--,E===0&&y.push({startOffset:k,endOffset:O+U,value:a.substring(k,O+U),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(O,U)=>{E++},onArrayEnd:(O,U)=>{E--,E===0&&y.push({startOffset:k,endOffset:O+U,value:a.substring(k,O+U),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(O,U,F)=>{E===0&&y.push({startOffset:k,endOffset:U+F,value:a.substring(k,U+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(O,U,F)=>{if(E===0&&O===","){let M=y.length-1;for(;M>=0&&!y[M].setting;M--);const x=y[M];x&&y.splice(M,1,{startOffset:x.startOffset,endOffset:x.endOffset,value:x.value,setting:{key:x.setting.key,commaOffset:U}})}},onComment:(O,U)=>{E===0&&y.push({startOffset:O,endOffset:O+U,value:a.substring(O,O+U)})}};return(0,A.$Bn)(a,p),y}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WHb=e.$VHb=void 0,e.$VHb=(0,N.$hi)("IUserDataSyncAccountService");let D=class extends A.$Uc{get account(){return this.a}constructor(P,d){super(),this.g=P,this.h=d,this.b=this.B(new I.$7d),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$7d),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$WHb=D,e.$WHb=D=ve([Q(0,j.$Fpb),Q(1,j.$Upb)],D)}),define(le[245],he([0,1,20,178,16,9,25]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gKb=void 0;let R=class extends j.$Sj{constructor(d,C){super(),this.g=this.B(d.createLogger((0,I.$Ug)(C.logsHome,`${D.$Vpb}.log`),{id:D.$Vpb,name:(0,A.localize)(0,null)}))}trace(d,...C){this.g.trace(d,...C)}debug(d,...C){this.g.debug(d,...C)}info(d,...C){this.g.info(d,...C)}warn(d,...C){this.g.warn(d,...C)}error(d,...C){this.g.error(d,...C)}flush(){this.g.flush()}};e.$gKb=R,e.$gKb=R=ve([Q(0,j.$Oj),Q(1,N.$oi)],R)}),define(le[246],he([0,1,6,3,2]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class j extends N.$Uc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:P,getActiveWindowId:d}){super(),this.a=this.B(new N.$Tc),A.Event.latch(A.Event.any(R,P))(this.f,this,this.a),this.b=(0,I.$7g)(()=>d()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$$ac=j}),define(le[112],he([0,1,181,15,50,20,8,4,23]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=d,e.$si=C,e.$vi=v,e.$wi=w,e.$xi=u,e.$yi=b,e.$zi=m,e.$Ci=l,e.$Hi=c,e.$Ii=$,e.$Ki=i,e.$Li=o,e.$Mi=n,e.$qi=(0,R.$hi)("contextService");function d(s){const t=s;return typeof t?.id=="string"&&D.URI.isUri(t.uri)}function C(s){return typeof s?.id=="string"&&!d(s)&&!w(s)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function v(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.$oc)(s)}:t?e.$ti:e.$ui;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function w(s){const t=s;return typeof t?.id=="string"&&D.URI.isUri(t.configPath)}function u(s){const t=s;if(t?.uri)return{id:t.id,uri:D.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function m(s){const t=s;return!!(t&&typeof t=="object"&&D.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class h{constructor(t,r,a,y,E){this.h=t,this.j=a,this.k=y,this.l=E,this.c=N.$ni.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=N.$ni.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=h;class g{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Ug)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=g;function l(s){return new g({uri:s,index:0,name:(0,j.$Qg)(s)},{uri:s.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,I.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function c(s,t){return j.$Lg.isEqualOrParent(s,t.untitledWorkspacesHome)}function $(s){let t;return D.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===P.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ji}function o(s,t){return!c(s,t)&&!$(s)}function n(s){return(typeof s=="string"?(0,A.$pc)(s):(0,j.$Sg)(s))===e.$Ei}}),define(le[18],he([0,1,54,3,2,20,8,172,16,12,4,9,112,35,28,6,32,27,13]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=c,e.$ol=$,e.$pl=i;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&D.URI.isUri(t.location)&&D.URI.isUri(t.globalStorageHome)&&D.URI.isUri(t.settingsResource)&&D.URI.isUri(t.keybindingsResource)&&D.URI.isUri(t.tasksResource)&&D.URI.isUri(t.snippetsHome)&&D.URI.isUri(t.extensionsResource))}e.$nl=(0,C.$hi)("IUserDataProfilesService");function $(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:D.URI.revive(s.location).with({scheme:t}),globalStorageHome:D.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:D.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:D.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:D.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:D.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:D.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:D.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,y,E){return{id:s,name:t,location:r,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:E&&y?.useDefaultFlags?.globalState?E.globalStorageHome:(0,j.$Ug)(r,"globalStorage"),settingsResource:E&&y?.useDefaultFlags?.settings?E.settingsResource:(0,j.$Ug)(r,"settings.json"),keybindingsResource:E&&y?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,j.$Ug)(r,"keybindings.json"),tasksResource:E&&y?.useDefaultFlags?.tasks?E.tasksResource:(0,j.$Ug)(r,"tasks.json"),snippetsHome:E&&y?.useDefaultFlags?.snippets?E.snippetsHome:(0,j.$Ug)(r,"snippets"),extensionsResource:E&&y?.useDefaultFlags?.extensions?E.extensionsResource:(0,j.$Ug)(r,"extensions.json"),cacheHome:(0,j.$Ug)(a,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let o=class extends N.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,y){super(),this.t=t,this.u=r,this.w=a,this.y=y,this.f=!0,this.h=this.B(new A.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Bc,emptyWindows:new Map},this.profilesHome=(0,j.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const E of this.O()){if(!E.name||!(0,g.$Uf)(E.name)||!E.location){this.y.warn("Skipping the invalid stored profile",E.location||E.name);continue}r.push(i((0,j.$Rg)(E.location),E.name,E.location,this.g,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},t))}}catch(E){this.y.error(E)}const a=new u.$Bc,y=new Map;if(r.length)try{const E=this.Q();if(E.workspaces)for(const[k,S]of Object.entries(E.workspaces)){const p=D.URI.parse(k),O=r.find(U=>U.id===S);O&&a.set(p,O)}if(E.emptyWindows)for(const[k,S]of Object.entries(E.emptyWindows)){const p=r.find(O=>O.id===S);p&&y.set(k,p)}}catch(E){this.y.error(E)}this.z={profiles:r,workspaces:a,emptyWindows:y}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,h.$Ze)(r)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const S=a.exec(k.name),p=S?parseInt(S[1]):0;y=p>y?p:y}const E=`${r} ${y+1}`;return this.createProfile((0,I.$8i)((0,m.$Dg)()).toString(16),E,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,I.$8i)((0,m.$Dg)()).toString(16),t,r,a)}async createProfile(t,r,a,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.F(t,r,a);return y&&await this.setProfileForWorkspace(y,E),E}async F(t,r,a){if(!(0,g.$Uf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(r);return y||(y=(async()=>{try{const E=this.profiles.find(p=>p.name===r||p.id===t);if(E)return E;const k=i(t,r,(0,j.$Ug)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(k.location);const S=[];return this.j.fire({profile:k,join(p){S.push(p)}}),await b.Promises.settled(S),this.I([k],[],[]),k}finally{this.r.delete(r)}})(),this.r.set(r,y)),y}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(y=>y.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(y=>y.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(y){a.push(y)}});try{await Promise.allSettled(a)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(y){(0,d.$5k)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(y=>y.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,w.$ri)(t)?t.uri:(0,w.$wi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const y=[...this.profiles,...t],E=[];this.s.profiles=[];for(let k of y)k.isDefault||r.some(S=>k.id===S.id)||(k=a.find(S=>k.id===S.id)??k,k.isTransient?this.s.profiles.push(k):E.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(E),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const y=this.G(t),E=a?this.s:this.C;D.URI.isUri(y)?(E.workspaces.delete(y),r&&E.workspaces.set(y,r)):(E.emptyWindows.delete(y),r&&E.emptyWindows.set(y,r)),a||this.M()}M(){const t={};for(const[a,y]of this.C.workspaces.entries())t[a.toString()]=y.id;const r={};for(const[a,y]of this.C.emptyWindows.entries())r[a.toString()]=y.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[E,k]of Object.entries(t.workspaces)){const S=D.URI.parse(k);r[E]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const y={};if(t.emptyWindows)for(const[E,k]of Object.entries(t.emptyWindows)){const S=D.URI.parse(k);y[E]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:y}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$ql=o,e.$ql=o=ve([Q(0,P.$oi),Q(1,d.$Nk),Q(2,f.$ll),Q(3,v.$Nj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$rl=n}),define(le[247],he([0,1,6,2,18]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;let j=class extends A.$Uc{constructor(R){super(),this.B(new I.$th(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$kcc=j,e.$kcc=j=ve([Q(0,N.$nl)],j)}),define(le[248],he([0,1,17,6,26,7,3,2,5,13,8,154,29,33,47,9,24,22,28,18]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$8p=void 0,e.$9p=$,e.$0p=i;let c=class extends R.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,y,E,k){super(),this.z=t,this.C=r,this.D=a,this.F=y,this.G=E,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$7d),this.s=this.B(new D.$7d),this.t=this.B(new D.$7d),this.u=this.B(new D.$7d),this.w=this.B(new D.$7d),this.y=[],this.B((0,R.$Sc)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.m.forEach(S=>S.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,w.$Oo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const y=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:E})=>(0,u.$fp)(E,t.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new w.$Ro(`Unknown error while installing extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new w.$Ro(v.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:y,options:E})=>{try{const k=await this.N(y,!!E?.installGivenVersion,!!E?.installPreReleaseVersion,E.productVersion??{version:this.G.version,date:this.G.date});a.push({...k,options:E})}catch(k){r.push({identifier:y.identifier,operation:2,source:y,error:k})}})),a.length&&r.push(...await this.I(a));for(const y of r)y.error&&(this.F.error("Failed to install extension.",y.identifier.id),this.F.error(y.error),y.source&&!C.URI.isUri(y.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,u.$np)(y.source),error:y.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,f.$Fm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const y of this.H.profiles){const E=(await this.getInstalled(1,y.extensionsResource)).find(k=>(0,u.$fp)(k.identifier,t.identifier));E?this.w.fire(E):this.u.fire({identifier:t.identifier,profileLocation:y.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,y=[],E=[],k=(p,O)=>`${u.$gp.create(p).toString()}-${O.toString()}`,S=(p,O,U)=>{const F=this.Y(p,O,U),M=C.URI.isUri(O)?O.path:`${O.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`;a.set(M,{task:F,manifest:p}),this.n.fire({identifier:F.identifier,source:O,profileLocation:U.profileLocation}),this.F.info("Installing extension:",F.identifier.id),C.URI.isUri(O)||this.j.set(k(O,U.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:p,extension:O,options:U}of t){const F=U.isApplicationScoped||U.isBuiltin||(0,f.$Fm)(p),M={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!C.URI.isUri(O),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:U.profileLocation??this.X(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},x=C.URI.isUri(O)?void 0:this.j.get(k(O,M.profileLocation));x?(this.F.info("Extension is already requested to install",x.task.identifier.id),y.push(x.task.waitUntilTaskIsFinished())):S(p,O,M)}await Promise.all([...a.values()].map(async({task:p,manifest:O})=>{if(p.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",p.identifier.id);else try{const U=await this.M(p.identifier,O,!!p.options.installOnlyNewlyAddedFromExtensionPack,!!p.options.installPreReleaseVersion,p.options.profileLocation,p.options.productVersion),F=await this.getInstalled(void 0,p.options.profileLocation,p.options.productVersion),M={...p.options,donotIncludePackAndDependencies:!0,context:{...p.options.context,[w.$Jo]:!0}};for(const{gallery:x,manifest:J}of(0,I.$Mb)(U,({gallery:Z})=>Z.identifier.id)){if(a.has(`${x.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const Z=this.j.get(k(x,M.profileLocation));if(Z){if(this.J(p,Z.task)){const W=Z.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,p.identifier.id),Z.waitingTasks.push(p),y.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,K=>K.some(V=>(0,u.$fp)(V.identifier,W)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,p.identifier.id),!K.find(B=>(0,u.$fp)(B.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else F.some(({identifier:W})=>(0,u.$fp)(W,x.identifier))||S(J,x,M)}}catch(U){if(C.URI.isUri(p.source))(0,I.$Lb)(O.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",p.identifier.id,U.message),(0,I.$Lb)(O.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",p.identifier.id,U.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",p.identifier.id),U}})),await this.L([...a.values()].map(async({task:p})=>{const O=new Date().getTime();try{const U=await p.run();if(await this.L(this.y.map(F=>F.postInstall(U,p.source,p.options,N.CancellationToken.None))),!C.URI.isUri(p.source)){const F=p.operation===3,M=F?void 0:(new Date().getTime()-p.source.lastUpdated)/1e3;if(o(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$np)(p.source),verificationStatus:p.verificationStatus,duration:new Date().getTime()-O,durationSinceUpdate:M}),P.$o&&p.operation!==3)try{await this.z.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}}E.push({local:U,identifier:p.identifier,operation:p.operation,source:p.source,context:p.options.context,profileLocation:p.profileLocation,applicationScoped:U.isApplicationScoped})}catch(U){throw this.F.error("Error while installing the extension",p.identifier.id,(0,j.$0)(U)),U}})),y.length&&await this.L(y);for(const p of E)this.F.info("Extension installed successfully:",p.identifier.id),r.push(p);return r}catch(p){E.length&&await Promise.allSettled(E.map(async({local:O,profileLocation:U})=>{try{await this.Z(O,{versionOnly:!0,profileLocation:U}).run(),this.F.info("Rollback: Uninstalled extension",O.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",O.identifier.id,(0,j.$0)(F))}}));for(const{task:O}of a.values())O.cancel(),r.push({identifier:O.identifier,operation:2,source:O.source,context:O.options.context,profileLocation:O.profileLocation,error:p});throw p}finally{for(const{task:p}of a.values())p.source&&!C.URI.isUri(p.source)&&this.j.delete(k(p.source,p.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:y}]of this.j.entries())if(a===t&&(y.includes(r)||y.some(E=>this.J(E,r)))||a===r&&y[0]&&!this.J(t,y[0]))return!1;return!0}async L(t){const r=[],a=[],y=await Promise.allSettled(t);for(const E of y)E.status==="fulfilled"?r.push(E.value):a.push(E.reason);if(a.length)throw $(a);return r}async M(t,r,a,y,E,k){if(!this.z.isEnabled())return[];const S=await this.getInstalled(void 0,E,k),p=[],O=[],U=async(F,M)=>{p.push(F);const x=M.extensionDependencies||[],J=[...x];if(M.extensionPack){const Z=a?S.find(W=>(0,u.$fp)(W.identifier,F)):void 0;for(const W of M.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(K=>(0,u.$fp)({id:K},{id:W}))||J.every(K=>!(0,u.$fp)({id:K},{id:W}))&&J.push(W)}if(J.length){const Z=J.filter(W=>p.every(K=>!(0,u.$fp)(K,{id:W})));if(Z.length){const W=await this.z.getExtensions(Z.map(K=>({id:K,preRelease:y})),N.CancellationToken.None);for(const K of W){if(p.find(ie=>(0,u.$fp)(ie,K.identifier)))continue;const V=x.some(ie=>(0,u.$fp)({id:ie},K.identifier));let B;try{B=await this.N(K,!1,y,k)}catch(ie){if(V)throw ie;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,j.$0)(ie));continue}O.push({gallery:B.extension,manifest:B.manifest}),await U(B.extension.identifier,B.manifest)}}}};return await U(t,r),O}async N(t,r,a,y){let E;const k=await this.getExtensionsControlManifest();if(k.malicious.some(O=>(0,u.$fp)(t.identifier,O)))throw new w.$Ro(v.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);const S=k.deprecated[t.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},N.CancellationToken.None))[0],!E)throw new w.$Ro(v.localize(2,null,t.identifier.id,S.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new w.$Ro(v.localize(3,null,t.identifier.id,this.G.nameLong,(0,w.$Ko)(O)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.O(t,r,a,y),!E)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],N.CancellationToken.None))[0]?new w.$Ro(v.localize(4,null,t.displayName??t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$Ro(v.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const p=await this.z.getManifest(E,N.CancellationToken.None);if(p===null)throw new w.$Ro(`Missing manifest for extension ${E.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(p.version!==E.version)throw new w.$Ro(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:p}}async O(t,r,a,y){const E=await this.getTargetPlatform();let k=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(k=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:E,compatible:!0,productVersion:y},N.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(t,a,E,y)&&(k=t),k||(r?k=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:E,compatible:!0,productVersion:y},N.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(t,a,E,y)),k}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},y=U=>`${U.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,E=this.m.get(y(t.identifier));if(E)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),E.waitUntilTaskIsFinished();const k=U=>{const F=this.Z(U,a);return this.m.set(y(F.extension.identifier),F),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this.t.fire({identifier:U.identifier,profileLocation:a.profileLocation,applicationScoped:U.isApplicationScoped}),F},S=(U,F)=>{F?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,a.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,F.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,u.$mp)(U),error:F}),this.u.fire({identifier:U.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:U.isApplicationScoped})},p=[],O=[];try{p.push(k(t));const U=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,U);for(const M of F)this.m.has(y(M.identifier))?this.F.info("Extensions is already requested to uninstall",M.identifier.id):p.push(k(M))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(p.map(F=>F.extension),U,t),await this.L(p.map(async F=>{try{if(await F.run(),await this.L(this.y.map(M=>M.postUninstall(F.extension,a,N.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}S(F.extension)}catch(M){const x=M instanceof w.$Ro?M:new w.$Ro((0,j.$0)(M),w.ExtensionManagementErrorCode.Internal);throw S(F.extension,x),x}finally{O.push(F)}}))}catch(U){const F=U instanceof w.$Ro?U:new w.$Ro((0,j.$0)(U),w.ExtensionManagementErrorCode.Internal);for(const M of p){try{M.cancel()}catch{}O.includes(M)||S(M.extension,F)}throw F}finally{for(const U of p)this.m.delete(y(U.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}Q(t,r,a){for(const y of t){const E=this.U(y,r);if(E.length){const k=E.filter(S=>!t.some(p=>(0,u.$fp)(p.identifier,S.identifier)));if(k.length)throw new Error(this.R(y,k,a))}}}R(t,r,a){return a===t?r.length===1?v.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?v.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const y=t.manifest.extensionPack?t.manifest.extensionPack:[];if(y.length){const E=r.filter(S=>!S.isBuiltin&&y.some(p=>(0,u.$fp)({id:p},S.identifier))),k=[];for(const S of E)k.push(...this.S(S,r,a));return[...E,...k]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(y=>(0,u.$fp)({id:y},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$8p=c,e.$8p=c=ve([Q(0,w.$Qo),Q(1,h.$Ml),Q(2,g.$ll),Q(3,b.$Nj),Q(4,m.$7j),Q(5,l.$nl)],c);function $(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof w.$Ro)return s;if(s instanceof w.$So){const r=new w.$Ro(s.message,w.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new w.$Ro(s.message,w.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:y,error:E,durationSinceUpdate:k}){let S,p;(0,d.$3f)(a)&&(a===!0?a="Verified":(a===!1||(S=w.ExtensionManagementErrorCode.Signature,p=a),a="Unverified")),E&&(E instanceof w.$Ro||E instanceof w.$So?(S=E.code,E.code===w.ExtensionManagementErrorCode.Signature&&(p=E.message)):S=w.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!E,duration:y,errorcode:S,errorcodeDetail:p,durationSinceUpdate:k})}class n{constructor(){this.d=new A.$gh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$7g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$7g)(t=>new Promise((r,a)=>{const y=t.onCancellationRequested(()=>{y.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$$p=n}),define(le[52],he([0,1,6,14,2,3,35,8,29,33,12,4,9,18,28,13,7,22]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class l extends Error{constructor(n,s){super(n),this.code=s}}e.$_p=l,e.$aq=(0,v.$hi)("IExtensionsProfileScannerService");let c=class extends N.$Uc{constructor(n,s,t,r,a,y){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=y,this.b=this.B(new j.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new j.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,y=>{const E=[];if(t)E.push(...y);else for(const k of y)n.some(([S])=>(0,d.$fp)(S.identifier,k.identifier)&&S.manifest.version!==k.version)?r.push(k):E.push(k);for(const[k,S]of n){const p=E.findIndex(U=>(0,d.$fp)(U.identifier,k.identifier)&&U.version===k.manifest.version),O={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:S};p===-1?(a.push(O),E.push(O)):E.splice(p,1,O)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),E}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(y){throw a.length&&this.c.fire({extensions:a,error:y,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:y,profileLocation:s}),y}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const y of r){const E=n.find(([k])=>(0,d.$fp)(k.identifier,y.identifier)&&k.manifest.version===y.version);E&&(y.metadata={...y.metadata,...E[1]},t.push(y)),a.push(y)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const y of r)(0,d.$fp)(y.identifier,n.identifier)?t.push(y):a.push(y);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const y=await this.m.readFile(n);a=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,C.$5k)(y)!==1)throw y;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new l((0,m.$0)(y),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let y=!1;for(const E of a){$(E)||this.w(n);let k;if((0,b.$Uf)(E.relativeLocation)&&E.relativeLocation)k=this.z(E.relativeLocation);else if((0,b.$Uf)(E.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${E.location}`);continue}else{k=R.URI.revive(E.location);const S=this.y(k);S&&(y=!0,E.relativeLocation=S)}(0,b.$2f)(E.metadata?.hasPreReleaseVersion)&&E.metadata?.preRelease&&(y=!0,E.metadata.hasPreReleaseVersion=!0),r.push({identifier:E.identifier,location:k,version:E.version,metadata:E.metadata})}y&&await this.m.writeFile(n,A.$ue.fromString(JSON.stringify(a)))}if(s){r=s(r);const y=r.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.y(E.location),metadata:E.metadata}));await this.m.writeFile(n,A.$ue.fromString(JSON.stringify(y)))}return r})}w(n){const s=new l(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$5k)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(y=>$(y))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ue.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$5k)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$5k)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$5k)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new I.$oh,this.h.set(n,s)),s}};e.$bq=c,e.$bq=c=ve([Q(1,C.$Nk),Q(2,u.$nl),Q(3,f.$ll),Q(4,h.$Ml),Q(5,w.$Nj)],c);function $(o){return(0,b.$Wf)(o)&&(0,P.$Po)(o.identifier)&&(i(o.location)||(0,b.$Uf)(o.location)&&o.location)&&((0,b.$2f)(o.relativeLocation)||(0,b.$Uf)(o.relativeLocation))&&o.version&&(0,b.$Uf)(o.version)}function i(o){return o?(0,b.$Uf)(o.path)&&(0,b.$Uf)(o.scheme):!1}}),define(le[81],he([0,1,17,6,30,14,7,34,138,2,23,15,5,20,55,88,13,8,157,16,33,47,71,12,4,9,24,3,66,52,18,28,186]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i,o,n,s,t,r,a,y,E,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.$fq=e.$eq=e.Translations=void 0,e.$hq=x;var p;(function(Z){function W(K,V){if(K===V)return!0;const B=Object.keys(K),ie=new Set;for(const oe of Object.keys(V))ie.add(oe);if(B.length!==ie.size)return!1;for(const oe of B){if(K[oe]!==V[oe])return!1;ie.delete(oe)}return ie.size===0}Z.equals=W})(p||(e.Translations=p={})),e.$eq=(0,n.$hi)("IExtensionsScannerService");let O=class extends d.$Uc{constructor(W,K,V,B,ie,oe,te,ce,H,q,L,T){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=K,this.r=V,this.s=B,this.t=ie,this.u=oe,this.w=te,this.y=ce,this.z=H,this.C=q,this.D=L,this.F=T,this.g=this.B(new r.$7d),this.onDidChangeCache=this.g.event,this.h=(0,u.$Ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$qp)(this.w,this.y)),this.G}async scanAllExtensions(W,K,V){const[B,ie]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(K)]),oe=V?await this.scanExtensionsUnderDevelopment(W,[...B,...ie]):[];return this.L(B,ie,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const K=[];K.push(this.M(!!W.useCache,W.language)),K.push(this.N(W.language,!!W.checkControlFile));const[V,B]=await Promise.all(K);return this.J([...V,...B],0,W,!1)}async scanUserExtensions(W){const K=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const V=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(K,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V,W.productVersion??this.R()),ie=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let oe;try{oe=await ie.scanExtensions(B)}catch(te){if(te instanceof y.$_p&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await ie.scanExtensions(B);else throw te}return oe=await this.J(oe,1,W,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(W,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===C.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(te=>(te.type=K.find(ce=>(0,c.$fp)(ce.identifier,te.identifier))?.type??te.type,this.n.validate(te,ie)))}))).flat();return this.J(V,"development",W,!0)}return[]}async scanExistingExtension(W,K,V){const B=await this.P(W,!1,K,!0,V.language,!0,void 0,V.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!V.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(W,K,V){const B=await this.P(W,!1,K,!0,V.language,!0,void 0,V.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,K,V,!0)}async scanMetadata(W){const K=(0,u.$Ug)(W,"package.json"),V=(await this.w.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,K){const V=(0,u.$Ug)(W,"package.json"),B=(await this.w.readFile(V)).value.toString(),ie=JSON.parse(B);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,ie.__metadata={...ie.__metadata,...K},await this.w.writeFile((0,u.$Ug)(W,"package.json"),j.$ue.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof y.$_p&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ue.fromString(JSON.stringify([])))}catch(K){(0,o.$5k)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,K,V,B){return V.includeAllVersions||(W=this.L(K===0?W:void 0,K===1?W:void 0,K==="development"?W:void 0,await this.getTargetPlatform(),B)),V.includeInvalid||(W=W.filter(ie=>ie.isValid)),W.sort((ie,oe)=>{const te=v.$oc(ie.location.fsPath),ce=v.$oc(oe.location.fsPath);return te<ce?-1:te>ce?1:0})}L(W,K,V,B,ie){const oe=(ce,H,q)=>{if(ce.isValid&&!H.isValid)return!1;if(ce.isValid===H.isValid){if(ie&&f.gt(ce.manifest.version,H.manifest.version))return this.y.debug(`Skipping extension ${H.location.path} with lower version ${H.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(f.eq(ce.manifest.version,H.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${H.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===B)return this.y.debug(`Skipping extension ${H.location.path} from different target platform ${H.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ce.location.path} with ${H.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${H.location.path}.`),!0},te=new $.$Em;return W?.forEach(ce=>{const H=te.get(ce.identifier.id);(!H||oe(H,ce,!1))&&te.set(ce.identifier.id,ce)}),K?.forEach(ce=>{const H=te.get(ce.identifier.id);if(!H&&W&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!H||oe(H,ce,!1))&&te.set(ce.identifier.id,ce)}),V?.forEach(ce=>{const H=te.get(ce.identifier.id);(!H||oe(H,ce,!0))&&te.set(ce.identifier.id,ce),te.set(ce.identifier.id,ce)}),[...te.values()]}async M(W,K){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),ie=await(W&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(W,K){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const B=K?await this.O():{},ie=[],oe=h.URI.file(v.$ic(v.$kc(C.$Bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of V){const H=B[ce.name]||"marketplace";switch(H){case"disabled":break;case"marketplace":ie.push((0,u.$Ug)(oe,ce.name));break;default:ie.push(h.URI.file(H));break}}const te=await Promise.all(ie.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,I.$Hb)(te)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,K,V,B,ie,oe,te,ce){const H=await this.f(ie??w.$w),q=await this.Q(W),L=K&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,T=L?await this.Q(L):void 0;return new U(W,q,L,T,K,te,V,B,oe,ce.version,ce.date,this.C.commit,!this.z.isBuilt,ie,H)}async Q(W){try{const K=await this.w.stat(W);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$fq=O,e.$fq=O=ve([Q(4,E.$nl),Q(5,y.$aq),Q(6,o.$Nk),Q(7,s.$Nj),Q(8,l.$oi),Q(9,t.$7j),Q(10,k.$ll),Q(11,n.$gi)],O);class U{constructor(W,K,V,B,ie,oe,te,ce,H,q,L,T,z,Y,G){this.location=W,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=oe,this.type=te,this.excludeObsolete=ce,this.validate=H,this.productVersion=q,this.productDate=L,this.productCommit=T,this.devMode=z,this.language=Y,this.translations=G}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,K){return(0,u.$Ng)(W.location,K.location)&&W.mtime===K.mtime&&(0,u.$Ng)(W.applicationExtensionslocation,K.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&W.profile===K.profile&&N.$Rn(W.profileScanOptions,K.profileScanOptions)&&W.type===K.type&&W.excludeObsolete===K.excludeObsolete&&W.validate===K.validate&&W.productVersion===K.productVersion&&W.productDate===K.productDate&&W.productCommit===K.productCommit&&W.devMode===K.devMode&&W.language===K.language&&p.equals(W.translations,K.translations)}}e.$gq=U;let F=class extends d.$Uc{constructor(W,K,V,B,ie){super(),this.f=W,this.g=K,this.h=V,this.j=B,this.m=ie}async scanExtensions(W){const K=W.profile?await this.r(W):await this.n(W);let V={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(B)}catch{}return(0,m.$8f)(V)?K:K.filter(B=>!V[c.$gp.create(B).toString()])}async n(W){const K=await this.j.resolve(W.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,u.$Rg)(B.resource).indexOf(".")===0)return null;const ie=new U(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ie)}));return(0,I.$Hb)(V).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(W){let K=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){K=K.filter(B=>!B.metadata?.isApplicationScoped);const V=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);K.push(...V)}return K}async s(W,K,V){const B=await this.g.scanProfileExtensions(W,V.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async oe=>{if(K(oe)){const te=new U(oe.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,oe.metadata)}return null}));return(0,I.$Hb)(ie)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,u.$Ug)(W.location,"package.json"))){const K=await this.scanExtension(W);return K?[K]:[]}else return await this.scanExtensions(W)}catch(K){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,D.$0)(K)),[]}}async scanExtension(W,K){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=$.$ym),K=K??V.__metadata,delete V.__metadata;const B=(0,c.$kp)(V.publisher,V.name),ie=K?.id?{id:B,uuid:K.id}:{id:B},oe=K?.isSystem?0:W.type,te=oe===0||!!K?.isBuiltin;V=await this.t(W.location,V,U.createNlsConfiguration(W));const ce={type:oe,identifier:ie,manifest:V,location:W.location,isBuiltin:te,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return W.validate?this.validate(ce,W):ce}}catch(V){W.type!==0&&this.m.error(V)}return null}validate(W,K){let V=!0;const B=(0,i.$vp)(K.productVersion,K.productDate,K.location,W.manifest,W.isBuiltin);for(const[ie,oe]of B)ie===b.default.Error&&(V=!1,this.m.error(this.z(K.location,oe)));return W.isValid=V,W.validations=B,W}async scanExtensionManifest(W){const K=(0,u.$Ug)(W,"package.json");let V;try{V=(await this.j.readFile(K)).value.toString()}catch(ie){return(0,o.$5k)(ie)!==1&&this.m.error(this.z(W,(0,g.localize)(0,null,K.path,ie.message))),null}let B;try{B=JSON.parse(V)}catch{const oe=[];(0,R.$un)(V,oe);for(const te of oe)this.m.error(this.z(W,(0,g.localize)(1,null,K.path,te.offset,te.length,(0,P.$cq)(te.error))));return null}return(0,R.$Dn)(B)!=="object"?(this.m.error(this.z(W,(0,g.localize)(2,null,K.path))),null):B}async t(W,K,V){const B=await this.u(W,K,V);if(B)try{const ie=[],oe=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(ce=>{this.m.error(this.z(W,(0,g.localize)(3,null,B.default?.path,(0,P.$cq)(ce.error))))}),K;if((0,R.$Dn)(B)!=="object")return this.m.error(this.z(W,(0,g.localize)(4,null,B.default?.path))),K;const te=B.values||Object.create(null);return(0,S.$dq)(this.m,K,te,oe)}catch{}return K}async u(W,K,V){const B=(0,u.$Ug)(W,"package.nls.json"),ie=(H,q)=>{q.forEach(L=>{this.m.error(this.z(W,(0,g.localize)(5,null,H?.path,(0,P.$cq)(L.error))))})},oe=H=>{this.m.error(this.z(W,(0,g.localize)(6,null,H?.path)))},te=`${K.publisher}.${K.name}`,ce=V.translations[te];if(ce)try{const H=h.URI.file(ce),q=(await this.j.readFile(H)).value.toString(),L=[],T=(0,R.$un)(q,L);return L.length>0?(ie(H,L),{values:void 0,default:B}):(0,R.$Dn)(T)!=="object"?(oe(H),{values:void 0,default:B}):{values:T.contents?T.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let q;try{q=await this.y(W,V)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const L=(await this.j.readFile(q.localized)).value.toString(),T=[],z=(0,R.$un)(L,T);return T.length>0?(ie(q.localized,T),{values:void 0,default:q.original}):(0,R.$Dn)(z)!=="object"?(oe(q.localized),{values:void 0,default:q.original}):{values:z,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(W,K){if(W)try{const V=(await this.j.readFile(W)).value.toString();return(0,R.$un)(V,K)}catch{}}y(W,K){return new Promise((V,B)=>{const ie=oe=>{const te=(0,u.$Ug)(W,`package.nls.${oe}.json`);this.j.exists(te).then(ce=>{ce&&V({localized:te,original:(0,u.$Ug)(W,"package.nls.json")});const H=oe.lastIndexOf("-");H===-1?V({localized:(0,u.$Ug)(W,"package.nls.json"),original:null}):(oe=oe.substring(0,H),ie(oe))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,u.$Ug)(W,"package.nls.json"),original:null});ie(K.language)})}z(W,K){return`[${W.path}]: ${K}`}};F=ve([Q(1,y.$aq),Q(2,k.$ll),Q(3,o.$Nk),Q(4,s.$Nj)],F);let M=class extends F{constructor(W,K,V,B,ie,oe,te){super(K,B,ie,oe,te),this.G=W,this.H=V,this.D=this.B(new A.$fh(3e3)),this.F=this.B(new r.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(W){const K=this.M(W),V=await this.I(K);if(this.C=W,V&&V.input&&U.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ie=>(ie.location=h.URI.revive(ie.location),ie));const B=await super.scanExtensions(W);return await this.J(K,{input:W,result:B}),B}async I(W){try{const K=await this.j.readFile(W),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,a.$Qh)(V.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",W.path,(0,D.$0)(K))}return null}async J(W,K){try{await this.j.writeFile(W,j.$ue.fromString(JSON.stringify(K)))}catch(V){this.m.debug("Error while writing the extension cache file:",W.path,(0,D.$0)(V))}}async L(){if(!this.C)return;const W=this.M(this.C),K=await this.I(W);if(!K)return;const V=K.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$Rn(B,V))try{this.m.info("Invalidating Cache",V,B),await this.j.del(W),this.F.fire()}catch(ie){this.m.error(ie)}}M(W){const K=this.N(W);return this.h.extUri.joinPath(K.cacheHome,W.type===0?$.$xm:$.$wm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(W.location,K.extensionsResource))??this.G:this.H.defaultProfile}};M=ve([Q(2,E.$nl),Q(3,y.$aq),Q(4,k.$ll),Q(5,o.$Nk),Q(6,s.$Nj)],M);function x(Z,W){const K=(0,c.$ip)(Z.manifest.publisher,Z.manifest.name);return{id:K,identifier:new $.$Cm(K),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:W,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}class J extends O{constructor(W,K,V,B,ie,oe,te,ce,H,q,L,T){super(W,K,(0,u.$Ug)(V,".vscode-oss-dev","extensions","control.json"),B,ie,oe,te,ce,H,q,L,T),this.S=(async()=>{if(w.$z)try{const z=await this.w.readFile(h.URI.file(w.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$iq=J}),define(le[249],he([0,1,67,6,38,3,2,23,15,31,9,18]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let w=class extends D.$Uc{constructor(f,b){super(),this.b=f,this.f=b,this.a=new A.$nh(5)}async postUninstall(f){const b=this.g(f,"uninstall");b&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,f),this.f.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.f.error(m)}}));try{await d.Promises.rm(this.m(f))}catch(m){this.f.error("Error while removing extension storage path",f.identifier.id),this.f.error(m)}}g(f,b){const m=`vscode:${b}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[m]=="string"){const h=f.manifest.scripts[m].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${m} should be a node script`),null):{script:(0,P.$kc)(f.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(f,b,m,h,g){return new Promise((l,c)=>{const $=this.j(f,b,m,g);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):l(void 0)};$.on("error",n=>{o((0,N.$5i)(n)||"Unknown")}),$.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),h&&(i=setTimeout(()=>{i=null,$.kill(),c("timed out")},5e3))})}j(f,b,m,h){const g={silent:!0,execArgv:void 0},l=(0,I.fork)(f,[`--type=extension-post-${b}`,...m],g);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const c=j.Event.fromNodeEventEmitter(l.stdout,"data"),$=j.Event.fromNodeEventEmitter(l.stderr,"data");c(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${b}`,n)),$(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${b}`,n));const i=j.Event.any(j.Event.map(c,n=>({data:`%c${n}`,format:[""]})),j.Event.map($,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}m(f){return(0,P.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.$kq=w,e.$kq=w=ve([Q(0,v.$nl),Q(1,C.$Nj)],w)}),define(le[113],he([0,1,6,14,26,38,7,3,54,2,35,23,15,20,55,13,8,32,31,70,158,95,16,248,29,33,52,81,229,249,187,219,230,71,12,4,9,24,22,28,18]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i,o,n,s,t,r,a,y,E,k,S,p,O,U,F,M,x,J,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.$oq=void 0,e.$oq=(0,U.$ii)(n.$To);const W=".vsctmp";let K=class extends o.$8p{constructor(H,q,L,T,z,Y,G,ee,_,X,ne,re){super(H,q,ne,L,X,re),this.eb=z,this.fb=Y,this.gb=G,this.hb=_,this.db=new Map,this.qb=new C.$Cc;const ue=this.B(ee.createInstance(y.$kq));this.ab=this.B(ee.createInstance(V,$e=>ue.postUninstall($e))),this.bb=this.B(new k.$mq(re,_,ne,this,this.F)),this.cb=this.B(ee.createInstance(a.$jq));const de=this.B(new S.$nq(this,this.eb,re,Y,ne,_,L));this.B(de.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$qp)(this.hb,this.F)),this.ib}async zip(H){this.F.trace("ExtensionManagementService#zip",H.identifier.id);const q=await this.ob(H),L=await(0,l.zip)((0,u.$Ug)(this.cb.extensionsDownloadDir,(0,h.$Dg)()).fsPath,q);return m.URI.file(L)}async unzip(H){return this.F.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:q,cleanup:L}=await this.kb(H),T=w.$lc(q.fsPath);try{return await(0,E.$lq)(T)}finally{await L()}}getInstalled(H,q=this.H.defaultProfile.extensionsResource,L={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(H??null,q,L)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.ab.scanUserExtensionAtLocation(H)}async install(H,q={}){this.F.trace("ExtensionManagementService#install",H.toString());const{location:L,cleanup:T}=await this.kb(H);try{const z=await(0,E.$lq)(w.$lc(L.fsPath)),Y=(0,s.$kp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,p.$xp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,Y,this.G.version));const ee=(await this.I([{manifest:z,extension:L,options:q}])).find(({identifier:_})=>(0,s.$fp)(_,{id:Y}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,o.$0p)(new Error(`Unknown error while installing extension ${Y}`))}finally{await T()}}async installFromLocation(H,q){this.F.trace("ExtensionManagementService#installFromLocation",H.toString());const L=await this.ab.scanUserExtensionAtLocation(H);if(!L||!L.manifest.name||!L.manifest.version)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.tb([[L,{source:"resource"}]],q),this.F.info("Successfully installed extension",L.identifier.id,q.toString()),L}async installExtensionsFromProfile(H,q,L){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",H,q.toString(),L.toString());const T=(await this.getInstalled(1,q)).filter(z=>H.some(Y=>(0,s.$fp)(Y,z.identifier)));if(T.length){const z=await Promise.all(T.map(Y=>this.ab.scanMetadata(Y,q)));await this.tb(T.map((Y,G)=>[Y,z[G]]),L),this.F.info("Successfully installed extensions",T.map(Y=>Y.identifier.id),L.toString())}return T}async updateMetadata(H,q,L=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",H.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),H=await this.ab.updateMetadata(H,q,L),this.bb.invalidate(L),this.w.fire(H),H}async reinstallFromGallery(H){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const q=await this.getTargetPlatform(),[L]=await this.z.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:q,compatible:!0},N.CancellationToken.None);if(!L)throw new Error(c.localize(2,null));await this.ab.setUninstalled(H);try{await this.ab.removeUninstalledExtension(H)}catch(T){throw new Error(c.localize(3,null,(0,j.$5i)(T)))}return this.installFromGallery(L)}$(H,q,L,T){return this.ab.copyExtension(H,q,L,T)}copyExtensions(H,q){return this.ab.copyExtensions(H,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...H){return this.ab.setUninstalled(...H)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(H){this.F.error(H)}}async download(H,q,L){const{location:T}=await this.cb.download(H,q,!L);return T}async kb(H){if(H.scheme===v.Schemas.file)return{location:H,async cleanup(){}};this.F.trace("Downloading extension from",H.toString());const q=(0,u.$Ug)(this.cb.extensionsDownloadDir,(0,h.$Dg)());return await this.gb.download(H,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.hb.del(q)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(H,q,L){if(m.URI.isUri(q))return new oe(H,q,L,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$gp.create(q).toString();let z=this.db.get(T);return z||(this.db.set(T,z=new ie(H,q,L,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),z}Z(H,q){return new te(H,q.profileLocation,this.fb)}async ob(H){const q=async T=>{let z=await g.Promises.readdir(T);z=z.map(ee=>w.$kc(T,ee));const Y=await Promise.all(z.map(ee=>g.Promises.stat(ee)));let G=Promise.resolve([]);return Y.forEach((ee,_)=>{const X=z[_];ee.isFile()&&(G=G.then(ne=>[...ne,X])),ee.isDirectory()&&(G=G.then(ne=>q(X).then(re=>[...ne,...re])))}),G};return(await q(H.location.fsPath)).map(T=>({path:`extension/${w.$mc(H.location.fsPath,T)}`,localPath:T}))}async pb({added:H,removed:q}){if(q){const L=H&&this.D.extUri.isEqual(q.profileLocation,H.profileLocation)?q.extensions.filter(T=>H.extensions.every(z=>!(0,s.$fp)(z,T))):q.extensions;for(const T of L)this.F.info("Extensions removed from another source",T.id,q.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:q.profileLocation})}if(H){const T=(await this.getInstalled(1,H.profileLocation)).filter(z=>H.extensions.some(Y=>(0,s.$fp)(Y,z.identifier)));this.s.fire(T.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,H.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:H.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(q=>this.qb.add(q)));const H=await this.hb.resolve(this.eb.userExtensionsLocation);for(const q of H.children??[])q.isDirectory&&this.qb.add(q.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(q=>this.sb(q)))}async sb(H){if(!H.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const L of H.rawAdded){if(this.qb.has(L)||!this.D.extUri.isEqual(this.D.extUri.dirname(L),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(L,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(L).startsWith(".")||!(await this.hb.stat(L)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(L);T&&T.installedTimestamp===void 0&&(this.qb.add(L),q.push(T))}q.length&&(await this.tb(q.map(L=>[L,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(L=>L.identifier.id)))}async tb(H,q){const L=H.map(T=>T[0]);await this.ub(L),await this.fb.addExtensionsToProfile(H,q),this.s.fire(L.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:q})))}async ub(H){const q=await this.ab.getUninstalledExtensions();for(const L of H){const T=s.$gp.create(L);q[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$pq=K,e.$pq=K=ve([Q(0,n.$Qo),Q(1,x.$Ml),Q(2,F.$Nj),Q(3,i.$pi),Q(4,r.$eq),Q(5,t.$aq),Q(6,$.$vo),Q(7,U.$gi),Q(8,O.$Nk),Q(9,M.$7j),Q(10,J.$ll),Q(11,Z.$nl)],K);let V=class extends d.$Uc{constructor(H,q,L,T,z,Y){super(),this.j=H,this.m=q,this.n=L,this.s=T,this.t=z,this.u=Y,this.h=this.B(new R.$7d),this.onExtract=this.h.event,this.c=(0,u.$Ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$oh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(H,q,L){const T={includeInvalid:!0,profileLocation:q,productVersion:L};let z=[];return H===null||H===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},T,!1)):H===1&&z.push(...await this.n.scanUserExtensions(T)),z=H!==null?z.filter(Y=>Y.type===H):z,Promise.all(z.map(Y=>this.F(Y)))}async scanAllUserExtensions(H){const q=await this.n.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return Promise.all(q.map(L=>this.F(L)))}async scanUserExtensionAtLocation(H){try{const q=await this.n.scanExistingExtension(H,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(H,q,L,T,z){const Y=H.toString(),G=m.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$Dg)()}`)),ee=m.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,Y));let _=await this.m.exists(ee);if(_&&T){try{await this.y(H.id,ee,"removeExisting")}catch{throw new n.$Ro(c.localize(4,null,ee.fsPath,H.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,L);else try{try{this.u.trace(`Started extracting the extension from ${q} to ${ee.fsPath}`),await(0,l.$6p)(q,G.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${ee}:`,H.id)}catch(X){let ne=n.ExtensionManagementErrorCode.Extract;throw X instanceof l.$4p&&(X.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:X.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Ro(X.message,ne)}await this.n.updateMetadata(G,L);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${ee.fsPath}`),await this.C(G.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(X){if(X.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(X)}. Deleted from extracted location`,G),X}this.h.fire(ee)}catch(X){try{await this.m.del(G,{recursive:!0})}catch{}throw X}return this.D(ee,1)}async scanMetadata(H,q){return q?(await this.w(H,q))?.metadata:this.n.scanMetadata(H.location)}async w(H,q){return(await this.s.scanProfileExtensions(q)).find(T=>(0,s.$fp)(T.identifier,H.identifier))}async updateMetadata(H,q,L){return L?await this.s.updateMetadata([[H,q]],L):await this.n.updateMetadata(H.location,q),this.D(H.location,H.type,L)}getUninstalledExtensions(){return this.z()}async setUninstalled(...H){const q=H.map(L=>s.$gp.create(L));await this.z(L=>q.forEach(T=>{L[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(H){await this.z(q=>delete q[H.toString()])}async removeExtension(H,q){if(this.t.extUri.isEqualOrParent(H.location,this.n.userExtensionsLocation))return this.y(H.identifier.id,H.location,q)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.z(q=>delete q[s.$gp.create(H).toString()])}async copyExtension(H,q,L,T){const z=await this.w(H,q),Y=await this.w(H,L);if(T={...z?.metadata,...T},Y)if(this.t.extUri.isEqual(Y.location,H.location))await this.s.updateMetadata([[H,{...Y.metadata,...T}]],L);else{const G=await this.D(Y.location,H.type,L);await this.s.removeExtensionFromProfile(G,L),await this.s.addExtensionsToProfile([[H,{...Y.metadata,...T}]],L)}else await this.s.addExtensionsToProfile([[H,T]],L);return this.D(H.location,H.type,L)}async copyExtensions(H,q,L){const T=await this.scanExtensions(1,H,L),z=await Promise.all(T.filter(Y=>!Y.isApplicationScoped).map(async Y=>[Y,await this.scanMetadata(Y,H)]));await this.s.addExtensionsToProfile(z,q)}async y(H,q,L){this.u.trace(`Deleting ${L} extension from disk`,H,q.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,P.$8i)((0,h.$Dg)()).toString(16)}${W}`);await this.C(q.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${L} extension from disk`,H,q.fsPath)}async z(H){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,O.$5k)(T)!==1)throw T}let L={};if(q)try{L=JSON.parse(q)}catch{}return H&&(H(L),Object.keys(L).length?await this.m.writeFile(this.c,A.$ue.fromString(JSON.stringify(L))):await this.m.del(this.c)),L})}async C(H,q){try{await g.Promises.rename(H,q,2*60*1e3)}catch(L){throw new n.$Ro(L.message||c.localize(5,null,H,q),L.code||n.ExtensionManagementErrorCode.Rename)}}async D(H,q,L){if(L){const z=(await this.n.scanUserExtensions({profileLocation:L})).find(Y=>this.t.extUri.isEqual(Y.location,H));if(z)return this.F(z)}else{const T=await this.n.scanExistingExtension(H,q,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(c.localize(6,null,H.path))}async F(H){const q=await this.m.resolve(H.location);let L,T;return q.children&&(L=q.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,T=q.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:L,changelogUrl:T,publisherDisplayName:H.metadata?.publisherDisplayName||null,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!H.metadata?.hasPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned,isWorkspaceScoped:!1,source:H.metadata?.source??(H.identifier.uuid?"gallery":"vsix")}}async G(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(H));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const z of q)H[s.$gp.create(z).toString()]||L.add(z.identifier.id.toLowerCase());try{const z=(0,s.$lp)(q,Y=>Y.identifier);await I.Promises.settled(z.map(async Y=>{const G=Y.sort((ee,_)=>f.rcompare(ee.manifest.version,_.manifest.version))[0];L.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(z){this.u.error(z)}const T=q.filter(z=>z.metadata&&H[s.$gp.create(z).toString()]);await Promise.allSettled(T.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let H;try{H=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,O.$5k)(q)!==1&&this.u.error(q);return}if(H?.children)try{await Promise.allSettled(H.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(L){(0,O.$5k)(L)!==1&&this.u.error(L)}}}))}catch{}}};e.$qq=V,e.$qq=V=ve([Q(1,O.$Nk),Q(2,r.$eq),Q(3,t.$aq),Q(4,J.$ll),Q(5,F.$Nj)],V);class B extends o.$$p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$2f)(this.options.operation)?this.l:this.options.operation}constructor(H,q,L,T,z,Y,G,ee,_){super(),this.identifier=H,this.source=q,this.options=L,this.m=T,this.n=z,this.o=Y,this.p=G,this.q=ee,this.s=_,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(H){const[q,L]=await this.x(H);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,L]],this.j,!q.isValid),q}async u({zipPath:H,key:q,metadata:L},T,z){let Y=await this.v(q);return Y?Y=await this.m.updateMetadata(Y,L):(this.s.trace("Extracting extension...",q.id),Y=await this.m.extractUserExtension(q,H,L,T,z),this.s.info("Extracting extension completed.",q.id)),Y}async v(H){return await this.w(H)?(this.s.trace("Removing the extension from uninstalled list:",H.id),await this.m.setInstalled(H),this.s.info("Removed the extension from uninstalled list:",H.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$gp.create(T).equals(H))):void 0}async w(H){return!!(await this.m.getUninstalledExtensions())[H.toString()]}}class ie extends B{constructor(H,q,L,T,z,Y,G,ee,_,X){super(q.identifier,q,L,z,Y,G,ee,_,X),this.y=q,this.z=T}async x(H){let q;try{q=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(G){throw new n.$Ro(G,n.ExtensionManagementErrorCode.Scanning)}const L=q.find(G=>(0,s.$fp)(G.identifier,this.y.identifier));L&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||L?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:L?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??L?.pinned,preRelease:(0,b.$1f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||L?.preRelease,source:"gallery"};if(L?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(L,T),T]}catch(G){throw new n.$Ro((0,D.$0)(G),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:Y}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=Y,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:s.$gp.create(this.y),metadata:T},!1,H),T]}catch(G){try{await this.z.delete(z)}catch(ee){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,D.$0)(ee))}throw G}}async B(H){try{await(0,E.$lq)(H)}catch(q){throw new n.$Ro((0,o.$9p)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$rq=ie;class oe extends B{constructor(H,q,L,T,z,Y,G,ee,_,X){super({id:(0,s.$kp)(H.publisher,H.name)},q,L,z,Y,G,ee,_,X),this.y=H,this.z=q,this.A=T}async h(H){const q=await super.h(H);return this.D(q,H),q}async x(H){const q=new s.$gp(this.identifier,this.y.version),T=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,s.$fp)(this.identifier,G.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned,source:"vsix"};if(T)if(this.l=3,q.equals(new s.$gp(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&f.gt(T.manifest.version,this.y.version)&&await this.m.setUninstalled(T);else{const G=await this.v(q);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$lc(this.z.fsPath),key:q,metadata:z},!0,H),z]}async D(H,q){try{let[L]=await this.A.getExtensions([{id:H.identifier.id,version:H.manifest.version}],q);if(L||([L]=await this.A.getExtensions([{id:H.identifier.id}],q)),L){const T={id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,hasPreReleaseVersion:H.hasPreReleaseVersion||L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(H,T,this.options.profileLocation)}}catch{}}}class te extends o.$$p{constructor(H,q,L){super(),this.extension=H,this.j=q,this.k=L}async h(H){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[250],he([0,1,9,18,28,22,52,12,16,8]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=void 0;let C=class extends D.$bq{constructor(w,u,f,b,m,h){super(d.URI.file(w.extensionsPath),u,f,b,m,h)}};e.$ZP=C,e.$ZP=C=ve([Q(0,P.$pi),Q(1,R.$Nk),Q(2,A.$nl),Q(3,N.$ll),Q(4,j.$Ml),Q(5,I.$Nj)],C)}),define(le[251],he([0,1,8,16,52,81,12,4,9,24,28,18]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=void 0;let w=class extends j.$iq{constructor(f,b,m,h,g,l,c,$){super(I.URI.file(g.builtinExtensionsPath),I.URI.file(g.extensionsPath),g.userHome,f.defaultProfile,f,b,m,h,g,l,c,$)}};e.$cbc=w,e.$cbc=w=ve([Q(0,v.$nl),Q(1,N.$aq),Q(2,D.$Nk),Q(3,P.$Nj),Q(4,A.$pi),Q(5,d.$7j),Q(6,C.$ll),Q(7,R.$gi)],w)}),define(le[19],he([0,1,6,3,2,99,13,69,4,18]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=u,e.$Op=b,e.$Qp=h,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,P.$hi)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var v;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var w;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function u(g){const l=g.get(e.$Kp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class f extends N.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:f.a}){super(),this.m=l,this.b=this.B(new A.$0d),this.c=this.B(new A.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new I.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,c,$){return A.Event.filter(this.b.event,i=>i.scope===l&&(c===void 0||i.key===c),$)}n(){this.j.value=(0,I.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,c){const{key:$,external:i}=c;if($===e.$Kp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:$,target:this.J(l)[$],external:i})}w(l){this.f.fire({reason:l})}get(l,c,$){return this.P(c)?.get(l,$)}getBoolean(l,c,$){return this.P(c)?.getBoolean(l,$)}getNumber(l,c,$){return this.P(c)?.getNumber(l,$)}getObject(l,c,$){return this.P(c)?.getObject(l,$)}storeAll(l,c){this.y(()=>{for(const $ of l)this.store($.key,$.value,$.scope,$.target,c)})}store(l,c,$,i,o=!1){if((0,D.$4f)(c)){this.remove(l,$,o);return}this.y(()=>{this.z(l,$,i),this.P($)?.set(l,c,o)})}remove(l,c,$=!1){this.y(()=>{this.z(l,c,void 0),this.P(c)?.delete(l,$)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,c){const $=[],i=this.J(l);for(const o of Object.keys(i))i[o]===c&&$.push(o);return $}z(l,c,$,i=!1){const o=this.J(c);typeof $=="number"?o[l]!==$&&(o[l]=$,this.P(c)?.set(e.$Kp,JSON.stringify(o),i)):typeof o[l]=="number"&&(delete o[l],this.P(c)?.set(e.$Kp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const c=this.P(l);return c?u(c):Object.create(null)}isNew(l){return this.getBoolean(e.$Jp,l)===!0}async flush(l=C.NONE){this.f.fire({reason:l});const c=this.P(-1),$=this.P(0),i=this.P(1);switch(l){case C.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return h(l,c,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,c){return this.w(C.NONE),(0,d.$ml)(l)?this.R(l,c):this.S(l,c)}M(l,c){return!(l.id===c.id||b(c)&&b(l))}N(l,c,$){this.y(()=>{const i=new Set;for(const[o,n]of l)i.add(o),c.get(o)!==n&&this.u($,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u($,{key:o,external:!0})})}}e.$Np=f;function b(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class m extends f{constructor(){super(),this.U=this.B(new R.$Hp(new R.$Ip,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Hp(new R.$Ip,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Hp(new R.$Ip,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Pp=m;async function h(g,l,c,$,i,o){const n=p=>{try{return JSON.parse(p)}catch{return p}},s=new Map,t=new Map;g.forEach((p,O)=>{s.set(O,p),t.set(O,n(p))});const r=new Map,a=new Map;l.forEach((p,O)=>{r.set(O,p),a.set(O,n(p))});const y=new Map,E=new Map;c.forEach((p,O)=>{y.set(O,p),E.set(O,n(p))}),console.group($!==i?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const k=[];if(s.forEach((p,O)=>{k.push({key:O,value:p})}),console.table(k),console.groupEnd(),console.log(t),$!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const p=[];r.forEach((O,U)=>{p.push({key:U,value:O})}),console.table(p),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const S=[];y.forEach((p,O)=>{S.push({key:O,value:p})}),console.table(S),console.groupEnd(),console.log(E)}}),define(le[114],he([0,1,3,2,13,29,33,19]),function(se,e,I,A,N,j,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UHb=e.$THb=void 0;let P=class extends A.$Uc{constructor(v,w){super(),this.a=new I.$7d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(v)),this.B(this.b.onDidChange(u=>this.a.fire({extensions:u,source:"storage"}))),this.B(w.onDidInstallExtensions(u=>u.forEach(({local:f,operation:b})=>{f&&b===4&&this.f(f.identifier)})))}async enableExtension(v,w){return this.f(v)?(this.a.fire({extensions:[v],source:w}),!0):!1}async disableExtension(v,w){return this.c(v)?(this.a.fire({extensions:[v],source:w}),!0):!1}getDisabledExtensions(){return this.h(j.$Uo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(v){const w=this.getDisabledExtensions();return w.every(u=>!(0,D.$fp)(u,v))?(w.push(v),this.g(w),!0):!1}f(v){const w=this.getDisabledExtensions();for(let u=0;u<w.length;u++){const f=w[u];if((0,D.$fp)(f,v))return w.splice(u,1),this.g(w),!0}return!1}g(v){this.j(j.$Uo,v)}h(v){return this.b.get(v,0)}j(v,w){this.b.set(v,w,0)}};e.$THb=P,e.$THb=P=ve([Q(0,R.$Lp),Q(1,j.$To)],P);class d extends A.$Uc{constructor(v){super(),this.c=v,this.a=Object.create(null),this.b=this.B(new I.$7d),this.onDidChange=this.b.event,this.B(v.onDidChangeValue(0,void 0,this.B(new A.$Tc))(w=>this.f(w)))}get(v,w){let u;return w===0?((0,N.$4f)(this.a[v])&&(this.a[v]=this.g(v,w)),u=this.a[v]):u=this.g(v,w),JSON.parse(u)}set(v,w,u){const f=JSON.stringify(w.map(({id:m,uuid:h})=>({id:m,uuid:h})));this.g(v,u)!==f&&(u===0&&(w.length?this.a[v]=f:delete this.a[v]),this.h(v,w.length?f:void 0,u))}f(v){if(!(0,N.$4f)(this.a[v.key])&&this.g(v.key,v.scope)!==this.a[v.key]){const u=this.get(v.key,v.scope);delete this.a[v.key];const f=this.get(v.key,v.scope),b=u.filter(h=>!f.some(g=>(0,D.$fp)(h,g))),m=f.filter(h=>!u.some(g=>(0,D.$fp)(g,h)));(b.length||m.length)&&this.b.fire([...b,...m])}}g(v,w){return this.c.get(v,w,"[]")}h(v,w,u){w?this.c.store(v,w,u,1):this.c.remove(v,u)}}e.$UHb=d}),define(le[252],he([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,231,19,22,63]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0,e.$Tp=oe;const i=j.$o?"web":(0,v.$Mo)(j.$u,D.$fc),o="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((z,Y)=>z|Y,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class k{constructor(z=E){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,Y=this.d.pageSize){return new k({...this.d,pageNumber:z,pageSize:Y})}withFilter(z,...Y){const G=[...this.d.criteria,...Y.length?Y.map(ee=>({filterType:z,value:ee})):[{filterType:z}]];return new k({...this.d,criteria:G})}withSortBy(z){return new k({...this.d,sortBy:z})}withSortOrder(z){return new k({...this.d,sortOrder:z})}withFlags(...z){return new k({...this.d,flags:z.reduce((Y,G)=>Y|G,0)})}withAssetTypes(...z){return new k({...this.d,assetTypes:z})}withSource(z){return new k({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:Y,pageSize:G,sortBy:ee,sortOrder:_,flags:X,assetTypes:ne}=this.d;return{filters:[{criteria:z,pageNumber:Y,pageSize:G,sortBy:ee,sortOrder:_}],assetTypes:ne,flags:X}}get searchText(){const z=this.d.criteria.filter(Y=>Y.filterType===t.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(T,z){const Y=(T||[]).filter(G=>G.statisticName===z)[0];return Y?Y.value:0}function p(T){const z="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(G=>G.assetType.indexOf(z)===0).reduce((G,ee)=>{const _=F(T,ee.assetType);return _&&G.push([ee.assetType.substring(z.length),_]),G},[])}function O(T){if(T.properties){const z=T.properties.filter(ee=>ee.key===r.Repository),Y=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=z.filter(ee=>Y.test(ee.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return F(T,r.Repository)}function U(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function F(T,z){return T.files.filter(G=>G.assetType===z)[0]?{uri:`${T.assetUri}/${z}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${z}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function M(T,z){const Y=T.properties?T.properties.filter(ee=>ee.key===z):[],G=Y.length>0&&Y[0].value;return G?G.split(",").map(ee=>(0,w.$jp)(ee)):[]}function x(T){const z=T.properties?T.properties.filter(Y=>Y.key===a.Engine):[];return z.length>0&&z[0].value||""}function J(T){const z=T.properties?T.properties.filter(Y=>Y.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function Z(T){const z=T.properties?T.properties.filter(G=>G.key===a.LocalizedLanguages):[],Y=z.length>0&&z[0].value||"";return Y?Y.split(","):[]}function W(T){return T.properties?.find(z=>z.key===a.SponsorLink)?.value}function K(T){return T.properties?.find(z=>z.key===a.SupportLink)?.value}function V(T){return T.indexOf("preview")!==-1}function B(T){return T.targetPlatform?(0,v.$Lo)(T.targetPlatform):"undefined"}function ie(T){const z=(0,I.$Mb)(T.versions.map(B)),Y=!!T.tags?.includes(v.$Go),G=z.indexOf("web");return Y?G===-1&&z.push("web"):G!==-1&&z.splice(G,1),z}function oe(T,z){for(let Y=0;Y<T.length;Y++){const G=T[Y];if(G.version===T[Y-1]?.version){let ee=Y;if(B(G)===z)for(;ee>0&&T[ee-1].version===G.version;)ee--;ee!==Y&&(T.splice(Y,1),T.splice(ee,0,G))}}return T}function te(T,z,Y){T.telemetryData={index:z,querySource:Y,queryActivityId:T.queryContext?.[o]}}function ce(T,z,Y,G){const ee=T.versions[0],_={manifest:F(z,r.Manifest),readme:F(z,r.Details),changelog:F(z,r.Changelog),license:F(z,r.License),repository:O(z),download:U(z),icon:F(z,r.Icon),signature:F(z,r.Signature),coreTranslations:p(z)};return{identifier:{id:(0,w.$kp)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:z.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:T.shortDescription??"",installCount:S(T.statistics,"install"),rating:S(T.statistics,"averagerating"),ratingCount:S(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:Y,assets:_,properties:{dependencies:M(z,a.Dependency),extensionPack:M(z,a.ExtensionPack),engine:x(z),localizedLanguages:Z(z),targetPlatform:B(z),isPreReleaseVersion:J(z)},hasPreReleaseVersion:J(ee),hasReleaseVersion:!0,preview:V(T.flags),isSigned:!!_.signature,queryContext:G,supportLink:K(ee)}}let H=class{constructor(z,Y,G,ee,_,X,ne,re){this.k=Y,this.l=G,this.n=ee,this.o=_,this.q=X,this.u=ne,this.w=re;const ue=ne.extensionsGallery,de=ue?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.d=de?ue.servicePPEUrl:ue?.serviceUrl,this.g=de?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,g.$Sp)(ne.version,ne,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,Y,G){const ee=A.CancellationToken.isCancellationToken(Y)?{}:Y,_=A.CancellationToken.isCancellationToken(Y)?Y:G,X=[],ne=[],re=[],ue=[];let de=!0;for(const Se of z){Se.uuid?ne.push(Se.uuid):X.push(Se.id);const Ie=!!(Se.version||Se.preRelease);re.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&ue.push({id:Se.id,uuid:Se.uuid,version:Se.version}),de=de&&!!Se.hasPreRelease&&!Ie}if(!ne.length&&!X.length)return[];let $e=new k().withPage(1,z.length);ne.length&&($e=$e.withFilter(t.ExtensionId,...ne)),X.length&&($e=$e.withFilter(t.ExtensionName,...X)),(ee.queryAllVersions||de)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??i,includePreRelease:re,versions:ue,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((Se,Ie)=>te(Se,Ie,ee.source)),ye}async getCompatibleExtension(z,Y,G,ee={version:this.u.version,date:this.u.date}){if((0,v.$No)(z.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(z,Y,G))return z;const _=new k().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,z.identifier.uuid),{extensions:X}=await this.z(_,{targetPlatform:G,compatible:!0,includePreRelease:Y,productVersion:ee},A.CancellationToken.None);return X[0]||null}async isExtensionCompatible(z,Y,G,ee={version:this.u.version,date:this.u.date}){if(!(0,v.$Oo)(z.properties.targetPlatform,z.allTargetPlatforms,G)||!Y&&z.properties.isPreReleaseVersion)return!1;let _=z.properties.engine;if(!_){const X=await this.getManifest(z,A.CancellationToken.None);if(!X)throw new Error("Manifest was not found");_=X.engines.vscode}return(0,u.$xp)(_,ee.version,ee.date)}async y(z,Y,G,ee,_,X,ne={version:this.u.version,date:this.u.date}){if(!(0,v.$Oo)(B(Y),_,X)||G!=="any"&&J(Y)!==(G==="prerelease"))return!1;if(ee)try{const re=await this.E(z,Y);if(!(0,u.$xp)(re,ne.version,ne.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${Y.version}.`,(0,N.$0)(re)),!1}return!0}async query(z,Y){let G=z.text||"";const ee=z.pageSize??50;let _=new k().withPage(1,ee);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,ye)=>(_=_.withFilter(t.Category,ye||$e),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,ye)=>(_=_.withFilter(t.Tag,ye||$e),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),_=_.withFilter(t.SearchText,G)),_=_.withSortBy(0)):z.ids?_=_.withFilter(t.ExtensionId,...z.ids):z.names?_=_.withFilter(t.ExtensionName,...z.names):_=_.withSortBy(4),typeof z.sortBy=="number"&&(_=_.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(_=_.withSortOrder(z.sortOrder)),z.source&&(_=_.withSource(z.source));const X=async(de,$e)=>{const{extensions:ye,total:Se}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Ie,Le)=>te(Ie,(de.pageNumber-1)*de.pageSize+Le,z.source)),{extensions:ye,total:Se}},{extensions:ne,total:re}=await X(_,Y),ue=async(de,$e)=>{if($e.isCancellationRequested)throw new N.$5;const{extensions:ye}=await X(_.withPage(de+1),$e);return ye};return{firstPage:ne,total:re,pageSize:_.pageSize,getPage:ue}}async z(z,Y,G){const ee=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),Y.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:X,context:ne}=await this.B(z,G);if(!(z.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const Se=await this.A(ye,Y,ne);Se&&$e.push(Se)}return{extensions:$e,total:X}}const ue=[],de=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],Se={id:(0,w.$kp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ie=(0,R.$1f)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(fe=>(0,w.$fp)(fe,Se))?.includePreRelease;if(Y.compatible&&(0,v.$No)(ie(ye),Y.targetPlatform))continue;const Le=await this.A(ye,Y,ne);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==Y.targetPlatform&&Le.hasPreReleaseVersion?de.set(ye.extensionId,$e):ue.push([$e,Le])}if(de.size){const $e=new $.$3d,ye=new k().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Se}=await this.z(ye,Y,G);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:de.size});for(const Ie of Se){const Le=de.get(Ie.identifier.uuid);ue.push([Le,Ie])}}return{extensions:ue.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:X}}async A(z,Y,G){const ee={id:(0,w.$kp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},_=Y.versions?.find(ue=>(0,w.$fp)(ue,ee))?.version,X=(0,R.$1f)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(ue=>(0,w.$fp)(ue,ee))?.includePreRelease,ne=ie(z),re=oe(z.versions,Y.targetPlatform);if(Y.compatible&&(0,v.$No)(ne,Y.targetPlatform))return null;for(let ue=0;ue<re.length;ue++){const de=re[ue];if(!(_&&de.version!==_)){if(await this.y((0,w.$kp)(z.publisher.publisherName,z.extensionName),de,X?"any":"release",Y.compatible,ne,Y.targetPlatform,Y.productVersion))return ce(z,de,ne,G);if(_&&de.version===_)return null}}return _||Y.compatible?null:ce(z,z.versions[0],ne)}async B(z,Y){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const G=await this.j,ee=JSON.stringify(z.raw),_={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},X=new $.$3d;let ne,re,ue=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&z.criteria.some($e=>$e.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},Y),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,h.$Ep)(ne);if(de){const $e=de.results[0],ye=$e.extensions,Se=$e.resultMetadata&&$e.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ue=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ue,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){const $e=(0,N.$4)(de)?v.ExtensionGalleryErrorCode.Cancelled:(0,N.$0)(de).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw re=new v.$So((0,N.$0)(de),$e),re}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(ee.length),duration:X.elapsed(),success:!!ne&&(0,h.$Ap)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:re?.code,count:String(ue)})}}async reportStatistic(z,Y,G,ee){if(!this.isEnabled())return;const _=j.$o?this.x(`/itemName/${z}.${Y}/version/${G}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${Y}/${G}/stats?statType=${ee}`),X=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.j,Accept:X};try{await this.k.request({type:"POST",url:_,headers:re},A.CancellationToken.None)}catch{}}async download(z,Y,G){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const ee=(0,w.$np)(z),_=new Date().getTime(),X=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),ne=G===2?"install":G===3?"update":"",re=ne?{uri:`${z.assets.download.uri}${P.URI.parse(z.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${z.assets.download.fallbackUri}${P.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:z.assets.download,ue=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,de=await this.D(z.identifier.id,re,r.VSIX,ue?{headers:ue}:void 0);await this.q.writeFile(Y,de.stream),X(new Date().getTime()-_)}async downloadSignatureArchive(z,Y){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const G=await this.D(z.identifier.id,z.assets.signature,r.Signature);await this.q.writeFile(Y,G.stream)}async getReadme(z,Y){if(z.assets.readme){const G=await this.D(z.identifier.id,z.assets.readme,r.Details,{},Y);return await(0,h.$Dp)(G)||""}return""}async getManifest(z,Y){if(z.assets.manifest){const G=await this.D(z.identifier.id,z.assets.manifest,r.Manifest,{},Y),ee=await(0,h.$Dp)(G);return ee?JSON.parse(ee):null}return null}async C(z,Y,G){const ee=F(Y,r.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},X=await this.D(z,ee,r.Manifest,{headers:_});return await(0,h.$Ep)(X)}async getCoreTranslation(z,Y){const G=z.assets.coreTranslations.filter(ee=>ee[0]===Y.toUpperCase())[0];if(G){const ee=await this.D(z.identifier.id,G[1],G[0]),_=await(0,h.$Dp)(ee);return _?JSON.parse(_):null}return null}async getChangelog(z,Y){if(z.assets.changelog){const G=await this.D(z.identifier.id,z.assets.changelog,r.Changelog,{},Y);return await(0,h.$Dp)(G)||""}return""}async getAllCompatibleVersions(z,Y,G){let ee=new k().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?ee=ee.withFilter(t.ExtensionId,z.identifier.uuid):ee=ee.withFilter(t.ExtensionName,z.identifier.id);const{galleryExtensions:_}=await this.B(ee,A.CancellationToken.None);if(!_.length)return[];const X=ie(_[0]);if((0,v.$No)(X,G))return[];const ne=[];await Promise.all(_[0].versions.map(async de=>{try{await this.y(z.identifier.id,de,Y?"any":"release",!0,X,G)&&ne.push(de)}catch{}}));const re=[],ue=new Set;for(const de of oe(ne,G))ue.has(de.version)||(ue.add(de.version),re.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:J(de)}));return re}async D(z,Y,G,ee={},_=A.CancellationToken.None){const X=await this.j,ne={type:"GET"},re={...X,...ee.headers||{}};ee={...ee,...ne,headers:re};const ue=Y.uri,de=Y.fallbackUri,$e={...ee,url:ue};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const Se=await(0,h.$Dp)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${Se}`)}catch(ye){if((0,N.$4)(ye))throw ye;const Se=(0,N.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:G,message:Se});const Ie={...ee,url:de};return this.k.request(Ie,_)}}async E(z,Y){let G=x(Y);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:Y.version});const ee=await this.C(z,Y,A.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const Y=await(0,h.$Ep)(z),G=[],ee={},_=[];if(Y){for(const X of Y.malicious)G.push({id:X});if(Y.migrateToPreRelease)for(const[X,ne]of Object.entries(Y.migrateToPreRelease))(!ne.engine||(0,u.$xp)(ne.engine,this.u.version,this.u.date))&&(ee[X.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(Y.deprecated)for(const[X,ne]of Object.entries(Y.deprecated))ne&&(ee[X.toLowerCase()]=(0,R.$1f)(ne)?{}:ne);if(Y.search)for(const X of Y.search)_.push(X)}return{malicious:G,deprecated:ee,search:_}}};H=ve([Q(1,h.$yp),Q(2,b.$Nj),Q(3,C.$oi),Q(4,c.$Ml),Q(5,f.$Nk),Q(6,m.$7j),Q(7,d.$Ni)],H);let q=class extends H{constructor(z,Y,G,ee,_,X,ne,re){super(z,Y,G,ee,_,X,ne,re)}};e.$Up=q,e.$Up=q=ve([Q(0,l.$Lp),Q(1,h.$yp),Q(2,b.$Nj),Q(3,C.$oi),Q(4,c.$Ml),Q(5,f.$Nk),Q(6,m.$7j),Q(7,d.$Ni)],q);let L=class extends H{constructor(z,Y,G,ee,_,X,ne){super(void 0,z,Y,G,ee,_,X,ne)}};e.$Vp=L,e.$Vp=L=ve([Q(0,h.$yp),Q(1,b.$Nj),Q(2,C.$oi),Q(3,c.$Ml),Q(4,f.$Nk),Q(5,m.$7j),Q(6,d.$Ni)],L)}),define(le[82],he([0,1,4,3,2,19,33,24,17,9,13]),function(se,e,I,A,N,j,D,R,P,d,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=void 0,e.$Hv=(0,I.$hi)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let u=class extends N.$Uc{static{v=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,D.$jp)(b.id)}@${b.version}`}static c(b){const m=w.exec(b);if(m&&m[1])return{id:m[1],version:m[2]}}static async removeOutdatedExtensionVersions(b,m){const h=await b.getInstalled(),g=[];for(const[l,c]of v.f(m)){const $=h.find(i=>(0,D.$fp)(i.identifier,{id:l}))?.manifest.version;for(const i of c)$!==i&&g.push(v.b({id:l,version:i}))}for(const l of g)m.remove(l,0)}static f(b){const m=new Map,h=b.keys(0,1);for(const g of h){const l=v.c(g);if(l){let c=m.get(l.id.toLowerCase());c||m.set(l.id.toLowerCase(),c=[]),c.push(l.version)}}return m}constructor(b,m,h){super(),this.j=b,this.m=m,this.n=h,this.g=this.B(new A.$7d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=v.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new N.$Tc))(g=>this.r(g)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const m=v.c(b.key);if(m){if(this.j.get(b.key,0)===void 0)this.h.delete(m.id.toLowerCase());else{let h=this.h.get(m.id.toLowerCase());h||this.h.set(m.id.toLowerCase(),h=[]),h.push(m.version),this.g.fire()}return}}s(b){if((0,C.$Uf)(b))return b;const m=b.manifest?b.manifest.publisher:b.publisher,h=b.manifest?b.manifest.name:b.name;return(0,D.$ip)(m,h)}getExtensionState(b,m){const h=this.s(b),g=this.getExtensionStateRaw(b,m);if(g)try{return JSON.parse(g)}catch(l){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${m}): ${l}`)}}getExtensionStateRaw(b,m){const h=this.s(b),g=this.j.get(h,m?0:1);return g&&g?.length>v.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${m}): ${g.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),g}setExtensionState(b,m,h){const g=this.s(b);m===void 0?this.j.remove(g,h?0:1):this.j.store(g,JSON.stringify(m),h?0:1,1)}setKeysForSync(b,m){this.j.store(v.b(b),JSON.stringify(m),0,1)}getKeysForSync(b){const m=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],h=this.j.get(v.b(b),0),g=h?JSON.parse(h):void 0;return g&&m?(0,P.$Mb)([...g,...m]):g||m}addToMigrationList(b,m){if(b!==m){const h=this.t.filter(g=>!g.includes(b)&&!g.includes(m));h.push([b,m]),this.t=h}}getSourceExtensionToMigrate(b){const m=this.t.find(([,h])=>b===h);return m?m[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const m=JSON.parse(b);if(Array.isArray(m))return m}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Iv=u,e.$Iv=u=v=ve([Q(0,j.$Lp),Q(1,R.$7j),Q(2,d.$Nj)],u)}),define(le[253],he([0,1,2,29,82,228,113,9,19]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;let d=class extends I.$Uc{constructor(v,w,u,f,b,m){super(),v.cleanUp(),(0,j.$J2b)(v,w,u,f,m),N.$Iv.removeOutdatedExtensionVersions(v,b)}};e.$scc=d,e.$scc=d=ve([Q(0,D.$oq),Q(1,A.$Qo),Q(2,N.$Hv),Q(3,A.$Wo),Q(4,P.$Lp),Q(5,R.$Nj)],d)}),define(le[254],he([0,1,29,12,24,16,96,57,19,22,227]),function(se,e,I,A,N,j,D,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let v=class extends C.$O$b{constructor(u,f,b,m,h,g,l,c){super(u.userHome,h,f,b,m,g,l,c)}};e.$zcc=v,e.$zcc=v=ve([Q(0,j.$pi),Q(1,d.$Ml),Q(2,I.$To),Q(3,P.$Lp),Q(4,R.$pac),Q(5,D.$t2b),Q(6,A.$Nk),Q(7,N.$7j)],v)}),define(le[255],he([0,1,105,3,22,16,2,9,15,67,24,5,6,100,21,168,37,19,13,132,20]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;const $=[I.$occ,I.$pcc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends D.$Uc{constructor(a,y,E,k,S,p,O){super(),this.y=a,this.z=y,this.C=E,this.D=p,this.F=O,this.f=new A.$7d,this.onDidTokenFailed=this.f.event,this.g=new A.$7d,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$7d,this.onDidChangeMode=this.h.event,this.n=I.$mcc,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(k.createLogger((0,c.$Ug)(E.logsHome,`${I.$qcc}.log`),{id:I.$qcc,name:I.$rcc})),this.t=new w.$eh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,R.$3j)(U)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(p.onDidChangeConfiguration(U=>{$.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let a;v.$j?a=this.C.appRoot:a=(0,P.$nc)((0,P.$nc)(this.C.appRoot)),this.u=(0,P.$kc)(a,"bin",`${this.z.tunnelApplicationName}${v.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$mcc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",y=!1;const E=(F,M)=>{M?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,b.localize)(0,null)))},k=this.O("status",["status"],E);this.r=k;try{if(await k,this.r!==k)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(y=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(I.TunnelStates.disconnected());return}finally{this.r===k&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(I.TunnelStates.connecting((0,b.localize)(1,null,S.accountLabel,S.providerId)));const M=(J,Z)=>{J=J.replaceAll(F,"*".repeat(4)),E(J,Z)},x=this.O("login",["user","login","--provider",S.providerId,"--access-token",F,"--log",(0,R.$3j)(this.j.getLevel())],M);this.r=x;try{if(await x,this.r!==x)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(S),this.G(I.TunnelStates.disconnected(S));return}}const p=this.Q();p?this.G(I.TunnelStates.connecting((0,b.localize)(2,null,p))):this.G(I.TunnelStates.connecting((0,b.localize)(3,null)));const O=["--accept-server-license-terms","--log",(0,R.$3j)(this.j.getLevel())];p?O.push("--name",p):O.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!y&&(U=await this.M(O)===!1),this.N(S,O,U)}async M(a){let y;try{y=await this.O("serviceInstall",["service","install",...a])}catch(E){this.j.error(E),y=1}if(y!==0){const E=(0,b.localize)(4,null);return this.j.warn(E),this.G(I.TunnelStates.connecting(E)),!1}return!0}async N(a,y,E){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let k=!1;const S=this.O("tunnel",y,(p,O)=>{O?this.j.error(p):this.j.info(p),p.includes("Connected to an existing tunnel process")&&(k=!0);const U=p.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:k};this.G(I.TunnelStates.connected(F,E))}else p.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$mcc,this.G(I.TunnelStates.disconnected()))})}O(a,y,E=this.I){return(0,w.$7g)(k=>new Promise((S,p)=>{k.isCancellationRequested&&S(-1);let O;const U=["ignore","pipe","pipe"];if(k.onCancellationRequested(()=>{O&&(this.j.info(`${a} terminating(${O.pid})`),O.kill())}),!this.C.isBuilt)E(`Building tunnel CLI from sources and run
`,!1),E(`${a} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),O=(0,d.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,P.$kc)(this.C.appRoot,"cli"),stdio:U});else{E(`Running tunnel CLI
`,!1);const F=this.J();E(`${a} Spawning: ${F} tunnel ${y.join(" ")}
`,!1),O=(0,d.spawn)(F,["tunnel",...y],{cwd:(0,m.homedir)(),stdio:U})}O.stdout.pipe(new l.$VV(`
`)).on("data",F=>{if(O){const M=F.toString();E(M,!1)}}),O.stderr.pipe(new l.$VV(`
`)).on("data",F=>{if(O){const M=F.toString();E(M,!0)}}),O.on("exit",F=>{O&&(E(`${a} exit(${O.pid}): + ${F} `,!1),O=void 0,S(F||0))}),O.on("error",F=>{O&&(E(`${a} error(${O.pid}): + ${F} `,!0),O=void 0,p())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$pcc)}Q(){let a=this.D.getValue(I.$occ)||(0,m.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),y=this.F.getBoolean(o,-1,!1);if(a){const E=JSON.parse(a);if(E&&(0,g.$Uf)(E.accountLabel)&&(0,g.$Uf)(E.sessionId)&&(0,g.$Uf)(E.providerId))return{active:!0,session:E,asService:y};this.j.error("Problems restoring session from storage, invalid format",E)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$mcc}S(a){if(a.active){const y={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(y),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$vcc=n,e.$vcc=n=ve([Q(0,N.$Ml),Q(1,C.$7j),Q(2,j.$pi),Q(3,R.$Oj),Q(4,u.$tcc),Q(5,f.$Ni),Q(6,h.$Lp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[256],he([0,1,6,2,23,20,69,19,77,18]),function(se,e,I,A,N,j,D,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class C extends R.$Np{constructor(w,u,f,b){super(),this.bb=w,this.cb=u,this.db=f,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Tc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new P.$rIb(this.db.getChannel("storage"))),u=this.B(new D.$Hp(w));return this.B(u.onDidChangeStorage(f=>this.u(-1,f))),u}gb(w){this.X.clear(),this.W=w;let u;if((0,R.$Op)(w))u=this.U;else{const f=this.X.add(new P.$sIb(this.db.getChannel("storage"),w));u=this.X.add(new D.$Hp(f))}return this.X.add(u.onDidChangeStorage(f=>this.u(0,f))),u}hb(w){this.$.clear(),this.Z=w?.id;let u;if(w){const f=this.$.add(new P.$tIb(this.db.getChannel("storage"),w));u=this.$.add(new D.$Hp(f)),this.$.add(u.onDidChangeStorage(b=>this.u(1,b)))}return u}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Ug)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const u=this.Y,f=u.items;u!==this.U&&await u.close(),this.Y=this.gb(w),await this.Y.init(),this.N(f,this.Y,0)}async S(w,u){const f=this.ab,b=f?.items??new Map;await f?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(b,this.ab,1)}hasScope(w){return(0,d.$ml)(w)?this.W.id===w.id:this.Z===w.id}}e.$Acc=C}),define(le[257],he([0,1,3,2,18,91]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0;class D{constructor(d,C){this.a=d,this.b=C}listen(d,C){const v=this.b(d);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(u=>(0,j.$ln)({...u},v)),added:w.added.map(u=>(0,j.$ln)({...u},v)),removed:w.removed.map(u=>(0,j.$ln)({...u},v)),updated:w.updated.map(u=>(0,j.$ln)({...u},v))}))}throw new Error(`Invalid listen ${C}`)}async call(d,C,v){const w=this.b(d);switch(C){case"createProfile":{const u=await this.a.createProfile(v[0],v[1],v[2]);return(0,j.$ln)({...u},w)}case"updateProfile":{let u=(0,N.$ol)((0,j.$mn)(v[0],w),this.a.profilesHome.scheme);return u=await this.a.updateProfile(u,v[1]),(0,j.$ln)({...u},w)}case"removeProfile":{const u=(0,N.$ol)((0,j.$mn)(v[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(u)}}throw new Error(`Invalid call ${C}`)}}e.$7P=D;class R extends A.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,C,v){super(),this.profilesHome=C,this.f=v,this.a=[],this.b=this.B(new I.$7d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(w=>(0,N.$ol)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const u=w.added.map(m=>(0,N.$ol)(m,this.profilesHome.scheme)),f=w.removed.map(m=>(0,N.$ol)(m,this.profilesHome.scheme)),b=w.updated.map(m=>(0,N.$ol)(m,this.profilesHome.scheme));this.a=w.all.map(m=>(0,N.$ol)(m,this.profilesHome.scheme)),this.b.fire({added:u,removed:f,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,C,v){const w=await this.f.call("createNamedProfile",[d,C,v]);return(0,N.$ol)(w,this.profilesHome.scheme)}async createProfile(d,C,v,w){const u=await this.f.call("createProfile",[d,C,v,w]);return(0,N.$ol)(u,this.profilesHome.scheme)}async createTransientProfile(d){const C=await this.f.call("createTransientProfile",[d]);return(0,N.$ol)(C,this.profilesHome.scheme)}async setProfileForWorkspace(d,C){await this.f.call("setProfileForWorkspace",[d,C])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,C){const v=await this.f.call("updateProfile",[d,C]);return(0,N.$ol)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$8P=R}),define(le[60],he([0,1,2,69,4,19,3,77,18]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xIb=e.$wIb=e.$vIb=void 0,e.$vIb=(0,N.$hi)("IUserDataProfileStorageService");let d=class extends I.$Uc{constructor(u){super(),this.a=u}async readStorageData(u){return this.withProfileScopedStorageService(u,async f=>this.b(f))}async updateStorageData(u,f,b){return this.withProfileScopedStorageService(u,async m=>this.c(m,f,b))}async withProfileScopedStorageService(u,f){if(this.a.hasScope(u))return f(this.a);const b=await this.g(u),m=new v(b);try{await m.initialize();const h=await f(m);return await m.flush(),h}finally{m.dispose(),await this.f(b)}}b(u){const f=new Map,b=m=>{for(const h of u.keys(0,m))f.set(h,{value:u.get(h,0),target:m})};return b(0),b(1),f}c(u,f,b){u.storeAll(Array.from(f.entries()).map(([m,h])=>({key:m,value:h,scope:0,target:b})),!0)}async f(u){try{await u.close()}finally{(0,I.$Oc)(u)&&u.dispose()}}};e.$wIb=d,e.$wIb=d=ve([Q(0,j.$Lp)],d);class C extends d{constructor(u,f,b,m){super(b),this.j=u;const h=u.getChannel("profileStorageListener"),g=this.B(new I.$Vc);this.h=this.B(new D.$7d({onWillAddFirstListener:()=>{g.value=h.listen("onDidChange")(l=>{m.trace("profile storage changes",l),this.h.fire({targetChanges:l.targetChanges.map(c=>(0,P.$ol)(c,f.profilesHome.scheme)),valueChanges:l.valueChanges.map(c=>({...c,profile:(0,P.$ol)(c.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this.h.event}async g(u){const f=this.j.getChannel("storage");return(0,j.$Op)(u)?new R.$rIb(f):new R.$sIb(f,u)}}e.$xIb=C;class v extends j.$Np{constructor(u){super({flushInterval:100}),this.s=this.B(new A.$Hp(u))}O(){return this.s.init()}P(u){return u===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[258],he([0,1,19,9,18,56,60]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;let R=class extends D.$xIb{constructor(d,C,v,w){super(d,C,v,w)}};e.$fcc=R,e.$fcc=R=ve([Q(0,j.$Ebc),Q(1,N.$nl),Q(2,I.$Lp),Q(3,A.$Nj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,13,173,21,16,12,9,44,19,22,28,25,18]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJb=e.$vJb=e.$uJb=e.$tJb=void 0,e.$qJb=i,e.$rJb=o,e.$sJb=n;function i(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||o(y.syncData)))}function o(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function n(y,E){return`${(0,d.$Mf)(y)}${E.isDefault?"":` (${E.name})`}`}let s=class extends P.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(E,k,S,p,O,U,F,M,x,J,Z,W){super(),this.syncResource=E,this.collection=k,this.G=S,this.H=p,this.I=O,this.J=U,this.L=F,this.M=M,this.N=x,this.O=J,this.P=Z,this.c=null,this.m="idle",this.n=this.B(new D.$7d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$7d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$fh(50)),this.w=this.B(new D.$7d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(E.syncResource,E.profile),this.h=W.extUri,this.f=this.h.joinPath(p.userDataSyncHome,...(0,c.$Cpb)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.g=this.h.joinPath(this.f,c.$Xpb),this.y=(0,c.$Dpb)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,p,this.h),this.j=(0,m.$Rp)(p,S,O)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const E=await this.c;this.c=null;const k=await this.Y(E.remoteUserData,E.lastSyncUserData,!0,this.ob());this.S(k)}else{this.O.trace(`${this.D}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.ub(E):!0)&&this.w.fire()}}S(E){this.m!==E&&(this.m=E,this.n.fire(E))}async sync(E,k={}){await this.U(E,!0,this.ob(),k)}async preview(E,k,S={}){return this.U(E,!1,k,S)}async apply(E,k={}){try{this.F={...k};const S=await this.ab(E);return this.S(S),this.c}finally{this.F={}}}async U(E,k,S,p){try{if(this.F={...p},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let O="idle";try{const U=await this.getLastSyncUserData(),F=await this.X(E,U);return O=await this.Y(F,U,k,S),O==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(O)}}finally{this.F={}}}async replace(E){const k=this.kb(E);if(!k)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const S=await this.getLastSyncUserData(),p=await this.X(null,S),O=await this.W(p),U=await this.qb({ref:p.ref,syncData:k},S,O,this.ob(),j.CancellationToken.None),F=[];for(const M of U){const x=await this.sb(M,M.remoteResource,void 0,j.CancellationToken.None),{remoteChange:J}=await this.sb(M,M.previewResource,M.remoteContent,j.CancellationToken.None);F.push([M,{...x,remoteChange:J!==0?J:2}])}await this.tb(p,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(E){const k=await this.j;return!!E.syncData?.machineId&&E.syncData.machineId===k}async X(E,k){if(k){const S=E?E[this.resource]:void 0;if(k.ref===S||S===void 0&&k.syncData===null)return k}return this.getRemoteUserData(k)}async Y(E,k,S,p){if(E.syncData&&E.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$Kpb((0,v.localize)(0,null,this.resource,this.pb,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(E,k,S,p)}catch(O){if(O instanceof c.$Kpb)switch(O.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(E,k,S,p);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),k=await this.getLastSyncUserData(),this.Y(E,k,S,p)}throw O}}async Z(E,k,S,p){try{const O=await this.W(E),U=!O&&k===null&&this.gb()!==void 0,F=S&&!U;this.c||(this.c=(0,A.$7g)(x=>this.eb(E,k,O,F,p,x)));let M=await this.c;if(S&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const x of M.resourcePreviews)M=await this.accept(x.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:x})=>x==="conflict")?"hasConflicts":S?await this.ab(!1):"syncing"}catch(O){throw this.c=null,O}}async merge(E){return await this.$(E,async k=>{const S=await this.rb(k,j.CancellationToken.None);await this.G.writeFile(k.previewResource,N.$ue.fromString(S?.content||""));const p=S&&!S.hasConflicts?await this.sb(k,k.previewResource,void 0,j.CancellationToken.None):void 0;return k.acceptResult=p,k.mergeState=S.hasConflicts?"conflict":p?"accepted":"preview",k.localChange=p?p.localChange:S.localChange,k.remoteChange=p?p.remoteChange:S.remoteChange,k}),this.c}async accept(E,k){return await this.$(E,async S=>{const p=await this.sb(S,E,k,j.CancellationToken.None);return S.acceptResult=p,S.mergeState="accepted",S.localChange=p.localChange,S.remoteChange=p.remoteChange,S}),this.c}async discard(E){return await this.$(E,async k=>{const S=await this.rb(k,j.CancellationToken.None);return await this.G.writeFile(k.previewResource,N.$ue.fromString(S.content||"")),k.acceptResult=void 0,k.mergeState="preview",k.localChange=S.localChange,k.remoteChange=S.remoteChange,k}),this.c}async $(E,k){if(!this.c)return;let S=await this.c;const p=S.resourcePreviews.findIndex(({localResource:O,remoteResource:U,previewResource:F})=>this.h.isEqual(O,E)||this.h.isEqual(U,E)||this.h.isEqual(F,E));p!==-1&&(this.c=(0,A.$7g)(async O=>{const U=[...S.resourcePreviews];return U[p]=await k(U[p]),{...S,resourcePreviews:U}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(E){if(!this.c)return"idle";const k=await this.c;return k.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":k.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.tb(k.remoteUserData,k.lastSyncUserData,k.resourcePreviews.map(S=>[S,S.acceptResult]),E),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(E){const k=E.filter(({mergeState:S})=>S==="conflict");(0,I.$ub)(this.s,k,(S,p)=>this.h.isEqual(S.previewResource,p.previewResource))||(this.s=k,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async db(E){const k=this.c?await this.c:null;if(k)for(const S of k.resourcePreviews){if(this.h.isEqual(S.acceptedResource,E))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,E))return S.remoteContent;if(this.h.isEqual(S.localResource,E))return S.localContent;if(this.h.isEqual(S.baseResource,E))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(E){(0,f.$5k)(E)!==1&&this.O.error(E)}}async eb(E,k,S,p,O,U){const F=await this.qb(E,k,S,O,U),M=[];for(const x of F){const J=x.previewResource.with({scheme:c.$Wpb,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)M.push({...x,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Z=p?await this.rb(x,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(x.previewResource,N.$ue.fromString(Z?.content||""));const W=Z&&!Z.hasConflicts?await this.sb(x,x.previewResource,void 0,U):void 0;M.push({...x,acceptResult:W,mergeState:Z?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:Z?Z.localChange:x.localChange,remoteChange:W?W.remoteChange:Z?Z.remoteChange:x.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:k,resourcePreviews:M,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let E=this.gb();if(E||(E=await this.jb()),!E)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const k=JSON.parse(E),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!k.version&&!!S&&k.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${k.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let p,O=1;for(;p===void 0&&O++<6;)try{const U=await this.hb();U&&(U.ref===k.ref?p=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof f.$9k&&U.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof c.$Kpb)throw U;this.O.error(U,O)}}if(p===void 0)try{const U=await this.J.resolveResourceContent(this.resource,k.ref,this.collection,this.F);p=U===null?null:this.kb(U),await this.ib({ref:k.ref,syncData:p})}catch(U){if(U instanceof c.$Kpb&&U.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return p===void 0?null:{...k,syncData:p}}async fb(E,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),p={ref:E.ref,version:S,...k};this.I.store(this.z,JSON.stringify(p),-1,1),await this.ib(E)}gb(){return this.I.get(this.z,-1)}async hb(){const E=(await this.G.readFile(this.y)).value.toString();try{const k=E?JSON.parse(E):void 0;if(i(k))return k}catch(k){this.O.error(k)}}async ib(E){await this.G.writeFile(this.y,N.$ue.fromString(JSON.stringify(E)))}async jb(){try{const E=await this.G.readFile(this.y),k=JSON.parse(E.value.toString());await this.G.del(this.y),k.ref&&k.content!==void 0?(this.I.store(this.z,JSON.stringify({...k,content:void 0}),-1,1),await this.ib({ref:k.ref,syncData:k.content===null?null:JSON.parse(k.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,k)}catch(E){E instanceof f.$9k&&E.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(E)}return this.I.get(this.z,-1)}async getRemoteUserData(E){const{ref:k,content:S}=await this.lb(E);let p=null;return S!==null&&(p=this.kb(S)),{ref:k,syncData:p}}kb(E){try{const k=JSON.parse(E);if(o(k))return k}catch(k){this.O.error(k)}throw new c.$Kpb((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(E){const k=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.J.readResource(this.resource,k,this.collection,this.F)}async mb(E,k){const S=await this.j,p={version:this.pb,machineId:S,content:E};try{return k=await this.J.writeResource(this.resource,JSON.stringify(p),k,this.collection,this.F),{ref:k,syncData:p}}catch(O){throw O instanceof c.$Kpb&&O.code==="TooLarge"&&(O=new c.$Kpb(O.message,O.code,this.resource)),O}}async nb(E){const k={version:this.pb,content:E};return this.L.writeResource(this.resource,JSON.stringify(k),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$xpb)}};e.$tJb=s,e.$tJb=s=ve([Q(2,f.$Nk),Q(3,u.$oi),Q(4,h.$Lp),Q(5,c.$Fpb),Q(6,c.$Gpb),Q(7,c.$Ppb),Q(8,g.$Ml),Q(9,c.$Upb),Q(10,w.$Ni),Q(11,l.$ll)],s);let t=class extends s{constructor(E,k,S,p,O,U,F,M,x,J,Z,W,K){super(k,S,p,O,U,F,M,x,J,Z,W,K),this.r=E,this.B(this.G.watch(this.h.dirname(E))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(E,k,S){try{k?await this.G.writeFile(this.r,N.$ue.fromString(E),S?void 0:k):await this.G.createFile(this.r,N.$ue.fromString(E),{overwrite:S})}catch(p){throw p instanceof f.$9k&&p.fileOperationResult===1||p instanceof f.$9k&&p.fileOperationResult===3?new c.$Kpb(p.message,"LocalPreconditionFailed"):p}}async xb(){try{await this.G.del(this.r)}catch(E){if(!(E instanceof f.$9k&&E.fileOperationResult===1))throw E}}yb(E){E.contains(this.r)&&this.Q()}};e.$uJb=t,e.$uJb=t=ve([Q(3,f.$Nk),Q(4,u.$oi),Q(5,h.$Lp),Q(6,c.$Fpb),Q(7,c.$Gpb),Q(8,c.$Ppb),Q(9,g.$Ml),Q(10,c.$Upb),Q(11,w.$Ni),Q(12,l.$ll)],t);let r=class extends t{constructor(E,k,S,p,O,U,F,M,x,J,Z,W,K,V){super(E,k,S,p,O,U,F,M,x,J,Z,K,V),this.zb=W,this.Bb=void 0}Ab(E,k){const S=[],p=(0,R.$un)(E,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,C.$2f)(p)&&k!==Array.isArray(p)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$vJb=r,e.$vJb=r=ve([Q(3,f.$Nk),Q(4,u.$oi),Q(5,h.$Lp),Q(6,c.$Fpb),Q(7,c.$Gpb),Q(8,c.$Ppb),Q(9,g.$Ml),Q(10,c.$Upb),Q(11,c.$Tpb),Q(12,w.$Ni),Q(13,l.$ll)],r);let a=class{constructor(E,k,S,p,O,U,F){this.resource=E,this.g=k,this.h=S,this.j=p,this.k=O,this.l=U,this.d=F.extUri,this.f=(0,c.$Dpb)(void 0,this.resource,S,this.d)}async initialize({ref:E,content:k}){if(!k){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(k);if(S)try{await this.o({ref:E,syncData:S})}catch(p){this.j.error(p)}}m(E){try{const k=JSON.parse(E);if(o(k))return k}catch(k){this.j.error(k)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(E,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const S={ref:E.ref,version:void 0,...k};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),-1,1),await this.k.writeFile(this.f,N.$ue.fromString(JSON.stringify(E)))}};e.$wJb=a,e.$wJb=a=ve([Q(1,$.$nl),Q(2,u.$oi),Q(3,b.$Nj),Q(4,f.$Nk),Q(5,h.$Lp),Q(6,l.$ll)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,16,114,29,33,82,47,12,4,74,9,19,22,28,18,39,239,111,25,60]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.$V9b=e.$U9b=void 0,e.$S9b=E,e.$T9b=k;async function y(U,F){const M=JSON.parse(U.content);if(U.version===1||U.version===2){const x=(await F.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of M)U.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),U.version===2&&x.every(Z=>!(0,u.$fp)(Z.identifier,J.identifier))&&(J.installed=!0)}return M}function E(U){return JSON.parse(U.content)}function k(U,F){return U.sort((M,x)=>!M.identifier.uuid&&x.identifier.uuid?-1:M.identifier.uuid&&!x.identifier.uuid?1:(0,P.$ef)(M.identifier.id,x.identifier.id)),F?(0,D.$Fn)(U,{}):JSON.stringify(U)}let S=class extends n.$tJb{constructor(F,M,x,J,Z,W,K,V,B,ie,oe,te,ce,H,q,L,T){super({syncResource:"extensions",profile:F},M,J,x,Z,W,K,te,ce,ie,oe,q),this.Cb=V,this.Db=B,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Wpb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Wpb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Wpb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Wpb,authority:"accepted"}),this.Bb=this.Eb.createInstance(p),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:Y})=>!!Y)),j.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),j.Event.filter(L.onDidChange,z=>z.valueChanges.some(({profile:Y,changes:G})=>this.syncResource.profile.id===Y.id&&G.some(ee=>ee.key===w.$Uo))),H.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,M){const x=F.syncData?await y(F.syncData,this.Cb):null,J=M?.skippedExtensions??[],Z=M?.builtinExtensions??null,W=M?.syncData?await y(M.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);x?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$R9b)(K,x,W,J,V,Z),oe={local:B,remote:ie,content:this.Hb(K,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},te=this.Ob(K,!1);return[{skippedExtensions:J,builtinExtensions:Z,baseResource:this.xb,baseContent:W?this.Ob(W,!1):te,localResource:this.yb,localContent:te,localExtensions:K,remoteResource:this.zb,remoteExtensions:x,remoteContent:x?this.Ob(x,!1):null,previewResource:this.wb,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.Ab}]}async ub(F){const M=F.syncData?await y(F.syncData,this.Cb):null,{localExtensions:x,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,s.$R9b)(x,M,M,F.skippedExtensions||[],J,F.builtinExtensions||[]);return Z!==null}Hb(F,M,x,J){const Z=[...M,...x],W=new Set,K=V=>{W.add(V.id.toLowerCase()),V.uuid&&W.add(V.uuid)};Z.forEach(({identifier:V})=>K(V)),J.forEach(K);for(const V of F)W.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&W.has(V.identifier.uuid)||Z.push(V);return this.Ob(Z,!1)}async rb(F,M){return{...F.previewResult,hasConflicts:!1}}async sb(F,M,x,J){if(this.h.isEqual(M,this.yb))return this.Kb(F);if(this.h.isEqual(M,this.zb))return this.Lb(F);if(this.h.isEqual(M,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.Db.getIgnoredExtensions(M),J=(0,s.$R9b)(F.localExtensions,null,null,F.skippedExtensions,x,F.builtinExtensions),{local:Z,remote:W}=J;return{content:F.localContent,local:Z,remote:W,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.Db.getIgnoredExtensions(M),J=F.remoteContent?JSON.parse(F.remoteContent):null;if(J!==null){const Z=(0,s.$R9b)(F.localExtensions,J,F.localExtensions,[],x,F.builtinExtensions),{local:W,remote:K}=Z;return{content:F.remoteContent,local:W,remote:K,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,M,x,J){let{skippedExtensions:Z,builtinExtensions:W,localExtensions:K}=x[0][0];const{local:V,remote:B,localChange:ie,remoteChange:oe}=x[0][1];if(ie===0&&oe===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(K)),Z=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,Z,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const te=JSON.stringify(B.all);F=await this.mb(te,J?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ce=>ce.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ce=>ce.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ce=>ce.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(K,W),await this.fb(F,{skippedExtensions:Z,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(te=>te.identifier.id))}.`:""}`))}Nb(F,M){const x=new Set,J=[];for(const Z of F)x.add(Z.identifier.id.toLowerCase()),Z.installed||J.push(Z.identifier);if(M)for(const Z of M)x.has(Z.id.toLowerCase())||J.push(Z);return J}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const M=await this.db(F);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(F,M){return k(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$U9b=S,e.$U9b=S=ve([Q(2,C.$oi),Q(3,m.$Nk),Q(4,c.$Lp),Q(5,r.$Fpb),Q(6,r.$Gpb),Q(7,w.$To),Q(8,t.$eKb),Q(9,r.$Upb),Q(10,d.$Ni),Q(11,r.$Ppb),Q(12,$.$Ml),Q(13,f.$Hv),Q(14,i.$ll),Q(15,a.$vIb),Q(16,h.$gi)],S);let p=class{constructor(F,M,x,J,Z,W){this.a=F,this.b=M,this.c=x,this.d=J,this.f=Z,this.g=W}async getLocalExtensions(F){const M=await this.a.getInstalled(void 0,F.extensionsResource),x=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(F,async(Z,W)=>{const K=Z.getDisabledExtensions();return M.map(V=>{const{identifier:B,isBuiltin:ie,manifest:oe,preRelease:te,pinned:ce,isApplicationScoped:H}=V,q={identifier:B,preRelease:te,version:oe.version,pinned:!!ce};H&&!(0,b.$Fm)(oe)&&(q.isApplicationScoped=H),K.some(L=>(0,u.$fp)(L,B))&&(q.disabled=!0),ie||(q.installed=!0);try{const L=W.getKeysForSync({id:B.id,version:oe.version});if(L){const T=W.getExtensionState(V,!0)||{};q.state=Object.keys(T).reduce((z,Y)=>(L.includes(Y)&&(z[Y]=T[Y]),z),{})}}catch(L){this.g.info(`${(0,n.$sJb)("extensions",F)}: Error while parsing extension state`,(0,N.$0)(L))}return q})}),ignoredExtensions:x}}async updateLocalExtensions(F,M,x,J,Z){const W=(0,n.$sJb)("extensions",Z),K=[],V=new Map,B=[],ie=[],oe=await this.a.getInstalled(void 0,Z.extensionsResource);if((F.length||x.length)&&await this.j(Z,async(H,q)=>{await I.Promises.settled([...F,...x].map(async L=>{const T=oe.find(G=>(0,u.$fp)(G.identifier,L.identifier));if(T&&T.isBuiltin){L.state&&T.manifest.version===L.version&&this.h(L.state,T,T.manifest.version,q),H.getDisabledExtensions().some(ee=>(0,u.$fp)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${W}: Disabling extension...`,L.identifier.id),await H.disableExtension(L.identifier),this.g.info(`${W}: Disabled extension`,L.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,L.identifier.id),await H.enableExtension(L.identifier),this.g.info(`${W}: Enabled extension`,L.identifier.id))),B.push(L.identifier);return}const z=L.pinned?L.version:void 0,Y=(await this.c.getExtensions([{...L.identifier,version:z,preRelease:z?void 0:L.preRelease}],A.CancellationToken.None))[0];if(L.state&&(T?T.manifest.version===L.version:Y)&&this.h(L.state,T||Y,T?.manifest.version,q),Y)try{H.getDisabledExtensions().some(ee=>(0,u.$fp)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${W}: Disabling extension...`,L.identifier.id,Y.version),await H.disableExtension(Y.identifier),this.g.info(`${W}: Disabled extension`,L.identifier.id,Y.version)):(this.g.trace(`${W}: Enabling extension...`,L.identifier.id,Y.version),await H.enableExtension(Y.identifier),this.g.info(`${W}: Enabled extension`,L.identifier.id,Y.version))),(!T||T.preRelease!==L.preRelease||T.pinned!==L.pinned||z&&T.manifest.version!==z)&&(await this.a.canInstall(Y)?(K.push({extension:Y,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:L.pinned&&!!L.version,installPreReleaseVersion:L.preRelease,profileLocation:Z.extensionsResource,isApplicationScoped:L.isApplicationScoped,context:{[w.$Ho]:!0,[w.$Io]:!0}}}),V.set(Y.identifier.id.toLowerCase(),L)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,Y.displayName||Y.identifier.id),ie.push(L)))}catch(G){ie.push(L),this.g.error(G),this.g.info(`${W}: Skipped synchronizing extension`,Y.displayName||Y.identifier.id)}else ie.push(L),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,L.identifier.id)}))}),M.length){const H=oe.filter(({identifier:q,isBuiltin:L})=>!L&&M.some(T=>(0,u.$fp)(q,T)));await I.Promises.settled(H.map(async q=>{this.g.trace(`${W}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,q.identifier.id),B.push(q.identifier)}))}const te=await this.a.installGalleryExtensions(K);for(const{identifier:H,local:q,error:L,source:T}of te){const z=T;if(q)this.g.info(`${W}: Installed extension.`,H.id,z.version),B.push(H);else{const Y=V.get(H.id.toLowerCase());Y&&(ie.push(Y),this.g.info(`${W}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),L instanceof w.$Ro&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(L.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):L&&this.g.error(L)}}const ce=[];for(const H of J)B.some(q=>(0,u.$fp)(q,H.identifier))||ce.push(H);for(const H of ie)ce.some(q=>(0,u.$fp)(q.identifier,H.identifier))||ce.push(H);return ce}h(F,M,x,J){const Z=J.getExtensionState(M,!0)||{},W=x?J.getKeysForSync({id:M.identifier.id,version:x}):void 0;W?W.forEach(K=>{Z[K]=F[K]}):Object.keys(F).forEach(K=>Z[K]=F[K]),J.setExtensionState(M,Z,!0)}async j(F,M){return this.b.withProfileScopedStorageService(F,async x=>{const J=new R.$Tc,Z=this.f.createChild(new g.$fi([c.$Lp,x])),W=J.add(Z.createInstance(v.$THb)),K=J.add(Z.createInstance(f.$Iv));try{return await M(W,K)}finally{J.dispose()}})}};e.$V9b=p,e.$V9b=p=ve([Q(0,w.$To),Q(1,a.$vIb),Q(2,w.$Qo),Q(3,t.$eKb),Q(4,h.$gi),Q(5,r.$Upb)],p);let O=class extends n.$wJb{constructor(F,M,x,J,Z,W,K,V){super("extensions",J,Z,W,x,K,V),this.p=F,this.q=M}async t(F){return F.syncData?await y(F.syncData,this.p):null}u(F,M){const x=[],J=[],Z=[];for(const W of F){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const K=M.find(V=>(0,u.$fp)(V.identifier,W.identifier));K?(x.push(K),W.disabled&&Z.push(W.identifier)):W.installed&&(J.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&Z.push(W.identifier))}return{installedExtensions:x,newExtensions:J,disabledExtensions:Z,remoteExtensions:F}}};e.$W9b=O,e.$W9b=O=ve([Q(0,w.$To),Q(1,t.$eKb),Q(2,m.$Nk),Q(3,o.$nl),Q(4,C.$oi),Q(5,l.$Nj),Q(6,c.$Lp),Q(7,i.$ll)],O)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,16,12,9,44,19,22,28,39,79,243,25,18,60,4]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJb=e.$BJb=e.$AJb=e.$zJb=void 0,e.$yJb=t;const n="globalState.argv.",s=["locale"];function t(S,p){const O=S.storage?Object.keys(S.storage).sort():[],U={};return O.forEach(F=>U[F]=S.storage[F]),S.storage=U,p?(0,D.$Fn)(S,{}):JSON.stringify(S)}const r=1;let a=class extends h.$tJb{constructor(p,O,U,F,M,x,J,Z,W,K,V,B,ie,oe){super({syncResource:"globalState",profile:p},O,F,Z,B,M,x,W,K,J,V,ie),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$Wpb,authority:"base"}),this.xb=this.vb.with({scheme:c.$Wpb,authority:"local"}),this.yb=this.vb.with({scheme:c.$Wpb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$Wpb,authority:"accepted"}),this.Ab=oe.createInstance(y),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(F.onDidFilesChange,te=>te.contains(this.H.argvResource)),N.Event.filter(U.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:H})=>this.syncResource.profile.id===ce.id&&H.some(q=>q.target===0)))))(()=>this.Q()))}async qb(p,O,U){const F=p.syncData?JSON.parse(p.syncData.content):null;O=O===null&&U?p:O;const M=O&&O.syncData?JSON.parse(O.syncData.content):null,x=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(M),{local:Z,remote:W}=(0,l.$xJb)(x.storage,F?F.storage:null,M?M.storage:null,J,this.O),K={content:null,local:Z,remote:W,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?2:0,remoteChange:W.all!==null?2:0},V=t(x,!1);return[{baseResource:this.wb,baseContent:M?t(M,!1):V,localResource:this.xb,localContent:V,localUserData:x,remoteResource:this.yb,remoteContent:F?t(F,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(p){const O=p.syncData?JSON.parse(p.syncData.content):null;if(O===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(O),{remote:M}=(0,l.$xJb)(U.storage,O.storage,O.storage,F,this.O);return M.all!==null}async rb(p,O){return{...p.previewResult,hasConflicts:!1}}async sb(p,O,U,F){if(this.h.isEqual(O,this.xb))return this.Gb(p);if(this.h.isEqual(O,this.yb))return this.Hb(p);if(this.h.isEqual(O,this.vb))return p.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async Gb(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(p.localUserData.storage),removed:[],updated:[],all:p.localUserData.storage},localChange:0,remoteChange:2}}async Hb(p){if(p.remoteContent!==null){const O=JSON.parse(p.remoteContent),{local:U,remote:F}=(0,l.$xJb)(p.localUserData.storage,O.storage,null,p.storageKeys,this.O);return{content:p.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(p,O,U,F){const{localUserData:M}=U[0][0],{local:x,remote:J,localChange:Z,remoteChange:W}=U[0][1];if(Z===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Z!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(x,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:J.all});p=await this.mb(K,F?null:p.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}O?.ref!==p.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(p),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(p){if(this.h.isEqual(this.yb,p)||this.h.isEqual(this.wb,p)||this.h.isEqual(this.xb,p)||this.h.isEqual(this.zb,p)){const O=await this.db(p);return O&&t(JSON.parse(O),!0)}return null}async hasLocalData(){try{const{storage:p}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(p).length>1||p[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(p){const O=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[J,Z]of O)Z.target===0?U.push(J):Z.target===1&&F.push(J);const M=[...U,...F],x=p?.storage?Object.keys(p.storage).filter(J=>!J.startsWith(n)&&!M.includes(J)&&O.get(J)!==void 0):[];if(!R.$o){const J=[...c.$Bpb.map(Z=>(0,c.$Opb)(Z)),c.$Npb];x.push(...J),F.push(...J)}return{user:U,machine:F,unregistered:x}}};e.$zJb=a,e.$zJb=a=ve([Q(2,i.$vIb),Q(3,v.$Nk),Q(4,c.$Fpb),Q(5,c.$Gpb),Q(6,c.$Upb),Q(7,C.$oi),Q(8,c.$Ppb),Q(9,b.$Ml),Q(10,d.$Ni),Q(11,f.$Lp),Q(12,m.$ll),Q(13,o.$gi)],a);let y=class{constructor(p,O,U,F){this.a=p,this.b=O,this.c=U,this.d=F}async getLocalGlobalState(p){const O={};if(p.isDefault){const F=await this.f(),M=(0,j.$un)(F);for(const x of s)M[x]!==void 0&&(O[`${n}${x}`]={version:1,value:M[x]})}const U=await this.c.readStorageData(p);for(const[F,M]of U)M.value&&M.target===0&&(O[F]={version:1,value:M.value});return{storage:O}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const p=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),p.value.toString()}catch(p){this.d.debug((0,A.$0)(p))}return"{}"}async writeLocalGlobalState({added:p,removed:O,updated:U},F){const M=(0,h.$sJb)("globalState",F),x={},J=new Map,Z=await this.c.readStorageData(F),W=(K,V)=>{for(const B of K){if(B.startsWith(n)){x[B.substring(n.length)]=V?V[B].value:void 0;continue}if(V){const ie=V[B];ie.value!==Z.get(B)?.value&&J.set(B,ie.value)}else Z.get(B)!==void 0&&J.set(B,void 0)}};if(W(Object.keys(p),p),W(Object.keys(U),U),W(O),Object.keys(x).length){this.d.trace(`${M}: Updating locale...`);const K=await this.f();let V=K;for(const B of Object.keys(x))V=(0,g.edit)(V,[B],x[B],{});K!==V&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$ue.fromString(V)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}J.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(F,J,0),this.d.info(`${M}: Updated global state`,[...J.keys()]))}};e.$AJb=y,e.$AJb=y=ve([Q(0,v.$Nk),Q(1,C.$oi),Q(2,i.$vIb),Q(3,c.$Upb)],y);let E=class extends h.$wJb{constructor(p,O,U,F,M,x){super("globalState",U,F,M,O,p,x)}async o(p){const O=p.syncData?JSON.parse(p.syncData.content):null;if(!O){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const M of Object.keys(O.storage))M.startsWith(n)?U[M.substring(n.length)]=O.storage[M].value:this.l.get(M,0)===void 0&&(F[M]=O.storage[M].value);if(Object.keys(U).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const x of Object.keys(U))M=(0,g.edit)(M,[x],U[x],{});await this.k.writeFile(this.h.argvResource,I.$ue.fromString(M))}if(Object.keys(F).length){const M=[];for(const x of Object.keys(F))M.push({key:x,value:F[x],scope:0,target:0});this.l.storeAll(M,!0)}}};e.$BJb=E,e.$BJb=E=ve([Q(0,f.$Lp),Q(1,v.$Nk),Q(2,$.$nl),Q(3,C.$oi),Q(4,c.$Upb),Q(5,m.$ll)],E);let k=class{constructor(p,O,U,F,M){this.a=p,this.b=O,this.c=U,this.d=F,this.f=M}getSyncStoreType(p){return this.h(p)?.storage[c.$Npb]?.value}async sync(p){const O=(0,c.$Jpb)((0,P.$Dg)());try{return await this.g(p,O)}catch(U){if(U instanceof c.$Kpb)switch(U.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(p,O)}throw U}}async g(p,O){const U=await this.a.readResource("globalState",null,void 0,O),F=this.h(U)||{storage:{}};F.storage[c.$Npb]={value:p,version:r};const M=await(0,u.$Rp)(this.c,this.d,this.b),x={version:r,machineId:M,content:t(F,!1)};await this.a.writeResource("globalState",JSON.stringify(x),U.ref,void 0,O)}h({content:p}){if(!p)return null;const O=JSON.parse(p);if((0,h.$rJb)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};e.$CJb=k,e.$CJb=k=ve([Q(1,f.$Lp),Q(2,C.$oi),Q(3,v.$Nk),Q(4,w.$Nj)],k)}),define(le[117],he([0,1,17,14,3,34,5,13,174,21,16,12,19,22,28,18,39,240,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=e.$Z9b=void 0,e.$Y9b=l;function l(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$2f)(s.all)?null:s.all;switch(D.OS){case 2:return(0,R.$2f)(s.mac)?null:s.mac;case 3:return(0,R.$2f)(s.linux)?null:s.linux;case 1:return(0,R.$2f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends m.$vJb{constructor(o,n,s,t,r,a,y,E,k,S,p,O,U){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,E,k,S,s,t,y,O,r,p,a,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:g.$Wpb,authority:"base"}),this.Gb=this.Eb.with({scheme:g.$Wpb,authority:"local"}),this.Hb=this.Eb.with({scheme:g.$Wpb,authority:"remote"}),this.Ib=this.Eb.with({scheme:g.$Wpb,authority:"accepted"}),this.B(N.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?l(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,y=await this.vb(),E=await this.Cb();let k=null,S=!1,p=!1,O=!1;if(r){let M=y?y.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new g.$Kpb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==M||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const x=await(0,h.$X9b)(M,r,a,E,this.zb);x.hasChanges&&(k=x.mergeContent,O=x.hasConflicts,S=O||x.mergeContent!==M,p=O||x.mergeContent!==r)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),k=y.value.toString(),p=!0);const U={content:O?a:k,localChange:S?y?2:1:0,remoteChange:p?2:0,hasConflicts:O},F=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,h.$X9b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:y,remoteChange:E}=s[0][1];if(y===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new g.$Kpb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),E!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const k=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(k,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$un)(o.value.toString());if((0,I.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:l(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,D.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(g.$ypb)}};e.$Z9b=c,e.$Z9b=c=ve([Q(2,g.$Fpb),Q(3,g.$Gpb),Q(4,g.$Upb),Q(5,d.$Ni),Q(6,g.$Ppb),Q(7,v.$Nk),Q(8,C.$oi),Q(9,w.$Lp),Q(10,g.$Tpb),Q(11,u.$Ml),Q(12,f.$ll)],c);let $=class extends m.$wJb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$ue.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$un)(o.value.toString());return!(0,I.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return l(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$19b=$,e.$19b=$=ve([Q(0,v.$Nk),Q(1,b.$nl),Q(2,C.$oi),Q(3,g.$Upb),Q(4,w.$Lp),Q(5,f.$ll)],$)}),define(le[118],he([0,1,14,3,175,21,76,16,29,12,19,22,28,18,39,244,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=e.$39b=void 0,e.$29b=g;function h($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function g($){const i=JSON.parse($);return h(i)?i:{settings:$}}let l=class extends f.$vJb{constructor(i,o,n,s,t,r,a,y,E,k,S,p,O,U){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,S,p,y,E,k,U),this.Eb=O,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.$Wpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$Wpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$Wpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$Wpb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new D.$jo(m.$xpb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(m.$xpb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,y=await this.Pb();let E=null,k=!1,S=!1,p=!1;if(r){let M=s?s.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,b.$cIb)(M,r.settings,a?a.settings:null,y,[],t);E=x.localContent||x.remoteContent,k=x.localContent!==null,S=x.remoteContent!==null,p=x.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),E=s.value.toString().trim()||"{}",this.Qb(E),S=!0);const O=s?s.value.toString():null,U=a?.settings??null,F={content:p?U:E,localChange:k?2:0,remoteChange:S?2:0,hasConflicts:p};return[{fileContent:s,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:O,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$cIb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$bIb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$bIb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$bIb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$bIb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:y}=n[0][1];if(a===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),y!==0){const E=await this.Cb(),k=this.Lb(i),S=await this.Pb(r);r=(0,b.$bIb)(r,k?k.settings:"{}",S,E),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$dIb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$bIb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return g(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$_Hb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new m.$Kpb((0,N.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$39b=l,e.$39b=l=ve([Q(2,d.$Nk),Q(3,R.$oi),Q(4,C.$Lp),Q(5,m.$Fpb),Q(6,m.$Gpb),Q(7,m.$Upb),Q(8,m.$Tpb),Q(9,j.$Ni),Q(10,m.$Ppb),Q(11,v.$Ml),Q(12,P.$To),Q(13,w.$ll)],l);let c=class extends f.$wJb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$ue.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$dIb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return g(i)}catch(o){this.j.error(o)}return null}};e.$49b=c,e.$49b=c=ve([Q(0,d.$Nk),Q(1,u.$nl),Q(2,R.$oi),Q(3,m.$Upb),Q(4,C.$Lp),Q(5,w.$ll)],c)}),define(le[119],he([0,1,14,3,30,21,16,12,19,22,28,18,39,241,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$99b=e.$89b=void 0,e.$79b=b;function b(g){return JSON.parse(g.content)}let m=class extends w.$tJb{constructor(l,c,$,i,o,n,s,t,r,a,y,E){super({syncResource:"snippets",profile:l},c,i,$,o,n,s,a,y,t,r,E),this.pb=1,this.vb=l.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,k=>k.affects(this.vb))(()=>this.Q()))}async qb(l,c,$){const i=await this.Hb(),o=this.Gb(i),n=l.syncData?this.Fb(l.syncData):null;c=c===null&&$?l:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,u.$59b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(l){const c=l.syncData?this.Fb(l.syncData):null;if(c===null)return!0;const $=await this.Hb(),i=this.Gb($),o=(0,u.$59b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(l,c){return l.previewResult}async sb(l,c,$,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:f.$Wpb,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:f.$Wpb,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return $===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:$,localChange:$===null?l.fileContent!==null?3:0:2,remoteChange:$===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(l,c,$,i){const o=$.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(l=await this.Eb(o,l,i)),c?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(l,c,$,i){const o=new Map;for(const n of Object.keys(l.local.added)){const s={content:l.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of Object.keys(l.local.updated)){const s={content:l.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of l.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of Object.keys(l.remote.added)){const s={content:l.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of Object.keys(l.remote.updated)){const s={content:l.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of l.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of l.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:$[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Wpb,authority:"accepted"})})}return[...o.values()]}async resolveContent(l){return this.h.isEqualOrParent(l,this.g.with({scheme:f.$Wpb,authority:"remote"}))||this.h.isEqualOrParent(l,this.g.with({scheme:f.$Wpb,authority:"local"}))||this.h.isEqualOrParent(l,this.g.with({scheme:f.$Wpb,authority:"base"}))||this.h.isEqualOrParent(l,this.g.with({scheme:f.$Wpb,authority:"accepted"}))?this.db(l):null}async hasLocalData(){try{const l=await this.Hb();if(Object.keys(l).length)return!0}catch{}return!1}async Cb(l){const c={};for(const $ of l)$.fileContent&&(c[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(l,c){for(const{fileContent:$,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of l)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$ue.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$ue.fromString(i.content),c?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(l,c,$){const i=c.syncData?this.Fb(c.syncData):{},o=(0,N.$Nn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of l)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,u.$69b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),$?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(l){return b(l)}Gb(l){const c={};for(const $ of Object.keys(l))c[$]=l[$].value.toString();return c}async Hb(){const l={};let c;try{c=await this.G.resolve(this.vb)}catch($){if($ instanceof R.$9k&&$.fileOperationResult===1)return l;throw $}for(const $ of c.children||[]){const i=$.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);l[n]=s}}return l}};e.$89b=m,e.$89b=m=ve([Q(2,D.$oi),Q(3,R.$Nk),Q(4,P.$Lp),Q(5,f.$Fpb),Q(6,f.$Gpb),Q(7,f.$Upb),Q(8,j.$Ni),Q(9,f.$Ppb),Q(10,d.$Ml),Q(11,C.$ll)],m);let h=class extends w.$wJb{constructor(l,c,$,i,o,n){super("snippets",c,$,i,l,o,n)}async o(l){const c=l.syncData?JSON.parse(l.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,I.$ue.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(l)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};e.$99b=h,e.$99b=h=ve([Q(0,R.$Nk),Q(1,v.$nl),Q(2,D.$oi),Q(3,f.$Upb),Q(4,P.$Lp),Q(5,C.$ll)],h)}),define(le[120],he([0,1,14,21,16,12,19,22,28,18,39,25]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_9b=e.$$9b=void 0,e.$09b=w;function w(m,h){try{return JSON.parse(m).tasks??null}catch(g){return h.error(g),null}}let u=class extends C.$uJb{constructor(h,g,l,c,$,i,o,n,s,t,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},g,n,s,t,l,c,o,r,$,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:v.$Wpb,authority:"base"}),this.Cb=this.Ab.with({scheme:v.$Wpb,authority:"local"}),this.Db=this.Ab.with({scheme:v.$Wpb,authority:"remote"}),this.Eb=this.Ab.with({scheme:v.$Wpb,authority:"accepted"})}async qb(h,g,l,c){const $=h.syncData?w(h.syncData.content,this.O):null;g=g===null&&l?h:g;const i=g?.syncData?w(g.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(h.syncData){const E=o?o.value.toString():null;if(!i||i!==E||i!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const k=b(E,$,i);n=k.content,r=k.hasConflicts,s=k.hasLocalChanged,t=k.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},y=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:y,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const g=h?.syncData?w(h.syncData.content,this.O):null;if(g===null)return!0;const l=await this.vb(),c=l?l.value.toString():null,$=b(c,g,g);return $.hasLocalChanged||$.hasRemoteChanged}async rb(h,g){return h.previewResult}async sb(h,g,l,c){if(this.h.isEqual(g,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(g,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(g,this.Ab))return l===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(h,g,l,c){const{fileContent:$}=l[0][0],{content:i,localChange:o,remoteChange:n}=l[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),i?await this.wb(i,$,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));h=await this.mb(s,c?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}g?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$$9b=u,e.$$9b=u=ve([Q(2,v.$Fpb),Q(3,v.$Gpb),Q(4,v.$Upb),Q(5,A.$Ni),Q(6,v.$Ppb),Q(7,j.$Nk),Q(8,N.$oi),Q(9,D.$Lp),Q(10,R.$Ml),Q(11,P.$ll)],u);let f=class extends C.$wJb{constructor(h,g,l,c,$,i){super("tasks",g,l,c,h,$,i),this.c=this.g.defaultProfile.tasksResource}async o(h){const g=h.syncData?w(h.syncData.content,this.j):null;if(!g){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$ue.fromString(g)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$_9b=f,e.$_9b=f=ve([Q(0,j.$Nk),Q(1,d.$nl),Q(2,N.$oi),Q(3,v.$Upb),Q(4,D.$Lp),Q(5,P.$ll)],f);function b(m,h,g){if(m===null&&h===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(m===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=g!==m,c=g!==h;return!l&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!c?{content:m,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!l?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:m,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,16,12,19,22,28,18,39,242,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=void 0,e.$T$b=f,e.$U$b=b;let u=class extends C.$tJb{constructor(h,g,l,c,$,i,o,n,s,t,r,a,y){super({syncResource:"profiles",profile:h},g,c,$,i,o,n,r,a,s,t,y),this.vb=l,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$Wpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Wpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Wpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Wpb,authority:"accepted"}),this.B(l.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?b(h.syncData):null}async getRemoteSyncedProfiles(h){const g=await this.getLastSyncUserData(),l=await this.X(h,g);return l?.syncData?b(l.syncData):null}async qb(h,g,l){if(!this.vb.isEnabled())throw new w.$Kpb("Cannot sync profiles because they are disabled","LocalError");const c=h.syncData?b(h.syncData):null,$=g?.syncData?b(g.syncData):null,i=this.Db(),{local:o,remote:n}=(0,v.$R$b)(i,c,$,[]),s={local:o,remote:n,content:$?this.Eb($):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=f(i,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const g=h?.syncData?b(h.syncData):null,l=this.Db(),{remote:c}=(0,v.$R$b)(l,g,g,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(h,g){return{...h.previewResult,hasConflicts:!1}}async sb(h,g,l,c){if(this.h.isEqual(g,this.localResource))return this.Ab(h);if(this.h.isEqual(g,this.remoteResource))return this.Bb(h);if(this.h.isEqual(g,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async Ab(h){const g=this.Db(),l=(0,v.$R$b)(g,null,null,[]),{local:c,remote:$}=l;return{content:h.localContent,local:c,remote:$,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(h){const g=h.remoteContent?JSON.parse(h.remoteContent):null,l=[],c=[];for(const $ of this.Db()){const i=g?.find(o=>o.id===$.id);i&&(l.push({id:$.id,name:$.name,collection:i.collection}),c.push($))}if(g!==null){const $=(0,v.$R$b)(c,g,l,[]),{local:i,remote:o}=$;return{content:h.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,g,l,c){const{local:$,remote:i,localChange:o,remoteChange:n}=l[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=l[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new w.$Kpb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(f(this.Db(),!1));const t=[];for(const r of $.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of $.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of $.updated){const a=this.vb.profiles.find(y=>y.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const y=await this.J.createCollection(this.F);t.push(y),s.push({id:a.id,name:a.name,collection:y,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:y})=>a.id===y),1);for(const a of i?.updated||[]){const y=s.find(({id:E})=>a.id===E);y&&s.splice(s.indexOf(y),1,{...y,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(s,c?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of t)await this.J.deleteCollection(y,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}g?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,g){return this.mb(this.Eb(h),g)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const g=await this.db(h);return g&&(0,I.$Fn)(JSON.parse(g),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((g,l)=>g.name.localeCompare(l.name)))}};e.$S$b=u,e.$S$b=u=ve([Q(2,d.$nl),Q(3,j.$Nk),Q(4,N.$oi),Q(5,D.$Lp),Q(6,w.$Fpb),Q(7,w.$Gpb),Q(8,w.$Upb),Q(9,A.$Ni),Q(10,w.$Ppb),Q(11,R.$Ml),Q(12,P.$ll)],u);function f(m,h){const g=[...m].sort((l,c)=>l.name.localeCompare(c.name)).map(l=>({id:l.id,name:l.name}));return h?(0,I.$Fn)(g,{}):JSON.stringify(g)}function b(m){return JSON.parse(m.content)}}),define(le[259],he([0,1,3,2,5,16,19,22,25]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=void 0;const d="sync.enable";let C=class extends A.$Uc{constructor(w,u,f,b){super(),this.c=w,this.f=u,this.g=f,this.h=b,this.a=new I.$7d,this.onDidChangeEnablement=this.a.event,this.b=new I.$7d,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new A.$Tc))(m=>this.m(m)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:w}),this.c.store(d,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,P.$Opb)(w),-1,!0)}setResourceEnablement(w,u){if(this.isResourceEnabled(w)!==u){const f=(0,P.$Opb)(w);this.j(f,u)}}getResourceSyncStateVersion(w){}j(w,u){this.c.store(w,u,-1,N.$o?0:1)}m(w){if(d===w.key){this.a.fire(this.isEnabled());return}const u=P.$Bpb.filter(f=>(0,P.$Opb)(f)===w.key)[0];if(u){this.b.fire([u,this.isResourceEnabled(u)]);return}}};e.$F$b=C,e.$F$b=C=ve([Q(0,D.$Lp),Q(1,R.$Ml),Q(2,j.$oi),Q(3,P.$Epb)],C)}),define(le[260],he([0,1,6,14,65,2,20,21,16,12,18,25]),function(se,e,I,A,N,j,D,R,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;let w=class extends j.$Uc{constructor(f,b,m,h,g){super(),this.a=f,this.b=b,this.c=m,this.f=h,this.g=g,this.h()}async h(){for(const b of this.g.profiles)for(const m of v.$Bpb)try{await this.m(this.j(m,b.isDefault?void 0:b.id))}catch(h){this.f.error(h)}let f;try{f=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,d.$5k)(b)!==1&&this.f.error(b);return}if(f.children){for(const b of f.children)if(b.isDirectory&&!this.g.profiles.some(m=>m.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(m){this.f.error(m)}}}async getAllResourceRefs(f,b,m){const h=this.j(f,b,m);try{const g=await this.b.resolve(h);if(g.children)return g.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(g){if((0,d.$5k)(g)!==1)throw g}return[]}async resolveResourceContent(f,b,m,h){const g=this.j(f,m,h),l=(0,D.$Ug)(g,b);try{return(await this.b.readFile(l)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(f,b,m,h,g){const l=this.j(f,h,g),c=(0,D.$Ug)(l,`${(0,N.$Om)(m).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,A.$ue.fromString(b))}catch($){this.f.error($)}}j(f,b,m=this.a.userDataSyncHome){return(0,D.$Ug)(m,...b?[b,f]:[f])}async m(f){try{try{if(!await this.b.exists(f))return}catch{return}const b=await this.b.resolve(f);if(b.children){const m=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let g=m.filter(c=>Date.now()-this.n(c)>h);const l=m.length-g.length;l<10&&(g=g.slice(10-l)),await I.Promises.settled(g.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(b){this.f.error(b)}}n(f){return new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.$Q$b=w,e.$Q$b=w=ve([Q(0,P.$oi),Q(1,d.$Nk),Q(2,R.$Ni),Q(3,v.$Upb),Q(4,C.$nl)],w)}),define(le[83],he([0,1,3,2,5,27,179,16,12,4,24,44,19,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$upb=e.$spb=void 0,e.$tpb=$,e.$spb=(0,d.$hi)("IUserDataSyncMachinesService");const b="sync.currentMachineName",m="Safari",h="Chrome",g="Edge",l="Firefox",c="Android";function $(n){switch(n){case m:case h:case g:case l:case c:case(0,N.$h)(0):return!0}return!1}function i(){return N.$G?m:N.$E?h:N.$H?g:N.$F?l:N.$I?c:(0,N.$h)(N.$o?0:N.$u)}let o=class extends A.$Uc{static{f=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,y,E){super(),this.h=r,this.j=a,this.m=y,this.n=E,this.c=this.B(new I.$7d),this.onDidChange=this.c.event,this.g=null,this.f=(0,v.$Rp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:y})=>y!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),y=a.machines.find(({id:E})=>E===s);if(y){y.name=t,await this.t(a);const E=await this.f;s===E&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const y=t.machines.find(E=>E.id===r);y&&(y.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Ze)(r)}\\s#(\\d+)`);let y=0;for(const E of s){const k=a.exec(E.name),S=k?parseInt(k[1]):0;y=S>y?S:y}return`${r} #${y+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==f.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(f.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[f.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(f.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:f.a,machines:[]}}};e.$upb=o,e.$upb=o=f=ve([Q(0,R.$oi),Q(1,P.$Nk),Q(2,w.$Lp),Q(3,u.$Fpb),Q(4,u.$Upb),Q(5,C.$7j)],o)}),define(le[261],he([0,1,6,65,38,7,3,2,5,20,8,176,24,19,22,25,80,83]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;const g="sync.disableMachineEventually",l="sync.sessionId",c="sync.storeUrl",$="sync.productQuality";let i=class extends R.$Uc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,t,r,a,y,E,k,S,p,O){super(),this.u=t,this.w=r,this.y=a,this.z=y,this.C=E,this.D=k,this.F=S,this.G=p,this.H=O,this.a=this.B(new R.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$7d),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$fh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$Ng)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(k.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$Om)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(l,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$Kpb.toUserDataSyncError(s);t instanceof b.$Mpb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?P.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(g,!0,-1,1),await(0,I.$ih)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(g,-1,!1)}R(){this.H.remove(g,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$W$b=i,e.$W$b=i=ve([Q(0,w.$7j),Q(1,b.$Epb),Q(2,b.$Fpb),Q(3,b.$Ppb),Q(4,b.$Qpb),Q(5,b.$Upb),Q(6,m.$VHb),Q(7,f.$Ml),Q(8,h.$spb),Q(9,u.$Lp)],i);class o extends R.$Uc{static{this.a="Interval"}constructor(s,t,r,a,y,E,k,S,p){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=y,this.w=E,this.y=k,this.z=S,this.C=p,this.b=this.B(new R.$Vc),this.c=this.B(new D.$7d),this.onDidStartSync=this.c.event,this.f=this.B(new D.$7d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,I.$jh)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,I.$7g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,j.$4)(y))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$Ng)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,d.$Ng)(t.defaultUrl,s.defaultUrl)||!(0,d.$Ng)(t.insidersUrl,s.insidersUrl)||!(0,d.$Ng)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(y){if(this.y.error(y),a=y,b.$Kpb.toUserDataSyncError(y).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(E){this.y.error(E),a=E}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$Mpb((0,v.localize)(0,null),"DefaultServiceChanged"):new b.$Mpb((0,v.localize)(1,null),"ServiceChanged"):new b.$Mpb((0,v.localize)(2,null),"TurnedOff");const r=this.C.get(l,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$Mpb((0,v.localize)(3,null),"DefaultServiceChanged"):new b.$Mpb((0,v.localize)(4,null),"ServiceChanged"):new b.$Mpb((0,v.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const y=a.find(k=>k.isCurrent);if(y?.disabled)throw new b.$Mpb((0,v.localize)(6,null),"TurnedOff");const E=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-E}),this.g===null)try{this.g=await this.s.manifest(null)}catch(k){throw new b.$Mpb((0,N.$5i)(k),k instanceof b.$Kpb?k.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(l,this.g.session,-1,1),!t.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[262],he([0,1,8,180,16,12,44,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,y,E,k,S,p,O,U){this.e=t,this.f=r,this.g=a,this.h=E,this.i=k,this.j=S,this.k=p,this.l=O,this.n=U,this.d=y.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$U$b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const y=this.L(a,"profiles");return(0,c.$U$b)(y)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(E=>({...E,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:y,ref:E})=>({created:y,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:E,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:E,ref:k})=>({created:E,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:k,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(y=>y.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(y=>y.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,D.$Rp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,y,E){if(t){const{content:k}=await this.M(r,y,a);return k}return this.f.resolveResourceContent(r,y,a,E)}q(t,r,a){const y=this.L(r,t);switch(t){case"settings":return this.t(y,a);case"keybindings":return this.v(y,a);case"tasks":return this.x(y,a);case"snippets":return this.z(y,a);case"globalState":return this.E(y,a);case"extensions":return this.B(y,a);case"profiles":return this.H(y,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(y=>y.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),y=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}t(t,r){switch(r){case"settings.json":return(0,u.$29b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),y=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}v(t,r){switch(r){case"keybindings.json":return(0,f.$Y9b)(t.content,!!this.l.getValue(d.$ypb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),y=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}x(t,r){switch(r){case"tasks.json":return(0,m.$09b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const y=this.L(a,"snippets");if(y){const E=(0,w.$79b)(y),k=[];for(const S of Object.keys(E)){const p=this.d.joinPath(t,S),O=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(t,o.a);k.push({resource:p,comparableResource:O})}return k}}return[]}z(t,r){return(0,w.$79b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),y=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}B(t,r){switch(r){case"extensions.json":return(0,h.$T9b)((0,h.$S9b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(h.$V9b).getLocalExtensions(t);return(0,h.$T9b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),y=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}E(t,r){switch(r){case"globalState.json":return(0,g.$yJb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(g.$AJb).getLocalGlobalState(t);return(0,g.$yJb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),y=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:y}]}H(t,r){switch(r){case"profiles.json":return(0,$.$Fn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$T$b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$4e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(I.URI.from({scheme:d.$Wpb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==d.$Wpb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let y,E;const k=[];let S,p,O,U,F;for(;r.length;){const M=r.shift();M.startsWith("scheme:")?y=M.substring(7):M.startsWith("authority:")?E=M.substring(10):M.startsWith("syncResource:")?S=M.substring(13):M.startsWith("profile:")?p=M.substring(8):M.startsWith("collection:")?O=M.substring(11):M.startsWith("ref:")?U=M.substring(4):S?F=M:k.push(M)}return{remote:a,syncResource:S,profile:p,collection:O,ref:U,node:F,location:y&&E!==void 0?this.d.joinPath(I.URI.from({scheme:y,authority:E,query:t.query,fragment:t.fragment,path:"/"}),...k):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,v.$rJb)(a))return a}catch(a){this.g.error(a)}throw new d.$Kpb((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const y=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:y}}};e.$s_b=n,e.$s_b=n=o=ve([Q(0,d.$Fpb),Q(1,d.$Gpb),Q(2,d.$Upb),Q(3,P.$ll),Q(4,N.$oi),Q(5,R.$Lp),Q(6,j.$Nk),Q(7,C.$nl),Q(8,b.$Ni),Q(9,l.$gi)],n)}),define(le[263],he([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,p,O,U,F,M,x,J,Z,W,K){super(),this.C=S,this.D=p,this.F=O,this.G=U,this.H=F,this.I=M,this.J=x,this.L=J,this.M=Z,this.N=W,this.O=K,this.f="uninitialized",this.g=this.B(new D.$7d),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$7d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$7d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$7d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$7d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$7d),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$7d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=O.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Sc)(()=>this.bb()))}async createSyncTask(S,p){this.cb(),this.H.info("Sync started.");const O=new Date().getTime(),U=(0,C.$Dg)();try{const J=(0,s.$Jpb)(U);p&&(J["Cache-Control"]="no-cache"),S=await this.D.manifest(S,J)}catch(J){const Z=s.$Kpb.toUserDataSyncError(J);throw E(Z,U,this.F,this.I),Z}const F=!1,M=this;let x;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");x=(0,A.$7g)(J=>M.P(S,!1,U,J)),await x.finally(()=>x=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-O}ms`),M.$()},stop(){return x?.cancel(),M.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Kpb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const S=new Date().getTime(),p=(0,C.$Dg)(),O=(0,s.$Jpb)(p);let U;try{U=await this.D.manifest(null,O)}catch(x){const J=s.$Kpb.toUserDataSyncError(x);throw E(J,p,this.F,this.I),J}await this.resetLocal();const F=this,M=new N.$ee;return{id:p,async merge(){return F.P(U,!0,p,M.token)},async apply(){try{try{await F.R(U,p,M.token)}catch(x){if(s.$Kpb.toUserDataSyncError(x).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,p,M.token);else throw x}}catch(x){throw F.H.error(x),x}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.$()},async stop(){M.cancel(),await F.U(),await F.resetLocal()}}}async P(S,p,O,U){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,p,O,U));const M=F.enabled.find(x=>x.resource==="profiles");if(M){const x=await M.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(x,S,p,O,U)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(S,p,O,U,F){for(const M of S){if(F.isCancellationRequested)return;const x=this.M.profiles.find(Z=>Z.id===M.id);if(!x){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const J=this.getOrCreateActiveProfileSynchronizer(x,M);this.n.push(...await this.S(J,p,O,U,F))}for(const[M,x]of this.z.entries())this.M.profiles.some(J=>J.id===x[0].profile.id)||(x[1].dispose(),this.z.delete(M))}async R(S,p,O){const U=this.ab();for(const Z of U){if(O.isCancellationRequested)return;await Z.apply(p,O)}const F=U.find(Z=>Z.profile.isDefault);if(!F)return;const M=F.enabled.find(Z=>Z.resource==="profiles");if(!M)return;const J=(await M.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(Z=>U.every(W=>W.profile.id!==Z.id));J.length&&await this.Q(J,S,!1,p,O)}async S(S,p,O,U,F){return(await S.sync(p,O,U,F)).map(([x,J])=>({profile:S.profile,syncResource:x,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(S=>S.stop()))}async resolveContent(S){const p=await this.N.resolveContent(S);if(p)return p;for(const O of this.ab())for(const U of O.enabled){const F=await U.resolveContent(S);if(F)return F}return null}async replace(S){this.cb();const p=this.N.resolveUserDataSyncResource(S);if(!p)return;const O=await this.resolveContent(S.uri);O&&await this.W(p.profile,async U=>{if(p.syncResource===U.resource)return await U.replace(O),!0})}async accept(S,p,O,U){this.cb(),await this.W(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(p,O),U&&await F.apply((0,d.$1f)(U)?!1:U.force,(0,s.$Jpb)((0,C.$Dg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async p=>{if(p.resource!=="globalState"&&await p.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async p=>{if(await p.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[S]of this.z.values())try{await S.resetLocal()}catch(p){this.H.error(p)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),p=S.map(M=>M.collection),O=await this.D.getAllCollections(),U=O.filter(M=>!p.includes(M));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const F=S.filter(M=>O.includes(M.collection));if(F.length!==S.length){const M=this.G.createInstance(n.$S$b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(S){this.cb();const p=await this.D.getActivityData();await this.C.writeFile(S,p)}async extractActivityData(S,p){const O=(await this.C.readFile(S)).value.toString(),U=JSON.parse(O);if(U.resources)for(const F in U.resources)for(const M of U.resources[F])await this.O.writeResource(F,M.content,new Date(M.created*1e3),void 0,p);if(U.collections)for(const F in U.collections)for(const M in U.collections[F].resources)for(const x of U.collections[F].resources?.[M]??[])await this.O.writeResource(M,x.content,new Date(x.created*1e3),F,p)}async W(S,p){const O=new R.$Tc;try{const U=this.z.get(S.id);if(U){const Z=await this.X(U[0],p,O);return(0,d.$2f)(Z)?null:Z}if(S.isDefault){const Z=O.add(this.G.createInstance(a,S,void 0)),W=await this.X(Z,p,O);return(0,d.$2f)(W)?null:W}if(this.M.isEnabled())return null;const F=O.add(this.G.createInstance(n.$S$b,S,void 0)),M=await this.D.manifest(null),J=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(Z=>Z.id===S.id);if(J){const Z=O.add(this.G.createInstance(a,S,J.collection)),W=await this.X(Z,p,O);return(0,d.$2f)(W)?null:W}return null}finally{O.dispose()}}async X(S,p,O){const U=[...S.enabled,...S.disabled.reduce((F,M)=>(M!=="workspaceState"&&F.push(O.add(S.createSynchronizer(M))),F),[])];for(const F of U){const M=await p(F);if(!(0,d.$2f)(M))return M}}Y(S){const p=this.f;this.f!==S&&(this.f=S,this.g.fire(S),p==="hasConflicts"&&this.$())}Z(){const S=this.ab().map(p=>p.conflicts).flat();(0,I.$ub)(this.j,S,(p,O)=>p.profile.id===O.profile.id&&p.syncResource===O.syncResource&&(0,I.$ub)(p.conflicts,O.conflicts,(U,F)=>(0,P.$Ng)(U.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,p){let O=this.z.get(S.id);if(O&&O[0].collection!==p?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.z.delete(S.id)),!O){const U=new R.$Tc,F=U.add(this.G.createInstance(a,S,p?.collection));U.add(F.onDidChangeStatus(M=>this.Y(M))),U.add(F.onDidChangeConflicts(M=>this.Z())),U.add(F.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(S.id,O=[F,U])}return O[0]}ab(){const S=[];for(const[p]of this.z.values())S.push(p);return S}bb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$V$b=r,e.$V$b=r=ve([Q(0,u.$Nk),Q(1,s.$Fpb),Q(2,s.$Epb),Q(3,f.$gi),Q(4,s.$Upb),Q(5,m.$Ml),Q(6,b.$Lp),Q(7,s.$Ppb),Q(8,h.$nl),Q(9,s.$Rpb),Q(10,s.$Gpb)],r);let a=class extends R.$Uc{get enabled(){return this.f.sort((S,p)=>S[1]-p[1]).map(([S])=>S)}get disabled(){return s.$Bpb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,p,O,U,F,M,x,J,Z,W){super(),this.profile=S,this.collection=p,this.r=O,this.t=U,this.u=F,this.w=M,this.y=x,this.z=J,this.C=Z,this.D=W,this.f=[],this.g="idle",this.h=this.B(new D.$7d),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$7d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$7d),this.onDidChangeConflicts=this.n.event,this.B(O.onDidChangeResourceEnablement(([K,V])=>this.F(K,V))),this.B((0,R.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of s.$Bpb)O.isResourceEnabled(K)&&this.G(K)}F(S,p){p?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||S==="workspaceState")return;if(S!=="profiles"&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const p=new R.$Tc,O=p.add(this.createSynchronizer(S));p.add(O.onDidChangeStatus(()=>this.L())),p.add(O.onDidChangeConflicts(()=>this.M())),p.add(O.onDidChangeLocal(()=>this.j.fire(S)));const U=this.N(S);this.f.push([O,U,p])}H(S){const p=this.f.findIndex(([O])=>O.resource===S);if(p!==-1){const[[O,,U]]=this.f.splice(p,1);U.dispose(),this.L(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case"settings":return this.t.createInstance($.$39b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$Z9b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$89b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$$9b,this.profile,this.collection);case"globalState":return this.t.createInstance(l.$zJb,this.profile,this.collection);case"extensions":return this.t.createInstance(g.$U9b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$S$b,this.profile,this.collection)}}async sync(S,p,O,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],x=(0,s.$Jpb)(O),J=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,Z=p?await this.I(J):{};for(const W of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(p){const K=await W.preview(J,Z,x);if(K)for(const V of K.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await W.merge(V.previewResource)}else await W.sync(J,x)}catch(K){const V=s.$Kpb.toUserDataSyncError(K);if(E(V,O,this.w,this.y),y(K))throw V;this.z.error(K),this.z.error(`${W.resource}: ${(0,j.$5i)(K)}`),M.push([W.resource,V])}}return M}finally{this.L()}}async apply(S,p){const O=(0,s.$Jpb)(S);for(const U of this.enabled){if(p.isCancellationRequested)return;try{await U.apply(!1,O)}catch(F){const M=s.$Kpb.toUserDataSyncError(F);if(E(M,S,this.w,this.y),y(F))throw M;this.z.error(F),this.z.error(`${U.resource}: ${(0,j.$5i)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(p){this.z.error(p)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(p){this.z.error(`${S.resource}: ${(0,j.$5i)(p)}`),this.z.error(p)}}async I(S){if(!this.profile.isDefault)return{};const p=this.D.getValue(s.$xpb),O=this.enabled.find(U=>U instanceof $.$39b);if(O){const U=await O.getRemoteUserDataSyncConfiguration(S);return{...p,...U}}return p}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const S=this.enabled.filter(p=>p.status==="hasConflicts").filter(p=>p.conflicts.conflicts.length>0).map(p=>p.conflicts);(0,I.$ub)(this.m,S,(p,O)=>p.syncResource===O.syncResource&&(0,I.$ub)(p.conflicts,O.conflicts,(U,F)=>(0,P.$Ng)(U.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ve([Q(2,s.$Ppb),Q(3,f.$gi),Q(4,w.$Qo),Q(5,s.$Epb),Q(6,m.$Ml),Q(7,s.$Upb),Q(8,h.$nl),Q(9,v.$Ni)],a);function y(k){if(k instanceof s.$Kpb)switch(k.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function E(k,S,p,O){O.publicLog2("sync/error",{code:k.code,serverCode:k instanceof s.$Lpb?String(k.serverCode):void 0,url:k instanceof s.$Lpb?k.url:void 0,resource:k.resource,executionId:S,service:p.userDataSyncStore.url.toString()})}}),define(le[264],he([0,1,3,2,8,18,25]),function(se,e,I,A,N,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;function R(w,u){return{...w,profile:(0,j.$ol)(w.profile,u.profilesHome.scheme)}}function P(w){return{created:w.created,uri:N.URI.revive(w.uri)}}class d{constructor(u,f,b){this.c=u,this.d=f,this.f=b,this.a=new Map,this.b=new I.$7d}listen(u,f){switch(f){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${f}`)}async call(u,f,b){try{return await this.g(u,f,b)}catch(m){throw this.f.error(m),m}}async g(u,f,b){switch(f){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(b[0]));case"accept":return this.c.accept(R(b[0],this.d),N.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(P(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(b[0]),N.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(f.startsWith("manualSync/")){const m=f.substring(11),h=b[0],g=this.h(h);switch(b=b.slice(1),m){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.a.delete(this.j(g.id)));case"stop":return g.stop().finally(()=>this.a.delete(this.j(g.id)))}}throw new Error("Invalid call")}h(u){const f=this.a.get(this.j(u));if(!f)throw new Error(`Manual sync taks not found: ${u}`);return f}async i(){const u=await this.c.createManualSyncTask();return this.a.set(this.j(u.id),u),u.id}j(u){return`manualSyncTask-${u}`}}e.$dcc=d;let C=class extends A.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(u,f){super(),this.n=f,this.b="uninitialized",this.c=this.B(new I.$7d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$7d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$7d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$7d),this.onSyncErrors=this.m.event,this.a={call(b,m,h){return u.call(b,m,h).then(null,g=>{throw D.$Kpb.toUserDataSyncError(g)})},listen(b,m){return u.listen(b,m)}},this.a.call("_getInitialData").then(([b,m,h])=>{this.s(b),this.t(m),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(g=>this.s(g))),this.B(this.a.listen("onDidChangeLastSyncTime")(g=>this.u(g)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(m=>({...m,error:D.$Kpb.toUserDataSyncError(m.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const u=await this.a.call("createManualSyncTask"),f=this;return new v(u,{async call(m,h,g){return f.a.call(`manualSync/${m}`,[u,...Array.isArray(h)?h:[h]],g)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(u,f,b,m){return this.a.call("accept",[u,f,b,m])}resolveContent(u){return this.a.call("resolveContent",[u])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(u){return this.a.call("replace",[u])}saveRemoteActivityData(u){return this.a.call("getRemoteActivityData",[u])}extractActivityData(u,f){return this.a.call("extractActivityData",[u,f])}async s(u){this.b=u,this.c.fire(u)}async t(u){this.f=u.map(f=>({syncResource:f.syncResource,profile:(0,j.$ol)(f.profile,this.n.profilesHome.scheme),conflicts:f.conflicts.map(b=>({...b,baseResource:N.URI.revive(b.baseResource),localResource:N.URI.revive(b.localResource),remoteResource:N.URI.revive(b.remoteResource),previewResource:N.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(u){this.h!==u&&(this.h=u,this.j.fire(u))}};e.$ecc=C,e.$ecc=C=ve([Q(1,j.$nl)],C);class v extends A.$Uc{constructor(u,f){super(),this.id=u,this.a=f}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,44,19,25]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJb=e.$oJb=e.$nJb=e.$mJb=e.$lJb=void 0;const $="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends D.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$Npb,-1)}set c(O){this.h.store(c.$Npb,O,-1,P.$o?0:1)}constructor(O,U,F){super(),this.f=O,this.g=U,this.h=F,this.a=this.B(new j.$7d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new D.$Tc);this.B(j.Event.filter(F.onDidChangeValue(-1,c.$Npb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(O){if(O&&(O=P.$o&&O.web?{...O,...O.web}:O,(0,C.$Uf)(O.url)&&(0,C.$Wf)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every(U=>Array.isArray(O.authenticationProviders[U].scopes)))){const U=O,F=!!U.canSwitch,M=U.url===U.insidersUrl?"insiders":"stable",x=(F?this.c:void 0)||M,J=x==="insiders"?U.insidersUrl:x==="stable"?U.stableUrl:U.url;return{url:v.URI.parse(J),type:x,defaultType:M,defaultUrl:v.URI.parse(U.url),stableUrl:v.URI.parse(U.stableUrl),insidersUrl:v.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((Z,W)=>(Z.push({id:W,scopes:U.authenticationProviders[W].scopes}),Z),[])}}}};e.$lJb=a,e.$lJb=a=ve([Q(0,m.$7j),Q(1,u.$Ni),Q(2,l.$Lp)],a);let y=class extends a{constructor(O,U,F){super(O,U,F);const M=this.h.get(i,-1);M&&(this.n=JSON.parse(M));const x=this.f[$];x?this.h.store(i,JSON.stringify(x),-1,1):this.h.remove(i,-1)}async switch(O){O!==this.c&&(this.c=O,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$mJb=y,e.$mJb=y=ve([Q(0,m.$7j),Q(1,u.$Ni),Q(2,l.$Lp)],y);let E=class extends D.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(O,U,F,M,x,J,Z){super(),this.n=F,this.r=M,this.s=Z,this.g=this.B(new j.$7d),this.onTokenFailed=this.g.event,this.h=this.B(new j.$7d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$7d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(O),this.c=(0,g.$Rp)(x,J,Z).then(W=>{const K={"X-Client-Name":`${U.applicationName}${P.$o?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(K["X-Client-Commit"]=U.commit),K}),this.f=new S(t,r,this.n,this.r),this.u(),this.B((0,D.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(O,U){this.b={token:O,type:U}}t(O){this.a=O?(0,d.$Ug)(O,"v1"):void 0}u(){const O=this.s.getNumber(o,-1);O&&Date.now()<O&&this.y(new Date(O))}y(O){this.j?.getTime()!==O?.getTime()&&(this.j=O,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,I.$7g)(U=>(0,I.$ih)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,d.$Ug)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:O},[],A.CancellationToken.None);return(await(0,h.$Ep)(F))?.map(({id:M})=>M)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,d.$Ug)(this.a,"collection").toString();O={...O},O["Content-Type"]=R.$ys.text;const F=await this.D(U,{type:"POST",headers:O},[],A.CancellationToken.None),M=await(0,h.$Dp)(F);if(!M)throw new c.$Lpb("Server did not return the collection id",U,"NoCollection",F.res.statusCode,F.res.headers[c.$Hpb]);return M}async deleteCollection(O,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=O?(0,d.$Ug)(this.a,"collection",O).toString():(0,d.$Ug)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],A.CancellationToken.None)}async getAllResourceRefs(O,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,O),M={},x=await this.D(F.toString(),{type:"GET",headers:M},[],A.CancellationToken.None);return(await(0,h.$Ep)(x)||[]).map(({url:Z,created:W})=>({ref:(0,d.$Wg)(F,F.with({path:Z})),created:W*1e3}))}async resolveResourceContent(O,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const x=(0,d.$Ug)(this.z(this.a,F,O),U).toString();M={...M},M["Cache-Control"]="no-cache";const J=await this.D(x,{type:"GET",headers:M},[],A.CancellationToken.None);return await(0,h.$Dp)(J)}async deleteResource(O,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=U!==null?(0,d.$Ug)(this.z(this.a,F,O),U).toString():this.z(this.a,F,O).toString(),x={};await this.D(M,{type:"DELETE",headers:x},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,d.$Ug)(this.a,"resource").toString(),U={"Content-Type":R.$ys.text};await this.D(O,{type:"DELETE",headers:U},[],A.CancellationToken.None)}async readResource(O,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const x=(0,d.$Ug)(this.z(this.a,F,O),"latest").toString();M={...M},M["Cache-Control"]="no-cache",U&&(M["If-None-Match"]=U.ref);const J=await this.D(x,{type:"GET",headers:M},[304],A.CancellationToken.None);let Z=null;if(J.res.statusCode===304&&(Z=U),Z===null){const W=J.res.headers.etag;if(!W)throw new c.$Lpb("Server did not return the ref",x,"NoRef",J.res.statusCode,J.res.headers[c.$Hpb]);const K=await(0,h.$Dp)(J);if(!K&&J.res.statusCode===304)throw new c.$Lpb("Empty response",x,"EmptyResponse",J.res.statusCode,J.res.headers[c.$Hpb]);Z={ref:W,content:K}}return Z}async writeResource(O,U,F,M,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,M,O).toString();x={...x},x["Content-Type"]=R.$ys.text,F&&(x["If-Match"]=F);const Z=await this.D(J,{type:"POST",data:U,headers:x},[],A.CancellationToken.None),W=Z.res.headers.etag;if(!W)throw new c.$Lpb("Server did not return the ref",J,"NoRef",Z.res.statusCode,Z.res.headers[c.$Hpb]);return W}async manifest(O,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,d.$Ug)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",O&&(U["If-None-Match"]=O.ref);const M=await this.D(F,{type:"GET",headers:U},[304],A.CancellationToken.None);let x=null;if(M.res.statusCode===304&&(x=O),!x){const Z=M.res.headers.etag;if(!Z)throw new c.$Lpb("Server did not return the ref",F,"NoRef",M.res.statusCode,M.res.headers[c.$Hpb]);const W=await(0,h.$Dp)(M);if(!W&&M.res.statusCode===304)throw new c.$Lpb("Empty response",F,"EmptyResponse",M.res.statusCode,M.res.headers[c.$Hpb]);W&&(x={...JSON.parse(W),ref:Z})}const J=this.s.get(n,-1);return J&&x&&J!==x.session&&this.C(),x===null&&J&&this.C(),x&&this.s.store(n,x.session,-1,1),x}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,d.$Ug)(this.a,"download").toString(),U={},F=await this.D(O,{type:"GET",headers:U},[],A.CancellationToken.None);if(!(0,h.$Ap)(F))throw new c.$Lpb("Server returned "+F.res.statusCode,O,"EmptyResponse",F.res.statusCode,F.res.headers[c.$Hpb]);if((0,h.$Bp)(F))throw new c.$Lpb("Empty response",O,"EmptyResponse",F.res.statusCode,F.res.headers[c.$Hpb]);return F.stream}z(O,U,F){return U?(0,d.$Ug)(O,"collection",U,"resource",F):(0,d.$Ug)(O,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(O,U,F,M){if(!this.b)throw new c.$Lpb("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$Lpb(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const x=await this.c;U.headers={...U.headers||{},...x,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:O,type:U.type,headers:{...U.headers,authorization:void 0}});let J;try{J=await this.f.request(O,U,M)}catch(B){if(!(B instanceof c.$Lpb)){let ie="RequestFailed";const oe=(0,N.$0)(B).toLowerCase();oe.includes("xhr timeout")?ie="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?ie="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":oe.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,N.$4)(B)&&(ie="RequestCanceled"),B=new c.$Lpb(`Connection refused for the request '${O}'.`,O,ie,void 0,void 0)}throw this.r.info("Request failed",O),B}const Z=J.res.headers[c.$Hpb],W={url:O,status:J.res.statusCode,"execution-id":U.headers[c.$Ipb],"operation-id":Z},K=(0,h.$Ap)(J)||J.res.statusCode&&F.includes(J.res.statusCode);let V="";if(K?this.r.trace("Request succeeded",W):(V=await(0,h.$Cp)(J)||"",this.r.info("Request failed",W,V)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$Lpb(`${U.type} request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",J.res.statusCode,Z);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$Lpb(`${U.type} request '${O}' failed because the access is forbidden (403).`,O,"Forbidden",J.res.statusCode,Z)}if(this.h.fire(),J.res.statusCode===404)throw new c.$Lpb(`${U.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",J.res.statusCode,Z);if(J.res.statusCode===405)throw new c.$Lpb(`${U.type} request '${O}' failed because the requested endpoint is not found (405). ${V}`,O,"MethodNotFound",J.res.statusCode,Z);if(J.res.statusCode===409)throw new c.$Lpb(`${U.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",J.res.statusCode,Z);if(J.res.statusCode===410)throw new c.$Lpb(`${U.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",J.res.statusCode,Z);if(J.res.statusCode===412)throw new c.$Lpb(`${U.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",J.res.statusCode,Z);if(J.res.statusCode===413)throw new c.$Lpb(`${U.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",J.res.statusCode,Z);if(J.res.statusCode===426)throw new c.$Lpb(`${U.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",J.res.statusCode,Z);if(J.res.statusCode===429){const B=J.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new c.$Lpb(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",J.res.statusCode,Z)):new c.$Lpb(`${U.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",J.res.statusCode,Z)}if(!K)throw new c.$Lpb("Server returned "+J.res.statusCode,O,"Unknown",J.res.statusCode,Z);return J}F(O){let U=this.s.get(s,-1);U===void 0&&(U=(0,w.$Dg)(),this.s.store(s,U,-1,1)),O["X-Machine-Session-Id"]=U;const F=this.s.get(n,-1);F!==void 0&&(O["X-User-Session-Id"]=F)}};e.$nJb=E,e.$nJb=E=ve([Q(1,m.$7j),Q(2,h.$yp),Q(3,c.$Upb),Q(4,f.$oi),Q(5,b.$Nk),Q(6,l.$Lp)],E);let k=class extends E{constructor(O,U,F,M,x,J,Z){super(O.userDataSyncStore?.url,U,F,M,x,J,Z),this.B(O.onDidChangeUserDataSyncStore(()=>this.t(O.userDataSyncStore?.url)))}};e.$oJb=k,e.$oJb=k=ve([Q(0,c.$Epb),Q(1,m.$7j),Q(2,h.$yp),Q(3,c.$Upb),Q(4,f.$oi),Q(5,b.$Nk),Q(6,l.$Lp)],k);class S{constructor(O,U,F,M){this.c=O,this.d=U,this.f=F,this.g=M,this.a=[],this.b=void 0}request(O,U,F){if(this.h()&&this.i(),U.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$Lpb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$pJb=S}),define(le[265],he([0,1,3,2,8,21,24,19,122]),function(se,e,I,A,N,j,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=void 0;class d{constructor(f){this.a=f}listen(f,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(f,b,m){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(m)}throw new Error("Invalid call")}}e.$_bc=d;class C extends A.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(f){super(),this.c=f,this.b=this.B(new I.$7d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(m=>{this.a=m,this.b.fire(m)}))})}updateAccount(f){return this.c.call("updateAccount",f)}}e.$acc=C;class v{constructor(f){this.a=f}listen(f,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(f,b,m){switch(b){case"switch":return this.a.switch(m[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$bcc=v;let w=class extends P.$lJb{constructor(f,b,m,h){super(b,m,h),this.n=f,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(f){return this.n.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.n.call("getPreviousUserDataSyncStore");return this.r(f)}r(f){return{url:N.URI.revive(f.url),type:f.type,defaultUrl:N.URI.revive(f.defaultUrl),insidersUrl:N.URI.revive(f.insidersUrl),stableUrl:N.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}};e.$ccc=w,e.$ccc=w=ve([Q(1,D.$7j),Q(2,j.$Ni),Q(3,R.$Lp)],w)}),define(le[266],he([0,1,3,57,24,19,22,261,25,80,83]),function(se,e,I,A,N,j,D,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;let v=class extends R.$W$b{constructor(u,f,b,m,h,g,l,c,$,i,o){super(u,f,b,m,h,l,c,$,i,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(g.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(g.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$ycc=v,e.$ycc=v=ve([Q(0,N.$7j),Q(1,P.$Epb),Q(2,P.$Fpb),Q(3,P.$Ppb),Q(4,P.$Qpb),Q(5,A.$pac),Q(6,P.$Upb),Q(7,d.$VHb),Q(8,D.$Ml),Q(9,C.$spb),Q(10,j.$Lp)],v)}),define(le[267],he([0,1,73,23,5,20]),function(se,e,I,A,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0,e.$Q_b=D,e.$R_b=R,e.$S_b=P,e.$P_b=128/4;function D(d){function C(){let v=d.scheme===A.Schemas.file?(0,j.$Ig)(d):d.toString();return N.$k||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:C(),configPath:d}}function R(d,C){function v(){if(d.scheme!==A.Schemas.file)return(0,I.createHash)("md5").update(d.toString()).digest("hex");if(!C)return;let u;return N.$k?u=C.ino:N.$j?u=C.birthtime.getTime():N.$i&&(typeof C.birthtimeMs=="number"?u=Math.floor(C.birthtimeMs):u=C.birthtime.getTime()),(0,I.createHash)("md5").update(d.fsPath).update(u?String(u):"").digest("hex")}const w=v();if(typeof w=="string")return{id:w,uri:d}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[268],he([0,1,6,7,2,15,31,16,9,77,112,267,57,56,23]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;let b=class extends N.$Uc{constructor(h,g,l,c){super(),this.a=h,this.b=g,this.c=l,this.f=c,this.B(new I.$th(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:f.Schemas.file}).fsPath,g=await D.Promises.readdir(h),l=new d.$uIb(this.f.getChannel("storage"));await Promise.all(g.map(async c=>{const $=(0,j.$kc)(h,c);c.length===v.$P_b||c===C.$ti.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await l.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await D.Promises.rm($))}))}catch(h){(0,A.$1)(h)}}};e.$8bc=b,e.$8bc=b=ve([Q(0,R.$pi),Q(1,P.$Nj),Q(2,w.$pac),Q(3,u.$Ebc)],b)}),define(le[123],he([0,1,73,64,37,278,14,7,3,2,15,5,32,40,68]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$$h=e.$0h=e.$9h=void 0,e.$_h=n,e.$ai=s,e.$ci=a,e.$di=y;class b{traceSocketEvent(k,S){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,S)}constructor(k,S=""){this.f=!0,this.debugLabel=S,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,R.$1)(p)}},this.socket.on("error",this.a),this.b=p=>{this.traceSocketEvent("close",{hadError:p}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const S=p=>{this.traceSocketEvent("read",p),k(D.$ue.wrap(p))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(k){const S=p=>{k({type:0,hadError:p,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(k){const S=()=>{k()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,R.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,R.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.$9h=b;var m;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var h;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(h||(h={}));class g extends d.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,S){this.socket.traceSocketEvent(k,S)}constructor(k,S,p,O){super(),this.f=this.B(new P.$7d),this.g=this.B(new P.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:p?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new l(this,S,p,O,this.f,(U,F)=>this.m(U,F))),this.B(this.a.onError(U=>{console.error(U),(0,R.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new f.$4h,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let S=0;for(;S<k.byteLength;)this.a.writeMessage(k.slice(S,Math.min(S+262144,k.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(k,{compressed:S,opcode:p}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let O=2;k.byteLength<126?O+=0:k.byteLength<2**16?O+=2:O+=8;const U=D.$ue.alloc(O),F=S?64:0,M=p&15;if(U.writeUInt8(128|F|M,0),k.byteLength<126)U.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){U.writeUInt8(126,1);let x=1;U.writeUInt8(k.byteLength>>>8&255,++x),U.writeUInt8(k.byteLength>>>0&255,++x)}else{U.writeUInt8(127,1);let x=1;U.writeUInt8(0,++x),U.writeUInt8(0,++x),U.writeUInt8(0,++x),U.writeUInt8(0,++x),U.writeUInt8(k.byteLength>>>24&255,++x),U.writeUInt8(k.byteLength>>>16&255,++x),U.writeUInt8(k.byteLength>>>8&255,++x),U.writeUInt8(k.byteLength>>>0&255,++x)}this.socket.write(D.$ue.concat([U,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),p=S.readUInt8(0),O=(p&128)>>>7,U=(p&64)>>>6,F=p&15,M=S.readUInt8(1),x=(M&128)>>>7,J=M&127;this.j.state=2,this.j.readLen=2+(x?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),p=S.readUInt8(1),O=(p&128)>>>7;let U=p&127,F=1;U===126?U=S.readUInt8(++F)*2**8+S.readUInt8(++F):U===127&&(U=S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F));let M=0;O&&(M=S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F)),this.j.state=3,this.j.readLen=U,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),i(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$0h=g;class l extends d.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ue.alloc(0)}constructor(k,S,p,O,U,F){super(),this.n=k,this.r=U,this.s=F,this.a=this.B(new P.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new c(this.n,O,p,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(k,S){this.g.push({data:k,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:S}=this.g.shift();if(this.f&&S.compressed){const p=await this.w(this.f,k);this.s(p,S)}else this.s(k,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,S){return new Promise((p,O)=>{k.write(S),k.flush(U=>p(U))})}acceptFrame(k,S,p){this.h.push({data:k,isCompressed:S,isLastFrameOfMessage:p}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const S=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,S,p){return new Promise((O,U)=>{k.write(S),p&&k.write(D.$ue.fromByteArray([0,0,255,255])),k.flush(F=>O(F))})}}class c extends d.$Uc{get recordedInflateBytes(){return this.j?D.$ue.concat(this.f):D.$ue.alloc(0)}constructor(k,S,p,O){super(),this.h=k,this.j=S,this.a=this.B(new P.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(O),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(D.$ue.wrap(U))}),p&&(this.h.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this.b.write(p.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=D.$ue.concat(this.g);this.g.length=0,k(S)})}}class $ extends d.$Uc{constructor(k,S){super(),this.g=k,this.a=this.B(new P.$7d),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",p=>{this.g.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.g.traceSocketEvent("zlibDeflateData",p),this.f.push(D.$ue.wrap(p))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=D.$ue.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),k(S)})}}function i(E,k){if(k===0)return;const S=E.byteLength>>>2;for(let x=0;x<S;x++){const J=E.readUInt32BE(x*4);E.writeUInt32BE(J^k,x*4)}const p=S*4,O=E.byteLength-p,U=k>>>24&255,F=k>>>16&255,M=k>>>8&255;O>=1&&E.writeUInt8(E.readUInt8(p)^U,p),O>=2&&E.writeUInt8(E.readUInt8(p+1)^F,p+1),O>=3&&E.writeUInt8(E.readUInt8(p+2)^M,p+2)}e.$$h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const E=(0,w.$Dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const k=process.platform!=="darwin"&&e.$$h?e.$$h:(0,N.tmpdir)(),S=(0,C.$kc)(k,`vscode-ipc-${E}.sock`);return t(S),S}function s(E,k,S){const O=(0,I.createHash)("sha256").update(E).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${S}-${k}-sock`;const U=S.substr(0,4),F=k.substr(0,6);let M;return process.platform!=="darwin"&&e.$$h&&!process.env.VSCODE_PORTABLE?M=(0,C.$kc)(e.$$h,`vscode-${O}-${U}-${F}.sock`):M=(0,C.$kc)(E,`${U}-${F}.sock`),t(M),M}function t(E){const k=o[v.$u];typeof k=="number"&&E.length>=k&&console.warn(`WARNING: IPC handle "${E}" is longer than ${k} chars, try a shorter --user-data-dir`)}class r extends u.$Xh{static b(k){const S=P.Event.fromNodeEventEmitter(k,"connection");return P.Event.map(S,p=>({protocol:new f.$5h(new b(p,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(p,"close"))}))}constructor(k){super(r.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$bi=r;function a(E){return new Promise((k,S)=>{const p=(0,A.createServer)();p.on("error",S),p.listen(E,()=>{p.removeListener("error",S),k(new r(p))})})}function y(E,k){return new Promise((S,p)=>{const O=(0,A.createConnection)(E,()=>{O.removeListener("error",p),S(f.$6h.fromSocket(new b(O,`ipc-client${k}`),k))});O.once("error",p)})}}),define(le[269],he([0,1,64,123,216]),function(se,e,I,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0,e.$Bcc=new class{supports(j){return!0}connect({host:j,port:D},R,P,d){return new Promise((C,v)=>{const w=I.createConnection({host:j,port:D},()=>{w.removeListener("error",v),w.write((0,N.$Ytb)(R,P,d));const u=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",u),C(new A.$9h(w,d)))};w.on("data",u)});w.setNoDelay(!0),w.once("error",v)})}}}),define(le[270],he([0,1,64,37,133,123,6,2,5,21,9,24,218,104,106,78,14]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=e.$xbc=e.$wbc=e.$vbc=void 0;async function h(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new g(i,o,n,s,t).waitForReady(),!(t&&N.$Gg[t]||!N.$Gg[r.tunnelLocalPort]));a--);return r}class g extends R.$Uc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=I.createServer(),this.c=new D.$gh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$4v)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,N.$Hg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$2v)(this.tunnelRemoteHost)||(0,b.$4v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Dl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$9h?t.socket.destroy():t.end()}),t instanceof j.$9h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(m.$ue.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$vbc=g;let l=class extends b.$7v{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$5v)(o,this.m,P.OS,A.release())}t(o,n,s,t,r,a,y,E){const k=this.s(n,s);if(k)return++k.refcount,k.value;if((0,b.$Xv)(o))return this.u(o,n,s,r,a,y,E);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},p=h(S,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,p),p}}};e.$wbc=l,e.$wbc=l=ve([Q(0,u.$xl),Q(1,C.$Nj),Q(2,f.$Al),Q(3,v.$7j),Q(4,d.$Ni)],l);let c=class extends l{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$xbc=c,e.$xbc=c=ve([Q(0,u.$xl),Q(1,C.$Nj),Q(2,f.$Al),Q(3,v.$7j),Q(4,d.$Ni)],c);let $=class extends R.$Uc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,y,E,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const S=new c(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(o,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,y,E,k)}};e.$ybc=$,e.$ybc=$=ve([Q(0,u.$xl),Q(1,C.$Nj),Q(2,v.$7j),Q(3,f.$Al),Q(4,d.$Ni)],$)}),define(le[279],he([0,1,37,38,7,2,23,8,17,3,40,149,210,211,201,202,268,191,193,21,215,94,226,95,221,16,114,252,29,98,192,113,96,12,204,205,72,4,200,74,75,232,9,206,101,24,59,19,107,22,108,109,110,48,235,82,111,25,80,260,265,245,83,259,263,264,122,60,258,246,106,225,78,270,220,236,28,237,5,238,194,213,212,81,251,18,52,209,58,257,234,247,105,262,253,10,207,100,255,250,222,188,57,208,266,254,56,256,104,269,185,223,145,140]),function(se,e,I,A,N,j,D,R,P,d,C,v,w,u,f,b,m,h,g,l,c,$,i,o,n,s,t,r,a,y,E,k,S,p,O,U,F,M,x,J,Z,W,K,V,B,ie,oe,te,ce,H,q,L,T,z,Y,G,ee,_,X,ne,re,ue,de,$e,ye,Se,Ie,Le,fe,me,we,Ce,Re,Ue,De,qe,Te,Me,ze,je,ae,ge,be,pe,Ee,Pe,Oe,Ae,We,Be,Fe,Ke,Ge,_e,tt,Et,St,gt,kt,Pt,Ct,Rt,It,Ot,Dt,Lt,$t,Nt,mt,jt,At,st,Ut,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class Ft extends j.$Uc{constructor(ke){super(),this.f=ke,this.a=this.B(new v.$aW(this)),this.b=void 0,this.c=this.B(new d.$7d),this.g()}g(){let ke=!1;const Ne=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,v.$bW)(process.parentPort,st.$Kac.exit,Ne)}async init(){const ke=await this.h();(0,_.$zpb)(),ke.invokeFunction(Ne=>{const He=Ne.get(K.$Nj),Ve=Ne.get(H.$Ml),Ze=Ne.get(Pe.$nl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ne),this.m(He),this.n(Ve,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(Ve,Ze))),this.r(Ve,He)}),this.B((0,j.$Rc)(ke.createInstance(w.$4bc,this.f.codeCachePath),ke.createInstance(u.$5bc),ke.createInstance(m.$8bc),ke.createInstance(b.$7bc),ke.createInstance(f.$6bc),ke.createInstance(tt.$scc),ke.createInstance(Ke.$kcc)))}async h(){const ke=new J.$fi,Ne={_serviceBrand:void 0,...B.default};ke.set(ie.$7j,Ne);const He=new C.$2h(Je=>Je==="main"),Ve=new $t.$Fbc(this.a,He);ke.set($t.$Ebc,Ve);const Ze=this.f.policiesData?new Ae.$bbc(this.f.policiesData,Ve.getChannel("policy")):new We.$4n;ke.set(We.$2n,Ze);const Qe=new At.$Tm(this.f.args,Ne);ke.set(s.$pi,Qe);const et=new V.$Tr(void 0,this.f.logLevel,Qe.logsHome,this.f.loggers.map(Je=>({...Je,resource:R.URI.revive(Je.resource)})),Ve.getChannel("logger"));ke.set(K.$Oj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new K.$Vj(ot.getLevel())),Xe=this.B(new St.$1P(ot,[ht]));ke.set(K.$Nj,Xe),this.b=this.B(new gt.$ucc(Xe)),ke.set(gt.$tcc,this.b);const Ye=this.B(new O.$tq(Xe));ke.set(p.$Nk,Ye);const ut=this.B(new U.$Uq(Xe));Ye.registerProvider(D.Schemas.file,ut);const at=new Me.$is(Ye);ke.set(Te.$ll,at);const xe=this.B(new Be.$8P(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Qe.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ke.set(Pe.$nl,xe);const ft=this.B(new je.$Dbc(D.Schemas.file,this.B(new ae.$JP(Ve.getChannel(ae.$IP),{pathCaseSensitive:ze.$k})),D.Schemas.vscodeUserData,xe,at,Xe));Ye.registerProvider(D.Schemas.vscodeUserData,ft);const it=this.B(new c.$ro(xe.defaultProfile.settingsResource,Ye,Ze,Xe));ke.set(l.$Ni,it);const dt=new Nt.$Acc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Qe);ke.set(te.$Lp,dt),this.B((0,j.$Sc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const wt=new Ct.$Er(Ve.getChannel("request"));ke.set(oe.$yp,wt),ke.set(h.$9bc,new F.$ei(g.$0bc,void 0,!1)),ke.set(be.$MF,new F.$ei(ge.$jcc,void 0,!1));const bt=new Ot.$Kbc(-1,Ve);ke.set(It.$pac,bt),ke.set(o.$vo,new F.$ei(n.$dQ,void 0,!0));const qt=this.B(new me.$$ac(bt)),zt=new C.$2h(Je=>qt.getActiveClientId().then(lt=>Je===lt));ke.set(S.$t2b,new Rt.$wcc(this.a.getChannel("extensionRecommendationNotification",zt)));let ct;const nt=[],yt=(0,z.$cp)(Ne,it);if((0,z.$0o)(Ne,Qe)){const Je=new L.$b$b(Xe,et,Qe,Ne);if(nt.push(Je),!(0,z.$$o)(Ne,Qe)&&Ne.aiConfig?.ariaKey){const lt=new Fe.$OP(wt,yt,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,j.$Sc)(()=>lt.flush())),nt.push(lt)}ct=new T.$Ir({appenders:nt,commonProperties:(0,ce.$1o)((0,I.release)(),(0,I.hostname)(),process.arch,Ne.commit,Ne.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,z.$dp)(Qe)},it,Ne)}else{ct=z.$5o;const Je=z.$9o;nt.push(Je)}this.a.registerChannel("telemetryAppender",new q.$Pac(nt)),ke.set(H.$Ml,ct);const Bt=new Y.$$bc(it,ct,Xe,et,Qe,Ne);ke.set(H.$Nl,Bt),ke.set(Oe.$aq,new F.$ei(Pt.$ZP,void 0,!0)),ke.set(pe.$eq,new F.$ei(Ee.$cbc,void 0,!0)),ke.set(y.$Wp,new F.$ei(y.$Xp,void 0,!0)),ke.set(k.$oq,new F.$ei(k.$pq,void 0,!0)),ke.set(a.$Qo,new F.$ei(r.$Up,void 0,!0)),ke.set(a.$Xo,new F.$ei(Lt.$zcc,void 0,!1)),ke.set(Z.$Ar,new F.$ei(W.$Cr,void 0,!1)),ke.set($.$1m,new F.$ei(i.$ps,void 0,!1)),ke.set(X.$VHb,new F.$ei(X.$WHb,void 0,!0)),ke.set(_.$Upb,new F.$ei(ue.$gKb,void 0,!0)),ke.set(_.$Tpb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),ke.set(a.$Wo,new F.$ei(t.$THb,void 0,!1)),ke.set(ee.$eKb,new F.$ei(ee.$fKb,void 0,!0)),ke.set(G.$Hv,new F.$ei(G.$Iv)),ke.set(_.$Epb,new F.$ei(Ie.$mJb,void 0,!0)),ke.set(_.$Fpb,new F.$ei(Ie.$oJb,void 0,!0)),ke.set(de.$spb,new F.$ei(de.$upb,void 0,!0)),ke.set(_.$Gpb,new F.$ei(ne.$Q$b,void 0,!1)),ke.set(_.$Ppb,new F.$ei($e.$F$b,void 0,!0)),ke.set(_.$Qpb,new F.$ei(ye.$V$b,void 0,!1)),ke.set(Le.$vIb,new F.$ei(fe.$fcc,void 0,!0)),ke.set(_.$Rpb,new F.$ei(_e.$s_b,void 0,!0)),ke.set(we.$Al,new F.$ei(Ce.$Abc,void 0,!1));const vt=new mt.$yl;return ke.set(mt.$xl,vt),vt.register(0,jt.$Bcc),ke.set(Re.$Wv,new F.$ei(Ue.$ybc)),ke.set(De.$gcc,new F.$ei(qe.$icc)),ke.set(Ge.$lcc,new F.$ei(kt.$vcc)),new x.$Xq(ke)}j(ke){const Ne=new E.$Zp(ke.get(a.$To),()=>null);this.a.registerChannel("extensions",Ne);const He=C.ProxyChannel.fromService(ke.get(Z.$Ar),this.q);this.a.registerChannel("languagePacks",He);const Ve=C.ProxyChannel.fromService(ke.get($.$1m),this.q);this.a.registerChannel("diagnostics",Ve);const Ze=new E.$2p(ke.get(a.$Xo));this.a.registerChannel("extensionTipsService",Ze);const Qe=C.ProxyChannel.fromService(ke.get(h.$9bc),this.q);this.a.registerChannel("checksum",Qe);const et=C.ProxyChannel.fromService(ke.get(be.$MF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(ke.get(de.$spb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(ke.get(H.$Nl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Xe=new re.$_bc(ke.get(X.$VHb));this.a.registerChannel("userDataSyncAccount",Xe);const Ye=new re.$bcc(ke.get(_.$Epb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new Se.$dcc(ke.get(_.$Qpb),ke.get(Pe.$nl),ke.get(K.$Nj));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(M.$gi).createInstance(Dt.$ycc));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(ke.get(_.$Rpb),this.q));const xe=C.ProxyChannel.fromService(ke.get(De.$gcc),this.q);this.a.registerChannel(De.$hcc,xe);const ft=C.ProxyChannel.fromService(ke.get(Ge.$lcc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",Ne=>(0,N.$1)(Ne)),process.on("unhandledRejection",Ne=>(0,N.$1)(Ne)),(0,N.setUnexpectedErrorHandler)(Ne=>{const He=(0,A.$5i)(Ne,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,Ne){ke.publicLog2("profilesInfo",{count:Ne.profiles.length})}async r(ke,Ne){if(ze.$k){const He=await(0,Ut.$Eg)(Ne.error.bind(Ne)),Ve=(0,Tt.$CV)();He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Ve})}}handledClientConnection(ke){if(ke.data!==st.$Mac.response)return!1;const Ne=(0,P.$Ob)(ke.ports);return Ne?(this.c.fire(Ne),!0):!1}}async function pt(rt){try{const ke=new Ft(rt);process.parentPort.postMessage(st.$Kac.ipcReady),await ke.init(),process.parentPort.postMessage(st.$Kac.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const Mt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(Mt),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/99a19815253d91900be5ec1016e0ecc7cc9a6950/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
