/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContributionService","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(de){for(var e=[],u=0,j=de.length;u<j;u++)e[u]=Ee[de[u]];return e};define(Ee[161],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const R=new Map,P=new Map,A=new Map,p=new Map;function $(E,v){E.has(v.detail)||E.set(v.detail,-v.timestamp)}function k(E,v){const c=E.get(v.detail);c&&(c>=0||E.set(v.detail,c+v.timestamp))}let M=[];typeof de=="function"&&typeof de.getStats=="function"&&(M=de.getStats().slice(0).sort((E,v)=>E.timestamp-v.timestamp));for(const E of M)switch(E.type){case 10:$(R,E);break;case 11:case 12:k(R,E);break;case 21:$(P,E);break;case 22:k(P,E);break;case 33:$(A,E);break;case 34:k(A,E);break;case 31:$(p,E);break;case 32:k(p,E);break}let I=0;A.forEach(E=>I+=E);function b(E){const v=[];return E.forEach((c,m)=>v.push([m,c])),v}return{amdLoad:b(R),amdInvoke:b(P),nodeRequire:b(A),nodeEval:b(p),nodeRequireTotal:I}}static toMarkdownTable(R,P){let A="";const p=[];return R.forEach(($,k)=>{p[k]=$.length}),P.forEach($=>{$.forEach((k,M)=>{typeof k>"u"&&(k=$[M]="-");const I=k.toString().length;p[M]=Math.max(I,p[M])})}),R.forEach(($,k)=>{A+=`| ${$+" ".repeat(p[k]-$.toString().length)} `}),A+=`|
`,R.forEach(($,k)=>{A+=`| ${"-".repeat(p[k])} `}),A+=`|
`,P.forEach($=>{$.forEach((k,M)=>{typeof k<"u"&&(A+=`| ${k+" ".repeat(p[M]-k.toString().length)} `)}),A+=`|
`}),A}}e.$U=u}),define(Ee[162],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=j,e.$hb=R,e.$ib=P,e.$jb=A,e.$kb=p,e.$lb=$,e.$nb=M,e.$ob=I,e.$pb=b,e.$qb=E,e.$rb=v;function u(c,m,a){const n=j(c,m);if(n!==-1)return c[n]}function j(c,m,a=c.length-1){for(let n=a;n>=0;n--){const i=c[n];if(m(i))return n}return-1}function R(c,m){const a=P(c,m);return a===-1?void 0:c[a]}function P(c,m,a=0,n=c.length){let i=a,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(c[s])?i=s+1:r=s}return i-1}function A(c,m){const a=p(c,m);return a===c.length?void 0:c[a]}function p(c,m,a=0,n=c.length){let i=a,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(c[s])?r=s:i=s+1}return i}function $(c,m,a=0,n=c.length){const i=p(c,m,a,n);return i===c.length?-1:i}class k{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(k.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const a=P(this.e,m,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=k;function M(c,m){if(c.length===0)return;let a=c[0];for(let n=1;n<c.length;n++){const i=c[n];m(i,a)>0&&(a=i)}return a}function I(c,m){if(c.length===0)return;let a=c[0];for(let n=1;n<c.length;n++){const i=c[n];m(i,a)>=0&&(a=i)}return a}function b(c,m){return M(c,(a,n)=>-m(a,n))}function E(c,m){if(c.length===0)return-1;let a=0;for(let n=1;n<c.length;n++){const i=c[n];m(i,c[a])>0&&(a=n)}return a}function v(c,m){for(const a of c){const n=m(a);if(n!==void 0)return n}}}),define(Ee[73],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=j,e.$M=R,e.$N=P;function u(A,p){const $=Object.create(null);for(const k of A){const M=p(k);let I=$[M];I||(I=$[M]=[]),I.push(k)}return $}function j(A,p){const $=[],k=[];for(const M of A)p.has(M)||$.push(M);for(const M of p)A.has(M)||k.push(M);return{removed:$,added:k}}function R(A,p){const $=[],k=[];for(const[M,I]of A)p.has(M)||$.push(I);for(const[M,I]of p)A.has(M)||k.push(I);return{removed:$,added:k}}function P(A,p){const $=new Set;for(const k of p)A.has(k)&&$.add(k);return $}}),define(Ee[54],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=j,e.$Mh=R,e.$Nh=P;function u(A){return(p,$,k)=>{let M=null,I=null;if(typeof k.value=="function"?(M="value",I=k.value):typeof k.get=="function"&&(M="get",I=k.get),!I)throw new Error("not supported");k[M]=A(I,$)}}function j(A,p,$){let k=null,M=null;if(typeof $.value=="function"?(k="value",M=$.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",M=$.get),!M)throw new Error("not supported");const I=`$memoize$${p}`;$[k]=function(...b){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,b)}),this[I]}}function R(A,p,$){return u((k,M)=>{const I=`$debounce$${M}`,b=`$debounce$result$${M}`;return function(...E){this[b]||(this[b]=$?$():void 0),clearTimeout(this[I]),p&&(this[b]=p(this[b],...E),E=[this[b]]),this[I]=setTimeout(()=>{k.apply(this,E),this[b]=$?$():void 0},A)}})}function P(A,p,$){return u((k,M)=>{const I=`$throttle$timer$${M}`,b=`$throttle$result$${M}`,E=`$throttle$lastRun$${M}`,v=`$throttle$pending$${M}`;return function(...c){if(this[b]||(this[b]=$?$():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),p&&(this[b]=p(this[b],...c)),this[v])return;const m=this[E]+A;m<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[b]]),this[b]=$?$():void 0):(this[v]=!0,this[I]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),k.apply(this,[this[b]]),this[b]=$?$():void 0},m-Date.now()))}})}}),define(Ee[13],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=j,e.$Z=R,e.$1=P,e.$2=A,e.$3=p,e.$4=k,e.$6=I,e.$7=b,e.$8=E,e.$0=c;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(g=>{g(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function j(s){e.$X.setUnexpectedErrorHandler(s)}function R(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function P(s){k(s)||e.$X.onUnexpectedError(s)}function A(s){k(s)||e.$X.onUnexpectedExternalError(s)}function p(s){if(s instanceof Error){const{name:t,message:g}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:g,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const $="Canceled";function k(s){return s instanceof M?!0:s instanceof Error&&s.name===$&&s.message===$}class M extends Error{constructor(){super($),this.name=this.message}}e.$5=M;function I(){const s=new Error($);return s.name=s.message,s}function b(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function c(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const g=new i;return g.message=t.message,g.stack=t.stack,g}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Ee[19],Se([1,0,13,162]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=R,e.$tb=P,e.$ub=A,e.$vb=p,e.$wb=$,e.$xb=k,e.$yb=M,e.$zb=I,e.$Ab=b,e.$Bb=E,e.$Cb=v,e.$Db=c,e.$Eb=m,e.top=a,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=g,e.$Lb=d,e.$Mb=l,e.$Nb=o,e.$Ob=h,e.$Pb=f,e.$Qb=D,e.$Rb=w,e.$Sb=S,e.$Tb=y,e.$Ub=C,e.$Vb=O,e.$Wb=z,e.$Xb=F,e.$Yb=T,e.$Zb=L,e.$1b=N,e.$2b=B,e.$3b=U,e.$4b=Z,e.$5b=_,e.$6b=Y,e.$7b=X,e.$8b=me,e.$$b=W;function R(le,ue=0){return le[le.length-(1+ue)]}function P(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}function A(le,ue,oe=(K,ee)=>K===ee){if(le===ue)return!0;if(!le||!ue||le.length!==ue.length)return!1;for(let K=0,ee=le.length;K<ee;K++)if(!oe(le[K],ue[K]))return!1;return!0}function p(le,ue){const oe=le.length-1;ue<oe&&(le[ue]=le[oe]),le.pop()}function $(le,ue,oe){return k(le.length,K=>oe(le[K],ue))}function k(le,ue){let oe=0,K=le-1;for(;oe<=K;){const ee=(oe+K)/2|0,he=ue(ee);if(he<0)oe=ee+1;else if(he>0)K=ee-1;else return ee}return-(oe+1)}function M(le,ue,oe){if(le=le|0,le>=ue.length)throw new TypeError("invalid index");const K=ue[Math.floor(ue.length*Math.random())],ee=[],he=[],fe=[];for(const Ae of ue){const pe=oe(Ae,K);pe<0?ee.push(Ae):pe>0?he.push(Ae):fe.push(Ae)}return le<ee.length?M(le,ee,oe):le<ee.length+fe.length?fe[0]:M(le-(ee.length+fe.length),he,oe)}function I(le,ue){const oe=[];let K;for(const ee of le.slice(0).sort(ue))!K||ue(K[0],ee)!==0?(K=[ee],oe.push(K)):K.push(ee);return oe}function*b(le,ue){let oe,K;for(const ee of le)K!==void 0&&ue(K,ee)?oe.push(ee):(oe&&(yield oe),oe=[ee]),K=ee;oe&&(yield oe)}function E(le,ue){for(let oe=0;oe<=le.length;oe++)ue(oe===0?void 0:le[oe-1],oe===le.length?void 0:le[oe])}function v(le,ue){for(let oe=0;oe<le.length;oe++)ue(oe===0?void 0:le[oe-1],le[oe],oe+1===le.length?void 0:le[oe+1])}function c(le,ue,oe){const K=[];function ee(Ae,pe,Ce){if(pe===0&&Ce.length===0)return;const Me=K[K.length-1];Me&&Me.start+Me.deleteCount===Ae?(Me.deleteCount+=pe,Me.toInsert.push(...Ce)):K.push({start:Ae,deleteCount:pe,toInsert:Ce})}let he=0,fe=0;for(;;){if(he===le.length){ee(he,0,ue.slice(fe));break}if(fe===ue.length){ee(he,le.length-he,[]);break}const Ae=le[he],pe=ue[fe],Ce=oe(Ae,pe);Ce===0?(he+=1,fe+=1):Ce<0?(ee(he,1,[]),he+=1):Ce>0&&(ee(he,0,[pe]),fe+=1)}return K}function m(le,ue,oe){const K=c(le,ue,oe),ee=[],he=[];for(const fe of K)ee.push(...le.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:ee,added:he}}function a(le,ue,oe){if(oe===0)return[];const K=le.slice(0,oe).sort(ue);return i(le,ue,K,oe,le.length),K}function n(le,ue,oe,K,ee){return oe===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const Ae=le.length,pe=le.slice(0,oe).sort(ue);for(let Ce=oe,Me=Math.min(oe+K,Ae);Ce<Ae;Ce=Me,Me=Math.min(Me+K,Ae)){if(Ce>oe&&await new Promise(Fe=>setTimeout(Fe)),ee&&ee.isCancellationRequested)throw new u.$5;i(le,ue,pe,Ce,Me)}return pe})().then(he,fe)})}function i(le,ue,oe,K,ee){for(const he=oe.length;K<ee;K++){const fe=le[K];if(ue(fe,oe[he-1])<0){oe.pop();const Ae=(0,j.$kb)(oe,pe=>ue(fe,pe)<0);oe.splice(Ae,0,fe)}}}function r(le){return le.filter(ue=>!!ue)}function s(le){let ue=0;for(let oe=0;oe<le.length;oe++)le[oe]&&(le[ue]=le[oe],ue+=1);le.length=ue}function t(le,ue,oe){le.splice(oe,0,le.splice(ue,1)[0])}function g(le){return!Array.isArray(le)||le.length===0}function d(le){return Array.isArray(le)&&le.length>0}function l(le,ue=oe=>oe){const oe=new Set;return le.filter(K=>{const ee=ue(K);return oe.has(ee)?!1:(oe.add(ee),!0)})}function o(le){const ue=new Set;return oe=>{const K=le(oe);return ue.has(K)?!1:(ue.add(K),!0)}}function h(le,ue){return le.length>0?le[0]:ue}function f(le,ue){return le.length>0?le[le.length-1]:ue}function D(le,ue,oe=(K,ee)=>K===ee){let K=0;for(let ee=0,he=Math.min(le.length,ue.length);ee<he&&oe(le[ee],ue[ee]);ee++)K++;return K}function w(le){return[].concat(...le)}function S(le,ue){let oe=typeof ue=="number"?le:0;typeof ue=="number"?oe=le:(oe=0,ue=le);const K=[];if(oe<=ue)for(let ee=oe;ee<ue;ee++)K.push(ee);else for(let ee=oe;ee>ue;ee--)K.push(ee);return K}function y(le,ue,oe){return le.reduce((K,ee)=>(K[ue(ee)]=oe?oe(ee):ee,K),Object.create(null))}function C(le,ue){return le.push(ue),()=>O(le,ue)}function O(le,ue){const oe=le.indexOf(ue);if(oe>-1)return le.splice(oe,1),ue}function z(le,ue,oe){const K=le.slice(0,ue),ee=le.slice(ue);return K.concat(oe,ee)}function F(le,ue){let oe;if(typeof ue=="number"){let K=ue;oe=()=>{const ee=Math.sin(K++)*179426549;return ee-Math.floor(ee)}}else oe=Math.random;for(let K=le.length-1;K>0;K-=1){const ee=Math.floor(oe()*(K+1)),he=le[K];le[K]=le[ee],le[ee]=he}}function T(le,ue){const oe=le.indexOf(ue);oe>-1&&(le.splice(oe,1),le.unshift(ue))}function L(le,ue){const oe=le.indexOf(ue);oe>-1&&(le.splice(oe,1),le.push(ue))}function N(le,ue){for(const oe of ue)le.push(oe)}function B(le,ue){return Array.isArray(le)?le.map(ue):ue(le)}function U(le){return Array.isArray(le)?le:[le]}function Z(le){return le[Math.floor(Math.random()*le.length)]}function _(le,ue,oe){const K=x(le,ue),ee=le.length,he=oe.length;le.length=ee+he;for(let fe=ee-1;fe>=K;fe--)le[fe+he]=le[fe];for(let fe=0;fe<he;fe++)le[fe+K]=oe[fe]}function Y(le,ue,oe,K){const ee=x(le,ue);let he=le.splice(ee,oe);return he===void 0&&(he=[]),_(le,ee,K),he}function x(le,ue){return ue<0?Math.max(ue+le.length,0):Math.min(ue,le.length)}var ce;(function(le){function ue(he){return he<0}le.isLessThan=ue;function oe(he){return he<=0}le.isLessThanOrEqual=oe;function K(he){return he>0}le.isGreaterThan=K;function ee(he){return he===0}le.isNeitherLessOrGreaterThan=ee,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function X(le,ue){return(oe,K)=>ue(le(oe),le(K))}function me(...le){return(ue,oe)=>{for(const K of le){const ee=K(ue,oe);if(!ce.isNeitherLessOrGreaterThan(ee))return ee}return ce.neitherLessOrGreaterThan}}const ae=(le,ue)=>le-ue;e.$9b=ae;const re=(le,ue)=>(0,e.$9b)(le?1:0,ue?1:0);e.$0b=re;function W(le){return(ue,oe)=>-le(ue,oe)}class ie{constructor(ue){this.g=ue,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let oe=this.c;for(;oe<this.g.length&&ue(this.g[oe]);)oe++;const K=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,K}takeFromEndWhile(ue){let oe=this.d;for(;oe>=0&&ue(this.g[oe]);)oe--;const K=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ue=this.g[this.c];return this.c++,ue}removeLast(){const ue=this.g[this.d];return this.d--,ue}takeCount(ue){const oe=this.g.slice(this.c,this.c+ue);return this.c+=ue,oe}}e.$_b=ie;class ve{static{this.empty=new ve(ue=>{})}constructor(ue){this.iterate=ue}forEach(ue){this.iterate(oe=>(ue(oe),!0))}toArray(){const ue=[];return this.iterate(oe=>(ue.push(oe),!0)),ue}filter(ue){return new ve(oe=>this.iterate(K=>ue(K)?oe(K):!0))}map(ue){return new ve(oe=>this.iterate(K=>oe(ue(K))))}some(ue){let oe=!1;return this.iterate(K=>(oe=ue(K),!oe)),oe}findFirst(ue){let oe;return this.iterate(K=>ue(K)?(oe=K,!1):!0),oe}findLast(ue){let oe;return this.iterate(K=>(ue(K)&&(oe=K),!0)),oe}findLastMaxBy(ue){let oe,K=!0;return this.iterate(ee=>((K||ce.isGreaterThan(ue(ee,oe)))&&(K=!1,oe=ee),!0)),oe}}e.$ac=ve;class Pe{constructor(ue){this.c=ue}static createSortPermutation(ue,oe){const K=Array.from(ue.keys()).sort((ee,he)=>oe(ue[ee],ue[he]));return new Pe(K)}apply(ue){return ue.map((oe,K)=>ue[this.c[K]])}inverse(){const ue=this.c.slice();for(let oe=0;oe<this.c.length;oe++)ue[this.c[oe]]=oe;return new Pe(ue)}}e.$bc=Pe}),define(Ee[61],Se([1,0,13]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$0c=R,e.$$c=P,e.$_c=A,e.$ad=p,e.$bd=$;function j(k,M){if(!k)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}function R(k,M="Unreachable"){throw new Error(M)}function P(k){if(!k)throw new u.$cb("Assertion Failed")}function A(k){k||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function p(k){if(!k()){debugger;k(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function $(k,M){let I=0;for(;I<k.length-1;){const b=k[I],E=k[I+1];if(!M(b,E))return!1;I++}return!0}}),define(Ee[74],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(j,R){const P=this;let A=!1,p;return function(){if(A)return p;if(A=!0,R)try{p=j.apply(P,arguments)}finally{R()}else p=j.apply(P,arguments);return p}}}),define(Ee[124],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0;class u{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$HO=u,e.$IO=new u("id#")}),define(Ee[38],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(j){function R(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}j.is=R;const P=Object.freeze([]);function A(){return P}j.empty=A;function*p(t){yield t}j.single=p;function $(t){return R(t)?t:p(t)}j.wrap=$;function k(t){return t||P}j.from=k;function*M(t){for(let g=t.length-1;g>=0;g--)yield t[g]}j.reverse=M;function I(t){return!t||t[Symbol.iterator]().next().done===!0}j.isEmpty=I;function b(t){return t[Symbol.iterator]().next().value}j.first=b;function E(t,g){for(const d of t)if(g(d))return!0;return!1}j.some=E;function v(t,g){for(const d of t)if(g(d))return d}j.find=v;function*c(t,g){for(const d of t)g(d)&&(yield d)}j.filter=c;function*m(t,g){let d=0;for(const l of t)yield g(l,d++)}j.map=m;function*a(...t){for(const g of t)yield*g}j.concat=a;function n(t,g,d){let l=d;for(const o of t)l=g(l,o);return l}j.reduce=n;function*i(t,g,d=t.length){for(g<0&&(g+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);g<d;g++)yield t[g]}j.slice=i;function r(t,g=Number.POSITIVE_INFINITY){const d=[];if(g===0)return[d,t];const l=t[Symbol.iterator]();for(let o=0;o<g;o++){const h=l.next();if(h.done)return[d,j.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}j.consume=r;async function s(t){const g=[];for await(const d of t)g.push(d);return Promise.resolve(g)}j.asyncToArray=s})(u||(e.Iterable=u={}))}),define(Ee[163],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=A,e.$tn=I,e.$un=b,e.$vn=E,e.$wn=v,e.$xn=c,e.$yn=m,e.$zn=a,e.$An=n,e.$Bn=i,e.$Cn=r,e.$Dn=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var j;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,g=!1){let d=0;const l=t.length;let o="",h=0,f=16,D=0;function w(T){let L=0,N=0;for(;L<T;){const B=t.charCodeAt(d);if(B>=48&&B<=57)N=N*16+B-48;else if(B>=65&&B<=70)N=N*16+B-65+10;else if(B>=97&&B<=102)N=N*16+B-97+10;else break;d++,L++}return L<T&&(N=-1),N}function S(T){d=T,o="",h=0,f=16,D=0}function y(){const T=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&k(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&k(t.charCodeAt(d)))for(d++;d<t.length&&k(t.charCodeAt(d));)d++;else return D=3,t.substring(T,d);let L=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&k(t.charCodeAt(d))){for(d++;d<t.length&&k(t.charCodeAt(d));)d++;L=d}else D=3;return t.substring(T,L)}function C(){let T="",L=d;for(;;){if(d>=l){T+=t.substring(L,d),D=2;break}const N=t.charCodeAt(d);if(N===34){T+=t.substring(L,d),d++;break}if(N===92){if(T+=t.substring(L,d),d++,d>=l){D=2;break}switch(t.charCodeAt(d++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const U=w(4);U>=0?T+=String.fromCharCode(U):D=4;break}default:D=5}L=d;continue}if(N>=0&&N<=31)if($(N)){T+=t.substring(L,d),D=2;break}else D=6;d++}return T}function O(){if(o="",D=0,h=d,d>=l)return h=l,f=17;let T=t.charCodeAt(d);if(p(T)){do d++,o+=String.fromCharCode(T),T=t.charCodeAt(d);while(p(T));return f=15}if($(T))return d++,o+=String.fromCharCode(T),T===13&&t.charCodeAt(d)===10&&(d++,o+=`
`),f=14;switch(T){case 123:return d++,f=1;case 125:return d++,f=2;case 91:return d++,f=3;case 93:return d++,f=4;case 58:return d++,f=6;case 44:return d++,f=5;case 34:return d++,o=C(),f=10;case 47:{const L=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!$(t.charCodeAt(d));)d++;return o=t.substring(L,d),f=12}if(t.charCodeAt(d+1)===42){d+=2;const N=l-1;let B=!1;for(;d<N;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,D=1),o=t.substring(L,d),f=13}return o+=String.fromCharCode(T),d++,f=16}case 45:if(o+=String.fromCharCode(T),d++,d===l||!k(t.charCodeAt(d)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=y(),f=11;default:for(;d<l&&z(T);)d++,T=t.charCodeAt(d);if(h!==d){switch(o=t.substring(h,d),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(T),d++,f=16}}function z(T){if(p(T)||$(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let T;do T=O();while(T>=12&&T<=15);return T}return{setPosition:S,getPosition:()=>d,scan:g?F:O,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function I(t,g){const d=[],l=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function D(w,S,y,C){h.value=w,h.offset=S,h.length=y,h.type=C,h.colonOffset=void 0,o=h}try{i(t,{onObjectBegin:(w,S)=>{if(g<=w)throw l;o=void 0,f=g>w,d.push("")},onObjectProperty:(w,S,y)=>{if(g<S||(D(w,S,y,"property"),d[d.length-1]=w,g<=S+y))throw l},onObjectEnd:(w,S)=>{if(g<=w)throw l;o=void 0,d.pop()},onArrayBegin:(w,S)=>{if(g<=w)throw l;o=void 0,d.push(0)},onArrayEnd:(w,S)=>{if(g<=w)throw l;o=void 0,d.pop()},onLiteralValue:(w,S,y)=>{if(g<S||(D(w,S,y,s(w)),g<=S+y))throw l},onSeparator:(w,S,y)=>{if(g<=S)throw l;if(w===":"&&o&&o.type==="property")o.colonOffset=S,f=!1,o=void 0;else if(w===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(f=!0,d[d.length-1]=""),o=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:o,isAtPropertyKey:f,matches:w=>{let S=0;for(let y=0;S<w.length&&y<d.length;y++)if(w[S]===d[y]||w[S]==="*")S++;else if(w[S]!=="**")return!1;return S===w.length}}}function b(t,g=[],d=P.DEFAULT){let l=null,o=[];const h=[];function f(w){Array.isArray(o)?o.push(w):l!==null&&(o[l]=w)}return i(t,{onObjectBegin:()=>{const w={};f(w),h.push(o),o=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const w=[];f(w),h.push(o),o=w,l=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:f,onError:(w,S,y)=>{g.push({error:w,offset:S,length:y})}},d),o[0]}function E(t,g=[],d=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}i(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,S,y)=>{l=h({type:"property",offset:S,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:S,length:y,parent:l})},onObjectEnd:(w,S)=>{l.length=w+S-l.offset,l=l.parent,o(w+S)},onArrayBegin:(w,S)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,S)=>{l.length=w+S-l.offset,l=l.parent,o(w+S)},onLiteralValue:(w,S,y)=>{h({type:s(w),offset:S,length:y,parent:l,value:w}),o(S+y)},onSeparator:(w,S,y)=>{l.type==="property"&&(w===":"?l.colonOffset=S:w===","&&o(S))},onError:(w,S,y)=>{g.push({error:w,offset:S,length:y})}},d);const D=l.children[0];return D&&delete D.parent,D}function v(t,g){if(!t)return;let d=t;for(const l of g)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let o=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],o=!0;break}if(!o)return}else{const o=l;if(d.type!=="array"||o<0||!Array.isArray(d.children)||o>=d.children.length)return;d=d.children[o]}return d}function c(t){if(!t.parent||!t.parent.children)return[];const g=c(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;g.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&g.push(d)}return g}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const g=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(g[d.children[0].value]=m(l))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,g,d=!1){return g>=t.offset&&g<t.offset+t.length||d&&g===t.offset+t.length}function n(t,g,d=!1){if(a(t,g,d)){const l=t.children;if(Array.isArray(l))for(let o=0;o<l.length&&l[o].offset<=g;o++){const h=n(l[o],g,d);if(h)return h}return t}}function i(t,g,d=P.DEFAULT){const l=A(t,!1);function o(X){return X?()=>X(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(X){return X?me=>X(me,l.getTokenOffset(),l.getTokenLength()):()=>!0}const f=o(g.onObjectBegin),D=h(g.onObjectProperty),w=o(g.onObjectEnd),S=o(g.onArrayBegin),y=o(g.onArrayEnd),C=h(g.onLiteralValue),O=h(g.onSeparator),z=o(g.onComment),F=h(g.onError),T=d&&d.disallowComments,L=d&&d.allowTrailingComma;function N(){for(;;){const X=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:T||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(X){case 12:case 13:T?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return X}}}function B(X,me=[],ae=[]){if(F(X),me.length+ae.length>0){let re=l.getToken();for(;re!==17;){if(me.indexOf(re)!==-1){N();break}else if(ae.indexOf(re)!==-1)break;re=N()}}}function U(X){const me=l.getTokenValue();return X?C(me):D(me),N(),!0}function Z(){switch(l.getToken()){case 11:{let X=0;try{X=JSON.parse(l.getTokenValue()),typeof X!="number"&&(B(2),X=0)}catch{B(2)}C(X);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return N(),!0}function _(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(U(!1),l.getToken()===6?(O(":"),N(),ce()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Y(){f(),N();let X=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(X||B(4,[],[]),O(","),N(),l.getToken()===2&&L)break}else X&&B(6,[],[]);_()||B(4,[],[2,5]),X=!0}return w(),l.getToken()!==2?B(7,[2],[]):N(),!0}function x(){S(),N();let X=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(X||B(4,[],[]),O(","),N(),l.getToken()===4&&L)break}else X&&B(6,[],[]);ce()||B(4,[],[4,5]),X=!0}return y(),l.getToken()!==4?B(8,[4],[]):N(),!0}function ce(){switch(l.getToken()){case 3:return x();case 1:return Y();case 10:return U(!0);default:return Z()}}return N(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):ce()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,g){const d=A(t),l=[];let o,h=0,f;do switch(f=d.getPosition(),o=d.scan(),o){case 12:case 13:case 17:h!==f&&l.push(t.substring(h,f)),g!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,g)),h=d.getPosition();break}while(o!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[45],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(R){this.d=R,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(Ee[75],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(P){this.element=P,this.next=u.Undefined,this.prev=u.Undefined}}class j{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let P=this.a;for(;P!==u.Undefined;){const A=P.next;P.prev=u.Undefined,P.next=u.Undefined,P=A}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const p=new u(P);if(this.a===u.Undefined)this.a=p,this.b=p;else if(A){const k=this.b;this.b=p,p.prev=k,k.next=p}else{const k=this.a;this.a=p,p.next=k,k.prev=p}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(p))}}shift(){if(this.a!==u.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==u.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==u.Undefined&&P.next!==u.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===u.Undefined&&P.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):P.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):P.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==u.Undefined;)yield P.element,P=P.next}}e.$5c=j}),define(Ee[28],Se([1,0]),function(de,e){"use strict";var u,j,R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=P,e.$zc=A,e.$Ac=p,e.$Ic=n;function P(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function A(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function p(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class ${constructor(r,s){this.uri=r,this.value=s}}function k(i){return Array.isArray(i)}class M{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof M)this.d=new Map(r.d),this.e=s??M.c;else if(k(r)){this.d=new Map,this.e=s??M.c;for(const[t,g]of r)this.set(t,g)}else this.d=new Map,this.e=r??M.c}set(r,s){return this.d.set(this.e(r),new $(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,g]of this.d)r(g.value,g.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=M;class I{constructor(r,s){this[j]="ResourceSet",!r||typeof r=="function"?this.c=new M(r):(this.c=new M(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,g)=>r.call(s,g,g,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=I;var b;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class E{constructor(){this[R]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let g=this.c.get(r);if(g)g.value=s,t!==0&&this.l(g,t);else{switch(g={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(g);break;case 1:this.i(g);break;case 2:this.j(g);break;default:this.j(g);break}this.c.set(r,g),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let g=this.d;for(;g;){if(s?r.bind(s)(g.value,g.key,this):r(g.value,g.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return g}values(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return g}entries(){const r=this,s=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return g}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,g=r.previous;r===this.e?(g.next=void 0,this.e=g):(t.previous=g,g.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,g=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=g,g.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=E;class v extends E{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class c{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=c;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,g)=>{r.call(s,t,g,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class a{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=a;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(Ee[3],Se([1,0,19,73,28,74,38]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=M,e.$Lc=I,e.$Mc=b,e.$Nc=c,e.$Oc=m,e.$Pc=a,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=w;const p=!1;let $=null;class k{constructor(){this.b=new Map}static{this.a=0}c(C){let O=this.b.get(C);return O||(O={parent:null,source:null,isSingleton:!1,value:C,idx:k.a++},this.b.set(C,O)),O}trackDisposable(C){const O=this.c(C);O.source||(O.source=new Error().stack)}setParent(C,O){const z=this.c(C);z.parent=O}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,O){const z=O.get(C);if(z)return z;const F=C.parent?this.f(this.c(C.parent),O):C;return O.set(C,F),F}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,C).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(C=10,O){let z;if(O)z=O;else{const B=new Map,U=[...this.b.values()].filter(_=>_.source!==null&&!this.f(_,B).isSingleton);if(U.length===0)return;const Z=new Set(U.map(_=>_.value));if(z=U.filter(_=>!(_.parent&&Z.has(_.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function F(B){function U(_,Y){for(;_.length>0&&Y.some(x=>typeof x=="string"?x===_[0]:_[0].match(x));)_.shift()}const Z=B.source.split(`
`).map(_=>_.trim().replace("at ","")).filter(_=>_!=="");return U(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const T=new R.$Hc;for(const B of z){const U=F(B);for(let Z=0;Z<=U.length;Z++)T.add(U.slice(0,Z).join(`
`),B)}z.sort((0,u.$7b)(B=>B.idx,u.$9b));let L="",N=0;for(const B of z.slice(0,C)){N++;const U=F(B),Z=[];for(let _=0;_<U.length;_++){let Y=U[_];Y=`(shared with ${T.get(U.slice(0,_+1).join(`
`)).size}/${z.length} leaks) at ${Y}`;const ce=T.get(U.slice(0,_).join(`
`)),X=(0,j.$K)([...ce].map(me=>F(me)[_]),me=>me);delete X[U[_]];for(const[me,ae]of Object.entries(X))Z.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${me}`);Z.unshift(Y)}L+=`


==================== Leaking disposable ${N}/${z.length}: ${B.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return z.length>C&&(L+=`


... and ${z.length-C} more leaking disposables

`),{leaks:z,details:L}}}e.$Jc=k;function M(y){$=y}if(p){const y="__is_disposable_tracked__";M(new class{trackDisposable(C){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[y]||console.log(O)},3e3)}setParent(C,O){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsSingleton(C){}})}function I(y){return $?.trackDisposable(y),y}function b(y){$?.markAsDisposed(y)}function E(y,C){$?.setParent(y,C)}function v(y,C){if($)for(const O of y)$.setParent(O,C)}function c(y){return $?.markAsSingleton(y),y}function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}function a(y){if(A.Iterable.is(y)){const C=[];for(const O of y)if(O)try{O.dispose()}catch(z){C.push(z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const C of y)m(C)&&C.dispose();return[]}function i(...y){const C=r(()=>a(y));return v(y,C),C}function r(y){const C=I({dispose:(0,P.$db)(()=>{b(C),y()})});return C}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return E(C,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),E(C,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,I(this),E(this.q,this)}dispose(){b(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class g{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&E(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&E(C,null),C}}e.$Vc=g;class d{constructor(C){this.a=new g,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(C){let O=C;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,b(this))},this}}e.$Yc=o;class h{constructor(){this.a=new Map}acquire(C,...O){let z=this.a.get(C);z||(z={counter:0,object:this.b(C,...O)},this.a.set(C,z));const{object:F}=z,T=(0,P.$db)(()=>{--z.counter===0&&(this.c(C,z.object),this.a.delete(C))});return z.counter++,{object:F,dispose:T}}}e.$Zc=h;class f{constructor(C){this.a=C}async acquire(C,...O){const z=this.a.acquire(C,...O);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(F){throw z.dispose(),F}}}e.$1c=f;class D{constructor(C){this.object=C}dispose(){}}e.$2c=D;function w(y){const C=new s;try{y(C)}finally{C.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,O,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(C)?.dispose(),this.a.set(C,O)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=S}),function(de,e){typeof define=="function"&&define.amd?define(Ee[164],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(de=typeof globalThis<"u"?globalThis:de||self,e(de.marked={}))}(this,function(de){"use strict";function e(le,ue){for(var oe=0;oe<ue.length;oe++){var K=ue[oe];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(le,K.key,K)}}function u(le,ue,oe){return ue&&e(le.prototype,ue),oe&&e(le,oe),Object.defineProperty(le,"prototype",{writable:!1}),le}function j(le,ue){if(le){if(typeof le=="string")return R(le,ue);var oe=Object.prototype.toString.call(le).slice(8,-1);if(oe==="Object"&&le.constructor&&(oe=le.constructor.name),oe==="Map"||oe==="Set")return Array.from(le);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return R(le,ue)}}function R(le,ue){(ue==null||ue>le.length)&&(ue=le.length);for(var oe=0,K=new Array(ue);oe<ue;oe++)K[oe]=le[oe];return K}function P(le,ue){var oe=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(oe)return(oe=oe.call(le)).next.bind(oe);if(Array.isArray(le)||(oe=j(le))||ue&&le&&typeof le.length=="number"){oe&&(le=oe);var K=0;return function(){return K>=le.length?{done:!0}:{done:!1,value:le[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}de.defaults=A();function p(le){de.defaults=le}var $=/[&<>"']/,k=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ue){return b[ue]};function v(le,ue){if(ue){if($.test(le))return le.replace(k,E)}else if(M.test(le))return le.replace(I,E);return le}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(le){return le.replace(c,function(ue,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(le,ue){le=typeof le=="string"?le:le.source,ue=ue||"";var oe={replace:function(ee,he){return he=he.source||he,he=he.replace(a,"$1"),le=le.replace(ee,he),oe},getRegex:function(){return new RegExp(le,ue)}};return oe}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(le,ue,oe){if(le){var K;try{K=decodeURIComponent(m(oe)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ue&&!r.test(oe)&&(oe=o(ue,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},g=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(le,ue){t[" "+le]||(g.test(le)?t[" "+le]=le+"/":t[" "+le]=w(le,"/",!0)),le=t[" "+le];var oe=le.indexOf(":")===-1;return ue.substring(0,2)==="//"?oe?ue:le.replace(d,"$1")+ue:ue.charAt(0)==="/"?oe?ue:le.replace(l,"$1")+ue:le+ue}var h={exec:function(){}};function f(le){for(var ue=1,oe,K;ue<arguments.length;ue++){oe=arguments[ue];for(K in oe)Object.prototype.hasOwnProperty.call(oe,K)&&(le[K]=oe[K])}return le}function D(le,ue){var oe=le.replace(/\|/g,function(he,fe,Ae){for(var pe=!1,Ce=fe;--Ce>=0&&Ae[Ce]==="\\";)pe=!pe;return pe?"|":" |"}),K=oe.split(/ \|/),ee=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ue)K.splice(ue);else for(;K.length<ue;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function w(le,ue,oe){var K=le.length;if(K===0)return"";for(var ee=0;ee<K;){var he=le.charAt(K-ee-1);if(he===ue&&!oe)ee++;else if(he!==ue&&oe)ee++;else break}return le.slice(0,K-ee)}function S(le,ue){if(le.indexOf(ue[1])===-1)return-1;for(var oe=le.length,K=0,ee=0;ee<oe;ee++)if(le[ee]==="\\")ee++;else if(le[ee]===ue[0])K++;else if(le[ee]===ue[1]&&(K--,K<0))return ee;return-1}function y(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(le,ue){if(ue<1)return"";for(var oe="";ue>1;)ue&1&&(oe+=le),ue>>=1,le+=le;return oe+le}function O(le,ue,oe,K){var ee=ue.href,he=ue.title?v(ue.title):null,fe=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){K.state.inLink=!0;var Ae={type:"link",raw:oe,href:ee,title:he,text:fe,tokens:K.inlineTokens(fe)};return K.state.inLink=!1,Ae}return{type:"image",raw:oe,href:ee,title:he,text:v(fe)}}function z(le,ue){var oe=le.match(/^(\s+)(?:```)/);if(oe===null)return ue;var K=oe[1];return ue.split(`
`).map(function(ee){var he=ee.match(/^\s+/);if(he===null)return ee;var fe=he[0];return fe.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var F=function(){function le(oe){this.options=oe||de.defaults}var ue=le.prototype;return ue.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ue.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var he=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?he:w(he,`
`)}}},ue.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var he=ee[0],fe=z(he,ee[3]||"");return{type:"code",raw:he,lang:ee[2]?ee[2].trim():ee[2],text:fe}}},ue.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var he=ee[2].trim();if(/#$/.test(he)){var fe=w(he,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(he=fe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:he,tokens:this.lexer.inline(he)}}},ue.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},ue.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var he=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ue.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var he,fe,Ae,pe,Ce,Me,Fe,V,q,Q,J,ge,we=ee[1].trim(),Te=we.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(ge=!1,!(!(ee=Xe.exec(K))||this.rules.block.hr.test(K)));){if(he=ee[0],K=K.substring(he.length),V=ee[2].split(`
`,1)[0],q=K.split(`
`,1)[0],this.options.pedantic?(pe=2,J=V.trimLeft()):(pe=ee[2].search(/[^ ]/),pe=pe>4?1:pe,J=V.slice(pe),pe+=ee[1].length),Me=!1,!V&&/^ *$/.test(q)&&(he+=q+`
`,K=K.substring(q.length+1),ge=!0),!ge)for(var tt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");K&&(Q=K.split(`
`,1)[0],V=Q,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(V)||st.test(V)||tt.test(V)||nt.test(K)));){if(V.search(/[^ ]/)>=pe||!V.trim())J+=`
`+V.slice(pe);else if(!Me)J+=`
`+V;else break;!Me&&!V.trim()&&(Me=!0),he+=Q+`
`,K=K.substring(Q.length+1)}He.loose||(Fe?He.loose=!0:/\n *\n *$/.test(he)&&(Fe=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(J),fe&&(Ae=fe[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:he,task:!!fe,checked:Ae,loose:!1,text:J}),He.raw+=he}He.items[He.items.length-1].raw=he.trimRight(),He.items[He.items.length-1].text=J.trimRight(),He.raw=He.raw.trimRight();var Ie=He.items.length;for(Ce=0;Ce<Ie;Ce++){this.lexer.state.top=!1,He.items[Ce].tokens=this.lexer.blockTokens(He.items[Ce].text,[]);var ze=He.items[Ce].tokens.filter(function(Ge){return Ge.type==="space"}),Re=ze.every(function(Ge){for(var ne=Ge.raw.split(""),se=0,De=P(ne),Ke;!(Ke=De()).done;){var xe=Ke.value;if(xe===`
`&&(se+=1),se>1)return!0}return!1});!He.loose&&ze.length&&Re&&(He.loose=!0,He.items[Ce].loose=!0)}return He}},ue.html=function(K){var ee=this.rules.block.html.exec(K);if(ee){var he={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]);he.type="paragraph",he.text=fe,he.tokens=this.lexer.inline(fe)}return he}},ue.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var he=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:ee[0],href:ee[2],title:ee[3]}}},ue.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var he={type:"table",header:D(ee[1]).map(function(Fe){return{text:Fe}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=ee[0];var fe=he.align.length,Ae,pe,Ce,Me;for(Ae=0;Ae<fe;Ae++)/^ *-+: *$/.test(he.align[Ae])?he.align[Ae]="right":/^ *:-+: *$/.test(he.align[Ae])?he.align[Ae]="center":/^ *:-+ *$/.test(he.align[Ae])?he.align[Ae]="left":he.align[Ae]=null;for(fe=he.rows.length,Ae=0;Ae<fe;Ae++)he.rows[Ae]=D(he.rows[Ae],he.header.length).map(function(Fe){return{text:Fe}});for(fe=he.header.length,pe=0;pe<fe;pe++)he.header[pe].tokens=this.lexer.inline(he.header[pe].text);for(fe=he.rows.length,pe=0;pe<fe;pe++)for(Me=he.rows[pe],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return he}}},ue.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ue.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee){var he=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:he,tokens:this.lexer.inline(he)}}},ue.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ue.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:v(ee[1])}},ue.tag=function(K){var ee=this.rules.inline.tag.exec(K);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]):ee[0]}},ue.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var he=ee[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var fe=w(he.slice(0,-1),"\\");if((he.length-fe.length)%2===0)return}else{var Ae=S(ee[2],"()");if(Ae>-1){var pe=ee[0].indexOf("!")===0?5:4,Ce=pe+ee[1].length+Ae;ee[2]=ee[2].substring(0,Ae),ee[0]=ee[0].substring(0,Ce).trim(),ee[3]=""}}var Me=ee[2],Fe="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);V&&(Me=V[1],Fe=V[3])}else Fe=ee[3]?ee[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),O(ee,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ue.reflink=function(K,ee){var he;if((he=this.rules.inline.reflink.exec(K))||(he=this.rules.inline.nolink.exec(K))){var fe=(he[2]||he[1]).replace(/\s+/g," ");if(fe=ee[fe.toLowerCase()],!fe||!fe.href){var Ae=he[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(he,fe,he[0],this.lexer)}},ue.emStrong=function(K,ee,he){he===void 0&&(he="");var fe=this.rules.inline.emStrong.lDelim.exec(K);if(fe&&!(fe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=fe[1]||fe[2]||"";if(!Ae||Ae&&(he===""||this.rules.inline.punctuation.exec(he))){var pe=fe[0].length-1,Ce,Me,Fe=pe,V=0,q=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ee=ee.slice(-1*K.length+pe);(fe=q.exec(ee))!=null;)if(Ce=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ce){if(Me=Ce.length,fe[3]||fe[4]){Fe+=Me;continue}else if((fe[5]||fe[6])&&pe%3&&!((pe+Me)%3)){V+=Me;continue}if(Fe-=Me,!(Fe>0)){if(Me=Math.min(Me,Me+Fe+V),Math.min(pe,Me)%2){var Q=K.slice(1,pe+fe.index+Me);return{type:"em",raw:K.slice(0,pe+fe.index+Me+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=K.slice(2,pe+fe.index+Me-1);return{type:"strong",raw:K.slice(0,pe+fe.index+Me+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ue.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var he=ee[2].replace(/\n/g," "),fe=/[^ ]/.test(he),Ae=/^ /.test(he)&&/ $/.test(he);return fe&&Ae&&(he=he.substring(1,he.length-1)),he=v(he,!0),{type:"codespan",raw:ee[0],text:he}}},ue.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},ue.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ue.autolink=function(K,ee){var he=this.rules.inline.autolink.exec(K);if(he){var fe,Ae;return he[2]==="@"?(fe=v(this.options.mangle?ee(he[1]):he[1]),Ae="mailto:"+fe):(fe=v(he[1]),Ae=fe),{type:"link",raw:he[0],text:fe,href:Ae,tokens:[{type:"text",raw:fe,text:fe}]}}},ue.url=function(K,ee){var he;if(he=this.rules.inline.url.exec(K)){var fe,Ae;if(he[2]==="@")fe=v(this.options.mangle?ee(he[0]):he[0]),Ae="mailto:"+fe;else{var pe;do pe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(pe!==he[0]);fe=v(he[0]),he[1]==="www."?Ae="http://"+fe:Ae=fe}return{type:"link",raw:he[0],text:fe,href:Ae,tokens:[{type:"text",raw:fe,text:fe}]}}},ue.inlineText=function(K,ee){var he=this.rules.inline.text.exec(K);if(he){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):v(he[0]):he[0]:fe=v(this.options.smartypants?ee(he[0]):he[0]),{type:"text",raw:he[0],text:fe}}},le}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=n(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=n(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=n(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=n(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=n(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=f({},T),T.gfm=f({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=n(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=n(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=f({},T.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=n(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=n(T._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=n(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=n(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=n(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=n(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=n(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=n(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=n(L.reflink).replace("label",L._label).replace("ref",T._label).getRegex(),L.nolink=n(L.nolink).replace("ref",T._label).getRegex(),L.reflinkSearch=n(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=f({},L),L.pedantic=f({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=f({},L.normal,{escape:n(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=n(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=f({},L.gfm,{br:n(L.br).replace("{2,}","*").getRegex(),text:n(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(le){var ue="",oe,K,ee=le.length;for(oe=0;oe<ee;oe++)K=le.charCodeAt(oe),Math.random()>.5&&(K="x"+K.toString(16)),ue+="&#"+K+";";return ue}var U=function(){function le(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||de.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:T.normal,inline:L.normal};this.options.pedantic?(K.block=T.pedantic,K.inline=L.pedantic):this.options.gfm&&(K.block=T.gfm,this.options.breaks?K.inline=L.breaks:K.inline=L.gfm),this.tokenizer.rules=K}le.lex=function(K,ee){var he=new le(ee);return he.lex(K)},le.lexInline=function(K,ee){var he=new le(ee);return he.inlineTokens(K)};var ue=le.prototype;return ue.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ue.blockTokens=function(K,ee){var he=this;ee===void 0&&(ee=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Fe,V,q){return V+"    ".repeat(q.length)});for(var fe,Ae,pe,Ce;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(fe=Fe.call({lexer:he},K,ee))?(K=K.substring(fe.raw.length),ee.push(fe),!0):!1}))){if(fe=this.tokenizer.space(K)){K=K.substring(fe.raw.length),fe.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(fe);continue}if(fe=this.tokenizer.code(K)){K=K.substring(fe.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+fe.raw,Ae.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(fe);continue}if(fe=this.tokenizer.fences(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.heading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.hr(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.blockquote(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.list(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.html(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.def(K)){K=K.substring(fe.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+fe.raw,Ae.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.lheading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(pe=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,V=K.slice(1),q=void 0;he.options.extensions.startBlock.forEach(function(Q){q=Q.call({lexer:this},V),typeof q=="number"&&q>=0&&(Fe=Math.min(Fe,q))}),Fe<1/0&&Fe>=0&&(pe=K.substring(0,Fe+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(pe))){Ae=ee[ee.length-1],Ce&&Ae.type==="paragraph"?(Ae.raw+=`
`+fe.raw,Ae.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(fe),Ce=pe.length!==K.length,K=K.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(K)){K=K.substring(fe.raw.length),Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+fe.raw,Ae.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(fe);continue}if(K){var Me="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,ee},ue.inline=function(K,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:K,tokens:ee}),ee},ue.inlineTokens=function(K,ee){var he=this;ee===void 0&&(ee=[]);var fe,Ae,pe,Ce=K,Me,Fe,V;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)q.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Fe||(V=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(fe=J.call({lexer:he},K,ee))?(K=K.substring(fe.raw.length),ee.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.tag(K)){K=K.substring(fe.raw.length),Ae=ee[ee.length-1],Ae&&fe.type==="text"&&Ae.type==="text"?(Ae.raw+=fe.raw,Ae.text+=fe.text):ee.push(fe);continue}if(fe=this.tokenizer.link(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(fe.raw.length),Ae=ee[ee.length-1],Ae&&fe.type==="text"&&Ae.type==="text"?(Ae.raw+=fe.raw,Ae.text+=fe.text):ee.push(fe);continue}if(fe=this.tokenizer.emStrong(K,Ce,V)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.codespan(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.br(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.del(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.autolink(K,B)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(K,B))){K=K.substring(fe.raw.length),ee.push(fe);continue}if(pe=K,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,ge=K.slice(1),we=void 0;he.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},ge),typeof we=="number"&&we>=0&&(J=Math.min(J,we))}),J<1/0&&J>=0&&(pe=K.substring(0,J+1))}(),fe=this.tokenizer.inlineText(pe,N)){K=K.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(V=fe.raw.slice(-1)),Fe=!0,Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=fe.raw,Ae.text+=fe.text):ee.push(fe);continue}if(K){var Q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return ee},u(le,null,[{key:"rules",get:function(){return{block:T,inline:L}}}]),le}(),Z=function(){function le(oe){this.options=oe||de.defaults}var ue=le.prototype;return ue.code=function(K,ee,he){var fe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(K,fe);Ae!=null&&Ae!==K&&(he=!0,K=Ae)}return K=K.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+v(fe,!0)+'">'+(he?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+(he?K:v(K,!0))+`</code></pre>
`},ue.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ue.html=function(K){return K},ue.heading=function(K,ee,he,fe){if(this.options.headerIds){var Ae=this.options.headerPrefix+fe.slug(he);return"<h"+ee+' id="'+Ae+'">'+K+"</h"+ee+`>
`}return"<h"+ee+">"+K+"</h"+ee+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(K,ee,he){var fe=ee?"ol":"ul",Ae=ee&&he!==1?' start="'+he+'"':"";return"<"+fe+Ae+`>
`+K+"</"+fe+`>
`},ue.listitem=function(K){return"<li>"+K+`</li>
`},ue.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(K){return"<p>"+K+`</p>
`},ue.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},ue.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ue.tablecell=function(K,ee){var he=ee.header?"th":"td",fe=ee.align?"<"+he+' align="'+ee.align+'">':"<"+he+">";return fe+K+("</"+he+`>
`)},ue.strong=function(K){return"<strong>"+K+"</strong>"},ue.em=function(K){return"<em>"+K+"</em>"},ue.codespan=function(K){return"<code>"+K+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(K){return"<del>"+K+"</del>"},ue.link=function(K,ee,he){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return he;var fe='<a href="'+v(K)+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=">"+he+"</a>",fe},ue.image=function(K,ee,he){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return he;var fe='<img src="'+K+'" alt="'+he+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=this.options.xhtml?"/>":">",fe},ue.text=function(K){return K},le}(),_=function(){function le(){}var ue=le.prototype;return ue.strong=function(K){return K},ue.em=function(K){return K},ue.codespan=function(K){return K},ue.del=function(K){return K},ue.html=function(K){return K},ue.text=function(K){return K},ue.link=function(K,ee,he){return""+he},ue.image=function(K,ee,he){return""+he},ue.br=function(){return""},le}(),Y=function(){function le(){this.seen={}}var ue=le.prototype;return ue.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(K,ee){var he=K,fe=0;if(this.seen.hasOwnProperty(he)){fe=this.seen[K];do fe++,he=K+"-"+fe;while(this.seen.hasOwnProperty(he))}return ee||(this.seen[K]=fe,this.seen[he]=0),he},ue.slug=function(K,ee){ee===void 0&&(ee={});var he=this.serialize(K);return this.getNextSafeSlug(he,ee.dryrun)},le}(),x=function(){function le(oe){this.options=oe||de.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new Y}le.parse=function(K,ee){var he=new le(ee);return he.parse(K)},le.parseInline=function(K,ee){var he=new le(ee);return he.parseInline(K)};var ue=le.prototype;return ue.parse=function(K,ee){ee===void 0&&(ee=!0);var he="",fe,Ae,pe,Ce,Me,Fe,V,q,Q,J,ge,we,Te,He,Xe,tt,nt,at,st,Ie=K.length;for(fe=0;fe<Ie;fe++){if(J=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(st=this.options.extensions.renderers[J.type].call({parser:this},J),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){he+=st||"";continue}switch(J.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(q="",V="",Ce=J.header.length,Ae=0;Ae<Ce;Ae++)V+=this.renderer.tablecell(this.parseInline(J.header[Ae].tokens),{header:!0,align:J.align[Ae]});for(q+=this.renderer.tablerow(V),Q="",Ce=J.rows.length,Ae=0;Ae<Ce;Ae++){for(Fe=J.rows[Ae],V="",Me=Fe.length,pe=0;pe<Me;pe++)V+=this.renderer.tablecell(this.parseInline(Fe[pe].tokens),{header:!1,align:J.align[pe]});Q+=this.renderer.tablerow(V)}he+=this.renderer.table(q,Q);continue}case"blockquote":{Q=this.parse(J.tokens),he+=this.renderer.blockquote(Q);continue}case"list":{for(ge=J.ordered,we=J.start,Te=J.loose,Ce=J.items.length,Q="",Ae=0;Ae<Ce;Ae++)Xe=J.items[Ae],tt=Xe.checked,nt=Xe.task,He="",Xe.task&&(at=this.renderer.checkbox(tt),Te?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=at+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=at+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(Xe.tokens,Te),Q+=this.renderer.listitem(He,nt,tt);he+=this.renderer.list(Q,ge,we);continue}case"html":{he+=this.renderer.html(J.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;fe+1<Ie&&K[fe+1].type==="text";)J=K[++fe],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);he+=ee?this.renderer.paragraph(Q):Q;continue}default:{var ze='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return he},ue.parseInline=function(K,ee){ee=ee||this.renderer;var he="",fe,Ae,pe,Ce=K.length;for(fe=0;fe<Ce;fe++){if(Ae=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(pe=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){he+=pe||"";continue}switch(Ae.type){case"escape":{he+=ee.text(Ae.text);break}case"html":{he+=ee.html(Ae.text);break}case"link":{he+=ee.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ee));break}case"image":{he+=ee.image(Ae.href,Ae.title,Ae.text);break}case"strong":{he+=ee.strong(this.parseInline(Ae.tokens,ee));break}case"em":{he+=ee.em(this.parseInline(Ae.tokens,ee));break}case"codespan":{he+=ee.codespan(Ae.text);break}case"br":{he+=ee.br();break}case"del":{he+=ee.del(this.parseInline(Ae.tokens,ee));break}case"text":{he+=ee.text(Ae.text);break}default:{var Me='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},le}();function ce(le,ue,oe){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ue=="function"&&(oe=ue,ue=null),ue=f({},ce.defaults,ue||{}),y(ue),oe){var K=ue.highlight,ee;try{ee=U.lex(le,ue)}catch(Ce){return oe(Ce)}var he=function(Me){var Fe;if(!Me)try{ue.walkTokens&&ce.walkTokens(ee,ue.walkTokens),Fe=x.parse(ee,ue)}catch(V){Me=V}return ue.highlight=K,Me?oe(Me):oe(null,Fe)};if(!K||K.length<3||(delete ue.highlight,!ee.length))return he();var fe=0;ce.walkTokens(ee,function(Ce){Ce.type==="code"&&(fe++,setTimeout(function(){K(Ce.text,Ce.lang,function(Me,Fe){if(Me)return he(Me);Fe!=null&&Fe!==Ce.text&&(Ce.text=Fe,Ce.escaped=!0),fe--,fe===0&&he()})},0))}),fe===0&&he();return}function Ae(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(Ce.message+"",!0)+"</pre>";throw Ce}try{var pe=U.lex(le,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ce.walkTokens(pe,ue.walkTokens)).then(function(){return x.parse(pe,ue)}).catch(Ae);ce.walkTokens(pe,ue.walkTokens)}return x.parse(pe,ue)}catch(Ce){Ae(Ce)}}ce.options=ce.setOptions=function(le){return f(ce.defaults,le),p(ce.defaults),ce},ce.getDefaults=A,ce.defaults=de.defaults,ce.use=function(){for(var le=arguments.length,ue=new Array(le),oe=0;oe<le;oe++)ue[oe]=arguments[oe];var K=f.apply(void 0,[{}].concat(ue)),ee=ce.defaults.extensions||{renderers:{},childTokens:{}},he;ue.forEach(function(fe){if(fe.extensions&&(he=!0,fe.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Ce=ee.renderers?ee.renderers[pe.name]:null;Ce?ee.renderers[pe.name]=function(){for(var Me=arguments.length,Fe=new Array(Me),V=0;V<Me;V++)Fe[V]=arguments[V];var q=pe.renderer.apply(this,Fe);return q===!1&&(q=Ce.apply(this,Fe)),q}:ee.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[pe.level]?ee[pe.level].unshift(pe.tokenizer):ee[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?ee.startBlock?ee.startBlock.push(pe.start):ee.startBlock=[pe.start]:pe.level==="inline"&&(ee.startInline?ee.startInline.push(pe.start):ee.startInline=[pe.start]))}pe.childTokens&&(ee.childTokens[pe.name]=pe.childTokens)})),fe.renderer&&function(){var pe=ce.defaults.renderer||new Z,Ce=function(V){var q=pe[V];pe[V]=function(){for(var Q=arguments.length,J=new Array(Q),ge=0;ge<Q;ge++)J[ge]=arguments[ge];var we=fe.renderer[V].apply(pe,J);return we===!1&&(we=q.apply(pe,J)),we}};for(var Me in fe.renderer)Ce(Me);K.renderer=pe}(),fe.tokenizer&&function(){var pe=ce.defaults.tokenizer||new F,Ce=function(V){var q=pe[V];pe[V]=function(){for(var Q=arguments.length,J=new Array(Q),ge=0;ge<Q;ge++)J[ge]=arguments[ge];var we=fe.tokenizer[V].apply(pe,J);return we===!1&&(we=q.apply(pe,J)),we}};for(var Me in fe.tokenizer)Ce(Me);K.tokenizer=pe}(),fe.walkTokens){var Ae=ce.defaults.walkTokens;K.walkTokens=function(pe){var Ce=[];return Ce.push(fe.walkTokens.call(this,pe)),Ae&&(Ce=Ce.concat(Ae.call(this,pe))),Ce}}he&&(K.extensions=ee),ce.setOptions(K)})},ce.walkTokens=function(le,ue){for(var oe=[],K=function(){var Ae=he.value;switch(oe=oe.concat(ue.call(ce,Ae)),Ae.type){case"table":{for(var pe=P(Ae.header),Ce;!(Ce=pe()).done;){var Me=Ce.value;oe=oe.concat(ce.walkTokens(Me.tokens,ue))}for(var Fe=P(Ae.rows),V;!(V=Fe()).done;)for(var q=V.value,Q=P(q),J;!(J=Q()).done;){var ge=J.value;oe=oe.concat(ce.walkTokens(ge.tokens,ue))}break}case"list":{oe=oe.concat(ce.walkTokens(Ae.items,ue));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(we){oe=oe.concat(ce.walkTokens(Ae[we],ue))}):Ae.tokens&&(oe=oe.concat(ce.walkTokens(Ae.tokens,ue)))}},ee=P(le),he;!(he=ee()).done;)K();return oe},ce.parseInline=function(le,ue){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ue=f({},ce.defaults,ue||{}),y(ue);try{var oe=U.lexInline(le,ue);return ue.walkTokens&&ce.walkTokens(oe,ue.walkTokens),x.parseInline(oe,ue)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},ce.Parser=x,ce.parser=x.parse,ce.Renderer=Z,ce.TextRenderer=_,ce.Lexer=U,ce.lexer=U.lex,ce.Tokenizer=F,ce.Slugger=Y,ce.parse=ce;var X=ce.options,me=ce.setOptions,ae=ce.use,re=ce.walkTokens,W=ce.parseInline,ie=ce,ve=x.parse,Pe=U.lex;de.Lexer=U,de.Parser=x,de.Renderer=Z,de.Slugger=Y,de.TextRenderer=_,de.Tokenizer=F,de.getDefaults=A,de.lexer=Pe,de.marked=ce,de.options=X,de.parse=ie,de.parseInline=W,de.parser=ve,de.setOptions=me,de.use=ae,de.walkTokens=re,Object.defineProperty(de,"__esModule",{value:!0})}),define(Ee[165],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=u;function u(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}let j=0;const R=new Uint32Array(10);function P(c){if(j=0,A(c,I,4352),j>0||(A(c,b,4449),j>0)||(A(c,E,4520),j>0)||(A(c,v,12593),j))return R.subarray(0,j);if(c>=44032&&c<=55203){const m=c-44032,a=m%588,n=Math.floor(m/588),i=Math.floor(a/28),r=a%28-1;if(n<I.length?A(n,I,0):4352+n-12593<v.length&&A(4352+n,v,12593),i<b.length?A(i,b,0):4449+i-12593<v.length&&A(4449+i-12593,v,12593),r>=0&&(r<E.length?A(r,E,0):4520+r-12593<v.length&&A(4520+r-12593,v,12593)),j>0)return R.subarray(0,j)}}function A(c,m,a){c>=a&&c<a+m.length&&p(m[c-a])}function p(c){c!==0&&(R[j++]=c&255,c>>8&&(R[j++]=c>>8&255),c>>16&&(R[j++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(k||(k={}));var M;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(M||(M={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[76],Se([1,0,28]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=void 0,e.$Yl=R,e.$Zl=A;const j=new u.$Ec(1e4);function R(k){return $(k,"NFC",j)}const P=new u.$Ec(1e4);function A(k){return $(k,"NFD",P)}const p=/[^\u0000-\u0080]/;function $(k,M,I){if(!k)return k;const b=I.get(k);if(b)return b;let E;return p.test(k)?E=k.normalize(M):E=k,I.set(k,E),E}e.$1l=function(){const k=/[\u0300-\u036f]/g;return function(M){return A(M).replace(k,"")}}()}),define(Ee[125],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=u,e.rot=j;function u(p,$,k){return Math.min(Math.max(p,$),k)}function j(p,$){return($+p%$)%$}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$om=R;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=P;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=A}),function(){function de(R){const P=[];typeof R=="number"&&P.push("code/timeOrigin",R);function A($){P.push($,Date.now())}function p(){const $=[];for(let k=0;k<P.length;k+=2)$.push({name:P[k],startTime:P[k+1]});return $}return{mark:A,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?de():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(R+A.startTime)});return P}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return de(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),de()}function u(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=u(j))}(),define(Ee[166],Se([1,0,38]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;const j=Symbol("unset");class R{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert($,k,M){this.d($,I=>I._value=k,M)}mutate($,k){this.d($,M=>M._value=k(M._value===j?void 0:M._value))}delete($){const k=this.c($);if(!k)return;let M=k.length-1;const I=k[M].node._value;if(I!==j){for(this.b--,k[M].node._value=j;M>0;M--){const{node:b,part:E}=k[M];if(b.children?.size||b._value!==j)break;k[M-1].node.children.delete(E)}return I}}*deleteRecursive($){const k=this.c($);if(!k)return;const M=k[k.length-1].node;for(let I=k.length-1;I>0;I--){const b=k[I-1];if(b.node.children.delete(k[I].part),b.node.children.size>0||b.node._value!==j)break}for(const I of P(M))I._value!==j&&(this.b--,yield I._value)}find($){let k=this.a;for(const M of $){const I=k.children?.get(M);if(!I)return;k=I}return k._value===j?void 0:k._value}hasKeyOrParent($){let k=this.a;for(const M of $){const I=k.children?.get(M);if(!I)return!1;if(I._value!==j)return!0;k=I}return!1}hasKeyOrChildren($){let k=this.a;for(const M of $){const I=k.children?.get(M);if(!I)return!1;k=I}return!0}hasKey($){let k=this.a;for(const M of $){const I=k.children?.get(M);if(!I)return!1;k=I}return k._value!==j}c($){const k=[{part:"",node:this.a}];let M=0;for(const I of $){const b=k[M].node.children?.get(I);if(!b)return;k.push({part:I,node:b}),M++}return k}d($,k,M){let I=this.a;for(const v of $){if(I.children)if(I.children.has(v))I=I.children.get(v);else{const c=new A;I.children.set(v,c),I=c}else{const c=new A;I.children=new Map([[v,c]]),I=c}M?.(I)}const b=I._value===j?0:1;k(I);const E=I._value===j?0:1;this.b+=E-b}*values(){for(const{_value:$}of P(this.a))$!==j&&(yield $)}}e.$rO=R;function*P(p){const $=[p];for(;$.length>0;){const k=$.pop();if(yield k,k.children)for(const M of k.children.values())$.push(M)}}class A{constructor(){this._value=j}get value(){return this._value===j?void 0:this._value}set value($){this._value=$===void 0?j:$}}}),function(de,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var j in u)(typeof exports=="object"?exports:de)[j]=u[j]}}(typeof self<"u"?self:this,function(){return function(de){var e={};function u(j){if(e[j])return e[j].exports;var R=e[j]={i:j,l:!1,exports:{}};return de[j].call(R.exports,R,R.exports,u),R.l=!0,R.exports}return u.m=de,u.c=e,u.d=function(j,R,P){u.o(j,R)||Object.defineProperty(j,R,{enumerable:!0,get:P})},u.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},u.t=function(j,R){if(1&R&&(j=u(j)),8&R||4&R&&typeof j=="object"&&j&&j.__esModule)return j;var P=Object.create(null);if(u.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:j}),2&R&&typeof j!="string")for(var A in j)u.d(P,A,function(p){return j[p]}.bind(null,A));return P},u.n=function(j){var R=j&&j.__esModule?function(){return j.default}:function(){return j};return u.d(R,"a",R),R},u.o=function(j,R){return Object.prototype.hasOwnProperty.call(j,R)},u.p="",u(u.s=0)}([function(de,e,u){(function(j){var R;e=de.exports=ae,R=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],k=0,M=k++;$[M]="0|[1-9]\\d*";var I=k++;$[I]="[0-9]+";var b=k++;$[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;$[E]="("+$[M]+")\\.("+$[M]+")\\.("+$[M]+")";var v=k++;$[v]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var c=k++;$[c]="(?:"+$[M]+"|"+$[b]+")";var m=k++;$[m]="(?:"+$[I]+"|"+$[b]+")";var a=k++;$[a]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var n=k++;$[n]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var i=k++;$[i]="[0-9A-Za-z-]+";var r=k++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var s=k++,t="v?"+$[E]+$[a]+"?"+$[r]+"?";$[s]="^"+t+"$";var g="[v=\\s]*"+$[v]+$[n]+"?"+$[r]+"?",d=k++;$[d]="^"+g+"$";var l=k++;$[l]="((?:<|>)?=?)";var o=k++;$[o]=$[I]+"|x|X|\\*";var h=k++;$[h]=$[M]+"|x|X|\\*";var f=k++;$[f]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[a]+")?"+$[r]+"?)?)?";var D=k++;$[D]="[v=\\s]*("+$[o]+")(?:\\.("+$[o]+")(?:\\.("+$[o]+")(?:"+$[n]+")?"+$[r]+"?)?)?";var w=k++;$[w]="^"+$[l]+"\\s*"+$[f]+"$";var S=k++;$[S]="^"+$[l]+"\\s*"+$[D]+"$";var y=k++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;$[C]="(?:~>?)";var O=k++;$[O]="(\\s*)"+$[C]+"\\s+",p[O]=new RegExp($[O],"g");var z=k++;$[z]="^"+$[C]+$[f]+"$";var F=k++;$[F]="^"+$[C]+$[D]+"$";var T=k++;$[T]="(?:\\^)";var L=k++;$[L]="(\\s*)"+$[T]+"\\s+",p[L]=new RegExp($[L],"g");var N=k++;$[N]="^"+$[T]+$[f]+"$";var B=k++;$[B]="^"+$[T]+$[D]+"$";var U=k++;$[U]="^"+$[l]+"\\s*("+g+")$|^$";var Z=k++;$[Z]="^"+$[l]+"\\s*("+t+")$|^$";var _=k++;$[_]="(\\s*)"+$[l]+"\\s*("+g+"|"+$[f]+")",p[_]=new RegExp($[_],"g");var Y=k++;$[Y]="^\\s*("+$[f]+")\\s+-\\s+("+$[f]+")\\s*$";var x=k++;$[x]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ce=k++;$[ce]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)R(X,$[X]),p[X]||(p[X]=new RegExp($[X]));function me(q,Q){if(q instanceof ae)return q;if(typeof q!="string"||q.length>P||!(Q?p[d]:p[s]).test(q))return null;try{return new ae(q,Q)}catch{return null}}function ae(q,Q){if(q instanceof ae){if(q.loose===Q)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ae))return new ae(q,Q);R("SemVer",q,Q),this.loose=Q;var J=q.trim().match(Q?p[d]:p[s]);if(!J)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var we=+ge;if(we>=0&&we<A)return we}return ge}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=me,e.valid=function(q,Q){var J=me(q,Q);return J?J.version:null},e.clean=function(q,Q){var J=me(q.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=ae,ae.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ae.prototype.toString=function(){return this.version},ae.prototype.compare=function(q){return R("SemVer.compare",this.version,this.loose,q),q instanceof ae||(q=new ae(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ae.prototype.compareMain=function(q){return q instanceof ae||(q=new ae(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},ae.prototype.comparePre=function(q){if(q instanceof ae||(q=new ae(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],ge=q.prerelease[Q];if(R("prerelease compare",Q,J,ge),J===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(J===void 0)return-1;if(J!==ge)return W(J,ge)}while(++Q)},ae.prototype.inc=function(q,Q){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Q,J,ge){typeof J=="string"&&(ge=J,J=void 0);try{return new ae(q,J).inc(Q,ge).version}catch{return null}},e.diff=function(q,Q){if(le(q,Q))return null;var J=me(q),ge=me(Q);if(J.prerelease.length||ge.prerelease.length){for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==ge[we])return"pre"+we;return"prerelease"}for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==ge[we])return we},e.compareIdentifiers=W;var re=/^[0-9]+$/;function W(q,Q){var J=re.test(q),ge=re.test(Q);return J&&ge&&(q=+q,Q=+Q),J&&!ge?-1:ge&&!J?1:q<Q?-1:q>Q?1:0}function ie(q,Q,J){return new ae(q,J).compare(new ae(Q,J))}function ve(q,Q,J){return ie(q,Q,J)>0}function Pe(q,Q,J){return ie(q,Q,J)<0}function le(q,Q,J){return ie(q,Q,J)===0}function ue(q,Q,J){return ie(q,Q,J)!==0}function oe(q,Q,J){return ie(q,Q,J)>=0}function K(q,Q,J){return ie(q,Q,J)<=0}function ee(q,Q,J,ge){var we;switch(Q){case"===":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),we=q===J;break;case"!==":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),we=q!==J;break;case"":case"=":case"==":we=le(q,J,ge);break;case"!=":we=ue(q,J,ge);break;case">":we=ve(q,J,ge);break;case">=":we=oe(q,J,ge);break;case"<":we=Pe(q,J,ge);break;case"<=":we=K(q,J,ge);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function he(q,Q){if(q instanceof he){if(q.loose===Q)return q;q=q.value}if(!(this instanceof he))return new he(q,Q);R("comparator",q,Q),this.loose=Q,this.parse(q),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(q,Q){return W(Q,q)},e.major=function(q,Q){return new ae(q,Q).major},e.minor=function(q,Q){return new ae(q,Q).minor},e.patch=function(q,Q){return new ae(q,Q).patch},e.compare=ie,e.compareLoose=function(q,Q){return ie(q,Q,!0)},e.rcompare=function(q,Q,J){return ie(Q,q,J)},e.sort=function(q,Q){return q.sort(function(J,ge){return e.compare(J,ge,Q)})},e.rsort=function(q,Q){return q.sort(function(J,ge){return e.rcompare(J,ge,Q)})},e.gt=ve,e.lt=Pe,e.eq=le,e.neq=ue,e.gte=oe,e.lte=K,e.cmp=ee,e.Comparator=he;var fe={};function Ae(q,Q){if(q instanceof Ae)return q.loose===Q?q:new Ae(q.raw,Q);if(q instanceof he)return new Ae(q.value,Q);if(!(this instanceof Ae))return new Ae(q,Q);if(this.loose=Q,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function pe(q){return!q||q.toLowerCase()==="x"||q==="*"}function Ce(q,Q,J,ge,we,Te,He,Xe,tt,nt,at,st,Ie){return((Q=pe(J)?"":pe(ge)?">="+J+".0.0":pe(we)?">="+J+"."+ge+".0":">="+Q)+" "+(Xe=pe(tt)?"":pe(nt)?"<"+(+tt+1)+".0.0":pe(at)?"<"+tt+"."+(+nt+1)+".0":st?"<="+tt+"."+nt+"."+at+"-"+st:"<="+Xe)).trim()}function Me(q,Q){for(var J=0;J<q.length;J++)if(!q[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<q.length;J++)if(R(q[J].semver),q[J].semver!==fe&&q[J].semver.prerelease.length>0){var ge=q[J].semver;if(ge.major===Q.major&&ge.minor===Q.minor&&ge.patch===Q.patch)return!0}return!1}return!0}function Fe(q,Q,J){try{Q=new Ae(Q,J)}catch{return!1}return Q.test(q)}function V(q,Q,J,ge){var we,Te,He,Xe,tt;switch(q=new ae(q,ge),Q=new Ae(Q,ge),J){case">":we=ve,Te=K,He=Pe,Xe=">",tt=">=";break;case"<":we=Pe,Te=oe,He=ve,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(q,Q,ge))return!1;for(var nt=0;nt<Q.set.length;++nt){var at=Q.set[nt],st=null,Ie=null;if(at.forEach(function(ze){ze.semver===fe&&(ze=new he(">=0.0.0")),st=st||ze,Ie=Ie||ze,we(ze.semver,st.semver,ge)?st=ze:He(ze.semver,Ie.semver,ge)&&(Ie=ze)}),st.operator===Xe||st.operator===tt||(!Ie.operator||Ie.operator===Xe)&&Te(q,Ie.semver)||Ie.operator===tt&&He(q,Ie.semver))return!1}return!0}he.prototype.parse=function(q){var Q=this.loose?p[U]:p[Z],J=q.match(Q);if(!J)throw new TypeError("Invalid comparator: "+q);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new ae(J[2],this.loose):this.semver=fe},he.prototype.toString=function(){return this.value},he.prototype.test=function(q){return R("Comparator.test",q,this.loose),this.semver===fe||(typeof q=="string"&&(q=new ae(q,this.loose)),ee(q,this.operator,this.semver,this.loose))},he.prototype.intersects=function(q,Q){if(!(q instanceof he))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Ae(q.value,Q),Fe(this.value,J,Q);if(q.operator==="")return J=new Ae(this.value,Q),Fe(q.semver,J,Q);var ge=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Te=this.semver.version===q.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Xe=ee(this.semver,"<",q.semver,Q)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),tt=ee(this.semver,">",q.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return ge||we||Te&&He||Xe||tt},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(q){var Q=this.loose;q=q.trim(),R("range",q,Q);var J=Q?p[x]:p[Y];q=q.replace(J,Ce),R("hyphen replace",q),q=q.replace(p[_],"$1$2$3"),R("comparator trim",q,p[_]),q=(q=(q=q.replace(p[O],"$1~")).replace(p[L],"$1^")).split(/\s+/).join(" ");var ge=Q?p[U]:p[Z],we=q.split(" ").map(function(Te){return function(He,Xe){return R("comp",He),He=function(tt,nt){return tt.trim().split(/\s+/).map(function(at){return function(st,Ie){R("caret",st,Ie);var ze=Ie?p[B]:p[N];return st.replace(ze,function(Re,Ge,ne,se,De){var Ke;return R("caret",st,Re,Ge,ne,se,De),pe(Ge)?Ke="":pe(ne)?Ke=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":pe(se)?Ke=Ge==="0"?">="+Ge+"."+ne+".0 <"+Ge+"."+(+ne+1)+".0":">="+Ge+"."+ne+".0 <"+(+Ge+1)+".0.0":De?(R("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ke=Ge==="0"?ne==="0"?">="+Ge+"."+ne+"."+se+De+" <"+Ge+"."+ne+"."+(+se+1):">="+Ge+"."+ne+"."+se+De+" <"+Ge+"."+(+ne+1)+".0":">="+Ge+"."+ne+"."+se+De+" <"+(+Ge+1)+".0.0"):(R("no pr"),Ke=Ge==="0"?ne==="0"?">="+Ge+"."+ne+"."+se+" <"+Ge+"."+ne+"."+(+se+1):">="+Ge+"."+ne+"."+se+" <"+Ge+"."+(+ne+1)+".0":">="+Ge+"."+ne+"."+se+" <"+(+Ge+1)+".0.0"),R("caret return",Ke),Ke})}(at,nt)}).join(" ")}(He,Xe),R("caret",He),He=function(tt,nt){return tt.trim().split(/\s+/).map(function(at){return function(st,Ie){var ze=Ie?p[F]:p[z];return st.replace(ze,function(Re,Ge,ne,se,De){var Ke;return R("tilde",st,Re,Ge,ne,se,De),pe(Ge)?Ke="":pe(ne)?Ke=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":pe(se)?Ke=">="+Ge+"."+ne+".0 <"+Ge+"."+(+ne+1)+".0":De?(R("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ke=">="+Ge+"."+ne+"."+se+De+" <"+Ge+"."+(+ne+1)+".0"):Ke=">="+Ge+"."+ne+"."+se+" <"+Ge+"."+(+ne+1)+".0",R("tilde return",Ke),Ke})}(at,nt)}).join(" ")}(He,Xe),R("tildes",He),He=function(tt,nt){return R("replaceXRanges",tt,nt),tt.split(/\s+/).map(function(at){return function(st,Ie){st=st.trim();var ze=Ie?p[S]:p[w];return st.replace(ze,function(Re,Ge,ne,se,De,Ke){R("xRange",st,Re,Ge,ne,se,De,Ke);var xe=pe(ne),ot=xe||pe(se),Ne=ot||pe(De);return Ge==="="&&Ne&&(Ge=""),xe?Re=Ge===">"||Ge==="<"?"<0.0.0":"*":Ge&&Ne?(ot&&(se=0),Ne&&(De=0),Ge===">"?(Ge=">=",ot?(ne=+ne+1,se=0,De=0):Ne&&(se=+se+1,De=0)):Ge==="<="&&(Ge="<",ot?ne=+ne+1:se=+se+1),Re=Ge+ne+"."+se+"."+De):ot?Re=">="+ne+".0.0 <"+(+ne+1)+".0.0":Ne&&(Re=">="+ne+"."+se+".0 <"+ne+"."+(+se+1)+".0"),R("xRange return",Re),Re})}(at,nt)}).join(" ")}(He,Xe),R("xrange",He),He=function(tt,nt){return R("replaceStars",tt,nt),tt.trim().replace(p[ce],"")}(He,Xe),R("stars",He),He}(Te,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(ge)})),we=we.map(function(Te){return new he(Te,Q)})},Ae.prototype.intersects=function(q,Q){if(!(q instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ge){return q.set.some(function(we){return we.every(function(Te){return ge.intersects(Te,Q)})})})})},e.toComparators=function(q,Q){return new Ae(q,Q).set.map(function(J){return J.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ae(q,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Me(this.set[Q],q))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(q,Q,J){var ge=null,we=null;try{var Te=new Ae(Q,J)}catch{return null}return q.forEach(function(He){Te.test(He)&&(ge&&we.compare(He)!==-1||(we=new ae(ge=He,J)))}),ge},e.minSatisfying=function(q,Q,J){var ge=null,we=null;try{var Te=new Ae(Q,J)}catch{return null}return q.forEach(function(He){Te.test(He)&&(ge&&we.compare(He)!==1||(we=new ae(ge=He,J)))}),ge},e.validRange=function(q,Q){try{return new Ae(q,Q).range||"*"}catch{return null}},e.ltr=function(q,Q,J){return V(q,Q,"<",J)},e.gtr=function(q,Q,J){return V(q,Q,">",J)},e.outside=V,e.prerelease=function(q,Q){var J=me(q,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(q,Q,J){return q=new Ae(q,J),Q=new Ae(Q,J),q.intersects(Q)},e.coerce=function(q){if(q instanceof ae)return q;if(typeof q!="string")return null;var Q=q.match(p[y]);return Q==null?null:me((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,u(1))},function(de,e){var u,j,R=de.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function p(m){if(u===setTimeout)return setTimeout(m,0);if((u===P||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:P}catch{u=P}try{j=typeof clearTimeout=="function"?clearTimeout:A}catch{j=A}})();var $,k=[],M=!1,I=-1;function b(){M&&$&&(M=!1,$.length?k=$.concat(k):I=-1,k.length&&E())}function E(){if(!M){var m=p(b);M=!0;for(var a=k.length;a;){for($=k,k=[];++I<a;)$&&$[I].run();I=-1,a=k.length}$=null,M=!1,function(n){if(j===clearTimeout)return clearTimeout(n);if((j===A||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(n);try{j(n)}catch{try{return j.call(null,n)}catch{return j.call(this,n)}}}(m)}}function v(m,a){this.fun=m,this.array=a}function c(){}R.nextTick=function(m){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];k.push(new v(m,a)),k.length!==1||M||p(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=c,R.addListener=c,R.once=c,R.off=c,R.removeListener=c,R.removeAllListeners=c,R.emit=c,R.prependListener=c,R.prependOnceListener=c,R.listeners=function(m){return[]},R.binding=function(m){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(m){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Ee[39],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class j{static create(P){return new j(P)}constructor(P){this.c=u&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=j}),define(Ee[4],Se([1,0,13,74,3,75,39]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=E;const p=!1,$=!1,k=!1;var M;(function(y){y.None=()=>R.$Uc.None;function C(he){if(k){const{onDidAddListener:fe}=he,Ae=c.create();let pe=0;he.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),fe?.()}}}function O(he,fe){return Y(he,()=>{},0,void 0,!0,void 0,fe)}y.defer=O;function z(he){return(fe,Ae=null,pe)=>{let Ce=!1,Me;return Me=he(Fe=>{if(!Ce)return Me?Me.dispose():Ce=!0,fe.call(Ae,Fe)},null,pe),Ce&&Me.dispose(),Me}}y.once=z;function F(he,fe,Ae){return Z((pe,Ce=null,Me)=>he(Fe=>pe.call(Ce,fe(Fe)),null,Me),Ae)}y.map=F;function T(he,fe,Ae){return Z((pe,Ce=null,Me)=>he(Fe=>{fe(Fe),pe.call(Ce,Fe)},null,Me),Ae)}y.forEach=T;function L(he,fe,Ae){return Z((pe,Ce=null,Me)=>he(Fe=>fe(Fe)&&pe.call(Ce,Fe),null,Me),Ae)}y.filter=L;function N(he){return he}y.signal=N;function B(...he){return(fe,Ae=null,pe)=>{const Ce=(0,R.$Rc)(...he.map(Me=>Me(Fe=>fe.call(Ae,Fe))));return _(Ce,pe)}}y.any=B;function U(he,fe,Ae,pe){let Ce=Ae;return F(he,Me=>(Ce=fe(Ce,Me),Ce),pe)}y.reduce=U;function Z(he,fe){let Ae;const pe={onWillAddFirstListener(){Ae=he(Ce.fire,Ce)},onDidRemoveLastListener(){Ae?.dispose()}};fe||C(pe);const Ce=new s(pe);return fe?.add(Ce),Ce.event}function _(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function Y(he,fe,Ae=100,pe=!1,Ce=!1,Me,Fe){let V,q,Q,J=0,ge;const we={leakWarningThreshold:Me,onWillAddFirstListener(){V=he(He=>{J++,q=fe(q,He),pe&&!Q&&(Te.fire(q),q=void 0),ge=()=>{const Xe=q;q=void 0,Q=void 0,(!pe||J>1)&&Te.fire(Xe),J=0},typeof Ae=="number"?(clearTimeout(Q),Q=setTimeout(ge,Ae)):Q===void 0&&(Q=0,queueMicrotask(ge))})},onWillRemoveListener(){Ce&&J>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,V.dispose()}};Fe||C(we);const Te=new s(we);return Fe?.add(Te),Te.event}y.debounce=Y;function x(he,fe=0,Ae){return y.debounce(he,(pe,Ce)=>pe?(pe.push(Ce),pe):[Ce],fe,void 0,!0,void 0,Ae)}y.accumulate=x;function ce(he,fe=(pe,Ce)=>pe===Ce,Ae){let pe=!0,Ce;return L(he,Me=>{const Fe=pe||!fe(Me,Ce);return pe=!1,Ce=Me,Fe},Ae)}y.latch=ce;function X(he,fe,Ae){return[y.filter(he,fe,Ae),y.filter(he,pe=>!fe(pe),Ae)]}y.split=X;function me(he,fe=!1,Ae=[],pe){let Ce=Ae.slice(),Me=he(q=>{Ce?Ce.push(q):V.fire(q)});pe&&pe.add(Me);const Fe=()=>{Ce?.forEach(q=>V.fire(q)),Ce=null},V=new s({onWillAddFirstListener(){Me||(Me=he(q=>V.fire(q)),pe&&pe.add(Me))},onDidAddFirstListener(){Ce&&(fe?setTimeout(Fe):Fe())},onDidRemoveLastListener(){Me&&Me.dispose(),Me=null}});return pe&&pe.add(V),V.event}y.buffer=me;function ae(he,fe){return(pe,Ce,Me)=>{const Fe=fe(new W);return he(function(V){const q=Fe.evaluate(V);q!==re&&pe.call(Ce,q)},void 0,Me)}}y.chain=ae;const re=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(Ae=>(fe(Ae),Ae)),this}filter(fe){return this.f.push(Ae=>fe(Ae)?Ae:re),this}reduce(fe,Ae){let pe=Ae;return this.f.push(Ce=>(pe=fe(pe,Ce),pe)),this}latch(fe=(Ae,pe)=>Ae===pe){let Ae=!0,pe;return this.f.push(Ce=>{const Me=Ae||!fe(Ce,pe);return Ae=!1,pe=Ce,Me?Ce:re}),this}evaluate(fe){for(const Ae of this.f)if(fe=Ae(fe),fe===re)break;return fe}}function ie(he,fe,Ae=pe=>pe){const pe=(...V)=>Fe.fire(Ae(...V)),Ce=()=>he.on(fe,pe),Me=()=>he.removeListener(fe,pe),Fe=new s({onWillAddFirstListener:Ce,onDidRemoveLastListener:Me});return Fe.event}y.fromNodeEventEmitter=ie;function ve(he,fe,Ae=pe=>pe){const pe=(...V)=>Fe.fire(Ae(...V)),Ce=()=>he.addEventListener(fe,pe),Me=()=>he.removeEventListener(fe,pe),Fe=new s({onWillAddFirstListener:Ce,onDidRemoveLastListener:Me});return Fe.event}y.fromDOMEventEmitter=ve;function Pe(he){return new Promise(fe=>z(he)(fe))}y.toPromise=Pe;function le(he){const fe=new s;return he.then(Ae=>{fe.fire(Ae)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}y.fromPromise=le;function ue(he,fe,Ae){return fe(Ae),he(pe=>fe(pe))}y.runAndSubscribe=ue;class oe{constructor(fe,Ae){this._observable=fe,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};Ae||C(pe),this.emitter=new s(pe),Ae&&Ae.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,Ae){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function K(he,fe){return new oe(he,fe).emitter.event}y.fromObservable=K;function ee(he){return(fe,Ae,pe)=>{let Ce=0,Me=!1;const Fe={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(he.reportChanges(),Me&&(Me=!1,fe.call(Ae)))},handlePossibleChange(){},handleChange(){Me=!0}};he.addObserver(Fe),he.reportChanges();const V={dispose(){he.removeObserver(Fe)}};return pe instanceof R.$Tc?pe.add(V):Array.isArray(pe)&&pe.push(V),V}}y.fromObservableLight=ee})(M||(e.Event=M={}));class I{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${I.f++}`,I.all.add(this)}start(C){this.g=new A.$3d,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}e.$5d=I;let b=-1;function E(y){const C=b;return b=y,{dispose(){b=C}}}class v{constructor(C,O=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=O,this.g=0}dispose(){this.f?.clear()}check(C,O){const z=this.threshold;if(z<=0||O<z)return;this.f||(this.f=new Map);const F=this.f.get(C.value)||0;if(this.f.set(C.value,F+1),this.g-=1,this.g<=0){this.g=z*.5;let T,L=0;for(const[N,B]of this.f)(!T||L<B)&&(T=N,L=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${L}):`),console.warn(T)}return()=>{const T=this.f.get(C.value)||0;this.f.set(C.value,T-1)}}}class c{static create(){return new c(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class a{constructor(C){this.value=C,this.id=m++}}const n=2,i=(y,C)=>{if(y instanceof a)C(y);else for(let O=0;O<y.length;O++){const z=y[O];z&&C(z)}},r=p?new FinalizationRegistry(y=>{typeof y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(y))}):void 0;class s{constructor(C){this.w=0,this.f=C,this.g=b>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const C=this.t;queueMicrotask(()=>{i(C,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,O,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.$Uc.None;if(this.m)return R.$Uc.None;O&&(C=C.bind(O));const F=new a(C);let T,L;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=c.create(),T=this.g.check(F.stack,this.w+1)),$&&(F.stack=L??c.create()),this.t?this.t instanceof a?(this.u??=new g,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const N=(0,R.$Sc)(()=>{r?.unregister(N),T?.(),this.x(F)});if(z instanceof R.$Tc?z.add(N):Array.isArray(z)&&z.push(N),r){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(N,B,N)}return N},this.q}x(C){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,z=O.indexOf(C);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[z]=void 0;const F=this.u.current===this;if(this.w*n<=O.length){let T=0;for(let L=0;L<O.length;L++)O[L]?O[T++]=O[L]:F&&(this.u.end--,T<this.u.i&&this.u.i--);O.length=T}}y(C,O){if(!C)return;const z=this.f?.onListenerError||u.$1;if(!z){C.value(O);return}try{C.value(O)}catch(F){z(F)}}z(C){const O=C.current.t;for(;C.i<C.end;)this.y(O[C.i++],C.value);C.reset()}fire(C){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,C);else{const O=this.u;O.enqueue(this,C,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=s;const t=()=>new g;e.$8d=t;class g{constructor(){this.i=-1,this.end=0}enqueue(C,O,z){this.i=0,this.end=z,this.current=C,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(C,O,z){if(this.t)for(this.h||(this.h=new P.$5c),i(this.t,F=>this.h.push([F.value,C]));this.h.size>0&&!O.isCancellationRequested;){const[F,T]=this.h.shift(),L=[],N={...T,token:O,waitUntil:B=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");z&&(B=z(B,F)),L.push(B)}};try{F(N)}catch(B){(0,u.$1)(B);continue}Object.freeze(L),await Promise.allSettled(L).then(B=>{for(const U of B)U.status==="rejected"&&(0,u.$1)(U.reason)})}}}e.$9d=d;class l extends s{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new P.$5c,this.A=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.A(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.w&&(this.h!==0?this.s.push(C):super.fire(C))}}e.$0d=l;class o extends l{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}e.$$d=o;class h extends s{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}e.$_d=h;class f{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const O={event:C,listener:null};this.h.push(O),this.g&&this.m(O);const z=()=>{this.g&&this.o(O);const F=this.h.indexOf(O);this.h.splice(F,1)};return(0,R.$Sc)((0,j.$db)(z))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(O=>this.f.fire(O))}o(C){C.listener?.dispose(),C.listener=null}dispose(){this.f.dispose();for(const C of this.h)C.listener?.dispose();this.h=[]}}e.$ae=f;class D{constructor(C,O,z,F){this.f=new R.$Tc;const T=this.f.add(new f),L=this.f.add(new R.$4c);function N(B){L.set(B,T.add(F(B)))}for(const B of C)N(B);this.f.add(O(B=>{N(B)})),this.f.add(z(B=>{L.deleteAndDispose(B)})),this.event=T.event}dispose(){this.f.dispose()}}e.$be=D;class w{constructor(){this.f=[]}wrapEvent(C){return(O,z,F)=>C(T=>{const L=this.f[this.f.length-1];L?L.push(()=>O.call(z,T)):O.call(z,T)},void 0,F)}bufferEvents(C){const O=[];this.f.push(O);const z=C();return this.f.pop(),O.forEach(F=>F()),z}}e.$ce=w;class S{constructor(){this.f=!1,this.g=M.None,this.h=R.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=S}),define(Ee[22],Se([1,0,4]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const j=Object.freeze(function(p,$){const k=setTimeout(p.bind($),0);return{dispose(){clearTimeout(k)}}});var R;(function(p){function $(k){return k===p.None||k===p.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}p.isCancellationToken=$,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:j})})(R||(e.CancellationToken=R={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?j:(this.b||(this.b=new u.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=R.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=R.None}}e.$ee=A}),define(Ee[167],Se([1,0,22]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class j{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new u.$ee,$=this.b(p.token);return this.a={promise:$,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Pe=j;class R{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const $=JSON.stringify(p);return this.b!==$&&(this.b=$,this.a=this.c(p)),this.a}}e.$Qe=R;class P{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const $=this.b(p);return this.a.set(p,$),$}}e.$Re=P}),define(Ee[98],Se([1,0,13,3]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=R,e.$ge=P,e.$he=A,e.$ie=p,e.$je=k,e.$ke=M,e.$le=I,e.$me=b,e.$ne=E,e.$oe=v,e.$pe=c,e.$qe=m,e.$re=a,e.$se=n,e.$te=i;function R(r){const s=r;return s?typeof s.read=="function":!1}function P(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function A(r){const s=r;return s?P(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function p(r,s){return new $(r,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let g;switch(s){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const d=g.indexOf(t);d>=0&&g.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(r,s){const t=[];let g;for(;(g=r.read())!==null;)t.push(g);return s(t)}function M(r,s,t){const g=[];let d;for(;(d=r.read())!==null&&g.length<t;)g.push(d);return d===null&&g.length>0?s(g):{read:()=>{if(g.length>0)return g.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function I(r,s){return new Promise((t,g)=>{const d=[];b(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?g(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function b(r,s,t){r.on("error",g=>{t?.isCancellationRequested||s.onError(g)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",g=>{t?.isCancellationRequested||s.onData(g)})}function E(r,s){return new Promise((t,g)=>{const d=new j.$Tc,l=[],o=D=>{if(l.push(D),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=D=>(d.dispose(),g(D)),f=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,j.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,j.$Sc)(()=>r.removeListener("end",f))),r.on("end",f),d.add((0,j.$Sc)(()=>r.removeListener("data",o))),r.on("data",o)})}function v(r,s){const t=p(s);return t.end(r),t}function c(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function a(r,s,t){const g=p(t);return b(r,{onData:d=>g.write(s.data(d)),onError:d=>g.error(s.error?s.error(d):d),onEnd:()=>g.end()}),g}function n(r,s,t){let g=!1;return{read:()=>{const d=s.read();return g?d:(g=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let g=!1;const d=p(t);return b(s,{onData:l=>g?d.write(l):(g=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{g||(g=!0,d.write(r)),d.end()}}),d}}),define(Ee[21],Se([1,0,45,98]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=k,e.$we=M,e.$xe=I,e.$ye=b,e.$ze=E,e.$Ae=v,e.$Be=c,e.$Ce=m,e.$De=a,e.$Ee=n,e.$Fe=i,e.$Ge=r,e.$He=s,e.$Ie=t,e.$Je=g,e.$Ke=d,e.$Le=l,e.$Me=o,e.$Ne=h,e.$Oe=w;const R=typeof Buffer<"u",P=new u.$V(()=>new Uint8Array(256));let A,p;class ${static alloc(y){return R?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return R&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&R?new $(Buffer.from(y)):(A||(A=new TextEncoder),new $(A.encode(y)))}static fromByteArray(y){const C=$.alloc(y.length);for(let O=0,z=y.length;O<z;O++)C.buffer[O]=y[O];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let F=0,T=y.length;F<T;F++)C+=y[F].byteLength}const O=$.alloc(C);let z=0;for(let F=0,T=y.length;F<T;F++){const L=y[F];O.set(L,z),z+=L.byteLength}return O}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(y,C){return new $(this.buffer.subarray(y,C))}set(y,C){if(y instanceof $)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return b(this.buffer,y)}writeUInt32BE(y,C){E(this.buffer,y,C)}readUInt32LE(y){return v(this.buffer,y)}writeUInt32LE(y,C){c(this.buffer,y,C)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,C){a(this.buffer,y,C)}indexOf(y,C=0){return k(this.buffer,y instanceof $?y.buffer:y,C)}}e.$ue=$;function k(S,y,C=0){const O=y.byteLength,z=S.byteLength;if(O===0)return 0;if(O===1)return S.indexOf(y[0]);if(O>z-C)return-1;const F=P.value;F.fill(y.length);for(let B=0;B<y.length;B++)F[y[B]]=y.length-B-1;let T=C+y.length-1,L=T,N=-1;for(;T<z;)if(S[T]===y[L]){if(L===0){N=T;break}T--,L--}else T+=Math.max(y.length-L,F[S[T]]),L=y.length-1;return N}function M(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function I(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255}function b(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function E(S,y,C){S[C+3]=y,y=y>>>8,S[C+2]=y,y=y>>>8,S[C+1]=y,y=y>>>8,S[C]=y}function v(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function c(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255,y=y>>>8,S[C+2]=y&255,y=y>>>8,S[C+3]=y&255}function m(S,y){return S[y]}function a(S,y,C){S[C]=y}function n(S){return j.$je(S,y=>$.concat(y))}function i(S){return j.$qe(S)}function r(S){return j.$le(S,y=>$.concat(y))}async function s(S){return S.ended?$.concat(S.buffer):$.concat([...S.buffer,await r(S.stream)])}function t(S){return j.$oe(S,y=>$.concat(y))}function g(S){return j.$re(S,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}function d(S){return j.$ie(y=>$.concat(y),S)}function l(S,y){return j.$se(S,y,C=>$.concat(C))}function o(S,y){return j.$te(S,y,C=>$.concat(C))}function h(S){let y=0,C=0,O=0;const z=new Uint8Array(Math.floor(S.length/4*3)),F=L=>{switch(C){case 3:z[O++]=y|L,C=0;break;case 2:z[O++]=y|L>>>2,y=L<<6,C=3;break;case 1:z[O++]=y|L>>>4,y=L<<4,C=2;break;default:y=L<<2,C=1}};for(let L=0;L<S.length;L++){const N=S.charCodeAt(L);if(N>=65&&N<=90)F(N-65);else if(N>=97&&N<=122)F(N-97+26);else if(N>=48&&N<=57)F(N-48+52);else if(N===43||N===45)F(62);else if(N===47||N===95)F(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${S[L]}`)}}const T=O;for(;C>0;)F(0);return $.wrap(z).slice(0,T)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:S},y=!0,C=!1){const O=C?D:f;let z="";const F=S.byteLength%3;let T=0;for(;T<S.byteLength-F;T+=3){const L=S[T+0],N=S[T+1],B=S[T+2];z+=O[L>>>2],z+=O[(L<<4|N>>>4)&63],z+=O[(N<<2|B>>>6)&63],z+=O[B&63]}if(F===1){const L=S[T+0];z+=O[L>>>2],z+=O[L<<4&63],y&&(z+="==")}else if(F===2){const L=S[T+0],N=S[T+1];z+=O[L>>>2],z+=O[(L<<4|N>>>4)&63],z+=O[N<<2&63],y&&(z+="=")}return z}}),define(Ee[14],Se([1,0,167,45]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.GraphemeBreakType=e.$Hf=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=R,e.$Ve=A,e.$We=$,e.$Xe=k,e.$Ye=M,e.$Ze=I,e.$1e=b,e.$2e=E,e.$3e=v,e.$4e=c,e.$5e=m,e.$6e=a,e.$7e=n,e.$8e=i,e.$9e=r,e.$0e=s,e.$$e=t,e.$_e=g,e.$af=d,e.$bf=l,e.$cf=o,e.$df=h,e.$ef=f,e.$ff=D,e.$gf=w,e.$hf=S,e.$if=y,e.$jf=C,e.$kf=O,e.$lf=z,e.$mf=F,e.$nf=T,e.$of=L,e.$pf=N,e.$qf=B,e.$rf=U,e.$sf=Z,e.$vf=ce,e.$wf=X,e.$xf=me,e.$yf=ae,e.$zf=ie,e.$Af=Pe,e.$Cf=le,e.$Df=ue,e.$Ef=oe,e.$Ff=K,e.$Gf=fe,e.$If=Ae,e.$Jf=pe,e.$Kf=Ce,e.$Lf=Me,e.$Mf=Fe,e.$Nf=V,e.$Of=q,e.$Pf=Q,e.$Qf=He;function R(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}const P=/{(\d+)}/g;function A(Ie,...ze){return ze.length===0?Ie:Ie.replace(P,function(Re,Ge){const ne=parseInt(Ge,10);return isNaN(ne)||ne<0||ne>=ze.length?Re:ze[ne]})}const p=/{([^}]+)}/g;function $(Ie,ze){return Object.keys(ze).length===0?Ie:Ie.replace(p,(Re,Ge)=>ze[Ge]??Re)}function k(Ie){return Ie.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function M(Ie){return Ie.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function I(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Ie,ze){let Re=0;const Ge=ze.charCodeAt(0);for(let ne=Ie.length-1;ne>=0;ne--)Ie.charCodeAt(ne)===Ge&&Re++;return Re}function E(Ie,ze,Re="\u2026"){return Ie.length<=ze?Ie:`${Ie.substr(0,ze)}${Re}`}function v(Ie,ze,Re="\u2026"){if(Ie.length<=ze)return Ie;const Ge=Math.ceil(ze/2)-Re.length/2,ne=Math.floor(ze/2)-Re.length/2;return`${Ie.substr(0,Ge)}${Re}${Ie.substr(Ie.length-ne)}`}function c(Ie,ze=" "){const Re=m(Ie,ze);return a(Re,ze)}function m(Ie,ze){if(!Ie||!ze)return Ie;const Re=ze.length;if(Re===0||Ie.length===0)return Ie;let Ge=0;for(;Ie.indexOf(ze,Ge)===Ge;)Ge=Ge+Re;return Ie.substring(Ge)}function a(Ie,ze){if(!Ie||!ze)return Ie;const Re=ze.length,Ge=Ie.length;if(Re===0||Ge===0)return Ie;let ne=Ge,se=-1;for(;se=Ie.lastIndexOf(ze,ne-1),!(se===-1||se+Re!==ne);){if(se===0)return"";ne=se}return Ie.substring(0,ne)}function n(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ie){return Ie.replace(/\*/g,"")}function r(Ie,ze,Re={}){if(!Ie)throw new Error("Cannot create regex from empty string");ze||(Ie=I(Ie)),Re.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Ge="";return Re.global&&(Ge+="g"),Re.matchCase||(Ge+="i"),Re.multiline&&(Ge+="m"),Re.unicode&&(Ge+="u"),new RegExp(Ie,Ge)}function s(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}function t(Ie){return Ie.split(/\r\n|\r|\n/)}function g(Ie){const ze=[],Re=Ie.split(/(\r\n|\r|\n)/);for(let Ge=0;Ge<Math.ceil(Re.length/2);Ge++)ze.push(Re[2*Ge]+(Re[2*Ge+1]??""));return ze}function d(Ie){for(let ze=0,Re=Ie.length;ze<Re;ze++){const Ge=Ie.charCodeAt(ze);if(Ge!==32&&Ge!==9)return ze}return-1}function l(Ie,ze=0,Re=Ie.length){for(let Ge=ze;Ge<Re;Ge++){const ne=Ie.charCodeAt(Ge);if(ne!==32&&ne!==9)return Ie.substring(ze,Ge)}return Ie.substring(ze,Re)}function o(Ie,ze=Ie.length-1){for(let Re=ze;Re>=0;Re--){const Ge=Ie.charCodeAt(Re);if(Ge!==32&&Ge!==9)return Re}return-1}function h(Ie,ze,Re){const Ge=[];let ne=0;for(const se of Ie.matchAll(ze)){if(Ge.push(Ie.slice(ne,se.index)),se.index===void 0)throw new Error("match.index should be defined");ne=se.index+se[0].length,Ge.push(Re(se[0],...se.slice(1),se.index,Ie,se.groups))}return Ge.push(Ie.slice(ne)),Promise.all(Ge).then(se=>se.join(""))}function f(Ie,ze){return Ie<ze?-1:Ie>ze?1:0}function D(Ie,ze,Re=0,Ge=Ie.length,ne=0,se=ze.length){for(;Re<Ge&&ne<se;Re++,ne++){const xe=Ie.charCodeAt(Re),ot=ze.charCodeAt(ne);if(xe<ot)return-1;if(xe>ot)return 1}const De=Ge-Re,Ke=se-ne;return De<Ke?-1:De>Ke?1:0}function w(Ie,ze){return S(Ie,ze,0,Ie.length,0,ze.length)}function S(Ie,ze,Re=0,Ge=Ie.length,ne=0,se=ze.length){for(;Re<Ge&&ne<se;Re++,ne++){let xe=Ie.charCodeAt(Re),ot=ze.charCodeAt(ne);if(xe===ot)continue;if(xe>=128||ot>=128)return D(Ie.toLowerCase(),ze.toLowerCase(),Re,Ge,ne,se);C(xe)&&(xe-=32),C(ot)&&(ot-=32);const Ne=xe-ot;if(Ne!==0)return Ne}const De=Ge-Re,Ke=se-ne;return De<Ke?-1:De>Ke?1:0}function y(Ie){return Ie>=48&&Ie<=57}function C(Ie){return Ie>=97&&Ie<=122}function O(Ie){return Ie>=65&&Ie<=90}function z(Ie,ze){return Ie.length===ze.length&&S(Ie,ze)===0}function F(Ie,ze){const Re=ze.length;return ze.length>Ie.length?!1:S(Ie,ze,0,Re)===0}function T(Ie,ze){const Re=Math.min(Ie.length,ze.length);let Ge;for(Ge=0;Ge<Re;Ge++)if(Ie.charCodeAt(Ge)!==ze.charCodeAt(Ge))return Ge;return Re}function L(Ie,ze){const Re=Math.min(Ie.length,ze.length);let Ge;const ne=Ie.length-1,se=ze.length-1;for(Ge=0;Ge<Re;Ge++)if(Ie.charCodeAt(ne-Ge)!==ze.charCodeAt(se-Ge))return Ge;return Re}function N(Ie){return 55296<=Ie&&Ie<=56319}function B(Ie){return 56320<=Ie&&Ie<=57343}function U(Ie,ze){return(Ie-55296<<10)+(ze-56320)+65536}function Z(Ie,ze,Re){const Ge=Ie.charCodeAt(Re);if(N(Ge)&&Re+1<ze){const ne=Ie.charCodeAt(Re+1);if(B(ne))return U(Ge,ne)}return Ge}function _(Ie,ze){const Re=Ie.charCodeAt(ze-1);if(B(Re)&&ze>1){const Ge=Ie.charCodeAt(ze-2);if(N(Ge))return U(Ge,Re)}return Re}class Y{get offset(){return this.e}constructor(ze,Re=0){this.c=ze,this.d=ze.length,this.e=Re}setOffset(ze){this.e=ze}prevCodePoint(){const ze=_(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=Z(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$tf=Y;class x{get offset(){return this.c.offset}constructor(ze,Re=0){this.c=new Y(ze,Re)}nextGraphemeLength(){const ze=we.getInstance(),Re=this.c,Ge=Re.offset;let ne=ze.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const se=Re.offset,De=ze.getGraphemeBreakType(Re.nextCodePoint());if(J(ne,De)){Re.setOffset(se);break}ne=De}return Re.offset-Ge}prevGraphemeLength(){const ze=we.getInstance(),Re=this.c,Ge=Re.offset;let ne=ze.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const se=Re.offset,De=ze.getGraphemeBreakType(Re.prevCodePoint());if(J(De,ne)){Re.setOffset(se);break}ne=De}return Ge-Re.offset}eol(){return this.c.eol()}}e.$uf=x;function ce(Ie,ze){return new x(Ie,ze).nextGraphemeLength()}function X(Ie,ze){return new x(Ie,ze).prevGraphemeLength()}function me(Ie,ze){ze>0&&B(Ie.charCodeAt(ze))&&ze--;const Re=ze+ce(Ie,ze);return[Re-X(Ie,Re),Re]}function ae(Ie){const ze=new x(Ie);let Re=0;for(;!ze.eol();)Re++,ze.nextGraphemeLength();return Re}let re;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(Ie){return re||(re=W()),re.test(Ie)}const ve=/^[\t\n\r\x20-\x7E]*$/;function Pe(Ie){return ve.test(Ie)}e.$Bf=/[\u2028\u2029]/;function le(Ie){return e.$Bf.test(Ie)}function ue(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}function oe(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}function K(Ie,ze,Re=""){const Ge=Ie.trimStart();if(Ge.length<ze)return Ge;const ne=/\b/g;let se=0;for(;ne.test(Ge)&&!(Ge.length-ne.lastIndex<ze);)se=ne.lastIndex,ne.lastIndex+=1;return se===0?Ge:Re+Ge.substring(se).trimStart()}const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function fe(Ie){return Ie&&(Ie=Ie.replace(ee,"").replace(he,"")),Ie}e.$Hf="\uFEFF";function Ae(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}function pe(Ie){return Ae(Ie)?Ie.substr(1):Ie}function Ce(Ie,ze){if(!Ie||!ze||Ie.length<ze.length)return!1;const Re=ze.length,Ge=Ie.toLowerCase();let ne=0,se=-1;for(;ne<Re;){const De=Ge.indexOf(ze[ne],se+1);if(De<0)return!1;se=De,ne++}return!0}function Me(Ie,ze=!1){return Ie?(ze&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}function Fe(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}function V(Ie,ze=1){if(ze===0)return"";let Re=-1;do Re=Ie.indexOf(`
`,Re+1),ze--;while(ze>0&&Re>=0);return Re===-1?Ie:(Ie[Re-1]==="\r"&&Re--,Ie.substr(0,Re))}function q(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}function Q(Ie){return we.getInstance().getGraphemeBreakType(Ie)}function J(Ie,ze){return Ie===0?ze!==5&&ze!==7:Ie===2&&ze===3?!1:Ie===4||Ie===2||Ie===3||ze===4||ze===2||ze===3?!0:!(Ie===8&&(ze===8||ze===9||ze===11||ze===12)||(Ie===11||Ie===9)&&(ze===9||ze===10)||(Ie===12||Ie===10)&&ze===10||ze===5||ze===13||ze===7||Ie===1||Ie===13&&ze===14||Ie===6&&ze===6)}var ge;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Te()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Re=this.d,Ge=Re.length/3;let ne=1;for(;ne<=Ge;)if(ze<Re[3*ne])ne=2*ne;else if(ze>Re[3*ne+1])ne=2*ne+1;else return Re[3*ne+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ie,ze){if(Ie===0)return 0;const Re=Xe(Ie,ze);if(Re!==void 0)return Re;const Ge=new Y(ze,Ie);return Ge.prevCodePoint(),Ge.offset}function Xe(Ie,ze){const Re=new Y(ze,Ie);let Ge=Re.prevCodePoint();for(;tt(Ge)||Ge===65039||Ge===8419;){if(Re.offset===0)return;Ge=Re.prevCodePoint()}if(!oe(Ge))return;let ne=Re.offset;return ne>0&&Re.prevCodePoint()===8205&&(ne=Re.offset),ne}function tt(Ie){return 127995<=Ie&&Ie<=127999}var nt;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Rf="\xA0";class at{static{this.c=new j.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Qe(ze=>{function Re(Ne){const bt=new Map;for(let St=0;St<Ne.length;St+=2)bt.set(Ne[St],Ne[St+1]);return bt}function Ge(Ne,bt){const St=new Map(Ne);for(const[It,xt]of bt)St.set(It,xt);return St}function ne(Ne,bt){if(!Ne)return bt;const St=new Map;for(const[It,xt]of Ne)bt.has(It)&&St.set(It,xt);return St}const se=this.c.value;let De=ze.filter(Ne=>!Ne.startsWith("_")&&Ne in se);De.length===0&&(De=["_default"]);let Ke;for(const Ne of De){const bt=Re(se[Ne]);Ke=ne(Ke,bt)}const xe=Re(se._common),ot=Ge(xe,Ke);return new at(ot)})}static getInstance(ze){return at.d.get(Array.from(ze))}static{this.e=new j.$V(()=>Object.keys(at.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return at.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Sf=at;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(ze){return st.e().has(ze)}static get codePoints(){return st.e()}}e.$Tf=st}),define(Ee[126],Se([1,0,28,165,14]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.FuzzyScore=e.$jk=e.$ik=void 0,e.or=P,e.$kk=p,e.$lk=$,e.$mk=I,e.$nk=h,e.$ok=f,e.$pk=O,e.$qk=z,e.$rk=F,e.$sk=T,e.$tk=ie,e.$vk=ue,e.$wk=ee,e.$xk=he;function P(...pe){return function(Ce,Me){for(let Fe=0,V=pe.length;Fe<V;Fe++){const q=pe[Fe](Ce,Me);if(q)return q}return null}}e.$ik=A.bind(void 0,!1),e.$jk=A.bind(void 0,!0);function A(pe,Ce,Me){if(!Me||Me.length<Ce.length)return null;let Fe;return pe?Fe=R.$mf(Me,Ce):Fe=Me.indexOf(Ce)===0,Fe?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(pe,Ce){const Me=Ce.toLowerCase().indexOf(pe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+pe.length}]}function $(pe,Ce){return k(pe.toLowerCase(),Ce.toLowerCase(),0,0)}function k(pe,Ce,Me,Fe){if(Me===pe.length)return[];if(Fe===Ce.length)return null;if(pe[Me]===Ce[Fe]){let V=null;return(V=k(pe,Ce,Me+1,Fe+1))?r({start:Fe,end:Fe+1},V):null}return k(pe,Ce,Me,Fe+1)}function M(pe){return 97<=pe&&pe<=122}function I(pe){return 65<=pe&&pe<=90}function b(pe){return 48<=pe&&pe<=57}function E(pe){return pe===32||pe===9||pe===10||pe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>v.add(pe.charCodeAt(0)));function c(pe){return E(pe)||v.has(pe)}function m(pe,Ce){return pe===Ce||c(pe)&&c(Ce)}const a=new Map;function n(pe){if(a.has(pe))return a.get(pe);let Ce;const Me=(0,j.$gk)(pe);return Me&&(Ce=Me),a.set(pe,Ce),Ce}function i(pe){return M(pe)||I(pe)||b(pe)}function r(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function s(pe,Ce){for(let Me=Ce;Me<pe.length;Me++){const Fe=pe.charCodeAt(Me);if(I(Fe)||b(Fe)||Me>0&&!i(pe.charCodeAt(Me-1)))return Me}return pe.length}function t(pe,Ce,Me,Fe){if(Me===pe.length)return[];if(Fe===Ce.length)return null;if(pe[Me]!==Ce[Fe].toLowerCase())return null;{let V=null,q=Fe+1;for(V=t(pe,Ce,Me+1,Fe+1);!V&&(q=s(Ce,q))<Ce.length;)V=t(pe,Ce,Me+1,q),q++;return V===null?null:r({start:Fe,end:Fe+1},V)}}function g(pe){let Ce=0,Me=0,Fe=0,V=0,q=0;for(let Te=0;Te<pe.length;Te++)q=pe.charCodeAt(Te),I(q)&&Ce++,M(q)&&Me++,i(q)&&Fe++,b(q)&&V++;const Q=Ce/pe.length,J=Me/pe.length,ge=Fe/pe.length,we=V/pe.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:ge,numericPercent:we}}function d(pe){const{upperPercent:Ce,lowerPercent:Me}=pe;return Me===0&&Ce>.6}function l(pe){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:Fe,numericPercent:V}=pe;return Me>.2&&Ce<.8&&Fe>.6&&V<.2}function o(pe){let Ce=0,Me=0,Fe=0,V=0;for(let q=0;q<pe.length;q++)Fe=pe.charCodeAt(q),I(Fe)&&Ce++,M(Fe)&&Me++,E(Fe)&&V++;return(Ce===0||Me===0)&&V===0?pe.length<=30:Ce<=5}function h(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!o(pe))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=g(Ce);if(!l(Me)){if(!d(Me))return null;Ce=Ce.toLowerCase()}let Fe=null,V=0;for(pe=pe.toLowerCase();V<Ce.length&&(Fe=t(pe,Ce,0,V))===null;)V=s(Ce,V+1);return Fe}function f(pe,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let Fe=null,V=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();V<Ce.length&&(Fe=D(pe,Ce,0,V,Me),Fe===null);)V=w(Ce,V+1);return Fe}function D(pe,Ce,Me,Fe,V){let q=0;if(Me===pe.length)return[];if(Fe===Ce.length)return null;if(!m(pe.charCodeAt(Me),Ce.charCodeAt(Fe))){const ge=n(pe.charCodeAt(Me));if(!ge)return null;for(let we=0;we<ge.length;we++)if(!m(ge[we],Ce.charCodeAt(Fe+we)))return null;q+=ge.length-1}let Q=null,J=Fe+q+1;if(Q=D(pe,Ce,Me+1,J,V),!V)for(;!Q&&(J=w(Ce,J))<Ce.length;)Q=D(pe,Ce,Me+1,J,V),J++;if(!Q)return null;if(pe.charCodeAt(Me)!==Ce.charCodeAt(Fe)){const ge=n(pe.charCodeAt(Me));if(!ge)return Q;for(let we=0;we<ge.length;we++)if(ge[we]!==Ce.charCodeAt(Fe+we))return Q}return r({start:Fe,end:Fe+q+1},Q)}function w(pe,Ce){for(let Me=Ce;Me<pe.length;Me++)if(c(pe.charCodeAt(Me))||Me>0&&c(pe.charCodeAt(Me-1)))return Me;return pe.length}const S=P(e.$jk,h,p),y=P(e.$jk,h,$),C=new u.$Ec(1e4);function O(pe,Ce,Me=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let Fe=C.get(pe);Fe||(Fe=new RegExp(R.$7e(pe),"i"),C.set(pe,Fe));const V=Fe.exec(Ce);return V?[{start:V.index,end:V.index+V[0].length}]:Me?y(pe,Ce):S(pe,Ce)}function z(pe,Ce){const Me=ue(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?T(Me):null}function F(pe,Ce,Me,Fe,V,q){const Q=Math.min(13,pe.length);for(;Me<Q;Me++){const J=ue(pe,Ce,Me,Fe,V,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,q]}function T(pe){if(typeof pe>"u")return[];const Ce=[],Me=pe[1];for(let Fe=pe.length-1;Fe>1;Fe--){const V=pe[Fe]+Me,q=Ce[Ce.length-1];q&&q.end===V?q.end=V+1:Ce.push({start:V,end:V+1})}return Ce}const L=128;function N(){const pe=[],Ce=[];for(let Me=0;Me<=L;Me++)Ce[Me]=0;for(let Me=0;Me<=L;Me++)pe.push(Ce.slice(0));return pe}function B(pe){const Ce=[];for(let Me=0;Me<=pe;Me++)Ce[Me]=0;return Ce}const U=B(2*L),Z=B(2*L),_=N(),Y=N(),x=N(),ce=!1;function X(pe,Ce,Me,Fe,V){function q(J,ge,we=" "){for(;J.length<ge;)J=we+J;return J}let Q=` |   |${Fe.split("").map(J=>q(J,3)).join("|")}
`;for(let J=0;J<=Me;J++)J===0?Q+=" |":Q+=`${Ce[J-1]}|`,Q+=pe[J].slice(0,V+1).map(ge=>q(ge.toString(),3)).join("|")+`
`;return Q}function me(pe,Ce,Me,Fe){pe=pe.substr(Ce),Me=Me.substr(Fe),console.log(X(Y,pe,pe.length,Me,Me.length)),console.log(X(x,pe,pe.length,Me,Me.length)),console.log(X(_,pe,pe.length,Me,Me.length))}function ae(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Me=pe.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Ef(Me)}}function re(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function W(pe,Ce,Me){return Ce[pe]!==Me[pe]}function ie(pe,Ce,Me,Fe,V,q,Q=!1){for(;Ce<Me&&V<q;)pe[Ce]===Fe[V]&&(Q&&(U[Ce]=V),Ce+=1),V+=1;return Ce===Me}var ve;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Pe;(function(pe){pe.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}pe.isDefault=Ce})(Pe||(e.FuzzyScore=Pe={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$uk=le;function ue(pe,Ce,Me,Fe,V,q,Q=le.default){const J=pe.length>L?L:pe.length,ge=Fe.length>L?L:Fe.length;if(Me>=J||q>=ge||J-Me>ge-q||!ie(Ce,Me,J,V,q,ge,!0))return;oe(J,ge,Me,q,Ce,V);let we=1,Te=1,He=Me,Xe=q;const tt=[!1];for(we=1,He=Me;He<J;we++,He++){const ze=U[He],Re=Z[He],Ge=He+1<J?Z[He+1]:ge;for(Te=ze-q+1,Xe=ze;Xe<Ge;Te++,Xe++){let ne=Number.MIN_SAFE_INTEGER,se=!1;Xe<=Re&&(ne=K(pe,Ce,He,Me,Fe,V,Xe,ge,q,_[we-1][Te-1]===0,tt));let De=0;ne!==Number.MAX_SAFE_INTEGER&&(se=!0,De=ne+Y[we-1][Te-1]);const Ke=Xe>ze,xe=Ke?Y[we][Te-1]+(_[we][Te-1]>0?-5:0):0,ot=Xe>ze+1&&_[we][Te-1]>0,Ne=ot?Y[we][Te-2]+(_[we][Te-2]>0?-5:0):0;if(ot&&(!Ke||Ne>=xe)&&(!se||Ne>=De))Y[we][Te]=Ne,x[we][Te]=3,_[we][Te]=0;else if(Ke&&(!se||xe>=De))Y[we][Te]=xe,x[we][Te]=2,_[we][Te]=0;else if(se)Y[we][Te]=De,x[we][Te]=1,_[we][Te]=_[we-1][Te-1]+1;else throw new Error("not possible")}}if(ce&&me(pe,Me,Fe,q),!tt[0]&&!Q.firstMatchCanBeWeak)return;we--,Te--;const nt=[Y[we][Te],q];let at=0,st=0;for(;we>=1;){let ze=Te;do{const Re=x[we][ze];if(Re===3)ze=ze-2;else if(Re===2)ze=ze-1;else break}while(ze>=1);at>1&&Ce[Me+we-1]===V[q+Te-1]&&!W(ze+q-1,Fe,V)&&at+1>_[we][ze]&&(ze=Te),ze===Te?at++:at=1,st||(st=ze),we--,Te=ze-1,nt.push(Te)}ge===J&&Q.boostFullMatch&&(nt[0]+=2);const Ie=st-J;return nt[0]-=Ie,nt}function oe(pe,Ce,Me,Fe,V,q){let Q=pe-1,J=Ce-1;for(;Q>=Me&&J>=Fe;)V[Q]===q[J]&&(Z[Q]=J,Q--),J--}function K(pe,Ce,Me,Fe,V,q,Q,J,ge,we,Te){if(Ce[Me]!==q[Q])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return Q===Me-Fe?He=pe[Me]===V[Q]?7:5:W(Q,V,q)&&(Q===0||!W(Q-1,V,q))?(He=pe[Me]===V[Q]?7:5,Xe=!0):ae(q,Q)&&(Q===0||!ae(q,Q-1))?He=5:(ae(q,Q-1)||re(q,Q-1))&&(He=5,Xe=!0),He>1&&Me===Fe&&(Te[0]=!0),Xe||(Xe=W(Q,V,q)||ae(q,Q-1)||re(q,Q-1)),Me===Fe?Q>ge&&(He-=Xe?3:5):we?He+=Xe?2:0:He+=Xe?0:1,Q+1===J&&(He-=Xe?3:5),He}function ee(pe,Ce,Me,Fe,V,q,Q){return fe(pe,Ce,Me,Fe,V,q,!0,Q)}function he(pe,Ce,Me,Fe,V,q,Q){return fe(pe,Ce,Me,Fe,V,q,!1,Q)}function fe(pe,Ce,Me,Fe,V,q,Q,J){let ge=ue(pe,Ce,Me,Fe,V,q,J);if(ge&&!Q)return ge;if(pe.length>=3){const we=Math.min(7,pe.length-1);for(let Te=Me+1;Te<we;Te++){const He=Ae(pe,Te);if(He){const Xe=ue(He,He.toLowerCase(),Me,Fe,V,q,J);Xe&&(Xe[0]-=3,(!ge||Xe[0]>ge[0])&&(ge=Xe))}}}return ge}function Ae(pe,Ce){if(Ce+1>=pe.length)return;const Me=pe[Ce],Fe=pe[Ce+1];if(Me!==Fe)return pe.slice(0,Ce)+Fe+Me+pe.slice(Ce+2)}}),define(Ee[55],Se([1,0,14]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=j,e.$9i=R,e.$0i=P,e.$$i=p,e.$aj=c;function j(a){return R(a,0)}function R(a,n){switch(typeof a){case"object":return a===null?P(349,n):Array.isArray(a)?$(a,n):k(a,n);case"string":return p(a,n);case"boolean":return A(a,n);case"number":return P(a,n);case"undefined":return P(937,n);default:return P(617,n)}}function P(a,n){return(n<<5)-n+a|0}function A(a,n){return P(a?433:863,n)}function p(a,n){n=P(149417,n);for(let i=0,r=a.length;i<r;i++)n=P(a.charCodeAt(i),n);return n}function $(a,n){return n=P(104579,n),a.reduce((i,r)=>R(r,i),n)}function k(a,n){return n=P(181387,n),Object.keys(a).sort().reduce((i,r)=>(i=p(r,i),R(a[r],i)),n)}class M{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=R(n,this.g),this.g}}e.$_i=M;var I;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function b(a,n,i=32){const r=i-n,s=~((1<<r)-1);return(a<<n|(s&a)>>>r)>>>0}function E(a,n=0,i=a.byteLength,r=0){for(let s=0;s<i;s++)a[n+s]=r}function v(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function c(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((a>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,g,d;for(t!==0?(g=t,d=-1,t=0):(g=n.charCodeAt(0),d=0);;){let l=g;if(u.$pf(g))if(d+1<i){const o=n.charCodeAt(d+1);u.$qf(o)?(d++,l=u.$rf(g,o)):l=65533}else{t=g;break}else u.$qf(g)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)g=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let f=0;f<64;f+=4)n.setUint32(f,i.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)n.setUint32(f,b(n.getUint32(f-12,!1)^n.getUint32(f-32,!1)^n.getUint32(f-56,!1)^n.getUint32(f-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,g=this.n,d=this.o,l,o,h;for(let f=0;f<80;f++)f<20?(l=s&t|~s&g,o=1518500249):f<40?(l=s^t^g,o=1859775393):f<60?(l=s&t|s&g|t&g,o=2400959708):(l=s^t^g,o=3395469782),h=b(r,5)+l+d+o+n.getUint32(f*4,!1)&4294967295,d=g,g=t,t=b(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+g&4294967295,this.o=this.o+d&4294967295}}e.$bj=m}),define(Ee[40],Se([1,0,14]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(j||(j={})),function(R){const P="error",A="warning",p="warn",$="info",k="ignore";function M(b){return b?u.$lf(P,b)?R.Error:u.$lf(A,b)||u.$lf(p,b)?R.Warning:u.$lf($,b)?R.Info:R.Ignore:R.Ignore}R.fromValue=M;function I(b){switch(b){case R.Error:return P;case R.Warning:return A;case R.Info:return $;default:return k}}R.toString=I}(j||(j={})),e.default=j}),define(Ee[168],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ee[77],Se([1,0,19,14]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class R{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const v=E.charCodeAt(0),c=this.b.charCodeAt(this.c);return v-c}value(){return this.b[this.c]}}e.$ji=R;class P{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,j.$ff)(E,this.b,0,E.length,this.c,this.d):(0,j.$hf)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=P;class A{constructor(E=!0,v=!0){this.f=E,this.g=v}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let v=E.length-1;v>=0;v--,this.c--){const c=this.b.charCodeAt(v);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,j.$ff)(E,this.b,0,E.length,this.d,this.e):(0,j.$hf)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=A;var p;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(E,v){this.f=E,this.g=v,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,j.$gf)(E,this.c.scheme);if(this.d[this.e]===2)return(0,j.$gf)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,j.$ef)(E,this.c.query);if(this.d[this.e]===5)return(0,j.$ef)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(M||(M={}));class I{static forUris(E=()=>!1,v=()=>!1){return new I(new $(E,v))}static forPaths(E=!1){return new I(new A(void 0,!E))}static forStrings(){return new I(new R)}static forConfigKeys(){return new I(new P)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,v){if(v){const c=v.slice(0);(0,u.$Xb)(c);for(const m of c)this.set(m,E)}else{const c=E.slice(0);(0,u.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(E,v){const c=this.b.reset(E);let m;this.c||(this.c=new k,this.c.segment=c.value());const a=[];for(m=this.c;;){const i=c.cmp(m.segment);if(i>0)m.left||(m.left=new k,m.left.segment=c.value()),a.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new k,m.right.segment=c.value()),a.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new k,m.mid.segment=c.value()),a.push([0,m]),m=m.mid;else break}const n=m.value;m.value=v,m.key=E;for(let i=a.length-1;i>=0;i--){const r=a[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=a[i][0],g=a[i+1][0];if(t===1&&g===1)a[i][1]=r.rotateLeft();else if(t===-1&&g===-1)a[i][1]=r.rotateRight();else if(t===1&&g===-1)r.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=r.rotateLeft();else if(t===-1&&g===1)r.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(E){return this.d(E)?.value}d(E){const v=this.b.reset(E);let c=this.c;for(;c;){const m=v.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(v.hasNext())v.next(),c=c.mid;else break}return c}has(E){const v=this.d(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,v){const c=this.b.reset(E),m=[];let a=this.c;for(;a;){const n=c.cmp(a.segment);if(n>0)m.push([-1,a]),a=a.left;else if(n<0)m.push([1,a]),a=a.right;else if(c.hasNext())c.next(),m.push([0,a]),a=a.mid;else break}if(a){if(v?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),a.key=i,a.value=r,a.segment=s}}else{const n=a.left??a.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this.b.reset(E);let c=this.c,m;for(;c;){const a=v.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(v.hasNext())v.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(E){return this.g(E,!1)}g(E,v){const c=this.b.reset(E);let m=this.c;for(;m;){const a=c.cmp(m.segment);if(a>0)m=m.left;else if(a<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):v?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[v,c]of this)E(c,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const v=[];return this.j(E,v),v[Symbol.iterator]()}j(E,v){E&&(E.left&&this.j(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this.j(E.mid,v),E.right&&this.j(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const c=v.balanceFactor();return c<-1||c>1?!1:E(v.left)&&E(v.right)};return E(this.c)}}e.$ni=I}),define(Ee[18],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=u,e.$Vf=j,e.$Wf=R,e.$Xf=P,e.$Yf=A,e.$Zf=p,e.$1f=$,e.$2f=k,e.$3f=M,e.$4f=I,e.$5f=b,e.$6f=E,e.$7f=v,e.$8f=m,e.$9f=a,e.$0f=n,e.$$f=i,e.$_f=r;function u(s){return typeof s=="string"}function j(s){return Array.isArray(s)&&s.every(t=>u(t))}function R(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function P(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function A(s){return typeof s=="number"&&!isNaN(s)}function p(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function k(s){return typeof s>"u"}function M(s){return!I(s)}function I(s){return k(s)||s===null}function b(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function E(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let g=0;g<s.length;g++){const d=s[g];if(I(d))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);t.push(d)}return t}const c=Object.prototype.hasOwnProperty;function m(s){if(!R(s))return!1;for(const t in s)if(c.call(s,t))return!1;return!0}function a(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(a)}function i(s,t){const g=Math.min(s.length,t.length);for(let d=0;d<g;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(s instanceof t)return}catch{}if(!I(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[99],Se([1,0,18]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=R,e.$Cj=P;const j=Object.create(null);function R(A,p){if((0,u.$Uf)(p)){const $=j[p];if($===void 0)throw new Error(`${A} references an unknown codicon: ${p}`);p=$}return j[A]=p,{id:A}}function P(){return j}}),define(Ee[169],Se([1,0,99]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=void 0,e.$Dj={add:(0,u.$Bj)("add",6e4),plus:(0,u.$Bj)("plus",6e4),gistNew:(0,u.$Bj)("gist-new",6e4),repoCreate:(0,u.$Bj)("repo-create",6e4),lightbulb:(0,u.$Bj)("lightbulb",60001),lightBulb:(0,u.$Bj)("light-bulb",60001),repo:(0,u.$Bj)("repo",60002),repoDelete:(0,u.$Bj)("repo-delete",60002),gistFork:(0,u.$Bj)("gist-fork",60003),repoForked:(0,u.$Bj)("repo-forked",60003),gitPullRequest:(0,u.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Bj)("record-keys",60005),keyboard:(0,u.$Bj)("keyboard",60005),tag:(0,u.$Bj)("tag",60006),gitPullRequestLabel:(0,u.$Bj)("git-pull-request-label",60006),tagAdd:(0,u.$Bj)("tag-add",60006),tagRemove:(0,u.$Bj)("tag-remove",60006),person:(0,u.$Bj)("person",60007),personFollow:(0,u.$Bj)("person-follow",60007),personOutline:(0,u.$Bj)("person-outline",60007),personFilled:(0,u.$Bj)("person-filled",60007),gitBranch:(0,u.$Bj)("git-branch",60008),gitBranchCreate:(0,u.$Bj)("git-branch-create",60008),gitBranchDelete:(0,u.$Bj)("git-branch-delete",60008),sourceControl:(0,u.$Bj)("source-control",60008),mirror:(0,u.$Bj)("mirror",60009),mirrorPublic:(0,u.$Bj)("mirror-public",60009),star:(0,u.$Bj)("star",60010),starAdd:(0,u.$Bj)("star-add",60010),starDelete:(0,u.$Bj)("star-delete",60010),starEmpty:(0,u.$Bj)("star-empty",60010),comment:(0,u.$Bj)("comment",60011),commentAdd:(0,u.$Bj)("comment-add",60011),alert:(0,u.$Bj)("alert",60012),warning:(0,u.$Bj)("warning",60012),search:(0,u.$Bj)("search",60013),searchSave:(0,u.$Bj)("search-save",60013),logOut:(0,u.$Bj)("log-out",60014),signOut:(0,u.$Bj)("sign-out",60014),logIn:(0,u.$Bj)("log-in",60015),signIn:(0,u.$Bj)("sign-in",60015),eye:(0,u.$Bj)("eye",60016),eyeUnwatch:(0,u.$Bj)("eye-unwatch",60016),eyeWatch:(0,u.$Bj)("eye-watch",60016),circleFilled:(0,u.$Bj)("circle-filled",60017),primitiveDot:(0,u.$Bj)("primitive-dot",60017),closeDirty:(0,u.$Bj)("close-dirty",60017),debugBreakpoint:(0,u.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Bj)("primitive-square",60018),edit:(0,u.$Bj)("edit",60019),pencil:(0,u.$Bj)("pencil",60019),info:(0,u.$Bj)("info",60020),issueOpened:(0,u.$Bj)("issue-opened",60020),gistPrivate:(0,u.$Bj)("gist-private",60021),gitForkPrivate:(0,u.$Bj)("git-fork-private",60021),lock:(0,u.$Bj)("lock",60021),mirrorPrivate:(0,u.$Bj)("mirror-private",60021),close:(0,u.$Bj)("close",60022),removeClose:(0,u.$Bj)("remove-close",60022),x:(0,u.$Bj)("x",60022),repoSync:(0,u.$Bj)("repo-sync",60023),sync:(0,u.$Bj)("sync",60023),clone:(0,u.$Bj)("clone",60024),desktopDownload:(0,u.$Bj)("desktop-download",60024),beaker:(0,u.$Bj)("beaker",60025),microscope:(0,u.$Bj)("microscope",60025),vm:(0,u.$Bj)("vm",60026),deviceDesktop:(0,u.$Bj)("device-desktop",60026),file:(0,u.$Bj)("file",60027),fileText:(0,u.$Bj)("file-text",60027),more:(0,u.$Bj)("more",60028),ellipsis:(0,u.$Bj)("ellipsis",60028),kebabHorizontal:(0,u.$Bj)("kebab-horizontal",60028),mailReply:(0,u.$Bj)("mail-reply",60029),reply:(0,u.$Bj)("reply",60029),organization:(0,u.$Bj)("organization",60030),organizationFilled:(0,u.$Bj)("organization-filled",60030),organizationOutline:(0,u.$Bj)("organization-outline",60030),newFile:(0,u.$Bj)("new-file",60031),fileAdd:(0,u.$Bj)("file-add",60031),newFolder:(0,u.$Bj)("new-folder",60032),fileDirectoryCreate:(0,u.$Bj)("file-directory-create",60032),trash:(0,u.$Bj)("trash",60033),trashcan:(0,u.$Bj)("trashcan",60033),history:(0,u.$Bj)("history",60034),clock:(0,u.$Bj)("clock",60034),folder:(0,u.$Bj)("folder",60035),fileDirectory:(0,u.$Bj)("file-directory",60035),symbolFolder:(0,u.$Bj)("symbol-folder",60035),logoGithub:(0,u.$Bj)("logo-github",60036),markGithub:(0,u.$Bj)("mark-github",60036),github:(0,u.$Bj)("github",60036),terminal:(0,u.$Bj)("terminal",60037),console:(0,u.$Bj)("console",60037),repl:(0,u.$Bj)("repl",60037),zap:(0,u.$Bj)("zap",60038),symbolEvent:(0,u.$Bj)("symbol-event",60038),error:(0,u.$Bj)("error",60039),stop:(0,u.$Bj)("stop",60039),variable:(0,u.$Bj)("variable",60040),symbolVariable:(0,u.$Bj)("symbol-variable",60040),array:(0,u.$Bj)("array",60042),symbolArray:(0,u.$Bj)("symbol-array",60042),symbolModule:(0,u.$Bj)("symbol-module",60043),symbolPackage:(0,u.$Bj)("symbol-package",60043),symbolNamespace:(0,u.$Bj)("symbol-namespace",60043),symbolObject:(0,u.$Bj)("symbol-object",60043),symbolMethod:(0,u.$Bj)("symbol-method",60044),symbolFunction:(0,u.$Bj)("symbol-function",60044),symbolConstructor:(0,u.$Bj)("symbol-constructor",60044),symbolBoolean:(0,u.$Bj)("symbol-boolean",60047),symbolNull:(0,u.$Bj)("symbol-null",60047),symbolNumeric:(0,u.$Bj)("symbol-numeric",60048),symbolNumber:(0,u.$Bj)("symbol-number",60048),symbolStructure:(0,u.$Bj)("symbol-structure",60049),symbolStruct:(0,u.$Bj)("symbol-struct",60049),symbolParameter:(0,u.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Bj)("symbol-type-parameter",60050),symbolKey:(0,u.$Bj)("symbol-key",60051),symbolText:(0,u.$Bj)("symbol-text",60051),symbolReference:(0,u.$Bj)("symbol-reference",60052),goToFile:(0,u.$Bj)("go-to-file",60052),symbolEnum:(0,u.$Bj)("symbol-enum",60053),symbolValue:(0,u.$Bj)("symbol-value",60053),symbolRuler:(0,u.$Bj)("symbol-ruler",60054),symbolUnit:(0,u.$Bj)("symbol-unit",60054),activateBreakpoints:(0,u.$Bj)("activate-breakpoints",60055),archive:(0,u.$Bj)("archive",60056),arrowBoth:(0,u.$Bj)("arrow-both",60057),arrowDown:(0,u.$Bj)("arrow-down",60058),arrowLeft:(0,u.$Bj)("arrow-left",60059),arrowRight:(0,u.$Bj)("arrow-right",60060),arrowSmallDown:(0,u.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Bj)("arrow-small-up",60064),arrowUp:(0,u.$Bj)("arrow-up",60065),bell:(0,u.$Bj)("bell",60066),bold:(0,u.$Bj)("bold",60067),book:(0,u.$Bj)("book",60068),bookmark:(0,u.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Bj)("briefcase",60076),broadcast:(0,u.$Bj)("broadcast",60077),browser:(0,u.$Bj)("browser",60078),bug:(0,u.$Bj)("bug",60079),calendar:(0,u.$Bj)("calendar",60080),caseSensitive:(0,u.$Bj)("case-sensitive",60081),check:(0,u.$Bj)("check",60082),checklist:(0,u.$Bj)("checklist",60083),chevronDown:(0,u.$Bj)("chevron-down",60084),chevronLeft:(0,u.$Bj)("chevron-left",60085),chevronRight:(0,u.$Bj)("chevron-right",60086),chevronUp:(0,u.$Bj)("chevron-up",60087),chromeClose:(0,u.$Bj)("chrome-close",60088),chromeMaximize:(0,u.$Bj)("chrome-maximize",60089),chromeMinimize:(0,u.$Bj)("chrome-minimize",60090),chromeRestore:(0,u.$Bj)("chrome-restore",60091),circleOutline:(0,u.$Bj)("circle-outline",60092),circle:(0,u.$Bj)("circle",60092),debugBreakpointUnverified:(0,u.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Bj)("circle-slash",60093),circuitBoard:(0,u.$Bj)("circuit-board",60094),clearAll:(0,u.$Bj)("clear-all",60095),clippy:(0,u.$Bj)("clippy",60096),closeAll:(0,u.$Bj)("close-all",60097),cloudDownload:(0,u.$Bj)("cloud-download",60098),cloudUpload:(0,u.$Bj)("cloud-upload",60099),code:(0,u.$Bj)("code",60100),collapseAll:(0,u.$Bj)("collapse-all",60101),colorMode:(0,u.$Bj)("color-mode",60102),commentDiscussion:(0,u.$Bj)("comment-discussion",60103),creditCard:(0,u.$Bj)("credit-card",60105),dash:(0,u.$Bj)("dash",60108),dashboard:(0,u.$Bj)("dashboard",60109),database:(0,u.$Bj)("database",60110),debugContinue:(0,u.$Bj)("debug-continue",60111),debugDisconnect:(0,u.$Bj)("debug-disconnect",60112),debugPause:(0,u.$Bj)("debug-pause",60113),debugRestart:(0,u.$Bj)("debug-restart",60114),debugStart:(0,u.$Bj)("debug-start",60115),debugStepInto:(0,u.$Bj)("debug-step-into",60116),debugStepOut:(0,u.$Bj)("debug-step-out",60117),debugStepOver:(0,u.$Bj)("debug-step-over",60118),debugStop:(0,u.$Bj)("debug-stop",60119),debug:(0,u.$Bj)("debug",60120),deviceCameraVideo:(0,u.$Bj)("device-camera-video",60121),deviceCamera:(0,u.$Bj)("device-camera",60122),deviceMobile:(0,u.$Bj)("device-mobile",60123),diffAdded:(0,u.$Bj)("diff-added",60124),diffIgnored:(0,u.$Bj)("diff-ignored",60125),diffModified:(0,u.$Bj)("diff-modified",60126),diffRemoved:(0,u.$Bj)("diff-removed",60127),diffRenamed:(0,u.$Bj)("diff-renamed",60128),diff:(0,u.$Bj)("diff",60129),diffSidebyside:(0,u.$Bj)("diff-sidebyside",60129),discard:(0,u.$Bj)("discard",60130),editorLayout:(0,u.$Bj)("editor-layout",60131),emptyWindow:(0,u.$Bj)("empty-window",60132),exclude:(0,u.$Bj)("exclude",60133),extensions:(0,u.$Bj)("extensions",60134),eyeClosed:(0,u.$Bj)("eye-closed",60135),fileBinary:(0,u.$Bj)("file-binary",60136),fileCode:(0,u.$Bj)("file-code",60137),fileMedia:(0,u.$Bj)("file-media",60138),filePdf:(0,u.$Bj)("file-pdf",60139),fileSubmodule:(0,u.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Bj)("file-symlink-file",60142),fileZip:(0,u.$Bj)("file-zip",60143),files:(0,u.$Bj)("files",60144),filter:(0,u.$Bj)("filter",60145),flame:(0,u.$Bj)("flame",60146),foldDown:(0,u.$Bj)("fold-down",60147),foldUp:(0,u.$Bj)("fold-up",60148),fold:(0,u.$Bj)("fold",60149),folderActive:(0,u.$Bj)("folder-active",60150),folderOpened:(0,u.$Bj)("folder-opened",60151),gear:(0,u.$Bj)("gear",60152),gift:(0,u.$Bj)("gift",60153),gistSecret:(0,u.$Bj)("gist-secret",60154),gist:(0,u.$Bj)("gist",60155),gitCommit:(0,u.$Bj)("git-commit",60156),gitCompare:(0,u.$Bj)("git-compare",60157),compareChanges:(0,u.$Bj)("compare-changes",60157),gitMerge:(0,u.$Bj)("git-merge",60158),githubAction:(0,u.$Bj)("github-action",60159),githubAlt:(0,u.$Bj)("github-alt",60160),globe:(0,u.$Bj)("globe",60161),grabber:(0,u.$Bj)("grabber",60162),graph:(0,u.$Bj)("graph",60163),gripper:(0,u.$Bj)("gripper",60164),heart:(0,u.$Bj)("heart",60165),home:(0,u.$Bj)("home",60166),horizontalRule:(0,u.$Bj)("horizontal-rule",60167),hubot:(0,u.$Bj)("hubot",60168),inbox:(0,u.$Bj)("inbox",60169),issueReopened:(0,u.$Bj)("issue-reopened",60171),issues:(0,u.$Bj)("issues",60172),italic:(0,u.$Bj)("italic",60173),jersey:(0,u.$Bj)("jersey",60174),json:(0,u.$Bj)("json",60175),kebabVertical:(0,u.$Bj)("kebab-vertical",60176),key:(0,u.$Bj)("key",60177),law:(0,u.$Bj)("law",60178),lightbulbAutofix:(0,u.$Bj)("lightbulb-autofix",60179),linkExternal:(0,u.$Bj)("link-external",60180),link:(0,u.$Bj)("link",60181),listOrdered:(0,u.$Bj)("list-ordered",60182),listUnordered:(0,u.$Bj)("list-unordered",60183),liveShare:(0,u.$Bj)("live-share",60184),loading:(0,u.$Bj)("loading",60185),location:(0,u.$Bj)("location",60186),mailRead:(0,u.$Bj)("mail-read",60187),mail:(0,u.$Bj)("mail",60188),markdown:(0,u.$Bj)("markdown",60189),megaphone:(0,u.$Bj)("megaphone",60190),mention:(0,u.$Bj)("mention",60191),milestone:(0,u.$Bj)("milestone",60192),gitPullRequestMilestone:(0,u.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Bj)("mortar-board",60193),move:(0,u.$Bj)("move",60194),multipleWindows:(0,u.$Bj)("multiple-windows",60195),mute:(0,u.$Bj)("mute",60196),noNewline:(0,u.$Bj)("no-newline",60197),note:(0,u.$Bj)("note",60198),octoface:(0,u.$Bj)("octoface",60199),openPreview:(0,u.$Bj)("open-preview",60200),package:(0,u.$Bj)("package",60201),paintcan:(0,u.$Bj)("paintcan",60202),pin:(0,u.$Bj)("pin",60203),play:(0,u.$Bj)("play",60204),run:(0,u.$Bj)("run",60204),plug:(0,u.$Bj)("plug",60205),preserveCase:(0,u.$Bj)("preserve-case",60206),preview:(0,u.$Bj)("preview",60207),project:(0,u.$Bj)("project",60208),pulse:(0,u.$Bj)("pulse",60209),question:(0,u.$Bj)("question",60210),quote:(0,u.$Bj)("quote",60211),radioTower:(0,u.$Bj)("radio-tower",60212),reactions:(0,u.$Bj)("reactions",60213),references:(0,u.$Bj)("references",60214),refresh:(0,u.$Bj)("refresh",60215),regex:(0,u.$Bj)("regex",60216),remoteExplorer:(0,u.$Bj)("remote-explorer",60217),remote:(0,u.$Bj)("remote",60218),remove:(0,u.$Bj)("remove",60219),replaceAll:(0,u.$Bj)("replace-all",60220),replace:(0,u.$Bj)("replace",60221),repoClone:(0,u.$Bj)("repo-clone",60222),repoForcePush:(0,u.$Bj)("repo-force-push",60223),repoPull:(0,u.$Bj)("repo-pull",60224),repoPush:(0,u.$Bj)("repo-push",60225),report:(0,u.$Bj)("report",60226),requestChanges:(0,u.$Bj)("request-changes",60227),rocket:(0,u.$Bj)("rocket",60228),rootFolderOpened:(0,u.$Bj)("root-folder-opened",60229),rootFolder:(0,u.$Bj)("root-folder",60230),rss:(0,u.$Bj)("rss",60231),ruby:(0,u.$Bj)("ruby",60232),saveAll:(0,u.$Bj)("save-all",60233),saveAs:(0,u.$Bj)("save-as",60234),save:(0,u.$Bj)("save",60235),screenFull:(0,u.$Bj)("screen-full",60236),screenNormal:(0,u.$Bj)("screen-normal",60237),searchStop:(0,u.$Bj)("search-stop",60238),server:(0,u.$Bj)("server",60240),settingsGear:(0,u.$Bj)("settings-gear",60241),settings:(0,u.$Bj)("settings",60242),shield:(0,u.$Bj)("shield",60243),smiley:(0,u.$Bj)("smiley",60244),sortPrecedence:(0,u.$Bj)("sort-precedence",60245),splitHorizontal:(0,u.$Bj)("split-horizontal",60246),splitVertical:(0,u.$Bj)("split-vertical",60247),squirrel:(0,u.$Bj)("squirrel",60248),starFull:(0,u.$Bj)("star-full",60249),starHalf:(0,u.$Bj)("star-half",60250),symbolClass:(0,u.$Bj)("symbol-class",60251),symbolColor:(0,u.$Bj)("symbol-color",60252),symbolConstant:(0,u.$Bj)("symbol-constant",60253),symbolEnumMember:(0,u.$Bj)("symbol-enum-member",60254),symbolField:(0,u.$Bj)("symbol-field",60255),symbolFile:(0,u.$Bj)("symbol-file",60256),symbolInterface:(0,u.$Bj)("symbol-interface",60257),symbolKeyword:(0,u.$Bj)("symbol-keyword",60258),symbolMisc:(0,u.$Bj)("symbol-misc",60259),symbolOperator:(0,u.$Bj)("symbol-operator",60260),symbolProperty:(0,u.$Bj)("symbol-property",60261),wrench:(0,u.$Bj)("wrench",60261),wrenchSubaction:(0,u.$Bj)("wrench-subaction",60261),symbolSnippet:(0,u.$Bj)("symbol-snippet",60262),tasklist:(0,u.$Bj)("tasklist",60263),telescope:(0,u.$Bj)("telescope",60264),textSize:(0,u.$Bj)("text-size",60265),threeBars:(0,u.$Bj)("three-bars",60266),thumbsdown:(0,u.$Bj)("thumbsdown",60267),thumbsup:(0,u.$Bj)("thumbsup",60268),tools:(0,u.$Bj)("tools",60269),triangleDown:(0,u.$Bj)("triangle-down",60270),triangleLeft:(0,u.$Bj)("triangle-left",60271),triangleRight:(0,u.$Bj)("triangle-right",60272),triangleUp:(0,u.$Bj)("triangle-up",60273),twitter:(0,u.$Bj)("twitter",60274),unfold:(0,u.$Bj)("unfold",60275),unlock:(0,u.$Bj)("unlock",60276),unmute:(0,u.$Bj)("unmute",60277),unverified:(0,u.$Bj)("unverified",60278),verified:(0,u.$Bj)("verified",60279),versions:(0,u.$Bj)("versions",60280),vmActive:(0,u.$Bj)("vm-active",60281),vmOutline:(0,u.$Bj)("vm-outline",60282),vmRunning:(0,u.$Bj)("vm-running",60283),watch:(0,u.$Bj)("watch",60284),whitespace:(0,u.$Bj)("whitespace",60285),wholeWord:(0,u.$Bj)("whole-word",60286),window:(0,u.$Bj)("window",60287),wordWrap:(0,u.$Bj)("word-wrap",60288),zoomIn:(0,u.$Bj)("zoom-in",60289),zoomOut:(0,u.$Bj)("zoom-out",60290),listFilter:(0,u.$Bj)("list-filter",60291),listFlat:(0,u.$Bj)("list-flat",60292),listSelection:(0,u.$Bj)("list-selection",60293),selection:(0,u.$Bj)("selection",60293),listTree:(0,u.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Bj)("symbol-string",60301),debugReverseContinue:(0,u.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Bj)("debug-step-back",60303),debugRestartFrame:(0,u.$Bj)("debug-restart-frame",60304),debugAlt:(0,u.$Bj)("debug-alt",60305),callIncoming:(0,u.$Bj)("call-incoming",60306),callOutgoing:(0,u.$Bj)("call-outgoing",60307),menu:(0,u.$Bj)("menu",60308),expandAll:(0,u.$Bj)("expand-all",60309),feedback:(0,u.$Bj)("feedback",60310),gitPullRequestReviewer:(0,u.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Bj)("ungroup-by-ref-type",60312),account:(0,u.$Bj)("account",60313),gitPullRequestAssignee:(0,u.$Bj)("git-pull-request-assignee",60313),bellDot:(0,u.$Bj)("bell-dot",60314),debugConsole:(0,u.$Bj)("debug-console",60315),library:(0,u.$Bj)("library",60316),output:(0,u.$Bj)("output",60317),runAll:(0,u.$Bj)("run-all",60318),syncIgnored:(0,u.$Bj)("sync-ignored",60319),pinned:(0,u.$Bj)("pinned",60320),githubInverted:(0,u.$Bj)("github-inverted",60321),serverProcess:(0,u.$Bj)("server-process",60322),serverEnvironment:(0,u.$Bj)("server-environment",60323),pass:(0,u.$Bj)("pass",60324),issueClosed:(0,u.$Bj)("issue-closed",60324),stopCircle:(0,u.$Bj)("stop-circle",60325),playCircle:(0,u.$Bj)("play-circle",60326),record:(0,u.$Bj)("record",60327),debugAltSmall:(0,u.$Bj)("debug-alt-small",60328),vmConnect:(0,u.$Bj)("vm-connect",60329),cloud:(0,u.$Bj)("cloud",60330),merge:(0,u.$Bj)("merge",60331),export:(0,u.$Bj)("export",60332),graphLeft:(0,u.$Bj)("graph-left",60333),magnet:(0,u.$Bj)("magnet",60334),notebook:(0,u.$Bj)("notebook",60335),redo:(0,u.$Bj)("redo",60336),checkAll:(0,u.$Bj)("check-all",60337),pinnedDirty:(0,u.$Bj)("pinned-dirty",60338),passFilled:(0,u.$Bj)("pass-filled",60339),circleLargeFilled:(0,u.$Bj)("circle-large-filled",60340),circleLarge:(0,u.$Bj)("circle-large",60341),circleLargeOutline:(0,u.$Bj)("circle-large-outline",60341),combine:(0,u.$Bj)("combine",60342),gather:(0,u.$Bj)("gather",60342),table:(0,u.$Bj)("table",60343),variableGroup:(0,u.$Bj)("variable-group",60344),typeHierarchy:(0,u.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Bj)("git-pull-request-create",60348),runAbove:(0,u.$Bj)("run-above",60349),runBelow:(0,u.$Bj)("run-below",60350),notebookTemplate:(0,u.$Bj)("notebook-template",60351),debugRerun:(0,u.$Bj)("debug-rerun",60352),workspaceTrusted:(0,u.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Bj)("workspace-unknown",60355),terminalCmd:(0,u.$Bj)("terminal-cmd",60356),terminalDebian:(0,u.$Bj)("terminal-debian",60357),terminalLinux:(0,u.$Bj)("terminal-linux",60358),terminalPowershell:(0,u.$Bj)("terminal-powershell",60359),terminalTmux:(0,u.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Bj)("terminal-ubuntu",60361),terminalBash:(0,u.$Bj)("terminal-bash",60362),arrowSwap:(0,u.$Bj)("arrow-swap",60363),copy:(0,u.$Bj)("copy",60364),personAdd:(0,u.$Bj)("person-add",60365),filterFilled:(0,u.$Bj)("filter-filled",60366),wand:(0,u.$Bj)("wand",60367),debugLineByLine:(0,u.$Bj)("debug-line-by-line",60368),inspect:(0,u.$Bj)("inspect",60369),layers:(0,u.$Bj)("layers",60370),layersDot:(0,u.$Bj)("layers-dot",60371),layersActive:(0,u.$Bj)("layers-active",60372),compass:(0,u.$Bj)("compass",60373),compassDot:(0,u.$Bj)("compass-dot",60374),compassActive:(0,u.$Bj)("compass-active",60375),azure:(0,u.$Bj)("azure",60376),issueDraft:(0,u.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Bj)("git-pull-request-draft",60379),debugAll:(0,u.$Bj)("debug-all",60380),debugCoverage:(0,u.$Bj)("debug-coverage",60381),runErrors:(0,u.$Bj)("run-errors",60382),folderLibrary:(0,u.$Bj)("folder-library",60383),debugContinueSmall:(0,u.$Bj)("debug-continue-small",60384),beakerStop:(0,u.$Bj)("beaker-stop",60385),graphLine:(0,u.$Bj)("graph-line",60386),graphScatter:(0,u.$Bj)("graph-scatter",60387),pieChart:(0,u.$Bj)("pie-chart",60388),bracket:(0,u.$Bj)("bracket",60175),bracketDot:(0,u.$Bj)("bracket-dot",60389),bracketError:(0,u.$Bj)("bracket-error",60390),lockSmall:(0,u.$Bj)("lock-small",60391),azureDevops:(0,u.$Bj)("azure-devops",60392),verifiedFilled:(0,u.$Bj)("verified-filled",60393),newline:(0,u.$Bj)("newline",60394),layout:(0,u.$Bj)("layout",60395),layoutActivitybarLeft:(0,u.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Bj)("layout-panel-right",60401),layoutPanel:(0,u.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Bj)("layout-statusbar",60405),layoutMenubar:(0,u.$Bj)("layout-menubar",60406),layoutCentered:(0,u.$Bj)("layout-centered",60407),target:(0,u.$Bj)("target",60408),indent:(0,u.$Bj)("indent",60409),recordSmall:(0,u.$Bj)("record-small",60410),errorSmall:(0,u.$Bj)("error-small",60411),terminalDecorationError:(0,u.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Bj)("layout-sidebar-left-off",60418),blank:(0,u.$Bj)("blank",60419),heartFilled:(0,u.$Bj)("heart-filled",60420),map:(0,u.$Bj)("map",60421),mapFilled:(0,u.$Bj)("map-filled",60422),circleSmall:(0,u.$Bj)("circle-small",60423),bellSlash:(0,u.$Bj)("bell-slash",60424),bellSlashDot:(0,u.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Bj)("search-fuzzy",60429),commentDraft:(0,u.$Bj)("comment-draft",60430),send:(0,u.$Bj)("send",60431),sparkle:(0,u.$Bj)("sparkle",60432),insert:(0,u.$Bj)("insert",60433),mic:(0,u.$Bj)("mic",60434),thumbsdownFilled:(0,u.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Bj)("thumbsup-filled",60436),coffee:(0,u.$Bj)("coffee",60437),snake:(0,u.$Bj)("snake",60438),game:(0,u.$Bj)("game",60439),vr:(0,u.$Bj)("vr",60440),chip:(0,u.$Bj)("chip",60441),piano:(0,u.$Bj)("piano",60442),music:(0,u.$Bj)("music",60443),micFilled:(0,u.$Bj)("mic-filled",60444),repoFetch:(0,u.$Bj)("repo-fetch",60445),copilot:(0,u.$Bj)("copilot",60446),lightbulbSparkle:(0,u.$Bj)("lightbulb-sparkle",60447),robot:(0,u.$Bj)("robot",60448),sparkleFilled:(0,u.$Bj)("sparkle-filled",60449),diffSingle:(0,u.$Bj)("diff-single",60450),diffMultiple:(0,u.$Bj)("diff-multiple",60451),surroundWith:(0,u.$Bj)("surround-with",60452),share:(0,u.$Bj)("share",60453),gitStash:(0,u.$Bj)("git-stash",60454),gitStashApply:(0,u.$Bj)("git-stash-apply",60455),gitStashPop:(0,u.$Bj)("git-stash-pop",60456),vscode:(0,u.$Bj)("vscode",60457),vscodeInsiders:(0,u.$Bj)("vscode-insiders",60458),codeOss:(0,u.$Bj)("code-oss",60459),runCoverage:(0,u.$Bj)("run-coverage",60460),runAllCoverage:(0,u.$Bj)("run-all-coverage",60461),coverage:(0,u.$Bj)("coverage",60462),githubProject:(0,u.$Bj)("github-project",60463)}}),define(Ee[78],Se([1,0,99,169]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Ej=R;function R(){return Object.values(e.$Gj)}e.$Fj={dialogError:(0,u.$Bj)("dialog-error","error"),dialogWarning:(0,u.$Bj)("dialog-warning","warning"),dialogInfo:(0,u.$Bj)("dialog-info","info"),dialogClose:(0,u.$Bj)("dialog-close","close"),treeItemExpanded:(0,u.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Bj)("tree-item-loading","loading"),menuSelection:(0,u.$Bj)("menu-selection","check"),menuSubmenu:(0,u.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Bj)("toolbar-more","more"),quickInputBack:(0,u.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Bj)("drop-down-button",60084),symbolCustomColor:(0,u.$Bj)("symbol-customcolor",60252),exportIcon:(0,u.$Bj)("export",60332),workspaceUnspecified:(0,u.$Bj)("workspace-unspecified",60355),newLine:(0,u.$Bj)("newline",60394),thumbsDownFilled:(0,u.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Bj)("thumbsup-filled",60436),gitFetch:(0,u.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Bj)("debug-breakpoint-pending",60377)},e.$Gj={...j.$Dj,...e.$Fj}}),define(Ee[24],Se([1,0,18]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=j,e.$On=R,e.$Pn=A,e.$Qn=$,e.$Rn=k,e.$Sn=M,e.$Tn=I,e.$Un=b,e.$Vn=E,e.$Wn=v,e.$Xn=c,e.$Yn=m;function j(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?j(r):r}),n}function R(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(P.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$Xf)(s)&&n.push(s)}}return a}const P=Object.prototype.hasOwnProperty;function A(a,n){return p(a,n,new Set)}function p(a,n,i){if((0,u.$4f)(a))return a;const r=n(a);if(typeof r<"u")return r;if(Array.isArray(a)){const s=[];for(const t of a)s.push(p(t,n,i));return s}if((0,u.$Wf)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const s={};for(const t in a)P.call(a,t)&&(s[t]=p(a[t],n,i));return i.delete(a),s}return a}function $(a,n,i=!0){return(0,u.$Wf)(a)?((0,u.$Wf)(n)&&Object.keys(n).forEach(r=>{r in a?i&&((0,u.$Wf)(a[r])&&(0,u.$Wf)(n[r])?$(a[r],n[r],i):a[r]=n[r]):a[r]=n[r]}),a):n}function k(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!k(a[i],n[i]))return!1}else{const s=[];for(r in a)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!k(s,t))return!1;for(i=0;i<s.length;i++)if(!k(a[s[i]],n[s[i]]))return!1}return!0}function M(a){const n=new Set;return JSON.stringify(a,(i,r)=>{if((0,u.$Wf)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function I(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(s=>{const t=a[s],g=n[s];k(t,g)||(i[s]=g)}),i}function b(a,n){const i=n.toLowerCase(),r=Object.keys(a).find(s=>s.toLowerCase()===i);return r?a[r]:a[n]}function E(a,n){const i=Object.create(null);for(const[r,s]of Object.entries(a))n(r,s)&&(i[r]=s);return i}function v(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function c(a){const n=[];for(const i of v(a))typeof a[i]=="function"&&n.push(i);return n}function m(a,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of a)r[s]=i(s);return r}}),define(Ee[56],Se([1,0,78]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Hj=R;var j;(function(A){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=p})(j||(e.ThemeColor=j={}));function R(A){return{id:A}}var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(n){const i=p.exec(n.id);if(!i)return $(u.$Gj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}A.asClassNameArray=$;function k(n){return $(n).join(" ")}A.asClassName=k;function M(n){return"."+$(n).join(".")}A.asCSSSelector=M;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||j.isThemeColor(n.color))}A.isThemeIcon=I;const b=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(n){const i=b.exec(n);if(!i)return;const[,r]=i;return{id:r}}A.fromString=E;function v(n){return{id:n}}A.fromId=v;function c(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}A.modify=c;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=m;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=a})(P||(e.ThemeIcon=P={}))}),define(Ee[170],Se([1,0,126,14,56]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=$,e.$zk=M,e.$Ak=b,e.$Bk=E,e.$Ck=c,e.$Dk=m;const P="$(",A=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${A.source}`,"g");function $(a){return a.replace(p,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${A.source}`,"g");function M(a){return a.replace(k,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(a){return a.indexOf(P)===-1?a:a.replace(I,(n,i,r,s)=>r?n:i||s||"")}function E(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(a){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=v.lastIndex,t=v.exec(a),g=a.substring(s,t?.index);if(g.length>0){n+=g;for(let d=0;d<g.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(a,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$pk)(a,r,i);const t=(0,j.$5e)(r," "),g=r.length-t.length,d=(0,u.$pk)(a,t,i);if(d)for(const l of d){const o=s[l.start+g]+g;l.start+=o,l.end+=o}return d}}),define(Ee[127],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Se=j,e.$Te=R;var u;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function j(P){return P<0?0:P>255?255:P|0}function R(P){return P<0?0:P>4294967295?4294967295:P|0}}),define(Ee[30],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=j;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(R){return u.test(R)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const P=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));return function(){R(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,k="";return k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k}}()}),define(Ee[171],Se([1,0,19,38,30]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=P,e.$Ht=A,e.$Jt=k;function P(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function A(I,b,E){const v={id:(0,R.$Dg)(),name:I,uri:b,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}class p{constructor(){this.a=new Map}get size(){let b=0;for(const E of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const E=[...this.a.keys()];return j.Iterable.some(this,([v,c])=>c.asFile())&&E.push("files"),M($(b),E)}get(b){return this.a.get(this.b(b))?.[0]}append(b,E){const v=this.a.get(b);v?v.push(E):this.a.set(this.b(b),[E])}replace(b,E){this.a.set(this.b(b),[E])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,E]of this.a)for(const v of E)yield[b,v]}b(b){return $(b)}}e.$It=p;function $(I){return I.toLowerCase()}function k(I,b){return M($(I),b.map($))}function M(I,b){if(I==="*/*")return b.length>0;if(b.includes(I))return!0;const E=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,c,m]=E;return m==="*"?b.some(a=>a.startsWith(c+"/")):!1}e.$Kt=Object.freeze({create:I=>(0,u.$Mb)(I.map(b=>b.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Kt.split(I).filter(b=>!b.startsWith("#"))})}),define(Ee[172],Se([1,0,62]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=void 0,e.$Fg=j,e.$Hg=P;function j(p,$,k,M=1){let I=!1;return new Promise(b=>{const E=setTimeout(()=>{if(!I)return I=!0,b(0)},k);R(p,$,M,v=>{if(!I)return I=!0,clearTimeout(E),b(v)})})}function R(p,$,k,M){if($===0)return M(0);const I=new u.Socket;I.once("connect",()=>(A(I),R(p+k,$-1,k,M))),I.once("data",()=>{}),I.once("error",b=>(A(I),b.code!=="ECONNREFUSED"?R(p+k,$-1,k,M):M(p))),I.connect(p,"127.0.0.1")}e.$Gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(p,$,k,M="127.0.0.1"){let I=!1,b,E=1;const v=u.createServer({pauseOnConnect:!0});function c(m,a){I||(I=!0,v.removeAllListeners(),v.close(),b&&clearTimeout(b),a(m))}return new Promise(m=>{b=setTimeout(()=>{c(0,m)},k),v.on("listening",()=>{c(p,m)}),v.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&E<$?(p++,E++,v.listen(p,M)):c(0,m)}),v.on("close",()=>{c(0,m)}),v.listen(p,M)})}function A(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch($){console.error($)}}}),define(Ee[128],Se([1,0,127]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$yt=void 0;class j{constructor(p){const $=(0,u.$Se)(p);this.c=$,this.a=j.d($),this.b=new Map}static d(p){const $=new Uint8Array(256);return $.fill(p),$}set(p,$){const k=(0,u.$Se)($);p>=0&&p<256?this.a[p]=k:this.b.set(p,k)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$yt=j;var R;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(R||(R={}));class P{constructor(){this.a=new j(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$zt=P}),define(Ee[173],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=j;var u;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function j(R){let P=0,A=0,p=0,$=0;for(let k=0,M=R.length;k<M;k++){const I=R.charCodeAt(k);I===13?(P===0&&(A=k),P++,k+1<M&&R.charCodeAt(k+1)===10?($|=2,k++):$|=3,p=k+1):I===10&&($|=1,P===0&&(A=k),P++,p=k+1)}return P===0&&(A=R.length),[P,A,R.length-p,$]}}),define(Ee[49],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0;class u{constructor(R,P){this.lineNumber=R,this.column=P}with(R=this.lineNumber,P=this.column){return R===this.lineNumber&&P===this.column?this:new u(R,P)}delta(R=0,P=0){return this.with(this.lineNumber+R,this.column+P)}equals(R){return u.equals(this,R)}static equals(R,P){return!R&&!P?!0:!!R&&!!P&&R.lineNumber===P.lineNumber&&R.column===P.column}isBefore(R){return u.isBefore(this,R)}static isBefore(R,P){return R.lineNumber<P.lineNumber?!0:P.lineNumber<R.lineNumber?!1:R.column<P.column}isBeforeOrEqual(R){return u.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,P){return R.lineNumber<P.lineNumber?!0:P.lineNumber<R.lineNumber?!1:R.column<=P.column}static compare(R,P){const A=R.lineNumber|0,p=P.lineNumber|0;if(A===p){const $=R.column|0,k=P.column|0;return $-k}return A-p}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new u(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$at=u}),define(Ee[29],Se([1,0,49]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class j{constructor(P,A,p,$){P>p||P===p&&A>$?(this.startLineNumber=p,this.startColumn=$,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=p,this.endColumn=$)}isEmpty(){return j.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return j.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return j.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return j.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return j.plusRange(this,P)}static plusRange(P,A){let p,$,k,M;return A.startLineNumber<P.startLineNumber?(p=A.startLineNumber,$=A.startColumn):A.startLineNumber===P.startLineNumber?(p=A.startLineNumber,$=Math.min(A.startColumn,P.startColumn)):(p=P.startLineNumber,$=P.startColumn),A.endLineNumber>P.endLineNumber?(k=A.endLineNumber,M=A.endColumn):A.endLineNumber===P.endLineNumber?(k=A.endLineNumber,M=Math.max(A.endColumn,P.endColumn)):(k=P.endLineNumber,M=P.endColumn),new j(p,$,k,M)}intersectRanges(P){return j.intersectRanges(this,P)}static intersectRanges(P,A){let p=P.startLineNumber,$=P.startColumn,k=P.endLineNumber,M=P.endColumn;const I=A.startLineNumber,b=A.startColumn,E=A.endLineNumber,v=A.endColumn;return p<I?(p=I,$=b):p===I&&($=Math.max($,b)),k>E?(k=E,M=v):k===E&&(M=Math.min(M,v)),p>k||p===k&&$>M?null:new j(p,$,k,M)}equalsRange(P){return j.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return j.getEndPosition(this)}static getEndPosition(P){return new u.$at(P.endLineNumber,P.endColumn)}getStartPosition(){return j.getStartPosition(this)}static getStartPosition(P){return new u.$at(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new j(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new j(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return j.collapseToStart(this)}static collapseToStart(P){return new j(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return j.collapseToEnd(this)}static collapseToEnd(P){return new j(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new j(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new j(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new j(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const k=P.startLineNumber|0,M=A.startLineNumber|0;if(k===M){const I=P.startColumn|0,b=A.startColumn|0;if(I===b){const E=P.endLineNumber|0,v=A.endLineNumber|0;if(E===v){const c=P.endColumn|0,m=A.endColumn|0;return c-m}return E-v}return I-b}return k-M}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$bt=j}),define(Ee[174],Se([1,0,29]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class j{static insert(P,A){return{range:new u.$bt(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$ct=j}),define(Ee[175],Se([1,0,49,29]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.SelectionDirection=void 0;var R;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(R||(e.SelectionDirection=R={}));class P extends j.$bt{constructor(p,$,k,M){super(p,$,k,M),this.selectionStartLineNumber=p,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=M}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return P.selectionsEqual(this,p)}static selectionsEqual(p,$){return p.selectionStartLineNumber===$.selectionStartLineNumber&&p.selectionStartColumn===$.selectionStartColumn&&p.positionLineNumber===$.positionLineNumber&&p.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,p,$):new P(p,$,this.startLineNumber,this.startColumn)}getPosition(){return new u.$at(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$at(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,$){return this.getDirection()===0?new P(p,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,p,$)}static fromPositions(p,$=p){return new P(p.lineNumber,p.column,$.lineNumber,$.column)}static fromRange(p,$){return $===0?new P(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new P(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new P(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,$){if(p&&!$||!p&&$)return!1;if(!p&&!$)return!0;if(p.length!==$.length)return!1;for(let k=0,M=p.length;k<M;k++)if(!this.selectionsEqual(p[k],$[k]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,$,k,M,I){return I===0?new P(p,$,k,M):new P(k,M,p,$)}}e.$dt=P}),define(Ee[176],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0,e.$Ls={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[177],Se([1,0,128]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.WordCharacterClass=void 0;var j;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(j||(e.WordCharacterClass=j={}));class R extends u.$yt{constructor(p){super(0);for(let $=0,k=p.length;$<k;$++)this.set(p.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$At=R;function P(A){const p={};return $=>(p.hasOwnProperty($)||(p[$]=A($)),p[$])}e.$Bt=P(A=>new R(A))}),define(Ee[129],Se([1,0,38,3,75]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=e.$Ms=void 0,e.$Os=A,e.$Ps=$,e.$Qs=k,e.$Ms="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(I=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Ms)I.indexOf(E)>=0||(b+="\\"+E);return b+="\\s]+)",new RegExp(b,"g")}e.$Ns=P();function A(I){let b=e.$Ns;if(I&&I instanceof RegExp)if(I.global)b=I;else{let E="g";I.ignoreCase&&(E+="i"),I.multiline&&(E+="m"),I.unicode&&(E+="u"),b=new RegExp(I.source,E)}return b.lastIndex=0,b}const p=new R.$5c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const b=p.unshift(I);return(0,j.$Sc)(b)}function k(I,b,E,v,c){if(b=A(b),c||(c=u.Iterable.first(p)),E.length>c.maxLen){let r=I-c.maxLen/2;return r<0?r=0:v+=r,E=E.substring(r,I+c.maxLen/2),k(I,b,E,v,c)}const m=Date.now(),a=I-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-m>=c.timeBudget);r++){const s=a-c.windowSize*r;b.lastIndex=Math.max(0,s);const t=M(b,E,a,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return b.lastIndex=0,r}return null}function M(I,b,E,v){let c;for(;c=I.exec(b);){const m=c.index||0;if(m<=E&&I.lastIndex>=E)return c;if(v>0&&m>v)return null}return null}}),define(Ee[178],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var u;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class j{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,k=p.notIn.length;$<k;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset($-2),M=p.getStandardTokenType(k);return this.isOK(M)}g(p,$){for(let k=p;k<=$;k++){const M=String.fromCharCode(k);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=j;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$bu=R;function P(A,p,$){A.has(p)?A.get(p).push($):A.set(p,[$])}}),define(Ee[179],Se([1,0,128]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l2=e.$k2=e.State=void 0,e.$m2=b;var j;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(j||(e.State=j={}));class R{constructor(v,c,m){const a=new Uint8Array(v*c);for(let n=0,i=v*c;n<i;n++)a[n]=m;this.a=a,this.rows=v,this.cols=c}get(v,c){return this.a[v*this.cols+c]}set(v,c,m){this.a[v*this.cols+c]=m}}class P{constructor(v){let c=0,m=0;for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];s>c&&(c=s),r>m&&(m=r),t>m&&(m=t)}c++,m++;const a=new R(m,c,0);for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];a.set(r,s,t)}this.a=a,this.b=c}nextState(v,c){return c<0||c>=this.b?0:this.a.get(v,c)}}e.$k2=P;let A=null;function p(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var $;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function M(){if(k===null){k=new u.$yt(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<E.length;c++)k.set(E.charCodeAt(c),1);const v=".,;:";for(let c=0;c<v.length;c++)k.set(v.charCodeAt(c),2)}return k}class I{static a(v,c,m,a,n){let i=n-1;do{const r=c.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>a);if(a>0){const r=c.charCodeAt(a-1),s=c.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:a+1,endLineNumber:m,endColumn:i+2},url:c.substring(a,i+1)}}static computeLinks(v,c=p()){const m=M(),a=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),s=r.length;let t=0,g=0,d=0,l=1,o=!1,h=!1,f=!1,D=!1;for(;t<s;){let w=!1;const S=r.charCodeAt(t);if(l===13){let y;switch(S){case 40:o=!0,y=0;break;case 41:y=o?0:1;break;case 91:f=!0,h=!0,y=0;break;case 93:f=!1,y=h?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:d===S?y=1:d===39||d===34||d===96?y=0:y=1;break;case 42:y=d===42?1:0;break;case 124:y=d===124?1:0;break;case 32:y=f?0:1;break;default:y=m.get(S)}y===1&&(a.push(I.a(m,r,n,g,t)),w=!0)}else if(l===12){let y;S===91?(h=!0,y=0):y=m.get(S),y===1?w=!0:l=13}else l=c.nextState(l,S),l===0&&(w=!0);w&&(l=1,o=!1,h=!1,D=!1,g=t+1,d=S),t++}l===13&&a.push(I.a(m,r,n,g,s))}return a}}e.$l2=I;function b(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:I.computeLinks(E)}}),define(Ee[79],Se([1,0,24]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$vv=e.$uv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$wv=E,e.$Av=i;var j;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(j||(e.OverviewRulerLane=j={}));var R;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(R||(e.GlyphMarginLane=R={}));var P;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var p;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var $;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var k;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class M{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),s.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,s.indentSize|0),this.a=!1),this.insertSpaces=!!s.insertSpaces,this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=!!s.trimAutoWhitespace,this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.a===s.a&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,u.$Rn)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.$uv=M;class I{constructor(s,t){this._findMatchBrand=void 0,this.range=s,this.matches=t}}e.$vv=I;var b;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(e.TrackedRangeStickiness=b={}));function E(r){return r&&typeof r.read=="function"}var v;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(v||(e.PositionAffinity=v={}));var c;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class m{constructor(s,t,g,d,l,o){this.identifier=s,this.range=t,this.text=g,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=l,this._isTracked=o}}e.$xv=m;class a{constructor(s,t,g){this.regex=s,this.wordSeparators=t,this.simpleSearch=g}}e.$yv=a;class n{constructor(s,t,g){this.reverseEdits=s,this.changes=t,this.trimAutoWhitespaceLineNumbers=g}}e.$zv=n;function i(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}}),define(Ee[180],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.NodeColor=e.$cC=void 0,e.$eC=R,e.$fC=P,e.$gC=k,e.$hC=M,e.$iC=I,e.$jC=b,e.$kC=E,e.$lC=v;class u{constructor(m,a){this.piece=m,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$dC)return R(this.right);let m=this;for(;m.parent!==e.$dC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$dC?e.$dC:m.parent}prev(){if(this.left!==e.$dC)return P(this.left);let m=this;for(;m.parent!==e.$dC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$dC?e.$dC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$cC=u;var j;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(j||(e.NodeColor=j={})),e.$dC=new u(null,0),e.$dC.parent=e.$dC,e.$dC.left=e.$dC,e.$dC.right=e.$dC,e.$dC.color=0;function R(c){for(;c.left!==e.$dC;)c=c.left;return c}function P(c){for(;c.right!==e.$dC;)c=c.right;return c}function A(c){return c===e.$dC?0:c.size_left+c.piece.length+A(c.right)}function p(c){return c===e.$dC?0:c.lf_left+c.piece.lineFeedCnt+p(c.right)}function $(){e.$dC.parent=e.$dC}function k(c,m){const a=m.right;a.size_left+=m.size_left+(m.piece?m.piece.length:0),a.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=a.left,a.left!==e.$dC&&(a.left.parent=m),a.parent=m.parent,m.parent===e.$dC?c.root=a:m.parent.left===m?m.parent.left=a:m.parent.right=a,a.left=m,m.parent=a}function M(c,m){const a=m.left;m.left=a.right,a.right!==e.$dC&&(a.right.parent=m),a.parent=m.parent,m.size_left-=a.size_left+(a.piece?a.piece.length:0),m.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),m.parent===e.$dC?c.root=a:m===m.parent.right?m.parent.right=a:m.parent.left=a,a.right=m,m.parent=a}function I(c,m){let a,n;if(m.left===e.$dC?(n=m,a=n.right):m.right===e.$dC?(n=m,a=n.left):(n=R(m.right),a=n.right),n===c.root){c.root=a,a.color=0,m.detach(),$(),c.root.parent=e.$dC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===m?(a.parent=n.parent,v(c,a)):(n.parent===m?a.parent=n:a.parent=n.parent,v(c,a),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===c.root?c.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$dC&&(n.left.parent=n),n.right!==e.$dC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,v(c,n)),m.detach(),a.parent.left===a){const s=A(a),t=p(a);if(s!==a.parent.size_left||t!==a.parent.lf_left){const g=s-a.parent.size_left,d=t-a.parent.lf_left;a.parent.size_left=s,a.parent.lf_left=t,E(c,a.parent,g,d)}}if(v(c,a.parent),i){$();return}let r;for(;a!==c.root&&a.color===0;)a===a.parent.left?(r=a.parent.right,r.color===1&&(r.color=0,a.parent.color=1,k(c,a.parent),r=a.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,a=a.parent):(r.right.color===0&&(r.left.color=0,r.color=1,M(c,r),r=a.parent.right),r.color=a.parent.color,a.parent.color=0,r.right.color=0,k(c,a.parent),a=c.root)):(r=a.parent.left,r.color===1&&(r.color=0,a.parent.color=1,M(c,a.parent),r=a.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,a=a.parent):(r.left.color===0&&(r.right.color=0,r.color=1,k(c,r),r=a.parent.left),r.color=a.parent.color,a.parent.color=0,r.left.color=0,M(c,a.parent),a=c.root));a.color=0,$()}function b(c,m){for(v(c,m);m!==c.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const a=m.parent.parent.right;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,k(c,m)),m.parent.color=0,m.parent.parent.color=1,M(c,m.parent.parent))}else{const a=m.parent.parent.left;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,M(c,m)),m.parent.color=0,m.parent.parent.color=1,k(c,m.parent.parent))}c.root.color=0}function E(c,m,a,n){for(;m!==c.root&&m!==e.$dC;)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=n),m=m.parent}function v(c,m){let a=0,n=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,a=A(m.left)-m.size_left,n=p(m.left)-m.lf_left,m.size_left+=a,m.lf_left+=n;m!==c.root&&(a!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=n),m=m.parent}}}),define(Ee[181],Se([1,0,19,127]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=void 0;class R{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,j.$Te)($);const M=this.a,I=this.b,b=k.length;return b===0?!1:(this.a=new Uint32Array(M.length+b),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($),$+b),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,j.$Te)($),k=(0,j.$Te)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,j.$Te)($),k=(0,j.$Te)(k);const M=this.a,I=this.b;if($>=M.length)return!1;const b=M.length-$;return k>=b&&(k=b),k===0?!1:(this.a=new Uint32Array(M.length-k),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,j.$Te)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let M=k;M<=$;M++)this.b[M]=this.b[M-1]+this.a[M];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,M=this.a.length-1,I=0,b=0,E=0;for(;k<=M;)if(I=k+(M-k)/2|0,b=this.b[I],E=b-this.a[I],$<E)M=I-1;else if($>=b)k=I+1;else break;return new A(I,$-E)}}e.$Dv=R;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],M=k>0?this.d[k-1]:0;return new A(k,$-M)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,u.$Wb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const M=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+M;for(let b=0;b<M;b++)this.e[I+b]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$Ev=P;class A{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$Fv=A}),define(Ee[182],Se([1,0,14,49,181]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=void 0;class P{constructor(p,$,k,M){this.d=p,this.f=$,this.g=k,this.h=M,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const $=p.changes;for(const k of $)this.o(k.range),this.p(new j.$at(k.range.startLineNumber,k.range.startColumn),k.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,$=this.f.length,k=new Uint32Array($);for(let M=0;M<$;M++)k[M]=this.f[M].length+p;this.j=new R.$Dv(k)}}n(p,$){this.f[p]=$,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,$){if($.length===0)return;const k=(0,u.$$e)($);if(k.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+k[0]+this.f[p.lineNumber-1].substring(p.column-1));return}k[k.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+k[0]);const M=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this.f.splice(p.lineNumber+I-1,0,k[I]),M[I-1]=k[I].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,M)}}e.$Gv=P}),define(Ee[100],Se([1,0,14,177,49,29,79]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.$pC=e.$mC=void 0,e.$nC=k,e.$oC=M,e.$qC=c;const p=999;class ${constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=k(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new A.$yv(i,this.wordSeparators?(0,j.$Bt)(this.wordSeparators):null,r?this.searchString:null)}}e.$mC=$;function k(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const r=a.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=a.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function M(a,n,i){if(!i)return new A.$vv(a,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new A.$vv(a,r)}class I{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class b{static findMatches(n,i,r,s,t){const g=i.parseSearchRequest();return g?g.regex.multiline?this.b(n,r,new m(g.wordSeparators,g.regex),s,t):this.c(n,r,g,s,t):[]}static a(n,i,r,s,t,g){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let o;if(s){const w=s.findLineFeedCountBeforeOffset(t+g.length)-l;o=d+g.length+w}else o=d+g.length;const h=n.getPositionAt(d),f=n.getPositionAt(o);return new P.$bt(h.lineNumber,h.column,f.lineNumber,f.column)}static b(n,i,r,s,t){const g=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new I(d):null,o=[];let h=0,f;for(r.reset(0);f=r.next(d);)if(o[h++]=M(this.a(n,g,d,l,f.index,f[0]),f,s),h>=t)return o;return o}static c(n,i,r,s,t){const g=[];let d=0;if(i.startLineNumber===i.endLineNumber){const o=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,o,i.startLineNumber,i.startColumn-1,d,g,s,t),g}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,g,s,t);for(let o=i.startLineNumber+1;o<i.endLineNumber&&d<t;o++)d=this.d(r,n.getLineContent(o),o,0,d,g,s,t);if(d<t){const o=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,o,i.endLineNumber,0,d,g,s,t)}return g}static d(n,i,r,s,t,g,d,l){const o=n.wordSeparators;if(!d&&n.simpleSearch){const D=n.simpleSearch,w=D.length,S=i.length;let y=-w;for(;(y=i.indexOf(D,y+w))!==-1;)if((!o||c(o,i,S,y,w))&&(g[t++]=new A.$vv(new P.$bt(r,y+1+s,r,y+1+w+s),null),t>=l))return t;return t}const h=new m(n.wordSeparators,n.regex);let f;h.reset(0);do if(f=h.next(i),f&&(g[t++]=M(new P.$bt(r,f.index+1+s,r,f.index+1+f[0].length+s),f,d),t>=l))return t;while(f);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const g=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,g,s):this.f(n,r,g,s)}static e(n,i,r,s){const t=new R.$at(i.lineNumber,1),g=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new P.$bt(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),o=n.getEOL()===`\r
`?new I(l):null;r.reset(i.column-1);const h=r.next(l);return h?M(this.a(n,g,l,o,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new R.$at(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),g=i.lineNumber,d=n.getLineContent(g),l=this.g(r,d,g,i.column,s);if(l)return l;for(let o=1;o<=t;o++){const h=(g+o-1)%t,f=n.getLineContent(h+1),D=this.g(r,f,h+1,1,s);if(D)return D}return null}static g(n,i,r,s,t){n.reset(s-1);const g=n.next(i);return g?M(new P.$bt(r,g.index+1,r,g.index+1+g[0].length),g,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const g=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,g,s):this.j(n,r,g,s)}static h(n,i,r,s){const t=this.b(n,new P.$bt(1,1,i.lineNumber,i.column),r,s,10*p);if(t.length>0)return t[t.length-1];const g=n.getLineCount();return i.lineNumber!==g||i.column!==n.getLineMaxColumn(g)?this.h(n,new R.$at(g,n.getLineMaxColumn(g)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),g=i.lineNumber,d=n.getLineContent(g).substring(0,i.column-1),l=this.k(r,d,g,s);if(l)return l;for(let o=1;o<=t;o++){const h=(t+g-o-1)%t,f=n.getLineContent(h+1),D=this.k(r,f,h+1,s);if(D)return D}return null}static k(n,i,r,s){let t=null,g;for(n.reset(0);g=n.next(i);)t=M(new P.$bt(r,g.index+1,r,g.index+1+g[0].length),g,s);return t}}e.$pC=b;function E(a,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(a.get(t)!==0||t===13||t===10)return!0;if(s>0){const g=n.charCodeAt(r);if(a.get(g)!==0)return!0}return!1}function v(a,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(a.get(t)!==0||t===13||t===10)return!0;if(s>0){const g=n.charCodeAt(r+s-1);if(a.get(g)!==0)return!0}return!1}function c(a,n,i,r,s){return E(a,n,i,r,s)&&v(a,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$sf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||c(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$rC=m}),define(Ee[130],Se([1,0,49,29,79,180,100]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=e.$vC=e.$uC=void 0,e.$sC=M,e.$tC=I;const p=65535;function $(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class k{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function M(a,n=!0){const i=[0];let r=1;for(let s=0,t=a.length;s<t;s++){const g=a.charCodeAt(s);g===13?s+1<t&&a.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:g===10&&(i[r++]=s+1)}return n?$(i):i}function I(a,n){a.length=0,a[0]=0;let i=1,r=0,s=0,t=0,g=!0;for(let l=0,o=n.length;l<o;l++){const h=n.charCodeAt(l);h===13?l+1<o&&n.charCodeAt(l+1)===10?(t++,a[i++]=l+2,l++):(r++,a[i++]=l+1):h===10?(s++,a[i++]=l+1):g&&h!==9&&(h<32||h>126)&&(g=!1)}const d=new k($(a),r,s,t,g);return a.length=0,d}class b{constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$uC=b;class E{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$vC=E;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==P.$dC&&n.iterate(n.root,r=>(r!==P.$dC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=P.$dC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,g=n.length;t<g;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=M(n[t].buffer));const d=new b(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=p,r=i-Math.floor(i/3),s=r*2;let t="",g=0;const d=[];if(this.iterate(this.root,l=>{const o=this.R(l),h=o.length;if(g<=r||g+h<s)return t+=o,g+=h,!0;const f=t.replace(/\r\n|\r|\n/g,n);return d.push(new E(f,M(f))),t=o,g=h,!0}),g>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new E(l,M(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===P.$dC)return!0;const t=this.R(s),g=t.length,d=n.G(i),l=n.G(i+g),o=n.getValueInRange2(d,l);return i+=g,t===o})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==P.$dC;)if(s.left!==P.$dC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==P.$dC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const g=this.getOffsetAt(r+1,1),d=s-g;return new u.$at(r+1,d+1)}return new u.$at(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===P.$dC){const t=this.getOffsetAt(r+1,1),g=s-n-t;return new u.$at(r+1,g+1)}else i=i.right;return new u.$at(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,o=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(o+n.remainder,o+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let g=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==P.$dC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){g+=d.substring(l,l+i.remainder);break}else g+=d.substr(l,r.piece.length);r=r.next()}return g}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===P.$dC)return!0;const g=t.piece;let d=g.length;if(d===0)return!0;const l=this.a[g.bufferIndex].buffer,o=this.a[g.bufferIndex].lineStarts,h=g.start.line,f=g.end.line;let D=o[h]+g.start.column;if(s&&(l.charCodeAt(D)===10&&(D++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===f)return!this.f&&l.charCodeAt(D+d-1)===13?(s=!0,r+=l.substr(D,d-1)):r+=l.substr(D,d),!0;r+=this.f?l.substring(D,Math.max(D,o[h+1]-this.e)):l.substring(D,o[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let w=h+1;w<f;w++)r=this.f?l.substring(o[w],o[w+1]-this.e):l.substring(o[w],o[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(o[f]+g.end.column-1)===13?(s=!0,g.end.column===0?i--:r=l.substr(o[f],g.end.column-1)):r=l.substr(o[f],g.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,g,d,l,o,h,f){const D=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),S=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,g);let C;const O={line:0,column:0};let z,F;i._wordSeparators?(z=D.buffer.substring(S,y),F=T=>T+S,i.reset(0)):(z=D.buffer,F=T=>T,i.reset(S));do if(C=i.next(z),C){if(F(C.index)>=y)return h;this.s(n,F(C.index)-w,O);const T=this.t(n.piece.bufferIndex,t,O),L=O.line===t.line?O.column-t.column+s:O.column+1,N=L+C[0].length;if(f[h++]=(0,A.$oC)(new j.$bt(r+T,L,r+T,N),C,l),F(C.index)+C[0].length>=y||h>=o)return h}while(C);return h}findMatchesLineByLine(n,i,r,s){const t=[];let g=0;const d=new A.$rC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const o=this.H(n.endLineNumber,n.endColumn);if(o===null)return[];let h=this.s(l.node,l.remainder);const f=this.s(o.node,o.remainder);if(l.node===o.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,f,i,r,s,g,t),t;let D=n.startLineNumber,w=l.node;for(;w!==o.node;){const y=this.t(w.piece.bufferIndex,h,w.piece.end);if(y>=1){const O=this.a[w.piece.bufferIndex].lineStarts,z=this.u(w.piece.bufferIndex,w.piece.start),F=O[h.line+y],T=D===n.startLineNumber?n.startColumn:1;if(g=this.findMatchesInNode(w,d,D,T,h,this.s(w,F-z),i,r,s,g,t),g>=s)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const O=this.getLineContent(D).substring(C,n.endColumn-1);return g=this.n(i,d,O,n.endLineNumber,C,g,t,r,s),t}if(g=this.n(i,d,this.getLineContent(D).substr(C),D,C,g,t,r,s),g>=s)return t;D++,l=this.H(D,1),w=l.node,h=this.s(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return g=this.n(i,d,C,n.endLineNumber,y,g,t,r,s),t}const S=D===n.startLineNumber?n.startColumn:1;return g=this.findMatchesInNode(o.node,d,D,S,h,f,i,r,s,g,t),t}n(n,i,r,s,t,g,d,l,o){const h=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,w=D.length,S=r.length;let y=-w;for(;(y=r.indexOf(D,y+w))!==-1;)if((!h||(0,A.$qC)(h,r,S,y,w))&&(d[g++]=new R.$vv(new j.$bt(s,y+1+t,s,y+1+w+t),null),g>=o))return g;return g}let f;i.reset(0);do if(f=i.next(r),f&&(d[g++]=(0,A.$oC)(new j.$bt(s,f.index+1+t,s,f.index+1+f[0].length+t),f,l),g>=o))return g;while(f);return g}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==P.$dC){const{node:s,remainder:t,nodeStartOffset:g}=this.G(n),d=s.piece,l=d.bufferIndex,o=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&g+d.length===n&&i.length<p){this.F(s,i),this.y();return}if(g===n)this.o(i,s),this.h.validate(n);else if(g+s.piece.length>n){const h=[];let f=new b(d.bufferIndex,o,d.end,this.t(d.bufferIndex,o,d.end),this.u(l,d.end)-this.u(l,o));if(this.K()&&this.M(i)&&this.I(s,t)===10){const y={line:f.start.line+1,column:0};f=new b(f.bufferIndex,y,f.end,this.t(f.bufferIndex,y,f.end),f.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,o);else this.C(s,o);const D=this.w(i);f.length>0&&this.S(s,f);let w=s;for(let S=0;S<D.length;S++)w=this.S(w,D[S]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let g=1;g<s.length;g++)t=this.S(t,s[g])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===P.$dC)return;const r=this.G(n),s=this.G(n+i),t=r.node,g=s.node;if(t===g){const D=this.s(t,r.remainder),w=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const S=t.next();(0,P.$iC)(this,t),this.N(S),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,w),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const o=this.s(g,s.remainder);this.D(g,o),g.piece.length===0&&d.push(g);const h=t.next();for(let D=h;D!==P.$dC&&D!==g;D=D.next())d.push(D);const f=t.piece.length===0?t.prev():t;this.v(d),this.O(f),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const g=i.piece,d={line:g.start.line+1,column:0},l=new b(g.bufferIndex,d,g.end,this.t(g.bufferIndex,d,g.end),g.length-1);i.piece=l,n+=`
`,(0,P.$kC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let g=s.length-2;g>=0;g--)t=this.T(t,s[g]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let g=1;g<r.length;g++)t=this.S(t,r[g]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,g=this.a[t].lineStarts,l=g[s.start.line]+s.start.column+i;let o=s.start.line,h=s.end.line,f=0,D=0,w=0;for(;o<=h&&(f=o+(h-o)/2|0,w=g[f],f!==h);)if(D=g[f+1],l<w)h=f-1;else if(l>=D)o=f+1;else break;return r?(r.line=f,r.column=l-w,null):{line:f,column:l-w}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],g=s[r.line]+r.column;if(t>g+1)return r.line-i.line;const d=g-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,P.$iC)(this,n[i])}w(n){if(n.length>p){const h=[];for(;n.length>p;){const D=n.charCodeAt(p-1);let w;D===13||D>=55296&&D<=56319?(w=n.substring(0,p-1),n=n.substring(p-1)):(w=n.substring(0,p),n=n.substring(p));const S=M(w);h.push(new b(this.a.length,{line:0,column:0},{line:S.length-1,column:w.length-S[S.length-1]},S.length-1,w.length)),this.a.push(new E(w,S))}const f=M(n);return h.push(new b(this.a.length,{line:0,column:0},{line:f.length-1,column:n.length-f[f.length-1]},f.length-1,n.length)),this.a.push(new E(n,f)),h}let i=this.a[0].buffer.length;const r=M(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[g],l={line:g,column:d},o=new b(0,s,l,this.t(0,s,l),t-i);return this.g=l,[o]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const g=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+g,l+r.piece.length);else{const o=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+g,l+o-i)}}else{let g=0;const d=n;for(;r!==P.$dC;)if(r.left!==P.$dC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),o=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,f=this.u(r.piece.bufferIndex,r.piece.start);return g+=r.size_left,this.h.set({node:r,nodeStartOffset:g,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(f+l,f+o-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),o=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=o.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,g+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==P.$dC;){const g=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=g.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=g.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==P.$dC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const g=this.t(n.piece.bufferIndex,r.start,s);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),g=i,d=this.u(r.bufferIndex,g),l=this.t(r.bufferIndex,r.start,g),o=l-s,h=d-t,f=r.length+h;n.piece=new b(r.bufferIndex,r.start,g,l,f),(0,P.$kC)(this,n,h,o)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),g=i,d=this.t(r.bufferIndex,g,r.end),l=this.u(r.bufferIndex,g),o=d-s,h=t-l,f=r.length+h;n.piece=new b(r.bufferIndex,g,r.end,d,f),(0,P.$kC)(this,n,h,o)}E(n,i,r){const s=n.piece,t=s.start,g=s.end,d=s.length,l=s.lineFeedCnt,o=i,h=this.t(s.bufferIndex,s.start,o),f=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new b(s.bufferIndex,s.start,o,h,f),(0,P.$kC)(this,n,f-d,h-l);const D=new b(s.bufferIndex,r,g,this.t(s.bufferIndex,r,g),this.u(s.bufferIndex,g)-this.u(s.bufferIndex,r)),w=this.S(n,D);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=M(i,!1);for(let w=0;w<t.length;w++)t[w]+=s;if(r){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[g],l={line:g,column:d},o=n.piece.length+i.length,h=n.piece.lineFeedCnt,f=this.t(0,n.piece.start,l),D=f-h;n.piece=new b(n.piece.bufferIndex,n.piece.start,l,f,o),this.g=l,(0,P.$kC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==P.$dC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==P.$dC;)if(r.left!==P.$dC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),g=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,g),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==P.$dC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),g=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:g}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===P.$dC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===P.$dC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const g=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new b(n.piece.bufferIndex,n.piece.start,t,d,g),(0,P.$kC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},o=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new b(i.piece.bufferIndex,l,i.piece.end,h,o),(0,P.$kC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const f=this.w(`\r
`);this.S(n,f[0]);for(let D=0;D<r.length;D++)(0,P.$iC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,P.$iC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},g=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new b(s.bufferIndex,t,s.end,d,g),(0,P.$kC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===P.$dC)return i(P.$dC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===P.$dC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new P.$cC(i,1);if(r.left=P.$dC,r.right=P.$dC,r.parent=P.$dC,r.size_left=0,r.lf_left=0,this.root===P.$dC)this.root=r,r.color=0;else if(n.right===P.$dC)n.right=r,r.parent=n;else{const t=(0,P.$eC)(n.right);t.left=r,r.parent=t}return(0,P.$jC)(this,r),r}T(n,i){const r=new P.$cC(i,1);if(r.left=P.$dC,r.right=P.$dC,r.parent=P.$dC,r.size_left=0,r.lf_left=0,this.root===P.$dC)this.root=r,r.color=0;else if(n.left===P.$dC)n.left=r,r.parent=n;else{const s=(0,P.$fC)(n.left);s.right=r,r.parent=s}return(0,P.$jC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$wC=m}),define(Ee[183],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9=e.$Y9=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const A=this.a.get(P);return this.a.delete(P),A}}addDragOperationTransfer(P,A){this.a.set(P,A)}}e.$Y9=u;class j{constructor(P){this.identifier=P}}e.$Z9=j}),define(Ee[184],Se([1,0,4,3]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,$){return this.a.set(p,$),this.handleChange([p]),(0,j.$Sc)(()=>{this.a.get(p)===$&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,$){this.b.get(p)?.dispose();const k=new P(this,p,$);return this.b.set(p,k),(0,j.$Sc)(()=>{const M=this.b.get(p);!M||M!==k||(this.b.delete(p),M.dispose())})}async getOrCreate(p){const $=this.get(p);if($)return $;const k=this.b.get(p);return!k||k.isResolved?null:(await k.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const k=this.b.get(p);return!!(!k||k.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Mt=R;class P extends j.$Uc{get isResolved(){return this.c}constructor(p,$,k){super(),this.f=p,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Ee[185],Se([9,10]),function(de,e){return de.create("vs/base/common/actions",e)}),define(Ee[186],Se([1,0,4,3,185]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=void 0,e.$4i=M;class P extends j.$Uc{constructor(b,E="",v="",c=!0,m){super(),this.h=this.B(new u.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=E,this.u=v,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,E){this.C&&await this.C(b)}}e.$Yi=P;class A extends j.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$7d),this.onWillRun=this.f.event,this.m=this.B(new u.$7d),this.onDidRun=this.m.event}async run(b,E){if(!b.enabled)return;this.f.fire({action:b});let v;try{await this.u(b,E)}catch(c){v=c}this.m.fire({action:b,error:v})}async u(b,E){await b.run(E)}}e.$Zi=A;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let E=[];for(const v of b)v.length&&(E.length?E=[...E,new p,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$1i=p;class ${get actions(){return this.a}constructor(b,E,v,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=E,this.class=c,this.a=v}async run(){}}e.$2i=$;class k extends P{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,R.localize(0,null),void 0,!1)}}e.$3i=k;function M(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...b)=>I.run(...b),tooltip:I.label}}}),define(Ee[187],Se([9,10]),function(de,e){return de.create("vs/base/common/date",e)}),define(Ee[188],Se([1,0,187]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=k,e.$Nm=M,e.$Om=I;const j=60,R=j*60,P=R*24,A=P*7,p=P*30,$=P*365;function k(b,E,v,c){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,u.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,u.localize)(1,null);let a;return m<j?(a=m,E?a===1?v?(0,u.localize)(2,null,a):(0,u.localize)(3,null,a):v?(0,u.localize)(4,null,a):(0,u.localize)(5,null,a):a===1?v?(0,u.localize)(6,null,a):(0,u.localize)(7,null,a):v?(0,u.localize)(8,null,a):(0,u.localize)(9,null,a)):m<R?(a=Math.floor(m/j),E?a===1?v?(0,u.localize)(10,null,a):(0,u.localize)(11,null,a):v?(0,u.localize)(12,null,a):(0,u.localize)(13,null,a):a===1?v?(0,u.localize)(14,null,a):(0,u.localize)(15,null,a):v?(0,u.localize)(16,null,a):(0,u.localize)(17,null,a)):m<P?(a=Math.floor(m/R),E?a===1?v?(0,u.localize)(18,null,a):(0,u.localize)(19,null,a):v?(0,u.localize)(20,null,a):(0,u.localize)(21,null,a):a===1?v?(0,u.localize)(22,null,a):(0,u.localize)(23,null,a):v?(0,u.localize)(24,null,a):(0,u.localize)(25,null,a)):m<A?(a=Math.floor(m/P),E?a===1?(0,u.localize)(26,null,a):(0,u.localize)(27,null,a):a===1?(0,u.localize)(28,null,a):(0,u.localize)(29,null,a)):m<p?(a=Math.floor(m/A),E?a===1?v?(0,u.localize)(30,null,a):(0,u.localize)(31,null,a):v?(0,u.localize)(32,null,a):(0,u.localize)(33,null,a):a===1?v?(0,u.localize)(34,null,a):(0,u.localize)(35,null,a):v?(0,u.localize)(36,null,a):(0,u.localize)(37,null,a)):m<$?(a=Math.floor(m/p),E?a===1?v?(0,u.localize)(38,null,a):(0,u.localize)(39,null,a):v?(0,u.localize)(40,null,a):(0,u.localize)(41,null,a):a===1?v?(0,u.localize)(42,null,a):(0,u.localize)(43,null,a):v?(0,u.localize)(44,null,a):(0,u.localize)(45,null,a)):(a=Math.floor(m/$),E?a===1?v?(0,u.localize)(46,null,a):(0,u.localize)(47,null,a):v?(0,u.localize)(48,null,a):(0,u.localize)(49,null,a):a===1?v?(0,u.localize)(50,null,a):(0,u.localize)(51,null,a):v?(0,u.localize)(52,null,a):(0,u.localize)(53,null,a))}function M(b,E){const v=Math.abs(b/1e3);return v<1?E?(0,u.localize)(54,null,b):(0,u.localize)(55,null,b):v<j?E?(0,u.localize)(56,null,Math.round(b)/1e3):(0,u.localize)(57,null,Math.round(b)/1e3):v<R?E?(0,u.localize)(58,null,Math.round(b/(1e3*j))):(0,u.localize)(59,null,Math.round(b/(1e3*j))):v<P?E?(0,u.localize)(60,null,Math.round(b/(1e3*R))):(0,u.localize)(61,null,Math.round(b/(1e3*R))):(0,u.localize)(62,null,Math.round(b/(1e3*P)))}function I(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[189],Se([9,10]),function(de,e){return de.create("vs/base/common/errorMessage",e)}),define(Ee[46],Se([1,0,19,18,189]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=$,e.$6i=k,e.$7i=M;function P(I,b){return b&&(I.stack||I.stacktrace)?R.localize(0,null,p(I),A(I.stack)||A(I.stacktrace)):p(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function p(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function $(I=null,b=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const E=u.$Hb(I),v=$(E[0],b);return E.length>1?R.localize(4,null,v,E.length):v}if(j.$Uf(I))return I;if(I.detail){const E=I.detail;if(E.error)return P(E.error,b);if(E.exception)return P(E.exception,b)}return I.stack?P(I,b):I.message?I.message:R.localize(5,null)}function k(I){const b=I;return b instanceof Error&&Array.isArray(b.actions)}function M(I,b){let E;return typeof I=="string"?E=new Error(I):E=I,E.actions=b,E}}),define(Ee[190],Se([9,10]),function(de,e){return de.create("vs/base/common/platform",e)}),define(Ee[11],Se([1,0,190]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=g,e.$D=D,e.$J=w,e.$g="en";let j=!1,R=!1,P=!1,A=!1,p=!1,$=!1,k=!1,M=!1,I=!1,b=!1,E,v=e.$g,c=e.$g,m,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){j=i.platform==="win32",R=i.platform==="darwin",P=i.platform==="linux",A=P&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,k=r,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,v=e.$g;const S=i.env.VSCODE_NLS_CONFIG;if(S)try{const y=JSON.parse(S),C=y.availableLanguages["*"];E=y.locale,c=y.osLocale,v=C||e.$g,m=y._translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!s?(a=navigator.userAgent,j=a.indexOf("Windows")>=0,R=a.indexOf("Macintosh")>=0,M=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=a.indexOf("Linux")>=0,b=a?.indexOf("Mobi")>=0,$=!0,E=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=E,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(t||(e.Platform=t={}));function g(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;R?d=1:j?d=3:P&&(d=2),e.$i=j,e.$j=R,e.$k=P,e.$l=A,e.$m=p,e.$n=k,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=M,e.$s=b,e.$t=I,e.$u=d,e.$v=a,e.$w=v;var l;(function(S){function y(){return e.$w}S.value=y;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=C;function O(){return e.$w==="en"}S.isDefault=O})(l||(e.Language=l={})),e.$x=E,e.$y=c,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const S=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let O=0,z=S.length;O<z;O++){const F=S[O];if(F.id===C.data.vscodeScheduleAsyncWork){S.splice(O,1),F.callback();return}}});let y=0;return C=>{const O=++y;S.push({id:O,callback:C}),n.postMessage({vscodeScheduleAsyncWork:O},"*")}}return S=>setTimeout(S)})();var o;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=R||M?2:j?1:3;let h=!0,f=!1;function D(){if(!f){f=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,h=new Uint16Array(S.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(S){return parseFloat(S)>=20}}),define(Ee[50],Se([1,0,11]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let j;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.process<"u"){const P=R.process;j={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?j={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:j={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=j.cwd,e.env=j.env,e.$ec=j.platform,e.$fc=j.arch}),define(Ee[17],Se([1,0,50]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const j=65,R=97,P=90,A=122,p=46,$=47,k=92,M=58,I=63;class b extends Error{constructor(g,d,l){let o;typeof d=="string"&&d.indexOf("not ")===0?(o="must not be",d=d.replace(/^not /,"")):o="must be";const h=g.indexOf(".")!==-1?"property":"argument";let f=`The "${g}" ${h} ${o} of type ${d}`;f+=`. Received type ${typeof l}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,g){if(t===null||typeof t!="object")throw new b(g,"Object",t)}function v(t,g){if(typeof t!="string")throw new b(g,"string",t)}const c=u.$ec==="win32";function m(t){return t===$||t===k}function a(t){return t===$}function n(t){return t>=j&&t<=P||t>=R&&t<=A}function i(t,g,d,l){let o="",h=0,f=-1,D=0,w=0;for(let S=0;S<=t.length;++S){if(S<t.length)w=t.charCodeAt(S);else{if(l(w))break;w=$}if(l(w)){if(!(f===S-1||D===1))if(D===2){if(o.length<2||h!==2||o.charCodeAt(o.length-1)!==p||o.charCodeAt(o.length-2)!==p){if(o.length>2){const y=o.lastIndexOf(d);y===-1?(o="",h=0):(o=o.slice(0,y),h=o.length-1-o.lastIndexOf(d)),f=S,D=0;continue}else if(o.length!==0){o="",h=0,f=S,D=0;continue}}g&&(o+=o.length>0?`${d}..`:"..",h=2)}else o.length>0?o+=`${d}${t.slice(f+1,S)}`:o=t.slice(f+1,S),h=S-f-1;f=S,D=0}else w===p&&D!==-1?++D:D=-1}return o}function r(t,g){E(g,"pathObject");const d=g.dir||g.root,l=g.base||`${g.name||""}${g.ext||""}`;return d?d===g.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let g="",d="",l=!1;for(let o=t.length-1;o>=-1;o--){let h;if(o>=0){if(h=t[o],v(h,"path"),h.length===0)continue}else g.length===0?h=u.cwd():(h=u.env[`=${g}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==g.toLowerCase()&&h.charCodeAt(2)===k)&&(h=`${g}\\`));const f=h.length;let D=0,w="",S=!1;const y=h.charCodeAt(0);if(f===1)m(y)&&(D=1,S=!0);else if(m(y))if(S=!0,m(h.charCodeAt(1))){let C=2,O=C;for(;C<f&&!m(h.charCodeAt(C));)C++;if(C<f&&C!==O){const z=h.slice(O,C);for(O=C;C<f&&m(h.charCodeAt(C));)C++;if(C<f&&C!==O){for(O=C;C<f&&!m(h.charCodeAt(C));)C++;(C===f||C!==O)&&(w=`\\\\${z}\\${h.slice(O,C)}`,D=C)}}}else D=1;else n(y)&&h.charCodeAt(1)===M&&(w=h.slice(0,2),D=2,f>2&&m(h.charCodeAt(2))&&(S=!0,D=3));if(w.length>0)if(g.length>0){if(w.toLowerCase()!==g.toLowerCase())continue}else g=w;if(l){if(g.length>0)break}else if(d=`${h.slice(D)}\\${d}`,l=S,S&&g.length>0)break}return d=i(d,!l,"\\",m),l?`${g}\\${d}`:`${g}${d}`||"."},normalize(t){v(t,"path");const g=t.length;if(g===0)return".";let d=0,l,o=!1;const h=t.charCodeAt(0);if(g===1)return a(h)?"\\":t;if(m(h))if(o=!0,m(t.charCodeAt(1))){let D=2,w=D;for(;D<g&&!m(t.charCodeAt(D));)D++;if(D<g&&D!==w){const S=t.slice(w,D);for(w=D;D<g&&m(t.charCodeAt(D));)D++;if(D<g&&D!==w){for(w=D;D<g&&!m(t.charCodeAt(D));)D++;if(D===g)return`\\\\${S}\\${t.slice(w)}\\`;D!==w&&(l=`\\\\${S}\\${t.slice(w,D)}`,d=D)}}}else d=1;else n(h)&&t.charCodeAt(1)===M&&(l=t.slice(0,2),d=2,g>2&&m(t.charCodeAt(2))&&(o=!0,d=3));let f=d<g?i(t.slice(d),!o,"\\",m):"";return f.length===0&&!o&&(f="."),f.length>0&&m(t.charCodeAt(g-1))&&(f+="\\"),l===void 0?o?`\\${f}`:f:o?`${l}\\${f}`:`${l}${f}`},isAbsolute(t){v(t,"path");const g=t.length;if(g===0)return!1;const d=t.charCodeAt(0);return m(d)||g>2&&n(d)&&t.charCodeAt(1)===M&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let g,d;for(let h=0;h<t.length;++h){const f=t[h];v(f,"path"),f.length>0&&(g===void 0?g=d=f:g+=`\\${f}`)}if(g===void 0)return".";let l=!0,o=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++o;const h=d.length;h>1&&m(d.charCodeAt(1))&&(++o,h>2&&(m(d.charCodeAt(2))?++o:l=!1))}if(l){for(;o<g.length&&m(g.charCodeAt(o));)o++;o>=2&&(g=`\\${g.slice(o)}`)}return e.$gc.normalize(g)},relative(t,g){if(v(t,"from"),v(g,"to"),t===g)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(g);if(d===l||(t=d.toLowerCase(),g=l.toLowerCase(),t===g))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===k;)o++;let h=t.length;for(;h-1>o&&t.charCodeAt(h-1)===k;)h--;const f=h-o;let D=0;for(;D<g.length&&g.charCodeAt(D)===k;)D++;let w=g.length;for(;w-1>D&&g.charCodeAt(w-1)===k;)w--;const S=w-D,y=f<S?f:S;let C=-1,O=0;for(;O<y;O++){const F=t.charCodeAt(o+O);if(F!==g.charCodeAt(D+O))break;F===k&&(C=O)}if(O!==y){if(C===-1)return l}else{if(S>y){if(g.charCodeAt(D+O)===k)return l.slice(D+O+1);if(O===2)return l.slice(D+O)}f>y&&(t.charCodeAt(o+O)===k?C=O:O===2&&(C=3)),C===-1&&(C=0)}let z="";for(O=o+C+1;O<=h;++O)(O===h||t.charCodeAt(O)===k)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${l.slice(D,w)}`:(l.charCodeAt(D)===k&&++D,l.slice(D,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const g=e.$gc.resolve(t);if(g.length<=2)return t;if(g.charCodeAt(0)===k){if(g.charCodeAt(1)===k){const d=g.charCodeAt(2);if(d!==I&&d!==p)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(n(g.charCodeAt(0))&&g.charCodeAt(1)===M&&g.charCodeAt(2)===k)return`\\\\?\\${g}`;return t},dirname(t){v(t,"path");const g=t.length;if(g===0)return".";let d=-1,l=0;const o=t.charCodeAt(0);if(g===1)return m(o)?t:".";if(m(o)){if(d=l=1,m(t.charCodeAt(1))){let D=2,w=D;for(;D<g&&!m(t.charCodeAt(D));)D++;if(D<g&&D!==w){for(w=D;D<g&&m(t.charCodeAt(D));)D++;if(D<g&&D!==w){for(w=D;D<g&&!m(t.charCodeAt(D));)D++;if(D===g)return t;D!==w&&(d=l=D+1)}}}}else n(o)&&t.charCodeAt(1)===M&&(d=g>2&&m(t.charCodeAt(2))?3:2,l=d);let h=-1,f=!0;for(let D=g-1;D>=l;--D)if(m(t.charCodeAt(D))){if(!f){h=D;break}}else f=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,g){g!==void 0&&v(g,"ext"),v(t,"path");let d=0,l=-1,o=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===M&&(d=2),g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let f=g.length-1,D=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(m(w)){if(!o){d=h+1;break}}else D===-1&&(o=!1,D=h+1),f>=0&&(w===g.charCodeAt(f)?--f===-1&&(l=h):(f=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(m(t.charCodeAt(h))){if(!o){d=h+1;break}}else l===-1&&(o=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let g=0,d=-1,l=0,o=-1,h=!0,f=0;t.length>=2&&t.charCodeAt(1)===M&&n(t.charCodeAt(0))&&(g=l=2);for(let D=t.length-1;D>=g;--D){const w=t.charCodeAt(D);if(m(w)){if(!h){l=D+1;break}continue}o===-1&&(h=!1,o=D+1),w===p?d===-1?d=D:f!==1&&(f=1):d!==-1&&(f=-1)}return d===-1||o===-1||f===0||f===1&&d===o-1&&d===l+1?"":t.slice(d,o)},format:r.bind(null,"\\"),parse(t){v(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const d=t.length;let l=0,o=t.charCodeAt(0);if(d===1)return m(o)?(g.root=g.dir=t,g):(g.base=g.name=t,g);if(m(o)){if(l=1,m(t.charCodeAt(1))){let C=2,O=C;for(;C<d&&!m(t.charCodeAt(C));)C++;if(C<d&&C!==O){for(O=C;C<d&&m(t.charCodeAt(C));)C++;if(C<d&&C!==O){for(O=C;C<d&&!m(t.charCodeAt(C));)C++;C===d?l=C:C!==O&&(l=C+1)}}}}else if(n(o)&&t.charCodeAt(1)===M){if(d<=2)return g.root=g.dir=t,g;if(l=2,m(t.charCodeAt(2))){if(d===3)return g.root=g.dir=t,g;l=3}}l>0&&(g.root=t.slice(0,l));let h=-1,f=l,D=-1,w=!0,S=t.length-1,y=0;for(;S>=l;--S){if(o=t.charCodeAt(S),m(o)){if(!w){f=S+1;break}continue}D===-1&&(w=!1,D=S+1),o===p?h===-1?h=S:y!==1&&(y=1):h!==-1&&(y=-1)}return D!==-1&&(h===-1||y===0||y===1&&h===D-1&&h===f+1?g.base=g.name=t.slice(f,D):(g.name=t.slice(f,h),g.base=t.slice(f,D),g.ext=t.slice(h,D))),f>0&&f!==l?g.dir=t.slice(0,f-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(c){const t=/\\/g;return()=>{const g=u.cwd().replace(t,"/");return g.slice(g.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let g="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const o=l>=0?t[l]:s();v(o,"path"),o.length!==0&&(g=`${o}/${g}`,d=o.charCodeAt(0)===$)}return g=i(g,!d,"/",a),d?`/${g}`:g.length>0?g:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=i(t,!g,"/",a),t.length===0?g?"/":d?"./":".":(d&&(t+="/"),g?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let g;for(let d=0;d<t.length;++d){const l=t[d];v(l,"path"),l.length>0&&(g===void 0?g=l:g+=`/${l}`)}return g===void 0?".":e.$hc.normalize(g)},relative(t,g){if(v(t,"from"),v(g,"to"),t===g||(t=e.$hc.resolve(t),g=e.$hc.resolve(g),t===g))return"";const d=1,l=t.length,o=l-d,h=1,f=g.length-h,D=o<f?o:f;let w=-1,S=0;for(;S<D;S++){const C=t.charCodeAt(d+S);if(C!==g.charCodeAt(h+S))break;C===$&&(w=S)}if(S===D)if(f>D){if(g.charCodeAt(h+S)===$)return g.slice(h+S+1);if(S===0)return g.slice(h+S)}else o>D&&(t.charCodeAt(d+S)===$?w=S:S===0&&(w=0));let y="";for(S=d+w+1;S<=l;++S)(S===l||t.charCodeAt(S)===$)&&(y+=y.length===0?"..":"/..");return`${y}${g.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$;let d=-1,l=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===$){if(!l){d=o;break}}else l=!1;return d===-1?g?"/":".":g&&d===1?"//":t.slice(0,d)},basename(t,g){g!==void 0&&v(g,"ext"),v(t,"path");let d=0,l=-1,o=!0,h;if(g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let f=g.length-1,D=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===$){if(!o){d=h+1;break}}else D===-1&&(o=!1,D=h+1),f>=0&&(w===g.charCodeAt(f)?--f===-1&&(l=h):(f=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!o){d=h+1;break}}else l===-1&&(o=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let g=-1,d=0,l=-1,o=!0,h=0;for(let f=t.length-1;f>=0;--f){const D=t.charCodeAt(f);if(D===$){if(!o){d=f+1;break}continue}l===-1&&(o=!1,l=f+1),D===p?g===-1?g=f:h!==1&&(h=1):g!==-1&&(h=-1)}return g===-1||l===-1||h===0||h===1&&g===l-1&&g===d+1?"":t.slice(g,l)},format:r.bind(null,"/"),parse(t){v(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const d=t.charCodeAt(0)===$;let l;d?(g.root="/",l=1):l=0;let o=-1,h=0,f=-1,D=!0,w=t.length-1,S=0;for(;w>=l;--w){const y=t.charCodeAt(w);if(y===$){if(!D){h=w+1;break}continue}f===-1&&(D=!1,f=w+1),y===p?o===-1?o=w:S!==1&&(S=1):o!==-1&&(S=-1)}if(f!==-1){const y=h===0&&d?1:h;o===-1||S===0||S===1&&o===f-1&&o===h+1?g.base=g.name=t.slice(y,f):(g.name=t.slice(y,o),g.base=t.slice(y,f),g.ext=t.slice(o,f))}return h>0?g.dir=t.slice(0,h-1):d&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[131],Se([1,0,45,17]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=p,e.$3q=$,e.$4q=k,e.$5q=M,e.$6q=I,e.$7q=b,e.$8q=E,e.$9q=v,e.$0q=c,e.$$q=m,e.$_q=o,e.$ar=h,e.$br=f;const R=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),P=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,w,S=!1){const y=D||"",C=w||"",O=R.value.collator.compare(y,C);return R.value.collatorIsNumeric&&O===0&&y!==C?y<C?-1:1:O}function $(D,w){const S=P.value.collator;return D=D||"",w=w||"",r(S,D,w)}function k(D,w){const S=P.value.collator;return D=D||"",w=w||"",d(D,w)||r(S,D,w)}function M(D,w){const S=P.value.collator;return D=D||"",w=w||"",g(D,w)||r(S,D,w)}function I(D,w){return D=D||"",w=w||"",D===w?0:D<w?-1:1}function b(D,w){const[S,y]=n(D),[C,O]=n(w);let z=R.value.collator.compare(y,O);if(z===0){if(R.value.collatorIsNumeric&&y!==O)return y<O?-1:1;if(z=R.value.collator.compare(S,C),R.value.collatorIsNumeric&&z===0&&S!==C)return S<C?-1:1}return z}function E(D,w){D=D||"",w=w||"";const S=i(D),y=i(w),C=P.value.collator,O=A.value.collator;return r(O,S,y)||r(C,D,w)}function v(D,w){D=D||"",w=w||"";const S=i(D),y=i(w),C=P.value.collator,O=A.value.collator;return r(O,S,y)||d(D,w)||r(C,D,w)}function c(D,w){D=D||"",w=w||"";const S=i(D),y=i(w),C=P.value.collator,O=A.value.collator;return r(O,S,y)||g(D,w)||r(C,D,w)}function m(D,w){D=D||"",w=w||"";const S=i(D).toLowerCase(),y=i(w).toLowerCase();return S!==y?S<y?-1:1:D!==w?D<w?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(D,w=!1){const S=D?a.exec(D):[];let y=[S&&S[1]||"",S&&S[3]||""];return w&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const w=D?a.exec(D):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function r(D,w,S){const y=D.compare(w,S);return y!==0?y:w.length!==S.length?w.length<S.length?-1:1:0}function s(D){const w=D.charAt(0);return w.toLocaleUpperCase()!==w}function t(D){const w=D.charAt(0);return w.toLocaleLowerCase()!==w}function g(D,w){return s(D)&&t(w)?-1:t(D)&&s(w)?1:0}function d(D,w){return t(D)&&s(w)?-1:s(D)&&t(w)?1:0}function l(D,w,S=!1){return S||(D=D&&D.toLowerCase(),w=w&&w.toLowerCase()),D===w?0:D<w?-1:1}function o(D,w,S=!1){const y=D.split(j.sep),C=w.split(j.sep),O=y.length-1,z=C.length-1;let F,T;for(let L=0;;L++){if(F=O===L,T=z===L,F&&T)return p(y[L],C[L],S);if(F)return-1;if(T)return 1;const N=l(y[L],C[L],S);if(N!==0)return N}}function h(D,w,S){const y=D.toLowerCase(),C=w.toLowerCase(),O=f(D,w,S);if(O)return O;const z=y.endsWith(S),F=C.endsWith(S);if(z!==F)return z?-1:1;const T=p(y,C);return T!==0?T:y.localeCompare(C)}function f(D,w,S){const y=D.toLowerCase(),C=w.toLowerCase(),O=y.startsWith(S),z=C.startsWith(S);if(O!==z)return O?-1:1;if(O&&z){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Ee[34],Se([1,0,17,11,14,18]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=A,e.$bg=p,e.$cg=$,e.$dg=k,e.$eg=M,e.$fg=v,e.$gg=c,e.$hg=m,e.$ig=a,e.$jg=n,e.$kg=i,e.$lg=r,e.$mg=s,e.$ng=t,e.$og=g,e.$pg=o;function A(h){return h===47||h===92}function p(h){return h.replace(/[\\/]/g,u.$hc.sep)}function $(h){return h.indexOf("/")===-1&&(h=p(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function k(h,f=u.$hc.sep){if(!h)return"";const D=h.length,w=h.charCodeAt(0);if(A(w)){if(A(h.charCodeAt(1))&&!A(h.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!A(h.charCodeAt(y));y++);if(C!==y&&!A(h.charCodeAt(y+1))){for(y+=1;y<D;y++)if(A(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,f)}}return f}else if(a(w)&&h.charCodeAt(1)===58)return A(h.charCodeAt(2))?h.slice(0,2)+f:h.slice(0,2);let S=h.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(A(h.charCodeAt(S)))return h.slice(0,S+1)}return""}function M(h){if(!j.$i||!h||h.length<5)return!1;let f=h.charCodeAt(0);if(f!==92||(f=h.charCodeAt(1),f!==92))return!1;let D=2;const w=D;for(;D<h.length&&(f=h.charCodeAt(D),f!==92);D++);return!(w===D||(f=h.charCodeAt(D+1),isNaN(f)||f===92))}const I=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(h,f=j.$i){const D=f?I:b;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||f&&E.test(h)||h==="."||h===".."||f&&h[h.length-1]==="."||f&&h.length!==h.trim().length||h.length>255)}function c(h,f,D){const w=h===f;return!D||w?w:!h||!f?!1:(0,R.$lf)(h,f)}function m(h,f,D,w=u.sep){if(h===f)return!0;if(!h||!f||f.length>h.length)return!1;if(D){if(!(0,R.$mf)(h,f))return!1;if(f.length===h.length)return!0;let y=f.length;return f.charAt(f.length-1)===w&&y--,h.charAt(y)===w}return f.charAt(f.length-1)!==w&&(f+=w),h.indexOf(f)===0}function a(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,f){return j.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(f,h)),h=(0,u.$ic)(h),j.$i?(h=(0,R.$6e)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,R.$6e)(h,u.sep),h||(h=u.sep)),h}function i(h){const f=(0,u.$ic)(h);return j.$i?h.length>3?!1:r(f)&&(h.length===2||f.charCodeAt(2)===92):f===u.$hc.sep}function r(h,f=j.$i){return f?a(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,f=j.$i){return r(h,f)?h[0]:void 0}function t(h,f,D){return f.length>h.length?-1:h===f?0:(D&&(h=h.toLowerCase(),f=f.toLowerCase()),h.indexOf(f))}function g(h){const f=h.split(":");let D,w,S;for(const y of f){const C=Number(y);(0,P.$Yf)(C)?w===void 0?w=C:S===void 0&&(S=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:w!==void 0?w:void 0,column:S!==void 0?S:w!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(h,f,D=8){let w="";for(let y=0;y<D;y++){let C;y===0&&j.$i&&!f&&(D===3||D===4)?C=l:C=d,w+=C.charAt(Math.floor(Math.random()*C.length))}let S;return f?S=`${f}-${w}`:S=w,h?(0,u.$kc)(h,S):S}}),define(Ee[132],Se([1,0,131,126,55,17,11,14]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=M,e.$dr=m,e.$er=d,e.$fr=S,e.$gr=T,e.$hr=N;const $=0,k=[$,[]];function M(B,U,Z,_){if(!B||!U)return k;const Y=B.length,x=U.length;if(Y<x)return k;const ce=B.toLowerCase();return I(U,Z,x,B,ce,Y,_)}function I(B,U,Z,_,Y,x,ce){const X=[],me=[];for(let ie=0;ie<Z;ie++){const ve=ie*x,Pe=ve-x,le=ie>0,ue=B[ie],oe=U[ie];for(let K=0;K<x;K++){const ee=K>0,he=ve+K,fe=he-1,Ae=Pe+K-1,pe=ee?X[fe]:0,Ce=le&&ee?X[Ae]:0,Me=le&&ee?me[Ae]:0;let Fe;!Ce&&le?Fe=0:Fe=b(ue,oe,_,Y,K,Me),Fe&&Ce+Fe>=pe&&(ce||le||Y.startsWith(U,K))?(me[he]=Me+1,X[he]=Ce+Fe):(me[he]=$,X[he]=pe)}}const ae=[];let re=Z-1,W=x-1;for(;re>=0&&W>=0;){const ie=re*x+W;me[ie]===$||(ae.push(W),re--),W--}return[X[Z*x-1],ae.reverse()]}function b(B,U,Z,_,Y,x){let ce=0;if(!E(U,_[Y]))return ce;if(ce+=1,x>0&&(ce+=x*5),B===Z[Y]&&(ce+=1),Y===0)ce+=8;else{const X=v(Z.charCodeAt(Y-1));X?ce+=X:(0,j.$mk)(Z.charCodeAt(Y))&&x===0&&(ce+=2)}return ce}function E(B,U){return B===U?!0:B==="/"||B==="\\"?U==="/"||U==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(B,U,Z=0,_=0){const Y=U;return Y.values&&Y.values.length>1?a(B,Y.values,Z,_):n(B,U,Z,_)}function a(B,U,Z,_){let Y=0;const x=[];for(const ce of U){const[X,me]=n(B,ce,Z,_);if(typeof X!="number")return c;Y+=X,x.push(...me)}return[Y,D(x)]}function n(B,U,Z,_){const Y=(0,j.$vk)(U.original,U.originalLowercase,Z,B,B.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,j.$sk)(Y)]:c}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function g(B,U,Z,_){const Y=_.values?_.values:[_];return(0,R.$8i)({[_.normalized]:{values:Y.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:B,description:U,allowNonContiguousMatches:Z}})}function d(B,U,Z,_,Y){if(!B||!U.normalized)return i;const x=_.getItemLabel(B);if(!x)return i;const ce=_.getItemDescription(B),X=g(x,ce,Z,U),me=Y[X];if(me)return me;const ae=l(x,ce,_.getItemPath(B),U,Z);return Y[X]=ae,ae}function l(B,U,Z,_,Y){const x=!Z||!_.containsPathSeparator;return Z&&(A.$k?_.pathNormalized===Z:(0,p.$lf)(_.pathNormalized,Z))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:_.values&&_.values.length>1?o(B,U,Z,_.values,x,Y):h(B,U,Z,_,x,Y)}function o(B,U,Z,_,Y,x){let ce=0;const X=[],me=[];for(const ae of _){const{score:re,labelMatch:W,descriptionMatch:ie}=h(B,U,Z,ae,Y,x);if(re===$)return i;ce+=re,W&&X.push(...W),ie&&me.push(...ie)}return{score:ce,labelMatch:D(X),descriptionMatch:D(me)}}function h(B,U,Z,_,Y,x){if(Y||!U){const[ce,X]=M(B,_.normalized,_.normalizedLowercase,x&&!_.expectContiguousMatch);if(ce){const me=(0,j.$jk)(_.normalized,B);let ae;if(me){ae=s;const re=Math.round(_.normalized.length/B.length*100);ae+=re}else ae=t;return{score:ae+ce,labelMatch:me||f(X)}}}if(U){let ce=U;Z&&(ce=`${U}${P.sep}`);const X=ce.length,me=`${ce}${B}`,[ae,re]=M(me,_.normalized,_.normalizedLowercase,x&&!_.expectContiguousMatch);if(ae){const W=f(re),ie=[],ve=[];return W.forEach(Pe=>{Pe.start<X&&Pe.end>X?(ie.push({start:0,end:Pe.end-X}),ve.push({start:Pe.start,end:X})):Pe.start>=X?ie.push({start:Pe.start-X,end:Pe.end-X}):ve.push(Pe)}),{score:ae,labelMatch:ie,descriptionMatch:ve}}}return i}function f(B){const U=[];if(!B)return U;let Z;for(const _ of B)Z&&Z.end===_?Z.end+=1:(Z={start:_,end:_+1},U.push(Z));return U}function D(B){const U=B.sort((Y,x)=>Y.start-x.start),Z=[];let _;for(const Y of U)!_||!w(_,Y)?(_=Y,Z.push(Y)):(_.start=Math.min(_.start,Y.start),_.end=Math.max(_.end,Y.end));return Z}function w(B,U){return!(B.end<U.start||U.end<B.start)}function S(B,U,Z,_,Y,x){const ce=d(B,Z,_,Y,x),X=d(U,Z,_,Y,x),me=ce.score,ae=X.score;if((me===r||ae===r)&&me!==ae)return me===r?-1:1;if(me>t||ae>t){if(me!==ae)return me>ae?-1:1;if(me<s&&ae<s){const ue=C(ce.labelMatch,X.labelMatch);if(ue!==0)return ue}const Pe=Y.getItemLabel(B)||"",le=Y.getItemLabel(U)||"";if(Pe.length!==le.length)return Pe.length-le.length}if(me!==ae)return me>ae?-1:1;const re=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,W=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(re&&!W)return-1;if(W&&!re)return 1;const ie=y(B,ce,Y),ve=y(U,X,Y);return ie&&ve&&ie!==ve?ve>ie?-1:1:O(B,U,Z,Y)}function y(B,U,Z){let _=-1,Y=-1;if(U.descriptionMatch&&U.descriptionMatch.length?_=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(_=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(Y=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const x=Z.getItemDescription(B);x&&(Y+=x.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(Y=U.descriptionMatch[U.descriptionMatch.length-1].end);return Y-_}function C(B,U){if(!B&&!U||(!B||!B.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!B||!B.length)return 1;const Z=B[0].start,Y=B[B.length-1].end-Z,x=U[0].start,X=U[U.length-1].end-x;return Y===X?0:X<Y?1:-1}function O(B,U,Z,_){const Y=_.getItemLabel(B)||"",x=_.getItemLabel(U)||"",ce=_.getItemDescription(B),X=_.getItemDescription(U),me=Y.length+(ce?ce.length:0),ae=x.length+(X?X.length:0);if(me!==ae)return me-ae;const re=_.getItemPath(B),W=_.getItemPath(U);return re&&W&&re.length!==W.length?re.length-W.length:Y!==x?(0,u.$ar)(Y,x,Z.normalized):ce&&X&&ce!==X?(0,u.$ar)(ce,X,Z.normalized):re&&W&&re!==W?(0,u.$ar)(re,W,Z.normalized):0}function z(B){return B.startsWith('"')&&B.endsWith('"')}const F=" ";function T(B){typeof B!="string"&&(B="");const U=B.toLowerCase(),{pathNormalized:Z,normalized:_,normalizedLowercase:Y}=L(B),x=Z.indexOf(P.sep)>=0,ce=z(B);let X;const me=B.split(F);if(me.length>1)for(const ae of me){const re=z(ae),{pathNormalized:W,normalized:ie,normalizedLowercase:ve}=L(ae);ie&&(X||(X=[]),X.push({original:ae,originalLowercase:ae.toLowerCase(),pathNormalized:W,normalized:ie,normalizedLowercase:ve,expectContiguousMatch:re}))}return{original:B,originalLowercase:U,pathNormalized:Z,normalized:_,normalizedLowercase:Y,values:X,containsPathSeparator:x,expectContiguousMatch:ce}}function L(B){let U;A.$i?U=B.replace(/\//g,P.sep):U=B.replace(/\\/g,P.sep);const Z=(0,p.$8e)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function N(B){return Array.isArray(B)?T(B.map(U=>U.original).join(F)):T(B.original)}}),define(Ee[101],Se([1,0,17]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0,e.$zs=P,e.$As=A,e.$Bs=p,e.$Cs=k,e.$ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const j={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(M){const I=(0,u.$pc)(M),b=j[I.toLowerCase()];return b!==void 0?b:A(M)}function A(M){const I=(0,u.$pc)(M);return R[I.toLowerCase()]}function p(M){for(const I in R)if(R[I]===M)return I}const $=/^(.+)\/(.+?)(;.+)?$/;function k(M,I){const b=$.exec(M);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:I?void 0:M}}),define(Ee[102],Se([1,0,11]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=P,e.$$l=A;var j;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(j||(e.Source=j={}));var R;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function P(p,...$){const k=$.reduce((b,E)=>(b[E]=!0,b),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(b=>!k[b]).forEach(b=>{for(let E=0;E<M.length;E++)if(b.search(M[E])!==-1){delete p[b];break}})}function A(p){p&&(delete p.DEBUG,u.$j&&delete p.DYLD_LIBRARY_PATH,u.$k&&delete p.LD_PRELOAD)}}),define(Ee[2],Se([1,0,17,11]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const R=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function p(l,o){if(!l.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!R.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!P.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,o){return!l&&!o?"file":l}function k(l,o){switch(l){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const M="",I="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(o){return o instanceof E?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,h,f,D,w,S=!1){typeof o=="object"?(this.scheme=o.scheme||M,this.authority=o.authority||M,this.path=o.path||M,this.query=o.query||M,this.fragment=o.fragment||M):(this.scheme=$(o,S),this.authority=h||M,this.path=k(this.scheme,f||M),this.query=D||M,this.fragment=w||M,p(this,S))}get fsPath(){return r(this,!1)}with(o){if(!o)return this;let{scheme:h,authority:f,path:D,query:w,fragment:S}=o;return h===void 0?h=this.scheme:h===null&&(h=M),f===void 0?f=this.authority:f===null&&(f=M),D===void 0?D=this.path:D===null&&(D=M),w===void 0?w=this.query:w===null&&(w=M),S===void 0?S=this.fragment:S===null&&(S=M),h===this.scheme&&f===this.authority&&D===this.path&&w===this.query&&S===this.fragment?this:new m(h,f,D,w,S)}static parse(o,h=!1){const f=b.exec(o);return f?new m(f[2]||M,d(f[4]||M),d(f[5]||M),d(f[7]||M),d(f[9]||M),h):new m(M,M,M,M,M)}static file(o){let h=M;if(j.$i&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const f=o.indexOf(I,2);f===-1?(h=o.substring(2),o=I):(h=o.substring(2,f),o=o.substring(f)||I)}return new m("file",h,o,M,M)}static from(o,h){return new m(o.scheme,o.authority,o.path,o.query,o.fragment,h)}static joinPath(o,...h){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return j.$i&&o.scheme==="file"?f=E.file(u.$gc.join(r(o,!0),...h)).path:f=u.$hc.join(o.path,...h),o.with({path:f})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof E)return o;{const h=new m(o);return h._formatted=o.external??null,h._fsPath=o._sep===c?o.fsPath??null:null,h}}else return o}}e.URI=E;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const c=j.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=c),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,o,h){let f,D=-1;for(let w=0;w<l.length;w++){const S=l.charCodeAt(w);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||o&&S===47||h&&S===91||h&&S===93||h&&S===58)D!==-1&&(f+=encodeURIComponent(l.substring(D,w)),D=-1),f!==void 0&&(f+=l.charAt(w));else{f===void 0&&(f=l.substr(0,w));const y=a[S];y!==void 0?(D!==-1&&(f+=encodeURIComponent(l.substring(D,w)),D=-1),f+=y):D===-1&&(D=w)}}return D!==-1&&(f+=encodeURIComponent(l.substring(D))),f!==void 0?f:l}function i(l){let o;for(let h=0;h<l.length;h++){const f=l.charCodeAt(h);f===35||f===63?(o===void 0&&(o=l.substr(0,h)),o+=a[f]):o!==void 0&&(o+=l[h])}return o!==void 0?o:l}function r(l,o){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?o?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,j.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,o){const h=o?i:n;let f="",{scheme:D,authority:w,path:S,query:y,fragment:C}=l;if(D&&(f+=D,f+=":"),(w||D==="file")&&(f+=I,f+=I),w){let O=w.indexOf("@");if(O!==-1){const z=w.substr(0,O);w=w.substr(O+1),O=z.lastIndexOf(":"),O===-1?f+=h(z,!1,!1):(f+=h(z.substr(0,O),!1,!1),f+=":",f+=h(z.substr(O+1),!1,!0)),f+="@"}w=w.toLowerCase(),O=w.lastIndexOf(":"),O===-1?f+=h(w,!1,!0):(f+=h(w.substr(0,O),!1,!0),f+=w.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}f+=h(S,!0,!1)}return y&&(f+="?",f+=h(y,!1,!1)),C&&(f+="#",f+=o?C:n(C,!1,!1)),f}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(g)?l.replace(g,o=>t(o)):l}}),define(Ee[191],Se([1,0,2]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=j,e.$Fq=R,e.$Gq=P,e.log=p;function j(k){const M=k;return M&&typeof M.type=="string"&&typeof M.severity=="string"}function R(k){const M=[];let I;try{const b=JSON.parse(k.arguments),E=b[b.length-1];E&&E.__$stack&&(b.pop(),I=E.__$stack),M.push(...b)}catch{M.push("Unable to log remote console arguments",k.arguments)}return{args:M,stack:I}}function P(k){if(typeof k!="string")return P(R(k).stack);const M=k;if(M){const I=A(M),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(b&&b.length===4)return{uri:u.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function A(k){if(!k)return k;const M=k.indexOf(`
`);return M===-1?k:k.substring(0,M)}function p(k,M){const{args:I,stack:b}=R(k),E=typeof I[0]=="string"&&I.length===1;let v=A(b);v&&(v=`(${v.trim()})`);let c=[];if(typeof I[0]=="string"?v&&E?c=[`%c[${M}] %c${I[0]} %c${v}`,$("blue"),$(""),$("grey")]:c=[`%c[${M}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:c=[`%c[${M}]%`,$("blue"),...I],v&&!E&&c.push(v),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,c)}function $(k){return`color: ${k}`}}),define(Ee[57],Se([1,0,21,2]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=R,e.$Ph=P,e.$Qh=p;function R($){return JSON.stringify($,A)}function P($){let k=JSON.parse($);return k=p(k),k}function A($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return j.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof u.$ue||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let M=0;M<$.length;++M)$[M]=p($[M],k+1);else for(const M in $)Object.hasOwnProperty.call($,M)&&($[M]=p($[M],k+1))}return $}}),define(Ee[15],Se([1,0,13,11,14,2,17]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=$,e.$rg=k,e.$vg=I;var p;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(v,c){return P.URI.isUri(v)?(0,R.$lf)(v.scheme,c):(0,R.$mf)(v,c+":")}function k(v,...c){return c.some(m=>$(v,m))}e.$sg="vscode-tkn",e.$tg="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=I(c,m)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,p.vscodeRemoteResource)}set(c,m,a){this.a[c]=m,this.b[c]=a}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(s){return u.$1(s),c}const m=c.authority;let a=this.a[m];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(c.path)}`;return typeof i=="string"&&(r+=`&${e.$tg}=${encodeURIComponent(i)}`),P.URI.from({scheme:j.$o?this.d:p.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:r})}}e.$ug=new M;function I(v,c){return A.$hc.join(c??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class b{static{this.a=e.$Ag}asBrowserUri(c){const m=this.b(c,de);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===p.vscodeRemote?e.$ug.rewrite(c):c.scheme===p.file&&(j.$m||j.$q===`${p.vscodeFileResource}://${b.a}`)?c.with({scheme:p.vscodeFileResource,authority:c.authority||b.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,de);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===p.vscodeFileResource?c.with({scheme:p.file,authority:c.authority!==b.a?c.authority:null,query:null,fragment:null}):c}b(c,m){return P.URI.isUri(c)?c:P.URI.parse(m.toUrl(c))}}e.$Bg=new b;var E;(function(v){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function a(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:P.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return c.get(s)}v.getHeadersFromQuery=a;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}v.addSearchParam=n})(E||(e.COI=E={}))}),define(Ee[192],Se([1,0,161,15,11,2]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DD=M;class A{constructor(b,E,v){this.id=b,this.dependencies=E,this.callback=v}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,E,v)=>{typeof b!="string"&&(v=E,E=b,b=null),(typeof E!="object"||!Array.isArray(E))&&(v=E,E=null),this.c.push(new A(b,E,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const E=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!E)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(b){return new Promise((E,v)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",a),c.removeEventListener("error",n)},a=i=>{m(),E(this.c.pop())},n=i=>{m(),v(i)};c.addEventListener("load",a),c.addEventListener("error",n),this.f&&(b=this.f.createScriptURL(b)),c.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(b){return new Promise((E,v)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),E(this.c.pop())}catch(c){v(c)}})}async j(b){try{const E=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(b).fsPath,a=E.readFileSync(m).toString(),n=c.wrap(a.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function M(I,b,E){if(u.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[I]&&(I=k[I]);const v=`${I}/${b}`;if($.has(v))return $.get(v);let c;if(/^\w[\w\d+.-]*:\/\//.test(v))c=v;else{const i=`${E&&!R.$o?j.$yg:j.$xg}/${v}`;c=j.$Bg.asBrowserUri(i).toString(!0)}const m=p.INSTANCE.load(c);return $.set(v,m),m}else return await new Promise((v,c)=>{de([I],v,c)})}}),define(Ee[23],Se([1,0,34,15,17,11,14,2]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=$,e.$4g=M,e.$5g=b;function $(E){return(0,p.$xc)(E,!0)}class k{constructor(v){this.a=v}compare(v,c,m=!1){return v===c?0:(0,A.$ef)(this.getComparisonKey(v,m),this.getComparisonKey(c,m))}isEqual(v,c,m=!1){return v===c?!0:!v||!c?!1:this.getComparisonKey(v,m)===this.getComparisonKey(c,m)}getComparisonKey(v,c=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,c,m=!1){if(v.scheme===c.scheme){if(v.scheme===j.Schemas.file)return u.$hg($(v),$(c),this.a(v))&&v.query===c.query&&(m||v.fragment===c.fragment);if((0,e.$Zg)(v.authority,c.authority))return u.$hg(v.path,c.path,this.a(v),"/")&&v.query===c.query&&(m||v.fragment===c.fragment)}return!1}joinPath(v,...c){return p.URI.joinPath(v,...c)}basenameOrAuthority(v){return(0,e.$Rg)(v)||v.authority}basename(v){return R.$hc.basename(v.path)}extname(v){return R.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let c;return v.scheme===j.Schemas.file?c=p.URI.file(R.$nc($(v))).path:(c=R.$hc.dirname(v.path),v.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),c="/")),v.with({path:c})}normalizePath(v){if(!v.path.length)return v;let c;return v.scheme===j.Schemas.file?c=p.URI.file(R.$ic($(v))).path:c=R.$hc.normalize(v.path),v.with({path:c})}relativePath(v,c){if(v.scheme!==c.scheme||!(0,e.$Zg)(v.authority,c.authority))return;if(v.scheme===j.Schemas.file){const n=R.$mc($(v),$(c));return P.$i?u.$bg(n):n}let m=v.path||"/";const a=c.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(m.length,a.length);n<i&&!(m.charCodeAt(n)!==a.charCodeAt(n)&&m.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);m=a.substr(0,n)+m.substr(n)}return R.$hc.relative(m,a)}resolvePath(v,c){if(v.scheme===j.Schemas.file){const m=p.URI.file(R.$lc($(v),c));return v.with({authority:m.authority,path:m.path})}return c=u.$cg(c),v.with({path:R.$hc.resolve(v.path,c)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,c){return v===c||v!==void 0&&c!==void 0&&(0,A.$lf)(v,c)}hasTrailingPathSeparator(v,c=R.sep){if(v.scheme===j.Schemas.file){const m=$(v);return m.length>u.$dg(m).length&&m[m.length-1]===c}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,c=R.sep){return(0,e.$1g)(v,c)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,c=R.sep){let m=!1;if(v.scheme===j.Schemas.file){const a=$(v);m=a!==void 0&&a.length===u.$dg(a).length&&a[a.length-1]===c}else{c="/";const a=v.path;m=a.length===1&&a.charCodeAt(a.length-1)===47}return!m&&!(0,e.$1g)(v,c)?v.with({path:v.path+"/"}):v}}e.$Jg=k,e.$Kg=new k(()=>!1),e.$Lg=new k(E=>E.scheme===j.Schemas.file?!P.$k:!0),e.$Mg=new k(E=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function M(E,v){const c=[];for(let m=0;m<E.length;m++){const a=v(E[m]);E.some((n,i)=>i===m?!1:(0,e.$Og)(a,v(n)))||c.push(E[m])}return c}var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=c.path.substring(0,c.path.indexOf(";"));return n&&m.set(E.META_DATA_MIME,n),m}E.parseMetaData=v})(I||(e.DataUri=I={}));function b(E,v,c){if(v){let m=E.path;return m&&m[0]!==R.$hc.sep&&(m=R.$hc.sep+m),E.with({scheme:c,authority:v,path:m})}return E.with({scheme:c})}}),define(Ee[8],Se([1,0,22,13,4,3,23,11,168,45]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=M,e.$7g=I,e.$8g=b,e.$9g=E,e.$0g=v,e.$$g=c,e.$_g=m,e.$ah=a,e.$ih=h,e.$jh=f,e.$kh=D,e.$lh=w,e.$mh=S,e.$Bh=Y,e.$Jh=le;function M(oe){return!!oe&&typeof oe.then=="function"}function I(oe){const K=new u.$ee,ee=oe(K.token),he=new Promise((fe,Ae)=>{const pe=K.token.onCancellationRequested(()=>{pe.dispose(),Ae(new j.$5)});Promise.resolve(ee).then(Ce=>{pe.dispose(),K.dispose(),fe(Ce)},Ce=>{pe.dispose(),K.dispose(),Ae(Ce)})});return new class{cancel(){K.cancel(),K.dispose()}then(fe,Ae){return he.then(fe,Ae)}catch(fe){return this.then(void 0,fe)}finally(fe){return he.finally(fe)}}}function b(oe,K,ee){return new Promise((he,fe)=>{const Ae=K.onCancellationRequested(()=>{Ae.dispose(),he(ee)});oe.then(he,fe).finally(()=>Ae.dispose())})}function E(oe,K){return new Promise((ee,he)=>{const fe=K.onCancellationRequested(()=>{fe.dispose(),he(new j.$5)});oe.then(ee,he).finally(()=>fe.dispose())})}async function v(oe){let K=-1;const ee=oe.map((he,fe)=>he.then(Ae=>(K=fe,Ae)));try{return await Promise.race(ee)}finally{oe.forEach((he,fe)=>{fe!==K&&he.cancel()})}}function c(oe,K,ee){let he;const fe=setTimeout(()=>{he?.(void 0),ee?.()},K);return Promise.race([oe.finally(()=>clearTimeout(fe)),new Promise(Ae=>he=Ae)])}function m(oe){return new Promise((K,ee)=>{const he=oe();M(he)?he.then(K,ee):K(he)})}function a(){let oe,K;return{promise:new Promise((he,fe)=>{oe=he,K=fe}),resolve:oe,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ee=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(ee,ee).then(he)})}return new Promise((ee,he)=>{this.b.then(ee,he)})}return this.a=K(),new Promise((ee,he)=>{this.a.then(fe=>{this.a=null,ee(fe)},fe=>{this.a=null,he(fe)})})}dispose(){this.f=!0}}e.$bh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$ch=i;class r{constructor(){this.a=new Map}queue(K,ee){const fe=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(K)===fe&&this.a.delete(K)});return this.a.set(K,fe),fe}}e.$dh=r;const s=(oe,K)=>{let ee=!0;const he=setTimeout(()=>{ee=!1,K()},oe);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(he),ee=!1}}},t=oe=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,oe())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class g{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ee=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((fe,Ae)=>{this.d=fe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=ee===$.$4d?t(he):s(ee,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new j.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=g;class d{constructor(K){this.a=new g(K),this.b=new n}trigger(K,ee){return this.a.trigger(()=>this.b.queue(K),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=d;class l{constructor(){this.a=!1,this.b=new Promise((K,ee)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=l;class o extends l{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$hh=o;function h(oe,K){return K?new Promise((ee,he)=>{const fe=setTimeout(()=>{Ae.dispose(),ee()},oe),Ae=K.onCancellationRequested(()=>{clearTimeout(fe),Ae.dispose(),he(new j.$5)})}):I(ee=>h(oe,ee))}function f(oe,K=0,ee){const he=setTimeout(()=>{oe(),ee&&fe.dispose()},K),fe=(0,P.$Sc)(()=>{clearTimeout(he),ee?.deleteAndLeak(fe)});return ee?.add(fe),fe}function D(oe){const K=[];let ee=0;const he=oe.length;function fe(){return ee<he?oe[ee++]():null}function Ae(pe){pe!=null&&K.push(pe);const Ce=fe();return Ce?Ce.then(Ae):Promise.resolve(K)}return Promise.resolve(null).then(Ae)}function w(oe,K=he=>!!he,ee=null){let he=0;const fe=oe.length,Ae=()=>{if(he>=fe)return Promise.resolve(ee);const pe=oe[he++];return Promise.resolve(pe()).then(Me=>K(Me)?Promise.resolve(Me):Ae())};return Ae()}function S(oe,K=he=>!!he,ee=null){if(oe.length===0)return Promise.resolve(ee);let he=oe.length;const fe=()=>{he=-1;for(const Ae of oe)Ae.cancel?.()};return new Promise((Ae,pe)=>{for(const Ce of oe)Ce.then(Me=>{--he>=0&&K(Me)?(fe(),Ae(Me)):he===0&&Ae(ee)}).catch(Me=>{--he>=0&&(fe(),pe(Me))})})}class y{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new R.$7d}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,he)=>{this.g.push({factory:K,c:ee,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ee=K.factory();ee.then(K.c,K.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=y;class C extends y{constructor(){super(1)}}e.$oh=C;class O{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$ph=O;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new me;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ee=A.$Kg){const he=ee.getComparisonKey(K);return this.a.get(he)?.size??0}queueFor(K,ee,he=A.$Kg){const fe=he.getComparisonKey(K);let Ae=this.a.get(fe);if(!Ae){Ae=new C;const pe=this.f++,Ce=R.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$4c),this.d.set(pe,Ce),this.a.set(fe,Ae)}return Ae.queue(ee)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=z;class F{constructor(K,ee){this.a=-1,typeof K=="function"&&typeof ee=="number"&&this.setIfNotSet(K,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ee)}setIfNotSet(K,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ee))}}e.$rh=F;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ee,he=globalThis){this.cancel();const fe=he.setInterval(()=>{K()},ee);this.d=(0,P.$Sc)(()=>{he.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$sh=T;class L{constructor(K,ee){this.b=-1,this.a=K,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=L;class N{constructor(K,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=K,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=N;class B extends L{constructor(K,ee){super(K,ee),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$vh=B;class U extends P.$Uc{constructor(K,ee){super(),this.g=K,this.h=ee,this.a=[],this.b=this.B(new P.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of K)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new L(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(oe,K)=>{(0,p.$B)(()=>{if(ee)return;const he=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$yh=(oe,K,ee)=>{const he=oe.requestIdleCallback(K,typeof ee=="number"?{timeout:ee}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,oe.cancelIdleCallback(he))}}},e.$xh=oe=>(0,e.$yh)(globalThis,oe)}();class Z{constructor(K,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$yh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=Z;class _ extends Z{constructor(K){super(globalThis,K)}}e.$Ah=_;async function Y(oe,K,ee){let he;for(let fe=0;fe<ee;fe++)try{return await oe()}catch(Ae){he=Ae,await h(K)}throw he}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ee,he){return this.a={taskId:K,cancel:()=>he?.(),promise:ee},ee.then(()=>this.d(K),()=>this.d(K)),ee}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ee,resolve:he,reject:fe}=a();this.b={run:K,promise:ee,promiseResolve:he,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=x;class ce{constructor(K,ee=()=>Date.now()){this.d=K,this.f=ee,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Dh=ce;var X;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(X||(X={}));class me{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ee)=>{this.a=K,this.b=ee})}complete(K){return new Promise(ee=>{this.a(K),this.d={outcome:0,value:K},ee()})}error(K){return new Promise(ee=>{this.b(K),this.d={outcome:1,value:K},ee()})}cancel(){return this.error(new j.$5)}}e.$Eh=me;var ae;(function(oe){async function K(he){let fe;const Ae=await Promise.all(he.map(pe=>pe.then(Ce=>Ce,Ce=>{fe||(fe=Ce)})));if(typeof fe<"u")throw fe;return Ae}oe.settled=K;function ee(he){return new Promise(async(fe,Ae)=>{try{await he(fe,Ae)}catch(pe){Ae(pe)}})}oe.withAsyncBody=ee})(ae||(e.Promises=ae={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new j.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=re;class W{constructor(K){this.b=K,this.a=new k.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=W;var ie;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(ie||(ie={}));class ve{static fromArray(K){return new ve(ee=>{ee.emitMany(K)})}static fromPromise(K){return new ve(async ee=>{ee.emitMany(await K)})}static fromPromises(K){return new ve(async ee=>{await Promise.all(K.map(async he=>ee.emitOne(await he)))})}static merge(K){return new ve(async ee=>{await Promise.all(K.map(async he=>{for await(const fe of he)ee.emitOne(fe)}))})}static{this.EMPTY=ve.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new R.$7d,queueMicrotask(async()=>{const ee={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(K(ee)),this.j()}catch(he){this.k(he)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(K,ee){return new ve(async he=>{for await(const fe of K)he.emitOne(ee(fe))})}map(K){return ve.map(this,K)}static filter(K,ee){return new ve(async he=>{for await(const fe of K)ee(fe)&&he.emitOne(fe)})}filter(K){return ve.filter(this,K)}static coalesce(K){return ve.filter(K,ee=>!!ee)}coalesce(){return ve.coalesce(this)}static async toPromise(K){const ee=[];for await(const he of K)ee.push(he);return ee}toPromise(){return ve.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Hh=ve;class Pe extends ve{constructor(K,ee){super(ee),this.l=K}cancel(){this.l.cancel()}}e.$Ih=Pe;function le(oe){const K=new u.$ee,ee=oe(K.token);return new Pe(K,async he=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),K.dispose(),he.reject(new j.$5)});try{for await(const Ae of ee){if(K.token.isCancellationRequested)return;he.emitOne(Ae)}fe.dispose(),K.dispose()}catch(Ae){fe.dispose(),K.dispose(),he.reject(Ae)}})}class ue{constructor(){this.a=new me,this.b=new ve(he=>{if(K){he.reject(K);return}return ee&&he.emitMany(ee),this.d=fe=>he.reject(fe),this.f=fe=>he.emitOne(fe),this.a.p});let K,ee;this.f=he=>{ee||(ee=[]),ee.push(he)},this.d=he=>{K||(K=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Kh=ue}),define(Ee[35],Se([1,0,19,8,34,28,17,11,14]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=k,e.$_j=v,e.$ak=C,e.$bk=O,e.$ck=z,e.$dk=F,e.$ek=T,e.$fk=U;function k(){return Object.create(null)}e.$0j="**",e.$$j="/";const M="[/\\\\]",I="[^/\\\\]",b=/\//g;function E(Z,_){switch(Z){case 0:return"";case 1:return`${I}*?`;default:return`(?:${M}|${I}+${M}${_?`|${M}${I}+`:""})*?`}}function v(Z,_){if(!Z)return[];const Y=[];let x=!1,ce=!1,X="";for(const me of Z){switch(me){case _:if(!x&&!ce){Y.push(X),X="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}X+=me}return X&&Y.push(X),Y}function c(Z){if(!Z)return"";let _="";const Y=v(Z,e.$$j);if(Y.every(x=>x===e.$0j))_=".*";else{let x=!1;Y.forEach((ce,X)=>{if(ce===e.$0j){if(x)return;_+=E(2,X===Y.length-1)}else{let me=!1,ae="",re=!1,W="";for(const ie of ce){if(ie!=="}"&&me){ae+=ie;continue}if(re&&(ie!=="]"||!W)){let ve;ie==="-"?ve=ie:(ie==="^"||ie==="!")&&!W?ve="^":ie===e.$$j?ve="":ve=(0,$.$Ze)(ie),W+=ve;continue}switch(ie){case"{":me=!0;continue;case"[":re=!0;continue;case"}":{const Pe=`(?:${v(ae,",").map(le=>c(le)).join("|")})`;_+=Pe,me=!1,ae="";break}case"]":{_+="["+W+"]",re=!1,W="";break}case"?":_+=I;continue;case"*":_+=E(1);continue;default:_+=(0,$.$Ze)(ie)}}X<Y.length-1&&(Y[X+1]!==e.$0j||X+2<Y.length)&&(_+=M)}x=ce===e.$0j})}return _}const m=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Ec(1e4),g=function(){return!1},d=function(){return null};function l(Z,_){if(!Z)return d;let Y;typeof Z!="string"?Y=Z.pattern:Y=Z,Y=Y.trim();const x=`${Y}_${!!_.trimForExclusions}`;let ce=t.get(x);if(ce)return o(ce,Z);let X;return m.test(Y)?ce=f(Y.substr(4),Y):(X=a.exec(h(Y,_)))?ce=D(X[1],Y):(_.trimForExclusions?i:n).test(Y)?ce=w(Y,_):(X=r.exec(h(Y,_)))?ce=S(X[1].substr(1),Y,!0):(X=s.exec(h(Y,_)))?ce=S(X[1],Y,!1):ce=y(Y),t.set(x,ce),o(ce,Z)}function o(Z,_){if(typeof _=="string")return Z;const Y=function(x,ce){return(0,R.$hg)(x,_.base,!p.$k)?Z((0,$.$5e)(x.substr(_.base.length),A.sep),ce):null};return Y.allBasenames=Z.allBasenames,Y.allPaths=Z.allPaths,Y.basenames=Z.basenames,Y.patterns=Z.patterns,Y}function h(Z,_){return _.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function f(Z,_){return function(Y,x){return typeof Y=="string"&&Y.endsWith(Z)?_:null}}function D(Z,_){const Y=`/${Z}`,x=`\\${Z}`,ce=function(me,ae){return typeof me!="string"?null:ae?ae===Z?_:null:me===Z||me.endsWith(Y)||me.endsWith(x)?_:null},X=[Z];return ce.basenames=X,ce.patterns=[_],ce.allBasenames=X,ce}function w(Z,_){const Y=B(Z.slice(1,-1).split(",").map(ae=>l(ae,_)).filter(ae=>ae!==d),Z),x=Y.length;if(!x)return d;if(x===1)return Y[0];const ce=function(ae,re){for(let W=0,ie=Y.length;W<ie;W++)if(Y[W](ae,re))return Z;return null},X=Y.find(ae=>!!ae.allBasenames);X&&(ce.allBasenames=X.allBasenames);const me=Y.reduce((ae,re)=>re.allPaths?ae.concat(re.allPaths):ae,[]);return me.length&&(ce.allPaths=me),ce}function S(Z,_,Y){const x=A.sep===A.$hc.sep,ce=x?Z:Z.replace(b,A.sep),X=A.sep+ce,me=A.$hc.sep+Z;let ae;return Y?ae=function(re,W){return typeof re=="string"&&(re===ce||re.endsWith(X)||!x&&(re===Z||re.endsWith(me)))?_:null}:ae=function(re,W){return typeof re=="string"&&(re===ce||!x&&re===Z)?_:null},ae.allPaths=[(Y?"*/":"./")+Z],ae}function y(Z){try{const _=new RegExp(`^${c(Z)}$`);return function(Y){return _.lastIndex=0,typeof Y=="string"&&_.test(Y)?Z:null}}catch{return d}}function C(Z,_,Y){return!Z||typeof _!="string"?!1:O(Z)(_,void 0,Y)}function O(Z,_={}){if(!Z)return g;if(typeof Z=="string"||z(Z)){const Y=l(Z,_);if(Y===d)return g;const x=function(ce,X){return!!Y(ce,X)};return Y.allBasenames&&(x.allBasenames=Y.allBasenames),Y.allPaths&&(x.allPaths=Y.allPaths),x}return L(Z,_)}function z(Z){const _=Z;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}function F(Z){return Z.allBasenames||[]}function T(Z){return Z.allPaths||[]}function L(Z,_){const Y=B(Object.getOwnPropertyNames(Z).map(ae=>N(ae,Z[ae],_)).filter(ae=>ae!==d)),x=Y.length;if(!x)return d;if(!Y.some(ae=>!!ae.requiresSiblings)){if(x===1)return Y[0];const ae=function(ie,ve){let Pe;for(let le=0,ue=Y.length;le<ue;le++){const oe=Y[le](ie,ve);if(typeof oe=="string")return oe;(0,j.$6g)(oe)&&(Pe||(Pe=[]),Pe.push(oe))}return Pe?(async()=>{for(const le of Pe){const ue=await le;if(typeof ue=="string")return ue}return null})():null},re=Y.find(ie=>!!ie.allBasenames);re&&(ae.allBasenames=re.allBasenames);const W=Y.reduce((ie,ve)=>ve.allPaths?ie.concat(ve.allPaths):ie,[]);return W.length&&(ae.allPaths=W),ae}const ce=function(ae,re,W){let ie,ve;for(let Pe=0,le=Y.length;Pe<le;Pe++){const ue=Y[Pe];ue.requiresSiblings&&W&&(re||(re=(0,A.$oc)(ae)),ie||(ie=re.substr(0,re.length-(0,A.$pc)(ae).length)));const oe=ue(ae,re,ie,W);if(typeof oe=="string")return oe;(0,j.$6g)(oe)&&(ve||(ve=[]),ve.push(oe))}return ve?(async()=>{for(const Pe of ve){const le=await Pe;if(typeof le=="string")return le}return null})():null},X=Y.find(ae=>!!ae.allBasenames);X&&(ce.allBasenames=X.allBasenames);const me=Y.reduce((ae,re)=>re.allPaths?ae.concat(re.allPaths):ae,[]);return me.length&&(ce.allPaths=me),ce}function N(Z,_,Y){if(_===!1)return d;const x=l(Z,Y);if(x===d)return d;if(typeof _=="boolean")return x;if(_){const ce=_.when;if(typeof ce=="string"){const X=(me,ae,re,W)=>{if(!W||!x(me,ae))return null;const ie=ce.replace("$(basename)",()=>re),ve=W(ie);return(0,j.$6g)(ve)?ve.then(Pe=>Pe?Z:null):ve?Z:null};return X.requiresSiblings=!0,X}}return x}function B(Z,_){const Y=Z.filter(ae=>!!ae.basenames);if(Y.length<2)return Z;const x=Y.reduce((ae,re)=>{const W=re.basenames;return W?ae.concat(W):ae},[]);let ce;if(_){ce=[];for(let ae=0,re=x.length;ae<re;ae++)ce.push(_)}else ce=Y.reduce((ae,re)=>{const W=re.patterns;return W?ae.concat(W):ae},[]);const X=function(ae,re){if(typeof ae!="string")return null;if(!re){let ie;for(ie=ae.length;ie>0;ie--){const ve=ae.charCodeAt(ie-1);if(ve===47||ve===92)break}re=ae.substr(ie)}const W=x.indexOf(re);return W!==-1?ce[W]:null};X.basenames=x,X.patterns=ce,X.allBasenames=x;const me=Z.filter(ae=>!ae.basenames);return me.push(X),me}function U(Z,_){return(0,u.$ub)(Z,_,(Y,x)=>typeof Y=="string"&&typeof x=="string"?Y===x:typeof Y!="string"&&typeof x!="string"?Y.base===x.base&&Y.pattern===x.pattern:!1)}}),define(Ee[80],Se([1,0,13,170,23,14,2]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.MarkdownStringTextNewlineStyle=void 0,e.$Fk=k,e.$Gk=M,e.$Hk=I,e.$Ik=b,e.$Jk=E,e.$Kk=v,e.$Lk=c,e.$Mk=m;var p;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=b(this.supportThemeIcons?(0,j.$yk)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${E(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,P.$Ze)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Ek=$;function k(a){return M(a)?!a.value:Array.isArray(a)?a.every(k):!0}function M(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function I(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,R.$Ng)(A.URI.from(a.baseUri),A.URI.from(n.baseUri)))}function b(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(a,n){const i=a.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,a,`${"`".repeat(r)}`].join(`
`)}function v(a){return a.replace(/"/g,"&quot;")}function c(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(a){const n=[],i=a.split("|").map(s=>s.trim());a=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),g=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),o=isFinite(parseInt(g));l&&n.push(`width="${d}"`),o&&n.push(`height="${g}"`)}return{href:a,dimensions:n}}}),define(Ee[103],Se([1,0,19,34,17,11,23,14]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=$,e.$gw=M,e.$hw=b,e.$iw=E,e.$jw=a,e.$kw=i,e.$lw=r,e.$mw=s,e.$nw=t,e.$ow=g;function $(l,o){const{os:h,tildify:f,relative:D}=o;if(D){const y=k(l,D,h);if(typeof y=="string")return y}let w=l.fsPath;if(h===1&&!P.$i?w=w.replace(/\//g,"\\"):h!==1&&P.$i&&(w=w.replace(/\\/g,"/")),h!==1&&f?.userHome){const y=f.userHome.fsPath;let C;l.scheme!==f.userHome.scheme&&l.path[0]===R.$hc.sep&&l.path[1]!==R.$hc.sep?C=f.userHome.with({path:l.path}).fsPath:C=w,w=b(C,y,h)}return(h===1?R.$gc:R.$hc).normalize(M(w,h===1))}function k(l,o,h){const f=h===1?R.$gc:R.$hc,D=h===3?A.$Kg:A.$Mg,w=o.getWorkspace(),S=(0,u.$Ob)(w.folders);if(!S)return;l.scheme!==S.uri.scheme&&l.path[0]===R.$hc.sep&&l.path[1]!==R.$hc.sep&&(l=S.uri.with({path:l.path}));const y=o.getWorkspaceFolder(l);if(!y)return;let C;if(D.isEqual(y.uri,l)?C="":C=D.relativePath(y.uri,l)??"",C&&(C=f.normalize(C)),w.folders.length>1&&!o.noPrefix){const O=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${O} \u2022 ${C}`:O}return C}function M(l,o=P.$i){return(0,j.$lg)(l,o)?l.charAt(0).toUpperCase()+l.slice(1):l}let I=Object.create(null);function b(l,o,h=P.OS){if(h===1||!l||!o)return l;let f=I.original===o?I.normalized:void 0;f||(f=o,P.$i&&(f=(0,j.$bg)(f)),f=`${(0,p.$6e)(f,R.$hc.sep)}${R.$hc.sep}`,I={original:o,normalized:f});let D=l;return P.$i&&(D=(0,j.$bg)(D)),(h===3?D.startsWith(f):(0,p.$mf)(D,f))?`~/${D.substr(f.length)}`:l}function E(l,o){return l.replace(/^~($|\/|\\)/,`${o}$1`)}const v="\u2026",c="\\\\",m="~";function a(l,o=R.sep){const h=new Array(l.length);let f=!1;for(let D=0;D<l.length;D++){const w=l[D];if(w===""){h[D]=`.${o}`;continue}if(!w){h[D]=w;continue}f=!0;let S="",y=w;y.indexOf(c)===0?(S=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(o)===0?(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length)):y.indexOf(m)===0&&(S=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const C=y.split(o);for(let O=1;f&&O<=C.length;O++)for(let z=C.length-O;f&&z>=0;z--){f=!1;let F=C.slice(z,z+O).join(o);for(let T=0;!f&&T<l.length;T++)if(T!==D&&l[T]&&l[T].indexOf(F)>-1){const L=z+O===C.length,N=z>0&&l[T].indexOf(o)>-1?o+F:F,B=l[T].endsWith(N);f=!L||B}if(!f){let T="";(C[0].endsWith(":")||S!=="")&&(z===1&&(z=0,O++,F=C[0]+o+F),z>0&&(T=C[0]+o),T=S+T),z>0&&(T=T+v+o),T=T+F,z+O<C.length&&(T=T+o+v),h[D]=T}}f&&(h[D]=w)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,o=Object.create(null)){const h=[];let f=!1,D="";for(const w of l)if(w==="$"||f&&w==="{")D&&h.push({value:D,type:n.TEXT}),D="",f=!0;else if(w==="}"&&f){const S=o[D];if(typeof S=="string")S.length&&h.push({value:S,type:n.VARIABLE});else if(S){const y=h[h.length-1];(!y||y.type!==n.SEPARATOR)&&h.push({value:S.label,type:n.SEPARATOR})}D="",f=!1}else D+=w;return D&&!f&&h.push({value:D,type:n.TEXT}),h.filter((w,S)=>{if(w.type===n.SEPARATOR){const y=h[S-1],C=h[S+1];return[y,C].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(w=>w.value).join("")}function r(l,o){return P.$j||o?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,o){return P.$j||o?l.replace(/\(&&\w\)|&&/g,""):P.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function g(l){if(l.endsWith("]")){const o=l.lastIndexOf(" [",l.length-2);if(o!==-1){const h=d(l.substring(0,o)),f=l.substring(o);return{name:h.name+f,parentPath:h.parentPath}}}return d(l)}function d(l){const o=l.indexOf("/")!==-1?R.$hc:R.$gc,h=o.basename(l),f=o.dirname(l);return h.length?{name:h,parentPath:f}:{name:f,parentPath:""}}}),define(Ee[133],Se([1,0,21,2]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=p,e.$mn=k,e.$nn=M;function R(I){return I.toJSON()}class P{constructor(b){this.a=b}transformIncoming(b){const E=this.a.transformIncoming(b);return E===b?b:R(j.URI.from(E))}transformOutgoing(b){const E=this.a.transformOutgoing(b);return E===b?b:R(j.URI.from(E))}transformOutgoingURI(b){const E=this.a.transformOutgoing(b);return E===b?b:j.URI.from(E)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$jn=P,e.$kn=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,b,E){if(!I||E>200)return null;if(typeof I=="object"){if(I instanceof j.URI)return b.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const c=A(I[v],b,E+1);c!==null&&(I[v]=c)}}return null}function p(I,b){const E=A(I,b,0);return E===null?I:E}function $(I,b,E,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return E?j.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);if(I instanceof u.$ue)return null;for(const c in I)if(Object.hasOwnProperty.call(I,c)){const m=$(I[c],b,E,v+1);m!==null&&(I[c]=m)}}return null}function k(I,b){const E=$(I,b,!1,0);return E===null?I:E}function M(I,b){const E=$(I,b,!0,0);return E===null?I:E}}),define(Ee[31],Se([1,0,51,63,396,8,34,76,17,11,23,2]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=D;var b;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function E(N,B=b.UNLINK,U){if((0,A.$kg)(N))throw new Error("rimraf - will refuse to recursively delete root");return B===b.UNLINK?c(N):v(N,U)}async function v(N,B=(0,A.$pg)((0,j.tmpdir)())){try{try{await u.promises.rename(N,B)}catch(U){return U.code==="ENOENT"?void 0:c(N)}c(B).catch(U=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function c(N){return(0,R.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function m(N){if((0,A.$kg)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}async function a(N,B){return r(await(B?n(N):(0,R.promisify)(u.readdir)(N)))}async function n(N){try{return await(0,R.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const B=[],U=await a(N);for(const Z of U){let _=!1,Y=!1,x=!1;try{const ce=await e.Promises.lstat((0,$.$kc)(N,Z));_=ce.isFile(),Y=ce.isDirectory(),x=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}B.push({name:Z,isFile:()=>_,isDirectory:()=>Y,isSymbolicLink:()=>x})}return B}function i(N){return r(u.readdirSync(N))}function r(N){return N.map(B=>typeof B=="string"?k.$j?(0,p.$Yl)(B):B:(B.name=k.$j?(0,p.$Yl)(B.name):B.name,B))}async function s(N){const B=await a(N),U=[];for(const Z of B)await g.existsDirectory((0,$.$kc)(N,Z))&&U.push(Z);return U}function t(N,B=1e3){return new Promise(U=>{let Z=!1;const _=setInterval(()=>{Z||(Z=!0,u.access(N,Y=>{Z=!1,Y&&(clearInterval(_),U(void 0))}))},B)})}var g;(function(N){async function B(_){let Y;try{if(Y=await e.Promises.lstat(_),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(k.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ce}throw x}}N.stat=B;async function U(_){try{const{stat:Y,symbolicLink:x}=await N.stat(_);return Y.isFile()&&x?.dangling!==!0}catch{}return!1}N.existsFile=U;async function Z(_){try{const{stat:Y,symbolicLink:x}=await N.stat(_);return Y.isDirectory()&&x?.dangling!==!0}catch{}return!1}N.existsDirectory=Z})(g||(e.SymlinkSupport=g={}));const d=new P.$qh;function l(N,B,U){return d.queueFor(I.URI.file(N),()=>{const Z=w(U);return new Promise((_,Y)=>f(N,B,Z,x=>x?Y(x):_()))},M.$Lg)}let o=!0;function h(N){o=N}function f(N,B,U,Z){if(!o)return u.writeFile(N,B,{mode:U.mode,flag:U.flag},Z);u.open(N,U.flag,U.mode,(_,Y)=>{if(_)return Z(_);u.writeFile(Y,B,x=>{if(x)return u.close(Y,()=>Z(x));u.fdatasync(Y,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),h(!1)),u.close(Y,X=>Z(X))))})})}function D(N,B,U){const Z=w(U);if(!o)return u.writeFileSync(N,B,{mode:Z.mode,flag:Z.flag});const _=u.openSync(N,Z.flag,Z.mode);try{u.writeFileSync(_,B);try{u.fdatasyncSync(_)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{u.closeSync(_)}}function w(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function S(N,B,U=6e4){if(N!==B)try{k.$i&&typeof U=="number"?await y(N,B,Date.now(),U):await(0,R.promisify)(u.rename)(N,B)}catch(Z){if(N.toLowerCase()!==B.toLowerCase()&&Z.code==="EXDEV"||N.endsWith("."))await C(N,B,{preserveSymlinks:!1}),await E(N,b.MOVE);else throw Z}}async function y(N,B,U,Z,_=0){try{return await(0,R.promisify)(u.rename)(N,B)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-U>=Z)throw console.error(`[node.js fs] rename failed after ${_} retries with error: ${Y}`),Y;if(_===0){let x=!1;try{const{stat:ce}=await g.stat(B);ce.isFile()||(x=!0)}catch{}if(x)throw Y}return await(0,P.$ih)(Math.min(100,_*10)),y(N,B,U,Z,_+1)}}async function C(N,B,U){return z(N,B,{root:{source:N,target:B},options:U,handledSourcePaths:new Set})}const O=511;async function z(N,B,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:Z,symbolicLink:_}=await g.stat(N);if(_){if(U.options.preserveSymlinks)try{return await L(N,B,U)}catch{}if(_.dangling)return}return Z.isDirectory()?F(N,B,Z.mode&O,U):T(N,B,Z.mode&O)}async function F(N,B,U,Z){await e.Promises.mkdir(B,{recursive:!0,mode:U});const _=await a(N);for(const Y of _)await z((0,$.$kc)(N,Y),(0,$.$kc)(B,Y),Z)}async function T(N,B,U){await e.Promises.copyFile(N,B),await e.Promises.chmod(B,U)}async function L(N,B,U){let Z=await e.Promises.readlink(N);(0,A.$hg)(Z,U.root.source,!k.$k)&&(Z=(0,$.$kc)(U.root.target,Z.substr(U.root.source.length+1))),await e.Promises.symlink(Z,B)}e.Promises=new class{get access(){return(0,R.promisify)(u.access)}get stat(){return(0,R.promisify)(u.stat)}get lstat(){return(0,R.promisify)(u.lstat)}get utimes(){return(0,R.promisify)(u.utimes)}get read(){return(N,B,U,Z,_)=>new Promise((Y,x)=>{u.read(N,B,U,Z,_,(ce,X,me)=>ce?x(ce):Y({bytesRead:X,buffer:me}))})}get readFile(){return(0,R.promisify)(u.readFile)}get write(){return(N,B,U,Z,_)=>new Promise((Y,x)=>{u.write(N,B,U,Z,_,(ce,X,me)=>ce?x(ce):Y({bytesWritten:X,buffer:me}))})}get appendFile(){return(0,R.promisify)(u.appendFile)}get fdatasync(){return(0,R.promisify)(u.fdatasync)}get truncate(){return(0,R.promisify)(u.truncate)}get copyFile(){return(0,R.promisify)(u.copyFile)}get open(){return(0,R.promisify)(u.open)}get close(){return(0,R.promisify)(u.close)}get symlink(){return(0,R.promisify)(u.symlink)}get readlink(){return(0,R.promisify)(u.readlink)}get chmod(){return(0,R.promisify)(u.chmod)}get mkdir(){return(0,R.promisify)(u.mkdir)}get unlink(){return(0,R.promisify)(u.unlink)}get rmdir(){return(0,R.promisify)(u.rmdir)}get realpath(){return(0,R.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return E}get rename(){return S}get copy(){return C}}}),define(Ee[104],Se([1,0,51,17,11,14,31]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=p,e.$Nq=$,e.$Oq=k,e.$Pq=M;function p(b){if(R.$k)return b;const E=(0,j.$nc)(b);if(b===E)return b;const v=((0,j.$oc)(b)||b).toLowerCase();try{const m=(0,A.readdirSync)(E).filter(a=>a.toLowerCase()===v);if(m.length===1){const a=p(E);if(a)return(0,j.$kc)(a,m[0])}else if(m.length>1){const a=m.indexOf(v);if(a>=0){const n=p(E);if(n)return(0,j.$kc)(n,m[a])}}}catch{}return null}async function $(b){if(R.$k)return b;const E=(0,j.$nc)(b);if(b===E)return b;const v=((0,j.$oc)(b)||b).toLowerCase();try{const m=(await A.Promises.readdir(E)).filter(a=>a.toLowerCase()===v);if(m.length===1){const a=await $(E);if(a)return(0,j.$kc)(a,m[0])}else if(m.length>1){const a=m.indexOf(v);if(a>=0){const n=await $(E);if(n)return(0,j.$kc)(n,m[a])}}}catch{}return null}async function k(b){try{return await A.Promises.realpath(b)}catch{const v=I(b);return await A.Promises.access(v,u.constants.R_OK),v}}function M(b){try{return u.realpathSync(b)}catch{const v=I(b);return u.accessSync(v,u.constants.R_OK),v}}function I(b){return(0,P.$6e)((0,j.$ic)(b),j.sep)}}),define(Ee[105],Se([1,0,17,11,50,102,18,31]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=$,e.$am=k,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(I=R.env){return I.comspec||"cmd.exe"}function k(I){let b=[],E=!1;const v=function(c){if(E){b.push(c);return}(!I.send(c,a=>{if(a&&console.error(a),E=!1,b.length>0){const n=b.slice(0);b=[],n.forEach(i=>v(i))}})||j.$i)&&(E=!0)};return{send:v}}var M;(function(I){async function b(E,v,c){if(u.$jc(E))return E;if(v===void 0&&(v=R.cwd()),u.$nc(E)!=="."||(c===void 0&&A.$Uf(R.env.PATH)&&(c=R.env.PATH.split(u.$uc)),c===void 0||c.length===0))return u.$kc(v,E);async function a(n){if(await p.Promises.exists(n)){let i;try{i=await p.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await p.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of c){let i;if(u.$jc(n)?i=u.$kc(n,E):i=u.$kc(v,n,E),await a(i))return i;let r=i+".com";if(await a(r)||(r=i+".exe",await a(r)))return r}return u.$kc(v,E)}I.findExecutable=b})(M||(e.win32=M={}))});var Je=this&&this.__decorate||function(de,e,u,j){var R=arguments.length,P=R<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,u):j,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(de,e,u,j);else for(var p=de.length-1;p>=0;p--)(A=de[p])&&(P=(R<3?A(P):R>3?A(e,u,P):A(e,u))||P);return R>3&&P&&Object.defineProperty(e,u,P),P};define(Ee[81],Se([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=h,e.$Uh=f,e.$Zh=O,e.$1h=z;var E;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(E||(E={}));function v(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(c||(c={}));function m(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(a||(a={}));function n(_){let Y=0;for(let x=0;;x+=7){const ce=_.read(1);if(Y|=(ce.buffer[0]&127)<<x,!(ce.buffer[0]&128))return Y}}const i=d(0);function r(_,Y){if(Y===0){_.write(i);return}let x=0;for(let X=Y;X!==0;X=X>>>7)x++;const ce=R.$ue.alloc(x);for(let X=0;Y!==0;X++)ce.buffer[X]=Y&127,Y=Y>>>7,Y>0&&(ce.buffer[X]|=128);_.write(ce)}class s{constructor(Y){this.b=Y,this.a=0}read(Y){const x=this.b.slice(this.a,this.a+Y);return this.a+=x.byteLength,x}}e.$Rh=s;class t{constructor(){this.a=[]}get buffer(){return R.$ue.concat(this.a)}write(Y){this.a.push(Y)}}e.$Sh=t;var g;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(g||(g={}));function d(_){const Y=R.$ue.alloc(1);return Y.writeUInt8(_,0),Y}const l={Undefined:d(g.Undefined),String:d(g.String),Buffer:d(g.Buffer),VSBuffer:d(g.VSBuffer),Array:d(g.Array),Object:d(g.Object),Uint:d(g.Int)},o=typeof Buffer<"u";function h(_,Y){if(typeof Y>"u")_.write(l.Undefined);else if(typeof Y=="string"){const x=R.$ue.fromString(Y);_.write(l.String),r(_,x.byteLength),_.write(x)}else if(o&&Buffer.isBuffer(Y)){const x=R.$ue.wrap(Y);_.write(l.Buffer),r(_,x.byteLength),_.write(x)}else if(Y instanceof R.$ue)_.write(l.VSBuffer),r(_,Y.byteLength),_.write(Y);else if(Array.isArray(Y)){_.write(l.Array),r(_,Y.length);for(const x of Y)h(_,x)}else if(typeof Y=="number"&&(Y|0)===Y)_.write(l.Uint),r(_,Y);else{const x=R.$ue.fromString(JSON.stringify(Y));_.write(l.Object),r(_,x.byteLength),_.write(x)}}function f(_){switch(_.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return _.read(n(_)).toString();case g.Buffer:return _.read(n(_)).buffer;case g.VSBuffer:return _.read(n(_));case g.Array:{const x=n(_),ce=[];for(let X=0;X<x;X++)ce.push(f(_));return ce}case g.Object:return JSON.parse(_.read(n(_)).toString());case g.Int:return n(_)}}class D{constructor(Y,x,ce=null,X=1e3){this.h=Y,this.j=x,this.k=ce,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(me=>this.q(me)),this.m({type:200})}registerChannel(Y,x){this.b.set(Y,x),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const x=this.o([Y.type]);this.k?.logOutgoing(x,0,1,m(Y.type));return}case 201:case 202:case 204:case 203:{const x=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(x,Y.id,1,m(Y.type),Y.data);return}}}o(Y,x=void 0){const ce=new t;return h(ce,Y),h(ce,x),this.p(ce.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const x=new s(Y),ce=f(x),X=f(x),me=ce[0];switch(me){case 100:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(me)}: ${ce[2]}.${ce[3]}`,X),this.s({type:me,id:ce[1],channelName:ce[2],name:ce[3],arg:X});case 102:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(me)}: ${ce[2]}.${ce[3]}`,X),this.t({type:me,id:ce[1],channelName:ce[2],name:ce[3],arg:X});case 101:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(me)}`),this.u({type:me,id:ce[1]});case 103:return this.k?.logIncoming(Y.byteLength,ce[1],1,`${v(me)}`),this.u({type:me,id:ce[1]})}}s(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const ce=new P.$ee;let X;try{X=x.call(this.j,Y.name,Y.arg,ce.token)}catch(re){X=Promise.reject(re)}const me=Y.id;X.then(re=>{this.m({id:me,data:re,type:201})},re=>{re instanceof Error?this.m({id:me,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split?re.stack.split(`
`):re.stack:void 0},type:202}):this.m({id:me,data:re,type:203})}).finally(()=>{ae.dispose(),this.d.delete(Y.id)});const ae=(0,k.$Sc)(()=>ce.cancel());this.d.set(Y.id,ae)}t(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const ce=Y.id,me=x.listen(this.j,Y.name,Y.arg)(ae=>this.m({id:ce,data:ae,type:204}));this.d.set(Y.id,me)}u(Y){const x=this.d.get(Y.id);x&&(x.dispose(),this.d.delete(Y.id))}v(Y){let x=this.g.get(Y.channelName);x||(x=[],this.g.set(Y.channelName,x));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:Y,timeoutTimer:ce})}w(Y){const x=this.g.get(Y);if(x){for(const ce of x)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=D;var w;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class S{constructor(Y,x=null){this.l=Y,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=x}getChannel(Y){const x=this;return{call(ce,X,me){return x.a?Promise.reject(new p.$5):x.m(Y,ce,X,me)},listen(ce,X){return x.a?$.Event.None:x.o(Y,ce,X)}}}m(Y,x,ce,X=P.CancellationToken.None){const me=this.g++,re={id:me,type:100,channelName:Y,name:x,arg:ce};if(X.isCancellationRequested)return Promise.reject(new p.$5);let W;return new Promise((ve,Pe)=>{if(X.isCancellationRequested)return Pe(new p.$5);const le=()=>{const ee=he=>{switch(he.type){case 201:this.f.delete(me),ve(he.data);break;case 202:{this.f.delete(me);const fe=new Error(he.data.message);fe.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,fe.name=he.data.name,Pe(fe);break}case 203:this.f.delete(me),Pe(he.data);break}};this.f.set(me,ee),this.p(re)};let ue=null;this.b===a.Idle?le():(ue=(0,j.$7g)(ee=>this.u()),ue.then(()=>{ue=null,le()}));const oe=()=>{ue?(ue.cancel(),ue=null):this.p({id:me,type:101}),Pe(new p.$5)},K=X.onCancellationRequested(oe);W=(0,k.$Rc)((0,k.$Sc)(oe),K),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(Y,x,ce){const X=this.g++,ae={id:X,type:102,channelName:Y,name:x,arg:ce};let re=null;const W=new $.$7d({onWillAddFirstListener:()=>{re=(0,j.$7g)(ve=>this.u()),re.then(()=>{re=null,this.d.add(W),this.p(ae)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(W),this.p({id:X,type:103}))}}),ie=ve=>W.fire(ve.data);return this.f.set(X,ie),W.event}p(Y){switch(Y.type){case 100:case 102:{const x=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(x,Y.id,0,`${v(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const x=this.q([Y.type,Y.id]);this.j?.logOutgoing(x,Y.id,0,v(Y.type));return}}}q(Y,x=void 0){const ce=new t;return h(ce,Y),h(ce,x),this.r(ce.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const x=new s(Y),ce=f(x),X=f(x),me=ce[0];switch(me){case 200:return this.j?.logIncoming(Y.byteLength,0,0,m(me)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ce[1],0,m(me),X),this.t({type:ce[0],id:ce[1],data:X})}}t(Y){if(Y.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=S,Je([A.$Lh],S.prototype,"onDidInitializePromise",null);class y{get connections(){const Y=[];return this.f.forEach(x=>Y.push(x)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new $.$7d,this.onDidAddConnection=this.g.event,this.h=new $.$7d,this.onDidRemoveConnection=this.h.event,this.j=new k.$Tc,this.j.add(Y(({protocol:x,onDidClientDisconnect:ce})=>{const X=$.Event.once(x.onMessage);this.j.add(X(me=>{const ae=new s(me),re=f(ae),W=new D(x,re),ie=new S(x);this.a.forEach((Pe,le)=>W.registerChannel(le,Pe));const ve={channelServer:W,channelClient:ie,ctx:re};this.f.add(ve),this.g.fire(ve),this.j.add(ce(()=>{W.dispose(),ie.dispose(),this.f.delete(ve),this.h.fire(ve)}))}))}))}getChannel(Y,x){const ce=this;return{call(X,me,ae){let re;if((0,b.$9f)(x)){const ie=(0,u.$4b)(ce.connections.filter(x));re=ie?Promise.resolve(ie):$.Event.toPromise($.Event.filter(ce.onDidAddConnection,x))}else re=x.routeCall(ce,X,me);const W=re.then(ie=>ie.channelClient.getChannel(Y));return O(W).call(X,me,ae)},listen(X,me){if((0,b.$9f)(x))return ce.k(Y,x,X,me);const ae=x.routeEvent(ce,X,me).then(re=>re.channelClient.getChannel(Y));return O(ae).listen(X,me)}}}k(Y,x,ce,X){const me=this;let ae;const re=new $.$7d({onWillAddFirstListener:()=>{ae=new k.$Tc;const W=new $.$ae,ie=new Map,ve=le=>{const oe=le.channelClient.getChannel(Y).listen(ce,X),K=W.add(oe);ie.set(le,K)},Pe=le=>{const ue=ie.get(le);ue&&(ue.dispose(),ie.delete(le))};me.connections.filter(x).forEach(ve),$.Event.filter(me.onDidAddConnection,x)(ve,void 0,ae),me.onDidRemoveConnection(Pe,void 0,ae),W.event(re.fire,re,ae),ae.add(W)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return re.event}registerChannel(Y,x){this.a.set(Y,x);for(const ce of this.f)ce.channelServer.registerChannel(Y,x)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=y;class C{constructor(Y,x,ce=null){const X=new t;h(X,x),Y.send(X.buffer),this.a=new S(Y,ce),this.d=new D(Y,x,ce)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,x){this.d.registerChannel(Y,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=C;function O(_){return{call(Y,x,ce){return _.then(X=>X.call(Y,x,ce))},listen(Y,x){const ce=new $.$de;return _.then(X=>ce.input=X.listen(Y,x)),ce.event}}}function z(_){let Y=!1;return{call(x,ce,X){return Y?_.call(x,ce,X):(0,j.$ih)(0).then(()=>Y=!0).then(()=>_.call(x,ce,X))},listen(x,ce){if(Y)return _.listen(x,ce);const X=new $.$de;return(0,j.$ih)(0).then(()=>Y=!0).then(()=>X.input=_.listen(x,ce)),X.event}}}class F{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const x of Y.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$2h=F;var T;(function(_){function Y(me,ae,re){const W=me,ie=re&&re.disableMarshalling,ve=new Map;for(const Pe in W)ce(Pe)&&ve.set(Pe,$.Event.buffer(W[Pe],!0,void 0,ae));return new class{listen(Pe,le,ue){const oe=ve.get(le);if(oe)return oe;const K=W[le];if(typeof K=="function"){if(X(le))return K.call(W,ue);if(ce(le))return ve.set(le,$.Event.buffer(W[le],!0,void 0,ae)),ve.get(le)}throw new p.$bb(`Event not found: ${le}`)}call(Pe,le,ue){const oe=W[le];if(typeof oe=="function"){if(!ie&&Array.isArray(ue))for(let ee=0;ee<ue.length;ee++)ue[ee]=(0,M.$Qh)(ue[ee]);let K=oe.apply(W,ue);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new p.$bb(`Method not found: ${le}`)}}}_.fromService=Y;function x(me,ae){const re=ae&&ae.disableMarshalling;return new Proxy({},{get(W,ie){if(typeof ie=="string")return ae?.properties?.has(ie)?ae.properties.get(ie):X(ie)?function(ve){return me.listen(ie,ve)}:ce(ie)?me.listen(ie):async function(...ve){let Pe;ae&&!(0,b.$4f)(ae.context)?Pe=[ae.context,...ve]:Pe=ve;const le=await me.call(ie,Pe);return re?le:(0,M.$Qh)(le)};throw new p.$bb(`Property not found: ${String(ie)}`)}})}_.toService=x;function ce(me){return me[0]==="o"&&me[1]==="n"&&I.$kf(me.charCodeAt(2))}function X(me){return/^onDynamic/.test(me)&&I.$kf(me.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const L=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const Y=_.toString();if(Y!=="[object Object]")return Y}return _}function B(_){return Array.isArray(_)?_.map(N):N(_)}function U(_,Y,x,ce,X,me,ae){ae=B(ae);const re=L[X],W=re[ce%re.length];let ie=[`%c[${_}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(me)?(ie=ie.concat(ae),ie.push(")")):ie.push(ae),console.log.apply(console,ie)}class Z{constructor(Y,x){this.d=Y,this.f=x,this.a=0,this.b=0}logOutgoing(Y,x,ce,X,me){this.b+=Y,U(this.d,this.b,Y,x,ce,X,me)}logIncoming(Y,x,ce,X,me){this.a+=Y,U(this.f,this.a,Y,x,ce,X,me)}}e.$3h=Z}),define(Ee[82],Se([1,0,21,4,3,81]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.ProtocolConstants=e.$4h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var p;(function(l){l.enableDiagnostics=!1,l.records=[];const o=new WeakMap;let h=0;function f(w,S){if(!o.has(w)){const y=String(++h);o.set(w,y)}return o.get(w)}function D(w,S,y,C){if(!l.enableDiagnostics)return;const O=f(w,S);if(C instanceof u.$ue||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=u.$ue.alloc(C.byteLength);z.set(C),l.records.push({timestamp:Date.now(),id:O,label:S,type:y,buff:z})}else l.records.push({timestamp:Date.now(),id:O,label:S,type:y,data:C})}l.traceSocketEvent=D})(p||(e.SocketDiagnostics=p={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function M(){return k||(k=u.$ue.alloc(0)),k}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,h){if(o===0)return M();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const S=this.a[0];return h&&(this.a.shift(),this.b-=o),S}if(this.a[0].byteLength>o){const S=this.a[0].slice(0,o);return h&&(this.a[0]=this.a[0].slice(o),this.b-=o),S}const f=u.$ue.alloc(o);let D=0,w=0;for(;o>0;){const S=this.a[w];if(S.byteLength>o){const y=S.slice(0,o);f.set(y,D),D+=o,h&&(this.a[w]=S.slice(o),this.b-=o),o-=o}else f.set(S,D),D+=S.byteLength,h?(this.a.shift(),this.b-=S.byteLength):w++,o-=S.byteLength}return f}}e.$4h=I;var b;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(b||(b={}));function E(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class c{constructor(o,h,f,D){this.type=o,this.id=h,this.ack=f,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends R.$Uc{constructor(o){super(),this.f=this.B(new j.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,D=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new c(f,D,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$ue.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(h,o.data)}g(o,h){const f=this.f===0;return this.d.push(o,h),this.f+=o.byteLength+h.byteLength,f}h(){const o=u.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,h){this.g(o,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class n extends R.$Uc{constructor(o){super(),this.f=new j.$7d,this.onMessage=this.f.event,this.g=new j.$7d,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new a(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new c(1,0,0,o))}}e.$5h=n;class i extends P.$Yh{static fromSocket(o,h){return new i(new n(o),h)}get onDidDispose(){return this.b.onDidDispose}constructor(o,h,f=null){super(o,h,f),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$6h=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new j.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$7h=r;class s{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,h=this.a;for(;h;)h=h.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let h=0,f=this.a;for(;f;)o[h++]=f.data,f=f.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const h=new s(o);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class g{static{this.a=10}static{this.b=null}static getInstance(){return g.b||(g.b=new g),g.b}constructor(){this.c=[];const o=Date.now();for(let h=0;h<g.a;h++)this.c[h]=o-1e3*h;setInterval(()=>{for(let h=g.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),h=(1+g.a)*1e3;let f=0;for(let D=0;D<g.a;D++)o-this.c[D]<=h&&f++;return 1-f/g.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??g.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new R.$Tc,this.o=o.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new c(5,0,0,M());this.p.write(o),this.p.flush()}sendPause(){const o=new c(7,0,0,M());this.p.write(o)}sendResume(){const o=new c(8,0,0,M());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,h){this.a=!0,this.r.dispose(),this.r=new R.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new c(3,0,this.h,M());this.p.write(o);const h=this.b.toArray();for(let f=0,D=h.length;f<D;f++)this.p.write(h[f]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const h=this.b.peek();if(h&&h.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new c(6,0,0,M())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let f=0,D=h.length;f<D;f++)this.p.write(h[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const h=++this.c;this.h=this.g;const f=new c(1,h,this.h,o);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(o){const h=new c(2,0,0,o);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),h=Date.now()-o.writtenTime,f=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&f>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:f});return}const w=Math.max(2e4-h,2e4-f,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new c(3,0,this.h,M());this.p.write(o)}D(){this.h=this.g;const o=new c(9,0,this.h,M());this.p.write(o)}}e.$8h=d}),define(Ee[193],Se([1,0,52,8,21,22,191,13,4,3,24,105,102,81]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class v extends E.$Vh{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>R.$ue.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Iq=v;class c{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$7d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new j.$eh(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,r,s){return n.k(a,i,r,s)},listen(i,r){return n.l(a,i,r)}}}k(a,n,i,r=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const s=this.n(a),t=(0,j.$7g)(l=>s.call(n,i,l)),g=r.onCancellationRequested(()=>t.cancel()),d=(0,k.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{g.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return $.Event.None;this.b.cancel();let r;const s=new $.$7d({onWillAddFirstListener:()=>{r=this.n(a).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,M.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,b.$$l)(n.env),this.d=(0,u.fork)(this.i,a,n);const i=new $.$7d;$.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Eq)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}i.fire(R.$ue.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,I.$am)(this.d):this.d,t=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),g=i.event,d={send:t,onMessage:g};this.f=new E.$Wh(d);const l=()=>this.o();process.once("exit",l),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",l),this.c.forEach(f=>(0,k.$Pc)(f)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jq=c}),define(Ee[194],Se([1,0,8,4,3,57,18]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=$;var p;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(b){const E=b;return E?.changed instanceof Map||E?.deleted instanceof Set}var k;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(k||(e.StorageState=k={}));class M extends R.$Uc{static{this.a=100}constructor(E,v=Object.create(null)){super(),this.r=E,this.s=v,this.b=this.B(new j.$0d),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new u.$fh(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((v,c)=>this.w(c,v)),E.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(E,v){if(this.c===k.Closed)return;let c=!1;(0,A.$4f)(v)?c=this.f.delete(E):this.f.get(E)!==v&&(this.f.set(E,v),c=!0),c&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,v){const c=this.f.get(E);return(0,A.$4f)(c)?v:c}getBoolean(E,v){const c=this.get(E);return(0,A.$4f)(c)?v:c==="true"}getNumber(E,v){const c=this.get(E);return(0,A.$4f)(c)?v:parseInt(c,10)}getObject(E,v){const c=this.get(E);return(0,A.$4f)(c)?v:(0,P.$Ph)(c)}async set(E,v,c=!1){if(this.c===k.Closed)return;if((0,A.$4f)(v))return this.delete(E,c);const m=(0,A.$Wf)(v)||Array.isArray(v)?(0,P.$Oh)(v):String(v);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:c}),this.D()}async delete(E,v=!1){if(!(this.c===k.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:v}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Hp=M;class I{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((v,c)=>this.a.set(c,v)),E.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Ip=I}),define(Ee[195],Se([1,0,14,11,21]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=M,e.$ut=I;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function M(){return k||(k=j.$D()?A():$()),k}function I(v,c,m){const a=new Uint16Array(v.buffer,c,m);return m>0&&(a[0]===65279||a[0]===65534)?b(v,c,m):A().decode(a)}function b(v,c,m){const a=[];let n=0;for(let i=0;i<m;i++){const r=R.$we(v,c);c+=2,a[n++]=String.fromCharCode(r)}return a.join("")}class E{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return M().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||u.$pf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let a=0;a<m;a++)this.b[this.d++]=c.charCodeAt(a)}}e.$vt=E}),define(Ee[196],Se([1,0,21,195]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=A;function R($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,M,I,b){this.oldPosition=k,this.oldText=M,this.newPosition=I,this.newText=b}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,M,I){const b=M.length;u.$ze(k,b,I),I+=4;for(let E=0;E<b;E++)u.$xe(k,M.charCodeAt(E),I),I+=2;return I}static d(k,M){const I=u.$ye(k,M);return M+=4,(0,j.$ut)(k,M,I)}writeSize(){return 8+P.a(this.oldText)+P.a(this.newText)}write(k,M){return u.$ze(k,this.oldPosition,M),M+=4,u.$ze(k,this.newPosition,M),M+=4,M=P.c(k,this.oldText,M),M=P.c(k,this.newText,M),M}static read(k,M,I){const b=u.$ye(k,M);M+=4;const E=u.$ye(k,M);M+=4;const v=P.d(k,M);M+=P.a(v);const c=P.d(k,M);return M+=P.a(c),I.push(new P(b,v,E,c)),M}}e.$wt=P;function A($,k){return $===null||$.length===0?k:new p($,k).compress()}class p{constructor(k,M){this.a=k,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,M=0,I=this.n(k),b=this.l(M);for(;k<this.f||M<this.h;){if(I===null){this.k(b),b=this.l(++M);continue}if(b===null){this.m(I),I=this.n(++k);continue}if(b.oldEnd<=I.newPosition){this.k(b),b=this.l(++M);continue}if(I.newEnd<=b.oldPosition){this.m(I),I=this.n(++k);continue}if(b.oldPosition<I.newPosition){const[a,n]=p.r(b,I.newPosition-b.oldPosition);this.k(a),b=n;continue}if(I.newPosition<b.oldPosition){const[a,n]=p.q(I,b.oldPosition-I.newPosition);this.m(a),I=n;continue}let c,m;if(b.oldEnd===I.newEnd)c=I,m=b,I=this.n(++k),b=this.l(++M);else if(b.oldEnd<I.newEnd){const[a,n]=p.q(I,b.oldLength);c=a,m=b,I=n,b=this.l(++M)}else{const[a,n]=p.r(b,I.newLength);c=I,m=a,I=this.n(++k),b=n}this.d[this.e++]=new P(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const E=p.s(this.d);return p.t(E)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,M){return new P(M.oldPosition-k,M.oldText,M.newPosition,M.newText)}static p(k,M){return new P(M.oldPosition,M.oldText,M.newPosition+k,M.newText)}static q(k,M){const I=k.newText.substr(0,M),b=k.newText.substr(M);return[new P(k.oldPosition,k.oldText,k.newPosition,I),new P(k.oldEnd,"",k.newPosition+M,b)]}static r(k,M){const I=k.oldText.substr(0,M),b=k.oldText.substr(M);return[new P(k.oldPosition,I,k.newPosition,k.newText),new P(k.oldPosition+M,b,k.newEnd,"")]}static s(k){if(k.length===0)return k;const M=[];let I=0,b=k[0];for(let E=1;E<k.length;E++){const v=k[E];b.oldEnd===v.oldPosition?b=new P(b.oldPosition,b.oldText+v.oldText,b.newPosition,b.newText+v.newText):(M[I++]=b,b=v)}return M[I++]=b,M}static t(k){if(k.length===0)return k;const M=[];let I=0;for(let b=0;b<k.length;b++){const E=k[b];E.oldText!==E.newText&&(M[I++]=E)}return M}}}),define(Ee[197],Se([1,0,35,17]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=R,e.$Vt=P;function R(A,p,$,k,M,I){if(Array.isArray(A)){let b=0;for(const E of A){const v=R(E,p,$,k,M,I);if(v===10)return v;v>b&&(b=v)}return b}else{if(typeof A=="string")return k?A==="*"?5:A===$?10:0:0;if(A){const{language:b,pattern:E,scheme:v,hasAccessToAllModels:c,notebookType:m}=A;if(!k&&!c)return 0;m&&M&&(p=M);let a=0;if(v)if(v===p.scheme)a=10;else if(v==="*")a=5;else return 0;if(b)if(b===$)a=10;else if(b==="*")a=Math.max(a,5);else return 0;if(m)if(m===I)a=10;else if(m==="*"&&I!==void 0)a=Math.max(a,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,j.$ic)(E.base)},n===p.fsPath||(0,u.$ak)(n,p.fsPath))a=10;else return 0}return a}else return 0}}function P(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(P):!!A.notebookType}}),define(Ee[198],Se([1,0,4,14,29,79,130,173,196,3]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=void 0;class M extends k.$Uc{constructor(b,E,v,c,m,a,n){super(),this.m=this.B(new u.$7d),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=c,this.h=m,this.c=new A.$wC(b,v,n)}equals(b){return!(b instanceof M)||this.f!==b.f||this.getEOL()!==b.getEOL()?!1:this.c.equal(b.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(b){return this.c.createSnapshot(b?this.f:"")}getOffsetAt(b,E){return this.c.getOffsetAt(b,E)}getPositionAt(b){return this.c.getPositionAt(b)}getRangeAt(b,E){const v=b+E,c=this.getPositionAt(b),m=this.getPositionAt(v);return new R.$bt(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(b,E=0){if(b.isEmpty())return"";const v=this.n(E);return this.c.getValueInRange(b,v)}getValueLengthInRange(b,E=0){if(b.isEmpty())return 0;if(b.startLineNumber===b.endLineNumber)return b.endColumn-b.startColumn;const v=this.getOffsetAt(b.startLineNumber,b.startColumn),c=this.getOffsetAt(b.endLineNumber,b.endColumn);let m=0;const a=this.n(E),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,r=b.endLineNumber-b.startLineNumber;m=i*r}return c-v+m}getCharacterCountInRange(b,E=0){if(this.j){let v=0;const c=b.startLineNumber,m=b.endLineNumber;for(let a=c;a<=m;a++){const n=this.getLineContent(a),i=a===c?b.startColumn-1:0,r=a===m?b.endColumn-1:n.length;for(let s=i;s<r;s++)j.$pf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(E).length*(m-c),v}return this.getValueLengthInRange(b,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(b){return this.c.getLineContent(b)}getLineCharCode(b,E){return this.c.getLineCharCode(b,E)}getCharCode(b){return this.c.getCharCode(b)}getLineLength(b){return this.c.getLineLength(b)}getLineMinColumn(b){return 1}getLineMaxColumn(b){return this.getLineLength(b)+1}getLineFirstNonWhitespaceColumn(b){const E=j.$af(this.getLineContent(b));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(b){const E=j.$cf(this.getLineContent(b));return E===-1?0:E+2}n(b){switch(b){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(b){this.c.setEOL(b)}applyEdits(b,E,v){let c=this.g,m=this.h,a=this.j,n=!0,i=[];for(let o=0;o<b.length;o++){const h=b[o];n&&h._isTracked&&(n=!1);const f=h.range;if(h.text){let C=!0;a||(C=!j.$Af(h.text),a=C),!c&&C&&(c=j.$zf(h.text)),!m&&C&&(m=j.$Cf(h.text))}let D="",w=0,S=0,y=0;if(h.text){let C;[w,S,y,C]=(0,p.$Nt)(h.text);const O=this.getEOL();C===0||C===(O===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,O)}i[o]={sortIndex:o,identifier:h.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:D,eolCount:w,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(M.u);let r=!1;for(let o=0,h=i.length-1;o<h;o++){const f=i[o].range.getEndPosition(),D=i[o+1].range.getStartPosition();if(D.isBeforeOrEqual(f)){if(D.isBefore(f))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=v||E?M._getInverseEditRanges(i):[],t=[];if(E)for(let o=0;o<i.length;o++){const h=i[o],f=s[o];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=f.startLineNumber;D<=f.endLineNumber;D++){let w="";D===f.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),j.$af(w)!==-1)||t.push({lineNumber:D,oldContent:w})}}let g=null;if(v){let o=0;g=[];for(let h=0;h<i.length;h++){const f=i[h],D=s[h],w=this.getValueInRange(f.range),S=f.rangeOffset+o;o+=f.text.length-w.length,g[h]={sortIndex:f.sortIndex,identifier:f.identifier,range:D,text:w,textChange:new $.$wt(f.rangeOffset,w,S,f.text)}}r||g.sort((h,f)=>h.sortIndex-f.sortIndex)}this.g=c,this.h=m,this.j=a;const d=this.t(i);let l=null;if(E&&t.length>0){t.sort((o,h)=>h.lineNumber-o.lineNumber),l=[];for(let o=0,h=t.length;o<h;o++){const f=t[o].lineNumber;if(o>0&&t[o-1].lineNumber===f)continue;const D=t[o].oldContent,w=this.getLineContent(f);w.length===0||w===D||j.$af(w)!==-1||l.push(f)}}return this.m.fire(),new P.$zv(g,d,l)}s(b){return b.length<1e3?b:[this._toSingleEditOperation(b)]}_toSingleEditOperation(b){let E=!1;const v=b[0].range,c=b[b.length-1].range,m=new R.$bt(v.startLineNumber,v.startColumn,c.endLineNumber,c.endColumn);let a=v.startLineNumber,n=v.startColumn;const i=[];for(let d=0,l=b.length;d<l;d++){const o=b[d],h=o.range;E=E||o.forceMoveMarkers,i.push(this.getValueInRange(new R.$bt(a,n,h.startLineNumber,h.startColumn))),o.text.length>0&&i.push(o.text),a=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,g]=(0,p.$Nt)(r);return{sortIndex:0,identifier:b[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:g,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(b){b.sort(M.w);const E=[];for(let v=0;v<b.length;v++){const c=b[v],m=c.range.startLineNumber,a=c.range.startColumn,n=c.range.endLineNumber,i=c.range.endColumn;if(m===n&&a===i&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const r=new R.$bt(m,a,n,i);E.push({range:r,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return E}findMatchesLineByLine(b,E,v,c){return this.c.findMatchesLineByLine(b,E,v,c)}getPieceTree(){return this.c}static _getInverseEditRange(b,E){const v=b.startLineNumber,c=b.startColumn,[m,a,n]=(0,p.$Nt)(E);let i;if(E.length>0){const r=m+1;r===1?i=new R.$bt(v,c,v,c+a):i=new R.$bt(v,c,v+r-1,n+1)}else i=new R.$bt(v,c,v,c);return i}static _getInverseEditRanges(b){const E=[];let v=0,c=0,m=null;for(let a=0,n=b.length;a<n;a++){const i=b[a];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=v,s=c+(i.range.startColumn-m.range.endColumn)):(r=v+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const g=i.eolCount+1;g===1?t=new R.$bt(r,s,r,s+i.firstLineLength):t=new R.$bt(r,s,r+g-1,i.lastLineLength+1)}else t=new R.$bt(r,s,r,s);v=t.endLineNumber,c=t.endColumn,E.push(t),m=i}return E}static u(b,E){const v=R.$bt.compareRangesUsingEnds(b.range,E.range);return v===0?b.sortIndex-E.sortIndex:v}static w(b,E){const v=R.$bt.compareRangesUsingEnds(b.range,E.range);return v===0?E.sortIndex-b.sortIndex:-v}}e.$xC=M}),define(Ee[199],Se([1,0,14,130,198]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=void 0;class P{constructor($,k,M,I,b,E,v,c,m){this.a=$,this.b=k,this.c=M,this.d=I,this.e=b,this.f=E,this.g=v,this.h=c,this.j=m}k($){const k=this.c+this.d+this.e,M=this.c+this.e;return k===0?$===1?`
`:`\r
`:M>k/2?`\r
`:`
`}create($){const k=this.k($),M=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let b=0,E=M.length;b<E;b++){const v=M[b].buffer.replace(/\r\n|\r|\n/g,k),c=(0,j.$sC)(v);M[b]=new j.$vC(v,c)}const I=new R.$xC(M,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&u.$If($)&&(this.b=u.$Hf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,j.$tC)(this.e,$);this.a.push(new j.$vC($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=u.$zf($)),this.k||(this.k=u.$Cf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,j.$sC)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$yC=A}),define(Ee[134],Se([1,0,21,11]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sab=$,e.$tab=M;var R;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(R||(R={}));function P(I){for(let b=0,E=I.length;b<E;b+=4){const v=I[b+0],c=I[b+1],m=I[b+2],a=I[b+3];I[b+0]=a,I[b+1]=m,I[b+2]=c,I[b+3]=v}}function A(I){const b=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return j.$D()||P(b),u.$ue.wrap(b)}function p(I){const b=I.buffer;if(j.$D()||P(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const E=new Uint8Array(b.byteLength);return E.set(b),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function $(I){const b=new Uint32Array(k(I));let E=0;if(b[E++]=I.id,I.type==="full")b[E++]=1,b[E++]=I.data.length,b.set(I.data,E),E+=I.data.length;else{b[E++]=2,b[E++]=I.deltas.length;for(const v of I.deltas)b[E++]=v.start,b[E++]=v.deleteCount,v.data?(b[E++]=v.data.length,b.set(v.data,E),E+=v.data.length):b[E++]=0}return A(b)}function k(I){let b=0;if(b+=2,I.type==="full")b+=1+I.data.length;else{b+=1,b+=3*I.deltas.length;for(const E of I.deltas)E.data&&(b+=E.data.length)}return b}function M(I){const b=p(I);let E=0;const v=b[E++];if(b[E++]===1){const n=b[E++],i=b.subarray(E,E+n);return E+=n,{id:v,type:"full",data:i}}const m=b[E++],a=[];for(let n=0;n<m;n++){const i=b[E++],r=b[E++],s=b[E++];let t;s>0&&(t=b.subarray(E,E+s),E+=s),a[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:a}}}),define(Ee[200],Se([9,10]),function(de,e){return de.create("vs/editor/common/config/editorOptions",e)}),define(Ee[135],Se([1,0,19,24,11,176,129,200]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=g,e.cursorStyleToString=y,e.filterValidationDecorations=fe;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=k;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class I{constructor(se,De,Ke,xe){this.id=se,this.name=De,this.defaultValue=Ke,this.schema=xe}applyUpdate(se,De){return E(se,De)}compute(se,De,Ke){return Ke}}class b{constructor(se,De){this.newValue=se,this.didChange=De}}e.ApplyUpdateResult=b;function E(ne,se){if(typeof ne!="object"||typeof se!="object"||!ne||!se)return new b(se,ne!==se);if(Array.isArray(ne)||Array.isArray(se)){const Ke=Array.isArray(ne)&&Array.isArray(se)&&u.$ub(ne,se);return new b(se,!Ke)}let De=!1;for(const Ke in se)if(se.hasOwnProperty(Ke)){const xe=E(ne[Ke],se[Ke]);xe.didChange&&(ne[Ke]=xe.newValue,De=!0)}return new b(ne,De)}class v{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,De){return E(se,De)}validate(se){return this.defaultValue}}class c{constructor(se,De,Ke,xe){this.id=se,this.name=De,this.defaultValue=Ke,this.schema=xe}applyUpdate(se,De){return E(se,De)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,De,Ke){return Ke}}function m(ne,se){return typeof ne>"u"?se:ne==="false"?!1:!!ne}class a extends c{constructor(se,De,Ke,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ke),super(se,De,Ke,xe)}validate(se){return m(se,this.defaultValue)}}function n(ne,se,De,Ke){if(typeof ne>"u")return se;let xe=parseInt(ne,10);return isNaN(xe)?se:(xe=Math.max(De,xe),xe=Math.min(Ke,xe),xe|0)}class i extends c{static clampedInt(se,De,Ke,xe){return n(se,De,Ke,xe)}constructor(se,De,Ke,xe,ot,Ne=void 0){typeof Ne<"u"&&(Ne.type="integer",Ne.default=Ke,Ne.minimum=xe,Ne.maximum=ot),super(se,De,Ke,Ne),this.minimum=xe,this.maximum=ot}validate(se){return i.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function r(ne,se,De,Ke){if(typeof ne>"u")return se;const xe=s.float(ne,se);return s.clamp(xe,De,Ke)}class s extends c{static clamp(se,De,Ke){return se<De?De:se>Ke?Ke:se}static float(se,De){if(typeof se=="number")return se;if(typeof se>"u")return De;const Ke=parseFloat(se);return isNaN(Ke)?De:Ke}constructor(se,De,Ke,xe,ot){typeof ot<"u"&&(ot.type="number",ot.default=Ke),super(se,De,Ke,ot),this.validationFn=xe}validate(se){return this.validationFn(s.float(se,this.defaultValue))}}class t extends c{static string(se,De){return typeof se!="string"?De:se}constructor(se,De,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ke),super(se,De,Ke,xe)}validate(se){return t.string(se,this.defaultValue)}}function g(ne,se,De,Ke){return typeof ne!="string"?se:Ke&&ne in Ke?Ke[ne]:De.indexOf(ne)===-1?se:ne}class d extends c{constructor(se,De,Ke,xe,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=xe,ot.default=Ke),super(se,De,Ke,ot),this.c=xe}validate(se){return g(se,this.defaultValue,this.c)}}class l extends I{constructor(se,De,Ke,xe,ot,Ne,bt=void 0){typeof bt<"u"&&(bt.type="string",bt.enum=ot,bt.default=xe),super(se,De,Ke,bt),this.c=ot,this.d=Ne}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function o(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,De,Ke){return Ke===0?se.accessibilitySupport:Ke}}class f extends I{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:p.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{insertSpace:m(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function w(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(ne){switch(ne){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(ne){switch(ne){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class O extends v{constructor(){super(141)}compute(se,De,Ke){const xe=["monaco-editor"];return De.get(39)&&xe.push(De.get(39)),se.extraEditorClassName&&xe.push(se.extraEditorClassName),De.get(74)==="default"?xe.push("mouse-default"):De.get(74)==="copy"&&xe.push("mouse-copy"),De.get(111)&&xe.push("showUnused"),De.get(139)&&xe.push("showDeprecated"),xe.join(" ")}}class z extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(se,De,Ke){return Ke&&se.emptySelectionClipboard}}class F extends I{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:p.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{cursorMoveOnType:m(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":g(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":g(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(De.loop,this.defaultValue.loop)}}}class T extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?T.OFF:se==="true"?T.ON:se:se?T.ON:T.OFF}}e.EditorFontLigatures=T;class L extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?L.OFF:se==="true"?L.TRANSLATE:se:se?L.TRANSLATE:L.OFF}compute(se,De,Ke){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class N extends v{constructor(){super(50)}compute(se,De,Ke){return se.fontInfo}}class B extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(se){const De=s.float(se,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(De,6,100)}compute(se,De,Ke){return se.fontInfo.fontSize}}class U extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(i.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}class Z extends I{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ke,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ke,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ke,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ke,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ke,description:p.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{multiple:g(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??g(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??g(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??g(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??g(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??g(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends I{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:p.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),delay:i.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:m(De.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(De.above,this.defaultValue.above)}}}var Y;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class x extends v{constructor(){super(144)}compute(se,De,Ke){return x.computeLayout(De,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const De=se.height/se.lineHeight,Ke=Math.floor(se.paddingTop/se.lineHeight);let xe=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(xe=Math.max(xe,De-1));const ot=(Ke+se.viewLineCount+xe)/(se.pixelRatio*se.height),Ne=Math.floor(se.viewLineCount/ot);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:xe,desiredRatio:ot,minimapLineCount:Ne}}static c(se,De){const Ke=se.outerWidth,xe=se.outerHeight,ot=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Ne=De.stableMinimapLayoutInput,bt=Ne&&se.outerHeight===Ne.outerHeight&&se.lineHeight===Ne.lineHeight&&se.typicalHalfwidthCharacterWidth===Ne.typicalHalfwidthCharacterWidth&&se.pixelRatio===Ne.pixelRatio&&se.scrollBeyondLastLine===Ne.scrollBeyondLastLine&&se.paddingTop===Ne.paddingTop&&se.paddingBottom===Ne.paddingBottom&&se.minimap.enabled===Ne.minimap.enabled&&se.minimap.side===Ne.minimap.side&&se.minimap.size===Ne.minimap.size&&se.minimap.showSlider===Ne.minimap.showSlider&&se.minimap.renderCharacters===Ne.minimap.renderCharacters&&se.minimap.maxColumn===Ne.minimap.maxColumn&&se.minimap.scale===Ne.minimap.scale&&se.verticalScrollbarWidth===Ne.verticalScrollbarWidth&&se.isViewportWrapping===Ne.isViewportWrapping,St=se.lineHeight,It=se.typicalHalfwidthCharacterWidth,xt=se.scrollBeyondLastLine,Tt=se.minimap.renderCharacters;let Dt=ot>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Qt=se.minimap.maxColumn,Ut=se.minimap.size,ai=se.minimap.side,ii=se.verticalScrollbarWidth,_e=se.viewLineCount,_t=se.remainingWidth,ni=se.isViewportWrapping,dt=Tt?2:3;let pt=Math.floor(ot*xe);const ri=pt/ot;let Wt=!1,qt=!1,ft=dt*Dt,Rt=Dt/ot,ei=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:Pt,extraLinesBeyondLastLine:Lt,desiredRatio:oi,minimapLineCount:Gt}=x.computeContainedMinimapLineCount({viewLineCount:_e,scrollBeyondLastLine:xt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:xe,lineHeight:St,pixelRatio:ot});if(_e/Gt>1)Wt=!0,qt=!0,Dt=1,ft=1,Rt=Dt/ot;else{let vt=!1,Nt=Dt+1;if(Ut==="fit"){const Bt=Math.ceil((Pt+_e+Lt)*ft);ni&&bt&&_t<=De.stableFitRemainingWidth?(vt=!0,Nt=De.stableFitMaxMinimapScale):vt=Bt>pt}if(Ut==="fill"||vt){Wt=!0;const Bt=Dt;ft=Math.min(St*ot,Math.max(1,Math.floor(1/oi))),ni&&bt&&_t<=De.stableFitRemainingWidth&&(Nt=De.stableFitMaxMinimapScale),Dt=Math.min(Nt,Math.max(1,Math.floor(ft/dt))),Dt>Bt&&(ei=Math.min(2,Dt/Bt)),Rt=Dt/ot/ei,pt=Math.ceil(Math.max(jt,Pt+_e+Lt)*ft),ni?(De.stableMinimapLayoutInput=se,De.stableFitRemainingWidth=_t,De.stableFitMaxMinimapScale=Dt):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const si=Math.floor(Qt*Rt),Qe=Math.min(si,Math.max(0,Math.floor((_t-ii-2)*Rt/(It+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Vt=Math.floor(ot*Qe);const Yt=Vt/ot;Vt=Math.floor(Vt*ei);const Ht=Tt?1:2,mt=ai==="left"?0:Ke-Qe-ii;return{renderMinimap:Ht,minimapLeft:mt,minimapWidth:Qe,minimapHeightIsEditorHeight:Wt,minimapIsSampling:qt,minimapScale:Dt,minimapLineHeight:ft,minimapCanvasInnerWidth:Vt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Yt,minimapCanvasOuterHeight:ri}}static computeLayout(se,De){const Ke=De.outerWidth|0,xe=De.outerHeight|0,ot=De.lineHeight|0,Ne=De.lineNumbersDigitCount|0,bt=De.typicalHalfwidthCharacterWidth,St=De.maxDigitWidth,It=De.pixelRatio,xt=De.viewLineCount,Tt=se.get(136),Dt=Tt==="inherit"?se.get(135):Tt,Qt=Dt==="inherit"?se.get(131):Dt,Ut=se.get(134),ai=De.isDominatedByLongLines,ii=se.get(57),_e=se.get(68).renderType!==0,_t=se.get(69),ni=se.get(105),dt=se.get(84),pt=se.get(73),ri=se.get(103),Wt=ri.verticalScrollbarSize,qt=ri.verticalHasArrows,ft=ri.arrowSize,Rt=ri.horizontalScrollbarSize,ei=se.get(43),si=se.get(110)!=="never";let Qe=se.get(66);ei&&si&&(Qe+=16);let Vt=0;if(_e){const kt=Math.max(Ne,_t);Vt=Math.round(kt*St)}let Yt=0;ii&&(Yt=ot*De.glyphMarginDecorationLaneCount);let Ht=0,mt=Ht+Yt,jt=mt+Vt,Pt=jt+Qe;const Lt=Ke-Yt-Vt-Qe;let oi=!1,Gt=!1,Zt=-1;Dt==="inherit"&&ai?(oi=!0,Gt=!0):Qt==="on"||Qt==="bounded"?Gt=!0:Qt==="wordWrapColumn"&&(Zt=Ut);const vt=x.c({outerWidth:Ke,outerHeight:xe,lineHeight:ot,typicalHalfwidthCharacterWidth:bt,pixelRatio:It,scrollBeyondLastLine:ni,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:pt,verticalScrollbarWidth:Wt,viewLineCount:xt,remainingWidth:Lt,isViewportWrapping:Gt},De.memory||new M);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ht+=vt.minimapWidth,mt+=vt.minimapWidth,jt+=vt.minimapWidth,Pt+=vt.minimapWidth);const Nt=Lt-vt.minimapWidth,Bt=Math.max(1,Math.floor((Nt-Wt-2)/bt)),Ft=qt?ft:0;return Gt&&(Zt=Math.max(1,Bt),Qt==="bounded"&&(Zt=Math.min(Zt,Ut))),{width:Ke,height:xe,glyphMarginLeft:Ht,glyphMarginWidth:Yt,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Vt,decorationsLeft:jt,decorationsWidth:Qe,contentLeft:Pt,contentWidth:Nt,minimap:vt,viewportColumn:Bt,isWordWrapMinified:oi,isViewportWrapping:Gt,wrappingColumn:Zt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:Rt,overviewRuler:{top:Ft,width:Wt,height:xe-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=x;class ce extends I{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(se){return g(se,"simple",["simple","advanced"])}compute(se,De,Ke){return De.get(2)===2?"advanced":Ke}}var X;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(X||(e.ShowLightbulbIconMode=X={}));class me extends I{constructor(){const se={enabled:X.OnCode};super(65,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[X.Off,X.OnCode,X.On],default:se.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:g(se.enabled,this.defaultValue.enabled,[X.Off,X.OnCode,X.On])}}}class ae extends I{constructor(){const se={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:p.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends I{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:p.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:g(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),padding:m(De.padding,this.defaultValue.padding)}}}class W extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):i.clampedInt(se,this.defaultValue,0,1e3)}compute(se,De,Ke){return Ke<0?i.clampedInt(-Ke*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ie extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>s.clamp(se,0,150),{markdownDescription:p.localize(66,null)})}compute(se,De,Ke){return se.fontInfo.lineHeight}}class ve extends I{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:se.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:p.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),autohide:m(De.autohide,this.defaultValue.autohide),size:g(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(De.side,this.defaultValue.side,["right","left"]),showSlider:g(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(De.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(De.scale,1,1,3),maxColumn:i.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Pe(ne){return ne==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class le extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{top:i.clampedInt(De.top,0,0,1e3),bottom:i.clampedInt(De.bottom,0,0,1e3)}}}class ue extends I{constructor(){const se={enabled:!0,cycle:!0};super(86,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:p.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:p.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),cycle:m(De.cycle,this.defaultValue.cycle)}}}class oe extends v{constructor(){super(142)}compute(se,De,Ke){return se.pixelRatio}}class K extends I{constructor(){const se={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(82,null),p.localize(83,null),p.localize(84,null)]}];super(89,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:se.strings,description:p.localize(85,null)},comments:{anyOf:De,default:se.comments,description:p.localize(86,null)},other:{anyOf:De,default:se.other,description:p.localize(87,null)}},default:se,markdownDescription:p.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const It=se?"on":"off";return{comments:It,strings:It,other:It}}if(!se||typeof se!="object")return this.defaultValue;const{other:De,comments:Ke,strings:xe}=se,ot=["on","inline","off"];let Ne,bt,St;return typeof De=="boolean"?Ne=De?"on":"off":Ne=g(De,this.defaultValue.other,ot),typeof Ke=="boolean"?bt=Ke?"on":"off":bt=g(Ke,this.defaultValue.comments,ot),typeof xe=="boolean"?St=xe?"on":"off":St=g(xe,this.defaultValue.strings,ot),{other:Ne,comments:bt,strings:St}}}var ee;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class he extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(89,null),p.localize(90,null),p.localize(91,null),p.localize(92,null)],default:"on",description:p.localize(93,null)})}validate(se){let De=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(De=4,Ke=se):se==="interval"?De=3:se==="relative"?De=2:se==="on"?De=1:De=0),{renderType:De,renderFn:Ke}}}function fe(ne){const se=ne.get(98);return se==="editable"?ne.get(91):se!=="on"}class Ae extends I{constructor(){const se=[],De={type:"number",description:p.localize(94,null)};super(102,"rulers",se,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:p.localize(95,null),format:"color-hex"}}}]},default:se,description:p.localize(96,null)})}validate(se){if(Array.isArray(se)){const De=[];for(const Ke of se)if(typeof Ke=="number")De.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const xe=Ke;De.push({column:i.clampedInt(xe.column,0,0,1e4),color:xe.color})}return De.sort((Ke,xe)=>Ke.column-xe.column),De}return this.defaultValue}}class pe extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ce(ne,se){if(typeof ne!="string")return se;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends I{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(97,null),p.localize(98,null),p.localize(99,null)],default:"auto",description:p.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(101,null),p.localize(102,null),p.localize(103,null)],default:"auto",description:p.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:p.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:p.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:p.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:p.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se,Ke=i.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=i.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(De.vertical,this.defaultValue.vertical),horizontal:Ce(De.horizontal,this.defaultValue.horizontal),useShadows:m(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(De.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:i.clampedInt(De.verticalSliderSize,xe,0,1e3),scrollByPage:m(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Fe extends I{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:p.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:p.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:p.localize(115,null)}})}applyUpdate(se,De){let Ke=!1;De.allowedCharacters&&se&&(j.$Rn(se.allowedCharacters,De.allowedCharacters)||(se={...se,allowedCharacters:De.allowedCharacters},Ke=!0)),De.allowedLocales&&se&&(j.$Rn(se.allowedLocales,De.allowedLocales)||(se={...se,allowedLocales:De.allowedLocales},Ke=!0));const xe=super.applyUpdate(se,De);return Ke?new b(xe.newValue,!0):xe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{nonBasicASCII:ge(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,De){if(typeof se!="object"||!se)return De;const Ke={};for(const[xe,ot]of Object.entries(se))ot===!0&&(Ke[xe]=!0);return Ke}}class V extends I{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:p.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(117,null),p.localize(118,null),p.localize(119,null)],description:p.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:p.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:p.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),mode:g(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily)}}}class q extends I{constructor(){const se={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",se,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:se.enabled,description:p.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(124,null),p.localize(125,null),p.localize(126,null)],description:p.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:se.fontFamily,description:p.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:se.backgroundColoring,description:p.localize(129,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),showToolbar:g(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends I{constructor(){const se={enabled:P.$Ls.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$Ls.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:p.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:p.localize(131,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends I{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(132,null),p.localize(133,null),p.localize(134,null)],default:se.bracketPairs,description:p.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(136,null),p.localize(137,null),p.localize(138,null)],default:se.bracketPairsHorizontal,description:p.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:p.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:p.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(142,null),p.localize(143,null),p.localize(144,null)],default:se.highlightActiveIndentation,description:p.localize(145,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{bracketPairs:ge(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(ne,se,De){const Ke=De.indexOf(ne);return Ke===-1?se:De[Ke]}class we extends I{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(146,null),p.localize(147,null)],default:se.insertMode,description:p.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:p.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:p.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:p.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(152,null),p.localize(153,null),p.localize(154,null),p.localize(155,null)],default:se.selectionMode,markdownDescription:p.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:p.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:p.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:p.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:p.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:p.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{insertMode:g(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(De.showIcons,this.defaultValue.showIcons),showStatusBar:m(De.showStatusBar,this.defaultValue.showStatusBar),preview:m(De.preview,this.defaultValue.preview),previewMode:g(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(De.showMethods,this.defaultValue.showMethods),showFunctions:m(De.showFunctions,this.defaultValue.showFunctions),showConstructors:m(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(De.showFields,this.defaultValue.showFields),showVariables:m(De.showVariables,this.defaultValue.showVariables),showClasses:m(De.showClasses,this.defaultValue.showClasses),showStructs:m(De.showStructs,this.defaultValue.showStructs),showInterfaces:m(De.showInterfaces,this.defaultValue.showInterfaces),showModules:m(De.showModules,this.defaultValue.showModules),showProperties:m(De.showProperties,this.defaultValue.showProperties),showEvents:m(De.showEvents,this.defaultValue.showEvents),showOperators:m(De.showOperators,this.defaultValue.showOperators),showUnits:m(De.showUnits,this.defaultValue.showUnits),showValues:m(De.showValues,this.defaultValue.showValues),showConstants:m(De.showConstants,this.defaultValue.showConstants),showEnums:m(De.showEnums,this.defaultValue.showEnums),showEnumMembers:m(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(De.showKeywords,this.defaultValue.showKeywords),showWords:m(De.showWords,this.defaultValue.showWords),showColors:m(De.showColors,this.defaultValue.showColors),showFiles:m(De.showFiles,this.defaultValue.showFiles),showReferences:m(De.showReferences,this.defaultValue.showReferences),showFolders:m(De.showFolders,this.defaultValue.showFolders),showTypeParameters:m(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(De.showSnippets,this.defaultValue.showSnippets),showUsers:m(De.showUsers,this.defaultValue.showUsers),showIssues:m(De.showIssues,this.defaultValue.showIssues)}}}class Te extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(195,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(se.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Xe extends I{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(196,null),p.localize(197,null),p.localize(198,null),p.localize(199,null)],description:p.localize(200,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,De,Ke){return De.get(2)===2?0:Ke}}class tt extends v{constructor(){super(145)}compute(se,De,Ke){const xe=De.get(144);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class nt extends I{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:p.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(203,null),p.localize(204,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),showDropSelector:g(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends I{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:p.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(207,null),p.localize(208,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),showPasteSelector:g(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",Ie="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?Ie:R.$k?ze:st,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ge;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSeparators=130]="wordSeparators",ne[ne.wordWrap=131]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=134]="wordWrapColumn",ne[ne.wordWrapOverride1=135]="wordWrapOverride1",ne[ne.wordWrapOverride2=136]="wordWrapOverride2",ne[ne.wrappingIndent=137]="wrappingIndent",ne[ne.wrappingStrategy=138]="wrappingStrategy",ne[ne.showDeprecated=139]="showDeprecated",ne[ne.inlayHints=140]="inlayHints",ne[ne.editorClassName=141]="editorClassName",ne[ne.pixelRatio=142]="pixelRatio",ne[ne.tabFocusMode=143]="tabFocusMode",ne[ne.layoutInfo=144]="layoutInfo",ne[ne.wrappingInfo=145]="wrappingInfo",ne[ne.defaultColorDecorators=146]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ge||(e.EditorOption=Ge={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(209,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(210,null),""],markdownDescription:p.localize(211,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(212,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",p.localize(213,null))),ariaRequired:Re(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(215,null),p.localize(216,null),""],description:p.localize(217,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(218,null),p.localize(219,null),""],description:p.localize(220,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(221,null),""],description:p.localize(222,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(223,null),""],description:p.localize(224,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(225,null),p.localize(226,null),""],description:p.localize(227,null)})),autoIndent:Re(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[p.localize(228,null),p.localize(229,null),p.localize(230,null),p.localize(231,null),p.localize(232,null)],description:p.localize(233,null)})),automaticLayout:Re(new a(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null),""],description:p.localize(237,null)})),bracketPairColorization:Re(new Q),bracketPairGuides:Re(new J),stickyTabStops:Re(new a(116,"stickyTabStops",!1,{description:p.localize(238,null)})),codeLens:Re(new a(17,"codeLens",!0,{description:p.localize(239,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:p.localize(240,null)})),codeLensFontSize:Re(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(241,null)})),colorDecorators:Re(new a(20,"colorDecorators",!0,{description:p.localize(242,null)})),colorDecoratorActivatedOn:Re(new d(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(243,null),p.localize(244,null),p.localize(245,null)],description:p.localize(246,null)})),colorDecoratorsLimit:Re(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(247,null)})),columnSelection:Re(new a(22,"columnSelection",!1,{description:p.localize(248,null)})),comments:Re(new f),contextmenu:Re(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new a(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(249,null)})),cursorBlinking:Re(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:p.localize(250,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(251,null),p.localize(252,null),p.localize(253,null)],description:p.localize(254,null)})),cursorStyle:Re(new l(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(255,null)})),cursorSurroundingLines:Re(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(256,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(257,null),p.localize(258,null)],markdownDescription:p.localize(259,null)})),cursorWidth:Re(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(260,null)})),disableLayerHinting:Re(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new a(34,"domReadOnly",!1)),dragAndDrop:Re(new a(35,"dragAndDrop",!0,{description:p.localize(261,null)})),emptySelectionClipboard:Re(new z),dropIntoEditor:Re(new nt),stickyScroll:Re(new ae),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(262,null),p.localize(263,null),p.localize(264,null)],description:p.localize(265,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new s(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:p.localize(266,null)})),find:Re(new F),fixedOverflowWidgets:Re(new a(42,"fixedOverflowWidgets",!1)),folding:Re(new a(43,"folding",!0,{description:p.localize(267,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),foldingHighlight:Re(new a(45,"foldingHighlight",!0,{description:p.localize(271,null)})),foldingImportsByDefault:Re(new a(46,"foldingImportsByDefault",!1,{description:p.localize(272,null)})),foldingMaximumRegions:Re(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(273,null)})),unfoldOnClickAfterEndOfLine:Re(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(274,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(275,null)})),fontInfo:Re(new N),fontLigatures2:Re(new T),fontSize:Re(new B),fontWeight:Re(new U),fontVariations:Re(new L),formatOnPaste:Re(new a(55,"formatOnPaste",!1,{description:p.localize(276,null)})),formatOnType:Re(new a(56,"formatOnType",!1,{description:p.localize(277,null)})),glyphMargin:Re(new a(57,"glyphMargin",!0,{description:p.localize(278,null)})),gotoLocation:Re(new Z),hideCursorInOverviewRuler:Re(new a(59,"hideCursorInOverviewRuler",!1,{description:p.localize(279,null)})),hover:Re(new _),inDiffEditor:Re(new a(61,"inDiffEditor",!1)),letterSpacing:Re(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>s.clamp(ne,-5,20),{description:p.localize(280,null)})),lightbulb:Re(new me),lineDecorationsWidth:Re(new W),lineHeight:Re(new ie),lineNumbers:Re(new he),lineNumbersMinChars:Re(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new a(70,"linkedEditing",!1,{description:p.localize(281,null)})),links:Re(new a(71,"links",!0,{description:p.localize(282,null)})),matchBrackets:Re(new d(72,"matchBrackets","always",["always","near","never"],{description:p.localize(283,null)})),minimap:Re(new ve),mouseStyle:Re(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new s(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:p.localize(284,null)})),mouseWheelZoom:Re(new a(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(285,null):p.localize(286,null)})),multiCursorMergeOverlapping:Re(new a(77,"multiCursorMergeOverlapping",!0,{description:p.localize(287,null)})),multiCursorModifier:Re(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[p.localize(288,null),p.localize(289,null)],markdownDescription:p.localize(290,null)})),multiCursorPaste:Re(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(291,null),p.localize(292,null)],markdownDescription:p.localize(293,null)})),multiCursorLimit:Re(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(294,null)})),occurrencesHighlight:Re(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(295,null),p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),overviewRulerBorder:Re(new a(82,"overviewRulerBorder",!0,{description:p.localize(299,null)})),overviewRulerLanes:Re(new i(83,"overviewRulerLanes",3,0,3)),padding:Re(new le),pasteAs:Re(new at),parameterHints:Re(new ue),peekWidgetDefaultFocus:Re(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(300,null),p.localize(301,null)],description:p.localize(302,null)})),definitionLinkOpensInPeek:Re(new a(88,"definitionLinkOpensInPeek",!1,{description:p.localize(303,null)})),quickSuggestions:Re(new K),quickSuggestionsDelay:Re(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(304,null)})),readOnly:Re(new a(91,"readOnly",!1)),readOnlyMessage:Re(new pe),renameOnType:Re(new a(93,"renameOnType",!1,{description:p.localize(305,null),markdownDeprecationMessage:p.localize(306,null)})),renderControlCharacters:Re(new a(94,"renderControlCharacters",!0,{description:p.localize(307,null),restricted:!0})),renderFinalNewline:Re(new d(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(308,null)})),renderLineHighlight:Re(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(309,null)],description:p.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Re(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(311,null)})),renderValidationDecorations:Re(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(312,null),p.localize(313,null),p.localize(314,null),""],description:p.localize(315,null)})),revealHorizontalRightPadding:Re(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new a(101,"roundedSelection",!0,{description:p.localize(316,null)})),rulers:Re(new Ae),scrollbar:Re(new Me),scrollBeyondLastColumn:Re(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(317,null)})),scrollBeyondLastLine:Re(new a(105,"scrollBeyondLastLine",!0,{description:p.localize(318,null)})),scrollPredominantAxis:Re(new a(106,"scrollPredominantAxis",!0,{description:p.localize(319,null)})),selectionClipboard:Re(new a(107,"selectionClipboard",!0,{description:p.localize(320,null),included:R.$k})),selectionHighlight:Re(new a(108,"selectionHighlight",!0,{description:p.localize(321,null)})),selectOnLineNumbers:Re(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(322,null),p.localize(323,null),p.localize(324,null)],description:p.localize(325,null)})),showUnused:Re(new a(111,"showUnused",!0,{description:p.localize(326,null)})),showDeprecated:Re(new a(139,"showDeprecated",!0,{description:p.localize(327,null)})),inlayHints:Re(new re),snippetSuggestions:Re(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(328,null),p.localize(329,null),p.localize(330,null),p.localize(331,null)],description:p.localize(332,null)})),smartSelect:Re(new Te),smoothScrolling:Re(new a(114,"smoothScrolling",!1,{description:p.localize(333,null)})),stopRenderingLineAfter:Re(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new we),inlineSuggest:Re(new V),inlineEdit:Re(new q),inlineCompletionsAccessibilityVerbose:Re(new a(148,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(334,null)})),suggestFontSize:Re(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new a(121,"suggestOnTriggerCharacters",!0,{description:p.localize(337,null)})),suggestSelection:Re(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(338,null),p.localize(339,null),p.localize(340,null)],description:p.localize(341,null)})),tabCompletion:Re(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(342,null),p.localize(343,null),p.localize(344,null)],description:p.localize(345,null)})),tabIndex:Re(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Fe),unusualLineTerminators:Re(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(346,null),p.localize(347,null),p.localize(348,null)],description:p.localize(349,null)})),useShadowDOM:Re(new a(127,"useShadowDOM",!0)),useTabStops:Re(new a(128,"useTabStops",!0,{description:p.localize(350,null)})),wordBreak:Re(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(351,null),p.localize(352,null)],description:p.localize(353,null)})),wordSeparators:Re(new t(130,"wordSeparators",A.$Ms,{description:p.localize(354,null)})),wordWrap:Re(new d(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(355,null),p.localize(356,null),p.localize(357,null),p.localize(358,null)],description:p.localize(359,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new i(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(360,null)})),wordWrapOverride1:Re(new d(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new O),defaultColorDecorators:Re(new a(146,"defaultColorDecorators",!1,{markdownDescription:p.localize(361,null)})),pixelRatio:Re(new oe),tabFocusMode:Re(new a(143,"tabFocusMode",!1,{markdownDescription:p.localize(362,null)})),layoutInfo:Re(new x),wrappingInfo:Re(new tt),wrappingIndent:Re(new Xe),wrappingStrategy:Re(new ce)}}),define(Ee[201],Se([9,10]),function(de,e){return de.create("vs/editor/common/languages",e)}),define(Ee[83],Se([1,0,78,2,174,29,184,201]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$8t=e.$7t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$6t=e.$5t=e.SymbolKinds=e.SymbolTag=e.$3t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$1t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Zt=e.$Yt=e.$Xt=void 0,e.$2t=g,e.$4t=l;class ${constructor(Z,_,Y){this.offset=Z,this.type=_,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Xt=$;class k{constructor(Z,_){this.tokens=Z,this.endState=_,this._tokenizationResultBrand=void 0}}e.$Yt=k;class M{constructor(Z,_){this.tokens=Z,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$Zt=M;var I;(function(U){U[U.Method=0]="Method",U[U.Function=1]="Function",U[U.Constructor=2]="Constructor",U[U.Field=3]="Field",U[U.Variable=4]="Variable",U[U.Class=5]="Class",U[U.Struct=6]="Struct",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Event=10]="Event",U[U.Operator=11]="Operator",U[U.Unit=12]="Unit",U[U.Value=13]="Value",U[U.Constant=14]="Constant",U[U.Enum=15]="Enum",U[U.EnumMember=16]="EnumMember",U[U.Keyword=17]="Keyword",U[U.Text=18]="Text",U[U.Color=19]="Color",U[U.File=20]="File",U[U.Reference=21]="Reference",U[U.Customcolor=22]="Customcolor",U[U.Folder=23]="Folder",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue",U[U.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var b;(function(U){const Z=new Map;Z.set(0,u.$Gj.symbolMethod),Z.set(1,u.$Gj.symbolFunction),Z.set(2,u.$Gj.symbolConstructor),Z.set(3,u.$Gj.symbolField),Z.set(4,u.$Gj.symbolVariable),Z.set(5,u.$Gj.symbolClass),Z.set(6,u.$Gj.symbolStruct),Z.set(7,u.$Gj.symbolInterface),Z.set(8,u.$Gj.symbolModule),Z.set(9,u.$Gj.symbolProperty),Z.set(10,u.$Gj.symbolEvent),Z.set(11,u.$Gj.symbolOperator),Z.set(12,u.$Gj.symbolUnit),Z.set(13,u.$Gj.symbolValue),Z.set(15,u.$Gj.symbolEnum),Z.set(14,u.$Gj.symbolConstant),Z.set(15,u.$Gj.symbolEnum),Z.set(16,u.$Gj.symbolEnumMember),Z.set(17,u.$Gj.symbolKeyword),Z.set(27,u.$Gj.symbolSnippet),Z.set(18,u.$Gj.symbolText),Z.set(19,u.$Gj.symbolColor),Z.set(20,u.$Gj.symbolFile),Z.set(21,u.$Gj.symbolReference),Z.set(22,u.$Gj.symbolCustomColor),Z.set(23,u.$Gj.symbolFolder),Z.set(24,u.$Gj.symbolTypeParameter),Z.set(25,u.$Gj.account),Z.set(26,u.$Gj.issues);function _(ce){let X=Z.get(ce);return X||(console.info("No codicon found for CompletionItemKind "+ce),X=u.$Gj.symbolProperty),X}U.toIcon=_;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function x(ce,X){let me=Y.get(ce);return typeof me>"u"&&!X&&(me=9),me}U.fromString=x})(b||(e.CompletionItemKinds=b={}));var E;(function(U){U[U.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var v;(function(U){U[U.None=0]="None",U[U.KeepWhitespace=1]="KeepWhitespace",U[U.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var c;(function(U){U[U.Word=0]="Word",U[U.Line=1]="Line",U[U.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var m;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var a;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(a||(e.InlineCompletionTriggerKind=a={}));class n{constructor(Z,_,Y,x){this.range=Z,this.text=_,this.completionKind=Y,this.isSnippetText=x}equals(Z){return P.$bt.lift(this.range).equalsRange(Z.range)&&this.text===Z.text&&this.completionKind===Z.completionKind&&this.isSnippetText===Z.isSnippetText}}e.$1t=n;var i;(function(U){U[U.Invoke=1]="Invoke",U[U.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function g(U){return U&&j.URI.isUri(U.uri)&&P.$bt.isIRange(U.range)&&(P.$bt.isIRange(U.originSelectionRange)||P.$bt.isIRange(U.targetSelectionRange))}var d;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$3t={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function l(U,Z){return(0,p.localize)(26,null,U,e.$3t[Z])}var o;(function(U){U[U.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var h;(function(U){const Z=new Map;Z.set(0,u.$Gj.symbolFile),Z.set(1,u.$Gj.symbolModule),Z.set(2,u.$Gj.symbolNamespace),Z.set(3,u.$Gj.symbolPackage),Z.set(4,u.$Gj.symbolClass),Z.set(5,u.$Gj.symbolMethod),Z.set(6,u.$Gj.symbolProperty),Z.set(7,u.$Gj.symbolField),Z.set(8,u.$Gj.symbolConstructor),Z.set(9,u.$Gj.symbolEnum),Z.set(10,u.$Gj.symbolInterface),Z.set(11,u.$Gj.symbolFunction),Z.set(12,u.$Gj.symbolVariable),Z.set(13,u.$Gj.symbolConstant),Z.set(14,u.$Gj.symbolString),Z.set(15,u.$Gj.symbolNumber),Z.set(16,u.$Gj.symbolBoolean),Z.set(17,u.$Gj.symbolArray),Z.set(18,u.$Gj.symbolObject),Z.set(19,u.$Gj.symbolKey),Z.set(20,u.$Gj.symbolNull),Z.set(21,u.$Gj.symbolEnumMember),Z.set(22,u.$Gj.symbolStruct),Z.set(23,u.$Gj.symbolEvent),Z.set(24,u.$Gj.symbolOperator),Z.set(25,u.$Gj.symbolTypeParameter);function _(Y){let x=Z.get(Y);return x||(console.info("No codicon found for SymbolKind "+Y),x=u.$Gj.symbolProperty),x}U.toIcon=_})(h||(e.SymbolKinds=h={}));class f{static asEditOperation(Z){return R.$ct.replace(P.$bt.lift(Z.range),Z.text)}}e.$5t=f;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(Z){switch(Z){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(Z)}constructor(Z){this.value=Z}}e.$6t=D;var w;(function(U){U[U.AIGenerated=1]="AIGenerated"})(w||(e.NewSymbolNameTag=w={}));var S;(function(U){function Z(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}U.is=Z})(S||(e.Command=S={}));var y;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var C;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(C||(e.CommentThreadState=C={}));var O;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var z;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var F;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(F||(e.CommentState=F={}));var T;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class L{constructor(Z){this.b=Z,this.a=null}dispose(){this.a&&this.a.then(Z=>{Z&&Z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$7t=L,e.$8t=new A.$Mt;var N;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}));var B;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(Ee[202],Se([9,10]),function(de,e){return de.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[203],Se([9,10]),function(de,e){return de.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[204],Se([9,10]),function(de,e){return de.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[205],Se([9,10]),function(de,e){return de.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[206],Se([9,10]),function(de,e){return de.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[207],Se([9,10]),function(de,e){return de.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[208],Se([9,10]),function(de,e){return de.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[209],Se([9,10]),function(de,e){return de.create("vs/platform/files/common/files",e)}),define(Ee[210],Se([9,10]),function(de,e){return de.create("vs/platform/files/common/io",e)}),define(Ee[211],Se([9,10]),function(de,e){return de.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[212],Se([9,10]),function(de,e){return de.create("vs/platform/log/common/log",e)}),define(Ee[213],Se([9,10]),function(de,e){return de.create("vs/platform/markers/common/markers",e)}),define(Ee[214],Se([9,10]),function(de,e){return de.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[215],Se([9,10]),function(de,e){return de.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[216],Se([9,10]),function(de,e){return de.create("vs/platform/workspace/common/workspace",e)}),define(Ee[217],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ee[218],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[219],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[220],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[221],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[222],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[223],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[224],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[225],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[226],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[227],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[228],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[229],Se([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[230],Se([9,10]),function(de,e){return de.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[231],Se([9,10]),function(de,e){return de.create("vs/workbench/common/configuration",e)}),define(Ee[232],Se([9,10]),function(de,e){return de.create("vs/workbench/common/editor",e)}),define(Ee[233],Se([9,10]),function(de,e){return de.create("vs/workbench/common/views",e)}),define(Ee[234],Se([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[235],Se([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[236],Se([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[237],Se([9,10]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[238],Se([9,10]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[239],Se([9,10]),function(de,e){return de.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[240],Se([9,10]),function(de,e){return de.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[241],Se([9,10]),function(de,e){return de.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[242],Se([9,10]),function(de,e){return de.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[243],Se([9,10]),function(de,e){return de.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[244],Se([1,0,13,204]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var R;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(R||(e.TokenType=R={}));function P(...k){switch(k.length){case 1:return(0,j.localize)(0,null,k[0]);case 2:return(0,j.localize)(1,null,k[0],k[1]);case 3:return(0,j.localize)(2,null,k[0],k[1],k[2]);default:return}}const A=(0,j.localize)(3,null),p=(0,j.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(M=>M.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const I=this.d,b=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:b};this.g.push({offset:I,lexeme:b,additionalInfo:M}),this.f.push(E)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const I=this.c.substring(this.d,this.e),b=$.b.get(I);b?this.k(b):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,I=!1,b=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(p);return}const v=this.c.charCodeAt(M);if(I)I=!1;else if(v===47&&!b){M++;break}else v===91?b=!0:v===92?I=!0:v===93&&(b=!1);M++}for(;M<this.c.length&&$.a.has(this.c.charCodeAt(M));)M++;this.e=M;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=$}),define(Ee[245],Se([1,0,23,40,207,397]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=$,e.$sp=k,e.$tp=M,e.$up=I,e.$vp=b,e.$wp=E,e.$xp=v;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||A.test(a)}function k(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function M(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,r=a.minorBase;let s=a.minorMustEqual;const t=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(n===0||(s=!1),g=!1);let d=0;if(a.preRelease){const l=p.exec(a.preRelease);if(l){const[,o,h,f]=l;d=Date.UTC(Number(o),Number(h)-1,Number(f))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:d}}function I(a,n,i){let r;typeof a=="string"?r=M(k(a)):r=a;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=M(k(i)):t=i,!r||!t)return!1;const g=r.majorBase,d=r.minorBase,l=r.patchBase;let o=t.majorBase,h=t.minorBase,f=t.patchBase;const D=t.notBefore;let w=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?g>o?!0:g<o?!1:d>h?!0:d<h||s&&s<D?!1:l>=f:(g===1&&o===0&&(!w||!S||!y)&&(o=1,h=0,f=0,w=!0,S=!1,y=!1),g<o?!1:g>o?!w:d<h?!1:d>h?!S:l<f?!1:l>f?!y:!(s&&s<D))}function b(a,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([j.default.Error,R.localize(0,null)]),t;if(typeof r.name!="string")return t.push([j.default.Error,R.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([j.default.Error,R.localize(2,null,"version")]),t;if(!r.engines)return t.push([j.default.Error,R.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([j.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([j.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([j.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([j.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([j.default.Warning,R.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([j.default.Error,R.localize(9,null,"main")]),t;{const l=(0,u.$Ug)(i,r.main);(0,u.$Og)(l,i)||t.push([j.default.Warning,R.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([j.default.Error,R.localize(11,null,"browser")]),t;{const l=(0,u.$Ug)(i,r.browser);(0,u.$Og)(l,i)||t.push([j.default.Warning,R.localize(12,null,l.path,i.path)])}}if(!P.valid(r.version))return t.push([j.default.Error,R.localize(13,null)]),t;const g=[];if(!E(a,n,r,s,g))for(const l of g)t.push([j.default.Error,l]);return t}function E(a,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:c(a,n,i.engines.vscode,s)}function v(a,n,i){return a==="*"||c(n,i,a)}function c(a,n,i,r=[]){const s=M(k(i));if(!s)return r.push(R.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(R.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(R.localize(16,null,i)),!1;return I(a,n,s)?!0:(r.push(R.localize(17,null,a,i)),!1)}function m(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(Ee[106],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class u{constructor(R,P=[],A=!1){this.ctor=R,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$ei=u}),define(Ee[84],Se([1,0,106]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$fs=P,e.$gs=A;const j=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function P(p,$,k){$ instanceof u.$ei||($=new u.$ei($,[],!!k)),j.push([p,$])}function A(){return j}}),define(Ee[246],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;class u{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Vq=u;class j{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const p=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(A);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const p of this.a.values())p.outgoing.delete(A),p.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let p=this.a.get(A);return p||(p=new u(A,P),this.a.set(A,p)),p}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,p]of this.a)P.push(`${A}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const p=new Set([P]),$=this.c(A,p);if($)return $}}c(P,A){for(const[p,$]of P.outgoing){if(A.has(p))return[...A,p].join(" -> ");A.add(p);const k=this.c($,A);if(k)return k;A.delete(p)}}}e.$Wq=j}),define(Ee[5],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=R,e.$ii=P;var u;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function p($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=p})(u||(e._util=u={})),e.$gi=R("instantiationService");function j(A,p,$){p[u.DI_TARGET]===p?p[u.DI_DEPENDENCIES].push({id:A,index:$}):(p[u.DI_DEPENDENCIES]=[{id:A,index:$}],p[u.DI_TARGET]=p)}function R(A){if(u.serviceIds.has(A))return u.serviceIds.get(A);const p=function($,k,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");j(p,$,M)};return p.toString=()=>A,u.serviceIds.set(A,p),p}function P(A){return A}}),define(Ee[53],Se([1,0,18,2,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=P,e.$Pi=A,e.$Qi=$,e.$Ri=k,e.$Si=M,e.$Ti=I,e.$Ui=b,e.$Vi=v,e.$Wi=c,e.$Xi=m,e.$Ni=(0,R.$hi)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof j.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof j.URI)}var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function M(a,n){const i=Object.create(null);for(const r in a)I(i,r,a[r],n);return i}function I(a,n,i,r){const s=n.split("."),t=s.pop();let g=a;for(let d=0;d<s.length;d++){const l=s[d];let o=g[l];switch(typeof o){case"undefined":o=g[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(o)}`);return}g=o}if(typeof g=="object"&&g!==null)try{g[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(g)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(g)}`)}function b(a,n){const i=n.split(".");E(a,i)}function E(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const r=a[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,n),Object.keys(r).length===0&&delete a[i])}}function v(a,n,i){function r(g,d){let l=g;for(const o of d){if(typeof l!="object"||l===null)return;l=l[o]}return l}const s=n.split("."),t=r(a,s);return typeof t>"u"?i:t}function c(a,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in a?u.$Wf(a[r])&&u.$Wf(n[r])?c(a[r],n[r],i):i&&(a[r]=n[r]):a[r]=n[r])})}function m(a){return a.replace(/[\[\]]/g,"")}}),define(Ee[41],Se([1,0,11,14,244,5,203,13]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=k,e.$gj=g,e.$hj=d,e.$Aj=X;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",u.$j),$.set("isLinux",u.$k),$.set("isWindows",u.$i),$.set("isWeb",u.$o),$.set("isMacNative",u.$j&&!u.$o),$.set("isEdge",u.$H),$.set("isFirefox",u.$F),$.set("isChrome",u.$E),$.set("isSafari",u.$G);function k(re,W){if($.get(re)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(re,W)}const M=Object.prototype.hasOwnProperty;var I;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const b={regexParsingWithErrorRecovery:!0},E=(0,A.localize)(0,null),v=(0,A.localize)(1,null),c=(0,A.localize)(2,null),m=(0,A.localize)(3,null),a=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),r=(0,A.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=b){this.k=W,this.d=new R.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ve=this.D(),Pe=ve.type===17?n:void 0;throw this.h.push({message:a,offset:ve.offset,lexeme:R.$cj.getLexeme(ve),additionalInfo:Pe}),s.c}return ie}catch(ie){if(ie!==s.c)throw ie;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ie=this.o();W.push(ie)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ie=this.s();W.push(ie)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=W.lexeme;if(this.z(),this.y(9)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==10)throw this.B("REGEX",Pe);const le=Pe.lexeme,ue=le.lastIndexOf("/"),oe=ue===le.length-1?void 0:this.w(le.substring(ue+1));let K;try{K=new RegExp(le.substring(1,ue),oe)}catch{throw this.B("REGEX",Pe)}return N.create(ie,K)}switch(Pe.type){case 10:case 19:{const le=[Pe.lexeme];this.z();let ue=this.D(),oe=0;for(let Ae=0;Ae<Pe.lexeme.length;Ae++)Pe.lexeme.charCodeAt(Ae)===40?oe++:Pe.lexeme.charCodeAt(Ae)===41&&oe--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Ae=0;Ae<ue.lexeme.length;Ae++)ue.lexeme.charCodeAt(Ae)===40?oe++:Pe.lexeme.charCodeAt(Ae)===41&&oe--}if(oe<0)break;le.push(R.$cj.getLexeme(ue)),this.z(),ue=this.D()}const K=le.join(""),ee=K.lastIndexOf("/"),he=ee===K.length-1?void 0:this.w(K.substring(ee+1));let fe;try{fe=new RegExp(K.substring(1,ee),he)}catch{throw this.B("REGEX",Pe)}return t.regex(ie,fe)}case 18:{const le=Pe.lexeme;this.z();let ue=null;if(!(0,j.$Ue)(le)){const oe=le.indexOf("/"),K=le.lastIndexOf("/");if(oe!==K&&oe>=0){const ee=le.slice(oe+1,K),he=le[K+1]==="i"?"i":"";try{ue=new RegExp(ee,he)}catch{throw this.B("REGEX",Pe)}}}if(ue===null)throw this.B("REGEX",Pe);return N.create(ie,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Pe=this.u();return t.notIn(ie,Pe)}switch(this.D().type){case 3:{this.z();const Pe=this.u();if(this.x().type===18)return t.equals(ie,Pe);switch(Pe){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Pe)}}case 4:{this.z();const Pe=this.u();if(this.x().type===18)return t.notEquals(ie,Pe);switch(Pe){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Pe)}}case 5:return this.z(),T.create(ie,this.u());case 6:return this.z(),L.create(ie,this.u());case 7:return this.z(),z.create(ie,this.u());case 8:return this.z(),F.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:W.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ie){if(this.C(W))return this.z();throw this.B(ie,this.D())}B(W,ie,ve){const Pe=(0,A.localize)(8,null,W,R.$cj.getLexeme(ie)),le=ie.offset,ue=R.$cj.getLexeme(ie);return this.h.push({message:Pe,offset:le,lexeme:ue,additionalInfo:ve}),s.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=s;class t{static false(){return o.INSTANCE}static true(){return h.INSTANCE}static has(W){return f.create(W)}static equals(W,ie){return D.create(W,ie)}static notEquals(W,ie){return y.create(W,ie)}static regex(W,ie){return N.create(W,ie)}static in(W,ie){return w.create(W,ie)}static notIn(W,ie){return S.create(W,ie)}static not(W){return C.create(W)}static and(...W){return Z.create(W,null,!0)}static or(...W){return _.create(W,null,!0)}static greater(W,ie){return z.create(W,ie)}static greaterEquals(W,ie){return F.create(W,ie)}static smaller(W,ie){return T.create(W,ie)}static smallerEquals(W,ie){return L.create(W,ie)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$fj=t;function g(re){const W=new s({regexParsingWithErrorRecovery:!1});return re.map(ie=>(W.parse(ie),W.lexingErrors.length>0?W.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,A.localize)(9,null,ve.additionalInfo):(0,A.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function d(re,W){const ie=re?re.substituteConstants():void 0,ve=W?W.substituteConstants():void 0;return!ie&&!ve?!0:!ie||!ve?!1:ie.equals(ve)}function l(re,W){return re.cmp(W)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return h.INSTANCE}}e.$ij=o;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return o.INSTANCE}}e.$jj=h;class f{static create(W,ie=null){const ve=$.get(W);return typeof ve=="boolean"?ve?h.INSTANCE:o.INSTANCE:new f(W,ie)}constructor(W,ie){this.key=W,this.c=ie,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:x(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=$.get(this.key);return typeof W=="boolean"?W?h.INSTANCE:o.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$kj=f;class D{static create(W,ie,ve=null){if(typeof ie=="boolean")return ie?f.create(W,ve):C.create(W,ve);const Pe=$.get(W);return typeof Pe=="boolean"?ie===(Pe?"true":"false")?h.INSTANCE:o.INSTANCE:new D(W,ie,ve)}constructor(W,ie,ve){this.c=W,this.d=ie,this.f=ve,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?h.INSTANCE:o.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$lj=D;class w{static create(W,ie){return new w(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.f),ve=W.getValue(this.d);return Array.isArray(ie)?ie.includes(ve):typeof ve=="string"&&typeof ie=="object"&&ie!==null?M.call(ie,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$mj=w;class S{static create(W,ie){return new S(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=11,this.c=w.create(W,ie)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=S;class y{static create(W,ie,ve=null){if(typeof ie=="boolean")return ie?C.create(W,ve):f.create(W,ve);const Pe=$.get(W);return typeof Pe=="boolean"?ie===(Pe?"true":"false")?o.INSTANCE:h.INSTANCE:new y(W,ie,ve)}constructor(W,ie,ve){this.c=W,this.d=ie,this.f=ve,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?o.INSTANCE:h.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$oj=y;class C{static create(W,ie=null){const ve=$.get(W);return typeof ve=="boolean"?ve?o.INSTANCE:h.INSTANCE:new C(W,ie)}constructor(W,ie){this.c=W,this.d=ie,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:x(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=$.get(this.c);return typeof W=="boolean"?W?o.INSTANCE:h.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$pj=C;function O(re,W){if(typeof re=="string"){const ie=parseFloat(re);isNaN(ie)||(re=ie)}return typeof re=="string"||typeof re=="number"?W(re):o.INSTANCE}class z{static create(W,ie,ve=null){return O(ie,Pe=>new z(W,Pe,ve))}constructor(W,ie,ve){this.c=W,this.d=ie,this.f=ve,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$qj=z;class F{static create(W,ie,ve=null){return O(ie,Pe=>new F(W,Pe,ve))}constructor(W,ie,ve){this.c=W,this.d=ie,this.f=ve,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$rj=F;class T{static create(W,ie,ve=null){return O(ie,Pe=>new T(W,Pe,ve))}constructor(W,ie,ve){this.c=W,this.d=ie,this.f=ve,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$sj=T;class L{static create(W,ie,ve=null){return O(ie,Pe=>new L(W,Pe,ve))}constructor(W,ie,ve){this.c=W,this.d=ie,this.f=ve,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$tj=L;class N{static create(W,ie){return new N(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ie=this.f?this.f.source:"",ve=W.f?W.f.source:"";return ie<ve?-1:ie>ve?1:0}equals(W){if(W.type===this.type){const ie=this.f?this.f.source:"",ve=W.f?W.f.source:"";return this.d===W.d&&ie===ve}return!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$uj=N;class B{static create(W){return new B(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new B(this.c.map(W))}negate(){return this.c}}e.$vj=B;function U(re){let W=null;for(let ie=0,ve=re.length;ie<ve;ie++){const Pe=re[ie].substituteConstants();if(re[ie]!==Pe&&W===null){W=[];for(let le=0;le<ie;le++)W[le]=re[le]}W!==null&&(W[ie]=Pe)}return W===null?re:W}class Z{static create(W,ie,ve){return Z.d(W,ie,ve)}constructor(W,ie){this.expr=W,this.c=ie,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const Pe=l(this.expr[ie],W.expr[ie]);if(Pe!==0)return Pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=U(this.expr);return W===this.expr?this:Z.create(W,this.c,!1)}evaluate(W){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].evaluate(W))return!1;return!0}static d(W,ie,ve){const Pe=[];let le=!1;for(const ue of W)if(ue){if(ue.type===1){le=!0;continue}if(ue.type===0)return o.INSTANCE;if(ue.type===6){Pe.push(...ue.expr);continue}Pe.push(ue)}if(Pe.length===0&&le)return h.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(l);for(let ue=1;ue<Pe.length;ue++)Pe[ue-1].equals(Pe[ue])&&(Pe.splice(ue,1),ue--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const ue=Pe[Pe.length-1];if(ue.type!==9)break;Pe.pop();const oe=Pe.pop(),K=Pe.length===0,ee=_.create(ue.expr.map(he=>Z.create([he,oe],null,ve)),null,K);ee&&(Pe.push(ee),Pe.sort(l))}if(Pe.length===1)return Pe[0];if(ve){for(let ue=0;ue<Pe.length;ue++)for(let oe=ue+1;oe<Pe.length;oe++)if(Pe[ue].negate().equals(Pe[oe]))return o.INSTANCE;if(Pe.length===1)return Pe[0]}return new Z(Pe,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new Z(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());this.c=_.create(W,this,!0)}return this.c}}e.$wj=Z;class _{static create(W,ie,ve){return _.d(W,ie,ve)}constructor(W,ie){this.expr=W,this.c=ie,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const Pe=l(this.expr[ie],W.expr[ie]);if(Pe!==0)return Pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=U(this.expr);return W===this.expr?this:_.create(W,this.c,!1)}evaluate(W){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(this.expr[ie].evaluate(W))return!0;return!1}static d(W,ie,ve){let Pe=[],le=!1;if(W){for(let ue=0,oe=W.length;ue<oe;ue++){const K=W[ue];if(K){if(K.type===0){le=!0;continue}if(K.type===1)return h.INSTANCE;if(K.type===9){Pe=Pe.concat(K.expr);continue}Pe.push(K)}}if(Pe.length===0&&le)return o.INSTANCE;Pe.sort(l)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let ue=1;ue<Pe.length;ue++)Pe[ue-1].equals(Pe[ue])&&(Pe.splice(ue,1),ue--);if(Pe.length===1)return Pe[0];if(ve){for(let ue=0;ue<Pe.length;ue++)for(let oe=ue+1;oe<Pe.length;oe++)if(Pe[ue].negate().equals(Pe[oe]))return h.INSTANCE;if(Pe.length===1)return Pe[0]}return new _(Pe,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new _(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());for(;W.length>1;){const ie=W.shift(),ve=W.shift(),Pe=[];for(const le of ae(ie))for(const ue of ae(ve))Pe.push(Z.create([le,ue],null,!1));W.unshift(_.create(Pe,null,!1))}this.c=_.create(W,this,!0)}return this.c}}e.$xj=_;class Y extends f{static{this.d=[]}static all(){return Y.d.values()}constructor(W,ie,ve){super(W,null),this.f=ie,typeof ve=="object"?Y.d.push({...ve,key:W}):ve!==!0&&Y.d.push({key:W,description:ve,type:ie!=null?typeof ie:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return D.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$yj=Y,e.$zj=(0,P.$hi)("contextKeyService");function x(re,W){return re<W?-1:re>W?1:0}function ce(re,W,ie,ve){return re<ie?-1:re>ie?1:W<ve?-1:W>ve?1:0}function X(re,W){if(re.type===0||W.type===1)return!0;if(re.type===9)return W.type===9?me(re.expr,W.expr):!1;if(W.type===9){for(const ie of W.expr)if(X(re,ie))return!0;return!1}if(re.type===6){if(W.type===6)return me(W.expr,re.expr);for(const ie of re.expr)if(X(ie,W))return!0;return!1}return re.equals(W)}function me(re,W){let ie=0,ve=0;for(;ie<re.length&&ve<W.length;){const Pe=re[ie].cmp(W[ve]);if(Pe<0)return!1;Pe===0&&ie++,ve++}return ie===re.length}function ae(re){return re.type===9?re.expr:[re]}}),define(Ee[247],Se([1,0,23,40,205,5,103,11,24]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$rw=e.$qw=e.$pw=void 0,e.$sw=E,e.$tw=v,e.$pw=(0,P.$hi)("dialogService");var k;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(k||(k={}));class M{a(m){return this.d(m,k.Confirmation)}b(m){return this.d(m,k.Prompt)}c(m){return this.d(m,k.Input)}d(m,a){const n=[];switch(a){case k.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,R.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,R.localize)(1,null));break}case k.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,R.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,R.localize)(3,null))),n.length===0&&n.push((0,R.localize)(4,null));break}case k.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,R.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,R.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===j.default.Info?"info":m===j.default.Error?"error":m===j.default.Warning?"warning":"none"}f(m,a,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[a]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$qw=M,e.$rw=(0,P.$hi)("fileDialogService");var I;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const b=10;function E(c){const m=[];return m.push(...c.slice(0,b).map(a=>typeof a=="string"?a:(0,u.$Rg)(a))),c.length>b&&(c.length-b===1?m.push((0,R.localize)(7,null)):m.push((0,R.localize)(8,null,c.length-b))),m.push(""),m.join(`
`)}function v(c,m){const a=(0,$.$Nn)(c);let n=(a.buttons??[]).map(t=>(0,A.$mw)(t)),i=(c.buttons||[]).map((t,g)=>g),r=0,s=a.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const g=i[s];i.splice(s,1),i.splice(1,0,g),s=1}p.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(p.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const g=i[s];i.splice(s,1),i.push(g),s=n.length-1}}return a.buttons=n,a.defaultId=r,a.cancelId=s,a.noLink=!0,a.title=a.title||m.nameLong,{options:a,buttonIndeces:i}}}),define(Ee[136],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,u.$hi)("environmentService"),e.$pi=(0,u.$ii)(e.$oi)}),define(Ee[137],Se([1,0,206,5]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=R,e.$Lo=P,e.$Mo=A,e.$No=p,e.$Oo=$,e.$Po=k,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(i,r){return r==="web"&&!i.includes("web")}function $(i,r,s){return p(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var M;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var b;(function(i){i.Install="install",i.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Qo=(0,j.$hi)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var c;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$Ro=m;var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$So=n,e.$To=(0,j.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,j.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,j.$hi)("IExtensionTipsService"),e.$Yo=(0,u.localize2)(0,"Extensions"),e.$Zo=(0,u.localize2)(1,"Preferences")}),define(Ee[248],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=e.$i5b=void 0,e.$i5b=(0,u.$hi)("externalTerminal"),e.$j5b="Terminal.app"}),define(Ee[249],Se([1,0,52,54,15,17,11,102,31,105,208,248]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=e.$mac=e.$lac=void 0;const b=M.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,k.$_l(),t)}spawnTerminal(s,t,g,d){const l=t.windowsExec||v.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const o=P.$oc(l,".exe").toLowerCase();if(o==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),o==="wt"&&h.push("-d ."),new Promise((f,D)=>{const w=a(process),S=s.spawn(g,h,{cwd:d,env:w,detached:!0});S.on("error",D),S.on("exit",()=>f())})}async runInTerminal(s,t,g,d,l){const o="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),h=await v.f();return new Promise((f,D)=>{const w=`"${t} - ${b}"`,S=`"${g.join('" "')}" & pause`,y=Object.assign({},a(process),d);Object.keys(y).filter(T=>y[T]===null).forEach(T=>delete y[T]);const C={cwd:t,env:y,windowsVerbatimArguments:!0};let O,z;P.$oc(o,".exe")==="wt"?(O=o,z=["-d",".",v.b,"/c",S]):h?(O=h,z=["-d",".",o,"/c",S]):(O=v.b,z=["/c","start",w,"/wait",o,"/c",`"${S}"`]),u.spawn(O,z,C).on("error",T=>{D(n(T))}),f(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await k.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$lac=v,Je([j.$Lh],v,"f",null);class c extends E{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,g,d,l){const o=l.osxExec||I.$j5b;return new Promise((h,f)=>{if(o===I.$j5b||o==="iTerm.app"){const D=o===I.$j5b?"TerminalHelper":"iTermHelper",S=[R.$Bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",s||b,"-w",t];for(const O of g)S.push("-a"),S.push(O);if(d){const O=Object.assign({},a(process),d);for(const z in O){const F=O[z];F===null?(S.push("-u"),S.push(z)):(S.push("-e"),S.push(`${z}=${F}`))}}let y="";const C=u.spawn(c.b,S);C.on("error",O=>{f(n(O))}),C.stderr.on("data",O=>{y+=O.toString()}),C.on("exit",O=>{if(O===0)h(void 0);else if(y){const z=y.split(`
`,1);f(new Error(z[0]))}else f(new Error(M.localize(1,null,D,O)))})}else f(new Error(M.localize(2,null,o)))})}spawnTerminal(s,t,g){const d=t.osxExec||I.$j5b;return new Promise((l,o)=>{const h=["-a",d];g&&h.push(g);const f=a(process),D=s.spawn("/usr/bin/open",h,{cwd:g,env:f});D.on("error",o),D.on("exit",()=>l())})}}e.$mac=c;class m extends E{static{this.b=M.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,g,d,l){const o=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,f)=>{const D=[];o.then(w=>{w.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const S=`${i(g)}; echo; read -p "${m.b}" -n1;`;D.push(`''${S}''`);const y=Object.assign({},a(process),d);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const C={cwd:t,env:y};let O="";const z=u.spawn(w,D,C);z.on("error",F=>{f(n(F))}),z.stderr.on("data",F=>{O+=F.toString()}),z.on("exit",F=>{if(F===0)h(void 0);else if(O){const T=O.split(`
`,1);f(new Error(T[0]))}else f(new Error(M.localize(4,null,w,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!A.$k)m.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,g){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,o)=>{d.then(h=>{const f=a(process),D=s.spawn(h,[],{cwd:g,env:f});D.on("error",o),D.on("exit",()=>l())})})}}e.$nac=m;function a(r){const s={...r.env};return(0,p.$0l)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(M.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(Ee[32],Se([1,0,77,17,14,18,2,209,5,11,15,45]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=b,e.$Pk=c,e.$Qk=a,e.$Rk=n,e.$Sk=i,e.$Tk=r,e.$Uk=s,e.$Vk=t,e.$Wk=g,e.$Xk=d,e.$Yk=l,e.$1k=f,e.$2k=D,e.$3k=w,e.$4k=S,e.$5k=y,e.$8k=T,e.$hl=_,e.$il=Y,e.$kl=ce,e.$Nk=(0,$.$hi)("fileService");function b(X){return X.create===!0}var E;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var v;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function c(X){const me=X;return!!me&&typeof me.onDidChange=="function"}var m;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function a(X){return!!(X.capabilities&2)}function n(X){return!!(X.capabilities&8)}function i(X){return!!(X.capabilities&131072)}function r(X){return!!(X.capabilities&4)}function s(X){return!!(X.capabilities&16)}function t(X){return a(X)?!!(X.capabilities&16384):!1}function g(X){return a(X)?!!(X.capabilities&32768):!1}function d(X){return!!(X.capabilities&65536)}function l(X){return!!(X.capabilities&2048)}var o;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class h extends Error{static create(me,ae){const re=new h(me.toString(),ae);return w(re,ae),re}constructor(me,ae){super(me),this.code=ae}}e.$Zk=h;function f(X,me){return h.create(X,me)}function D(X){return X||f((0,p.localize)(0,null),o.Unknown)}function w(X,me){return X.name=me?`${me} (FileSystemError)`:"FileSystemError",X}function S(X){if(!X)return o.Unknown;if(X instanceof h)return X.code;const me=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!me)return o.Unknown;switch(me[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function y(X){if(X instanceof L)return X.fileOperationResult;switch(S(X)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var C;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class O{constructor(me,ae,re){this.resource=me,this.operation=ae,this.target=re}isOperation(me){return this.operation===me}}e.$6k=O;var z;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class F{static{this.a=null}constructor(me,ae){this.c=ae,this.b=void 0,this.d=new I.$V(()=>{const re=u.$ni.forUris(()=>this.c);return re.fill(this.rawAdded.map(W=>[W,!0])),re}),this.f=new I.$V(()=>{const re=u.$ni.forUris(()=>this.c);return re.fill(this.rawUpdated.map(W=>[W,!0])),re}),this.g=new I.$V(()=>{const re=u.$ni.forUris(()=>this.c);return re.fill(this.rawDeleted.map(W=>[W,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of me){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==F.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(me,...ae){return this.h(me,{includeChildren:!1},...ae)}affects(me,...ae){return this.h(me,{includeChildren:!0},...ae)}h(me,ae,...re){if(!me)return!1;const W=re.length>0;return!!((!W||re.includes(1))&&(this.d.value.get(me)||ae.includeChildren&&this.d.value.findSuperstr(me))||(!W||re.includes(0))&&(this.f.value.get(me)||ae.includeChildren&&this.f.value.findSuperstr(me))||(!W||re.includes(2))&&(this.g.value.findSubstr(me)||ae.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}e.$7k=F;function T(X,me,ae){return!X||!me||X===me||me.length>X.length?!1:(me.charAt(me.length-1)!==j.sep&&(me+=j.sep),ae?(0,R.$mf)(X,me):X.indexOf(me)===0)}class L extends Error{constructor(me,ae,re){super(me),this.fileOperationResult=ae,this.options=re}}e.$9k=L;class N extends L{constructor(me,ae,re,W){super(me,ae,W),this.fileOperationResult=ae,this.size=re}}e.$0k=N;class B extends L{constructor(me,ae,re){super(me,2,re),this.stat=ae}}e.$$k=B;var U;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(U||(e.FileOperationResult=U={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var Z;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$gl="";function _(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}async function Y(X,me){if(!me.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(ae=>{const re=me.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===X.scheme&&W.added&&(re.dispose(),ae())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(me){return(0,P.$Yf)(me)||(me=0),me<x.KB?(0,p.localize)(1,null,me.toFixed(0)):me<x.MB?(0,p.localize)(2,null,(me/x.KB).toFixed(2)):me<x.GB?(0,p.localize)(3,null,(me/x.MB).toFixed(2)):me<x.TB?(0,p.localize)(4,null,(me/x.GB).toFixed(2)):(0,p.localize)(5,null,(me/x.TB).toFixed(2))}}e.$jl=x;function ce(X){const me=typeof X=="string"||X?.scheme===M.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===M.Schemas.file?1024*x.MB:me?10*x.MB:k.$o?50*x.MB:1024*x.MB}}),define(Ee[250],Se([1,0,21,13,210,32]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=A;async function A(M,I,b,E,v,c){let m;try{await p(M,I,b,E,v,c)}catch(a){m=a}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&b.error(m),b.end()}}async function p(M,I,b,E,v,c){$(c);const m=await M.open(I,{create:!1});try{$(c);let a=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$ue.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await M.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await b.write(E(r)),r=u.$ue.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(c)&&k(a,v));if(t>0){let g=t;typeof i=="number"&&(g=Math.min(t,i)),b.write(E(r.slice(0,g)))}}catch(a){throw(0,P.$2k)(a)}finally{await M.close(m)}}function $(M){if(M.isCancellationRequested)throw(0,j.$6)();return!0}function k(M,I){if(typeof I?.limits?.size=="number"&&M>I.limits.size)throw(0,P.$1k)((0,R.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[64],Se([1,0,35,3,17,11,2,32]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=void 0,e.$uq=$,e.$vq=k,e.$zq=E,e.$Aq=v,e.$Bq=c,e.$Cq=m;function $(n){return typeof n.correlationId=="number"}function k(n){return n.recursive===!0}class M extends j.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new j.$Vc),this.f=void 0,this.g=0}s(){const i=new j.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<M.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wq=M;class I extends M{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$xq=I;class b extends M{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$yq=b;function E(n){return n.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new a;for(const r of n)i.processEvent(r);return i.coalesce()}function c(n,i){return typeof i=="string"&&!i.startsWith(u.$0j)&&!(0,R.$jc)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,u.$bk)(c(n,s)));return r}class a{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,g=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&g===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&g===1?r.type=0:t===1&&g===0||(r.type=g)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,p.$8k)(s.resource.fsPath,t,!P.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(Ee[251],Se([1,0,51,3,64,4,2]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class p extends j.$Uc{constructor(){super(),this.a=this.B(new P.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new P.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=5007,this.B(this.f(k=>this.n(k)))}n(k){this.r(k)&&this.t(k)}r(k){return(0,R.$uq)(k)}async watch(k){this.h.clear(),this.g.clear();for(const M of k)this.r(M)?this.h.set(M.correlationId,M):this.g.add(M);for(const[M]of this.j)this.h.has(M)||this.j.deleteAndDispose(M);return this.s()}s(){return this.C([...this.g,...Array.from(this.h.values()).filter(k=>!this.j.has(k.correlationId))])}t(k){if(this.j.has(k.correlationId))return;const M=new j.$Tc;this.j.set(k.correlationId,M),this.w(k,M),this.s()}u(k){this.j.deleteAndDispose(k.correlationId),this.s()}w(k,M){const I=A.URI.file(k.path),b=this;let E=!1;const v=(c,m)=>{if(M.isDisposed)return;const a=this.y(c),n=this.y(m),i=E;if(E=a,n&&!a||i&&!a&&!n){this.D(`fs.watchFile() detected ${k.path} exists again, resuming watcher (correlationId: ${k.correlationId})`);const r={resource:I,type:1,cId:k.correlationId};b.a.fire([r]),this.z(r,k),this.u(k)}};this.D(`starting fs.watchFile() on ${k.path} (correlationId: ${k.correlationId})`);try{(0,u.watchFile)(k.path,{persistent:!1,interval:this.m},v)}catch(c){this.F(`fs.watchFile() failed with error ${c} on path ${k.path} (correlationId: ${k.correlationId})`)}M.add((0,j.$Sc)(()=>{this.D(`stopping fs.watchFile() on ${k.path} (correlationId: ${k.correlationId})`);try{(0,u.unwatchFile)(k.path,v)}catch(c){this.F(`fs.unwatchFile() failed with error ${c} on path ${k.path} (correlationId: ${k.correlationId})`)}}))}y(k){return k.ctimeMs===0&&k.ino===0}async stop(){this.j.clearAndDisposeAll()}z(k,M){const I=` >> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`;this.D(typeof M.correlationId=="number"?`${I} (correlationId: ${M.correlationId})`:I)}}e.$Lq=p}),define(Ee[252],Se([1,0,51,8,22,34,3,76,17,11,23,2,104,31,64]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,e.$Rq=m;class c extends A.$Uc{static{this.a=100}static{this.b=75}constructor(n,i,r,s,t){super(),this.m=n,this.n=i,this.r=r,this.s=s,this.t=t,this.c=this.B(new j.$wh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.n(g))),this.f=this.B(new j.$vh(g=>this.D(g),c.b)),this.g=(0,v.$Cq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Cq)(this.m.path,this.m.includes):void 0,this.j=new R.$ee,this.ready=this.u()}async u(){try{const n=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const i=await E.Promises.stat(n);this.B(await this.y(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.G(n):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${n})`),this.r?.()}}async w(n){let i=n.path;try{i=await E.Promises.realpath(n.path),n.path===i&&(i=await(0,b.$Nq)(n.path)??n.path),n.path!==i&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async y(n,i){if(k.$j&&(0,P.$hg)(n,"/Volumes/",!0))return this.G(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Uc.None;const r=new R.$ee(this.j.token),s=new A.$Tc;try{const t=I.URI.file(this.m.path),g=(0,$.$oc)(n),d=(0,u.watch)(n);s.add((0,A.$Sc)(()=>{d.removeAllListeners(),d.close()})),this.I(`Started watching: '${n}'`);const l=new Set;if(i)try{for(const h of await E.Promises.readdir(n))l.add(h)}catch(h){this.G(h)}const o=new Map;s.add((0,A.$Sc)(()=>{for(const[,h]of o)h.dispose();o.clear()})),d.on("error",(h,f)=>{this.G(`Failed to watch ${n} for changes using fs.watch() (${h}, ${f})`),this.r?.()}),d.on("change",(h,f)=>{if(r.token.isCancellationRequested)return;this.I(`[raw] ["${h}"] ${f}`);let D="";if(f&&(D=f.toString(),k.$j&&(D=(0,p.$Yl)(D))),!(!D||h!=="change"&&h!=="rename"))if(i)if(h==="rename"){o.get(D)?.dispose();const w=setTimeout(async()=>{if(o.delete(D),D===g&&!await E.Promises.exists(n)){this.z(t);return}const S=await this.F((0,$.$kc)(n,D));if(r.token.isCancellationRequested)return;let y;S?l.has(D)?y=0:(y=1,l.add(D)):(l.delete(D),y=2),this.C({resource:(0,M.$Ug)(t,D),type:y,cId:this.m.correlationId})},c.a);o.set(D,(0,A.$Sc)(()=>clearTimeout(w)))}else{let w;l.has(D)?w=0:(w=1,l.add(D)),this.C({resource:(0,M.$Ug)(t,D),type:w,cId:this.m.correlationId})}else if(h==="rename"||D!==g){const w=setTimeout(async()=>{const S=await E.Promises.exists(n);r.token.isCancellationRequested||(S?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),s.add(await this.y(n,!1))):this.z(t))},c.a);s.clear(),s.add((0,A.$Sc)(()=>clearTimeout(w)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){return!r.token.isCancellationRequested&&await E.Promises.exists(n)&&this.G(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`),this.r?.(),A.$Uc.None}return(0,A.$Sc)(()=>{r.dispose(!0),s.dispose()})}z(n){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(n,i=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}D(n){const i=(0,v.$Aq)(n);if(i.length>0){if(this.t)for(const s of i)this.I(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(n){if(k.$k)return E.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await E.Promises.readdir((0,$.$nc)(n))).some(s=>s===i)}catch(i){return this.I(i),!1}}setVerboseLogging(n){this.t=n}G(n){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}H(n){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}I(n){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.I(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Qq=c;async function m(a,n,i,r,s=512){const t=await E.Promises.open(a,"r"),g=Buffer.allocUnsafe(s),d=new R.$ee(r);let l,o=!1;const h={path:a,excludes:[],recursive:!1},f=new c(h,D=>{(async()=>{for(const{type:w}of D)if(w===0){if(o)return;o=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:S}=await E.Promises.read(t,g,0,s,null);if(!S||d.token.isCancellationRequested)break;n(g.slice(0,S))}}catch(S){l=new Error(S),d.dispose(!0)}finally{o=!1}}})()});return await f.ready,i(),new Promise((D,w)=>{d.token.onCancellationRequested(async()=>{f.dispose();try{await E.Promises.close(t)}catch(S){l=new Error(S)}l?w(l):D()})})}}),define(Ee[253],Se([1,0,4,35,251,11,252]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class p extends R.$Lq{constructor(){super(...arguments),this.onDidError=u.Event.None,this.G=new Map,this.H=!1}async C(k){const M=this.M(k),I=M.filter(E=>{const v=this.G.get(E.path);return v?!(0,j.$fk)(v.request.excludes,E.excludes)||!(0,j.$fk)(v.request.includes,E.includes):!0}),b=Array.from(this.G.values()).filter(({request:E})=>!M.find(v=>v.path===E.path&&(0,j.$fk)(v.excludes,E.excludes)&&(0,j.$fk)(v.includes,E.includes))).map(({request:E})=>E.path);I.length&&this.D(`Request to start watching: ${I.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),b.length&&this.D(`Request to stop watching: ${b.join(",")}`);for(const E of b)this.L(E);for(const E of I)this.J(E)}J(k){const M=new A.$Qq(k,b=>this.a.fire(b),()=>this.c.fire(k),b=>this.b.fire(b),this.H),I={request:k,instance:M};this.G.set(k.path,I)}async stop(){await super.stop();for(const[k]of this.G)this.L(k);this.G.clear()}L(k){const M=this.G.get(k);M&&(this.G.delete(k),M.instance.dispose())}M(k){const M=new Map;for(const I of k){const b=P.$k?I.path:I.path.toLowerCase();let E=M.get(I.correlationId);E||(E=new Map,M.set(I.correlationId,E)),E.set(b,I)}return Array.from(M.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(k){this.H=k;for(const[,M]of this.G)M.instance.setVerboseLogging(k)}D(k){this.H&&this.b.fire({type:"trace",message:this.P(k)})}F(k){this.b.fire({type:"warn",message:this.P(k)})}P(k){return`[File Watcher (node.js)] ${k}`}}e.$Sq=p}),define(Ee[254],Se([1,0,64,253]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class R extends u.$xq{constructor(A,p,$){super(A,p,$),this.s()}r(A){return A.add(new j.$Sq)}}e.$Tq=R}),define(Ee[255],Se([1,0,15,81,193,64]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class A extends P.$yq{constructor($,k,M){super($,k,M),this.s()}r($){const k=$.add(new R.$Jq(u.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:M,signal:I})=>this.t(`terminated by itself with code ${M}, signal: ${I}`))),j.ProxyChannel.toService((0,j.$1h)(k.getChannel("watcher")))}}e.$Kq=A}),define(Ee[107],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class u{constructor(...R){this.a=new Map;for(const[P,A]of R)this.set(P,A)}set(R,P){const A=this.a.get(R);return this.a.set(R,P),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$fi=u}),define(Ee[256],Se([1,0,8,13,3,106,246,5,107,75]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;const M=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class b{constructor(m=new $.$fi,a=!1,n,i=M){this.f=m,this.g=a,this.h=n,this.i=i,this.o=new Set,this.f.set(p.$gi,this),this._globalGraph=i?n?._globalGraph??new A.$Wq(r=>r):void 0}createChild(m){return new b(m,this.g,this,this.i)}invokeFunction(m,...a){const n=v.traceInvocation(this.i,m);let i=!1;try{return m({get:s=>{if(i)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(m,...a){let n,i;return m instanceof P.$ei?(n=v.traceCreation(this.i,m.ctor),i=this.j(m.ctor,m.staticArguments.concat(a),n)):(n=v.traceCreation(this.i,m),i=this.j(m,a,n)),n.stop(),i}j(m,a=[],n){const i=p._util.getServiceDependencies(m).sort((t,g)=>t.index-g.index),r=[];for(const t of i){const g=this.m(t.id,n);g||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(g)}const s=i.length>0?i[0].index:a.length;if(a.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${a.length} static arguments`);const t=s-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,s)}return Reflect.construct(m,a.concat(r))}k(m,a){if(this.f.get(m)instanceof P.$ei)this.f.set(m,a);else if(this.h)this.h.k(m,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const a=this.f.get(m);return!a&&this.h?this.h.l(m):a}m(m,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.l(m);return n instanceof P.$ei?this.q(m,n,a.branch(m,!0)):(a.branch(m,!1),n)}q(m,a,n){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,a,n)}finally{this.o.delete(m)}}r(m,a,n){const i=new A.$Wq(t=>t.id.toString());let r=0;const s=[{id:m,desc:a,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new I(i);for(const g of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(g.id);if(d||this.u(`[createInstance] ${m} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),d instanceof P.$ei){const l={id:g.id,desc:d,_trace:t._trace.branch(g.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:g}of t){if(this.l(g.id)instanceof P.$ei){const l=this.s(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.k(g.id,l)}i.removeNode(g)}}return this.l(m)}s(m,a,n=[],i,r){if(this.f.get(m)instanceof P.$ei)return this.t(m,a,n,i,r);if(this.h)return this.h.s(m,a,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(m,a,n=[],i,r){if(i){const s=new b(void 0,this.g,this,this.i);s.c=String(m);const t=new Map,g=new u.$Ah(()=>{const d=s.j(a,n,r);for(const[l,o]of t){const h=d[l];if(typeof h=="function")for(const f of o)f.disposable=h.apply(d,f.listener)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!g.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let f=t.get(l);return f||(f=new k.$5c,t.set(l,f)),(w,S,y)=>{if(g.isInitialized)return g.value[l](w,S,y);{const C={listener:[w,S,y],disposable:void 0},O=f.push(C);return(0,R.$Sc)(()=>{O(),C.disposable?.dispose()})}}}if(l in d)return d[l];const o=g.value;let h=o[l];return typeof h!="function"||(h=h.bind(o),d[l]=h),h},set(d,l,o){return g.value[l]=o,!0},getPrototypeOf(d){return a.prototype}})}else return this.j(a,n,r)}u(m,a){if(a&&console.warn(m),this.g)throw new Error(m)}}e.$Xq=b;var E;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,a){return m?new v(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,a){return m?new v(1,a.name):v.c}static{this.f=0}constructor(m,a){this.type=m,this.name=a,this.g=Date.now(),this.h=[]}branch(m,a){const n=new v(3,m.toString());return this.h.push([m,a,n]),n}stop(){const m=Date.now()-this.g;v.f+=m;let a=!1;function n(r,s){const t=[],g=new Array(r+1).join("	");for(const[d,l,o]of s.h)if(l&&o){a=!0,t.push(`${g}CREATES -> ${d}`);const h=n(r+1,o);h&&t.push(h)}else t.push(`${g}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||a)&&v.all.add(i.join(`
`))}}e.$Yq=v}),define(Ee[12],Se([1,0,212,46,4,55,3,28,11,23,18,2,41,5]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=c,e.log=a,e.$2j=f,e.$3j=D,e.$4j=w,e.$5j=S,e.$Nj=(0,E.$hi)("logService"),e.$Oj=(0,E.$hi)("loggerService");function v(){return new Date().toISOString()}function c(y){return(0,M.$Yf)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Qj=m.Info;function a(y,C,O){switch(C){case m.Trace:y.trace(O);break;case m.Debug:y.debug(O);break;case m.Info:y.info(O);break;case m.Warning:y.warn(O);break;case m.Error:y.error(O);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let O="";for(let z=0;z<y.length;z++){let F=y[z];if(F instanceof Error&&(F=(0,j.$5i)(F,C)),typeof F=="object")try{F=JSON.stringify(F)}catch{}O+=(z>0?" ":"")+F}return O}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new R.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$Sj=i;class r extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...O){this.f(m.Trace)&&this.g(m.Trace,n([C,...O],!0))}debug(C,...O){this.f(m.Debug)&&this.g(m.Debug,n([C,...O]))}info(C,...O){this.f(m.Info)&&this.g(m.Info,n([C,...O]))}warn(C,...O){this.f(m.Warning)&&this.g(m.Warning,n([C,...O]))}error(C,...O){if(this.f(m.Error))if(C instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=C.stack,this.g(m.Error,n(z))}else this.g(m.Error,n([C,...O]))}flush(){}}e.$Tj=r;class s extends i{constructor(C=e.$Qj){super(),this.setLevel(C),this.g=!$.$i}trace(C,...O){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...O):console.log(`[main ${v()}]`,C,...O))}debug(C,...O){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...O):console.log(`[main ${v()}]`,C,...O))}info(C,...O){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...O):console.log(`[main ${v()}]`,C,...O))}warn(C,...O){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...O):console.warn(`[main ${v()}]`,C,...O))}error(C,...O){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...O):console.error(`[main ${v()}]`,C,...O))}flush(){}}e.$Uj=s;class t extends i{constructor(C=e.$Qj,O=!0){super(),this.g=O,this.setLevel(C)}trace(C,...O){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...O):console.log(C,...O))}debug(C,...O){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...O):console.log(C,...O))}info(C,...O){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...O):console.log(C,...O))}warn(C,...O){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...O):console.log(C,...O))}error(C,...O){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...O):console.error(C,...O))}flush(){}}e.$Vj=t;class g extends i{constructor(C,O=e.$Qj){super(),this.g=C,this.setLevel(O)}trace(C,...O){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...O])}debug(C,...O){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...O])}info(C,...O){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...O])}warn(C,...O){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...O])}error(C,...O){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...O])}h(C){return typeof C=="string"?C:(0,j.$5i)(C,this.f(m.Trace))}flush(){}}e.$Wj=g;class d extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const O of this.g)O.setLevel(C);super.setLevel(C)}trace(C,...O){for(const z of this.g)z.trace(C,...O)}debug(C,...O){for(const z of this.g)z.debug(C,...O)}info(C,...O){for(const z of this.g)z.info(C,...O)}warn(C,...O){for(const z of this.g)z.warn(C,...O)}error(C,...O){for(const z of this.g)z.error(C,...O)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$Xj=d;class l extends A.$Uc{constructor(C,O,z){if(super(),this.h=C,this.j=O,this.b=new p.$Bc,this.c=this.B(new R.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$7d),this.onDidChangeVisibility=this.g.event,z)for(const F of z)this.b.set(F.resource,{logger:void 0,info:F})}m(C){return(0,M.$Uf)(C)?[...this.b.values()].find(O=>O.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,O){const z=this.n(C),F=(0,M.$Uf)(C)?C:O?.id??(0,P.$8i)(z.toString()).toString(16);let T=this.b.get(z)?.logger;const L=O?.logLevel==="always"?m.Trace:O?.logLevel;T||(T=this.s(z,L??this.getLogLevel(z)??this.h,{...O,id:F}));const N={logger:T,info:{resource:z,id:F,logLevel:L,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(N.info),this.b.set(z,N),T}n(C){return(0,M.$Uf)(C)?(0,k.$Ug)(this.j,`${C}.log`):C}setLogLevel(C,O){if(I.URI.isUri(C)){const z=C,F=O,T=this.b.get(z);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([z,F]))}else{this.h=C;for(const[z,F]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,O){const z=this.m(C);z&&O!==!z.info.hidden&&(z.info.hidden=!O,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,O]))}getLogLevel(C){let O;return C&&(O=this.b.get(C)?.info.logLevel),O??this.h}registerLogger(C){const O=this.b.get(C.resource);O?O.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const O=this.b.get(C);O&&(O.logger&&O.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=l;class o{constructor(){this.onDidChangeLogLevel=new R.$7d().event}setLevel(C){}getLevel(){return m.Info}trace(C,...O){}debug(C,...O){}info(C,...O){}warn(C,...O){}error(C,...O){}critical(C,...O){}dispose(){}flush(){}}e.$Zj=o;class h extends o{}e.$1j=h;function f(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const C=S(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Qj}function D(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function w(y){switch(y){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function S(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$6j=new b.$yj("logLevel",D(m.Info))}),define(Ee[257],Se([1,0,19,8,13,4,3,17,64,12]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class M extends A.$Uc{constructor(b,E){super(),this.a=b,this.b=E,this.c=this.B(new P.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$fh(0)),this.w=[],this.y=this.B(new j.$fh(0))}watch(b,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(b,E):this.z(b,E)}n(b,E){const v={path:this.H(b),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},c=(0,u.$Ub)(this.j,v);return this.r(),(0,A.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,R.$1)(b))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,$.$zq)(E)),E=>this.G(E),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const E of this.j)(0,$.$vq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const E of this.j)(0,$.$vq)(E)&&b.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,E){const v={path:this.H(b),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},c=(0,u.$Ub)(this.w,v);return this.C(),(0,A.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,R.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,$.$zq)(b)),b=>this.G(b),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,p.$ic)(b.fsPath)}}e.$Dq=M}),define(Ee[258],Se([1,0,51,398,8,28,21,4,34,3,17,11,23,98,31,211,32,250,257,46,255,254]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0,(()=>{try{(0,j.gracefulify)(u)}catch(g){console.error(`Error enabling graceful-fs: ${(0,i.$5i)(g)}`)}})();class t extends n.$Dq{static{this.I=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=p.Event.None,this.N=new P.$Bc(o=>b.$Lg.getComparisonKey(o)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:o}=await v.SymlinkSupport.stat(this.H(d));return{type:this.M(l,o),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await v.Promises.readdir(this.H(d),{withFileTypes:!0}),o=[];return await Promise.all(l.map(async h=>{try{let f;h.isSymbolicLink()?f=(await this.stat((0,b.$Ug)(d,h.name))).type:f=this.M(h),o.push([h.name,f])}catch(f){this.a.trace(f)}})),o}catch(l){throw this.fb(l)}}M(d,l){let o;return l?.dangling?o=m.FileType.Unknown:d.isFile()?o=m.FileType.File:d.isDirectory()?o=m.FileType.Directory:o=m.FileType.Unknown,l&&(o|=m.FileType.SymbolicLink),o}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let o;for(;o=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await o.wait();const h=new R.$gh;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,k.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let o;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),o=await this.O(d));const h=this.H(d);return await v.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{o?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,o){const h=(0,E.$ie)(f=>A.$ue.concat(f.map(D=>A.$ue.wrap(D))).buffer);return(0,a.$sq)(this,d,h,f=>f.buffer,{...l,bufferSize:256*1024},o),h}async writeFile(d,l,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,b.$Ug)((0,b.$Tg)(d),`${(0,b.$Rg)(d)}${o.atomic.postfix}`),l,o):this.S(d,l,o)}async Q(d){try{const l=this.H(d),{symbolicLink:o}=await v.SymlinkSupport.stat(l);if(o)return!1}catch{}return!0}async R(d,l,o,h){const f=new k.$Tc;try{f.add(await this.O(d)),f.add(await this.O(l)),await this.S(l,o,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{f.dispose()}}async S(d,l,o,h){let f;try{const D=this.H(d);if(!o.create||!o.overwrite){if(await v.Promises.exists(D)){if(!o.overwrite)throw(0,m.$1k)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,m.$1k)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(d,{create:!0,unlock:o.unlock},h),await this.write(f,0,l,0,l.byteLength)}catch(D){throw await this.gb(d,D)}finally{typeof f=="number"&&await this.close(f)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,l,o){const h=this.H(d);let f;(0,m.$Ok)(l)&&!o&&(f=await this.O(d));let D;try{if((0,m.$Ok)(l)&&l.unlock)try{const{stat:S}=await v.SymlinkSupport.stat(h);S.mode&128||await v.Promises.chmod(h,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let w;if((0,m.$Ok)(l)){if(I.$i)try{await v.Promises.truncate(h,0),w="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}w||(w="w")}else w="r";D=await v.Promises.open(h,w)}catch(w){throw f?.dispose(),(0,m.$Ok)(l)?await this.gb(d,w):this.fb(w)}if(this.U.set(D,0),(0,m.$Ok)(l)&&this.X.set(D,d),f){const w=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,f),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),w.dispose())}return D}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await v.Promises.fdatasync(d)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await v.Promises.close(d)}catch(o){throw this.fb(o)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,o,h,f){const D=this.Z(d,l);let w=null;try{w=(await v.Promises.read(d,o,h,f,D)).bytesRead}catch(S){throw this.fb(S)}finally{this.$(d,D,w)}return w}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,o){const h=this.U.get(d);typeof h=="number"&&(typeof l=="number"||(typeof o=="number"?this.U.set(d,h+o):this.U.delete(d)))}async write(d,l,o,h,f){return(0,R.$Bh)(()=>this.ab(d,l,o,h,f),100,3)}async ab(d,l,o,h,f){const D=this.Z(d,l);let w=null;try{w=(await v.Promises.write(d,o,h,f,D)).bytesWritten}catch(S){throw await this.gb(this.X.get(d),S)}finally{this.$(d,D,w)}return w}async mkdir(d){try{await v.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const o=this.H(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,M.$kc)((0,M.$nc)(o),`${(0,M.$oc)(o)}${l.atomic.postfix}`)),await v.Promises.rm(o,v.RimRafMode.MOVE,h)}else try{await v.Promises.unlink(o)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let f=!1;try{const{stat:D,symbolicLink:w}=await v.SymlinkSupport.stat(o);f=D.isDirectory()&&!w}catch{}if(f)await v.Promises.rmdir(o);else throw h}else throw h}}catch(o){throw this.fb(o)}}async rename(d,l,o){const h=this.H(d),f=this.H(l);if(h!==f)try{await this.bb(d,l,"move",o.overwrite),await v.Promises.rename(h,f)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,c.localize)(2,null,(0,M.$oc)(h),(0,M.$oc)((0,M.$nc)(f)),D.toString()))),this.fb(D)}}async copy(d,l,o){const h=this.H(d),f=this.H(l);if(h!==f)try{await this.bb(d,l,"copy",o.overwrite),await v.Promises.copy(h,f,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,c.localize)(3,null,(0,M.$oc)(h),(0,M.$oc)((0,M.$nc)(f)),D.toString()))),this.fb(D)}}async bb(d,l,o,h){const f=this.H(d),D=this.H(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$gg)(f,D,!0)),w){if(o==="copy")throw(0,m.$1k)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const y=await this.L(d);if(!y)throw(0,m.$1k)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(l);if(C){if(!h)throw(0,m.$1k)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&C.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,o){const h=this.H(d),f=this.H(l),D=!!(this.capabilities&1024);if((0,$.$gg)(h,f,!D))return;const w=new k.$Tc;try{w.add(await this.O(d)),w.add(await this.O(l)),o&&await v.Promises.mkdir((0,M.$nc)(f),{recursive:!0}),await v.Promises.copyFile(h,f)}catch(S){if(S.code==="ENOENT"&&!o)return this.cb(d,l,!0);throw this.fb(S)}finally{w.dispose()}}t(d,l,o){return new r.$Kq(h=>d(h),h=>l(h),o)}F(d,l,o){return new s.$Tq(h=>d(h),h=>l(h),o)}fb(d){if(d instanceof m.$Zk)return d;let l=d,o;switch(d.code){case"ENOENT":o=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=m.FileSystemProviderErrorCode.Unknown;break;default:o=m.FileSystemProviderErrorCode.Unknown}return(0,m.$1k)(l,o)}async gb(d,l){let o=this.fb(l);if(d&&o.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await v.SymlinkSupport.stat(this.H(d));h.mode&128||(o=(0,m.$1k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return o}}e.$Uq=t}),define(Ee[259],Se([1,0,3,12]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;class R extends u.$Uc{constructor(A,p=[]){super(),this.a=new j.$Xj([A,...p]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...p){this.a.trace(A,...p)}debug(A,...p){this.a.debug(A,...p)}info(A,...p){this.a.info(A,...p)}warn(A,...p){this.a.warn(A,...p)}error(A,...p){this.a.error(A,...p)}flush(){this.a.flush()}}e.$1P=R}),define(Ee[260],Se([1,0,32,12]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;var R;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(R||(R={}));async function P(k,M,I,b,E){try{const v=await new Promise((m,a)=>{de(["@vscode/spdlog"],m,a)});v.setFlushOn(R.Trace);const c=await v.createAsyncRotatingLogger(k,M,I,b);return E?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(v){console.error(v)}return null}function A(k,M,I){switch(M){case j.LogLevel.Trace:k.trace(I);break;case j.LogLevel.Debug:k.debug(I);break;case j.LogLevel.Info:k.info(I);break;case j.LogLevel.Warning:k.warn(I);break;case j.LogLevel.Error:k.error(I);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function p(k,M){switch(M){case j.LogLevel.Trace:k.setLevel(R.Trace);break;case j.LogLevel.Debug:k.setLevel(R.Debug);break;case j.LogLevel.Info:k.setLevel(R.Info);break;case j.LogLevel.Warning:k.setLevel(R.Warning);break;case j.LogLevel.Error:k.setLevel(R.Error);break;case j.LogLevel.Off:k.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${M}`)}}class $ extends j.$Tj{constructor(M,I,b,E,v){super(),this.m=[],this.setLevel(v),this.n=this.s(M,I,b,E),this.B(this.onDidChangeLogLevel(c=>{this.r&&p(this.r,c)}))}async s(M,I,b,E){const v=b?6:1,c=30/v*u.$jl.MB,m=await P(M,I,c,v,E);if(m){this.r=m,p(this.r,this.getLevel());for(const{level:a,message:n}of this.m)A(this.r,a,n);this.m=[]}}g(M,I){this.r?A(this.r,M,I):this.getLevel()<=M&&this.m.push({level:M,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$PP=$}),define(Ee[138],Se([1,0,40,213,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function k(v,c){return c-v}$.compare=k;const M=Object.create(null);M[$.Error]=(0,j.localize)(0,null),M[$.Warning]=(0,j.localize)(1,null),M[$.Info]=(0,j.localize)(2,null);function I(v){return M[v]||""}$.toString=I;function b(v){switch(v){case u.default.Error:return $.Error;case u.default.Warning:return $.Warning;case u.default.Info:return $.Info;case u.default.Ignore:return $.Hint}}$.fromSeverity=b;function E(v){switch(v){case $.Error:return u.default.Error;case $.Warning:return u.default.Warning;case $.Info:return u.default.Info;case $.Hint:return u.default.Ignore}}$.toSeverity=E}(A||(e.MarkerSeverity=A={}));var p;(function($){const k="";function M(b){return I(b,!0)}$.makeKey=M;function I(b,E){const v=[k];return b.source?v.push(b.source.replace("\xA6","\\\xA6")):v.push(k),b.code?typeof b.code=="string"?v.push(b.code.replace("\xA6","\\\xA6")):v.push(b.code.value.replace("\xA6","\\\xA6")):v.push(k),b.severity!==void 0&&b.severity!==null?v.push(A.toString(b.severity)):v.push(k),b.message&&E?v.push(b.message.replace("\xA6","\\\xA6")):v.push(k),b.startLineNumber!==void 0&&b.startLineNumber!==null?v.push(b.startLineNumber.toString()):v.push(k),b.startColumn!==void 0&&b.startColumn!==null?v.push(b.startColumn.toString()):v.push(k),b.endLineNumber!==void 0&&b.endLineNumber!==null?v.push(b.endLineNumber.toString()):v.push(k),b.endColumn!==void 0&&b.endColumn!==null?v.push(b.endColumn.toString()):v.push(k),v.push(k),v.join("\xA6")}$.makeKeyOptionalMessage=I})(p||(e.IMarkerData=p={})),e.$Tt=(0,R.$hi)("markerService")}),define(Ee[261],Se([1,0,4,40,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nv=e.$Mv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Kv=e.Severity=void 0,e.$Lv=p,e.Severity=j.default,e.$Kv=(0,R.$hi)("notificationService");var P;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function p(I){if(I){const b=I;return typeof b.id=="string"&&typeof b.label=="string"}return!1}var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new M,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.$Mv=k;class M{infinite(){}done(){}total(b){}worked(b){}}e.$Nv=M}),define(Ee[262],Se([1,0,50]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.context<"u"){const P=R.context.configuration();if(P)j=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:P.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(Ee[139],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,u.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(de,e){return function(u,j){e(u,j,de)}};define(Ee[108],Se([1,0,8,22,3,5]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.ProgressLocation=e.$Ov=void 0,e.$Ov=(0,P.$hi)("progressService");var A;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Pv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(b){this.b=b}report(b){this.a=b,this.b(this.a)}}e.$Qv=p;class ${get value(){return this.a}constructor(b){this.e=b}report(b){this.b?this.b.push(b):this.b=[b],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const b=this.b.shift();this.a=b,await this.e(this.a)}}finally{this.c=!1;const b=this.d;this.d=void 0,b?.()}}drain(){return this.c?new Promise(b=>{const E=this.d;this.d=()=>{E?.(),b()}}):Promise.resolve()}}e.$Rv=$;let k=class extends R.$Uc{constructor(b,E){super(),this.a=new u.$Eh,E.withProgress(b,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(b){this.b?this.b.report(b):this.c=b}};e.$Sv=k,e.$Sv=k=Je([Ve(1,e.$Ov)],k);class M extends R.$Uc{constructor(b){super(),this.g=b,this.a=0,this.b=this.B(new R.$Tc)}start(b){this.stop();const E=++this.a,v=new j.$ee;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},b),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>v.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:E,token:v.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(b){this.a===b&&this.b.clear()}}e.$Tv=M,e.$Uv=(0,P.$hi)("editorProgressService")}),define(Ee[37],Se([1,0,61,18]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class R{constructor(){this.a=new Map}add(A,p){u.ok(j.$Uf(A)),u.ok(j.$Wf(p)),u.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,p)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Zn=new R}),define(Ee[109],Se([1,0,4,37]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class P{constructor(){this.b=new u.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[R($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;j.$Zn.add(e.$1n.JSONContribution,A)}),define(Ee[85],Se([1,0,19,4,18,202,53,109,37]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=c,e.$eo=m,e.$fo=a,e.$go=i,e.$ho=r;var k;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$5n={Configuration:"base.contributions.configuration"};var M;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const I=$.$Zn.as(p.$1n.JSONContribution);class b{constructor(){this.h=new Set,this.i=new j.$7d,this.onDidSchemaChange=this.i.event,this.j=new j.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const d=new Set;this.n(t,g,d),I.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const g=new Set;this.o(t,g),I.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const d=new Set;this.o(g,d),this.n(t,!1,d),I.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const d=[];for(const{overrides:l,source:o}of t)for(const h in l)if(g.add(h),e.$co.test(h)){const f=this.a.get(h),D=f?.valuesSources??new Map;if(o)for(const C of Object.keys(l[h]))D.set(C,o);const w={...f?.value||{},...l[h]};this.a.set(h,{source:o,value:w,valuesSources:D});const S=(0,A.$Xi)(h),y={type:"object",default:w,description:P.localize(1,null,S),$ref:e.$_n,defaultDefaultValue:w,source:R.$Uf(o)?void 0:o,defaultValueSource:o};d.push(...c(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:l[h],source:o});const f=this.d[h];f&&(this.w(h,f),this.r(h,f))}this.m(d)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:d,source:l}of t)for(const o in d){const h=this.a.get(o),f=R.$Uf(l)?l:l?.id,D=R.$Uf(h?.source)?h?.source:h?.source?.id;if(f===D)if(g.add(o),this.a.delete(o),e.$co.test(o))delete this.d[o],delete this.b.properties[o];else{const w=this.d[o];w&&(this.w(o,w),this.r(o,w))}}this.u()}deltaConfiguration(t){let g=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,d){t.forEach(l=>{this.p(l,g,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,g){const d=l=>{if(l.properties)for(const o in l.properties){g.add(o);const h=this.d[o];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[o],this.s(o,l.properties[o])}l.allOf?.forEach(o=>d(o))};for(const l of t){d(l);const o=this.c.indexOf(l);o!==-1&&this.c.splice(o,1)}}p(t,g=!0,d,l,o=3,h){o=R.$4f(t.scope)?o:t.scope;const f=t.properties;if(f)for(const w in f){const S=f[w];if(g&&i(w,S)){delete f[w];continue}if(S.source=d,S.defaultDefaultValue=f[w].default,this.w(w,S),e.$co.test(w)?S.scope=void 0:(S.scope=R.$4f(S.scope)?o:S.scope,S.restricted=R.$4f(S.restricted)?!!l?.includes(w):S.restricted),f[w].hasOwnProperty("included")&&!f[w].included){this.f[w]=f[w],delete f[w];continue}else this.d[w]=f[w],f[w].policy?.name&&this.e.set(f[w].policy.name,w);!f[w].deprecationMessage&&f[w].markdownDeprecationMessage&&(f[w].deprecationMessage=f[w].markdownDeprecationMessage),h.add(w)}const D=t.allOf;if(D)for(const w of D)this.p(w,g,d,l,o,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$6n.properties[t]=g,g.scope){case 1:e.$7n.properties[t]=g;break;case 2:e.$8n.properties[t]=g;break;case 6:e.$9n.properties[t]=g;break;case 3:e.$0n.properties[t]=g;break;case 4:e.$$n.properties[t]=g;break;case 5:e.$$n.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$6n.properties[t],g.scope){case 1:delete e.$7n.properties[t];break;case 2:delete e.$8n.properties[t];break;case 6:delete e.$9n.properties[t];break;case 3:delete e.$0n.properties[t];break;case 4:case 5:delete e.$$n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,d={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$_n};this.w(g,d),e.$6n.properties[g]=d,e.$7n.properties[g]=d,e.$8n.properties[g]=d,e.$9n.properties[g]=d,e.$0n.properties[g]=d,e.$$n.properties[g]=d}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=t,e.$7n.patternProperties[e.$bo]=t,e.$8n.patternProperties[e.$bo]=t,e.$9n.patternProperties[e.$bo]=t,e.$0n.patternProperties[e.$bo]=t,e.$$n.patternProperties[e.$bo]=t,this.i.fire()}w(t,g){const d=this.a.get(t);let l=d?.value,o=d?.source;R.$2f(l)&&(l=g.defaultDefaultValue,o=void 0),R.$2f(l)&&(l=a(g.type)),g.default=l,g.defaultValueSource=o}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.$bo=`^(${E})+$`,e.$co=new RegExp(e.$bo);function c(s){const t=[];if(e.$co.test(s)){let g=v.exec(s);for(;g?.length;){const d=g[1].trim();d&&t.push(d),g=v.exec(s)}}return(0,u.$Mb)(t)}function m(s){return s.reduce((t,g)=>`${t}[${g}]`,"")}function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new b;$.$Zn.add(e.$5n.Configuration,n);function i(s,t){return s.trim()?e.$co.test(s)?P.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?P.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const g of Object.keys(t))s.push([g,t[g].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(Ee[263],Se([1,0,19,4,163,3,28,24,18,2,53,85,37]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=i;function E(g){return Object.isFrozen(g)?g:p.$On(g)}class v{constructor(d={},l=[],o=[],h){this.b=d,this.c=l,this.d=o,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof v)return l;const o=new c("");return o.parseRaw(l),o.configurationModel});this.f=d.reduce((l,o)=>o===l?o:l.merge(o),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,M.$Vi)(this.contents,d):this.contents}inspect(d,l){const o=this;return{get value(){return E(o.rawConfiguration.getValue(d))},get override(){return l?E(o.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return E(l?o.rawConfiguration.override(l).getValue(d):o.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:f,identifiers:D,keys:w}of o.rawConfiguration.overrides){const S=new v(f,w).getValue(d);S!==void 0&&h.push({identifiers:D,value:S})}return h.length?E(h):void 0}}}getOverrideValue(d,l){const o=this.i(l);return o?d?(0,M.$Vi)(o,d):o:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const o of this.overrides)o.identifiers.includes(d)&&l.push(...o.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=p.$Nn(this.contents),o=p.$Nn(this.overrides),h=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const D of d)if(f.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(l,D.contents);for(const w of D.overrides){const[S]=o.filter(y=>u.$ub(y.identifiers,w.identifiers));S?(this.h(S.contents,w.contents),S.keys.push(...w.keys),S.keys=u.$Mb(S.keys)):o.push(p.$Nn(w))}for(const w of D.keys)h.indexOf(w)===-1&&h.push(w)}return new v(l,h,o,f.every(D=>D instanceof v)?void 0:f)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const o={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let f=this.contents[h];const D=l[h];D&&(typeof f=="object"&&typeof D=="object"?(f=p.$Nn(f),this.h(f,D)):f=D),o[h]=f}return new v(o,this.keys,this.overrides)}h(d,l){for(const o of Object.keys(l)){if(o in d&&$.$Wf(d[o])&&$.$Wf(l[o])){this.h(d[o],l[o]);continue}d[o]=p.$Nn(l[o])}}i(d){let l=null,o=null;const h=f=>{f&&(o?this.h(o,f):o=p.$Nn(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===d?l=f.contents:f.identifiers.includes(d)&&h(f.contents);return h(l),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,M.$Ui)(this.contents,d),I.$co.test(d)&&this.overrides.splice(this.overrides.findIndex(o=>u.$ub(o.identifiers,(0,I.$do)(d))),1))}j(d,l,o){(0,M.$Ti)(this.contents,d,l,h=>console.error(h)),o=o||this.keys.indexOf(d)===-1,o&&this.keys.push(d),I.$co.test(d)&&this.overrides.push({identifiers:(0,I.$do)(d),keys:Object.keys(this.contents[d]),contents:(0,M.$Si)(this.contents[d],h=>console.error(h))})}}e.$io=v;class c{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!$.$4f(d)){const o=this.g(d);this.parseRaw(o,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:o,keys:h,overrides:f,restricted:D,hasExcludedProperties:w}=this.h(d,l);this.b=new v(o,h,f,w?[d]:void 0),this.c=D||[]}g(d){let l={},o=null,h=[];const f=[],D=[];function w(y){Array.isArray(h)?h.push(y):o!==null&&(h[o]=y)}const S={onObjectBegin:()=>{const y={};w(y),f.push(h),h=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const y=[];w(y),f.push(h),h=y,o=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:w,onError:(y,C,O)=>{D.push({error:y,offset:C,length:O})}};if(d)try{R.$Bn(d,S),l=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}h(d,l){const o=b.$Zn.as(I.$5n.Configuration).getConfigurationProperties(),h=this.i(d,o,!0,l);d=h.raw;const f=(0,M.$Si)(d,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(d),w=this.j(d,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:f,keys:D,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,o,h){let f=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:f};const D={},w=[];for(const S in d)if(I.$co.test(S)&&o){const y=this.i(d[S],l,!1,h);D[S]=y.raw,f=f||y.hasExcludedProperties,w.push(...y.restricted)}else{const y=l[S],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&w.push(S),!h.exclude?.includes(S)&&(h.include?.includes(S)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&y?.restricted))?D[S]=d[S]:f=!0}return{raw:D,restricted:w,hasExcludedProperties:f}}j(d,l){const o=[];for(const h of Object.keys(d))if(I.$co.test(h)){const f={};for(const D in d[h])f[D]=d[h][D];o.push({identifiers:(0,I.$do)(h),keys:Object.keys(f),contents:(0,M.$Si)(f,l)})}return o}}e.$jo=c;class m extends P.$Uc{constructor(d,l,o,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new j.$7d),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&o.isEqual(f.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=m;class a{constructor(d,l,o,h,f,D,w,S,y,C,O,z,F){this.a=d,this.b=l,this.c=o,this.overrideIdentifiers=h,this.d=f,this.f=D,this.g=w,this.h=S,this.i=y,this.j=C,this.k=O,this.l=z,this.m=F}get value(){return E(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,o,h,f=new v,D=new v,w=new A.$Bc,S=new v,y=new A.$Bc){this.c=d,this.d=l,this.f=o,this.g=h,this.h=f,this.i=D,this.j=w,this.l=S,this.m=y,this.a=null,this.b=new A.$Bc,this.n=null}getValue(d,l,o){return this.p(d,l,o).getValue(d)}updateValue(d,l,o={}){let h;o.resource?(h=this.m.get(o.resource),h||(h=new v,this.m.set(o.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),o.resource||(this.a=null)}inspect(d,l,o){const h=this.p(d,l,o),f=this.t(l.resource,o),D=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const S of h.overrides)for(const y of S.identifiers)h.getOverrideValue(d,y)!==void 0&&w.add(y);return new a(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,f||void 0,D)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const o=[];if(!l){const{added:h,updated:f,removed:D}=s(this.c,d);l=[...h,...f,...D]}for(const h of l)for(const f of(0,I.$do)(h)){const D=this.c.getKeysForOverrideIdentifier(f),w=d.getKeysForOverrideIdentifier(f),S=[...w.filter(y=>D.indexOf(y)===-1),...D.filter(y=>w.indexOf(y)===-1),...D.filter(y=>!p.$Rn(this.c.override(f).getValue(y),d.override(f).getValue(y)))];o.push([f,S])}return this.updateDefaultConfiguration(d),{keys:l,overrides:o}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:o,removed:h}=s(this.d,d),f=[...l,...o,...h];return f.length&&this.updatePolicyConfiguration(d),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:o,removed:h,overrides:f}=s(this.applicationConfiguration,d),D=[...l,...o,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:f}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:o,removed:h,overrides:f}=s(this.localUserConfiguration,d),D=[...l,...o,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:f}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:o,removed:h,overrides:f}=s(this.remoteUserConfiguration,d),D=[...l,...o,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:f}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:o,removed:h,overrides:f}=s(this.workspaceConfiguration,d),D=[...l,...o,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:f}}compareAndUpdateFolderConfiguration(d,l){const o=this.folderConfigurations.get(d),{added:h,updated:f,removed:D,overrides:w}=s(o,l),S=[...h,...f,...D];return(S.length||!o)&&this.updateFolderConfiguration(d,l),{keys:S,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:o,updated:h,removed:f,overrides:D}=s(l,void 0);return{keys:[...o,...h,...f],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,o){let h=this.q(l,o);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let o=this.r();if(l&&d){const h=l.getFolder(d);h&&(o=this.s(h.uri)||o);const f=this.m.get(d);f&&(o=o.merge(f))}return o}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const o=this.r(),h=this.j.get(d);h?(l=o.merge(h),this.b.set(d,l)):l=o}return l}t(d,l){if(l&&d){const o=l.getFolder(d);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:o,overrides:h,keys:f}=this.j.get(l);return d.push([l,{contents:o,overrides:h,keys:f}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(o=>d.add(o))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(o=>d.add(o))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(o=>l.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>l.add(o)),this.i.getKeysForOverrideIdentifier(d).forEach(o=>l.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),o=this.w(d.policy),h=this.w(d.application),f=this.w(d.user),D=this.w(d.workspace),w=d.folders.reduce((S,y)=>(S.set(k.URI.revive(y[0]),this.w(y[1])),S),new A.$Bc);return new n(l,o,h,f,new v,D,w,new v,new A.$Bc)}static w(d){return new v(d.contents,d.keys,d.overrides)}}e.$lo=n;function i(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const d=new Set,l=new Map;for(const h of g)h.keys.forEach(f=>d.add(f)),h.overrides.forEach(([f,D])=>{const w=(0,A.$yc)(l,f,new Set);D.forEach(S=>w.add(S))});const o=[];return l.forEach((h,f)=>o.push([f,[...h.values()]])),{keys:[...d.values()],overrides:o}}class r{constructor(d,l,o,h){this.change=d,this.f=l,this.g=o,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const f of d.keys)this.affectedKeys.add(f);for(const[,f]of d.overrides)for(const D of f)this.affectedKeys.add(D);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const o=this.a+d,h=this.d.indexOf(o);if(h<0)return!1;const f=h+o.length;if(f>=this.d.length)return!1;const D=this.d.charCodeAt(f);if(D!==this.b&&D!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,S=this.g.getValue(d,l,this.h);return!p.$Rn(w,S)}return!0}}e.$no=r;function s(g,d){const{added:l,removed:o,updated:h}=t(d?.rawConfiguration,g?.rawConfiguration),f=[],D=g?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const S=w.filter(y=>!D.includes(y));for(const y of S)f.push([y,d.getKeysForOverrideIdentifier(y)])}if(g){const S=D.filter(y=>!w.includes(y));for(const y of S)f.push([y,g.getKeysForOverrideIdentifier(y)])}if(d&&g){for(const S of D)if(w.includes(S)){const y=t({contents:g.getOverrideValue(void 0,S)||{},keys:g.getKeysForOverrideIdentifier(S)},{contents:d.getOverrideValue(void 0,S)||{},keys:d.getKeysForOverrideIdentifier(S)});f.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:o,updated:h,overrides:f}}function t(g,d){const l=g?d?g.keys.filter(f=>d.keys.indexOf(f)===-1):[...g.keys]:[],o=d?g?d.keys.filter(f=>g.keys.indexOf(f)===-1):[...d.keys]:[],h=[];if(g&&d){for(const f of d.keys)if(g.keys.indexOf(f)!==-1){const D=(0,M.$Vi)(d.contents,f),w=(0,M.$Vi)(g.contents,f);p.$Rn(D,w)||h.push(f)}}return{added:l,removed:o,updated:h}}}),define(Ee[264],Se([1,0,21,4,3,82]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2tb=e.$Ztb=e.$Ytb=void 0,e.$1tb=p;const A=(k,M,I)=>{const b=new Uint8Array(16);for(let c=0;c<16;c++)b[c]=Math.round(Math.random()*256);const E=(0,u.$Oe)(u.$ue.wrap(b));return[`GET ws://localhost${k}?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$Ytb=A,e.$Ztb=u.$ue.fromString(`\r
\r
`);async function p(k,M,I,b,E){k.write(u.$ue.fromString((0,e.$Ytb)(M,I,b)));const v=new R.$Tc;try{return await new Promise((c,m)=>{let a;v.add(k.onData(n=>{a?a=u.$ue.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$Ztb);if(i===-1)return;c(k),k.pauseData();const r=a.slice(i+e.$Ztb.byteLength);r.byteLength&&E.onData.fire(r)})),v.add(k.onClose(n=>m(n??new Error("socket closed")))),v.add(k.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw k.dispose(),c}finally{v.dispose()}}class $ extends R.$Uc{constructor(M,I){super(),this.g=M,this.a=this.B(new j.$0d),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new j.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(b=>this.a.fire(b))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(M,I){P.SocketDiagnostics.traceSocketEvent(this,this.g,M,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$2tb=$}),define(Ee[65],Se([1,0,13,5]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=k,e.$sl=(0,j.$hi)("remoteAuthorityResolverService");var R;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class P{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=P;class A{constructor(I,b){this.host=I,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=A;var p;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends u.$bb{static isNotAvailable(I){return I instanceof $&&I._code===p.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===p.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===p.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===p.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,b=p.Unknown,E){super(I),this._message=I,this._code=b,this._detail=E,this.isHandled=b===p.NotAvailable&&E===!0,Object.setPrototypeOf(this,$.prototype)}}e.$vl=$;function k(M){const I=M.indexOf("+");return I===-1?M:M.substring(0,I)}}),define(Ee[265],Se([1,0,8,21,22,13,4,3,15,58,39,30,82,65]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Bl=D,e.$Cl=w,e.$Dl=y;const v=30*1e3;var c;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(re){switch(re){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(re){const W=new R.$ee;return setTimeout(()=>W.cancel(),re),W.token}function n(re,W){if(re.isCancellationRequested||W.isCancellationRequested)return R.CancellationToken.Cancelled;const ie=new R.$ee;return re.onCancellationRequested(()=>ie.cancel()),W.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new p.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$ah)(),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function r(re,W){const ie=new i(W);return ie.registerDisposable(re.onControlMessage(ve=>{const Pe=JSON.parse(ve.toString()),le=Y(Pe);le?ie.reject(le):ie.resolve(Pe)})),ie.promise}function s(re,W,ie,ve,Pe,le,ue,oe){const K=new i(oe),ee=M.$3d.create(!1);return re.info(`Creating a socket (${ue})...`),k.mark(`code/willCreateSocket/${le}`),W.connect(ie,ve,Pe,ue).then(he=>{K.didTimeout?(k.mark(`code/didCreateSocketError/${le}`),re.info(`Creating a socket (${ue}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(k.mark(`code/didCreateSocketOK/${le}`),re.info(`Creating a socket (${ue}) was successful after ${ee.elapsed()} ms.`),K.resolve(he))},he=>{k.mark(`code/didCreateSocketError/${le}`),re.info(`Creating a socket (${ue}) returned an error after ${ee.elapsed()} ms.`),re.error(he),K.reject(he)}),K.promise}function t(re,W){const ie=new i(W);return re.then(ve=>{ie.didTimeout||ie.resolve(ve)},ve=>{ie.didTimeout||ie.reject(ve)}),ie.promise}async function g(re,W,ie,ve){const Pe=me(re,W);re.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let le;try{le=await s(re.logService,re.remoteSocketFactoryService,re.connectTo,$.$ug.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,m(W),`renderer-${m(W)}-${re.reconnectionToken}`,ve)}catch(he){throw re.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let ue,oe;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(le,null),ue=re.reconnectionProtocol,oe=!1):(ue=new b.$8h({socket:le}),oe=!0),re.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const K=await t(re.signService.createNewMessage((0,I.$Dg)()),ve),ee={type:"auth",auth:re.connectionToken||"00000000000000000000",data:K.data};ue.sendControl(j.$ue.fromString(JSON.stringify(ee)));try{const he=await r(ue,n(ve,a(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(re.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(re.signService.validate(K,he.signedData),ve)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Ae=await t(re.signService.sign(he.data),ve),pe={type:"connectionType",commit:re.commit,signedData:Ae,desiredConnectionType:W};return ie&&(pe.args=ie),re.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),ue.sendControl(j.$ue.fromString(JSON.stringify(pe))),{protocol:ue,ownsProtocol:oe}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${Pe} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${Pe} received error control message when negotiating connection. Error:`),re.logService.error(he)),oe&&_(ue),he}}async function d(re,W,ie,ve){const Pe=Date.now(),le=me(re,W),{protocol:ue,ownsProtocol:oe}=await g(re,W,ie,ve),K=new i(ve);return K.registerDisposable(ue.onControlMessage(ee=>{const he=JSON.parse(ee.toString()),fe=Y(he);fe?(re.logService.error(`${le} received error control message when negotiating connection. Error:`),re.logService.error(fe),oe&&_(ue),K.reject(fe)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${ae(Pe)}!`),K.resolve({protocol:ue,firstMessage:he}))})),K.promise}async function l(re,W){const{protocol:ie}=await d(re,1,void 0,W);return{protocol:ie}}async function o(re,W,ie){const{protocol:ve,firstMessage:Pe}=await d(re,2,W,ie),le=Pe&&Pe.debugPort;return{protocol:ve,debugPort:le}}async function h(re,W,ie){const ve=Date.now(),Pe=me(re,3),{protocol:le}=await g(re,3,W,ie);return re.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${ae(ve)}!`),le}async function f(re,W,ie){const{connectTo:ve,connectionToken:Pe}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:ve,connectionToken:Pe,reconnectionToken:W,reconnectionProtocol:ie,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function D(re,W,ie){return S(re,async ve=>{const{protocol:Pe}=await l(ve,R.CancellationToken.None);return new U(re,W,ie,ve.reconnectionToken,Pe)})}async function w(re,W){return S(re,async ie=>{const{protocol:ve,debugPort:Pe}=await o(ie,W,R.CancellationToken.None);return new Z(re,W,ie.reconnectionToken,ve,Pe)})}async function S(re,W){for(let ve=1;;ve++)try{const Pe=(0,I.$Dg)(),le=await f(re,Pe,null);return await W(le)}catch(Pe){if(ve<5)re.logService.error(`[remote-connection][attempt ${ve}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(Pe);else throw re.logService.error(`[remote-connection][attempt ${ve}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(Pe),B.triggerPermanentFailure(0,0,E.$vl.isHandled(Pe)),Pe}}async function y(re,W,ie){const ve=await f(re,(0,I.$Dg)(),null);return await h(ve,{host:W,port:ie},R.CancellationToken.None)}function C(re){return(0,u.$7g)(W=>new Promise((ie,ve)=>{const Pe=setTimeout(ie,re*1e3);W.onCancellationRequested(()=>{clearTimeout(Pe),ie()})}))}var O;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class z{constructor(W,ie){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.type=0}}e.$El=z;class F{constructor(W,ie,ve,Pe){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.durationSeconds=ve,this.c=Pe,this.type=1}skipWait(){this.c.cancel()}}e.$Fl=F;class T{constructor(W,ie,ve){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=ve,this.type=2}}e.$Gl=T;class L{constructor(W,ie,ve){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=ve,this.type=4}}e.$Hl=L;class N{constructor(W,ie,ve,Pe){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=ve,this.handled=Pe,this.type=3}}e.$Il=N;class B extends p.$Uc{static triggerPermanentFailure(W,ie,ve){this._permanentFailure=!0,this.f=W,this.g=ie,this.h=ve,this.j.forEach(Pe=>Pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(W,ie,ve,Pe,le){super(),this.t=W,this.u=ie,this.reconnectionToken=ve,this.protocol=Pe,this.w=le,this.m=this.B(new A.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new L(this.reconnectionToken,0,0)),this.B(Pe.onSocketClose(ue=>{const oe=X(this.t,this.reconnectionToken,!0);ue?ue.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${ue.hadError}).`),ue.error&&this.u.logService.error(ue.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${ue.wasClean}, code: ${ue.code}, reason: ${ue.reason}).`),ue.event&&this.u.logService.error(ue.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(Pe.onSocketTimeout(ue=>{const oe=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${ue.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ue.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ue.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,p.$Sc)(()=>{const ue=B.j.indexOf(this);ue>=0&&B.j.splice(ue,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ve=-1;do{ve++;const Pe=ve<ie.length?ie[ve]:ie[ie.length-1];try{if(Pe>0){const ue=C(Pe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,ue)),this.u.logService.info(`${W} waiting for ${Pe} seconds before reconnecting...`);try{await ue}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve+1)),this.u.logService.info(`${W} resolving connection...`);const le=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${le.connectTo}...`),await this.G(le,a(v)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve+1));break}catch(le){if(le.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}if(ve>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}if(E.$vl.isTemporarilyNotAvailable(le)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if((le.code==="ETIMEDOUT"||le.code==="ENETUNREACH"||le.code==="ECONNREFUSED"||le.code==="ECONNRESET")&&le.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if((0,P.$4)(le)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if(le instanceof E.$vl){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,E.$vl.isHandled(le));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}}while(!this.n&&!this.s)}C(W,ie,ve){this.w?B.triggerPermanentFailure(W,ie,ve):this.D(W,ie,ve)}D(W,ie,ve){this.m.fire(new N(this.reconnectionToken,W,ie,ve)),_(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Jl=B;class U extends B{constructor(W,ie,ve,Pe,le){super(1,W,Pe,le,!0),this.client=this.B(new b.$6h(le,{remoteAuthority:ie,clientId:ve},W.ipcLogger))}async G(W,ie){await l(W,ie)}}e.$Kl=U;class Z extends B{constructor(W,ie,ve,Pe,le){super(2,W,ve,Pe,!1),this.H=ie,this.debugPort=le}async G(W,ie){await o(W,this.H,ie)}}e.$Ll=Z;function _(re){try{re.acceptDisconnect();const W=re.getSocket();re.dispose(),W.dispose()}catch(W){(0,P.$1)(W)}}function Y(re){if(re&&re.type==="error"){const W=new Error(`Connection error: ${re.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function x(re,W){for(;re.length<W;)re+=" ";return re}function ce(re,W){return`[remote-connection][${x(m(re),13)}][${W.substr(0,5)}\u2026]`}function X(re,W,ie){return`${ce(re,W)}[${ie?"reconnect":"initial"}]`}function me(re,W){return`${X(W,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function ae(re){return`${Date.now()-re} ms`}}),define(Ee[86],Se([1,0,15]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=j,e.$tm=R,e.$um=P,e.$vm=A;function j($){return $.scheme===u.Schemas.vscodeRemote?$.authority:void 0}function R($){if(!$)return;const k=$.indexOf("+");return k<0?$:$.substr(0,k)}function P($){const{host:k,port:M}=p($);if(typeof M>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:M}}function A($,k){let{host:M,port:I}=p($);return typeof I>"u"&&(I=k),{host:M,port:I}}function p($){const k=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const M=$.match(/^(\[[0-9a-z:]+\])$/);if(M)return{host:M[1],port:void 0};const I=$.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:$,port:void 0}}}),define(Ee[25],Se([1,0,14,5,86]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=P,e.$Fm=I,e.$Gm=b,e.$Hm=E,e.$Im=v,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var p;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const n=typeof m=="string"?m:m.value,i=typeof a=="string"?a:a.value;return u.$lf(n,i)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Cm=$;class k{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const a of m)this.add(a)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$Dm=k;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,a){this.c.set($.toKey(m),a)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=M;function I(c){return b(c)}function b(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function E(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function v(c,m){if(m){const a=`onResolveRemoteAuthority:${(0,R.$tm)(m)}`;return!!c.activationEvents?.includes(a)}return!1}e.$Jm=(0,j.$hi)("IBuiltinExtensionsScannerService")}),define(Ee[140],Se([1,0,13,25]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(A,p){this.a.set(A,p)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const p=Object.create(null);for(const $ of A){const k=this.readActivationEvents($);k.length>0&&(p[j.$Cm.toKey($.identifier)]=k)}return p}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const p=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${j.$Cm.toKey(A.identifier)}`);if(!A.contributes)return p;for(const $ in A.contributes){const k=this.a.get($);if(!k)continue;const M=A.contributes[$],I=Array.isArray(M)?M:[M];try{k(I,p)}catch(b){(0,u.$1)(b)}}return p}}e.$KF=R,e.$LF=new R}),define(Ee[266],Se([1,0,3,5]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0,e.$xl=(0,j.$hi)("remoteSocketFactoryService");class R{constructor(){this.a={}}register(A,p){return this.a[A]??=[],this.a[A].push(p),(0,u.$Sc)(()=>{const $=this.a[A]?.indexOf(p);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find($=>$.supports(A))}connect(A,p,$,k){const M=this.b(A);if(!M)throw new Error(`No socket factory found for ${A}`);return M.connect(A,p,$,k)}}e.$yl=R}),define(Ee[267],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(R){try{const P=await this.c();if(P){const A=String(u.a++);return this.b.set(A,P),{id:A,data:P.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,P){if(!R.id)return!0;const A=this.b.get(R.id);if(!A)return!1;this.b.delete(R.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(R){try{return await this.d(R)}catch{}return R}}e.$E9b=u}),define(Ee[110],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0,e.$zl="signService",e.$Al=(0,u.$hi)(e.$zl)}),define(Ee[141],Se([1,0,267]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class j extends u.$E9b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(A=>new A.signer().sign(P))}h(){return new Promise((P,A)=>de(["vsda"],P,A))}}e.$Abc=j}),define(Ee[268],Se([1,0,11,50,30]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=A,e.$2o=p;function P($){if(u.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,k,M,I,b,E,v,c,m){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=v,a.sessionID=(0,R.$Dg)()+Date.now(),a.commitHash=I,a.version=b,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,u.$h)(u.$u),a["common.nodePlatform"]=j.$ec,a["common.nodeArch"]=M,a["common.product"]=m||"desktop",c&&(a["common.msftInternal"]=c);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(a["common.snap"]="true");const r=P(k);return r&&(a["common.platformDetail"]=r),a}function p($){const k=j.env.USERDNSDOMAIN;if(!k)return!1;const M=k.toLowerCase();return $.some(I=>M===I)}}),define(Ee[269],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,u.$hi)("telemetryService"),e.$Nl=(0,u.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var j;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var R;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Ee[87],Se([1,0,24,18,86,268,269]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=M,e.$$o=I,e.$_o=b,e.$ap=E,e.$bp=c,e.$cp=a,e.$dp=n,e.$ep=s;class p{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$3o=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=$,e.$5o=new $;class k{async publicLog(g,d,l){}async publicLogError(g,d,l){}}e.$6o=k,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function M(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}function I(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function b(t){const g=t.getValue(A.$Ul),d=t.getValue(A.$Vl);if(t.getValue(A.$Wl)===!1||d===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function E(t){const g={},d={},l={};m(t,l);for(let o in l){o=o.length>150?o.substr(o.length-149):o;const h=l[o];typeof h=="number"?d[o]=h:typeof h=="boolean"?d[o]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${h.length}`),g[o]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(g[o]=h)}return{properties:g,measurements:d}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const g=(0,R.$tm)(t);return v.has(g)?g:"other"}function m(t,g,d=0,l){if(t)for(const o of Object.getOwnPropertyNames(t)){const h=t[o],f=l?l+o:o;Array.isArray(h)?g[f]=(0,u.$Sn)(h):h instanceof Date?g[f]=h.toISOString():(0,j.$Wf)(h)?d<2?m(h,g,d+1,f+"."):g[f]=(0,u.$Sn)(h):g[f]=h}}function a(t,g){const d=t.msftInternalDomains||[],l=g.getValue("telemetry.internalTesting");return(0,P.$2o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const D of g)for(;;){const w=D.exec(t);if(!w)break;l.push([w.index,D.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(d="";;){const D=h.exec(t);if(!D)break;const w=l.some(([S,y])=>D.index<y&&S<h.lastIndex);!o.test(D[0])&&!w&&(d+=t.substring(f,D.index)+"<REDACTED: user-file-path>",f=h.lastIndex)}return f<t.length&&(d+=t.substr(f)),d}function r(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of g)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,g){return(0,u.$Pn)(t,d=>{if(d instanceof p||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,g);for(const o of g)l=l.replace(o,"");return l=r(l),l}})}}),define(Ee[270],Se([1,0,14,137,25,11,2,13,50,87]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=M,e.$hp=v,e.$ip=c,e.$jp=m,e.$kp=a,e.$lp=n,e.$mp=i,e.$np=r,e.$pp=s,e.$qp=g;function M(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$gf)(d.id,l.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(l){const o=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new b(l.identifier,o,h)}static parse(l){const o=I.exec(l);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(l,o,h="undefined"){this.version=o,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof b?M(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$gp=b;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(d){const l=E.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function c(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function a(d,l){return m(c(d??R.$ym,l))}function n(d,l){const o=[],h=f=>{for(const D of o)if(D.some(w=>M(l(w),l(f))))return D;return null};for(const f of d){const D=h(f);D?D.push(f):o.push([f])}return o}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new k.$3o(d.identifier.id),name:new k.$3o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$op=new R.$Cm("pprice.better-merge");function s(d,l){const o=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const f=h.shift();if(f&&o.every(D=>!M(D.identifier,{id:f}))){const D=d.filter(w=>M(w.identifier,{id:f}));D.length===1&&(o.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(d,l){if(!P.$k)return!1;let o;try{o=(await d.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await d.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){l.debug("Error while getting the os-release file.",(0,p.$0)(f))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(d,l){const o=await t(d,l),h=(0,j.$Mo)(o?"alpine":P.$u,$.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(Ee[271],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=u,e.$7r=j,e.$8r=R,e.$9r=P,e.$0r=A,e.$$r=p;function u($){return[...$.entries()]}function j($){return $?[...$.entries()]:[]}function R($){return new Map($)}function P($){return new Map($??[])}function A($){return Array.from($.entries()).map(k=>[k[0],u(k[1].map),j(k[1].descriptionMap)])}function p($){return new Map($.map(k=>[k[0],{map:R(k[1]),descriptionMap:P(k[2])}]))}}),define(Ee[272],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hub=void 0;class u{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,P,A=5){const p=P($=>{const k=typeof $=="string"?$:$.data;let M=this.a.get(R);if(M){M.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(R),A);M={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(R),p.dispose()}},this.a.set(R,M)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const P=this.a.get(R);P&&(this.a.delete(R),this.b(R,P.data.join("")))}}e.$hub=u}),define(Ee[273],Se([1,0,8,78,99,56,4,18,2,214,109,37]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.$Vw=e.IconFontDefinition=e.IconContribution=e.$Sw=void 0,e.$Tw=m,e.$Uw=a,e.$Sw={IconContribution:"base.contributions.icons"};var b;(function(s){function t(g,d){let l=g.defaults;for(;P.ThemeIcon.isThemeIcon(l);){const o=c.getIcon(l.id);if(!o)return;l=o.defaults}return l}s.getDefinition=t})(b||(e.IconContribution=b={}));var E;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function g(d){const l=o=>(0,p.$Uf)(o)?o:void 0;if(d&&Array.isArray(d.src)&&d.src.every(o=>(0,p.$Uf)(o.format)&&(0,p.$Uf)(o.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(o=>({format:o.format,location:$.URI.parse(o.location)}))}}s.fromJSONObject=g})(E||(e.IconFontDefinition=E={}));class v{constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,g,d,l){const o=this.b[t];if(o){if(d&&!o.description){o.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return o}const h={id:t,description:d,defaults:g,deprecationMessage:l};this.b[t]=h;const f={$ref:"#/definitions/icons"};return l&&(f.deprecationMessage=l),d&&(f.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const g=this.e.enum.indexOf(t);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,g){const d=this.f[t];return d||(this.f[t]=g,this.a.fire(),g)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(o,h)=>o.id.localeCompare(h.id),g=o=>{for(;P.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(o=>this.b[o]);for(const o of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${g(o)}"></i>|${o.id}|${P.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const o of l.filter(h=>!P.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${g(o)}"></i>|${o.id}|`);return d.join(`
`)}}const c=new v;I.$Zn.add(e.$Sw.IconContribution,c);function m(s,t,g,d){return c.registerIcon(s,t,g,d)}function a(){return c}function n(){const s=(0,R.$Cj)();for(const t in s){const g="\\"+s[t].toString(16);c.registerIcon(t,{fontCharacter:g})}}n(),e.$Vw="vscode://schemas/icons";const i=I.$Zn.as(M.$1n.JSONContribution);i.registerSchema(e.$Vw,c.getIconSchema());const r=new u.$th(()=>i.notifySchemaChanged(e.$Vw),200);c.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Ww=m("widget-close",j.$Gj.close,(0,k.localize)(2,null)),e.$Xw=m("goto-previous-location",j.$Gj.arrowUp,(0,k.localize)(3,null)),e.$Yw=m("goto-next-location",j.$Gj.arrowDown,(0,k.localize)(4,null)),e.$Zw=P.ThemeIcon.modify(j.$Gj.sync,"spin"),e.$1w=P.ThemeIcon.modify(j.$Gj.loading,"spin")}),define(Ee[88],Se([1,0,4,2,53,5,12]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$3v=e.$1v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wv=e.$Vv=void 0,e.$Xv=k,e.$Yv=I,e.$Zv=b,e.$2v=E,e.$4v=v,e.$5v=c,e.$Vv=(0,P.$hi)("tunnelService"),e.$Wv=(0,P.$hi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(n){return!!n.forwardPort}var M;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(M||(e.ProvidedOnAutoForward=M={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function b(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=I(j.URI.parse(s));if(t)return t}}}e.$1v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(n){return e.$1v.indexOf(n)>=0}e.$3v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$3v.indexOf(n)>=0}function c(n,i,r,s){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6v=m;let a=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$7d,this.onTunnelOpened=this.a.event,this.b=new u.$7d,this.onTunnelClosed=this.b.event,this.c=new u.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const g of t){const d=await g.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,g){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||E(i))&&(i=e.$1v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,g,d=!1,l,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${g}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(h,r,s,t,g,d,l,o);return f?f.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),g=t?await t.value:void 0;(!g||typeof g=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];E(i)?(s.push(...e.$1v),s.push(...e.$3v)):v(i)&&s.push(...e.$3v);const t=s.map(g=>this.e.get(g));for(const g of t){const d=g?.get(r);if(d)return d}}canTunnel(i){return!!I(i)}u(i,r,s,t,g,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const o=s;this.j.add(o);const h=t===void 0?s:t,f={elevationRequired:g?this.isPortPrivileged(h):!1},D={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==$.Private:void 0,protocol:l},w=i.forwardPort(D,f);return w?(this.q(r,s,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),w}};e.$7v=a,e.$7v=a=Je([Ve(0,A.$Nj),Ve(1,R.$Ni)],a)}),define(Ee[274],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,u.$hi)("IUriIdentityService")}),define(Ee[275],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$8v=void 0,e.$8v=(0,u.$hi)("editSessionIdentityService");var j;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(j||(e.EditSessionIdentityMatch=j={}))}),define(Ee[276],Se([1,0,15]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=j,e.$SL=R,e.$TL=P,e.$UL=A,e.$VL=p;function j($){return $.scheme!==u.Schemas.file&&$.scheme!==u.Schemas.vscodeRemote}function R($){if($.folders.length)return $.folders.every(k=>j(k.uri))?$.folders[0].uri:void 0;if($.configuration&&j($.configuration))return $.configuration}function P($){return R($)?.scheme}function A($){return R($)?.authority}function p($){return R($)!==void 0}}),define(Ee[42],Se([1,0,216,17,77,23,2,5,15]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=k,e.$si=M,e.$vi=I,e.$wi=b,e.$xi=E,e.$yi=c,e.$zi=m,e.$Ci=i,e.$Hi=r,e.$Ii=s,e.$Ki=t,e.$Li=g,e.$Mi=d,e.$qi=(0,p.$hi)("contextService");function k(l){const o=l;return typeof o?.id=="string"&&A.URI.isUri(o.uri)}function M(l){return typeof l?.id=="string"&&!k(l)&&!b(l)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function I(l,o){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,j.$oc)(l)}:o?e.$ti:e.$ui;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function b(l){const o=l;return typeof o?.id=="string"&&A.URI.isUri(o.configPath)}function E(l){const o=l;if(o?.uri)return{id:o.id,uri:A.URI.revive(o.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:A.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function c(l){const o=l;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function m(l){const o=l;return!!(o&&typeof o=="object"&&A.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class a{constructor(o,h,f,D,w){this.h=o,this.j=f,this.k=D,this.l=w,this.c=R.$ni.forUris(this.l,()=>!0),this.folders=h}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=R.$ni.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=a;class n{constructor(o,h){this.raw=h,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.$Ug)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=n;function i(l){return new n({uri:l,index:0,name:(0,P.$Qg)(l)},{uri:l.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,u.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function r(l,o){return P.$Lg.isEqualOrParent(l,o.untitledWorkspacesHome)}function s(l){let o;return A.URI.isUri(l)?o=l:o=l.configuration,o?.scheme===$.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Ji}function g(l,o){return!r(l,o)&&!s(l)}function d(l){return(typeof l=="string"?(0,j.$pc)(l):(0,P.$Sg)(l))===e.$Ei}}),define(Ee[277],Se([1,0,55,4,3,23,2,215,136,32,5,12,42,28,274,8,30,14,18]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=r,e.$ol=s,e.$pl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const o=l;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&A.URI.isUri(o.location)&&A.URI.isUri(o.globalStorageHome)&&A.URI.isUri(o.settingsResource)&&A.URI.isUri(o.keybindingsResource)&&A.URI.isUri(o.tasksResource)&&A.URI.isUri(o.snippetsHome)&&A.URI.isUri(o.extensionsResource))}e.$nl=(0,M.$hi)("IUserDataProfilesService");function s(l,o){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:o}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:o}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:o}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:o}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:o}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:o}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:o}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:o}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,o,h,f,D,w){return{id:l,name:o,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:w&&D?.useDefaultFlags?.globalState?w.globalStorageHome:(0,P.$Ug)(h,"globalStorage"),settingsResource:w&&D?.useDefaultFlags?.settings?w.settingsResource:(0,P.$Ug)(h,"settings.json"),keybindingsResource:w&&D?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,P.$Ug)(h,"keybindings.json"),tasksResource:w&&D?.useDefaultFlags?.tasks?w.tasksResource:(0,P.$Ug)(h,"tasks.json"),snippetsHome:w&&D?.useDefaultFlags?.snippets?w.snippetsHome:(0,P.$Ug)(h,"snippets"),extensionsResource:w&&D?.useDefaultFlags?.extensions?w.extensionsResource:(0,P.$Ug)(h,"extensions.json"),cacheHome:(0,P.$Ug)(f,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let g=class extends R.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,h,f,D){super(),this.t=o,this.u=h,this.w=f,this.y=D,this.f=!0,this.h=this.B(new j.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,P.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),h=[o];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$Uf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,P.$Rg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},o))}}catch(w){this.y.error(w)}const f=new E.$Bc,D=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[S,y]of Object.entries(w.workspaces)){const C=A.URI.parse(S),O=h.find(z=>z.id===y);O&&f.set(C,O)}if(w.emptyWindows)for(const[S,y]of Object.entries(w.emptyWindows)){const C=h.find(O=>O.id===y);C&&D.set(S,C)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:f,emptyWindows:D}}return this.z}D(){const o=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const h="Temp",f=new RegExp(`${(0,a.$Ze)(h)}\\s(\\d+)`);let D=0;for(const S of this.profiles){const y=f.exec(S.name),C=y?parseInt(y[1]):0;D=C>D?C:D}const w=`${h} ${D+1}`;return this.createProfile((0,u.$8i)((0,m.$Dg)()).toString(16),w,{transient:!0},o)}async createNamedProfile(o,h,f){return this.createProfile((0,u.$8i)((0,m.$Dg)()).toString(16),o,h,f)}async createProfile(o,h,f,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(o,h,f);return D&&await this.setProfileForWorkspace(D,w),w}async F(o,h,f){if(!(0,n.$Uf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const w=this.profiles.find(C=>C.name===h||C.id===o);if(w)return w;const S=t(o,h,(0,P.$Ug)(this.profilesHome,o),this.g,f,this.defaultProfile);await this.u.createFolder(S.location);const y=[];return this.j.fire({profile:S,join(C){y.push(C)}}),await c.Promises.settled(y),this.I([S],[],[]),S}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(o,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(D=>D.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);return f=t(f.id,h.name??f.name,f.location,this.g,{shortName:h.shortName??f.shortName,icon:h.icon===null?void 0:h.icon??f.icon,transient:h.transient??f.isTransient,useDefaultFlags:h.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);const f=[];this.m.fire({profile:h,join(D){f.push(D)}});try{await Promise.allSettled(f)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,k.$5k)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(o,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(D=>D.id===h.id);if(!f)throw new Error(`Profile '${h.name}' does not exist`);this.L(o,f)}unsetWorkspace(o,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(h=>h.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(o.map(h=>this.removeProfile(h)))}getProfileForWorkspace(o){const h=this.G(o);return A.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(o){return(0,b.$ri)(o)?o.uri:(0,b.$wi)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,o.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,o.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,o.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,o.location)))}I(o,h,f){const D=[...this.profiles,...o],w=[];this.s.profiles=[];for(let S of D)S.isDefault||h.some(y=>S.id===y.id)||(S=f.find(y=>S.id===y.id)??S,S.isTransient?this.s.profiles.push(S):w.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags}));this.P(w),this.z=void 0,this.J(o,h,f)}J(o,h,f){this.h.fire({added:o,removed:h,updated:f,all:this.profiles})}L(o,h,f){f=h?.isTransient?!0:f,f||this.L(o,void 0,!0);const D=this.G(o),w=f?this.s:this.C;A.URI.isUri(D)?(w.workspaces.delete(D),h&&w.workspaces.set(D,h)):(w.emptyWindows.delete(D),h&&w.emptyWindows.set(D,h)),f||this.M()}M(){const o={};for(const[f,D]of this.C.workspaces.entries())o[f.toString()]=D.id;const h={};for(const[f,D]of this.C.emptyWindows.entries())h[f.toString()]=D.id;this.R({workspaces:o,emptyWindows:h}),this.z=void 0}N(o){const h={},f=this.D();if(o.workspaces)for(const[w,S]of Object.entries(o.workspaces)){const y=A.URI.parse(S);h[w]=this.w.extUri.isEqual(y,f.location)?f.id:this.w.extUri.basename(y)}const D={};if(o.emptyWindows)for(const[w,S]of Object.entries(o.emptyWindows)){const y=A.URI.parse(S);D[w]=this.w.extUri.isEqual(y,f.location)?f.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$ql=g,e.$ql=g=Je([Ve(0,$.$oi),Ve(1,k.$Nk),Ve(2,v.$ll),Ve(3,I.$Nj)],g);class d extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$rl=d}),define(Ee[278],Se([1,0,8,4,3,58,18,194,5,277]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=E,e.$Op=c,e.$Qp=a,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,$.$hi)("storageService");var M;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var b;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function E(n){const i=n.get(e.$Kp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends R.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new j.$0d),this.c=this.B(new j.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return j.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Kp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,g=!1){if((0,A.$4f)(r)){this.remove(i,s,g);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,g)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const g of Object.keys(t))t[g]===r&&s.push(g);return s}z(i,r,s,t=!1){const g=this.J(r);typeof s=="number"?g[i]!==s&&(g[i]=s,this.P(r)?.set(e.$Kp,JSON.stringify(g),t)):typeof g[i]=="number"&&(delete g[i],this.P(r)?.set(e.$Kp,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Jp,i)===!0}async flush(i=M.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case M.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return a(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(M.NONE),(0,k.$ml)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||c(r)&&c(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[g,d]of i)t.add(g),r.get(g)!==d&&this.u(s,{key:g,external:!0});for(const[g]of r.items)t.has(g)||this.u(s,{key:g,external:!0})})}}e.$Np=v;function c(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends v{constructor(){super(),this.U=this.B(new p.$Hp(new p.$Ip,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Hp(new p.$Ip,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Hp(new p.$Ip,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Pp=m;async function a(n,i,r,s,t,g){const d=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,o=new Map;n.forEach((C,O)=>{l.set(O,C),o.set(O,d(C))});const h=new Map,f=new Map;i.forEach((C,O)=>{h.set(O,C),f.set(O,d(C))});const D=new Map,w=new Map;r.forEach((C,O)=>{D.set(O,C),w.set(O,d(C))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const S=[];if(l.forEach((C,O)=>{S.push({key:O,value:C})}),console.table(S),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((O,z)=>{C.push({key:z,value:O})}),console.table(C),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${g})`);const y=[];D.forEach((C,O)=>{y.push({key:O,value:C})}),console.table(y),console.groupEnd(),console.log(w)}}),define(Ee[111],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class u{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const P=this.c++;return this.b.set(P,R),this.e(),P}get(R,P){return this.b.has(R)?this.b.get(R)[P]:void 0}delete(R){this.b.delete(R),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Jic=u}),define(Ee[59],Se([1,0,15,23,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;class P{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new j.$Jg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Oic=P,e.$Pic=(0,R.$hi)("IExtHostFileSystemInfo")}),define(Ee[27],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=void 0,e.$SO=(0,u.$hi)("IExtHostInitDataService")}),define(Ee[279],Se([1,0,222,12,259,27]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;let A=class extends R.$1P{constructor($,k,M){const I=M.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",b=M.remote.isRemote?(0,u.localize)(0,null):$?(0,u.localize)(1,null):(0,u.localize)(2,null);super(k.createLogger(I,{name:b}))}};e.$Vkc=A,e.$Vkc=A=Je([Ve(1,j.$Oj),Ve(2,P.$SO)],A)}),define(Ee[280],Se([1,0,8]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=e.$xjc=void 0;class j{constructor(A,p,$){this.h=new Map,this.a=A,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new u.$th(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of k.values())M.complete()}catch(M){for(const I of k.values())I.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,p){let $=this.f[A];return typeof $>"u"&&($=p),$}update(A,p){this.f[A]=p;const $=this.h.get(A);if($!==void 0)return $.p;const k=new u.$Eh;return this.h.set(A,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$xjc=j;class R extends j{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,p){super(A.identifier.value,!0,p),this.j=A}}e.$yjc=R}),define(Ee[281],Se([1,0,4,2]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;class R{constructor(A){this.c=A,this.a=new u.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,p,$,k){const I=this.c.getNotebookDocument(j.URI.revive(A)).acceptModelChanged(p.value,$,k);this.b.fire(I)}$acceptDirtyStateChanged(A,p){this.c.getNotebookDocument(j.URI.revive(A)).acceptDirty(p)}$acceptModelSaved(A){const p=this.c.getNotebookDocument(j.URI.revive(A));this.a.fire(p.apiNotebook)}}e.$lkc=R}),define(Ee[20],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0,e.$CO=(0,u.$hi)("IExtHostRpcService");class j{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$DO=j}),define(Ee[282],Se([1,0,25,4]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class R{#e;constructor(A,p){this.b=new j.$7d,this.onDidChange=this.b.event,this.a=u.$Cm.toKey(A.identifier),this.#e=p,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,p){return this.#e.store(this.a,A,p)}delete(A){return this.#e.delete(this.a,A)}}e.$Fjc=R}),define(Ee[66],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=e.$8ic=void 0,e.$8ic=(0,u.$hi)("IURITransformerService");class j{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$9ic=j}),define(Ee[283],Se([1,0,21]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnb=R,e.$Mnb=A;class j{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function R(p,$){if($.serializeBuffersForPostMessage){const k=new j,I=JSON.stringify(p,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v)};if(ArrayBuffer.isView(v)){const c=P(v);if(c)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v.buffer),view:{type:c,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),b=k.buffers.map(E=>{const v=new Uint8Array(E);return u.$ue.wrap(v)});return{message:I,buffers:b}}else return{message:JSON.stringify(p),buffers:[]}}function P(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(p,$){const k=$.map(b=>{const E=new ArrayBuffer(b.byteLength);return new Uint8Array(E).set(b.buffer),E}),M=$.length?(b,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:c}=v,m=k[c];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(p,M),arrayBuffers:k}}}),define(Ee[284],Se([1,0,285,399,400,62,2,12,401]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=M;const k=!1;function M(i,r,s,t,g,d){const l=d.environment.useHostProxy,o=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,g,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>b(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case p.LogLevel.Trace:return $.LogLevel.Trace;case p.LogLevel.Debug:return $.LogLevel.Debug;case p.LogLevel.Info:return $.LogLevel.Info;case p.LogLevel.Warning:return $.LogLevel.Warning;case p.LogLevel.Error:return $.LogLevel.Error;case p.LogLevel.Off:return $.LogLevel.Off;default:return S(w)}function S(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:o,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),o){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const S=i.loadCertificates();S.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),w.push(S)}return(await Promise.all(w)).flat()},env:process.env},f=(0,$.createProxyResolver)(h),D=I(h,f);return c(s,D)}function I(i,r){return{http:Object.assign(u,(0,$.createHttpPatch)(i,u,r)),https:Object.assign(j,(0,$.createHttpPatch)(i,j,r)),net:Object.assign(P,(0,$.createNetPatch)(i,P)),tls:Object.assign(R,(0,$.createTlsPatch)(i,R))}}function b(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",k)&&!!r.get("systemCertificates")}function E(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",k)&&!!r.get("systemCertificates")}const v=new Map;function c(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,g=t._load;t._load=function(l,o,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return g.apply(this,arguments);const f=s.findSubstr(A.URI.file(o.filename));let D=v.get(f);if(D||v.set(f,D={}),!D[l]){const w=r[l];D[l]={...w}}return D[l]}})}async function m(i,r,s,t,g,d,l,o){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const f=l||h,D=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(n(r,D,g),D.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!o.kerberosRequested)try{o.kerberosRequested=!0;const w=await new Promise((z,F)=>{de(["kerberos"],z,F)}),S=new URL(d),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${S.hostname}`:`HTTP@${S.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${y}`),"Negotiate "+await(await w.initializeClient(y)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let a=!1;function n(i,r,s){a||!r.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(Ee[286],Se([1,0,133]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=R;function j(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function R(P){return new u.$jn(j(P))}}),define(Ee[142],Se([1,0,232,18,2,3,5,37,32,15,46,186,40]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$mF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$dF=e.EditorInputCapabilities=e.$cF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=void 0,e.$7E=c,e.$8E=m,e.$9E=a,e.$0E=n,e.$$E=i,e.$_E=r,e.$aF=s,e.$bF=t,e.$eF=f,e.$fF=w,e.$gF=S,e.$hF=y,e.$iF=C,e.$jF=O,e.$kF=z,e.$lF=U,e.$nF=Y,e.$oF=ce,e.$pF=X,e.$qF=me,e.$2E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$3E={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$4E="workbench.editor.sidebysideEditor",e.$5E="workbench.editors.textDiffEditor",e.$6E="workbench.editors.binaryResourceDiffEditor";var E;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function c(ae){const re=ae;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}function m(ae,re,W){for(const ie of W.visibleEditorPanes)if(ie.group.id===re&&ae.matches(ie.input))return ie.getViewState()}function a(ae){if(f(ae))return!1;const re=ae;return R.URI.isUri(re?.resource)}function n(ae){if(f(ae))return!1;const re=ae;return re?.original!==void 0&&re.modified!==void 0}function i(ae){if(f(ae))return!1;const re=ae;return!re||re.resources&&!Array.isArray(re.resources)?!1:!!re.resources||!!re.multiDiffSource}function r(ae){if(f(ae)||n(ae))return!1;const re=ae;return re?.primary!==void 0&&re.secondary!==void 0}function s(ae){if(f(ae))return!1;const re=ae;return re?re.resource===void 0||re.resource.scheme===k.Schemas.untitled||re.forceUntitled===!0:!1}function t(ae){if(f(ae))return!1;const re=ae;return R.URI.isUri(re?.base?.resource)&&R.URI.isUri(re?.input1?.resource)&&R.URI.isUri(re?.input2?.resource)&&R.URI.isUri(re?.result?.resource)}var g;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var d;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class l{constructor(){this.a=new Map}registerSource(re,W){let ie=this.a.get(re);return ie||(ie={source:re,label:W},this.a.set(re,ie)),ie.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.$cF=new l;var o;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad",ae[ae.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(o||(e.EditorInputCapabilities=o={}));class h extends P.$Uc{}e.$dF=h;function f(ae){return ae instanceof h}function D(ae){const re=ae;return R.URI.isUri(re?.preferredResource)}function w(ae){const re=ae;return f(re?.primary)&&f(re?.secondary)}function S(ae){const re=ae;return f(re?.modified)&&f(re?.original)}function y(ae,re,W,ie,ve){return me(ie,[(0,I.$4i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const Pe={...W,limits:{size:Number.MAX_VALUE}};ae.openEditor(re,Pe)}}),(0,I.$4i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}function C(ae){return f(ae?.editor)}function O(ae){const re=ae;return C(ae)&&re?.group!==void 0}function z(ae){const re=ae;return typeof re?.groupId=="number"&&f(re.editor)}var F;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var T;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LABEL=2]="GROUP_LABEL",ae[ae.GROUP_LOCKED=3]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=4]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=5]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=6]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=8]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=10]="EDITOR_PIN",ae[ae.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ae[ae.EDITOR_STICKY=12]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=13]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var L;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class N{getOriginalUri(re,W){if(!re)return;if(t(re))return e.$mF.getOriginalUri(re.result,W);if(W?.supportSideBySide){const{primary:ve,secondary:Pe}=this.a(re);if(ve&&Pe){if(W?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===L.ANY)return this.getOriginalUri(ve,{filterByScheme:W.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:W.filterByScheme});re=W.supportSideBySide===L.PRIMARY?ve:Pe}}if(n(re)||i(re)||r(re)||t(re))return;const ie=D(re)?re.preferredResource:re.resource;return!ie||!W||!W.filterByScheme?ie:this.b(ie,W.filterByScheme)}a(re){return w(re)||r(re)?{primary:re.primary,secondary:re.secondary}:S(re)||n(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,W){if(!re)return;if(t(re))return e.$mF.getCanonicalUri(re.result,W);if(W?.supportSideBySide){const{primary:ve,secondary:Pe}=this.a(re);if(ve&&Pe){if(W?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===L.ANY)return this.getCanonicalUri(ve,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:W.filterByScheme});re=W.supportSideBySide===L.PRIMARY?ve:Pe}}if(n(re)||i(re)||r(re)||t(re))return;const ie=re.resource;return!ie||!W||!W.filterByScheme?ie:this.b(ie,W.filterByScheme)}b(re,W){if(Array.isArray(W)){if(W.some(ie=>re.scheme===ie))return re}else if(W===re.scheme)return re}}var B;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(B||(e.EditorCloseMethod=B={}));function U(ae,re,W,ie){if(!ae.isSticky(re))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return W===B.MOUSE||W===B.KEYBOARD;case"mouse":return W===B.MOUSE;case"keyboard":return W===B.KEYBOARD}return!1}e.$mF=new N;var Z;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class _{constructor(){this.c=new Map,this.d=new Map}start(re){const W=this.a=re.get(A.$gi);for(const[ie,ve]of this.c)this.e(ie,ve,W);this.c.clear()}e(re,W,ie){const ve=ie.createInstance(W);this.d.set(re,ve)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,j.$6f)(this.b)}registerEditorSerializer(re,W){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,W,this.a):this.c.set(re,W),(0,P.$Sc)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}p.$Zn.add(e.$2E.EditorFactory,new _);async function Y(ae,re,W){return!ae||!ae.length?[]:await Promise.all(ae.map(async ie=>{const ve=R.URI.revive(ie.fileUri);if(!ve){W.info("Cannot resolve the path because it is not valid.",ie);return}if(!await re.canHandleResource(ve)){W.info("Cannot resolve the path because it cannot be handled",ie);return}let le=ie.exists,ue=ie.type;if(typeof le!="boolean"||typeof ue!="number")try{ue=(await re.stat(ve)).isDirectory?$.FileType.Directory:$.FileType.Unknown,le=!0}catch(K){W.error(K),le=!1}if(!le&&ie.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ie);return}if(ue===$.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ie);return}const oe={...ie.options,pinned:!0};return le?{resource:ve,options:oe}:{resource:ve,options:oe,forceUntitled:!0}}))}var x;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function ce(ae){const re=ae;if(!re)return!1;const W=re;if(W.modified)return ce(W.modified);const ie=re;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}function X(ae){return(0,M.$6i)(ae)}function me(ae,re,W){const ie=(0,M.$7i)(ae,re);return ie.forceMessage=W?.forceMessage,ie.forceSeverity=W?.forceSeverity,ie.allowDialog=W?.allowDialog,ie}}),define(Ee[287],Se([1,0,4,233,5,3,28,37,19,24,78,273]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$wF=e.ViewContentGroups=e.$uF=e.ViewContainerLocation=e.Extensions=e.$tF=e.$sF=e.$rF=void 0,e.$vF=v,e.$rF="views",e.$sF=(0,j.localize)(0,null),e.$tF=(0,I.$Tw)("default-view-icon",M.$Gj.window,(0,j.localize)(1,null));var b;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var E;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$uF=[0,1,2];function v(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class c extends P.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onDidRegister=this.c.event,this.f=this.B(new u.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,l,o){const h=this.get(d.id);if(h)return h;const f=d;return f.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,A.$yc)(this.g,l,[]).push(f),o?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:l}),f}deregisterViewContainer(d){for(const l of this.g.keys()){const o=this.g.get(l),h=o?.indexOf(d);if(h!==-1){o?.splice(h,1),o.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(o=>o?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}p.$Zn.add(b.ViewContainersRegistry,new c);var m;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(m||(e.ViewContentGroups=m={}));function a(g,d){const l=g.group??m.More,o=d.group??m.More;return l!==o?l.localeCompare(o):(g.order??5)-(d.order??5)}class n extends P.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:o})=>this.r(l,o)),this.c.fire(d)}deregisterViews(d,l){const o=this.s(d,l);o.length&&this.f.fire({views:o,viewContainer:l})}moveViews(d,l){for(const o of this.m.keys())if(o!==l){const h=this.s(d,o);h.length&&(this.r(h,l),this.g.fire({views:h,from:o,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const o=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(o)return o}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,P.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const o=new Map;for(const[h,f]of l)this.n.add(d,f),o.set(h,(0,P.$Sc)(()=>{this.n.delete(d,f),this.h.fire(d)}));return this.h.fire(d),o}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,o=>l.push(o)),l.sort(a)}r(d,l){let o=this.m.get(l);o||(o=[],this.m.set(l,o),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,j.localize)(2,null,h.id));o.push(h)}}s(d,l){const o=this.m.get(l);if(!o)return[];const h=[],f=[];for(const D of o)d.includes(D)?h.push(D):f.push(D);return h.length&&(f.length?this.m.set(l,f):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}p.$Zn.add(b.ViewsRegistry,new n),e.$wF=(0,R.$hi)("viewDescriptorService");var i;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,k.$Qn)(this,d),this.d=!!l,this.resolve=async o=>{if(l&&!this.c){const h=await l(o);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}o.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$xF=s;class t extends Error{constructor(d){super((0,j.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$yF=t}),define(Ee[288],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CF=void 0,e.$CF=(0,u.$hi)("IChatContributionService")}),define(Ee[289],Se([1,0,19,4,38,3,41,5,288]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.$xG=e.ChatAgentLocation=void 0;var k;(function(b){b[b.Panel=1]="Panel",b[b.Terminal=2]="Terminal",b[b.Notebook=3]="Notebook"})(k||(e.ChatAgentLocation=k={})),function(b){function E(v){switch(v){case"panel":return b.Panel;case"terminal":return b.Terminal;case"notebook":return b.Notebook}return b.Panel}b.fromRaw=E}(k||(e.ChatAgentLocation=k={})),e.$xG=(0,p.$hi)("chatAgentService");let M=class extends P.$Uc{static{this.AGENT_LEADER="@"}constructor(E,v){super(),this.g=E,this.h=v,this.b=new Map,this.f=this.B(new j.$7d),this.onDidChangeAgents=this.f.event}dispose(){super.dispose(),this.b.clear()}registerAgent(E,v){if(this.b.has(E))throw new Error(`Already registered an agent with id ${E}`);const c=this.getAgent(E);if(!c)throw new Error(`Unknown agent: ${E}`);const m={data:c,impl:v};return this.b.set(E,m),this.f.fire(new I(c,v)),(0,P.$Sc)(()=>{this.b.delete(E)&&this.f.fire(void 0)})}registerDynamicAgent(E,v){const c={data:E,impl:v};return this.b.set(E.id,c),this.f.fire(new I(E,v)),(0,P.$Sc)(()=>{this.b.delete(E.id)&&this.f.fire(void 0)})}updateAgent(E,v){const c=this.b.get(E);if(!c?.impl)throw new Error(`No activated agent with id ${E} registered`);c.data.metadata={...c.data.metadata,...v},this.f.fire(new I(c.data,c.impl))}getDefaultAgent(){return this.getActivatedAgents().find(E=>!!E.isDefault)}getSecondaryAgent(){return R.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getRegisteredAgents(){const E=this;return this.g.registeredParticipants.map(v=>({extensionId:v.extensionId,id:v.name,metadata:{description:v.description},isDefault:v.isDefault,defaultImplicitVariables:v.defaultImplicitVariables,locations:(0,u.$Lb)(v.locations)?v.locations.map(k.fromRaw):[k.Panel],get slashCommands(){return(v.commands??[]).filter(m=>!m.when||E.h.contextMatchesRules(A.$fj.deserialize(m.when)))}}))}getAgents(){const E=this.getRegisteredAgents(),v=Array.from(this.b.values()).map(m=>m.data),c=[...E,...v];return(0,u.$Mb)(c,m=>m.id)}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).map(E=>new I(E.data,E.impl))}getAgent(E){return this.getAgents().find(v=>v.id===E)}async invokeAgent(E,v,c,m,a){const n=this.b.get(E);if(!n?.impl)throw new Error(`No activated agent with id ${E}`);return await n.impl.invoke(v,c,m,a)}async getFollowups(E,v,c,m,a){const n=this.b.get(E);if(!n?.impl)throw new Error(`No activated agent with id ${E}`);return n.impl?.provideFollowups?n.impl.provideFollowups(v,c,m,a):[]}};e.$yG=M,e.$yG=M=Je([Ve(0,$.$CF),Ve(1,A.$zj)],M);class I{constructor(E,v){this.b=E,this.d=v}get id(){return this.b.id}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(E,v,c,m){return this.d.invoke(E,v,c,m)}async provideFollowups(E,v,c,m){return this.d.provideFollowups?this.d.provideFollowups(E,v,c,m):[]}provideWelcomeMessage(E){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E)}provideSampleQuestions(E){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E)}}e.$zG=I}),define(Ee[290],Se([1,0,2,29,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=e.$IF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$GF=P,e.$HF=A;function P(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof u.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(j.$bt.isIRange)}function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(P)}var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$IF=(0,R.$hi)("IChatService"),e.$JF="accessibility.voice.keywordActivation"}),define(Ee[143],Se([1,0,4,8,234]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fob=void 0;class P{constructor(){this.f=new Map,this.m=[],this.n=new u.$7d,this.o=new u.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,k,M){const I={command:p};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof M=="number"){const b=setTimeout(()=>{clearTimeout(b);const E=this.f.get(I.seq);if(E){this.f.delete(I.seq);const v={type:"response",seq:0,request_seq:I.seq,success:!1,command:p,message:(0,R.localize)(0,null,M,p)};E(v)}},M)}return k&&this.f.set(I.seq,k),I.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,j.$ih)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,k)=>p.set(k,$)),await(0,j.$ih)(500),p.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$fob=P}),define(Ee[291],Se([1,0,2,235,41,5]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$NI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$MI=e.MemoryRangeType=e.State=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=void 0,e.$LI=$,e.$AH="workbench.view.debug",e.$BH="workbench.debug.variablesView",e.$CH="workbench.debug.watchExpressionsView",e.$DH="workbench.debug.callStackView",e.$EH="workbench.debug.loadedScriptsView",e.$FH="workbench.debug.breakPointsView",e.$GH="workbench.debug.disassemblyView",e.$HH="workbench.panel.repl",e.$IH="workbench.panel.repl.view",e.$JH=new R.$yj("debugType",void 0,{type:"string",description:j.localize(0,null)}),e.$KH=new R.$yj("debugConfigurationType",void 0,{type:"string",description:j.localize(1,null)}),e.$LH=new R.$yj("debugState","inactive",{type:"string",description:j.localize(2,null)}),e.$MH="debugUx",e.$NH=new R.$yj(e.$MH,"default",{type:"string",description:j.localize(3,null)}),e.$OH=new R.$yj("hasDebugged",!1,{type:"boolean",description:j.localize(4,null)}),e.$PH=new R.$yj("inDebugMode",!1,{type:"boolean",description:j.localize(5,null)}),e.$QH=new R.$yj("inDebugRepl",!1,{type:"boolean",description:j.localize(6,null)}),e.$RH=new R.$yj("breakpointWidgetVisible",!1,{type:"boolean",description:j.localize(7,null)}),e.$SH=new R.$yj("inBreakpointWidget",!1,{type:"boolean",description:j.localize(8,null)}),e.$TH=new R.$yj("breakpointsFocused",!0,{type:"boolean",description:j.localize(9,null)}),e.$UH=new R.$yj("watchExpressionsFocused",!0,{type:"boolean",description:j.localize(10,null)}),e.$VH=new R.$yj("watchExpressionsExist",!1,{type:"boolean",description:j.localize(11,null)}),e.$WH=new R.$yj("variablesFocused",!0,{type:"boolean",description:j.localize(12,null)}),e.$XH=new R.$yj("expressionSelected",!1,{type:"boolean",description:j.localize(13,null)}),e.$YH=new R.$yj("breakpointInputFocused",!1,{type:"boolean",description:j.localize(14,null)}),e.$ZH=new R.$yj("callStackItemType",void 0,{type:"string",description:j.localize(15,null)}),e.$1H=new R.$yj("callStackSessionIsAttach",!1,{type:"boolean",description:j.localize(16,null)}),e.$2H=new R.$yj("callStackItemStopped",!1,{type:"boolean",description:j.localize(17,null)}),e.$3H=new R.$yj("callStackSessionHasOneThread",!1,{type:"boolean",description:j.localize(18,null)}),e.$4H=new R.$yj("watchItemType",void 0,{type:"string",description:j.localize(19,null)}),e.$5H=new R.$yj("canViewMemory",void 0,{type:"boolean",description:j.localize(20,null)}),e.$6H=new R.$yj("breakpointItemType",void 0,{type:"string",description:j.localize(21,null)}),e.$7H=new R.$yj("breakpointItemBytes",void 0,{type:"boolean",description:j.localize(22,null)}),e.$8H=new R.$yj("breakpointHasModes",!1,{type:"boolean",description:j.localize(23,null)}),e.$9H=new R.$yj("breakpointSupportsCondition",!1,{type:"boolean",description:j.localize(24,null)}),e.$0H=new R.$yj("loadedScriptsSupported",!1,{type:"boolean",description:j.localize(25,null)}),e.$$H=new R.$yj("loadedScriptsItemType",void 0,{type:"string",description:j.localize(26,null)}),e.$_H=new R.$yj("focusedSessionIsAttach",!1,{type:"boolean",description:j.localize(27,null)}),e.$aI=new R.$yj("focusedSessionIsNoDebug",!1,{type:"boolean",description:j.localize(28,null)}),e.$bI=new R.$yj("stepBackSupported",!1,{type:"boolean",description:j.localize(29,null)}),e.$cI=new R.$yj("restartFrameSupported",!1,{type:"boolean",description:j.localize(30,null)}),e.$dI=new R.$yj("stackFrameSupportsRestart",!1,{type:"boolean",description:j.localize(31,null)}),e.$eI=new R.$yj("jumpToCursorSupported",!1,{type:"boolean",description:j.localize(32,null)}),e.$fI=new R.$yj("stepIntoTargetsSupported",!1,{type:"boolean",description:j.localize(33,null)}),e.$gI=new R.$yj("breakpointsExist",!1,{type:"boolean",description:j.localize(34,null)}),e.$hI=new R.$yj("debuggersAvailable",!1,{type:"boolean",description:j.localize(35,null)}),e.$iI=new R.$yj("debugExtensionAvailable",!0,{type:"boolean",description:j.localize(36,null)}),e.$jI=new R.$yj("debugProtocolVariableMenuContext",void 0,{type:"string",description:j.localize(37,null)}),e.$kI=new R.$yj("debugSetVariableSupported",!1,{type:"boolean",description:j.localize(38,null)}),e.$lI=new R.$yj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:j.localize(39,null)}),e.$mI=new R.$yj("debugSetExpressionSupported",!1,{type:"boolean",description:j.localize(40,null)}),e.$nI=new R.$yj("breakWhenValueChangesSupported",!1,{type:"boolean",description:j.localize(41,null)}),e.$oI=new R.$yj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:j.localize(42,null)}),e.$pI=new R.$yj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:j.localize(43,null)}),e.$qI=new R.$yj("terminateDebuggeeSupported",!1,{type:"boolean",description:j.localize(44,null)}),e.$rI=new R.$yj("suspendDebuggeeSupported",!1,{type:"boolean",description:j.localize(45,null)}),e.$sI=new R.$yj("variableEvaluateNamePresent",!1,{type:"boolean",description:j.localize(46,null)}),e.$tI=new R.$yj("variableIsReadonly",!1,{type:"boolean",description:j.localize(47,null)}),e.$uI=new R.$yj("variableValue",!1,{type:"string",description:j.localize(48,null)}),e.$vI=new R.$yj("variableType",!1,{type:"string",description:j.localize(49,null)}),e.$wI=new R.$yj("variableName",!1,{type:"string",description:j.localize(50,null)}),e.$xI=new R.$yj("variableLanguage",!1,{type:"string",description:j.localize(51,null)}),e.$yI=new R.$yj("variableExtensionId",!1,{type:"string",description:j.localize(52,null)}),e.$zI=new R.$yj("exceptionWidgetVisible",!1,{type:"boolean",description:j.localize(53,null)}),e.$AI=new R.$yj("multiSessionRepl",!1,{type:"boolean",description:j.localize(54,null)}),e.$BI=new R.$yj("multiSessionDebug",!1,{type:"boolean",description:j.localize(55,null)}),e.$CI=new R.$yj("disassembleRequestSupported",!1,{type:"boolean",description:j.localize(56,null)}),e.$DI=new R.$yj("disassemblyViewFocus",!1,{type:"boolean",description:j.localize(57,null)}),e.$EI=new R.$yj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:j.localize(58,null)}),e.$FI=new R.$yj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:j.localize(59,null)});const A=n=>j.localize(60,null,n);e.$GI=A,e.$HI="editor.contrib.debug",e.$II="editor.contrib.breakpoint",e.$JI="debug",e.$KI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:j.localize(61,null)};var p;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(p||(e.State=p={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$MI="vscode-debug-memory";var M;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(M||(e.DataBreakpointSetType=M={}));var I;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(I||(e.DebugConfigurationProviderTriggerKind=I={}));var b;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$NI=(0,P.$hi)("debugService");var E;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(E||(e.BreakpointWidgetContext=E={}));var v;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(v||(e.DebugVisualizationType=v={}));var c;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(c||(e.DebugTreeItemCollapsibleState=c={}));var m;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(m||(e.IDebugVisualizationTreeItem=m={}));var a;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:u.URI.revive(i.iconPath.light),dark:u.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(a||(e.IDebugVisualization=a={}))}),define(Ee[292],Se([1,0,14,2,17,24,15,29,22,19]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OG=void 0,e.$CG=I,e.$DG=b,e.$EG=E,e.$FG=v,e.$GG=c,e.$HG=m,e.$IG=a,e.$JG=i,e.$KG=t,e.$LG=g,e.$MG=l,e.$NG=h;const M=/{([^}]+)}/g;function I(D,w,S){return D.replace(M,function(y,C){return w&&C.length>0&&C[0]!=="_"?y:S&&S.hasOwnProperty(C)?S[C]:y})}function b(D){const w={};for(const S of Object.keys(D))S.startsWith("!")||(w[S]=D[S]);return w}function E(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||E(D.parentSession))}function v(D){let w=D.configuration.type;if(w)return w==="vslsShare"&&(w=D.configuration.adapterProxy.configuration.type),(0,u.$lf)(w,"extensionhost")||(0,u.$lf)(w,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function c(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,w,S){let y,C=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=O.exec(D);){const F=z.index+1,T=F+z[0].length;if(F<=w&&T>=S){y=z[0],C=F;break}}if(y){const F=/\w+/g;let T=null;for(;(T=F.exec(y))&&!(T.index+1+C+T[0].length>=S););T&&(y=y.substring(0,F.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function a(D,w,S,y){if(D.evaluatableExpressionProvider.has(w)){const C=D.evaluatableExpressionProvider.ordered(w),O=(0,k.$Hb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression(w,S,y??$.CancellationToken.None)}catch{return}})));if(O.length>0){let z=O[0].expression;const F=O[0].range;return z||(z=w.getLineContent(S.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:z}}}else{const C=w.getLineContent(S.lineNumber),{start:O,end:z}=m(C,S.column,S.column),F=C.substring(O-1,z);return{matchingExpression:F,range:new p.$bt(S.lineNumber,O,S.lineNumber,O+F.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return j.URI.parse(D.path);if((0,R.$jc)(D.path))return j.URI.file(D.path)}return D.path}function s(D){if(typeof D.path=="object"){const w=j.URI.revive(D.path);if(w)return w.scheme===A.Schemas.file?w.fsPath:w.toString()}return D.path}function t(D,w){const S=w?r:s,y=(0,P.$Nn)(D);return d(y,(C,O)=>{C&&O&&(O.path=S(O))}),y}function g(D,w){const S=w?r:s,y=(0,P.$Nn)(D);return d(y,(C,O)=>{!C&&O&&(O.path=S(O))}),y}function d(D,w){switch(D.type){case"event":{const S=D;switch(S.event){case"output":w(!1,S.body.source);break;case"loadedSource":w(!1,S.body.source);break;case"breakpoint":w(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":w(!0,S.arguments.source);break;case"breakpointLocations":w(!0,S.arguments.source);break;case"source":w(!0,S.arguments.source);break;case"gotoTargets":w(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>w(!1,y));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>w(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>w(!1,y));break;case"scopes":S.body.scopes.forEach(y=>w(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>w(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>w(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(C=>w(!1,C.location));break;default:break}break}}}function l(D){return D.filter(w=>!w.presentation?.hidden).sort((w,S)=>w.presentation?S.presentation?w.presentation.group?S.presentation.group?w.presentation.group!==S.presentation.group?w.presentation.group.localeCompare(S.presentation.group):o(w.presentation.order,S.presentation.order):-1:S.presentation.group?1:o(w.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function o(D,w){return typeof D!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:D-w}async function h(D,w){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(S!=="none"&&(await w.saveAll(),S==="allEditorsInActiveGroup")){const y=w.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await w.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const f=(D,w)=>!D||!w?D===w:D.name===w.name&&D.path===w.path&&D.sourceReference===w.sourceReference;e.$OG=f}),define(Ee[293],Se([1,0,52,62,24,17,11,14,31,236,143]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=e.$4kc=e.$3kc=e.$2kc=void 0;class I extends M.$fob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(I.b);for(const s of r){const t=s.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$2kc=I;class b extends I{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$3kc=b;class E extends b{constructor(a){super(),this.z=a}y(a){return j.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$4kc=E;class v extends b{constructor(a){super(),this.z=a}y(a){return j.createConnection(this.z.path,a)}}e.$5kc=v;class c extends I{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(P.$jc(a)){if(!await $.Promises.exists(a))throw new Error(k.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=R.$Qn(R.$Nn(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const g=u.fork(n[0],n.slice(1),t);if(!g.pid)throw new Error(k.localize(2,null,n[0]));this.x=g}else throw new Error(k.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(a,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),A.$i?new Promise((a,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=P.$kc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(P.$jc(a.program)?i.program=a.program:i.program=P.$kc(n,a.program)),a.args&&(i.args=a.args);const r=a;return r.win&&(i.win=c.A(r.win,n)),r.winx86&&(i.winx86=c.A(r.winx86,n)),r.windows&&(i.windows=c.A(r.windows,n)),r.osx&&(i.osx=c.A(r.osx,n)),r.linux&&(i.linux=c.A(r.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const l of a)if(l.contributes){const o=l.contributes.debuggers;o&&o.length>0&&o.filter(h=>typeof h.type=="string"&&p.$lf(h.type,n)).forEach(h=>{const f=c.A(h,l.extensionLocation.fsPath);i=R.$Qn(i,f,l.isBuiltin)})}let r;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:A.$i?r=i.win||i.windows:A.$j?r=i.osx:A.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,g=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(g)return{type:"executable",command:g,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$6kc=c}),define(Ee[294],Se([1,0,52,34,11]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=A,e.$8kc=$;function P(k,M){return new Promise((I,b)=>{let E="";const v=u.spawn(k,M);v.pid&&v.stdout.on("data",c=>{E+=c.toString()}),v.on("error",c=>{b(c)}),v.on("close",c=>{I(E)})})}async function A(k){if(k)if(R.$i){const M=await new Promise((I,b)=>{de(["@vscode/windows-process-tree"],I,b)});return new Promise(I=>{M.getProcessTree(k,b=>{I(!!b&&b.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(M=>{const I=M.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},M=>!0);return Promise.resolve(!0)}var p;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(p||(p={}));function $(k,M,I,b){k=k.trim().toLowerCase();let E;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?E=1:k.indexOf("cmd.exe")>=0?E=0:k.indexOf("bash")>=0?E=2:R.$i?E=0:E=2;let v,c=" ";switch(E){case 1:if(v=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),b){const m=(0,j.$mg)(b);m&&(c+=`${m}:; `),c+=`cd ${v(b)}; `}if(M.length>0){const m=M.shift(),a=I?m:v(m);c+=a[0]==="'"?`& ${a} `:`${a} `;for(const n of M)c+=n==="<"||n===">"||I?n:v(n),c+=" "}break;case 0:if(v=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>m.includes(a))||m.length===0?`"${m}"`:m),b){const m=(0,j.$mg)(b);m&&(c+=`${m}: && `),c+=`cd ${v(b)} && `}for(const m of M)c+=m==="<"||m===">"||I?m:v(m),c+=" ";break;case 2:{v=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),b&&(c+=`cd ${v(b)} ; `);for(const m of M)c+=m==="<"||m===">"||I?m:v(m),c+=" ";break}}return c}}),define(Ee[295],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.CellExecutionUpdateType=void 0;var j;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(j||(e.CellExecutionUpdateType=j={})),e.$1J=(0,u.$hi)("INotebookExecutionService")}),define(Ee[296],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhb=e.$qhb=e.ProxyKernelState=e.$phb=void 0,e.$phb=100;var j;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(j||(e.ProxyKernelState=j={})),e.$qhb=(0,u.$hi)("INotebookKernelService"),e.$rhb=(0,u.$hi)("INotebookKernelHistoryService")}),define(Ee[297],Se([1,0,3,29,199,100]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Tb=void 0;class A extends u.$Uc{constructor($,k,M){super(),this._source=$,this.b=k,this.c=M,this.a=void 0}f($){const k=$.getLineCount();return new j.$bt(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new R.$yC;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:M,disposable:I}=k.create(1);this.b=M,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new R.$yC;k.acceptChunk($);const M=k.finish(!0),{textBuffer:I,disposable:b}=M.create(1);return this.B(b),I})),this.a}findInInputs($){const M=new P.$mC($,!1,!1,null).parseSearchRequest();if(!M)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,M,!0,5e3)}findInOutputs($){const M=new P.$mC($,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(I=>{const b=I.findMatchesLineByLine(this.f(I),M,!0,5e3);if(b.length!==0)return{textBuffer:I,matches:b}}).filter(I=>!!I):[]}}e.$0Tb=A}),define(Ee[67],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var j;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(j||(e.TestPosition=j={}));class R{static fromExtHostTestItem(A,p,$=A.parent){if(A._isRoot)return new R([p]);const k=[A.id];for(let M=$;M&&M.id!==p;M=M.parent)k.push(M.id);return k.push(p),new R(k.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const p=A.indexOf("\0");return p===-1?A:A.slice(0,p)}static fromString(A){return new R(A.split("\0"))}static join(A,p){return new R([...A.path,p])}static joinToString(A,p){return A.toString()+"\0"+p}static parentId(A){const p=A.lastIndexOf("\0");return p===-1?void 0:A.slice(0,p)}static localId(A){const p=A.lastIndexOf("\0");return p===-1?A:A.slice(p+1)}static isChild(A,p){return p.startsWith(A)&&p[A.length]==="\0"}static compare(A,p){return A===p?0:R.isChild(A,p)?2:R.isChild(p,A)?3:1}constructor(A,p=A.length){if(this.path=A,this.d=p,A.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new R(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new R(this.path,A)}compare(A){if(typeof A=="string")return R.compare(this.toString(),A);for(let p=0;p<A.d&&p<this.d;p++)if(A.path[p]!==this.path[p])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$7K=R}),define(Ee[89],Se([1,0,2,49,29,67]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$cL=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$bL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aL=e.$_K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$0K=e.$9K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$8K=e.TestResultState=void 0;var A;(function(L){L[L.Unset=0]="Unset",L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$8K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(L){L[L.Run=2]="Run",L[L.Debug=4]="Debug",L[L.Coverage=8]="Coverage",L[L.HasNonDefaultProfile=16]="HasNonDefaultProfile",L[L.HasConfigurable=32]="HasConfigurable",L[L.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$9K=[2,4,8,16,32,64];const k=L=>"runId"in L;e.$0K=k;var M;(function(L){L.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),L.deserialize=(N,B)=>({range:R.$bt.lift(B.range),uri:N.asCanonicalUri(u.URI.revive(B.uri))})})(M||(e.IRichLocation=M={}));var I;(function(L){L[L.Error=0]="Error",L[L.Output=1]="Output"})(I||(e.TestMessageType=I={}));var b;(function(L){L.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&M.serialize(N.location)}),L.deserialize=(N,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&M.deserialize(N,B.location)})})(b||(e.ITestErrorMessage=b={}));const E=(L,N)=>`${N?"s":"e"}${L}`;e.$$K=E;var v;(function(L){L.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&M.serialize(N.location)}),L.deserialize=(N,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&M.deserialize(N,B.location)})})(v||(e.ITestOutputMessage=v={}));var c;(function(L){L.serialize=N=>N.type===0?b.serialize(N):v.serialize(N),L.deserialize=(N,B)=>B.type===0?b.deserialize(N,B):v.deserialize(N,B)})(c||(e.ITestMessage=c={}));var m;(function(L){L.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),L.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(c.serialize)}),L.deserialize=(N,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(U=>c.deserialize(N,U))})})(m||(e.ITestTaskState=m={}));const a="\0",n=(L,N)=>L+a+N;e.$_K=n;const i=L=>{const N=L.indexOf(a);return{ctrlId:L.slice(0,N),tagId:L.slice(N+1)}};e.$aL=i;var r;(function(L){L.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),L.deserialize=(N,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?N.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?R.$bt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(L){L[L.NotExpandable=0]="NotExpandable",L[L.Expandable=1]="Expandable",L[L.BusyExpanding=2]="BusyExpanding",L[L.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(L){L.serialize=N=>({expand:N.expand,item:r.serialize(N.item)}),L.deserialize=(N,B)=>({controllerId:P.$7K.root(B.item.extId),expand:B.expand,item:r.deserialize(N,B.item)})})(t||(e.InternalTestItem=t={}));var g;(function(L){L.serialize=N=>{let B;return N.item&&(B={},N.item.label!==void 0&&(B.label=N.item.label),N.item.tags!==void 0&&(B.tags=N.item.tags),N.item.busy!==void 0&&(B.busy=N.item.busy),N.item.uri!==void 0&&(B.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(B.range=N.item.range?.toJSON()),N.item.description!==void 0&&(B.description=N.item.description),N.item.error!==void 0&&(B.error=N.item.error),N.item.sortText!==void 0&&(B.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:B}},L.deserialize=N=>{let B;return N.item&&(B={},N.item.label!==void 0&&(B.label=N.item.label),N.item.tags!==void 0&&(B.tags=N.item.tags),N.item.busy!==void 0&&(B.busy=N.item.busy),N.item.range!==void 0&&(B.range=N.item.range?R.$bt.lift(N.item.range):null),N.item.description!==void 0&&(B.description=N.item.description),N.item.error!==void 0&&(B.error=N.item.error),N.item.sortText!==void 0&&(B.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:B}}})(g||(e.ITestItemUpdate=g={}));const d=(L,N)=>{N.expand!==void 0&&(L.expand=N.expand),N.item!==void 0&&(L.item=L.item?Object.assign(L.item,N.item):N.item)};e.$bL=d;var l;(function(L){L.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(m.serializeWithoutMessages)}),L.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(m.serialize)}),L.deserialize=(N,B)=>({...t.deserialize(N,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(U=>m.deserialize(N,U)),retired:!0})})(l||(e.TestResultItem=l={}));var o;(function(L){L.empty=()=>({covered:0,total:0}),L.sum=(N,B)=>{N.covered+=B.covered,N.total+=B.total}})(o||(e.ICoveredCount=o={}));var h;(function(L){L.serialize=N=>({statement:N.statement,branch:N.branch,declaration:N.declaration,details:N.details?.map(S.serialize),uri:N.uri.toJSON()}),L.deserialize=(N,B)=>({statement:B.statement,branch:B.branch,declaration:B.declaration,details:B.details?.map(S.deserialize),uri:N.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function f(L){return{...L,location:L.location?.toJSON()}}function D(L){return L.location=L.location?j.$at.isIPosition(L.location)?j.$at.lift(L.location):R.$bt.lift(L.location):void 0,L}e.$cL=3;var w;(function(L){L[L.Declaration=0]="Declaration",L[L.Statement=1]="Statement",L[L.Branch=2]="Branch"})(w||(e.DetailType=w={}));var S;(function(L){L.serialize=N=>N.type===0?C.serialize(N):O.serialize(N),L.deserialize=N=>N.type===0?C.deserialize(N):O.deserialize(N)})(S||(e.CoverageDetails=S={}));var y;(function(L){L.serialize=f,L.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(L){L.serialize=f,L.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var O;(function(L){L.serialize=N=>({...f(N),branches:N.branches?.map(y.serialize)}),L.deserialize=N=>({...D(N),branches:N.branches?.map(y.deserialize)})})(O||(e.IStatementCoverage=O={}));var z;(function(L){L[L.Add=0]="Add",L[L.Update=1]="Update",L[L.DocumentSynced=2]="DocumentSynced",L[L.Remove=3]="Remove",L[L.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",L[L.Retire=5]="Retire",L[L.AddTag=6]="AddTag",L[L.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var F;(function(L){L.deserialize=(N,B)=>B.op===0?{op:B.op,item:t.deserialize(N,B.item)}:B.op===1?{op:B.op,item:g.deserialize(B.item)}:B.op===2?{op:B.op,uri:N.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,L.serialize=N=>N.op===0?{op:N.op,item:t.serialize(N.item)}:N.op===1?{op:N.op,item:g.serialize(N.item)}:N})(F||(e.TestsDiffOp=F={}));class T{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const B=this.v();for(const U of N)switch(U.op){case 0:this.l(t.deserialize(this.k,U.item),B);break;case 1:this.o(g.deserialize(U.item),B);break;case 3:this.p(U.itemId,B);break;case 5:this.q(U.itemId);break;case 4:this.updatePendingRoots(U.amount);break;case 6:this.c.set(U.tag.id,U.tag);break;case 7:this.c.delete(U.id);break}B.complete?.()}l(N,B){const U=P.$7K.parentId(N.item.extId)?.toString();let Z;if(!U)Z=this.w(N),this.g.add(Z),this.f.set(N.item.extId,Z);else if(this.f.has(U)){const _=this.f.get(U);_.children.add(N.item.extId),Z=this.w(N,_),this.f.set(N.item.extId,Z)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return B.add?.(Z),N.expand===2&&this.h++,Z}o(N,B){const U=this.f.get(N.extId);if(U)return N.expand!==void 0&&(U.expand===2&&this.h--,N.expand===2&&this.h++),(0,e.$bL)(U,N),B.update?.(U),U}p(N,B){const U=this.f.get(N);if(!U)return;const Z=P.$7K.parentId(U.item.extId)?.toString();Z?this.f.get(Z).children.delete(U.item.extId):this.g.delete(U);const _=[[N]];for(;_.length;)for(const Y of _.pop()){const x=this.f.get(Y);x&&(_.push(x.children),this.f.delete(Y),B.remove?.(x,x!==U),x.expand===2&&this.h--)}}q(N){}updatePendingRoots(N){this.j+=N}v(){return{}}}e.$dL=T}),define(Ee[112],Se([1,0,8,4,3,61,89,67]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),b=(n,i)=>{let r;for(const[s,t]of I)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class E extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$th(()=>this.flushDiff(),200)),this.g=this.B(new j.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,A.$bL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,A.$bL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(p.$7K.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,P.$0c)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=p.$7K.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let g=this.tree.get(s.toString());if(!g){g={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(i)}}),this.I(i,g,r);return}if(g.actual===i){this.H(i,g,r);return}if(g.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(g.actual),l=g.actual,o=b(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,g.actual=i,g.expand=0,o&&(o.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete o.tags),this.w(g,{op:4,update:o})),this.I(i,g,r);for(const[h,f]of d)this.s.getChildren(i).get(f.id)||this.O(p.$7K.joinToString(s,f.id));this.y(g.actual.uri)}C(i,r,s){const t=new Set(r.map(g=>g.id));for(const g of i)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(g=>(0,A.$_K)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$_K)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$_K)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=g=>this.w(r,g),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,g]of this.s.getChildren(i))this.z(g,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,g]of this.s.getChildren(i.actual)){const d=this.expand(p.$7K.joinToString(i.fullId,g.id),r);(0,u.$6g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const g=new u.$gh;return g.open(),g}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$gh,s=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(g){s(g)}return(0,u.$6g)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,d]of this.s.getChildren(t.actual))s.push(this.tree.get(p.$7K.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$sO=E;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$tO=v;class c extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$uO=c;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$vO=m;const a=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,g){for(const d of s.values())t.call(g,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const g=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const o of t){if(!(o instanceof r))throw new c(o.id);const h=i(o).controllerId;if(h!==n.controllerId)throw new m(o.id,h,n.controllerId);if(g.has(o.id))throw new v(o.id);g.set(o.id,o),d.delete(o.id),l.ops.push({op:0,item:o})}for(const o of d.keys())l.ops.push({op:3,id:o});n.listener?.(l),s=g},add(t){if(!(t instanceof r))throw new c(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$wO=a}),define(Ee[144],Se([1,0,112]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=void 0;const j=new WeakMap,R=(A,p)=>{const $={controllerId:p};return j.set(A,$),$};e.$xO=R;const P=A=>{const p=j.get(A);if(!p)throw new u.$uO(A?.id||"<unknown>");return p};e.$yO=P}),define(Ee[113],Se([1,0,15,2]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nyb=e.$Myb=e.$Lyb=void 0,e.$Oyb=R,e.$Pyb=A,e.$Lyb="vscode-cdn.net",e.$Myb=`vscode-resource.${e.$Lyb}`,e.$Nyb=`'self' https://*.${e.$Lyb}`;function R(p,$){return p.scheme===u.Schemas.http||p.scheme===u.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===u.Schemas.file&&(p=j.URI.from({scheme:u.Schemas.vscodeRemote,authority:$.authority,path:p.path})),j.URI.from({scheme:u.Schemas.https,authority:`${p.scheme}+${P(p.authority)}.${e.$Myb}`,path:p.path,fragment:p.fragment,query:p.query}))}function P(p){return p.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ee[298],Se([1,0,4,3,113]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class P{constructor(p,$,k){this.d=p,this.e=$,this.f=k,this.a=0,this.b=new j.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const M=$.getVisibleTextEditors();for(const I of this.c.values())M.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,k,M,I){let b;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){b=i;break}if(!b)throw new Error("not a visible editor");const E=this,v=this.a++,c=new u.$7d,m=new u.$7d,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$Oyb)(i,E.f)}get cspSource(){return R.$Nyb}set options(i){this.b=i,E.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(i){return E.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=p,this.line=$,this.height=k,this.webview=a,this.onDidDispose=m.event}dispose(){E.c.has(v)&&(E.c.delete(v),E.d.$disposeEditorInset(v),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(v,b.id,b.value.document.uri,$+1,k,M||{},I.identifier,I.extensionLocation),this.c.set(v,{editor:p,inset:n,onDidReceiveMessage:c}),n}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$6ic=P}),define(Ee[145],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.$kL=void 0,e.$kL="__",e.$lL=(0,u.$hi)("IAuthenticationService"),e.$mL=(0,u.$hi)("IAuthenticationExtensionsService")}),define(Ee[299],Se([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.VariableKind=e.$oP=void 0,e.$oP=(0,u.$hi)("configurationResolverService");var j;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(j||(e.VariableKind=j={}));class R extends Error{constructor(A,p){super(p),this.variable=A}}e.$pP=R}),define(Ee[300],Se([1,0,17,50,18,24,11,103,239,299,14]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,c,m){this.h=new Map,this.a=E,this.b=v,this.g=c,m&&(this.c=m.then(a=>this.i(a)))}i(E){if(A.$i){const v=Object.create(null);return Object.keys(E).forEach(c=>{v[c.toLowerCase()]=E[c]}),v}return E}resolveWithEnvironment(E,v,c){return this.l({env:this.i(E),userHome:void 0},v?v.uri:void 0,c)}async resolveAsync(E,v){const c={env:await this.c,userHome:await this.g};return this.l(c,E?E.uri:void 0,v)}async j(E,v,c,m){const a=P.$Nn(v);A.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):A.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):A.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,a,c,m)}async resolveAnyAsync(E,v,c){return this.j(E,v,c)}async resolveAnyMap(E,v,c){const m=new Map;return{newConfig:await this.j(E,v,c,m),resolvedVariables:m}}resolveWithInteractionReplace(E,v,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,v)}async l(E,v,c,m,a){if(R.$Uf(c))return this.m(E,v,c,m,a);if(Array.isArray(c))return Promise.all(c.map(n=>this.l(E,v,n,m,a)));if(R.$Wf(c)){const n=Object.create(null),i=await Promise.all(Object.keys(c).map(async r=>[await this.m(E,v,r,m,a),await this.l(E,v,c[r],m,a)]));for(const[r,s]of i)n[r]=s;return n}return c}m(E,v,c,m,a){return(0,M.$df)(c,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let r=await this.o(E,n,i,v,m);return a?.set(i,r),r!==n&&R.$Uf(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.m(E,v,r,m,a)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,v,c,m,a){let n;const i=c.split(":");i.length>1&&(c=i[0],n=i[1]);const r=g=>{const d=this.a.getFilePath();if(d)return(0,p.$gw)(d);throw new k.$pP(g,(0,$.localize)(0,null,v))},s=g=>{const d=r(g);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,p.$gw)(l)}throw new k.$pP(g,(0,$.localize)(1,null,v,u.$oc(d)))},t=g=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new k.$pP(g,(0,$.localize)(2,null,v,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new k.$pP(g,(0,$.localize)(3,null,v)):new k.$pP(g,(0,$.localize)(4,null,v))};switch(c){case"env":if(n){if(E.env){const g=E.env[A.$i?n.toLowerCase():n];if(R.$Uf(g))return g}return""}throw new k.$pP(k.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const g=this.a.getConfigurationValue(m,n);if(R.$4f(g))throw new k.$pP(k.VariableKind.Config,(0,$.localize)(6,null,v,n));if(R.$Wf(g))throw new k.$pP(k.VariableKind.Config,(0,$.localize)(7,null,v,n));return g}throw new k.$pP(k.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(k.VariableKind.Command,v,n,a,"command");case"input":return this.p(k.VariableKind.Input,v,n,a,"input");case"extensionInstallFolder":if(n){const g=await this.a.getExtension(n);if(!g)throw new k.$pP(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(g.extensionLocation)}throw new k.$pP(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,p.$gw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,p.$gw)(this.n(t(k.VariableKind.Cwd))):j.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$gw)(u.$oc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$pP(k.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new k.$pP(k.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new k.$pP(k.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return r(k.VariableKind.File);case"fileWorkspaceFolder":return s(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(k.VariableKind.RelativeFile)),r(k.VariableKind.RelativeFile)):r(k.VariableKind.RelativeFile);case"relativeFileDirname":{const g=u.$nc(r(k.VariableKind.RelativeFileDirname));if(m||n){const d=u.$mc(this.n(t(k.VariableKind.RelativeFileDirname)),g);return d.length===0?".":d}return g}case"fileDirname":return u.$nc(r(k.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(k.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=u.$oc(r(k.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-u.$pc(g).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(k.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||v}case"execInstallFolder":{const g=this.a.getAppRoot();return g||v}case"pathSeparator":case"/":return u.sep;default:try{const g=n?`${c}:${n}`:c;return this.p(k.VariableKind.Unknown,v,g,a,void 0)}catch{return v}}}}p(E,v,c,m,a){if(c&&m){const n=a===void 0?m[c]:m[a+":"+c];if(typeof n=="string")return n;throw new k.$pP(E,(0,$.localize)(14,null,v))}return v}}e.$EP=I}),define(Ee[146],Se([1,0,5,142]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$uD=void 0,e.$vD=k,e.$wD=b,e.$xD=E,e.$uD=(0,u.$hi)("editorGroupsService");var R;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var P;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var p;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(v){const c=v;return(0,j.$eF)(c?.editor)&&(0,j.$eF)(c?.replacement)}var M;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var I;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function b(v){const c=v;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ee[301],Se([1,0,5,146]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BD=e.$AD=e.$zD=e.$yD=void 0,e.$CD=R,e.$yD=(0,u.$hi)("editorService"),e.$zD=-1,e.$AD=-2,e.$BD=-3;function R(P){const A=P;return typeof P=="number"||(0,j.$wD)(A)}}),define(Ee[147],Se([1,0,5,136]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=void 0,e.$FL=(0,u.$ii)(j.$oi)}),define(Ee[148],Se([1,0,25,4,17,3,8]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=e.$F0b=e.$E0b=e.$D0b=void 0;class p{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$D0b=p;class ${static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new j.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(c),this.f=new u.$Em,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const r=$.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const o=i.getArcs(d);for(let h=0;h<o.length;h++)if(!l.has(o[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Em;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Cm.toKey(d.identifier),u.$Cm.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let g;do{g=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),g=!0)}}while(g);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$E0b=$;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$F0b=k;class M{constructor(n){this.d=new E,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$G0b=M;class I extends P.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$H0b=I;class b{constructor(n){this.name=n;const i=(0,A.$ah)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class E{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new b(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,P.$Sc)(s))}}var v;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(v||(v={}));function c(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=R.$hc.basename(a.extensionLocation.path),t=R.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(a,n){const i=new u.$Dm(n);return a.filter(r=>!i.has(r.identifier))}}),define(Ee[302],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.ExtHostConnectionType=void 0,e.$$m=p,e.$_m=$;var u;(function(M){M[M.IPC=1]="IPC",M[M.Socket=2]="Socket",M[M.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class j{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[j.ENV_KEY]=this.pipeName}}e.$8m=j;class R{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[R.ENV_KEY]="1"}}e.$9m=R;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[P.ENV_KEY]="1"}}e.$0m=P;function A(M){delete M[j.ENV_KEY],delete M[R.ENV_KEY],delete M[P.ENV_KEY]}function p(M,I){A(I),M.serialize(I)}function $(M){if(M[j.ENV_KEY])return k(M,new j(M[j.ENV_KEY]));if(M[R.ENV_KEY])return k(M,new R);if(M[P.ENV_KEY])return k(M,new P);throw new Error("No connection information defined in environment!")}function k(M,I){return A(M),I}}),define(Ee[114],Se([1,0,21]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Km=A,e.$Lm=p;var j;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(j||(e.UIKind=j={}));var R;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(k){const M=u.$ue.alloc(1);switch(k){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}function p(k,M){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[90],Se([1,0,5,4,12,27,114,86,87,24,2,3,225]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$UO=e.$TO=void 0,e.$VO=c;let E=class extends I.$Uc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new j.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new j.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$8o,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,R.$Pj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const r=this.getTelemetryDetails(),s=new v(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$tm)((0,$.$bp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const r=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(a.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$TO=E,e.$TO=E=Je([Ve(0,P.$SO),Ve(1,R.$Oj)],E);class v{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,r,s,t,g){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new j.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,$.$ep)(n,[]),this.c&&(n=(0,k.$Qn)(n,this.c)),this.b||(n=(0,k.$Qn)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},r=(0,$.$ep)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$UO=v;function c(m){const a=Date.now()-new Date(m).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$WO=(0,u.$hi)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,270,140,25,5]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_F=e.ActivationKind=e.$9F=e.$8F=e.$5F=e.ExtensionHostStartup=e.$4F=e.$3F=e.$2F=e.$1F=void 0,e.$6F=b,e.$7F=E,e.$0F=a,e.$$F=n,e.$1F=Object.freeze({identifier:new A.$Cm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:j.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2F="extensions.webWorker",e.$3F=(0,p.$hi)("extensionService");class ${constructor(s){this.dependency=s}}e.$4F=$;var k;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,g){this.c=s,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$LF.createActivationEventsMap(this.d)}}set(s,t,g){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],o=[],h=[],f=I(this.d),D=I(t),w=(z,F)=>z.extensionLocation.toString()===F.extensionLocation.toString()||z.isBuiltin===F.isBuiltin||z.isUserBuiltin===F.isUserBuiltin||z.isUnderDevelopment===F.isUnderDevelopment;for(const z of this.d){const F=D.get(z.identifier);if(!F){d.push(z.identifier),f.delete(z.identifier);continue}if(!w(z,F)){d.push(z.identifier),f.delete(z.identifier);continue}}for(const z of t){const F=f.get(z.identifier);if(!F){l.push(z);continue}if(!w(F,z)){d.push(F.identifier),f.delete(F.identifier);continue}}const S=new A.$Dm(this.e),y=new A.$Dm(g);for(const z of this.e)y.has(z)||o.push(z);for(const z of g)S.has(z)||h.push(z);const C=P.$LF.createActivationEventsMap(l),O={versionId:s,toRemove:d,toAdd:l,addActivationEvents:C,myToRemove:o,myToAdd:h};return this.delta(O),O}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:d,myToAdd:l}=s,o=new A.$Dm(t),h=new A.$Dm(d);for(let f=0;f<this.d.length;f++)o.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)h.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of g)this.d.push(f);for(const f of l)this.e.push(f);return this.f=null,s}containsExtension(s){for(const t of this.e)if(A.$Cm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=P.$LF.readActivationEvents(t);for(const d of g)s.add(d)}return s}}e.$5F=M;function I(r){const s=new A.$Em;for(const t of r)s.set(t.identifier,t);return s}function b(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function E(r,s){if(!b(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(s,t,g,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=d}}e.$8F=v;class c{constructor(s,t){this.description=s,this.value=t}}e.$9F=c;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function a(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,R.$kp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new A.$Cm((0,R.$ip)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_F=i}),define(Ee[303],Se([1,0,13,148,25,26,12,8]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=e.$sjc=e.$rjc=e.$qjc=e.$pjc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,n,i,r){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$pjc=$;class k{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$qjc=k;class M{constructor(a,n,i,r,s,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$rjc=M;class I extends M{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$sjc=I;class b extends M{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$tjc=b;class E extends M{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(a,n,i,r){this.g=r,this.a=a,this.b=n,this.c=i,this.d=new R.$Em,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const s=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(s));return this.c.onExtensionActivationError(a.id,s,new P.$4F(a.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(s);if(g){if(!g.main&&!g.browser)continue;i.push(this.j({id:g.identifier,reason:a.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),o=this.k(a,n.displayName,[],new E(l));return this.c.onExtensionActivationError(n.identifier,l,new P.$4F(s)),o}return this.k(a,n.displayName,i,null)}k(a,n,i,r){const s=new c(a.id,n,a.reason,i,r,this.c,this.g);return this.d.set(a.id,s),s}l(a){return j.$E0b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$ujc=v,e.$ujc=v=Je([Ve(3,A.$Nj)],v);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,r,s,t,g){this.c=a,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=g,this.a=new p.$gh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new E(n),this.b&&u.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};c=Je([Ve(6,A.$Nj)],c)}),define(Ee[304],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[305],Se([1,0,241,13,40,137,109,37,25,304,139,140]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0;const b=p.$Zn.as(A.$1n.JSONContribution);class E{constructor(s,t,g){this.a=s,this.b=t,this.c=g}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(R.default.Error,s)}warn(s){this.d(R.default.Warning,s)}info(s){this.d(R.default.Info,s)}}e.$UF=E;class v{static a(s){const t=new $.$Dm;for(let g=0,d=s.length;g<d;g++)t.add(s[g].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const g=this.a(s),d=this.a(t),l=t.filter(h=>!g.has(h.description.identifier)),o=s.filter(h=>!d.has(h.description.identifier));return new v(l,o)}constructor(s,t){this.added=s,this.removed=t}}e.$VF=v;class c{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,j.$1)(s)}}}e.$WF=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$XF={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Bm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$Eo}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$Eo}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new c(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&I.$LF.register(s.extensionPoint,s.activationEventsGenerator),e.$XF.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,b.registerSchema(a,e.$XF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$YF=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$Zn.add(i.ExtensionsRegistry,new n),e.$ZF=p.$Zn.as(i.ExtensionsRegistry),b.registerSchema(a,e.$XF),b.registerSchema(M.$8j,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ee[306],Se([1,0,237,18,24,305,41,4]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var k;(function(b){function E(v,c,m){if(!v)return;const a=j.$Uf(v.type)?v.type:void 0;if(!a||a.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)j.$Uf(i)&&n.push(i);return{extensionId:c.value,taskType:a,required:n,properties:v.properties?R.$Nn(v.properties):{},when:v.when?A.$fj.deserialize(v.when):void 0}}b.from=E})(k||(k={}));const M=P.$ZF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,E)=>{for(const v of b)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new p.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,v)=>{M.setHandler((c,m)=>{this.c=void 0;try{for(const a of m.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of m.added){const n=a.value;for(const i of n){const r=k.from(i,a.description.identifier,a.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const v of this.all()){const c={type:"object",additionalProperties:!1};v.required.length>0&&(c.required=v.required.slice(0)),v.properties!==void 0?c.properties=R.$Nn(v.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[v.taskType]},E.push(c)}this.c={oneOf:E}}return this.c}}e.$pH=new I}),define(Ee[307],Se([1,0,238,18,23,24,41,306]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$zH=e.JsonSchemaVersion=e.ExecutionEngine=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$tH=e.ShellQuoting=e.$sH=e.$rH=e.$qH=void 0,e.$qH="settings",e.$rH=new A.$yj("taskRunning",!1,u.localize(0,null)),e.$sH=u.localize2(2,"Tasks");var $;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$tH="$customized",function(L){function N(B){if(!B)return L.Strong;switch(B.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=N}($||(e.ShellQuoting=$={}));var k;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var M;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(M||(e.RevealKind=M={})),function(L){function N(B){switch(B.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=N}(M||(e.RevealKind=M={}));var I;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(L){function N(B){switch(B.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=N}(I||(e.RevealProblemKind=I={}));var b;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(b||(e.PanelKind=b={})),function(L){function N(B){switch(B.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=N}(b||(e.PanelKind=b={}));var E;(function(L){L.defaults={echo:!0,reveal:M.Always,revealProblems:I.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(L){function N(U){switch(U.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=N;function B(U){switch(U){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=B}(v||(e.RuntimeType=v={}));var c;(function(L){function N(B){return j.$Uf(B)?B:B.value}L.value=N})(c||(e.CommandString=c={}));var m;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function N(U){return U===L.Clean._id||U===L.Build._id||U===L.Rebuild._id||U===L.Test._id}L.is=N;function B(U){if(U!==void 0)return j.$Uf(U)?N(U)?{_id:U,isDefault:!1}:void 0:U}L.from=B})(m||(e.TaskGroup=m={}));var a;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function N(B){switch(B){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var i;(function(L){L.parallel="parallel",L.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(N,B,U,Z,_,Y){this._label="",this._id=N,B&&(this._label=B),U&&(this.type=U),this.runOptions=Z,this.configurationProperties=_,this._source=Y}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,B=!1){if(N===void 0)return!1;if(j.$Uf(N))return N===this._label||N===this.configurationProperties.identifier||B&&N===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$uH=t;class g extends t{constructor(N,B,U,Z,_,Y,x,ce){super(N,U,void 0,x,ce,B),this.command={},this._source=B,this.hasDefinedMatchers=Y,_&&(this.command=_)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(N){return N instanceof g}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$qH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const U={type:e.$tH,folder:N,id:B};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new g(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$vH=g;class d extends t{constructor(N,B,U,Z,_,Y,x){super(N,U,Z,Y,x,B),this._source=B,this.configures=_}static is(N){return N instanceof d}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$qH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const U={type:e.$tH,folder:N,id:B};return JSON.stringify(U)}}e.$wH=d;class l extends t{constructor(N,B,U,Z,_,Y,x,ce,X){super(N,U,Z,ce,X,B),this.defines=_,this.hasDefinedMatchers=x,this.command=Y,this.icon=X.icon,this.hide=X.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof l}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new l(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$xH=l;class o extends t{constructor(N,B,U,Z,_,Y){super(N,U,Z,_,Y,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new o(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$yH=o;var h;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(L){L._default=L.Terminal}(h||(e.ExecutionEngine=h={}));var f;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class D{constructor(N){this.c=new Map;for(let B=0;B<N.length;B++)this.c.set(N[B].uri.toString(),B)}compare(N,B){const U=N.getWorkspaceFolder(),Z=B.getWorkspaceFolder();if(U&&Z){let _=this.c.get(U.uri.toString());_=_===void 0?0:_+1;let Y=this.c.get(Z.uri.toString());return Y=Y===void 0?0:Y+1,_===Y?N._label.localeCompare(B._label):_-Y}else return!U&&Z?-1:U&&!Z?1:0}}e.$zH=D;var w;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(w||(e.TaskEventKind=w={}));var S;(function(L){L.SingleRun="singleRun",L.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(L){function N(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function B(ce,X,me){return{...N(ce),kind:"start",terminalId:X,resolvedVariables:me}}L.start=B;function U(ce,X,me){return{...N(ce),kind:"processStarted",terminalId:X,processId:me}}L.processStarted=U;function Z(ce,X,me){return{...N(ce),kind:"processEnded",terminalId:X,exitCode:me}}L.processEnded=Z;function _(ce,X,me){return{...N(ce),kind:"terminated",exitReason:me,terminalId:X}}L.terminated=_;function Y(ce,X,me){return{...N(X),kind:ce,terminalId:me}}L.general=Y;function x(){return{kind:"changed"}}L.changed=x})(C||(e.TaskEvent=C={}));var O;(function(L){function N(U){const Z=Object.keys(U).sort();let _="";for(const Y of Z){let x=U[Y];x instanceof Object?x=N(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),_+=Y+","+x+","}return _}function B(U){const _={_key:N(U),type:U.taskType};return Object.assign(_,U),_}L.create=B})(O||(e.KeyedTaskIdentifier=O={}));var z;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var F;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var T;(function(L){function N(B,U){const Z=p.$pH.get(B.type);if(Z===void 0){const ce=P.$Nn(B);return delete ce._key,O.create(ce)}const _=Object.create(null);_.type=Z.taskType;const Y=new Set;Z.required.forEach(ce=>Y.add(ce));const x=Z.properties;for(const ce of Object.keys(x)){const X=B[ce];if(X!=null)_[ce]=X;else if(Y.has(ce)){const me=x[ce];if(me.default!==void 0)_[ce]=P.$Nn(me.default);else switch(me.type){case"boolean":_[ce]=!1;break;case"number":case"integer":_[ce]=0;break;case"string":_[ce]="";break;default:U.error(u.localize(1,null,JSON.stringify(B,void 0,0),ce));return}}}return O.create(_)}L.createTaskIdentifier=N})(T||(e.TaskDefinition=T={}))}),define(Ee[308],Se([1,0,13]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=e.$I0b=void 0;class j{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,p)=>{this.b=A,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,u.$1)(A))}then(A,p){return this.j().then(A,p)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$I0b=j;class R extends j{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$J0b=R}),define(Ee[68],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$aw=void 0,e.$bw=R,e.$cw=P;class u{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++u.count}}e.$aw=u;const j=[];function R(p){const $=new u(p);return j[$.nid]=$,$}function P(p){return j[p].sid}class A{constructor($){this.value=$}}e.$dw=A}),define(Ee[6],Se([1,0,68]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$hM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var j;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(j||(e.TextEditorRevealType=j={}));var R;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(R||(e.TabInputKind=R={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var p;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var M;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class I{static{this.a=0}static mixin(m){return m._id=I.a++,m}}e.$hM=I;var b;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var E;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$iM={MainThreadAuthentication:(0,u.$bw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$bw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$bw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$bw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$bw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$bw)("MainThreadClipboard"),MainThreadCommands:(0,u.$bw)("MainThreadCommands"),MainThreadComments:(0,u.$bw)("MainThreadComments"),MainThreadConfiguration:(0,u.$bw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$bw)("MainThreadConsole"),MainThreadDebugService:(0,u.$bw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$bw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$bw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$bw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$bw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$bw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$bw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$bw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$bw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$bw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$bw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$bw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$bw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$bw)("MainThreadLanguages"),MainThreadLogger:(0,u.$bw)("MainThreadLogger"),MainThreadMessageService:(0,u.$bw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$bw)("MainThreadOutputService"),MainThreadProgress:(0,u.$bw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$bw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$bw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$bw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$bw)("MainThreadSecretState"),MainThreadStorage:(0,u.$bw)("MainThreadStorage"),MainThreadSpeech:(0,u.$bw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$bw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$bw)("MainThreadTerminalService"),MainThreadWebviews:(0,u.$bw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$bw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$bw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$bw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$bw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$bw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$bw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$bw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$bw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$bw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$bw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$bw)("MainThreadSCM"),MainThreadSearch:(0,u.$bw)("MainThreadSearch"),MainThreadShare:(0,u.$bw)("MainThreadShare"),MainThreadTask:(0,u.$bw)("MainThreadTask"),MainThreadWindow:(0,u.$bw)("MainThreadWindow"),MainThreadLabelService:(0,u.$bw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$bw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$bw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$bw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$bw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$bw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$bw)("MainThreadInteractive"),MainThreadChat:(0,u.$bw)("MainThreadChat"),MainThreadInlineChat:(0,u.$bw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$bw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$bw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$bw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$bw)("MainThreadTimeline"),MainThreadTesting:(0,u.$bw)("MainThreadTesting"),MainThreadLocalization:(0,u.$bw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$bw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$bw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,u.$bw)("MainThreadIssueReporter")},e.$jM={ExtHostCommands:(0,u.$bw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$bw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$bw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$bw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$bw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$bw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$bw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$bw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$bw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$bw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$bw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$bw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$bw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$bw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$bw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$bw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$bw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$bw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$bw)("ExtHostStatusBar"),ExtHostShare:(0,u.$bw)("ExtHostShare"),ExtHostExtensionService:(0,u.$bw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$bw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$bw)("ExtHostTerminalService"),ExtHostSCM:(0,u.$bw)("ExtHostSCM"),ExtHostSearch:(0,u.$bw)("ExtHostSearch"),ExtHostTask:(0,u.$bw)("ExtHostTask"),ExtHostWorkspace:(0,u.$bw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$bw)("ExtHostWindow"),ExtHostWebviews:(0,u.$bw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$bw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$bw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$bw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$bw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$bw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$bw)("ExtHostProgress"),ExtHostComments:(0,u.$bw)("ExtHostComments"),ExtHostSecretState:(0,u.$bw)("ExtHostSecretState"),ExtHostStorage:(0,u.$bw)("ExtHostStorage"),ExtHostUrls:(0,u.$bw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$bw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$bw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$bw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$bw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$bw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$bw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$bw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$bw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$bw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$bw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$bw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$bw)("ExtHostInlineChatShape"),ExtHostChat:(0,u.$bw)("ExtHostChat"),ExtHostChatAgents2:(0,u.$bw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$bw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$bw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$bw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$bw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$bw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$bw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$bw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$bw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$bw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$bw)("ExtHostTimeline"),ExtHostTesting:(0,u.$bw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$bw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$bw)("ExtHostLocalization"),ExtHostIssueReporter:(0,u.$bw)("ExtHostIssueReporter")}}),define(Ee[91],Se([1,0,5,12,6,20]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=void 0,e.$Lic=(0,u.$hi)("IExtHostApiDeprecationService");let A=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(R.$iM.MainThreadTelemetry)}report($,k,M){const I=this.d($,k);this.a.has(I)||(this.a.add(I),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$Mic=A,e.$Mic=A=Je([Ve(0,P.$CO),Ve(1,j.$Nj)],A),e.$Nic=Object.freeze(new class{report(p,$,k){}})}),define(Ee[309],Se([1,0,38,3,6]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class P{static{this.a=0}constructor($,k){this.extension=$,this.provider=k,this.handle=P.a++}}class A{static{this.a=0}constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(R.$iM.MainThreadChat)}registerChatProvider($,k,M){const I=new P($,M);return this.b.set(I.handle,I),this.d.$registerChatProvider(I.handle,k),(0,j.$Sc)(()=>{this.d.$unregisterChatProvider(I.handle),this.b.delete(I.handle)})}transferChatSession($,k){const M=u.Iterable.find(this.c.keys(),I=>this.c.get(I)===$)??0;typeof M=="number"&&this.d.$transferChatSession(M,k)}async $prepareChat($,k){const M=this.b.get($);if(!M)return;const I=await M.provider.prepareSession(k);if(!I)return;const b=A.a++;return this.c.set(b,I),{id:b}}$releaseSession($){this.c.delete($)}}e.$Yic=A}),define(Ee[310],Se([1,0,6]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class j{constructor(P){const A=P.getProxy(u.$iM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(p){return A.$writeText(p)}})}}e.$4ic=j}),define(Ee[311],Se([1,0,24,6,27,20]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;let A=class{constructor(M,I){this.a=M.getProxy(j.$iM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,I){const b=this,E=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){b.e(M,I,E,arguments)}})}e(M,I,b,E){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(E,this.b)}),this.c&&this.f(M,b,E)}};e.$Ukc=A,e.$Ukc=A=Je([Ve(0,P.$CO),Ve(1,R.$SO)],A);const p=1e5;function $(k,M){const I=[];if(k.length)for(let b=0;b<k.length;b++){let E=k[b];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}I.push(E)}if(M){const b=new Error().stack;b&&I.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,u.$Sn)(I);return b.length>p?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(Ee[312],Se([1,0,2,6,26]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class P{constructor(p){this.a=p.getProxy(j.$iM.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,R.$7F)(p,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(M=>u.URI.revive(M)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?u.URI.revive($):void 0)}}e.$Yjc=P}),define(Ee[313],Se([1,0,3,6]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=void 0;class R{constructor(A){this.b=0,this.a=A.getProxy(j.$iM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,A),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$hkc=R}),define(Ee[115],Se([1,0,11,14,2,5,12,6,27,20]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=e.$Gjc=void 0;let M=class{constructor(b,E,v){this.f=v,this.d=new Map,this.a=E.getProxy(p.$iM.MainThreadLocalization),this.b=b.environment.appLanguage,this.c=this.b===u.$g}getMessage(b,E){const{message:v,args:c,comment:m}=E;if(this.c)return(0,j.$We)(v,c??{});let a=v;m&&m.length>0&&(a+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get(b)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,j.$We)(n??v,c??{})}getBundle(b){return this.d.get(b)?.contents}getBundleUri(b){return this.d.get(b)?.uri}async initializeLocalizedMessages(b){if(this.c||!b.l10n&&!b.isBuiltin||this.d.has(b.identifier.value))return;let E;const v=await this.g(b);if(!v){this.f.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(v),m=JSON.parse(c);E=b.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${b.identifier.value} from ${v}: ${c.message}`);return}E&&this.d.set(b.identifier.value,{contents:E,uri:v})}async g(b){if(b.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(b.identifier.value,this.b);return R.URI.revive(E)}return b.l10n?R.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Gjc=M,e.$Gjc=M=Je([Ve(0,$.$SO),Ve(1,k.$CO),Ve(2,A.$Nj)],M),e.$Hjc=(0,P.$hi)("IExtHostLocalizationService")}),define(Ee[149],Se([1,0,12,6,27,20,2,57]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;let $=class extends u.$Yj{constructor(I,b){super(b.logLevel,b.logsLocation,b.loggers.map(E=>(0,p.$Qh)(E))),this.r=I.getProxy(j.$iM.MainThreadLogger)}$setLogLevel(I,b){b?this.setLogLevel(A.URI.revive(b),I):this.setLogLevel(I)}setVisibility(I,b){super.setVisibility(I,b),this.r.$setVisibility(I,b)}s(I,b,E){return new k(this.r,I,b,E)}};e.$Tkc=$,e.$Tkc=$=Je([Ve(0,P.$CO),Ve(1,R.$SO)],$);class k extends u.$Tj{constructor(I,b,E,v){super(v?.logLevel==="always"),this.r=I,this.s=b,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(b,v).then(()=>{this.u(this.n),this.m=!0})}g(I,b){const E=[[I,b]];this.m?this.u(E):this.n.push(...E)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Ee[116],Se([1,0,6,5,3,20,21]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=e.$Ijc=void 0,e.$Ijc=(0,j.$hi)("IExtHostManagedSockets");let p=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(u.$iM.MainThreadManagedSockets)}setFactory(I,b){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,b),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const b=++this.b,E=await this.c.makeConnection(),v=new R.$Tc;return this.d.set(b,new k(b,E,v)),v.add((0,R.$Sc)(()=>this.d.delete(b))),v.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(b),v.dispose()})),v.add(E.onDidClose(c=>{this.a.$onDidManagedSocketClose(b,c?.stack??c?.message),v.dispose()})),v.add(E.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(b,A.$ue.wrap(c)))),b}$remoteSocketWrite(I,b){this.d.get(I)?.actual.send(b.buffer)}$remoteSocketEnd(I){const b=this.d.get(I);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Jjc=p,e.$Jjc=p=Je([Ve(0,P.$CO)],p);class ${constructor(I,b){this.socketFactoryId=I,this.makeConnection=b}}class k extends R.$Uc{constructor(I,b,E){super(),this.socketId=I,this.actual=b,this.B(E)}}}),define(Ee[314],Se([1,0,6,12,26]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;function P(p){return p&&p.title}let A=class{constructor($,k){this.b=k,this.a=$.getProxy(u.$iM.MainThreadMessageService)}showMessage($,k,M,I,b){const E={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof I=="string"||P(I)?v=[I,...b]:(E.modal=I?.modal,E.useCustom=I?.useCustom,E.detail=I?.detail,v=b),E.useCustom&&(0,R.$7F)($,"resolvers");const c=[];let m=!1;for(let a=0;a<v.length;a++){const n=v[a];if(typeof n=="string")c.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;c.push({title:i,isCloseAffordance:!!r,handle:a}),r&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,M,E,c).then(a=>{if(typeof a=="number")return v[a]})}};e.$jkc=A,e.$jkc=A=Je([Ve(1,j.$Nj)],A)}),define(Ee[315],Se([1,0,3,18,2,26,6]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(A.$iM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,M,I){if((0,P.$7F)(k,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,I),this.a.$registerProfileContentHandler(M,I.name,I.description,k.identifier.value),(0,u.$Sc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(k,M,I,b){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(M,I,b)}async $readProfile(k,M,I){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.readProfile((0,j.$Uf)(M)?M:R.URI.revive(M),I)}}e.$skc=p}),define(Ee[117],Se([1,0,6,4,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=void 0;class P{constructor(p){this.b=new j.$7d,this.onDidChangePassword=this.b.event,this.a=p.getProxy(u.$iM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,k){return this.a.$setPassword(p,$,k)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$Djc=P,e.$Ejc=(0,R.$hi)("IExtHostSecretState")}),define(Ee[316],Se([1,0,22,3,6]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class P{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(R.$iM.MainThreadSpeech)}async $createSpeechToTextSession(p,$,k){const M=this.c.get(p);if(!M)return;const I=new j.$Tc,b=new u.$ee;this.d.set($,b);const E=I.add(M.provideSpeechToTextSession(b.token,k?{language:k}:void 0));I.add(E.onDidChange(v=>{b.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),I.add(b.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,$){const k=this.c.get(p);if(!k)return;const M=new j.$Tc,I=new u.$ee;this.d.set($,I);const b=M.add(k.provideKeywordRecognitionSession(I.token));M.add(b.onDidChange(E=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,E)})),M.add(I.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,k){const M=P.a++;return this.c.set(M,k),this.b.$registerProvider(M,$,{extension:p,displayName:p.value}),(0,j.$Sc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$zkc=P}),define(Ee[118],Se([1,0,6,4,5]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$vjc=void 0;class P{constructor(p,$){this.c=$,this.b=new j.$7d,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(u.$iM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,k){const M=await this.a.$initializeExtensionStorage(p,$);let I;return M&&(I=this.d(p,$,M)),I||k}setValue(p,$,k){return this.a.$setValue(p,$,k)}$acceptValue(p,$,k){const M=this.d(p,$,k);M&&this.b.fire({shared:p,key:$,value:M})}d(p,$,k){try{return JSON.parse(k)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${M}`)}}}e.$vjc=P,e.$wjc=(0,R.$hi)("IExtHostStorage")}),define(Ee[317],Se([1,0,3,15,2,6]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class A{static{this.a=new Set([j.Schemas.http,j.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$iM.MainThreadUriOpeners)}registerExternalUriOpener($,k,M,I){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const b=I.schemes.find(E=>!A.a.has(E));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this.c.set(k,M),this.b.$registerUriOpener(k,I.schemes,$,I.label),(0,u.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,M){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const b=R.URI.revive(k);return I.canOpenExternalUri(b,M)}async $openUri($,k,M){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(R.URI.revive(k.resolvedUri),{sourceUri:R.URI.revive(k.sourceUri)},M)}}e.$Nkc=A}),define(Ee[318],Se([1,0,6,2,3,13,25]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class p{static{this.a=0}constructor(k){this.c=new A.$Dm,this.d=new Map,this.b=k.getProxy(u.$iM.MainThreadUrls)}registerUriHandler(k,M){const I=k.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const b=p.a++;return this.c.add(I),this.d.set(b,M),this.b.$registerUriHandler(b,I,k.displayName||k.name),(0,R.$Sc)(()=>{this.c.delete(I),this.d.delete(b),this.b.$unregisterUriHandler(b)})}$handleExternalUri(k,M){const I=this.d.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(j.URI.revive(M))}catch(b){(0,P.$1)(b)}return Promise.resolve(void 0)}async createAppUri(k){return j.URI.revive(await this.b.$createAppUri(k))}}e.$Okc=p}),define(Ee[92],Se([1,0,4,3,15,24,2,245,283,113,6]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=e.$gjc=void 0,e.$hjc=b,e.$jjc=c,e.$kjc=m;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,g,d,l,o){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$7d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=g,this.#s=d,this.#r=l,this.#l=b(l),this.#d=E(l),this.#i=o}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,k.$Oyb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===R.Schemas.https||r.scheme===R.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+k.$Nyb}return k.$Nyb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),P.$Rn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,$.$Lnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,d,l,o,h,f)=>{const D=A.URI.from({scheme:o||"file",path:decodeURIComponent(h)}),w=(0,k.$Oyb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${f}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,d,l,o,h,f)=>{const D=A.URI.from({scheme:o||"file",path:decodeURIComponent(h)}),w=(0,k.$Oyb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${f}`})}}e.$gjc=I;function b(i){try{const r=(0,p.$tp)((0,p.$sp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,p.$tp)((0,p.$sp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends j.$Uc{constructor(r,s,t,g,d){super(),this.c=s,this.f=t,this.g=g,this.h=d,this.b=new Map,this.a=r.getProxy(M.$iM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const g=this.j(r);if(g){const{message:d}=(0,$.$Mnb)(s,t.value);g._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const g=new I(r,this.a,a(s),this.c,this.f,t,this.h);this.b.set(r,g);const d=g._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return g}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$ijc=v;function c(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(Ee[150],Se([1,0,4,6,2,15,14,5,20,26]),function(de,e,u,j,R,P,A,p,$,k){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0;let I=class{static{M=this}static{this.a={focused:!0,active:!0}}getState(E){const v=this.d;return{get focused(){return v.focused},get active(){return(0,k.$7F)(E,"windowActivity"),v.active}}}constructor(E){this.c=new u.$7d,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=E.getProxy(j.$iM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:c})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,v){v!==this.d[E]&&(this.d={...this.d,[E]:v},this.c.fire(this.d))}openUri(E,v){let c;if(typeof E=="string"){c=E;try{E=R.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,A.$Ue)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,c,v)}async asExternalUri(E,v){if((0,A.$Ue)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(E,v);return R.URI.from(c)}};e.$Qkc=I,e.$Qkc=I=M=Je([Ve(0,$.$CO)],I),e.$Rkc=(0,p.$hi)("IExtHostWindow")}),define(Ee[319],Se([1,0,311,27,20]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;const P=1024*1024;let A=class extends u.$Ukc{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,M){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),k.apply(console,M),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const M=process[$],I=M.write;let b="";Object.defineProperty(M,"write",{set:()=>{},get:()=>(E,v,c)=>{if(!this.g){b+=E.toString(v);const m=b.length>P?b.length:b.lastIndexOf(`
`);m!==-1&&(console[k](b.slice(0,m)),b=b.slice(m+1))}I.call(M,E,v,c)}})}};e.$tlc=A,e.$tlc=A=Je([Ve(0,R.$CO),Ve(1,j.$SO)],A)}),define(Ee[320],Se([1,0,149,15,260,30]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class A extends u.$Tkc{s($,k,M){return $.scheme===j.Schemas.file?new R.$PP(M?.name||(0,P.$Dg)(),$.fsPath,!M?.donotRotate,!!M?.donotUseFormatters,k):super.s($,k,M)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Flc=A}),define(Ee[321],Se([1,0,8,21,22,13,4,3,133,308,68]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.ResponsiveState=e.RequestInitiator=void 0,e.$K0b=m,e.$L0b=a;function b(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class c{constructor(C,O){this.jsonString=C,this.referencedBuffers=O}}function m(y,C=null,O=!1){const z=[];return{jsonString:(O?b:JSON.stringify)(y,(T,L)=>{if(typeof L>"u")return v;if(typeof L=="object"){if(L instanceof j.$ue){const N=z.push(L)-1;return{[E]:N}}if(C)return C(T,L)}return L}),referencedBuffers:z}}function a(y,C,O){return JSON.parse(y,(z,F)=>{if(F){const T=F[E];if(typeof T=="number")return C[T];if(O&&F.$mid===1)return O.transformIncoming(F)}return F})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,O)=>O&&O.$mid===1?y.transformOutgoing(O):O:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},g=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends p.$Uc{static{I=g}static{this.a=3*1e3}constructor(C,O=null,z=null){super(),this[I]=!0,this.b=this.B(new A.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=O,this.g=z,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,T=M.$aw.count;F<T;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$th(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const O=this.w[C];delete this.w[C],O.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$mn)(C,this.g):C}getProxy(C){const{nid:O,sid:z}=C;return this.s[O]||(this.s[O]=this.J(O,z)),this.s[O]}J(C,O){const z={get:(F,T)=>(typeof T=="string"&&!F[T]&&T.charCodeAt(0)===36&&(F[T]=(...L)=>this.U(C,T,L)),T===d?O:F[T])};return new Proxy(Object.create(null),z)}set(C,O){return this.m[C.nid]=O,O}assertRegistered(C){for(let O=0,z=C.length;O<z;O++){const F=C[O];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(C){if(this.j)return;const O=C.byteLength,z=h.read(C,0),F=z.readUInt8(),T=z.readUInt32();switch(F){case 1:case 2:{let{rpcId:L,method:N,args:B}=D.deserializeRequestJSONArgs(z);this.g&&(B=(0,$.$mn)(B,this.g)),this.M(O,T,L,N,B,F===2);break}case 3:case 4:{let{rpcId:L,method:N,args:B}=D.deserializeRequestMixedArgs(z);this.g&&(B=(0,$.$mn)(B,this.g)),this.M(O,T,L,N,B,F===4);break}case 5:{this.f?.logIncoming(O,T,0,"ack"),this.G(T);break}case 6:{this.N(O,T);break}case 7:{this.O(O,T,void 0);break}case 9:{let L=D.deserializeReplyOKJSON(z);this.g&&(L=(0,$.$mn)(L,this.g)),this.O(O,T,L);break}case 10:{const L=D.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(O,T,L);break}case 8:{const L=D.deserializeReplyOKVSBuffer(z);this.O(O,T,L);break}case 11:{let L=D.deserializeReplyErrError(z);this.g&&(L=(0,$.$mn)(L,this.g)),this.P(O,T,L);break}case 12:{this.P(O,T,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,O,z,F,T,L){this.f?.logIncoming(C,O,1,`receiveRequest ${(0,M.$cw)(z)}.${F}(`,T);const N=String(O);let B,U;if(L){const _=new R.$ee;T.push(_.token),B=this.Q(z,F,T),U=()=>_.cancel()}else B=this.Q(z,F,T),U=t;this.u[N]=U;const Z=D.serializeAcknowledged(O);this.f?.logOutgoing(Z.byteLength,O,1,"ack"),this.c.send(Z),B.then(_=>{delete this.u[N];const Y=D.serializeReplyOK(O,_,this.h);this.f?.logOutgoing(Y.byteLength,O,1,"reply:",_),this.c.send(Y)},_=>{delete this.u[N];const Y=D.serializeReplyErr(O,_);this.f?.logOutgoing(Y.byteLength,O,1,"replyErr:",_),this.c.send(Y)})}N(C,O){this.f?.logIncoming(C,O,1,"receiveCancel");const z=String(O);this.u[z]?.()}O(C,O,z){this.f?.logIncoming(C,O,0,"receiveReply:",z);const F=String(O);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F],T.resolveOk(z)}P(C,O,z){this.f?.logIncoming(C,O,0,"receiveReplyErr:",z);const F=String(O);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F];let L;z&&(z.$isError?(L=new Error,L.name=z.name,L.message=z.message,L.stack=z.stack):L=z),T.resolveErr(L)}Q(C,O,z){try{return Promise.resolve(this.S(C,O,z))}catch(F){return Promise.reject(F)}}S(C,O,z){const F=this.m[C];if(!F)throw new Error("Unknown actor "+(0,M.$cw)(C));const T=F[O];if(typeof T!="function")throw new Error("Unknown method "+O+" on actor "+(0,M.$cw)(C));return T.apply(F,z)}U(C,O,z){if(this.j)return new k.$J0b;let F=null;if(z.length>0&&R.CancellationToken.isCancellationToken(z[z.length-1])&&(F=z.pop()),F&&F.isCancellationRequested)return Promise.reject(P.$6());const T=D.serializeRequestArguments(z,this.h),L=++this.t,N=String(L),B=new k.$I0b,U=new p.$Tc;F&&U.add(F.onCancellationRequested(()=>{const _=D.serializeCancel(L);this.f?.logOutgoing(_.byteLength,L,0,"cancel"),this.c.send(D.serializeCancel(L))})),this.w[N]=new o(B,U),this.F(L);const Z=D.serializeRequest(L,C,O,T,!!F);return this.f?.logOutgoing(Z.byteLength,L,0,`request: ${(0,M.$cw)(C)}.${O}(`,z),this.c.send(Z),B}}e.$M0b=l;class o{constructor(C,O){this.a=C,this.b=O}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,O,z){const F=new h(j.$ue.alloc(z+1+4),0);return F.writeUInt8(C),F.writeUInt32(O),F}static read(C,O){return new h(C,O)}get buffer(){return this.a}constructor(C,O){this.a=C,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+C);return this.b+=C,O}static sizeMixedArray(C){let O=0;O+=1;for(let z=0,F=C.length;z<F;z++){const T=C[z];switch(O+=1,T.type){case 1:O+=this.sizeLongString(T.value);break;case 2:O+=this.sizeVSBuffer(T.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(T.value);for(let L=0;L<T.buffers.length;++L)O+=this.sizeVSBuffer(T.buffers[L]);break;case 4:break}}return O}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let O=0,z=C.length;O<z;O++){const F=C[O];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let T=0;T<F.buffers.length;++T)this.writeBuffer(F.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const O=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:O[z]=this.readLongString();break;case 2:O[z]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),L=this.readLongString(),N=[];for(let B=0;B<T;++B)N.push(this.readVSBuffer());O[z]=new M.$dw(a(L,N,null));break}case 4:O[z]=void 0;break}return O}}var f;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(f||(f={}));class D{static a(C){for(let O=0,z=C.length;O<z;O++)if(C[O]instanceof j.$ue||C[O]instanceof M.$dw||typeof C[O]>"u")return!0;return!1}static serializeRequestArguments(C,O){if(this.a(C)){const z=[];for(let F=0,T=C.length;F<T;F++){const L=C[F];if(L instanceof j.$ue)z[F]={type:2,value:L};else if(typeof L>"u")z[F]={type:4};else if(L instanceof M.$dw){const{jsonString:N,referencedBuffers:B}=m(L.value,O);z[F]={type:3,value:j.$ue.fromString(N),buffers:B}}else z[F]={type:1,value:j.$ue.fromString(n(L,O))}}return{type:1,args:z}}return{type:0,args:n(C,O)}}static serializeRequest(C,O,z,F,T){switch(F.type){case 0:return this.b(C,O,z,F.args,T);case 1:return this.c(C,O,z,F.args,T)}}static b(C,O,z,F,T){const L=j.$ue.fromString(z),N=j.$ue.fromString(F);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(L),B+=h.sizeLongString(N);const U=h.alloc(T?2:1,C,B);return U.writeUInt8(O),U.writeShortString(L),U.writeLongString(N),U.buffer}static deserializeRequestJSONArgs(C){const O=C.readUInt8(),z=C.readShortString(),F=C.readLongString();return{rpcId:O,method:z,args:JSON.parse(F)}}static c(C,O,z,F,T){const L=j.$ue.fromString(z);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(L),N+=h.sizeMixedArray(F);const B=h.alloc(T?4:3,C,N);return B.writeUInt8(O),B.writeShortString(L),B.writeMixedArray(F),B.buffer}static deserializeRequestMixedArgs(C){const O=C.readUInt8(),z=C.readShortString(),F=C.readMixedArray(),T=new Array(F.length);for(let L=0,N=F.length;L<N;L++){const B=F[L];typeof B=="string"?T[L]=JSON.parse(B):T[L]=B}return{rpcId:O,method:z,args:T}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,O,z){if(typeof O>"u")return this.d(C);if(O instanceof j.$ue)return this.e(C,O);if(O instanceof M.$dw){const{jsonString:F,referencedBuffers:T}=m(O.value,z,!0);return this.g(C,F,T)}else return this.f(C,b(O,z))}static d(C){return h.alloc(7,C,0).buffer}static e(C,O){let z=0;z+=h.sizeVSBuffer(O);const F=h.alloc(8,C,z);return F.writeVSBuffer(O),F.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,O){const z=j.$ue.fromString(O);let F=0;F+=h.sizeLongString(z);const T=h.alloc(9,C,F);return T.writeLongString(z),T.buffer}static g(C,O,z){const F=j.$ue.fromString(O);let T=0;T+=h.sizeUInt32,T+=h.sizeLongString(F);for(const N of z)T+=h.sizeVSBuffer(N);const L=h.alloc(10,C,T);L.writeUInt32(z.length),L.writeLongString(F);for(const N of z)L.writeBuffer(N);return L.buffer}static deserializeReplyOKJSON(C){const O=C.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(C,O){const z=C.readUInt32(),F=C.readLongString(),T=[];for(let L=0;L<z;++L)T.push(C.readVSBuffer());return new M.$dw(a(F,T,O))}static serializeReplyErr(C,O){const z=O?b(P.$3(O),null):void 0;if(typeof z!="string")return this.h(C);const F=j.$ue.fromString(z);let T=0;T+=h.sizeLongString(F);const L=h.alloc(11,C,T);return L.writeLongString(F),L.buffer}static deserializeReplyErrError(C){const O=C.readLongString();return JSON.parse(O)}static h(C){return h.alloc(12,C,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Ee[322],Se([1,0,21,28,15,84,5]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$WJ=void 0,e.$XJ=M,e.$YJ=I,e.$WJ=(0,A.$hi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),k=7;function M(E){if(E.scheme!==R.Schemas.vscodeNotebookCell)return;const v=E.fragment.indexOf("s");if(v<0)return;const c=parseInt(E.fragment.substring(0,v).replace($,""),k),m=(0,u.$Ne)(E.fragment.substring(v+1)).toString();if(!isNaN(c))return{handle:c,notebook:E.with({scheme:m,fragment:null})}}function I(E,v){const c=v.toString(k),a=`${c.length<p.length?p[c.length-1]:"z"}${c}s${(0,u.$Oe)(u.$ue.fromString(E.scheme),!0,!0)}`;return E.with({scheme:R.Schemas.vscodeNotebookCell,fragment:a})}class b{constructor(){this.a=new j.$Bc}getNotebook(v){if(v.scheme===R.Schemas.vscodeNotebookCell){const c=M(v);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$ZJ=b,(0,P.$fs)(e.$WJ,b,1)}),define(Ee[119],Se([1,0,21,35,38,101,15,17,11,41,322]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$eK=e.CellStatusbarAlignment=e.$dK=e.NotebookEditorPriority=e.$aK=e.$_J=e.$0J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$9J=e.$8J=e.$7J=e.$6J=e.CellKind=e.$5J=e.$4J=e.$3J=void 0,e.$$J=g,e.$bK=l,e.$cK=o,e.$fK=D,e.$gK=S,e.$3J="workbench.editor.notebook",e.$4J="workbench.editor.notebookTextDiffEditor",e.$5J="workbench.editor.interactive";var I;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(I||(e.CellKind=I={})),e.$6J=["application/json","application/javascript","text/html","image/svg+xml",P.$ys.latex,P.$ys.markdown,"image/png","image/jpeg",P.$ys.text],e.$7J=[P.$ys.latex,P.$ys.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$ys.text],e.$8J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$9J="_notAvailable";var b;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var a;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=A.Schemas.vscodeNotebookCell;function U(X,me){return(0,M.$YJ)(X,me)}B.generate=U;function Z(X){return(0,M.$XJ)(X)}B.parse=Z;function _(X,me){return X.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${X.scheme!==A.Schemas.file?X.scheme:""}`})}B.generateCellOutputUri=_;function Y(X){if(X.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!me)return;const ae=me[1]&&me[1]!==""?me[1]:void 0,re=me[2];return{outputId:ae,notebook:X.with({scheme:re||A.Schemas.file,fragment:null})}}B.parseCellOutputUri=Y;function x(X,me,ae){return B.generate(X,me).with({scheme:ae})}B.generateCellPropertyUri=x;function ce(X,me){if(X.scheme===me)return B.parse(X.with({scheme:B.scheme}))}B.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const s=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(U=[],Z=e.$6J){this.e=Z,this.d=[...new Set(U)].map(_=>({pattern:_,matches:j.$bk(s(_))}))}sort(U){const Z=new Map(R.Iterable.map(U,Y=>[Y,s(Y)]));let _=[];for(const{matches:Y}of this.d)for(const[x,ce]of Z)if(Y(ce)){_.push(x),Z.delete(x);break}return Z.size&&(_=_.concat([...Z.keys()].sort((Y,x)=>this.e.indexOf(Y)-this.e.indexOf(x)))),_}prioritize(U,Z){const _=this.f(U);if(_===-1){this.d.unshift({pattern:U,matches:j.$bk(s(U))});return}const Y=new Set(Z.map(ce=>this.f(ce,_)));Y.delete(-1);const x=Array.from(Y).sort();this.d.splice(_+1,0,...x.map(ce=>this.d[ce]));for(let ce=x.length-1;ce>=0;ce--)this.d.splice(x[ce],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,Z=this.d.length){const _=s(U);for(let Y=0;Y<Z;Y++)if(this.d[Y].matches(_))return Y;return-1}}e.$0J=t;function g(B,U,Z,_=(Y,x)=>Y===x){const Y=[];function x(me,ae,re){if(ae===0&&re.length===0)return;const W=Y[Y.length-1];W&&W.start+W.deleteCount===me?(W.deleteCount+=ae,W.toInsert.push(...re)):Y.push({start:me,deleteCount:ae,toInsert:re})}let ce=0,X=0;for(;;){if(ce===B.length){x(ce,0,U.slice(X));break}if(X===U.length){x(ce,B.length-ce,[]);break}const me=B[ce],ae=U[X];if(_(me,ae)){ce+=1,X+=1;continue}Z(ae)?(x(ce,1,[]),ce+=1):(x(ce,0,[ae]),X+=1)}return Y}e.$_J=new k.$yj("notebookEditorCursorAtBoundary","none"),e.$aK=new k.$yj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const U=B;return!!((typeof U.include=="string"||j.$ck(U.include))&&(typeof U.exclude=="string"||j.$ck(U.exclude)))}function o(B,U,Z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const _=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Y=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(j.$ak(_,(0,p.$oc)(Z.fsPath).toLowerCase()))return!(Y&&j.$ak(Y,(0,p.$oc)(Z.fsPath).toLowerCase()))}return!1}e.$dK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class f{static{this.d="notebook/"}static create(U){return`${f.d}${U}`}static parse(U){if(U.startsWith(f.d))return U.substring(f.d.length)}}e.$eK=f;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const w=new TextDecoder;function S(B){const U=[];let Z=!1;for(const ce of B)(U.length===0||Z)&&(U.push(ce),Z=!0);let _=O(U);const Y=u.$ue.concat(U.map(ce=>u.$ue.wrap(ce))),x=N(Y);return _=_||x.byteLength!==Y.byteLength,{data:x,didCompression:_}}e.$hK="\x1B[A";const y=e.$hK.split("").map(B=>B.charCodeAt(0)),C=10;function O(B){let U=!1;return B.forEach((Z,_)=>{if(_===0||Z.length<e.$hK.length)return;const Y=B[_-1],x=Z.subarray(0,e.$hK.length);if(x[0]===y[0]&&x[1]===y[1]&&x[2]===y[2]){const ce=Y.lastIndexOf(C);if(ce===-1)return;U=!0,B[_-1]=Y.subarray(0,ce),B[_]=Z.subarray(e.$hK.length)}}),U}function z(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function F(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let Z=B.match(/\r+(.*)$/m)[1];Z=Z+U.slice(Z.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return B}const T=8,L=13;function N(B){return!B.buffer.includes(T)&&!B.buffer.includes(L)?B:u.$ue.fromString(F(z(w.decode(B.buffer))))}}),define(Ee[7],Se([1,0,19,13,80,28,101,14,18,2,30,25,32,65,119]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v){"use strict";var c,m,a,n,i,r,s,t,g,d,l,o,h,f,D,w,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$qO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$pO=e.$oO=e.$nO=e.$mO=e.ChatLocation=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$dO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.TestRunProfileKind=e.TestResultState=e.$VN=e.$UN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$TN=e.NotebookVariablesRequestKind=e.$SN=e.$RN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$QN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.ColorThemeKind=e.$KN=e.$JN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$IN=e.$HN=e.DebugConsoleMode=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BN=e.$AN=e.FileChangeType=e.$zN=e.NewSymbolNameTag=e.$yN=e.$xN=e.$wN=e.$vN=e.InlineCompletionTriggerKind=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$iN=e.ConfigurationTarget=e.$hN=e.$gN=e.$fN=e.$eN=e.DocumentPasteTriggerKind=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$0M=e.ViewBadge=e.ProgressLocation=e.$9M=e.$8M=e.TaskScope=e.ShellQuoting=e.$7M=e.$6M=e.$5M=e.TaskPanelKind=e.TaskRevealKind=e.$4M=e.TerminalLocation=e.$3M=e.$2M=e.$1M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$ZM=e.$YM=e.$XM=e.$WM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$UM=e.$TM=e.$SM=e.$RM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$QM=e.$PM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.LanguageStatusSeverity=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.CodeActionTriggerKind=e.$DM=e.$CM=e.SymbolTag=e.SymbolKind=e.$BM=e.$AM=e.DocumentHighlightKind=e.$zM=e.$yM=e.$xM=e.$wM=e.DiagnosticSeverity=e.DiagnosticTag=e.$vM=e.$uM=e.FileEditType=e.$tM=e.$sM=e.$rM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$VM=bt,e.$jN=te;function y(G){return Object.assign(G,{apply:function(...be){if(be.length===0)return Reflect.construct(G,[]);{const Le=be.length===1?[]:be[1];return Reflect.construct(G,Le,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(G,[]);{const[Le,...Ze]=be;return Reflect.construct(G,Ze,Le.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var O;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let z=c=class{static from(...H){let be=H;return new c(function(){if(be){for(const Le of be)Le&&typeof Le.dispose=="function"&&Le.dispose();be=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$kM=z,e.$kM=z=c=Je([y],z);let F=m=class{static Min(...H){if(H.length===0)throw new TypeError;let be=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isBefore(be)&&(be=Ze)}return be}static Max(...H){if(H.length===0)throw new TypeError;let be=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isAfter(be)&&(be=Ze)}return be}static isPosition(H){if(!H)return!1;if(H instanceof m)return!0;const{line:be,character:Le}=H;return typeof be=="number"&&typeof Le=="number"}static of(H){if(H instanceof m)return H;if(this.isPosition(H))return new m(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,be){if(H<0)throw(0,j.$7)("line must be non-negative");if(be<0)throw(0,j.$7)("character must be non-negative");this.c=H,this.e=be}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,be=0){if(H===null||be===null)throw(0,j.$7)();let Le;return typeof H>"u"?Le=0:typeof H=="number"?Le=H:(Le=typeof H.lineDelta=="number"?H.lineDelta:0,be=typeof H.characterDelta=="number"?H.characterDelta:0),Le===0&&be===0?this:new m(this.line+Le,this.character+be)}with(H,be=this.character){if(H===null||be===null)throw(0,j.$7)();let Le;return typeof H>"u"?Le=this.line:typeof H=="number"?Le=H:(Le=typeof H.line=="number"?H.line:this.line,be=typeof H.character=="number"?H.character:this.character),Le===this.line&&be===this.character?this:new m(Le,be)}toJSON(){return{line:this.line,character:this.character}}};e.$lM=F,e.$lM=F=m=Je([y],F);let T=a=class{static isRange(H){return H instanceof a?!0:H?F.isPosition(H.start)&&F.isPosition(H.end):!1}static of(H){if(H instanceof a)return H;if(this.isRange(H))return new a(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,be,Le,Ze){let it,ht;if(typeof H=="number"&&typeof be=="number"&&typeof Le=="number"&&typeof Ze=="number"?(it=new F(H,be),ht=new F(Le,Ze)):F.isPosition(H)&&F.isPosition(be)&&(it=F.of(H),ht=F.of(be)),!it||!ht)throw new Error("Invalid arguments");it.isBefore(ht)?(this.c=it,this.e=ht):(this.c=ht,this.e=it)}contains(H){return a.isRange(H)?this.contains(H.start)&&this.contains(H.end):F.isPosition(H)?!(F.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const be=F.Max(H.start,this.c),Le=F.Min(H.end,this.e);if(!be.isAfter(Le))return new a(be,Le)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const be=F.Min(H.start,this.c),Le=F.Max(H.end,this.end);return new a(be,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,be=this.end){if(H===null||be===null)throw(0,j.$7)();let Le;return H?F.isPosition(H)?Le=H:(Le=H.start||this.start,be=H.end||this.end):Le=this.start,Le.isEqual(this.c)&&be.isEqual(this.end)?this:new a(Le,be)}toJSON(){return[this.start,this.end]}};e.$mM=T,e.$mM=T=a=Je([y],T);let L=n=class extends T{static isSelection(H){return H instanceof n?!0:H?T.isRange(H)&&F.isPosition(H.anchor)&&F.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,be,Le,Ze){let it,ht;if(typeof H=="number"&&typeof be=="number"&&typeof Le=="number"&&typeof Ze=="number"?(it=new F(H,be),ht=new F(Le,Ze)):F.isPosition(H)&&F.isPosition(be)&&(it=F.of(H),ht=F.of(be)),!it||!ht)throw new Error("Invalid arguments");super(it,ht),this.f=it,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$nM=L,e.$nM=L=n=Je([y],L);const N=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,j.$7)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,be,Le){if(typeof H!="string"||H.length===0)throw(0,j.$7)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,j.$7)("port");typeof Le<"u"&&N(Le),this.host=H,this.port=Math.round(be),this.connectionToken=Le}}e.$oM=B;class U{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,be){this.makeConnection=H,this.connectionToken=be,typeof be<"u"&&N(be)}}e.$pM=U;class Z extends Error{static NotAvailable(H,be){return new Z(H,E.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(H){return new Z(H,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,be=E.RemoteAuthorityResolverErrorCode.Unknown,Le){super(H),this._message=H,this._code=be,this._detail=Le,Object.setPrototypeOf(this,Z.prototype)}}e.$qM=Z;var _;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var Y;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let x=i=class{static isTextEdit(H){return H instanceof i?!0:H?T.isRange(H)&&typeof H.newText=="string":!1}static replace(H,be){return new i(H,be)}static insert(H,be){return i.replace(new T(H,H),be)}static delete(H){return i.replace(H,"")}static setEndOfLine(H){const be=new i(new T(new F(0,0),new F(0,0)),"");return be.newEol=H,be}get range(){return this.c}set range(H){if(H&&!T.isRange(H))throw(0,j.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,j.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,j.$7)("newEol");this.f=H}constructor(H,be){this.c=H,this.e=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$rM=x,e.$rM=x=i=Je([y],x);let ce=r=class{static isNotebookCellEdit(H){return H instanceof r?!0:H?Ue.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,be){return new r(H,be)}static insertCells(H,be){return new r(new Ue(H,H),be)}static deleteCells(H){return new r(H,[])}static updateCellMetadata(H,be){const Le=new r(new Ue(H,H),[]);return Le.newCellMetadata=be,Le}static updateNotebookMetadata(H){const be=new r(new Ue(0,0),[]);return be.newNotebookMetadata=H,be}constructor(H,be){this.range=H,this.newCells=be}};e.$sM=ce,e.$sM=ce=r=Je([y],ce);class X{static isSnippetTextEdit(H){return H instanceof X?!0:H?T.isRange(H.range)&&re.isSnippetString(H.snippet):!1}static replace(H,be){return new X(H,be)}static insert(H,be){return X.replace(new T(H,H),be)}constructor(H,be){this.range=H,this.snippet=be}}e.$tM=X;var me;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(me||(e.FileEditType=me={}));let ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,be,Le,Ze){this.c.push({_type:1,from:H,to:be,options:Le,metadata:Ze})}createFile(H,be,Le){this.c.push({_type:1,from:void 0,to:H,options:be,metadata:Le})}deleteFile(H,be,Le){this.c.push({_type:1,from:H,to:void 0,options:be,metadata:Le})}e(H,be,Le){this.c.push({_type:3,metadata:Le,uri:H,edit:{editType:5,metadata:be},notebookMetadata:be})}f(H,be,Le,Ze){const it=be.start,ht=be.end;(it!==ht||Le.length>0)&&this.c.push({_type:5,uri:H,index:it,count:ht-it,cells:Le,metadata:Ze})}g(H,be,Le,Ze){this.c.push({_type:3,metadata:Ze,uri:H,edit:{editType:3,index:be,metadata:Le}})}replace(H,be,Le,Ze){this.c.push({_type:2,uri:H,edit:new x(be,Le),metadata:Ze})}insert(H,be,Le,Ze){this.replace(H,new T(be,be),Le,Ze)}delete(H,be,Le){this.replace(H,be,"",Le)}has(H){return this.c.some(be=>be._type===2&&be.uri.toString()===H.toString())}set(H,be){if(be)for(const Le of be){if(!Le)continue;let Ze,it;Array.isArray(Le)?(Ze=Le[0],it=Le[1]):Ze=Le,ce.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(H,Ze.range.start,Ze.newCellMetadata,it):Ze.newNotebookMetadata?this.e(H,Ze.newNotebookMetadata,it):this.f(H,Ze.range,Ze.newCells,it):X.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:H,range:Ze.range,edit:Ze.snippet,metadata:it}):this.c.push({_type:2,uri:H,edit:Ze,metadata:it})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===H.toString()&&(this.c[Le]=void 0);break}}(0,u.$Ib)(this.c)}}get(H){const be=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===H.toString()&&be.push(Le.edit);return be}entries(){const H=new P.$Bc;for(const be of this.c)if(be._type===2){let Le=H.get(be.uri);Le||(Le=[be.uri,[]],H.set(be.uri,Le)),Le[1].push(be.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$uM=ae,e.$uM=ae=Je([y],ae);let re=s=class{static isSnippetString(H){return H instanceof s?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=s.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,be=this.e++){if(typeof H=="function"){const Le=new s;Le.e=this.e,H(Le),this.e=Le.e,H=Le.value}else H=s.c(H);return this.value+="${",this.value+=be,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,be=this.e++){const Le=H.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(H,be){if(typeof be=="function"){const Le=new s;Le.e=this.e,be(Le),this.e=Le.e,be=Le.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.$vM=re,e.$vM=re=s=Je([y],re);var W;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var ie;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ve=t=class{static isLocation(H){return H instanceof t?!0:H?T.isRange(H.range)&&k.URI.isUri(H.uri):!1}constructor(H,be){if(this.uri=H,be)if(T.isRange(be))this.range=T.of(be);else if(F.isPosition(be))this.range=new T(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$wM=ve,e.$wM=ve=t=Je([y],ve);let Pe=class{static is(H){return H?typeof H.message=="string"&&H.location&&T.isRange(H.location.range)&&k.URI.isUri(H.location.uri):!1}constructor(H,be){this.location=H,this.message=be}static isEqual(H,be){return H===be?!0:!H||!be?!1:H.message===be.message&&H.location.range.isEqual(be.location.range)&&H.location.uri.toString()===be.location.uri.toString()}};e.$xM=Pe,e.$xM=Pe=Je([y],Pe);let le=class{constructor(H,be,Le=ie.Error){if(!T.isRange(H))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=H,this.message=be,this.severity=Le}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,be){return H===be?!0:!H||!be?!1:H.message===be.message&&H.severity===be.severity&&H.code===be.code&&H.severity===be.severity&&H.source===be.source&&H.range.isEqual(be.range)&&(0,u.$ub)(H.tags,be.tags)&&(0,u.$ub)(H.relatedInformation,be.relatedInformation,Pe.isEqual)}};e.$yM=le,e.$yM=le=Je([y],le);let ue=class{constructor(H,be){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=be}};e.$zM=ue,e.$zM=ue=Je([y],ue);var oe;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let K=class{constructor(H,be=oe.Text){this.range=H,this.kind=be}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$AM=K,e.$AM=K=Je([y],K);let ee=class{constructor(H,be){this.uri=H,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$BM=ee,e.$BM=ee=Je([y],ee);var he;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var fe;(function(G){G[G.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Ae=g=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,be,Le,Ze,it){this.name=H,this.kind=be,this.containerName=it,typeof Le=="string"&&(this.containerName=Le),Ze instanceof ve?this.location=Ze:Le instanceof T&&(this.location=new ve(Ze,Le)),g.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$CM=Ae,e.$CM=Ae=g=Je([y],Ae);let pe=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(d.validate)}constructor(H,be,Le,Ze,it){this.name=H,this.detail=be,this.kind=Le,this.range=Ze,this.selectionRange=it,this.children=[],d.validate(this)}};e.$DM=pe,e.$DM=pe=d=Je([y],pe);var Ce;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Me=class{constructor(H,be){this.title=H,this.kind=be}};e.$EM=Me,e.$EM=Me=Je([y],Me);let Fe=class{static{l=this}static{this.c="."}constructor(H){this.value=H}append(H){return new l(this.value?this.value+l.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+l.c)}};e.$FM=Fe,e.$FM=Fe=l=Je([y],Fe),Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll"),Fe.Notebook=Fe.Empty.append("notebook");let V=class{constructor(H,be){if(this.range=H,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$GM=V,e.$GM=V=Je([y],V);class q{constructor(H,be,Le,Ze,it,ht){this.kind=H,this.name=be,this.detail=Le,this.uri=Ze,this.range=it,this.selectionRange=ht}}e.$HM=q;class Q{constructor(H,be){this.fromRanges=be,this.from=H}}e.$IM=Q;class J{constructor(H,be){this.fromRanges=be,this.to=H}}e.$JM=J;var ge;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(ge||(e.LanguageStatusSeverity=ge={}));let we=class{constructor(H,be){this.range=H,this.command=be}get isResolved(){return!!this.command}};e.$KM=we,e.$KM=we=Je([y],we);let Te=o=class{#e;static isMarkdownString(H){return H instanceof o?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,be=!1){this.#e=new R.$Ek(H,{supportThemeIcons:be})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,be){return this.#e.appendCodeblock(be??"",H),this}};e.$LM=Te,e.$LM=Te=o=Je([y],Te);let He=class{constructor(H,be){this.label=H,this.documentation=be}};e.$MM=He,e.$MM=He=Je([y],He);let Xe=class{constructor(H,be){this.label=H,this.documentation=be,this.parameters=[]}};e.$NM=Xe,e.$NM=Xe=Je([y],Xe);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$OM=tt,e.$OM=tt=Je([y],tt);var nt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var at;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let st=class{constructor(H){this.value=H}};e.$PM=st,e.$PM=st=Je([y],st);let Ie=class{constructor(H,be,Le){this.position=H,this.label=be,this.kind=Le}};e.$QM=Ie,e.$QM=Ie=Je([y],Ie);var ze;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var Re;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Re||(e.CompletionItemKind=Re={}));var Ge;(function(G){G[G.Deprecated=1]="Deprecated"})(Ge||(e.CompletionItemTag=Ge={}));let ne=class{constructor(H,be){this.label=H,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Re[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$RM=ne,e.$RM=ne=Je([y],ne);let se=class{constructor(H=[],be=!1){this.items=H,this.isIncomplete=be}};e.$SM=se,e.$SM=se=Je([y],se);let De=class{constructor(H,be,Le){this.insertText=H,this.range=be,this.command=Le}};e.$TM=De,e.$TM=De=Je([y],De);let Ke=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$UM=Ke,e.$UM=Ke=Je([y],Ke);var xe;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(xe||(e.PartialAcceptTriggerKind=xe={}));var ot;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var Ne;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ne||(e.StatusBarAlignment=Ne={}));function bt(G,H){return`${I.$Cm.toKey(G)}.${H}`}var St;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(St||(e.TextEditorLineNumbersStyle=St={}));var It;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var xt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(xt||(e.TextEditorRevealType=xt={}));var Tt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Dt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Dt||(e.TextDocumentChangeReason=Dt={}));var Qt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Qt||(e.DecorationRangeBehavior=Qt={})),function(G){function H(be){switch(be){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ut;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Ut||(e.SyntaxTokenType=Ut={})),function(G){function H(be){switch(be){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}(Ut||(e.SyntaxTokenType=Ut={}));let ai=class{constructor(H,be){if(be&&!k.URI.isUri(be))throw(0,j.$7)("target");if(!T.isRange(H)||H.isEmpty)throw(0,j.$7)("range");this.range=H,this.target=be}};e.$WM=ai,e.$WM=ai=Je([y],ai);let ii=class{constructor(H,be,Le,Ze){this.red=H,this.green=be,this.blue=Le,this.alpha=Ze}};e.$XM=ii,e.$XM=ii=Je([y],ii);let _e=class{constructor(H,be){if(be&&!(be instanceof ii))throw(0,j.$7)("color");if(!T.isRange(H)||H.isEmpty)throw(0,j.$7)("range");this.range=H,this.color=be}};e.$YM=_e,e.$YM=_e=Je([y],_e);let _t=class{constructor(H){if(!H||typeof H!="string")throw(0,j.$7)("label");this.label=H}};e.$ZM=_t,e.$ZM=_t=Je([y],_t);var ni;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ni||(e.ColorFormat=ni={}));var dt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var pt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(pt||(e.TerminalExitReason=pt={}));class ri{constructor(H,be,Le){if(this.startIndex=H,this.length=be,this.tooltip=Le,typeof H!="number"||H<0)throw(0,j.$7)("startIndex");if(typeof be!="number"||be<1)throw(0,j.$7)("length");if(Le!==void 0&&typeof Le!="string")throw(0,j.$7)("tooltip")}}e.$1M=ri;class Wt{constructor(H){this.uri=H}}e.$2M=Wt;class qt{constructor(H){this.terminalCommand=H}}e.$3M=qt;var ft;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(ft||(e.TerminalLocation=ft={}));class Rt{constructor(H){if(this.options=H,typeof H!="object")throw(0,j.$7)("options")}}e.$4M=Rt;var ei;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(ei||(e.TaskRevealKind=ei={}));var si;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(si||(e.TaskPanelKind=si={}));let Qe=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(H){switch(H){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(H,be){if(this.label=be,typeof H!="string"||typeof be!="string")throw(0,j.$7)("name");this.c=H}get id(){return this.c}};e.$5M=Qe,e.$5M=Qe=h=Je([y],Qe);function Vt(G){let H="";for(let be=0;be<G.length;be++)H+=G[be].replace(/,/g,",,")+",";return H}let Yt=class{constructor(H,be,Le){if(typeof H!="string")throw(0,j.$7)("process");this.e=[],this.c=H,be!==void 0&&(Array.isArray(be)?(this.e=be,this.f=Le):this.f=be)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,j.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const be of this.e)H.push(be);return Vt(H)}};e.$6M=Yt,e.$6M=Yt=Je([y],Yt);let Ht=class{constructor(H,be,Le){if(this.f=[],Array.isArray(be)){if(!H)throw(0,j.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,j.$7)("command");this.e=H,this.f=be,this.g=Le}else{if(typeof H!="string")throw(0,j.$7)("commandLine");this.c=H,this.g=be}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,j.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,j.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const be of this.f)H.push(typeof be=="string"?be:be.value);return Vt(H)}};e.$7M=Ht,e.$7M=Ht=Je([y],Ht);var mt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(mt||(e.ShellQuoting=mt={}));var jt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(jt||(e.TaskScope=jt={}));class Pt{constructor(H){this.c=H}computeId(){return"customExecution"+(0,M.$Dg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$8M=Pt;let Lt=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,be,Le,Ze,it,ht){this.k=!1,this.l=this.definition=H;let gt;typeof be=="string"?(this.o=this.name=be,this.w=this.source=Le,this.execution=Ze,gt=it,this.k=!0):be===jt.Global||be===jt.Workspace?(this.target=be,this.o=this.name=Le,this.w=this.source=Ze,this.execution=it,gt=ht):(this.target=be,this.o=this.name=Le,this.w=this.source=Ze,this.execution=it,gt=ht),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Yt?this.l={type:f.e,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:f.f,id:this.q.computeId()}:this.q instanceof Pt?this.l={type:f.c,id:this.q.computeId()}:this.l={type:f.g,id:(0,M.$Dg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,j.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,j.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const be=this.l.type;(f.g===be||f.e===be||f.f===be||f.c===be)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,j.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$9M=Lt,e.$9M=Lt=f=Je([y],Lt);var oi;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var Gt;(function(G){function H(be){const Le=be;return(0,$.$Yf)(Le.value)?Le.tooltip&&!(0,$.$Uf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}G.isViewBadge=H})(Gt||(e.ViewBadge=Gt={}));let Zt=D=class{static isTreeItem(H,be){const Le=H;if(Le.checkboxState!==void 0){const Ze=(0,$.$Yf)(Le.checkboxState)?Le.checkboxState:(0,$.$Wf)(Le.checkboxState)&&(0,$.$Yf)(Le.checkboxState.state)?Le.checkboxState.state:void 0,it=!(0,$.$Yf)(Le.checkboxState)&&(0,$.$Wf)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Nt.Checked&&Ze!==Nt.Unchecked||it!==void 0&&!(0,$.$Uf)(it))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(H instanceof D)return!0;if(Le.label!==void 0&&!(0,$.$Uf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$Uf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$Uf)(Le.iconPath)&&!k.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$Uf)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,$.$Uf)(Ze.light)&&!k.URI.isUri(Ze.light)&&!(0,$.$Uf)(Ze.dark)&&!k.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$Uf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!k.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$Uf)(Le.tooltip)&&!(Le.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<vt.None&&Le.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$Uf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(H,be=vt.None){this.collapsibleState=be,k.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$0M=Zt,e.$0M=Zt=D=Je([y],Zt);var vt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Nt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Nt||(e.TreeItemCheckboxState=Nt={}));let Bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$$M=Bt,e.$$M=Bt=Je([y],Bt);class Ft extends Bt{}e.$_M=Ft;class kt extends Ft{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$aN=kt;class Ct{constructor(H,be,Le,Ze){this.name=H,this.uri=be,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$bN=Ct;let Et=class{#e=new Map;constructor(H){for(const[be,Le]of H??[]){const Ze=this.#e.get(this.#t(be));Ze?Ze.push(Le):this.#e.set(this.#t(be),[Le])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,be){this.#e.set(this.#t(H),[be])}forEach(H,be){for(const[Le,Ze]of this.#e)for(const it of Ze)H.call(be,it,Le,this)}*[Symbol.iterator](){for(const[H,be]of this.#e)for(const Le of be)yield[H,Le]}#t(H){return H.toLowerCase()}};e.$cN=Et,e.$cN=Et=Je([y],Et);let ui=class{constructor(H,be,Le){this.insertText=H,this.title=be,this.kind=Le}};e.$dN=ui,e.$dN=ui=Je([y],ui);var ti;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(ti||(e.DocumentPasteTriggerKind=ti={}));class li{static{this.c="."}constructor(H){this.value=H}append(...H){return new li((this.value?[this.value,...H]:H).join(li.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+li.c)}}e.$eN=li,li.Empty=new li("");let di=class{constructor(H,be,Le){this.title=be,this.insertText=H,this.kind=Le}};e.$fN=di,e.$fN=di=Je([y],di);let Xt=class{constructor(H,be){this.id=H,this.color=be}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$gN=Xt,e.$gN=Xt=Je([y],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let At=class{constructor(H){this.id=H}};e.$hN=At,e.$hN=At=Je([y],At);var Oe;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Oe||(e.ConfigurationTarget=Oe={}));let Be=class{get base(){return this.c}set base(H){this.c=H,this.e=k.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,be){if(typeof H!="string"&&(!H||!k.URI.isUri(H)&&!k.URI.isUri(H.uri)))throw(0,j.$7)("base");if(typeof be!="string")throw(0,j.$7)("pattern");typeof H=="string"?this.baseUri=k.URI.file(H):k.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$iN=Be,e.$iN=Be=Je([y],Be);const ye=new WeakMap;function te(G,H){ye.set(G,H)}let je=class{constructor(H,be,Le,Ze,it){this.enabled=typeof H=="boolean"?H:!0,typeof be=="string"&&(this.condition=be),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=ye.get(this)??(0,M.$Dg)()),this.c}};e.$kN=je,e.$kN=je=Je([y],je);let qe=class extends je{constructor(H,be,Le,Ze,it,ht){if(super(be,Le,Ze,it,ht),H===null)throw(0,j.$7)("location");this.location=H}};e.$lN=qe,e.$lN=qe=Je([y],qe);let et=class extends je{constructor(H,be,Le,Ze,it,ht){super(be,Le,Ze,it,ht),this.functionName=H}};e.$mN=et,e.$mN=et=Je([y],et);let Ye=class extends je{constructor(H,be,Le,Ze,it,ht,gt,Jt){if(super(Ze,it,ht,gt,Jt),!be)throw(0,j.$7)("dataId");this.label=H,this.dataId=be,this.canPersist=Le}};e.$nN=Ye,e.$nN=Ye=Je([y],Ye);let ct=class{constructor(H,be,Le){this.command=H,this.args=be||[],this.options=Le}};e.$oN=ct,e.$oN=ct=Je([y],ct);let yt=class{constructor(H,be){this.port=H,this.host=be}};e.$pN=yt,e.$pN=yt=Je([y],yt);let Kt=class{constructor(H){this.path=H}};e.$qN=Kt,e.$qN=Kt=Je([y],Kt);let zt=class{constructor(H){this.implementation=H}};e.$rN=zt,e.$rN=zt=Je([y],zt);class Mt{constructor(H,be,Le){this.session=H,this.threadId=be,this.frameId=Le}}e.$sN=Mt;class lt{constructor(H,be){this.session=H,this.threadId=be}}e.$tN=lt;let Ii=class{constructor(H,be){this.range=H,this.expression=be}};e.$uN=Ii,e.$uN=Ii=Je([y],Ii);var gi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=class{constructor(H,be){this.range=H,this.text=be}};e.$vN=$i,e.$vN=$i=Je([y],$i);let vi=class{constructor(H,be,Le=!0){this.range=H,this.variableName=be,this.caseSensitiveLookup=Le}};e.$wN=vi,e.$wN=vi=Je([y],vi);let Pi=class{constructor(H,be){this.range=H,this.expression=be}};e.$xN=Pi,e.$xN=Pi=Je([y],Pi);let Ai=class{constructor(H,be){this.frameId=H,this.stoppedLocation=be}};e.$yN=Ai,e.$yN=Ai=Je([y],Ai);var Wi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));class qi{constructor(H,be){this.newSymbolName=H,this.tags=be}}e.$zN=qi;var Vi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let yi=w=class extends Error{static FileExists(H){return new w(H,b.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(H){return new w(H,b.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(H){return new w(H,b.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(H){return new w(H,b.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(H){return new w(H,b.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(H){return new w(H,b.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(H,be=b.FileSystemProviderErrorCode.Unknown,Le){super(k.URI.isUri(H)?H.toString(!0):H),this.code=Le?.name??"Unknown",(0,b.$3k)(this,be),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$AN=yi,e.$AN=yi=w=Je([y],yi);let Mi=class{constructor(H,be,Le){this.start=H,this.end=be,this.kind=Le}};e.$BN=Mi,e.$BN=Mi=Je([y],Mi);var ki;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Gi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));var Ki;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Ki||(e.CommentThreadApplicability=Ki={}));class gn{constructor(H,be=[]){this.tokenTypes=H,this.tokenModifiers=be}}e.$CN=gn;function mn(G){return typeof G>"u"||(0,$.$Vf)(G)}class Ri{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let be=0,Le=H.tokenTypes.length;be<Le;be++)this.k.set(H.tokenTypes[be],be);for(let be=0,Le=H.tokenModifiers.length;be<Le;be++)this.l.set(H.tokenModifiers[be],be)}}push(H,be,Le,Ze,it){if(typeof H=="number"&&typeof be=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(H,be,Le,Ze,it);if(T.isRange(H)&&typeof be=="string"&&mn(Le))return this.o(H,be,Le);throw(0,j.$7)()}o(H,be,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(be))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,it=H.start.character,ht=H.end.character-H.start.character,gt=this.k.get(be);let Jt=0;if(Le)for(const hi of Le){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(hi);Jt|=1<<fi>>>0}this.q(Ze,it,ht,gt,Jt)}q(H,be,Le,Ze,it){if(this.f&&(H<this.c||H===this.c&&be<this.e)){this.f=!1;const Jt=this.g.length/5|0;let hi=0,fi=0;for(let mi=0;mi<Jt;mi++){let pi=this.g[5*mi],zi=this.g[5*mi+1];pi===0?(pi=hi,zi+=fi):pi+=hi,this.g[5*mi]=pi,this.g[5*mi+1]=zi,hi=pi,fi=zi}}let ht=H,gt=be;this.f&&this.j>0&&(ht-=this.c,ht===0&&(gt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=gt,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=it,this.c=H,this.e=be}static r(H){const be=[],Le=H.length/5|0;for(let gt=0;gt<Le;gt++)be[gt]=gt;be.sort((gt,Jt)=>{const hi=H[5*gt],fi=H[5*Jt];if(hi===fi){const mi=H[5*gt+1],pi=H[5*Jt+1];return mi-pi}return hi-fi});const Ze=new Uint32Array(H.length);let it=0,ht=0;for(let gt=0;gt<Le;gt++){const Jt=5*be[gt],hi=H[Jt+0],fi=H[Jt+1],mi=H[Jt+2],pi=H[Jt+3],zi=H[Jt+4],jn=hi-it,rr=jn===0?fi-ht:fi,Ui=5*gt;Ze[Ui+0]=jn,Ze[Ui+1]=rr,Ze[Ui+2]=mi,Ze[Ui+3]=pi,Ze[Ui+4]=zi,it=hi,ht=fi}return Ze}build(H){return this.f?new Oi(new Uint32Array(this.g),H):new Oi(Ri.r(this.g),H)}}e.$DN=Ri;class Oi{constructor(H,be){this.resultId=be,this.data=H}}e.$EN=Oi;class Ji{constructor(H,be,Le){this.start=H,this.deleteCount=be,this.data=Le}}e.$FN=Ji;class Qi{constructor(H,be){this.resultId=be,this.edits=H}}e.$GN=Qi;var Yi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class Zi{constructor(H){this.name=H}}e.$HN=Zi;let Si=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$IN=Si,e.$IN=Si=Je([y],Si);var Xi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var xi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var _i;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(H){if(typeof H.badge=="string"){let be=(0,p.$vf)(H.badge,0);if(be<H.badge.length&&(be+=(0,p.$vf)(H.badge,be)),H.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Xt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,be,Le){this.badge=H,this.tooltip=be,this.color=Le}}e.$JN=$n;let wi=class{constructor(H){this.kind=H}};e.$KN=wi,e.$KN=wi=Je([y],wi);var ji;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(ji||(e.ColorThemeKind=ji={}));class Ue{static isNotebookRange(H){return H instanceof Ue?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,be){if(H<0)throw(0,j.$7)("start must be positive");if(be<0)throw(0,j.$7)("end must be positive");H<=be?(this.c=H,this.e=be):(this.c=be,this.e=H)}with(H){let be=this.c,Le=this.e;return H.start!==void 0&&(be=H.start),H.end!==void 0&&(Le=H.end),be===this.c&&Le===this.e?this:new Ue(be,Le)}}e.$LN=Ue;class ci{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(be=>ci.isNotebookCellData(be))}static isNotebookCellData(H){return!0}constructor(H,be,Le,Ze,it,ht,gt){this.kind=H,this.value=be,this.languageId=Le,this.mime=Ze,this.outputs=it??[],this.metadata=ht,this.executionSummary=gt,ci.validate(this)}}e.$MN=ci;class en{constructor(H){this.cells=H}}e.$NN=en;class rt{static isNotebookCellOutputItem(H){return H instanceof rt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const be={name:H.name,message:H.message,stack:H.stack};return rt.json(be,"application/vnd.code.notebook.error")}static stdout(H){return rt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return rt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,be="application/octet-stream"){return new rt(H,be)}static#e=new TextEncoder;static text(H,be=A.$ys.text){const Le=rt.#e.encode(String(H));return new rt(Le,be)}static json(H,be="text/x-json"){const Le=JSON.stringify(H,void 0,"	");return rt.text(Le,be)}constructor(H,be){this.data=H,this.mime=be;const Le=(0,A.$Cs)(be,!0);if(!Le)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$ON=rt;class $t{static isNotebookCellOutput(H){return H instanceof $t?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,be=!1){const Le=new Set,Ze=new Set;for(let it=0;it<H.length;it++){const ht=H[it],gt=(0,A.$Cs)(ht.mime);if(!Le.has(gt)||(0,v.$fK)(gt)){Le.add(gt);continue}Ze.add(it),be&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ze.size===0?H:H.filter((it,ht)=>!Ze.has(ht))}constructor(H,be,Le){this.items=$t.ensureUniqueMimeTypes(H,!0),typeof be=="string"?(this.id=be,this.metadata=Le):(this.id=(0,M.$Dg)(),this.metadata=be??Le)}}e.$PN=$t;var tn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Li;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Li||(e.NotebookCellStatusBarAlignment=Li={}));var rn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class Di{constructor(H,be){this.text=H,this.alignment=be}}e.$QN=Di;var sn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(H,be=[]){this.uri=H,this.provides=(0,u.$3b)(be)}}e.$RN=pn;class an{constructor(H){this.label=H}}e.$SN=an;var cn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ni=class{constructor(H,be){this.label=H,this.timestamp=be}};e.$TN=Ni,e.$TN=Ni=Je([y],Ni);var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class bn{constructor(H,be){this.ranges=H,this.wordPattern=be}}e.$UN=bn;class wn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$VN=wn;var dn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Fi=class{constructor(H=void 0,be=void 0,Le=void 0,Ze=!1){this.include=H,this.exclude=be,this.profile=Le,this.continuous=Ze}};e.$WN=Fi,e.$WN=Fi=Je([y],Fi);let Ti=S=class{static diff(H,be,Le){const Ze=new S(H);return Ze.expectedOutput=be,Ze.actualOutput=Le,Ze}constructor(H){this.message=H}};e.$XN=Ti,e.$XN=Ti=S=Je([y],Ti);let $e=class{constructor(H){this.id=H}};e.$YN=$e,e.$YN=$e=Je([y],$e);class ke{constructor(H,be){this.covered=H,this.total=be}}e.$ZN=ke;const We=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class ut{static fromDetails(H,be){const Le=new ke(0,0),Ze=new ke(0,0),it=new ke(0,0);for(const gt of be)if("branches"in gt){Le.total+=1,Le.covered+=gt.executed?1:0;for(const Jt of gt.branches)Ze.total+=1,Ze.covered+=Jt.executed?1:0}else it.total+=1,it.covered+=gt.executed?1:0;const ht=new ut(H,Le,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return ht.detailedCoverage=be,ht}constructor(H,be,Le,Ze){this.uri=H,this.statementCoverage=be,this.branchCoverage=Le,this.declarationCoverage=Ze,We(be),We(Le),We(Ze)}}e.$1N=ut;class wt{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,be,Le=[]){this.executed=H,this.location=be,this.branches=Le}}e.$2N=wt;class Ot{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,be,Le){this.executed=H,this.location=be,this.label=Le}}e.$3N=Ot;class Bi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,be,Le){this.name=H,this.executed=be,this.location=Le}}e.$4N=Bi;var vn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var yn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Ln{constructor(H,be,Le,Ze,it,ht){this.kind=H,this.name=be,this.detail=Le,this.uri=Ze,this.range=it,this.selectionRange=ht}}e.$5N=Ln;class Nn{constructor(H){this.uri=H}}e.$6N=Nn;class Fn{constructor(H,be){this.original=H,this.modified=be}}e.$7N=Fn;class Tn{constructor(H,be,Le,Ze){this.base=H,this.input1=be,this.input2=Le,this.result=Ze}}e.$8N=Tn;class Bn{constructor(H,be){this.uri=H,this.viewType=be}}e.$9N=Bn;class zn{constructor(H){this.viewType=H}}e.$0N=zn;class Un{constructor(H,be){this.uri=H,this.notebookType=be}}e.$$N=Un;class Wn{constructor(H,be,Le){this.original=H,this.modified=be,this.notebookType=Le}}e.$_N=Wn;class qn{constructor(){}}e.$aO=qn;class Vn{constructor(H,be){this.uri=H,this.inputBoxUri=be}}e.$bO=Vn;class Hn{constructor(H){this.providerId=H}}e.$cO=Hn;var En;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Sn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var Dn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Gn{constructor(H,be){this.label=H,this.values=be}}e.$dO=Gn;var Cn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var In;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(In||(e.ChatResultFeedbackKind=In={}));class Kn{constructor(H){this.value=typeof H=="string"?new Te(H):H}}e.$eO=Kn;class Jn{constructor(H,be){this.value=H,this.baseUri=be}}e.$fO=Jn;class Qn{constructor(H,be){this.value=H,this.title=be}}e.$gO=Qn;class Yn{constructor(H){this.value=H}}e.$hO=Yn;class Zn{constructor(H){this.value=H}}e.$iO=Zn;class Xn{constructor(H){this.value=H}}e.$jO=Xn;class xn{constructor(H,be,Le,Ze){this.prompt=H,this.command=be,this.variables=Le,this.participant=Ze}}e.$kO=xn;class _n{constructor(H,be,Le,Ze){this.response=H,this.result=be,this.participant=Le,this.command=Ze}}e.$lO=_n;var Pn;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook"})(Pn||(e.ChatLocation=Pn={}));class er{constructor(H){this.content=H}}e.$mO=er;class tr{constructor(H,be){this.content=H,this.name=be}}e.$nO=tr;class ir{constructor(H){this.content=H}}e.$oO=ir;class Ci extends Error{static NotFound(H){return new Ci(H,Ci.NotFound.name)}static NoPermissions(H){return new Ci(H,Ci.NoPermissions.name)}constructor(H,be,Le){super(H,{cause:Le}),this.name="LanguageModelError",this.code=be??""}}e.$pO=Ci;var An;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Mn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Mn||(e.SpeechToTextStatus=Mn={}));var Rn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class nr{constructor(H,be){this.text=H,this.range=be}}e.$qO=nr;var On;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Ee[323],Se([1,0,6,7]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(u.$iM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(A);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,$)??[]}getRelatedInformation(A,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(A,p,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,p),new j.$kM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Kic=R}),define(Ee[120],Se([1,0,4,6,7,25,145,5,20]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=void 0,e.$Vic=(0,p.$hi)("IExtHostAuthentication");let k=class{constructor(b){this.b=new Map,this.c=new u.$7d,this.onDidChangeSessions=this.c.event,this.d=new M,this.f=new M,this.a=b.getProxy(j.$iM.MainThreadAuthentication)}async getSession(b,E,v,c={}){const m=P.$Cm.toKey(b.identifier),a=[...v].sort().join(" ");return await this.d.getOrCreate(`${m} ${E} ${a}`,async()=>{await this.a.$ensureProvider(E);const n=b.displayName||b.name;return this.a.$getSession(E,v,m,n,c)})}async getSessions(b,E,v){const c=P.$Cm.toKey(b.identifier),m=[...v].sort().join(" ");return await this.f.getOrCreate(`${c} ${m}`,async()=>{await this.a.$ensureProvider(E);const a=b.displayName||b.name;return this.a.$getSessions(E,v,c,a)})}async removeSession(b,E){const v=this.b.get(b);return v?v.provider.removeSession(E):this.a.$removeSession(b,E)}registerAuthenticationProvider(b,E,v,c){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:E,provider:v,options:c??{supportsMultipleAccounts:!1}});const m=v.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(b,a));return this.a.$registerAuthenticationProvider(b,E,c?.supportsMultipleAccounts??!1),new R.$kM(()=>{m.dispose(),this.b.delete(b),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,E,v){const c=this.b.get(b);if(c)return Promise.resolve(c.provider.createSession(E,v));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,E){const v=this.b.get(b);if(v)return Promise.resolve(v.provider.removeSession(E));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,E){const v=this.b.get(b);if(v)return Promise.resolve(v.provider.getSessions(E));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,E){return b.startsWith(A.$kL)||this.c.fire({provider:{id:b,label:E}}),Promise.resolve()}};e.$Wic=k,e.$Wic=k=Je([Ve(0,$.$CO)],k);class M{constructor(){this.a=new Map}getOrCreate(b,E){const v=this.a.get(b);if(v)return v;const c=E().finally(()=>this.a.delete(b));return this.a.set(b,c),c}}}),define(Ee[151],Se([1,0,2,6,7,5,20,12,19,14,17,26]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Wjc=void 0;let E=class{static{b=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(j.$iM.MainThreadDecorations)}registerFileDecorationProvider(c,m){const a=b.c++;this.f.set(a,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(a,m.identifier.value);const n=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const r=(0,$.$3b)(i);if(r.length<=b.d){this.g.$onDidChange(a,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,k.$1e)(d.path,"/")})),t=(0,$.$zb)(s,(d,l)=>d.rank-l.rank||(0,k.$ef)(d.uri.path,l.uri.path)),g=[];e:for(const d of t){let l;for(const o of d){const h=(0,M.$nc)(o.uri.path);if(l!==h&&(l=h,g.push(o.uri)>=b.d))break e}}this.g.$onDidChange(a,g)});return new R.$kM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(c,m,a){if(!this.f.has(c))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(c);return await Promise.all(m.map(async s=>{try{const{uri:t,id:g}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),a));if(!d)return;try{R.$JN.validate(d),d.badge&&typeof d.badge!="string"&&(0,I.$7F)(r,"codiconDecoration"),n[g]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$Wjc=E,e.$Wjc=E=b=Je([Ve(0,A.$CO),Ve(1,p.$Nj)],E),e.$Xjc=(0,P.$hi)("IExtHostDecorations")}),define(Ee[324],Se([1,0,13,2,7,6,15,22,14]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class k{static{this.a=0}constructor(I,b,E){this.d=b,this.e=E,this.b=new Map,this.c=I.getProxy(P.$iM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,b){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const E=k.a++;this.b.set(E,b),this.c.$registerTextContentProvider(E,I);let v;if(typeof b.onDidChange=="function"){let c;v=b.onDidChange(async m=>{if(m.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const a=this.$provideTextDocumentContent(E,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const r=(0,$.$$e)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{c===a&&(c=void 0)});c=a})}return new R.$kM(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(I,b){const E=this.b.get(I);return E?Promise.resolve(E.provideTextDocumentContent(j.URI.revive(b),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.$Zjc=k}),define(Ee[152],Se([1,0,61,15,14,182,129,7,19]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0,e.$EO=M;const k=new Map;function M(v,c){c?k.set(v,c):k.delete(v)}function I(v){return k.get(v)}class b extends P.$Gv{constructor(c,m,a,n,i,r,s){super(m,a,n,i),this.c=c,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===j.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,a){return c.y(m,a)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,u.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,u.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const a=this.g,n=m.start.line,i=m.end.line,r=[];r.push(this.f[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,m.end.character)),r.join(a)}t(c){let m;if(c instanceof p.$lM?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),a=this.f[m.index].length;return new p.$lM(m.index,Math.min(m.remainder,a))}w(c){if(!(c instanceof p.$mM))throw new Error("Invalid argument");const m=this.x(c.start),a=this.x(c.end);return m===c.start&&a===c.end?c:new p.$mM(m.line,m.character,a.line,a.character)}x(c){if(!(c instanceof p.$lM))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:a}=c,n=!1;if(m<0)m=0,a=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,a=this.f[m].length,n=!0;else{const i=this.f[m].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new p.$lM(m,a):c}y(c,m){const a=this.x(c);if(!m)m=I(this.m);else if((0,R.$0e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,A.$Qs)(a.character+1,(0,A.$Os)(m),this.f[a.line],0);if(n)return new p.$mM(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$FO=b;class E{constructor(c,m,a){this.a=c,this.b=m,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$mM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$mM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$GO=E}),define(Ee[325],Se([1,0,6,7]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(u.$iM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(A);if(!k)throw new Error("Embedding vector provider not found");const M=await k.provideEmbeddingVector(p,$);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(A,p,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(p,k),new j.$kM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$2jc=R}),define(Ee[69],Se([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=void 0;let v=E=class{constructor(m,a){this.b=new Map,this.c=new M.$qh,this.a=m.getProxy(u.$iM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===j.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,P.$ue.wrap(r))}catch(s){return E.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return E.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},isWritableFileSystem(i){const r=a.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(m,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await m.stat(n)).type&j.FileType.Directory))throw R.$AN.FileExists(`Unable to create folder '${n.scheme===b.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(j.$4k(r)!==j.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(a.basename(n)),n=a.dirname(n)}for(let r=i.length-1;r>=0;r--){n=a.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(j.$4k(s)!==j.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof R.$AN)throw m;if(m instanceof j.$Zk)switch(m.code){case j.FileSystemProviderErrorCode.FileExists:throw R.$AN.FileExists(m.message);case j.FileSystemProviderErrorCode.FileNotFound:throw R.$AN.FileNotFound(m.message);case j.FileSystemProviderErrorCode.FileNotADirectory:throw R.$AN.FileNotADirectory(m.message);case j.FileSystemProviderErrorCode.FileIsADirectory:throw R.$AN.FileIsADirectory(m.message);case j.FileSystemProviderErrorCode.NoPermissions:throw R.$AN.NoPermissions(m.message);case j.FileSystemProviderErrorCode.Unavailable:throw R.$AN.Unavailable(m.message);default:throw new R.$AN(m.message,m.name)}if(!(m instanceof Error))throw new R.$AN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw R.$AN.Unavailable(m.message);switch(m.name){case j.FileSystemProviderErrorCode.FileExists:throw R.$AN.FileExists(m.message);case j.FileSystemProviderErrorCode.FileNotFound:throw R.$AN.FileNotFound(m.message);case j.FileSystemProviderErrorCode.FileNotADirectory:throw R.$AN.FileNotADirectory(m.message);case j.FileSystemProviderErrorCode.FileIsADirectory:throw R.$AN.FileIsADirectory(m.message);case j.FileSystemProviderErrorCode.NoPermissions:throw R.$AN.NoPermissions(m.message);case j.FileSystemProviderErrorCode.Unavailable:throw R.$AN.Unavailable(m.message);default:throw new R.$AN(m.message,m.name)}}addFileSystemProvider(m,a,n){return this.b.set(m,{impl:a,extUri:n?.isCaseSensitive?I.$Kg:I.$Mg,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??I.$Kg}};e.$cjc=v,e.$cjc=v=E=Je([Ve(0,p.$CO),Ve(1,$.$Pic)],v),e.$djc=(0,A.$hi)("IExtHostConsumerFileSystem")}),define(Ee[326],Se([1,0,6,7]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class R{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(u.$iM.MainThreadIssueReporter)}async $getIssueReporterUri(A,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(A);if(!$)throw new Error("Issue request handler not found");const k=await $.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(A,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueData(p);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(A,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueTemplate(p);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(A,p){const $=A.identifier.value;return this.a.set($,p),this.c.$registerIssueUriRequestHandler($),new j.$kM(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(A,p){const $=A.identifier.value;return this.b.set($,p),this.c.$registerIssueDataProvider($),new j.$kM(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$gkc=R}),define(Ee[93],Se([1,0,5,27,12,69,2]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=e.$ejc=void 0,e.$ejc=(0,u.$hi)("IExtensionStoragePaths");let p=class{constructor(k,M,I){this.d=M,this.f=I,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(b=>this.c=b)}async g(k){return A.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,M=await this.g(k);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(A.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this.c)return A.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return A.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fjc=p,e.$fjc=p=Je([Ve(0,j.$SO),Ve(1,R.$Nj),Ve(2,P.$djc)],p)}),define(Ee[327],Se([1,0,7,20,4]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;let P=class{constructor(p){this.a=new u.$KN(u.ColorThemeKind.Dark),this.b=new R.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=u.ColorThemeKind.Light;break;case"hcDark":$=u.ColorThemeKind.HighContrast;break;case"hcLight":$=u.ColorThemeKind.HighContrastLight;break;default:$=u.ColorThemeKind.Dark}this.a=new u.$KN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jkc=P,e.$Jkc=P=Je([Ve(0,j.$CO)],P)}),define(Ee[70],Se([1,0,22,4,3,228,5,12,88,6,27,20,7]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fBb=e.$eBb=e.TunnelDtoConverter=void 0;class E extends $.$6v{}var v;(function(m){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$eBb=(0,A.$hi)("IExtHostTunnelService");let c=class extends R.$Uc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new j.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(k.$iM.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new b.$kM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,r,s){const t=[];for(const d of a){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async o=>{let h;try{h=await l.provider.providePortAttributes({port:o,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(o,i,r,s)}return{providedAttributes:h,port:o}})))}const g=t.filter(d=>!!d.providedAttributes);return g.length>0?g.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await a.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const s=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:r,disposeListener:s}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(r=>this.f(r.host,r.port,r.detail??""))),i=a.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$fBb=c,e.$fBb=c=Je([Ve(0,I.$CO),Ve(1,M.$SO),Ve(2,p.$Nj)],c)}),define(Ee[16],Se([1,0,19,21,171,74,80,28,164,57,101,24,166,23,18,2,29,83,138,144,142,289,119,67,89,301,26,7]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g,d,l,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$zO=B,e.$AO=Z,e.$BO=_;var f;(function(Oe){function Be(te){const{selectionStartLineNumber:je,selectionStartColumn:qe,positionLineNumber:et,positionColumn:Ye}=te,ct=new h.$lM(je-1,qe-1),yt=new h.$lM(et-1,Ye-1);return new h.$nM(ct,yt)}Oe.to=Be;function ye(te){const{anchor:je,active:qe}=te;return{selectionStartLineNumber:je.line+1,selectionStartColumn:je.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Oe.from=ye})(f||(e.Selection=f={}));var D;(function(Oe){function Be(te){if(!te)return;const{start:je,end:qe}=te;return{startLineNumber:je.line+1,startColumn:je.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Oe.from=Be;function ye(te){if(!te)return;const{startLineNumber:je,startColumn:qe,endLineNumber:et,endColumn:Ye}=te;return new h.$mM(je-1,qe-1,et-1,Ye-1)}Oe.to=ye})(D||(e.Range=D={}));var w;(function(Oe){function Be(te){return{uri:te.uri,range:D.from(te.range)}}Oe.from=Be;function ye(te){return new h.$wM(c.URI.revive(te.uri),D.to(te.range))}Oe.to=ye})(w||(e.Location=w={}));var S;(function(Oe){function Be(ye){switch(ye){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Oe.to=Be})(S||(e.TokenType=S={}));var y;(function(Oe){function Be(te){return new h.$lM(te.lineNumber-1,te.column-1)}Oe.to=Be;function ye(te){return{lineNumber:te.line+1,column:te.character+1}}Oe.from=ye})(y||(e.Position=y={}));var C;(function(Oe){function Be(je,qe,et){return(0,u.$Hb)((0,u.$3b)(je).map(Ye=>ye(Ye,qe,et)))}Oe.from=Be;function ye(je,qe,et){if(typeof je=="string")return{$serialized:!0,language:je,isBuiltin:et?.isBuiltin};if(je)return{$serialized:!0,language:je.language,scheme:te(je.scheme,qe),pattern:Ke.from(je.pattern)??void 0,exclusive:je.exclusive,notebookType:je.notebookType,isBuiltin:et?.isBuiltin}}function te(je,qe){return qe&&typeof je=="string"?qe.transformOutgoingScheme(je):je}})(C||(e.DocumentSelector=C={}));var O;(function(Oe){function Be(te){switch(te){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Oe.from=Be;function ye(te){switch(te){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Oe.to=ye})(O||(e.DiagnosticTag=O={}));var z;(function(Oe){function Be(te){let je;return te.code&&((0,v.$Uf)(te.code)||(0,v.$Yf)(te.code)?je=String(te.code):je={value:String(te.code.value),target:te.code.target}),{...D.from(te.range),message:te.message,source:te.source,code:je,severity:T.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(F.from),tags:Array.isArray(te.tags)?(0,u.$Hb)(te.tags.map(O.from)):void 0}}Oe.from=Be;function ye(te){const je=new h.$yM(D.to(te),te.message,T.to(te.severity));return je.source=te.source,je.code=(0,v.$Uf)(te.code)?te.code:te.code?.value,je.relatedInformation=te.relatedInformation&&te.relatedInformation.map(F.to),je.tags=te.tags&&(0,u.$Hb)(te.tags.map(O.to)),je}Oe.to=ye})(z||(e.Diagnostic=z={}));var F;(function(Oe){function Be(te){return{...D.from(te.location.range),message:te.message,resource:te.location.uri}}Oe.from=Be;function ye(te){return new h.$xM(new h.$wM(te.resource,D.to(te)),te.message)}Oe.to=ye})(F||(e.DiagnosticRelatedInformation=F={}));var T;(function(Oe){function Be(te){switch(te){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=Be;function ye(te){switch(te){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Oe.to=ye})(T||(e.DiagnosticSeverity=T={}));var L;(function(Oe){function Be(te){return typeof te=="number"&&te>=h.ViewColumn.One?te-1:te===h.ViewColumn.Beside?l.$AD:l.$zD}Oe.from=Be;function ye(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=ye})(L||(e.ViewColumn=L={}));function N(Oe){return typeof Oe.range<"u"}function B(Oe){return Oe.length===0?!0:!!N(Oe[0])}var U;(function(Oe){function Be(Ye){return Ye.map(Oe.from)}Oe.fromMany=Be;function ye(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function te(Ye){let ct;if(ye(Ye)){const{language:Mt,value:lt}=Ye;ct={value:"```"+Mt+`
`+lt+"\n```\n"}}else h.$LM.isMarkdownString(Ye)?ct={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?ct={value:Ye}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const Kt=Mt=>{try{let lt=c.URI.parse(Mt,!0);lt=lt.with({query:je(lt.query,yt)}),yt[Mt]=lt}catch{}return""},zt=new $.marked.Renderer;return zt.link=Kt,zt.image=Mt=>typeof Mt=="string"?Kt(A.$Mk(Mt).href):"",(0,$.marked)(ct.value,{renderer:zt}),ct}Oe.from=te;function je(Ye,ct){if(!Ye)return Ye;let yt;try{yt=(0,k.$Ph)(Ye)}catch{}if(!yt)return Ye;let Kt=!1;return yt=(0,I.$Pn)(yt,zt=>{if(c.URI.isUri(zt)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Mt]=zt,Kt=!0,Mt}else return}),Kt?JSON.stringify(yt):Ye}function qe(Ye){const ct=new h.$LM(Ye.value,Ye.supportThemeIcons);return ct.isTrusted=Ye.isTrusted,ct.supportHtml=Ye.supportHtml,ct.baseUri=Ye.baseUri?c.URI.from(Ye.baseUri):void 0,ct}Oe.to=qe;function et(Ye){if(Ye)return typeof Ye=="string"?Ye:Oe.from(Ye)}Oe.fromStrict=et})(U||(e.MarkdownString=U={}));function Z(Oe){return B(Oe)?Oe.map(Be=>({range:D.from(Be.range),hoverMessage:Array.isArray(Be.hoverMessage)?U.fromMany(Be.hoverMessage):Be.hoverMessage?U.from(Be.hoverMessage):void 0,renderOptions:Be.renderOptions})):Oe.map(Be=>({range:D.from(Be)}))}function _(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?c.URI.file(Oe):Oe}var Y;(function(Oe){function Be(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?_(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Oe.from=Be})(Y||(e.ThemableDecorationAttachmentRenderOptions=Y={}));var x;(function(Oe){function Be(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?_(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?Y.from(ye.before):void 0,after:ye.after?Y.from(ye.after):void 0}}Oe.from=Be})(x||(e.ThemableDecorationRenderOptions=x={}));var ce;(function(Oe){function Be(ye){if(typeof ye>"u")return ye;switch(ye){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=Be})(ce||(e.DecorationRangeBehavior=ce={}));var X;(function(Oe){function Be(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ce.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?x.from(ye.light):void 0,dark:ye.dark?x.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?_(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?Y.from(ye.before):void 0,after:ye.after?Y.from(ye.after):void 0}}Oe.from=Be})(X||(e.DecorationRenderOptions=X={}));var me;(function(Oe){function Be(te){return{text:te.newText,eol:te.newEol&&Re.from(te.newEol),range:D.from(te.range)}}Oe.from=Be;function ye(te){const je=new h.$rM(D.to(te.range),te.text);return je.newEol=typeof te.eol>"u"?void 0:Re.to(te.eol),je}Oe.to=ye})(me||(e.TextEdit=me={}));var ae;(function(Oe){function Be(te,je){const qe={edits:[]};if(te instanceof h.$uM){const et=new p.$Cc;for(const Ye of te._allEntries())Ye._type===1&&c.URI.isUri(Ye.to)&&Ye.from===void 0&&et.add(Ye.to);for(const Ye of te._allEntries())if(Ye._type===1){let ct;Ye.options?.contents&&(ArrayBuffer.isView(Ye.options.contents)?ct={type:"base64",value:(0,j.$Oe)(j.$ue.wrap(Ye.options.contents))}:ct={type:"dataTransferItem",id:Ye.options.contents._itemId}),qe.edits.push({oldResource:Ye.from,newResource:Ye.to,options:{...Ye.options,contents:ct},metadata:Ye.metadata})}else Ye._type===2?qe.edits.push({resource:Ye.uri,textEdit:me.from(Ye.edit),versionId:et.has(Ye.uri)?void 0:je?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===6?qe.edits.push({resource:Ye.uri,textEdit:{range:D.from(Ye.range),text:Ye.edit.value,insertAsSnippet:!0},versionId:et.has(Ye.uri)?void 0:je?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===3?qe.edits.push({metadata:Ye.metadata,resource:Ye.uri,cellEdit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:je?.getNotebookDocumentVersion(Ye.uri)}):Ye._type===5&&qe.edits.push({metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:je?.getNotebookDocumentVersion(Ye.uri),cellEdit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(Tt.from)}})}return qe}Oe.from=Be;function ye(te){const je=new h.$uM,qe=new p.$Bc;for(const et of te.edits)if(et.textEdit){const Ye=et,ct=c.URI.revive(Ye.resource),yt=D.to(Ye.textEdit.range),Kt=Ye.textEdit.text,zt=Ye.textEdit.insertAsSnippet;let Mt;zt?Mt=h.$tM.replace(yt,new h.$vM(Kt)):Mt=h.$rM.replace(yt,Kt);const lt=qe.get(ct);lt?lt.push(Mt):qe.set(ct,[Mt])}else je.renameFile(c.URI.revive(et.oldResource),c.URI.revive(et.newResource),et.options);for(const[et,Ye]of qe)je.set(et,Ye);return je}Oe.to=ye})(ae||(e.WorkspaceEdit=ae={}));var re;(function(Oe){const Be=Object.create(null);Be[h.SymbolKind.File]=0,Be[h.SymbolKind.Module]=1,Be[h.SymbolKind.Namespace]=2,Be[h.SymbolKind.Package]=3,Be[h.SymbolKind.Class]=4,Be[h.SymbolKind.Method]=5,Be[h.SymbolKind.Property]=6,Be[h.SymbolKind.Field]=7,Be[h.SymbolKind.Constructor]=8,Be[h.SymbolKind.Enum]=9,Be[h.SymbolKind.Interface]=10,Be[h.SymbolKind.Function]=11,Be[h.SymbolKind.Variable]=12,Be[h.SymbolKind.Constant]=13,Be[h.SymbolKind.String]=14,Be[h.SymbolKind.Number]=15,Be[h.SymbolKind.Boolean]=16,Be[h.SymbolKind.Array]=17,Be[h.SymbolKind.Object]=18,Be[h.SymbolKind.Key]=19,Be[h.SymbolKind.Null]=20,Be[h.SymbolKind.EnumMember]=21,Be[h.SymbolKind.Struct]=22,Be[h.SymbolKind.Event]=23,Be[h.SymbolKind.Operator]=24,Be[h.SymbolKind.TypeParameter]=25;function ye(je){return typeof Be[je]=="number"?Be[je]:6}Oe.from=ye;function te(je){for(const qe in Be)if(Be[qe]===je)return Number(qe);return h.SymbolKind.Property}Oe.to=te})(re||(e.SymbolKind=re={}));var W;(function(Oe){function Be(te){switch(te){case h.SymbolTag.Deprecated:return 1}}Oe.from=Be;function ye(te){switch(te){case 1:return h.SymbolTag.Deprecated}}Oe.to=ye})(W||(e.SymbolTag=W={}));var ie;(function(Oe){function Be(te){return{name:te.name,kind:re.from(te.kind),tags:te.tags&&te.tags.map(W.from),containerName:te.containerName,location:oe.from(te.location)}}Oe.from=Be;function ye(te){const je=new h.$CM(te.name,re.to(te.kind),te.containerName,oe.to(te.location));return je.tags=te.tags&&te.tags.map(W.to),je}Oe.to=ye})(ie||(e.WorkspaceSymbol=ie={}));var ve;(function(Oe){function Be(te){const je={name:te.name||"!!MISSING: name!!",detail:te.detail,range:D.from(te.range),selectionRange:D.from(te.selectionRange),kind:re.from(te.kind),tags:te.tags?.map(W.from)??[]};return te.children&&(je.children=te.children.map(Be)),je}Oe.from=Be;function ye(te){const je=new h.$DM(te.name,te.detail,re.to(te.kind),D.to(te.range),D.to(te.selectionRange));return(0,u.$Lb)(te.tags)&&(je.tags=te.tags.map(W.to)),te.children&&(je.children=te.children.map(ye)),je}Oe.to=ye})(ve||(e.DocumentSymbol=ve={}));var Pe;(function(Oe){function Be(te){const je=new h.$HM(re.to(te.kind),te.name,te.detail||"",c.URI.revive(te.uri),D.to(te.range),D.to(te.selectionRange));return je._sessionId=te._sessionId,je._itemId=te._itemId,je}Oe.to=Be;function ye(te,je,qe){if(je=je??te._sessionId,qe=qe??te._itemId,je===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:qe,name:te.name,detail:te.detail,kind:re.from(te.kind),uri:te.uri,range:D.from(te.range),selectionRange:D.from(te.selectionRange),tags:te.tags?.map(W.from)}}Oe.from=ye})(Pe||(e.CallHierarchyItem=Pe={}));var le;(function(Oe){function Be(ye){return new h.$IM(Pe.to(ye.from),ye.fromRanges.map(te=>D.to(te)))}Oe.to=Be})(le||(e.CallHierarchyIncomingCall=le={}));var ue;(function(Oe){function Be(ye){return new h.$JM(Pe.to(ye.to),ye.fromRanges.map(te=>D.to(te)))}Oe.to=Be})(ue||(e.CallHierarchyOutgoingCall=ue={}));var oe;(function(Oe){function Be(te){return{range:te.range&&D.from(te.range),uri:te.uri}}Oe.from=Be;function ye(te){return new h.$wM(c.URI.revive(te.uri),D.to(te.range))}Oe.to=ye})(oe||(e.location=oe={}));var K;(function(Oe){function Be(te){const je=te,qe=te;return{originSelectionRange:je.originSelectionRange?D.from(je.originSelectionRange):void 0,uri:je.targetUri?je.targetUri:qe.uri,range:D.from(je.targetRange?je.targetRange:qe.range),targetSelectionRange:je.targetSelectionRange?D.from(je.targetSelectionRange):void 0}}Oe.from=Be;function ye(te){return{targetUri:c.URI.revive(te.uri),targetRange:D.to(te.range),targetSelectionRange:te.targetSelectionRange?D.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?D.to(te.originSelectionRange):void 0}}Oe.to=ye})(K||(e.DefinitionLink=K={}));var ee;(function(Oe){function Be(te){return{range:D.from(te.range),contents:U.fromMany(te.contents)}}Oe.from=Be;function ye(te){return new h.$zM(te.contents.map(U.to),D.to(te.range))}Oe.to=ye})(ee||(e.Hover=ee={}));var he;(function(Oe){function Be(te){return{range:D.from(te.range),expression:te.expression}}Oe.from=Be;function ye(te){return new h.$uN(D.to(te.range),te.expression)}Oe.to=ye})(he||(e.EvaluatableExpression=he={}));var fe;(function(Oe){function Be(te){if(te instanceof h.$vN)return{type:"text",range:D.from(te.range),text:te.text};if(te instanceof h.$wN)return{type:"variable",range:D.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof h.$xN)return{type:"expression",range:D.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Be;function ye(te){switch(te.type){case"text":return{range:D.to(te.range),text:te.text};case"variable":return{range:D.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:D.to(te.range),expression:te.expression}}}Oe.to=ye})(fe||(e.InlineValue=fe={}));var Ae;(function(Oe){function Be(te){return{frameId:te.frameId,stoppedLocation:D.from(te.stoppedLocation)}}Oe.from=Be;function ye(te){return new h.$yN(te.frameId,D.to(te.stoppedLocation))}Oe.to=ye})(Ae||(e.InlineValueContext=Ae={}));var pe;(function(Oe){function Be(te){return{range:D.from(te.range),kind:te.kind}}Oe.from=Be;function ye(te){return new h.$AM(D.to(te.range),te.kind)}Oe.to=ye})(pe||(e.DocumentHighlight=pe={}));var Ce;(function(Oe){function Be(te){return{uri:te.uri,highlights:te.highlights.map(pe.from)}}Oe.from=Be;function ye(te){return new h.$BM(c.URI.revive(te.uri),te.highlights.map(pe.to))}Oe.to=ye})(Ce||(e.MultiDocumentHighlight=Ce={}));var Me;(function(Oe){function Be(ye){switch(ye){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Oe.to=Be})(Me||(e.CompletionTriggerKind=Me={}));var Fe;(function(Oe){function Be(ye){return{triggerKind:Me.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Oe.to=Be})(Fe||(e.CompletionContext=Fe={}));var V;(function(Oe){function Be(te){switch(te){case h.CompletionItemTag.Deprecated:return 1}}Oe.from=Be;function ye(te){switch(te){case 1:return h.CompletionItemTag.Deprecated}}Oe.to=ye})(V||(e.CompletionItemTag=V={}));var q;(function(Oe){const Be=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ye(qe){return Be.get(qe)??9}Oe.from=ye;const te=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function je(qe){return te.get(qe)??h.CompletionItemKind.Property}Oe.to=je})(q||(e.CompletionItemKind=q={}));var Q;(function(Oe){function Be(ye,te){const je=new h.$RM(ye.label);return je.insertText=ye.insertText,je.kind=q.to(ye.kind),je.tags=ye.tags?.map(V.to),je.detail=ye.detail,je.documentation=A.$Gk(ye.documentation)?U.to(ye.documentation):ye.documentation,je.sortText=ye.sortText,je.filterText=ye.filterText,je.preselect=ye.preselect,je.commitCharacters=ye.commitCharacters,m.$bt.isIRange(ye.range)?je.range=D.to(ye.range):typeof ye.range=="object"&&(je.range={inserting:D.to(ye.range.insert),replacing:D.to(ye.range.replace)}),je.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?je.insertText=new h.$vM(ye.insertText):(je.insertText=ye.insertText,je.textEdit=je.range instanceof h.$mM?new h.$rM(je.range,je.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(je.additionalTextEdits=ye.additionalTextEdits.map(qe=>me.to(qe))),je.command=te&&ye.command?te.fromInternal(ye.command):void 0,je}Oe.to=Be})(Q||(e.CompletionItem=Q={}));var J;(function(Oe){function Be(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:U.fromStrict(te.documentation)}}Oe.from=Be;function ye(te){return{label:te.label,documentation:A.$Gk(te.documentation)?U.to(te.documentation):te.documentation}}Oe.to=ye})(J||(e.ParameterInformation=J={}));var ge;(function(Oe){function Be(te){return{label:te.label,documentation:U.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(J.from):[],activeParameter:te.activeParameter}}Oe.from=Be;function ye(te){return{label:te.label,documentation:A.$Gk(te.documentation)?U.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(J.to):[],activeParameter:te.activeParameter}}Oe.to=ye})(ge||(e.SignatureInformation=ge={}));var we;(function(Oe){function Be(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(ge.from):[]}}Oe.from=Be;function ye(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(ge.to):[]}}Oe.to=ye})(we||(e.SignatureHelp=we={}));var Te;(function(Oe){function Be(ye,te){const je=new h.$QM(y.to(te.position),typeof te.label=="string"?te.label:te.label.map(He.to.bind(void 0,ye)),te.kind&&Xe.to(te.kind));return je.textEdits=te.textEdits&&te.textEdits.map(me.to),je.tooltip=A.$Gk(te.tooltip)?U.to(te.tooltip):te.tooltip,je.paddingLeft=te.paddingLeft,je.paddingRight=te.paddingRight,je}Oe.to=Be})(Te||(e.InlayHint=Te={}));var He;(function(Oe){function Be(ye,te){const je=new h.$PM(te.label);return je.tooltip=A.$Gk(te.tooltip)?U.to(te.tooltip):te.tooltip,a.Command.is(te.command)&&(je.command=ye.fromInternal(te.command)),te.location&&(je.location=oe.to(te.location)),je}Oe.to=Be})(He||(e.InlayHintLabelPart=He={}));var Xe;(function(Oe){function Be(te){return te}Oe.from=Be;function ye(te){return te}Oe.to=ye})(Xe||(e.InlayHintKind=Xe={}));var tt;(function(Oe){function Be(te){return{range:D.from(te.range),url:te.target,tooltip:te.tooltip}}Oe.from=Be;function ye(te){let je;if(te.url)try{je=typeof te.url=="string"?c.URI.parse(te.url,!0):c.URI.revive(te.url)}catch{}return new h.$WM(D.to(te.range),je)}Oe.to=ye})(tt||(e.DocumentLink=tt={}));var nt;(function(Oe){function Be(te){const je=new h.$ZM(te.label);return te.textEdit&&(je.textEdit=me.to(te.textEdit)),te.additionalTextEdits&&(je.additionalTextEdits=te.additionalTextEdits.map(qe=>me.to(qe))),je}Oe.to=Be;function ye(te){return{label:te.label,textEdit:te.textEdit?me.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(je=>me.from(je)):void 0}}Oe.from=ye})(nt||(e.ColorPresentation=nt={}));var at;(function(Oe){function Be(te){return new h.$XM(te[0],te[1],te[2],te[3])}Oe.to=Be;function ye(te){return[te.red,te.green,te.blue,te.alpha]}Oe.from=ye})(at||(e.Color=at={}));var st;(function(Oe){function Be(te){return{range:D.from(te.range)}}Oe.from=Be;function ye(te){return new h.$GM(D.to(te.range))}Oe.to=ye})(st||(e.SelectionRange=st={}));var Ie;(function(Oe){function Be(ye){switch(ye){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Oe.to=Be})(Ie||(e.TextDocumentSaveReason=Ie={}));var ze;(function(Oe){function Be(te){switch(te){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=Be;function ye(te){switch(te){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Oe.to=ye})(ze||(e.TextEditorLineNumbersStyle=ze={}));var Re;(function(Oe){function Be(te){if(te===h.EndOfLine.CRLF)return 1;if(te===h.EndOfLine.LF)return 0}Oe.from=Be;function ye(te){if(te===1)return h.EndOfLine.CRLF;if(te===0)return h.EndOfLine.LF}Oe.to=ye})(Re||(e.EndOfLine=Re={}));var Ge;(function(Oe){function Be(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Be})(Ge||(e.ProgressLocation=Ge={}));var ne;(function(Oe){function Be(te){const je={start:te.start+1,end:te.end+1};return te.kind&&(je.kind=se.from(te.kind)),je}Oe.from=Be;function ye(te){const je={start:te.start-1,end:te.end-1};return te.kind&&(je.kind=se.to(te.kind)),je}Oe.to=ye})(ne||(e.FoldingRange=ne={}));var se;(function(Oe){function Be(te){if(te)switch(te){case h.FoldingRangeKind.Comment:return a.$6t.Comment;case h.FoldingRangeKind.Imports:return a.$6t.Imports;case h.FoldingRangeKind.Region:return a.$6t.Region}}Oe.from=Be;function ye(te){if(te)switch(te.value){case a.$6t.Comment.value:return h.FoldingRangeKind.Comment;case a.$6t.Imports.value:return h.FoldingRangeKind.Imports;case a.$6t.Region.value:return h.FoldingRangeKind.Region}}Oe.to=ye})(se||(e.FoldingRangeKind=se={}));var De;(function(Oe){function Be(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?D.from(ye.selection):void 0,override:typeof ye.override=="boolean"?r.$3E.id:void 0}}Oe.from=Be})(De||(e.TextEditorOpenOptions=De={}));var Ke;(function(Oe){function Be(qe){return qe instanceof h.$iN?qe.toJSON():typeof qe=="string"?qe:ye(qe)||te(qe)?new h.$iN(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Oe.from=Be;function ye(qe){const et=qe;return et?c.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function te(qe){const et=qe;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function je(qe){return typeof qe=="string"?qe:new h.$iN(c.URI.revive(qe.baseUri),qe.pattern)}Oe.to=je})(Ke||(e.GlobPattern=Ke={}));var xe;(function(Oe){function Be(ye){if(ye){if(Array.isArray(ye))return ye.map(Be);if(typeof ye=="string")return ye;{const te=ye;return{language:te.language,scheme:te.scheme,pattern:Ke.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Oe.from=Be})(xe||(e.LanguageSelector=xe={}));var ot;(function(Oe){function Be(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(je=>Array.isArray(je)&&je.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&c.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(et=>et instanceof h.$mM)))}Oe.is=Be;function ye(te){return{documents:te.documents.map(je=>je.map(qe=>({uri:c.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(et=>D.from(et))})))}}Oe.from=ye})(ot||(e.MappedEditsContext=ot={}));var Ne;(function(Oe){function Be(te){return{start:te.start,end:te.end}}Oe.from=Be;function ye(te){return new h.$LN(te.start,te.end)}Oe.to=ye})(Ne||(e.NotebookRange=Ne={}));var bt;(function(Oe){function Be(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Oe.to=Be;function ye(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Oe.from=ye})(bt||(e.NotebookCellExecutionSummary=bt={}));var St;(function(Oe){function Be(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Oe.to=Be})(St||(e.NotebookCellExecutionState=St={}));var It;(function(Oe){function Be(te){switch(te){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Oe.from=Be;function ye(te){switch(te){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Oe.to=ye})(It||(e.NotebookCellKind=It={}));var xt;(function(Oe){function Be(te){const je={metadata:te.metadata??Object.create(null),cells:[]};for(const qe of te.cells)h.$MN.validate(qe),je.cells.push(Tt.from(qe));return je}Oe.from=Be;function ye(te){const je=new h.$NN(te.cells.map(Tt.to));return(0,v.$8f)(te.metadata)||(je.metadata=te.metadata),je}Oe.to=ye})(xt||(e.NotebookData=xt={}));var Tt;(function(Oe){function Be(te){return{cellKind:It.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:bt.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Qt.from):[]}}Oe.from=Be;function ye(te){return new h.$MN(It.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Qt.to):void 0,te.metadata,te.internalMetadata?bt.to(te.internalMetadata):void 0)}Oe.to=ye})(Tt||(e.NotebookCellData=Tt={}));var Dt;(function(Oe){function Be(te){return{mime:te.mime,valueBytes:j.$ue.wrap(te.data)}}Oe.from=Be;function ye(te){return new h.$ON(te.valueBytes.buffer,te.mime)}Oe.to=ye})(Dt||(e.NotebookCellOutputItem=Dt={}));var Qt;(function(Oe){function Be(te){return{outputId:te.id,items:te.items.map(Dt.from),metadata:te.metadata}}Oe.from=Be;function ye(te){const je=te.items.map(Dt.to);return new h.$PN(je,te.outputId,te.metadata)}Oe.to=ye})(Qt||(e.NotebookCellOutput=Qt={}));var Ut;(function(Oe){function Be(je){return te(je)?{include:Ke.from(je.include)??void 0,exclude:Ke.from(je.exclude)??void 0}:Ke.from(je)??void 0}Oe.from=Be;function ye(je){return te(je)?{include:Ke.to(je.include),exclude:Ke.to(je.exclude)}:Ke.to(je)}Oe.to=ye;function te(je){const qe=je;return qe?!(0,v.$4f)(qe.include)&&!(0,v.$4f)(qe.exclude):!1}})(Ut||(e.NotebookExclusiveDocumentPattern=Ut={}));var ai;(function(Oe){function Be(ye,te,je){const qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(qe,je),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Oe.from=Be})(ai||(e.NotebookStatusBarItem=ai={}));var ii;(function(Oe){function Be(ye,te,je){const qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:te.toInternal(qe,je),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Oe.from=Be})(ii||(e.NotebookKernelSourceAction=ii={}));var _e;(function(Oe){function Be(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Oe.from=Be})(_e||(e.NotebookDocumentContentOptions=_e={}));var _t;(function(Oe){function Be(te){return{uri:te.uri,provides:te.provides}}Oe.from=Be;function ye(te){return new h.$RN(c.URI.revive(te.uri),te.provides)}Oe.to=ye})(_t||(e.NotebookRendererScript=_t={}));var ni;(function(Oe){function Be(te){return{message:U.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:D.from(te.location.range),uri:te.location.uri}}}Oe.from=Be;function ye(te){const je=new h.$XN(typeof te.message=="string"?te.message:U.to(te.message));return je.actualOutput=te.actual,je.expectedOutput=te.expected,je.contextValue=te.contextValue,je.location=te.location?oe.to(te.location):void 0,je}Oe.to=ye})(ni||(e.TestMessage=ni={}));var dt;(function(Oe){Oe.namespace=d.$_K,Oe.denamespace=d.$aL})(dt||(e.TestTag=dt={}));var pt;(function(Oe){function Be(te){const je=(0,i.$yO)(te).controllerId;return{extId:g.$7K.fromExtHostTestItem(te,je).toString(),label:te.label,uri:c.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(qe=>dt.namespace(je,qe.id)),range:m.$bt.lift(D.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&U.fromStrict(te.error)||null}}Oe.from=Be;function ye(te){return{parent:void 0,error:void 0,id:g.$7K.fromString(te.extId).localId,label:te.label,uri:c.URI.revive(te.uri),tags:(te.tags||[]).map(je=>{const{tagId:qe}=dt.denamespace(je);return new h.$YN(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Oe.toPlain=ye})(pt||(e.TestItem=pt={})),function(Oe){function Be(te){return{id:te.id}}Oe.from=Be;function ye(te){return new h.$YN(te.id)}Oe.to=ye}(dt||(e.TestTag=dt={}));var ri;(function(Oe){const Be=(te,je)=>{const qe=te.value;if(!qe)return;const et={...pt.toPlain(qe.item),parent:je,taskStates:qe.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(ct=>ct.type===0).map(ni.to)})),children:[]};if(te.children)for(const Ye of te.children.values()){const ct=Be(Ye,et);ct&&et.children.push(ct)}return et};function ye(te){const je=new b.$rO;for(const Ye of te.items)je.insert(g.$7K.fromString(Ye.item.extId).path,Ye);const qe=[je.nodes],et=[];for(;qe.length;)for(const Ye of qe.pop())Ye.value?et.push(Ye):Ye.children&&qe.push(Ye.children.values());return{completedAt:te.completedAt,results:et.map(Ye=>Be(Ye)).filter(v.$3f)}}Oe.to=ye})(ri||(e.TestResults=ri={}));var Wt;(function(Oe){function Be(qe){return{covered:qe.covered,total:qe.total}}function ye(qe){return"line"in qe?y.from(qe):D.from(qe)}function te(qe){return"branches"in qe?{count:qe.executed,location:ye(qe.location),type:1,branches:qe.branches.length?qe.branches.map(et=>({count:et.executed,location:et.location&&ye(et.location),label:et.label})):void 0}:{type:0,name:qe.name,count:qe.executed,location:ye(qe.location)}}Oe.fromDetailed=te;function je(qe){return{uri:qe.uri,statement:Be(qe.statementCoverage),branch:qe.branchCoverage&&Be(qe.branchCoverage),declaration:qe.declarationCoverage&&Be(qe.declarationCoverage),details:qe.detailedCoverage?.map(te)}}Oe.fromFile=je})(Wt||(e.TestCoverage=Wt={}));var qt;(function(Oe){function Be(ye){switch(ye){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Oe.to=Be})(qt||(e.CodeActionTriggerKind=qt={}));var ft;(function(Oe){function Be(te){const je=new h.$5N(re.to(te.kind),te.name,te.detail||"",c.URI.revive(te.uri),D.to(te.range),D.to(te.selectionRange));return je._sessionId=te._sessionId,je._itemId=te._itemId,je}Oe.to=Be;function ye(te,je,qe){if(je=je??te._sessionId,qe=qe??te._itemId,je===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:qe,kind:re.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:D.from(te.range),selectionRange:D.from(te.selectionRange),tags:te.tags?.map(W.from)}}Oe.from=ye})(ft||(e.TypeHierarchyItem=ft={}));var Rt;(function(Oe){function Be(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Oe.from=Be})(Rt||(e.ViewBadge=Rt={}));var ei;(function(Oe){function Be(qe,et,Ye){const ct=et.fileData;return ct?new h.$aN(new h.$bN(ct.name,c.URI.revive(ct.uri),ct.id,(0,P.$db)(()=>Ye(ct.id)))):qe===M.$ys.uriList&&et.uriListData?new h.$_M(je(et.uriListData)):new h.$_M(et.asString)}Oe.to=Be;async function ye(qe,et){const Ye=await et.asString();if(qe===M.$ys.uriList)return{asString:Ye,fileData:void 0,uriListData:te(Ye)};const ct=et.asFile();return{asString:Ye,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Oe.from=ye;function te(qe){return R.$Kt.split(qe).map(et=>{if(et.startsWith("#"))return et;try{return c.URI.parse(et)}catch{}return et})}function je(qe){return R.$Kt.create(qe.map(et=>typeof et=="string"?et:c.URI.revive(et)))}})(ei||(e.DataTransferItem=ei={}));var si;(function(Oe){function Be(te,je){const qe=te.items.map(([et,Ye])=>[et,ei.to(et,Ye,je)]);return new h.$cN(qe)}Oe.toDataTransfer=Be;async function ye(te){const je={items:[]},qe=[];for(const[et,Ye]of te)qe.push((async()=>{je.items.push([et,await ei.from(et,Ye)])})());return await Promise.all(qe),je}Oe.from=ye})(si||(e.DataTransfer=si={}));var Qe;(function(Oe){function Be(te,je){return{kind:"reply",agentId:te.participant??je?.agentId??"",subCommand:te.command??je?.command,message:te.prompt,title:te.label}}Oe.from=Be;function ye(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Oe.to=ye})(Qe||(e.ChatFollowup=Qe={}));var Vt;(function(Oe){function Be(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Oe.from=Be})(Vt||(e.ChatInlineFollowup=Vt={}));var Yt;(function(Oe){function Be(te){switch(te.role){case 0:return new h.$mO(te.content);case 1:return new h.$nO(te.content);case 2:return new h.$oO(te.content)}}Oe.to=Be;function ye(te){if(te instanceof h.$mO)return{role:0,content:te.content};if(te instanceof h.$nO)return{role:1,content:te.content};if(te instanceof h.$oO)return{role:2,content:te.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=ye})(Yt||(e.LanguageModelMessage=Yt={}));var Ht;(function(Oe){function Be(je){const qe={};for(const et of Object.keys(je))qe[et]=je[et].map(Oe.to);return qe}Oe.objectTo=Be;function ye(je){return{level:mt.to(je.level),kind:je.kind,value:(0,c.$wc)(je.value)?c.URI.revive(je.value):je.value,description:je.description}}Oe.to=ye;function te(je){return{level:mt.from(je.level),kind:je.kind,value:je.value,description:je.description}}Oe.from=te})(Ht||(e.ChatVariable=Ht={}));var mt;(function(Oe){function Be(te){switch(te){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Oe.to=Be;function ye(te){switch(te){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Oe.from=ye})(mt||(e.ChatVariableLevel=mt={}));var jt;(function(Oe){function Be(ye){switch(ye){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=Be})(jt||(e.InteractiveEditorResponseFeedbackKind=jt={}));var Pt;(function(Oe){function Be(te){return{kind:"markdownContent",content:U.from(te.value)}}Oe.to=Be;function ye(te){return new h.$eO(U.to(te.content))}Oe.from=ye})(Pt||(e.ChatResponseMarkdownPart=Pt={}));var Lt;(function(Oe){function Be(te){const{value:je,baseUri:qe}=te;function et(Ye,ct){return Ye.map(yt=>{const Kt=c.URI.joinPath(ct,yt.name);return{label:yt.name,uri:Kt,children:yt.children&&et(yt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,E.$Rg)(qe),uri:qe,children:et(je,qe)}}}Oe.to=Be;function ye(te){const je=(0,k.$Qh)(te.treeData);function qe(ct){return ct.map(yt=>({name:yt.label,children:yt.children&&qe(yt.children)}))}const et=je.uri,Ye=je.children?qe(je.children):[];return new h.$fO(Ye,et)}Oe.from=ye})(Lt||(e.ChatResponseFilesPart=Lt={}));var oi;(function(Oe){function Be(te){return{kind:"inlineReference",name:te.title,inlineReference:c.URI.isUri(te.value)?te.value:w.from(te.value)}}Oe.to=Be;function ye(te){const je=(0,k.$Qh)(te);return new h.$gO(c.URI.isUri(je.inlineReference)?je.inlineReference:w.to(je.inlineReference),te.name)}Oe.from=ye})(oi||(e.ChatResponseAnchorPart=oi={}));var Gt;(function(Oe){function Be(te){return{kind:"progressMessage",content:U.from(te.value)}}Oe.to=Be;function ye(te){return new h.$hO(te.content.value)}Oe.from=ye})(Gt||(e.ChatResponseProgressPart=Gt={}));var Zt;(function(Oe){function Be(te,je,qe){return{kind:"command",command:je.toInternal(te.value,qe)??{command:te.value.command,title:te.value.title}}}Oe.to=Be;function ye(te,je){return new h.$iO(je.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Oe.from=ye})(Zt||(e.ChatResponseCommandButtonPart=Zt={}));var vt;(function(Oe){function Be(te){return{kind:"reference",reference:c.URI.isUri(te.value)?te.value:w.from(te.value)}}Oe.to=Be;function ye(te){const je=(0,k.$Qh)(te);return new h.$jO(c.URI.isUri(je.reference)?je.reference:w.to(je.reference))}Oe.from=ye})(vt||(e.ChatResponseReferencePart=vt={}));var Nt;(function(Oe){function Be(je){return je instanceof h.$eO?Pt.to(je):je instanceof h.$gO?oi.to(je):je instanceof h.$jO?vt.to(je):je instanceof h.$hO?Gt.to(je):je instanceof h.$fO?Lt.to(je):{kind:"content",content:""}}Oe.to=Be;function ye(je,qe){switch(je.kind){case"reference":return vt.from(je);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(je,qe)}}Oe.from=ye;function te(je,qe){switch(je.kind){case"markdownContent":return Pt.from(je);case"inlineReference":return oi.from(je);case"progressMessage":return;case"treeData":return Lt.from(je);case"command":return Zt.from(je,qe)}}Oe.fromContent=te})(Nt||(e.ChatResponsePart=Nt={}));var Bt;(function(Oe){function Be(je,qe){return"markdownContent"in qe?((0,o.$7F)(je,"chatParticipantAdditions"),{content:U.from(qe.markdownContent),kind:"markdownContent"}):"content"in qe?"vulnerabilities"in qe&&qe.vulnerabilities?((0,o.$7F)(je,"chatParticipantAdditions"),{content:qe.content,vulnerabilities:qe.vulnerabilities,kind:"vulnerability"}):typeof qe.content=="string"?{content:qe.content,kind:"content"}:((0,o.$7F)(je,"chatParticipantAdditions"),{content:U.from(qe.content),kind:"markdownContent"}):"documents"in qe?{documents:qe.documents.map(et=>({uri:et.uri,version:et.version,ranges:et.ranges.map(Ye=>D.from(Ye))})),kind:"usedContext"}:"reference"in qe?{reference:"uri"in qe.reference?{uri:qe.reference.uri,range:D.from(qe.reference.range)}:qe.reference,kind:"reference"}:"inlineReference"in qe?{inlineReference:"uri"in qe.inlineReference?{uri:qe.inlineReference.uri,range:D.from(qe.inlineReference.range)}:qe.inlineReference,name:qe.title,kind:"inlineReference"}:"participant"in qe?((0,o.$7F)(je,"chatParticipantAdditions"),{agentName:qe.participant,command:qe.command,kind:"agentDetection"}):"message"in qe?{content:U.from(qe.message),kind:"progressMessage"}:void 0}Oe.from=Be;function ye(je){switch(je.kind){case"markdownContent":case"inlineReference":case"treeData":return Oe.to(je);case"content":return{content:je.content};case"usedContext":return{documents:je.documents.map(qe=>({uri:c.URI.revive(qe.uri),version:qe.version,ranges:qe.ranges.map(et=>D.to(et))}))};case"reference":return{reference:(0,c.$wc)(je.reference)?c.URI.revive(je.reference):w.to(je.reference)};case"agentDetection":return;case"progressMessage":return{message:je.content.value};case"vulnerability":return{content:je.content,vulnerabilities:je.vulnerabilities};default:return}}Oe.to=ye;function te(je,qe){switch(je.kind){case"markdownContent":return{content:je.content.value};case"inlineReference":return{inlineReference:(0,c.$wc)(je.inlineReference)?c.URI.revive(je.inlineReference):w.to(je.inlineReference),title:je.name};case"command":return{command:qe.fromInternal(je.command)??{command:je.command.id,title:je.command.title}};default:return}}Oe.toProgressContent=te})(Bt||(e.ChatResponseProgress=Bt={}));var Ft;(function(Oe){function Be(ye){return{prompt:ye.message,command:ye.command,variables:ye.variables.variables.map(Ct.to),location:kt.to(ye.location)}}Oe.to=Be})(Ft||(e.ChatAgentRequest=Ft={}));var kt;(function(Oe){function Be(ye){switch(ye){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel}}Oe.to=Be})(kt||(e.ChatLocation=kt={}));var Ct;(function(Oe){function Be(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(Ht.to)}}Oe.to=Be})(Ct||(e.ChatAgentResolvedVariable=Ct={}));var Et;(function(Oe){function Be(ye){return{label:ye.label,values:ye.values.map(Ht.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Oe.from=Be})(Et||(e.ChatAgentCompletionItem=Et={}));var ui;(function(Oe){function Be(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Oe.to=Be})(ui||(e.ChatAgentResult=ui={}));var ti;(function(Oe){function Be(ye,te,je){if(te.action.kind==="vote")return;const qe=ui.to(ye);return te.action.kind==="command"?{action:{kind:"command",commandButton:Bt.toProgressContent(te.action.commandButton,je)},result:qe}:te.action.kind==="followUp"?{action:{kind:"followUp",followup:Qe.to(te.action.followup)},result:qe}:{action:te.action,result:qe}}Oe.to=Be})(ti||(e.ChatAgentUserActionEvent=ti={}));var li;(function(Oe){function Be(ye,te,je){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:te.toInternal(ye,je)}Oe.from=Be})(li||(e.TerminalQuickFix=li={}));var di;(function(Oe){function Be(ye){return{kind:Xt.to(ye.kind)}}Oe.to=Be})(di||(e.PartialAcceptInfo=di={}));var Xt;(function(Oe){function Be(ye){switch(ye){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Oe.to=Be})(Xt||(e.PartialAcceptTriggerKind=Xt={}));var At;(function(Oe){function Be(ye,te){return{id:te,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Oe.from=Be})(At||(e.DebugTreeItem=At={}))}),define(Ee[328],Se([1,0,6,20,16]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;let P=class{constructor(p,$){this.a=p.getProxy(u.$iM.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>$.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,$,k){const M=R.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,k?.isRefactoring??!1)}};e.$Xic=P,e.$Xic=P=Je([Ve(0,j.$CO)],P)}),define(Ee[329],Se([1,0,19,8,46,4,38,3,39,18,2,217,25,6,16,7,290,26]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class n{constructor(t,g,d,l,o,h){this.i=t,this.j=g,this.k=d,this.l=l,this.m=o,this.n=h,this.b=$.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let g=function(l){if(t.c){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,l),o}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){g(this.markdown);const o=new c.$eO(l),h=v.ChatResponseMarkdownPart.to(o);return d(h),this},filetree(l,o){g(this.filetree);const h=new c.$fO(l,o),f=v.ChatResponseFilesPart.to(h);return d(f),this},anchor(l,o){g(this.anchor);const h=new c.$gO(l,o),f=v.ChatResponseAnchorPart.to(h);return d(f),this},button(l){g(this.anchor);const o=new c.$iO(l),h=v.ChatResponseCommandButtonPart.to(o,t.m,t.n);return d(h),this},progress(l){g(this.progress);const o=new c.$hO(l),h=v.ChatResponseProgressPart.to(o);return d(h),this},reference(l){g(this.reference);const o=new c.$jO(l),h=v.ChatResponseReferencePart.to(o);return d(h),this},push(l){g(this.push);const o=v.ChatResponsePart.to(l);return d(o),this},report(l){if(g(this.report),"placeholder"in l&&"resolvedContent"in l)return;const o=v.ChatResponseProgress.from(t.i,l);if(!o){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(o),this}}}return this.g}}class i{static{this.b=0}constructor(t,g,d){this.i=g,this.j=d,this.c=new Map,this.g=new p.$4c,this.d=t.getProxy(E.$iM.MainThreadChatAgents2)}createChatAgent(t,g,d){const l=i.b++,o=new r(t,g,this.d,l,d);return this.c.set(l,o),this.d.$registerAgent(l,t.identifier,g,{},(0,a.$6F)(t,"chatParticipantAdditions")),o.apiAgent}async $invokeAgent(t,g,d,l){const o=this.c.get(t);if(!o)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(g.sessionId);h||(h=new p.$Tc,this.g.set(g.sessionId,h));const f=new n(o.extension,g,this.d,this.i,this.j.converter,h);try{const D=await this.k(g.agentId,d),w=o.invoke(v.ChatAgentRequest.to(g),{history:D},f.apiObject,l);return await(0,j.$8g)(Promise.resolve(w).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${o.extension.identifier.value}] [@${o.id}] ${C}`,o.extension),{errorDetails:{message:C},timings:f.timings}}return{errorDetails:S?.errorDetails,timings:f.timings,metadata:S?.metadata}}),l)}catch(D){return this.i.error(D,o.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,R.$5i)(D)),responseIsIncomplete:!0}}}finally{f.close()}}async k(t,g){const d=[];for(const l of g.history){const o=v.ChatAgentResult.to(l.result),h=t===l.request.agentId?o:{...o,metadata:void 0};d.push(new c.$kO(l.request.message,l.request.command,l.request.variables.variables.map(v.ChatAgentResolvedVariable.to),{extensionId:"",name:l.request.agentId}));const f=(0,u.$Hb)(l.response.map(D=>v.ChatResponsePart.fromContent(D,this.j.converter)));d.push(new c.$lO(f,h,{extensionId:"",name:l.request.agentId},l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,g,d,l,o){const h=this.c.get(g);if(!h)return Promise.resolve([]);const f=await this.k(h.id,l),D=v.ChatAgentResult.to(d);return(await h.provideFollowups(D,{history:f},o)).filter(w=>{const S=!w.participant||A.Iterable.some(this.c.values(),y=>y.id===w.participant&&b.$Cm.equals(y.extension.identifier,h.extension.identifier));return S||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),S}).map(w=>v.ChatFollowup.from(w,t))}$acceptFeedback(t,g,d,l){const o=this.c.get(t);if(!o)return;const h=v.ChatAgentResult.to(g);let f;switch(d){case m.InteractiveSessionVoteDirection.Down:f=c.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:f=c.ChatResultFeedbackKind.Helpful;break}o.acceptFeedback(Object.freeze(l?{result:h,kind:f,reportIssue:l}:{result:h,kind:f}))}$acceptAction(t,g,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const o=v.ChatAgentUserActionEvent.to(g,d,this.j.converter);o&&l.acceptAction(Object.freeze(o))}async $invokeCompletionProvider(t,g,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(g,d)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,g){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(g)}async $provideSampleQuestions(t,g){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(g)).map(l=>v.ChatFollowup.from(l,void 0))}}e.$Zic=i;class r{constructor(t,g,d,l,o){this.extension=t,this.id=g,this.x=d,this.y=l,this.z=o,this.o=new P.$7d,this.p=new P.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,g){return this.s?await this.s.provider.provideCompletionItems(t,g)??[]:[]}async provideFollowups(t,g,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,g,d);return l?l.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const g=await this.t.provideWelcomeMessage(t);return g?g.map(d=>typeof d=="string"?d:v.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const g=await this.t.provideSampleQuestions(t);return g||[]}get apiAgent(){let t=!1,g=!1;const d=()=>{t||g||(g=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof M.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof c.$gN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),g=!1}))},l=this;return{get name(){return l.id},get description(){return l.c??""},set description(o){l.c=o,d()},get fullName(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.d??l.extension.displayName??l.extension.name},set fullName(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.d=o,d()},get iconPath(){return l.g},set iconPath(o){l.g=o,d()},get requestHandler(){return l.z},set requestHandler(o){(0,k.$5f)(typeof o=="function","Invalid request handler"),l.z=o},get followupProvider(){return l.b},set followupProvider(o){l.b=o,d()},get isDefault(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.i},set isDefault(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.i=o,d()},get helpTextPrefix(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.j},set helpTextPrefix(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.j=o,d()},get helpTextVariablesPrefix(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.k},set helpTextVariablesPrefix(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.k=o,d()},get helpTextPostfix(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.l},set helpTextPostfix(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.l=o,d()},get isSecondary(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.n},set isSecondary(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.n=o,d()},get sampleRequest(){return l.m},set sampleRequest(o){l.m=o,d()},get supportIssueReporting(){return(0,a.$7F)(l.extension,"chatParticipantAdditions"),l.q},set supportIssueReporting(o){(0,a.$7F)(l.extension,"chatParticipantAdditions"),l.q=o,d()},get onDidReceiveFeedback(){return l.o.event},set participantVariableProvider(o){if((0,a.$7F)(l.extension,"chatParticipantAdditions"),l.s=o,o){if(!o.triggerCharacters.length)throw new Error("triggerCharacters are required");l.x.$registerAgentCompletionsProvider(l.y,o.triggerCharacters)}else l.x.$unregisterAgentCompletionsProvider(l.y)},get participantVariableProvider(){return(0,a.$7F)(l.extension,"chatParticipantAdditions"),l.s},set welcomeMessageProvider(o){(0,a.$7F)(l.extension,"defaultChatParticipant"),l.t=o,d()},get welcomeMessageProvider(){return(0,a.$7F)(l.extension,"defaultChatParticipant"),l.t},onDidPerformAction:(0,a.$6F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return l.u},set isSticky(o){l.u=o,d()},set requester(o){l.w=o,d()},get requester(){return l.w},dispose(){t=!0,l.b=void 0,l.o.dispose(),l.x.$unregisterAgent(l.y)}}}invoke(t,g,d,l){return this.z(t,g,d,l)}}}),define(Ee[330],Se([1,0,13,3,6,16,7,26]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class ${static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(R.$iM.MainThreadChatVariables)}async $resolveVariable(I,b,E,v){const c=this.b.get(I);if(c)try{if(c.resolver.resolve2){(0,p.$7F)(c.extension,"chatParticipantAdditions");const m=new k(b,this.c),a=await c.resolver.resolve2(c.data.name,{prompt:E},m.apiObject,v);if(a)return a.map(P.ChatVariable.from)}else{const m=await c.resolver.resolve(c.data.name,{prompt:E},v);if(m)return m.map(P.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(I,b,E,v){const c=$.a++;return this.b.set(c,{extension:I,data:{name:b,description:E},resolver:v}),this.c.$registerVariable(c,{name:b,description:E}),(0,j.$Sc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$3ic=$;class k{constructor(I,b){this.c=I,this.d=b,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let b=function(v){if(I.a){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,v),c}};const I=this,E=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){b(this.progress);const c=new A.$hO(v),m=P.ChatResponseProgressPart.to(c);return E(m),this},reference(v){b(this.reference);const c=new A.$jO(v),m=P.ChatResponseReferencePart.to(c);return E(m),this},push(v){b(this.push);const c=P.ChatResponsePart.to(v);return E(c),this}}}return this.b}}}),define(Ee[331],Se([1,0,8,54,4,3,2,83,25,16,7,6,26]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=E;function E(v,c,m){const a=v.getProxy(I.$iM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Em,c.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const D=this.b.get(f.handle);return D?D.value:f}else if(f&&f.$mid===7){const D=f,w=this.b.get(D.commentControlHandle);if(!w)return D;const S=w.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(f&&(f.$mid===9||f.$mid===8)){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const w=D.getCommentThread(f.thread.commentThreadHandle);return w?f.$mid===8?w.value:{thread:w.value,text:f.text}:f}else if(f&&f.$mid===10){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const w=D.getCommentThread(f.thread.commentThreadHandle);if(!w)return f;const S=f.commentUniqueId,y=w.getCommentByUniqueId(S);return y||f}else if(f&&f.$mid===11){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const w=D.getCommentThread(f.thread.commentThreadHandle);if(!w)return f;const S=f.text,y=f.commentUniqueId,C=w.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=S:C.body=new M.$LM(S),C):f}return f}})}createCommentController(f,D,w){const S=n.a++,y=new r(f,S,D,w);this.b.set(y.handle,y);const C=this.c.get(f.identifier)||[];return C.push(y),this.c.set(f.identifier,C),y.value}async $createCommentThreadTemplate(f,D,w){const S=this.b.get(f);S&&S.$createCommentThreadTemplate(D,w)}async $setActiveComment(f,D){const w=this.b.get(f);w&&w.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(f,D,w){const S=this.b.get(f);S&&S.$updateCommentThreadTemplate(D,w)}$deleteCommentThread(f,D){this.b.get(f)?.$deleteCommentThread(D)}async $provideCommentingRanges(f,D,w){const S=this.b.get(f);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await m.ensureDocumentData(A.URI.revive(D));return(0,u.$_g)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(y.document,w);let O;return Array.isArray(C)?O={ranges:C,fileComments:!1}:C?O={ranges:C.ranges||[],fileComments:C.fileComments||!1}:O=C??void 0,O}).then(C=>{let O;return C&&(O={ranges:C.ranges.map(z=>k.Range.from(z)),fileComments:C.fileComments}),O})}$toggleReaction(f,D,w,S,y){const C=this.b.get(f);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,u.$_g)(()=>{const O=C.getCommentThread(D);if(O){const z=O.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&z&&C.reactionHandler)return C.reactionHandler(z,g(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,typeof f=="object"?((0,b.$7F)(this.extensionDescription,"commentThreadApplicability"),this.b.state=f.resolved,this.b.applicability=f.applicability):this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,D,w,S,y,C,O,z){this.m=D,this.n=w,this.o=S,this.p=y,this.q=C,this.extensionDescription=O,this.r=z,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Vc,this.l.value=new P.$Tc,this.n===void 0&&(this.n=`${f}.${this.handle}`),a.$createCommentThread(D,this.handle,this.n,this.o,k.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{a.$deleteCommentThread(D,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(T){F.range=T},get comments(){return F.comments},set comments(T){F.comments=T},get collapsibleState(){return F.collapsibleState},set collapsibleState(T){F.collapsibleState=T},get canReply(){return F.canReply},set canReply(T){F.canReply=T},get contextValue(){return F.contextValue},set contextValue(T){F.contextValue=T},get label(){return F.label},set label(T){F.label=T},get state(){return F.state},set state(T){F.state=T},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Tc);const f=w=>Object.prototype.hasOwnProperty.call(this.b,w),D={};f("range")&&(D.range=k.Range.from(this.p)),f("label")&&(D.label=this.label),f("contextValue")&&(D.contextValue=this.contextValue??null),f("comments")&&(D.comments=this.q.map(w=>s(this,w,this.k,this.extensionDescription))),f("collapsibleState")&&(D.collapseState=d(this.g)),f("canReply")&&(D.canReply=this.canReply),f("state")&&(D.state=l(this.h)),f("applicability")&&(D.applicability=o(this.h)),f("isTemplate")&&(D.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(f){for(const D of this.k){const w=D[0],S=D[1];if(f===S)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Je([(0,j.$Mh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,f?.resourceHints&&(0,b.$7F)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,f?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,b.$7F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,b.$7F)(this.h,"activeComment"),this.f}constructor(f,D,w,S){this.h=f,this.i=D,this.j=w,this.k=S,this.a=new Map,a.$registerCommentController(this.handle,w,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,O,z){return y.createCommentThread(C,O,z).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(f,D,w){D===void 0&&(0,b.$7F)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,f,D,w,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(f){if(!f){this.e=void 0,this.f=void 0;return}const D=this.a.get(f.commentThreadHandle);D&&(this.e=f.uniqueIdInThread?D.getCommentByUniqueId(f.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(f,D){const w=new i(this.id,this.handle,void 0,A.URI.revive(f),k.Range.to(D),[],this.h,!0);return w.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(f,D){const w=this.a.get(f);w&&(w.range=k.Range.to(D))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.g.forEach(f=>f.dispose())}}function s(h,f,D,w){let S=D.get(f);return S||(S=++h.commentHandle,D.set(f,S)),f.state!==void 0&&(0,b.$7F)(w,"commentsDraftState"),f.reactions?.some(y=>y.reactors!==void 0)&&(0,b.$7F)(w,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:S,body:typeof f.body=="string"?f.body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>t(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?k.$BO(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(f=>f.name):h.reactors}}function g(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?A.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(f=>({name:f}))}}function d(h){if(h!==void 0)switch(h){case M.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function l(h){let f;if(typeof h=="object"?f=h.resolved:f=h,f!==void 0)switch(f){case M.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function o(h){let f;if(typeof h=="object"&&(f=h.applicability),f!==void 0)switch(f){case M.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case M.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Ee[332],Se([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class E{constructor(g,d){this.document=g,this.b=d,this.a=1,this.c=new M.$Jic("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,d){await this.f(g).undo(),d||this.disposeBackup()}async redo(g,d){await this.f(g).redo(),d||this.disposeBackup()}disposeEdits(g){for(const d of g)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=s(this.document.uri)+this.a++;return(0,A.$Ug)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const d=this.c.get(g,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this.a=new Map}get(g,d){return this.a.get(this.b(g,d))}add(g,d,l){const o=this.b(g,d.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${g} resource:${d.uri}`);const h=new E(d,l);return this.a.set(o,h),h}delete(g,d){const l=this.b(g,d.uri);this.a.delete(l)}b(g,d){return`${g}@@@${d}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(g,d,l){return this.b(0,g,d,l)}addCustomProvider(g,d,l){return this.b(1,g,d,l)}get(g){return this.a.get(g)}b(g,d,l,o){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:g,extension:l,provider:o}),new b.$kM(()=>this.a.delete(d))}}class a{constructor(g,d,l,o,h){this.d=d,this.f=l,this.g=o,this.h=h,this.b=new m,this.c=new v,this.a=g.getProxy(I.$iM.MainThreadCustomEditors)}registerCustomEditorProvider(g,d,l,o){const h=new R.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,g,l)),this.a.$registerTextEditorProvider((0,k.$jjc)(g),d,o.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.$hjc)(g))):(h.add(this.b.addCustomProvider(d,g,l)),n(l)&&h.add(l.onDidChangeCustomDocument(f=>{const D=this.i(d,f.document.uri);if(r(f)){const w=D.addEdit(f);this.a.$onDidEdit(f.document.uri,d,w,f.label)}else this.a.$onContentChange(f.document.uri,d)})),this.a.$registerCustomEditorProvider((0,k.$jjc)(g),d,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.$hjc)(g))),b.$kM.from(h,new b.$kM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(g,d,l,o,h){const f=this.b.get(d);if(!f)throw new Error(`No provider found for '${d}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=p.URI.revive(g),w=await f.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:o?.buffer},h);let S;return n(f.provider)&&this.f&&(S=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(d,w,S),{editable:n(f.provider)}}async $disposeCustomDocument(g,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const o=p.URI.revive(g),{document:h}=this.i(d,o);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(g,d,l,o,h,f){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const w=$.ViewColumn.to(h),S=this.g.createNewWebview(d,o.contentOptions,D.extension),y=this.h.createNewWebviewPanel(d,l,o.title,w,o.options,S,o.active),C=p.URI.revive(g);switch(D.type){case 1:{const{document:O}=this.i(l,C);return D.provider.resolveCustomEditor(O,y,f)}case 0:{const O=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(O,y,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,d,l){this.i(d,g).disposeEdits(l)}async $onMoveCustomEditor(g,d,l){const o=this.b.get(l);if(!o)throw new Error(`No provider found for '${l}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(g);if(!h)throw new Error("No webview found");const f=p.URI.revive(d),D=this.d.getDocument(f);await o.provider.moveCustomTextEditor(D,h,u.CancellationToken.None)}async $undo(g,d,l,o){return this.i(d,g).undo(l,o)}async $redo(g,d,l,o){return this.i(d,g).redo(l,o)}async $revert(g,d,l){const o=this.i(d,g);await this.j(d).revertCustomDocument(o.document,l),o.disposeBackup()}async $onSave(g,d,l){const o=this.i(d,g);await this.j(d).saveCustomDocument(o.document,l),o.disposeBackup()}async $onSaveAs(g,d,l,o){const h=this.i(d,g);return this.j(d).saveCustomDocumentAs(h.document,p.URI.revive(l),o)}async $backup(g,d,l){const o=this.i(d,g),f=await this.j(d).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},l);return o.updateBackup(f),f.id}i(g,d){const l=this.c.get(g,p.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(g){const l=this.b.get(g)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$mjc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const g=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,j.$8i)(g)+""}}),define(Ee[333],Se([1,0,218,138,2,6,7,16,4,12,28,59]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=void 0;class E{#e;#t;#i;constructor(m,a,n,i,r,s,t,g){this.d=m,this.e=a,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new M.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,a){if(!m){this.clear();return}this.j();let n=[];if(R.URI.isUri(m)){if(!a){this.delete(m);return}this.#i.set(m,a.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(E.k);for(const t of m){const[g,d]=t;if((!s||g.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=g,n.push(g),this.#i.set(g,[])),d)this.#i.get(g)?.push(...d);else{const l=this.#i.get(g);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const g=this.#i.get(s);if(g)if(g.length>this.g){t=[];const d=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const o of g)if(o.severity===d[l]&&t.push({...p.Diagnostic.from(o),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:j.MarkerSeverity.Info,message:(0,u.localize)(0,null,g.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=g.map(d=>({...p.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,a){this.j();for(const[n,i]of this)m.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const a=this.#i.get(m);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,a){return m[0].toString()<a[0].toString()?-1:m[0].toString()>a[0].toString()?1:0}}e.$Qic=E;let v=class{static{b=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*b.d}static _mapper(m){const a=new M.$Bc;for(const n of m)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(m,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new $.$$d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,b._mapper),this.f=m.getProxy(P.$iM.MainThreadDiagnostics)}createDiagnosticCollection(m,a){const{g:n,f:i,h:r,j:s,k:t,l:g}=this,d=new class{$changeMany(h,f){i.$changeMany(h,f),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,f.length===0?"CLEARING":f)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){i.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+b.c++,l=a;else if(!n.has(a))l=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+b.c++;while(n.has(l))}return new class extends E{constructor(){super(a,l,b.e,b.d,h=>g.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=a.get(r.toString());typeof t>"u"&&(t=n.length,a.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(m){let a=[];for(const n of this.g.values())n.has(m)&&(a=a.concat(n.get(m)));return a}$acceptMarkersChange(m){if(!this.n){const a="_generated_mirror",n=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of m)this.n.set(R.URI.revive(a),n.map(p.Diagnostic.to))}};e.$Ric=v,e.$Ric=v=b=Je([Ve(1,k.$Nj),Ve(2,I.$Pic)],v)}),define(Ee[334],Se([1,0,2,13,7,16,75]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class p{constructor(k,M,I,b={timeout:1500,errors:3}){this.c=k,this.d=M,this.f=I,this.g=b,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(M,I,b)=>{const v={dispose:this.a.push([M,I,k])};return Array.isArray(b)&&b.push(v),v}}async $participateInSave(k,M){const I=u.URI.revive(k);let b=!1;const E=setTimeout(()=>b=!0,this.g.timeout),v=[];try{for(const c of[...this.a]){if(b)break;const m=this.d.getDocument(I),a=await this.h(c,{document:m,reason:P.TextDocumentSaveReason.to(M)});v.push(a)}}finally{clearTimeout(E)}return v}h([k,M,I],b){const E=this.b.get(k);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(I,k,M,b).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const c=this.b.get(k);this.b.set(k,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,M,I,b){const E=[],v=Date.now(),{document:c,reason:m}=b,{version:a}=c,n=Object.freeze({document:c,reason:m,waitUntil(i){if(Object.isFrozen(E))throw(0,j.$8)("waitUntil can not be called async");E.push(Promise.resolve(i))}});try{M.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(E),new Promise((i,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(s),i(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(i=>{const r={edits:[]};for(const s of i)if(Array.isArray(s)&&s.every(t=>t instanceof R.$rM))for(const{newText:t,newEol:g,range:d}of s)r.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:d&&P.Range.from(d),text:t,eol:g&&P.EndOfLine.from(g)}});if(r.edits.length!==0)return a===c.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$1jc=p}),define(Ee[335],Se([1,0,4,3,2,6,152,16,18,24,7]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;class I{constructor(E,v){this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new j.$Tc,this.h=new Map,this.f=E.getProxy(P.$iM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const v=this.g.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this.g.getDocument(E);if(v)return Promise.resolve(v);let c=this.h.get(E.toString());return c||(c=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const a=R.URI.revive(m);return(0,$.$6f)(this.g.getDocument(a))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),c)),c}createDocumentData(E){return this.f.$tryCreateDocument(E).then(v=>R.URI.revive(v))}$acceptModelLanguageChanged(E,v){const c=R.URI.revive(E),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(E){const v=R.URI.revive(E),c=this.g.getDocument(v);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(E,v){const c=R.URI.revive(E),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,c){const m=R.URI.revive(E),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");a._acceptIsDirty(c),a.onEvents(v);let n;v.isUndoing?n=M.TextDocumentChangeReason.Undo:v.isRedoing&&(n=M.TextDocumentChangeReason.Redo),this.c.fire((0,k.$On)({document:a.document,contentChanges:v.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(E,v){(0,A.$EO)(E,v)}}e.$Sic=I}),define(Ee[71],Se([1,0,73,4,18,2,5,6,20,16,7]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0,e.$njc=(0,A.$hi)("IExtHostEditorTabs");class I{constructor(m,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$6N(P.URI.revive(this.b.input.uri));case 2:return new M.$7N(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new M.$8N(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new M.$9N(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$0N(this.b.input.viewType);case 4:return new M.$$N(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$_N(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$aO;case 9:return new M.$bO(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$cO(this.b.input.providerId);default:return}}}class b{constructor(m,a){this.c=[],this.d="",this.b=m,this.e=a;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return k.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new I(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const a=this.c.find(n=>n.tabId===m.tabDto.id);if(!a)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(m.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new j.$7d,this.c=new j.$7d,this.e=[],this.a=m.getProxy(p.$iM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,a={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,R.$6f)(m.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(m){const a=new Set(this.e.map(d=>d.groupId)),n=new Set(m.map(d=>d.groupId)),i=(0,u.$L)(a,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const l=new b(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const g=(0,R.$6f)(m.find(d=>d.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const a=this.e.find(n=>n.groupId===m.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const a=this.e.find(i=>i.groupId===m.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(a=>a.apiObject===m)}async i(m,a){const n=[];for(const i of m){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,a)}async j(m,a){const n=[];for(const i of m){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,a)}};e.$ojc=E,e.$ojc=E=Je([Ve(0,$.$CO)],E);function v(c){return c.tabs!==void 0}}),define(Ee[336],Se([1,0,2,6,3,7,16,179,14,21,26,80]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;class b{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const m=this.a.indexOf(c);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),m=[];let a,n,i=14,r=14;for(const s of c){let t=a?(0,$.$nf)(a,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;a=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new p.$k2(m)}}provideDocumentLinks(c){this.c();const m=[],a=p.$l2.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of a){const i=A.DocumentLink.to(n);i.target&&m.push(i)}return m}}class E{constructor(c,m){this.i=m,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(j.$iM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,m,a,n={}){if(E.j(a),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,a);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof a.copy=="function"&&(r+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,M.$7F)(c,"fsChunks"),r+=4);let s;n.isReadonly&&(0,I.$Gk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,r,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${m}`),console.error(g)});const t=a.onDidChangeFile(g=>{const d=[];for(const l of g){const{uri:o,type:h}=l;if(o.scheme!==m)continue;let f;switch(h){case P.FileChangeType.Changed:f=0;break;case P.FileChangeType.Created:f=1;break;case P.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:o,type:f})}this.a.$onFileSystemChange(i,d)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:m,ctime:a,mtime:n,size:i,permissions:r}=c;return{type:m,ctime:a,mtime:n,size:i,permissions:r}}$stat(c,m){return Promise.resolve(this.l(c).stat(u.URI.revive(m))).then(a=>E.k(a))}$readdir(c,m){return Promise.resolve(this.l(c).readDirectory(u.URI.revive(m)))}$readFile(c,m){return Promise.resolve(this.l(c).readFile(u.URI.revive(m))).then(a=>k.$ue.wrap(a))}$writeFile(c,m,a,n){return Promise.resolve(this.l(c).writeFile(u.URI.revive(m),a.buffer,n))}$delete(c,m,a){return Promise.resolve(this.l(c).delete(u.URI.revive(m),a))}$rename(c,m,a,n){return Promise.resolve(this.l(c).rename(u.URI.revive(m),u.URI.revive(a),n))}$copy(c,m,a,n){const i=this.l(c);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(a),n))}$mkdir(c,m){return Promise.resolve(this.l(c).createDirectory(u.URI.revive(m)))}$watch(c,m,a,n){const i=this.l(c).watch(u.URI.revive(a),n);this.f.set(m,i)}$unwatch(c,m){const a=this.f.get(m);a&&(a.dispose(),this.f.delete(m))}$open(c,m,a){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),a))}$close(c,m){const a=this.l(c);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(m))}$read(c,m,a,n){const i=this.l(c);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=k.$ue.alloc(n);return Promise.resolve(i.read(m,a,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(c,m,a,n){const i=this.l(c);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,a,n.buffer,0,n.byteLength))}l(c){const m=this.c.get(c);if(!m){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return m}}e.$3jc=E}),define(Ee[337],Se([1,0,4,35,2,6,16,7,45]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,v,c,m,a,n){this.a=Math.random(),this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,j.$bk)(a),r=typeof a=="string",s=n?.correlate,t=m(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(s&&typeof g.session>"u")){if(!n?.ignoreCreateEvents)for(const d of g.created){const l=R.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of g.changed){const l=R.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of g.deleted){const l=R.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=p.$kM.from(this.i(E,c,a,n,n?.correlate),this.b,this.c,this.d,t)}i(E,v,c,m,a){const n=p.$kM.from();if(typeof c=="string")return n;const i=E.getProxy(P.$iM.MainThreadFileSystemEventService);let r=!1;return(c.pattern.includes(j.$0j)||c.pattern.includes(j.$$j))&&(r=!0),i.$watch(v.identifier.value,this.a,c.baseUri,{recursive:r,excludes:m?.excludes??[]},!!a),p.$kM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(E){this.a=E,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(R.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(E,v,c){this.j=E,this.k=v,this.l=c,this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.g=new u.$9d,this.h=new u.$9d,this.i=new u.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,v,c,m){return new k(this.j,E,v,this.a.event,A.GlobPattern.from(c),m)}$onFileEvent(E){this.a.fire(new M(E))}$onDidRunFileOperation(E,v){switch(E){case 2:this.b.fire(Object.freeze({files:v.map(c=>({oldUri:R.URI.revive(c.source),newUri:R.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(c=>R.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(c=>R.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,v){return(c,m,a)=>{const n=function(r){c.call(m,r)};return n.extension=E,v.event(n,void 0,a)}}async $onWillRunFileOperation(E,v,c,m){switch(E){case 2:return await this.n(this.g,{files:v.map(a=>({oldUri:R.URI.revive(a.source),newUri:R.URI.revive(a.target)}))},c,m);case 1:return await this.n(this.i,{files:v.map(a=>R.URI.revive(a.target))},c,m);case 0:case 3:return await this.n(this.h,{files:v.map(a=>R.URI.revive(a.target))},c,m)}}async n(E,v,c,m){const a=new Set,n=[];if(await E.fireAsync(v,m,async(r,s)=>{const t=Date.now(),g=await Promise.resolve(r);g instanceof p.$uM&&(n.push([s.extension,g]),a.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=A.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(a)}}}e.$4jc=I}),define(Ee[338],Se([1,0,19,8,22,13,124,3,24,39,14,18,2,29,175,83,134,220,25,16,7,26,111,6]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;class d{constructor(V,q){this.d=V,this.e=q}async provideDocumentSymbols(V,q){const Q=this.d.getDocument(V),J=await this.e.provideDocumentSymbols(Q,q);if(!(0,u.$Kb)(J))return J[0]instanceof r.$DM?J.map(i.DocumentSymbol.from):d.f(J)}static f(V){V=V.slice(0).sort((J,ge)=>{let we=J.location.range.start.compareTo(ge.location.range.start);return we===0&&(we=ge.location.range.end.compareTo(J.location.range.end)),we});const q=[],Q=[];for(const J of V){const ge={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(ge),q.push(ge);break}const we=Q[Q.length-1];if(E.$bt.containsRange(we.range,ge.range)&&!E.$bt.equalsRange(we.range,ge.range)){we.children?.push(ge),Q.push(ge);break}Q.pop()}}return q}}class l{constructor(V,q,Q,J,ge,we){this.f=V,this.g=q,this.h=Q,this.j=J,this.k=ge,this.l=we,this.d=new t.$Jic("CodeLens"),this.e=new Map}async provideCodeLenses(V,q){const Q=this.f.getDocument(V),J=await this.h.provideCodeLenses(Q,q);if(!J||q.isCancellationRequested)return;const ge=this.d.add(J),we=new p.$Tc;this.e.set(ge,we);const Te={cacheId:ge,lenses:[]};for(let He=0;He<J.length;He++)Te.lenses.push({cacheId:[ge,He],range:i.Range.from(J[He].range),command:this.g.toInternal(J[He].command,we)});return Te}async resolveCodeLens(V,q){const Q=V.cacheId&&this.d.get(...V.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,q),J||(J=Q),q.isCancellationRequested)return;const ge=V.cacheId&&this.e.get(V.cacheId[0]);if(ge){if(!J.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(J.command,ge),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function o(Fe){return Array.isArray(Fe)?Fe.map(i.DefinitionLink.from):Fe?[i.DefinitionLink.from(Fe)]:[]}class h{constructor(V,q){this.d=V,this.e=q}async provideDefinition(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideDefinition(J,ge,Q);return o(we)}}class f{constructor(V,q){this.d=V,this.e=q}async provideDeclaration(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideDeclaration(J,ge,Q);return o(we)}}class D{constructor(V,q){this.d=V,this.e=q}async provideImplementation(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideImplementation(J,ge,Q);return o(we)}}class w{constructor(V,q){this.d=V,this.e=q}async provideTypeDefinition(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideTypeDefinition(J,ge,Q);return o(we)}}class S{constructor(V,q){this.d=V,this.e=q}async provideHover(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideHover(J,ge,Q);if(!(!we||(0,u.$Kb)(we.contents)))return we.range||(we.range=J.getWordRangeAtPosition(ge)),we.range||(we.range=new r.$mM(ge,ge)),i.Hover.from(we)}}class y{constructor(V,q){this.d=V,this.e=q}async provideEvaluatableExpression(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideEvaluatableExpression(J,ge,Q);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(V,q){this.d=V,this.e=q}async provideInlineValues(V,q,Q,J){const ge=this.d.getDocument(V),we=await this.e.provideInlineValues(ge,i.Range.to(q),i.InlineValueContext.to(Q),J);if(Array.isArray(we))return we.map(Te=>i.InlineValue.from(Te))}}class O{constructor(V,q){this.d=V,this.e=q}async provideDocumentHighlights(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideDocumentHighlights(J,ge,Q);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class z{constructor(V,q){this.d=V,this.e=q}async provideMultiDocumentHighlights(V,q,Q,J){const ge=this.d.getDocument(V),we=Q.map(Xe=>this.d.getDocument(Xe)),Te=i.Position.to(q),He=await this.e.provideMultiDocumentHighlights(ge,Te,we,J);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class F{constructor(V,q){this.d=V,this.e=q}async provideLinkedEditingRanges(V,q,Q){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideLinkedEditingRanges(J,ge,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,u.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class T{constructor(V,q){this.d=V,this.e=q}async provideReferences(V,q,Q,J){const ge=this.d.getDocument(V),we=i.Position.to(q),Te=await this.e.provideReferences(ge,we,Q,J);if(Array.isArray(Te))return Te.map(i.location.from)}}class L{static{this.d=1e3}constructor(V,q,Q,J,ge,we,Te){this.g=V,this.h=q,this.j=Q,this.k=J,this.l=ge,this.m=we,this.n=Te,this.e=new t.$Jic("CodeAction"),this.f=new Map}async provideCodeActions(V,q,Q,J){const ge=this.g.getDocument(V),we=v.$dt.isISelection(q)?i.Selection.to(q):i.Range.to(q),Te=[];for(const st of this.j.getDiagnostics(V))if(we.intersection(st.range)&&Te.push(st)>L.d)break;const He={diagnostics:Te,only:Q.only?new r.$FM(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Xe=await this.k.provideCodeActions(ge,we,He,J);if(!(0,u.$Lb)(Xe)||J.isCancellationRequested)return;const tt=this.e.add(Xe),nt=new p.$Tc;this.f.set(tt,nt);const at=[];for(let st=0;st<Xe.length;st++){const Ie=Xe[st];if(Ie)if(L.o(Ie))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Ie.title,command:this.h.toInternal(Ie,nt)});else{He.only&&(Ie.kind?He.only.contains(Ie.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ze=Ie.ranges??[];at.push({cacheId:[tt,st],title:Ie.title,command:Ie.command&&this.h.toInternal(Ie.command,nt),diagnostics:Ie.diagnostics&&Ie.diagnostics.map(i.Diagnostic.from),edit:Ie.edit&&i.WorkspaceEdit.from(Ie.edit,void 0),kind:Ie.kind&&Ie.kind.value,isPreferred:Ie.isPreferred,isAI:(0,s.$6F)(this.m,"codeActionAI")?Ie.isAI:!1,ranges:(0,s.$6F)(this.m,"codeActionRanges")?(0,u.$Hb)(ze.map(i.Range.from)):void 0,disabled:Ie.disabled?.reason})}}return{cacheId:tt,actions:at}}async resolveCodeAction(V,q){const[Q,J]=V,ge=this.e.get(Q,J);if(!ge||L.o(ge))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(ge,q)??ge;let Te;we.edit&&(Te=i.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const Xe=this.f.get(Q);Xe&&(He=this.h.toInternal(we.command,Xe))}return{edit:Te,command:He}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class N{constructor(V,q,Q,J,ge){this.e=V,this.f=q,this.g=Q,this.h=J,this.j=ge,this.d=new t.$Jic("DocumentPasteEdit")}async prepareDocumentPaste(V,q,Q,J){if(!this.g.prepareDocumentPaste)return;const ge=this.f.getDocument(V),we=q.map(Xe=>i.Range.to(Xe)),Te=i.DataTransfer.toDataTransfer(Q,()=>{throw new P.$$});if(await this.g.prepareDocumentPaste(ge,we,Te,J),J.isCancellationRequested)return;const He=Array.from(Te).filter(([,Xe])=>!(Xe instanceof r.$_M));return i.DataTransfer.from(He)}async providePasteEdits(V,q,Q,J,ge,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(q),He=Q.map(at=>i.Range.to(at)),Xe=i.DataTransfer.toDataTransfer(J,async at=>(await this.e.$resolvePasteFileData(this.h,V,at)).buffer),tt=await this.g.provideDocumentPasteEdits(Te,He,Xe,{only:ge.only?new r.$eN(ge.only):void 0,triggerKind:ge.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const nt=this.d.add(tt);return tt.map((at,st)=>({_cacheId:[nt,st],title:at.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(Ie=>Ie.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,q){const[Q,J]=V,ge=this.d.get(Q,J);if(!ge||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(ge,q)??ge;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class B{constructor(V,q){this.d=V,this.e=q}async provideDocumentFormattingEdits(V,q,Q){const J=this.d.getDocument(V),ge=await this.e.provideDocumentFormattingEdits(J,q,Q);if(Array.isArray(ge))return ge.map(i.TextEdit.from)}}class U{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeFormattingEdits(V,q,Q,J){const ge=this.d.getDocument(V),we=i.Range.to(q),Te=await this.e.provideDocumentRangeFormattingEdits(ge,we,Q,J);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,q,Q,J){(0,I.$5f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ge=this.d.getDocument(V),we=q.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(ge,we,Q,J);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class Z{constructor(V,q){this.d=V,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,q,Q,J,ge){const we=this.d.getDocument(V),Te=i.Position.to(q),He=await this.e.provideOnTypeFormattingEdits(we,Te,Q,J,ge);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class _{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Jic("WorkspaceSymbols")}async provideWorkspaceSymbols(V,q){const Q=await this.e.provideWorkspaceSymbols(V,q);if(!(0,u.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),ge={cacheId:J,symbols:[]};for(let we=0;we<Q.length;we++){const Te=Q[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}ge.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[J,we]})}return ge}async resolveWorkspaceSymbol(V,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Q=this.d.get(...V.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,q);return J&&(0,$.$Qn)(V,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class Y{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideRenameEdits(V,q,Q,J){const ge=this.d.getDocument(V),we=i.Position.to(q);try{const Te=await this.e.provideRenameEdits(ge,we,Q,J);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=Y.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(V,q,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(V),ge=i.Position.to(q);try{const we=await this.e.prepareRename(J,ge,Q);let Te,He;if(r.$mM.isRange(we)?(Te=we,He=J.getText(we)):(0,I.$Wf)(we)&&(Te=we.range,He=we.placeholder),!Te||!He)return;if(Te.start.line>ge.line||Te.end.line<ge.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(we){const Te=Y.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideNewSymbolNames(V,q,Q){const J=this.d.getDocument(V),ge=i.Range.to(q);try{const we=await this.e.provideNewSymbolNames(J,ge,Q);return we?we.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(we){this.f.error(x.g(we)??JSON.stringify(we,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ce{constructor(V,q){this.resultId=V,this.tokens=q}}class X{constructor(V,q){this.f=V,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,q,Q){const J=this.f.getDocument(V),ge=q!==0?this.d.get(q):null;let we=typeof ge?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,ge.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return ge&&this.d.delete(q),we?(we=X.h(we),this.o(X.n(ge,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return X.j(V)?X.k(V)?V:new r.$EN(new Uint32Array(V.data),V.resultId):X.l(V)?X.m(V)?V:new r.$GN(V.edits.map(q=>new r.$FN(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const q of V.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(V,q){if(!X.j(q)||!V||!V.tokens)return q;const Q=V.tokens,J=Q.length,ge=q.data,we=ge.length;let Te=0;const He=Math.min(J,we);for(;Te<He&&Q[Te]===ge[Te];)Te++;if(Te===J&&Te===we)return new r.$GN([],q.resultId);let Xe=0;const tt=He-Te;for(;Xe<tt&&Q[J-Xe-1]===ge[we-Xe-1];)Xe++;return new r.$GN([{start:Te,deleteCount:J-Te-Xe,data:ge.subarray(Te,we-Xe)}],q.resultId)}o(V,q){if(X.j(V)){const Q=this.e++;return this.d.set(Q,new ce(V.resultId,V.data)),(0,m.$sab)({id:Q,type:"full",data:V.data})}if(X.l(V)){const Q=this.e++;return X.j(q)?this.d.set(Q,new ce(q.resultId,q.data)):this.d.set(Q,new ce(V.resultId)),(0,m.$sab)({id:Q,type:"delta",deltas:(V.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class me{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeSemanticTokens(V,q,Q){const J=this.d.getDocument(V),ge=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(q),Q);return ge?this.f(ge):null}f(V){return(0,m.$sab)({id:0,type:"full",data:V.data})}}class ae{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,q,Q,J,ge){this.f=V,this.g=q,this.h=Q,this.j=J,this.k=ge,this.d=new t.$Jic("CompletionItem"),this.e=new Map}async provideCompletionItems(V,q,Q,J){const ge=this.f.getDocument(V),we=i.Position.to(q),Te=ge.getWordRangeAtPosition(we)||new r.$mM(we,we),He=Te.with({end:we}),Xe=new k.$3d,tt=await this.h.provideCompletionItems(ge,we,J,i.CompletionContext.to(Q));if(!tt||J.isCancellationRequested)return;const nt=Array.isArray(tt)?new r.$SM(tt):tt,at=ae.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),st=new p.$Tc;this.e.set(at,st);const Ie=[],ze={x:at,b:Ie,a:{replace:i.Range.from(Te),insert:i.Range.from(He)},c:nt.isIncomplete||void 0,d:Xe.elapsed()};for(let Re=0;Re<nt.items.length;Re++){const Ge=nt.items[Re],ne=this.l(Ge,[at,Re],He,Te);Ie.push(ne)}return ze}async resolveCompletionItem(V,q){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=this.l(Q,V),ge=await this.h.resolveCompletionItem(Q,q);if(!ge)return;const we=this.l(ge,V);return(J.h!==we.h||J.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==we.n||J.o!==we.o||!(0,$.$Rn)(J.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q,Q,J){const ge=this.e.get(q[0]);if(!ge)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,ge),Te={x:q,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=V.textEdit.newText):typeof V.insertText=="string"?Te.h=V.insertText:V.insertText instanceof r.$vM&&(Te.h=V.insertText.value,Te.i|=4);let He;return V.textEdit?He=V.textEdit.range:V.range&&(He=V.range),r.$mM.isRange(He)?Te.j=i.Range.from(He):He&&(!Q?.isEqual(He.inserting)||!J?.isEqual(He.replacing))&&(Te.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class re{async provideInlineCompletions(V,q,Q,J){}disposeCompletions(V){}handleDidShowCompletionItem(V,q,Q){}handlePartialAccept(V,q,Q,J){}}class W extends re{constructor(V,q,Q,J){super(),this.f=V,this.g=q,this.h=Q,this.j=J,this.d=new ve,this.e=(0,s.$6F)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$6F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,q,Q,J){const ge=this.g.getDocument(V),we=i.Position.to(q),Te=await this.h.provideInlineCompletionItems(ge,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!Te||J.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],tt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((st,Ie)=>{let ze;st.command&&(nt||(nt=new p.$Tc),ze=this.j.toInternal(st.command,nt));const Re=st.insertText;return{insertText:typeof Re=="string"?Re:{snippet:Re.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:ze,idx:Ie,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Xe.map(st=>(nt||(nt=new p.$Tc),this.j.toInternal(st,nt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,q,Q){const J=this.d.get(V)?.items[q];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(V,q,Q,J){const ge=this.d.get(V)?.items[q];ge&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ge,Q),this.h.handleDidPartiallyAcceptCompletionItem(ge,i.PartialAcceptInfo.to(J)))}}class ie{async provideInlineEdits(V,q,Q){const J=this.f.getDocument(V),ge=await this.g.provideInlineEdit(J,{triggerKind:this.e[q.triggerKind]},Q);if(!ge||Q.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:ge});let He;ge.accepted&&(we||(we=new p.$Tc),He=this.h.toInternal(ge.accepted,we));let Xe;return ge.rejected&&(we||(we=new p.$Tc),Xe=this.h.toInternal(ge.rejected,we)),{pid:Te,text:ge.text,range:i.Range.from(ge.range),accepted:He,rejected:Xe}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,q,Q,J){this.f=q,this.g=Q,this.h=J,this.d=new ve,this.e={[c.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const q=this.e++;return this.d.set(q,V),q}disposeReferenceId(V){const q=this.d.get(V);return this.d.delete(V),q}get(V){return this.d.get(V)}}class Pe{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Jic("SignatureHelp")}async provideSignatureHelp(V,q,Q,J){const ge=this.e.getDocument(V),we=i.Position.to(q),Te=this.g(Q),He=await this.f.provideSignatureHelp(ge,we,J,Te);if(He){const Xe=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Xe}}}g(V){let q;if(V.activeSignatureHelp){const Q=i.SignatureHelp.to(V.activeSignatureHelp),J=this.d.get(V.activeSignatureHelp.id,0);J?(q=J,q.activeSignature=Q.activeSignature,q.activeParameter=Q.activeParameter):q=Q}return{...V,activeSignatureHelp:q}}releaseSignatureHelp(V){this.d.delete(V)}}class le{constructor(V,q,Q,J,ge){this.f=V,this.g=q,this.h=Q,this.j=J,this.k=ge,this.d=new t.$Jic("InlayHints"),this.e=new Map}async provideInlayHints(V,q,Q){const J=this.f.getDocument(V),ge=i.Range.to(q),we=await this.h.provideInlayHints(J,ge,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Q.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new p.$Tc);const He={hints:[],cacheId:Te};for(let Xe=0;Xe<we.length;Xe++)this.l(we[Xe],ge)&&He.hints.push(this.m(we[Xe],[Te,Xe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),He}async resolveInlayHint(V,q){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=await this.h.resolveInlayHint(Q,q);if(J&&this.l(J))return this.m(J,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(q&&!q.contains(V.position))}m(V,q){const Q=this.e.get(q[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:q,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")J.label=V.label;else{const ge=[];J.label=ge;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};r.$wM.isLocation(we.location)&&(Te.location=i.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,Q)),ge.push(Te)}}return J}}class ue{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Jic("DocumentLink")}async provideLinks(V,q){const Q=this.e.getDocument(V),J=await this.f.provideDocumentLinks(Q,q);if(!(!Array.isArray(J)||J.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ue.g).map(i.DocumentLink.from)};{const ge=this.d.add(J),we={links:[],cacheId:ge};for(let Te=0;Te<J.length;Te++){if(!ue.g(J[Te]))continue;const He=i.DocumentLink.from(J[Te]);He.cacheId=[ge,Te],we.links.push(He)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,q){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...V);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,q);if(!(!J||!ue.g(J)))return i.DocumentLink.from(J)}releaseLinks(V){this.d.delete(V)}}class oe{constructor(V,q){this.d=V,this.e=q}async provideColors(V,q){const Q=this.d.getDocument(V),J=await this.e.provideDocumentColors(Q,q);return Array.isArray(J)?J.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,q,Q){const J=this.d.getDocument(V),ge=i.Range.to(q.range),we=i.Color.to(q.color),Te=await this.e.provideColorPresentations(we,{document:J,range:ge},Q);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class K{constructor(V,q){this.d=V,this.e=q}async provideFoldingRanges(V,q,Q){const J=this.d.getDocument(V),ge=await this.e.provideFoldingRanges(J,q,Q);if(Array.isArray(ge))return ge.map(i.FoldingRange.from)}}class ee{constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideSelectionRanges(V,q,Q){const J=this.d.getDocument(V),ge=q.map(i.Position.to),we=await this.e.provideSelectionRanges(J,ge,Q);if(!(0,u.$Lb)(we))return[];if(we.length!==ge.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<ge.length;He++){const Xe=[];Te.push(Xe);let tt=ge[He],nt=we[He];for(;;){if(!nt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(i.SelectionRange.from(nt)),!nt.parent)break;tt=nt.range,nt=nt.parent}}return Te}}class he{constructor(V,q){this.f=V,this.g=q,this.d=new A.$HO(""),this.e=new Map}async prepareSession(V,q,Q){const J=this.f.getDocument(V),ge=i.Position.to(q),we=await this.g.prepareCallHierarchy(J,ge,Q);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideCallsTo(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing call hierarchy item");const ge=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(ge)return ge.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing call hierarchy item");const ge=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(ge)return ge.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(V){this.e.delete(V)}h(V,q){const Q=this.e.get(V),J=i.CallHierarchyItem.from(q,V,Q.size.toString(36));return Q.set(J._itemId,q),J}j(V,q){return this.e.get(V)?.get(q)}}class fe{constructor(V,q){this.f=V,this.g=q,this.d=new A.$HO(""),this.e=new Map}async prepareSession(V,q,Q){const J=this.f.getDocument(V),ge=i.Position.to(q),we=await this.g.prepareTypeHierarchy(J,ge,Q);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideSupertypes(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing type hierarchy item");const ge=await this.g.provideTypeHierarchySupertypes(J,Q);if(ge)return ge.map(we=>this.h(V,we))}async provideSubtypes(V,q,Q){const J=this.j(V,q);if(!J)throw new Error("missing type hierarchy item");const ge=await this.g.provideTypeHierarchySubtypes(J,Q);if(ge)return ge.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,q){const Q=this.e.get(V),J=i.TypeHierarchyItem.from(q,V,Q.size.toString(36));return Q.set(J._itemId,q),J}j(V,q){return this.e.get(V)?.get(q)}}class Ae{constructor(V,q,Q,J,ge){this.d=V,this.e=q,this.f=Q,this.g=J,this.h=ge}async provideDocumentOnDropEdits(V,q,Q,J,ge){const we=this.e.getDocument(q),Te=i.Position.to(Q),He=i.DataTransfer.toDataTransfer(J,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,V,tt)).buffer),Xe=await this.f.provideDocumentDropEdits(we,Te,He,ge);if(Xe)return(0,u.$3b)(Xe).map(tt=>({title:tt.title??(0,a.localize)(1,null,this.h.displayName||this.h.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}}class pe{constructor(V,q){this.d=V,this.e=q}async provideMappedEdits(V,q,Q,J){const ge=b.URI.revive(V),we=this.d.getDocument(ge),Te=Q.documents.map(tt=>tt.map(nt=>({uri:b.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(at=>i.Range.to(at))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(we,q,He,J);return Xe?i.WorkspaceEdit.from(Xe):null}}class Ce{constructor(V,q){this.adapter=V,this.extension=q}}class Me{static{this.d=0}constructor(V,q,Q,J,ge,we,Te,He){this.g=q,this.h=Q,this.j=J,this.k=ge,this.l=we,this.m=Te,this.n=He,this.f=new Map,this.e=V.getProxy(g.$iM.MainThreadLanguageFeatures)}o(V,q){return i.DocumentSelector.from(V,this.g,q)}p(V){return new r.$kM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Me.d++}async s(V,q,Q,J,ge,we=!1){const Te=this.f.get(V);if(!Te||!(Te.adapter instanceof q))return J;const He=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Xe=Q(Te.adapter,Te.extension);return Promise.resolve(Xe).catch(tt=>{(0,P.$4)(tt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Te.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),R.CancellationToken.isCancellationToken(ge)?(0,j.$9g)(Xe,ge):Xe}t(V,q){const Q=this.q();return this.f.set(Q,new Ce(V,q)),Q}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,q,Q,J){const ge=this.t(new d(this.h,Q),V),we=J&&J.label||Me.u(V);return this.e.$registerDocumentSymbolProvider(ge,this.o(q,V),we),this.p(ge)}$provideDocumentSymbols(V,q,Q){return this.s(V,d,J=>J.provideDocumentSymbols(b.URI.revive(q),Q),void 0,Q)}registerCodeLensProvider(V,q,Q){const J=this.q(),ge=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ce(new l(this.h,this.j.converter,Q,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(J,this.o(q,V),ge);let we=this.p(J);if(ge!==void 0){const Te=Q.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(ge));we=r.$kM.from(we,Te)}return we}$provideCodeLenses(V,q,Q){return this.s(V,l,J=>J.provideCodeLenses(b.URI.revive(q),Q),void 0,Q)}$resolveCodeLens(V,q,Q){return this.s(V,l,J=>J.resolveCodeLens(q,Q),void 0,void 0)}$releaseCodeLenses(V,q){this.s(V,l,Q=>Promise.resolve(Q.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(V,q,Q){const J=this.t(new h(this.h,Q),V);return this.e.$registerDefinitionSupport(J,this.o(q,V)),this.p(J)}$provideDefinition(V,q,Q,J){return this.s(V,h,ge=>ge.provideDefinition(b.URI.revive(q),Q,J),[],J)}registerDeclarationProvider(V,q,Q){const J=this.t(new f(this.h,Q),V);return this.e.$registerDeclarationSupport(J,this.o(q,V)),this.p(J)}$provideDeclaration(V,q,Q,J){return this.s(V,f,ge=>ge.provideDeclaration(b.URI.revive(q),Q,J),[],J)}registerImplementationProvider(V,q,Q){const J=this.t(new D(this.h,Q),V);return this.e.$registerImplementationSupport(J,this.o(q,V)),this.p(J)}$provideImplementation(V,q,Q,J){return this.s(V,D,ge=>ge.provideImplementation(b.URI.revive(q),Q,J),[],J)}registerTypeDefinitionProvider(V,q,Q){const J=this.t(new w(this.h,Q),V);return this.e.$registerTypeDefinitionSupport(J,this.o(q,V)),this.p(J)}$provideTypeDefinition(V,q,Q,J){return this.s(V,w,ge=>ge.provideTypeDefinition(b.URI.revive(q),Q,J),[],J)}registerHoverProvider(V,q,Q,J){const ge=this.t(new S(this.h,Q),V);return this.e.$registerHoverProvider(ge,this.o(q,V)),this.p(ge)}$provideHover(V,q,Q,J){return this.s(V,S,ge=>ge.provideHover(b.URI.revive(q),Q,J),void 0,J)}registerEvaluatableExpressionProvider(V,q,Q,J){const ge=this.t(new y(this.h,Q),V);return this.e.$registerEvaluatableExpressionProvider(ge,this.o(q,V)),this.p(ge)}$provideEvaluatableExpression(V,q,Q,J){return this.s(V,y,ge=>ge.provideEvaluatableExpression(b.URI.revive(q),Q,J),void 0,J)}registerInlineValuesProvider(V,q,Q,J){const ge=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,Q),V);this.e.$registerInlineValuesProvider(we,this.o(q,V),ge);let Te=this.p(we);if(ge!==void 0){const He=Q.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(ge));Te=r.$kM.from(Te,He)}return Te}$provideInlineValues(V,q,Q,J,ge){return this.s(V,C,we=>we.provideInlineValues(b.URI.revive(q),Q,J,ge),void 0,ge)}registerDocumentHighlightProvider(V,q,Q){const J=this.t(new O(this.h,Q),V);return this.e.$registerDocumentHighlightProvider(J,this.o(q,V)),this.p(J)}registerMultiDocumentHighlightProvider(V,q,Q){const J=this.t(new z(this.h,Q),V);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(q,V)),this.p(J)}$provideDocumentHighlights(V,q,Q,J){return this.s(V,O,ge=>ge.provideDocumentHighlights(b.URI.revive(q),Q,J),void 0,J)}$provideMultiDocumentHighlights(V,q,Q,J,ge){return this.s(V,z,we=>we.provideMultiDocumentHighlights(b.URI.revive(q),Q,J.map(Te=>b.URI.revive(Te)),ge),void 0,ge)}registerLinkedEditingRangeProvider(V,q,Q){const J=this.t(new F(this.h,Q),V);return this.e.$registerLinkedEditingRangeProvider(J,this.o(q,V)),this.p(J)}$provideLinkedEditingRanges(V,q,Q,J){return this.s(V,F,async ge=>{const we=await ge.provideLinkedEditingRanges(b.URI.revive(q),Q,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Me.w(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(V,q,Q){const J=this.t(new T(this.h,Q),V);return this.e.$registerReferenceSupport(J,this.o(q,V)),this.p(J)}$provideReferences(V,q,Q,J,ge){return this.s(V,T,we=>we.provideReferences(b.URI.revive(q),Q,J,ge),void 0,ge)}registerCodeActionProvider(V,q,Q,J){const ge=new p.$Tc,we=this.t(new L(this.h,this.j.converter,this.k,Q,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(q,V),{providedKinds:J?.providedCodeActionKinds?.map(Te=>Te.value),documentation:J?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,ge)}))},Me.u(V),!!Q.resolveCodeAction),ge.add(this.p(we)),ge}$provideCodeActions(V,q,Q,J,ge){return this.s(V,L,we=>we.provideCodeActions(b.URI.revive(q),Q,J,ge),void 0,ge)}$resolveCodeAction(V,q,Q){return this.s(V,L,J=>J.resolveCodeAction(q,Q),{},void 0)}$releaseCodeActions(V,q){this.s(V,L,Q=>Promise.resolve(Q.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(V,q,Q){const J=this.t(new B(this.h,Q),V);return this.e.$registerDocumentFormattingSupport(J,this.o(q,V),V.identifier,V.displayName||V.name),this.p(J)}$provideDocumentFormattingEdits(V,q,Q,J){return this.s(V,B,ge=>ge.provideDocumentFormattingEdits(b.URI.revive(q),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(V,q,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",ge=this.t(new U(this.h,Q),V);return this.e.$registerRangeFormattingSupport(ge,this.o(q,V),V.identifier,V.displayName||V.name,J),this.p(ge)}$provideDocumentRangeFormattingEdits(V,q,Q,J,ge){return this.s(V,U,we=>we.provideDocumentRangeFormattingEdits(b.URI.revive(q),Q,J,ge),void 0,ge)}$provideDocumentRangesFormattingEdits(V,q,Q,J,ge){return this.s(V,U,we=>we.provideDocumentRangesFormattingEdits(b.URI.revive(q),Q,J,ge),void 0,ge)}registerOnTypeFormattingEditProvider(V,q,Q,J){const ge=this.t(new Z(this.h,Q),V);return this.e.$registerOnTypeFormattingSupport(ge,this.o(q,V),J,V.identifier),this.p(ge)}$provideOnTypeFormattingEdits(V,q,Q,J,ge,we){return this.s(V,Z,Te=>Te.provideOnTypeFormattingEdits(b.URI.revive(q),Q,J,ge,we),void 0,we)}registerWorkspaceSymbolProvider(V,q){const Q=this.t(new _(q,this.l),V);return this.e.$registerNavigateTypeSupport(Q,typeof q.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(V,q,Q){return this.s(V,_,J=>J.provideWorkspaceSymbols(q,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(V,q,Q){return this.s(V,_,J=>J.resolveWorkspaceSymbol(q,Q),void 0,void 0)}$releaseWorkspaceSymbols(V,q){this.s(V,_,Q=>Q.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(V,q,Q){const J=this.t(new Y(this.h,Q,this.l),V);return this.e.$registerRenameSupport(J,this.o(q,V),Y.supportsResolving(Q)),this.p(J)}$provideRenameEdits(V,q,Q,J,ge){return this.s(V,Y,we=>we.provideRenameEdits(b.URI.revive(q),Q,J,ge),void 0,ge)}$resolveRenameLocation(V,q,Q,J){return this.s(V,Y,ge=>ge.resolveRenameLocation(b.URI.revive(q),Q,J),void 0,J)}registerNewSymbolNamesProvider(V,q,Q){const J=this.t(new x(this.h,Q,this.l),V);return this.e.$registerNewSymbolNamesProvider(J,this.o(q,V)),this.p(J)}$provideNewSymbolNames(V,q,Q,J){return this.s(V,x,ge=>ge.provideNewSymbolNames(b.URI.revive(q),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(V,q,Q,J){const ge=this.t(new X(this.h,Q),V),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ge,this.o(q,V),J,we);let Te=this.p(ge);if(we){const He=Q.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(we));Te=r.$kM.from(Te,He)}return Te}$provideDocumentSemanticTokens(V,q,Q,J){return this.s(V,X,ge=>ge.provideDocumentSemanticTokens(b.URI.revive(q),Q,J),null,J)}$releaseDocumentSemanticTokens(V,q){this.s(V,X,Q=>Q.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,q,Q,J){const ge=this.t(new me(this.h,Q),V);return this.e.$registerDocumentRangeSemanticTokensProvider(ge,this.o(q,V),J),this.p(ge)}$provideDocumentRangeSemanticTokens(V,q,Q,J){return this.s(V,me,ge=>ge.provideDocumentRangeSemanticTokens(b.URI.revive(q),Q,J),null,J)}registerCompletionItemProvider(V,q,Q,J){const ge=this.t(new ae(this.h,this.j.converter,Q,this.m,V),V);return this.e.$registerCompletionsProvider(ge,this.o(q,V),J,ae.supportsResolving(Q),V.identifier),this.p(ge)}$provideCompletionItems(V,q,Q,J,ge){return this.s(V,ae,we=>we.provideCompletionItems(b.URI.revive(q),Q,J,ge),void 0,ge)}$resolveCompletionItem(V,q,Q){return this.s(V,ae,J=>J.resolveCompletionItem(q,Q),void 0,Q)}$releaseCompletionItems(V,q){this.s(V,ae,Q=>Q.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(V,q,Q,J){const ge=new W(V,this.h,Q,this.j.converter),we=this.t(ge,V);return this.e.$registerInlineCompletionsSupport(we,this.o(q,V),ge.supportsHandleEvents,n.$Cm.toKey(V.identifier.value),J?.yieldTo?.map(Te=>n.$Cm.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(V,q,Q,J,ge){return this.s(V,re,we=>we.provideInlineCompletions(b.URI.revive(q),Q,J,ge),void 0,ge)}$handleInlineCompletionDidShow(V,q,Q,J){this.s(V,re,async ge=>{ge.handleDidShowCompletionItem(q,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,q,Q,J,ge){this.s(V,re,async we=>{we.handlePartialAccept(q,Q,J,ge)},void 0,void 0)}$freeInlineCompletionsList(V,q){this.s(V,re,async Q=>{Q.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(V,q,Q){const J=new ie(V,this.h,Q,this.j.converter),ge=this.t(J,V);return this.e.$registerInlineEditProvider(ge,this.o(q,V),V.identifier),this.p(ge)}$provideInlineEdit(V,q,Q,J){return this.s(V,ie,ge=>ge.provideInlineEdits(b.URI.revive(q),Q,J),void 0,J)}$freeInlineEdit(V,q){this.s(V,ie,async Q=>{Q.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(V,q,Q,J){const ge=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this.t(new Pe(this.h,Q),V);return this.e.$registerSignatureHelpProvider(we,this.o(q,V),ge),this.p(we)}$provideSignatureHelp(V,q,Q,J,ge){return this.s(V,Pe,we=>we.provideSignatureHelp(b.URI.revive(q),Q,J,ge),void 0,ge)}$releaseSignatureHelp(V,q){this.s(V,Pe,Q=>Q.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(V,q,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,ge=this.t(new le(this.h,this.j.converter,Q,this.l,V),V);this.e.$registerInlayHintsProvider(ge,this.o(q,V),typeof Q.resolveInlayHint=="function",J,Me.u(V));let we=this.p(ge);if(J!==void 0){const Te=Q.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(J));we=r.$kM.from(we,Te)}return we}$provideInlayHints(V,q,Q,J){return this.s(V,le,ge=>ge.provideInlayHints(b.URI.revive(q),Q,J),void 0,J)}$resolveInlayHint(V,q,Q){return this.s(V,le,J=>J.resolveInlayHint(q,Q),void 0,Q)}$releaseInlayHints(V,q){this.s(V,le,Q=>Q.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(V,q,Q){const J=this.t(new ue(this.h,Q),V);return this.e.$registerDocumentLinkProvider(J,this.o(q,V),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(V,q,Q){return this.s(V,ue,J=>J.provideLinks(b.URI.revive(q),Q),void 0,Q,q.scheme==="output")}$resolveDocumentLink(V,q,Q){return this.s(V,ue,J=>J.resolveLink(q,Q),void 0,void 0,!0)}$releaseDocumentLinks(V,q){this.s(V,ue,Q=>Q.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(V,q,Q){const J=this.t(new oe(this.h,Q),V);return this.e.$registerDocumentColorProvider(J,this.o(q,V)),this.p(J)}$provideDocumentColors(V,q,Q){return this.s(V,oe,J=>J.provideColors(b.URI.revive(q),Q),[],Q)}$provideColorPresentations(V,q,Q,J){return this.s(V,oe,ge=>ge.provideColorPresentations(b.URI.revive(q),Q,J),void 0,J)}registerFoldingRangeProvider(V,q,Q){const J=this.q(),ge=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ce(new K(this.h,Q),V)),this.e.$registerFoldingRangeProvider(J,this.o(q,V),V.identifier,ge);let we=this.p(J);if(ge!==void 0){const Te=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ge));we=r.$kM.from(we,Te)}return we}$provideFoldingRanges(V,q,Q,J){return this.s(V,K,ge=>ge.provideFoldingRanges(b.URI.revive(q),Q,J),void 0,J)}registerSelectionRangeProvider(V,q,Q){const J=this.t(new ee(this.h,Q,this.l),V);return this.e.$registerSelectionRangeProvider(J,this.o(q,V)),this.p(J)}$provideSelectionRanges(V,q,Q,J){return this.s(V,ee,ge=>ge.provideSelectionRanges(b.URI.revive(q),Q,J),[],J)}registerCallHierarchyProvider(V,q,Q){const J=this.t(new he(this.h,Q),V);return this.e.$registerCallHierarchyProvider(J,this.o(q,V)),this.p(J)}$prepareCallHierarchy(V,q,Q,J){return this.s(V,he,ge=>Promise.resolve(ge.prepareSession(b.URI.revive(q),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(V,q,Q,J){return this.s(V,he,ge=>ge.provideCallsTo(q,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(V,q,Q,J){return this.s(V,he,ge=>ge.provideCallsFrom(q,Q,J),void 0,J)}$releaseCallHierarchy(V,q){this.s(V,he,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(V,q,Q){const J=this.t(new fe(this.h,Q),V);return this.e.$registerTypeHierarchyProvider(J,this.o(q,V)),this.p(J)}$prepareTypeHierarchy(V,q,Q,J){return this.s(V,fe,ge=>Promise.resolve(ge.prepareSession(b.URI.revive(q),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(V,q,Q,J){return this.s(V,fe,ge=>ge.provideSupertypes(q,Q,J),void 0,J)}$provideTypeHierarchySubtypes(V,q,Q,J){return this.s(V,fe,ge=>ge.provideSubtypes(q,Q,J),void 0,J)}$releaseTypeHierarchy(V,q){this.s(V,fe,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(V,q,Q,J){const ge=this.q();return this.f.set(ge,new Ce(new Ae(this.e,this.h,Q,ge,V),V)),this.e.$registerDocumentOnDropEditProvider(ge,this.o(q,V),(0,s.$6F)(V,"dropMetadata")?J:void 0),this.p(ge)}$provideDocumentOnDropEdits(V,q,Q,J,ge,we){return this.s(V,Ae,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(q,b.URI.revive(Q),J,ge,we)),void 0,void 0)}registerMappedEditsProvider(V,q,Q){const J=this.t(new pe(this.h,Q),V);return this.e.$registerMappedEditsProvider(J,this.o(q,V)),this.p(J)}$provideMappedEdits(V,q,Q,J,ge){return this.s(V,pe,we=>Promise.resolve(we.provideMappedEdits(q,Q,J,ge)),null,ge)}registerDocumentPasteEditProvider(V,q,Q,J){const ge=this.q();return this.f.set(ge,new Ce(new N(this.e,this.h,Q,ge,V),V)),this.e.$registerPasteEditProvider(ge,this.o(q,V),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(ge)}$prepareDocumentPaste(V,q,Q,J,ge){return this.s(V,N,we=>we.prepareDocumentPaste(b.URI.revive(q),Q,J,ge),void 0,ge)}$providePasteEdits(V,q,Q,J,ge,we,Te){return this.s(V,N,He=>He.providePasteEdits(q,b.URI.revive(Q),J,ge,we,Te),void 0,Te)}$resolvePasteEdit(V,q,Q){return this.s(V,N,J=>J.resolvePasteEdit(q,Q),{},void 0)}$releasePasteEdits(V,q){this.s(V,N,Q=>Promise.resolve(Q.releasePasteEdits(q)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Me.w(V.decreaseIndentPattern),increaseIndentPattern:Me.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Me.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Me.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Me.w(V.beforeText),afterText:V.afterText?Me.w(V.afterText):void 0,previousLineText:V.previousLineText?Me.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Me.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(q=>r.SyntaxTokenType.toString(q)):void 0}}static D(V){return V.map(Me.C)}setLanguageConfiguration(V,q,Q){const{wordPattern:J}=Q;if(J&&(0,M.$0e)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(q,J):this.h.setWordDefinitionFor(q,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const ge=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Me.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Me.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Me.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Me.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ge,q,we),this.p(ge)}$setWordDefinitions(V){for(const q of V)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Tic=Me}),define(Ee[121],Se([1,0,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0,e.$1ic=(0,E.$hi)("IExtHostLanguageModels");class n{constructor(t,g){this.option=t,this.stream=new $.$Kh,this.stream=g??new $.$Kh}}class i{constructor(){this.a=new Map,this.b=new $.$Kh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let g=this.a.get(t.index);g||(this.a.size===0?g=new n(t.index,this.b):g=new n(t.index),this.a.set(t.index,g)),g.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const g of this.f())g.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{a=this}static{this.a=1}constructor(t,g,d){this.j=g,this.k=d,this.c=new k.$7d,this.d=new k.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Em,this.i=new Map,this.o=new Set,this.b=t.getProxy(j.$iM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,g,d,l){const o=a.a++;this.f.set(o,{extension:t.identifier,provider:d,languageModelId:g});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(o,g,{extension:t.identifier,identifier:g,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(o),this.b.$unregisterProvider(o)})}async $provideLanguageModelResponse(t,g,d,l,o,h){const f=this.f.get(t);if(!f)return;const D=new A.$Qv(async w=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:w.index,part:w.part})});return f.provider.provideLanguageModelResponse2(l.map(R.LanguageModelMessage.to),o,p.$Cm.toKey(d),D,h)}$updateLanguageModels(t){const g=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),g.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[o,h]of this.i)h.languageModelId===l&&(h.res.reject(new b.$5),this.i.delete(o))}this.d.fire(Object.freeze({added:Object.freeze(g),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const g=new Array;for(const{from:d,to:l,enabled:o}of t){const h=this.h.get(d)??new p.$Dm;if(h.has(l)!==o){o?h.add(l):h.delete(l),this.h.set(d,h);const D={from:d,to:l};g.push(D),this.c.fire(D)}}}async sendChatRequest(t,g,d,l,o){const h=t.identifier,f=await this.b.$prepareChatAccess(h,g,l.justification);if(!f||!this.g.has(g))throw P.$pO.NotFound(`Language model '${g}' is unknown.`);if(this.m(h,f)&&(!await this.l(t,{identifier:f.extension,displayName:f.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(f.extension)))throw P.$pO.NoPermissions(`Language model '${g}' cannot be used by '${h.value}'.`);const D=Math.random()*1e6|0,w=this.b.$fetchResponse(h,g,D,d.map(R.LanguageModelMessage.from),l.modelOptions??{},o),S=new $.$gh,y=new i;this.i.set(D,{languageModelId:g,res:y});let C;if(w.catch(O=>{S.isOpen()?y.reject(O):C=O}).finally(()=>{this.i.delete(D),y.resolve(),S.open()}),await S.wait(),C)throw new P.$pO(`Language model '${g}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,g){const d=this.i.get(t);d&&d.res.handleFragment(g)}async l(t,g,d,l){const o=I.$kL+g.identifier.value;if(await this.k.getSession(t,o,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:g.identifier,enabled:!0}]),!0;if(l)return!1;try{const f=d?(0,M.localize)(0,null,g.displayName,d):(0,M.localize)(1,null,g.displayName);return await this.k.getSession(t,o,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:t.identifier,to:g.identifier,enabled:!0}]),!0}catch{return!1}}m(t,g){return!!g.auth&&!p.$Cm.equals(g.extension,t)}async n(t){for(const g of this.o)try{await this.l(g,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const g=this,d=k.Event.signal(k.Event.filter(this.c.event,o=>p.$Cm.equals(o.from,t.identifier))),l=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(d,l)},canSendRequest(o){const h=g.g.get(o);if(!h)return;if(!g.m(t.identifier,h))return!0;const f=g.h.get(t.identifier);if(f)return f.has(h.extension)}}}};e.$2ic=r,e.$2ic=r=a=Je([Ve(0,v.$CO),Ve(1,m.$Nj),Ve(2,c.$Vic)],r)}),define(Ee[339],Se([1,0,6,16,7,40,8,3,26]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;class k{constructor(I,b,E,v){this.c=b,this.d=E,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(u.$iM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,b){await this.a.$changeLanguage(I,b);const E=this.c.getDocumentData(I);if(!E)throw new Error(`document '${I.toString()}' NOT found`);return E.document}async tokenAtPosition(I,b){const E=I.version,v=j.Position.from(b),c=await this.a.$tokensAtPosition(I.uri,v),m={type:R.StandardTokenType.Other,range:I.getWordRangeAtPosition(b)??new R.$mM(b.line,b.character,b.line,b.character)};if(!c)return m;const a={range:j.Range.to(c.range),type:j.TokenType.to(c.type)};return!a.range.contains(b)||E!==I.version?m:a}createLanguageStatusItem(I,b,E){const v=this.f++,c=this.a,m=this.g,a=`${I.identifier.value}/${b}`;if(m.has(a))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);m.add(a);const n={selector:E,id:b,name:I.displayName??I.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new p.$Tc,s=()=>{if(i?.dispose(),!m.has(a)){console.warn(`LanguageStatusItem (${b}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$jh)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:a,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:j.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===R.LanguageStatusSeverity.Error?P.default.Error:n.severity===R.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),c.$removeLanguageStatus(v),m.delete(a)},get id(){return n.id},get name(){return n.name},set name(g){n.name=g,s()},get selector(){return n.selector},set selector(g){n.selector=g,s()},get text(){return n.text},set text(g){n.text=g,s()},set text2(g){(0,$.$7F)(I,"languageStatusText"),n.text=g,s()},get text2(){return(0,$.$7F)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(g){n.detail=g,s()},get severity(){return n.severity},set severity(g){n.severity=g,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(g){n.accessibilityInformation=g,s()},get command(){return n.command},set command(g){n.command=g,s()},get busy(){return n.busy},set busy(g){n.busy=g,s()}};return s(),t}}e.$ikc=k}),define(Ee[340],Se([1,0,15,2,16,7,119]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0;class p{constructor(I,b,E,v){this.start=I,this.deletedCount=b,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new P.$LN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,b,E){this.notebook=I,this.h=b,this.j=E,this.handle=E.handle,this.uri=j.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(R.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,b=this.h.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:b.document,get mime(){return I.g},set mime(v){I.g=v},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(E)}return this.f}setOutputs(I){this.a=I.map(R.NotebookCellOutput.to)}setOutputItems(I,b,E){const v=E.map(R.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===I);if(c&&(b||(c.items.length=0),c.items.push(...v),c.items.length>1&&c.items.every(m=>A.$fK(m.mime)))){const m=new Map,a=[];c.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),c.items.length=0,a.forEach(n=>{const i=A.$gK(m.get(n));c.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$6jc=$;class k{static{this.a=0}constructor(I,b,E,v,c){this.k=I,this.l=b,this.m=E,this.uri=v,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,b={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(E){return E=I.n(E),I.b[E].apiCell},getCells(E){return(E?I.p(E):I.b).map(c=>c.apiCell)},save(){return I.q()}};this.e=Object.freeze(b)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,b,E){this.g=I.versionId,this.h=b,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},c=[];for(const a of I.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,v.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,v.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),c.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),c.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const m=new Map;for(let a=0;a<c.length;a++){const n=c[a],i=m.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let b=I.start|0,E=I.end|0;return b<0&&(b=0),E>this.b.length&&(E=this.b.length),I.with({start:b,end:E})}p(I){I=this.o(I);const b=[];for(let E=I.start;E<I.end;E++)b.push(this.b[E]);return b}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,b,E){if(this.j)return;const v=[],c=[],m=[];if(I.reverse().forEach(a=>{const i=a[2].map(t=>{const g=new $(this,this.l,t);return b||c.push($.asModelAddData(t)),g}),r=new p(a[0],a[1],[],i),s=this.b.splice(a[0],a[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),E)for(const a of v)E.push(a.asApiEvent())}s(I,b,E,v){const c=this.b.splice(I,b);this.b.splice(E,0,...c);const m=[new p(I,b,c.map(a=>a.apiCell),[]),new p(E,0,[],c)];for(const a of m)v.push(a.asApiEvent())}t(I,b){this.b[I].setOutputs(b)}u(I,b,E,v){this.b[I].setOutputItems(b,E,v)}v(I,b){const E=this.b[I];E.apiCell.document.languageId!==b&&this.m.$acceptModelLanguageChanged(E.uri,b)}w(I,b){const E=this.b[I];E.apiCell.mime=b}x(I,b){this.b[I].setMetadata(b)}y(I,b){this.b[I].setInternalMetadata(b)}getCellFromApiCell(I){return this.b.find(b=>b.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(b=>b.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$7jc=k}),define(Ee[341],Se([1,0,4,2,16,7]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class A{constructor($,k,M,I={timeout:1500,errors:3}){this.b=$,this.c=k,this.d=M,this.f=I,this.a=new u.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(k,M,I)=>{const b=function(v){k.call(M,v)};return b.extension=$,this.a.event(b,void 0,I)}}async $participateInSave($,k,M){const I=j.URI.revive($),b=this.c.getNotebookDocument(I);if(!b)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:R.TextDocumentSaveReason.to(k)},M,async(c,m)=>{const a=Date.now(),n=await await Promise.resolve(c);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!M.isCancellationRequested&&n&&(n instanceof P.$uM?E.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(E.length===0)return!0;const v={edits:[]};for(const c of E){const{edits:m}=R.WorkspaceEdit.from(c);v.edits=v.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$kkc=A}),define(Ee[153],Se([1,0,13,16,7]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,$,k,M,I,b){this.id=p,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=M,this.c=b}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(R.$LN.isNotebookRange))throw(0,u.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,k){p.f.$tryRevealRange(p.id,j.NotebookRange.from($),k??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(j.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$8jc=P}),define(Ee[342],Se([1,0,4,12,16]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;let P=class{constructor(p,$){this.c=p,this.d=$,this.a=new u.$7d,this.b=new u.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const k=this.d.getEditorById(p);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(R.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(R.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(R.ViewColumn.to(p[$]))}};e.$mkc=P,e.$mkc=P=Je([Ve(0,j.$Nj)],P)}),define(Ee[343],Se([1,0,4,6,153]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class P{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(j.$iM.MainThreadNotebookRenderers)}$postRendererMessage(p,$,k){const M=this.c.getEditorById(p);this.a.get($)?.fire({editor:M.apiEditor,message:k})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(M=>M.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(M,I,b)=>this.d($).event(M,I,b),postMessage:(M,I)=>{R.$8jc.apiEditorsToExtHost.has(M)&&([M,I]=[I,M]);const b=I&&R.$8jc.apiEditorsToExtHost.get(I);return this.b.$postMessage(b?.id,$,M)}}}d(p){let $=this.a.get(p);return $||($=new u.$7d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$pkc=P}),define(Ee[344],Se([1,0,16,108,22,54,13]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class p{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,b,E){const v=this.b++,{title:c,location:m,cancellable:a}=b,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(m),title:c,source:n,cancellable:a},I.isUnderDevelopment?void 0:I.identifier.value).catch(A.$2),this.d(v,E,!!a)}d(I,b,E){let v;E&&(v=new R.$ee,this.c.set(I,v));const c=a=>{this.a.$progressEnd(a),this.c.delete(a),v?.dispose()};let m;try{m=b(new k(this.a,I),E&&v?v.token:R.CancellationToken.None)}catch(a){throw c(I),a}return m.then(a=>c(I),a=>c(I)),m}$acceptProgressCanceled(I){const b=this.c.get(I);b&&(b.cancel(),this.c.delete(I))}}e.$tkc=p;function $(M,I){return M.message=I.message,typeof I.increment=="number"&&(typeof M.increment=="number"?M.increment+=I.increment:M.increment=I.increment),M}class k extends j.$Qv{constructor(I,b){super(E=>this.throttledReport(E)),this.c=I,this.d=b}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,P.$Nh)(100,(M,I)=>$(M,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ee[345],Se([1,0,2,6,8,16]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class A{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(j.$iM.MainThreadQuickDiff)}$provideOriginalResource($,k,M){const I=u.URI.revive(k),b=this.c.get($);return b?(0,R.$_g)(()=>b.provideOriginalResource(I,M)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider($,k,M,I){const b=A.a++;return this.c.set(b,k),this.b.$registerQuickDiffProvider(b,P.DocumentSelector.from($,this.d),M,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(b),this.c.delete(b)}}}}e.$ukc=A}),define(Ee[346],Se([1,0,22,4,3,6,2,7,13,19,40,56,26,16]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=v;function v(c,m,a){const n=c.getProxy(P.$iM.MainThreadQuickOpen);class i{constructor(f,D){this.e=new Map,this.f=0,this.a=f,this.b=D}showQuickPick(f,D,w,S=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,O=n.$show(C,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},S),z={},F=O.then(()=>z);return Promise.race([F,y]).then(T=>{if(T===z)return;const L=(0,b.$6F)(f,"quickPickItemTooltip");return y.then(N=>{const B=[];for(let U=0;U<N.length;U++){const Z=N[U];if(typeof Z=="string")B.push({label:Z,handle:U});else if(Z.kind===p.QuickPickItemKind.Separator)B.push({type:"separator",label:Z.label});else{Z.tooltip&&!L&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const _=Z.iconPath?d(Z.iconPath):void 0;B.push({label:Z.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:L?E.MarkdownString.fromStrict(Z.tooltip):void 0,handle:U})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=U=>{w.onDidSelectItem(N[U])}),n.$setItems(C,B),O.then(U=>{if(typeof U=="number")return N[U];if(Array.isArray(U))return U.map(Z=>N[Z])})})}).then(void 0,T=>{if(!(0,$.$4)(T))return n.$setError(C,T),Promise.reject(T)})}$onItemSelected(f){this.c?.(f)}showInput(f,D=u.CancellationToken.None){return this.d=f?.validateInput,n.$input(f,typeof this.d=="function",D).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(f){if(!this.d)return;const D=await this.d(f);if(!D||typeof D=="string")return D;let w;switch(D.severity){case p.InputBoxValidationSeverity.Info:w=M.default.Info;break;case p.InputBoxValidationSeverity.Warning:w=M.default.Warning;break;case p.InputBoxValidationSeverity.Error:w=M.default.Error;break;default:w=D.message?M.default.Error:M.default.Ignore;break}return{content:D.message,severity:w}}async showWorkspaceFolderPick(f,D=u.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!w)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(f){const D=new l(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(f){const D=new o(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(f,D){this.e.get(f)?._fireDidChangeValue(D)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,D){const w=this.e.get(f);w instanceof l&&w._fireDidChangeActive(D)}$onDidChangeSelection(f,D){const w=this.e.get(f);w instanceof l&&w._fireDidChangeSelection(D)}$onDidTriggerButton(f,D){this.e.get(f)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(f,D,w){const S=this.e.get(f);S instanceof l&&S._fireDidTriggerItemButton(D,w)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class r{static{this.a=1}constructor(f,D){this.x=f,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new j.$7d,this.q=new j.$7d,this.r=new j.$7d,this.s=new j.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((D,w)=>{const S=D===p.$IN.Back?-1:w;this.o.set(S,D)}),this.z({buttons:f.map((D,w)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===p.$IN.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const D=this.o.get(f);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(f){if(!this.v){for(const D of Object.keys(f)){const w=f[D];this.u[D]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof p.$gN)return{id:h.id};const f=g(h),D=t(h);return{dark:typeof f=="string"?A.URI.file(f):f,light:typeof D=="string"?A.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function g(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const f=s(h);let D,w;return"id"in f?w=I.ThemeIcon.asClassName(f):D=f,{iconPath:D,iconClass:w}}class l extends r{constructor(f,D){super(f.identifier,D),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new j.$7d,this.L=[],this.M=new j.$7d,this.N=new j.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const D=(0,b.$6F)(this.O,"quickPickItemTooltip"),w=[];for(let S=0;S<f.length;S++){const y=f[S];if(y.kind===p.QuickPickItemKind.Separator)w.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?d(y.iconPath):void 0;w.push({handle:S,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((O,z)=>({...d(O.iconPath),tooltip:O.tooltip,handle:z}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(f){const D=(0,k.$Hb)(f.map(w=>this.C.get(w)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(f){const D=(0,k.$Hb)(f.map(w=>this.C.get(w)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(f,D){const w=this.C.get(f);if(!w||!w.buttons||!w.buttons.length)return;const S=w.buttons[D];S&&this.N.fire({button:S,item:w})}}class o extends r{constructor(f,D){super(f.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:M.default.Error}):this.z({validationMessage:f.message,severity:f.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new i(m,a)}}),define(Ee[347],Se([1,0,2,4,54,3,8,6,19,131,12,25,56,16,26,15,11]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=e.$wkc=void 0;function n(C){return C instanceof u.URI}function i(C,O){return C.scheme===c.Schemas.file&&O.scheme===c.Schemas.file&&m.$k?C.toString()===O.toString():C.toString().toLowerCase()===O.toString().toLowerCase()}function r(C){if(C)return typeof C.iconPath=="string"?u.URI.file(C.iconPath):u.URI.isUri(C.iconPath)||b.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function s(C){if(C.icon){if(u.URI.isUri(C.icon))return C.icon;if(b.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const O=C.icon;return{light:O.light,dark:O.dark}}}else return}function t(C,O){if(!C.iconPath&&!O.iconPath)return 0;if(C.iconPath){if(!O.iconPath)return 1}else return-1;const z=typeof C.iconPath=="string"?C.iconPath:u.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,F=typeof O.iconPath=="string"?O.iconPath:u.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,k.$_q)(z,F)}function g(C,O){let z=0;if(C.strikeThrough!==O.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==O.faded)return C.faded?1:-1;if(C.tooltip!==O.tooltip)return(C.tooltip||"").localeCompare(O.tooltip||"");if(z=t(C,O),z!==0)return z;if(C.light&&O.light)z=t(C.light,O.light);else{if(C.light)return 1;if(O.light)return-1}if(z!==0)return z;if(C.dark&&O.dark)z=t(C.dark,O.dark);else{if(C.dark)return 1;if(O.dark)return-1}return z}function d(C,O){if(C.command!==O.command)return C.command<O.command?-1:1;if(C.title!==O.title)return C.title<O.title?-1:1;if(C.tooltip!==O.tooltip){if(C.tooltip!==void 0&&O.tooltip!==void 0)return C.tooltip<O.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(C.arguments===O.arguments)return 0;if(C.arguments)if(O.arguments){if(C.arguments.length!==O.arguments.length)return C.arguments.length-O.arguments.length}else return 1;else return-1;for(let z=0;z<C.arguments.length;z++){const F=C.arguments[z],T=O.arguments[z];if(F!==T&&!(n(F)&&n(T)&&i(F,T)))return F<T?-1:1}return 0}function l(C,O){let z=(0,k.$_q)(C.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(z!==0)return z;if(C.command&&O.command)z=d(C.command,O.command);else{if(C.command)return 1;if(O.command)return-1}if(z!==0)return z;if(C.decorations&&O.decorations)z=g(C.decorations,O.decorations);else{if(C.decorations)return 1;if(O.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)z=(0,k.$_q)(C.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)z=(0,k.$_q)(C.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return z}function o(C,O){for(let z=0;z<C.length;z++)if(C[z]!==O[z])return!1;return!0}function h(C,O){return C.command===O.command&&C.title===O.title&&C.tooltip===O.tooltip&&(C.arguments&&O.arguments?o(C.arguments,O.arguments):C.arguments===O.arguments)}function f(C,O){return(0,$.$ub)(C,O,h)}class D{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,v.$7F)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,v.$7F)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,v.$7F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,z,F,T,L){this.k=O,this.l=T,this.m=L,this.d="",this.e=new j.$7d,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=F}showValidationMessage(O,z){(0,v.$7F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,z)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$wkc=D;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,z,F,T,L,N,B){this.q=O,this.s=z,this.t=F,this.u=T,this.v=L,this.multiDiffEditorEnableViewChanges=N,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new j.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new j.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,z){const F=this.h.get(O);return F?(0,A.$_g)(()=>this.s.executeCommand(F.command,...F.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(l),F=(0,$.$Db)(this.o,O,l).map(N=>{const B=N.toInsert.map(U=>{const Z=this.e++;this.g.set(Z,U);const _=U.resourceUri;let Y;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"||U.command.command==="vscode.changes"){const oe=new P.$Tc;Y=this.s.converter.toInternal(U.command,oe),this.j.set(Z,oe)}else this.h.set(Z,U.command);const x=(0,v.$6F)(this.w,"scmMultiDiffEditor"),ce=x?U.multiDiffEditorOriginalUri:void 0,X=x?U.multiFileDiffEditorModifiedUri:void 0,me=r(U.decorations),ae=U.decorations&&r(U.decorations.light)||me,re=U.decorations&&r(U.decorations.dark)||me,W=[ae,re],ie=U.decorations&&U.decorations.tooltip||"",ve=U.decorations&&!!U.decorations.strikeThrough,Pe=U.decorations&&!!U.decorations.faded,le=U.contextValue||"";return{rawResource:[Z,_,W,ie,ve,Pe,le,Y,ce,X],handle:Z}});return{start:N.start,deleteCount:N.deleteCount,toInsert:B}}),T=F.map(({start:N,deleteCount:B,toInsert:U})=>[N,B,U.map(Z=>Z.rawResource)]),L=F.reverse();for(const{start:N,deleteCount:B,toInsert:U}of L){const Z=U.map(Y=>Y.handle),_=this.n.splice(N,B,...Z);for(const Y of _)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=O,T}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let z;(0,v.$6F)(this.x,"quickDiffProvider")&&(z=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:z})}get historyProvider(){return(0,v.$7F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,v.$7F)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new P.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new P.$Tc,this.o=O;const z=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,v.$7F)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,v.$7F)(this.x,"scmActionButton"),this.p.value=new P.$Tc,this.q=O;const z=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(F=>F.map(T=>this.y.converter.toInternal(T,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&f(this.t,O))return;this.s.value=new P.$Tc,this.t=O;const z=(O||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(O,z,F,T,L,N,B){this.x=O,this.y=T,this.z=L,this.A=N,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Vc,this.m=void 0,this.n=new P.$Vc,this.o=void 0,this.p=new P.$Vc,this.s=new P.$Vc,this.t=void 0,this.u=!1,this.v=new j.$7d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=F;const U=u.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${L}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(O,z,this.#e,this.w,U),this.#e.$registerSourceControl(this.w,L,N,B,U)}createResourceGroup(O,z,F){const T=(0,v.$6F)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,L=new w(this.#e,this.y,this.w,O,z,T,this.x),N=j.Event.once(L.onDidDispose)(()=>this.C.delete(L));return this.C.set(L,N),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const O=[],z=[];for(const[F,T]of this.C){T.dispose();const L=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});j.Event.once(F.onDidDispose)(()=>{this.D.delete(F),L.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),O.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const N=F._takeResourceStateSnapshot();N.length>0&&z.push([F.handle,N]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,O,z),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(z=>{const F=z._takeResourceStateSnapshot();F.length!==0&&O.push([z.handle,F])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Mh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Mh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,z,F,T){this.l=z,this.m=F,this.n=T,this.g=new Map,this.h=new I.$Em,this.j=new j.$7d,this.e=O.getProxy(p.$iM.MainThreadSCM),this.f=O.getProxy(p.$iM.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const N=this.g.get(L.sourceControlHandle);if(!N)return L;const B=N.getResourceGroup(L.groupHandle);return B?B.getResourceState(L.handle):L}else if(L&&L.$mid===4){const N=this.g.get(L.sourceControlHandle);return N?N.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const N=this.g.get(L.handle);return N||L}return L}})}createSourceControl(O,z,F,T){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,z,F,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const L=a.d++,N=new S(O,this.m,this.e,this.l,z,F,T);this.g.set(L,N);const B=this.h.get(O.identifier)||[];return B.push(N),this.h.set(O.identifier,B),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const z=this.h.get(O.identifier),F=z&&z[z.length-1];return F&&F.inputBox}$provideOriginalResource(O,z,F){const T=u.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",O,T.toString());const L=this.g.get(O);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$_g)(()=>L.quickDiffProvider.provideOriginalResource(T,F)).then(N=>N||null)}$onInputBoxValueChange(O,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const F=this.g.get(O);return F&&F.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(O,z,F,T){this.n.trace("ExtHostSCM#$executeResourceCommand",O,z,F);const L=this.g.get(O);if(!L)return Promise.resolve(void 0);const N=L.getResourceGroup(z);return N?N.$executeResourceCommand(F,T):Promise.resolve(void 0)}$validateInput(O,z,F){this.n.trace("ExtHostSCM#$validateInput",O);const T=this.g.get(O);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,A.$_g)(()=>T.inputBox.validateInput(z,F)).then(L=>{if(!L)return Promise.resolve(void 0);const N=E.MarkdownString.fromStrict(L.message);return N?Promise.resolve([N,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,z,F,T){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,F,T)??void 0}async $provideHistoryItems(O,z,F,T){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(z,F,T))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(O,z,F,T){const L=this.g.get(O)?.historyProvider;if(typeof L?.provideHistoryItemSummary!="function")return;const N=await L.provideHistoryItemSummary(z,F,T);return N?{...N,icon:s(N)}:void 0}async $provideHistoryItemChanges(O,z,F,T){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(z,F,T)??void 0}};e.$xkc=y,e.$xkc=y=a=Je([Ve(3,M.$Nj)],y)}),define(Ee[348],Se([1,0,6,16,2]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class P{static{this.a=0}constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(u.$iM.MainThreadShare)}async $provideShare(p,$,k){return await this.c.get(p)?.provideShare({selection:j.Range.to($.selection),resourceUri:R.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(p,$){const k=P.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,j.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$ykc=P}),define(Ee[349],Se([1,0,7,6,224,3,16,18]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$hN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$hN("statusBarItem.warningForeground")]])}#e;#t;constructor(b,E,v,c,m,a=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new P.$Tc,this.#e=b,this.#t=E,m&&c){this.c=(0,u.$VM)(c.identifier,m);const i=v.get(this.c);i&&(a=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=m,this.g=a,this.h=this.u(n)}u(b){if((0,p.$Yf)(b))return b===Number.POSITIVE_INFINITY?Number.MAX_VALUE:b===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:b}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(b){this.k=b,this.v()}set name(b){this.m=b,this.v()}set tooltip(b){this.l=b,this.v()}set color(b){this.n=b,this.v()}set backgroundColor(b){b&&!$.b.has(b.id)&&(b=void 0),this.o=b,this.v()}set command(b){this.r?.fromApi!==b&&(this.p&&this.q.add(this.p),this.p=new P.$Tc,typeof b=="string"?this.r={fromApi:b,internal:this.#t.toInternal({title:"",command:b},this.p)}:b?this.r={fromApi:b,internal:this.#t.toInternal(b,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(b){this.t=b,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let b;this.e?this.f?b=`${this.e.identifier.value}.${this.f}`:b=this.e.identifier.value:b=this.f;let E;this.m?E=this.m:E=(0,R.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,b,this.e?.identifier.value,E,this.k,c,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Akc=$;class k{constructor(b){this.b=[],this.a=b.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(b){const E={message:b};return this.b.unshift(E),this.c(),new u.$kM(()=>{const v=this.b.indexOf(E);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class M{constructor(b,E){this.e=new Map,this.a=b.getProxy(j.$iM.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(b){for(const E of b)this.e.set(E.entryId,E)}createStatusBarEntry(b,E,v,c){return new $(this.a,this.b,this.e,b,E,v,c)}setStatusBarMessage(b,E){const v=this.c.setMessage(b);let c;return typeof E=="number"?c=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new u.$kM(()=>{v.dispose(),clearTimeout(c)})}}e.$Bkc=M}),define(Ee[154],Se([1,0,29,144,67,112,89,16,2]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=e.$PO=e.$OO=void 0;const k=(i,r,s,t)=>{let g=r;return{enumerable:!0,configurable:!1,get(){return g},set(d){if(!s(g,d)){const l=g;g=d,i.listener?.(t(d,l))}}}},M=(i,r)=>i===r,I={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},b=i=>r=>({op:4,update:i(r)}),E=(i,r)=>({range:(()=>{let s;const t=b(g=>({range:u.$bt.lift(p.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return s},set(g){i.listener?.({op:6}),I.range(s,g)||(s=g,i.listener?.(t(g)))}}})(),label:k(i,r,I.label,b(s=>({label:s}))),description:k(i,void 0,I.description,b(s=>({description:s}))),sortText:k(i,void 0,I.sortText,b(s=>({sortText:s}))),canResolveChildren:k(i,!1,I.canResolveChildren,s=>({op:2,state:s})),busy:k(i,!1,I.busy,b(s=>({busy:s}))),error:k(i,void 0,I.error,b(s=>({error:p.MarkdownString.fromStrict(s)||null}))),tags:k(i,[],I.tags,(s,t)=>({op:1,new:s.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),v=i=>{const r=R.$7K.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return s.range=p.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>p.TestTag.to({id:(0,A.$aL)(t).tagId})),s},c=i=>{let r;for(const s of i.tests){const t=v(s.item);(0,j.$yO)(t).parent=r,r=t}return r};e.$OO=c;class m{constructor(r,s,t,g){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,j.$xO)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof a?void 0:d.parent}},children:{value:(0,P.$wO)(d,j.$yO,m),enumerable:!0,writable:!1},...E(d,t)})}}e.$PO=m;class a extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$QO=a;class n extends P.$sO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:j.$yO,getChildren:g=>g.children,root:new a(r,s),toITestItem:p.TestItem.from})}}e.$RO=n}),define(Ee[33],Se([1,0,18,7,16,24,6,19,12,57,29,49,2,3,5,20,154,21,68,46,39,87,90,30]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=void 0;let d=class{#e;#t;#i;constructor(w,S,y){this.b=new Map,this.c=new Map,this.#e=w.getProxy(A.$iM.MainThreadCommands),this.d=S,this.#i=y,this.#t=w.getProxy(A.$iM.MainThreadTelemetry),this.converter=new l(this,C=>{const O=this.c.get(C);return O?.result===h.Void?O:void 0},S),this.f=[{processArgument(C){return(0,k.$Qh)(C)}},{processArgument(C){return(0,P.$Pn)(C,function(O){if(M.$bt.isIRange(O))return R.Range.to(O);if(I.$at.isIPosition(O))return R.Position.to(O);if(M.$bt.isIRange(O.range)&&b.URI.isUri(O.uri))return R.location.to(O);if(O instanceof a.$ue)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const S=this.registerCommand(!1,w.id,async(...y)=>{const C=w.args.map((z,F)=>{if(!z.validate(y[F]))throw new Error(`Invalid argument '${z.name}' when running '${w.id}', received: ${typeof y[F]=="object"?JSON.stringify(y[F],null,"	"):y[F]} `);return z.convert(y[F])}),O=await this.executeCommand(w.internalId,...C);return w.result.convert(O,y,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new j.$kM(()=>{S.dispose(),this.c.delete(w.id)})}registerCommand(w,S,y,C,O,z){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:C,metadata:O,extension:z}),w&&this.#e.$registerCommand(S),new j.$kM(()=>{this.b.delete(S)&&w&&this.#e.$unregisterCommand(S)})}executeCommand(w,...S){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,S,!0)}async g(w,S,y){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,S,!1);{let C=!1;const O=(0,P.$Pn)(S,function(z){if(z instanceof j.$lM)return R.Position.from(z);if(z instanceof j.$mM)return R.Range.from(z);if(z instanceof j.$wM)return R.location.from(z);if(j.$LN.isNotebookRange(z))return R.NotebookRange.from(z);if(z instanceof ArrayBuffer)return C=!0,a.$ue.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return C=!0,a.$ue.wrap(z);if(z instanceof a.$ue)return C=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(w,C?new n.$dw(O):O,y);return(0,k.$Qh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(w,S,!1);throw z}}}async h(w,S,y){const C=this.b.get(w);if(!C)throw new Error("Unknown command");const{callback:O,thisArg:z,metadata:F}=C;if(F?.args)for(let L=0;L<F.args.length;L++)try{(0,u.$_f)(S[L],F.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${F.args[L].name}' - ${F.args[L].description}`)}const T=r.$3d.create();try{return await O.apply(z,S)}catch(L){if(w===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...S);N&&(w=N.command)}if(this.d.error(L,w,C.extension?.identifier),!y)throw L;if(C.extension?.identifier){const N=this.#i.onExtensionError(C.extension.identifier,L);this.d.trace("forwarded error to extension?",N,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$5i)(L)),this.id=w,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,w,T.elapsed())}}j(w,S,y){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new s.$3o(S),duration:y})}$executeContributedCommand(w,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const y=this.b.get(w);return y?(S=S.map(C=>this.f.reduce((O,z)=>z.processArgument(O,y.extension?.identifier),C)),this.h(w,S,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(S=>(w&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[S,y]of this.b){const{metadata:C}=y;C&&(w[S]=C)}return Promise.resolve(w)}};e.$XO=d,e.$XO=d=Je([Ve(0,c.$CO),Ve(1,$.$Nj),Ve(2,t.$WO)],d),e.$YO=(0,v.$hi)("IExtHostCommands");class l{constructor(w,S,y){this.d=w,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,g.$Dg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,S){if(!w)return;const y={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return y;const C=this.f(w.command);if(C)y.id=C.internalId,y.arguments=C.args.map((O,z)=>O.convert(w.arguments&&w.arguments[z]));else if((0,p.$Lb)(w.arguments)){const O=`${w.command} /${++this.c}`;this.b.set(O,w),S.add((0,E.$Sc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),y.$ident=O,y.id=this.delegatingCommandId,y.arguments=[O],this.g.trace("CommandsConverter#CREATE",w.command,O)}return y}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const S=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$ZO=l;class o{static{this.Uri=new o("uri","Uri of a text document",w=>b.URI.isUri(w),w=>w)}static{this.Position=new o("position","A position in a text document",w=>j.$lM.isPosition(w),R.Position.from)}static{this.Range=new o("range","A range in a text document",w=>j.$mM.isRange(w),R.Range.from)}static{this.Selection=new o("selection","A selection in a text document",w=>j.$nM.isSelection(w),R.Selection.from)}static{this.Number=new o("number","",w=>typeof w=="number",w=>w)}static{this.String=new o("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=o.Arr(o.String)}static Arr(w){return new o(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,S=>Array.isArray(S)&&S.every(y=>w.validate(y)),S=>S.map(y=>w.convert(y)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",w=>w instanceof j.$HM,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",w=>w instanceof j.$5N,R.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",w=>w instanceof m.$PO,R.TestItem.from)}constructor(w,S,y,C){this.name=w,this.description=S,this.validate=y,this.convert=C}optional(){return new o(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,S){return new o(w??this.name,S??this.description,this.validate,this.convert)}}e.$1O=o;class h{static{this.Void=new h("no result",w=>w)}constructor(w,S){this.description=w,this.convert=S}}e.$2O=h;class f{constructor(w,S,y,C,O){this.id=w,this.internalId=S,this.description=y,this.args=C,this.result=O}}e.$3O=f}),define(Ee[350],Se([1,0,19,15,2,83,134,41,33,16,7]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;const I=[new $.$3O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new $.$3O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$1O.Uri],new $.$2O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,u.$Kb)(c))return;class a extends M.$CM{static to(i){const r=new a(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new M.$wM(m[0],k.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=k.Range.to(i.selectionRange),r.children=i.children?i.children.map(a.to):[],r}}return c.map(a.to)})),new $.$3O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$1O.Uri,new $.$1O("options","Formatting options",c=>!0,c=>c)],new $.$2O("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$3O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$1O.Uri,$.$1O.Range,new $.$1O("options","Formatting options",c=>!0,c=>c)],new $.$2O("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$3O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$1O.Uri,$.$1O.Position,new $.$1O("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$1O("options","Formatting options",c=>!0,c=>c)],new $.$2O("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$3O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$3O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$3O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$3O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$3O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of Location-instances.",E(k.location.to))),new $.$3O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new $.$3O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$1O.Uri,new $.$1O("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>M.$lM.isPosition(m)),c=>c.map(k.Position.from))],new $.$2O("A promise that resolves to an array of ranges.",c=>c.map(m=>{let a;for(const n of m.reverse())a=new M.$GM(k.Range.to(n),a);return a}))),new $.$3O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$1O.String.with("query","Search string")],new $.$2O("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(k.WorkspaceSymbol.to))),new $.$3O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(k.CallHierarchyItem.to))),new $.$3O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$1O.CallHierarchyItem],new $.$2O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(k.CallHierarchyIncomingCall.to))),new $.$3O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$1O.CallHierarchyItem],new $.$2O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(k.CallHierarchyOutgoingCall.to))),new $.$3O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:k.Range.to(c.range),placeholder:c.text}})),new $.$3O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$1O.Uri,$.$1O.Position,$.$1O.String.with("newName","The new symbol name")],new $.$2O("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return k.WorkspaceEdit.to(c)}})),new $.$3O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$1O.Uri,$.$1O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$2O("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(k.DocumentLink.to))),new $.$3O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$1O.Uri],new $.$2O("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new M.$CN(c.tokenTypes,c.tokenModifiers)})),new $.$3O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$1O.Uri],new $.$2O("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$tab)(c);if(m.type==="full")return new M.$EN(m.data,void 0)})),new $.$3O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$1O.Uri,$.$1O.Range.optional()],new $.$2O("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new M.$CN(c.tokenTypes,c.tokenModifiers)})),new $.$3O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$1O.Uri,$.$1O.Range],new $.$2O("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$tab)(c);if(m.type==="full")return new M.$EN(m.data,void 0)})),new $.$3O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$1O.Uri,$.$1O.Position,$.$1O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$1O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$2O("A promise that resolves to a CompletionList-instance.",(c,m,a)=>{if(!c)return new M.$SM([]);const n=c.suggestions.map(i=>k.CompletionItem.to(i,a));return new M.$SM(n,c.incomplete)})),new $.$3O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$1O.Uri,$.$1O.Position,$.$1O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$2O("A promise that resolves to SignatureHelp.",c=>{if(c)return k.SignatureHelp.to(c)})),new $.$3O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$1O.Uri,$.$1O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$2O("A promise that resolves to an array of CodeLens-instances.",(c,m,a)=>E(n=>new M.$KM(k.Range.to(n.range),n.command&&a.fromInternal(n.command)))(c))),new $.$3O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$1O.Uri,new $.$1O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>M.$mM.isRange(c),c=>M.$nM.isSelection(c)?k.Selection.from(c):k.Range.from(c)),$.$1O.String.with("kind","Code action kind to return code actions for").optional(),$.$1O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$2O("A promise that resolves to an array of Command-instances.",(c,m,a)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new M.$EM(n.title,n.kind?new M.$FM(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(c))),new $.$3O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$1O.Uri],new $.$2O("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new M.$YM(k.Range.to(m.range),k.Color.to(m.color))):[])),new $.$3O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$1O("color","The color to show and insert",c=>c instanceof M.$XM,k.Color.from),new $.$1O("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:k.Range.from(c.range)}))],new $.$2O("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(k.ColorPresentation.to):[])),new $.$3O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$1O.Uri,$.$1O.Range],new $.$2O("A promise that resolves to an array of Inlay objects",(c,m,a)=>c.map(k.InlayHint.to.bind(void 0,a)))),new $.$3O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$1O.Uri],new $.$2O("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(k.FoldingRange.to)})),new $.$3O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$2O("A promise that resolves to an array of NotebookContentProvider static info objects.",E(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>k.NotebookExclusiveDocumentPattern.to(m))})))),new $.$3O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$1O.Uri,$.$1O.Range,new $.$1O("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof M.$mM,c=>k.InlineValueContext.from(c))],new $.$2O("A promise that resolves to an array of InlineValue objects",c=>c.map(k.InlineValue.to))),new $.$3O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$1O("uriOrString","Uri-instance or string (only http/https)",c=>R.URI.isUri(c)||typeof c=="string"&&(0,j.$rg)(c,j.Schemas.http,j.Schemas.https),c=>c),new $.$1O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[k.ViewColumn.from(c),void 0]:[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)])).optional(),$.$1O.String.with("label","").optional()],$.$2O.Void),new $.$3O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$1O.Uri.with("resource","Resource to open"),$.$1O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$1O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[k.ViewColumn.from(c),void 0]:[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)])).optional()],$.$2O.Void),new $.$3O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$1O.Uri.with("left","Left-hand side resource of the diff editor"),$.$1O.Uri.with("right","Right-hand side resource of the diff editor"),$.$1O.String.with("title","Human readable title for the diff editor").optional(),new $.$1O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)]).optional()],$.$2O.Void),new $.$3O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$1O.String.with("title","Human readable title for the changes editor"),new $.$1O("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[a,n,i]=m;if(!R.URI.isUri(a)||!R.URI.isUri(n)&&n!==void 0&&n!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},c=>c)],$.$2O.Void),new $.$3O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$1O.Uri,$.$1O.Position],new $.$2O("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new $.$3O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$1O.TypeHierarchyItem],new $.$2O("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new $.$3O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$1O.TypeHierarchyItem],new $.$2O("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new $.$3O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$1O.TestItem],$.$2O.Void),new $.$3O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$1O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$2O.Void),new $.$3O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$1O.String.with("name","The context key name"),new $.$1O("value","The context key value",()=>!0,c=>c)],$.$2O.Void),new $.$3O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$1O.Uri,$.$1O.StringArray,new $.$1O("MappedEditsContext","Mapped Edits Context",c=>k.MappedEditsContext.is(c),c=>k.MappedEditsContext.from(c))],new $.$2O("A promise that resolves to a workspace edit or null",c=>c?k.WorkspaceEdit.to(c):null))];class b{static register(m){I.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",p.$gj)}}e.$Uic=b;function E(c){return m=>{if(Array.isArray(m))return m.map(c)}}function v(c){if(!Array.isArray(c))return;const m=[];for(const a of c)P.$2t(a)?m.push(k.DefinitionLink.to(a)):m.push(k.location.to(a));return m}}),define(Ee[351],Se([1,0,8,3,2,6,33,16,7]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=void 0;class k{static{this.a=0}constructor(E,v){this.extension=E,this.provider=v,this.handle=k.a++}}class M{constructor(E){this.session=E,this.responses=[]}}class I{static{this.a=0}constructor(E,v,c,m){this.f=c,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(P.$iM.MainThreadInlineChat),v.registerApiCommand(new A.$3O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$1O("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?p.Range.from(a.initialRange):void 0,initialSelection:$.$nM.isSelection(a.initialSelection)?p.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?p.Position.from(a.position):void 0}})],A.$2O.Void))}registerProvider(E,v,c){const m=new k(E,v);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,c?.label??E.displayName??E.name,E.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",c?.supportReportIssue??!1),(0,j.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,v,c,m){const a=this.b.get(E);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(R.URI.revive(v)),i=p.Selection.to(c),r=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=I.a++;return this.d.set(s,new M(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,v,c,m){const a=this.b.get(E);if(!a)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:c.prompt,selection:p.Selection.to(c.selection),wholeRange:p.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,previewDocument:this.f.getDocument(R.URI.revive(c.previewDocument)),withIntentDetection:c.withIntentDetection};let r=!1;const s={report:async D=>{if(!c.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:D.message,edits:D.edits?.map(p.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:$.$LM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,s,m));let g;try{g=await(0,u.$8g)(t,m)}finally{r=!0}if(!g)return;const d=n.responses.push(g)-1,l={wholeRange:p.Range.from(g.wholeRange),placeholder:g.placeholder};if(!I.h(g))return{...l,id:d,type:"editorEdit",message:p.MarkdownString.from(g.contents),edits:[]};const{edits:o,contents:h}=g,f=h!==void 0?p.MarkdownString.from(h):void 0;return o instanceof $.$uM?{...l,id:d,type:"bulkEdit",edits:p.WorkspaceEdit.from(o),message:f}:{...l,id:d,type:"editorEdit",edits:o.map(p.TextEdit.from),message:f}}async $provideFollowups(E,v,c,m){const a=this.b.get(E),n=this.d.get(v),i=n?.responses[c];if(a&&i&&a.provider.provideFollowups){const r=Promise.resolve(a.provider.provideFollowups(n.session,i,m));return(await(0,u.$8g)(r,m))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(E,v,c,m){const a=this.b.get(E),n=this.d.get(v),i=n?.responses[c];if(a&&i){const r=p.InteractiveEditorResponseFeedbackKind.to(m);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(E,v){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$5jc=I}),define(Ee[352],Se([1,0,2,33]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class R{constructor(A,p,$,k,M){this.a=p,this.b=$,this.c=k;const I=new j.$3O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new j.$1O("showOptions","Show Options",b=>!0,b=>b),new j.$1O("resource","Interactive resource Uri",b=>!0,b=>b),new j.$1O("controllerId","Notebook controller Id",b=>!0,b=>b),new j.$1O("title","Interactive editor title",b=>!0,b=>b)],new j.$2O("Notebook and input URI",b=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const E=this.a.getEditorById(b.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:u.URI.revive(b.notebookUri),inputUri:u.URI.revive(b.inputUri),notebookEditor:E.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:u.URI.revive(b.notebookUri),inputUri:u.URI.revive(b.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,p,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$fkc=R}),define(Ee[353],Se([1,0,19,8,22,4,3,28,2,25,12,6,33,16,7,113,295,26,68,296]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0,e.$okc=o;let r=class{constructor(f,D,w,S,y){this.m=D,this.n=w,this.o=S,this.q=y,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(I.$iM.MainThreadNotebookKernels);const C=new b.$3O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$1O("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const F=this.n.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:F}}else if(z&&"notebookEditor"in z){const F=this.n.getIdByEditor(z.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return z})],b.$2O.Void),O=new b.$3O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[b.$1O.Uri],new b.$2O("A promise that resolves to an array of variables",(z,F)=>z.map(T=>({name:T.name,value:T.value,type:T.type,editable:!1}))));this.o.registerApiCommand(C),this.o.registerApiCommand(O)}createNotebookController(f,D,w,S,y,C){for(const me of this.j.values())if(me.controller.id===D&&k.$Cm.equals(f.identifier,me.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const O=this.k++,z=this;this.q.trace(`NotebookController[${O}], CREATED by ${f.identifier.value}, ${D}`);const F=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${f.identifier}'`);let T=!1;const L=new P.$7d,N=new P.$7d,B={id:o(f.identifier,D),notebookType:w,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:S||f.identifier.value,preloads:C?C.map(E.NotebookRendererScript.from):[]};let U=y??F,Z,_;this.a.$addKernel(O,B).catch(me=>{console.log(me),T=!0});let Y=0;const x=()=>{if(T)return;const me=++Y;Promise.resolve().then(()=>{me===Y&&this.a.$updateKernel(O,B)})},ce=new p.$Bc,X={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return B.label},set label(me){B.label=me??f.displayName??f.name,x()},get detail(){return B.detail??""},set detail(me){B.detail=me,x()},get description(){return B.description??""},set description(me){B.description=me,x()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(me){B.supportedLanguages=me,x()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(me){B.supportsExecutionOrder=me,x()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(me){U=me??F},get interruptHandler(){return Z},set interruptHandler(me){Z=me,B.supportsInterrupt=!!me,x()},set variableProvider(me){(0,a.$7F)(f,"notebookVariableProvider"),_=me,B.hasVariableProvider=!!me,me?.onDidChangeVariables(ae=>z.a.$variablesUpdated(ae.uri)),x()},get variableProvider(){return _},createNotebookCellExecution(me){if(T)throw new Error("notebook controller is DISPOSED");if(!ce.has(me.notebook.uri))throw z.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return z._createNotebookCellExecution(me,o(f.identifier,this.id))},createNotebookExecution(me){if((0,a.$7F)(f,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!ce.has(me.uri))throw z.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return z._createNotebookExecution(me,o(f.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${O}], DISPOSED`),T=!0,this.j.delete(O),L.dispose(),N.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(me,ae){ae===v.NotebookControllerAffinity2.Hidden&&(0,a.$7F)(f,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(O,me.uri,ae)},onDidReceiveMessage:N.event,postMessage(me,ae){return(0,a.$7F)(f,"notebookMessaging"),z.a.$postMessage(O,ae&&z.n.getIdByEditor(ae),me)},asWebviewUri(me){return(0,a.$7F)(f,"notebookMessaging"),(0,c.$Oyb)(me,z.m.remote)}};return this.j.set(O,{extensionId:f.identifier,controller:X,onDidReceiveMessage:N,onDidChangeSelection:L,associatedNotebooks:ce}),X}getIdByController(f){for(const[D,w]of this.j)if(w.controller===f)return o(w.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,D){const w=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(w,D);const y={dispose:()=>{this.f.delete(w),S.a.$removeKernelDetectionTask(w)}};return this.f.set(w,y),y}registerKernelSourceActionProvider(f,D,w){const S=this.i++,y=typeof w.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,w),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let O;return y!==void 0&&(O=w.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),O?.dispose()}}}async $provideKernelSourceActions(f,D){const w=this.h.get(f);if(w){const S=new A.$Tc;return(await w.provideNotebookKernelSourceActions(D)??[]).map(C=>E.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(f,D,w){const S=this.j.get(f);if(S){const y=this.n.getNotebookDocument($.URI.revive(D));w?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),w),S.onDidChangeSelection.fire({selected:w,notebook:y.apiNotebook})}}async $executeCells(f,D,w){const S=this.j.get(f);if(!S)return;const y=this.n.getNotebookDocument($.URI.revive(D)),C=[];for(const O of w){const z=y.getCell(O);z&&C.push(z.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,y.apiNotebook,S.controller)}catch(O){this.q.error(`NotebookController[${f}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(f,D,w){const S=this.j.get(f);if(!S)return;const y=this.n.getNotebookDocument($.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const C of w){const O=y.getCell(C);O&&this.b.get(O.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(y.uri);w.length&&Array.isArray(C)&&C.length&&C.forEach(O=>O.dispose())}}async $provideVariables(f,D,w,S,y,C,O){const z=this.j.get(f);if(!z)return;const F=this.n.getNotebookDocument($.URI.revive(w)),T=z.controller.variableProvider;if(!T)return;let L;if(S!==void 0){if(L=this.s[S],!L)return}else this.s={};const N=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=T.provideVariables(F.apiNotebook,L,N,C,O);let U=0;for await(const Z of B){if(O.isCancellationRequested)return;const _={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[_.id]=Z.variable,this.a.$receiveVariable(D,_),U++>=i.$phb)return}}$acceptKernelMessageFromRenderer(f,D,w){const S=this.j.get(f);if(!S)return;const y=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:w}))}$cellExecutionChanged(f,D,w){const y=this.n.getNotebookDocument($.URI.revive(f)).getCell(D);if(y){const C=w?E.NotebookCellExecutionState.to(w):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(f,D){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(D,S,this.a);this.b.set(S.uri,y);const C=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),C.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(f,D){const w=this.n.getNotebookDocument(f.uri),S=f.getCells().find(O=>{const z=w.getCellFromApiCell(O);return z&&this.b.has(z.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const y=new d(D,w,this.a),C=y.onDidChangeState(()=>{y.state===g.Resolved&&(y.dispose(),C.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[y,C]),y.asApiObject()}};e.$nkc=r,e.$nkc=r=Je([Ve(4,M.$Nj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(f,D,w){super(),this.m=D,this.n=w,this.b=t.a++,this.c=new P.$7d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new R.$ee),this.h=new l(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const D=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$dw(D))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let D=this.m;if(f&&(D=this.m.notebook.getCellFromApiCell(f)),!D)throw new Error("INVALID cell");return D.handle}y(f){return f.map(D=>{const w=v.$PN.ensureUniqueMimeTypes(D.items,!0);return w===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:w,id:D.id,metadata:D.metadata})})}async z(f,D,w){const S=this.w(D),y=this.y((0,u.$3b)(f));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:S,append:w,outputs:y})}async C(f,D,w){return f=v.$PN.ensureUniqueMimeTypes((0,u.$3b)(f),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:f.map(E.NotebookCellOutputItem.from),outputId:D.id,append:w})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(w){f.j=w,f.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(w){if(f.f===s.Resolved||f.f===s.Started)throw new Error("Cannot call start again");f.f=s.Started,f.c.fire(),f.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,S,y){if(f.f===s.Resolved)throw new Error("Cannot call resolve twice");f.f=s.Resolved,f.c.fire(),f.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;f.n.$completeExecution(f.b,new n.$dw({runEndTime:S,lastRunSuccess:w,error:C}))},clearOutput(w){return f.t(),f.z([],w,!1)},appendOutput(w,S){return f.t(),f.z(w,S,!0)},replaceOutput(w,S){return f.t(),f.z(w,S,!1)},appendOutputItems(w,S){return f.t(),f.C(w,S,!0)},replaceOutputItems(w,S){return f.t(),f.C(w,S,!1)}})}}var g;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(g||(g={}));class d extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(f,D,w){super(),this.h=D,this.j=w,this.b=d.a++,this.c=new P.$7d,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new R.$ee),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(f,D){this.f=f,this.g=D,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new j.$Eh,this.b=Date.now(),(0,j.$ih)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>f.complete())}}function o(h,f){return`${h.value}/${f}`}}),define(Ee[47],Se([1,0,4,6,5,2,20,3,7,226,13,271,22,30,272,56,8,16,33]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=e.$Ajc=e.$zjc=void 0,e.$zjc=(0,R.$hi)("IExtHostTerminalService");class i{constructor(w,S,y,C){this.l=w,this._id=S,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(z,F=!0){O.q(),O.l.$sendText(O._id,z,F)},show(z){O.q(),O.l.$show(O._id,z)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(w,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??S?.cwd??void 0,env:w.env??void 0,icon:o(w.iconPath)??void 0,color:c.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.o(w.location,S?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,S,y,C,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:C,color:c.ThemeColor.isThemeColor(O)?O.id:void 0,location:S?.location||this.o(w,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,S){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in w?{viewColumn:a.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,S){this.h=Object.freeze({code:w,reason:S})}setDimensions(w,S){return w===this.d&&S===this.g||w===0||S===0?!1:(this.d=w,this.g=S,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(S=>{S!==w&&(this.b=Promise.resolve(w))})}}e.$Ajc=i;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new u.$7d,this.onProcessData=this.a.event,this.b=new u.$7d,this.d=new u.$7d,this.onDidChangeProperty=this.d.event,this.f=new u.$7d,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,S){this.g.setDimensions?.({columns:w,rows:S})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$7d,this.onDidCloseTerminal=this.H.event,this.I=new u.$7d,this.onDidOpenTerminal=this.I.event,this.J=new u.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$7d,this.onDidChangeShell=this.N.event,this.O=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(j.$iM.MainThreadTerminalService),this.y=new v.$hub(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:C=>{const O=z=>{const F=z;return this.W(F.instanceId)?.value};switch(C?.$mid){case 15:return O(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=O(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,O]of this.g)O.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,S){const y=new i(this.a,(0,E.$Dg)(),w,w.name),C=new r(w.pty);return y.createExtensionTerminal(w.location,S,this.R(w,S).resolvedExtHostIdentifier,o(w.iconPath),h(w.color)).then(O=>{const z=this.S(O,C);this.h[O]=z}),this.f.push(y),y.value}R(w,S){if(S=S||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const y=w.location.parentTerminal;if(y){const C=this.f.find(O=>O.value===y);C&&(S.resolvedExtHostIdentifier=C._id)}}else w.location&&typeof w.location!="object"?S.location=w.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(w,S){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const C=new r(S),O=this.S(w,C);this.h[w]=O}async $acceptActiveTerminalChanged(w){const S=this.b;if(w===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.W(w);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,S){const y=this.W(w);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(w,S,y){const C=this.W(w);C&&C.setDimensions(S,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(w,S){const y=this.W(w);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(w,S,y){this.g.get(w)?.resize(S,y)}async $acceptTerminalTitleChange(w,S){const y=this.W(w);y&&(y.name=S)}async $acceptTerminalClosed(w,S,y){const C=this.Y(this.f,w);if(C!==null){const O=this.f.splice(C,1)[0];O.setExitStatus(S,y),this.H.fire(O.value)}}$acceptTerminalOpened(w,S,y,C){if(S){const F=this.Y(this.f,S);if(F!==null){this.f[F]._id=w,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const O={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:P.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new i(this.a,w,O,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(w,S){this.W(w)?._setProcessId(S)}async $startExtensionTerminal(w,S){const y=this.W(w);if(!y)return{message:(0,k.localize)(0,null,w)};y.isOpen||await new Promise(O=>{const z=this.onDidOpenTerminal(async F=>{F===y.value&&(z.dispose(),O())})});const C=this.g.get(w);C?C.startSendingEvents(S):this.j[w]={initialDimensions:S}}S(w,S){const y=new p.$Tc;y.add(S.onProcessReady(O=>this.a.$sendProcessReady(w,O.pid,O.cwd,O.windowsPty))),y.add(S.onDidChangeProperty(O=>this.a.$sendProcessProperty(w,O))),this.y.startBuffering(w,S.onProcessData),y.add(S.onProcessExit(O=>this.U(w,O))),this.g.set(w,S);const C=this.j[w];return C&&S instanceof r&&(S.startSendingEvents(C.initialDimensions),delete this.j[w]),y}$acceptProcessAckDataEvent(w,S){this.g.get(w)?.acknowledgeDataEvent(S)}$acceptProcessInput(w,S){this.g.get(w)?.input(S)}$acceptTerminalInteraction(w){const S=this.W(w);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(w,S){this.W(w)?.setSelection(S)}$acceptProcessResize(w,S,y){try{this.g.get(w)?.resize(S,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(w,S){this.g.get(w)?.shutdown(S)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(S=>this.a.$sendProcessProperty(w,{type:"cwd",value:S}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$kM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,w.identifier.value),new $.$kM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(w,S,y){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,y),this.a.$registerQuickFixProvider(w,S),new $.$kM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,S){const y=new b.$ee().token;if(y.isCancellationRequested)return;const C=this.D.get(w);if(!C)return;const O=await C.provideTerminalQuickFixes(S,y);if(O===null||Array.isArray(O)&&O.length===0)return;const z=new p.$Tc;if(this.w.value=z,!Array.isArray(O))return O?a.TerminalQuickFix.from(O,this.Q.converter,z):void 0;const F=[];for(const T of O){const L=a.TerminalQuickFix.from(T,this.Q.converter,z);L&&F.push(L)}return F}async $createContributedProfileTerminal(w,S){const y=new b.$ee().token;let C=await this.C.get(w)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(w,S){const y=this.W(w);if(!y)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const O=new b.$ee;this.G.set(w,O);const z=[],F={terminal:y.value,line:S},T=[];for(const B of this.z)T.push(m.Promises.withAsyncBody(async U=>{O.token.onCancellationRequested(()=>U({provider:B,links:[]}));const Z=await B.provideTerminalLinks(F,O.token)||[];O.token.isCancellationRequested||U({provider:B,links:Z})}));const L=await Promise.all(T);if(O.token.isCancellationRequested)return[];const N=new Map;for(const B of L)B&&B.links.length>0&&z.push(...B.links.map(U=>{const Z={id:s++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return N.set(Z.id,{provider:B.provider,link:U}),Z}));return this.F.set(w,N),z}$activateLink(w,S){const y=this.F.get(w)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(w,S){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const y=this.h[w];y&&(y.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,S)}W(w){return this.X(this.f,w)}X(w,S){const y=this.Y(w,S);return y!==null?w[y]:null}Y(w,S){const y=w.findIndex(C=>C._id===S);return y===-1?null:y}getEnvironmentVariableCollection(w){let S=this.n.get(w.identifier.value);return S||(S=new g,this.$(w.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Z(w,S){const y=(0,I.$6r)(S.map),C=(0,I.$7r)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(w,S.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(w){w.forEach(S=>{const y=S[0],C=new g(S[1]);this.$(y,C)})}$acceptDefaultProfile(w,S){const y=this.s;this.s=w,this.u=S,y?.path!==w.path&&this.N.fire(w.path)}$(w,S){this.n.set(w,S),S.onDidChangeCollection(()=>{this.Z(w,S)})}};e.$Bjc=t,e.$Bjc=t=Je([Ve(1,n.$YO),Ve(2,A.$CO)],t);class g{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$7d,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const S=this.h(w);let y=this.a.get(S);return y||(y=new d(this,w),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(w,S,y,C){this.f(w,{value:S,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(w,S,y,C){this.f(w,{value:S,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(w,S,y,C){this.f(w,{value:S,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(w,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(w,S.scope),C=this.map.get(y),O=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==O.applyAtProcessCreation||C.options?.applyAtShellIntegration!==O.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const z=this.g(w,S.scope),F={variable:w,...S,options:O};this.map.set(z,F),this.d.fire()}}get(w,S){const y=this.g(w,S),C=this.map.get(y);return C?f(C):void 0}g(w,S){const y=this.h(S);return y.length?`${w}:::${y}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const S=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(w)&&S.set(C.variable,f(C));return S}delete(w,S){const y=this.g(w,S);this.map.delete(y),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(S);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,S){const y=this.h(S),C=this.descriptionMap.get(y);if(!C||C.description!==w){let O;typeof w=="string"?O=w:O=w?.value.split(`

`)[0];const z={description:O,scope:S};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(w){const S=this.h(w);return this.descriptionMap.get(S)?.description}k(w){const S=this.h(w);this.descriptionMap.delete(S)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,S){this.b=w,this.d=S,this.a=new u.$7d}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,S,y){this.b.replace(w,S,y,this.d)}append(w,S,y){this.b.append(w,S,y,this.d)}prepend(w,S,y){this.b.prepend(w,S,y,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,S){this.b.getVariableMap(this.d).forEach((y,C)=>w.call(S,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,S){super(!1,w,S)}createTerminal(w,S,y){throw new M.$_}createTerminalFromOptions(w,S){throw new M.$_}};e.$Cjc=l,e.$Cjc=l=Je([Ve(0,n.$YO),Ve(1,A.$CO)],l);function o(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return c.ThemeColor.isThemeColor(D)?D:void 0}function f(D){const w={...D};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Ee[354],Se([1,0,8,21,22,4,74,55,3,18,30,12,6,20,154,16,7,67,112,89,26]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=e.$Gkc=e.$Fkc=void 0;let s=class extends $.$Uc{constructor(F,T,L,N){super(),this.w=N,this.f=this.B(new P.$7d),this.g=new Map,this.s=this.B(new P.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(b.$iM.MainThreadTesting),this.m=new S(this.h),this.j=new l(this.h,T),L.registerArgumentProcessor({processArgument:B=>{switch(B?.$mid){case 16:{const U=B,Z=U.tests[U.tests.length-1].item.extId;return this.g.get(a.$7K.root(Z))?.collection.tree.get(Z)?.actual??(0,v.$OO)(B)}case 18:{const{test:U,message:Z}=B,_=U.item.extId;return{test:this.g.get(a.$7K.root(_))?.collection.tree.get(_)?.actual??(0,v.$OO)({$mid:16,tests:[U]}),message:c.TestMessage.to(Z)}}default:return B}}}),L.registerCommand(!1,"testing.getExplorerSelection",async()=>{const B=await L.executeCommand("_testing.getExplorerSelection"),U=Z=>{const _=this.g.get(a.$7K.root(Z));if(_)return a.$7K.isRoot(Z)?_.controller:_.collection.tree.get(Z)?.actual};return{include:B?.include.map(U).filter(k.$3f)||[],exclude:B?.exclude.map(U).filter(k.$3f)||[]}})}createTestController(F,T,L,N){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const B=new $.$Tc,U=B.add(new v.$RO(T,L,this.w));U.root.label=L;const Z=new Map,_=new Set,Y=this.h,x={items:U.root.children,get label(){return L},set label(X){L=X,U.root.label=X,Y.$updateController(T,{label:L})},get refreshHandler(){return N},set refreshHandler(X){N=X,Y.$updateController(T,{canRefresh:!!X})},get id(){return T},createRunProfile:(X,me,ae,re,W,ie)=>{let ve=(0,p.$8i)(X);for(;Z.has(ve);)ve++;return new C(this.h,Z,_,this.s.event,T,ve,X,me,ae,re,W,ie)},createTestItem(X,me,ae){return new v.$PO(T,X,me,ae)},createTestRun:(X,me,ae=!0)=>this.j.createTestRun(F,T,U,X,me,ae),invalidateTestResults:X=>{if(X===void 0)this.h.$markTestRetired(void 0);else{const me=X instanceof Array?X:[X];this.h.$markTestRetired(me.map(ae=>a.$7K.fromExtHostTestItem(ae,T).toString()))}},set resolveHandler(X){U.resolveHandler=X},get resolveHandler(){return U.resolveHandler},dispose:()=>{B.dispose()}};Y.$registerTestController(T,L,!!N),B.add((0,$.$Sc)(()=>Y.$unregisterTestController(T)));const ce={controller:x,collection:U,profiles:Z,extension:F,activeProfiles:_};return this.g.set(T,ce),B.add((0,$.$Sc)(()=>this.g.delete(T))),B.add(U.onDidGenerateDiff(X=>Y.$publishDiff(T,X.map(i.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(F,T=R.CancellationToken.None){const L=o(F);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(L.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(B=>a.$7K.fromExtHostTestItem(B,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:O[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:F.exclude?.map(B=>B.id)},T)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $provideFileCoverage(F,T,L){return await this.j.getCoverageReport(F,T)?.provideFileCoverage(L)??[]}async $resolveFileCoverage(F,T,L,N){return await this.j.getCoverageReport(F,T)?.resolveFileCoverage(L,N)??[]}$configureRunProfile(F,T){this.g.get(F)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(F){const T=new Map;for(const[L,N]of Object.entries(F)){const B=this.g.get(L);if(!B)continue;const U=new Map,Z=N.filter(Y=>!B.activeProfiles.has(Y)),_=[...B.activeProfiles].filter(Y=>!N.includes(Y));for(const Y of Z)U.set(Y,!0),B.activeProfiles.add(Y);for(const Y of _)U.set(Y,!1),B.activeProfiles.delete(Y);U.size&&T.set(L,U)}this.s.fire(T)}async $refreshTests(F,T){await this.g.get(F)?.controller.refreshHandler?.(T)}$publishTestResults(F){this.results=Object.freeze(F.map(c.TestResults.to).concat(this.results).sort((T,L)=>L.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,T){const L=this.g.get(a.$7K.fromString(F).controllerId)?.collection;L&&(await L.expand(F,T<0?1/0:T),L.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(T=>i.TestsDiffOp.deserialize({asCanonicalUri:L=>L},T)))}async $runControllerTests(F,T){return Promise.all(F.map(L=>this.y(L,!1,T)))}async $startContinuousRun(F,T){const L=new R.$ee(T),N=await Promise.all(F.map(B=>this.y(B,!0,L.token)));return!T.isCancellationRequested&&!N.some(B=>B.error)&&await new Promise(B=>T.onCancellationRequested(B)),L.dispose(!0),N}async y(F,T,L){const N=this.g.get(F.controllerId);if(!N)return{};const{collection:B,profiles:U,extension:Z}=N,_=U.get(F.profileId);if(!_)return{};const Y=F.testIds.map(me=>B.tree.get(me)).filter(k.$3f),x=F.excludeExtIds.map(me=>N.collection.tree.get(me)).filter(k.$3f).filter(me=>Y.some(ae=>ae.fullId.compare(me.fullId)===2));if(!Y.length)return{};const ce=new m.$WN(Y.some(me=>me.actual instanceof v.$QO)?void 0:Y.map(me=>me.actual),x.map(me=>me.actual),_,T),X=(0,i.$0K)(F)&&this.j.prepareForMainThreadTestRun(ce,h.fromInternal(F,N.collection),Z,L);try{return await _.runHandler(ce,L),{}}catch(me){return{error:String(me)}}finally{X&&(X.hasRunningTasks&&!L.isCancellationRequested&&await P.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Fkc=s,e.$Fkc=s=Je([Ve(0,E.$CO),Ve(1,I.$Nj)],s);const t=1e4;var g;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(g||(g={}));class d extends $.$Uc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(F,T,L,N,B){super(),this.s=F,this.w=T,this.y=L,this.z=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$7d),this.m=this.B(new P.$7d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new R.$ee(B));const U=this.B(new u.$th(()=>this.C(),t));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(F){const T=this.s.id,L=this.s.controllerId,N=(0,M.$Dg)(),B=this.y,U=this.m;let Z;const _=X=>(me,...ae)=>{if(x){this.z.warn(`Setting the state of test "${me.id}" is a no-op after the run ends.`);return}this.s.isIncluded(me)&&(this.F(me),X(me,...ae))},Y=(X,me)=>{const ae=me instanceof Array?me.map(c.TestMessage.from):[c.TestMessage.from(me)];if(X.uri&&X.range){const re={range:c.Range.from(X.range),uri:X.uri};for(const W of ae)W.location=W.location||re}this.w.$appendTestMessagesInRun(T,N,a.$7K.fromExtHostTestItem(X,L).toString(),ae)};let x=!1;const ce={isPersisted:this.s.isPersisted,token:this.h.token,name:F,get coverageProvider(){return Z?.provider},set coverageProvider(X){(0,r.$7F)(B,"testCoverage"),Z=X&&new f(X),U.fire({taskId:N,runId:T,coverage:Z})},enqueued:_(X=>{this.w.$updateTestStateInRun(T,N,a.$7K.fromExtHostTestItem(X,L).toString(),1)}),skipped:_(X=>{this.w.$updateTestStateInRun(T,N,a.$7K.fromExtHostTestItem(X,L).toString(),5)}),started:_(X=>{this.w.$updateTestStateInRun(T,N,a.$7K.fromExtHostTestItem(X,L).toString(),2)}),errored:_((X,me,ae)=>{Y(X,me),this.w.$updateTestStateInRun(T,N,a.$7K.fromExtHostTestItem(X,L).toString(),6,ae)}),failed:_((X,me,ae)=>{Y(X,me),this.w.$updateTestStateInRun(T,N,a.$7K.fromExtHostTestItem(X,L).toString(),4,ae)}),passed:_((X,me)=>{this.w.$updateTestStateInRun(T,N,a.$7K.fromExtHostTestItem(X,this.s.controllerId).toString(),3,me)}),appendOutput:(X,me,ae)=>{x||(ae&&(this.s.isIncluded(ae)?this.F(ae):ae=void 0),this.w.$appendOutputToRun(T,N,j.$ue.fromString(X),me&&c.location.from(me),ae&&a.$7K.fromExtHostTestItem(ae,L).toString()))},end:()=>{x||(x=!0,this.w.$finishedTestRunTask(T,N),this.f.delete(N),this.f.size||this.D())}};return this.f.set(N,{run:ce}),this.w.$startedTestRunTask(T,{id:N,name:F,running:!0}),ce}C(){for(const{run:F}of this.f.values())F.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(F){if(!(F instanceof v.$PO))throw new n.$uO(F.id);if(this.g.has(a.$7K.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const T=[],L=this.s.colllection.root;for(;;){const N=c.TestItem.from(F);if(T.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),F===L))break;F=F.parent||L}this.w.$addTestsToRun(this.s.controllerId,this.s.id,T)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(F,T){this.g=F,this.h=T,this.c=new Map,this.f=[]}getCoverageReport(F,T){return this.f.find(L=>L.runId===F)?.coverage.get(T)}prepareForMainThreadTestRun(F,T,L,N){return this.j(F,T,L,N)}cancelRunById(F){for(const T of this.c.values())if(T.id===F){T.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,T,L,N,B,U){const Z=this.c.get(N);if(Z)return Z.createRun(B);const _=h.fromPublic(T,L,N,U),Y=o(N);this.g.$startedExtensionTestRun({controllerId:T,continuous:!!N.continuous,profile:Y&&{group:O[Y.kind],id:Y.profileId},exclude:N.exclude?.map(ce=>a.$7K.fromExtHostTestItem(ce,L.root.id).toString())??[],id:_.id,include:N.include?.map(ce=>a.$7K.fromExtHostTestItem(ce,L.root.id).toString())??[L.root.id],persist:U});const x=this.j(N,_,F);return P.Event.once(x.onEnd)(()=>{this.g.$finishedExtensionTestRun(_.id),x.dispose()}),x.createRun(B)}j(F,T,L,N){const B=new d(T,this.g,L,this.h,N);this.c.set(F,B);let U;const Z=B.onDidCoverage(({runId:_,taskId:Y,coverage:x})=>{U||(U={runId:_,coverage:new Map},this.f.unshift(U),this.f.length>i.$cL&&this.f.pop()),U.coverage.set(Y,x),this.g.$signalCoverageAvailable(_,Y,!!x)});return P.Event.once(B.onEnd)(()=>{this.c.delete(F),Z.dispose()}),B}}e.$Gkc=l;const o=z=>{if(z.profile){if(!(z.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class h{static fromPublic(F,T,L,N){return new h(F,(0,M.$Dg)(),L.include?.map(B=>a.$7K.fromExtHostTestItem(B,F).toString())??[F],L.exclude?.map(B=>a.$7K.fromExtHostTestItem(B,F).toString())??[],N,T)}static fromInternal(F,T){return new h(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,T)}constructor(F,T,L,N,B,U){this.controllerId=F,this.id=T,this.isPersisted=B,this.colllection=U,this.c=L.map(Z=>Z+"\0"),this.f=N.map(Z=>Z+"\0")}isIncluded(F){const T=a.$7K.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const L of this.f)if(T===L||T.startsWith(L))return!1;for(const L of this.c)if(T===L||T.startsWith(L))return!0;return!1}}e.$Hkc=h;class f{constructor(F){this.provider=F}async provideFileCoverage(F){this.c||(this.c=(async()=>this.provider.provideFileCoverage(F))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(T){throw this.c=void 0,T}}async resolveFileCoverage(F,T){const L=await this.c;let N=L?.[F];return!this.provider||!L||!N?[]:(N.detailedCoverage||(N=L[F]=await this.provider.resolveFileCoverage?.(N,T)??N),N.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,c.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const T=a.$7K.parentId(F.item.extId);if(T&&this.h.has(T.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:T,g:L}=this;return{get added(){return[...F].map(N=>N.revived)},get updated(){return[...T].map(N=>N.revived)},get removed(){return[...L].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends i.$dL{constructor(){super(...arguments),this.s=new P.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,T){return{...F,revived:c.TestItem.toPlain(F.item),depth:T?T.depth+1:0,children:new Set}}v(){return new D(this.s)}}class S{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(T=>T.revived)},dispose:(0,A.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new w({asCanonicalUri:T=>T});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const y=(z,F,T,L)=>{T?Object.assign(T,L):F.$updateTestRunConfig(z.controllerId,z.profileId,L)};class C{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,y(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,y(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),y(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,y(this,this.#e,this.#n,{tag:F?c.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,y(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return P.Event.chain(this.#i,F=>F.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(k.$3f))}constructor(F,T,L,N,B,U,Z,_,Y,x=!1,ce=void 0,X=!1){this.controllerId=B,this.profileId=U,this.f=Z,this.kind=_,this.runHandler=Y,this._tag=ce,this.g=X,this.#e=F,this.#s=T,this.#t=L,this.#i=N,T.set(U,this);const me=O[_];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);x&&L.add(U),this.#n={profileId:U,controllerId:B,tag:ce?c.TestTag.namespace(this.controllerId,ce.id):null,label:Z,group:me,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:X},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ikc=C;const O={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(Ee[155],Se([1,0,61,13,124,16,7]),function(de,e,u,j,R,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=void 0;class p{static{this.c=new R.$HO("TextEditorDecorationType")}constructor(b,E,v){const c=p.c.nextId();b.$registerTextEditorDecorationType(E.identifier,c,P.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:c,dispose(){b.$removeTextEditorDecorationType(c)}})}}e.$JO=p;class ${constructor(b,E){this.g=[],this.h=void 0,this.j=!1,this.c=b,this.d=b.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(b,E){this.k();let v=null;if(b instanceof A.$lM)v=new A.$mM(b,b);else if(b instanceof A.$mM)v=b;else throw new Error("Unrecognized location");this.l(v,E,!1)}insert(b,E){this.k(),this.l(new A.$mM(b,b),E,!0)}delete(b){this.k();let E=null;if(b instanceof A.$mM)E=b;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(b,E,v){const c=this.c.validateRange(b);this.g.push({range:c,text:E,forceMoveMarkers:v})}setEndOfLine(b){if(this.k(),b!==A.EndOfLine.LF&&b!==A.EndOfLine.CRLF)throw(0,j.$7)("endOfLine");this.h=b}}class k{constructor(b,E,v,c){this.c=b,this.d=E,this._accept(v),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(a){m.n(a)},get indentSize(){return m.g},set indentSize(a){m.p(a)},get insertSpaces(){return m.j},set insertSpaces(a){m.s(a)},get cursorStyle(){return m.k},set cursorStyle(a){m.t(a)},get lineNumbers(){return m.l},set lineNumbers(a){m.u(a)}}}_accept(b){this.f=b.tabSize,this.g=b.indentSize,this.h=b.originalIndentSize,this.j=b.insertSpaces,this.k=b.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(b.lineNumbers)}m(b){if(b==="auto")return"auto";if(typeof b=="number"){const E=Math.floor(b);return E>0?E:null}if(typeof b=="string"){const E=parseInt(b,10);return isNaN(E)?null:E>0?E:null}return null}n(b){const E=this.m(b);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const E=Math.floor(b);return E>0?E:null}if(typeof b=="string"){const E=parseInt(b,10);return isNaN(E)?null:E>0?E:null}return null}p(b){const E=this.o(b);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(b){return b==="auto"?"auto":b==="false"?!1:!!b}s(b){const E=this.q(b);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(b){this.k!==b&&(this.k=b,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:b})))}u(b){this.l!==b&&(this.l=b,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(b)})))}assign(b){const E={};let v=!1;if(typeof b.tabSize<"u"){const c=this.m(b.tabSize);c==="auto"?(v=!0,E.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,v=!0,E.tabSize=c)}if(typeof b.indentSize<"u"){const c=this.o(b.indentSize);c==="tabSize"?(v=!0,E.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,v=!0,E.indentSize=c)}if(typeof b.insertSpaces<"u"){const c=this.q(b.insertSpaces);c==="auto"?(v=!0,E.insertSpaces=c):this.j!==c&&(this.j=c,v=!0,E.insertSpaces=c)}typeof b.cursorStyle<"u"&&this.k!==b.cursorStyle&&(this.k=b.cursorStyle,v=!0,E.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this.l!==b.lineNumbers&&(this.l=b.lineNumbers,v=!0,E.lineNumbers=P.TextEditorLineNumbersStyle.from(b.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(b,E){E.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this.e.warn(v)})}}e.$KO=k;class M{constructor(b,E,v,c,m,a,n,i){this.id=b,this.j=E,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new k(this.j,this.id,a,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return c.value},set document(s){throw new j.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof A.$nM))throw(0,j.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof A.$nM)))throw(0,j.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new j.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new j.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(c.value,t);return s(g),r.m(g)},insertSnippet(s,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>P.Range.from(l));else if(t instanceof A.$lM){const{lineNumber:l,column:o}=P.Position.from(t);d=[{startLineNumber:l,startColumn:o,endLineNumber:l,endColumn:o}]}else if(t instanceof A.$mM)d=[P.Range.from(t)];else{d=[];for(const l of t)if(l instanceof A.$mM)d.push(P.Range.from(l));else{const{lineNumber:o,column:h}=P.Position.from(l);d.push({startLineNumber:o,startColumn:h,endLineNumber:o,endColumn:h})}}return E.$tryInsertSnippet(b,c.value.version,s.value,d,g)},setDecorations(s,t){const g=t.length===0;g&&!r.h.has(s.key)||(g?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(P.$zO(t))return E.$trySetDecorations(b,s.key,P.$AO(t));{const d=new Array(4*t.length);for(let l=0,o=t.length;l<o;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return E.$trySetDecorationsFast(b,s.key,d)}}))},revealRange(s,t){r.n(()=>E.$tryRevealRange(b,P.Range.from(s),t||A.TextEditorRevealType.Default))},show(s){E.$tryShowEditor(b,P.ViewColumn.from(s))},hide(){E.$tryHideEditor(b)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(b){(0,u.ok)(!this.g),this.d._accept(b)}_acceptVisibleRanges(b){(0,u.ok)(!this.g),this.e=b}_acceptViewColumn(b){(0,u.ok)(!this.g),this.f=b}_acceptSelections(b){(0,u.ok)(!this.g),this.c=b}async l(){const b=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,b)),this.value}m(b){const E=b.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(m=>m.range);v.sort((m,a)=>m.end.line===a.end.line?m.end.character===a.end.character?m.start.line===a.start.line?m.start.character-a.start.character:m.start.line-a.start.line:m.end.character-a.end.character:m.end.line-a.end.line);for(let m=0,a=v.length-1;m<a;m++){const n=v[m].end;if(v[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=E.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,c,{setEndOfLine:typeof E.setEndOfLine=="number"?P.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(b){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$LO=M}),define(Ee[72],Se([1,0,61,4,3,2,5,6,152,20,155,16,12,28,15,38,45]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;class a{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new j.$7d,this.e=new j.$7d,this.f=new j.$7d,this.g=new j.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],g=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=P.URI.revive(d),o=this.c.get(l);o?.unref()&&(this.c.delete(l),s.push(o.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=P.URI.revive(d.uri);let o=this.c.get(l);if(o&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);o||(o=new a(new $.$FO(this.h.getProxy(p.$iM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,o),t.push(o.value)),o.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&g.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=P.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const o=this.c.get(l).value,h=new M.$LO(d.id,this.h.getProxy(p.$iM.MainThreadTextEditors),this.i,new m.$V(()=>o.document),d.selections.map(I.Selection.to),d.options,d.visibleRanges.map(f=>I.Range.to(f)),typeof d.editorPosition=="number"?I.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,R.$Pc)(s),(0,R.$Pc)(g),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return c.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$MO=n,e.$MO=n=Je([Ve(0,k.$CO),Ve(1,b.$Nj)],n),e.$NO=(0,A.$hi)("IExtHostDocumentsAndEditors")}),define(Ee[355],Se([1,0,19,4,6,155,16,7]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;class ${constructor(M,I){this.i=I,this.a=new j.$7d,this.b=new j.$7d,this.c=new j.$7d,this.d=new j.$7d,this.f=new j.$7d,this.g=new j.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(R.$iM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const I=this.i.allEditors();return M?I:I.map(b=>b.value)}async showTextDocument(M,I,b){let E;typeof I=="number"?E={position:A.ViewColumn.from(I),preserveFocus:b}:typeof I=="object"?E={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:E={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(M.uri,E),c=v&&this.i.getEditor(v);if(c)return c.value;throw v?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,I){return new P.$JO(this.h,M,I).value}$acceptEditorPropertiesChanged(M,I){const b=this.i.getEditor(M);if(!b)throw new Error("unknown text editor");if(I.options&&b._acceptOptions(I.options),I.selections){const E=I.selections.selections.map(A.Selection.to);b._acceptSelections(E)}if(I.visibleRanges){const E=u.$Hb(I.visibleRanges.map(A.Range.to));b._acceptVisibleRanges(E)}if(I.options&&this.b.fire({textEditor:b.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const E=p.TextEditorSelectionChangeKind.fromValue(I.selections.source),v=I.selections.selections.map(A.Selection.to);this.a.fire({textEditor:b.value,selections:v,kind:E})}if(I.visibleRanges){const E=u.$Hb(I.visibleRanges.map(A.Range.to));this.c.fire({textEditor:b.value,visibleRanges:E})}}$acceptEditorPositionData(M){for(const I in M){const b=this.i.getEditor(I);if(!b)throw new Error("Unknown text editor");const E=A.ViewColumn.to(M[I]);b.value.viewColumn!==E&&(b._acceptViewColumn(E),this.d.fire({textEditor:b.value,viewColumn:E}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$5ic=$}),define(Ee[356],Se([1,0,2,5,6,3,7,16,25,18]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0,e.$Kkc=(0,j.$hi)("IExtHostTimeline");class M{constructor(E,v){this.b=new Map,this.c=new Map,this.a=E.getProxy(R.$iM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(c,m)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&$.$Cm.equals(m,this.b.get(c.source)?.extension)){const a=c.uri===void 0?void 0:u.URI.revive(c.uri);return this.c.get(c.source)?.get(I(a))?.get(c.handle)}else return;return c}})}async $getTimeline(E,v,c,m){return this.b.get(E)?.provider.provideTimeline(u.URI.revive(v),c,m)}registerTimelineProvider(E,v,c,m){const a=new P.$Tc,n=this.d(v.id,m,a).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const r=this.c;return this.f({...v,scheme:E,onDidChange:void 0,async provideTimeline(s,t,g){t?.resetCache&&(a.clear(),r.get(v.id)?.clear());const d=await v.provideTimeline(s,t,g);if(d==null)return;const l=n(s,t);return{...d,source:v.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(v.id)?.clear();i?.dispose(),a.dispose()}},c)}d(E,v,c){return(m,a)=>{let n;if(a?.cacheResults){let i=this.c.get(E);i===void 0&&(i=new Map,this.c.set(E,i));const r=I(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${E}|${i.id??i.timestamp}`;n?.set(t,i);let g,d,l;i.iconPath&&(r instanceof A.$gN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(g=r,d=r):{light:g,dark:d}=r);let o;return A.$LM.isMarkdownString(s.tooltip)?o=p.MarkdownString.from(s.tooltip):(0,k.$Uf)(s.tooltip)?o=s.tooltip:A.$LM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=p.MarkdownString.from(s.detail)):(0,k.$Uf)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=s.detail),{...s,id:s.id??void 0,handle:t,source:E,command:i.command?v.toInternal(i.command,c):void 0,icon:g,iconDark:d,themeIcon:l,tooltip:o,accessibilityInformation:i.accessibilityInformation}}}}f(E,v){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:v}),(0,P.$Sc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$Lkc=M;function I(b){return b?.toString()}}),define(Ee[357],Se([1,0,227,23,2,4,3,287,8,7,18,19,16,80,22,183,26]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;function a(r,s){if((0,M.$Uf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends A.$Uc{constructor(s,t,g){super(),this.f=s,this.g=t,this.h=g,this.a=new Map,this.b=new c.$Y9;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(o=>d(o)?this.r(o):o):l})}registerTreeDataProvider(s,t,g){const d=this.createTreeView(s,{treeDataProvider:t},g);return{dispose:()=>d.dispose()}}createTreeView(s,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],o=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,f=this.m(s,t,g),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:o,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(s,D),S={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,m.$7F)(g,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,m.$7F)(g,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(y){(0,E.$Gk)(y)&&(0,m.$7F)(g,"treeViewMarkdownMessage"),f.message=y},get title(){return f.title},set title(y){f.title=y},get description(){return f.description},set description(y){f.description=y},get badge(){return f.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?f.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(f.badge=void 0)},reveal:(y,C)=>f.reveal(y,C),dispose:async()=>{await w,this.a.delete(s),f.dispose()}};return this.B(S),S}$getChildren(s,t){const g=this.a.get(s);return g?g.getChildren(t):Promise.reject(new p.$yF(s))}async $handleDrop(s,t,g,d,l,o,h,f){const D=this.a.get(s);if(!D)return Promise.reject(new p.$yF(s));const w=b.DataTransfer.toDataTransfer(g,async S=>(await this.f.$resolveDropFileData(s,t,S)).buffer);return h===s&&f&&await this.j(w,D,f,l,o),D.onDrop(w,d,l)}async j(s,t,g,d,l){const o=this.b.removeDragOperationTransfer(l);if(o)(await o)?.forEach((h,f)=>{h&&s.set(f,h)});else if(l&&t.handleDrag){const h=t.handleDrag(g,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,g,d){const l=this.a.get(s);if(!l)return Promise.reject(new p.$yF(s));const o=await this.j(new k.$cN,l,t,d,g);if(!(!o||d.isCancellationRequested))return b.DataTransfer.from(o)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new p.$yF(s);return t.hasResolve}$resolve(s,t,g){const d=this.a.get(s);if(!d)throw new p.$yF(s);return d.resolveTreeItem(t,g)}$setExpanded(s,t,g){const d=this.a.get(s);if(!d)throw new p.$yF(s);d.setExpanded(t,g)}$setSelectionAndFocus(s,t,g){const d=this.a.get(s);if(!d)throw new p.$yF(s);d.setSelectionAndFocus(t,g)}$setVisible(s,t){const g=this.a.get(s);if(!g){if(!t)return;throw new p.$yF(s)}g.setVisible(t)}$changeCheckboxState(s,t){const g=this.a.get(s);if(!g)throw new p.$yF(s);g.setCheckboxState(t)}m(s,t,g){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,g));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$Mkc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,M.$4f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,g,d,l,o){if(super(),this.I=s,this.J=g,this.L=d,this.M=l,this.N=o,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$ee,o.contributes&&o.contributes.views)for(const w in o.contributes.views)for(const S of o.contributes.views[w])S.id===s&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,f;const D=P.Event.debounce(this.F.event,(w,S)=>(w||(w={message:!1,elements:[]}),S.element!==!1&&(h||(h=new Promise(y=>f=y),this.G=this.G.then(()=>h)),Array.isArray(S.element)?w.elements.push(...S.element):w.elements.push(S.element)),S.message&&(w.message=!0),w),200,!0);this.B(D(({message:w,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=f;return h=null,this.$(S).then(()=>y())})),w&&this.J.$setMessage(this.I,b.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let g=this.X(s);return g||(g=await this.Y(t)),g?g.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const g=(0,M.$4f)(t.select)?!0:t.select,d=(0,M.$4f)(t.focus)?!1:t.focus,l=(0,M.$4f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(o=>this.W(s,o[o.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:o.map(f=>f.item)},{select:g,focus:d,expand:l})),o=>this.M.error(o)):this.J.$reveal(this.I,void 0,{select:g,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=b.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const g=this.getExtensionElement(s);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(s,t){const g=!(0,I.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async g=>{const d=this.getExtensionElement(g.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:g.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(s,t,g){const d=[];for(const l of s){const o=this.getExtensionElement(l);o&&d.push(o)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,g){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$_g)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(s);if(g){const d=this.m.get(g);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,g,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(d=>(g.push(d),g))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$_g)(()=>this.f.getParent(s))}W(s,t){const g=this.m.get(s);return g?Promise.resolve(g):(0,$.$_g)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const o=this.m.get(l);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const g=this.getExtensionElement(s);t=g?this.m.get(g):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$ee(this.Z.token);try{const g=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,I.$Hb)(d||[]),o=await Promise.all((0,I.$Hb)(l).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const h=o.map((f,D)=>f?this.db(l[D],f,g):null);return(0,I.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(g=>!g))return this.Z.dispose(!0),this.Z=new v.$ee,this.tb(),this.J.$refresh(this.I);{const g=this.ab(s);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(s){const t=new Set,g=s.map(l=>this.m.get(l));for(const l of g)if(l&&!t.has(l.item.handle)){let o=l;for(;o&&o.parent&&g.findIndex(h=>o&&o.parent&&h&&h.item.handle===o.parent.item.handle)===-1;){const h=this.j.get(o.parent.item.handle);o=h?this.m.get(h):void 0}o&&!o.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const o=this.j.get(l);if(o){const h=this.m.get(o);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(g=>this.cb(g).then(d=>{d&&(t[g]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,$.$_g)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,g.parent);return this.pb(t,l,g,g.parent),g.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,g){const d=this.ib(s,t,g);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,g),d}eb(s){return k.$LM.isMarkdownString(s)?b.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,g,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,g=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:d}}hb(s){if(!k.$0M.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,g){this.hb(t);const d=this.B(new A.$Tc),l=this.kb(s,t,g),o=this.lb(t);return{item:{handle:l,parentHandle:g?g.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:o,iconDark:this.mb(t)||o,themeIcon:this.jb(t),collapsibleState:(0,M.$4f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof k.$gN?s.iconPath:void 0}kb(s,{id:t,label:g,resourceUri:d},l,o){if(t)return`${i.b}/${t}`;const h=a(g,this.N),f=l?l.item.handle:i.a;let D=h?h.label:d?(0,j.$Rg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const w=this.m.has(s)?this.m.get(s).item.handle:void 0,S=this.X(l)||[];let y,C=0;do{if(y=`${f}/${C}:${D}`,o||!this.j.has(y)||w===y)break;C++}while(C<=S.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof k.$gN))return typeof s.iconPath=="string"||R.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof k.$gN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return R.URI.isUri(s)?s:R.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,g,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(s,t);const l=this.X(d)||[],o=l.filter(h=>h.item.handle===g.item.handle)[0];o&&l.splice(l.indexOf(o),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const g of t.children){const d=this.j.get(g.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const g of t.children){const d=this.j.get(g.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[358],Se([1,0,4,3,2,30,16,92,6,7]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class M extends j.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,c,m,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$7d),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=c,this.#n=m,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,R.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:A.ViewColumn.from(v),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends j.$Uc{static c(){return(0,P.$Dg)()}constructor(v,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$iM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,c,m,a,n={}){const i=typeof a=="object"?a.viewColumn:a,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},s=(0,p.$hjc)(v),t=I.c();this.f.$createWebviewPanel((0,p.$jjc)(v),t,c,{title:m,panelOptions:b(n),webviewOptions:(0,p.$kjc)(v,this.m,n),serializeBuffersForPostMessage:s},r);const g=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,c,m,i,n,g,!0)}$onDidChangeWebviewPanelViewStates(v){const c=Object.keys(v);c.sort((m,a)=>{const n=v[m],i=v[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of c){const a=this.getWebviewPanel(m);if(!a)continue;const n=v[m];a._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:v}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,p.$hjc)(v)}),new k.$kM(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(v,c,m,a){const n=this.h.get(c);if(!n)throw new Error(`No serializer found for '${c}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(v,m.webviewOptions,r),t=this.createNewWebviewPanel(v,c,m.title,a,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(v,c,m,a,n,i,r){const s=new M(v,this.f,i,{viewType:c,title:m,viewColumn:a,panelOptions:n,active:r});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$ljc=I;function b(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ee[359],Se([1,0,4,3,92,16,6,7]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class $ extends j.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,b,E,v,c,m){super(),this.#s=!1,this.#u=this.B(new u.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$7d),this.onDidDispose=this.#l.event,this.#i=E,this.#a=v,this.#e=I,this.#t=b,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(I,b){this.d=b,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$iM.MainThreadWebviewViews)}registerWebviewViewProvider(I,b,E,v){if(this.b.has(b))throw new Error(`View provider for '${b}' already registered`);return this.b.set(b,{provider:E,extension:I}),this.a.$registerWebviewViewProvider((0,R.$jjc)(I),b,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$hjc)(I)}),new p.$kM(()=>{this.b.delete(b),this.a.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(I,b,E,v,c){const m=this.b.get(b);if(!m)throw new Error(`No view provider found for '${b}'`);const{provider:a,extension:n}=m,i=this.d.createNewWebview(I,{},n),r=new $(I,this.a,b,E,i,!0);this.c.set(I,r),await a.resolveWebviewView(r,{state:v},c)}async $onDidChangeWebviewViewVisibility(I,b){this.e(I)._setVisible(b)}async $disposeWebviewView(I){const b=this.e(I);this.c.delete(I),b.dispose(),this.d.deleteWebview(I)}e(I){const b=this.c.get(I);if(!b)throw new Error("No webview found");return b}}e.$Pkc=k}),define(Ee[360],Se([1,0,69,15,12,258,32,11]),function(de,e,u,j,R,P,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;let $=class{constructor(I,b){I.addFileSystemProvider(j.Schemas.file,new k(b),{isCaseSensitive:p.$k})}};e.$ulc=$,e.$ulc=$=Je([Ve(0,u.$djc),Ve(1,R.$Nj)],$);class k{constructor(I){this.b=I,this.a=new P.$Uq(this.b)}async stat(I){const b=await this.a.stat(I);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,b,E){return this.a.writeFile(I,b,{...E,unlock:!1,atomic:!1})}delete(I,b){return this.a.delete(I,{...b,useTrash:!1,atomic:!1})}rename(I,b,E){return this.a.rename(I,b,E)}copy(I,b,E){return this.a.copy(I,b,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,b){throw new Error("Method not implemented.")}}}),define(Ee[361],Se([1,0,17,63,30,33,3,6,2,20]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;let M=class extends A.$Uc{constructor(b,E){super();const v=b.getProxy(p.$iM.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=$.URI.file((0,u.$kc)((0,j.tmpdir)(),(0,R.$Dg)()));return await v.$download(c,m),m})}};e.$slc=M,e.$slc=M=Je([Ve(0,k.$CO),Ve(1,P.$YO)],M)}),define(Ee[362],Se([1,0,51,17,2,93,3,15,8,31]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class M extends P.$fjc{constructor(){super(...arguments),this.i=null}async g(t){const g=await super.g(t);if(g.scheme!==p.Schemas.file)return g;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${g.fsPath}.`),g;const d=g.fsPath;let l=0;do{let o;l===0?o=d:o=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await I(o);const h=j.$kc(o,"vscode.lock"),f=await c(this.d,h,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),R.URI.file(o);l++}while(l<10);return g}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Elc=M;async function I(s){try{await k.Promises.stat(s);return}catch{}try{await k.Promises.mkdir(s,{recursive:!0})}catch{}}const b=1e3,E=10*60*1e3;class v extends A.$Uc{constructor(t,g){super(),this.b=t,this.c=g,this.a=this.B(new $.$sh),this.a.cancelAndSet(async()=>{const d=await m(t,g);(!d||d.pid!==process.pid)&&(t.info(`Lock '${g}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(g,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${g}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const g={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(g),{flag:"w"})}catch(g){this.b.error(g)}}}async function c(s,t,g){try{const l={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await m(s,t);return!d||d.pid!==process.pid?g?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function m(s,t){let g;try{g=await k.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(g))}catch(d){return s.error(d),null}}async function a(s,t){let g;try{g=await k.Promises.stat(t)}catch(d){return s.error(d),0}return g.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const g=await m(s,t);if(!g)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(g.willReleaseAt){let f=g.willReleaseAt-Date.now();if(f<5e3){for(f>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,$.$ih)(Math.min(100,f)),await a(s,t)===0)return r(s,t);f=g.willReleaseAt-Date.now()}return r(s,t)}}if(!n(g.pid))return s.info(`Lock '${t}': The pid ${g.pid} appears to be gone.`),r(s,t);const d=await a(s,t),l=Date.now()-d;if(l<=E)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$ih)(2e3);const o=await a(s,t),h=Date.now()-o;return h<=E?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return c(s,t,!0)}}),define(Ee[363],Se([1,0,30,20,47,33]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=void 0;let A=class extends R.$Bjc{constructor($,k){super(!0,$,k)}createTerminal($,k,M){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:M})}createTerminalFromOptions($,k){const M=new R.$Ajc(this.a,(0,u.$Dg)(),$,$.name);return this.f.push(M),M.create($,this.R($,k)),M.value}};e.$Zkc=A,e.$Zkc=A=Je([Ve(0,P.$YO),Ve(1,j.$CO)],A)}),define(Ee[364],Se([1,0,4,37,41,5]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.OutputChannelUpdateMode=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=void 0,e.$qL="text/x-code-output",e.$rL="output",e.$sL="Log",e.$tL="text/x-code-log-output",e.$uL="log",e.$vL="workbench.panel.output",e.$wL=new R.$yj("inOutput",!1),e.$xL=new R.$yj("activeLogOutput",!1),e.$yL=new R.$yj("activeLogOutput.levelSettable",!1),e.$zL=new R.$yj("activeLogOutput.level",""),e.$AL=new R.$yj("activeLogOutput.levelIsDefault",!1),e.$BL=new R.$yj("outputView.scrollLock",!1),e.$CL=(0,P.$hi)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$DL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new u.$7d,this.onDidRegisterChannel=this.b.event,this.c=new u.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(M=>k.push(M)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}j.$Zn.add(e.$DL.OutputChannels,new p),e.$EL=new R.$yj("activeOutputChannel","")}),define(Ee[156],Se([1,0,6,5,20,25,12,364,69,27,59,188,21,18,32,4,3]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0;class a extends A.$Tj{get disposed(){return this.n}constructor(s,t,g,d,l){super(),this.id=s,this.name=t,this.r=g,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=b.$ue.fromString(t).byteLength,(0,A.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(s){this.append(s)}}let i=class{constructor(s,t,g,d,l,o){this.i=t,this.j=g,this.k=d,this.l=l,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$iM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(s,t,g){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,E.$Uf)(t)?t:void 0;if((0,E.$Uf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const h=this.i.environment.extensionLogLevel?.find(([D])=>P.$Cm.equals(g.identifier,D))?.[1];h&&(o=(0,A.$5j)(h));const f=d?this.o(s,o,g):this.n(s,l,g);return f.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(s,o??this.m.getLevel(),f):this.q(s,f)}async n(s,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,g.identifier.value);return new a(h,s,o,this.a,g)}async o(s,t,g){const d=await this.p(g),l=s.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(d,`${l}.log`),h=`${g.identifier.value}.${l}`,f=this.l.createLogger(o,{id:h,name:s,logLevel:t,extensionId:g.identifier.value});return new n(h,s,f,this.a,g)}p(s){let t=this.d.get(s.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(d){if((0,v.$4k)(d)!==v.FileSystemProviderErrorCode.FileExists)throw d}return g})())}return t}q(s,t){let g=!1;const d=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(o=>o.append(l))},appendLine(l){d(),t.then(o=>o.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(o=>o.replace(l))},show(l,o){d(),t.then(h=>h.show(l,o))},hide(){d(),t.then(l=>l.hide())},dispose(){g=!0,t.then(l=>l.dispose())}}}r(s,t,g){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},o=d.add(new c.$7d);function h(f){t=f,o.fire(f)}return g.then(f=>{d.add(f),f.logLevel!==t&&h(f.logLevel),d.add(f.onDidChangeLogLevel(D=>h(D)))}),{...this.q(s,g),get logLevel(){return t},onDidChangeLogLevel:o.event,trace(f,...D){l(),g.then(w=>w.trace(f,...D))},debug(f,...D){l(),g.then(w=>w.debug(f,...D))},info(f,...D){l(),g.then(w=>w.info(f,...D))},warn(f,...D){l(),g.then(w=>w.warn(f,...D))},error(f,...D){l(),g.then(w=>w.error(f,...D))},dispose(){d.dispose()}}}};e.$qkc=i,e.$qkc=i=Je([Ve(0,R.$CO),Ve(1,k.$SO),Ve(2,$.$djc),Ve(3,M.$Pic),Ve(4,A.$Oj),Ve(5,A.$Nj)],i),e.$rkc=(0,j.$hi)("IExtHostOutputService")}),define(Ee[157],Se([1,0,5,8]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$4m=(0,u.$hi)("remoteAgentService"),e.$5m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let P=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await R.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,j.$ih)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[365],Se([1,0,231,85,37,42,53,3,4,157,11,24,8]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=void 0,e.$VI=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$WI=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$XI=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$YI=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$ZI={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new $.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new E;R.$Zn.add(e.$ZI.ConfigurationMigration,v);let c=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,g]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const o=await this.h(n,t,d.value,i,void 0);for(const h of o??[])l.push([h,[]])}for(const{identifiers:o,value:h}of d.overrides??[])if(h!==void 0){const f=await this.h(n,t,h,i,o);for(const D of f??[])l.push([D,o])}l.length&&await Promise.allSettled(l.map(async([[o,h],f])=>this.a.updateValue(o,h.value,{resource:i,overrideIdentifiers:f},g)))}}async h(n,i,r,s,t){const g=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:f})=>(0,I.$Rn)(f,t))?.value:h.value},d=await n.migrateFn(r,g);return Array.isArray(d)?d:[[n.key,d]]}};e.$1I=c,e.$1I=c=Je([Ve(0,A.$Ni),Ve(1,P.$qi)],c);let m=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new b.$Eh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!M.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$Zn.as(j.$5n.Configuration).registerConfiguration({...e.$XI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$2I=m,e.$2I=m=Je([Ve(0,k.$4m)],m)}),define(Ee[366],Se([1,0,35,15,17,23,240,365,85,5,37]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$mfb=e.$lfb=void 0,e.$nfb=c,e.$ofb=m,e.$lfb=(0,k.$hi)("editorResolverService"),e.$mfb="workbench.editorAssociations";const I=M.$Zn.as($.$5n.Configuration),b={...p.$WI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(b);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var v;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function c(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function m(a,n){if(new Set([j.Schemas.extension,j.Schemas.webviewPanel,j.Schemas.vscodeWorkspaceTrust,j.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof a=="string"&&a.indexOf(R.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,P.$Rg)(n);return u.$ak(typeof a=="string"?a.toLowerCase():a,s.toLowerCase())}}),define(Ee[367],Se([1,0,34,15,17,11,23,2,5,276,42,147,157]),function(de,e,u,j,R,P,A,p,$,k,M,I,b){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0,e.$WL=(0,$.$hi)("pathService");let v=E=class{constructor(m,a,n,i){this.d=m,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(m,i,a)):this.h(m,a,n)}h(m,a,n){return m.scheme===j.Schemas.file||m.scheme===j.Schemas.vscodeRemote?(0,u.$fg)(n??(0,A.$Rg)(m),a===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return j.Schemas.vscodeRemote;const n=(0,k.$TL)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=a.getWorkspace().configuration;return r?r.scheme:j.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?R.$gc:R.$hc)}async fileURI(m){let a="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(a=m.substring(2),m="/"):(a=m.substring(2,i),m=m.substring(i)||"/")}return p.URI.from({scheme:j.Schemas.file,authority:a,path:m,query:"",fragment:""})}};e.$XL=v,e.$XL=v=E=Je([Ve(1,b.$4m),Ve(2,I.$FL),Ve(3,M.$qi)],v)}),define(Ee[368],Se([1,0,242,19,54,4,55,3,2,53,247,12,65,278,88,42,147,26,22,18,24,41]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.OnPortForward=e.$KL=e.$JL=e.TunnelSource=e.TunnelCloseReason=e.$HL=e.$GL=void 0,e.$IL=o,e.$LL=D,e.$ML=w,e.$NL=S,e.$OL=C;const t=10*1e3,g="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$GL="onTunnel",e.$HL=new s.$yj("forwardedPortsViewEnabled",!1,u.localize(0,null));function o(F){const T=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var h;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var f;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$JL={source:f.User,description:u.localize(1,null)},e.$KL={source:f.Auto,description:u.localize(2,null)};function D(F,T,L){const N=F.get(S(T,L));if(N)return N;if((0,v.$2v)(T))for(const B of v.$1v){const U=S(B,L);if(F.has(U))return F.get(U)}else if((0,v.$4v)(T))for(const B of v.$3v){const U=S(B,L);if(F.has(U))return F.get(U)}}function w(F,T,L){const N=D(F,T,L);if(N)return N;const B=(0,v.$4v)(T)?"localhost":(0,v.$2v)(T)?"0.0.0.0":void 0;if(B)return D(F,B,L)}function S(F,T){return F+":"+T}var y;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(y||(e.OnPortForward=y={}));function C(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class O extends p.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new P.$7d,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(L=>{(L.affectsConfiguration(O.c)||L.affectsConfiguration(O.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,L,N){let B=this.w(T,L,N,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Z=this.j[B];Z.key===T?(U.onAutoForward=Z.onAutoForward??U.onAutoForward,U.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:U.elevateIfNeeded,U.label=Z.label??U.label,U.requireLocalPort=Z.requireLocalPort,U.protocol=Z.protocol):(U.onAutoForward=U.onAutoForward??Z.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:Z.elevateIfNeeded,U.label=U.label??Z.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??Z.protocol),B=this.w(T,L,N,this.j,B+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,i.$Uf)(T.host)&&(0,i.$Yf)(T.port)}w(T,L,N,B,U){if(U>=B.length)return-1;const Z=!(0,v.$2v)(L)&&!(0,v.$4v)(L),Y=B.slice(U).findIndex(x=>(0,i.$Yf)(x.key)?Z?!1:x.key===T:this.t(x.key)?Z?!1:T>=x.key.start&&T<=x.key.end:this.u(x.key)?T===x.key.port&&L===x.key.host:N?x.key.test(N):!1);return Y>=0?Y+U:-1}y(){const T=this.r.getValue(O.c);if(!T||!(0,i.$Wf)(T))return[];const L=[];for(const B in T){if(B===void 0)continue;const U=T[B];let Z;if(Number(B))Z=Number(B);else if((0,i.$Uf)(B))if(O.g.test(B)){const _=B.match(O.g);Z={start:Number(_[1]),end:Number(_[2])}}else if(O.h.test(B)){const _=B.match(O.h);Z={host:_[1],port:Number(_[2])}}else{let _;try{_=RegExp(B)}catch{}_&&(Z=_)}Z&&L.push({key:Z,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const N=this.r.getValue(O.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(L)}z(T){function L(N,B){return(0,i.$Yf)(N.key)?N.key:B.t(N.key)?N.key.start:B.u(N.key)?N.key.port:Number.MAX_VALUE}return T.sort((N,B)=>L(N,this)-L(B,this))}C(){return this.m}static providedActionToAction(T){switch(T){case v.ProvidedOnAutoForward.Notify:return y.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case v.ProvidedOnAutoForward.Silent:return y.Silent;case v.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(T,L,N){const U=this.r.inspect(O.c).userRemoteValue;let Z;!U||!(0,i.$Wf)(U)?Z={}:Z=(0,r.$Nn)(U),Z[`${T}`]||(Z[`${T}`]={});for(const _ in L)Z[`${T}`][_]=L[_];return this.r.updateValue(O.c,Z,N)}}e.$PL=O;let z=class extends p.$Uc{constructor(T,L,N,B,U,Z,_,Y,x,ce){super(),this.H=T,this.I=L,this.J=N,this.L=B,this.M=U,this.N=Z,this.O=_,this.P=Y,this.Q=x,this.R=ce,this.c=new Map,this.g=new P.$7d,this.onForwardPort=this.g.event,this.h=new P.$7d,this.onClosePort=this.h.event,this.j=new P.$7d,this.onPortName=this.j.event,this.n=new P.$7d,this.onCandidatesChanged=this.n.event,this.t=new P.$7d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$7d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new O(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const me=await this.getAttributes(X.map(ae=>({port:ae.tunnelRemotePort,host:ae.tunnelRemoteHost})));for(const ae of X)if(ae.localAddress){const re=S(ae.tunnelRemoteHost,ae.tunnelRemotePort),W=w(this.m??new Map,ae.tunnelRemoteHost,ae.tunnelRemotePort);this.forwarded.set(re,{remotePort:ae.tunnelRemotePort,remoteHost:ae.tunnelRemoteHost,localAddress:ae.localAddress,protocol:me?.get(ae.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ae.localAddress,me?.get(ae.tunnelRemotePort)),localPort:ae.tunnelLocalPort,runningProcess:W?.detail,hasRunningProcess:!!W,pid:W?.pid,privacy:ae.privacy,source:e.$JL}),this.f.set(re,ae)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const me=S(X.tunnelRemoteHost,X.tunnelRemotePort);if(!w(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!w(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!w(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const ae=w(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),re=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(me,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:re?.protocol??v.TunnelProtocol.Http,localUri:await this.X(X.localAddress,re),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,privacy:X.privacy,source:e.$JL})}await this.cb(),this.f.set(me,X),this.g.fire(this.forwarded.get(me))})),this.B(this.H.onTunnelClosed(X=>this.W(X,h.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$GL))?(this.R.createKey(e.$HL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,L){const N=S(T.host,T.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(T))}X(T,L){if(T.startsWith("http"))return $.URI.parse(T);const N=L?.protocol??"http";return $.URI.parse(`${N}://${T}`)}async Y(T){const L=this.N.getWorkspace(),N=L.configuration?(0,A.$8i)(L.configuration.path):L.folders.length>0?(0,A.$8i)(L.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(g)}async $(){return this.Y(d)}async ab(){const T=this.I.get(g,1);if(T)return this.I.remove(g,1),await this.cb(),T;const L=await this.Z();if(L)return this.I.get(L,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const L=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${L.map(N=>N.remotePort).join(", ")}`);for(const N of L){const B=w(this.detected,N.remoteHost,N.remotePort);N.source.source!==f.Extension&&!B||N.source.source===f.Extension&&B?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===f.Extension&&!B&&this.D.set(S(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new p.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async L=>{L.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(L=>L.startsWith(d));for(const L of T){const N=this.I.getNumber(L,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const B=L.replace(d,g);this.I.remove(L,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),L=T.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let N;T.length>0&&(N=JSON.stringify(L));const B=await this.Z(),U=await this.$();!N&&B&&U?(this.I.remove(B,0),this.I.remove(U,0)):N!==this.y&&B&&U&&(this.I.store(B,N,0,0),this.I.store(U,Date.now()+l,0,0)),this.y=N}}async eb(T,L,N){if(!T.tunnelLocalPort||!N?.requireLocalPort||T.tunnelLocalPort===L)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const U=u.localize(3,null,L,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(U)}async forward(T,L){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(T,L)}async fb(T,L){await this.Q.activateByEvent(e.$GL);const N=w(this.forwarded,T.remote.host,T.remote.port);L=L??(L!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const B=T.local!==void 0?T.local:T.remote.port;let U;if(N)return this.hb(N,T,L);{const Z=this.L.remoteAuthority,_=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,Y=S(T.remote.host,T.remote.port);this.c.set(Y,!0),T=this.gb(Y,T);const x=await this.H.openTunnel(_,T.remote.host,T.remote.port,void 0,B,T.elevateIfNeeded?T.elevateIfNeeded:L?.elevateIfNeeded,T.privacy,L?.protocol);if(typeof x=="string")U=x;else if(x&&x.localAddress){const ce=w(this.m??new Map,T.remote.host,T.remote.port),X=x.protocol?x.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:L?.protocol??v.TunnelProtocol.Http,me={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:L?.label??T.name,closeable:!0,localAddress:x.localAddress,protocol:X,localUri:await this.X(x.localAddress,L),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:T.source??e.$JL,privacy:x.privacy};return this.forwarded.set(Y,me),this.f.set(Y,x),this.c.delete(Y),await this.cb(),await this.eb(x,B,L),this.g.fire(me),x}this.c.delete(Y)}return U}gb(T,L){const N=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(N){const B=N.get(T);N.delete(T),B&&(L.name=B.name??L.name,L.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??L.local,L.privacy=L.privacy)}return L}async hb(T,L,N){const B=N?.label??L.name;let U;(function(_){_[_.None=0]="None",_[_.Fire=1]="Fire",_[_.Reopen=2]="Reopen"})(U||(U={}));let Z=U.None;switch(B!==T.name&&(T.name=B,Z=U.Fire),(N?.protocol||T.protocol!==v.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&(L.source=T.source,Z=U.Reopen),L.privacy&&T.privacy!==L.privacy&&(Z=U.Reopen),Z){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(T.remoteHost,T.remotePort,h.User),await this.fb(L,N)}return w(this.f,L.remote.host,L.remote.port)}async name(T,L,N){const B=w(this.forwarded,T,L),U=S(T,L);if(B){B.name=N,await this.cb(),this.j.fire({host:T,port:L});return}else this.detected.has(U)&&(this.detected.get(U).name=N,this.j.fire({host:T,port:L}))}async close(T,L,N){const B=S(T,L),U=this.forwarded.get(B);return N===h.AutoForwardEnd&&U&&U.source.source===f.Auto&&this.F.set(B,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(T,L),this.W({host:T,port:L},N)}address(T,L){const N=S(T,L);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const L of T){const N=w(this.m??new Map,L.remoteAddress.host,L.remoteAddress.port),B=typeof L.localAddress=="string"?L.localAddress:S(L.localAddress.host,L.localAddress.port);this.detected.set(S(L.remoteAddress.host,L.remoteAddress.port),{remoteHost:L.remoteAddress.host,remotePort:L.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(L.remoteAddress.host,L.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let L=T;this.r&&(L=await this.r(T));const N=this.ib(L);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(B=>B.port).join(", ")}`),this.n.fire(N)}ib(T){const L=this.m??new Map,N=new Map;return this.m=N,T.forEach(B=>{const U=S(B.host,B.port);N.set(U,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),L.has(U)&&L.delete(U);const Z=w(this.forwarded,B.host,B.port);Z&&(Z.runningProcess=B.detail,Z.hasRunningProcess=!0,Z.pid=B.pid)}),L.forEach((B,U)=>{const Z=o(U);if(!Z)return;const _=w(this.forwarded,Z.host,Z.port);_&&(_.runningProcess=void 0,_.hasRunningProcess=!1,_.pid=void 0);const Y=w(this.detected,Z.host,Z.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0)}),L}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),L=await this.getAttributes(T.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(L)for(const N of T){const B=L.get(N.remotePort);(B?.protocol||N.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},B),B&&B.label&&B.label!==N.name&&await this.name(N.remoteHost,N.remotePort,B.label)}}async getAttributes(T,L=!0){const N=new Map,B=new Map;T.forEach(x=>{const ce=w(this.m??new Map,v.$1v[0],x.port)??x;if(ce){N.set(x.port,ce);const X=C(ce)?ce.pid:void 0;B.has(X)||B.set(X,[]),B.get(X)?.push(x.port)}});const U=new Map;if(T.forEach(x=>{const ce=this.configPortsAttributes.getAttributes(x.port,x.host,N.get(x.port)?.detail);ce&&U.set(x.port,ce)}),this.G.length===0||!L)return U.size>0?U:void 0;const Z=await Promise.all((0,j.$Rb)(this.G.map(x=>Array.from(B.entries()).map(ce=>{const X=ce[1],me=N.get(X[0]);return x.providePortAttributes(X,me?.pid,me?.detail,n.CancellationToken.None)})))),_=new Map;if(Z.forEach(x=>x.forEach(ce=>{ce&&_.set(ce.port,ce)})),!U&&!_)return;const Y=new Map;return T.forEach(x=>{const ce=U.get(x.port),X=_.get(x.port);Y.set(x.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??O.providedActionToAction(X?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),Y}addAttributesProvider(T){this.G.push(T)}};e.$QL=z,Je([(0,R.$Mh)(1e3)],z.prototype,"cb",null),e.$QL=z=Je([Ve(0,v.$Vv),Ve(1,E.$Lp),Ve(2,k.$Ni),Ve(3,m.$FL),Ve(4,b.$sl),Ve(5,c.$qi),Ve(6,I.$Nj),Ve(7,M.$pw),Ve(8,a.$3F),Ve(9,s.$zj)],z)}),define(Ee[94],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$qK=e.$pK=void 0;class u{constructor(A,p){this.line=A,this.character=p}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,p){return new u(0,0)}with(A){return new u(0,0)}}e.$pK=u;class j{constructor(A,p,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(A,p),this.end=new u($,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new j(0,0,0,0)}with(A){return new j(0,0,0,0)}}e.$qK=j;var R;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Ee[36],Se([1,0,19,35,24,34,14,5,17,13,94,8]),function(de,e,u,j,R,P,A,p,$,k,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$NK=e.$GK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$DK=e.$CK=e.$BK=e.$AK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TextSearchCompleteMessageType=void 0,e.$xK=a,e.$yK=n,e.$zK=i,e.$EK=f,e.$FK=D,e.$HK=y,e.$IK=C,e.$JK=O,e.$KK=z,e.$LK=F,e.$MK=T,e.$OK=N,e.$QK=Z,e.$RK=_,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$rK="workbench.view.search",e.$sK="workbench.panel.search",e.$tK="workbench.view.search",e.$uK="search-result",e.$vK="search.exclude";const b="\u27EA ",E=" characters skipped \u27EB",v=(b.length+E.length+5)*2;e.$wK=(0,p.$hi)("searchService");var c;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var m;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(m||(e.QueryType=m={}));function a(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var r;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ce){this.resource=ce,this.results=[]}}e.$AK=s;class t{constructor(ce,X,me,ae){this.ranges=X,this.webviewIndex=ae;const re=Array.isArray(X)?X:[X];if(me&&me.matchLines===1&&g(re)){ce=(0,A.$Nf)(ce,me.matchLines);let W="",ie=0,ve=0;const Pe=Math.floor(me.charsPerLine/5),le=[];for(const ue of re){const oe=Math.max(ue.startColumn-Pe,0),K=ue.startColumn+me.charsPerLine;if(oe>ve+Pe+v){const ee=b+(oe-ve)+E;W+=ee+ce.slice(oe,K),ie+=oe-(ve+ee.length)}else W+=ce.slice(ve,K);le.push(new l(0,ue.startColumn-ie,ue.endColumn-ie)),ve=K}this.preview={text:W,matches:Array.isArray(this.ranges)?le:le[0]}}else{const W=Array.isArray(X)?X[0].startLineNumber:X.startLineNumber;this.preview={text:ce,matches:(0,u.$2b)(X,ie=>new d(ie.startLineNumber-W,ie.startColumn,ie.endLineNumber-W,ie.endColumn))}}}}e.$BK=t;function g(x){const ce=x[0].startLineNumber;for(const X of x)if(X.startLineNumber!==ce||X.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,X,me,ae){this.startLineNumber=ce,this.startColumn=X,this.endLineNumber=me,this.endColumn=ae}}e.$CK=d;class l extends d{constructor(ce,X,me){super(ce,X,ce,me)}}e.$DK=l;var o;(function(x){x.List="list",x.Tree="tree"})(o||(e.ViewMode=o={}));var h;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function f(x,ce=!0){const X=x&&x.files&&x.files.exclude,me=ce&&x&&x.search&&x.search.exclude;if(!X&&!me)return;if(!X||!me)return X||me;let ae=Object.create(null);return ae=R.$Qn(ae,R.$Nn(X)),ae=R.$Qn(ae,R.$Nn(me),!0),ae}function D(x,ce){return x.excludePattern&&j.$ak(x.excludePattern,ce)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&j.$ak(x.includePattern,ce)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(X=>{const me=X.folder.fsPath;if(P.$hg(ce,me)){const ae=$.$mc(me,ce);return!X.includePattern||!!j.$ak(X.includePattern,ae)}else return!1}):!1:!0}var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class S extends Error{constructor(ce,X){super(ce),this.code=X}}e.$GK=S;function y(x){const ce=x.message;if((0,k.$4)(x))return new S(ce,w.canceled);try{const X=JSON.parse(ce);return new S(X.message,X.code)}catch{return new S(ce,w.other)}}function C(x){const ce={message:x.message,code:x.code};return new Error(JSON.stringify(ce))}function O(x){return x.type==="error"?!0:x.type==="success"}function z(x){return x.type==="success"}function F(x){return!!x.path}function T(x,ce,X=!0){const me=x.searchPath?x.searchPath:x.relativePath;return X?(0,A.$Kf)(me,ce):j.$ak(ce,me)}class L{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$NK=L;function N(x,ce){const X={...x||{},...ce||{}};return Object.keys(X).filter(me=>{const ae=X[me];return typeof ae=="boolean"&&ae})}class B{constructor(ce,X){this.c=null,this.a={...ce.excludePattern||{},...X.excludePattern||{}},this.b=j.$bk(this.a);let me=ce.includePattern;X.includePattern&&(me?me={...me,...X.includePattern}:me=X.includePattern),me&&(this.c=j.$bk(me))}matchesExcludesSync(ce,X,me){return!!(this.b&&this.b(ce,X,me))}includedInQuerySync(ce,X,me){return!(this.b&&this.b(ce,X,me)||this.c&&!this.c(ce,X,me))}includedInQuery(ce,X,me){const ae=this.b(ce,X,me),re=()=>this.c?!!this.c(ce,X,me):!0;return(0,I.$6g)(ae)?ae.then(W=>W?!1:re()):re()}hasSiblingExcludeClauses(){return U(this.a)}}e.$PK=B;function U(x){for(const ce in x)if(typeof x[ce]!="boolean")return!0;return!1}function Z(x){if(!x)return;let ce;return X=>(ce||(ce=(x()||Promise.resolve([])).then(me=>me?Y(me):{})),ce.then(me=>!!me[X]))}function _(x){if(!x)return;let ce;return X=>{if(!ce){const me=x();ce=me?Y(me):{}}return!!ce[X]}}function Y(x){const ce={};for(const X of x)ce[X]=!0;return ce}}),define(Ee[43],Se([1,0,19,8,22,4,3,77,15,125,23,14,2,229,5,12,261,42,59,27,20,16,7,66,36,6,57]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g,d,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=void 0;function h(z,F,T){return new M.$Jg(L=>S(L,T)).isEqual(z,F)}function f(z,F,T){return h(z.uri,F.uri,T)?0:(0,I.$ef)(z.uri.toString(),F.uri.toString())}function D(z,F,T){return z.index!==F.index?z.index<F.index?-1:1:h(z.uri,F.uri,T)?(0,I.$ef)(z.name,F.name):(0,I.$ef)(z.uri.toString(),F.uri.toString())}function w(z,F,T,L){const N=z.slice(0).sort((U,Z)=>T(U,Z,L)),B=F.slice(0).sort((U,Z)=>T(U,Z,L));return(0,u.$Eb)(N,B,(U,Z)=>T(U,Z,L))}function S(z,F){const T=F.getCapabilities(z.scheme);return!(T&&T&1024)}class y extends a.$Ai{static toExtHostWorkspace(F,T,L,N){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:U,folders:Z,configuration:_,transient:Y,isUntitled:x}=F,ce=[],X=T;T?Z.forEach((W,ie)=>{const ve=b.URI.revive(W.uri),Pe=y.o(L||T,ve,N);Pe?(Pe.name=W.name,Pe.index=W.index,ce.push(Pe)):ce.push({uri:ve,name:W.name,index:ie})}):ce.push(...Z.map(({uri:W,name:ie,index:ve})=>({uri:b.URI.revive(W),name:ie,index:ve}))),ce.sort((W,ie)=>W.index<ie.index?-1:1);const me=new y(B,U,ce,!!Y,_?b.URI.revive(_):null,!!x,W=>S(W,N)),{added:ae,removed:re}=w(X?X.workspaceFolders:[],me.workspaceFolders,f,N);return{workspace:me,added:ae,removed:re}}static o(F,T,L){for(let N=0;N<F.folders.length;N++){const B=F.workspaceFolders[N];if(h(B.uri,T,L))return B}}constructor(F,T,L,N,B,U,Z){super(F,L.map(_=>new a.$Bi(_)),N,B,Z),this.t=T,this.u=U,this.q=[],this.s=p.$ni.forUris(Z),L.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,T){return T&&this.s.get(F)&&(F=(0,M.$Tg)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let C=class{constructor(F,T,L,N,B){this.c=new P.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new P.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new P.$9d,this.C=new Map,this.h=N,this.s=L,this.t=B,this.j=new k.$om,this.k=new j.$gh,this.o=F.getProxy(l.$iM.MainThreadWorkspace),this.q=F.getProxy(l.$iM.MainThreadMessageService);const U=T.workspace;this.l=U?new y(U.id,U.name,[],!!U.transient,U.configuration?b.URI.revive(U.configuration):null,!!U.isUntitled,Z=>S(Z,L)):void 0}$initializeWorkspace(F,T){this.v=T,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:$.Schemas.untitled,path:(0,M.$Rg)((0,M.$Tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,T,L,...N){const B=[];if(Array.isArray(N)&&N.forEach(x=>{b.URI.isUri(x.uri)&&!B.some(ce=>h(ce.uri,x.uri,this.s))&&B.push({uri:x.uri,name:x.name||(0,M.$Qg)(x.uri)})}),this.n||[T,L].some(x=>typeof x!="number"||x<0)||L===0&&B.length===0)return!1;const U=this.x?this.x.workspaceFolders:[];if(T+L>U.length)return!1;const Z=U.slice(0);Z.splice(T,L,...B.map(x=>({uri:x.uri,name:x.name||(0,M.$Qg)(x.uri),index:void 0})));for(let x=0;x<Z.length;x++){const ce=Z[x];if(Z.some((X,me)=>me!==x&&h(ce.uri,X.uri,this.s)))return!1}Z.forEach((x,ce)=>x.index=ce);const{added:_,removed:Y}=w(U,Z,D,this.s);if(_.length===0&&Y.length===0)return!1;if(this.o){const x=F.displayName||F.name;this.o.$updateWorkspaceFolders(x,T,L,B).then(void 0,ce=>{this.n=void 0;const X={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,x,ce.toString()),X,[])})}return this.y(Z),!0}getWorkspaceFolder(F,T){if(this.x)return this.x.getWorkspaceFolder(F,T)}async getWorkspaceFolder2(F,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,T)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,T){let L,N="";if(typeof F=="string"?(L=b.URI.file(F),N=F):typeof F<"u"&&(L=F,N=F.fsPath),!L)return N;const B=this.getWorkspaceFolder(L,!0);if(!B)return N;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let U=(0,M.$Wg)(B.uri,L);return T&&B.name&&(U=`${B.name}/${U}`),U}y(F){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:T,added:L,removed:N}=y.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:N}))}findFiles(F,T,L,N,B=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let U="",Z=!0;return T===null?Z=!1:T!==void 0&&(typeof T=="string"?U=T:U=T.pattern),this.z(F,void 0,{exclude:U,maxResults:L,useDefaultExcludes:Z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(F,T={},L,N=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,F,T,N)}async z(F,T,L,N=R.CancellationToken.None){if(N&&N.isCancellationRequested)return Promise.resolve([]);const B=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,U={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:B,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let Z;if(F){const{includePattern:_,folder:Y}=O(s.GlobPattern.from(F));Z=Y,U.includePattern=_}else{const{includePattern:_,folder:Y}=O(s.GlobPattern.from(T));Z=Y,U.filePattern=_}return this.o.$startFileSearch(Z??null,U,N).then(_=>Array.isArray(_)?_.map(Y=>b.URI.revive(Y)):[])}async findTextInFiles(F,T,L,N,B=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const U=this.j.getNext(),Z=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:_,folder:Y}=O(s.GlobPattern.from(T.include)),x=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,ce={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:Z,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:_,excludePattern:x},X=!1;if(this.u[U]=me=>{if(X)return;const ae=b.URI.revive(me.resource);me.results.forEach(re=>{const W=(0,o.$Qh)(re);(0,d.$xK)(W)?L({uri:ae,preview:{text:W.preview.text,matches:(0,u.$2b)(W.preview.matches,ie=>new t.$mM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(W.ranges,ie=>new t.$mM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):L({uri:ae,text:W.text,lineNumber:W.lineNumber})})},B.isCancellationRequested)return{};try{const me=await this.o.$startTextSearch(F,Y??null,ce,U,B);return delete this.u[U],me||{}}catch(me){throw delete this.u[U],me}}$handleTextSearchResult(F,T){this.u[T]?.(F)}async save(F){const T=await this.o.$save(F,{saveAs:!1});return b.URI.revive(T)}async saveAs(F){const T=await this.o.$save(F,{saveAs:!0});return b.URI.revive(T)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,T){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,T);const L=this.t.transformOutgoingScheme(F),N=this.A++;return this.o.$registerEditSessionIdentityProvider(N,L),(0,A.$Sc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(F,T){this.h.info("Getting edit session identifier for workspaceFolder",F);const L=await this.resolveWorkspaceFolder(b.URI.revive(F));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const N=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!N),!N)return;const B=await N.provideEditSessionIdentity(L,T);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,T,L,N){this.h.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(b.URI.revive(F));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const U=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!U),!U)return;const Z=await U.provideEditSessionIdentityMatch?.(T,L,N);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(F){return(T,L,N)=>{const B=function(Z){T.call(L,Z)};return B.extension=F,this.B.event(B,void 0,N)}}async $onWillCreateEditSessionIdentity(F,T,L){const N=await this.resolveWorkspaceFolder(b.URI.revive(F));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:N},T,async(B,U)=>{const Z=Date.now();await Promise.resolve(B),Date.now()-Z>L&&this.h.warn("SLOW edit session create-participant",U.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(F,T){if(this.C.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.C.set(F,T);const L=this.t.transformOutgoingScheme(F),N=this.A++;return this.o.$registerCanonicalUriProvider(N,L),(0,A.$Sc)(()=>{this.C.delete(F),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(F,T,L){const N=this.C.get(F.scheme);if(!N)return;const B=await N.provideCanonicalUri?.(b.URI.revive(F),T,L);if(B)return B}async $provideCanonicalUri(F,T,L){return this.provideCanonicalUri(b.URI.revive(F),{targetScheme:T},L)}};e.$0ic=C,e.$0ic=C=Je([Ve(0,r.$CO),Ve(1,i.$SO),Ve(2,n.$Pic),Ve(3,c.$Nj),Ve(4,g.$8ic)],C),e.$$ic=(0,v.$hi)("IExtHostWorkspace");function O(z){let F,T;return z&&(typeof z=="string"?F=z:(F=z.pattern,T=b.URI.revive(z.baseUri))),{includePattern:F,folder:T}}}),define(Ee[44],Se([1,0,24,4,43,6,7,263,85,18,8,5,20,12,2]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=e.$ajc=e.$_ic=void 0;function c(g,d){if(d){const l=d.split(".");let o=g;for(let h=0;o&&h<l.length;h++)o=o[l[h]];return o}}function m(g){return g instanceof v.URI}function a(g){return g&&g.uri instanceof v.URI&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&g.uri instanceof v.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function r(g){if(m(g))return{resource:g};if(a(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(n(g))return{overrideIdentifier:g.languageId};if(i(g))return{resource:g.uri};if(g===null)return{resource:null}}let s=class{constructor(d,l,o){this.a=d.getProxy(P.$iM.MainThreadConfiguration),this.c=l,this.b=o,this.d=new M.$gh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(d,l))}};e.$_ic=s,e.$_ic=s=Je([Ve(0,b.$CO),Ve(1,R.$$ic),Ve(2,E.$Nj)],s);class t{constructor(d,l,o,h){this.a=new j.$7d,this.b=d,this.f=h,this.c=l,this.e=p.$lo.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$lo.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,o))}getConfiguration(d,l,o){const h=r(l)||{},f=this.g(d?c(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,o?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(S){return typeof c(f,S)<"u"},get:(S,y)=>{this.h(d?`${d}.${S}`:S,h,o?.identifier);let C=c(f,S);if(typeof C>"u")C=y;else{let O;const z=(F,T)=>{if((0,k.$Wf)(F)){let L;const N=()=>{O=O||(0,u.$Nn)(f),L=L||c(O,T)};return new Proxy(F,{get:(B,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return N(),()=>L;if(O)return L=L||c(O,T),L[U];const Z=B[U];return typeof U=="string"?z(Z,`${T}.${U}`):Z},set:(B,U,Z)=>(N(),L&&(L[U]=Z),!0),deleteProperty:(B,U)=>(N(),L&&delete L[U],!0),defineProperty:(B,U,Z)=>(N(),L&&Object.defineProperty(L,U,Z),!0)})}return Array.isArray(F)?(0,u.$Nn)(F):F};C=z(C,S)}return C},update:(S,y,C,O)=>{S=d?`${d}.${S}`:S;const z=D(C);return y!==void 0?this.b.$updateConfigurationOption(z,S,y,h,O):this.b.$removeConfigurationOption(z,S,h,O)},inspect:S=>{S=d?`${d}.${S}`:S;const y=this.e.inspect(S,h,this.c.workspace);if(y)return{key:S,defaultValue:(0,u.$Nn)(y.policy?.value??y.default?.value),globalValue:(0,u.$Nn)(y.user?.value??y.application?.value),workspaceValue:(0,u.$Nn)(y.workspace?.value),workspaceFolderValue:(0,u.$Nn)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$Nn)(y.default?.override),globalLanguageValue:(0,u.$Nn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$Nn)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$Nn)(y.workspaceFolder?.override),languageIds:(0,u.$Nn)(y.overrideIdentifiers)}}};return typeof f=="object"&&(0,u.$Qn)(w,f,!1),Object.freeze(w)}g(d){const l=o=>(0,k.$Wf)(o)?new Proxy(o,{get:(h,f)=>l(h[f]),set:(h,f,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(h,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(h,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return l(d)}h(d,l,o){const h=$.$co.test(d)?4:this.d.get(d),f=o?`[${o.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const o=new p.$no(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,f)=>o.affectsConfiguration(h,r(f))})}k(d){return d.reduce((l,o)=>(l.set(o[0],o[1]),l),new Map)}}e.$ajc=t,e.$bjc=(0,I.$hi)("IExtHostConfiguration")}),define(Ee[95],Se([1,0,2,8,4,6,7,43,72,44,22,47,20,27,5,15,11,12,91,307,13]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=e.$Dkc=e.$Ckc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(z){function F(L){if(L!=null)return L}z.from=F;function T(L){if(L!=null)return L}z.to=T})(s||(s={}));var t;(function(z){function F(L){if(L!=null)return L}z.from=F;function T(L){if(L!=null)return L}z.to=T})(t||(t={}));var g;(function(z){function F(L){if(L!=null)return L}z.from=F;function T(L){if(L!=null)return L}z.to=T})(g||(g={}));var d;(function(z){function F(N){if(N){const B=N;return B&&!!B.process}else return!1}z.is=F;function T(N){if(N==null)return;const B={process:N.process,args:N.args};return N.options&&(B.options=g.from(N.options)),B}z.from=T;function L(N){if(N!=null)return new A.$6M(N.process,N.args,N.options)}z.to=L})(d||(d={}));var l;(function(z){function F(L){if(L!=null)return L}z.from=F;function T(L){if(L!=null)return L}z.to=T})(l||(l={}));var o;(function(z){function F(N){if(N){const B=N;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=F;function T(N){if(N==null)return;const B={};return N.commandLine!==void 0?B.commandLine=N.commandLine:(B.command=N.command,B.args=N.args),N.options&&(B.options=l.from(N.options)),B}z.from=T;function L(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$7M(N.commandLine,N.options):new A.$7M(N.command,N.args?N.args:[],N.options)}z.to=L})(o||(o={}));var h;(function(z){function F(N){if(N){const B=N;return B&&B.customExecution==="customExecution"}else return!1}z.is=F;function T(N){return{customExecution:"customExecution"}}z.from=T;function L(N,B){return B.get(N)}z.to=L})(h||(e.CustomExecutionDTO=h={}));var f;(function(z){function F(T,L){let N;return T.scope!==void 0&&typeof T.scope!="number"?N=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===A.TaskScope.Workspace&&L&&L.workspaceFile?N=L.workspaceFile:N=i.$qH),{id:T._id,workspaceFolder:N}}z.from=F})(f||(e.TaskHandleDTO=f={}));var D;(function(z){function F(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}z.from=F})(D||(D={}));var w;(function(z){function F(N,B){if(N==null)return[];const U=[];for(const Z of N){const _=T(Z,B);_&&U.push(_)}return U}z.fromMany=F;function T(N,B){if(N==null)return;let U;N.execution instanceof A.$6M?U=d.from(N.execution):N.execution instanceof A.$7M?U=o.from(N.execution):N.execution&&N.execution instanceof A.$8M&&(U=h.from(N.execution));const Z=s.from(N.definition);let _;return N.scope?typeof N.scope=="number"?_=N.scope:_=N.scope.uri:_=A.TaskScope.Workspace,!Z||!_?void 0:{_id:N._id,definition:Z,name:N.name,source:{extensionId:B.identifier.value,label:N.source,scope:_},execution:U,isBackground:N.isBackground,group:D.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}z.from=T;async function L(N,B,U){if(N==null)return;let Z;d.is(N.execution)?Z=d.to(N.execution):o.is(N.execution)?Z=o.to(N.execution):h.is(N.execution)&&(Z=h.to(N._id,U));const _=s.to(N.definition);let Y;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Y=N.source.scope:Y=await B.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):Y=A.TaskScope.Workspace),!_||!Y)return;const x=new A.$9M(_,Y,N.name,N.source.label,Z,N.problemMatchers);return N.isBackground!==void 0&&(x.isBackground=N.isBackground),N.group!==void 0&&(x.group=A.$5M.from(N.group._id),x.group&&N.group.isDefault&&(x.group=new A.$5M(x.group.id,x.group.label),N.group.isDefault===!0&&(x.group.isDefault=N.group.isDefault))),N.presentationOptions&&(x.presentationOptions=t.to(N.presentationOptions)),N._id&&(x._id=N._id),N.detail&&(x.detail=N.detail),x}z.to=L})(w||(e.TaskDTO=w={}));var S;(function(z){function F(L){return L}z.from=F;function T(L){if(L)return Object.assign(Object.create(null),L)}z.to=T})(S||(S={}));class y{#e;constructor(F,T,L){this._id=T,this.a=L,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let C=class{constructor(F,T,L,N,B,U,Z,_){this.q=new R.$7d,this.r=new R.$7d,this.s=new R.$7d,this.u=new R.$7d,this.a=F.getProxy(P.$iM.MainThreadTask),this.b=L,this.c=N,this.d=B,this.e=U,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,T,L){if(!L)return new A.$kM(()=>{});const N=this.x();return this.j.set(N,{type:T,provider:L,extension:F}),this.a.$registerTaskProvider(N,T),new A.$kM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(F,T){this.a.$registerTaskSystem(F,T)}fetchTasks(F){return this.a.$fetchTasks(S.from(F)).then(async T=>{const L=[];for(const N of T){const B=await w.to(N,this.b,this.m);B&&L.push(B)}return L})}get taskExecutions(){const F=[];return this.k.forEach(T=>F.push(T)),F}terminateTask(F){if(!(F instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,T,L){const N=this.m.get(F.id);N&&(this.o.set(F.id,N),this.e.attachPtyToTerminal(T,await N.callback(L))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const T=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const T=await this.z(F.id);this.s.fire({execution:T,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const T=await this.z(F.id);this.u.fire({execution:T,exitCode:F.exitCode})}$provideTasks(F,T){const L=this.j.get(F);if(!L)return Promise.reject(new Error("no handler found"));const N=[],B=(0,j.$_g)(()=>L.provider.provideTasks(M.CancellationToken.None)).then(U=>this.v(T,N,L,U));return new Promise(U=>{B.then(Z=>{Promise.all(N).then(()=>{U(Z)})})})}async $resolveTask(F,T){const L=this.j.get(F);if(!L)return Promise.reject(new Error("no handler found"));if(T.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${L.type}].`);const N=await w.to(T,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const B=await L.provider.resolveTask(N,M.CancellationToken.None);if(!B)return;this.A(B,L);const U=w.from(B,L.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(U.execution)&&await this.y(U,B,!0),await this.w(U)}x(){return this.h++}async y(F,T,L){const N=await this.a.$createTaskId(F);!L&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,T.execution)),this.m.set(N,T.execution)}async z(F,T){if(typeof F=="string"){const B=this.l.get(F);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const L=this.l.get(F.id);if(L)return L;let N;return T?N=Promise.resolve(new y(this,F.id,T)):N=w.to(F.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,F.id,B)}),this.l.set(F.id,N),N.then(B=>(this.k.set(F.id,B),B))}A(F,T){F._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const L=this.n.values();let N=L.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=L.next()}};e.$Ckc=C,e.$Ckc=C=Je([Ve(0,b.$CO),Ve(1,E.$SO),Ve(2,p.$$ic),Ve(3,$.$NO),Ve(4,k.$bjc),Ve(5,I.$zjc),Ve(6,a.$Nj),Ve(7,n.$Lic)],C);let O=class extends C{constructor(F,T,L,N,B,U,Z,_){super(F,T,L,N,B,U,Z,_),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(F,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const L=w.from(T,F);if(L===void 0)throw new Error("Task is not valid");if(h.is(L.execution))await this.y(L,T,!1);else throw new r.$_;const N=await this.z(await this.a.$getTaskExecution(L),T);return this.a.$executeTask(L).catch(B=>{throw new Error(B)}),N}v(F,T,L,N){const B=[];if(N)for(const U of N){if(this.A(U,L),!U.definition||!F[U.definition.type]){const _=U.source?U.source:"No task source";this.f.warn(`The task [${_}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`)}const Z=w.from(U,L.extension);Z&&h.is(Z.execution)?(B.push(Z),T.push(this.y(Z,U,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:L.extension}}async w(F){if(h.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,T,L){}};e.$Dkc=O,e.$Dkc=O=Je([Ve(0,b.$CO),Ve(1,E.$SO),Ve(2,p.$$ic),Ve(3,$.$NO),Ve(4,k.$bjc),Ve(5,I.$zjc),Ve(6,a.$Nj),Ve(7,n.$Lic)],O),e.$Ekc=(0,v.$hi)("IExtHostTask")}),define(Ee[369],Se([1,0,36,29]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=void 0,e.$XK=R,e.$ZK=P;function R(A){return"cellResults"in A}e.$YK="rawCell#";function P(A,p){let $=-1;const k=[];let M=[];return A.forEach(b=>{b.range.startLineNumber!==$&&M.length>0&&(k.push([...M]),M=[]),M.push(b),$=b.range.endLineNumber}),M.length>0&&k.push([...M]),k.map(b=>{const E=[],v=b[0].range.startLineNumber,c=b[b.length-1].range.endLineNumber;for(let m=v;m<=c;m++)E.push(p.getLineContent(m));return new u.$BK(E.join(`
`)+`
`,b.map(m=>new j.$bt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Ee[370],Se([1,0,223,21,4,3,28,14,18,2,32,111,6,33,16,7,68,340,153,24,15,297,369,366]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,h,f,D,w,S){this.q=f,this.r=D,this.s=w,this.t=S,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new R.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Jic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=o.getProxy(b.$iM.MainThreadNotebook),this.c=o.getProxy(b.$iM.MainThreadNotebookDocuments),this.d=o.getProxy(b.$iM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,O=y.cell.handle,F=this.g.get(C)?.getCell(O);if(F)return F.apiCell}if(y&&y.$mid===14){const C=y.uri,O=this.g.get(C);if(O)return O.apiNotebook}return y}}),d.B(h)}getEditorById(o){const h=this.h.get(o);if(!h)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(o){for(const[h,f]of this.h)if(f.apiEditor===o)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,h){const f=this.g.get(o);if(!f&&!h)throw new Error(`NO notebook document for '${o}'`);return f}static u(o,h){if(!h)return;const f=h.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(h.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:h.displayName,filenamePattern:f,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,h,f){const D=d.a++,w=typeof f.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(D,f),this.b.$registerNotebookCellStatusBarItemProvider(D,w,h);let S;return w!==void 0&&(S=f.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(w))),new c.$kM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,w),S?.dispose()})}async createNotebookDocument(o){const h=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&v.NotebookData.from(o.content)});return k.URI.revive(h)}async openNotebookDocument(o){const h=this.g.get(o);if(h)return h.apiNotebook;const f=await this.c.$tryOpenNotebook(o),D=this.g.get(k.URI.revive(f));return(0,$.$6f)(D?.apiNotebook)}async showNotebookDocument(o,h){k.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let f;typeof h=="object"?f={position:v.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(v.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:f={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,f),w=D&&this.h.get(D)?.apiEditor;if(w)return w;throw D?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,h,f,D){const w=this.f.get(o),S=k.URI.revive(h),y=this.g.get(S);if(!y||!w)return;const C=y.getCellFromIndex(f);if(!C)return;const O=await w.provideCellStatusBarItems(C.apiCell,D);if(!O)return;const z=new P.$Tc,F=this.p.add([z]),L=(Array.isArray(O)?O:[O]).map(N=>v.NotebookStatusBarItem.from(N,this.i,z));return{cacheId:F,items:L}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,h,f,D,w){if((0,p.$Ue)(h))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:h,serializer:f,options:D}),this.b.$registerNotebookSerializer(S,{id:o.identifier,location:o.extensionLocation},h,v.NotebookDocumentContentOptions.from(D),d.u(o,w)),(0,P.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(o,h,f){const D=this.x.get(o);if(!D)throw new Error("NO serializer found");const w=await D.serializer.deserializeNotebook(h.buffer,f);return new m.$dw(v.NotebookData.from(w))}async $notebookToData(o,h,f){const D=this.x.get(o);if(!D)throw new Error("NO serializer found");const w=await D.serializer.serializeNotebook(v.NotebookData.to(h.value),f);return j.$ue.wrap(w)}async $saveNotebook(o,h,f,D,w){const S=k.URI.revive(h),y=this.x.get(o);if(!y)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new M.$9k((0,u.localize)(0,null,this.z(S)),6);await this.y(S,D);const O={metadata:(0,i.$Vn)(C.apiNotebook.metadata,N=>!(y.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of C.apiNotebook.getCells()){const B=new c.$MN(N.kind,N.document.getText(),N.document.languageId,N.mime,y.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);B.metadata=(0,i.$Vn)(N.metadata,U=>!(y.options?.transientCellMetadata??{})[U]),O.cells.push(B)}const z=await y.serializer.serializeNotebook(O,w);await this.s.value.writeFile(S,z);const F=this.s.getFileSystemProviderExtUri(S.scheme),T=await this.s.value.stat(S);return{name:F.basename(S),isFile:(T.type&M.FileType.File)!==0,isDirectory:(T.type&M.FileType.Directory)!==0,isSymbolicLink:(T.type&M.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((T.permissions??0)&M.FilePermission.Locked),etag:M.$hl({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(o,h,f,D,w){const S=this.x.get(o)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new A.$Cc;await(async(T,L,N)=>{await Promise.all(T.map(async B=>await Promise.all(B.filenamePatterns.map(U=>{const Z={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:U};return this.t.doInternalFileSearchWithCustomCallback(Z,L,_=>{_.forEach(Y=>{y.has(Y)||D.some(ce=>B.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(X=>(0,g.$ofb)(X,Y)))||y.add(Y)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(f,w,h);const O=new A.$Bc;let z=!1;const F=Array.from(y).map(async T=>{const L=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...O.values()].reduce((Z,_)=>Z+_.cellResults.length,0)>h.maxResults){z=!0;return}const N=[],B=this.g.get(T);if(B)B.apiNotebook.getCells().forEach(_=>N.push({input:_.document.getText(),outputs:_.outputs.flatMap(Y=>Y.items.map(x=>x.data.toString()))}));else{const Z=await this.s.value.readFile(T),_=j.$ue.fromString(Z.toString()),Y=await S.deserializeNotebook(_.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(Y).cells.forEach(ce=>N.push({input:ce.source,outputs:ce.outputs.flatMap(X=>X.items.map(me=>me.valueBytes.toString()))}))}if(w.isCancellationRequested)return;N.forEach((Z,_)=>{const Y=h.contentPattern.pattern,x=new s.$0Tb(Z.input,void 0,Z.outputs),ce=x.findInInputs(Y),X=x.findInOutputs(Y),me=X.flatMap(ae=>(0,t.$ZK)(ae.matches,ae.textBuffer)).map((ae,re)=>(ae.webviewIndex=re,ae));if(ce.length>0||X.length>0){const ae={index:_,contentResults:(0,t.$ZK)(ce,x.inputTextBuffer),webviewResults:me};L.push(ae)}});const U={resource:T,cellResults:L};O.set(T,U);return}catch{return}});return await Promise.all(F),{limitHit:z,results:[...O.values()]}}async y(o,h){const f=await this.s.value.stat(o);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==M.$gl&&typeof f.mtime=="number"&&typeof f.size=="number"&&h.mtime<f.mtime&&h.etag!==M.$hl({mtime:h.mtime,size:f.size}))throw new M.$9k((0,u.localize)(1,null),3,h)}z(o){return o.scheme===r.Schemas.file?o.fsPath:o.toString()}A(o,h,f){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const D=new n.$8jc(h,this.d,o,f.visibleRanges.map(v.NotebookRange.to),f.selections.map(v.NotebookRange.to),typeof f.viewColumn=="number"?v.ViewColumn.to(f.viewColumn):void 0);this.h.set(h,D)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const f of o.value.removedDocuments){const D=k.URI.revive(f),w=this.g.get(D);w&&(w.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(w.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(o.value.addedDocuments){const f=[];for(const D of o.value.addedDocuments){const w=k.URI.revive(D.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const S=new a.$7jc(this.c,this.q,this.r,w,D);f.push(...D.cells.map(y=>a.$6jc.asModelAddData(y))),this.g.get(w)?.dispose(),this.g.set(w,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(S.apiNotebook)}}if(o.value.addedEditors)for(const f of o.value.addedEditors){if(this.h.has(f.id))return;const D=k.URI.revive(f.documentUri),w=this.g.get(D);w&&this.A(w,f.id,f)}const h=[];if(o.value.removedEditors)for(const f of o.value.removedEditors){const D=this.h.get(f);D&&(this.h.delete(f),this.k?.id===D.id&&(this.k=void 0),h.push(D))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const f=new Set;this.l.forEach(D=>f.add(D.id));for(const D of this.h.values()){const w=f.has(D.id);D._acceptVisibility(w)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(o){const h=E.$1O.String.with("notebookType","A notebook type"),f=new E.$3O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new E.$1O("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>j.$ue.wrap(w))],new E.$2O("Notebook Data",w=>v.NotebookData.to(w.value))),D=new E.$3O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new E.$1O("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$dw(v.NotebookData.from(w)))],new E.$2O("Bytes",w=>w.buffer));o.registerApiCommand(f),o.registerApiCommand(D)}}e.$ekc=d}),define(Ee[371],Se([1,0,17,22,46,35,23,39,36]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class k{constructor(b,E,v){this.k=b,this.l=E,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=b.filePattern,this.b=b.includePattern&&P.$bk(b.includePattern),this.c=b.maxResults||void 0,this.d=b.exists,this.h=new Set,this.j=b.excludePattern&&P.$bk(b.excludePattern)}cancel(){this.g=!0,this.h.forEach(b=>b.cancel()),this.h=new Set}search(b){const E=this.k.folderQueries||[];return new Promise((v,c)=>{const m=a=>{this.f++,b(a)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:a,basename:i})}),Promise.all(E.map(a=>this.p(a,m))).then(a=>{v({limitHit:this.e,stats:a[0]||void 0})},a=>{c(new Error((0,R.$5i)(a)))})})}async p(b,E){const v=new j.$ee,c=this.q(b),m=this.r(),a=new $.$PK(this.k,b),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=p.$3d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,v.token),s=i.elapsed(),t=p.$3d.create();return this.g&&!this.e||(r&&r.forEach(g=>{const d=u.$hc.relative(b.folder.path,g.path);if(n){const l=u.$oc(g.path);this.v(E,{base:b.folder,relativePath:d,basename:l});return}this.s(m,b.folder,d,E)}),this.g&&!this.e)?null:(this.u(m,a,E),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(b){const E=(0,$.$OK)(this.k.includePattern,b.includePattern),v=(0,$.$OK)(this.k.excludePattern,b.excludePattern);return{folder:b.folder,excludes:v,includes:E,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}s({pathToEntries:b},E,v,c){if(v===this.a){const a=u.$oc(this.a);this.v(c,{base:E,relativePath:this.a,basename:a})}function m(a){const n=u.$oc(a),i=u.$nc(a);let r=b[i];r||(r=b[i]=[],m(i)),r.push({base:E,relativePath:a,basename:n})}m(v)}u({rootEntries:b,pathToEntries:E},v,c){const m=this,a=this.a;function n(i){const r=(0,$.$RK)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const g=i[s],{relativePath:d,basename:l}=g;if(v.matchesExcludesSync(d,l,a!==l?r:void 0))continue;const o=E[d];if(o)n(o);else{if(d===a)continue;m.v(c,g)}if(m.e)break}}n(b)}v(b,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||b(E))}}class M{constructor(){this.b=new Map}static{this.a=512}fileSearch(b,E,v,c){const m=this.c(b.cacheKey),a=new k(b,E,m&&m.token);let n=0;const i=r=>{n+=r.length,v(r.map(s=>this.d(s)))};return this.e(a,M.a,i,c).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache(b){this.c(b)?.cancel()}c(b){if(b)return this.b.has(b)||this.b.set(b,new j.$ee),this.b.get(b)}d(b){return b.relativePath?{resource:A.$Ug(b.base,b.relativePath)}:{resource:b.base}}e(b,E,v,c){const m=c.onCancellationRequested(()=>{b.cancel()}),a=i=>{i&&(n.push(i),E>0&&n.length>=E&&(v(n),n=[]))};let n=[];return b.search(a).then(i=>(n.length&&v(n),m.dispose(),i),i=>(n.length&&v(n),m.dispose(),Promise.reject(i)))}}e.$9jc=M}),define(Ee[372],Se([1,0,19,73,35,103,28,15,17,23,14,18,2,100,243,53,12,42,146,367,36]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=void 0,e.$ZL=D;let s=class{constructor(S,y,C,O,z){this.a=S,this.b=y,this.c=C,this.d=O,this.e=z}text(S,y,C={}){S=this.f(S,C);const O=this.a.getValue(),z=y&&y.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(y?.map(a.$Ci),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:O.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,y){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const O={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,y)&&(O.isCaseSensitive=!0),this.k(S)&&(O.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),O}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(o):o(S),y?this.parseSearchPaths(S):{pattern:g(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),O=this.g(y.excludePattern,y.expandPatterns),z=S.length>1,F=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(N=>this.q(N,y,O)):S.map(N=>this.r(N,y,O,z))).filter(N=>!!N),T={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:O.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=u.$Hb(u.$Rb(this.c.groups.map(Z=>Z.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const B=N.filter(Z=>(0,r.$FK)(T,Z.fsPath)),U=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...T,...U}}const L=y.extraFileResources&&y.extraFileResources.filter(N=>(0,r.$FK)(T,N.fsPath));return T.extraFileResources=L&&L.length?L:void 0,T}i(S){const y=[],C=new A.$Bc,O={};let z=!1;return S.forEach(F=>{if(F.scheme===p.Schemas.walkThrough)return;if((0,k.$Yg)(F)){const L=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$nc(F.fsPath)});let N=C.get(L);N||(z=!0,N={folder:L,includePattern:{}},y.push(N),C.set(L,N));const B=$.$mc(L.fsPath,F.fsPath);(0,I.$6f)(N.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(z=!0,O[F.fsPath]=!0)}),{folderQueries:y,includePattern:O,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(M.$Lf(S.pattern,!0))return!0}else if(M.$Lf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,E.$nC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=U=>$.$jc(U)||/^\.\.?([\/\\]|$)/.test(U),O=(Array.isArray(S)?S:d(S)).map(U=>{const Z=this.e.resolvedUserHome;return Z?(0,P.$iw)(U,Z.scheme===p.Schemas.file?Z.fsPath:Z.path):U}),z=j.$K(O,U=>y(U)?"searchPaths":"exprSegments"),F=(z.exprSegments||[]).map(U=>M.$6e(U,"/")).map(U=>M.$6e(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),l(U))),T={},L=this.m(z.searchPaths||[]);L&&L.length&&(T.searchPaths=L);const N=u.$Rb(F),B=g(...N);return B&&(T.pattern=B),T}l(S,y){return y.disregardExcludeSettings?void 0:(0,r.$EK)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(O=>{let{pathPortion:z,globPortion:F}=t(O);return F&&(F=h(F)),this.n(z).flatMap(L=>this.o(L,F))}),C=new Map;return y.forEach(O=>{const z=O.searchPath.toString(),F=C.get(z);F?O.pattern&&(F.pattern=F.pattern||{},F.pattern[O.pattern]=!0):C.set(z,{searchPath:O.searchPath,pattern:O.pattern?g(O.pattern):void 0})}),Array.from(C.values())}n(S){if($.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==p.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:b.URI.file($.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=o(S),S.startsWith("../")||S===".."){const O=$.$hc.resolve(y.path,S);return[{searchPath:y.with({path:O})}]}const C=h(S);return[{searchPath:y,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(z=>{const F=y.match(new RegExp(`^${M.$Ze(z.name)}(?:/(.*)|$)`));return F?{match:F,folder:z}:null}).filter(I.$3f);if(O.length)return O.map(z=>{const F=z.match[1];return{searchPath:z.folder.uri,pattern:F&&h(F)}});{const z=S.match(/\.[\/\\](.+)[\/\\]?/),F=z?z[1]:S,T=v.localize(0,null,F);throw new Error(T)}}}}o(S,y){const C=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,O=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&O.push({searchPath:S.searchPath,pattern:C+"/**"}),O}q(S,y,C){const O=this.r((0,a.$Ci)(S.searchPath),y,C,!1);return O?{...O,includePattern:S.pattern}:null}r(S,y,C,O){let z;const F=b.URI.isUri(S)?S:S.uri;if(C.searchPaths){const U=C.searchPaths.filter(Z=>(0,k.$Ng)(Z.searchPath,F))[0];if(U&&!U.pattern)return null;U&&(z=U.pattern)}const T=this.a.getValue({resource:F}),N={...this.l(T,y)||{},...z||{}},B=b.URI.isUri(S)?(0,k.$Rg)(S):S.name;return{folder:F,folderName:O?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!T.search.followSymlinks}}};e.$YL=s,e.$YL=s=Je([Ve(0,c.$Ni),Ve(1,a.$qi),Ve(2,n.$uD),Ve(3,m.$Nj),Ve(4,i.$WL)],s);function t(w){const S=w.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,C=w.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let O=w.substr(0,C.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:w.substr((C.index||0)+1)}}}return{pathPortion:w}}function g(...w){return w.length?w.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function d(w){return R.$_j(w,",").map(S=>S.trim()).filter(S=>!!S.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function o(w){return w.replace(/\\/g,"/")}function h(w){return o(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(w){return w.replace(/([?*[\]])/g,"[$1]")}function D(w,S){w=u.$Mb(w,O=>O.toString());const y=[],C=S.getWorkspace();return w&&w.forEach(O=>{let z;if(S.getWorkbenchState()===2)z=(0,k.$Wg)(C.folders[0].uri,O),z&&z!=="."&&(z="./"+z);else{const F=S.getWorkspaceFolder(O);if(F){const T=F.name;if(C.folders.filter(N=>N.name===T).length===1){const N=(0,k.$Wg)(F.uri,O);N===""?z=`./${F.name}`:z=`./${F.name}/${N}`}else z=O.fsPath}}z&&y.push(f(z))}),y}}),define(Ee[373],Se([1,0,23,2,22,13,5,372,36,42,8]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zub=b,e.$1ub=c;const I=7e3;function b(m,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const o of n)if(/^workspaceContains:/.test(o)){const h=o.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,M.$ah)(),g=o=>t({activationEvent:o}),d=Promise.all(i.map(o=>E(m,o,g))).then(()=>{}),l=v(m,a.identifier,r,g);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function E(m,a,n){for(const i of m.folders)if(await m.exists(u.$Ug(j.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function v(m,a,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new R.$ee,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let g=!1;try{g=await s}catch(d){P.$4(d)||P.$1(d)}r.dispose(),clearTimeout(t),g&&i(`workspaceContains:${n.join(",")}`)}function c(m,a,n,i){const r=m.get(A.$gi),s=m.get($.$wK),g=r.createInstance(p.$YL).file(a.map(d=>(0,k.$Ci)(j.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(g,i).then(d=>!!d.limitHit,d=>P.$4(d)?!1:Promise.reject(d))}}),define(Ee[48],Se([1,0,219,17,58,23,8,3,77,2,12,6,44,303,118,43,26,148,13,25,21,280,7,65,5,27,93,20,107,70,47,121,4,373,117,282,15,115,39,11,116]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g,d,l,o,h,f,D,w,S,y,C,O,z,F,T,L,N,B){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=e.$Njc=e.$Mjc=e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,d.$hi)("IHostUtils");let Z=U=class extends p.$Uc{constructor(W,ie,ve,Pe,le,ue,oe,K,ee,he,fe,Ae,pe){super(),this.X=Ae,this.Y=pe,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ie,this.g=ve,this.f=oe,this.j=Pe,this.m=le,this.s=ue,this.t=ee,this.u=he,this.w=fe,this.y=this.g.getProxy(I.$iM.MainThreadWorkspace),this.z=this.g.getProxy(I.$iM.MainThreadTelemetry),this.C=this.g.getProxy(I.$iM.MainThreadExtensionService),this.D=new A.$gh,this.F=new A.$gh,this.G=new A.$gh,this.H=new A.$gh,this.I=new ae(this.f.extensions.activationEvents),this.L=new a.$E0b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Dm(this.f.extensions.myExtensions);this.J=new a.$E0b(this.I,X(this.L,Ce)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$vjc(this.g,this.s),this.N=new O.$Djc(this.g),this.O=K,this.h=W.createChild(new f.$fi([v.$wjc,this.M],[O.$Ejc,this.N])),this.P=this.B(new E.$ujc(this.J,this.L,{onExtensionActivationError:(Me,Fe,V)=>{this.C.$onExtensionActivationError(Me,n.$3(Fe),V)},actualActivateExtension:async(Me,Fe)=>{if(a.$E0b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,Fe),new E.$tjc;const V=this.J.getExtensionDescription(Me);return this.eb(V,Fe)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(W){n.$1(W)}}async Z(){this.O.onWillDeactivateAll();let W=[];try{W=this.J.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.db(le))}catch{}await Promise.all(W)}terminate(W,ie=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${W}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const ve=this.Z();Promise.race([(0,A.$ih)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(W){return this.G.isOpen()?this.P.isActivated(W):!1}async getExtension(W){const ie=await this.C.$getExtension(W);return ie&&{...ie,identifier:new i.$Cm(ie.identifier.value),extensionLocation:k.URI.revive(ie.extensionLocation)}}$(W,ie){return this.P.activateByEvent(W,ie)}ab(W,ie){return this.P.activateById(W,ie)}activateByIdWithErrors(W,ie){return this.ab(W,ie).then(()=>{const ve=this.P.getActivatedExtension(W);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(W=>this.J)}getExtensionExports(W){if(this.G.isOpen())return this.P.getActivatedExtension(W).exports;try{return this.P.getActivatedExtension(W).exports}catch{return null}}async bb(W){if(W.scheme===F.Schemas.file&&this.c.fsRealpath){const ie=await this.c.fsRealpath(W.fsPath);return k.URI.file(ie)}return W}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(W=>new me(W))),this.Q}async cb(W){const ie=$.$ni.forUris(ve=>P.$Lg.ignorePathCasing(ve));return await Promise.all(W.map(async ve=>{if(this.vb(ve)){const Pe=await this.bb(ve.extensionLocation);ie.set(Pe,ve)}})),ie}db(W){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(W))return ie;const ve=this.P.getActivatedExtension(W);if(!ve)return ie;try{typeof ve.module.deactivate=="function"&&(ie=Promise.resolve(ve.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${W.value}':`),this.s.error(Pe)}try{(0,p.$Pc)(ve.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this.s.error(Pe)}return ie}async eb(W,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(W.identifier):await this.C.$onWillActivateExtension(W.identifier),this.gb(W,ie).then(ve=>{const Pe=ve.activationTimes;return this.C.$onDidActivateExtension(W.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,ie),this.fb(W,ie,"success",Pe),ve},ve=>{throw this.fb(W,ie,"failure"),ve})}fb(W,ie,ve,Pe){const le=Y(W,ie);this.z.$publicLog2("extensionActivationTimes",{...le,...Pe||{},outcome:ve})}gb(W,ie){const ve=Y(W,ie);this.z.$publicLog2("activatePlugin",ve);const Pe=this.vb(W);if(!Pe)return Promise.resolve(new E.$sjc(E.$pjc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${W.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const le=new E.$qjc(ie.startup);return Promise.all([this.wb(W,(0,P.$Ug)(W.extensionLocation,Pe),le),this.hb(W)]).then(ue=>(R.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),U.ib(this.s,W.identifier,ue[0],ue[1],le))).then(ue=>(R.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),ue))}hb(W){const ie=this.Y.createLanguageModelAccessInformation(W),ve=new s.$yjc(W,this.M),Pe=new s.$xjc(W.identifier.value,!1,this.M),le=new z.$Fjc(W,this.N),ue=W.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,oe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([ve.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const K=this;let ee,he;const fe=(0,m.$6F)(W,"ipc")?this.f.messagePorts?.get(i.$Cm.toKey(W.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Pe,secrets:le,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(Ae){return j.$kc(W.extensionLocation.fsPath,Ae)},get storagePath(){return K.O.workspaceValue(W)?.fsPath},get globalStoragePath(){return K.O.globalValue(W).fsPath},get logPath(){return j.$kc(K.f.logsLocation.fsPath,W.identifier.value)},get logUri(){return k.URI.joinPath(K.f.logsLocation,W.identifier.value)},get storageUri(){return K.O.workspaceValue(W)},get globalStorageUri(){return K.O.globalValue(W)},get extensionMode(){return ue},get extension(){return ee===void 0&&(ee=new ce(K,W.identifier,W,oe,!1)),ee},get extensionRuntime(){return(0,m.$7F)(W,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(W)},get messagePassingProtocol(){if(!he){if(!fe)return;const Ae=y.Event.buffer(y.Event.fromDOMEventEmitter(fe,"message",pe=>pe.data));fe.start(),he={onDidReceiveMessage:Ae,postMessage:fe.postMessage.bind(fe)}}return he}})})}static ib(W,ie,ve,Pe,le){return ve=ve||{activate:void 0,deactivate:void 0},this.jb(W,ie,ve,Pe,le).then(ue=>new E.$rjc(!1,null,le.build(),ve,ue,Pe.subscriptions))}static jb(W,ie,ve,Pe,le){if(typeof ve.activate=="function")try{le.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ue=typeof global=="object"?global:self,oe=ve.activate.apply(ue,[Pe]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(oe).then(K=>(le.activateResolveStop(),K))}catch(ue){return Promise.reject(ue)}else return Promise.resolve(ve)}kb(W,ie){this.ab(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:ie}).then(void 0,ve=>{this.s.error(ve)})}lb(W,ie=0){const Pe=Date.now();(0,N.$B)(()=>{for(let le=ie;le<W.length;le+=1){const ue=W[le];for(const oe of ue.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-Pe>50){this.lb(W,le);break}else this.kb(ue,oe)}})}mb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(W=>{const ie=W.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(ie)this.lb(ve);else for(const Pe of ve)if(Pe.activationEvents)for(const le of Pe.activationEvents)le==="onStartupFinished"&&this.kb(Pe,le)})}nb(){const W=this.$("*",!0).then(void 0,ue=>{this.s.error(ue)});this.B(this.j.onDidChangeWorkspace(ue=>this.ob(ue.added)));const ie=this.j.workspace?this.j.workspace.folders:[],ve=this.ob(ie),Pe=this.qb(),le=Promise.all([Pe,W,ve]).then(()=>{});return Promise.race([le,(0,A.$ih)(1e4)]).then(()=>{this.mb()}),le}ob(W){return W.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.pb(W,ie))).then(()=>{})}async pb(W,ie){if(this.isActivated(ie.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:W.map(ue=>ue.uri),forceUsingSearch:ve||!this.c.fsExists,exists:ue=>this.c.fsExists(ue.fsPath),checkExists:(ue,oe,K)=>this.y.$checkExists(ue,oe,K)},le=await(0,C.$Zub)(Pe,ie);if(le)return this.ab(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:le.activationEvent}).then(void 0,ue=>this.s.error(ue))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(W){throw console.error(W),W}}async rb(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:ie}=this.f.environment;if(!W||!ie)throw new Error(u.localize(0,null));const ve=await this.wb(null,ie,new E.$qjc(!1));if(!ve||typeof ve.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((Pe,le)=>{const ue=(ee,he)=>{ee?(N.$t&&this.s.error("Test runner called back with error",ee),le(ee)):(N.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof he=="number"&&he>0?1:0))},oe=(0,P.$Ig)(ie),K=ve.run(oe,ue);K&&K.then&&K.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(ee=>{N.$t&&this.s.error("Test runner finished with error",ee),le(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$ih)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,ie){return this.R[W]=ie,(0,p.$Sc)(()=>{delete this.R[W]})}async getRemoteExecServer(W){const{resolver:ie}=await this.tb(W);return ie?.resolveExecServer?.(W,{resolveAttempt:0})}async tb(W){const ie=W.indexOf("+");if(ie===-1)throw new t.$qM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=W.substr(0,ie);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.R[ve]}}async $resolveAuthority(W,ie){const ve=L.$3d.create(!1),Pe=()=>`[resolveAuthority(${(0,g.$wl)(W)},${ie})][${ve.elapsed()}ms] `,le=q=>this.s.info(`${Pe()}${q}`),ue=q=>this.s.warn(`${Pe()}${q}`),oe=(q,Q=void 0)=>this.s.error(`${Pe()}${q}`,Q),K=q=>{if(q instanceof t.$qM)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},ee=async q=>{le(`activating resolver for ${q}...`);const{resolver:Q,authorityPrefix:J}=await this.tb(q);if(!Q)throw oe(`no resolver for ${J}`),new t.$qM(`No remote extension installed to resolve ${J}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:q}},he=W.split(/@|%40/g).reverse();le(`activating remote resolvers ${he.join(" -> ")}`);let fe;try{fe=await Promise.all(he.map(ee)).catch(async q=>{if(!(q instanceof t.$qM)||q._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return ue(`resolving nested authorities failed: ${q.message}`),[await ee(W)]})}catch(q){return K(q)}const Ae=new A.$sh;Ae.cancelAndSet(()=>le("waiting..."),1e3);let pe,Ce;for(const[q,{authorityPrefix:Q,resolver:J,remoteAuthority:ge}]of fe.entries())try{if(q===fe.length-1)le("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${Q}`),pe=await J.resolve(ge,{resolveAttempt:ie,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${Q}`),le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$pM.isManagedResolvedAuthority(pe)?pe:void 0));else{if(le(`invoking resolveExecServer() for ${ge}`),R.mark(`code/extHost/willResolveExecServer/${Q}`),Ce=await J.resolveExecServer?.(ge,{resolveAttempt:ie,execServer:Ce}),!Ce)throw new t.$qM(`Exec server was not available for ${ge}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(we){return R.mark(`code/extHost/didResolveAuthorityError/${Q}`),oe("returned an error",we),Ae.dispose(),K(we)}Ae.dispose();const Me={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures?{elevation:pe.tunnelFeatures.elevation,privacyOptions:pe.tunnelFeatures.privacyOptions,protocol:pe.tunnelFeatures.protocol===void 0?!0:pe.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${t.$pM.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let V;if(t.$pM.isManagedResolvedAuthority(pe)){const q=ie;this.X.setFactory(q,pe.makeConnection),V={authority:W,connectTo:new g.$tl(q),connectionToken:pe.connectionToken}}else V={authority:W,connectTo:new g.$ul(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:V,options:Fe,tunnelInformation:Me}}}async $getCanonicalURI(W,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$wl)(W)})`);const{resolver:ve}=await this.tb(W);if(!ve)return null;const Pe=k.URI.revive(ie);if(typeof ve.getCanonicalURI>"u")return Pe;const le=await(0,A.$_g)(()=>ve.getCanonicalURI(Pe));return le||Pe}$startExtensionHost(W){W.toAdd.forEach(Pe=>Pe.extensionLocation=k.URI.revive(Pe.extensionLocation));const{globalRegistry:ie,myExtensions:ve}=_(this.I,this.L,this.J,W);return this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ve),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.sb()}$activateByEvent(W,ie){return ie===1?this.D.wait().then(ve=>this.$(W,!1)):this.G.wait().then(ve=>this.$(W,!1))}async $activate(W,ie){return await this.G.wait(),this.J.getExtensionDescription(W)?(await this.ab(W,ie),!0):!1}async $deltaExtensions(W){W.toAdd.forEach(ue=>ue.extensionLocation=k.URI.revive(ue.extensionLocation));const{globalRegistry:ie,myExtensions:ve}=_(this.I,this.L,this.J,W),Pe=await this.cb(ve);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ve),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){const ie=r.$ue.alloc(W),ve=Math.random()%256;for(let Pe=0;Pe<W;Pe++)ie.writeUInt8(ve,Pe);return ie}async $updateRemoteConnectionData(W){this.W=W,this.a.fire()}};e.$Ljc=Z,e.$Ljc=Z=U=Je([Ve(0,d.$gi),Ve(1,e.$Kjc),Ve(2,h.$CO),Ve(3,c.$$ic),Ve(4,b.$bjc),Ve(5,M.$Nj),Ve(6,l.$SO),Ve(7,o.$ejc),Ve(8,D.$eBb),Ve(9,w.$zjc),Ve(10,T.$Hjc),Ve(11,B.$Ijc),Ve(12,S.$1ic)],Z);function _(re,W,ie,ve){re.addActivationEvents(ve.addActivationEvents);const Pe=new a.$E0b(re,W.getAllExtensionDescriptions());Pe.deltaExtensions(ve.toAdd,ve.toRemove);const le=new i.$Dm(ie.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of ve.myToRemove)le.delete(oe);for(const oe of ve.myToAdd)le.add(oe);const ue=X(Pe,le);return{globalRegistry:Pe,myExtensions:ue}}function Y(re,W){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}function x(re){return re.getAllExtensionDescriptions().map(W=>W.identifier.value).join(",")}e.$Mjc=(0,d.$hi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(W,ie,ve,Pe,le){this.#e=W,this.#t=ie,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=j.$ic((0,P.$Ig)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Pe,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Njc=ce;function X(re,W){return re.getAllExtensionDescriptions().filter(ie=>W.has(ie.identifier))}class me{constructor(W){this.a=W}setSearchTree(W){this.a=W}findSubstr(W){return this.a.findSubstr(W)}forEach(W){return this.a.forEach(W)}}e.$Ojc=me;class ae{constructor(W){this.a=new i.$Em,this.addActivationEvents(W)}readActivationEvents(W){return this.a.get(W.identifier)??[]}addActivationEvents(W){for(const ie of Object.keys(W))this.a.set(ie,W[ie])}}}),define(Ee[374],Se([1,0,58,2,6,44,26,25,20,27,5,48,12,14]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;let c=class{constructor(r,s,t,g,d,l,o){this.c=r,this.d=s,this.e=t,this.f=g,this.g=d,this.h=l,this.i=o,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new a(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$Wkc=c,e.$Wkc=c=Je([Ve(2,M.$gi),Ve(3,P.$bjc),Ve(4,I.$Mjc),Ve(5,k.$SO),Ve(6,b.$Nj)],c);let m=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const s=(0,E.$Ze)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,g,d]=s,l=v.a.get(g);if(l!==void 0)return console.warn(`${g} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};m=v=Je([Ve(0,k.$SO)],m);class a{constructor(r,s,t,g,d){this.c=r,this.d=s,this.e=t,this.f=g,this.g=d,this.nodeModuleName="vscode",this.a=new p.$Em}load(r,s){const t=this.d.findSubstr(s);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((d,l)=>g+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${g}`),this.b=this.c(A.$1F,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$iM.MainThreadTelemetry);const g=t.getProxy(R.$iM.MainThreadWindow);this.c=(d,l)=>{const o=j.URI.parse(d);return l?this.g(d,l):o.scheme==="http"||o.scheme==="https"?g.$openUri(o,d,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this.f?g.$openUri(o,d,{}):this.g(d,l)}}load(r,s,t){const g=this.e.findSubstr(s);return g&&(this.a=g.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ve(2,$.$CO)],n)}),define(Ee[60],Se([1,0,45,3,17,50,5,72,71,48,7,43,300,44]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=void 0,e.$Pjc=(0,A.$hi)("IExtHostVariableResolverProvider");class v extends b.$EP{constructor(a,n,i,r,s,t,g){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const o=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof M.$7N||o.input instanceof M.$_N)return o.input.modified;if(o.input instanceof M.$6N||o.input instanceof M.$$N||o.input instanceof M.$9N)return o.input.uri}}}super({getFolderUri:l=>{const o=t.folders.filter(h=>h.name===l);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,o)=>s.getConfiguration(void 0,l).get(o),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return R.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const o=n.getWorkspaceFolder(l);if(o)return R.$ic(o.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(P.env))}}let c=class extends j.$Uc{constructor(a,n,i,r,s){super(),this.b=a,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Qjc=c,e.$Qjc=c=Je([Ve(0,k.$Mjc),Ve(1,I.$$ic),Ve(2,p.$NO),Ve(3,E.$bjc),Ve(4,$.$njc)],c)}),define(Ee[96],Se([1,0,8,4,2,25,5,6,71,48,20,7,43,143,292,44,60,3,56,33,16]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=e.$Tjc=e.$Sjc=e.$Rjc=void 0,e.$Rjc=(0,A.$hi)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,D,w,S,y,C,O){this.N=D,this.O=w,this.P=S,this.Q=y,this.R=C,this.S=O,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new j.$7d,this.o=new j.$7d,this.q=new j.$7d,this.w=new j.$7d,this.l=f.getProxy(p.$iM.MainThreadDebugService),this.A=new j.$7d,this.C=new j.$7d,this.y=new g(this.l),this.z=new Map,this.O.getExtensionRegistry().then(z=>{z.onDidChange(F=>{this.V(z)}),this.V(z)})}async $getVisualizerTreeItem(f,D){const w=this.W(D);if(!w)return;const S=await this.H.get(f)?.getTreeItem?.(w);return S?this.U(f,S):void 0}registerDebugVisualizationTree(f,D,w){const S=P.$Cm.toKey(f.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,w),this.l.$registerDebugVisualizerTree(y,!!w.editItem),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(f,D){const w=this.J.get(D)?.item;return w?(await this.H.get(f)?.getChildren?.(w))?.map(y=>this.U(f,y))||[]:[]}async $editVisualizerTreeItem(f,D){const w=this.J.get(f);if(!w)return;const S=await this.H.get(w.provider)?.editItem?.(w.item,D);return this.U(w.provider,S||w.item)}$disposeVisualizedTree(f){const D=this.J.get(f);if(!D)return;const w=[D.children];for(const S of w)if(S)for(const y of S)w.push(this.J.get(y)?.children),this.J.delete(y)}U(f,D){let w=this.I.get(D);return w||(w=this.F++,this.I.set(D,w),this.J.set(w,{provider:f,item:D})),r.DebugTreeItem.from(D,w)}asDebugSourceUri(f,D){const w=f;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let S=`debug:${encodeURIComponent(w.path||"")}`,y="?";return D&&(S+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),S+=`${y}ref=${w.sourceReference}`,R.URI.parse(S)}else{if(w.path)return R.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const D=[];for(const w of f.getAllExtensionDescriptions())if(w.contributes){const S=w.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,v.$GG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(D=>f.push(D)),f}async $resolveDebugVisualizer(f,D){const w=this.L.get(f);if(!w)throw new Error(`No debug visualizer found with id '${f}'`);let{v:S,provider:y,extensionId:C}=w;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,D)||S,w.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(f){const D=this.L.get(f);if(!D)throw new Error(`No debug visualizer found with id '${f}'`);const w=D.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(f){const D=this.m.get(f.sessionId);return D&&{session:D.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,D,w,S){const y=this.W(w),C=this.jb(f,D),O=this.G.get(C);if(!y||!O)return[];const z=await O.provideDebugVisualization(y,S);return z?z.map(F=>{const T=++this.M;this.L.set(T,{v:F,provider:O,extensionId:f});const L=F.iconPath?this.lb(F.iconPath):void 0;return{id:T,name:F.name,iconClass:L?.iconClass,iconPath:L?.iconPath,visualization:this.kb(f,F.visualization)}}):[]}$disposeDebugVisualizers(f){for(const D of f)this.L.delete(D)}registerDebugVisualizationProvider(f,D,w){if(!f.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=P.$Cm.toKey(f.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,w),this.l.$registerDebugVisualizer(S,D),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(f){const D=f.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const w=[],S=new Map;for(const y of D)if(y instanceof I.$lN){let C=S.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),C),w.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof I.$mN&&w.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(f){const D=f.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const w=D.filter(C=>C instanceof I.$lN).map(C=>C.id),S=D.filter(C=>C instanceof I.$mN).map(C=>C.id),y=D.filter(C=>C instanceof I.$nN).map(C=>C.id);return this.l.$unregisterBreakpoints(w,S,y)}startDebugging(f,D,w){return this.l.$startDebugging(f?f.uri:void 0,D,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,D,w){if(!D)return new I.$kM(()=>{});const S=this.d++;return this.f.push({type:f,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(f,w,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new I.$kM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(f,D,w){if(!w)return new I.$kM(()=>{});if(!this.cb(f,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new I.$kM(()=>{this.h=this.h.filter(y=>y.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(f,D){if(!D)return new I.$kM(()=>{});const w=this.j++;return this.k.push({type:f,handle:w,factory:D}),new I.$kM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(f,D){return Promise.resolve(void 0)}async $substituteVariables(f,D){let w;const S=await this.ib(f);return S&&(w={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,D)}X(f,D){if(f.type==="implementation")return new l(f.implementation)}Y(){}async $startDASession(f,D){const w=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(y),O=this.X(C,S);if(!O)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const z=O;return this.D.set(f,z),this.db(S).then(F=>(F&&this.E.set(f,F),z.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const L=T,N={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(L.arguments.value);N.body={signature:B},z.sendResponse(N)}else throw new Error("no signer")}catch(B){N.success=!1,N.message=B.message,z.sendResponse(N)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(T),T=(0,v.$LG)(T,!0),w.l.$acceptDAMessage(f,T)}),z.onError(T=>{F&&F.onError&&F.onError(T),this.l.$acceptDAError(f,T.name,T.message,T.stack)}),z.onExit(T=>{F&&F.onExit&&F.onExit(T??void 0,void 0),this.l.$acceptDAExit(f,T??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),z.startSession()))})}$sendDAMessage(f,D){D=(0,v.$KG)(D,!1);const w=this.E.get(f);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(D),this.D.get(f)?.sendMessage(D)}$stopDASession(f){const D=this.E.get(f);this.E.delete(f),D&&D.onWillStopSession&&D.onWillStopSession();const w=this.D.get(f);return this.D.delete(f),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const D=[],w=[],S=[];if(f.added)for(const y of f.added){const C=y.id;if(C&&!this.z.has(C)){let O;if(y.type==="function")O=new I.$mN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")O=new I.$nN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const z=R.URI.revive(y.uri);O=new I.$lN(new I.$wM(z,new I.$lM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,I.$jN)(O,C),this.z.set(C,O),D.push(O)}}if(f.removed)for(const y of f.removed){const C=this.z.get(y);C&&(this.z.delete(y),w.push(C))}if(f.changed){for(const y of f.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof I.$mN&&y.type==="function"){const O=C;O.enabled=y.enabled,O.condition=y.condition,O.hitCondition=y.hitCondition,O.logMessage=y.logMessage,O.functionName=y.functionName}else if(C instanceof I.$lN&&y.type==="source"){const O=C;O.enabled=y.enabled,O.condition=y.condition,O.hitCondition=y.hitCondition,O.logMessage=y.logMessage,O.location=new I.$wM(R.URI.revive(y.uri),new I.$lM(y.line,y.character))}S.push(C)}}}this.gb(D,w,S)}async $acceptStackFrameFocus(f){let D;if(f){const w=await this.hb(f.sessionId);f.kind==="thread"?D=new I.$tN(w.api,f.threadId):D=new I.$sN(w.api,f.threadId,f.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(f,D,w){return(0,u.$_g)(async()=>{const S=this.bb(f);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return S.provideDebugConfigurations(y,w)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(f,D,w,S){return(0,u.$_g)(async()=>{const y=this.bb(f);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,w,S)})}$resolveDebugConfigurationWithSubstitutedVariables(f,D,w,S){return(0,u.$_g)(async()=>{const y=this.bb(f);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,w,S)})}async $provideDebugAdapter(f,D){const w=this.ab(f);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(w,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(f){const D=await this.hb(f);this.n.fire(D.api)}async $acceptDebugSessionTerminated(f){const D=await this.hb(f);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,D){(await this.hb(f))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(f,D){const S={session:(await this.hb(f)).api,event:D.event,body:D.body};this.w.fire(S)}Z(f){if(f instanceof I.$oN)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof I.$pN)return{type:"server",port:f.port,host:f.host};if(f instanceof I.$qN)return{type:"pipeServer",path:f.path};if(f instanceof I.$rN)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const D=this.h.filter(w=>w.type===f);if(D.length>0)return D[0].factory}ab(f){const D=this.h.filter(w=>w.handle===f);if(D.length>0)return D[0].factory}bb(f){const D=this.f.filter(w=>w.handle===f);if(D.length>0)return D[0].provider}cb(f,D){if(f.contributes){const w=f.contributes.debuggers;if(w&&w.length>0){for(const S of w)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(f){const w=f.configuration.type,S=this.k.filter(y=>y.type===w||y.type==="*").map(y=>(0,u.$_g)(()=>y.factory.createDebugAdapterTracker(f.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(y=>{const C=y.filter(O=>!!O);if(C.length>0)return new d(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(f,D){const w=D.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new I.$pN(w));if(f){const y=await this.O.getExtensionRegistry();return(0,u.$_g)(()=>f.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(f,D){}gb(f,D,w){(f.length>0||D.length>0||w.length>0)&&this.A.fire(Object.freeze({added:f,removed:D,changed:w}))}async hb(f){if(f)if(typeof f=="string"){const D=this.m.get(f);if(D)return D}else{let D=this.m.get(f.id);if(!D){const w=await this.ib(f.folderUri),S=f.parent?this.m.get(f.parent):void 0;D=new t(this.l,f.id,f.type,f.name,w,f.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(f){if(f){const D=R.URI.revive(f);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(f,D){return`${f}\0${D}`}kb(f,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${f}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const D=this.mb(f);let w,S;return"id"in D?S=n.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:S}}mb(f){if(f instanceof I.$gN)return{id:f.id};const D=typeof f=="object"&&"dark"in f?f.dark:f,w=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof w=="string"?R.URI.file(w):w}}};e.$Sjc=s,e.$Sjc=s=Je([Ve(0,M.$CO),Ve(1,b.$$ic),Ve(2,k.$Mjc),Ve(3,c.$bjc),Ve(4,$.$njc),Ve(5,m.$Pjc),Ve(6,i.$YO)],s);class t{constructor(f,D,w,S,y,C,O){this.f=f,this.g=D,this.h=w,this.j=S,this.k=y,this.l=C,this.m=O}get api(){const f=this;return this.d??=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(D){f.j=D,f.f.$setDebugSessionName(f.g,D)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(D,w){return f.f.$customDebugAdapterRequest(f.g,D,w)},getDebugProtocolBreakpoint(D){return f.f.$getDebugProtocolBreakpoint(f.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$Tjc=t;class g{constructor(f){this.value=Object.freeze({append(D){f.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Ujc=g;class d{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(D=>D.onError?D.onError(f):void 0)}onExit(f,D){this.d.forEach(w=>w.onExit?w.onExit(f,D):void 0)}}class l extends E.$fob{constructor(f){super(),this.h=f,f.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let o=class extends s{constructor(f,D,w,S,y,C,O){super(f,D,w,S,y,C,O)}};e.$Vjc=o,e.$Vjc=o=Je([Ve(0,M.$CO),Ve(1,b.$$ic),Ve(2,k.$Mjc),Ve(3,c.$bjc),Ve(4,$.$njc),Ve(5,m.$Pjc),Ve(6,i.$YO)],o)}),define(Ee[375],Se([1,0,13,58,2,6,321,12,84,107,27,256,20,66,48,90]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(p.$Nj),t=i.get(b.$CO).getProxy(P.$iM.MainThreadErrors);u.setUnexpectedErrorHandler(g=>{r.error(g);const d=u.$3(g);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(p.$Nj),s=i.get(b.$CO),t=i.get(v.$Mjc),g=i.get(c.$WO),d=s.getProxy(P.$iM.MainThreadExtensionService),l=s.getProxy(P.$iM.MainThreadErrors),o=await t.getExtensionPathIndex(),h=new WeakMap;function f(S,y){if(h.has(S))return h.get(S).stack;let C="",O,z;for(const T of y)C+=`
	at ${T.toString()}`,z=T.getFileName(),!O&&z&&(O=o.findSubstr(R.URI.file(z)));const F=`${S.name||"Error"}: ${S.message||""}${C}`;return h.set(S,{extensionIdentifier:O?.identifier,stack:F}),F}const D=Symbol("prepareStackTrace wrapped");let w=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(S){if(S===f||!S||S[D]){w=S||f;return}w=function(y,C){return f(y,C),S.call(Error,y,C)},Object.assign(w,{[D]:!0})}}),u.setUnexpectedErrorHandler(S=>{r.error(S);const y=u.$3(S),C=h.get(S);if(!C?.extensionIdentifier){l.$onUnexpectedError(y);return}d.$onExtensionRuntimeError(C.extensionIdentifier,y);const O=g.onExtensionError(C.extensionIdentifier,S);r.trace("forwarded error to extension?",O,C)})}}e.$Xkc=m;class a{constructor(i,r,s,t,g){this.a=s,this.b=new A.$M0b(i,null,t),r=a.e(r,this.b);const d=new k.$fi(...(0,$.$gs)());d.set(M.$SO,{_serviceBrand:void 0,...r,messagePorts:g}),d.set(b.$CO,new b.$DO(this.b)),d.set(E.$8ic,new E.$9ic(t)),d.set(v.$Kjc,s);const l=new I.$Xq(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(o=>o.get(p.$Nj)),j.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(o=>o.get(v.$Mjc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(P.$iM.MainThreadExtensionService);return R.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>R.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Ykc=a}),define(Ee[376],Se([1,0,8,11,230,249,141,96,71,48,20,47,7,60,43,293,294,44,33,377]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;let r=class extends p.$Sjc{constructor(o,h,f,D,w,S,y,C){super(o,h,f,D,S,y,C),this.pb=w,this.nb=new d}X(o,h){switch(o.type){case"server":return new c.$4kc(o);case"pipeServer":return new c.$5kc(o);case"executable":return new c.$6kc(o,h.type)}return super.X(o,h)}fb(o,h){const f=c.$6kc.platformAdapterExecutable(h.getAllExtensionDescriptions(),o.type);if(f)return new b.$oN(f.command,f.args,f.options)}Y(){return new A.$Abc}async $runInTerminal(o,h){if(o.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(N=>{this.nb.onTerminalClosed(N)}));const f=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),S=o.title||R.localize(0,null),y=s(D,w,o);let C=await this.nb.checkout(y,S,!0),O,z=!1;if(C)O=o.cwd;else{const N={shellPath:D,shellArgs:w,cwd:o.cwd,name:S,iconPath:new b.$gN("debug"),env:o.env};z=!0,C=this.pb.createTerminalFromOptions(N,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,y)}C.show(!0);const F=await C.processId;z?await new Promise(N=>setTimeout(N,1e3)):(C.state.isInteractedWith&&C.sendText(""),f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?C.sendText("cls"):D.indexOf("bash")>=0?C.sendText("clear"):j.$i?C.sendText("cls"):C.sendText("clear")));const T=(0,m.$8kc)(D,o.args,!!o.argsCanBeInterpretedByShell,O);C.sendText(T);const L=this.onDidTerminateDebugSession(N=>{N.id===h&&(this.nb.free(C),L.dispose())});return F}else if(o.kind==="external")return g(o,await this.P.getConfigProvider());return super.$runInTerminal(o,h)}};e.$9kc=r,e.$9kc=r=Je([Ve(0,M.$CO),Ve(1,v.$$ic),Ve(2,k.$Mjc),Ve(3,a.$bjc),Ve(4,I.$zjc),Ve(5,$.$njc),Ve(6,E.$Pjc),Ve(7,n.$YO)],r);function s(l,o,h){const f=(0,i.createHash)("sha256");return f.update(JSON.stringify({shell:l,shellArgs:o})),f.update(JSON.stringify(Object.entries(h.env||{}).sort(([D],[w])=>D.localeCompare(w)))),f.digest("base64")}let t;function g(l,o){if(!t)if(j.$i)t=new P.$lac;else if(j.$j)t=new P.$mac;else if(j.$k)t=new P.$nac;else throw new Error("external terminals not supported on this platform");const h=o.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,h,f=!1){const w=[...this.b.entries()].map(([S,y])=>(0,u.$7g)(async C=>{if(S.name!==h||y.lastUsedAt!==-1&&await(0,m.$7kc)(await S.processId))return null;const O=Date.now();return y.lastUsedAt+d.a>O||C.isCancellationRequested?null:y.config!==o?(f&&S.dispose(),null):(y.lastUsedAt=O,S)}));return await(0,u.$mh)(w,S=>!!S)}insert(o,h){this.b.set(o,{lastUsedAt:Date.now(),config:h})}free(o){const h=this.b.get(o);h&&(h.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(Ee[378],Se([1,0,17,2,105,43,72,44,42,47,20,27,95,15,12,91,23,63,60]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;let i=class extends b.$Ckc{constructor(s,t,g,d,l,o,h,f,D){super(s,t,g,d,l,o,h,f),this.C=g,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const g=t;if(!t.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const d=b.TaskHandleDTO.from(g,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),o}else{const d=b.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,g,d){const l=[];if(d)for(const o of d){this.A(o,g),(!o.definition||!s[o.definition.type])&&this.f.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const h=b.TaskDTO.from(o,g.extension);h&&(l.push(h),b.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,o,!0)))}return{tasks:l,extension:g.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const g=j.URI.file((0,a.homedir)());t=new $.$Bi({uri:g,name:m.$Rg(g),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const g=j.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(g),o=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),f=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(o);for(const D of t.variables)d.variables[D]=await h.resolveAsync(f,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let w=0;w<D.length;w++)D[w]=await h.resolveAsync(f,D[w])}d.process=await R.win32.findExecutable(await h.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(f,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,g){return R.win32.findExecutable(s,t,g)}};e.$1kc=i,e.$1kc=i=Je([Ve(0,M.$CO),Ve(1,I.$SO),Ve(2,P.$$ic),Ve(3,A.$NO),Ve(4,p.$bjc),Ve(5,k.$zjc),Ve(6,v.$Nj),Ve(7,c.$Lic),Ve(8,n.$Pjc)],i)}),define(Ee[379],Se([1,0,63,60]),function(de,e,u,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class R extends j.$Qjc{m(){return(0,u.homedir)()}}e.$Glc=R}),define(Ee[158],Se([1,0,19,8,22,46,15,17,23,2,36]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=e.$$jc=e.$0jc=void 0,e.$_jc=c;class I{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new R.$ee(i);return new Promise((t,g)=>{this.a=new E(n);let d=!1;const l=(o,h)=>{if(!d&&!this.b){const f=this.h(o);c(o)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),o=this.j(o,this.g.maxResults-this.c));const D=this.h(o);this.c+=D,(D>0||!c(o))&&this.a.add(o,h)}};Promise.all(r.map((o,h)=>this.k(o,f=>l(f,h),s.token))).then(o=>{s.dispose(),this.a.flush();const h=o.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(o.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},o=>{s.dispose();const h=(0,P.$5i)(o);g(new Error(h))})})}h(n){return c(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new M.$PK(this.g,n),t=[],g={report:o=>{if(!this.l(o))return;const h=n.folder.scheme===A.Schemas.file?(0,M.$QK)(()=>this.e.readdir($.$Tg(o.uri))):void 0,f=$.$Wg(n.folder,o.uri);if(f){const D=s.includedInQuery(f,p.$oc(f),h);(0,j.$6g)(D)?t.push(D.then(w=>{w&&i(o)})):D&&i(o)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,g,r):l=await this.d.provider.provideTextSearchResults(b(this.d.query.contentPattern),d,g,r),t.length&&await Promise.all(t),l}l(n){if(c(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,M.$OK)(this.g.includePattern,n.includePattern),r=(0,M.$OK)(this.g.excludePattern,n.excludePattern),s={folder:k.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$0jc=I;function b(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Ng(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$$jc=E;function v(a){return c(a)?{preview:{matches:(0,u.$2b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,u.$2b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function c(a){return!!a.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$akc=m}),define(Ee[97],Se([1,0,3,6,5,371,20,66,12,2,158]),function(de,e,u,j,R,P,A,p,$,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$dkc=b,e.$bkc=(0,R.$hi)("IExtHostSearch");let I=class{constructor(c,m,a){this.n=c,this.o=m,this.q=a,this.c=this.n.getProxy(j.$iM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new P.$9jc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const a=this.d++;return this.e.set(a,m),this.c.$registerTextSearchProvider(a,this.s(c)),(0,u.$Sc)(()=>{this.g.delete(c),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(c,m){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const a=this.d++;return this.h.set(a,m),this.c.$registerAITextSearchProvider(a,this.s(c)),(0,u.$Sc)(()=>{this.i.delete(c),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(c,m){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const a=this.d++;return this.j.set(a,m),this.c.$registerFileSearchProvider(a,this.s(c)),(0,u.$Sc)(()=>{this.k.delete(c),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(c,m,a,n){const i=b(a),r=this.j.get(c);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(c,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,a){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,a,n){const i=this.e.get(c);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${c}`);const r=b(a);return this.t(r,i).search(t=>this.c.$handleTextMatch(c,m,t),n)}$provideAITextSearchResults(c,m,a,n){const i=this.h.get(c);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${c}`);const r=b(a);return this.v(r,i).search(t=>this.c.$handleTextMatch(c,m,t),n)}$enableExtensionHostSearch(){}t(c,m){return new M.$0jc({query:c,provider:m},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(c,m){return new M.$0jc({query:c,provider:m},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$ckc=I,e.$ckc=I=Je([Ve(0,A.$CO),Ve(1,p.$8ic),Ve(2,$.$Nj)],I);function b(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(c=>k.URI.revive(c))}}function E(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(Ee[380],Se([1,0,22,13,4,3,15,40,2,135,197,178,79,25,32,12,86,87,275,6,323,350,91,120,328,309,329,121,330,310,298,33,331,44,332,96,151,333,312,324,334,335,72,71,325,48,336,69,337,59,27,351,352,326,313,338,339,115,116,314,370,341,281,342,353,343,156,315,344,345,346,20,347,97,117,348,316,349,118,93,95,90,47,354,355,327,356,357,70,16,7,317,66,318,92,358,359,150,43,291,114,26,94]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g,d,l,o,h,f,D,w,S,y,C,O,z,F,T,L,N,B,U,Z,_,Y,x,ce,X,me,ae,re,W,ie,ve,Pe,le,ue,oe,K,ee,he,fe,Ae,pe,Ce,Me,Fe,V,q,Q,J,ge,we,Te,He,Xe,tt,nt,at,st,Ie,ze,Re,Ge,ne,se,De,Ke,xe,ot,Ne,bt,St,It,xt,Tt,Dt,Qt,Ut,ai,ii,_e,_t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=ni;function ni(dt){const pt=dt.get(re.$SO),ri=dt.get(ae.$Pic),Wt=dt.get(X.$djc),qt=dt.get(x.$Mjc),ft=dt.get(Ut.$$ic),Rt=dt.get(ze.$WO),ei=dt.get(C.$bjc),si=dt.get(St.$8ic),Qe=dt.get(ge.$CO),Vt=dt.get(at.$wjc),Yt=dt.get(st.$ejc),Ht=dt.get(c.$Oj),mt=dt.get(c.$Nj),jt=dt.get(xe.$eBb),Pt=dt.get(t.$Lic),Lt=dt.get(Qt.$Rkc),oi=dt.get(He.$Ejc),Gt=dt.get(_.$njc),Zt=dt.get(K.$Ijc),vt=dt.get(g.$Vic),Nt=dt.get(h.$1ic);Qe.set(i.$jM.ExtHostFileSystemInfo,ri),Qe.set(i.$jM.ExtHostLogLevelServiceShape,Ht),Qe.set(i.$jM.ExtHostWorkspace,ft),Qe.set(i.$jM.ExtHostConfiguration,ei),Qe.set(i.$jM.ExtHostExtensionService,qt),Qe.set(i.$jM.ExtHostStorage,Vt),Qe.set(i.$jM.ExtHostTunnelService,jt),Qe.set(i.$jM.ExtHostWindow,Lt),Qe.set(i.$jM.ExtHostSecretState,oi),Qe.set(i.$jM.ExtHostTelemetry,Rt),Qe.set(i.$jM.ExtHostEditorTabs,Gt),Qe.set(i.$jM.ExtHostManagedSockets,Zt),Qe.set(i.$jM.ExtHostAuthentication,vt),Qe.set(i.$jM.ExtHostChatProvider,Nt);const Bt=Qe.set(i.$jM.ExtHostDecorations,dt.get(F.$Xjc)),Ft=Qe.set(i.$jM.ExtHostDocumentsAndEditors,dt.get(Z.$NO)),kt=Qe.set(i.$jM.ExtHostCommands,dt.get(S.$YO)),Ct=Qe.set(i.$jM.ExtHostTerminalService,dt.get(Re.$zjc)),Et=Qe.set(i.$jM.ExtHostDebugService,dt.get(z.$Rjc)),ui=Qe.set(i.$jM.ExtHostSearch,dt.get(Te.$bkc)),ti=Qe.set(i.$jM.ExtHostTask,dt.get(Ie.$Ekc)),li=Qe.set(i.$jM.ExtHostOutputService,dt.get(Fe.$rkc)),di=Qe.set(i.$jM.ExtHostLocalization,dt.get(oe.$Hjc)),Xt=Qe.set(i.$jM.ExtHostUrls,new It.$Okc(Qe)),At=Qe.set(i.$jM.ExtHostDocuments,new U.$Sic(Qe,Ft)),Oe=Qe.set(i.$jM.ExtHostDocumentContentProviders,new N.$Zjc(Qe,Ft,mt)),Be=Qe.set(i.$jM.ExtHostDocumentSaveParticipant,new B.$1jc(mt,At,Qe.getProxy(i.$iM.MainThreadBulkEdits))),ye=Qe.set(i.$jM.ExtHostNotebook,new he.$ekc(Qe,kt,Ft,At,Wt,ui)),te=Qe.set(i.$jM.ExtHostNotebookDocuments,new Ae.$lkc(ye)),je=Qe.set(i.$jM.ExtHostNotebookEditors,new pe.$mkc(mt,ye)),qe=Qe.set(i.$jM.ExtHostNotebookKernels,new Ce.$nkc(Qe,pt,ye,kt,mt)),et=Qe.set(i.$jM.ExtHostNotebookRenderers,new Me.$pkc(Qe,ye)),Ye=Qe.set(i.$jM.ExtHostNotebookDocumentSaveParticipant,new fe.$kkc(mt,ye,Qe.getProxy(i.$iM.MainThreadBulkEdits))),ct=Qe.set(i.$jM.ExtHostEditors,new ne.$5ic(Qe,Ft)),yt=Qe.set(i.$jM.ExtHostTreeViews,new Ke.$Mkc(Qe.getProxy(i.$iM.MainThreadTreeViews),kt,mt)),Kt=Qe.set(i.$jM.ExtHostEditorInsets,new w.$6ic(Qe.getProxy(i.$iM.MainThreadEditorInsets),ct,pt.remote)),zt=Qe.set(i.$jM.ExtHostDiagnostics,new T.$Ric(Qe,mt,ri,Ft)),Mt=Qe.set(i.$jM.ExtHostLanguages,new ue.$ikc(Qe,At,kt.converter,si)),lt=Qe.set(i.$jM.ExtHostLanguageFeatures,new le.$Tic(Qe,si,At,kt,zt,mt,Pt,Rt)),Ii=Qe.set(i.$jM.ExtHostFileSystem,new ce.$3jc(Qe,lt)),gi=Qe.set(i.$jM.ExtHostFileSystemEventService,new me.$4jc(Qe,mt,Ft)),$i=Qe.set(i.$jM.ExtHostQuickOpen,(0,J.$vkc)(Qe,ft,kt)),vi=Qe.set(i.$jM.ExtHostSCM,new we.$xkc(Qe,kt,At,mt)),Pi=Qe.set(i.$jM.ExtHostQuickDiff,new Q.$ukc(Qe,si)),Ai=Qe.set(i.$jM.ExtHostShare,new Xe.$ykc(Qe,si)),Wi=Qe.set(i.$jM.ExtHostComments,(0,y.$7ic)(Qe,kt,At)),qi=Qe.set(i.$jM.ExtHostProgress,new q.$tkc(Qe.getProxy(i.$iM.MainThreadProgress))),Vi=Qe.set(i.$jM.ExtHostLabelService,new Pe.$hkc(Qe)),yi=Qe.set(i.$jM.ExtHostTheming,new se.$Jkc(Qe)),Mi=Qe.set(i.$jM.ExtHostTimeline,new De.$Lkc(Qe,kt)),ki=Qe.set(i.$jM.ExtHostWebviews,new xt.$ijc(Qe,pt.remote,ft,mt,Pt)),Ei=Qe.set(i.$jM.ExtHostWebviewPanels,new Tt.$ljc(Qe,ki,ft)),Hi=Qe.set(i.$jM.ExtHostCustomEditors,new O.$mjc(Qe,At,Yt,ki,Ei)),Gi=Qe.set(i.$jM.ExtHostWebviewViews,new Dt.$Pkc(Qe,ki)),bi=Qe.set(i.$jM.ExtHostTesting,new Ge.$Fkc(Qe,mt,kt,Ft)),Ki=Qe.set(i.$jM.ExtHostUriOpeners,new bt.$Nkc(Qe)),gn=Qe.set(i.$jM.ExtHostProfileContentHandlers,new V.$skc(Qe));Qe.set(i.$jM.ExtHostInteractive,new ie.$fkc(Qe,ye,Ft,kt,mt));const mn=Qe.set(i.$jM.ExtHostInlineChat,new W.$5jc(Qe,kt,At,mt)),Ri=Qe.set(i.$jM.ExtHostChatAgents2,new o.$Zic(Qe,mt,kt)),Oi=Qe.set(i.$jM.ExtHostChatVariables,new f.$3ic(Qe)),Ji=Qe.set(i.$jM.ExtHostChat,new l.$Yic(Qe)),Qi=Qe.set(i.$jM.ExtHostAiRelatedInformation,new r.$Kic(Qe)),Yi=Qe.set(i.$jM.ExtHostAiEmbeddingVector,new Y.$2jc(Qe)),Zi=Qe.set(i.$jM.ExtHostIssueReporter,new ve.$gkc(Qe)),Si=Qe.set(i.$jM.ExtHostStatusBar,new nt.$Bkc(Qe,kt.converter)),Xi=Qe.set(i.$jM.ExtHostSpeech,new tt.$zkc(Qe)),xi=Object.values(i.$jM);Qe.assertRegistered(xi);const _i=new d.$Xic(Qe,Ft),$n=new D.$4ic(Qe),wi=new ee.$jkc(Qe,mt),ji=new L.$Yjc(Qe);return s.$Uic.register(kt),function(Ue,ci,en){function rt($e){return(ke,We,ut)=>{const wt=$e(Ot=>{try{ke.call(We,Ot)}catch(Bi){j.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Bi.toString()}`,{cause:Bi})),Rt.onExtensionError(Ue.identifier,Bi)}});return ut?.push(wt),wt}}const $t=function(){let $e=!Ue.isUnderDevelopment;function ke(){$e||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function We(ut){if(Array.isArray(ut))ut.forEach(We);else if(typeof ut=="string")ke();else{const wt=ut;typeof wt.scheme>"u"&&ke(),typeof wt.exclusive=="boolean"&&(0,_e.$7F)(Ue,"documentFiltersExclusive")}return ut}}(),tn={getSession($e,ke,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,_e.$7F)(Ue,"authLearnMore"),vt.getSession(Ue,$e,ke,We)},getSessions($e,ke){return(0,_e.$7F)(Ue,"authGetSessions"),vt.getSessions(Ue,$e,ke)},async hasSession($e,ke){return(0,_e.$7F)(Ue,"authSession"),!!await vt.getSession(Ue,$e,ke,{silent:!0})},get onDidChangeSessions(){return rt(vt.onDidChangeSessions)},registerAuthenticationProvider($e,ke,We,ut){return vt.registerAuthenticationProvider($e,ke,We,ut)}},nn={registerCommand($e,ke,We){return kt.registerCommand(!0,$e,ke,We,void 0,Ue)},registerTextEditorCommand($e,ke,We){return kt.registerCommand(!0,$e,(...ut)=>{const wt=ct.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return wt.edit(Ot=>{ke.apply(We,[wt,Ot,...ut])}).then(Ot=>{Ot||mt.warn("Edits from command "+$e+" were not applied.")},Ot=>{mt.warn("An error occurred while running command "+$e,Ot)})},void 0,void 0,Ue)},registerDiffInformationCommand:($e,ke,We)=>((0,_e.$7F)(Ue,"diffCommand"),kt.registerCommand(!0,$e,async(...ut)=>{const wt=Ft.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Ot=await ct.getDiffInformation(wt.id);ke.apply(We,[Ot,...ut])},void 0,void 0,Ue)),executeCommand($e,...ke){return kt.executeCommand($e,...ke)},getCommands($e=!1){return kt.getCommands($e)}},Li={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return rt(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return rt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$7F)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$7F)(Ue,"telemetry"),rt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ze.$VO)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,ke){return ze.$UO.validateSender($e),Rt.instantiateLogger(Ue,$e,ke)},openExternal($e,ke){return Lt.openUri($e,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===pt.environment.appUriScheme)return Xt.createAppUri($e);try{return await Lt.asExternalUri($e,{allowTunneling:!!pt.remote.authority})}catch(ke){if((0,A.$qg)($e,A.Schemas.http)||(0,A.$qg)($e,A.Schemas.https))return $e;throw ke}},get remoteName(){return(0,m.$tm)(pt.remote.authority)},get remoteAuthority(){return(0,_e.$7F)(Ue,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return rt(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,_e.$7F)(Ue,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Ue,$e)},registerIssueDataProvider($e){return(0,_e.$7F)(Ue,"handleIssueUri"),Zi.registerIssueDataProvider(Ue,$e)},get appQuality(){return(0,_e.$7F)(Ue,"resolvers"),pt.quality},get appCommit(){return(0,_e.$7F)(Ue,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Li);const rn={createTestController($e,ke,We){return bi.createTestController(Ue,$e,ke,We)},createTestObserver(){return(0,_e.$7F)(Ue,"testObserver"),bi.createTestObserver()},runTests($e){return(0,_e.$7F)(Ue,"testObserver"),bi.runTests($e)},get onDidChangeTestResults(){return(0,_e.$7F)(Ue,"testObserver"),rt(bi.onResultsChanged)},get testResults(){return(0,_e.$7F)(Ue,"testObserver"),bi.results}},Di=pt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,sn={getExtension($e,ke){(0,_e.$6F)(Ue,"extensionsAny")||(ke=!1);const We=ci.mine.getExtensionDescription($e);if(We)return new x.$Njc(qt,Ue.identifier,We,Di,!1);if(ke){const ut=ci.all.getExtensionDescription($e);if(ut)return new x.$Njc(qt,Ue.identifier,ut,Di,!0)}},get all(){const $e=[];for(const ke of ci.mine.getAllExtensionDescriptions())$e.push(new x.$Njc(qt,Ue.identifier,ke,Di,!1));return $e},get allAcrossExtensionHosts(){(0,_e.$7F)(Ue,"extensionsAny");const $e=new E.$Dm(ci.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ke=[];for(const We of ci.all.getAllExtensionDescriptions()){const ut=!$e.has(We.identifier);ke.push(new x.$Njc(qt,Ue.identifier,We,Di,ut))}return ke},get onDidChange(){return(0,_e.$6F)(Ue,"extensionsAny")?rt(R.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):rt(ci.mine.onDidChange)}},on={createDiagnosticCollection($e){return zt.createDiagnosticCollection(Ue.identifier,$e)},get onDidChangeDiagnostics(){return rt(zt.onDidChangeDiagnostics)},getDiagnostics:$e=>zt.getDiagnostics($e),getLanguages(){return Mt.getLanguages()},setTextDocumentLanguage($e,ke){return Mt.changeLanguage($e.uri,ke)},match($e,ke){const We=ot.LanguageSelector.from($e);let ut;return(0,M.$Vt)(We)&&(ut=ye.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Ot=>Ot.document===ke))?.apiNotebook),(0,M.$Ut)(We,ke.uri,ke.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider($e,ke,We){return lt.registerCodeActionProvider(Ue,$t($e),ke,We)},registerDocumentPasteEditProvider($e,ke,We){return(0,_e.$7F)(Ue,"documentPaste"),lt.registerDocumentPasteEditProvider(Ue,$t($e),ke,We)},registerCodeLensProvider($e,ke){return lt.registerCodeLensProvider(Ue,$t($e),ke)},registerDefinitionProvider($e,ke){return lt.registerDefinitionProvider(Ue,$t($e),ke)},registerDeclarationProvider($e,ke){return lt.registerDeclarationProvider(Ue,$t($e),ke)},registerImplementationProvider($e,ke){return lt.registerImplementationProvider(Ue,$t($e),ke)},registerTypeDefinitionProvider($e,ke){return lt.registerTypeDefinitionProvider(Ue,$t($e),ke)},registerHoverProvider($e,ke){return lt.registerHoverProvider(Ue,$t($e),ke,Ue.identifier)},registerEvaluatableExpressionProvider($e,ke){return lt.registerEvaluatableExpressionProvider(Ue,$t($e),ke,Ue.identifier)},registerInlineValuesProvider($e,ke){return lt.registerInlineValuesProvider(Ue,$t($e),ke,Ue.identifier)},registerDocumentHighlightProvider($e,ke){return lt.registerDocumentHighlightProvider(Ue,$t($e),ke)},registerMultiDocumentHighlightProvider($e,ke){return lt.registerMultiDocumentHighlightProvider(Ue,$t($e),ke)},registerLinkedEditingRangeProvider($e,ke){return lt.registerLinkedEditingRangeProvider(Ue,$t($e),ke)},registerReferenceProvider($e,ke){return lt.registerReferenceProvider(Ue,$t($e),ke)},registerRenameProvider($e,ke){return lt.registerRenameProvider(Ue,$t($e),ke)},registerNewSymbolNamesProvider($e,ke){return(0,_e.$7F)(Ue,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Ue,$t($e),ke)},registerDocumentSymbolProvider($e,ke,We){return lt.registerDocumentSymbolProvider(Ue,$t($e),ke,We)},registerWorkspaceSymbolProvider($e){return lt.registerWorkspaceSymbolProvider(Ue,$e)},registerDocumentFormattingEditProvider($e,ke){return lt.registerDocumentFormattingEditProvider(Ue,$t($e),ke)},registerDocumentRangeFormattingEditProvider($e,ke){return lt.registerDocumentRangeFormattingEditProvider(Ue,$t($e),ke)},registerOnTypeFormattingEditProvider($e,ke,We,...ut){return lt.registerOnTypeFormattingEditProvider(Ue,$t($e),ke,[We].concat(ut))},registerDocumentSemanticTokensProvider($e,ke,We){return lt.registerDocumentSemanticTokensProvider(Ue,$t($e),ke,We)},registerDocumentRangeSemanticTokensProvider($e,ke,We){return lt.registerDocumentRangeSemanticTokensProvider(Ue,$t($e),ke,We)},registerSignatureHelpProvider($e,ke,We,...ut){return typeof We=="object"?lt.registerSignatureHelpProvider(Ue,$t($e),ke,We):lt.registerSignatureHelpProvider(Ue,$t($e),ke,typeof We>"u"?[]:[We,...ut])},registerCompletionItemProvider($e,ke,...We){return lt.registerCompletionItemProvider(Ue,$t($e),ke,We)},registerInlineCompletionItemProvider($e,ke,We){return ke.handleDidShowCompletionItem&&(0,_e.$7F)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,_e.$7F)(Ue,"inlineCompletionsAdditions"),We&&(0,_e.$7F)(Ue,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ue,$t($e),ke,We)},registerInlineEditProvider($e,ke){return(0,_e.$7F)(Ue,"inlineEdit"),lt.registerInlineEditProvider(Ue,$t($e),ke)},registerDocumentLinkProvider($e,ke){return lt.registerDocumentLinkProvider(Ue,$t($e),ke)},registerColorProvider($e,ke){return lt.registerColorProvider(Ue,$t($e),ke)},registerFoldingRangeProvider($e,ke){return lt.registerFoldingRangeProvider(Ue,$t($e),ke)},registerSelectionRangeProvider($e,ke){return lt.registerSelectionRangeProvider(Ue,$e,ke)},registerCallHierarchyProvider($e,ke){return lt.registerCallHierarchyProvider(Ue,$e,ke)},registerTypeHierarchyProvider($e,ke){return lt.registerTypeHierarchyProvider(Ue,$e,ke)},setLanguageConfiguration:($e,ke)=>lt.setLanguageConfiguration(Ue,$e,ke),getTokenInformationAtPosition($e,ke){return(0,_e.$7F)(Ue,"tokenInformation"),Mt.tokenAtPosition($e,ke)},registerInlayHintsProvider($e,ke){return lt.registerInlayHintsProvider(Ue,$e,ke)},createLanguageStatusItem($e,ke){return Mt.createLanguageStatusItem(Ue,$e,ke)},registerDocumentDropEditProvider($e,ke,We){return lt.registerDocumentOnDropEditProvider(Ue,$e,ke,(0,_e.$6F)(Ue,"dropMetadata")?We:void 0)}},pn={get activeTextEditor(){return ct.getActiveTextEditor()},get visibleTextEditors(){return ct.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument($e,ke,We){$.URI.isUri($e)&&$e.scheme===A.Schemas.vscodeRemote&&!$e.authority&&Pt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri($e)?Promise.resolve(an.openTextDocument($e)):Promise.resolve($e));return ct.showTextDocument(ut,ke,We)},createTextEditorDecorationType($e){return ct.createTextEditorDecorationType(Ue,$e)},onDidChangeActiveTextEditor($e,ke,We){return rt(ct.onDidChangeActiveTextEditor)($e,ke,We)},onDidChangeVisibleTextEditors($e,ke,We){return rt(ct.onDidChangeVisibleTextEditors)($e,ke,We)},onDidChangeTextEditorSelection($e,ke,We){return rt(ct.onDidChangeTextEditorSelection)($e,ke,We)},onDidChangeTextEditorOptions($e,ke,We){return rt(ct.onDidChangeTextEditorOptions)($e,ke,We)},onDidChangeTextEditorVisibleRanges($e,ke,We){return rt(ct.onDidChangeTextEditorVisibleRanges)($e,ke,We)},onDidChangeTextEditorViewColumn($e,ke,We){return rt(ct.onDidChangeTextEditorViewColumn)($e,ke,We)},onDidCloseTerminal($e,ke,We){return rt(Ct.onDidCloseTerminal)($e,ke,We)},onDidOpenTerminal($e,ke,We){return rt(Ct.onDidOpenTerminal)($e,ke,We)},onDidChangeActiveTerminal($e,ke,We){return rt(Ct.onDidChangeActiveTerminal)($e,ke,We)},onDidChangeTerminalDimensions($e,ke,We){return(0,_e.$7F)(Ue,"terminalDimensions"),rt(Ct.onDidChangeTerminalDimensions)($e,ke,We)},onDidChangeTerminalState($e,ke,We){return rt(Ct.onDidChangeTerminalState)($e,ke,We)},onDidWriteTerminalData($e,ke,We){return(0,_e.$7F)(Ue,"terminalDataWriteEvent"),rt(Ct.onDidWriteTerminalData)($e,ke,We)},onDidExecuteTerminalCommand($e,ke,We){return(0,_e.$7F)(Ue,"terminalExecuteCommandEvent"),rt(Ct.onDidExecuteTerminalCommand)($e,ke,We)},get state(){return Lt.getState(Ue)},onDidChangeWindowState($e,ke,We){return rt(Lt.onDidChangeWindowState)($e,ke,We)},showInformationMessage($e,...ke){return wi.showMessage(Ue,p.default.Info,$e,ke[0],ke.slice(1))},showWarningMessage($e,...ke){return wi.showMessage(Ue,p.default.Warning,$e,ke[0],ke.slice(1))},showErrorMessage($e,...ke){return wi.showMessage(Ue,p.default.Error,$e,ke[0],ke.slice(1))},showQuickPick($e,ke,We){return $i.showQuickPick(Ue,$e,ke,We)},showWorkspaceFolderPick($e){return $i.showWorkspaceFolderPick($e)},showInputBox($e,ke){return $i.showInput($e,ke)},showOpenDialog($e){return ji.showOpenDialog(Ue,$e)},showSaveDialog($e){return ji.showSaveDialog($e)},createStatusBarItem($e,ke,We){let ut,wt,Ot;return typeof $e=="string"?(ut=$e,wt=ke,Ot=We):(wt=$e,Ot=ke),Si.createStatusBarEntry(Ue,ut,wt,Ot)},setStatusBarMessage($e,ke){return Si.setStatusBarMessage($e,ke)},withScmProgress($e){return Pt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),qi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ke,We)=>$e({report(ut){}}))},withProgress($e,ke){return qi.withProgress(Ue,$e,ke)},createOutputChannel($e,ke){return li.createOutputChannel($e,ke,Ue)},createWebviewPanel($e,ke,We,ut){return Ei.createWebviewPanel(Ue,$e,ke,We,ut)},createWebviewTextEditorInset($e,ke,We,ut){return(0,_e.$7F)(Ue,"editorInsets"),Kt.createWebviewEditorInset($e,ke,We,ut,Ue)},createTerminal($e,ke,We){return typeof $e=="object"?"pty"in $e?Ct.createExtensionTerminal($e):Ct.createTerminalFromOptions($e):Ct.createTerminal($e,ke,We)},registerTerminalLinkProvider($e){return Ct.registerLinkProvider($e)},registerTerminalProfileProvider($e,ke){return Ct.registerProfileProvider(Ue,$e,ke)},registerTerminalQuickFixProvider($e,ke){return(0,_e.$7F)(Ue,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider($e,Ue.identifier.value,ke)},registerTreeDataProvider($e,ke){return yt.registerTreeDataProvider($e,ke,Ue)},createTreeView($e,ke){return yt.createTreeView($e,ke,Ue)},registerWebviewPanelSerializer:($e,ke)=>Ei.registerWebviewPanelSerializer(Ue,$e,ke),registerCustomEditorProvider:($e,ke,We={})=>Hi.registerCustomEditorProvider(Ue,$e,ke,We),registerFileDecorationProvider($e){return Bt.registerFileDecorationProvider($e,Ue)},registerUriHandler($e){return Xt.registerUriHandler(Ue,$e)},createQuickPick(){return $i.createQuickPick(Ue)},createInputBox(){return $i.createInputBox(Ue)},get activeColorTheme(){return yi.activeColorTheme},onDidChangeActiveColorTheme($e,ke,We){return rt(yi.onDidChangeActiveColorTheme)($e,ke,We)},registerWebviewViewProvider($e,ke,We){return Gi.registerWebviewViewProvider(Ue,$e,ke,We?.webviewOptions)},get activeNotebookEditor(){return ye.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,ke,We){return rt(ye.onDidChangeActiveNotebookEditor)($e,ke,We)},get visibleNotebookEditors(){return ye.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return rt(ye.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,ke,We){return rt(je.onDidChangeNotebookEditorSelection)($e,ke,We)},onDidChangeNotebookEditorVisibleRanges($e,ke,We){return rt(je.onDidChangeNotebookEditorVisibleRanges)($e,ke,We)},showNotebookDocument($e,ke){return ye.showNotebookDocument($e,ke)},registerExternalUriOpener($e,ke,We){return(0,_e.$7F)(Ue,"externalUriOpener"),Ki.registerExternalUriOpener(Ue.identifier,$e,ke,We)},registerProfileContentHandler($e,ke){return(0,_e.$7F)(Ue,"profileContentHandlers"),gn.registerProfileContentHandler(Ue,$e,ke)},registerQuickDiffProvider($e,ke,We,ut){return(0,_e.$7F)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider($t($e),ke,We,ut)},get tabGroups(){return Gt.tabGroups},registerShareProvider($e,ke){return(0,_e.$7F)(Ue,"shareProvider"),Ai.registerShareProvider($t($e),ke)}},an={get rootPath(){return Pt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new j.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new j.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new j.$9("workspaceFile")},updateWorkspaceFolders:($e,ke,...We)=>ft.updateWorkspaceFolders(Ue,$e,ke||0,...We),onDidChangeWorkspaceFolders:function($e,ke,We){return rt(ft.onDidChangeWorkspace)($e,ke,We)},asRelativePath:($e,ke)=>ft.getRelativePath($e,ke),findFiles:($e,ke,We,ut)=>ft.findFiles($e,ke,We,Ue.identifier,ut),findFiles2:($e,ke,We)=>((0,_e.$7F)(Ue,"findFiles2"),ft.findFiles2($e,ke,Ue.identifier,We)),findTextInFiles:($e,ke,We,ut)=>{(0,_e.$7F)(Ue,"findTextInFiles");let wt,Ot;return typeof ke=="object"?(wt=ke,Ot=We):(wt={},Ot=ke,ut=We),ft.findTextInFiles($e,wt||{},Ot,Ue.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,ke){return _i.applyWorkspaceEdit($e,Ue,ke)},createFileSystemWatcher:($e,ke,We,ut)=>{let wt;return typeof ke=="boolean"?wt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!ut,correlate:!1}:ke&&((0,_e.$7F)(Ue,"createFileSystemWatcher"),wt={...ke,correlate:!0}),gi.createFileSystemWatcher(ft,Ue,$e,wt)},get textDocuments(){return At.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new j.$9("textDocuments")},openTextDocument($e){let ke;const We=$e;if(typeof $e=="string")ke=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))ke=Promise.resolve($e);else if(!We||typeof We=="object")ke=At.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(ut=>(ut.scheme===A.Schemas.vscodeRemote&&!ut.authority&&Pt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(ut).then(wt=>wt.document)))},onDidOpenTextDocument:($e,ke,We)=>rt(At.onDidAddDocument)($e,ke,We),onDidCloseTextDocument:($e,ke,We)=>rt(At.onDidRemoveDocument)($e,ke,We),onDidChangeTextDocument:($e,ke,We)=>rt(At.onDidChangeDocument)($e,ke,We),onDidSaveTextDocument:($e,ke,We)=>rt(At.onDidSaveDocument)($e,ke,We),onWillSaveTextDocument:($e,ke,We)=>rt(Be.getOnWillSaveTextDocumentEvent(Ue))($e,ke,We),get notebookDocuments(){return ye.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,ke){let We;if($.URI.isUri($e))We=$e,await ye.openNotebookDocument($e);else if(typeof $e=="string")We=$.URI.revive(await ye.createNotebookDocument({viewType:$e,content:ke}));else throw new Error("Invalid arguments");return ye.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument($e,ke,We){return rt(te.onDidSaveNotebookDocument)($e,ke,We)},onDidChangeNotebookDocument($e,ke,We){return rt(te.onDidChangeNotebookDocument)($e,ke,We)},onWillSaveNotebookDocument($e,ke,We){return rt(Ye.getOnWillSaveNotebookDocumentEvent(Ue))($e,ke,We)},get onDidOpenNotebookDocument(){return rt(ye.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return rt(ye.onDidCloseNotebookDocument)},registerNotebookSerializer($e,ke,We,ut){return ye.registerNotebookSerializer(Ue,$e,ke,We,(0,_e.$6F)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,ke,We)=>rt(en.onDidChangeConfiguration)($e,ke,We),getConfiguration($e,ke){return ke=arguments.length===1?void 0:ke,en.getConfiguration($e,ke,Ue)},registerTextDocumentContentProvider($e,ke){return Oe.registerTextDocumentContentProvider($e,ke)},registerTaskProvider:($e,ke)=>(Pt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),ti.registerTaskProvider(Ue,$e,ke)),registerFileSystemProvider($e,ke,We){return(0,P.$Rc)(Ii.registerFileSystemProvider(Ue,$e,ke,We),Wt.addFileSystemProvider($e,ke,We))},get fs(){return Wt.value},registerFileSearchProvider:($e,ke)=>((0,_e.$7F)(Ue,"fileSearchProvider"),ui.registerFileSearchProvider($e,ke)),registerTextSearchProvider:($e,ke)=>((0,_e.$7F)(Ue,"textSearchProvider"),ui.registerTextSearchProvider($e,ke)),registerAITextSearchProvider:($e,ke)=>((0,_e.$7F)(Ue,"aiTextSearchProvider"),(0,_e.$7F)(Ue,"textSearchProvider"),ui.registerAITextSearchProvider($e,ke)),registerRemoteAuthorityResolver:($e,ke)=>((0,_e.$7F)(Ue,"resolvers"),qt.registerRemoteAuthorityResolver($e,ke)),registerResourceLabelFormatter:$e=>((0,_e.$7F)(Ue,"resolvers"),Vi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,_e.$7F)(Ue,"resolvers"),qt.getRemoteExecServer($e)),onDidCreateFiles:($e,ke,We)=>rt(gi.onDidCreateFile)($e,ke,We),onDidDeleteFiles:($e,ke,We)=>rt(gi.onDidDeleteFile)($e,ke,We),onDidRenameFiles:($e,ke,We)=>rt(gi.onDidRenameFile)($e,ke,We),onWillCreateFiles:($e,ke,We)=>rt(gi.getOnWillCreateFileEvent(Ue))($e,ke,We),onWillDeleteFiles:($e,ke,We)=>rt(gi.getOnWillDeleteFileEvent(Ue))($e,ke,We),onWillRenameFiles:($e,ke,We)=>rt(gi.getOnWillRenameFileEvent(Ue))($e,ke,We),openTunnel:$e=>((0,_e.$7F)(Ue,"tunnels"),jt.openTunnel(Ue,$e).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,_e.$7F)(Ue,"tunnels"),jt.getTunnels()},onDidChangeTunnels:($e,ke,We)=>((0,_e.$7F)(Ue,"tunnels"),rt(jt.onDidChangeTunnels)($e,ke,We)),registerPortAttributesProvider:($e,ke)=>((0,_e.$7F)(Ue,"portsAttributes"),jt.registerPortsAttributesProvider($e,ke)),registerTunnelProvider:($e,ke)=>((0,_e.$7F)(Ue,"tunnelFactory"),jt.registerTunnelProvider($e,ke)),registerTimelineProvider:($e,ke)=>((0,_e.$7F)(Ue,"timeline"),Mi.registerTimelineProvider($e,ke,Ue.identifier,kt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,_e.$7F)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,ke,We)=>rt(ft.onDidGrantWorkspaceTrust)($e,ke,We),registerEditSessionIdentityProvider:($e,ke)=>((0,_e.$7F)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,ke)),onWillCreateEditSessionIdentity:($e,ke,We)=>((0,_e.$7F)(Ue,"editSessionIdentityProvider"),rt(ft.getOnWillCreateEditSessionIdentityEvent(Ue))($e,ke,We)),registerCanonicalUriProvider:($e,ke)=>((0,_e.$7F)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,ke)),getCanonicalUri:($e,ke,We)=>((0,_e.$7F)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri($e,ke,We))},cn={get inputBox(){return Pt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ue)},createSourceControl($e,ke,We){return vi.createSourceControl(Ue,$e,ke,We)}},Ni={createCommentController($e,ke){return Wi.createCommentController(Ue,$e,ke)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,_e.$6F)(Ue,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider($e,ke){return(0,_e.$7F)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,$e,ke)},registerDebugVisualizationTreeProvider($e,ke){return(0,_e.$7F)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,$e,ke)},onDidStartDebugSession($e,ke,We){return rt(Et.onDidStartDebugSession)($e,ke,We)},onDidTerminateDebugSession($e,ke,We){return rt(Et.onDidTerminateDebugSession)($e,ke,We)},onDidChangeActiveDebugSession($e,ke,We){return rt(Et.onDidChangeActiveDebugSession)($e,ke,We)},onDidReceiveDebugSessionCustomEvent($e,ke,We){return rt(Et.onDidReceiveDebugSessionCustomEvent)($e,ke,We)},onDidChangeBreakpoints($e,ke,We){return rt(Et.onDidChangeBreakpoints)($e,ke,We)},onDidChangeActiveStackItem($e,ke,We){return(0,_e.$7F)(Ue,"debugFocus"),rt(Et.onDidChangeActiveStackItem)($e,ke,We)},registerDebugConfigurationProvider($e,ke,We){return Et.registerDebugConfigurationProvider($e,ke,We||ai.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,ke){return Et.registerDebugAdapterDescriptorFactory(Ue,$e,ke)},registerDebugAdapterTrackerFactory($e,ke){return Et.registerDebugAdapterTrackerFactory($e,ke)},startDebugging($e,ke,We){return!We||typeof We=="object"&&"configuration"in We?Et.startDebugging($e,ke,{parentSession:We}):Et.startDebugging($e,ke,We||{})},stopDebugging($e){return Et.stopDebugging($e)},addBreakpoints($e){return Et.addBreakpoints($e)},removeBreakpoints($e){return Et.removeBreakpoints($e)},asDebugSourceUri($e,ke){return Et.asDebugSourceUri($e,ke)}},ln={registerTaskProvider:($e,ke)=>ti.registerTaskProvider(Ue,$e,ke),fetchTasks:$e=>ti.fetchTasks($e),executeTask:$e=>ti.executeTask(Ue,$e),get taskExecutions(){return ti.taskExecutions},onDidStartTask:($e,ke,We)=>rt(ti.onDidStartTask)($e,ke,We),onDidEndTask:($e,ke,We)=>rt(ti.onDidEndTask)($e,ke,We),onDidStartTaskProcess:($e,ke,We)=>rt(ti.onDidStartTaskProcess)($e,ke,We),onDidEndTaskProcess:($e,ke,We)=>rt(ti.onDidEndTaskProcess)($e,ke,We)},hn={createNotebookController($e,ke,We,ut,wt){return qe.createNotebookController(Ue,$e,ke,We,ut,(0,_e.$6F)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:($e,ke)=>ye.registerNotebookCellStatusBarItemProvider(Ue,$e,ke),createRendererMessaging($e){return et.createRendererMessaging(Ue,$e)},createNotebookControllerDetectionTask($e){return(0,_e.$7F)(Ue,"notebookKernelSource"),qe.createNotebookControllerDetectionTask(Ue,$e)},registerKernelSourceActionProvider($e,ke){return(0,_e.$7F)(Ue,"notebookKernelSource"),qe.registerKernelSourceActionProvider(Ue,$e,ke)},onDidChangeNotebookCellExecutionState($e,ke,We){return(0,_e.$7F)(Ue,"notebookCellExecutionState"),rt(qe.onDidChangeNotebookCellExecutionState)($e,ke,We)}},bn={t(...$e){if(typeof $e[0]=="string"){const ke=$e.shift(),We=!$e||typeof $e[0]!="object"?$e:$e[0];return di.getMessage(Ue.identifier.value,{message:ke,args:We})}return di.getMessage(Ue.identifier.value,$e[0])},get bundle(){return di.getBundle(Ue.identifier.value)},get uri(){return di.getBundleUri(Ue.identifier.value)}},wn={_version:1,registerInteractiveEditorSessionProvider($e,ke){return(0,_e.$7F)(Ue,"interactive"),mn.registerProvider(Ue,$e,ke)},registerInteractiveSessionProvider($e,ke){return(0,_e.$7F)(Ue,"interactive"),Ji.registerChatProvider(Ue,$e,ke)},transferChatSession($e,ke){return(0,_e.$7F)(Ue,"interactive"),Ji.transferChatSession($e,ke)}},dn={getRelatedInformation($e,ke){return(0,_e.$7F)(Ue,"aiRelatedInformation"),Qi.getRelatedInformation(Ue,$e,ke)},registerRelatedInformationProvider($e,ke){return(0,_e.$7F)(Ue,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ue,$e,ke)},registerEmbeddingVectorProvider($e,ke){return(0,_e.$7F)(Ue,"aiRelatedInformation"),Yi.registerEmbeddingVectorProvider(Ue,$e,ke)}},fn={registerChatResponseProvider($e,ke,We){return(0,_e.$7F)(Ue,"chatProvider"),Nt.registerLanguageModel(Ue,$e,ke,We)},registerChatVariableResolver($e,ke,We){return(0,_e.$7F)(Ue,"chatVariableResolver"),Oi.registerVariableResolver(Ue,$e,ke,We)},registerMappedEditsProvider($e,ke){return(0,_e.$7F)(Ue,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ue,$e,ke)},createChatParticipant($e,ke){return(0,_e.$7F)(Ue,"chatParticipant"),Ri.createChatAgent(Ue,$e,ke)}},Fi={get languageModels(){return(0,_e.$7F)(Ue,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:($e,ke,We)=>((0,_e.$7F)(Ue,"languageModels"),Nt.onDidChangeProviders($e,ke,We)),sendChatRequest($e,ke,We,ut){return(0,_e.$7F)(Ue,"languageModels"),Nt.sendChatRequest(Ue,$e,ke,We,ut)}},Ti={registerSpeechProvider($e,ke){return(0,_e.$7F)(Ue,"speech"),Xi.registerProvider(Ue.identifier,$e,ke)}};return{version:pt.version,ai:dn,authentication:tn,commands:nn,comments:Ni,chat:fn,debug:un,env:Li,extensions:sn,interactive:wn,l10n:bn,languages:on,lm:Fi,notebooks:hn,scm:cn,speech:Ti,tasks:ln,tests:rn,window:pn,workspace:an,Breakpoint:Ne.$kN,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$dO,CallHierarchyIncomingCall:Ne.$IM,CallHierarchyItem:Ne.$HM,CallHierarchyOutgoingCall:Ne.$JM,CancellationError:j.$5,CancellationTokenSource:u.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Ne.$EM,CodeActionKind:Ne.$FM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$KM,Color:Ne.$XM,ColorInformation:Ne.$YM,ColorPresentation:Ne.$ZM,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CommentThreadApplicability:Ne.CommentThreadApplicability,CompletionItem:Ne.$RM,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$SM,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$8M,DebugAdapterExecutable:Ne.$oN,DebugAdapterInlineImplementation:Ne.$rN,DebugAdapterNamedPipeServer:Ne.$qN,DebugAdapterServer:Ne.$pN,DebugConfigurationProviderTriggerKind:ai.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$HN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$yM,DiagnosticRelatedInformation:Ne.$xM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$kM,DocumentHighlight:Ne.$AM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$BM,DocumentLink:Ne.$WM,DocumentSymbol:Ne.$DM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$uN,InlineValueText:Ne.$vN,InlineValueVariableLookup:Ne.$wN,InlineValueEvaluatableExpression:Ne.$xN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:R.$7d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$JN,FileDecoration2:Ne.$JN,FileSystemError:Ne.$AN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$BN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$mN,InlineCompletionItem:Ne.$TM,InlineCompletionList:Ne.$UM,Hover:Ne.$zM,IndentAction:I.IndentAction,Location:Ne.$wM,MarkdownString:Ne.$LM,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:Ne.$MM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$lM,ProcessExecution:Ne.$6M,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$IN,Range:Ne.$mM,RelativePattern:Ne.$iN,Selection:Ne.$nM,SelectionRange:Ne.$GM,SemanticTokens:Ne.$EN,SemanticTokensBuilder:Ne.$DN,SemanticTokensEdit:Ne.$FN,SemanticTokensEdits:Ne.$GN,SemanticTokensLegend:Ne.$CN,ShellExecution:Ne.$7M,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$OM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$NM,SnippetString:Ne.$vM,SourceBreakpoint:Ne.$lN,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$CM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$9M,TaskGroup:Ne.$5M,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$1M,TerminalQuickFixTerminalCommand:Ne.$3M,TerminalQuickFixOpener:Ne.$2M,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$4M,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$rM,SnippetTextEdit:Ne.$tM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$hN,ThemeIcon:Ne.$gN,TreeItem:Ne.$0M,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$5N,UIKind:ii.UIKind,Uri:$.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$uM,DocumentPasteTriggerKind:Ne.DocumentPasteTriggerKind,DocumentDropEdit:Ne.$dN,DocumentPasteEditKind:Ne.$eN,DocumentPasteEdit:Ne.$fN,InlayHint:Ne.$QM,InlayHintLabelPart:Ne.$PM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$qM,ResolvedAuthority:Ne.$oM,ManagedResolvedAuthority:Ne.$pM,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$TN,NotebookRange:Ne.$LN,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$MN,NotebookData:Ne.$NN,NotebookRendererScript:Ne.$RN,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$PN,NotebookCellOutputItem:Ne.$ON,NotebookCellStatusBarItem:Ne.$QN,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$sM,NotebookKernelSourceAction:Ne.$SN,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$VN,LinkedEditingRanges:Ne.$UN,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$WN,TestMessage:Ne.$XN,TestTag:Ne.$YN,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:_t.TextSearchCompleteMessageType,DataTransfer:Ne.$cN,DataTransferItem:Ne.$$M,CoveredCount:Ne.$ZN,FileCoverage:Ne.$1N,StatementCoverage:Ne.$2N,BranchCoverage:Ne.$3N,DeclarationCoverage:Ne.$4N,FunctionCoverage:Ne.$4N,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$6N,TabInputTextDiff:Ne.$7N,TabInputTextMerge:Ne.$8N,TabInputCustom:Ne.$9N,TabInputNotebook:Ne.$$N,TabInputNotebookDiff:Ne.$_N,TabInputWebview:Ne.$0N,TabInputTerminal:Ne.$aO,TabInputInteractiveWindow:Ne.$bO,TabInputChat:Ne.$cO,TelemetryTrustedValue:a.$3o,LogLevel:c.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrame:Ne.$sN,Thread:Ne.$tN,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,PartialAcceptTriggerKind:Ne.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$eO,ChatResponseFileTreePart:Ne.$fO,ChatResponseAnchorPart:Ne.$gO,ChatResponseProgressPart:Ne.$hO,ChatResponseReferencePart:Ne.$jO,ChatResponseCommandButtonPart:Ne.$iO,ChatRequestTurn:Ne.$kO,ChatResponseTurn:Ne.$lO,ChatLocation:Ne.ChatLocation,LanguageModelChatSystemMessage:Ne.$mO,LanguageModelChatUserMessage:Ne.$nO,LanguageModelChatAssistantMessage:Ne.$oO,LanguageModelSystemMessage:Ne.$mO,LanguageModelUserMessage:Ne.$nO,LanguageModelAssistantMessage:Ne.$oO,LanguageModelError:Ne.$pO,NewSymbolName:Ne.$zN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$qO,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}}),define(Ee[381],Se([1,0,84,156,43,151,44,33,72,47,95,96,97,118,70,91,150,69,59,117,90,71,149,12,60,115,116,120,121]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g,d,l,o,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$fs)(l.$Hjc,l.$Gjc,1),(0,u.$fs)(g.$Oj,t.$Tkc,1),(0,u.$fs)(c.$Lic,c.$Mic,1),(0,u.$fs)(p.$YO,p.$XO,0),(0,u.$fs)(h.$Vic,h.$Wic,0),(0,u.$fs)(f.$1ic,f.$2ic,0),(0,u.$fs)(A.$bjc,A.$_ic,0),(0,u.$fs)(a.$djc,a.$cjc,0),(0,u.$fs)(I.$Rjc,I.$Vjc,0),(0,u.$fs)(P.$Xjc,P.$Wjc,0),(0,u.$fs)($.$NO,$.$MO,0),(0,u.$fs)(o.$Ijc,o.$Jjc,0),(0,u.$fs)(n.$Pic,n.$Oic,0),(0,u.$fs)(j.$rkc,j.$qkc,1),(0,u.$fs)(b.$bkc,b.$ckc,0),(0,u.$fs)(E.$wjc,E.$vjc,0),(0,u.$fs)(M.$Ekc,M.$Dkc,0),(0,u.$fs)(k.$zjc,k.$Cjc,0),(0,u.$fs)(v.$eBb,v.$fBb,0),(0,u.$fs)(m.$Rkc,m.$Qkc,0),(0,u.$fs)(R.$$ic,R.$0ic,0),(0,u.$fs)(i.$Ejc,i.$Djc,0),(0,u.$fs)(r.$WO,r.$TO,0),(0,u.$fs)(s.$njc,s.$ojc,0),(0,u.$fs)(d.$Pjc,d.$Qjc,0)}),define(Ee[122],Se([1,0,19,12,36,94]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0,e.$0kc=A,e.$$kc=p;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function p(I,b,E,v){const c=(0,u.$2b)(E,$),m=new R.$BK(b,c,v),a=m.preview.matches;return{ranges:(0,u.$2b)(c,k),uri:I,preview:{text:m.preview.text,matches:(0,u.$2b)(a,k)}}}function $(I){return new R.$CK(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new P.$qK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let M=class{constructor(b,E){this.a=b,this.b=E}appendLine(b){this.b.debug(`${this.a}#search`,b)}};e.$_kc=M,e.$_kc=M=Je([Ve(1,j.$Nj)],M)}),define(Ee[382],Se([1,0,52,17,76,34,11,14,122,383]),function(de,e,u,j,R,P,A,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=I,e.$blc=m,e.$clc=n;const M=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,r,s,t){const g=b(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(M,g.args,{cwd:d}),rgDiskPath:M,siblingClauses:g.siblingClauses,rgArgs:g,cwd:d}}function b(i,r,s,t){const g=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],s,!1).forEach(l=>{const o=(0,$.$0kc)(l);if(g.push("-g",o),A.$j){const h=(0,R.$Zl)(o);h!==o&&g.push("-g",h)}});const d=E([r],t,void 0,!1);return d.globArgs.forEach(l=>{const o=`!${(0,$.$0kc)(l)}`;if(g.push("-g",o),A.$j){const h=(0,R.$Zl)(o);h!==o&&g.push("-g",h)}}),r.disregardIgnoreFiles!==!1?g.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&g.push("--no-ignore-parent"),r.ignoreSymlinks||g.push("--follow"),i.exists&&g.push("--quiet"),g.push("--no-config"),r.disregardGlobalIgnoreFiles&&g.push("--no-ignore-global"),{args:g,siblingClauses:d.siblingClauses}}function E(i,r,s,t=!0){const g=[];let d={};return i.forEach(l=>{const o=Object.assign({},l.excludePattern||{},r||{}),h=c(o,t?l.folder.fsPath:void 0,s);g.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:g,siblingClauses:d}}function v(i,r,s=!0){const t=[];return i.forEach(g=>{const d=Object.assign({},r||{},g.includePattern||{}),l=c(d,s?g.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function c(i,r,s){const t=[],g={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=a(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(g[d]=l)}),{globArgs:t,siblingClauses:g}}function m(i,r){return j.$jc(r)?r:j.$kc(i,r)}function a(i){return i=p.$6e(i,"\\"),p.$6e(i,"/")}function n(i){return P.$dg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Ee[384],Se([1,0,52,51,17,385,19,46,35,76,34,11,39,14,18,31,36,382,132]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$bk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$gr)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$bk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(o=>{const h=Object.assign({},o.excludePattern||{},this.a.excludePattern||{}),f=o.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==f).forEach(D=>{(0,M.$hg)(D,f)&&(h[R.$mc(f,D)]=!0)}),this.t.set(f,new t(h,f))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,o,h,f,D){if(this.m=b.$3d.create(!1),this.l)return D(null,this.j);o.forEach(w=>{const S=R.$oc(w.fsPath);this.u&&this.u(w.fsPath,S)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=b.$3d.create(!1),this.w(l,(w,S)=>{this.x(this.y,this,w,h,f,y=>{if(y){const C=(0,p.$5i)(y);console.error(C),this.q.push(C),S(y,void 0)}else S(null,void 0)})},(w,S)=>{this.m.stop();const y=w?A.$Hb(w)[0]:null;D(y,this.j)})}w(l,o,h){const f=new Array(l.length),D=new Array(l.length);let w=!1,S=0;if(l.length===0)return h(null,[]);l.forEach((y,C)=>{o(y,(O,z)=>{if(O?(w=!0,f[C]=null,D[C]=O):(f[C]=z,D[C]=null),++S===l.length)return h(w?D:null,f)})})}x(l,o,...h){try{l.apply(o,h)}catch(f){h[h.length-1](f)}}y(l,o,h,f){const D=l.folder.fsPath,w=I.$j,S=()=>F&&F.kill();i.add(S);let y=B=>{i.delete(S),y=()=>{},f(B)},C="";const O=this.D(),z=(0,a.$alc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),F=z.cmd,T=!Object.keys(z.siblingClauses).length,L=z.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let N=`${z.rgDiskPath} ${L}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:N}),this.s=0,this.z(F,"utf8",h,(B,U,Z)=>{if(B){y(B);return}if(this.j){y();return}const Y=(C+(w?k.$Yl(U||""):U)).split(`
`);if(Z){const x=Y.length;Y[x-1]=Y[x-1].trim(),Y[x-1]||Y.pop()}else C=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Y.length,T){for(const x of Y)if(this.J(o,{base:D,relativePath:x,searchPath:this.N(l,x)}),this.j){S();break}(Z||this.j)&&y();return}this.G(l,O,D,Y,o),Z&&(this.H(O,D,o),y())})}spawnFindCmd(l){const o=this.t.get(l.folder.fsPath),h=o.getBasenameTerms(),f=o.getPathTerms(),D=["-L","."];if(h.length||f.length){D.push("-not","(","(");for(const w of h)D.push("-name",w),D.push("-o");for(const w of f)D.push("-path",w),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,o,h){let f="";this.z(l,o,()=>{},(D,w,S)=>{if(D){h(D);return}f+=w,S&&h(null,f)})}z(l,o,h,f){let D=(y,C,O)=>{(y||O)&&(D=()=>{},this.r?.stop()),f(y,C,O)},w=!1;l.stdout?(this.A(l.stdout,o,D),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let S;l.stderr?S=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let C;!w&&(C=this.C(S,o))&&g(C)?D(new Error(`command failed with error code ${y}: ${this.C(S,o)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(l,o,h){const f=new P.StringDecoder(o);return l.on("data",D=>{h(null,f.write(D))}),f}B(l){const o=[];return l.on("data",h=>{o.push(h)}),o}C(l,o){const h=new P.StringDecoder(o);return l.map(f=>h.write(f)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:o},h,f,D){f.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=S=>{const y=R.$oc(S),C=R.$nc(S);let O=o[C];O||(O=o[C]=[],w(C)),O.push({base:h,relativePath:S,basename:y,searchPath:this.N(l,S)})};f.forEach(w)}H({rootEntries:l,pathToEntries:o},h,f){const D=this,w=this.t.get(h),S=this.b;function y(C){D.o++;const O=(0,m.$RK)(()=>C.map(z=>z.basename));for(let z=0,F=C.length;z<F;z++){const T=C[z],{relativePath:L,basename:N}=T;if(w.test(L,N,S!==N?O:void 0))continue;const B=o[L];if(B)y(B);else{if(D.p++,L===S)continue;D.J(f,T)}if(D.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,o,h,f,D){const w=l.folder,S=(0,m.$RK)(()=>h);this.w(h,(y,C)=>{if(this.l||this.j)return C(null);const O=o?[o,y].join(R.sep):y;if(this.t.get(l.folder.fsPath).test(O,y,this.a.filePattern!==y?S:void 0))return C(null);const z=[w.fsPath,O].join(R.sep);j.lstat(z,(F,T)=>{if(F||this.l||this.j)return C(null);this.L(z,T,(L,N)=>L||this.l||this.j?C(null):N.isDirectory()?(this.o++,this.M(z,T,(B,U)=>B||this.l||this.j||(U=U||"",this.v[U])?C(null):(this.v[U]=!0,c.Promises.readdir(z).then(Z=>{if(this.l||this.j)return C(null);this.I(l,O,Z,f,_=>C(_||null))},Z=>{C(null)})))):(this.p++,O===this.b||this.h&&v.$Yf(N.size)&&N.size>this.h||this.J(f,{base:w.fsPath,relativePath:O,searchPath:this.N(l,O)}),C(null,void 0)))})},y=>{const C=y&&A.$Hb(y);return D(C&&C.length>0?C[0]:void 0)})}J(l,o){this.K(o)&&(!this.d||this.d(o.relativePath,R.$oc(o.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(o))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$MK)(l,this.c);if(this.b)return(0,m.$MK)(l,this.b,!1)}return!0}L(l,o,h){return o.isSymbolicLink()?j.stat(l,h):h(null,o)}M(l,o,h){return o.isSymbolicLink()?j.realpath(l,(f,D)=>f?h(f):h(null,D)):h(null,l)}N(l,o){return l.folderName?R.$kc(l.folderName,o):o}}e.$dlc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,o,h){this.c.walk(this.a,this.b,l,o,(f,D)=>{h(f,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$elc=s;class t{constructor(l,o){this.expression=l,this.c=o,this.d(l)}d(l){let o,h;Object.keys(l).filter(f=>l[f]).forEach(f=>{R.$jc(f)?(o=o||$.$9j(),o[f]=l[f]):(h=h||$.$9j(),h[f]=l[f])}),this.a=o&&$.$bk(o,{trimForExclusions:!0}),this.b=h&&$.$bk(h,{trimForExclusions:!0})}test(l,o,h){return this.b&&this.b(l,o,h)||this.a&&this.a(R.$kc(this.c,l),o,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$dk(this.a)),this.b&&l.push(...$.$dk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$ek(this.a)),this.b&&l.push(...$.$ek(this.b)),l}}function g(d){const l=d.trim().split(`
`),o=l[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return E.$Mf(l[l.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(Ee[386],Se([1,0,98,21,192,22]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UD=e.$MD=e.DecodeStreamErrorKind=e.$LD=e.$KD=e.$JD=e.$HD=e.$GD=e.$FD=e.$ED=void 0,e.$ID=A,e.$ND=v,e.$OD=c,e.$PD=m,e.$QD=a,e.$RD=n,e.$SD=d,e.$TD=l,e.$ED="utf8",e.$FD="utf8bom",e.$GD="utf16be",e.$HD="utf16le";function A(o){return[e.$ED,e.$FD,e.$GD,e.$HD].some(h=>h===o)}e.$JD=[254,255],e.$KD=[255,254],e.$LD=[239,187,191];const p=512,$=512,k=512*8,M=512*128;var I;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class b extends Error{constructor(h,f){super(h),this.decodeStreamErrorKind=f}}e.$MD=b;class E{static async create(h){let f;if(h!==e.$ED)f=(await(0,R.$DD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(h));else{const D=new TextDecoder;f={write(w){return D.decode(w,{stream:!0})},end(){return D.decode()}}}return new E(f)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function v(o,h){const f=h.minBytesRequiredForDetection??h.guessEncoding?k:$;return new Promise((D,w)=>{const S=(0,u.$ie)(T=>T.join("")),y=[];let C=0,O;const z=new P.$ee,F=async()=>{try{const T=await l({buffer:j.$ue.concat(y),bytesRead:C},h.guessEncoding);if(T.seemsBinary&&h.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);T.encoding=await h.overwriteEncoding(T.encoding),O=await E.create(T.encoding);const L=O.write(j.$ue.concat(y).buffer);S.write(L),y.length=0,C=0,D({stream:S,detected:T})}catch(T){z.cancel(),S.destroy(),w(T)}};(0,u.$me)(o,{onData:async T=>{O?S.write(O.write(T.buffer)):(y.push(T),C+=T.byteLength,C>=f&&(o.pause(),await F(),setTimeout(()=>o.resume())))},onError:T=>S.error(T),onEnd:async()=>{O||await F(),S.end(O?.end())}},z.token)})}async function c(o,h,f){const w=(await(0,R.$DD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(h),f);let S=!1,y=!1;return{read(){if(y)return null;const C=o.read();if(typeof C!="string"){if(y=!0,!S&&f?.addBOM)switch(h){case e.$ED:case e.$FD:return j.$ue.wrap(Uint8Array.from(e.$LD));case e.$GD:return j.$ue.wrap(Uint8Array.from(e.$JD));case e.$HD:return j.$ue.wrap(Uint8Array.from(e.$KD))}const O=w.end();return O&&O.length>0?(S=!0,j.$ue.wrap(O)):null}return S=!0,j.$ue.wrap(w.write(C))}}}async function m(o){return(await(0,R.$DD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(o))}function a(o){return o===e.$FD||o===null?e.$ED:o}function n(o,h){if(!o||h<e.$JD.length)return null;const f=o.readUInt8(0),D=o.readUInt8(1);if(f===e.$JD[0]&&D===e.$JD[1])return e.$GD;if(f===e.$KD[0]&&D===e.$KD[1])return e.$HD;if(h<e.$LD.length)return null;const w=o.readUInt8(2);return f===e.$LD[0]&&D===e.$LD[1]&&w===e.$LD[2]?e.$FD:null}const i=["ascii","utf-16","utf-32"];async function r(o){const h=await(0,R.$DD)("jschardet","dist/jschardet.min.js"),f=o.slice(0,M),D=g(f.buffer),w=h.detect(D);if(!w||!w.encoding)return null;const S=w.encoding.toLowerCase();return 0<=i.indexOf(S)?null:t(w.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(o){const h=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function g(o){let h="";for(let f=0;f<o.length;f++)h+=String.fromCharCode(o[f]);return h}function d(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=o.match(/windows(\d+)/);return h?"windows-"+h[1]:o}}}function l({buffer:o,bytesRead:h},f){let D=n(o,h),w=!1;if(D!==e.$GD&&D!==e.$HD&&o){let S=!0,y=!0,C=!1;for(let O=0;O<h&&O<p;O++){const z=O%2===1,F=o.readUInt8(O)===0;if(F&&(C=!0),S&&(z&&!F||!z&&F)&&(S=!1),y&&(z&&F||!z&&!F)&&(y=!1),F&&!S&&!y)break}C&&(S?D=e.$HD:y?D=e.$GD:w=!0)}return f&&!w&&!D&&o?r(o.slice(0,h)).then(S=>({seemsBinary:!1,encoding:S})):{seemsBinary:w,encoding:D}}e.$UD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[159],Se([1,0,386,31,158]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;class P extends R.$0jc{constructor(p,$,k=j,M="searchProcess"){super({query:p,provider:$},{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.$SD)(I)},M)}}e.$mlc=P}),define(Ee[160],Se([1,0,52,402,385,19,73,35,14,2,36,94,403,383,122]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=void 0,e.$hlc=t,e.$ilc=d,e.$jlc=o,e.$klc=h,e.$llc=D;const c=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(S){this.a=S}provideTextSearchResults(S,y,C,O){return this.a.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,F)=>{O.onCancellationRequested(()=>Y());const T=t(S,y),L=y.folder.fsPath,N=T.map(ae=>ae.match(/^-/)?ae:`'${ae}'`).join(" ");this.a.appendLine(`${c} ${N}
 - cwd: ${L}`);let B=u.spawn(c,T,{cwd:L});B.on("error",ae=>{console.error(ae),this.a.appendLine("Error: "+(ae&&ae.message)),F((0,M.$IK)(new M.$GK(ae&&ae.message,M.SearchErrorCode.rgProcessError)))});let U=!1;const Z=new i(y.maxResults,y.folder,y.previewOptions);Z.on("result",ae=>{U=!0,ce="",C.report(ae)});let _=!1;const Y=()=>{_=!0,B?.kill(),Z?.cancel()};let x=!1;Z.on("hitLimit",()=>{x=!0,Y()});let ce="";B.stdout.on("data",ae=>{Z.handleData(ae),U||(ce+=ae)});let X=!1;B.stdout.once("data",()=>X=!0);let me="";B.stderr.on("data",ae=>{const re=ae.toString();this.a.appendLine(re),me.length+re.length<1e6&&(me+=re)}),B.on("close",()=>{if(this.a.appendLine(X?"Got data from stdout":"No data from stdout"),this.a.appendLine(U?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),_)z({limitHit:x});else{Z.flush(),B=null;let ae;me&&!X&&(ae=a(me))?F((0,M.$IK)(new M.$GK(ae.message,ae.code))):z({limitHit:x})}})})}}e.$flc=m;function a(w){const S=w.split(`
`),y=S[0].trim();if(S.some(O=>O.startsWith("regex parse error")))return new M.$GK(n(S),M.SearchErrorCode.regexParseError);const C=y.match(/grep config error: unknown encoding: (.*)/);if(C)return new M.$GK(`Unknown encoding: ${C[1]}`,M.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new M.$GK(y.charAt(0).toUpperCase()+y.substr(1),M.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new M.$GK(y.charAt(0).toUpperCase()+y.substr(1),M.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new M.$GK(y,M.SearchErrorCode.regexParseError)}function n(w){const S=["Regex parse error"],y=w.filter(C=>C.startsWith("PCRE2:"));if(y.length>=1){const C=y[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const O=C.split(":")[1];S.push(":"+O)}}return S.join("")}class i extends j.EventEmitter{constructor(S,y,C){super(),this.g=S,this.h=y,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new R.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(S,y){return super.on(S,y),this}handleData(S){if(this.b)return;const y=typeof S=="string"?S:this.d.write(S);this.k(y)}k(S){let y=S.indexOf(`
`);const C=this.a+S;if(y>=0)y+=this.a.length;else{this.a=C;return}let O=0;for(;y>=0;)this.m(C.substring(O,y).trim()),O=y+1,y=C.indexOf(`
`,O);this.a=C.substring(O)}m(S){if(this.b||!S)return;let y;try{y=JSON.parse(S)}catch{throw new Error(`malformed line from rg: ${S}`)}if(y.type==="match"){const C=r(y.data.path),O=k.URI.joinPath(this.h,C),z=this.n(y.data,O);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const C=r(y.data.path),O=k.URI.joinPath(this.h,C);this.o(y.data,O).forEach(F=>this.p(F))}}n(S,y){const C=S.line_number-1,O=r(S.lines),z=Buffer.from(O);let F=0,T=0,L=C;S.submatches.length===0&&S.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.$Hb)(S.submatches.map((B,U)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=r(B.match),_=z.slice(F,B.start).toString(),Y=s(_),x=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+T,ce=s(Z),X=Y.numLines+L,me=ce.numLines+X,ae=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+x;return F=B.end,T=ae,L=me,new I.$qK(X,x,me,ae)}));return(0,v.$$kc)(y,O,N,this.j)}o(S,y){const C=r(S.lines),O=S.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((z,F)=>({text:z,uri:y,lineNumber:O+F}))}p(S){this.emit("result",S)}}e.$glc=i;function r(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function s(w){const S=/\n/g;let y=0,C=-1,O;for(;O=S.exec(w);)y++,C=O.index;const z=C>=0?w.length-C-1:w.length;return{numLines:y,lastLineLength:z}}function t(w,S){const y=["--hidden","--no-require-git"];y.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:O}=(0,A.$K)(S.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const F=new Set;O.forEach(T=>{F.add(T)}),y.push("-g","!*"),F.forEach(T=>{g(T).map(v.$0kc).forEach(L=>{y.push("-g",L)})})}C&&C.length&&C.forEach(F=>{y.push("-g",F)}),S.excludes.map(v.$0kc).forEach(F=>y.push("-g",`!${F}`)),S.maxFileSize&&y.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?S.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),S.followSymlinks&&y.push("--follow"),S.encoding&&S.encoding!=="utf8"&&y.push("--encoding",S.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,$.$Ze)(w.pattern),w.isRegExp=!0),S.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),y.push("--engine","auto"));let z;if(w.isWordMatch){const T=(0,$.$9e)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",T)}else if(w.isRegExp){let F=o(w.pattern);F=h(F),y.push("--regexp",F)}else z=w.pattern,y.push("--fixed-strings");return y.push("--no-config"),S.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),w.isMultiline&&y.push("--multiline"),S.beforeContext&&y.push("--before-context",S.beforeContext+""),S.afterContext&&y.push("--after-context",S.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}function g(w){return D(w).flatMap(y=>{const C=(0,p.$_j)(y,"/");return C.map((O,z)=>C.slice(0,z+1).join("/"))})}function d(w){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(S);)w=w.replace(S,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");return w}const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function o(w){let S;try{S=new b.RegExpParser().parsePattern(w)}catch{return w}let y="",C=0;const O=(T,L,N)=>{y+=w.slice(C,T)+N,C=L},z=[];return new b.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const L=z[0];if(!L)O(T.start,T.end,"\\r?\\n");else if(!z.some(l))if(L.type==="CharacterClass")if(L.negate){const N=w.slice(L.start+2,T.start)+w.slice(T.end,L.end-1);L.parent?.type==="Quantifier"?O(L.start,L.end,N?`[^${N}]`:"."):O(L.start,L.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=w.slice(L.start+1,T.start)+w.slice(T.end,L.end-1);O(L.start,L.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else L.type==="Quantifier"&&O(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){z.unshift(T)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(T){z.unshift(T)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(T){z.unshift(T)},onCharacterClassLeave(){z.shift()},onAssertionEnter(T){l(T)&&z.push(T)},onAssertionLeave(T){z[0]===T&&z.shift()}}).visit(S),y+=w.slice(C),y}function h(w){return w.replace(/\n/g,"\\r?\\n")}function f(w){let S=!1,y=!1,C="",O="";for(let z=0;z<w.length;z++){const F=w[z];switch(F){case"\\":y?(S?O+="\\"+F:C+="\\"+F,y=!1):y=!0;break;case"{":if(y)S?O+=F:C+=F,y=!1;else{if(S)return{strInBraces:C+"{"+O+"{"+w.substring(z+1)};S=!0}break;case"}":if(y)S?O+=F:C+=F,y=!1;else{if(S)return{fixedStart:C,strInBraces:O,fixedEnd:w.substring(z+1)};C+=F}break;default:S?O+=(y?"\\":"")+F:C+=(y?"\\":"")+F,y=!1;break}}return{strInBraces:C+(S?"{"+O:"")}}function D(w){const{fixedStart:S,strInBraces:y,fixedEnd:C}=f(w);if(S===void 0||C===void 0)return[y];let O=(0,p.$_j)(y,",");O.length||(O=[""]);const z=D(C);return O.flatMap(F=>{const T=S+F;return z.map(L=>T+L)})}}),define(Ee[387],Se([1,0,22,160,108,15]),function(de,e,u,j,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class A{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,M,I,b){const E=new j.$flc(this.b);if(M.folder.scheme===P.Schemas.vscodeUserData){const v={...M,folder:M.folder.with({scheme:P.Schemas.file})},c=new R.$Qv(m=>I.report({...m,uri:m.uri.with({scheme:M.folder.scheme})}));return this.c(b,m=>E.provideTextSearchResults(k,v,c,m))}else return this.c(b,v=>E.provideTextSearchResults(k,M,I,v))}async c(k,M){const I=p(k);this.a.add(I);const b=await M(I.token);return this.a.delete(I),b}d(){this.a.forEach(k=>k.cancel())}}e.$plc=A;function p($){const k=new u.$ee;return $.onCancellationRequested(()=>k.cancel()),k}}),define(Ee[388],Se([1,0,31,160,159]),function(de,e,u,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;class P{constructor($){this.a=$}search($,k,M){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(E){M({message:E})}},b=new R.$mlc(this.a,new j.$flc(I),u);return new Promise((E,v)=>b.search(c=>{k(c.map(A))},$).then(c=>E({limitHit:c.limitHit,type:"success",stats:c.stats}),v))}}e.$nlc=P;function A(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce(($,k)=>{if(k.ranges){const M=k;return $+(Array.isArray(M.ranges)?M.ranges.length:1)}else return $+1},0)}}}),define(Ee[389],Se([1,0,19,8,13,4,132,17,39,2,32,36,384,388]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=a(r),g=new P.$7d({onDidAddFirstListener:()=>{s=(0,j.$7g)(d=>this.doFileSearchWithEngine(b.$elc,t,l=>g.fire(l),d)),s.then(d=>g.fire(d),d=>g.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return g.event}textSearch(r){let s;const t=a(r),g=new P.$7d({onDidAddFirstListener:()=>{s=(0,j.$7g)(d=>this.f(t,l=>g.fire(l),d)),s.then(d=>g.fire(d),d=>g.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return g.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new E.$nlc(r).search(t,s,s)}g(){return{maxFileSize:16*M.$jl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(b.$elc,r,s,t)}doFileSearchWithEngine(r,s,t,g,d=v.a){let l=0;const o=f=>{Array.isArray(f)?(l+=f.length,t(f.map(D=>this.h(D)))):f.relativePath?(l++,t(this.h(f))):t(f)};if(s.sortByScore){let f=this.l(s,o,g);if(!f){const D=s.maxResults?Object.assign({},s,{maxResults:null}):s,w=new r(D);f=this.j(w,s,t,o,g)}return new Promise((D,w)=>{f.then(([S,y])=>{const C=y.map(O=>this.h(O));this.o(C,t,d),D(S)},w)})}const h=new r(s);return this.r(h,o,d,g).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,g,d){const l=new P.$7d;let o=(0,j.$7g)(f=>{let D=[];const w=S=>{Array.isArray(S)?D=S:(g(S),l.fire(S))};return this.r(r,w,-1,f).then(S=>[S,D])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const f={promise:o,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=f,o.then(()=>{f.resolved=!0},D=>{delete h.resultsToSearchCache[s.filePattern||""]}),o=this.s(o)}return o.then(([f,D])=>{const w=h?h.scorerCache:Object.create(null),S=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$3d.create(!1);return this.n(s,D,w,d).then(y=>{const C=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:f.messages,limitHit:f.limitHit||typeof s.maxResults=="number"&&D.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new c)}l(r,s,t){const g=r.cacheKey&&this.b[r.cacheKey];if(!g)return;const d=this.q(g,r.filePattern||"",s,t);if(d)return d.then(([l,o,h])=>{const f=$.$3d.create(!1);return this.n(r,o,g.scorerCache,t).then(D=>{const w=f.elapsed(),S={fromCache:!0,detailStats:h,type:this.d,resultCount:o.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults,stats:S},D]})})}n(r,s,t,g){const d=(0,A.$gr)(r.filePattern||""),l=(h,f)=>(0,A.$fr)(h,f,d,!0,m,t),o=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,o,1e4,g)}o(r,s,t){if(t&&t>0)for(let g=0;g<r.length;g+=t)s(r.slice(g,g+t));else s(r)}q(r,s,t,g){const d=$.$3d.create(!1),l=s.indexOf(p.sep)>=0;let o;for(const w in r.resultsToSearchCache)if(s.startsWith(w)){if(l&&w.indexOf(p.sep)<0&&w!=="")continue;const S=r.resultsToSearchCache[w];o={promise:this.s(S.promise),event:S.event,resolved:S.resolved};break}if(!o)return null;const h=d.elapsed(),f=$.$3d.create(!1),D=o.event(t);return g&&g.onCancellationRequested(()=>{D.dispose()}),o.promise.then(([w,S])=>{if(g&&g.isCancellationRequested)throw(0,R.$6)();const y=[],C=(0,A.$gr)(s).normalizedLowercase;for(const O of S)(0,I.$MK)(O,C)&&y.push(O);return[w,y,{cacheWasResolved:o.resolved,cacheLookupTime:h,cacheFilterTime:f.elapsed(),cacheEntryCount:S.length}]})}r(r,s,t,g){return new Promise((d,l)=>{let o=[];g?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(o.push(h),t>0&&o.length>=t&&(s(o),o=[])):s(h))},h=>{s(h)},(h,f)=>{o.length&&s(o),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),d(f))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$olc=v;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,p.$oc)(i.relativePath)}getItemDescription(i){return(0,p.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>k.URI.revive(r))}}function n(i){return{...i,folder:k.URI.revive(i.folder)}}}),define(Ee[390],Se([1,0,3,15,2,31,12,27,20,97,66,36,389,387,122,159]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;let m=class extends k.$ckc{constructor(n,i,r,s){super(n,r,s),this.w=P,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$_kc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(j.Schemas.vscodeUserData,new E.$plc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$_kc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(j.Schemas.file,new E.$plc(n))),this.A.add(this.C(j.Schemas.file,new b.$olc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,k.$dkc)(r);if(n===this.x){const g=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-g;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,I.$LK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(g=>R.URI.file(g.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new c.$mlc(n,i,void 0,"textSearchProvider")}};e.$qlc=m,e.$qlc=m=Je([Ve(0,$.$CO),Ve(1,p.$SO),Ve(2,M.$8ic),Ve(3,A.$Nj)],m)}),define(Ee[123],Se([1,0,377,62,63,404,21,13,4,3,17,11,30,81,82]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$$h=e.$0h=e.$9h=void 0,e.$_h=d,e.$ai=l,e.$ci=f,e.$di=D;class c{traceSocketEvent(S,y){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,y)}constructor(S,y=""){this.f=!0,this.debugLabel=y,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,p.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const y=C=>{this.traceSocketEvent("read",C),S(A.$ue.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(S){const y=C=>{S({type:0,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(S){const y=()=>{S()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$9h=c;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var a;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(a||(a={}));class n extends k.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,y){this.socket.traceSocketEvent(S,y)}constructor(S,y,C,O){super(),this.f=this.B(new $.$7d),this.g=this.B(new $.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new i(this,y,C,O,this.f,(z,F)=>this.m(z,F))),this.B(this.a.onError(z=>{console.error(z),(0,p.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$4h,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let y=0;for(;y<S.byteLength;)this.a.writeMessage(S.slice(y,Math.min(y+262144,S.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(S,{compressed:y,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let O=2;S.byteLength<126?O+=0:S.byteLength<2**16?O+=2:O+=8;const z=A.$ue.alloc(O),F=y?64:0,T=C&15;if(z.writeUInt8(128|F|T,0),S.byteLength<126)z.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){z.writeUInt8(126,1);let L=1;z.writeUInt8(S.byteLength>>>8&255,++L),z.writeUInt8(S.byteLength>>>0&255,++L)}else{z.writeUInt8(127,1);let L=1;z.writeUInt8(0,++L),z.writeUInt8(0,++L),z.writeUInt8(0,++L),z.writeUInt8(0,++L),z.writeUInt8(S.byteLength>>>24&255,++L),z.writeUInt8(S.byteLength>>>16&255,++L),z.writeUInt8(S.byteLength>>>8&255,++L),z.writeUInt8(S.byteLength>>>0&255,++L)}this.socket.write(A.$ue.concat([z,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),O=(C&128)>>>7,z=(C&64)>>>6,F=C&15,T=y.readUInt8(1),L=(T&128)>>>7,N=T&127;this.j.state=2,this.j.readLen=2+(L?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),O=(C&128)>>>7;let z=C&127,F=1;z===126?z=y.readUInt8(++F)*2**8+y.readUInt8(++F):z===127&&(z=y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F));let T=0;O&&(T=y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F)),this.j.state=3,this.j.readLen=z,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$0h=n;class i extends k.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ue.alloc(0)}constructor(S,y,C,O,z,F){super(),this.n=S,this.r=z,this.s=F,this.a=this.B(new $.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,O,C,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(S,y){this.g.push({data:S,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:y}=this.g.shift();if(this.f&&y.compressed){const C=await this.w(this.f,S);this.s(C,y)}else this.s(S,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,y){return new Promise((C,O)=>{S.write(y),S.flush(z=>C(z))})}acceptFrame(S,y,C){this.h.push({data:S,isCompressed:y,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const y=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,y,C){return new Promise((O,z)=>{S.write(y),C&&S.write(A.$ue.fromByteArray([0,0,255,255])),S.flush(F=>O(F))})}}class r extends k.$Uc{get recordedInflateBytes(){return this.j?A.$ue.concat(this.f):A.$ue.alloc(0)}constructor(S,y,C,O){super(),this.h=S,this.j=y,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(O),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(A.$ue.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent("zlibInflateWrite",S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$ue.concat(this.g);this.g.length=0,S(y)})}}class s extends k.$Uc{constructor(S,y){super(),this.g=S,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(A.$ue.wrap(C))})}write(S){this.g.traceSocketEvent("zlibDeflateWrite",S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$ue.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),S(y)})}}function t(w,S){if(S===0)return;const y=w.byteLength>>>2;for(let L=0;L<y;L++){const N=w.readUInt32BE(L*4);w.writeUInt32BE(N^S,L*4)}const C=y*4,O=w.byteLength-C,z=S>>>24&255,F=S>>>16&255,T=S>>>8&255;O>=1&&w.writeUInt8(w.readUInt8(C)^z,C),O>=2&&w.writeUInt8(w.readUInt8(C+1)^F,C+1),O>=3&&w.writeUInt8(w.readUInt8(C+2)^T,C+2)}e.$$h=process.env.XDG_RUNTIME_DIR;const g={2:107,1:103};function d(){const w=(0,b.$Dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const S=process.platform!=="darwin"&&e.$$h?e.$$h:(0,R.tmpdir)(),y=(0,M.$kc)(S,`vscode-ipc-${w}.sock`);return o(y),y}function l(w,S,y){const O=(0,u.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${y}-${S}-sock`;const z=y.substr(0,4),F=S.substr(0,6);let T;return process.platform!=="darwin"&&e.$$h&&!process.env.VSCODE_PORTABLE?T=(0,M.$kc)(e.$$h,`vscode-${O}-${z}-${F}.sock`):T=(0,M.$kc)(w,`${z}-${F}.sock`),o(T),T}function o(w){const S=g[I.$u];typeof S=="number"&&w.length>=S&&console.warn(`WARNING: IPC handle "${w}" is longer than ${S} chars, try a shorter --user-data-dir`)}class h extends E.$Xh{static b(S){const y=$.Event.fromNodeEventEmitter(S,"connection");return $.Event.map(y,C=>({protocol:new v.$5h(new c(C,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(C,"close"))}))}constructor(S){super(h.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$bi=h;function f(w){return new Promise((S,y)=>{const C=(0,j.createServer)();C.on("error",y),C.listen(w,()=>{C.removeListener("error",y),S(new h(C))})})}function D(w,S){return new Promise((y,C)=>{const O=(0,j.createConnection)(w,()=>{O.removeListener("error",C),y(v.$6h.fromSocket(new c(O,`ipc-client${S}`),S))});O.once("error",C)})}}),define(Ee[391],Se([1,0,62,63,172,123,8,3,11,53,12,139,265,266,110,88,21]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=e.$xbc=e.$wbc=e.$vbc=void 0;async function a(t,g,d,l,o){let h;for(let f=3;f&&(h?.dispose(),h=await new n(t,g,d,l,o).waitForReady(),!(o&&R.$Gg[o]||!R.$Gg[h.tunnelLocalPort]));f--);return h}class n extends p.$Uc{constructor(g,d,l,o,h){super(),this.m=d,this.n=h,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=g,this.b=u.createServer(),this.c=new A.$gh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const g=this.n??this.tunnelRemotePort,d=(0,c.$4v)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,R.$Hg)(g,2,1e3,d),o=null;return this.b.listen(l,this.m),await this.c.wait(),o=this.b.address(),o||(l=0,this.b.listen(l,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(g){g.pause();const d=(0,c.$2v)(this.tunnelRemoteHost)||(0,c.$4v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,b.$Dl)(this.a,d,this.tunnelRemotePort),o=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&g.write(h.buffer),g.on("end",()=>{g.localAddress&&this.j.delete(g.localAddress),o.end()}),g.on("close",()=>o.end()),g.on("error",()=>{g.localAddress&&this.j.delete(g.localAddress),o instanceof P.$9h?o.socket.destroy():o.end()}),o instanceof P.$9h?this.t(g,o):this.s(g,o),g.localAddress&&this.j.set(g.localAddress,()=>{g.end(),o.end()})}s(g,d){d.onClose(()=>g.destroy()),d.onEnd(()=>g.end()),d.onData(l=>g.write(l.buffer)),g.on("data",l=>d.write(m.$ue.wrap(l))),g.resume()}t(g,d){const l=d.socket;l.on("end",()=>g.end()),l.on("close",()=>g.end()),l.on("error",()=>{g.destroy()}),l.pipe(g),g.pipe(l)}}e.$vbc=n;let i=class extends c.$7v{constructor(g,d,l,o,h){super(d,h),this.v=g,this.w=l,this.y=o}isPortPrivileged(g){return(0,c.$5v)(g,this.m,$.OS,j.release())}t(g,d,l,o,h,f,D,w){const S=this.s(d,l);if(S)return++S.refcount,S.value;if((0,c.$Xv)(g))return this.u(g,d,l,h,f,D,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:g,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=a(y,o,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,C),C}}};e.$wbc=i,e.$wbc=i=Je([Ve(0,E.$xl),Ve(1,M.$Nj),Ve(2,v.$Al),Ve(3,I.$7j),Ve(4,k.$Ni)],i);let r=class extends i{constructor(g,d,l,o,h){super(g,d,l,o,h)}};e.$xbc=r,e.$xbc=r=Je([Ve(0,E.$xl),Ve(1,M.$Nj),Ve(2,v.$Al),Ve(3,I.$7j),Ve(4,k.$Ni)],r);let s=class extends p.$Uc{constructor(g,d,l,o,h){super(),this.b=g,this.c=d,this.f=l,this.g=o,this.h=h,this.a=new Map}async openTunnel(g,d,l,o,h,f,D,w,S){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${o} on local port ${f}.`),!this.a.has(g)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(g,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(g))})}return this.a.get(g).openTunnel(d,l,o,h,f,D,w,S)}};e.$ybc=s,e.$ybc=s=Je([Ve(0,E.$xl),Ve(1,M.$Nj),Ve(2,I.$7j),Ve(3,v.$Al),Ve(4,k.$Ni)],s)}),define(Ee[392],Se([1,0,123,285,51,33,2,12,42]),function(de,e,u,j,R,P,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=void 0;class k{constructor(b,E,v){this.b=b,this.c=E,this.f=v,this.a=j.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(E.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,E){const v=(m,a)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},c=[];b.setEncoding("utf8"),b.on("data",m=>c.push(m)),b.on("end",async()=>{try{const m=JSON.parse(c.join(""));let a;switch(m.type){case"open":a=await this.i(m);break;case"openExternal":a=await this.j(m);break;case"status":a=await this.l(m);break;case"extensionManagement":a=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,a)}catch(m){const a=m instanceof Error?m.message:JSON.stringify(m);v(500,a),this.c.error("Error while processing pipe request",m)}})}async i(b){const{fileURIs:E,folderURIs:v,forceNewWindow:c,diffMode:m,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=b,g=[];if(Array.isArray(v))for(const h of v)try{g.push({folderUri:A.URI.parse(h)})}catch{}if(Array.isArray(E))for(const h of E)try{(0,$.$Mi)(h)?g.push({workspaceUri:A.URI.parse(h)}):g.push({fileUri:A.URI.parse(h)})}catch{}const d=s?A.URI.file(s):void 0,o={forceNewWindow:c,diffMode:m,mergeMode:a,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",g,o)}async j(b){for(const E of b.uris){const v=A.URI.parse(E),c=v.scheme==="file"?v:E;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(b){const E=c=>c?.map(m=>/\.vsix$/i.test(m)?A.URI.parse(m):m),v={list:b.list,install:E(b.install),uninstall:E(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&R.existsSync(this.f)&&R.unlinkSync(this.f)}}e.$4O=k;let M=class extends k{constructor(b,E){super(b,E,(0,u.$_h)())}};e.$5O=M,e.$5O=M=Je([Ve(0,P.$YO),Ve(1,p.$Nj)],M)}),define(Ee[393],Se([1,0,58,380,374,284,48,361,2,15,7,392,104,319,360]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class c extends R.$Wkc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,o){return d=t(d),n.a.has(d)?n.a.get(d).load(d,$.URI.file((0,b.$Pq)(l.filename)),h=>r.apply(this,[h,l,o])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(g,d)=>s.call(this,t(g),d);const t=g=>{for(const d of n.b){const l=d(g);if(l){g=l;break}}return g}}}class m extends A.$Ljc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Node}async ub(){this.h.createInstance(E.$tlc);const n=this.h.invokeFunction(j.$Skc);if(this.h.createInstance(p.$slc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(I.$5O);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$ulc),await this.h.createInstance(c,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,P.$rlc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}vb(n){return n.main}async wb(n,i,r){if(i.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=de.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$vlc=m}),define(Ee[394],Se([1,0,52,21,4,3,125,11,23,2,31,12,264,65,110,88,391,27,20,70,368]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0,e.$wlc=s,e.$xlc=t,e.$ylc=g,e.$zlc=d,e.$Alc=o,e.$Blc=h,e.$Clc=f;function s(S){const y=S.trim().split(`
`),C=[];return y.forEach(z=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);F&&F.length>=3&&C.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),C.reduce((z,F)=>(z[F.socket]=F,z),{})}function t(...S){const y=[].concat(...S.map(d));return[...new Map(y.filter(C=>C.st==="0A").map(C=>{const O=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:g(O[0]),port:parseInt(O[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function g(S){let y="";if(S.length===8)for(let C=S.length-2;C>=0;C-=2)y+=parseInt(S.substr(C,2),16),C!==0&&(y+=".");else for(let C=0;C<S.length;C+=8){const O=S.substring(C,C+8);let z="";for(let F=8;F>=2;F-=2)z+=O.substring(F-2,F),(F===6||F===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",C+F!==S.length-6&&(y+=":"))}return y}function d(S){const y=S.trim().split(`
`),C=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((F,T,L)=>(F[C[L]||L]=T,F),{}))}function l(S){return!!S.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||S.indexOf("out/server-main.js")!==-1||S.indexOf("_productName=VSCode")!==-1}function o(S){const y=S.trim().split(`
`),C=[];return y.forEach(O=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}async function h(S,y,C){const O=C.reduce((F,T)=>(F[T.pid]=T,F),{}),z=[];return S.forEach(({socket:F,ip:T,port:L})=>{const N=y[F]?y[F].pid:void 0,B=N?O[N]?.cmd:void 0;N&&B&&!l(B)&&z.push({host:T,port:L,detail:B,pid:N})}),z}function f(S,y,C){const O=new Map,z=o(y);for(const F of S){const T=C.get(F.port);if(T){O.set(F.port,T);continue}const L=z.find(N=>N.cmd.includes(`${F.port}`));if(L){let N=L,B;do B=z.find(U=>U.ppid===N.pid),B&&(N=B);while(B);O.set(F.port,{host:F.ip,port:F.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else O.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return O}let D=class extends i.$fBb{constructor(y,C,O,z){super(y,C,O),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new A.$pm;let z=0;for(;this.C;){const F=new Date().getTime(),T=(await this.I()).filter(B=>(0,c.$2v)(B.host)||(0,c.$4v)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(B=>B.port).join(", ")}`);const L=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${L} ms.`),z++>3&&O.update(L),(!C||JSON.stringify(C)!==JSON.stringify(T))&&(C=T,await this.a.$onFoundNewCandidates(C));const N=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(B=>setTimeout(()=>B(),N))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",C="";try{y=await M.Promises.readFile("/proc/net/tcp","utf8"),C=await M.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(y,C),z=await new Promise(_=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,x,ce)=>{_(x)})}),F=s(z),T=await M.Promises.readdir("/proc"),L=[];for(const _ of T)try{const Y=Number(_),x=$.$Ug(k.URI.file("/proc"),_);if((await M.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(Y)){const X=await M.Promises.readlink($.$Ug(x,"cwd").fsPath),me=await M.Promises.readFile($.$Ug(x,"cmdline").fsPath,"utf8");L.push({pid:Y,cwd:X,cmd:me})}}catch{}const N=[],B=O.filter(_=>{const Y=F[_.socket];return Y||N.push(_),Y}),U=h(B,F,L);let Z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const _=await new Promise(Y=>{(0,u.exec)("ps -F -A -l | grep root",(x,ce,X)=>{Y(ce)})});this.z=f(N,_,this.z),Z=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Z.map(Y=>Y.port).join(", ")}`)}return U.then(_=>Z?_.concat(Z):_)}w(y){return async C=>{const O=new m.$vbc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,T,L,N){const B=await y.makeConnection();return w.connect(B,T,L,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$tl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await O.waitForReady();const z=new R.$7d;return{localAddress:(0,r.$IL)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{O.dispose(),z.fire(),z.dispose()}}}}};e.$Dlc=D,e.$Dlc=D=Je([Ve(0,n.$CO),Ve(1,a.$SO),Ve(2,I.$Nj),Ve(3,v.$Al)],D);class w extends b.$2tb{static connect(y,C,O,z){const F=new P.$Tc,T={onClose:F.add(new R.$7d),onData:F.add(new R.$7d),onEnd:F.add(new R.$7d)};F.add(y.onDidReceiveMessage(N=>T.onData.fire(j.$ue.wrap(N)))),F.add(y.onDidEnd(()=>T.onEnd.fire())),F.add(y.onDidClose(N=>T.onClose.fire({type:0,error:N,hadError:!!N})));const L=new w(y,z,T);return L.B(F),(0,b.$1tb)(L,C,O,z,T)}constructor(y,C,O){super(C,O),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[395],Se([1,0,84,363,378,376,390,393,394,96,48,97,95,47,70,93,362,320,12,379,60,279,106,110,141]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a,n,i,r,s,t,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$fs)(M.$Mjc,p.$vlc,0),(0,u.$fs)(n.$Oj,a.$Flc,1),(0,u.$fs)(n.$Nj,new t.$ei(s.$Vkc,[!1],!0)),(0,u.$fs)(g.$Al,d.$Abc,1),(0,u.$fs)(c.$ejc,m.$Elc,0),(0,u.$fs)(k.$Rjc,P.$9kc,0),(0,u.$fs)(I.$bkc,A.$qlc,0),(0,u.$fs)(b.$Ekc,R.$1kc,0),(0,u.$fs)(E.$zjc,j.$Zkc,0),(0,u.$fs)(v.$eBb,$.$Dlc,0),(0,u.$fs)(r.$Pjc,i.$Glc,0)}),define(Ee[405],Se([1,0,62,406,58,13,82,123,262,114,375,21,31,104,8,135,286,302,381,395]),function(de,e,u,j,R,P,A,p,$,k,M,I,b,E,v,c,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const n=j(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,f=h._load;h._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(f){if(h)i(f);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(f,D){f==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(f,D)}}let t=function(h){i()};function g(){const h=(0,a.$_m)(process.env);if(h.type===3)return new Promise((f,D)=>{const w=S=>{const y=S[0],C=new A.$7h;y.on("message",O=>C.fire(I.$ue.wrap(O.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),f({onMessage:C.event,send:O=>y.postMessage(O.buffer)})};process.parentPort.on("message",S=>w(S.ports))});if(h.type===2)return new Promise((f,D)=>{let w=null;const S=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,C=3e5,O=new v.$uh(()=>t("renderer disconnected for too long (1)"),y),z=new v.$uh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(T,L)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){L.setNoDelay(!0);const N=I.$ue.wrap(Buffer.from(T.initialDataChunk,"base64"));let B;if(T.skipWebSocketFrames)B=new p.$9h(L,"extHost-socket");else{const U=I.$ue.wrap(Buffer.from(T.inflateBytes,"base64"));B=new p.$0h(new p.$9h(L,"extHost-socket"),T.permessageDeflate,U,!1)}w?(O.cancel(),z.cancel(),w.beginAcceptReconnection(B,N),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(S),w=new A.$8h({socket:B,initialChunk:N}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),f(w),w.onSocketClose(()=>{O.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;O.isScheduled()&&z.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const f=h.pipeName;return new Promise((D,w)=>{const S=u.createConnection(f,()=>{S.removeListener("error",w);const y=new A.$8h({socket:new p.$9h(S,"extHost-renderer")});y.sendResume(),D(y)});S.once("error",w),S.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await g();return new class{constructor(){this.a=new A.$7h,this.onMessage=this.a.event,this.b=!1,h.onMessage(f=>{(0,k.$Lm)(f,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||h.send(f)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(f=>{const D=h.onMessage(w=>{D.dispose();const S=JSON.parse(w.toString()),y=S.commit,C=$.default.commit;if(y&&C&&y!==C&&i(55),S.parentPid){let O=0;setInterval(function(){try{process.kill(S.parentPid,0),O=0}catch(F){F&&F.code==="EPERM"?(O++,O>=3&&t(`parent process ${S.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${S.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(S.parentPid)}catch(F){(0,P.$1)(F)}}h.send((0,k.$Km)(0)),f({protocol:h,initData:S})});h.send((0,k.$Km)(1))})}async function o(){const h=[];process.on("unhandledRejection",(O,z)=>{h.push(z),setTimeout(()=>{const F=h.indexOf(z);F>=0&&z.catch(T=>{h.splice(F,1),(0,P.$4)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),O&&(0,P.$1)(O))})},1e3)}),process.on("rejectionHandled",O=>{const z=h.indexOf(O);z>=0&&h.splice(z,1)}),process.on("uncaughtException",function(O){(0,P.$Z)(O)||(0,P.$1)(O)}),R.mark("code/extHost/willConnectToRenderer");const f=await d();R.mark("code/extHost/didConnectToRenderer");const D=await l(f);R.mark("code/extHost/didWaitForInitData");const{initData:w}=D;s(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,c.boolean)(n.skipWorkspaceStorageLock,!1);const S=new class{constructor(){this.pid=process.pid}exit(z){i(z)}fsExists(z){return b.Promises.exists(z)}fsRealpath(z){return(0,E.$Oq)(z)}};let y=null;w.remote.authority&&n.transformURIs&&(y=(0,m.$js)(w.remote.authority));const C=new M.$Ykc(D.protocol,w,S,y);t=O=>C.terminate(O)}o().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/99a19815253d91900be5ec1016e0ecc7cc9a6950/core/vs/workbench/api/node/extensionHostProcess.js.map
