/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContributionService","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Me=function(me){for(var e=[],I=0,F=me.length;I<F;I++)e[I]=Pe[me[I]];return e};define(Pe[68],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=F,e.$Mh=M,e.$Nh=N;function I(R){return(m,d,k)=>{let O=null,E=null;if(typeof k.value=="function"?(O="value",E=k.value):typeof k.get=="function"&&(O="get",E=k.get),!E)throw new Error("not supported");k[O]=R(E,d)}}function F(R,m,d){let k=null,O=null;if(typeof d.value=="function"?(k="value",O=d.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(k="get",O=d.get),!O)throw new Error("not supported");const E=`$memoize$${m}`;d[k]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,u)}),this[E]}}function M(R,m,d){return I((k,O)=>{const E=`$debounce$${O}`,u=`$debounce$result$${O}`;return function(...b){this[u]||(this[u]=d?d():void 0),clearTimeout(this[E]),m&&(this[u]=m(this[u],...b),b=[this[u]]),this[E]=setTimeout(()=>{k.apply(this,b),this[u]=d?d():void 0},R)}})}function N(R,m,d){return I((k,O)=>{const E=`$throttle$timer$${O}`,u=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...r){if(this[u]||(this[u]=d?d():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),m&&(this[u]=m(this[u],...r)),this[f])return;const o=this[b]+R;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[u]]),this[u]=d?d():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[u]]),this[u]=d?d():void 0},o-Date.now()))}})}}),define(Pe[90],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0;class I{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$HO=I,e.$IO=new I("id#")}),define(Pe[122],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=R,e.$tn=E,e.$un=u,e.$vn=b,e.$wn=f,e.$xn=r,e.$yn=o,e.$zn=s,e.$An=n,e.$Bn=i,e.$Cn=a,e.$Dn=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,v=!1){let c=0;const $=t.length;let w="",p=0,l=16,D=0;function g(W){let P=0,L=0;for(;P<W;){const K=t.charCodeAt(c);if(K>=48&&K<=57)L=L*16+K-48;else if(K>=65&&K<=70)L=L*16+K-65+10;else if(K>=97&&K<=102)L=L*16+K-97+10;else break;c++,P++}return P<W&&(L=-1),L}function S(W){c=W,w="",p=0,l=16,D=0}function y(){const W=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&k(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&k(t.charCodeAt(c)))for(c++;c<t.length&&k(t.charCodeAt(c));)c++;else return D=3,t.substring(W,c);let P=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&k(t.charCodeAt(c))){for(c++;c<t.length&&k(t.charCodeAt(c));)c++;P=c}else D=3;return t.substring(W,P)}function C(){let W="",P=c;for(;;){if(c>=$){W+=t.substring(P,c),D=2;break}const L=t.charCodeAt(c);if(L===34){W+=t.substring(P,c),c++;break}if(L===92){if(W+=t.substring(P,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const ne=g(4);ne>=0?W+=String.fromCharCode(ne):D=4;break}default:D=5}P=c;continue}if(L>=0&&L<=31)if(d(L)){W+=t.substring(P,c),D=2;break}else D=6;c++}return W}function A(){if(w="",D=0,p=c,c>=$)return p=$,l=17;let W=t.charCodeAt(c);if(m(W)){do c++,w+=String.fromCharCode(W),W=t.charCodeAt(c);while(m(W));return l=15}if(d(W))return c++,w+=String.fromCharCode(W),W===13&&t.charCodeAt(c)===10&&(c++,w+=`
`),l=14;switch(W){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,w=C(),l=10;case 47:{const P=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!d(t.charCodeAt(c));)c++;return w=t.substring(P,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const L=$-1;let K=!1;for(;c<L;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,D=1),w=t.substring(P,c),l=13}return w+=String.fromCharCode(W),c++,l=16}case 45:if(w+=String.fromCharCode(W),c++,c===$||!k(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=y(),l=11;default:for(;c<$&&G(W);)c++,W=t.charCodeAt(c);if(p!==c){switch(w=t.substring(p,c),w){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return w+=String.fromCharCode(W),c++,l=16}}function G(W){if(m(W)||d(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let W;do W=A();while(W>=12&&W<=15);return W}return{setPosition:S,getPosition:()=>c,scan:v?T:A,getToken:()=>l,getTokenValue:()=>w,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>D}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function E(t,v){const c=[],$=new Object;let w;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(g,S,y,C){p.value=g,p.offset=S,p.length=y,p.type=C,p.colonOffset=void 0,w=p}try{i(t,{onObjectBegin:(g,S)=>{if(v<=g)throw $;w=void 0,l=v>g,c.push("")},onObjectProperty:(g,S,y)=>{if(v<S||(D(g,S,y,"property"),c[c.length-1]=g,v<=S+y))throw $},onObjectEnd:(g,S)=>{if(v<=g)throw $;w=void 0,c.pop()},onArrayBegin:(g,S)=>{if(v<=g)throw $;w=void 0,c.push(0)},onArrayEnd:(g,S)=>{if(v<=g)throw $;w=void 0,c.pop()},onLiteralValue:(g,S,y)=>{if(v<S||(D(g,S,y,h(g)),v<=S+y))throw $},onSeparator:(g,S,y)=>{if(v<=S)throw $;if(g===":"&&w&&w.type==="property")w.colonOffset=S,l=!1,w=void 0;else if(g===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(l=!0,c[c.length-1]=""),w=void 0}}})}catch(g){if(g!==$)throw g}return{path:c,previousNode:w,isAtPropertyKey:l,matches:g=>{let S=0;for(let y=0;S<g.length&&y<c.length;y++)if(g[S]===c[y]||g[S]==="*")S++;else if(g[S]!=="**")return!1;return S===g.length}}}function u(t,v=[],c=N.DEFAULT){let $=null,w=[];const p=[];function l(g){Array.isArray(w)?w.push(g):$!==null&&(w[$]=g)}return i(t,{onObjectBegin:()=>{const g={};l(g),p.push(w),w=g,$=null},onObjectProperty:g=>{$=g},onObjectEnd:()=>{w=p.pop()},onArrayBegin:()=>{const g=[];l(g),p.push(w),w=g,$=null},onArrayEnd:()=>{w=p.pop()},onLiteralValue:l,onError:(g,S,y)=>{v.push({error:g,offset:S,length:y})}},c),w[0]}function b(t,v=[],c=N.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(g){$.type==="property"&&($.length=g-$.offset,$=$.parent)}function p(g){return $.children.push(g),g}i(t,{onObjectBegin:g=>{$=p({type:"object",offset:g,length:-1,parent:$,children:[]})},onObjectProperty:(g,S,y)=>{$=p({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:g,offset:S,length:y,parent:$})},onObjectEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,w(g+S)},onArrayBegin:(g,S)=>{$=p({type:"array",offset:g,length:-1,parent:$,children:[]})},onArrayEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,w(g+S)},onLiteralValue:(g,S,y)=>{p({type:h(g),offset:S,length:y,parent:$,value:g}),w(S+y)},onSeparator:(g,S,y)=>{$.type==="property"&&(g===":"?$.colonOffset=S:g===","&&w(S))},onError:(g,S,y)=>{v.push({error:g,offset:S,length:y})}},c);const D=$.children[0];return D&&delete D.parent,D}function f(t,v){if(!t)return;let c=t;for(const $ of v)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===$){c=p.children[1],w=!0;break}if(!w)return}else{const w=$;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const v=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;v.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&v.push(c)}return v}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const v=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(v[c.children[0].value]=o($))}return v}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,v,c=!1){return v>=t.offset&&v<t.offset+t.length||c&&v===t.offset+t.length}function n(t,v,c=!1){if(s(t,v,c)){const $=t.children;if(Array.isArray($))for(let w=0;w<$.length&&$[w].offset<=v;w++){const p=n($[w],v,c);if(p)return p}return t}}function i(t,v,c=N.DEFAULT){const $=R(t,!1);function w(ee){return ee?()=>ee($.getTokenOffset(),$.getTokenLength()):()=>!0}function p(ee){return ee?pe=>ee(pe,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=w(v.onObjectBegin),D=p(v.onObjectProperty),g=w(v.onObjectEnd),S=w(v.onArrayBegin),y=w(v.onArrayEnd),C=p(v.onLiteralValue),A=p(v.onSeparator),G=w(v.onComment),T=p(v.onError),W=c&&c.disallowComments,P=c&&c.allowTrailingComma;function L(){for(;;){const ee=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:W||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ee){case 12:case 13:W?K(10):G();break;case 16:K(1);break;case 15:case 14:break;default:return ee}}}function K(ee,pe=[],re=[]){if(T(ee),pe.length+re.length>0){let fe=$.getToken();for(;fe!==17;){if(pe.indexOf(fe)!==-1){L();break}else if(re.indexOf(fe)!==-1)break;fe=L()}}}function ne(ee){const pe=$.getTokenValue();return ee?C(pe):D(pe),L(),!0}function le(){switch($.getToken()){case 11:{let ee=0;try{ee=JSON.parse($.getTokenValue()),typeof ee!="number"&&(K(2),ee=0)}catch{K(2)}C(ee);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return L(),!0}function ye(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(ne(!1),$.getToken()===6?(A(":"),L(),be()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Se(){l(),L();let ee=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(ee||K(4,[],[]),A(","),L(),$.getToken()===2&&P)break}else ee&&K(6,[],[]);ye()||K(4,[],[2,5]),ee=!0}return g(),$.getToken()!==2?K(7,[2],[]):L(),!0}function he(){S(),L();let ee=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(ee||K(4,[],[]),A(","),L(),$.getToken()===4&&P)break}else ee&&K(6,[],[]);be()||K(4,[],[4,5]),ee=!0}return y(),$.getToken()!==4?K(8,[4],[]):L(),!0}function be(){switch($.getToken()){case 3:return he();case 1:return Se();case 10:return ne(!0);default:return le()}}return L(),$.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):be()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(t,v){const c=R(t),$=[];let w,p=0,l;do switch(l=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:p!==l&&$.push(t.substring(p,l)),v!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,v)),p=c.getPosition();break}while(w!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(me,e){typeof define=="function"&&define.amd?define(Pe[123],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Ie,ve){for(var ge=0;ge<ve.length;ge++){var J=ve[ge];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Ie,J.key,J)}}function I(Ie,ve,ge){return ve&&e(Ie.prototype,ve),ge&&e(Ie,ge),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function F(Ie,ve){if(Ie){if(typeof Ie=="string")return M(Ie,ve);var ge=Object.prototype.toString.call(Ie).slice(8,-1);if(ge==="Object"&&Ie.constructor&&(ge=Ie.constructor.name),ge==="Map"||ge==="Set")return Array.from(Ie);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return M(Ie,ve)}}function M(Ie,ve){(ve==null||ve>Ie.length)&&(ve=Ie.length);for(var ge=0,J=new Array(ve);ge<ve;ge++)J[ge]=Ie[ge];return J}function N(Ie,ve){var ge=typeof Symbol<"u"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ge)return(ge=ge.call(Ie)).next.bind(ge);if(Array.isArray(Ie)||(ge=F(Ie))||ve&&Ie&&typeof Ie.length=="number"){ge&&(Ie=ge);var J=0;return function(){return J>=Ie.length?{done:!0}:{done:!1,value:Ie[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function m(Ie){me.defaults=Ie}var d=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ve){return u[ve]};function f(Ie,ve){if(ve){if(d.test(Ie))return Ie.replace(k,b)}else if(O.test(Ie))return Ie.replace(E,b);return Ie}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ie){return Ie.replace(r,function(ve,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(Ie,ve){Ie=typeof Ie=="string"?Ie:Ie.source,ve=ve||"";var ge={replace:function(Y,ce){return ce=ce.source||ce,ce=ce.replace(s,"$1"),Ie=Ie.replace(Y,ce),ge},getRegex:function(){return new RegExp(Ie,ve)}};return ge}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ie,ve,ge){if(Ie){var J;try{J=decodeURIComponent(o(ge)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ve&&!a.test(ge)&&(ge=w(ve,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},v=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Ie,ve){t[" "+Ie]||(v.test(Ie)?t[" "+Ie]=Ie+"/":t[" "+Ie]=g(Ie,"/",!0)),Ie=t[" "+Ie];var ge=Ie.indexOf(":")===-1;return ve.substring(0,2)==="//"?ge?ve:Ie.replace(c,"$1")+ve:ve.charAt(0)==="/"?ge?ve:Ie.replace($,"$1")+ve:Ie+ve}var p={exec:function(){}};function l(Ie){for(var ve=1,ge,J;ve<arguments.length;ve++){ge=arguments[ve];for(J in ge)Object.prototype.hasOwnProperty.call(ge,J)&&(Ie[J]=ge[J])}return Ie}function D(Ie,ve){var ge=Ie.replace(/\|/g,function(ce,de,Ne){for(var ue=!1,Ce=de;--Ce>=0&&Ne[Ce]==="\\";)ue=!ue;return ue?"|":" |"}),J=ge.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ve)J.splice(ve);else for(;J.length<ve;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function g(Ie,ve,ge){var J=Ie.length;if(J===0)return"";for(var Y=0;Y<J;){var ce=Ie.charAt(J-Y-1);if(ce===ve&&!ge)Y++;else if(ce!==ve&&ge)Y++;else break}return Ie.slice(0,J-Y)}function S(Ie,ve){if(Ie.indexOf(ve[1])===-1)return-1;for(var ge=Ie.length,J=0,Y=0;Y<ge;Y++)if(Ie[Y]==="\\")Y++;else if(Ie[Y]===ve[0])J++;else if(Ie[Y]===ve[1]&&(J--,J<0))return Y;return-1}function y(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Ie,ve){if(ve<1)return"";for(var ge="";ve>1;)ve&1&&(ge+=Ie),ve>>=1,Ie+=Ie;return ge+Ie}function A(Ie,ve,ge,J){var Y=ve.href,ce=ve.title?f(ve.title):null,de=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){J.state.inLink=!0;var Ne={type:"link",raw:ge,href:Y,title:ce,text:de,tokens:J.inlineTokens(de)};return J.state.inLink=!1,Ne}return{type:"image",raw:ge,href:Y,title:ce,text:f(de)}}function G(Ie,ve){var ge=Ie.match(/^(\s+)(?:```)/);if(ge===null)return ve;var J=ge[1];return ve.split(`
`).map(function(Y){var ce=Y.match(/^\s+/);if(ce===null)return Y;var de=ce[0];return de.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var T=function(){function Ie(ge){this.options=ge||me.defaults}var ve=Ie.prototype;return ve.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ve.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var ce=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:g(ce,`
`)}}},ve.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var ce=Y[0],de=G(ce,Y[3]||"");return{type:"code",raw:ce,lang:Y[2]?Y[2].trim():Y[2],text:de}}},ve.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var ce=Y[2].trim();if(/#$/.test(ce)){var de=g(ce,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ce=de.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ce,tokens:this.lexer.inline(ce)}}},ve.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},ve.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var ce=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(ce,[]),text:ce}}},ve.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var ce,de,Ne,ue,Ce,Re,je,U,z,H,q,_,se=Y[1].trim(),Oe=se.length>1,We={type:"list",raw:"",ordered:Oe,start:Oe?+se.slice(0,-1):"",loose:!1,items:[]};se=Oe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Oe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(_=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(ce=Y[0],J=J.substring(ce.length),U=Y[2].split(`
`,1)[0],z=J.split(`
`,1)[0],this.options.pedantic?(ue=2,q=U.trimLeft()):(ue=Y[2].search(/[^ ]/),ue=ue>4?1:ue,q=U.slice(ue),ue+=Y[1].length),Re=!1,!U&&/^ *$/.test(z)&&(ce+=z+`
`,J=J.substring(z.length+1),_=!0),!_)for(var xe=new RegExp("^ {0,"+Math.min(3,ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,ue-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,ue-1)+"}#");J&&(H=J.split(`
`,1)[0],U=H,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(U)||nt.test(U)||xe.test(U)||tt.test(J)));){if(U.search(/[^ ]/)>=ue||!U.trim())q+=`
`+U.slice(ue);else if(!Re)q+=`
`+U;else break;!Re&&!U.trim()&&(Re=!0),ce+=H+`
`,J=J.substring(H.length+1)}We.loose||(je?We.loose=!0:/\n *\n *$/.test(ce)&&(je=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(q),de&&(Ne=de[0]!=="[ ] ",q=q.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:ce,task:!!de,checked:Ne,loose:!1,text:q}),We.raw+=ce}We.items[We.items.length-1].raw=ce.trimRight(),We.items[We.items.length-1].text=q.trimRight(),We.raw=We.raw.trimRight();var rt=We.items.length;for(Ce=0;Ce<rt;Ce++){this.lexer.state.top=!1,We.items[Ce].tokens=this.lexer.blockTokens(We.items[Ce].text,[]);var ct=We.items[Ce].tokens.filter(function(it){return it.type==="space"}),Be=ct.every(function(it){for(var Z=it.raw.split(""),X=0,$e=N(Z),Ve;!(Ve=$e()).done;){var Ze=Ve.value;if(Ze===`
`&&(X+=1),X>1)return!0}return!1});!We.loose&&ct.length&&Be&&(We.loose=!0,We.items[Ce].loose=!0)}return We}},ve.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var ce={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);ce.type="paragraph",ce.text=de,ce.tokens=this.lexer.inline(de)}return ce}},ve.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ce=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ce,raw:Y[0],href:Y[2],title:Y[3]}}},ve.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var ce={type:"table",header:D(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=Y[0];var de=ce.align.length,Ne,ue,Ce,Re;for(Ne=0;Ne<de;Ne++)/^ *-+: *$/.test(ce.align[Ne])?ce.align[Ne]="right":/^ *:-+: *$/.test(ce.align[Ne])?ce.align[Ne]="center":/^ *:-+ *$/.test(ce.align[Ne])?ce.align[Ne]="left":ce.align[Ne]=null;for(de=ce.rows.length,Ne=0;Ne<de;Ne++)ce.rows[Ne]=D(ce.rows[Ne],ce.header.length).map(function(je){return{text:je}});for(de=ce.header.length,ue=0;ue<de;ue++)ce.header[ue].tokens=this.lexer.inline(ce.header[ue].text);for(de=ce.rows.length,ue=0;ue<de;ue++)for(Re=ce.rows[ue],Ce=0;Ce<Re.length;Ce++)Re[Ce].tokens=this.lexer.inline(Re[Ce].text);return ce}}},ve.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ve.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var ce=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:ce,tokens:this.lexer.inline(ce)}}},ve.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ve.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},ve.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},ve.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var ce=Y[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var de=g(ce.slice(0,-1),"\\");if((ce.length-de.length)%2===0)return}else{var Ne=S(Y[2],"()");if(Ne>-1){var ue=Y[0].indexOf("!")===0?5:4,Ce=ue+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Re=Y[2],je="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);U&&(Re=U[1],je=U[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(ce)?Re=Re.slice(1):Re=Re.slice(1,-1)),A(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ve.reflink=function(J,Y){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var de=(ce[2]||ce[1]).replace(/\s+/g," ");if(de=Y[de.toLowerCase()],!de||!de.href){var Ne=ce[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return A(ce,de,ce[0],this.lexer)}},ve.emStrong=function(J,Y,ce){ce===void 0&&(ce="");var de=this.rules.inline.emStrong.lDelim.exec(J);if(de&&!(de[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=de[1]||de[2]||"";if(!Ne||Ne&&(ce===""||this.rules.inline.punctuation.exec(ce))){var ue=de[0].length-1,Ce,Re,je=ue,U=0,z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,Y=Y.slice(-1*J.length+ue);(de=z.exec(Y))!=null;)if(Ce=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ce){if(Re=Ce.length,de[3]||de[4]){je+=Re;continue}else if((de[5]||de[6])&&ue%3&&!((ue+Re)%3)){U+=Re;continue}if(je-=Re,!(je>0)){if(Re=Math.min(Re,Re+je+U),Math.min(ue,Re)%2){var H=J.slice(1,ue+de.index+Re);return{type:"em",raw:J.slice(0,ue+de.index+Re+1),text:H,tokens:this.lexer.inlineTokens(H)}}var q=J.slice(2,ue+de.index+Re-1);return{type:"strong",raw:J.slice(0,ue+de.index+Re+1),text:q,tokens:this.lexer.inlineTokens(q)}}}}}},ve.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var ce=Y[2].replace(/\n/g," "),de=/[^ ]/.test(ce),Ne=/^ /.test(ce)&&/ $/.test(ce);return de&&Ne&&(ce=ce.substring(1,ce.length-1)),ce=f(ce,!0),{type:"codespan",raw:Y[0],text:ce}}},ve.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},ve.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ve.autolink=function(J,Y){var ce=this.rules.inline.autolink.exec(J);if(ce){var de,Ne;return ce[2]==="@"?(de=f(this.options.mangle?Y(ce[1]):ce[1]),Ne="mailto:"+de):(de=f(ce[1]),Ne=de),{type:"link",raw:ce[0],text:de,href:Ne,tokens:[{type:"text",raw:de,text:de}]}}},ve.url=function(J,Y){var ce;if(ce=this.rules.inline.url.exec(J)){var de,Ne;if(ce[2]==="@")de=f(this.options.mangle?Y(ce[0]):ce[0]),Ne="mailto:"+de;else{var ue;do ue=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(ue!==ce[0]);de=f(ce[0]),ce[1]==="www."?Ne="http://"+de:Ne=de}return{type:"link",raw:ce[0],text:de,href:Ne,tokens:[{type:"text",raw:de,text:de}]}}},ve.inlineText=function(J,Y){var ce=this.rules.inline.text.exec(J);if(ce){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]:de=f(this.options.smartypants?Y(ce[0]):ce[0]),{type:"text",raw:ce[0],text:de}}},Ie}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=n(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=n(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=n(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=n(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=n(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=l({},W),W.gfm=l({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=n(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=l({},W.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(W._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",W._label).getRegex(),P.nolink=n(P.nolink).replace("ref",W._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=l({},P),P.pedantic=l({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=l({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=l({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ie){var ve="",ge,J,Y=Ie.length;for(ge=0;ge<Y;ge++)J=Ie.charCodeAt(ge),Math.random()>.5&&(J="x"+J.toString(16)),ve+="&#"+J+";";return ve}var ne=function(){function Ie(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:W.normal,inline:P.normal};this.options.pedantic?(J.block=W.pedantic,J.inline=P.pedantic):this.options.gfm&&(J.block=W.gfm,this.options.breaks?J.inline=P.breaks:J.inline=P.gfm),this.tokenizer.rules=J}Ie.lex=function(J,Y){var ce=new Ie(Y);return ce.lex(J)},Ie.lexInline=function(J,Y){var ce=new Ie(Y);return ce.inlineTokens(J)};var ve=Ie.prototype;return ve.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ve.blockTokens=function(J,Y){var ce=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(je,U,z){return U+"    ".repeat(z.length)});for(var de,Ne,ue,Ce;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(de=je.call({lexer:ce},J,Y))?(J=J.substring(de.raw.length),Y.push(de),!0):!1}))){if(de=this.tokenizer.space(J)){J=J.substring(de.raw.length),de.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(de);continue}if(de=this.tokenizer.code(J)){J=J.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(de);continue}if(de=this.tokenizer.fences(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.heading(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.hr(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.blockquote(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.list(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.html(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.def(J)){J=J.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.lheading(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(ue=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,U=J.slice(1),z=void 0;ce.options.extensions.startBlock.forEach(function(H){z=H.call({lexer:this},U),typeof z=="number"&&z>=0&&(je=Math.min(je,z))}),je<1/0&&je>=0&&(ue=J.substring(0,je+1))}(),this.state.top&&(de=this.tokenizer.paragraph(ue))){Ne=Y[Y.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(de),Ce=ue.length!==J.length,J=J.substring(de.raw.length);continue}if(de=this.tokenizer.text(J)){J=J.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(de);continue}if(J){var Re="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},ve.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},ve.inlineTokens=function(J,Y){var ce=this;Y===void 0&&(Y=[]);var de,Ne,ue,Ce=J,Re,je,U;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)z.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Re.index)+"["+C("a",Re[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Re.index)+"["+C("a",Re[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Re.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(je||(U=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(de=q.call({lexer:ce},J,Y))?(J=J.substring(de.raw.length),Y.push(de),!0):!1}))){if(de=this.tokenizer.escape(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.tag(J)){J=J.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&de.type==="text"&&Ne.type==="text"?(Ne.raw+=de.raw,Ne.text+=de.text):Y.push(de);continue}if(de=this.tokenizer.link(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&de.type==="text"&&Ne.type==="text"?(Ne.raw+=de.raw,Ne.text+=de.text):Y.push(de);continue}if(de=this.tokenizer.emStrong(J,Ce,U)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.codespan(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.br(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.del(J)){J=J.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.autolink(J,K)){J=J.substring(de.raw.length),Y.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(J,K))){J=J.substring(de.raw.length),Y.push(de);continue}if(ue=J,this.options.extensions&&this.options.extensions.startInline&&function(){var q=1/0,_=J.slice(1),se=void 0;ce.options.extensions.startInline.forEach(function(Oe){se=Oe.call({lexer:this},_),typeof se=="number"&&se>=0&&(q=Math.min(q,se))}),q<1/0&&q>=0&&(ue=J.substring(0,q+1))}(),de=this.tokenizer.inlineText(ue,L)){J=J.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(U=de.raw.slice(-1)),je=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=de.raw,Ne.text+=de.text):Y.push(de);continue}if(J){var H="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return Y},I(Ie,null,[{key:"rules",get:function(){return{block:W,inline:P}}}]),Ie}(),le=function(){function Ie(ge){this.options=ge||me.defaults}var ve=Ie.prototype;return ve.code=function(J,Y,ce){var de=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(J,de);Ne!=null&&Ne!==J&&(ce=!0,J=Ne)}return J=J.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+f(de,!0)+'">'+(ce?J:f(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:f(J,!0))+`</code></pre>
`},ve.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ve.html=function(J){return J},ve.heading=function(J,Y,ce,de){if(this.options.headerIds){var Ne=this.options.headerPrefix+de.slug(ce);return"<h"+Y+' id="'+Ne+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(J,Y,ce){var de=Y?"ol":"ul",Ne=Y&&ce!==1?' start="'+ce+'"':"";return"<"+de+Ne+`>
`+J+"</"+de+`>
`},ve.listitem=function(J){return"<li>"+J+`</li>
`},ve.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(J){return"<p>"+J+`</p>
`},ve.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},ve.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ve.tablecell=function(J,Y){var ce=Y.header?"th":"td",de=Y.align?"<"+ce+' align="'+Y.align+'">':"<"+ce+">";return de+J+("</"+ce+`>
`)},ve.strong=function(J){return"<strong>"+J+"</strong>"},ve.em=function(J){return"<em>"+J+"</em>"},ve.codespan=function(J){return"<code>"+J+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(J){return"<del>"+J+"</del>"},ve.link=function(J,Y,ce){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var de='<a href="'+f(J)+'"';return Y&&(de+=' title="'+Y+'"'),de+=">"+ce+"</a>",de},ve.image=function(J,Y,ce){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var de='<img src="'+J+'" alt="'+ce+'"';return Y&&(de+=' title="'+Y+'"'),de+=this.options.xhtml?"/>":">",de},ve.text=function(J){return J},Ie}(),ye=function(){function Ie(){}var ve=Ie.prototype;return ve.strong=function(J){return J},ve.em=function(J){return J},ve.codespan=function(J){return J},ve.del=function(J){return J},ve.html=function(J){return J},ve.text=function(J){return J},ve.link=function(J,Y,ce){return""+ce},ve.image=function(J,Y,ce){return""+ce},ve.br=function(){return""},Ie}(),Se=function(){function Ie(){this.seen={}}var ve=Ie.prototype;return ve.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(J,Y){var ce=J,de=0;if(this.seen.hasOwnProperty(ce)){de=this.seen[J];do de++,ce=J+"-"+de;while(this.seen.hasOwnProperty(ce))}return Y||(this.seen[J]=de,this.seen[ce]=0),ce},ve.slug=function(J,Y){Y===void 0&&(Y={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,Y.dryrun)},Ie}(),he=function(){function Ie(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Se}Ie.parse=function(J,Y){var ce=new Ie(Y);return ce.parse(J)},Ie.parseInline=function(J,Y){var ce=new Ie(Y);return ce.parseInline(J)};var ve=Ie.prototype;return ve.parse=function(J,Y){Y===void 0&&(Y=!0);var ce="",de,Ne,ue,Ce,Re,je,U,z,H,q,_,se,Oe,We,Qe,xe,tt,at,nt,rt=J.length;for(de=0;de<rt;de++){if(q=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(nt=this.options.extensions.renderers[q.type].call({parser:this},q),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){ce+=nt||"";continue}switch(q.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(q.tokens),q.depth,o(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(z="",U="",Ce=q.header.length,Ne=0;Ne<Ce;Ne++)U+=this.renderer.tablecell(this.parseInline(q.header[Ne].tokens),{header:!0,align:q.align[Ne]});for(z+=this.renderer.tablerow(U),H="",Ce=q.rows.length,Ne=0;Ne<Ce;Ne++){for(je=q.rows[Ne],U="",Re=je.length,ue=0;ue<Re;ue++)U+=this.renderer.tablecell(this.parseInline(je[ue].tokens),{header:!1,align:q.align[ue]});H+=this.renderer.tablerow(U)}ce+=this.renderer.table(z,H);continue}case"blockquote":{H=this.parse(q.tokens),ce+=this.renderer.blockquote(H);continue}case"list":{for(_=q.ordered,se=q.start,Oe=q.loose,Ce=q.items.length,H="",Ne=0;Ne<Ce;Ne++)Qe=q.items[Ne],xe=Qe.checked,tt=Qe.task,We="",Qe.task&&(at=this.renderer.checkbox(xe),Oe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=at+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=at+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:at}):We+=at),We+=this.parse(Qe.tokens,Oe),H+=this.renderer.listitem(We,tt,xe);ce+=this.renderer.list(H,_,se);continue}case"html":{ce+=this.renderer.html(q.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(H=q.tokens?this.parseInline(q.tokens):q.text;de+1<rt&&J[de+1].type==="text";)q=J[++de],H+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);ce+=Y?this.renderer.paragraph(H):H;continue}default:{var ct='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return ce},ve.parseInline=function(J,Y){Y=Y||this.renderer;var ce="",de,Ne,ue,Ce=J.length;for(de=0;de<Ce;de++){if(Ne=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(ue=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){ce+=ue||"";continue}switch(Ne.type){case"escape":{ce+=Y.text(Ne.text);break}case"html":{ce+=Y.html(Ne.text);break}case"link":{ce+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{ce+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{ce+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{ce+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{ce+=Y.codespan(Ne.text);break}case"br":{ce+=Y.br();break}case"del":{ce+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{ce+=Y.text(Ne.text);break}default:{var Re='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return ce},Ie}();function be(Ie,ve,ge){if(typeof Ie>"u"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ve=="function"&&(ge=ve,ve=null),ve=l({},be.defaults,ve||{}),y(ve),ge){var J=ve.highlight,Y;try{Y=ne.lex(Ie,ve)}catch(Ce){return ge(Ce)}var ce=function(Re){var je;if(!Re)try{ve.walkTokens&&be.walkTokens(Y,ve.walkTokens),je=he.parse(Y,ve)}catch(U){Re=U}return ve.highlight=J,Re?ge(Re):ge(null,je)};if(!J||J.length<3||(delete ve.highlight,!Y.length))return ce();var de=0;be.walkTokens(Y,function(Ce){Ce.type==="code"&&(de++,setTimeout(function(){J(Ce.text,Ce.lang,function(Re,je){if(Re)return ce(Re);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),de--,de===0&&ce()})},0))}),de===0&&ce();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+f(Ce.message+"",!0)+"</pre>";throw Ce}try{var ue=ne.lex(Ie,ve);if(ve.walkTokens){if(ve.async)return Promise.all(be.walkTokens(ue,ve.walkTokens)).then(function(){return he.parse(ue,ve)}).catch(Ne);be.walkTokens(ue,ve.walkTokens)}return he.parse(ue,ve)}catch(Ce){Ne(Ce)}}be.options=be.setOptions=function(Ie){return l(be.defaults,Ie),m(be.defaults),be},be.getDefaults=R,be.defaults=me.defaults,be.use=function(){for(var Ie=arguments.length,ve=new Array(Ie),ge=0;ge<Ie;ge++)ve[ge]=arguments[ge];var J=l.apply(void 0,[{}].concat(ve)),Y=be.defaults.extensions||{renderers:{},childTokens:{}},ce;ve.forEach(function(de){if(de.extensions&&(ce=!0,de.extensions.forEach(function(ue){if(!ue.name)throw new Error("extension name required");if(ue.renderer){var Ce=Y.renderers?Y.renderers[ue.name]:null;Ce?Y.renderers[ue.name]=function(){for(var Re=arguments.length,je=new Array(Re),U=0;U<Re;U++)je[U]=arguments[U];var z=ue.renderer.apply(this,je);return z===!1&&(z=Ce.apply(this,je)),z}:Y.renderers[ue.name]=ue.renderer}if(ue.tokenizer){if(!ue.level||ue.level!=="block"&&ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[ue.level]?Y[ue.level].unshift(ue.tokenizer):Y[ue.level]=[ue.tokenizer],ue.start&&(ue.level==="block"?Y.startBlock?Y.startBlock.push(ue.start):Y.startBlock=[ue.start]:ue.level==="inline"&&(Y.startInline?Y.startInline.push(ue.start):Y.startInline=[ue.start]))}ue.childTokens&&(Y.childTokens[ue.name]=ue.childTokens)})),de.renderer&&function(){var ue=be.defaults.renderer||new le,Ce=function(U){var z=ue[U];ue[U]=function(){for(var H=arguments.length,q=new Array(H),_=0;_<H;_++)q[_]=arguments[_];var se=de.renderer[U].apply(ue,q);return se===!1&&(se=z.apply(ue,q)),se}};for(var Re in de.renderer)Ce(Re);J.renderer=ue}(),de.tokenizer&&function(){var ue=be.defaults.tokenizer||new T,Ce=function(U){var z=ue[U];ue[U]=function(){for(var H=arguments.length,q=new Array(H),_=0;_<H;_++)q[_]=arguments[_];var se=de.tokenizer[U].apply(ue,q);return se===!1&&(se=z.apply(ue,q)),se}};for(var Re in de.tokenizer)Ce(Re);J.tokenizer=ue}(),de.walkTokens){var Ne=be.defaults.walkTokens;J.walkTokens=function(ue){var Ce=[];return Ce.push(de.walkTokens.call(this,ue)),Ne&&(Ce=Ce.concat(Ne.call(this,ue))),Ce}}ce&&(J.extensions=Y),be.setOptions(J)})},be.walkTokens=function(Ie,ve){for(var ge=[],J=function(){var Ne=ce.value;switch(ge=ge.concat(ve.call(be,Ne)),Ne.type){case"table":{for(var ue=N(Ne.header),Ce;!(Ce=ue()).done;){var Re=Ce.value;ge=ge.concat(be.walkTokens(Re.tokens,ve))}for(var je=N(Ne.rows),U;!(U=je()).done;)for(var z=U.value,H=N(z),q;!(q=H()).done;){var _=q.value;ge=ge.concat(be.walkTokens(_.tokens,ve))}break}case"list":{ge=ge.concat(be.walkTokens(Ne.items,ve));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[Ne.type]?be.defaults.extensions.childTokens[Ne.type].forEach(function(se){ge=ge.concat(be.walkTokens(Ne[se],ve))}):Ne.tokens&&(ge=ge.concat(be.walkTokens(Ne.tokens,ve)))}},Y=N(Ie),ce;!(ce=Y()).done;)J();return ge},be.parseInline=function(Ie,ve){if(typeof Ie>"u"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ve=l({},be.defaults,ve||{}),y(ve);try{var ge=ne.lexInline(Ie,ve);return ve.walkTokens&&be.walkTokens(ge,ve.walkTokens),he.parseInline(ge,ve)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+f(J.message+"",!0)+"</pre>";throw J}},be.Parser=he,be.parser=he.parse,be.Renderer=le,be.TextRenderer=ye,be.Lexer=ne,be.lexer=ne.lex,be.Tokenizer=T,be.Slugger=Se,be.parse=be;var ee=be.options,pe=be.setOptions,re=be.use,fe=be.walkTokens,V=be.parseInline,te=be,ke=he.parse,Te=ne.lex;me.Lexer=ne,me.Parser=he,me.Renderer=le,me.Slugger=Se,me.TextRenderer=ye,me.Tokenizer=T,me.getDefaults=R,me.lexer=Te,me.marked=be,me.options=ee,me.parse=te,me.parseInline=V,me.parser=ke,me.setOptions=pe,me.use=re,me.walkTokens=fe,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[124],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=I;function I(r){const o=N(r);if(o&&o.length>0)return new Uint32Array(o)}let F=0;const M=new Uint32Array(10);function N(r){if(F=0,R(r,E,4352),F>0||(R(r,u,4449),F>0)||(R(r,b,4520),F>0)||(R(r,f,12593),F))return M.subarray(0,F);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,n=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(n<E.length?R(n,E,0):4352+n-12593<f.length&&R(4352+n,f,12593),i<u.length?R(i,u,0):4449+i-12593<f.length&&R(4449+i-12593,f,12593),a>=0&&(a<b.length?R(a,b,0):4520+a-12593<f.length&&R(4520+a-12593,f,12593)),F>0)return M.subarray(0,F)}}function R(r,o,s){r>=s&&r<s+o.length&&m(o[r-s])}function m(r){r!==0&&(M[F++]=r&255,r>>8&&(M[F++]=r>>8&255),r>>16&&(M[F++]=r>>16&255))}var d;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var k;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(k||(k={}));var O;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(O||(O={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[125],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=I,e.rot=F;function I(m,d,k){return Math.min(Math.max(m,d),k)}function F(m,d){return(d+m%d)%d}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$om=M;class N{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=N;class R{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const k=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=R}),function(){function me(M){const N=[];typeof M=="number"&&N.push("code/timeOrigin",M);function R(d){N.push(d,Date.now())}function m(){const d=[];for(let k=0;k<N.length;k+=2)d.push({name:N[k],startTime:N[k+1]});return d}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(M+R.startTime)});return N}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),define(Pe[126],Me([1,0,39]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;const F=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(d,k,O){this.d(d,E=>E._value=k,O)}mutate(d,k){this.d(d,O=>O._value=k(O._value===F?void 0:O._value))}delete(d){const k=this.c(d);if(!k)return;let O=k.length-1;const E=k[O].node._value;if(E!==F){for(this.b--,k[O].node._value=F;O>0;O--){const{node:u,part:b}=k[O];if(u.children?.size||u._value!==F)break;k[O-1].node.children.delete(b)}return E}}*deleteRecursive(d){const k=this.c(d);if(!k)return;const O=k[k.length-1].node;for(let E=k.length-1;E>0;E--){const u=k[E-1];if(u.node.children.delete(k[E].part),u.node.children.size>0||u.node._value!==F)break}for(const E of N(O))E._value!==F&&(this.b--,yield E._value)}find(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return;k=E}return k._value===F?void 0:k._value}hasKeyOrParent(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return!1;if(E._value!==F)return!0;k=E}return!1}hasKeyOrChildren(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return!1;k=E}return!0}hasKey(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return!1;k=E}return k._value!==F}c(d){const k=[{part:"",node:this.a}];let O=0;for(const E of d){const u=k[O].node.children?.get(E);if(!u)return;k.push({part:E,node:u}),O++}return k}d(d,k,O){let E=this.a;for(const f of d){if(E.children)if(E.children.has(f))E=E.children.get(f);else{const r=new R;E.children.set(f,r),E=r}else{const r=new R;E.children=new Map([[f,r]]),E=r}O?.(E)}const u=E._value===F?0:1;k(E);const b=E._value===F?0:1;this.b+=b-u}*values(){for(const{_value:d}of N(this.a))d!==F&&(yield d)}}e.$rO=M;function*N(m){const d=[m];for(;d.length>0;){const k=d.pop();if(yield k,k.children)for(const O of k.children.values())d.push(O)}}class R{constructor(){this._value=F}get value(){return this._value===F?void 0:this._value}set value(d){this._value=d===void 0?F:d}}}),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:me)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(F){if(e[F])return e[F].exports;var M=e[F]={i:F,l:!1,exports:{}};return me[F].call(M.exports,M,M.exports,I),M.l=!0,M.exports}return I.m=me,I.c=e,I.d=function(F,M,N){I.o(F,M)||Object.defineProperty(F,M,{enumerable:!0,get:N})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,M){if(1&M&&(F=I(F)),8&M||4&M&&typeof F=="object"&&F&&F.__esModule)return F;var N=Object.create(null);if(I.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:F}),2&M&&typeof F!="string")for(var R in F)I.d(N,R,function(m){return F[m]}.bind(null,R));return N},I.n=function(F){var M=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(M,"a",M),M},I.o=function(F,M){return Object.prototype.hasOwnProperty.call(F,M)},I.p="",I(I.s=0)}([function(me,e,I){(function(F){var M;e=me.exports=re,M=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],d=e.src=[],k=0,O=k++;d[O]="0|[1-9]\\d*";var E=k++;d[E]="[0-9]+";var u=k++;d[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;d[b]="("+d[O]+")\\.("+d[O]+")\\.("+d[O]+")";var f=k++;d[f]="("+d[E]+")\\.("+d[E]+")\\.("+d[E]+")";var r=k++;d[r]="(?:"+d[O]+"|"+d[u]+")";var o=k++;d[o]="(?:"+d[E]+"|"+d[u]+")";var s=k++;d[s]="(?:-("+d[r]+"(?:\\."+d[r]+")*))";var n=k++;d[n]="(?:-?("+d[o]+"(?:\\."+d[o]+")*))";var i=k++;d[i]="[0-9A-Za-z-]+";var a=k++;d[a]="(?:\\+("+d[i]+"(?:\\."+d[i]+")*))";var h=k++,t="v?"+d[b]+d[s]+"?"+d[a]+"?";d[h]="^"+t+"$";var v="[v=\\s]*"+d[f]+d[n]+"?"+d[a]+"?",c=k++;d[c]="^"+v+"$";var $=k++;d[$]="((?:<|>)?=?)";var w=k++;d[w]=d[E]+"|x|X|\\*";var p=k++;d[p]=d[O]+"|x|X|\\*";var l=k++;d[l]="[v=\\s]*("+d[p]+")(?:\\.("+d[p]+")(?:\\.("+d[p]+")(?:"+d[s]+")?"+d[a]+"?)?)?";var D=k++;d[D]="[v=\\s]*("+d[w]+")(?:\\.("+d[w]+")(?:\\.("+d[w]+")(?:"+d[n]+")?"+d[a]+"?)?)?";var g=k++;d[g]="^"+d[$]+"\\s*"+d[l]+"$";var S=k++;d[S]="^"+d[$]+"\\s*"+d[D]+"$";var y=k++;d[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;d[C]="(?:~>?)";var A=k++;d[A]="(\\s*)"+d[C]+"\\s+",m[A]=new RegExp(d[A],"g");var G=k++;d[G]="^"+d[C]+d[l]+"$";var T=k++;d[T]="^"+d[C]+d[D]+"$";var W=k++;d[W]="(?:\\^)";var P=k++;d[P]="(\\s*)"+d[W]+"\\s+",m[P]=new RegExp(d[P],"g");var L=k++;d[L]="^"+d[W]+d[l]+"$";var K=k++;d[K]="^"+d[W]+d[D]+"$";var ne=k++;d[ne]="^"+d[$]+"\\s*("+v+")$|^$";var le=k++;d[le]="^"+d[$]+"\\s*("+t+")$|^$";var ye=k++;d[ye]="(\\s*)"+d[$]+"\\s*("+v+"|"+d[l]+")",m[ye]=new RegExp(d[ye],"g");var Se=k++;d[Se]="^\\s*("+d[l]+")\\s+-\\s+("+d[l]+")\\s*$";var he=k++;d[he]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var be=k++;d[be]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)M(ee,d[ee]),m[ee]||(m[ee]=new RegExp(d[ee]));function pe(z,H){if(z instanceof re)return z;if(typeof z!="string"||z.length>N||!(H?m[c]:m[h]).test(z))return null;try{return new re(z,H)}catch{return null}}function re(z,H){if(z instanceof re){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof re))return new re(z,H);M("SemVer",z,H),this.loose=H;var q=z.trim().match(H?m[c]:m[h]);if(!q)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(_){if(/^[0-9]+$/.test(_)){var se=+_;if(se>=0&&se<R)return se}return _}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}e.parse=pe,e.valid=function(z,H){var q=pe(z,H);return q?q.version:null},e.clean=function(z,H){var q=pe(z.trim().replace(/^[=v]+/,""),H);return q?q.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(z){return M("SemVer.compare",this.version,this.loose,z),z instanceof re||(z=new re(z,this.loose)),this.compareMain(z)||this.comparePre(z)},re.prototype.compareMain=function(z){return z instanceof re||(z=new re(z,this.loose)),V(this.major,z.major)||V(this.minor,z.minor)||V(this.patch,z.patch)},re.prototype.comparePre=function(z){if(z instanceof re||(z=new re(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var q=this.prerelease[H],_=z.prerelease[H];if(M("prerelease compare",H,q,_),q===void 0&&_===void 0)return 0;if(_===void 0)return 1;if(q===void 0)return-1;if(q!==_)return V(q,_)}while(++H)},re.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,q,_){typeof q=="string"&&(_=q,q=void 0);try{return new re(z,q).inc(H,_).version}catch{return null}},e.diff=function(z,H){if(Ie(z,H))return null;var q=pe(z),_=pe(H);if(q.prerelease.length||_.prerelease.length){for(var se in q)if((se==="major"||se==="minor"||se==="patch")&&q[se]!==_[se])return"pre"+se;return"prerelease"}for(var se in q)if((se==="major"||se==="minor"||se==="patch")&&q[se]!==_[se])return se},e.compareIdentifiers=V;var fe=/^[0-9]+$/;function V(z,H){var q=fe.test(z),_=fe.test(H);return q&&_&&(z=+z,H=+H),q&&!_?-1:_&&!q?1:z<H?-1:z>H?1:0}function te(z,H,q){return new re(z,q).compare(new re(H,q))}function ke(z,H,q){return te(z,H,q)>0}function Te(z,H,q){return te(z,H,q)<0}function Ie(z,H,q){return te(z,H,q)===0}function ve(z,H,q){return te(z,H,q)!==0}function ge(z,H,q){return te(z,H,q)>=0}function J(z,H,q){return te(z,H,q)<=0}function Y(z,H,q,_){var se;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof q=="object"&&(q=q.version),se=z===q;break;case"!==":typeof z=="object"&&(z=z.version),typeof q=="object"&&(q=q.version),se=z!==q;break;case"":case"=":case"==":se=Ie(z,q,_);break;case"!=":se=ve(z,q,_);break;case">":se=ke(z,q,_);break;case">=":se=ge(z,q,_);break;case"<":se=Te(z,q,_);break;case"<=":se=J(z,q,_);break;default:throw new TypeError("Invalid operator: "+H)}return se}function ce(z,H){if(z instanceof ce){if(z.loose===H)return z;z=z.value}if(!(this instanceof ce))return new ce(z,H);M("comparator",z,H),this.loose=H,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(z,H){return V(H,z)},e.major=function(z,H){return new re(z,H).major},e.minor=function(z,H){return new re(z,H).minor},e.patch=function(z,H){return new re(z,H).patch},e.compare=te,e.compareLoose=function(z,H){return te(z,H,!0)},e.rcompare=function(z,H,q){return te(H,z,q)},e.sort=function(z,H){return z.sort(function(q,_){return e.compare(q,_,H)})},e.rsort=function(z,H){return z.sort(function(q,_){return e.rcompare(q,_,H)})},e.gt=ke,e.lt=Te,e.eq=Ie,e.neq=ve,e.gte=ge,e.lte=J,e.cmp=Y,e.Comparator=ce;var de={};function Ne(z,H){if(z instanceof Ne)return z.loose===H?z:new Ne(z.raw,H);if(z instanceof ce)return new Ne(z.value,H);if(!(this instanceof Ne))return new Ne(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ue(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ce(z,H,q,_,se,Oe,We,Qe,xe,tt,at,nt,rt){return((H=ue(q)?"":ue(_)?">="+q+".0.0":ue(se)?">="+q+"."+_+".0":">="+H)+" "+(Qe=ue(xe)?"":ue(tt)?"<"+(+xe+1)+".0.0":ue(at)?"<"+xe+"."+(+tt+1)+".0":nt?"<="+xe+"."+tt+"."+at+"-"+nt:"<="+Qe)).trim()}function Re(z,H){for(var q=0;q<z.length;q++)if(!z[q].test(H))return!1;if(H.prerelease.length){for(q=0;q<z.length;q++)if(M(z[q].semver),z[q].semver!==de&&z[q].semver.prerelease.length>0){var _=z[q].semver;if(_.major===H.major&&_.minor===H.minor&&_.patch===H.patch)return!0}return!1}return!0}function je(z,H,q){try{H=new Ne(H,q)}catch{return!1}return H.test(z)}function U(z,H,q,_){var se,Oe,We,Qe,xe;switch(z=new re(z,_),H=new Ne(H,_),q){case">":se=ke,Oe=J,We=Te,Qe=">",xe=">=";break;case"<":se=Te,Oe=ge,We=ke,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(z,H,_))return!1;for(var tt=0;tt<H.set.length;++tt){var at=H.set[tt],nt=null,rt=null;if(at.forEach(function(ct){ct.semver===de&&(ct=new ce(">=0.0.0")),nt=nt||ct,rt=rt||ct,se(ct.semver,nt.semver,_)?nt=ct:We(ct.semver,rt.semver,_)&&(rt=ct)}),nt.operator===Qe||nt.operator===xe||(!rt.operator||rt.operator===Qe)&&Oe(z,rt.semver)||rt.operator===xe&&We(z,rt.semver))return!1}return!0}ce.prototype.parse=function(z){var H=this.loose?m[ne]:m[le],q=z.match(H);if(!q)throw new TypeError("Invalid comparator: "+z);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new re(q[2],this.loose):this.semver=de},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(z){return M("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new re(z,this.loose)),Y(z,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(z,H){if(!(z instanceof ce))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new Ne(z.value,H),je(this.value,q,H);if(z.operator==="")return q=new Ne(this.value,H),je(z.semver,q,H);var _=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Qe=Y(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),xe=Y(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return _||se||Oe&&We||Qe||xe},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),M("range",z,H);var q=H?m[he]:m[Se];z=z.replace(q,Ce),M("hyphen replace",z),z=z.replace(m[ye],"$1$2$3"),M("comparator trim",z,m[ye]),z=(z=(z=z.replace(m[A],"$1~")).replace(m[P],"$1^")).split(/\s+/).join(" ");var _=H?m[ne]:m[le],se=z.split(" ").map(function(Oe){return function(We,Qe){return M("comp",We),We=function(xe,tt){return xe.trim().split(/\s+/).map(function(at){return function(nt,rt){M("caret",nt,rt);var ct=rt?m[K]:m[L];return nt.replace(ct,function(Be,it,Z,X,$e){var Ve;return M("caret",nt,Be,it,Z,X,$e),ue(it)?Ve="":ue(Z)?Ve=">="+it+".0.0 <"+(+it+1)+".0.0":ue(X)?Ve=it==="0"?">="+it+"."+Z+".0 <"+it+"."+(+Z+1)+".0":">="+it+"."+Z+".0 <"+(+it+1)+".0.0":$e?(M("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ve=it==="0"?Z==="0"?">="+it+"."+Z+"."+X+$e+" <"+it+"."+Z+"."+(+X+1):">="+it+"."+Z+"."+X+$e+" <"+it+"."+(+Z+1)+".0":">="+it+"."+Z+"."+X+$e+" <"+(+it+1)+".0.0"):(M("no pr"),Ve=it==="0"?Z==="0"?">="+it+"."+Z+"."+X+" <"+it+"."+Z+"."+(+X+1):">="+it+"."+Z+"."+X+" <"+it+"."+(+Z+1)+".0":">="+it+"."+Z+"."+X+" <"+(+it+1)+".0.0"),M("caret return",Ve),Ve})}(at,tt)}).join(" ")}(We,Qe),M("caret",We),We=function(xe,tt){return xe.trim().split(/\s+/).map(function(at){return function(nt,rt){var ct=rt?m[T]:m[G];return nt.replace(ct,function(Be,it,Z,X,$e){var Ve;return M("tilde",nt,Be,it,Z,X,$e),ue(it)?Ve="":ue(Z)?Ve=">="+it+".0.0 <"+(+it+1)+".0.0":ue(X)?Ve=">="+it+"."+Z+".0 <"+it+"."+(+Z+1)+".0":$e?(M("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ve=">="+it+"."+Z+"."+X+$e+" <"+it+"."+(+Z+1)+".0"):Ve=">="+it+"."+Z+"."+X+" <"+it+"."+(+Z+1)+".0",M("tilde return",Ve),Ve})}(at,tt)}).join(" ")}(We,Qe),M("tildes",We),We=function(xe,tt){return M("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(at){return function(nt,rt){nt=nt.trim();var ct=rt?m[S]:m[g];return nt.replace(ct,function(Be,it,Z,X,$e,Ve){M("xRange",nt,Be,it,Z,X,$e,Ve);var Ze=ue(Z),ut=Ze||ue(X),Ae=ut||ue($e);return it==="="&&Ae&&(it=""),Ze?Be=it===">"||it==="<"?"<0.0.0":"*":it&&Ae?(ut&&(X=0),Ae&&($e=0),it===">"?(it=">=",ut?(Z=+Z+1,X=0,$e=0):Ae&&(X=+X+1,$e=0)):it==="<="&&(it="<",ut?Z=+Z+1:X=+X+1),Be=it+Z+"."+X+"."+$e):ut?Be=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ae&&(Be=">="+Z+"."+X+".0 <"+Z+"."+(+X+1)+".0"),M("xRange return",Be),Be})}(at,tt)}).join(" ")}(We,Qe),M("xrange",We),We=function(xe,tt){return M("replaceStars",xe,tt),xe.trim().replace(m[be],"")}(We,Qe),M("stars",We),We}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Oe){return!!Oe.match(_)})),se=se.map(function(Oe){return new ce(Oe,H)})},Ne.prototype.intersects=function(z,H){if(!(z instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(_){return z.set.some(function(se){return se.every(function(Oe){return _.intersects(Oe,H)})})})})},e.toComparators=function(z,H){return new Ne(z,H).set.map(function(q){return q.map(function(_){return _.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new re(z,this.loose));for(var H=0;H<this.set.length;H++)if(Re(this.set[H],z))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(z,H,q){var _=null,se=null;try{var Oe=new Ne(H,q)}catch{return null}return z.forEach(function(We){Oe.test(We)&&(_&&se.compare(We)!==-1||(se=new re(_=We,q)))}),_},e.minSatisfying=function(z,H,q){var _=null,se=null;try{var Oe=new Ne(H,q)}catch{return null}return z.forEach(function(We){Oe.test(We)&&(_&&se.compare(We)!==1||(se=new re(_=We,q)))}),_},e.validRange=function(z,H){try{return new Ne(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,q){return U(z,H,"<",q)},e.gtr=function(z,H,q){return U(z,H,">",q)},e.outside=U,e.prerelease=function(z,H){var q=pe(z,H);return q&&q.prerelease.length?q.prerelease:null},e.intersects=function(z,H,q){return z=new Ne(z,q),H=new Ne(H,q),z.intersects(H)},e.coerce=function(z){if(z instanceof re)return z;if(typeof z!="string")return null;var H=z.match(m[y]);return H==null?null:pe((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,I(1))},function(me,e){var I,F,M=me.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(o){if(I===setTimeout)return setTimeout(o,0);if((I===N||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:N}catch{I=N}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var d,k=[],O=!1,E=-1;function u(){O&&d&&(O=!1,d.length?k=d.concat(k):E=-1,k.length&&b())}function b(){if(!O){var o=m(u);O=!0;for(var s=k.length;s;){for(d=k,k=[];++E<s;)d&&d[E].run();E=-1,s=k.length}d=null,O=!1,function(n){if(F===clearTimeout)return clearTimeout(n);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(n);try{F(n)}catch{try{return F.call(null,n)}catch{return F.call(this,n)}}}(o)}}function f(o,s){this.fun=o,this.array=s}function r(){}M.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];k.push(new f(o,s)),k.length!==1||O||m(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(o){return[]},M.binding=function(o){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(o){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Pe[127],Me([1,0,14,6]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=M,e.$ge=N,e.$he=R,e.$ie=m,e.$je=k,e.$ke=O,e.$le=E,e.$me=u,e.$ne=b,e.$oe=f,e.$pe=r,e.$qe=o,e.$re=s,e.$se=n,e.$te=i;function M(a){const h=a;return h?typeof h.read=="function":!1}function N(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function R(a){const h=a;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(a,h){return new d(a,h)}class d{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let v;switch(h){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const c=v.indexOf(t);c>=0&&v.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(a,h){const t=[];let v;for(;(v=a.read())!==null;)t.push(v);return h(t)}function O(a,h,t){const v=[];let c;for(;(c=a.read())!==null&&v.length<t;)v.push(c);return c===null&&v.length>0?h(v):{read:()=>{if(v.length>0)return v.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function E(a,h){return new Promise((t,v)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?v($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",v=>{t?.isCancellationRequested||h.onError(v)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",v=>{t?.isCancellationRequested||h.onData(v)})}function b(a,h){return new Promise((t,v)=>{const c=new F.$Tc,$=[],w=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},p=D=>(c.dispose(),v(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,F.$Sc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,F.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,F.$Sc)(()=>a.removeListener("data",w))),a.on("data",w)})}function f(a,h){const t=m(h);return t.end(a),t}function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const v=m(t);return u(a,{onData:c=>v.write(h.data(c)),onError:c=>v.error(h.error?h.error(c):c),onEnd:()=>v.end()}),v}function n(a,h,t){let v=!1;return{read:()=>{const c=h.read();return v?c:(v=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let v=!1;const c=m(t);return u(h,{onData:$=>v?c.write($):(v=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{v||(v=!0,c.write(a)),c.end()}}),c}}),define(Pe[23],Me([1,0,40,127]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=k,e.$we=O,e.$xe=E,e.$ye=u,e.$ze=b,e.$Ae=f,e.$Be=r,e.$Ce=o,e.$De=s,e.$Ee=n,e.$Fe=i,e.$Ge=a,e.$He=h,e.$Ie=t,e.$Je=v,e.$Ke=c,e.$Le=$,e.$Me=w,e.$Ne=p,e.$Oe=g;const M=typeof Buffer<"u",N=new I.$V(()=>new Uint8Array(256));let R,m;class d{static alloc(y){return M?new d(Buffer.allocUnsafe(y)):new d(new Uint8Array(y))}static wrap(y){return M&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new d(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&M?new d(Buffer.from(y)):(R||(R=new TextEncoder),new d(R.encode(y)))}static fromByteArray(y){const C=d.alloc(y.length);for(let A=0,G=y.length;A<G;A++)C.buffer[A]=y[A];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let T=0,W=y.length;T<W;T++)C+=y[T].byteLength}const A=d.alloc(C);let G=0;for(let T=0,W=y.length;T<W;T++){const P=y[T];A.set(P,G),G+=P.byteLength}return A}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=d.alloc(this.byteLength);return y.set(this),y}toString(){return M?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,C){return new d(this.buffer.subarray(y,C))}set(y,C){if(y instanceof d)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,C){b(this.buffer,y,C)}readUInt32LE(y){return f(this.buffer,y)}writeUInt32LE(y,C){r(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return k(this.buffer,y instanceof d?y.buffer:y,C)}}e.$ue=d;function k(S,y,C=0){const A=y.byteLength,G=S.byteLength;if(A===0)return 0;if(A===1)return S.indexOf(y[0]);if(A>G-C)return-1;const T=N.value;T.fill(y.length);for(let K=0;K<y.length;K++)T[y[K]]=y.length-K-1;let W=C+y.length-1,P=W,L=-1;for(;W<G;)if(S[W]===y[P]){if(P===0){L=W;break}W--,P--}else W+=Math.max(y.length-P,T[S[W]]),P=y.length-1;return L}function O(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function E(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255}function u(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function b(S,y,C){S[C+3]=y,y=y>>>8,S[C+2]=y,y=y>>>8,S[C+1]=y,y=y>>>8,S[C]=y}function f(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function r(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255,y=y>>>8,S[C+2]=y&255,y=y>>>8,S[C+3]=y&255}function o(S,y){return S[y]}function s(S,y,C){S[C]=y}function n(S){return F.$je(S,y=>d.concat(y))}function i(S){return F.$qe(S)}function a(S){return F.$le(S,y=>d.concat(y))}async function h(S){return S.ended?d.concat(S.buffer):d.concat([...S.buffer,await a(S.stream)])}function t(S){return F.$oe(S,y=>d.concat(y))}function v(S){return F.$re(S,{data:y=>typeof y=="string"?d.fromString(y):d.wrap(y)},y=>d.concat(y))}function c(S){return F.$ie(y=>d.concat(y),S)}function $(S,y){return F.$se(S,y,C=>d.concat(C))}function w(S,y){return F.$te(S,y,C=>d.concat(C))}function p(S){let y=0,C=0,A=0;const G=new Uint8Array(Math.floor(S.length/4*3)),T=P=>{switch(C){case 3:G[A++]=y|P,C=0;break;case 2:G[A++]=y|P>>>2,y=P<<6,C=3;break;case 1:G[A++]=y|P>>>4,y=P<<4,C=2;break;default:y=P<<2,C=1}};for(let P=0;P<S.length;P++){const L=S.charCodeAt(P);if(L>=65&&L<=90)T(L-65);else if(L>=97&&L<=122)T(L-97+26);else if(L>=48&&L<=57)T(L-48+52);else if(L===43||L===45)T(62);else if(L===47||L===95)T(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${S[P]}`)}}const W=A;for(;C>0;)T(0);return d.wrap(G).slice(0,W)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:S},y=!0,C=!1){const A=C?D:l;let G="";const T=S.byteLength%3;let W=0;for(;W<S.byteLength-T;W+=3){const P=S[W+0],L=S[W+1],K=S[W+2];G+=A[P>>>2],G+=A[(P<<4|L>>>4)&63],G+=A[(L<<2|K>>>6)&63],G+=A[K&63]}if(T===1){const P=S[W+0];G+=A[P>>>2],G+=A[P<<4&63],y&&(G+="==")}else if(T===2){const P=S[W+0],L=S[W+1];G+=A[P>>>2],G+=A[(P<<4|L>>>4)&63],G+=A[L<<2&63],y&&(G+="=")}return G}}),define(Pe[128],Me([1,0,28,124,15]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.FuzzyScore=e.$jk=e.$ik=void 0,e.or=N,e.$kk=m,e.$lk=d,e.$mk=E,e.$nk=p,e.$ok=l,e.$pk=A,e.$qk=G,e.$rk=T,e.$sk=W,e.$tk=te,e.$vk=ve,e.$wk=Y,e.$xk=ce;function N(...ue){return function(Ce,Re){for(let je=0,U=ue.length;je<U;je++){const z=ue[je](Ce,Re);if(z)return z}return null}}e.$ik=R.bind(void 0,!1),e.$jk=R.bind(void 0,!0);function R(ue,Ce,Re){if(!Re||Re.length<Ce.length)return null;let je;return ue?je=M.$mf(Re,Ce):je=Re.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(ue,Ce){const Re=Ce.toLowerCase().indexOf(ue.toLowerCase());return Re===-1?null:[{start:Re,end:Re+ue.length}]}function d(ue,Ce){return k(ue.toLowerCase(),Ce.toLowerCase(),0,0)}function k(ue,Ce,Re,je){if(Re===ue.length)return[];if(je===Ce.length)return null;if(ue[Re]===Ce[je]){let U=null;return(U=k(ue,Ce,Re+1,je+1))?a({start:je,end:je+1},U):null}return k(ue,Ce,Re,je+1)}function O(ue){return 97<=ue&&ue<=122}function E(ue){return 65<=ue&&ue<=90}function u(ue){return 48<=ue&&ue<=57}function b(ue){return ue===32||ue===9||ue===10||ue===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ue=>f.add(ue.charCodeAt(0)));function r(ue){return b(ue)||f.has(ue)}function o(ue,Ce){return ue===Ce||r(ue)&&r(Ce)}const s=new Map;function n(ue){if(s.has(ue))return s.get(ue);let Ce;const Re=(0,F.$gk)(ue);return Re&&(Ce=Re),s.set(ue,Ce),Ce}function i(ue){return O(ue)||E(ue)||u(ue)}function a(ue,Ce){return Ce.length===0?Ce=[ue]:ue.end===Ce[0].start?Ce[0].start=ue.start:Ce.unshift(ue),Ce}function h(ue,Ce){for(let Re=Ce;Re<ue.length;Re++){const je=ue.charCodeAt(Re);if(E(je)||u(je)||Re>0&&!i(ue.charCodeAt(Re-1)))return Re}return ue.length}function t(ue,Ce,Re,je){if(Re===ue.length)return[];if(je===Ce.length)return null;if(ue[Re]!==Ce[je].toLowerCase())return null;{let U=null,z=je+1;for(U=t(ue,Ce,Re+1,je+1);!U&&(z=h(Ce,z))<Ce.length;)U=t(ue,Ce,Re+1,z),z++;return U===null?null:a({start:je,end:je+1},U)}}function v(ue){let Ce=0,Re=0,je=0,U=0,z=0;for(let Oe=0;Oe<ue.length;Oe++)z=ue.charCodeAt(Oe),E(z)&&Ce++,O(z)&&Re++,i(z)&&je++,u(z)&&U++;const H=Ce/ue.length,q=Re/ue.length,_=je/ue.length,se=U/ue.length;return{upperPercent:H,lowerPercent:q,alphaPercent:_,numericPercent:se}}function c(ue){const{upperPercent:Ce,lowerPercent:Re}=ue;return Re===0&&Ce>.6}function $(ue){const{upperPercent:Ce,lowerPercent:Re,alphaPercent:je,numericPercent:U}=ue;return Re>.2&&Ce<.8&&je>.6&&U<.2}function w(ue){let Ce=0,Re=0,je=0,U=0;for(let z=0;z<ue.length;z++)je=ue.charCodeAt(z),E(je)&&Ce++,O(je)&&Re++,b(je)&&U++;return(Ce===0||Re===0)&&U===0?ue.length<=30:Ce<=5}function p(ue,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!w(ue))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Re=v(Ce);if(!$(Re)){if(!c(Re))return null;Ce=Ce.toLowerCase()}let je=null,U=0;for(ue=ue.toLowerCase();U<Ce.length&&(je=t(ue,Ce,0,U))===null;)U=h(Ce,U+1);return je}function l(ue,Ce,Re=!1){if(!Ce||Ce.length===0)return null;let je=null,U=0;for(ue=ue.toLowerCase(),Ce=Ce.toLowerCase();U<Ce.length&&(je=D(ue,Ce,0,U,Re),je===null);)U=g(Ce,U+1);return je}function D(ue,Ce,Re,je,U){let z=0;if(Re===ue.length)return[];if(je===Ce.length)return null;if(!o(ue.charCodeAt(Re),Ce.charCodeAt(je))){const _=n(ue.charCodeAt(Re));if(!_)return null;for(let se=0;se<_.length;se++)if(!o(_[se],Ce.charCodeAt(je+se)))return null;z+=_.length-1}let H=null,q=je+z+1;if(H=D(ue,Ce,Re+1,q,U),!U)for(;!H&&(q=g(Ce,q))<Ce.length;)H=D(ue,Ce,Re+1,q,U),q++;if(!H)return null;if(ue.charCodeAt(Re)!==Ce.charCodeAt(je)){const _=n(ue.charCodeAt(Re));if(!_)return H;for(let se=0;se<_.length;se++)if(_[se]!==Ce.charCodeAt(je+se))return H}return a({start:je,end:je+z+1},H)}function g(ue,Ce){for(let Re=Ce;Re<ue.length;Re++)if(r(ue.charCodeAt(Re))||Re>0&&r(ue.charCodeAt(Re-1)))return Re;return ue.length}const S=N(e.$jk,p,m),y=N(e.$jk,p,d),C=new I.$Ec(1e4);function A(ue,Ce,Re=!1){if(typeof ue!="string"||typeof Ce!="string")return null;let je=C.get(ue);je||(je=new RegExp(M.$7e(ue),"i"),C.set(ue,je));const U=je.exec(Ce);return U?[{start:U.index,end:U.index+U[0].length}]:Re?y(ue,Ce):S(ue,Ce)}function G(ue,Ce){const Re=ve(ue,ue.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?W(Re):null}function T(ue,Ce,Re,je,U,z){const H=Math.min(13,ue.length);for(;Re<H;Re++){const q=ve(ue,Ce,Re,je,U,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(q)return q}return[0,z]}function W(ue){if(typeof ue>"u")return[];const Ce=[],Re=ue[1];for(let je=ue.length-1;je>1;je--){const U=ue[je]+Re,z=Ce[Ce.length-1];z&&z.end===U?z.end=U+1:Ce.push({start:U,end:U+1})}return Ce}const P=128;function L(){const ue=[],Ce=[];for(let Re=0;Re<=P;Re++)Ce[Re]=0;for(let Re=0;Re<=P;Re++)ue.push(Ce.slice(0));return ue}function K(ue){const Ce=[];for(let Re=0;Re<=ue;Re++)Ce[Re]=0;return Ce}const ne=K(2*P),le=K(2*P),ye=L(),Se=L(),he=L(),be=!1;function ee(ue,Ce,Re,je,U){function z(q,_,se=" "){for(;q.length<_;)q=se+q;return q}let H=` |   |${je.split("").map(q=>z(q,3)).join("|")}
`;for(let q=0;q<=Re;q++)q===0?H+=" |":H+=`${Ce[q-1]}|`,H+=ue[q].slice(0,U+1).map(_=>z(_.toString(),3)).join("|")+`
`;return H}function pe(ue,Ce,Re,je){ue=ue.substr(Ce),Re=Re.substr(je),console.log(ee(Se,ue,ue.length,Re,Re.length)),console.log(ee(he,ue,ue.length,Re,Re.length)),console.log(ee(ye,ue,ue.length,Re,Re.length))}function re(ue,Ce){if(Ce<0||Ce>=ue.length)return!1;const Re=ue.codePointAt(Ce);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Ef(Re)}}function fe(ue,Ce){if(Ce<0||Ce>=ue.length)return!1;switch(ue.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function V(ue,Ce,Re){return Ce[ue]!==Re[ue]}function te(ue,Ce,Re,je,U,z,H=!1){for(;Ce<Re&&U<z;)ue[Ce]===je[U]&&(H&&(ne[Ce]=U),Ce+=1),U+=1;return Ce===Re}var ke;(function(ue){ue[ue.Diag=1]="Diag",ue[ue.Left=2]="Left",ue[ue.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Te;(function(ue){ue.Default=[-100,0];function Ce(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}ue.isDefault=Ce})(Te||(e.FuzzyScore=Te={}));class Ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Re){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Re}}e.$uk=Ie;function ve(ue,Ce,Re,je,U,z,H=Ie.default){const q=ue.length>P?P:ue.length,_=je.length>P?P:je.length;if(Re>=q||z>=_||q-Re>_-z||!te(Ce,Re,q,U,z,_,!0))return;ge(q,_,Re,z,Ce,U);let se=1,Oe=1,We=Re,Qe=z;const xe=[!1];for(se=1,We=Re;We<q;se++,We++){const ct=ne[We],Be=le[We],it=We+1<q?le[We+1]:_;for(Oe=ct-z+1,Qe=ct;Qe<it;Oe++,Qe++){let Z=Number.MIN_SAFE_INTEGER,X=!1;Qe<=Be&&(Z=J(ue,Ce,We,Re,je,U,Qe,_,z,ye[se-1][Oe-1]===0,xe));let $e=0;Z!==Number.MAX_SAFE_INTEGER&&(X=!0,$e=Z+Se[se-1][Oe-1]);const Ve=Qe>ct,Ze=Ve?Se[se][Oe-1]+(ye[se][Oe-1]>0?-5:0):0,ut=Qe>ct+1&&ye[se][Oe-1]>0,Ae=ut?Se[se][Oe-2]+(ye[se][Oe-2]>0?-5:0):0;if(ut&&(!Ve||Ae>=Ze)&&(!X||Ae>=$e))Se[se][Oe]=Ae,he[se][Oe]=3,ye[se][Oe]=0;else if(Ve&&(!X||Ze>=$e))Se[se][Oe]=Ze,he[se][Oe]=2,ye[se][Oe]=0;else if(X)Se[se][Oe]=$e,he[se][Oe]=1,ye[se][Oe]=ye[se-1][Oe-1]+1;else throw new Error("not possible")}}if(be&&pe(ue,Re,je,z),!xe[0]&&!H.firstMatchCanBeWeak)return;se--,Oe--;const tt=[Se[se][Oe],z];let at=0,nt=0;for(;se>=1;){let ct=Oe;do{const Be=he[se][ct];if(Be===3)ct=ct-2;else if(Be===2)ct=ct-1;else break}while(ct>=1);at>1&&Ce[Re+se-1]===U[z+Oe-1]&&!V(ct+z-1,je,U)&&at+1>ye[se][ct]&&(ct=Oe),ct===Oe?at++:at=1,nt||(nt=ct),se--,Oe=ct-1,tt.push(Oe)}_===q&&H.boostFullMatch&&(tt[0]+=2);const rt=nt-q;return tt[0]-=rt,tt}function ge(ue,Ce,Re,je,U,z){let H=ue-1,q=Ce-1;for(;H>=Re&&q>=je;)U[H]===z[q]&&(le[H]=q,H--),q--}function J(ue,Ce,Re,je,U,z,H,q,_,se,Oe){if(Ce[Re]!==z[H])return Number.MIN_SAFE_INTEGER;let We=1,Qe=!1;return H===Re-je?We=ue[Re]===U[H]?7:5:V(H,U,z)&&(H===0||!V(H-1,U,z))?(We=ue[Re]===U[H]?7:5,Qe=!0):re(z,H)&&(H===0||!re(z,H-1))?We=5:(re(z,H-1)||fe(z,H-1))&&(We=5,Qe=!0),We>1&&Re===je&&(Oe[0]=!0),Qe||(Qe=V(H,U,z)||re(z,H-1)||fe(z,H-1)),Re===je?H>_&&(We-=Qe?3:5):se?We+=Qe?2:0:We+=Qe?0:1,H+1===q&&(We-=Qe?3:5),We}function Y(ue,Ce,Re,je,U,z,H){return de(ue,Ce,Re,je,U,z,!0,H)}function ce(ue,Ce,Re,je,U,z,H){return de(ue,Ce,Re,je,U,z,!1,H)}function de(ue,Ce,Re,je,U,z,H,q){let _=ve(ue,Ce,Re,je,U,z,q);if(_&&!H)return _;if(ue.length>=3){const se=Math.min(7,ue.length-1);for(let Oe=Re+1;Oe<se;Oe++){const We=Ne(ue,Oe);if(We){const Qe=ve(We,We.toLowerCase(),Re,je,U,z,q);Qe&&(Qe[0]-=3,(!_||Qe[0]>_[0])&&(_=Qe))}}}return _}function Ne(ue,Ce){if(Ce+1>=ue.length)return;const Re=ue[Ce],je=ue[Ce+1];if(Re!==je)return ue.slice(0,Ce)+je+Re+ue.slice(Ce+2)}}),define(Pe[32],Me([1,0,15]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(F||(F={})),function(M){const N="error",R="warning",m="warn",d="info",k="ignore";function O(u){return u?I.$lf(N,u)?M.Error:I.$lf(R,u)||I.$lf(m,u)?M.Warning:I.$lf(d,u)?M.Info:M.Ignore:M.Ignore}M.fromValue=O;function E(u){switch(u){case M.Error:return N;case M.Warning:return R;case M.Info:return d;default:return k}}M.toString=E}(F||(F={})),e.default=F}),define(Pe[129],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Pe[51],Me([1,0,18,15]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class M{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return f-r}value(){return this.b[this.c]}}e.$ji=M;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,F.$ff)(b,this.b,0,b.length,this.c,this.d):(0,F.$hf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=N;class R{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const r=this.b.charCodeAt(f);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,F.$ff)(b,this.b,0,b.length,this.d,this.e):(0,F.$hf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=R;var m;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(m||(m={}));class d{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,F.$gf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,F.$gf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,F.$ef)(b,this.c.query);if(this.d[this.e]===5)return(0,F.$ef)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=d;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(O||(O={}));class E{static forUris(b=()=>!1,f=()=>!1){return new E(new d(b,f))}static forPaths(b=!1){return new E(new R(void 0,!b))}static forStrings(){return new E(new M)}static forConfigKeys(){return new E(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const r=f.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o,b)}else{const r=b.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(b,f){const r=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=r.value());const s=[];for(o=this.c;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new k,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new k,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new k,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=f,o.key=b;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],v=s[i+1][0];if(t===1&&v===1)s[i][1]=a.rotateLeft();else if(t===-1&&v===-1)s[i][1]=a.rotateRight();else if(t===1&&v===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&v===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let r=this.c;for(;r;){const o=f.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(f.hasNext())f.next(),r=r.mid;else break}return r}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const r=this.b.reset(b),o=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(f?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:i,value:a,segment:h}=n;this.e(n.key,!1),s.key=i,s.value=a,s.segment=h}}else{const n=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const i=o[n][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[n][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[n][1]=i.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let r=this.c,o;for(;r;){const s=f.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(f.hasNext())f.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(b){return this.g(b,!1)}g(b,f){const r=this.b.reset(b);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):f?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,r]of this)b(r,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){b&&(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const r=f.balanceFactor();return r<-1||r>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.$ni=E}),define(Pe[41],Me([1,0,91]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Hj=M;var F;(function(R){function m(d){return d&&typeof d=="object"&&typeof d.id=="string"}R.isThemeColor=m})(F||(e.ThemeColor=F={}));function M(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function d(n){const i=m.exec(n.id);if(!i)return d(I.$Gj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}R.asClassNameArray=d;function k(n){return d(n).join(" ")}R.asClassName=k;function O(n){return"."+d(n).join(".")}R.asCSSSelector=O;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||F.isThemeColor(n.color))}R.isThemeIcon=E;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(n){const i=u.exec(n);if(!i)return;const[,a]=i;return{id:a}}R.fromString=b;function f(n){return{id:n}}R.fromId=f;function r(n,i){let a=n.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}R.modify=r;function o(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=o;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Pe[130],Me([1,0,128,15,41]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=d,e.$zk=O,e.$Ak=u,e.$Bk=b,e.$Ck=r,e.$Dk=o;const N="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function d(s){return s.replace(m,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${R.source}`,"g");function O(s){return s.replace(k,n=>`\\${n}`)}const E=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(s){return s.indexOf(N)===-1?s:s.replace(E,(n,i,a,h)=>a?n:i||h||"")}function b(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){f.lastIndex=0;let n="";const i=[];let a=0;for(;;){const h=f.lastIndex,t=f.exec(s),v=s.substring(h,t?.index);if(v.length>0){n+=v;for(let c=0;c<v.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:n,iconOffsets:i}}function o(s,n,i=!1){const{text:a,iconOffsets:h}=n;if(!h||h.length===0)return(0,I.$pk)(s,a,i);const t=(0,F.$5e)(a," "),v=a.length-t.length,c=(0,I.$pk)(s,t,i);if(c)for(const $ of c){const w=h[$.start+v]+v;$.start+=w,$.end+=w}return c}}),define(Pe[34],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=F;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(M){return I.test(M)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(m){for(let d=0;d<m.length;d++)m[d]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){M(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let d=0,k="";return k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k}}()}),define(Pe[131],Me([1,0,18,39,34]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=N,e.$Ht=R,e.$Jt=k;function N(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function R(E,u,b){const f={id:(0,M.$Dg)(),name:E,uri:u,data:b};return{asString:async()=>"",asFile:()=>f,value:void 0}}class m{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return F.Iterable.some(this,([f,r])=>r.asFile())&&b.push("files"),O(d(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const f=this.a.get(u);f?f.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const f of b)yield[u,f]}b(u){return d(u)}}e.$It=m;function d(E){return E.toLowerCase()}function k(E,u){return O(d(E),u.map(d))}function O(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const b=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[f,r,o]=b;return o==="*"?u.some(s=>s.startsWith(r+"/")):!1}e.$Kt=Object.freeze({create:E=>(0,I.$Mb)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Kt.split(E).filter(u=>!u.startsWith("#"))})}),define(Pe[132],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=F;var I;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(M){let N=0,R=0,m=0,d=0;for(let k=0,O=M.length;k<O;k++){const E=M.charCodeAt(k);E===13?(N===0&&(R=k),N++,k+1<O&&M.charCodeAt(k+1)===10?(d|=2,k++):d|=3,m=k+1):E===10&&(d|=1,N===0&&(R=k),N++,m=k+1)}return N===0&&(R=M.length),[N,R,M.length-m,d]}}),define(Pe[133],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0,e.$Ls={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[134],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let d=0,k=m.notIn.length;d<k;d++)switch(m.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,d){if(m.getTokenCount()===0)return!0;const k=m.findTokenIndexAtOffset(d-2),O=m.getStandardTokenType(k);return this.isOK(O)}g(m,d){for(let k=m;k<=d;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=F;class M{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of m)N(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),N(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),N(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),N(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&N(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$bu=M;function N(R,m,d){R.has(m)?R.get(m).push(d):R.set(m,[d])}}),define(Pe[135],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.NodeColor=e.$cC=void 0,e.$eC=M,e.$fC=N,e.$gC=k,e.$hC=O,e.$iC=E,e.$jC=u,e.$kC=b,e.$lC=f;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$dC)return M(this.right);let o=this;for(;o.parent!==e.$dC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$dC?e.$dC:o.parent}prev(){if(this.left!==e.$dC)return N(this.left);let o=this;for(;o.parent!==e.$dC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$dC?e.$dC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$cC=I;var F;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$dC=new I(null,0),e.$dC.parent=e.$dC,e.$dC.left=e.$dC,e.$dC.right=e.$dC,e.$dC.color=0;function M(r){for(;r.left!==e.$dC;)r=r.left;return r}function N(r){for(;r.right!==e.$dC;)r=r.right;return r}function R(r){return r===e.$dC?0:r.size_left+r.piece.length+R(r.right)}function m(r){return r===e.$dC?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function d(){e.$dC.parent=e.$dC}function k(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$dC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$dC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function O(r,o){const s=o.left;o.left=s.right,s.right!==e.$dC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$dC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function E(r,o){let s,n;if(o.left===e.$dC?(n=o,s=n.right):o.right===e.$dC?(n=o,s=n.left):(n=M(o.right),s=n.right),n===r.root){r.root=s,s.color=0,o.detach(),d(),r.root.parent=e.$dC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===o?(s.parent=n.parent,f(r,s)):(n.parent===o?s.parent=n:s.parent=n.parent,f(r,s),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$dC&&(n.left.parent=n),n.right!==e.$dC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,f(r,n)),o.detach(),s.parent.left===s){const h=R(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const v=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,b(r,s.parent,v,c)}}if(f(r,s.parent),i){d();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,k(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,O(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,k(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,O(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,k(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,O(r,s.parent),s=r.root));s.color=0,d()}function u(r,o){for(f(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(r,o)),o.parent.color=0,o.parent.parent.color=1,O(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,O(r,o)),o.parent.color=0,o.parent.parent.color=1,k(r,o.parent.parent))}r.root.color=0}function b(r,o,s,n){for(;o!==r.root&&o!==e.$dC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}function f(r,o){let s=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=R(o.left)-o.size_left,n=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=n;o!==r.root&&(s!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}}}),define(Pe[92],Me([1,0,93,29,94,135,95]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=e.$vC=e.$uC=void 0,e.$sC=O,e.$tC=E;const m=65535;function d(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class k{constructor(n,i,a,h,t){this.lineStarts=n,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function O(s,n=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const v=s.charCodeAt(h);v===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:v===10&&(i[a++]=h+1)}return n?d(i):i}function E(s,n){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,v=!0;for(let $=0,w=n.length;$<w;$++){const p=n.charCodeAt($);p===13?$+1<w&&n.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):p===10?(h++,s[i++]=$+1):v&&p!==9&&(p<32||p>126)&&(v=!1)}const c=new k(d(s),a,h,t,v);return s.length=0,c}class u{constructor(n,i,a,h,t){this.bufferIndex=n,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$uC=u;class b{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$vC=b;class f{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$dC&&n.iterate(n.root,a=>(a!==N.$dC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=n){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(n,i,a){this.create(n,i,a)}create(n,i,a){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$dC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,v=n.length;t<v;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=O(n[t].buffer));const c=new u(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,c)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=m,a=i-Math.floor(i/3),h=a*2;let t="",v=0;const c=[];if(this.iterate(this.root,$=>{const w=this.R($),p=w.length;if(v<=a||v+p<h)return t+=w,v+=p,!0;const l=t.replace(/\r\n|\r|\n/g,n);return c.push(new b(l,O(l))),t=w,v=p,!0}),v>0){const $=t.replace(/\r\n|\r|\n/g,n);c.push(new b($,O($)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$dC)return!0;const t=this.R(h),v=t.length,c=n.G(i),$=n.G(i+v),w=n.getValueInRange2(c,$);return i+=v,t===w})}getOffsetAt(n,i){let a=0,h=this.root;for(;h!==N.$dC;)if(h.left!==N.$dC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){a+=h.size_left;const t=this.B(h,n-h.lf_left-2);return a+=t+i-1}else n-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,a=0;const h=n;for(;i!==N.$dC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const v=this.getOffsetAt(a+1,1),c=h-v;return new I.$at(a+1,c+1)}return new I.$at(a+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$dC){const t=this.getOffsetAt(a+1,1),v=h-n-t;return new I.$at(a+1,v+1)}else i=i.right;return new I.$at(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const c=n.node,$=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(w+n.remainder,w+i.remainder)}let a=n.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let v=h.substring(t+n.remainder,t+a.piece.length);for(a=a.next();a!==N.$dC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){v+=c.substring($,$+i.remainder);break}else v+=c.substr($,a.piece.length);a=a.next()}return v}getLinesContent(){const n=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===N.$dC)return!0;const v=t.piece;let c=v.length;if(c===0)return!0;const $=this.a[v.bufferIndex].buffer,w=this.a[v.bufferIndex].lineStarts,p=v.start.line,l=v.end.line;let D=w[p]+v.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),n[i++]=a,a="",h=!1,c===0))return!0;if(p===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,w[p+1]-this.e)):$.substring(D,w[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;for(let g=p+1;g<l;g++)a=this.f?$.substring(w[g],w[g+1]-this.e):$.substring(w[g],w[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;return!this.f&&$.charCodeAt(w[l]+v.end.column-1)===13?(h=!0,v.end.column===0?i--:a=$.substr(w[l],v.end.column-1)):a=$.substr(w[l],v.end.column),!0}),h&&(n[i++]=a,a=""),n[i++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(n,i){const a=this.H(n,i+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,a,h,t,v,c,$,w,p,l){const D=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start),S=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,v);let C;const A={line:0,column:0};let G,T;i._wordSeparators?(G=D.buffer.substring(S,y),T=W=>W+S,i.reset(0)):(G=D.buffer,T=W=>W,i.reset(S));do if(C=i.next(G),C){if(T(C.index)>=y)return p;this.s(n,T(C.index)-g,A);const W=this.t(n.piece.bufferIndex,t,A),P=A.line===t.line?A.column-t.column+h:A.column+1,L=P+C[0].length;if(l[p++]=(0,R.$oC)(new F.$bt(a+W,P,a+W,L),C,$),T(C.index)+C[0].length>=y||p>=w)return p}while(C);return p}findMatchesLineByLine(n,i,a,h){const t=[];let v=0;const c=new R.$rC(i.wordSeparators,i.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let p=this.s($.node,$.remainder);const l=this.s(w.node,w.remainder);if($.node===w.node)return this.findMatchesInNode($.node,c,n.startLineNumber,n.startColumn,p,l,i,a,h,v,t),t;let D=n.startLineNumber,g=$.node;for(;g!==w.node;){const y=this.t(g.piece.bufferIndex,p,g.piece.end);if(y>=1){const A=this.a[g.piece.bufferIndex].lineStarts,G=this.u(g.piece.bufferIndex,g.piece.start),T=A[p.line+y],W=D===n.startLineNumber?n.startColumn:1;if(v=this.findMatchesInNode(g,c,D,W,p,this.s(g,T-G),i,a,h,v,t),v>=h)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const A=this.getLineContent(D).substring(C,n.endColumn-1);return v=this.n(i,c,A,n.endLineNumber,C,v,t,a,h),t}if(v=this.n(i,c,this.getLineContent(D).substr(C),D,C,v,t,a,h),v>=h)return t;D++,$=this.H(D,1),g=$.node,p=this.s($.node,$.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return v=this.n(i,c,C,n.endLineNumber,y,v,t,a,h),t}const S=D===n.startLineNumber?n.startColumn:1;return v=this.findMatchesInNode(w.node,c,D,S,p,l,i,a,h,v,t),t}n(n,i,a,h,t,v,c,$,w){const p=n.wordSeparators;if(!$&&n.simpleSearch){const D=n.simpleSearch,g=D.length,S=a.length;let y=-g;for(;(y=a.indexOf(D,y+g))!==-1;)if((!p||(0,R.$qC)(p,a,S,y,g))&&(c[v++]=new M.$vv(new F.$bt(h,y+1+t,h,y+1+g+t),null),v>=w))return v;return v}let l;i.reset(0);do if(l=i.next(a),l&&(c[v++]=(0,R.$oC)(new F.$bt(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),v>=w))return v;while(l);return v}insert(n,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==N.$dC){const{node:h,remainder:t,nodeStartOffset:v}=this.G(n),c=h.piece,$=c.bufferIndex,w=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&v+c.length===n&&i.length<m){this.F(h,i),this.y();return}if(v===n)this.o(i,h),this.h.validate(n);else if(v+h.piece.length>n){const p=[];let l=new u(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u($,c.end)-this.u($,w));if(this.K()&&this.M(i)&&this.I(h,t)===10){const y={line:l.start.line+1,column:0};l=new u(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),i="\r"+i,h.piece.length===0&&p.push(h)}else this.C(h,w);else this.C(h,w);const D=this.w(i);l.length>0&&this.S(h,l);let g=h;for(let S=0;S<D.length;S++)g=this.S(g,D[S]);this.v(p)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let v=1;v<h.length;v++)t=this.S(t,h[v])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$dC)return;const a=this.G(n),h=this.G(n+i),t=a.node,v=h.node;if(t===v){const D=this.s(t,a.remainder),g=this.s(t,h.remainder);if(a.nodeStartOffset===n){if(i===t.piece.length){const S=t.next();(0,N.$iC)(this,t),this.N(S),this.y();return}this.D(t,g),this.h.validate(n),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,g),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(n),t.piece.length===0&&c.push(t);const w=this.s(v,h.remainder);this.D(v,w),v.piece.length===0&&c.push(v);const p=t.next();for(let D=p;D!==N.$dC&&D!==v;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(n,i){const a=[];if(this.K()&&this.M(n)&&this.L(i)){const v=i.piece,c={line:v.start.line+1,column:0},$=new u(v.bufferIndex,c,v.end,this.t(v.bufferIndex,c,v.end),v.length-1);i.piece=$,n+=`
`,(0,N.$kC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(n);let t=this.T(i,h[h.length-1]);for(let v=h.length-2;v>=0;v--)t=this.T(t,h[v]);this.N(t),this.v(a)}q(n,i){this.Q(n,i)&&(n+=`
`);const a=this.w(n),h=this.S(i,a[0]);let t=h;for(let v=1;v<a.length;v++)t=this.S(t,a[v]);this.N(h)}s(n,i,a){const h=n.piece,t=n.piece.bufferIndex,v=this.a[t].lineStarts,$=v[h.start.line]+h.start.column+i;let w=h.start.line,p=h.end.line,l=0,D=0,g=0;for(;w<=p&&(l=w+(p-w)/2|0,g=v[l],l!==p);)if(D=v[l+1],$<g)p=l-1;else if($>=D)w=l+1;else break;return a?(a.line=l,a.column=$-g,null):{line:l,column:$-g}}t(n,i,a){if(a.column===0)return a.line-i.line;const h=this.a[n].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],v=h[a.line]+a.column;if(t>v+1)return a.line-i.line;const c=v-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$iC)(this,n[i])}w(n){if(n.length>m){const p=[];for(;n.length>m;){const D=n.charCodeAt(m-1);let g;D===13||D>=55296&&D<=56319?(g=n.substring(0,m-1),n=n.substring(m-1)):(g=n.substring(0,m),n=n.substring(m));const S=O(g);p.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:g.length-S[S.length-1]},S.length-1,g.length)),this.a.push(new b(g,S))}const l=O(n);return p.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:n.length-l[l.length-1]},l.length-1,n.length)),this.a.push(new b(n,l)),p}let i=this.a[0].buffer.length;const a=O(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let p=0;p<a.length;p++)a[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[v],$={line:v,column:c},w=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let a=this.root,h="";const t=this.h.get2(n);if(t){a=t.node;const v=this.B(a,n-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===n)h=c.substring($+v,$+a.piece.length);else{const w=this.B(a,n-t.nodeStartLineNumber);return c.substring($+v,$+w-i)}}else{let v=0;const c=n;for(;a!==N.$dC;)if(a.left!==N.$dC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const $=this.B(a,n-a.lf_left-2),w=this.B(a,n-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this.h.set({node:a,nodeStartOffset:v,nodeStartLineNumber:c-(n-1-a.lf_left)}),p.substring(l+$,l+w-i)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const $=this.B(a,n-a.lf_left-2),w=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=w.substring(p+$,p+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==N.$dC;){const v=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=v.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=v.substr(c,a.piece.length)}a=a.next()}return h}y(){let n=this.root,i=1,a=0;for(;n!==N.$dC;)i+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=a,this.h.validate(this.c)}A(n,i){const a=n.piece,h=this.s(n,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const v=this.t(n.piece.bufferIndex,a.start,h);if(v!==t)return{index:v,remainder:0}}return{index:t,remainder:h.column}}B(n,i){if(i<0)return 0;const a=n.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),v=i,c=this.u(a.bufferIndex,v),$=this.t(a.bufferIndex,a.start,v),w=$-h,p=c-t,l=a.length+p;n.piece=new u(a.bufferIndex,a.start,v,$,l),(0,N.$kC)(this,n,p,w)}D(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),v=i,c=this.t(a.bufferIndex,v,a.end),$=this.u(a.bufferIndex,v),w=c-h,p=t-$,l=a.length+p;n.piece=new u(a.bufferIndex,v,a.end,c,l),(0,N.$kC)(this,n,p,w)}E(n,i,a){const h=n.piece,t=h.start,v=h.end,c=h.length,$=h.lineFeedCnt,w=i,p=this.t(h.bufferIndex,h.start,w),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);n.piece=new u(h.bufferIndex,h.start,w,p,l),(0,N.$kC)(this,n,l-c,p-$);const D=new u(h.bufferIndex,a,v,this.t(h.bufferIndex,a,v),this.u(h.bufferIndex,v)-this.u(h.bufferIndex,a)),g=this.S(n,D);this.N(g)}F(n,i){this.Q(i,n)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=O(i,!1);for(let g=0;g<t.length;g++)t[g]+=h;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const v=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[v],$={line:v,column:c},w=n.piece.length+i.length,p=n.piece.lineFeedCnt,l=this.t(0,n.piece.start,$),D=l-p;n.piece=new u(n.piece.bufferIndex,n.piece.start,$,l,w),this.g=$,(0,N.$kC)(this,n,i.length,D)}G(n){let i=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let h=0;for(;i!==N.$dC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){h+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let a=this.root,h=0;for(;a!==N.$dC;)if(a.left!==N.$dC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const t=this.B(a,n-a.lf_left-2),v=this.B(a,n-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,v),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const t=this.B(a,n-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else n-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==N.$dC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),v=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:v}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+i;return a.buffer.charCodeAt(h)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$dC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$dC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const a=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const v=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,t,c,v),(0,N.$kC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const $={line:i.piece.start.line+1,column:0},w=i.piece.length-1,p=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,p,w),(0,N.$kC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(n,l[0]);for(let D=0;D<a.length;D++)(0,N.$iC)(this,a[D])}Q(n,i){if(this.K()&&this.M(n)){const a=i.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,N.$iC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},v=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,v),(0,N.$kC)(this,a,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$dC)return i(N.$dC);const a=this.iterate(n.left,i);return a&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$dC)return"";const i=this.a[n.piece.bufferIndex],a=n.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(n){const i=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return i.buffer.substring(a,h)}S(n,i){const a=new N.$cC(i,1);if(a.left=N.$dC,a.right=N.$dC,a.parent=N.$dC,a.size_left=0,a.lf_left=0,this.root===N.$dC)this.root=a,a.color=0;else if(n.right===N.$dC)n.right=a,a.parent=n;else{const t=(0,N.$eC)(n.right);t.left=a,a.parent=t}return(0,N.$jC)(this,a),a}T(n,i){const a=new N.$cC(i,1);if(a.left=N.$dC,a.right=N.$dC,a.parent=N.$dC,a.size_left=0,a.lf_left=0,this.root===N.$dC)this.root=a,a.color=0;else if(n.left===N.$dC)n.left=a,a.parent=n;else{const h=(0,N.$fC)(n.left);h.right=a,a.parent=h}return(0,N.$jC)(this,a),a}U(n){let i="";return this.iterate(n,a=>(i+=this.R(a),!0)),i}}e.$wC=o}),define(Pe[136],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9=e.$Y9=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$Y9=I;class F{constructor(N){this.identifier=N}}e.$Z9=F}),define(Pe[137],Me([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[138],Me([1,0,5,6,137]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=void 0,e.$4i=O;class N extends F.$Uc{constructor(u,b="",f="",r=!0,o){super(),this.h=this.B(new I.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=f,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Yi=N;class R extends F.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$7d),this.onWillRun=this.f.event,this.m=this.B(new I.$7d),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let f;try{await this.u(u,b)}catch(r){f=r}this.m.fire({action:u,error:f})}async u(u,b){await u.run(b)}}e.$Zi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const f of u)f.length&&(b.length?b=[...b,new m,...f]:b=f);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$1i=m;class d{get actions(){return this.a}constructor(u,b,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=r,this.a=f}async run(){}}e.$2i=d;class k extends N{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,M.localize(0,null),void 0,!1)}}e.$3i=k;function O(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u),tooltip:E.label}}}),define(Pe[139],Me([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[140],Me([1,0,139]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=k,e.$Nm=O,e.$Om=E;const F=60,M=F*60,N=M*24,R=N*7,m=N*30,d=N*365;function k(u,b,f,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<F?(s=o,b?s===1?f?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):f?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?f?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):f?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<M?(s=Math.floor(o/F),b?s===1?f?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):f?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?f?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):f?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<N?(s=Math.floor(o/M),b?s===1?f?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):f?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?f?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):f?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<R?(s=Math.floor(o/N),b?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<m?(s=Math.floor(o/R),b?s===1?f?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):f?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?f?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):f?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<d?(s=Math.floor(o/m),b?s===1?f?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):f?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?f?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):f?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/d),b?s===1?f?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):f?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?f?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):f?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function O(u,b){const f=Math.abs(u/1e3);return f<1?b?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):f<F?b?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):f<M?b?(0,I.localize)(58,null,Math.round(u/(1e3*F))):(0,I.localize)(59,null,Math.round(u/(1e3*F))):f<N?b?(0,I.localize)(60,null,Math.round(u/(1e3*M))):(0,I.localize)(61,null,Math.round(u/(1e3*M))):(0,I.localize)(62,null,Math.round(u/(1e3*N)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[141],Me([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[42],Me([1,0,18,16,141]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=d,e.$6i=k,e.$7i=O;function N(E,u){return u&&(E.stack||E.stacktrace)?M.localize(0,null,m(E),R(E.stack)||R(E.stacktrace)):m(E)}function R(E){return Array.isArray(E)?E.join(`
`):E}function m(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?M.localize(1,null,E.message):E.message||M.localize(2,null)}function d(E=null,u=!1){if(!E)return M.localize(3,null);if(Array.isArray(E)){const b=I.$Hb(E),f=d(b[0],u);return b.length>1?M.localize(4,null,f,b.length):f}if(F.$Uf(E))return E;if(E.detail){const b=E.detail;if(b.error)return N(b.error,u);if(b.exception)return N(b.exception,u)}return E.stack?N(E,u):E.message?E.message:M.localize(5,null)}function k(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function O(E,u){let b;return typeof E=="string"?b=new Error(E):b=E,b.actions=u,b}}),define(Pe[142],Me([1,0,40,19]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=m,e.$3q=d,e.$4q=k,e.$5q=O,e.$6q=E,e.$7q=u,e.$8q=b,e.$9q=f,e.$0q=r,e.$$q=o,e.$_q=w,e.$ar=p,e.$br=l;const M=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),N=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(D,g,S=!1){const y=D||"",C=g||"",A=M.value.collator.compare(y,C);return M.value.collatorIsNumeric&&A===0&&y!==C?y<C?-1:1:A}function d(D,g){const S=N.value.collator;return D=D||"",g=g||"",a(S,D,g)}function k(D,g){const S=N.value.collator;return D=D||"",g=g||"",c(D,g)||a(S,D,g)}function O(D,g){const S=N.value.collator;return D=D||"",g=g||"",v(D,g)||a(S,D,g)}function E(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}function u(D,g){const[S,y]=n(D),[C,A]=n(g);let G=M.value.collator.compare(y,A);if(G===0){if(M.value.collatorIsNumeric&&y!==A)return y<A?-1:1;if(G=M.value.collator.compare(S,C),M.value.collatorIsNumeric&&G===0&&S!==C)return S<C?-1:1}return G}function b(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),C=N.value.collator,A=R.value.collator;return a(A,S,y)||a(C,D,g)}function f(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),C=N.value.collator,A=R.value.collator;return a(A,S,y)||c(D,g)||a(C,D,g)}function r(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),C=N.value.collator,A=R.value.collator;return a(A,S,y)||v(D,g)||a(C,D,g)}function o(D,g){D=D||"",g=g||"";const S=i(D).toLowerCase(),y=i(g).toLowerCase();return S!==y?S<y?-1:1:D!==g?D<g?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(D,g=!1){const S=D?s.exec(D):[];let y=[S&&S[1]||"",S&&S[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const g=D?s.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(D,g,S){const y=D.compare(g,S);return y!==0?y:g.length!==S.length?g.length<S.length?-1:1:0}function h(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function v(D,g){return h(D)&&t(g)?-1:t(D)&&h(g)?1:0}function c(D,g){return t(D)&&h(g)?-1:h(D)&&t(g)?1:0}function $(D,g,S=!1){return S||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function w(D,g,S=!1){const y=D.split(F.sep),C=g.split(F.sep),A=y.length-1,G=C.length-1;let T,W;for(let P=0;;P++){if(T=A===P,W=G===P,T&&W)return m(y[P],C[P],S);if(T)return-1;if(W)return 1;const L=$(y[P],C[P],S);if(L!==0)return L}}function p(D,g,S){const y=D.toLowerCase(),C=g.toLowerCase(),A=l(D,g,S);if(A)return A;const G=y.endsWith(S),T=C.endsWith(S);if(G!==T)return G?-1:1;const W=m(y,C);return W!==0?W:y.localeCompare(C)}function l(D,g,S){const y=D.toLowerCase(),C=g.toLowerCase(),A=y.startsWith(S),G=C.startsWith(S);if(A!==G)return A?-1:1;if(A&&G){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Pe[46],Me([1,0,19,21,15,16]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=R,e.$bg=m,e.$cg=d,e.$dg=k,e.$eg=O,e.$fg=f,e.$gg=r,e.$hg=o,e.$ig=s,e.$jg=n,e.$kg=i,e.$lg=a,e.$mg=h,e.$ng=t,e.$og=v,e.$pg=w;function R(p){return p===47||p===92}function m(p){return p.replace(/[\\/]/g,I.$hc.sep)}function d(p){return p.indexOf("/")===-1&&(p=m(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function k(p,l=I.$hc.sep){if(!p)return"";const D=p.length,g=p.charCodeAt(0);if(R(g)){if(R(p.charCodeAt(1))&&!R(p.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!R(p.charCodeAt(y));y++);if(C!==y&&!R(p.charCodeAt(y+1))){for(y+=1;y<D;y++)if(R(p.charCodeAt(y)))return p.slice(0,y+1).replace(/[\\/]/g,l)}}return l}else if(s(g)&&p.charCodeAt(1)===58)return R(p.charCodeAt(2))?p.slice(0,2)+l:p.slice(0,2);let S=p.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(R(p.charCodeAt(S)))return p.slice(0,S+1)}return""}function O(p){if(!F.$i||!p||p.length<5)return!1;let l=p.charCodeAt(0);if(l!==92||(l=p.charCodeAt(1),l!==92))return!1;let D=2;const g=D;for(;D<p.length&&(l=p.charCodeAt(D),l!==92);D++);return!(g===D||(l=p.charCodeAt(D+1),isNaN(l)||l===92))}const E=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(p,l=F.$i){const D=l?E:u;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||l&&b.test(p)||p==="."||p===".."||l&&p[p.length-1]==="."||l&&p.length!==p.trim().length||p.length>255)}function r(p,l,D){const g=p===l;return!D||g?g:!p||!l?!1:(0,M.$lf)(p,l)}function o(p,l,D,g=I.sep){if(p===l)return!0;if(!p||!l||l.length>p.length)return!1;if(D){if(!(0,M.$mf)(p,l))return!1;if(l.length===p.length)return!0;let y=l.length;return l.charAt(l.length-1)===g&&y--,p.charAt(y)===g}return l.charAt(l.length-1)!==g&&(l+=g),p.indexOf(l)===0}function s(p){return p>=65&&p<=90||p>=97&&p<=122}function n(p,l){return F.$i&&p.endsWith(":")&&(p+=I.sep),(0,I.$jc)(p)||(p=(0,I.$kc)(l,p)),p=(0,I.$ic)(p),F.$i?(p=(0,M.$6e)(p,I.sep),p.endsWith(":")&&(p+=I.sep)):(p=(0,M.$6e)(p,I.sep),p||(p=I.sep)),p}function i(p){const l=(0,I.$ic)(p);return F.$i?p.length>3?!1:a(l)&&(p.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(p,l=F.$i){return l?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function h(p,l=F.$i){return a(p,l)?p[0]:void 0}function t(p,l,D){return l.length>p.length?-1:p===l?0:(D&&(p=p.toLowerCase(),l=l.toLowerCase()),p.indexOf(l))}function v(p){const l=p.split(":");let D,g,S;for(const y of l){const C=Number(y);(0,N.$Yf)(C)?g===void 0?g=C:S===void 0&&(S=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(p,l,D=8){let g="";for(let y=0;y<D;y++){let C;y===0&&F.$i&&!l&&(D===3||D===4)?C=$:C=c,g+=C.charAt(Math.floor(Math.random()*C.length))}let S;return l?S=`${l}-${g}`:S=g,p?(0,I.$kc)(p,S):S}}),define(Pe[69],Me([1,0,19]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0,e.$zs=N,e.$As=R,e.$Bs=m,e.$Cs=k,e.$ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const E=(0,I.$pc)(O),u=F[E.toLowerCase()];return u!==void 0?u:R(O)}function R(O){const E=(0,I.$pc)(O);return M[E.toLowerCase()]}function m(O){for(const E in M)if(M[E]===O)return E}const d=/^(.+)\/(.+?)(;.+)?$/;function k(O,E){const u=d.exec(O);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:O}}),define(Pe[52],Me([1,0,23,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=M,e.$Ph=N,e.$Qh=m;function M(d){return JSON.stringify(d,R)}function N(d){let k=JSON.parse(d);return k=m(k),k}function R(d,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function m(d,k=0){if(!d||k>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return F.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof I.$ue||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let O=0;O<d.length;++O)d[O]=m(d[O],k+1);else for(const O in d)Object.hasOwnProperty.call(d,O)&&(d[O]=m(d[O],k+1))}return d}}),define(Pe[12],Me([1,0,14,21,15,2,19]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=d,e.$rg=k,e.$vg=E;var m;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.codeSetting="code-setting"})(m||(e.Schemas=m={}));function d(f,r){return N.URI.isUri(f)?(0,M.$lf)(f.scheme,r):(0,M.$mf)(f,r+":")}function k(f,...r){return r.some(o=>d(f,o))}e.$sg="vscode-tkn",e.$tg="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=E(r,o)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,m.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return I.$1(h),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(a+=`&${e.$tg}=${encodeURIComponent(i)}`),N.URI.from({scheme:F.$o?this.d:m.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:a})}}e.$ug=new O;function E(f,r){return R.$hc.join(r??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class u{static{this.a=e.$Ag}asBrowserUri(r){const o=this.b(r,me);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===m.vscodeRemote?e.$ug.rewrite(r):r.scheme===m.file&&(F.$m||F.$q===`${m.vscodeFileResource}://${u.a}`)?r.with({scheme:m.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,me);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===m.vscodeFileResource?r.with({scheme:m.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return N.URI.isUri(r)?r:N.URI.parse(o.toUrl(r))}}e.$Bg=new u;var b;(function(f){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:N.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return r.get(h)}f.getHeadersFromQuery=s;function n(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}f.addSearchParam=n})(b||(e.COI=b={}))}),define(Pe[24],Me([1,0,46,12,19,21,15,2]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=d,e.$4g=O,e.$5g=u;function d(b){return(0,m.$xc)(b,!0)}class k{constructor(f){this.a=f}compare(f,r,o=!1){return f===r?0:(0,R.$ef)(this.getComparisonKey(f,o),this.getComparisonKey(r,o))}isEqual(f,r,o=!1){return f===r?!0:!f||!r?!1:this.getComparisonKey(f,o)===this.getComparisonKey(r,o)}getComparisonKey(f,r=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,r,o=!1){if(f.scheme===r.scheme){if(f.scheme===F.Schemas.file)return I.$hg(d(f),d(r),this.a(f))&&f.query===r.query&&(o||f.fragment===r.fragment);if((0,e.$Zg)(f.authority,r.authority))return I.$hg(f.path,r.path,this.a(f),"/")&&f.query===r.query&&(o||f.fragment===r.fragment)}return!1}joinPath(f,...r){return m.URI.joinPath(f,...r)}basenameOrAuthority(f){return(0,e.$Rg)(f)||f.authority}basename(f){return M.$hc.basename(f.path)}extname(f){return M.$hc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let r;return f.scheme===F.Schemas.file?r=m.URI.file(M.$nc(d(f))).path:(r=M.$hc.dirname(f.path),f.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),r="/")),f.with({path:r})}normalizePath(f){if(!f.path.length)return f;let r;return f.scheme===F.Schemas.file?r=m.URI.file(M.$ic(d(f))).path:r=M.$hc.normalize(f.path),f.with({path:r})}relativePath(f,r){if(f.scheme!==r.scheme||!(0,e.$Zg)(f.authority,r.authority))return;if(f.scheme===F.Schemas.file){const n=M.$mc(d(f),d(r));return N.$i?I.$bg(n):n}let o=f.path||"/";const s=r.path||"/";if(this.a(f)){let n=0;for(const i=Math.min(o.length,s.length);n<i&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return M.$hc.relative(o,s)}resolvePath(f,r){if(f.scheme===F.Schemas.file){const o=m.URI.file(M.$lc(d(f),r));return f.with({authority:o.authority,path:o.path})}return r=I.$cg(r),f.with({path:M.$hc.resolve(f.path,r)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,r){return f===r||f!==void 0&&r!==void 0&&(0,R.$lf)(f,r)}hasTrailingPathSeparator(f,r=M.sep){if(f.scheme===F.Schemas.file){const o=d(f);return o.length>I.$dg(o).length&&o[o.length-1]===r}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,r=M.sep){return(0,e.$1g)(f,r)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,r=M.sep){let o=!1;if(f.scheme===F.Schemas.file){const s=d(f);o=s!==void 0&&s.length===I.$dg(s).length&&s[s.length-1]===r}else{r="/";const s=f.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$1g)(f,r)?f.with({path:f.path+"/"}):f}}e.$Jg=k,e.$Kg=new k(()=>!1),e.$Lg=new k(b=>b.scheme===F.Schemas.file?!N.$k:!0),e.$Mg=new k(b=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function O(b,f){const r=[];for(let o=0;o<b.length;o++){const s=f(b[o]);b.some((n,i)=>i===o?!1:(0,e.$Og)(s,f(n)))||r.push(b[o])}return r}var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(b.META_DATA_MIME,n),o}b.parseMetaData=f})(E||(e.DataUri=E={}));function u(b,f,r){if(f){let o=b.path;return o&&o[0]!==M.$hc.sep&&(o=M.$hc.sep+o),b.with({scheme:r,authority:f,path:o})}return b.with({scheme:r})}}),define(Pe[11],Me([1,0,25,14,5,6,24,21,129,40]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=O,e.$7g=E,e.$8g=u,e.$9g=b,e.$0g=f,e.$$g=r,e.$_g=o,e.$ah=s,e.$ih=p,e.$jh=l,e.$kh=D,e.$lh=g,e.$mh=S,e.$Bh=Se,e.$Jh=Ie;function O(ge){return!!ge&&typeof ge.then=="function"}function E(ge){const J=new I.$ee,Y=ge(J.token),ce=new Promise((de,Ne)=>{const ue=J.token.onCancellationRequested(()=>{ue.dispose(),Ne(new F.$5)});Promise.resolve(Y).then(Ce=>{ue.dispose(),J.dispose(),de(Ce)},Ce=>{ue.dispose(),J.dispose(),Ne(Ce)})});return new class{cancel(){J.cancel(),J.dispose()}then(de,Ne){return ce.then(de,Ne)}catch(de){return this.then(void 0,de)}finally(de){return ce.finally(de)}}}function u(ge,J,Y){return new Promise((ce,de)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),ce(Y)});ge.then(ce,de).finally(()=>Ne.dispose())})}function b(ge,J){return new Promise((Y,ce)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ce(new F.$5)});ge.then(Y,ce).finally(()=>de.dispose())})}async function f(ge){let J=-1;const Y=ge.map((ce,de)=>ce.then(Ne=>(J=de,Ne)));try{return await Promise.race(Y)}finally{ge.forEach((ce,de)=>{de!==J&&ce.cancel()})}}function r(ge,J,Y){let ce;const de=setTimeout(()=>{ce?.(void 0),Y?.()},J);return Promise.race([ge.finally(()=>clearTimeout(de)),new Promise(Ne=>ce=Ne)])}function o(ge){return new Promise((J,Y)=>{const ce=ge();O(ce)?ce.then(J,Y):J(ce)})}function s(){let ge,J;return{promise:new Promise((ce,de)=>{ge=ce,J=de}),resolve:ge,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(Y,Y).then(ce)})}return new Promise((Y,ce)=>{this.b.then(Y,ce)})}return this.a=J(),new Promise((Y,ce)=>{this.a.then(de=>{this.a=null,Y(de)},de=>{this.a=null,ce(de)})})}dispose(){this.f=!0}}e.$bh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$ch=i;class a{constructor(){this.a=new Map}queue(J,Y){const de=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===de&&this.a.delete(J)});return this.a.set(J,de),de}}e.$dh=a;const h=(ge,J)=>{let Y=!0;const ce=setTimeout(()=>{Y=!1,J()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(ce),Y=!1}}},t=ge=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ge())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class v{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((de,Ne)=>{this.d=de,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=Y===d.$4d?t(ce):h(Y,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=v;class c{constructor(J){this.a=new v(J),this.b=new n}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=c;class ${constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=$;class w extends ${constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$hh=w;function p(ge,J){return J?new Promise((Y,ce)=>{const de=setTimeout(()=>{Ne.dispose(),Y()},ge),Ne=J.onCancellationRequested(()=>{clearTimeout(de),Ne.dispose(),ce(new F.$5)})}):E(Y=>p(ge,Y))}function l(ge,J=0,Y){const ce=setTimeout(()=>{ge(),Y&&de.dispose()},J),de=(0,N.$Sc)(()=>{clearTimeout(ce),Y?.deleteAndLeak(de)});return Y?.add(de),de}function D(ge){const J=[];let Y=0;const ce=ge.length;function de(){return Y<ce?ge[Y++]():null}function Ne(ue){ue!=null&&J.push(ue);const Ce=de();return Ce?Ce.then(Ne):Promise.resolve(J)}return Promise.resolve(null).then(Ne)}function g(ge,J=ce=>!!ce,Y=null){let ce=0;const de=ge.length,Ne=()=>{if(ce>=de)return Promise.resolve(Y);const ue=ge[ce++];return Promise.resolve(ue()).then(Re=>J(Re)?Promise.resolve(Re):Ne())};return Ne()}function S(ge,J=ce=>!!ce,Y=null){if(ge.length===0)return Promise.resolve(Y);let ce=ge.length;const de=()=>{ce=-1;for(const Ne of ge)Ne.cancel?.()};return new Promise((Ne,ue)=>{for(const Ce of ge)Ce.then(Re=>{--ce>=0&&J(Re)?(de(),Ne(Re)):ce===0&&Ne(Y)}).catch(Re=>{--ce>=0&&(de(),ue(Re))})})}class y{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new M.$7d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,ce)=>{this.g.push({factory:J,c:Y,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=y;class C extends y{constructor(){super(1)}}e.$oh=C;class A{constructor(){this.a=new he,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$ph=A;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new pe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=R.$Kg){const ce=Y.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,Y,ce=R.$Kg){const de=ce.getComparisonKey(J);let Ne=this.a.get(de);if(!Ne){Ne=new C;const ue=this.f++,Ce=M.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(ue,Ce),this.a.set(de,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=G;class T{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$rh=T;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,ce=globalThis){this.cancel();const de=ce.setInterval(()=>{J()},Y);this.d=(0,N.$Sc)(()=>{ce.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$sh=W;class P{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=P;class L{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=L;class K extends P{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$vh=K;class ne extends N.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new P(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(ge,J)=>{(0,m.$B)(()=>{if(Y)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$yh=(ge,J,Y)=>{const ce=ge.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,ge.cancelIdleCallback(ce))}}},e.$xh=ge=>(0,e.$yh)(globalThis,ge)}();class le{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$yh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=le;class ye extends le{constructor(J){super(globalThis,J)}}e.$Ah=ye;async function Se(ge,J,Y){let ce;for(let de=0;de<Y;de++)try{return await ge()}catch(Ne){ce=Ne,await p(J)}throw ce}class he{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:ce,reject:de}=s();this.b={run:J,promise:Y,promiseResolve:ce,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=he;class be{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Dh=be;var ee;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ee||(ee={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new F.$5)}}e.$Eh=pe;var re;(function(ge){async function J(ce){let de;const Ne=await Promise.all(ce.map(ue=>ue.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de<"u")throw de;return Ne}ge.settled=J;function Y(ce){return new Promise(async(de,Ne)=>{try{await ce(de,Ne)}catch(ue){Ne(ue)}})}ge.withAsyncBody=Y})(re||(e.Promises=re={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=fe;class V{constructor(J){this.b=J,this.a=new k.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=V;var te;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(te||(te={}));class ke{static fromArray(J){return new ke(Y=>{Y.emitMany(J)})}static fromPromise(J){return new ke(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new ke(async Y=>{await Promise.all(J.map(async ce=>Y.emitOne(await ce)))})}static merge(J){return new ke(async Y=>{await Promise.all(J.map(async ce=>{for await(const de of ce)Y.emitOne(de)}))})}static{this.EMPTY=ke.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new M.$7d,queueMicrotask(async()=>{const Y={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(Y)),this.j()}catch(ce){this.k(ce)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(J,Y){return new ke(async ce=>{for await(const de of J)ce.emitOne(Y(de))})}map(J){return ke.map(this,J)}static filter(J,Y){return new ke(async ce=>{for await(const de of J)Y(de)&&ce.emitOne(de)})}filter(J){return ke.filter(this,J)}static coalesce(J){return ke.filter(J,Y=>!!Y)}coalesce(){return ke.coalesce(this)}static async toPromise(J){const Y=[];for await(const ce of J)Y.push(ce);return Y}toPromise(){return ke.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Hh=ke;class Te extends ke{constructor(J,Y){super(Y),this.l=J}cancel(){this.l.cancel()}}e.$Ih=Te;function Ie(ge){const J=new I.$ee,Y=ge(J.token);return new Te(J,async ce=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),J.dispose(),ce.reject(new F.$5)});try{for await(const Ne of Y){if(J.token.isCancellationRequested)return;ce.emitOne(Ne)}de.dispose(),J.dispose()}catch(Ne){de.dispose(),J.dispose(),ce.reject(Ne)}})}class ve{constructor(){this.a=new pe,this.b=new ke(ce=>{if(J){ce.reject(J);return}return Y&&ce.emitMany(Y),this.d=de=>ce.reject(de),this.f=de=>ce.emitOne(de),this.a.p});let J,Y;this.f=ce=>{Y||(Y=[]),Y.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Kh=ve}),define(Pe[35],Me([1,0,18,11,46,28,19,21,15]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=k,e.$_j=f,e.$ak=C,e.$bk=A,e.$ck=G,e.$dk=T,e.$ek=W,e.$fk=ne;function k(){return Object.create(null)}e.$0j="**",e.$$j="/";const O="[/\\\\]",E="[^/\\\\]",u=/\//g;function b(le,ye){switch(le){case 0:return"";case 1:return`${E}*?`;default:return`(?:${O}|${E}+${O}${ye?`|${O}${E}+`:""})*?`}}function f(le,ye){if(!le)return[];const Se=[];let he=!1,be=!1,ee="";for(const pe of le){switch(pe){case ye:if(!he&&!be){Se.push(ee),ee="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":be=!0;break;case"]":be=!1;break}ee+=pe}return ee&&Se.push(ee),Se}function r(le){if(!le)return"";let ye="";const Se=f(le,e.$$j);if(Se.every(he=>he===e.$0j))ye=".*";else{let he=!1;Se.forEach((be,ee)=>{if(be===e.$0j){if(he)return;ye+=b(2,ee===Se.length-1)}else{let pe=!1,re="",fe=!1,V="";for(const te of be){if(te!=="}"&&pe){re+=te;continue}if(fe&&(te!=="]"||!V)){let ke;te==="-"?ke=te:(te==="^"||te==="!")&&!V?ke="^":te===e.$$j?ke="":ke=(0,d.$Ze)(te),V+=ke;continue}switch(te){case"{":pe=!0;continue;case"[":fe=!0;continue;case"}":{const Te=`(?:${f(re,",").map(Ie=>r(Ie)).join("|")})`;ye+=Te,pe=!1,re="";break}case"]":{ye+="["+V+"]",fe=!1,V="";break}case"?":ye+=E;continue;case"*":ye+=b(1);continue;default:ye+=(0,d.$Ze)(te)}}ee<Se.length-1&&(Se[ee+1]!==e.$0j||ee+2<Se.length)&&(ye+=O)}he=be===e.$0j})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),v=function(){return!1},c=function(){return null};function $(le,ye){if(!le)return c;let Se;typeof le!="string"?Se=le.pattern:Se=le,Se=Se.trim();const he=`${Se}_${!!ye.trimForExclusions}`;let be=t.get(he);if(be)return w(be,le);let ee;return o.test(Se)?be=l(Se.substr(4),Se):(ee=s.exec(p(Se,ye)))?be=D(ee[1],Se):(ye.trimForExclusions?i:n).test(Se)?be=g(Se,ye):(ee=a.exec(p(Se,ye)))?be=S(ee[1].substr(1),Se,!0):(ee=h.exec(p(Se,ye)))?be=S(ee[1],Se,!1):be=y(Se),t.set(he,be),w(be,le)}function w(le,ye){if(typeof ye=="string")return le;const Se=function(he,be){return(0,M.$hg)(he,ye.base,!m.$k)?le((0,d.$5e)(he.substr(ye.base.length),R.sep),be):null};return Se.allBasenames=le.allBasenames,Se.allPaths=le.allPaths,Se.basenames=le.basenames,Se.patterns=le.patterns,Se}function p(le,ye){return ye.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function l(le,ye){return function(Se,he){return typeof Se=="string"&&Se.endsWith(le)?ye:null}}function D(le,ye){const Se=`/${le}`,he=`\\${le}`,be=function(pe,re){return typeof pe!="string"?null:re?re===le?ye:null:pe===le||pe.endsWith(Se)||pe.endsWith(he)?ye:null},ee=[le];return be.basenames=ee,be.patterns=[ye],be.allBasenames=ee,be}function g(le,ye){const Se=K(le.slice(1,-1).split(",").map(re=>$(re,ye)).filter(re=>re!==c),le),he=Se.length;if(!he)return c;if(he===1)return Se[0];const be=function(re,fe){for(let V=0,te=Se.length;V<te;V++)if(Se[V](re,fe))return le;return null},ee=Se.find(re=>!!re.allBasenames);ee&&(be.allBasenames=ee.allBasenames);const pe=Se.reduce((re,fe)=>fe.allPaths?re.concat(fe.allPaths):re,[]);return pe.length&&(be.allPaths=pe),be}function S(le,ye,Se){const he=R.sep===R.$hc.sep,be=he?le:le.replace(u,R.sep),ee=R.sep+be,pe=R.$hc.sep+le;let re;return Se?re=function(fe,V){return typeof fe=="string"&&(fe===be||fe.endsWith(ee)||!he&&(fe===le||fe.endsWith(pe)))?ye:null}:re=function(fe,V){return typeof fe=="string"&&(fe===be||!he&&fe===le)?ye:null},re.allPaths=[(Se?"*/":"./")+le],re}function y(le){try{const ye=new RegExp(`^${r(le)}$`);return function(Se){return ye.lastIndex=0,typeof Se=="string"&&ye.test(Se)?le:null}}catch{return c}}function C(le,ye,Se){return!le||typeof ye!="string"?!1:A(le)(ye,void 0,Se)}function A(le,ye={}){if(!le)return v;if(typeof le=="string"||G(le)){const Se=$(le,ye);if(Se===c)return v;const he=function(be,ee){return!!Se(be,ee)};return Se.allBasenames&&(he.allBasenames=Se.allBasenames),Se.allPaths&&(he.allPaths=Se.allPaths),he}return P(le,ye)}function G(le){const ye=le;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function T(le){return le.allBasenames||[]}function W(le){return le.allPaths||[]}function P(le,ye){const Se=K(Object.getOwnPropertyNames(le).map(re=>L(re,le[re],ye)).filter(re=>re!==c)),he=Se.length;if(!he)return c;if(!Se.some(re=>!!re.requiresSiblings)){if(he===1)return Se[0];const re=function(te,ke){let Te;for(let Ie=0,ve=Se.length;Ie<ve;Ie++){const ge=Se[Ie](te,ke);if(typeof ge=="string")return ge;(0,F.$6g)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const Ie of Te){const ve=await Ie;if(typeof ve=="string")return ve}return null})():null},fe=Se.find(te=>!!te.allBasenames);fe&&(re.allBasenames=fe.allBasenames);const V=Se.reduce((te,ke)=>ke.allPaths?te.concat(ke.allPaths):te,[]);return V.length&&(re.allPaths=V),re}const be=function(re,fe,V){let te,ke;for(let Te=0,Ie=Se.length;Te<Ie;Te++){const ve=Se[Te];ve.requiresSiblings&&V&&(fe||(fe=(0,R.$oc)(re)),te||(te=fe.substr(0,fe.length-(0,R.$pc)(re).length)));const ge=ve(re,fe,te,V);if(typeof ge=="string")return ge;(0,F.$6g)(ge)&&(ke||(ke=[]),ke.push(ge))}return ke?(async()=>{for(const Te of ke){const Ie=await Te;if(typeof Ie=="string")return Ie}return null})():null},ee=Se.find(re=>!!re.allBasenames);ee&&(be.allBasenames=ee.allBasenames);const pe=Se.reduce((re,fe)=>fe.allPaths?re.concat(fe.allPaths):re,[]);return pe.length&&(be.allPaths=pe),be}function L(le,ye,Se){if(ye===!1)return c;const he=$(le,Se);if(he===c)return c;if(typeof ye=="boolean")return he;if(ye){const be=ye.when;if(typeof be=="string"){const ee=(pe,re,fe,V)=>{if(!V||!he(pe,re))return null;const te=be.replace("$(basename)",()=>fe),ke=V(te);return(0,F.$6g)(ke)?ke.then(Te=>Te?le:null):ke?le:null};return ee.requiresSiblings=!0,ee}}return he}function K(le,ye){const Se=le.filter(re=>!!re.basenames);if(Se.length<2)return le;const he=Se.reduce((re,fe)=>{const V=fe.basenames;return V?re.concat(V):re},[]);let be;if(ye){be=[];for(let re=0,fe=he.length;re<fe;re++)be.push(ye)}else be=Se.reduce((re,fe)=>{const V=fe.patterns;return V?re.concat(V):re},[]);const ee=function(re,fe){if(typeof re!="string")return null;if(!fe){let te;for(te=re.length;te>0;te--){const ke=re.charCodeAt(te-1);if(ke===47||ke===92)break}fe=re.substr(te)}const V=he.indexOf(fe);return V!==-1?be[V]:null};ee.basenames=he,ee.patterns=be,ee.allBasenames=he;const pe=le.filter(re=>!re.basenames);return pe.push(ee),pe}function ne(le,ye){return(0,I.$ub)(le,ye,(Se,he)=>typeof Se=="string"&&typeof he=="string"?Se===he:typeof Se!="string"&&typeof he!="string"?Se.base===he.base&&Se.pattern===he.pattern:!1)}}),define(Pe[53],Me([1,0,14,130,24,15,2]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.MarkdownStringTextNewlineStyle=void 0,e.$Fk=k,e.$Gk=O,e.$Hk=E,e.$Ik=u,e.$Jk=b,e.$Kk=f,e.$Lk=r,e.$Mk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class d{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=u(this.supportThemeIcons?(0,F.$yk)(n):n).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${b(i,n)}
`,this}appendLink(n,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(n,i){const a=new RegExp((0,N.$Ze)(i),"g");return n.replace(a,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Ek=d;function k(s){return O(s)?!s.value:Array.isArray(s)?s.every(k):!0}function O(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function E(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,M.$Ng)(R.URI.from(s.baseUri),R.URI.from(n.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(s,n){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${n}`,s,`${"`".repeat(a)}`].join(`
`)}function f(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const n=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),v=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),w=isFinite(parseInt(v));$&&n.push(`width="${c}"`),w&&n.push(`height="${v}"`)}return{href:s,dimensions:n}}}),define(Pe[96],Me([1,0,18,46,19,21,24,15]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=d,e.$gw=O,e.$hw=u,e.$iw=b,e.$jw=s,e.$kw=i,e.$lw=a,e.$mw=h,e.$nw=t,e.$ow=v;function d($,w){const{os:p,tildify:l,relative:D}=w;if(D){const y=k($,D,p);if(typeof y=="string")return y}let g=$.fsPath;if(p===1&&!N.$i?g=g.replace(/\//g,"\\"):p!==1&&N.$i&&(g=g.replace(/\\/g,"/")),p!==1&&l?.userHome){const y=l.userHome.fsPath;let C;$.scheme!==l.userHome.scheme&&$.path[0]===M.$hc.sep&&$.path[1]!==M.$hc.sep?C=l.userHome.with({path:$.path}).fsPath:C=g,g=u(C,y,p)}return(p===1?M.$gc:M.$hc).normalize(O(g,p===1))}function k($,w,p){const l=p===1?M.$gc:M.$hc,D=p===3?R.$Kg:R.$Mg,g=w.getWorkspace(),S=(0,I.$Ob)(g.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===M.$hc.sep&&$.path[1]!==M.$hc.sep&&($=S.uri.with({path:$.path}));const y=w.getWorkspaceFolder($);if(!y)return;let C;if(D.isEqual(y.uri,$)?C="":C=D.relativePath(y.uri,$)??"",C&&(C=l.normalize(C)),g.folders.length>1&&!w.noPrefix){const A=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${A} \u2022 ${C}`:A}return C}function O($,w=N.$i){return(0,F.$lg)($,w)?$.charAt(0).toUpperCase()+$.slice(1):$}let E=Object.create(null);function u($,w,p=N.OS){if(p===1||!$||!w)return $;let l=E.original===w?E.normalized:void 0;l||(l=w,N.$i&&(l=(0,F.$bg)(l)),l=`${(0,m.$6e)(l,M.$hc.sep)}${M.$hc.sep}`,E={original:w,normalized:l});let D=$;return N.$i&&(D=(0,F.$bg)(D)),(p===3?D.startsWith(l):(0,m.$mf)(D,l))?`~/${D.substr(l.length)}`:$}function b($,w){return $.replace(/^~($|\/|\\)/,`${w}$1`)}const f="\u2026",r="\\\\",o="~";function s($,w=M.sep){const p=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const g=$[D];if(g===""){p[D]=`.${w}`;continue}if(!g){p[D]=g;continue}l=!0;let S="",y=g;y.indexOf(r)===0?(S=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(w)===0?(S=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(o)===0&&(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(w);for(let A=1;l&&A<=C.length;A++)for(let G=C.length-A;l&&G>=0;G--){l=!1;let T=C.slice(G,G+A).join(w);for(let W=0;!l&&W<$.length;W++)if(W!==D&&$[W]&&$[W].indexOf(T)>-1){const P=G+A===C.length,L=G>0&&$[W].indexOf(w)>-1?w+T:T,K=$[W].endsWith(L);l=!P||K}if(!l){let W="";(C[0].endsWith(":")||S!=="")&&(G===1&&(G=0,A++,T=C[0]+w+T),G>0&&(W=C[0]+w),W=S+W),G>0&&(W=W+f+w),W=W+T,G+A<C.length&&(W=W+w+f),p[D]=W}}l&&(p[D]=g)}return p}var n;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i($,w=Object.create(null)){const p=[];let l=!1,D="";for(const g of $)if(g==="$"||l&&g==="{")D&&p.push({value:D,type:n.TEXT}),D="",l=!0;else if(g==="}"&&l){const S=w[D];if(typeof S=="string")S.length&&p.push({value:S,type:n.VARIABLE});else if(S){const y=p[p.length-1];(!y||y.type!==n.SEPARATOR)&&p.push({value:S.label,type:n.SEPARATOR})}D="",l=!1}else D+=g;return D&&!l&&p.push({value:D,type:n.TEXT}),p.filter((g,S)=>{if(g.type===n.SEPARATOR){const y=p[S-1],C=p[S+1];return[y,C].every(A=>A&&(A.type===n.VARIABLE||A.type===n.TEXT)&&A.value.length>0)}return!0}).map(g=>g.value).join("")}function a($,w){return N.$j||w?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):$.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function h($,w){return N.$j||w?$.replace(/\(&&\w\)|&&/g,""):N.$i?$.replace(/&&|&/g,p=>p==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function v($){if($.endsWith("]")){const w=$.lastIndexOf(" [",$.length-2);if(w!==-1){const p=c($.substring(0,w)),l=$.substring(w);return{name:p.name+l,parentPath:p.parentPath}}}return c($)}function c($){const w=$.indexOf("/")!==-1?M.$hc:M.$gc,p=w.basename($),l=w.dirname($);return p.length?{name:p,parentPath:l}:{name:l,parentPath:""}}}),define(Pe[143],Me([1,0,23,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=m,e.$mn=k,e.$nn=O;function M(E){return E.toJSON()}class N{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:M(F.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:M(F.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:F.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$jn=N,e.$kn=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function R(E,u,b){if(!E||b>200)return null;if(typeof E=="object"){if(E instanceof F.URI)return u.transformOutgoing(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const r=R(E[f],u,b+1);r!==null&&(E[f]=r)}}return null}function m(E,u){const b=R(E,u,0);return b===null?E:b}function d(E,u,b,f){if(!E||f>200)return null;if(typeof E=="object"){if(E.$mid===1)return b?F.URI.revive(u.transformIncoming(E)):u.transformIncoming(E);if(E instanceof I.$ue)return null;for(const r in E)if(Object.hasOwnProperty.call(E,r)){const o=d(E[r],u,b,f+1);o!==null&&(E[r]=o)}}return null}function k(E,u){const b=d(E,u,!1,0);return b===null?E:b}function O(E,u){const b=d(E,u,!0,0);return b===null?E:b}}),define(Pe[144],Me([1,0,15,21,23]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=O,e.$ut=E;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function d(){return m||(m=new TextDecoder("UTF-16BE")),m}let k;function O(){return k||(k=F.$D()?R():d()),k}function E(f,r,o){const s=new Uint16Array(f.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?u(f,r,o):R().decode(s)}function u(f,r,o){const s=[];let n=0;for(let i=0;i<o;i++){const a=M.$we(f,r);r+=2,s[n++]=String.fromCharCode(a)}return s.join("")}class b{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return O().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$pf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$vt=b}),define(Pe[145],Me([1,0,23,144]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=R;function M(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,O,E,u){this.oldPosition=k,this.oldText=O,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,O,E){const u=O.length;I.$ze(k,u,E),E+=4;for(let b=0;b<u;b++)I.$xe(k,O.charCodeAt(b),E),E+=2;return E}static d(k,O){const E=I.$ye(k,O);return O+=4,(0,F.$ut)(k,O,E)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(k,O){return I.$ze(k,this.oldPosition,O),O+=4,I.$ze(k,this.newPosition,O),O+=4,O=N.c(k,this.oldText,O),O=N.c(k,this.newText,O),O}static read(k,O,E){const u=I.$ye(k,O);O+=4;const b=I.$ye(k,O);O+=4;const f=N.d(k,O);O+=N.a(f);const r=N.d(k,O);return O+=N.a(r),E.push(new N(u,f,b,r)),O}}e.$wt=N;function R(d,k){return d===null||d.length===0?k:new m(d,k).compress()}class m{constructor(k,O){this.a=k,this.c=O,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,O=0,E=this.n(k),u=this.l(O);for(;k<this.f||O<this.h;){if(E===null){this.k(u),u=this.l(++O);continue}if(u===null){this.m(E),E=this.n(++k);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++O);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++k);continue}if(u.oldPosition<E.newPosition){const[s,n]=m.r(u,E.newPosition-u.oldPosition);this.k(s),u=n;continue}if(E.newPosition<u.oldPosition){const[s,n]=m.q(E,u.oldPosition-E.newPosition);this.m(s),E=n;continue}let r,o;if(u.oldEnd===E.newEnd)r=E,o=u,E=this.n(++k),u=this.l(++O);else if(u.oldEnd<E.newEnd){const[s,n]=m.q(E,u.oldLength);r=s,o=u,E=n,u=this.l(++O)}else{const[s,n]=m.r(u,E.newLength);r=E,o=s,E=this.n(++k),u=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const b=m.s(this.d);return m.t(b)}k(k){this.d[this.e++]=m.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=m.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,O){return new N(O.oldPosition-k,O.oldText,O.newPosition,O.newText)}static p(k,O){return new N(O.oldPosition,O.oldText,O.newPosition+k,O.newText)}static q(k,O){const E=k.newText.substr(0,O),u=k.newText.substr(O);return[new N(k.oldPosition,k.oldText,k.newPosition,E),new N(k.oldEnd,"",k.newPosition+O,u)]}static r(k,O){const E=k.oldText.substr(0,O),u=k.oldText.substr(O);return[new N(k.oldPosition,E,k.newPosition,k.newText),new N(k.oldPosition+O,u,k.newEnd,"")]}static s(k){if(k.length===0)return k;const O=[];let E=0,u=k[0];for(let b=1;b<k.length;b++){const f=k[b];u.oldEnd===f.oldPosition?u=new N(u.oldPosition,u.oldText+f.oldText,u.newPosition,u.newText+f.newText):(O[E++]=u,u=f)}return O[E++]=u,O}static t(k){if(k.length===0)return k;const O=[];let E=0;for(let u=0;u<k.length;u++){const b=k[u];b.oldText!==b.newText&&(O[E++]=b)}return O}}}),define(Pe[146],Me([1,0,35,19]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=M,e.$Vt=N;function M(R,m,d,k,O,E){if(Array.isArray(R)){let u=0;for(const b of R){const f=M(b,m,d,k,O,E);if(f===10)return f;f>u&&(u=f)}return u}else{if(typeof R=="string")return k?R==="*"?5:R===d?10:0:0;if(R){const{language:u,pattern:b,scheme:f,hasAccessToAllModels:r,notebookType:o}=R;if(!k&&!r)return 0;o&&O&&(m=O);let s=0;if(f)if(f===m.scheme)s=10;else if(f==="*")s=5;else return 0;if(u)if(u===d)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===E)s=10;else if(o==="*"&&E!==void 0)s=Math.max(s,5);else return 0;if(b){let n;if(typeof b=="string"?n=b:n={...b,base:(0,F.$ic)(b.base)},n===m.fsPath||(0,I.$ak)(n,m.fsPath))s=10;else return 0}return s}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Pe[147],Me([1,0,5,15,29,94,92,132,145,6]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=void 0;class O extends k.$Uc{constructor(u,b,f,r,o,s,n){super(),this.m=this.B(new I.$7d),this.onDidChangeContent=this.m.event,this.f=b,this.j=!s,this.g=r,this.h=o,this.c=new R.$wC(u,f,n)}equals(u){return!(u instanceof O)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const f=u+b,r=this.getPositionAt(u),o=this.getPositionAt(f);return new M.$bt(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const f=this.n(b);return this.c.getValueInRange(u,f)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const f=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(b),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return r-f+o}getCharacterCountInRange(u,b=0){if(this.j){let f=0;const r=u.startLineNumber,o=u.endLineNumber;for(let s=r;s<=o;s++){const n=this.getLineContent(s),i=s===r?u.startColumn-1:0,a=s===o?u.endColumn-1:n.length;for(let h=i;h<a;h++)F.$pf(n.charCodeAt(h))?(f=f+1,h=h+1):f=f+1}return f+=this.n(b).length*(o-r),f}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=F.$af(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=F.$cf(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,f){let r=this.g,o=this.h,s=this.j,n=!0,i=[];for(let w=0;w<u.length;w++){const p=u[w];n&&p._isTracked&&(n=!1);const l=p.range;if(p.text){let C=!0;s||(C=!F.$Af(p.text),s=C),!r&&C&&(r=F.$zf(p.text)),!o&&C&&(o=F.$Cf(p.text))}let D="",g=0,S=0,y=0;if(p.text){let C;[g,S,y,C]=(0,m.$Nt)(p.text);const A=this.getEOL();C===0||C===(A===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,A)}i[w]={sortIndex:w,identifier:p.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:g,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(O.u);let a=!1;for(let w=0,p=i.length-1;w<p;w++){const l=i[w].range.getEndPosition(),D=i[w+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(i=this.s(i));const h=f||b?O._getInverseEditRanges(i):[],t=[];if(b)for(let w=0;w<i.length;w++){const p=i[w],l=h[w];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let g="";D===l.startLineNumber&&(g=this.getLineContent(p.range.startLineNumber),F.$af(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let v=null;if(f){let w=0;v=[];for(let p=0;p<i.length;p++){const l=i[p],D=h[p],g=this.getValueInRange(l.range),S=l.rangeOffset+w;w+=l.text.length-g.length,v[p]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:g,textChange:new d.$wt(l.rangeOffset,g,S,l.text)}}a||v.sort((p,l)=>p.sortIndex-l.sortIndex)}this.g=r,this.h=o,this.j=s;const c=this.t(i);let $=null;if(b&&t.length>0){t.sort((w,p)=>p.lineNumber-w.lineNumber),$=[];for(let w=0,p=t.length;w<p;w++){const l=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===l)continue;const D=t[w].oldContent,g=this.getLineContent(l);g.length===0||g===D||F.$af(g)!==-1||$.push(l)}}return this.m.fire(),new N.$zv(v,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const f=u[0].range,r=u[u.length-1].range,o=new M.$bt(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let s=f.startLineNumber,n=f.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const w=u[c],p=w.range;b=b||w.forceMoveMarkers,i.push(this.getValueInRange(new M.$bt(s,n,p.startLineNumber,p.startColumn))),w.text.length>0&&i.push(w.text),s=p.endLineNumber,n=p.endColumn}const a=i.join(""),[h,t,v]=(0,m.$Nt)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:v,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(O.w);const b=[];for(let f=0;f<u.length;f++){const r=u[f],o=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(o===n&&s===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new M.$bt(o,s,n,i);b.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,f,r){return this.c.findMatchesLineByLine(u,b,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const f=u.startLineNumber,r=u.startColumn,[o,s,n]=(0,m.$Nt)(b);let i;if(b.length>0){const a=o+1;a===1?i=new M.$bt(f,r,f,r+s):i=new M.$bt(f,r,f+a-1,n+1)}else i=new M.$bt(f,r,f,r);return i}static _getInverseEditRanges(u){const b=[];let f=0,r=0,o=null;for(let s=0,n=u.length;s<n;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=f,h=r+(i.range.startColumn-o.range.endColumn)):(a=f+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const v=i.eolCount+1;v===1?t=new M.$bt(a,h,a,h+i.firstLineLength):t=new M.$bt(a,h,a+v-1,i.lastLineLength+1)}else t=new M.$bt(a,h,a,h);f=t.endLineNumber,r=t.endColumn,b.push(t),o=i}return b}static u(u,b){const f=M.$bt.compareRangesUsingEnds(u.range,b.range);return f===0?u.sortIndex-b.sortIndex:f}static w(u,b){const f=M.$bt.compareRangesUsingEnds(u.range,b.range);return f===0?b.sortIndex-u.sortIndex:-f}}e.$xC=O}),define(Pe[148],Me([1,0,15,92,147]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=void 0;class N{constructor(d,k,O,E,u,b,f,r,o){this.a=d,this.b=k,this.c=O,this.d=E,this.e=u,this.f=b,this.g=f,this.h=r,this.j=o}k(d){const k=this.c+this.d+this.e,O=this.c+this.e;return k===0?d===1?`
`:`\r
`:O>k/2?`\r
`:`
`}create(d){const k=this.k(d),O=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let u=0,b=O.length;u<b;u++){const f=O[u].buffer.replace(/\r\n|\r|\n/g,k),r=(0,F.$sC)(f);O[u]=new F.$vC(f,r)}const E=new M.$xC(O,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&I.$If(d)&&(this.b=I.$Hf,d=d.substr(1));const k=d.charCodeAt(d.length-1);k===13||k>=55296&&k<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=k):(this.m(d,!1),this.c=!1,this.d=k)}m(d,k){!k&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const k=(0,F.$tC)(this.e,d);this.a.push(new F.$vC(d,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$zf(d)),this.k||(this.k=I.$Cf(d)))}finish(d=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const k=(0,F.$sC)(d.buffer);d.lineStarts=k,this.d===13&&this.f++}}}e.$yC=R}),define(Pe[97],Me([1,0,23,21]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sab=d,e.$tab=O;var M;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(M||(M={}));function N(E){for(let u=0,b=E.length;u<b;u+=4){const f=E[u+0],r=E[u+1],o=E[u+2],s=E[u+3];E[u+0]=s,E[u+1]=o,E[u+2]=r,E[u+3]=f}}function R(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return F.$D()||N(u),I.$ue.wrap(u)}function m(E){const u=E.buffer;if(F.$D()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function d(E){const u=new Uint32Array(k(E));let b=0;if(u[b++]=E.id,E.type==="full")u[b++]=1,u[b++]=E.data.length,u.set(E.data,b),b+=E.data.length;else{u[b++]=2,u[b++]=E.deltas.length;for(const f of E.deltas)u[b++]=f.start,u[b++]=f.deleteCount,f.data?(u[b++]=f.data.length,u.set(f.data,b),b+=f.data.length):u[b++]=0}return R(u)}function k(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const b of E.deltas)b.data&&(u+=b.data.length)}return u}function O(E){const u=m(E);let b=0;const f=u[b++];if(u[b++]===1){const n=u[b++],i=u.subarray(b,b+n);return b+=n,{id:f,type:"full",data:i}}const o=u[b++],s=[];for(let n=0;n<o;n++){const i=u[b++],a=u[b++],h=u[b++];let t;h>0&&(t=u.subarray(b,b+h),b+=h),s[n]={start:i,deleteCount:a,data:t}}return{id:f,type:"delta",deltas:s}}}),define(Pe[149],Me([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[150],Me([1,0,18,26,21,133,151,149]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=a,e.stringSet=v,e.cursorStyleToString=y,e.filterValidationDecorations=de;var d;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class E{constructor(X,$e,Ve,Ze){this.id=X,this.name=$e,this.defaultValue=Ve,this.schema=Ze}applyUpdate(X,$e){return b(X,$e)}compute(X,$e,Ve){return Ve}}class u{constructor(X,$e){this.newValue=X,this.didChange=$e}}e.ApplyUpdateResult=u;function b(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new u(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const Ve=Array.isArray(Z)&&Array.isArray(X)&&I.$ub(Z,X);return new u(X,!Ve)}let $e=!1;for(const Ve in X)if(X.hasOwnProperty(Ve)){const Ze=b(Z[Ve],X[Ve]);Ze.didChange&&(Z[Ve]=Ze.newValue,$e=!0)}return new u(Z,$e)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,$e){return b(X,$e)}validate(X){return this.defaultValue}}class r{constructor(X,$e,Ve,Ze){this.id=X,this.name=$e,this.defaultValue=Ve,this.schema=Ze}applyUpdate(X,$e){return b(X,$e)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,$e,Ve){return Ve}}function o(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class s extends r{constructor(X,$e,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ve),super(X,$e,Ve,Ze)}validate(X){return o(X,this.defaultValue)}}function n(Z,X,$e,Ve){if(typeof Z>"u")return X;let Ze=parseInt(Z,10);return isNaN(Ze)?X:(Ze=Math.max($e,Ze),Ze=Math.min(Ve,Ze),Ze|0)}class i extends r{static clampedInt(X,$e,Ve,Ze){return n(X,$e,Ve,Ze)}constructor(X,$e,Ve,Ze,ut,Ae=void 0){typeof Ae<"u"&&(Ae.type="integer",Ae.default=Ve,Ae.minimum=Ze,Ae.maximum=ut),super(X,$e,Ve,Ae),this.minimum=Ze,this.maximum=ut}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Z,X,$e,Ve){if(typeof Z>"u")return X;const Ze=h.float(Z,X);return h.clamp(Ze,$e,Ve)}class h extends r{static clamp(X,$e,Ve){return X<$e?$e:X>Ve?Ve:X}static float(X,$e){if(typeof X=="number")return X;if(typeof X>"u")return $e;const Ve=parseFloat(X);return isNaN(Ve)?$e:Ve}constructor(X,$e,Ve,Ze,ut){typeof ut<"u"&&(ut.type="number",ut.default=Ve),super(X,$e,Ve,ut),this.validationFn=Ze}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class t extends r{static string(X,$e){return typeof X!="string"?$e:X}constructor(X,$e,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ve),super(X,$e,Ve,Ze)}validate(X){return t.string(X,this.defaultValue)}}function v(Z,X,$e,Ve){return typeof Z!="string"?X:Ve&&Z in Ve?Ve[Z]:$e.indexOf(Z)===-1?X:Z}class c extends r{constructor(X,$e,Ve,Ze,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=Ze,ut.default=Ve),super(X,$e,Ve,ut),this.c=Ze}validate(X){return v(X,this.defaultValue,this.c)}}class $ extends E{constructor(X,$e,Ve,Ze,ut,Ae,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=Ze),super(X,$e,Ve,Dt),this.c=ut,this.d=Ae}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,$e,Ve){return Ve===0?X.accessibilitySupport:Ve}}class l extends E{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:m.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(Z){switch(Z){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(Z){switch(Z){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class A extends f{constructor(){super(141)}compute(X,$e,Ve){const Ze=["monaco-editor"];return $e.get(39)&&Ze.push($e.get(39)),X.extraEditorClassName&&Ze.push(X.extraEditorClassName),$e.get(74)==="default"?Ze.push("mouse-default"):$e.get(74)==="copy"&&Ze.push("mouse-copy"),$e.get(111)&&Ze.push("showUnused"),$e.get(139)&&Ze.push("showDeprecated"),Ze.join(" ")}}class G extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(X,$e,Ve){return Ve&&X.emptySelectionClipboard}}class T extends E{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:m.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:m.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":v($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":v($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class W extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?W.OFF:X==="true"?W.ON:X:X?W.ON:W.OFF}}e.EditorFontLigatures=W;class P extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?P.OFF:X==="true"?P.TRANSLATE:X:X?P.TRANSLATE:P.OFF}compute(X,$e,Ve){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class L extends f{constructor(){super(50)}compute(X,$e,Ve){return X.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(X){const $e=h.float(X,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(X,$e,Ve){return X.fontInfo.fontSize}}class ne extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ne.d,maximum:ne.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ne.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ne.d,ne.e))}}class le extends E{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{multiple:v($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??v($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??v($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??v($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??v($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??v($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends E{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:m.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:i.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var Se;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class he extends f{constructor(){super(144)}compute(X,$e,Ve){return he.computeLayout($e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const $e=X.height/X.lineHeight,Ve=Math.floor(X.paddingTop/X.lineHeight);let Ze=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ze=Math.max(Ze,$e-1));const ut=(Ve+X.viewLineCount+Ze)/(X.pixelRatio*X.height),Ae=Math.floor(X.viewLineCount/ut);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ze,desiredRatio:ut,minimapLineCount:Ae}}static c(X,$e){const Ve=X.outerWidth,Ze=X.outerHeight,ut=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const Ae=$e.stableMinimapLayoutInput,Dt=Ae&&X.outerHeight===Ae.outerHeight&&X.lineHeight===Ae.lineHeight&&X.typicalHalfwidthCharacterWidth===Ae.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ae.pixelRatio&&X.scrollBeyondLastLine===Ae.scrollBeyondLastLine&&X.paddingTop===Ae.paddingTop&&X.paddingBottom===Ae.paddingBottom&&X.minimap.enabled===Ae.minimap.enabled&&X.minimap.side===Ae.minimap.side&&X.minimap.size===Ae.minimap.size&&X.minimap.showSlider===Ae.minimap.showSlider&&X.minimap.renderCharacters===Ae.minimap.renderCharacters&&X.minimap.maxColumn===Ae.minimap.maxColumn&&X.minimap.scale===Ae.minimap.scale&&X.verticalScrollbarWidth===Ae.verticalScrollbarWidth&&X.isViewportWrapping===Ae.isViewportWrapping,Jt=X.lineHeight,zt=X.typicalHalfwidthCharacterWidth,hi=X.scrollBeyondLastLine,Tt=X.minimap.renderCharacters;let Et=ut>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Qt=X.minimap.maxColumn,Ut=X.minimap.size,oi=X.minimap.side,ti=X.verticalScrollbarWidth,Xe=X.viewLineCount,xt=X.remainingWidth,ii=X.isViewportWrapping,dt=Tt?2:3;let pt=Math.floor(ut*Ze);const ni=pt/ut;let Bt=!1,Wt=!1,ft=dt*Et,Mt=Et/ut,_t=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:At,extraLinesBeforeFirstLine:It,extraLinesBeyondLastLine:Ft,desiredRatio:si,minimapLineCount:Ht}=he.computeContainedMinimapLineCount({viewLineCount:Xe,scrollBeyondLastLine:hi,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ze,lineHeight:Jt,pixelRatio:ut});if(Xe/Ht>1)Bt=!0,Wt=!0,Et=1,ft=1,Mt=Et/ut;else{let bt=!1,Ot=Et+1;if(Ut==="fit"){const Lt=Math.ceil((It+Xe+Ft)*ft);ii&&Dt&&xt<=$e.stableFitRemainingWidth?(bt=!0,Ot=$e.stableFitMaxMinimapScale):bt=Lt>pt}if(Ut==="fill"||bt){Bt=!0;const Lt=Et;ft=Math.min(Jt*ut,Math.max(1,Math.floor(1/si))),ii&&Dt&&xt<=$e.stableFitRemainingWidth&&(Ot=$e.stableFitMaxMinimapScale),Et=Math.min(Ot,Math.max(1,Math.floor(ft/dt))),Et>Lt&&(_t=Math.min(2,Et/Lt)),Mt=Et/ut/_t,pt=Math.ceil(Math.max(At,It+Xe+Ft)*ft),ii?($e.stableMinimapLayoutInput=X,$e.stableFitRemainingWidth=xt,$e.stableFitMaxMinimapScale=Et):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ri=Math.floor(Qt*Mt),He=Math.min(ri,Math.max(0,Math.floor((xt-ti-2)*Mt/(zt+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Vt=Math.floor(ut*He);const Zt=Vt/ut;Vt=Math.floor(Vt*_t);const qt=Tt?1:2,mt=oi==="left"?0:Ve-He-ti;return{renderMinimap:qt,minimapLeft:mt,minimapWidth:He,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Wt,minimapScale:Et,minimapLineHeight:ft,minimapCanvasInnerWidth:Vt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Zt,minimapCanvasOuterHeight:ni}}static computeLayout(X,$e){const Ve=$e.outerWidth|0,Ze=$e.outerHeight|0,ut=$e.lineHeight|0,Ae=$e.lineNumbersDigitCount|0,Dt=$e.typicalHalfwidthCharacterWidth,Jt=$e.maxDigitWidth,zt=$e.pixelRatio,hi=$e.viewLineCount,Tt=X.get(136),Et=Tt==="inherit"?X.get(135):Tt,Qt=Et==="inherit"?X.get(131):Et,Ut=X.get(134),oi=$e.isDominatedByLongLines,ti=X.get(57),Xe=X.get(68).renderType!==0,xt=X.get(69),ii=X.get(105),dt=X.get(84),pt=X.get(73),ni=X.get(103),Bt=ni.verticalScrollbarSize,Wt=ni.verticalHasArrows,ft=ni.arrowSize,Mt=ni.horizontalScrollbarSize,_t=X.get(43),ri=X.get(110)!=="never";let He=X.get(66);_t&&ri&&(He+=16);let Vt=0;if(Xe){const yt=Math.max(Ae,xt);Vt=Math.round(yt*Jt)}let Zt=0;ti&&(Zt=ut*$e.glyphMarginDecorationLaneCount);let qt=0,mt=qt+Zt,At=mt+Vt,It=At+He;const Ft=Ve-Zt-Vt-He;let si=!1,Ht=!1,Xt=-1;Et==="inherit"&&oi?(si=!0,Ht=!0):Qt==="on"||Qt==="bounded"?Ht=!0:Qt==="wordWrapColumn"&&(Xt=Ut);const bt=he.c({outerWidth:Ve,outerHeight:Ze,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:zt,scrollBeyondLastLine:ii,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:pt,verticalScrollbarWidth:Bt,viewLineCount:hi,remainingWidth:Ft,isViewportWrapping:Ht},$e.memory||new O);bt.renderMinimap!==0&&bt.minimapLeft===0&&(qt+=bt.minimapWidth,mt+=bt.minimapWidth,At+=bt.minimapWidth,It+=bt.minimapWidth);const Ot=Ft-bt.minimapWidth,Lt=Math.max(1,Math.floor((Ot-Bt-2)/Dt)),Nt=Wt?ft:0;return Ht&&(Xt=Math.max(1,Lt),Qt==="bounded"&&(Xt=Math.min(Xt,Ut))),{width:Ve,height:Ze,glyphMarginLeft:qt,glyphMarginWidth:Zt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Vt,decorationsLeft:At,decorationsWidth:He,contentLeft:It,contentWidth:Ot,minimap:bt,viewportColumn:Lt,isWordWrapMinified:si,isViewportWrapping:Ht,wrappingColumn:Xt,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Mt,overviewRuler:{top:Nt,width:Bt,height:Ze-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=he;class be extends E{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(X){return v(X,"simple",["simple","advanced"])}compute(X,$e,Ve){return $e.get(2)===2?"advanced":Ve}}var ee;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class pe extends E{constructor(){const X={enabled:ee.OnCode};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ee.Off,ee.OnCode,ee.On],default:X.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:v(X.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class re extends E{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:m.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class fe extends E{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:m.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:v($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class V extends E{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):i.clampedInt(X,this.defaultValue,0,1e3)}compute(X,$e,Ve){return Ve<0?i.clampedInt(-Ve*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class te extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>h.clamp(X,0,150),{markdownDescription:m.localize(66,null)})}compute(X,$e,Ve){return X.fontInfo.lineHeight}}class ke extends E{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:X.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:m.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:v($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:v($e.side,this.defaultValue.side,["right","left"]),showSlider:v($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt($e.scale,1,1,3),maxColumn:i.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Z){return Z==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class Ie extends E{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{top:i.clampedInt($e.top,0,0,1e3),bottom:i.clampedInt($e.bottom,0,0,1e3)}}}class ve extends E{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:m.localize(81,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class ge extends f{constructor(){super(142)}compute(X,$e,Ve){return X.pixelRatio}}class J extends E{constructor(){const X={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:X.strings,description:m.localize(85,null)},comments:{anyOf:$e,default:X.comments,description:m.localize(86,null)},other:{anyOf:$e,default:X.other,description:m.localize(87,null)}},default:X,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const zt=X?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!X||typeof X!="object")return this.defaultValue;const{other:$e,comments:Ve,strings:Ze}=X,ut=["on","inline","off"];let Ae,Dt,Jt;return typeof $e=="boolean"?Ae=$e?"on":"off":Ae=v($e,this.defaultValue.other,ut),typeof Ve=="boolean"?Dt=Ve?"on":"off":Dt=v(Ve,this.defaultValue.comments,ut),typeof Ze=="boolean"?Jt=Ze?"on":"off":Jt=v(Ze,this.defaultValue.strings,ut),{other:Ae,comments:Dt,strings:Jt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class ce extends E{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(X){let $e=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?($e=4,Ve=X):X==="interval"?$e=3:X==="relative"?$e=2:X==="on"?$e=1:$e=0),{renderType:$e,renderFn:Ve}}}function de(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Ne extends E{constructor(){const X=[],$e={type:"number",description:m.localize(94,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:X,description:m.localize(96,null)})}validate(X){if(Array.isArray(X)){const $e=[];for(const Ve of X)if(typeof Ve=="number")$e.push({column:i.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ze=Ve;$e.push({column:i.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return $e.sort((Ve,Ze)=>Ve.column-Ze.column),$e}return this.defaultValue}}class ue extends E{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ce(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends E{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X,Ve=i.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=i.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce($e.vertical,this.defaultValue.vertical),horizontal:Ce($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:i.clampedInt($e.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:i.clampedInt($e.verticalSliderSize,Ze,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends E{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:m.localize(115,null)}})}applyUpdate(X,$e){let Ve=!1;$e.allowedCharacters&&X&&(F.$Rn(X.allowedCharacters,$e.allowedCharacters)||(X={...X,allowedCharacters:$e.allowedCharacters},Ve=!0)),$e.allowedLocales&&X&&(F.$Rn(X.allowedLocales,$e.allowedLocales)||(X={...X,allowedLocales:$e.allowedLocales},Ve=!0));const Ze=super.applyUpdate(X,$e);return Ve?new u(Ze.newValue,!0):Ze}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{nonBasicASCII:_($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,$e){if(typeof X!="object"||!X)return $e;const Ve={};for(const[Ze,ut]of Object.entries(X))ut===!0&&(Ve[Ze]=!0);return Ve}}class U extends E{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(122,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:v($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily)}}}class z extends E{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:m.localize(129,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),showToolbar:v($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends E{constructor(){const X={enabled:N.$Ls.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Ls.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends E{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:X.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:X.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:X.highlightActiveIndentation,description:m.localize(145,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{bracketPairs:_($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:_($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Z,X,$e){const Ve=$e.indexOf(Z);return Ve===-1?X:$e[Ve]}class se extends E{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:X.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:X.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertMode:v($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:v($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Oe extends E{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(X.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Qe extends E{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(196,null),m.localize(197,null),m.localize(198,null),m.localize(199,null)],description:m.localize(200,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,$e,Ve){return $e.get(2)===2?0:Ve}}class xe extends f{constructor(){super(145)}compute(X,$e,Ve){const Ze=$e.get(144);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class tt extends E{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(203,null),m.localize(204,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:v($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends E{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(207,null),m.localize(208,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:v($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?rt:M.$k?ct:nt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var it;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSeparators=130]="wordSeparators",Z[Z.wordWrap=131]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=134]="wordWrapColumn",Z[Z.wordWrapOverride1=135]="wordWrapOverride1",Z[Z.wordWrapOverride2=136]="wordWrapOverride2",Z[Z.wrappingIndent=137]="wrappingIndent",Z[Z.wrappingStrategy=138]="wrappingStrategy",Z[Z.showDeprecated=139]="showDeprecated",Z[Z.inlayHints=140]="inlayHints",Z[Z.editorClassName=141]="editorClassName",Z[Z.pixelRatio=142]="pixelRatio",Z[Z.tabFocusMode=143]="tabFocusMode",Z[Z.layoutInfo=144]="layoutInfo",Z[Z.wrappingInfo=145]="wrappingInfo",Z[Z.defaultColorDecorators=146]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(it||(e.EditorOption=it={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(209,null)})),acceptSuggestionOnEnter:Be(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(210,null),""],markdownDescription:m.localize(211,null)})),accessibilitySupport:Be(new p),accessibilityPageSize:Be(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",m.localize(213,null))),ariaRequired:Be(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),""],description:m.localize(217,null)})),autoClosingComments:Be(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoClosingDelete:Be(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(221,null),""],description:m.localize(222,null)})),autoClosingOvertype:Be(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingQuotes:Be(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(225,null),m.localize(226,null),""],description:m.localize(227,null)})),autoIndent:Be(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),automaticLayout:Be(new s(13,"automaticLayout",!1)),autoSurround:Be(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),""],description:m.localize(237,null)})),bracketPairColorization:Be(new H),bracketPairGuides:Be(new q),stickyTabStops:Be(new s(116,"stickyTabStops",!1,{description:m.localize(238,null)})),codeLens:Be(new s(17,"codeLens",!0,{description:m.localize(239,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:m.localize(240,null)})),codeLensFontSize:Be(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(241,null)})),colorDecorators:Be(new s(20,"colorDecorators",!0,{description:m.localize(242,null)})),colorDecoratorActivatedOn:Be(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),colorDecoratorsLimit:Be(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(247,null)})),columnSelection:Be(new s(22,"columnSelection",!1,{description:m.localize(248,null)})),comments:Be(new l),contextmenu:Be(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(249,null)})),cursorBlinking:Be(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(250,null)})),cursorSmoothCaretAnimation:Be(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),cursorStyle:Be(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:m.localize(255,null)})),cursorSurroundingLines:Be(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(256,null)})),cursorSurroundingLinesStyle:Be(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],markdownDescription:m.localize(259,null)})),cursorWidth:Be(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(260,null)})),disableLayerHinting:Be(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(34,"domReadOnly",!1)),dragAndDrop:Be(new s(35,"dragAndDrop",!0,{description:m.localize(261,null)})),emptySelectionClipboard:Be(new G),dropIntoEditor:Be(new tt),stickyScroll:Be(new re),experimentalWhitespaceRendering:Be(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(266,null)})),find:Be(new T),fixedOverflowWidgets:Be(new s(42,"fixedOverflowWidgets",!1)),folding:Be(new s(43,"folding",!0,{description:m.localize(267,null)})),foldingStrategy:Be(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),foldingHighlight:Be(new s(45,"foldingHighlight",!0,{description:m.localize(271,null)})),foldingImportsByDefault:Be(new s(46,"foldingImportsByDefault",!1,{description:m.localize(272,null)})),foldingMaximumRegions:Be(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(274,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(275,null)})),fontInfo:Be(new L),fontLigatures2:Be(new W),fontSize:Be(new K),fontWeight:Be(new ne),fontVariations:Be(new P),formatOnPaste:Be(new s(55,"formatOnPaste",!1,{description:m.localize(276,null)})),formatOnType:Be(new s(56,"formatOnType",!1,{description:m.localize(277,null)})),glyphMargin:Be(new s(57,"glyphMargin",!0,{description:m.localize(278,null)})),gotoLocation:Be(new le),hideCursorInOverviewRuler:Be(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new s(61,"inDiffEditor",!1)),letterSpacing:Be(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:m.localize(280,null)})),lightbulb:Be(new pe),lineDecorationsWidth:Be(new V),lineHeight:Be(new te),lineNumbers:Be(new ce),lineNumbersMinChars:Be(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(70,"linkedEditing",!1,{description:m.localize(281,null)})),links:Be(new s(71,"links",!0,{description:m.localize(282,null)})),matchBrackets:Be(new c(72,"matchBrackets","always",["always","near","never"],{description:m.localize(283,null)})),minimap:Be(new ke),mouseStyle:Be(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new h(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(284,null)})),mouseWheelZoom:Be(new s(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?m.localize(285,null):m.localize(286,null)})),multiCursorMergeOverlapping:Be(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(287,null)})),multiCursorModifier:Be(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),multiCursorPaste:Be(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(291,null),m.localize(292,null)],markdownDescription:m.localize(293,null)})),multiCursorLimit:Be(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(294,null)})),occurrencesHighlight:Be(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(295,null),m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),overviewRulerBorder:Be(new s(82,"overviewRulerBorder",!0,{description:m.localize(299,null)})),overviewRulerLanes:Be(new i(83,"overviewRulerLanes",3,0,3)),padding:Be(new Ie),pasteAs:Be(new at),parameterHints:Be(new ve),peekWidgetDefaultFocus:Be(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(300,null),m.localize(301,null)],description:m.localize(302,null)})),definitionLinkOpensInPeek:Be(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(303,null)})),quickSuggestions:Be(new J),quickSuggestionsDelay:Be(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(304,null)})),readOnly:Be(new s(91,"readOnly",!1)),readOnlyMessage:Be(new ue),renameOnType:Be(new s(93,"renameOnType",!1,{description:m.localize(305,null),markdownDeprecationMessage:m.localize(306,null)})),renderControlCharacters:Be(new s(94,"renderControlCharacters",!0,{description:m.localize(307,null),restricted:!0})),renderFinalNewline:Be(new c(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(308,null)})),renderLineHighlight:Be(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(309,null)],description:m.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(311,null)})),renderValidationDecorations:Be(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(312,null),m.localize(313,null),m.localize(314,null),""],description:m.localize(315,null)})),revealHorizontalRightPadding:Be(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(101,"roundedSelection",!0,{description:m.localize(316,null)})),rulers:Be(new Ne),scrollbar:Be(new Re),scrollBeyondLastColumn:Be(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(317,null)})),scrollBeyondLastLine:Be(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(318,null)})),scrollPredominantAxis:Be(new s(106,"scrollPredominantAxis",!0,{description:m.localize(319,null)})),selectionClipboard:Be(new s(107,"selectionClipboard",!0,{description:m.localize(320,null),included:M.$k})),selectionHighlight:Be(new s(108,"selectionHighlight",!0,{description:m.localize(321,null)})),selectOnLineNumbers:Be(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),showUnused:Be(new s(111,"showUnused",!0,{description:m.localize(326,null)})),showDeprecated:Be(new s(139,"showDeprecated",!0,{description:m.localize(327,null)})),inlayHints:Be(new fe),snippetSuggestions:Be(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(328,null),m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),smartSelect:Be(new Oe),smoothScrolling:Be(new s(114,"smoothScrolling",!1,{description:m.localize(333,null)})),stopRenderingLineAfter:Be(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new se),inlineSuggest:Be(new U),inlineEdit:Be(new z),inlineCompletionsAccessibilityVerbose:Be(new s(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(334,null)})),suggestFontSize:Be(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(337,null)})),suggestSelection:Be(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),tabCompletion:Be(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(342,null),m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),tabIndex:Be(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new je),unusualLineTerminators:Be(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(346,null),m.localize(347,null),m.localize(348,null)],description:m.localize(349,null)})),useShadowDOM:Be(new s(127,"useShadowDOM",!0)),useTabStops:Be(new s(128,"useTabStops",!0,{description:m.localize(350,null)})),wordBreak:Be(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(351,null),m.localize(352,null)],description:m.localize(353,null)})),wordSeparators:Be(new t(130,"wordSeparators",R.$Ms,{description:m.localize(354,null)})),wordWrap:Be(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(355,null),m.localize(356,null),m.localize(357,null),m.localize(358,null)],description:m.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new i(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(360,null)})),wordWrapOverride1:Be(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new A),defaultColorDecorators:Be(new s(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new s(143,"tabFocusMode",!1,{markdownDescription:m.localize(362,null)})),layoutInfo:Be(new he),wrappingInfo:Be(new xe),wrappingIndent:Be(new Qe),wrappingStrategy:Be(new be)}}),define(Pe[152],Me([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[153],Me([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[154],Me([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[155],Me([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[156],Me([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[157],Me([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[158],Me([9,10]),function(me,e){return me.create("vs/platform/log/common/log",e)}),define(Pe[159],Me([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[160],Me([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[161],Me([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[162],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[163],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[164],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[165],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[166],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[167],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[168],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[169],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[170],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[171],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[172],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[173],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[174],Me([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[175],Me([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[176],Me([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[177],Me([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[178],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[179],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[180],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[181],Me([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[182],Me([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[183],Me([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[184],Me([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[185],Me([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[186],Me([1,0,14,154]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var M;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(M||(e.TokenType=M={}));function N(...k){switch(k.length){case 1:return(0,F.localize)(0,null,k[0]);case 2:return(0,F.localize)(1,null,k[0],k[1]);case 3:return(0,F.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,F.localize)(3,null),m=(0,F.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const E=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:E,lexeme:u,additionalInfo:O}),this.f.push(b)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const E=this.c.substring(this.d,this.e),u=d.b.get(E);u?this.k(u):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,E=!1,u=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(m);return}const f=this.c.charCodeAt(O);if(E)E=!1;else if(f===47&&!u){O++;break}else f===91?u=!0:f===92?E=!0:f===93&&(u=!1);O++}for(;O<this.c.length&&d.a.has(this.c.charCodeAt(O));)O++;this.e=O;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=d}),define(Pe[187],Me([1,0,24,32,156,301]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=d,e.$sp=k,e.$tp=O,e.$up=E,e.$vp=u,e.$wp=b,e.$xp=f;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||R.test(s)}function k(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function O(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let v=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),v=!1);let c=0;if(s.preRelease){const $=m.exec(s.preRelease);if($){const[,w,p,l]=$;c=Date.UTC(Number(w),Number(p)-1,Number(l))}}return{majorBase:n,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:v,isMinimum:s.hasGreaterEquals,notBefore:c}}function E(s,n,i){let a;typeof s=="string"?a=O(k(s)):a=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof i=="string"?t=O(k(i)):t=i,!a||!t)return!1;const v=a.majorBase,c=a.minorBase,$=a.patchBase;let w=t.majorBase,p=t.minorBase,l=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?v>w?!0:v<w?!1:c>p?!0:c<p||h&&h<D?!1:$>=l:(v===1&&w===0&&(!g||!S||!y)&&(w=1,p=0,l=0,g=!0,S=!1,y=!1),v<w?!1:v>w?!g:c<p?!1:c>p?!S:$<l?!1:$>l?!y:!(h&&h<D))}function u(s,n,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([F.default.Error,M.localize(0,null)]),t;if(typeof a.name!="string")return t.push([F.default.Error,M.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([F.default.Error,M.localize(2,null,"version")]),t;if(!a.engines)return t.push([F.default.Error,M.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([F.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([F.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([F.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([F.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([F.default.Warning,M.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([F.default.Error,M.localize(9,null,"main")]),t;{const $=(0,I.$Ug)(i,a.main);(0,I.$Og)($,i)||t.push([F.default.Warning,M.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([F.default.Error,M.localize(11,null,"browser")]),t;{const $=(0,I.$Ug)(i,a.browser);(0,I.$Og)($,i)||t.push([F.default.Warning,M.localize(12,null,$.path,i.path)])}}if(!N.valid(a.version))return t.push([F.default.Error,M.localize(13,null)]),t;const v=[];if(!b(s,n,a,h,v))for(const $ of v)t.push([F.default.Error,$]);return t}function b(s,n,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,h)}function f(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,a=[]){const h=O(k(i));if(!h)return a.push(M.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(M.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(M.localize(16,null,i)),!1;return E(s,n,h)?!0:(a.push(M.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Pe[70],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class I{constructor(M,N=[],R=!1){this.ctor=M,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$ei=I}),define(Pe[54],Me([1,0,70]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$fs=N,e.$gs=R;const F=[];var M;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function N(m,d,k){d instanceof I.$ei||(d=new I.$ei(d,[],!!k)),F.push([m,d])}function R(){return F}}),define(Pe[188],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;class I{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Vq=I;class F{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const m=this.lookupOrInsertNode(N),d=this.lookupOrInsertNode(R);m.outgoing.set(d.key,d),d.incoming.set(m.key,m)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let m=this.a.get(R);return m||(m=new I(R,N),this.a.set(R,m)),m}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,m]of this.a)N.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const m=new Set([N]),d=this.c(R,m);if(d)return d}}c(N,R){for(const[m,d]of N.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const k=this.c(d,R);if(k)return k;R.delete(m)}}}e.$Wq=F}),define(Pe[3],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=M,e.$ii=N;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(d){return d[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(I||(e._util=I={})),e.$gi=M("instantiationService");function F(R,m,d){m[I.DI_TARGET]===m?m[I.DI_DEPENDENCIES].push({id:R,index:d}):(m[I.DI_DEPENDENCIES]=[{id:R,index:d}],m[I.DI_TARGET]=m)}function M(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const m=function(d,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(m,d,O)};return m.toString=()=>R,I.serviceIds.set(R,m),m}function N(R){return R}}),define(Pe[47],Me([1,0,16,2,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=N,e.$Pi=R,e.$Qi=d,e.$Ri=k,e.$Si=O,e.$Ti=E,e.$Ui=u,e.$Vi=f,e.$Wi=r,e.$Xi=o,e.$Ni=(0,M.$hi)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function O(s,n){const i=Object.create(null);for(const a in s)E(i,a,s[a],n);return i}function E(s,n,i,a){const h=n.split("."),t=h.pop();let v=s;for(let c=0;c<h.length;c++){const $=h[c];let w=v[$];switch(typeof w){case"undefined":w=v[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}v=w}if(typeof v=="object"&&v!==null)try{v[t]=i}catch{a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}function u(s,n){const i=n.split(".");b(s,i)}function b(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(b(a,n),Object.keys(a).length===0&&delete s[i])}}function f(s,n,i){function a(v,c){let $=v;for(const w of c){if(typeof $!="object"||$===null)return;$=$[w]}return $}const h=n.split("."),t=a(s,h);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in s?I.$Wf(s[a])&&I.$Wf(n[a])?r(s[a],n[a],i):i&&(s[a]=n[a]):s[a]=n[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Pe[33],Me([1,0,21,15,186,3,153,14]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=k,e.$gj=v,e.$hj=c,e.$Aj=ee;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",I.$j),d.set("isLinux",I.$k),d.set("isWindows",I.$i),d.set("isWeb",I.$o),d.set("isMacNative",I.$j&&!I.$o),d.set("isEdge",I.$H),d.set("isFirefox",I.$F),d.set("isChrome",I.$E),d.set("isSafari",I.$G);function k(fe,V){if(d.get(fe)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(fe,V)}const O=Object.prototype.hasOwnProperty;var E;(function(fe){fe[fe.False=0]="False",fe[fe.True=1]="True",fe[fe.Defined=2]="Defined",fe[fe.Not=3]="Not",fe[fe.Equals=4]="Equals",fe[fe.NotEquals=5]="NotEquals",fe[fe.And=6]="And",fe[fe.Regex=7]="Regex",fe[fe.NotRegex=8]="NotRegex",fe[fe.Or=9]="Or",fe[fe.In=10]="In",fe[fe.NotIn=11]="NotIn",fe[fe.Greater=12]="Greater",fe[fe.GreaterEquals=13]="GreaterEquals",fe[fe.Smaller=14]="Smaller",fe[fe.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const u={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),f=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=u){this.k=V,this.d=new M.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ke=this.D(),Te=ke.type===17?n:void 0;throw this.h.push({message:s,offset:ke.offset,lexeme:M.$cj.getLexeme(ke),additionalInfo:Te}),h.c}return te}catch(te){if(te!==h.c)throw te;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const te=this.o();V.push(te)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const te=this.s();V.push(te)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const te=this.l();return this.A(1,o),te?.negate()}case 17:return this.z(),C.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const te=this.l();return this.A(1,o),te}case 17:{const te=V.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Ie=Te.lexeme,ve=Ie.lastIndexOf("/"),ge=ve===Ie.length-1?void 0:this.w(Ie.substring(ve+1));let J;try{J=new RegExp(Ie.substring(1,ve),ge)}catch{throw this.B("REGEX",Te)}return L.create(te,J)}switch(Te.type){case 10:case 19:{const Ie=[Te.lexeme];this.z();let ve=this.D(),ge=0;for(let Ne=0;Ne<Te.lexeme.length;Ne++)Te.lexeme.charCodeAt(Ne)===40?ge++:Te.lexeme.charCodeAt(Ne)===41&&ge--;for(;!this.E()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Ne=0;Ne<ve.lexeme.length;Ne++)ve.lexeme.charCodeAt(Ne)===40?ge++:Te.lexeme.charCodeAt(Ne)===41&&ge--}if(ge<0)break;Ie.push(M.$cj.getLexeme(ve)),this.z(),ve=this.D()}const J=Ie.join(""),Y=J.lastIndexOf("/"),ce=Y===J.length-1?void 0:this.w(J.substring(Y+1));let de;try{de=new RegExp(J.substring(1,Y),ce)}catch{throw this.B("REGEX",Te)}return t.regex(te,de)}case 18:{const Ie=Te.lexeme;this.z();let ve=null;if(!(0,F.$Ue)(Ie)){const ge=Ie.indexOf("/"),J=Ie.lastIndexOf("/");if(ge!==J&&ge>=0){const Y=Ie.slice(ge+1,J),ce=Ie[J+1]==="i"?"i":"";try{ve=new RegExp(Y,ce)}catch{throw this.B("REGEX",Te)}}}if(ve===null)throw this.B("REGEX",Te);return L.create(te,ve)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(te,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(te,Te);switch(Te){case"true":return t.has(te);case"false":return t.not(te);default:return t.equals(te,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(te,Te);switch(Te){case"true":return t.not(te);case"false":return t.has(te);default:return t.notEquals(te,Te)}}case 5:return this.z(),W.create(te,this.u());case 6:return this.z(),P.create(te,this.u());case 7:return this.z(),G.create(te,this.u());case 8:return this.z(),T.create(te,this.u());case 13:return this.z(),t.in(te,this.u());default:return t.has(te)}}case 20:throw this.h.push({message:i,offset:V.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,te){if(this.C(V))return this.z();throw this.B(te,this.D())}B(V,te,ke){const Te=(0,R.localize)(8,null,V,M.$cj.getLexeme(te)),Ie=te.offset,ve=M.$cj.getLexeme(te);return this.h.push({message:Te,offset:Ie,lexeme:ve,additionalInfo:ke}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=h;class t{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(V){return l.create(V)}static equals(V,te){return D.create(V,te)}static notEquals(V,te){return y.create(V,te)}static regex(V,te){return L.create(V,te)}static in(V,te){return g.create(V,te)}static notIn(V,te){return S.create(V,te)}static not(V){return C.create(V)}static and(...V){return le.create(V,null,!0)}static or(...V){return ye.create(V,null,!0)}static greater(V,te){return G.create(V,te)}static greaterEquals(V,te){return T.create(V,te)}static smaller(V,te){return W.create(V,te)}static smallerEquals(V,te){return P.create(V,te)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$fj=t;function v(fe){const V=new h({regexParsingWithErrorRecovery:!1});return fe.map(te=>(V.parse(te),V.lexingErrors.length>0?V.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,R.localize)(9,null,ke.additionalInfo):(0,R.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}function c(fe,V){const te=fe?fe.substituteConstants():void 0,ke=V?V.substituteConstants():void 0;return!te&&!ke?!0:!te||!ke?!1:te.equals(ke)}function $(fe,V){return fe.cmp(V)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return p.INSTANCE}}e.$ij=w;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return w.INSTANCE}}e.$jj=p;class l{static create(V,te=null){const ke=d.get(V);return typeof ke=="boolean"?ke?p.INSTANCE:w.INSTANCE:new l(V,te)}constructor(V,te){this.key=V,this.c=te,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:he(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=d.get(this.key);return typeof V=="boolean"?V?p.INSTANCE:w.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$kj=l;class D{static create(V,te,ke=null){if(typeof te=="boolean")return te?l.create(V,ke):C.create(V,ke);const Te=d.get(V);return typeof Te=="boolean"?te===(Te?"true":"false")?p.INSTANCE:w.INSTANCE:new D(V,te,ke)}constructor(V,te,ke){this.c=V,this.d=te,this.f=ke,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=d.get(this.c);if(typeof V=="boolean"){const te=V?"true":"false";return this.d===te?p.INSTANCE:w.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$lj=D;class g{static create(V,te){return new g(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:be(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const te=V.getValue(this.f),ke=V.getValue(this.d);return Array.isArray(te)?te.includes(ke):typeof ke=="string"&&typeof te=="object"&&te!==null?O.call(te,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$mj=g;class S{static create(V,te){return new S(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=11,this.c=g.create(V,te)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=S;class y{static create(V,te,ke=null){if(typeof te=="boolean")return te?C.create(V,ke):l.create(V,ke);const Te=d.get(V);return typeof Te=="boolean"?te===(Te?"true":"false")?w.INSTANCE:p.INSTANCE:new y(V,te,ke)}constructor(V,te,ke){this.c=V,this.d=te,this.f=ke,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=d.get(this.c);if(typeof V=="boolean"){const te=V?"true":"false";return this.d===te?w.INSTANCE:p.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$oj=y;class C{static create(V,te=null){const ke=d.get(V);return typeof ke=="boolean"?ke?w.INSTANCE:p.INSTANCE:new C(V,te)}constructor(V,te){this.c=V,this.d=te,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=d.get(this.c);return typeof V=="boolean"?V?w.INSTANCE:p.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$pj=C;function A(fe,V){if(typeof fe=="string"){const te=parseFloat(fe);isNaN(te)||(fe=te)}return typeof fe=="string"||typeof fe=="number"?V(fe):w.INSTANCE}class G{static create(V,te,ke=null){return A(te,Te=>new G(V,Te,ke))}constructor(V,te,ke){this.c=V,this.d=te,this.f=ke,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$qj=G;class T{static create(V,te,ke=null){return A(te,Te=>new T(V,Te,ke))}constructor(V,te,ke){this.c=V,this.d=te,this.f=ke,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$rj=T;class W{static create(V,te,ke=null){return A(te,Te=>new W(V,Te,ke))}constructor(V,te,ke){this.c=V,this.d=te,this.f=ke,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$sj=W;class P{static create(V,te,ke=null){return A(te,Te=>new P(V,Te,ke))}constructor(V,te,ke){this.c=V,this.d=te,this.f=ke,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$tj=P;class L{static create(V,te){return new L(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const te=this.f?this.f.source:"",ke=V.f?V.f.source:"";return te<ke?-1:te>ke?1:0}equals(V){if(V.type===this.type){const te=this.f?this.f.source:"",ke=V.f?V.f.source:"";return this.d===V.d&&te===ke}return!1}substituteConstants(){return this}evaluate(V){const te=V.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$uj=L;class K{static create(V){return new K(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new K(this.c.map(V))}negate(){return this.c}}e.$vj=K;function ne(fe){let V=null;for(let te=0,ke=fe.length;te<ke;te++){const Te=fe[te].substituteConstants();if(fe[te]!==Te&&V===null){V=[];for(let Ie=0;Ie<te;Ie++)V[Ie]=fe[Ie]}V!==null&&(V[te]=Te)}return V===null?fe:V}class le{static create(V,te,ke){return le.d(V,te,ke)}constructor(V,te){this.expr=V,this.c=te,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let te=0,ke=this.expr.length;te<ke;te++){const Te=$(this.expr[te],V.expr[te]);if(Te!==0)return Te}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let te=0,ke=this.expr.length;te<ke;te++)if(!this.expr[te].equals(V.expr[te]))return!1;return!0}return!1}substituteConstants(){const V=ne(this.expr);return V===this.expr?this:le.create(V,this.c,!1)}evaluate(V){for(let te=0,ke=this.expr.length;te<ke;te++)if(!this.expr[te].evaluate(V))return!1;return!0}static d(V,te,ke){const Te=[];let Ie=!1;for(const ve of V)if(ve){if(ve.type===1){Ie=!0;continue}if(ve.type===0)return w.INSTANCE;if(ve.type===6){Te.push(...ve.expr);continue}Te.push(ve)}if(Te.length===0&&Ie)return p.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort($);for(let ve=1;ve<Te.length;ve++)Te[ve-1].equals(Te[ve])&&(Te.splice(ve,1),ve--);if(Te.length===1)return Te[0];for(;Te.length>1;){const ve=Te[Te.length-1];if(ve.type!==9)break;Te.pop();const ge=Te.pop(),J=Te.length===0,Y=ye.create(ve.expr.map(ce=>le.create([ce,ge],null,ke)),null,J);Y&&(Te.push(Y),Te.sort($))}if(Te.length===1)return Te[0];if(ke){for(let ve=0;ve<Te.length;ve++)for(let ge=ve+1;ge<Te.length;ge++)if(Te[ve].negate().equals(Te[ge]))return w.INSTANCE;if(Te.length===1)return Te[0]}return new le(Te,te)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const te of this.expr)V.push(...te.keys());return V}map(V){return new le(this.expr.map(te=>te.map(V)),null)}negate(){if(!this.c){const V=[];for(const te of this.expr)V.push(te.negate());this.c=ye.create(V,this,!0)}return this.c}}e.$wj=le;class ye{static create(V,te,ke){return ye.d(V,te,ke)}constructor(V,te){this.expr=V,this.c=te,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let te=0,ke=this.expr.length;te<ke;te++){const Te=$(this.expr[te],V.expr[te]);if(Te!==0)return Te}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let te=0,ke=this.expr.length;te<ke;te++)if(!this.expr[te].equals(V.expr[te]))return!1;return!0}return!1}substituteConstants(){const V=ne(this.expr);return V===this.expr?this:ye.create(V,this.c,!1)}evaluate(V){for(let te=0,ke=this.expr.length;te<ke;te++)if(this.expr[te].evaluate(V))return!0;return!1}static d(V,te,ke){let Te=[],Ie=!1;if(V){for(let ve=0,ge=V.length;ve<ge;ve++){const J=V[ve];if(J){if(J.type===0){Ie=!0;continue}if(J.type===1)return p.INSTANCE;if(J.type===9){Te=Te.concat(J.expr);continue}Te.push(J)}}if(Te.length===0&&Ie)return w.INSTANCE;Te.sort($)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let ve=1;ve<Te.length;ve++)Te[ve-1].equals(Te[ve])&&(Te.splice(ve,1),ve--);if(Te.length===1)return Te[0];if(ke){for(let ve=0;ve<Te.length;ve++)for(let ge=ve+1;ge<Te.length;ge++)if(Te[ve].negate().equals(Te[ge]))return p.INSTANCE;if(Te.length===1)return Te[0]}return new ye(Te,te)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const te of this.expr)V.push(...te.keys());return V}map(V){return new ye(this.expr.map(te=>te.map(V)),null)}negate(){if(!this.c){const V=[];for(const te of this.expr)V.push(te.negate());for(;V.length>1;){const te=V.shift(),ke=V.shift(),Te=[];for(const Ie of re(te))for(const ve of re(ke))Te.push(le.create([Ie,ve],null,!1));V.unshift(ye.create(Te,null,!1))}this.c=ye.create(V,this,!0)}return this.c}}e.$xj=ye;class Se extends l{static{this.d=[]}static all(){return Se.d.values()}constructor(V,te,ke){super(V,null),this.f=te,typeof ke=="object"?Se.d.push({...ke,key:V}):ke!==!0&&Se.d.push({key:V,description:ke,type:te!=null?typeof te:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return D.create(this.key,V)}notEqualsTo(V){return y.create(this.key,V)}}e.$yj=Se,e.$zj=(0,N.$hi)("contextKeyService");function he(fe,V){return fe<V?-1:fe>V?1:0}function be(fe,V,te,ke){return fe<te?-1:fe>te?1:V<ke?-1:V>ke?1:0}function ee(fe,V){if(fe.type===0||V.type===1)return!0;if(fe.type===9)return V.type===9?pe(fe.expr,V.expr):!1;if(V.type===9){for(const te of V.expr)if(ee(fe,te))return!0;return!1}if(fe.type===6){if(V.type===6)return pe(V.expr,fe.expr);for(const te of fe.expr)if(ee(te,V))return!0;return!1}return fe.equals(V)}function pe(fe,V){let te=0,ke=0;for(;te<fe.length&&ke<V.length;){const Te=fe[te].cmp(V[ke]);if(Te<0)return!1;Te===0&&te++,ke++}return te===fe.length}function re(fe){return fe.type===9?fe.expr:[fe]}}),define(Pe[189],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,I.$hi)("environmentService"),e.$pi=(0,I.$ii)(e.$oi)}),define(Pe[98],Me([1,0,155,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=M,e.$Lo=N,e.$Mo=R,e.$No=m,e.$Oo=d,e.$Po=k,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,a){return a==="web"&&!i.includes("web")}function d(i,a,h){return m(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var O;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var E;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Qo=(0,F.$hi)("extensionGalleryService");var f;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var r;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$Ro=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$So=n,e.$To=(0,F.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,F.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,F.$hi)("IExtensionTipsService"),e.$Yo=(0,I.localize2)(0,"Extensions"),e.$Zo=(0,I.localize2)(1,"Preferences")}),define(Pe[43],Me([1,0,51,19,15,16,2,157,3,21,12,40]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=u,e.$Pk=r,e.$Qk=s,e.$Rk=n,e.$Sk=i,e.$Tk=a,e.$Uk=h,e.$Vk=t,e.$Wk=v,e.$Xk=c,e.$Yk=$,e.$1k=l,e.$2k=D,e.$3k=g,e.$4k=S,e.$5k=y,e.$8k=W,e.$hl=ye,e.$il=Se,e.$kl=be,e.$Nk=(0,d.$hi)("fileService");function u(ee){return ee.create===!0}var b;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function r(ee){const pe=ee;return!!pe&&typeof pe.onDidChange=="function"}var o;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(ee){return!!(ee.capabilities&2)}function n(ee){return!!(ee.capabilities&8)}function i(ee){return!!(ee.capabilities&131072)}function a(ee){return!!(ee.capabilities&4)}function h(ee){return!!(ee.capabilities&16)}function t(ee){return s(ee)?!!(ee.capabilities&16384):!1}function v(ee){return s(ee)?!!(ee.capabilities&32768):!1}function c(ee){return!!(ee.capabilities&65536)}function $(ee){return!!(ee.capabilities&2048)}var w;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class p extends Error{static create(pe,re){const fe=new p(pe.toString(),re);return g(fe,re),fe}constructor(pe,re){super(pe),this.code=re}}e.$Zk=p;function l(ee,pe){return p.create(ee,pe)}function D(ee){return ee||l((0,m.localize)(0,null),w.Unknown)}function g(ee,pe){return ee.name=pe?`${pe} (FileSystemError)`:"FileSystemError",ee}function S(ee){if(!ee)return w.Unknown;if(ee instanceof p)return ee.code;const pe=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!pe)return w.Unknown;switch(pe[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function y(ee){if(ee instanceof P)return ee.fileOperationResult;switch(S(ee)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}var C;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class A{constructor(pe,re,fe){this.resource=pe,this.operation=re,this.target=fe}isOperation(pe){return this.operation===pe}}e.$6k=A;var G;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class T{static{this.a=null}constructor(pe,re){this.c=re,this.b=void 0,this.d=new E.$V(()=>{const fe=I.$ni.forUris(()=>this.c);return fe.fill(this.rawAdded.map(V=>[V,!0])),fe}),this.f=new E.$V(()=>{const fe=I.$ni.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(V=>[V,!0])),fe}),this.g=new E.$V(()=>{const fe=I.$ni.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(V=>[V,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of pe){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==T.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(pe,...re){return this.h(pe,{includeChildren:!1},...re)}affects(pe,...re){return this.h(pe,{includeChildren:!0},...re)}h(pe,re,...fe){if(!pe)return!1;const V=fe.length>0;return!!((!V||fe.includes(1))&&(this.d.value.get(pe)||re.includeChildren&&this.d.value.findSuperstr(pe))||(!V||fe.includes(0))&&(this.f.value.get(pe)||re.includeChildren&&this.f.value.findSuperstr(pe))||(!V||fe.includes(2))&&(this.g.value.findSubstr(pe)||re.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}e.$7k=T;function W(ee,pe,re){return!ee||!pe||ee===pe||pe.length>ee.length?!1:(pe.charAt(pe.length-1)!==F.sep&&(pe+=F.sep),re?(0,M.$mf)(ee,pe):ee.indexOf(pe)===0)}class P extends Error{constructor(pe,re,fe){super(pe),this.fileOperationResult=re,this.options=fe}}e.$9k=P;class L extends P{constructor(pe,re,fe,V){super(pe,re,V),this.fileOperationResult=re,this.size=fe}}e.$0k=L;class K extends P{constructor(pe,re,fe){super(pe,2,fe),this.stat=re}}e.$$k=K;var ne;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var le;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$gl="";function ye(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function Se(ee,pe){if(!pe.hasProvider(R.URI.from({scheme:ee.scheme})))return new Promise(re=>{const fe=pe.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ee.scheme&&V.added&&(fe.dispose(),re())})})}class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize(pe){return(0,N.$Yf)(pe)||(pe=0),pe<he.KB?(0,m.localize)(1,null,pe.toFixed(0)):pe<he.MB?(0,m.localize)(2,null,(pe/he.KB).toFixed(2)):pe<he.GB?(0,m.localize)(3,null,(pe/he.MB).toFixed(2)):pe<he.TB?(0,m.localize)(4,null,(pe/he.GB).toFixed(2)):(0,m.localize)(5,null,(pe/he.TB).toFixed(2))}}e.$jl=he;function be(ee){const pe=typeof ee=="string"||ee?.scheme===O.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===O.Schemas.file?1024*he.MB:pe?10*he.MB:k.$o?50*he.MB:1024*he.MB}}),define(Pe[71],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class I{constructor(...M){this.a=new Map;for(const[N,R]of M)this.set(N,R)}set(M,N){const R=this.a.get(M);return this.a.set(M,N),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$fi=I}),define(Pe[190],Me([1,0,11,14,6,70,188,3,71,191]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=void 0;const O=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new d.$fi,s=!1,n,i=O){this.f=o,this.g=s,this.h=n,this.i=i,this.o=new Set,this.f.set(m.$gi,this),this._globalGraph=i?n?._globalGraph??new R.$Wq(a=>a):void 0}createChild(o){return new u(o,this.g,this,this.i)}invokeFunction(o,...s){const n=f.traceInvocation(this.i,o);let i=!1;try{return o({get:h=>{if(i)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(o,...s){let n,i;return o instanceof N.$ei?(n=f.traceCreation(this.i,o.ctor),i=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=f.traceCreation(this.i,o),i=this.j(o,s,n)),n.stop(),i}j(o,s=[],n){const i=m._util.getServiceDependencies(o).sort((t,v)=>t.index-v.index),a=[];for(const t of i){const v=this.m(t.id,n);v||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(v)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}k(o,s){if(this.f.get(o)instanceof N.$ei)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof N.$ei?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const i=new R.$Wq(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new E(i);for(const v of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(v.id);if(c||this.u(`[createInstance] ${o} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(v.id)),c instanceof N.$ei){const $={id:v.id,desc:c,_trace:t._trace.branch(v.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:v}of t){if(this.l(v.id)instanceof N.$ei){const $=this.s(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.k(v.id,$)}i.removeNode(v)}}return this.l(o)}s(o,s,n=[],i,a){if(this.f.get(o)instanceof N.$ei)return this.t(o,s,n,i,a);if(this.h)return this.h.s(o,s,n,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],i,a){if(i){const h=new u(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,v=new I.$Ah(()=>{const c=h.j(s,n,a);for(const[$,w]of t){const p=c[$];if(typeof p=="function")for(const l of w)l.disposable=p.apply(c,l.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,$){if(!v.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let l=t.get($);return l||(l=new k.$5c,t.set($,l)),(g,S,y)=>{if(v.isInitialized)return v.value[$](g,S,y);{const C={listener:[g,S,y],disposable:void 0},A=l.push(C);return(0,M.$Sc)(()=>{A(),C.disposable?.dispose()})}}}if($ in c)return c[$];const w=v.value;let p=w[$];return typeof p!="function"||(p=p.bind(w),c[$]=p),p},set(c,$,w){return v.value[$]=w,!0},getPrototypeOf(c){return s.prototype}})}else return this.j(s,n,a)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$Xq=u;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new f(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,s){return o?new f(1,s.name):f.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new f(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;f.f+=o;let s=!1;function n(a,h){const t=[],v=new Array(a+1).join("	");for(const[c,$,w]of h.h)if($&&w){s=!0,t.push(`${v}CREATES -> ${c}`);const p=n(a+1,w);p&&t.push(p)}else t.push(`${v}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||s)&&f.all.add(i.join(`
`))}}e.$Yq=f}),define(Pe[13],Me([1,0,158,42,5,99,6,28,21,24,16,2,33,3]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=r,e.log=s,e.$2j=l,e.$3j=D,e.$4j=g,e.$5j=S,e.$Nj=(0,b.$hi)("logService"),e.$Oj=(0,b.$hi)("loggerService");function f(){return new Date().toISOString()}function r(y){return(0,O.$Yf)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Qj=o.Info;function s(y,C,A){switch(C){case o.Trace:y.trace(A);break;case o.Debug:y.debug(A);break;case o.Info:y.info(A);break;case o.Warning:y.warn(A);break;case o.Error:y.error(A);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let A="";for(let G=0;G<y.length;G++){let T=y[G];if(T instanceof Error&&(T=(0,F.$5i)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}A+=(G>0?" ":"")+T}return A}class i extends R.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new M.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$Sj=i;class a extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...A){this.f(o.Trace)&&this.g(o.Trace,n([C,...A],!0))}debug(C,...A){this.f(o.Debug)&&this.g(o.Debug,n([C,...A]))}info(C,...A){this.f(o.Info)&&this.g(o.Info,n([C,...A]))}warn(C,...A){this.f(o.Warning)&&this.g(o.Warning,n([C,...A]))}error(C,...A){if(this.f(o.Error))if(C instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=C.stack,this.g(o.Error,n(G))}else this.g(o.Error,n([C,...A]))}flush(){}}e.$Tj=a;class h extends i{constructor(C=e.$Qj){super(),this.setLevel(C),this.g=!d.$i}trace(C,...A){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...A):console.log(`[main ${f()}]`,C,...A))}debug(C,...A){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...A):console.log(`[main ${f()}]`,C,...A))}info(C,...A){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...A):console.log(`[main ${f()}]`,C,...A))}warn(C,...A){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,C,...A):console.warn(`[main ${f()}]`,C,...A))}error(C,...A){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,C,...A):console.error(`[main ${f()}]`,C,...A))}flush(){}}e.$Uj=h;class t extends i{constructor(C=e.$Qj,A=!0){super(),this.g=A,this.setLevel(C)}trace(C,...A){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...A):console.log(C,...A))}debug(C,...A){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...A):console.log(C,...A))}info(C,...A){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...A):console.log(C,...A))}warn(C,...A){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...A):console.log(C,...A))}error(C,...A){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...A):console.error(C,...A))}flush(){}}e.$Vj=t;class v extends i{constructor(C,A=e.$Qj){super(),this.g=C,this.setLevel(A)}trace(C,...A){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...A])}debug(C,...A){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...A])}info(C,...A){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...A])}warn(C,...A){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...A])}error(C,...A){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...A])}h(C){return typeof C=="string"?C:(0,F.$5i)(C,this.f(o.Trace))}flush(){}}e.$Wj=v;class c extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const A of this.g)A.setLevel(C);super.setLevel(C)}trace(C,...A){for(const G of this.g)G.trace(C,...A)}debug(C,...A){for(const G of this.g)G.debug(C,...A)}info(C,...A){for(const G of this.g)G.info(C,...A)}warn(C,...A){for(const G of this.g)G.warn(C,...A)}error(C,...A){for(const G of this.g)G.error(C,...A)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$Xj=c;class $ extends R.$Uc{constructor(C,A,G){if(super(),this.h=C,this.j=A,this.b=new m.$Bc,this.c=this.B(new M.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$7d),this.onDidChangeVisibility=this.g.event,G)for(const T of G)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,O.$Uf)(C)?[...this.b.values()].find(A=>A.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,A){const G=this.n(C),T=(0,O.$Uf)(C)?C:A?.id??(0,N.$8i)(G.toString()).toString(16);let W=this.b.get(G)?.logger;const P=A?.logLevel==="always"?o.Trace:A?.logLevel;W||(W=this.s(G,P??this.getLogLevel(G)??this.h,{...A,id:T}));const L={logger:W,info:{resource:G,id:T,logLevel:P,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(L.info),this.b.set(G,L),W}n(C){return(0,O.$Uf)(C)?(0,k.$Ug)(this.j,`${C}.log`):C}setLogLevel(C,A){if(E.URI.isUri(C)){const G=C,T=A,W=this.b.get(G);W&&T!==W.info.logLevel&&(W.info.logLevel=T===this.h?void 0:T,W.logger?.setLevel(T),this.b.set(W.info.resource,W),this.f.fire([G,T]))}else{this.h=C;for(const[G,T]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,A){const G=this.m(C);G&&A!==!G.info.hidden&&(G.info.hidden=!A,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,A]))}getLogLevel(C){let A;return C&&(A=this.b.get(C)?.info.logLevel),A??this.h}registerLogger(C){const A=this.b.get(C.resource);A?A.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const A=this.b.get(C);A&&(A.logger&&A.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=$;class w{constructor(){this.onDidChangeLogLevel=new M.$7d().event}setLevel(C){}getLevel(){return o.Info}trace(C,...A){}debug(C,...A){}info(C,...A){}warn(C,...A){}error(C,...A){}critical(C,...A){}dispose(){}flush(){}}e.$Zj=w;class p extends w{}e.$1j=p;function l(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=S(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Qj}function D(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$6j=new u.$yj("logLevel",D(o.Info))}),define(Pe[192],Me([1,0,6,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;class M extends I.$Uc{constructor(R,m=[]){super(),this.a=new F.$Xj([R,...m]),this.B(R.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$1P=M}),define(Pe[100],Me([1,0,32,159,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(d){function k(f,r){return r-f}d.compare=k;const O=Object.create(null);O[d.Error]=(0,F.localize)(0,null),O[d.Warning]=(0,F.localize)(1,null),O[d.Info]=(0,F.localize)(2,null);function E(f){return O[f]||""}d.toString=E;function u(f){switch(f){case I.default.Error:return d.Error;case I.default.Warning:return d.Warning;case I.default.Info:return d.Info;case I.default.Ignore:return d.Hint}}d.fromSeverity=u;function b(f){switch(f){case d.Error:return I.default.Error;case d.Warning:return I.default.Warning;case d.Info:return I.default.Info;case d.Hint:return I.default.Ignore}}d.toSeverity=b}(R||(e.MarkerSeverity=R={}));var m;(function(d){const k="";function O(u){return E(u,!0)}d.makeKey=O;function E(u,b){const f=[k];return u.source?f.push(u.source.replace("\xA6","\\\xA6")):f.push(k),u.code?typeof u.code=="string"?f.push(u.code.replace("\xA6","\\\xA6")):f.push(u.code.value.replace("\xA6","\\\xA6")):f.push(k),u.severity!==void 0&&u.severity!==null?f.push(R.toString(u.severity)):f.push(k),u.message&&b?f.push(u.message.replace("\xA6","\\\xA6")):f.push(k),u.startLineNumber!==void 0&&u.startLineNumber!==null?f.push(u.startLineNumber.toString()):f.push(k),u.startColumn!==void 0&&u.startColumn!==null?f.push(u.startColumn.toString()):f.push(k),u.endLineNumber!==void 0&&u.endLineNumber!==null?f.push(u.endLineNumber.toString()):f.push(k),u.endColumn!==void 0&&u.endColumn!==null?f.push(u.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}d.makeKeyOptionalMessage=E})(m||(e.IMarkerData=m={})),e.$Tt=(0,M.$hi)("markerService")}),define(Pe[193],Me([1,0,5,32,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nv=e.$Mv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Kv=e.Severity=void 0,e.$Lv=m,e.Severity=F.default,e.$Kv=(0,M.$hi)("notificationService");var N;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var d;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class k{constructor(){this.progress=new O,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Mv=k;class O{infinite(){}done(){}total(u){}worked(u){}}e.$Nv=O}),define(Pe[194],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,I.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(me,e,I,F){var M=arguments.length,N=M<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(me,e,I,F);else for(var m=me.length-1;m>=0;m--)(R=me[m])&&(N=(M<3?R(N):M>3?R(e,I,N):R(e,I))||N);return M>3&&N&&Object.defineProperty(e,I,N),N},qe=this&&this.__param||function(me,e){return function(I,F){e(I,F,me)}};define(Pe[101],Me([1,0,11,25,6,3]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.ProgressLocation=e.$Ov=void 0,e.$Ov=(0,N.$hi)("progressService");var R;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Pv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Qv=m;class d{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$Rv=d;let k=class extends M.$Uc{constructor(u,b){super(),this.a=new I.$Eh,b.withProgress(u,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Sv=k,e.$Sv=k=Je([qe(1,e.$Ov)],k);class O extends M.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new M.$Tc)}start(u){this.stop();const b=++this.a,f=new F.$ee;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>f.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:f.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Tv=O,e.$Uv=(0,N.$hi)("editorProgressService")}),define(Pe[30],Me([1,0,55,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class M{constructor(){this.a=new Map}add(R,m){I.ok(F.$Uf(R)),I.ok(F.$Wf(m)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Zn=new M}),define(Pe[72],Me([1,0,5,30]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function M(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this.b=new I.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,k){this.a[M(d)]=k,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const R=new N;F.$Zn.add(e.$1n.JSONContribution,R)}),define(Pe[56],Me([1,0,18,5,16,152,47,72,30]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=r,e.$eo=o,e.$fo=s,e.$go=i,e.$ho=a;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$5n={Configuration:"base.contributions.configuration"};var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const E=d.$Zn.as(m.$1n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new F.$7d,this.onDidSchemaChange=this.i.event,this.j=new F.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(t,v=!0){this.registerConfigurations([t],v)}registerConfigurations(t,v=!0){const c=new Set;this.n(t,v,c),E.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const v=new Set;this.o(t,v),E.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:t,remove:v}){const c=new Set;this.o(v,c),this.n(t,!1,c),E.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const v=new Set;this.k(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(t,v){const c=[];for(const{overrides:$,source:w}of t)for(const p in $)if(v.add(p),e.$co.test(p)){const l=this.a.get(p),D=l?.valuesSources??new Map;if(w)for(const C of Object.keys($[p]))D.set(C,w);const g={...l?.value||{},...$[p]};this.a.set(p,{source:w,value:g,valuesSources:D});const S=(0,R.$Xi)(p),y={type:"object",default:g,description:N.localize(1,null,S),$ref:e.$_n,defaultDefaultValue:g,source:M.$Uf(w)?void 0:w,defaultValueSource:w};c.push(...r(p)),this.d[p]=y,this.b.properties[p]=y}else{this.a.set(p,{value:$[p],source:w});const l=this.d[p];l&&(this.w(p,l),this.r(p,l))}this.m(c)}deregisterDefaultConfigurations(t){const v=new Set;this.l(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(t,v){for(const{overrides:c,source:$}of t)for(const w in c){const p=this.a.get(w),l=M.$Uf($)?$:$?.id,D=M.$Uf(p?.source)?p?.source:p?.source?.id;if(l===D)if(v.add(w),this.a.delete(w),e.$co.test(w))delete this.d[w],delete this.b.properties[w];else{const g=this.d[w];g&&(this.w(w,g),this.r(w,g))}}this.u()}deltaConfiguration(t){let v=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),v=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),v=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const v of t)this.h.add(v);this.u()}n(t,v,c){t.forEach($=>{this.p($,v,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,v){const c=$=>{if($.properties)for(const w in $.properties){v.add(w);const p=this.d[w];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[w],this.s(w,$.properties[w])}$.allOf?.forEach(w=>c(w))};for(const $ of t){c($);const w=this.c.indexOf($);w!==-1&&this.c.splice(w,1)}}p(t,v=!0,c,$,w=3,p){w=M.$4f(t.scope)?w:t.scope;const l=t.properties;if(l)for(const g in l){const S=l[g];if(v&&i(g,S)){delete l[g];continue}if(S.source=c,S.defaultDefaultValue=l[g].default,this.w(g,S),e.$co.test(g)?S.scope=void 0:(S.scope=M.$4f(S.scope)?w:S.scope,S.restricted=M.$4f(S.restricted)?!!$?.includes(g):S.restricted),l[g].hasOwnProperty("included")&&!l[g].included){this.f[g]=l[g],delete l[g];continue}else this.d[g]=l[g],l[g].policy?.name&&this.e.set(l[g].policy.name,g);!l[g].deprecationMessage&&l[g].markdownDeprecationMessage&&(l[g].deprecationMessage=l[g].markdownDeprecationMessage),p.add(g)}const D=t.allOf;if(D)for(const g of D)this.p(g,v,c,$,w,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const v=c=>{const $=c.properties;if($)for(const p in $)this.r(p,$[p]);c.allOf?.forEach(v)};v(t)}r(t,v){switch(e.$6n.properties[t]=v,v.scope){case 1:e.$7n.properties[t]=v;break;case 2:e.$8n.properties[t]=v;break;case 6:e.$9n.properties[t]=v;break;case 3:e.$0n.properties[t]=v;break;case 4:e.$$n.properties[t]=v;break;case 5:e.$$n.properties[t]=v,this.g.properties[t]=v;break}}s(t,v){switch(delete e.$6n.properties[t],v.scope){case 1:delete e.$7n.properties[t];break;case 2:delete e.$8n.properties[t];break;case 6:delete e.$9n.properties[t];break;case 3:delete e.$0n.properties[t];break;case 4:case 5:delete e.$$n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const v=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$_n};this.w(v,c),e.$6n.properties[v]=c,e.$7n.properties[v]=c,e.$8n.properties[v]=c,e.$9n.properties[v]=c,e.$0n.properties[v]=c,e.$$n.properties[v]=c}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=t,e.$7n.patternProperties[e.$bo]=t,e.$8n.patternProperties[e.$bo]=t,e.$9n.patternProperties[e.$bo]=t,e.$0n.patternProperties[e.$bo]=t,e.$$n.patternProperties[e.$bo]=t,this.i.fire()}w(t,v){const c=this.a.get(t);let $=c?.value,w=c?.source;M.$2f($)&&($=v.defaultDefaultValue,w=void 0),M.$2f($)&&($=s(v.type)),v.default=$,v.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.$bo=`^(${b})+$`,e.$co=new RegExp(e.$bo);function r(h){const t=[];if(e.$co.test(h)){let v=f.exec(h);for(;v?.length;){const c=v[1].trim();c&&t.push(c),v=f.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,v)=>`${t}[${v}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;d.$Zn.add(e.$5n.Configuration,n);function i(h,t){return h.trim()?e.$co.test(h)?N.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function a(){const h=[],t=n.getConfigurationProperties();for(const v of Object.keys(t))h.push([v,t[v].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Pe[195],Me([1,0,18,5,122,6,28,26,16,2,47,56,30]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=i;function b(v){return Object.isFrozen(v)?v:m.$On(v)}class f{constructor(c={},$=[],w=[],p){this.b=c,this.c=$,this.d=w,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof f)return $;const w=new r("");return w.parseRaw($),w.configurationModel});this.f=c.reduce(($,w)=>w===$?w:$.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,O.$Vi)(this.contents,c):this.contents}inspect(c,$){const w=this;return{get value(){return b(w.rawConfiguration.getValue(c))},get override(){return $?b(w.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return b($?w.rawConfiguration.override($).getValue(c):w.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:l,identifiers:D,keys:g}of w.rawConfiguration.overrides){const S=new f(l,g).getValue(c);S!==void 0&&p.push({identifiers:D,value:S})}return p.length?b(p):void 0}}}getOverrideValue(c,$){const w=this.i($);return w?c?(0,O.$Vi)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const w of this.overrides)w.identifiers.includes(c)&&$.push(...w.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=m.$Nn(this.contents),w=m.$Nn(this.overrides),p=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const g of D.overrides){const[S]=w.filter(y=>I.$ub(y.identifiers,g.identifiers));S?(this.h(S.contents,g.contents),S.keys.push(...g.keys),S.keys=I.$Mb(S.keys)):w.push(m.$Nn(g))}for(const g of D.keys)p.indexOf(g)===-1&&p.push(g)}return new f($,p,w,l.every(D=>D instanceof f)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const w={};for(const p of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[p];const D=$[p];D&&(typeof l=="object"&&typeof D=="object"?(l=m.$Nn(l),this.h(l,D)):l=D),w[p]=l}return new f(w,this.keys,this.overrides)}h(c,$){for(const w of Object.keys($)){if(w in c&&d.$Wf(c[w])&&d.$Wf($[w])){this.h(c[w],$[w]);continue}c[w]=m.$Nn($[w])}}i(c){let $=null,w=null;const p=l=>{l&&(w?this.h(w,l):w=m.$Nn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&p(l.contents);return p($),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,O.$Ui)(this.contents,c),E.$co.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>I.$ub(w.identifiers,(0,E.$do)(c))),1))}j(c,$,w){(0,O.$Ti)(this.contents,c,$,p=>console.error(p)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),E.$co.test(c)&&this.overrides.push({identifiers:(0,E.$do)(c),keys:Object.keys(this.contents[c]),contents:(0,O.$Si)(this.contents[c],p=>console.error(p))})}}e.$io=f;class r{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!d.$4f(c)){const w=this.g(c);this.parseRaw(w,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:w,keys:p,overrides:l,restricted:D,hasExcludedProperties:g}=this.h(c,$);this.b=new f(w,p,l,g?[c]:void 0),this.c=D||[]}g(c){let $={},w=null,p=[];const l=[],D=[];function g(y){Array.isArray(p)?p.push(y):w!==null&&(p[w]=y)}const S={onObjectBegin:()=>{const y={};g(y),l.push(p),p=y,w=null},onObjectProperty:y=>{w=y},onObjectEnd:()=>{p=l.pop()},onArrayBegin:()=>{const y=[];g(y),l.push(p),p=y,w=null},onArrayEnd:()=>{p=l.pop()},onLiteralValue:g,onError:(y,C,A)=>{D.push({error:y,offset:C,length:A})}};if(c)try{M.$Bn(c,S),$=p[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}h(c,$){const w=u.$Zn.as(E.$5n.Configuration).getConfigurationProperties(),p=this.i(c,w,!0,$);c=p.raw;const l=(0,O.$Si)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),g=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:g,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,$,w,p){let l=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},g=[];for(const S in c)if(E.$co.test(S)&&w){const y=this.i(c[S],$,!1,p);D[S]=y.raw,l=l||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=$[S],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(S),!p.exclude?.includes(S)&&(p.include?.includes(S)||(C===void 0||p.scopes===void 0||p.scopes.includes(C))&&!(p.skipRestricted&&y?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:g,hasExcludedProperties:l}}j(c,$){const w=[];for(const p of Object.keys(c))if(E.$co.test(p)){const l={};for(const D in c[p])l[D]=c[p][D];w.push({identifiers:(0,E.$do)(p),keys:Object.keys(l),contents:(0,O.$Si)(l,$)})}return w}}e.$jo=r;class o extends N.$Uc{constructor(c,$,w,p){super(),this.c=c,this.f=$,this.g=p,this.b=this.B(new F.$7d),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&w.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new f}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=o;class s{constructor(c,$,w,p,l,D,g,S,y,C,A,G,T){this.a=c,this.b=$,this.c=w,this.overrideIdentifiers=p,this.d=l,this.f=D,this.g=g,this.h=S,this.i=y,this.j=C,this.k=A,this.l=G,this.m=T}get value(){return b(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(c,$,w,p,l=new f,D=new f,g=new R.$Bc,S=new f,y=new R.$Bc){this.c=c,this.d=$,this.f=w,this.g=p,this.h=l,this.i=D,this.j=g,this.l=S,this.m=y,this.a=null,this.b=new R.$Bc,this.n=null}getValue(c,$,w){return this.p(c,$,w).getValue(c)}updateValue(c,$,w={}){let p;w.resource?(p=this.m.get(w.resource),p||(p=new f,this.m.set(w.resource,p))):p=this.l,$===void 0?p.removeValue(c):p.setValue(c,$),w.resource||(this.a=null)}inspect(c,$,w){const p=this.p(c,$,w),l=this.t($.resource,w),D=$.resource?this.m.get($.resource)||this.l:this.l,g=new Set;for(const S of p.overrides)for(const y of S.identifiers)p.getOverrideValue(c,y)!==void 0&&g.add(y);return new s(c,$,p.getValue(c),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const w=[];if(!$){const{added:p,updated:l,removed:D}=h(this.c,c);$=[...p,...l,...D]}for(const p of $)for(const l of(0,E.$do)(p)){const D=this.c.getKeysForOverrideIdentifier(l),g=c.getKeysForOverrideIdentifier(l),S=[...g.filter(y=>D.indexOf(y)===-1),...D.filter(y=>g.indexOf(y)===-1),...D.filter(y=>!m.$Rn(this.c.override(l).getValue(y),c.override(l).getValue(y)))];w.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:w,removed:p}=h(this.d,c),l=[...$,...w,...p];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const w=this.folderConfigurations.get(c),{added:p,updated:l,removed:D,overrides:g}=h(w,$),S=[...p,...l,...D];return(S.length||!w)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:g}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:p,removed:l,overrides:D}=h($,void 0);return{keys:[...w,...p,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,w){let p=this.q($,w);return $.overrideIdentifier&&(p=p.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},$){let w=this.r();if($&&c){const p=$.getFolder(c);p&&(w=this.s(p.uri)||w);const l=this.m.get(c);l&&(w=w.merge(l))}return w}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const w=this.r(),p=this.j.get(c);p?($=w.merge(p),this.b.set(c,$)):$=w}return $}t(c,$){if($&&c){const w=$.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:w,overrides:p,keys:l}=this.j.get($);return c.push([$,{contents:w,overrides:p,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(w=>c.add(w))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(p=>$.add(p))),[...$.values()]}static parse(c){const $=this.w(c.defaults),w=this.w(c.policy),p=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),g=c.folders.reduce((S,y)=>(S.set(k.URI.revive(y[0]),this.w(y[1])),S),new R.$Bc);return new n($,w,p,l,new f,D,g,new f,new R.$Bc)}static w(c){return new f(c.contents,c.keys,c.overrides)}}e.$lo=n;function i(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const c=new Set,$=new Map;for(const p of v)p.keys.forEach(l=>c.add(l)),p.overrides.forEach(([l,D])=>{const g=(0,R.$yc)($,l,new Set);D.forEach(S=>g.add(S))});const w=[];return $.forEach((p,l)=>w.push([l,[...p.values()]])),{keys:[...c.values()],overrides:w}}class a{constructor(c,$,w,p){this.change=c,this.f=$,this.g=w,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,$){const w=this.a+c,p=this.d.indexOf(w);if(p<0)return!1;const l=p+w.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!m.$Rn(g,S)}return!0}}e.$no=a;function h(v,c){const{added:$,removed:w,updated:p}=t(c?.rawConfiguration,v?.rawConfiguration),l=[],D=v?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const S=g.filter(y=>!D.includes(y));for(const y of S)l.push([y,c.getKeysForOverrideIdentifier(y)])}if(v){const S=D.filter(y=>!g.includes(y));for(const y of S)l.push([y,v.getKeysForOverrideIdentifier(y)])}if(c&&v){for(const S of D)if(g.includes(S)){const y=t({contents:v.getOverrideValue(void 0,S)||{},keys:v.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:w,updated:p,overrides:l}}function t(v,c){const $=v?c?v.keys.filter(l=>c.keys.indexOf(l)===-1):[...v.keys]:[],w=c?v?c.keys.filter(l=>v.keys.indexOf(l)===-1):[...c.keys]:[],p=[];if(v&&c){for(const l of c.keys)if(v.keys.indexOf(l)!==-1){const D=(0,O.$Vi)(c.contents,l),g=(0,O.$Vi)(v.contents,l);m.$Rn(D,g)||p.push(l)}}return{added:$,removed:w,updated:p}}}),define(Pe[102],Me([1,0,14,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=k,e.$sl=(0,F.$hi)("remoteAuthorityResolverService");var M;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class N{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=N;class R{constructor(E,u){this.host=E,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=R;var m;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound",O.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class d extends I.$bb{static isNotAvailable(E){return E instanceof d&&E._code===m.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof d&&E._code===m.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof d&&E._code===m.NoResolverFound}static isInvalidAuthority(E){return E instanceof d&&E._code===m.InvalidAuthority}static isHandled(E){return E instanceof d&&E.isHandled}constructor(E,u=m.Unknown,b){super(E),this._message=E,this._code=u,this._detail=b,this.isHandled=u===m.NotAvailable&&b===!0,Object.setPrototypeOf(this,d.prototype)}}e.$vl=d;function k(O){const E=O.indexOf("+");return E===-1?O:O.substring(0,E)}}),define(Pe[57],Me([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=F,e.$tm=M,e.$um=N,e.$vm=R;function F(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}function M(d){if(!d)return;const k=d.indexOf("+");return k<0?d:d.substr(0,k)}function N(d){const{host:k,port:O}=m(d);if(typeof O>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:O}}function R(d,k){let{host:O,port:E}=m(d);return typeof E>"u"&&(E=k),{host:O,port:E}}function m(d){const k=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const O=d.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const E=d.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:d,port:void 0}}}),define(Pe[20],Me([1,0,15,3,57]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=N,e.$Fm=E,e.$Gm=u,e.$Hm=b,e.$Im=f,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class d{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$lf(n,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Cm=d;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(d.toKey(o))}delete(o){return this.c.delete(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}}e.$Dm=k;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(d.toKey(o))}get(o){return this.c.get(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}set(o,s){this.c.set(d.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=O;function E(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function f(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,M.$tm)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Jm=(0,F.$hi)("IBuiltinExtensionsScannerService")}),define(Pe[103],Me([1,0,14,20]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const d of R){const k=this.readActivationEvents(d);k.length>0&&(m[F.$Cm.toKey(d.identifier)]=k)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let d=0;d<m.length;d++)m[d]==="onUri"&&(m[d]=`onUri:${F.$Cm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const d in R.contributes){const k=this.a.get(d);if(!k)continue;const O=R.contributes[d],E=Array.isArray(O)?O:[O];try{k(E,m)}catch(u){(0,I.$1)(u)}}return m}}e.$KF=M,e.$LF=new M}),define(Pe[196],Me([1,0,21,73,34]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=R,e.$2o=m;function N(d){if(I.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function R(d,k,O,E,u,b,f,r,o){const s=Object.create(null);s["common.machineId"]=b,s["common.sqmId"]=f,s.sessionID=(0,M.$Dg)()+Date.now(),s.commitHash=E,s.version=u,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=F.$ec,s["common.nodeArch"]=O,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=N(k);return a&&(s["common.platformDetail"]=a),s}function m(d){const k=F.env.USERDNSDOMAIN;if(!k)return!1;const O=k.toLowerCase();return d.some(E=>O===E)}}),define(Pe[197],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,I.$hi)("telemetryService"),e.$Nl=(0,I.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var F;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var M;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Pe[58],Me([1,0,26,16,57,196,197]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=O,e.$$o=E,e.$_o=u,e.$ap=b,e.$bp=r,e.$cp=s,e.$dp=n,e.$ep=h;class m{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$3o=m;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=d,e.$5o=new d;class k{async publicLog(v,c,$){}async publicLogError(v,c,$){}}e.$6o=k,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function O(t,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!t.enableTelemetry)}function E(t,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const v=t.getValue(R.$Ul),c=t.getValue(R.$Vl);if(t.getValue(R.$Wl)===!1||c===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const v={},c={},$={};o(t,$);for(let w in $){w=w.length>150?w.substr(w.length-149):w;const p=$[w];typeof p=="number"?c[w]=p:typeof p=="boolean"?c[w]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${p.length}`),v[w]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(v[w]=p)}return{properties:v,measurements:c}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const v=(0,M.$tm)(t);return f.has(v)?v:"other"}function o(t,v,c=0,$){if(t)for(const w of Object.getOwnPropertyNames(t)){const p=t[w],l=$?$+w:w;Array.isArray(p)?v[l]=(0,I.$Sn)(p):p instanceof Date?v[l]=p.toISOString():(0,F.$Wf)(p)?c<2?o(p,v,c+1,l+"."):v[l]=(0,I.$Sn)(p):v[l]=p}}function s(t,v){const c=t.msftInternalDomains||[],$=v.getValue("telemetry.internalTesting");return(0,N.$2o)(c)||$}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,v){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of v)for(;;){const g=D.exec(t);if(!g)break;$.push([g.index,D.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=p.exec(t);if(!D)break;const g=$.some(([S,y])=>D.index<y&&S<p.lastIndex);!w.test(D[0])&&!g&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of v)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,v){return(0,I.$Pn)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,v);for(const w of v)$=$.replace(w,"");return $=a($),$}})}}),define(Pe[198],Me([1,0,15,98,20,21,2,14,73,58]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=O,e.$hp=f,e.$ip=r,e.$jp=o,e.$kp=s,e.$lp=n,e.$mp=i,e.$np=a,e.$pp=h,e.$qp=v;function O(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$gf)(c.id,$.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const w=$.manifest?$.manifest.version:$.version,p=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,w,p)}static parse($){const w=E.exec($);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor($,w,p="undefined"){this.version=w,this.targetPlatform=p,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?O(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$gp=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(c){const $=b.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function r(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(r(c??M.$ym,$))}function n(c,$){const w=[],p=l=>{for(const D of w)if(D.some(g=>O($(g),$(l))))return D;return null};for(const l of c){const D=p(l);D?D.push(l):w.push([l])}return w}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new k.$3o(c.identifier.id),name:new k.$3o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$op=new M.$Cm("pprice.better-merge");function h(c,$){const w=[],p=$.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const l=p.shift();if(l&&w.every(D=>!O(D.identifier,{id:l}))){const D=c.filter(g=>O(g.identifier,{id:l}));D.length===1&&(w.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(c,$){if(!N.$k)return!1;let w;try{w=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,m.$0)(l))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(c,$){const w=await t(c,$),p=(0,F.$Mo)(w?"alpine":N.$u,d.$fc);return $.debug("ComputeTargetPlatform:",p),p}}),define(Pe[199],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=I,e.$7r=F,e.$8r=M,e.$9r=N,e.$0r=R,e.$$r=m;function I(d){return[...d.entries()]}function F(d){return d?[...d.entries()]:[]}function M(d){return new Map(d)}function N(d){return new Map(d??[])}function R(d){return Array.from(d.entries()).map(k=>[k[0],I(k[1].map),F(k[1].descriptionMap)])}function m(d){return new Map(d.map(k=>[k[0],{map:M(k[1]),descriptionMap:N(k[2])}]))}}),define(Pe[200],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hub=void 0;class I{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,N,R=5){const m=N(d=>{const k=typeof d=="string"?d:d.data;let O=this.a.get(M);if(O){O.data.push(k);return}const E=setTimeout(()=>this.flushBuffer(M),R);O={data:[k],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(M),m.dispose()}},this.a.set(M,O)});return m}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const N=this.a.get(M);N&&(this.a.delete(M),this.b(M,N.data.join("")))}}e.$hub=I}),define(Pe[201],Me([1,0,11,91,302,41,5,16,2,160,72,30]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.$Vw=e.IconFontDefinition=e.IconContribution=e.$Sw=void 0,e.$Tw=o,e.$Uw=s,e.$Sw={IconContribution:"base.contributions.icons"};var u;(function(h){function t(v,c){let $=v.defaults;for(;N.ThemeIcon.isThemeIcon($);){const w=r.getIcon($.id);if(!w)return;$=w.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var b;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function v(c){const $=w=>(0,m.$Uf)(w)?w:void 0;if(c&&Array.isArray(c.src)&&c.src.every(w=>(0,m.$Uf)(w.format)&&(0,m.$Uf)(w.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(w=>({format:w.format,location:d.URI.parse(w.location)}))}}h.fromJSONObject=v})(b||(e.IconFontDefinition=b={}));class f{constructor(){this.a=new R.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,v,c,$){const w=this.b[t];if(w){if(c&&!w.description){w.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return w}const p={id:t,description:c,defaults:v,deprecationMessage:$};this.b[t]=p;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enum.splice(v,1),this.e.enumDescriptions.splice(v,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,v){const c=this.f[t];return c||(this.f[t]=v,this.a.fire(),v)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,p)=>w.id.localeCompare(p.id),v=w=>{for(;N.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(w=>this.b[w]);for(const w of $.filter(p=>!!p.description).sort(t))c.push(`|<i class="${v(w)}"></i>|${w.id}|${N.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const w of $.filter(p=>!N.ThemeIcon.isThemeIcon(p.defaults)).sort(t))c.push(`|<i class="${v(w)}"></i>|${w.id}|`);return c.join(`
`)}}const r=new f;E.$Zn.add(e.$Sw.IconContribution,r);function o(h,t,v,c){return r.registerIcon(h,t,v,c)}function s(){return r}function n(){const h=(0,M.$Cj)();for(const t in h){const v="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:v})}}n(),e.$Vw="vscode://schemas/icons";const i=E.$Zn.as(O.$1n.JSONContribution);i.registerSchema(e.$Vw,r.getIconSchema());const a=new I.$th(()=>i.notifySchemaChanged(e.$Vw),200);r.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$Ww=o("widget-close",F.$Gj.close,(0,k.localize)(2,null)),e.$Xw=o("goto-previous-location",F.$Gj.arrowUp,(0,k.localize)(3,null)),e.$Yw=o("goto-next-location",F.$Gj.arrowDown,(0,k.localize)(4,null)),e.$Zw=N.ThemeIcon.modify(F.$Gj.sync,"spin"),e.$1w=N.ThemeIcon.modify(F.$Gj.loading,"spin")}),define(Pe[202],Me([1,0,5,2,47,3,13]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$3v=e.$1v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wv=e.$Vv=void 0,e.$Xv=k,e.$Yv=E,e.$Zv=u,e.$2v=b,e.$4v=f,e.$5v=r,e.$Vv=(0,N.$hi)("tunnelService"),e.$Wv=(0,N.$hi)("sharedTunnelsService");var m;(function(n){n.Http="http",n.Https="https"})(m||(e.TunnelProtocol=m={}));var d;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(d||(e.TunnelPrivacyId=d={}));function k(n){return!!n.forwardPort}var O;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(O||(e.ProvidedOnAutoForward=O={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=E(F.URI.parse(h));if(t)return t}}}e.$1v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(n){return e.$1v.indexOf(n)>=0}e.$3v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$3v.indexOf(n)>=0}function r(n,i,a,h){if(a===1)return!1;if(a===2&&f(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6v=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$7d,this.onTunnelOpened=this.a.event,this.b=new I.$7d,this.onTunnelClosed=this.b.event,this.c=new I.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const v of t){const c=await v.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,v){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(f(i)||b(i))&&(i=e.$1v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,v,c=!1,$,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${v}.`);const p=this.f??i;if(!p)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(p,a,h,t,v,c,$,w);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),v=t?await t.value:void 0;(!v||typeof v=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];b(i)?(h.push(...e.$1v),h.push(...e.$3v)):f(i)&&h.push(...e.$3v);const t=h.map(v=>this.e.get(v));for(const v of t){const c=v?.get(a);if(c)return c}}canTunnel(i){return!!E(i)}u(i,a,h,t,v,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const w=h;this.j.add(w);const p=t===void 0?h:t,l={elevationRequired:v?this.isPortPrivileged(p):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==d.Private:void 0,protocol:$},g=i.forwardPort(D,l);return g?(this.q(a,h,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),g}};e.$7v=s,e.$7v=s=Je([qe(0,R.$Nj),qe(1,M.$Ni)],s)}),define(Pe[203],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$8v=void 0,e.$8v=(0,I.$hi)("editSessionIdentityService");var F;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Pe[204],Me([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=F,e.$SL=M,e.$TL=N,e.$UL=R,e.$VL=m;function F(d){return d.scheme!==I.Schemas.file&&d.scheme!==I.Schemas.vscodeRemote}function M(d){if(d.folders.length)return d.folders.every(k=>F(k.uri))?d.folders[0].uri:void 0;if(d.configuration&&F(d.configuration))return d.configuration}function N(d){return M(d)?.scheme}function R(d){return M(d)?.authority}function m(d){return M(d)!==void 0}}),define(Pe[48],Me([1,0,161,19,51,24,2,3,12]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=k,e.$si=O,e.$vi=E,e.$wi=u,e.$xi=b,e.$yi=r,e.$zi=o,e.$Ci=i,e.$Hi=a,e.$Ii=h,e.$Ki=t,e.$Li=v,e.$Mi=c,e.$qi=(0,m.$hi)("contextService");function k($){const w=$;return typeof w?.id=="string"&&R.URI.isUri(w.uri)}function O($){return typeof $?.id=="string"&&!k($)&&!u($)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function E($,w){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,F.$oc)($)}:w?e.$ti:e.$ui;const p=$;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function u($){const w=$;return typeof w?.id=="string"&&R.URI.isUri(w.configPath)}function b($){const w=$;if(w?.uri)return{id:w.id,uri:R.URI.revive(w.uri)};const p=$;if(p?.configPath)return{id:p.id,configPath:R.URI.revive(p.configPath)};if($?.id)return{id:$.id}}var f;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r($){const w=$;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function o($){const w=$;return!!(w&&typeof w=="object"&&R.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class s{constructor(w,p,l,D,g){this.h=w,this.j=l,this.k=D,this.l=g,this.c=M.$ni.forUris(this.l,()=>!0),this.folders=p}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=M.$ni.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=s;class n{constructor(w,p){this.raw=p,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,N.$Ug)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=n;function i($){return new n({uri:$,index:0,name:(0,N.$Qg)($)},{uri:$.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,I.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function a($,w){return N.$Lg.isEqualOrParent($,w.untitledWorkspacesHome)}function h($){let w;return R.URI.isUri($)?w=$:w=$.configuration,w?.scheme===d.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Ji}function v($,w){return!a($,w)&&!h($)}function c($){return(typeof $=="string"?(0,F.$pc)($):(0,N.$Sg)($))===e.$Ei}}),define(Pe[74],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class I{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const N=this.c++;return this.b.set(N,M),this.e(),N}get(M,N){return this.b.has(M)?this.b.get(M)[N]:void 0}delete(M){this.b.delete(M),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Jic=I}),define(Pe[44],Me([1,0,12,24,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;class N{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$Jg(m=>{const d=this.b.get(m.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(m,d){d===null?this.b.delete(m.scheme):this.b.set(m.scheme,d)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Oic=N,e.$Pic=(0,M.$hi)("IExtHostFileSystemInfo")}),define(Pe[27],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=void 0,e.$SO=(0,I.$hi)("IExtHostInitDataService")}),define(Pe[205],Me([1,0,167,13,192,27]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;let R=class extends M.$1P{constructor(d,k,O){const E=O.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",u=O.remote.isRemote?(0,I.localize)(0,null):d?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(E,{name:u}))}};e.$Vkc=R,e.$Vkc=R=Je([qe(1,F.$Oj),qe(2,N.$SO)],R)}),define(Pe[206],Me([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=e.$xjc=void 0;class F{constructor(R,m,d){this.h=new Map,this.a=R,this.b=m,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$th(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const E of k.values())E.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let d=this.f[R];return typeof d>"u"&&(d=m),d}update(R,m){this.f[R]=m;const d=this.h.get(R);if(d!==void 0)return d.p;const k=new I.$Eh;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$xjc=F;class M extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$yjc=M}),define(Pe[207],Me([1,0,5,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;class M{constructor(R){this.c=R,this.a=new I.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,d,k){const E=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(m.value,d,k);this.b.fire(E)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$lkc=M}),define(Pe[17],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0,e.$CO=(0,I.$hi)("IExtHostRpcService");class F{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$DO=F}),define(Pe[208],Me([1,0,20,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class M{#e;constructor(R,m){this.b=new F.$7d,this.onDidChange=this.b.event,this.a=I.$Cm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$Fjc=M}),define(Pe[59],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=e.$8ic=void 0,e.$8ic=(0,I.$hi)("IURITransformerService");class F{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$9ic=F}),define(Pe[209],Me([1,0,23]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnb=M,e.$Mnb=R;class F{constructor(){this.buffers=[]}add(d){let k=this.buffers.indexOf(d);return k<0&&(k=this.buffers.length,this.buffers.push(d)),k}}function M(m,d){if(d.serializeBuffersForPostMessage){const k=new F,E=JSON.stringify(m,(b,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(f)};if(ArrayBuffer.isView(f)){const r=N(f);if(r)return{$$vscode_array_buffer_reference$$:!0,index:k.add(f.buffer),view:{type:r,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),u=k.buffers.map(b=>{const f=new Uint8Array(b);return I.$ue.wrap(f)});return{message:E,buffers:u}}else return{message:JSON.stringify(m),buffers:[]}}function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,d){const k=d.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),O=d.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:r}=f,o=k[r];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(m,O),arrayBuffers:k}}}),define(Pe[104],Me([1,0,176,16,2,6,3,30,43,12,42,138,32]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$mF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$dF=e.EditorInputCapabilities=e.$cF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=void 0,e.$7E=r,e.$8E=o,e.$9E=s,e.$0E=n,e.$$E=i,e.$_E=a,e.$aF=h,e.$bF=t,e.$eF=l,e.$fF=g,e.$gF=S,e.$hF=y,e.$iF=C,e.$jF=A,e.$kF=G,e.$lF=ne,e.$nF=Se,e.$oF=be,e.$pF=ee,e.$qF=pe,e.$2E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$3E={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$4E="workbench.editor.sidebysideEditor",e.$5E="workbench.editors.textDiffEditor",e.$6E="workbench.editors.binaryResourceDiffEditor";var b;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var f;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(re){const fe=re;return!!fe&&typeof fe.getSelection=="function"&&!!fe.onDidChangeSelection}function o(re,fe,V){for(const te of V.visibleEditorPanes)if(te.group.id===fe&&re.matches(te.input))return te.getViewState()}function s(re){if(l(re))return!1;const fe=re;return M.URI.isUri(fe?.resource)}function n(re){if(l(re))return!1;const fe=re;return fe?.original!==void 0&&fe.modified!==void 0}function i(re){if(l(re))return!1;const fe=re;return!fe||fe.resources&&!Array.isArray(fe.resources)?!1:!!fe.resources||!!fe.multiDiffSource}function a(re){if(l(re)||n(re))return!1;const fe=re;return fe?.primary!==void 0&&fe.secondary!==void 0}function h(re){if(l(re))return!1;const fe=re;return fe?fe.resource===void 0||fe.resource.scheme===k.Schemas.untitled||fe.forceUntitled===!0:!1}function t(re){if(l(re))return!1;const fe=re;return M.URI.isUri(fe?.base?.resource)&&M.URI.isUri(fe?.input1?.resource)&&M.URI.isUri(fe?.input2?.resource)&&M.URI.isUri(fe?.result?.resource)}var v;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(v||(e.Verbosity=v={}));var c;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class ${constructor(){this.a=new Map}registerSource(fe,V){let te=this.a.get(fe);return te||(te={source:fe,label:V},this.a.set(fe,te)),te.source}getSourceLabel(fe){return this.a.get(fe)?.label??fe}}e.$cF=new $;var w;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(w||(e.EditorInputCapabilities=w={}));class p extends N.$Uc{}e.$dF=p;function l(re){return re instanceof p}function D(re){const fe=re;return M.URI.isUri(fe?.preferredResource)}function g(re){const fe=re;return l(fe?.primary)&&l(fe?.secondary)}function S(re){const fe=re;return l(fe?.modified)&&l(fe?.original)}function y(re,fe,V,te,ke){return pe(te,[(0,E.$4i)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Te={...V,limits:{size:Number.MAX_VALUE}};re.openEditor(fe,Te)}}),(0,E.$4i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function C(re){return l(re?.editor)}function A(re){const fe=re;return C(re)&&fe?.group!==void 0}function G(re){const fe=re;return typeof fe?.groupId=="number"&&l(fe.editor)}var T;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var W;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=12]="EDITOR_STICKY",re[re.EDITOR_DIRTY=13]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(W||(e.GroupModelChangeKind=W={}));var P;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class L{getOriginalUri(fe,V){if(!fe)return;if(t(fe))return e.$mF.getOriginalUri(fe.result,V);if(V?.supportSideBySide){const{primary:ke,secondary:Te}=this.a(fe);if(ke&&Te){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(ke,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:V.filterByScheme});fe=V.supportSideBySide===P.PRIMARY?ke:Te}}if(n(fe)||i(fe)||a(fe)||t(fe))return;const te=D(fe)?fe.preferredResource:fe.resource;return!te||!V||!V.filterByScheme?te:this.b(te,V.filterByScheme)}a(fe){return g(fe)||a(fe)?{primary:fe.primary,secondary:fe.secondary}:S(fe)||n(fe)?{primary:fe.modified,secondary:fe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(fe,V){if(!fe)return;if(t(fe))return e.$mF.getCanonicalUri(fe.result,V);if(V?.supportSideBySide){const{primary:ke,secondary:Te}=this.a(fe);if(ke&&Te){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(ke,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:V.filterByScheme});fe=V.supportSideBySide===P.PRIMARY?ke:Te}}if(n(fe)||i(fe)||a(fe)||t(fe))return;const te=fe.resource;return!te||!V||!V.filterByScheme?te:this.b(te,V.filterByScheme)}b(fe,V){if(Array.isArray(V)){if(V.some(te=>fe.scheme===te))return fe}else if(V===fe.scheme)return fe}}var K;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(K||(e.EditorCloseMethod=K={}));function ne(re,fe,V,te){if(!re.isSticky(fe))return!1;switch(te.preventPinnedEditorClose){case"keyboardAndMouse":return V===K.MOUSE||V===K.KEYBOARD;case"mouse":return V===K.MOUSE;case"keyboard":return V===K.KEYBOARD}return!1}e.$mF=new L;var le;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(fe){const V=this.a=fe.get(R.$gi);for(const[te,ke]of this.c)this.e(te,ke,V);this.c.clear()}e(fe,V,te){const ke=te.createInstance(V);this.d.set(fe,ke)}registerFileEditorFactory(fe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=fe}getFileEditorFactory(){return(0,F.$6f)(this.b)}registerEditorSerializer(fe,V){if(this.c.has(fe)||this.d.has(fe))throw new Error(`A editor serializer with type ID '${fe}' was already registered.`);return this.a?this.e(fe,V,this.a):this.c.set(fe,V),(0,N.$Sc)(()=>{this.c.delete(fe),this.d.delete(fe)})}getEditorSerializer(fe){return this.d.get(typeof fe=="string"?fe:fe.typeId)}}m.$Zn.add(e.$2E.EditorFactory,new ye);async function Se(re,fe,V){return!re||!re.length?[]:await Promise.all(re.map(async te=>{const ke=M.URI.revive(te.fileUri);if(!ke){V.info("Cannot resolve the path because it is not valid.",te);return}if(!await fe.canHandleResource(ke)){V.info("Cannot resolve the path because it cannot be handled",te);return}let Ie=te.exists,ve=te.type;if(typeof Ie!="boolean"||typeof ve!="number")try{ve=(await fe.stat(ke)).isDirectory?d.FileType.Directory:d.FileType.Unknown,Ie=!0}catch(J){V.error(J),Ie=!1}if(!Ie&&te.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",te);return}if(ve===d.FileType.Directory){V.info("Cannot resolve the path because it is a directory",te);return}const ge={...te.options,pinned:!0};return Ie?{resource:ke,options:ge}:{resource:ke,options:ge,forceUntitled:!0}}))}var he;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function be(re){const fe=re;if(!fe)return!1;const V=fe;if(V.modified)return be(V.modified);const te=fe;return!!(te.contributionsState&&te.viewState&&Array.isArray(te.cursorState))}function ee(re){return(0,O.$6i)(re)}function pe(re,fe,V){const te=(0,O.$7i)(re,fe);return te.forceMessage=V?.forceMessage,te.forceSeverity=V?.forceSeverity,te.allowDialog=V?.allowDialog,te}}),define(Pe[210],Me([1,0,5,177,3,6,28,30,18,26,91,201]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$wF=e.ViewContentGroups=e.$uF=e.ViewContainerLocation=e.Extensions=e.$tF=e.$sF=e.$rF=void 0,e.$vF=f,e.$rF="views",e.$sF=(0,F.localize)(0,null),e.$tF=(0,E.$Tw)("default-view-icon",O.$Gj.window,(0,F.localize)(1,null));var u;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$uF=[0,1,2];function f(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onDidRegister=this.c.event,this.f=this.B(new I.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(c,$,w){const p=this.get(c.id);if(p)return p;const l=c;return l.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,R.$yc)(this.g,$,[]).push(l),w?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const w=this.g.get($),p=w?.indexOf(c);if(p!==-1){w?.splice(p,1),w.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}m.$Zn.add(u.ViewContainersRegistry,new r);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(v,c){const $=v.group??o.More,w=c.group??o.More;return $!==w?$.localeCompare(w):(v.order??5)-(c.order??5)}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:w})=>this.r($,w)),this.c.fire(c)}deregisterViews(c,$){const w=this.s(c,$);w.length&&this.f.fire({views:w,viewContainer:$})}moveViews(c,$){for(const w of this.m.keys())if(w!==$){const p=this.s(c,w);p.length&&(this.r(p,$),this.g.fire({views:p,from:w,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const w=(this.m.get($)||[]).filter(p=>p.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(p=>p.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,N.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const w=new Map;for(const[p,l]of $)this.n.add(c,l),w.set(p,(0,N.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,w=>$.push(w)),$.sort(s)}r(c,$){let w=this.m.get($);w||(w=[],this.m.set($,w),this.j.push($));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,F.localize)(2,null,p.id));w.push(p)}}s(c,$){const w=this.m.get($);if(!w)return[];const p=[],l=[];for(const D of w)c.includes(D)?p.push(D):l.push(D);return p.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),p}}m.$Zn.add(u.ViewsRegistry,new n),e.$wF=(0,M.$hi)("viewDescriptorService");var i;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,k.$Qn)(this,c),this.d=!!$,this.resolve=async w=>{if($&&!this.c){const p=await $(w);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$xF=h;class t extends Error{constructor(c){super((0,F.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$yF=t}),define(Pe[211],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CF=void 0,e.$CF=(0,I.$hi)("IChatContributionService")}),define(Pe[212],Me([1,0,18,5,39,6,33,3,211]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.$xG=e.ChatAgentLocation=void 0;var k;(function(u){u[u.Panel=1]="Panel",u[u.Terminal=2]="Terminal",u[u.Notebook=3]="Notebook"})(k||(e.ChatAgentLocation=k={})),function(u){function b(f){switch(f){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook}return u.Panel}u.fromRaw=b}(k||(e.ChatAgentLocation=k={})),e.$xG=(0,m.$hi)("chatAgentService");let O=class extends N.$Uc{static{this.AGENT_LEADER="@"}constructor(b,f){super(),this.g=b,this.h=f,this.b=new Map,this.f=this.B(new F.$7d),this.onDidChangeAgents=this.f.event}dispose(){super.dispose(),this.b.clear()}registerAgent(b,f){if(this.b.has(b))throw new Error(`Already registered an agent with id ${b}`);const r=this.getAgent(b);if(!r)throw new Error(`Unknown agent: ${b}`);const o={data:r,impl:f};return this.b.set(b,o),this.f.fire(new E(r,f)),(0,N.$Sc)(()=>{this.b.delete(b)&&this.f.fire(void 0)})}registerDynamicAgent(b,f){const r={data:b,impl:f};return this.b.set(b.id,r),this.f.fire(new E(b,f)),(0,N.$Sc)(()=>{this.b.delete(b.id)&&this.f.fire(void 0)})}updateAgent(b,f){const r=this.b.get(b);if(!r?.impl)throw new Error(`No activated agent with id ${b} registered`);r.data.metadata={...r.data.metadata,...f},this.f.fire(new E(r.data,r.impl))}getDefaultAgent(){return this.getActivatedAgents().find(b=>!!b.isDefault)}getSecondaryAgent(){return M.Iterable.find(this.b.values(),b=>!!b.data.metadata.isSecondary)?.data}getRegisteredAgents(){const b=this;return this.g.registeredParticipants.map(f=>({extensionId:f.extensionId,id:f.name,metadata:{description:f.description},isDefault:f.isDefault,defaultImplicitVariables:f.defaultImplicitVariables,locations:(0,I.$Lb)(f.locations)?f.locations.map(k.fromRaw):[k.Panel],get slashCommands(){return(f.commands??[]).filter(o=>!o.when||b.h.contextMatchesRules(R.$fj.deserialize(o.when)))}}))}getAgents(){const b=this.getRegisteredAgents(),f=Array.from(this.b.values()).map(o=>o.data),r=[...b,...f];return(0,I.$Mb)(r,o=>o.id)}getActivatedAgents(){return Array.from(this.b.values()).filter(b=>!!b.impl).map(b=>new E(b.data,b.impl))}getAgent(b){return this.getAgents().find(f=>f.id===b)}async invokeAgent(b,f,r,o,s){const n=this.b.get(b);if(!n?.impl)throw new Error(`No activated agent with id ${b}`);return await n.impl.invoke(f,r,o,s)}async getFollowups(b,f,r,o,s){const n=this.b.get(b);if(!n?.impl)throw new Error(`No activated agent with id ${b}`);return n.impl?.provideFollowups?n.impl.provideFollowups(f,r,o,s):[]}};e.$yG=O,e.$yG=O=Je([qe(0,d.$CF),qe(1,R.$zj)],O);class E{constructor(b,f){this.b=b,this.d=f}get id(){return this.b.id}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(b,f,r,o){return this.d.invoke(b,f,r,o)}async provideFollowups(b,f,r,o){return this.d.provideFollowups?this.d.provideFollowups(b,f,r,o):[]}provideWelcomeMessage(b){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(b)}provideSampleQuestions(b){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(b)}}e.$zG=E}),define(Pe[213],Me([1,0,2,29,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=e.$IF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$GF=N,e.$HF=R;function N(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(F.$bt.isIRange)}function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(N)}var m;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var d;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(d||(e.ChatCopyKind=d={})),e.$IF=(0,M.$hi)("IChatService"),e.$JF="accessibility.voice.keywordActivation"}),define(Pe[214],Me([1,0,5,11,178]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fob=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new I.$7d,this.o=new I.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,d,k,O){const E={command:m};if(d&&Object.keys(d).length>0&&(E.arguments=d),this.u("request",E),typeof O=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(E.seq);if(b){this.f.delete(E.seq);const f={type:"response",seq:0,request_seq:E.seq,success:!1,command:m,message:(0,M.localize)(0,null,O,m)};b(f)}},O)}return k&&this.f.set(E.seq,k),E.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,d){return m.type!=="event"||d.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,F.$ih)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const d=m,k=this.f.get(d.request_seq);k&&(this.f.delete(d.request_seq),k(d));break}}}}u(m,d){d.type=m,d.seq=this.d++,this.sendMessage(d)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((d,k)=>m.set(k,d)),await(0,F.$ih)(500),m.forEach((d,k)=>{d({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$fob=N}),define(Pe[215],Me([1,0,2,179,33,3]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$NI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$MI=e.MemoryRangeType=e.State=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=void 0,e.$LI=d,e.$AH="workbench.view.debug",e.$BH="workbench.debug.variablesView",e.$CH="workbench.debug.watchExpressionsView",e.$DH="workbench.debug.callStackView",e.$EH="workbench.debug.loadedScriptsView",e.$FH="workbench.debug.breakPointsView",e.$GH="workbench.debug.disassemblyView",e.$HH="workbench.panel.repl",e.$IH="workbench.panel.repl.view",e.$JH=new M.$yj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$KH=new M.$yj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$LH=new M.$yj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$MH="debugUx",e.$NH=new M.$yj(e.$MH,"default",{type:"string",description:F.localize(3,null)}),e.$OH=new M.$yj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$PH=new M.$yj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$QH=new M.$yj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$RH=new M.$yj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$SH=new M.$yj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$TH=new M.$yj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$UH=new M.$yj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$VH=new M.$yj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$WH=new M.$yj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$XH=new M.$yj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$YH=new M.$yj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$ZH=new M.$yj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$1H=new M.$yj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$2H=new M.$yj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$3H=new M.$yj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$4H=new M.$yj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$5H=new M.$yj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$6H=new M.$yj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$7H=new M.$yj("breakpointItemBytes",void 0,{type:"boolean",description:F.localize(22,null)}),e.$8H=new M.$yj("breakpointHasModes",!1,{type:"boolean",description:F.localize(23,null)}),e.$9H=new M.$yj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(24,null)}),e.$0H=new M.$yj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(25,null)}),e.$$H=new M.$yj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(26,null)}),e.$_H=new M.$yj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(27,null)}),e.$aI=new M.$yj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(28,null)}),e.$bI=new M.$yj("stepBackSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.$cI=new M.$yj("restartFrameSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.$dI=new M.$yj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(31,null)}),e.$eI=new M.$yj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.$fI=new M.$yj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(33,null)}),e.$gI=new M.$yj("breakpointsExist",!1,{type:"boolean",description:F.localize(34,null)}),e.$hI=new M.$yj("debuggersAvailable",!1,{type:"boolean",description:F.localize(35,null)}),e.$iI=new M.$yj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(36,null)}),e.$jI=new M.$yj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(37,null)}),e.$kI=new M.$yj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$lI=new M.$yj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$mI=new M.$yj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$nI=new M.$yj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$oI=new M.$yj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$pI=new M.$yj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.$qI=new M.$yj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(44,null)}),e.$rI=new M.$yj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(45,null)}),e.$sI=new M.$yj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(46,null)}),e.$tI=new M.$yj("variableIsReadonly",!1,{type:"boolean",description:F.localize(47,null)}),e.$uI=new M.$yj("variableValue",!1,{type:"string",description:F.localize(48,null)}),e.$vI=new M.$yj("variableType",!1,{type:"string",description:F.localize(49,null)}),e.$wI=new M.$yj("variableName",!1,{type:"string",description:F.localize(50,null)}),e.$xI=new M.$yj("variableLanguage",!1,{type:"string",description:F.localize(51,null)}),e.$yI=new M.$yj("variableExtensionId",!1,{type:"string",description:F.localize(52,null)}),e.$zI=new M.$yj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(53,null)}),e.$AI=new M.$yj("multiSessionRepl",!1,{type:"boolean",description:F.localize(54,null)}),e.$BI=new M.$yj("multiSessionDebug",!1,{type:"boolean",description:F.localize(55,null)}),e.$CI=new M.$yj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(56,null)}),e.$DI=new M.$yj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(57,null)}),e.$EI=new M.$yj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(58,null)}),e.$FI=new M.$yj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(59,null)});const R=n=>F.localize(60,null,n);e.$GI=R,e.$HI="editor.contrib.debug",e.$II="editor.contrib.breakpoint",e.$JI="debug",e.$KI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(61,null)};var m;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(m||(e.State=m={}));function d(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$MI="vscode-debug-memory";var O;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(O||(e.DataBreakpointSetType=O={}));var E;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(E||(e.DebugConfigurationProviderTriggerKind=E={}));var u;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(u||(e.DebuggerString=u={})),e.$NI=(0,N.$hi)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var f;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:I.URI.revive(i.iconPath.light),dark:I.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Pe[216],Me([1,0,15,2,19,26,12,29,25,18]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OG=void 0,e.$CG=E,e.$DG=u,e.$EG=b,e.$FG=f,e.$GG=r,e.$HG=o,e.$IG=s,e.$JG=i,e.$KG=t,e.$LG=v,e.$MG=$,e.$NG=p;const O=/{([^}]+)}/g;function E(D,g,S){return D.replace(O,function(y,C){return g&&C.length>0&&C[0]!=="_"?y:S&&S.hasOwnProperty(C)?S[C]:y})}function u(D){const g={};for(const S of Object.keys(D))S.startsWith("!")||(g[S]=D[S]);return g}function b(D){return D.configuration.request==="attach"&&!f(D)&&(!D.parentSession||b(D.parentSession))}function f(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,I.$lf)(g,"extensionhost")||(0,I.$lf)(g,"pwa-extensionhost")?D:D.parentSession?f(D.parentSession):void 0}function r(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,g,S){let y,C=0;const A=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=A.exec(D);){const T=G.index+1,W=T+G[0].length;if(T<=g&&W>=S){y=G[0],C=T;break}}if(y){const T=/\w+/g;let W=null;for(;(W=T.exec(y))&&!(W.index+1+C+W[0].length>=S););W&&(y=y.substring(0,T.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(D,g,S,y){if(D.evaluatableExpressionProvider.has(g)){const C=D.evaluatableExpressionProvider.ordered(g),A=(0,k.$Hb)(await Promise.all(C.map(async G=>{try{return await G.provideEvaluatableExpression(g,S,y??d.CancellationToken.None)}catch{return}})));if(A.length>0){let G=A[0].expression;const T=A[0].range;return G||(G=g.getLineContent(S.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:G}}}else{const C=g.getLineContent(S.lineNumber),{start:A,end:G}=o(C,S.column,S.column),T=C.substring(A-1,G);return{matchingExpression:T,range:new m.$bt(S.lineNumber,A,S.lineNumber,A+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return F.URI.parse(D.path);if((0,M.$jc)(D.path))return F.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const g=F.URI.revive(D.path);if(g)return g.scheme===R.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const S=g?a:h,y=(0,N.$Nn)(D);return c(y,(C,A)=>{C&&A&&(A.path=S(A))}),y}function v(D,g){const S=g?a:h,y=(0,N.$Nn)(D);return c(y,(C,A)=>{!C&&A&&(A.path=S(A))}),y}function c(D,g){switch(D.type){case"event":{const S=D;switch(S.event){case"output":g(!1,S.body.source);break;case"loadedSource":g(!1,S.body.source);break;case"breakpoint":g(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":g(!0,S.arguments.source);break;case"breakpointLocations":g(!0,S.arguments.source);break;case"source":g(!0,S.arguments.source);break;case"gotoTargets":g(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>g(!1,y));break;case"scopes":S.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(C=>g(!1,C.location));break;default:break}break}}}function $(D){return D.filter(g=>!g.presentation?.hidden).sort((g,S)=>g.presentation?S.presentation?g.presentation.group?S.presentation.group?g.presentation.group!==S.presentation.group?g.presentation.group.localeCompare(S.presentation.group):w(g.presentation.order,S.presentation.order):-1:S.presentation.group?1:w(g.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function w(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function p(D,g){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(S!=="none"&&(await g.saveAll(),S==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const l=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.$OG=l}),define(Pe[217],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.CellExecutionUpdateType=void 0;var F;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$1J=(0,I.$hi)("INotebookExecutionService")}),define(Pe[218],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhb=e.$qhb=e.ProxyKernelState=e.$phb=void 0,e.$phb=100;var F;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$qhb=(0,I.$hi)("INotebookKernelService"),e.$rhb=(0,I.$hi)("INotebookKernelHistoryService")}),define(Pe[219],Me([1,0,6,29,148,95]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Tb=void 0;class R extends I.$Uc{constructor(d,k,O){super(),this._source=d,this.b=k,this.c=O,this.a=void 0}f(d){const k=d.getLineCount();return new F.$bt(1,1,k,this.g(d,k))}g(d,k){if(k<1||k>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const d=new M.$yC;d.acceptChunk(this._source);const k=d.finish(!0),{textBuffer:O,disposable:E}=k.create(1);this.b=O,this.B(E)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const k=new M.$yC;k.acceptChunk(d);const O=k.finish(!0),{textBuffer:E,disposable:u}=O.create(1);return this.B(u),E})),this.a}findInInputs(d){const O=new N.$mC(d,!1,!1,null).parseSearchRequest();if(!O)return[];const E=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(E,O,!0,5e3)}findInOutputs(d){const O=new N.$mC(d,!1,!1,null).parseSearchRequest();return O?this.outputTextBuffers.map(E=>{const u=E.findMatchesLineByLine(this.f(E),O,!0,5e3);if(u.length!==0)return{textBuffer:E,matches:u}}).filter(E=>!!E):[]}}e.$0Tb=R}),define(Pe[49],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(N){N.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class M{static fromExtHostTestItem(R,m,d=R.parent){if(R._isRoot)return new M([m]);const k=[R.id];for(let O=d;O&&O.id!==m;O=O.parent)k.push(O.id);return k.push(m),new M(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new M(R.split("\0"))}static join(R,m){return new M([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:M.isChild(R,m)?2:M.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$7K=M}),define(Pe[60],Me([1,0,2,93,29,49]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$cL=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$bL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aL=e.$_K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$0K=e.$9K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$8K=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$8K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var d;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$9K=[2,4,8,16,32,64];const k=P=>"runId"in P;e.$0K=k;var O;(function(P){P.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),P.deserialize=(L,K)=>({range:M.$bt.lift(K.range),uri:L.asCanonicalUri(I.URI.revive(K.uri))})})(O||(e.IRichLocation=O={}));var E;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(P){P.serialize=L=>({message:L.message,type:0,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&O.serialize(L.location)}),P.deserialize=(L,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&O.deserialize(L,K.location)})})(u||(e.ITestErrorMessage=u={}));const b=(P,L)=>`${L?"s":"e"}${P}`;e.$$K=b;var f;(function(P){P.serialize=L=>({message:L.message,type:1,offset:L.offset,length:L.length,location:L.location&&O.serialize(L.location)}),P.deserialize=(L,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&O.deserialize(L,K.location)})})(f||(e.ITestOutputMessage=f={}));var r;(function(P){P.serialize=L=>L.type===0?u.serialize(L):f.serialize(L),P.deserialize=(L,K)=>K.type===0?u.deserialize(L,K):f.deserialize(L,K)})(r||(e.ITestMessage=r={}));var o;(function(P){P.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),P.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(r.serialize)}),P.deserialize=(L,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ne=>r.deserialize(L,ne))})})(o||(e.ITestTaskState=o={}));const s="\0",n=(P,L)=>P+s+L;e.$_K=n;const i=P=>{const L=P.indexOf(s);return{ctrlId:P.slice(0,L),tagId:P.slice(L+1)}};e.$aL=i;var a;(function(P){P.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),P.deserialize=(L,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?L.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?M.$bt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(P){P.serialize=L=>({expand:L.expand,item:a.serialize(L.item)}),P.deserialize=(L,K)=>({controllerId:N.$7K.root(K.item.extId),expand:K.expand,item:a.deserialize(L,K.item)})})(t||(e.InternalTestItem=t={}));var v;(function(P){P.serialize=L=>{let K;return L.item&&(K={},L.item.label!==void 0&&(K.label=L.item.label),L.item.tags!==void 0&&(K.tags=L.item.tags),L.item.busy!==void 0&&(K.busy=L.item.busy),L.item.uri!==void 0&&(K.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(K.range=L.item.range?.toJSON()),L.item.description!==void 0&&(K.description=L.item.description),L.item.error!==void 0&&(K.error=L.item.error),L.item.sortText!==void 0&&(K.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:K}},P.deserialize=L=>{let K;return L.item&&(K={},L.item.label!==void 0&&(K.label=L.item.label),L.item.tags!==void 0&&(K.tags=L.item.tags),L.item.busy!==void 0&&(K.busy=L.item.busy),L.item.range!==void 0&&(K.range=L.item.range?M.$bt.lift(L.item.range):null),L.item.description!==void 0&&(K.description=L.item.description),L.item.error!==void 0&&(K.error=L.item.error),L.item.sortText!==void 0&&(K.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:K}}})(v||(e.ITestItemUpdate=v={}));const c=(P,L)=>{L.expand!==void 0&&(P.expand=L.expand),L.item!==void 0&&(P.item=P.item?Object.assign(P.item,L.item):L.item)};e.$bL=c;var $;(function(P){P.serializeWithoutMessages=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serializeWithoutMessages)}),P.serialize=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serialize)}),P.deserialize=(L,K)=>({...t.deserialize(L,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ne=>o.deserialize(L,ne)),retired:!0})})($||(e.TestResultItem=$={}));var w;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(L,K)=>{L.covered+=K.covered,L.total+=K.total}})(w||(e.ICoveredCount=w={}));var p;(function(P){P.serialize=L=>({statement:L.statement,branch:L.branch,declaration:L.declaration,details:L.details?.map(S.serialize),uri:L.uri.toJSON()}),P.deserialize=(L,K)=>({statement:K.statement,branch:K.branch,declaration:K.declaration,details:K.details?.map(S.deserialize),uri:L.asCanonicalUri(I.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function l(P){return{...P,location:P.location?.toJSON()}}function D(P){return P.location=P.location?F.$at.isIPosition(P.location)?F.$at.lift(P.location):M.$bt.lift(P.location):void 0,P}e.$cL=3;var g;(function(P){P[P.Declaration=0]="Declaration",P[P.Statement=1]="Statement",P[P.Branch=2]="Branch"})(g||(e.DetailType=g={}));var S;(function(P){P.serialize=L=>L.type===0?C.serialize(L):A.serialize(L),P.deserialize=L=>L.type===0?C.deserialize(L):A.deserialize(L)})(S||(e.CoverageDetails=S={}));var y;(function(P){P.serialize=l,P.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(P){P.serialize=l,P.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var A;(function(P){P.serialize=L=>({...l(L),branches:L.branches?.map(y.serialize)}),P.deserialize=L=>({...D(L),branches:L.branches?.map(y.deserialize)})})(A||(e.IStatementCoverage=A={}));var G;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var T;(function(P){P.deserialize=(L,K)=>K.op===0?{op:K.op,item:t.deserialize(L,K.item)}:K.op===1?{op:K.op,item:v.deserialize(K.item)}:K.op===2?{op:K.op,uri:L.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,P.serialize=L=>L.op===0?{op:L.op,item:t.serialize(L.item)}:L.op===1?{op:L.op,item:v.serialize(L.item)}:L})(T||(e.TestsDiffOp=T={}));class W{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const K=this.v();for(const ne of L)switch(ne.op){case 0:this.l(t.deserialize(this.k,ne.item),K);break;case 1:this.o(v.deserialize(ne.item),K);break;case 3:this.p(ne.itemId,K);break;case 5:this.q(ne.itemId);break;case 4:this.updatePendingRoots(ne.amount);break;case 6:this.c.set(ne.tag.id,ne.tag);break;case 7:this.c.delete(ne.id);break}K.complete?.()}l(L,K){const ne=N.$7K.parentId(L.item.extId)?.toString();let le;if(!ne)le=this.w(L),this.g.add(le),this.f.set(L.item.extId,le);else if(this.f.has(ne)){const ye=this.f.get(ne);ye.children.add(L.item.extId),le=this.w(L,ye),this.f.set(L.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return K.add?.(le),L.expand===2&&this.h++,le}o(L,K){const ne=this.f.get(L.extId);if(ne)return L.expand!==void 0&&(ne.expand===2&&this.h--,L.expand===2&&this.h++),(0,e.$bL)(ne,L),K.update?.(ne),ne}p(L,K){const ne=this.f.get(L);if(!ne)return;const le=N.$7K.parentId(ne.item.extId)?.toString();le?this.f.get(le).children.delete(ne.item.extId):this.g.delete(ne);const ye=[[L]];for(;ye.length;)for(const Se of ye.pop()){const he=this.f.get(Se);he&&(ye.push(he.children),this.f.delete(Se),K.remove?.(he,he!==ne),he.expand===2&&this.h--)}}q(L){}updatePendingRoots(L){this.j+=L}v(){return{}}}e.$dL=W}),define(Pe[75],Me([1,0,11,5,6,55,60,49]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.TestItemEventOp=void 0;var d;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const k=(n,i)=>n===i,E=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(a=>!i.includes(a)))}),u=(n,i)=>{let a;for(const[h,t]of E)t(n[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class b extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$th(()=>this.flushDiff(),200)),this.g=this.B(new F.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,R.$bL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,R.$bL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(m.$7K.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$0c)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=m.$7K.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(i)}}),this.I(i,v,a);return}if(v.actual===i){this.H(i,v,a);return}if(v.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(v.actual),$=v.actual,w=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,v.actual=i,v.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete w.tags),this.w(v,{op:4,update:w})),this.I(i,v,a);for(const[p,l]of c)this.s.getChildren(i).get(l.id)||this.O(m.$7K.joinToString(h,l.id));this.y(v.actual.uri)}C(i,a,h){const t=new Set(a.map(v=>v.id));for(const v of i)t.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(v=>(0,R.$_K)(this.s.controllerId,v.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$_K)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,R.$_K)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=v=>this.w(a,v),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,v]of this.s.getChildren(i))this.z(v,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,v]of this.s.getChildren(i.actual)){const c=this.expand(m.$7K.joinToString(i.fullId,v.id),a);(0,I.$6g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const v=new I.$gh;return v.open(),v}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$gh,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(v){h(v)}return(0,I.$6g)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const v of t.actual.tags)this.F(v.id);this.tree.delete(t.fullId.toString());for(const[v,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$7K.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$sO=b;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$tO=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$uO=r;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$vO=o;const s=(n,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,v){for(const c of h.values())t.call(v,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const v=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const w of t){if(!(w instanceof a))throw new r(w.id);const p=i(w).controllerId;if(p!==n.controllerId)throw new o(w.id,p,n.controllerId);if(v.has(w.id))throw new f(w.id);v.set(w.id,w),c.delete(w.id),$.ops.push({op:0,item:w})}for(const w of c.keys())$.ops.push({op:3,id:w});n.listener?.($),h=v},add(t){if(!(t instanceof a))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$wO=s}),define(Pe[105],Me([1,0,75]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=void 0;const F=new WeakMap,M=(R,m)=>{const d={controllerId:m};return F.set(R,d),d};e.$xO=M;const N=R=>{const m=F.get(R);if(!m)throw new I.$uO(R?.id||"<unknown>");return m};e.$yO=N}),define(Pe[76],Me([1,0,12,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nyb=e.$Myb=e.$Lyb=void 0,e.$Oyb=M,e.$Pyb=R,e.$Lyb="vscode-cdn.net",e.$Myb=`vscode-resource.${e.$Lyb}`,e.$Nyb=`'self' https://*.${e.$Lyb}`;function M(m,d){return m.scheme===I.Schemas.http||m.scheme===I.Schemas.https?m:(d&&d.authority&&d.isRemote&&m.scheme===I.Schemas.file&&(m=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:d.authority,path:m.path})),F.URI.from({scheme:I.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.$Myb}`,path:m.path,fragment:m.fragment,query:m.query}))}function N(m){return m.replace(/./g,d=>{const k=d.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?d:"-"+k.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(d,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Pe[220],Me([1,0,5,6,76]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class N{constructor(m,d,k){this.d=m,this.e=d,this.f=k,this.a=0,this.b=new F.$Tc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const O=d.getVisibleTextEditors();for(const E of this.c.values())O.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,d,k,O,E){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){u=i;break}if(!u)throw new Error("not a visible editor");const b=this,f=this.a++,r=new I.$7d,o=new I.$7d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$Oyb)(i,b.f)}get cspSource(){return M.$Nyb}set options(i){this.b=i,b.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return b.d.$postMessage(f,i)}},n=new class{constructor(){this.editor=m,this.line=d,this.height=k,this.webview=s,this.onDidDispose=o.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(f,u.id,u.value.document.uri,d+1,k,O||{},E.identifier,E.extensionLocation),this.c.set(f,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const d=this.c.get(m);d&&d.inset.dispose()}$onDidReceiveMessage(m,d){this.c.get(m)?.onDidReceiveMessage.fire(d)}}e.$6ic=N}),define(Pe[106],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.$kL=void 0,e.$kL="__",e.$lL=(0,I.$hi)("IAuthenticationService"),e.$mL=(0,I.$hi)("IAuthenticationExtensionsService")}),define(Pe[221],Me([1,0,3]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.VariableKind=e.$oP=void 0,e.$oP=(0,I.$hi)("configurationResolverService");var F;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class M extends Error{constructor(R,m){super(m),this.variable=R}}e.$pP=M}),define(Pe[222],Me([1,0,19,73,16,26,21,96,182,221,15]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,f,r,o){this.h=new Map,this.a=b,this.b=f,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(b){if(R.$i){const f=Object.create(null);return Object.keys(b).forEach(r=>{f[r.toLowerCase()]=b[r]}),f}return b}resolveWithEnvironment(b,f,r){return this.l({env:this.i(b),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(b,f){const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,f)}async j(b,f,r,o){const s=N.$Nn(f);R.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):R.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):R.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,s,r,o)}async resolveAnyAsync(b,f,r){return this.j(b,f,r)}async resolveAnyMap(b,f,r){const o=new Map;return{newConfig:await this.j(b,f,r,o),resolvedVariables:o}}resolveWithInteractionReplace(b,f,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,f)}async l(b,f,r,o,s){if(M.$Uf(r))return this.m(b,f,r,o,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(b,f,n,o,s)));if(M.$Wf(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async a=>[await this.m(b,f,a,o,s),await this.l(b,f,r[a],o,s)]));for(const[a,h]of i)n[a]=h;return n}return r}m(b,f,r,o,s){return(0,O.$df)(r,E.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(E.VARIABLE_LHS))return n;let a=await this.o(b,n,i,f,o);return s?.set(i,a),a!==n&&M.$Uf(a)&&a.match(E.VARIABLE_REGEXP)&&(a=await this.m(b,f,a,o,s)),a})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,f,r,o,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const a=v=>{const c=this.a.getFilePath();if(c)return(0,m.$gw)(c);throw new k.$pP(v,(0,d.localize)(0,null,f))},h=v=>{const c=a(v);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,m.$gw)($)}throw new k.$pP(v,(0,d.localize)(1,null,f,I.$oc(c)))},t=v=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new k.$pP(v,(0,d.localize)(2,null,f,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$pP(v,(0,d.localize)(3,null,f)):new k.$pP(v,(0,d.localize)(4,null,f))};switch(r){case"env":if(n){if(b.env){const v=b.env[R.$i?n.toLowerCase():n];if(M.$Uf(v))return v}return""}throw new k.$pP(k.VariableKind.Env,(0,d.localize)(5,null,f));case"config":if(n){const v=this.a.getConfigurationValue(o,n);if(M.$4f(v))throw new k.$pP(k.VariableKind.Config,(0,d.localize)(6,null,f,n));if(M.$Wf(v))throw new k.$pP(k.VariableKind.Config,(0,d.localize)(7,null,f,n));return v}throw new k.$pP(k.VariableKind.Config,(0,d.localize)(8,null,f));case"command":return this.p(k.VariableKind.Command,f,n,s,"command");case"input":return this.p(k.VariableKind.Input,f,n,s,"input");case"extensionInstallFolder":if(n){const v=await this.a.getExtension(n);if(!v)throw new k.$pP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,f,n));return this.n(v.extensionLocation)}throw new k.$pP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$gw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.$gw)(this.n(t(k.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$gw)(I.$oc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.$pP(k.VariableKind.UserHome,(0,d.localize)(11,null,f))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new k.$pP(k.VariableKind.LineNumber,(0,d.localize)(12,null,f))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new k.$pP(k.VariableKind.SelectedText,(0,d.localize)(13,null,f))}case"file":return a(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(t(k.VariableKind.RelativeFile)),a(k.VariableKind.RelativeFile)):a(k.VariableKind.RelativeFile);case"relativeFileDirname":{const v=I.$nc(a(k.VariableKind.RelativeFileDirname));if(o||n){const c=I.$mc(this.n(t(k.VariableKind.RelativeFileDirname)),v);return c.length===0?".":c}return v}case"fileDirname":return I.$nc(a(k.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(k.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=I.$oc(a(k.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-I.$pc(v).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(k.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||f}case"execInstallFolder":{const v=this.a.getAppRoot();return v||f}case"pathSeparator":case"/":return I.sep;default:try{const v=n?`${r}:${n}`:r;return this.p(k.VariableKind.Unknown,f,v,s,void 0)}catch{return f}}}}p(b,f,r,o,s){if(r&&o){const n=s===void 0?o[r]:o[s+":"+r];if(typeof n=="string")return n;throw new k.$pP(b,(0,d.localize)(14,null,f))}return f}}e.$EP=E}),define(Pe[107],Me([1,0,3,104]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$uD=void 0,e.$vD=k,e.$wD=u,e.$xD=b,e.$uD=(0,I.$hi)("editorGroupsService");var M;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var d;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function k(f){const r=f;return(0,F.$eF)(r?.editor)&&(0,F.$eF)(r?.replacement)}var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var E;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[223],Me([1,0,3,107]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BD=e.$AD=e.$zD=e.$yD=void 0,e.$CD=M,e.$yD=(0,I.$hi)("editorService"),e.$zD=-1,e.$AD=-2,e.$BD=-3;function M(N){const R=N;return typeof N=="number"||(0,F.$wD)(R)}}),define(Pe[224],Me([1,0,3,189]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=void 0,e.$FL=(0,I.$ii)(F.$oi)}),define(Pe[108],Me([1,0,20,5,19,6,11]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=e.$F0b=e.$E0b=e.$D0b=void 0;class m{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$D0b=m;class d{static isHostExtension(n,i,a){if(i.getExtensionDescription(n))return!1;const h=a.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,i){this.j=n,this.c=new F.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new I.$Em,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=o(this.e,i),this.e=this.e.concat(n);const a=d.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const w=i.getArcs(c);for(let p=0;p<w.length;p++)if(!$.has(w[p]))return!1;return!0}getNodes(){return this.e}},a=new I.$Em;for(const c of n)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Cm.toKey(c.identifier),I.$Cm.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let v;do{v=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),v=!0)}}while(v);return t.map(c=>a.get(c))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$E0b=d;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$F0b=k;class O{constructor(n){this.d=new b,this.c=new d(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new E(this,i)}deltaExtensions(n,i,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$G0b=O;class E extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$H0b=E;class u{constructor(n){this.name=n;const i=(0,R.$ah)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class b{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new u(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(h))}}var f;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(f||(f={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=M.$hc.basename(s.extensionLocation.path),t=M.$hc.basename(n.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,n){const i=new I.$Dm(n);return s.filter(a=>!i.has(a.identifier))}}),define(Pe[77],Me([1,0,23]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Km=R,e.$Lm=m;var F;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(F||(e.UIKind=F={}));var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var N;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(k){const O=I.$ue.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}function m(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}var d;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Pe[61],Me([1,0,3,5,13,27,77,57,58,26,2,6,170]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$UO=e.$TO=void 0,e.$VO=r;let b=class extends E.$Uc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new F.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=O.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:d.$8o,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Pj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,i){const a=this.getTelemetryDetails(),h=new f(n,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this.f=s,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$tm)((0,d.$bp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$TO=b,e.$TO=b=Je([qe(0,N.$SO),qe(1,M.$Oj)],b);class f{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,a,h,t,v){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new F.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,d.$ep)(n,[]),this.c&&(n=(0,k.$Qn)(n,this.c)),this.b||(n=(0,k.$Qn)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,d.$ep)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$UO=f;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$WO=(0,I.$hi)("IExtHostTelemetry")}),define(Pe[22],Me([1,0,5,2,198,103,20,3]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_F=e.ActivationKind=e.$9F=e.$8F=e.$5F=e.ExtensionHostStartup=e.$4F=e.$3F=e.$2F=e.$1F=void 0,e.$6F=u,e.$7F=b,e.$0F=s,e.$$F=n,e.$1F=Object.freeze({identifier:new R.$Cm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$2F="extensions.webWorker",e.$3F=(0,m.$hi)("extensionService");class d{constructor(h){this.dependency=h}}e.$4F=d;var k;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class O{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,v){this.c=h,this.d=t.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$LF.createActivationEventsMap(this.d)}}set(h,t,v){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],w=[],p=[],l=E(this.d),D=E(t),g=(G,T)=>G.extensionLocation.toString()===T.extensionLocation.toString()||G.isBuiltin===T.isBuiltin||G.isUserBuiltin===T.isUserBuiltin||G.isUnderDevelopment===T.isUnderDevelopment;for(const G of this.d){const T=D.get(G.identifier);if(!T){c.push(G.identifier),l.delete(G.identifier);continue}if(!g(G,T)){c.push(G.identifier),l.delete(G.identifier);continue}}for(const G of t){const T=l.get(G.identifier);if(!T){$.push(G);continue}if(!g(T,G)){c.push(T.identifier),l.delete(T.identifier);continue}}const S=new R.$Dm(this.e),y=new R.$Dm(v);for(const G of this.e)y.has(G)||w.push(G);for(const G of v)S.has(G)||p.push(G);const C=N.$LF.createActivationEventsMap($),A={versionId:h,toRemove:c,toAdd:$,addActivationEvents:C,myToRemove:w,myToAdd:p};return this.delta(A),A}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:v,myToRemove:c,myToAdd:$}=h,w=new R.$Dm(t),p=new R.$Dm(c);for(let l=0;l<this.d.length;l++)w.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)p.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of v)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(R.$Cm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const v=N.$LF.readActivationEvents(t);for(const c of v)h.add(c)}return h}}e.$5F=O;function E(a){const h=new R.$Em;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function b(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class f{constructor(h,t,v,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=v,this.activationReason=c}}e.$8F=f;class r{constructor(h,t){this.description=h,this.value=t}}e.$9F=r;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,M.$kp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function n(a,h){return{identifier:new R.$Cm((0,M.$ip)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$_F=i}),define(Pe[225],Me([1,0,14,108,20,22,13,11]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=e.$sjc=e.$rjc=e.$qjc=e.$pjc=void 0;class d{static{this.NONE=new d(!1,-1,-1,-1)}constructor(s,n,i,a){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=a}}e.$pjc=d;class k{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$qjc=k;class O{constructor(s,n,i,a,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$rjc=O;class E extends O{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$sjc=E;class u extends O{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$tjc=u;class b extends O{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(s,n,i,a){this.g=a,this.a=s,this.b=n,this.c=i,this.d=new M.$Em,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new b(h));return this.c.onExtensionActivationError(s.id,h,new N.$4F(s.id.value)),t}const i=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const v=this.a.getExtensionDescription(h);if(v){if(!v.main&&!v.browser)continue;i.push(this.j({id:v.identifier,reason:s.reason}));continue}const c=n.displayName||n.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),w=this.k(s,n.displayName,[],new b($));return this.c.onExtensionActivationError(n.identifier,$,new N.$4F(h)),w}return this.k(s,n.displayName,i,null)}k(s,n,i,a){const h=new r(s.id,n,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return F.$E0b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$ujc=f,e.$ujc=f=Je([qe(3,R.$Nj)],f);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,i,a,h,t,v){this.c=s,this.d=n,this.f=i,this.g=a,this.h=h,this.j=t,this.k=v,this.a=new m.$gh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new b(n),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([qe(6,R.$Nj)],r)}),define(Pe[226],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Me([1,0,184,14,32,98,72,30,20,226,194,103]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0;const u=m.$Zn.as(R.$1n.JSONContribution);class b{constructor(h,t,v){this.a=h,this.b=t,this.c=v}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(M.default.Error,h)}warn(h){this.d(M.default.Warning,h)}info(h){this.d(M.default.Info,h)}}e.$UF=b;class f{static a(h){const t=new d.$Dm;for(let v=0,c=h.length;v<c;v++)t.add(h[v].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new f(t,[]);if(!t||!t.length)return new f([],h);const v=this.a(h),c=this.a(t),$=t.filter(p=>!v.has(p.description.identifier)),w=h.filter(p=>!c.has(p.description.identifier));return new f($,w)}constructor(h,t){this.added=h,this.removed=t}}e.$VF=f;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=f.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$1)(h)}}}e.$WF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$XF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$Bm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Eo}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Eo}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&E.$LF.register(h.extensionPoint,h.activationEventsGenerator),e.$XF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$XF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$YF=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$Zn.add(i.ExtensionsRegistry,new n),e.$ZF=m.$Zn.as(i.ExtensionsRegistry),u.registerSchema(s,e.$XF),u.registerSchema(O.$8j,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Pe[228],Me([1,0,180,16,26,227,33,5]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(u){function b(f,r,o){if(!f)return;const s=F.$Uf(f.type)?f.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const i of f.required)F.$Uf(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:f.properties?M.$Nn(f.properties):{},when:f.when?R.$fj.deserialize(f.when):void 0}}u.from=b})(k||(k={}));const O=N.$ZF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const f of u)f.type&&b.push(`onTaskType:${f.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:d}});class E{constructor(){this.d=new m.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{O.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const n=s.value;for(const i of n){const a=k.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=M.$Nn(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.$pH=new E}),define(Pe[229],Me([1,0,181,16,24,26,33,228]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$zH=e.JsonSchemaVersion=e.ExecutionEngine=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$tH=e.ShellQuoting=e.$sH=e.$rH=e.$qH=void 0,e.$qH="settings",e.$rH=new R.$yj("taskRunning",!1,I.localize(0,null)),e.$sH=I.localize2(2,"Tasks");var d;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$tH="$customized",function(P){function L(K){if(!K)return P.Strong;switch(K.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=L}(d||(e.ShellQuoting=d={}));var k;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var O;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(O||(e.RevealKind=O={})),function(P){function L(K){switch(K.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=L}(O||(e.RevealKind=O={}));var E;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(P){function L(K){switch(K.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=L}(E||(e.RevealProblemKind=E={}));var u;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(u||(e.PanelKind=u={})),function(P){function L(K){switch(K.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=L}(u||(e.PanelKind=u={}));var b;(function(P){P.defaults={echo:!0,reveal:O.Always,revealProblems:E.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var f;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(P){function L(ne){switch(ne.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=L;function K(ne){switch(ne){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=K}(f||(e.RuntimeType=f={}));var r;(function(P){function L(K){return F.$Uf(K)?K:K.value}P.value=L})(r||(e.CommandString=r={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function L(ne){return ne===P.Clean._id||ne===P.Build._id||ne===P.Rebuild._id||ne===P.Test._id}P.is=L;function K(ne){if(ne!==void 0)return F.$Uf(ne)?L(ne)?{_id:ne,isDefault:!1}:void 0:ne}P.from=K})(o||(e.TaskGroup=o={}));var s;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function L(K){switch(K){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=L})(n||(e.TaskSourceKind=n={}));var i;(function(P){P.parallel="parallel",P.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(L,K,ne,le,ye,Se){this._label="",this._id=L,K&&(this._label=K),ne&&(this.type=ne),this.runOptions=le,this.configurationProperties=ye,this._source=Se}getDefinition(L){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,K=!1){if(L===void 0)return!1;if(F.$Uf(L))return L===this._label||L===this.configurationProperties.identifier||K&&L===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.$uH=t;class v extends t{constructor(L,K,ne,le,ye,Se,he,be){super(L,ne,void 0,he,be,K),this.command={},this._source=K,this.hasDefinedMatchers=Se,ye&&(this.command=ye)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case f.Shell:K="shell";break;case f.Process:K="process";break;case f.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(L){return L instanceof v}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$qH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const L=this.d();if(!L)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ne={type:e.$tH,folder:L,id:K};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new v(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$vH=v;class c extends t{constructor(L,K,ne,le,ye,Se,he){super(L,ne,le,Se,he,K),this._source=K,this.configures=ye}static is(L){return L instanceof c}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$qH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const L=this.d();if(!L)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ne={type:e.$tH,folder:L,id:K};return JSON.stringify(ne)}}e.$wH=c;class $ extends t{constructor(L,K,ne,le,ye,Se,he,be,ee){super(L,ne,le,be,ee,K),this.defines=ye,this.hasDefinedMatchers=he,this.command=Se,this.icon=ee.icon,this.hide=ee.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof $}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new $(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$xH=$;class w extends t{constructor(L,K,ne,le,ye,Se){super(L,ne,le,ye,Se,K),this._source=K}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new w(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.$yH=w;var p;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(P){P._default=P.Terminal}(p||(e.ExecutionEngine=p={}));var l;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(L){this.c=new Map;for(let K=0;K<L.length;K++)this.c.set(L[K].uri.toString(),K)}compare(L,K){const ne=L.getWorkspaceFolder(),le=K.getWorkspaceFolder();if(ne&&le){let ye=this.c.get(ne.uri.toString());ye=ye===void 0?0:ye+1;let Se=this.c.get(le.uri.toString());return Se=Se===void 0?0:Se+1,ye===Se?L._label.localeCompare(K._label):ye-Se}else return!ne&&le?-1:ne&&!le?1:0}}e.$zH=D;var g;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(g||(e.TaskEventKind=g={}));var S;(function(P){P.SingleRun="singleRun",P.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(P){function L(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function K(be,ee,pe){return{...L(be),kind:"start",terminalId:ee,resolvedVariables:pe}}P.start=K;function ne(be,ee,pe){return{...L(be),kind:"processStarted",terminalId:ee,processId:pe}}P.processStarted=ne;function le(be,ee,pe){return{...L(be),kind:"processEnded",terminalId:ee,exitCode:pe}}P.processEnded=le;function ye(be,ee,pe){return{...L(be),kind:"terminated",exitReason:pe,terminalId:ee}}P.terminated=ye;function Se(be,ee,pe){return{...L(ee),kind:be,terminalId:pe}}P.general=Se;function he(){return{kind:"changed"}}P.changed=he})(C||(e.TaskEvent=C={}));var A;(function(P){function L(ne){const le=Object.keys(ne).sort();let ye="";for(const Se of le){let he=ne[Se];he instanceof Object?he=L(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),ye+=Se+","+he+","}return ye}function K(ne){const ye={_key:L(ne),type:ne.taskType};return Object.assign(ye,ne),ye}P.create=K})(A||(e.KeyedTaskIdentifier=A={}));var G;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var T;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var W;(function(P){function L(K,ne){const le=m.$pH.get(K.type);if(le===void 0){const be=N.$Nn(K);return delete be._key,A.create(be)}const ye=Object.create(null);ye.type=le.taskType;const Se=new Set;le.required.forEach(be=>Se.add(be));const he=le.properties;for(const be of Object.keys(he)){const ee=K[be];if(ee!=null)ye[be]=ee;else if(Se.has(be)){const pe=he[be];if(pe.default!==void 0)ye[be]=N.$Nn(pe.default);else switch(pe.type){case"boolean":ye[be]=!1;break;case"number":case"integer":ye[be]=0;break;case"string":ye[be]="";break;default:ne.error(I.localize(1,null,JSON.stringify(K,void 0,0),be));return}}}return A.create(ye)}P.createTaskIdentifier=L})(W||(e.TaskDefinition=W={}))}),define(Pe[230],Me([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=e.$I0b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$I0b=F;class M extends F{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$J0b=M}),define(Pe[50],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$aw=void 0,e.$bw=M,e.$cw=N;class I{static{this.count=0}constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++I.count}}e.$aw=I;const F=[];function M(m){const d=new I(m);return F[d.nid]=d,d}function N(m){return F[m].sid}class R{constructor(d){this.value=d}}e.$dw=R}),define(Pe[4],Me([1,0,50]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$hM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(M||(e.TabInputKind=M={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var d;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var O;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class E{static{this.a=0}static mixin(o){return o._id=E.a++,o}}e.$hM=E;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$iM={MainThreadAuthentication:(0,I.$bw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$bw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$bw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$bw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$bw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$bw)("MainThreadClipboard"),MainThreadCommands:(0,I.$bw)("MainThreadCommands"),MainThreadComments:(0,I.$bw)("MainThreadComments"),MainThreadConfiguration:(0,I.$bw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$bw)("MainThreadConsole"),MainThreadDebugService:(0,I.$bw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$bw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$bw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$bw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$bw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$bw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$bw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$bw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$bw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$bw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$bw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$bw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$bw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$bw)("MainThreadLanguages"),MainThreadLogger:(0,I.$bw)("MainThreadLogger"),MainThreadMessageService:(0,I.$bw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$bw)("MainThreadOutputService"),MainThreadProgress:(0,I.$bw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$bw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$bw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$bw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$bw)("MainThreadSecretState"),MainThreadStorage:(0,I.$bw)("MainThreadStorage"),MainThreadSpeech:(0,I.$bw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$bw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$bw)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$bw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$bw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$bw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$bw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$bw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$bw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$bw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$bw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$bw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$bw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$bw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$bw)("MainThreadSCM"),MainThreadSearch:(0,I.$bw)("MainThreadSearch"),MainThreadShare:(0,I.$bw)("MainThreadShare"),MainThreadTask:(0,I.$bw)("MainThreadTask"),MainThreadWindow:(0,I.$bw)("MainThreadWindow"),MainThreadLabelService:(0,I.$bw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$bw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$bw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$bw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$bw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$bw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$bw)("MainThreadInteractive"),MainThreadChat:(0,I.$bw)("MainThreadChat"),MainThreadInlineChat:(0,I.$bw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$bw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$bw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$bw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$bw)("MainThreadTimeline"),MainThreadTesting:(0,I.$bw)("MainThreadTesting"),MainThreadLocalization:(0,I.$bw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$bw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$bw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$bw)("MainThreadIssueReporter")},e.$jM={ExtHostCommands:(0,I.$bw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$bw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$bw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$bw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$bw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$bw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$bw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$bw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$bw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$bw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$bw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$bw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$bw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$bw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$bw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$bw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$bw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$bw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$bw)("ExtHostStatusBar"),ExtHostShare:(0,I.$bw)("ExtHostShare"),ExtHostExtensionService:(0,I.$bw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$bw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$bw)("ExtHostTerminalService"),ExtHostSCM:(0,I.$bw)("ExtHostSCM"),ExtHostSearch:(0,I.$bw)("ExtHostSearch"),ExtHostTask:(0,I.$bw)("ExtHostTask"),ExtHostWorkspace:(0,I.$bw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$bw)("ExtHostWindow"),ExtHostWebviews:(0,I.$bw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$bw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$bw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$bw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$bw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$bw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$bw)("ExtHostProgress"),ExtHostComments:(0,I.$bw)("ExtHostComments"),ExtHostSecretState:(0,I.$bw)("ExtHostSecretState"),ExtHostStorage:(0,I.$bw)("ExtHostStorage"),ExtHostUrls:(0,I.$bw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$bw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$bw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$bw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$bw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$bw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$bw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$bw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$bw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$bw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$bw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$bw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$bw)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$bw)("ExtHostChat"),ExtHostChatAgents2:(0,I.$bw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$bw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$bw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$bw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$bw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$bw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$bw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$bw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$bw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$bw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$bw)("ExtHostTimeline"),ExtHostTesting:(0,I.$bw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$bw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$bw)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$bw)("ExtHostIssueReporter")}}),define(Pe[78],Me([1,0,3,13,4,17]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=void 0,e.$Lic=(0,I.$hi)("IExtHostApiDeprecationService");let R=class{constructor(d,k){this.c=k,this.a=new Set,this.b=d.getProxy(M.$iM.MainThreadTelemetry)}report(d,k,O){const E=this.d(d,k);this.a.has(E)||(this.a.add(E),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:d}))}d(d,k){return`${d}-${k.identifier.value}`}};e.$Mic=R,e.$Mic=R=Je([qe(0,N.$CO),qe(1,F.$Nj)],R),e.$Nic=Object.freeze(new class{report(m,d,k){}})}),define(Pe[231],Me([1,0,39,6,4]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class N{static{this.a=0}constructor(d,k){this.extension=d,this.provider=k,this.handle=N.a++}}class R{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(M.$iM.MainThreadChat)}registerChatProvider(d,k,O){const E=new N(d,O);return this.b.set(E.handle,E),this.d.$registerChatProvider(E.handle,k),(0,F.$Sc)(()=>{this.d.$unregisterChatProvider(E.handle),this.b.delete(E.handle)})}transferChatSession(d,k){const O=I.Iterable.find(this.c.keys(),E=>this.c.get(E)===d)??0;typeof O=="number"&&this.d.$transferChatSession(O,k)}async $prepareChat(d,k){const O=this.b.get(d);if(!O)return;const E=await O.provider.prepareSession(k);if(!E)return;const u=R.a++;return this.c.set(u,E),{id:u}}$releaseSession(d){this.c.delete(d)}}e.$Yic=R}),define(Pe[232],Me([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class F{constructor(N){const R=N.getProxy(I.$iM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$4ic=F}),define(Pe[233],Me([1,0,26,4,27,17]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;let R=class{constructor(O,E){this.a=O.getProxy(F.$iM.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(O,E){const u=this,b=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){u.e(O,E,b,arguments)}})}e(O,E,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:d(b,this.b)}),this.c&&this.f(O,u,b)}};e.$Ukc=R,e.$Ukc=R=Je([qe(0,N.$CO),qe(1,M.$SO)],R);const m=1e5;function d(k,O){const E=[];if(k.length)for(let u=0;u<k.length;u++){let b=k[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}E.push(b)}if(O){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$Sn)(E);return u.length>m?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[234],Me([1,0,2,4,22]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class N{constructor(m){this.a=m.getProxy(F.$iM.MainThreadDialogs)}showOpenDialog(m,d){return d?.allowUIResources&&(0,M.$7F)(m,"showLocal"),this.a.$showOpenDialog(d).then(k=>k?k.map(O=>I.URI.revive(O)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(d=>d?I.URI.revive(d):void 0)}}e.$Yjc=N}),define(Pe[235],Me([1,0,6,4]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(F.$iM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$hkc=M}),define(Pe[79],Me([1,0,21,15,2,3,13,4,27,17]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=e.$Gjc=void 0;let O=class{constructor(u,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(m.$iM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,b){const{message:f,args:r,comment:o}=b;if(this.c)return(0,F.$We)(f,r??{});let s=f;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$We)(n??f,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const f=await this.g(u);if(!f){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),o=JSON.parse(r);b=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${f}: ${r.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:f})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return M.URI.revive(b)}return u.l10n?M.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Gjc=O,e.$Gjc=O=Je([qe(0,d.$SO),qe(1,k.$CO),qe(2,R.$Nj)],O),e.$Hjc=(0,N.$hi)("IExtHostLocalizationService")}),define(Pe[236],Me([1,0,13,4,27,17,2,52]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=void 0;let d=class extends I.$Yj{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,m.$Qh)(b))),this.r=E.getProxy(F.$iM.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(R.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,b){return new k(this.r,E,u,b)}};e.$Tkc=d,e.$Tkc=d=Je([qe(0,N.$CO),qe(1,M.$SO)],d);class k extends I.$Tj{constructor(E,u,b,f){super(f?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,f).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const b=[[E,u]];this.m?this.u(b):this.n.push(...b)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Me([1,0,4,3,6,17,23]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=e.$Ijc=void 0,e.$Ijc=(0,F.$hi)("IExtHostManagedSockets");let m=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(I.$iM.MainThreadManagedSockets)}setFactory(E,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,b=await this.c.makeConnection(),f=new M.$Tc;return this.d.set(u,new k(u,b,f)),f.add((0,M.$Sc)(()=>this.d.delete(u))),f.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),f.dispose()})),f.add(b.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),f.dispose()})),f.add(b.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,R.$ue.wrap(r)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$Jjc=m,e.$Jjc=m=Je([qe(0,N.$CO)],m);class d{constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class k extends M.$Uc{constructor(E,u,b){super(),this.socketId=E,this.actual=u,this.B(b)}}}),define(Pe[237],Me([1,0,4,13,22]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;function N(m){return m&&m.title}let R=class{constructor(d,k){this.b=k,this.a=d.getProxy(I.$iM.MainThreadMessageService)}showMessage(d,k,O,E,u){const b={source:{identifier:d.identifier,label:d.displayName||d.name}};let f;typeof E=="string"||N(E)?f=[E,...u]:(b.modal=E?.modal,b.useCustom=E?.useCustom,b.detail=E?.detail,f=u),b.useCustom&&(0,M.$7F)(d,"resolvers");const r=[];let o=!1;for(let s=0;s<f.length;s++){const n=f[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:a}=n;r.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,O,b,r).then(s=>{if(typeof s=="number")return f[s]})}};e.$jkc=R,e.$jkc=R=Je([qe(1,F.$Nj)],R)}),define(Pe[238],Me([1,0,6,16,2,22,4]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class m{constructor(k){this.b=new Map,this.a=k.getProxy(R.$iM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,O,E){if((0,N.$7F)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,E),this.a.$registerProfileContentHandler(O,E.name,E.description,k.identifier.value),(0,I.$Sc)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,E,u){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(O,E,u)}async $readProfile(k,O,E){const u=this.b.get(k);if(!u)throw new Error(`Unknown handler with id: ${k}`);return u.readProfile((0,F.$Uf)(O)?O:M.URI.revive(O),E)}}e.$skc=m}),define(Pe[81],Me([1,0,4,5,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=void 0;class N{constructor(m){this.b=new F.$7d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(I.$iM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,d){return this.a.$getPassword(m,d)}store(m,d,k){return this.a.$setPassword(m,d,k)}delete(m,d){return this.a.$deletePassword(m,d)}}e.$Djc=N,e.$Ejc=(0,M.$hi)("IExtHostSecretState")}),define(Pe[239],Me([1,0,25,6,4]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class N{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(M.$iM.MainThreadSpeech)}async $createSpeechToTextSession(m,d,k){const O=this.c.get(m);if(!O)return;const E=new F.$Tc,u=new I.$ee;this.d.set(d,u);const b=E.add(O.provideSpeechToTextSession(u.token,k?{language:k}:void 0));E.add(b.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,f)})),E.add(u.token.onCancellationRequested(()=>E.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,d){const k=this.c.get(m);if(!k)return;const O=new F.$Tc,E=new I.$ee;this.d.set(d,E);const u=O.add(k.provideKeywordRecognitionSession(E.token));O.add(u.onDidChange(b=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,b)})),O.add(E.token.onCancellationRequested(()=>O.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,d,k){const O=N.a++;return this.c.set(O,k),this.b.$registerProvider(O,d,{extension:m,displayName:m.value}),(0,F.$Sc)(()=>{this.b.$unregisterProvider(O),this.c.delete(O)})}}e.$zkc=N}),define(Pe[82],Me([1,0,4,5,3]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$vjc=void 0;class N{constructor(m,d){this.c=d,this.b=new F.$7d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(I.$iM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,d){this.a.$registerExtensionStorageKeysToSync(m,d)}async initializeExtensionStorage(m,d,k){const O=await this.a.$initializeExtensionStorage(m,d);let E;return O&&(E=this.d(m,d,O)),E||k}setValue(m,d,k){return this.a.$setValue(m,d,k)}$acceptValue(m,d,k){const O=this.d(m,d,k);O&&this.b.fire({shared:m,key:d,value:O})}d(m,d,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${O}`)}}}e.$vjc=N,e.$wjc=(0,M.$hi)("IExtHostStorage")}),define(Pe[240],Me([1,0,6,12,2,4]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(d){this.c=new Map,this.b=d.getProxy(N.$iM.MainThreadUriOpeners)}registerExternalUriOpener(d,k,O,E){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const u=E.schemes.find(b=>!R.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,E.schemes,d,E.label),(0,I.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(d,k,O){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener with id: ${d}`);const u=M.URI.revive(k);return E.canOpenExternalUri(u,O)}async $openUri(d,k,O){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener id: '${d}'`);return E.openExternalUri(M.URI.revive(k.resolvedUri),{sourceUri:M.URI.revive(k.sourceUri)},O)}}e.$Nkc=R}),define(Pe[241],Me([1,0,4,2,6,14,20]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class m{static{this.a=0}constructor(k){this.c=new R.$Dm,this.d=new Map,this.b=k.getProxy(I.$iM.MainThreadUrls)}registerUriHandler(k,O){const E=k.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=m.a++;return this.c.add(E),this.d.set(u,O),this.b.$registerUriHandler(u,E,k.displayName||k.name),(0,M.$Sc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(k,O){const E=this.d.get(k);if(!E)return Promise.resolve(void 0);try{E.handleUri(F.URI.revive(O))}catch(u){(0,N.$1)(u)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this.b.$createAppUri(k))}}e.$Okc=m}),define(Pe[62],Me([1,0,5,6,12,26,2,187,209,76,4]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=e.$gjc=void 0,e.$hjc=u,e.$jjc=r,e.$kjc=o;class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,v,c,$,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$7d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=v,this.#s=c,this.#r=$,this.#l=u($),this.#d=b($),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,k.$Oyb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===M.Schemas.https||a.scheme===M.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$Nyb}return k.$Nyb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),N.$Rn(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,d.$Lnb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,w,p,l)=>{const D=R.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),g=(0,k.$Oyb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,w,p,l)=>{const D=R.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),g=(0,k.$Oyb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`})}}e.$gjc=E;function u(i){try{const a=(0,m.$tp)((0,m.$sp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function b(i){try{const a=(0,m.$tp)((0,m.$sp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class f extends F.$Uc{constructor(a,h,t,v,c){super(),this.c=h,this.f=t,this.g=v,this.h=c,this.b=new Map,this.a=a.getProxy(O.$iM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const v=this.j(a);if(v){const{message:c}=(0,d.$Mnb)(h,t.value);v._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const v=new E(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,v);const c=v._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$ijc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>R.URI.from(a))}}function n(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Pe[109],Me([1,0,5,4,2,12,15,3,17,22]),function(me,e,I,F,M,N,R,m,d,k){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0;let E=class{static{O=this}static{this.a={focused:!0,active:!0}}getState(b){const f=this.d;return{get focused(){return f.focused},get active(){return(0,k.$7F)(b,"windowActivity"),f.active}}}constructor(b){this.c=new I.$7d,this.onDidChangeWindowState=this.c.event,this.d=O.a,this.b=b.getProxy(F.$iM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:f,isActive:r})=>{this.onDidChangeWindowProperty("focused",f),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,f){f!==this.d[b]&&(this.d={...this.d,[b]:f},this.c.fire(this.d))}openUri(b,f){let r;if(typeof b=="string"){r=b;try{b=M.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,R.$Ue)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,r,f)}async asExternalUri(b,f){if((0,R.$Ue)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(b,f);return M.URI.from(r)}};e.$Qkc=E,e.$Qkc=E=O=Je([qe(0,d.$CO)],E),e.$Rkc=(0,m.$hi)("IExtHostWindow")}),define(Pe[242],Me([1,0,233,27,17]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;let N=class extends I.$Ukc{constructor(m,d){super(m,d)}f(m,d,k){d.apply(console,k)}};e.$3mc=N,e.$3mc=N=Je([qe(0,M.$CO),qe(1,F.$SO)],N)}),define(Pe[243],Me([1,0,11,23,25,14,5,6,143,230,50]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.ResponsiveState=e.RequestInitiator=void 0,e.$K0b=o,e.$L0b=s;function u(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class r{constructor(C,A){this.jsonString=C,this.referencedBuffers=A}}function o(y,C=null,A=!1){const G=[];return{jsonString:(A?u:JSON.stringify)(y,(W,P)=>{if(typeof P>"u")return f;if(typeof P=="object"){if(P instanceof F.$ue){const L=G.push(P)-1;return{[b]:L}}if(C)return C(W,P)}return P}),referencedBuffers:G}}function s(y,C,A){return JSON.parse(y,(G,T)=>{if(T){const W=T[b];if(typeof W=="number")return C[W];if(A&&T.$mid===1)return A.transformIncoming(T)}return T})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,A)=>A&&A.$mid===1?y.transformOutgoing(A):A:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},v=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends m.$Uc{static{E=v}static{this.a=3*1e3}constructor(C,A=null,G=null){super(),this[E]=!0,this.b=this.B(new R.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=A,this.g=G,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,W=O.$aw.count;T<W;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$th(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const A=this.w[C];delete this.w[C],A.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,d.$mn)(C,this.g):C}getProxy(C){const{nid:A,sid:G}=C;return this.s[A]||(this.s[A]=this.J(A,G)),this.s[A]}J(C,A){const G={get:(T,W)=>(typeof W=="string"&&!T[W]&&W.charCodeAt(0)===36&&(T[W]=(...P)=>this.U(C,W,P)),W===c?A:T[W])};return new Proxy(Object.create(null),G)}set(C,A){return this.m[C.nid]=A,A}assertRegistered(C){for(let A=0,G=C.length;A<G;A++){const T=C[A];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(C){if(this.j)return;const A=C.byteLength,G=p.read(C,0),T=G.readUInt8(),W=G.readUInt32();switch(T){case 1:case 2:{let{rpcId:P,method:L,args:K}=D.deserializeRequestJSONArgs(G);this.g&&(K=(0,d.$mn)(K,this.g)),this.M(A,W,P,L,K,T===2);break}case 3:case 4:{let{rpcId:P,method:L,args:K}=D.deserializeRequestMixedArgs(G);this.g&&(K=(0,d.$mn)(K,this.g)),this.M(A,W,P,L,K,T===4);break}case 5:{this.f?.logIncoming(A,W,0,"ack"),this.G(W);break}case 6:{this.N(A,W);break}case 7:{this.O(A,W,void 0);break}case 9:{let P=D.deserializeReplyOKJSON(G);this.g&&(P=(0,d.$mn)(P,this.g)),this.O(A,W,P);break}case 10:{const P=D.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(A,W,P);break}case 8:{const P=D.deserializeReplyOKVSBuffer(G);this.O(A,W,P);break}case 11:{let P=D.deserializeReplyErrError(G);this.g&&(P=(0,d.$mn)(P,this.g)),this.P(A,W,P);break}case 12:{this.P(A,W,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,A,G,T,W,P){this.f?.logIncoming(C,A,1,`receiveRequest ${(0,O.$cw)(G)}.${T}(`,W);const L=String(A);let K,ne;if(P){const ye=new M.$ee;W.push(ye.token),K=this.Q(G,T,W),ne=()=>ye.cancel()}else K=this.Q(G,T,W),ne=t;this.u[L]=ne;const le=D.serializeAcknowledged(A);this.f?.logOutgoing(le.byteLength,A,1,"ack"),this.c.send(le),K.then(ye=>{delete this.u[L];const Se=D.serializeReplyOK(A,ye,this.h);this.f?.logOutgoing(Se.byteLength,A,1,"reply:",ye),this.c.send(Se)},ye=>{delete this.u[L];const Se=D.serializeReplyErr(A,ye);this.f?.logOutgoing(Se.byteLength,A,1,"replyErr:",ye),this.c.send(Se)})}N(C,A){this.f?.logIncoming(C,A,1,"receiveCancel");const G=String(A);this.u[G]?.()}O(C,A,G){this.f?.logIncoming(C,A,0,"receiveReply:",G);const T=String(A);if(!this.w.hasOwnProperty(T))return;const W=this.w[T];delete this.w[T],W.resolveOk(G)}P(C,A,G){this.f?.logIncoming(C,A,0,"receiveReplyErr:",G);const T=String(A);if(!this.w.hasOwnProperty(T))return;const W=this.w[T];delete this.w[T];let P;G&&(G.$isError?(P=new Error,P.name=G.name,P.message=G.message,P.stack=G.stack):P=G),W.resolveErr(P)}Q(C,A,G){try{return Promise.resolve(this.S(C,A,G))}catch(T){return Promise.reject(T)}}S(C,A,G){const T=this.m[C];if(!T)throw new Error("Unknown actor "+(0,O.$cw)(C));const W=T[A];if(typeof W!="function")throw new Error("Unknown method "+A+" on actor "+(0,O.$cw)(C));return W.apply(T,G)}U(C,A,G){if(this.j)return new k.$J0b;let T=null;if(G.length>0&&M.CancellationToken.isCancellationToken(G[G.length-1])&&(T=G.pop()),T&&T.isCancellationRequested)return Promise.reject(N.$6());const W=D.serializeRequestArguments(G,this.h),P=++this.t,L=String(P),K=new k.$I0b,ne=new m.$Tc;T&&ne.add(T.onCancellationRequested(()=>{const ye=D.serializeCancel(P);this.f?.logOutgoing(ye.byteLength,P,0,"cancel"),this.c.send(D.serializeCancel(P))})),this.w[L]=new w(K,ne),this.F(P);const le=D.serializeRequest(P,C,A,W,!!T);return this.f?.logOutgoing(le.byteLength,P,0,`request: ${(0,O.$cw)(C)}.${A}(`,G),this.c.send(le),K}}e.$M0b=$;class w{constructor(C,A){this.a=C,this.b=A}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class p{static alloc(C,A,G){const T=new p(F.$ue.alloc(G+1+4),0);return T.writeUInt8(C),T.writeUInt32(A),T}static read(C,A){return new p(C,A)}get buffer(){return this.a}constructor(C,A){this.a=C,this.b=A}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+C).toString();return this.b+=C,G}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+C).toString();return this.b+=C,G}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const A=this.a.slice(this.b,this.b+C);return this.b+=C,A}static sizeMixedArray(C){let A=0;A+=1;for(let G=0,T=C.length;G<T;G++){const W=C[G];switch(A+=1,W.type){case 1:A+=this.sizeLongString(W.value);break;case 2:A+=this.sizeVSBuffer(W.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(W.value);for(let P=0;P<W.buffers.length;++P)A+=this.sizeVSBuffer(W.buffers[P]);break;case 4:break}}return A}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let A=0,G=C.length;A<G;A++){const T=C[A];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let W=0;W<T.buffers.length;++W)this.writeBuffer(T.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const A=new Array(C);for(let G=0;G<C;G++)switch(this.readUInt8()){case 1:A[G]=this.readLongString();break;case 2:A[G]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),P=this.readLongString(),L=[];for(let K=0;K<W;++K)L.push(this.readVSBuffer());A[G]=new O.$dw(s(P,L,null));break}case 4:A[G]=void 0;break}return A}}var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class D{static a(C){for(let A=0,G=C.length;A<G;A++)if(C[A]instanceof F.$ue||C[A]instanceof O.$dw||typeof C[A]>"u")return!0;return!1}static serializeRequestArguments(C,A){if(this.a(C)){const G=[];for(let T=0,W=C.length;T<W;T++){const P=C[T];if(P instanceof F.$ue)G[T]={type:2,value:P};else if(typeof P>"u")G[T]={type:4};else if(P instanceof O.$dw){const{jsonString:L,referencedBuffers:K}=o(P.value,A);G[T]={type:3,value:F.$ue.fromString(L),buffers:K}}else G[T]={type:1,value:F.$ue.fromString(n(P,A))}}return{type:1,args:G}}return{type:0,args:n(C,A)}}static serializeRequest(C,A,G,T,W){switch(T.type){case 0:return this.b(C,A,G,T.args,W);case 1:return this.c(C,A,G,T.args,W)}}static b(C,A,G,T,W){const P=F.$ue.fromString(G),L=F.$ue.fromString(T);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(P),K+=p.sizeLongString(L);const ne=p.alloc(W?2:1,C,K);return ne.writeUInt8(A),ne.writeShortString(P),ne.writeLongString(L),ne.buffer}static deserializeRequestJSONArgs(C){const A=C.readUInt8(),G=C.readShortString(),T=C.readLongString();return{rpcId:A,method:G,args:JSON.parse(T)}}static c(C,A,G,T,W){const P=F.$ue.fromString(G);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(P),L+=p.sizeMixedArray(T);const K=p.alloc(W?4:3,C,L);return K.writeUInt8(A),K.writeShortString(P),K.writeMixedArray(T),K.buffer}static deserializeRequestMixedArgs(C){const A=C.readUInt8(),G=C.readShortString(),T=C.readMixedArray(),W=new Array(T.length);for(let P=0,L=T.length;P<L;P++){const K=T[P];typeof K=="string"?W[P]=JSON.parse(K):W[P]=K}return{rpcId:A,method:G,args:W}}static serializeAcknowledged(C){return p.alloc(5,C,0).buffer}static serializeCancel(C){return p.alloc(6,C,0).buffer}static serializeReplyOK(C,A,G){if(typeof A>"u")return this.d(C);if(A instanceof F.$ue)return this.e(C,A);if(A instanceof O.$dw){const{jsonString:T,referencedBuffers:W}=o(A.value,G,!0);return this.g(C,T,W)}else return this.f(C,u(A,G))}static d(C){return p.alloc(7,C,0).buffer}static e(C,A){let G=0;G+=p.sizeVSBuffer(A);const T=p.alloc(8,C,G);return T.writeVSBuffer(A),T.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,A){const G=F.$ue.fromString(A);let T=0;T+=p.sizeLongString(G);const W=p.alloc(9,C,T);return W.writeLongString(G),W.buffer}static g(C,A,G){const T=F.$ue.fromString(A);let W=0;W+=p.sizeUInt32,W+=p.sizeLongString(T);for(const L of G)W+=p.sizeVSBuffer(L);const P=p.alloc(10,C,W);P.writeUInt32(G.length),P.writeLongString(T);for(const L of G)P.writeBuffer(L);return P.buffer}static deserializeReplyOKJSON(C){const A=C.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(C,A){const G=C.readUInt32(),T=C.readLongString(),W=[];for(let P=0;P<G;++P)W.push(C.readVSBuffer());return new O.$dw(s(T,W,A))}static serializeReplyErr(C,A){const G=A?u(N.$3(A),null):void 0;if(typeof G!="string")return this.h(C);const T=F.$ue.fromString(G);let W=0;W+=p.sizeLongString(T);const P=p.alloc(11,C,W);return P.writeLongString(T),P.buffer}static deserializeReplyErrError(C){const A=C.readLongString();return JSON.parse(A)}static h(C){return p.alloc(12,C,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Pe[244],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;const I=function(N){const R=m=>{globalThis.removeEventListener("message",R);const d=m.data;Object.defineProperties(globalThis,{postMessage:{value(k,O){d.postMessage(k,O)}},onmessage:{get(){return d.onmessage},set(k){d.onmessage=k}}}),d.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(N,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${I})('${R}'))`,k=new Blob([d],{type:"application/javascript"}),O=URL.createObjectURL(k),E=new MessageChannel,u=O,b={type:"_newWorker",id:u,port:E.port2,url:O,options:m};N(b,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(O),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(f){E.port1.onmessage=f}},onmessageerror:{get(){return E.port1.onmessageerror},set(f){E.port1.onmessageerror=f}}}),E.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),E.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),E.port1.start()}}e.$5mc=F}),define(Pe[245],Me([1,0,23,28,12,54,3]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$WJ=void 0,e.$XJ=O,e.$YJ=E,e.$WJ=(0,R.$hi)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${m.join("")}]+`),k=7;function O(b){if(b.scheme!==M.Schemas.vscodeNotebookCell)return;const f=b.fragment.indexOf("s");if(f<0)return;const r=parseInt(b.fragment.substring(0,f).replace(d,""),k),o=(0,I.$Ne)(b.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:o,fragment:null})}}function E(b,f){const r=f.toString(k),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,I.$Oe)(I.$ue.fromString(b.scheme),!0,!0)}`;return b.with({scheme:M.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new F.$Bc}getNotebook(f){if(f.scheme===M.Schemas.vscodeNotebookCell){const r=O(f);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$ZJ=u,(0,N.$fs)(e.$WJ,u,1)}),define(Pe[83],Me([1,0,23,35,39,69,12,19,21,33,245]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$eK=e.CellStatusbarAlignment=e.$dK=e.NotebookEditorPriority=e.$aK=e.$_J=e.$0J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$9J=e.$8J=e.$7J=e.$6J=e.CellKind=e.$5J=e.$4J=e.$3J=void 0,e.$$J=v,e.$bK=$,e.$cK=w,e.$fK=D,e.$gK=S,e.$3J="workbench.editor.notebook",e.$4J="workbench.editor.notebookTextDiffEditor",e.$5J="workbench.editor.interactive";var E;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(E||(e.CellKind=E={})),e.$6J=["application/json","application/javascript","text/html","image/svg+xml",N.$ys.latex,N.$ys.markdown,"image/png","image/jpeg",N.$ys.text],e.$7J=[N.$ys.latex,N.$ys.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$ys.text],e.$8J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$9J="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var b;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var f;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(K){K.scheme=R.Schemas.vscodeNotebookCell;function ne(ee,pe){return(0,O.$YJ)(ee,pe)}K.generate=ne;function le(ee){return(0,O.$XJ)(ee)}K.parse=le;function ye(ee,pe){return ee.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${ee.scheme!==R.Schemas.file?ee.scheme:""}`})}K.generateCellOutputUri=ye;function Se(ee){if(ee.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!pe)return;const re=pe[1]&&pe[1]!==""?pe[1]:void 0,fe=pe[2];return{outputId:re,notebook:ee.with({scheme:fe||R.Schemas.file,fragment:null})}}K.parseCellOutputUri=Se;function he(ee,pe,re){return K.generate(ee,pe).with({scheme:re})}K.generateCellPropertyUri=he;function be(ee,pe){if(ee.scheme===pe)return K.parse(ee.with({scheme:K.scheme}))}K.parseCellPropertyUri=be})(a||(e.CellUri=a={}));const h=K=>d.$i?K.replace(/\//g,"\\"):K;class t{constructor(ne=[],le=e.$6J){this.e=le,this.d=[...new Set(ne)].map(ye=>({pattern:ye,matches:F.$bk(h(ye))}))}sort(ne){const le=new Map(M.Iterable.map(ne,Se=>[Se,h(Se)]));let ye=[];for(const{matches:Se}of this.d)for(const[he,be]of le)if(Se(be)){ye.push(he),le.delete(he);break}return le.size&&(ye=ye.concat([...le.keys()].sort((Se,he)=>this.e.indexOf(Se)-this.e.indexOf(he)))),ye}prioritize(ne,le){const ye=this.f(ne);if(ye===-1){this.d.unshift({pattern:ne,matches:F.$bk(h(ne))});return}const Se=new Set(le.map(be=>this.f(be,ye)));Se.delete(-1);const he=Array.from(Se).sort();this.d.splice(ye+1,0,...he.map(be=>this.d[be]));for(let be=he.length-1;be>=0;be--)this.d.splice(he[be],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,le=this.d.length){const ye=h(ne);for(let Se=0;Se<le;Se++)if(this.d[Se].matches(ye))return Se;return-1}}e.$0J=t;function v(K,ne,le,ye=(Se,he)=>Se===he){const Se=[];function he(pe,re,fe){if(re===0&&fe.length===0)return;const V=Se[Se.length-1];V&&V.start+V.deleteCount===pe?(V.deleteCount+=re,V.toInsert.push(...fe)):Se.push({start:pe,deleteCount:re,toInsert:fe})}let be=0,ee=0;for(;;){if(be===K.length){he(be,0,ne.slice(ee));break}if(ee===ne.length){he(be,K.length-be,[]);break}const pe=K[be],re=ne[ee];if(ye(pe,re)){be+=1,ee+=1;continue}le(re)?(he(be,1,[]),be+=1):(he(be,0,[re]),ee+=1)}return Se}e.$_J=new k.$yj("notebookEditorCursorAtBoundary","none"),e.$aK=new k.$yj("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(K){const ne=K;return!!((typeof ne.include=="string"||F.$ck(ne.include))&&(typeof ne.exclude=="string"||F.$ck(ne.exclude)))}function w(K,ne,le){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ne)>=0||K.viewType===ne)return!0;if(K.filenamePattern){const ye=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Se=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(F.$ak(ye,(0,m.$oc)(le.fsPath).toLowerCase()))return!(Se&&F.$ak(Se,(0,m.$oc)(le.fsPath).toLowerCase()))}return!1}e.$dK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class l{static{this.d="notebook/"}static create(ne){return`${l.d}${ne}`}static parse(ne){if(ne.startsWith(l.d))return ne.substring(l.d.length)}}e.$eK=l;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const g=new TextDecoder;function S(K){const ne=[];let le=!1;for(const be of K)(ne.length===0||le)&&(ne.push(be),le=!0);let ye=A(ne);const Se=I.$ue.concat(ne.map(be=>I.$ue.wrap(be))),he=L(Se);return ye=ye||he.byteLength!==Se.byteLength,{data:he,didCompression:ye}}e.$hK="\x1B[A";const y=e.$hK.split("").map(K=>K.charCodeAt(0)),C=10;function A(K){let ne=!1;return K.forEach((le,ye)=>{if(ye===0||le.length<e.$hK.length)return;const Se=K[ye-1],he=le.subarray(0,e.$hK.length);if(he[0]===y[0]&&he[1]===y[1]&&he[2]===y[2]){const be=Se.lastIndexOf(C);if(be===-1)return;ne=!0,K[ye-1]=Se.subarray(0,be),K[ye]=le.subarray(e.$hK.length)}}),ne}function G(K){let ne=K;do K=ne,ne=K.replace(/[^\n]\x08/gm,"");while(ne.length<K.length);return K}function T(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ne=K.match(/^(.*)\r+/m)[1];let le=K.match(/\r+(.*)$/m)[1];le=le+ne.slice(le.length,ne.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return K}const W=8,P=13;function L(K){return!K.buffer.includes(W)&&!K.buffer.includes(P)?K:I.$ue.fromString(T(G(g.decode(K.buffer))))}}),define(Pe[7],Me([1,0,18,14,53,28,69,15,16,2,34,20,43,102,83]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f){"use strict";var r,o,s,n,i,a,h,t,v,c,$,w,p,l,D,g,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$qO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$pO=e.$oO=e.$nO=e.$mO=e.ChatLocation=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$dO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.TestRunProfileKind=e.TestResultState=e.$VN=e.$UN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$TN=e.NotebookVariablesRequestKind=e.$SN=e.$RN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$QN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.ColorThemeKind=e.$KN=e.$JN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$IN=e.$HN=e.DebugConsoleMode=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BN=e.$AN=e.FileChangeType=e.$zN=e.NewSymbolNameTag=e.$yN=e.$xN=e.$wN=e.$vN=e.InlineCompletionTriggerKind=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$iN=e.ConfigurationTarget=e.$hN=e.$gN=e.$fN=e.$eN=e.DocumentPasteTriggerKind=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$0M=e.ViewBadge=e.ProgressLocation=e.$9M=e.$8M=e.TaskScope=e.ShellQuoting=e.$7M=e.$6M=e.$5M=e.TaskPanelKind=e.TaskRevealKind=e.$4M=e.TerminalLocation=e.$3M=e.$2M=e.$1M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$ZM=e.$YM=e.$XM=e.$WM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$UM=e.$TM=e.$SM=e.$RM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$QM=e.$PM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.LanguageStatusSeverity=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.CodeActionTriggerKind=e.$DM=e.$CM=e.SymbolTag=e.SymbolKind=e.$BM=e.$AM=e.DocumentHighlightKind=e.$zM=e.$yM=e.$xM=e.$wM=e.DiagnosticSeverity=e.DiagnosticTag=e.$vM=e.$uM=e.FileEditType=e.$tM=e.$sM=e.$rM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$VM=Dt,e.$jN=Q;function y(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const De=ie.length===1?[]:ie[1];return Reflect.construct(B,De,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=ie;return Reflect.construct(B,Ge,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var A;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(A||(e.TerminalQuickFixType=A={}));let G=r=class{static from(...j){let ie=j;return new r(function(){if(ie){for(const De of ie)De&&typeof De.dispose=="function"&&De.dispose();ie=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$kM=G,e.$kM=G=r=Je([y],G);let T=o=class{static Min(...j){if(j.length===0)throw new TypeError;let ie=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...j){if(j.length===0)throw new TypeError;let ie=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:ie,character:De}=j;return typeof ie=="number"&&typeof De=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,ie){if(j<0)throw(0,F.$7)("line must be non-negative");if(ie<0)throw(0,F.$7)("character must be non-negative");this.c=j,this.e=ie}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,ie=0){if(j===null||ie===null)throw(0,F.$7)();let De;return typeof j>"u"?De=0:typeof j=="number"?De=j:(De=typeof j.lineDelta=="number"?j.lineDelta:0,ie=typeof j.characterDelta=="number"?j.characterDelta:0),De===0&&ie===0?this:new o(this.line+De,this.character+ie)}with(j,ie=this.character){if(j===null||ie===null)throw(0,F.$7)();let De;return typeof j>"u"?De=this.line:typeof j=="number"?De=j:(De=typeof j.line=="number"?j.line:this.line,ie=typeof j.character=="number"?j.character:this.character),De===this.line&&ie===this.character?this:new o(De,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$lM=T,e.$lM=T=o=Je([y],T);let W=s=class{static isRange(j){return j instanceof s?!0:j?T.isPosition(j.start)&&T.isPosition(j.end):!1}static of(j){if(j instanceof s)return j;if(this.isRange(j))return new s(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,ie,De,Ge){let _e,ht;if(typeof j=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new T(j,ie),ht=new T(De,Ge)):T.isPosition(j)&&T.isPosition(ie)&&(_e=T.of(j),ht=T.of(ie)),!_e||!ht)throw new Error("Invalid arguments");_e.isBefore(ht)?(this.c=_e,this.e=ht):(this.c=ht,this.e=_e)}contains(j){return s.isRange(j)?this.contains(j.start)&&this.contains(j.end):T.isPosition(j)?!(T.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const ie=T.Max(j.start,this.c),De=T.Min(j.end,this.e);if(!ie.isAfter(De))return new s(ie,De)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const ie=T.Min(j.start,this.c),De=T.Max(j.end,this.end);return new s(ie,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,ie=this.end){if(j===null||ie===null)throw(0,F.$7)();let De;return j?T.isPosition(j)?De=j:(De=j.start||this.start,ie=j.end||this.end):De=this.start,De.isEqual(this.c)&&ie.isEqual(this.end)?this:new s(De,ie)}toJSON(){return[this.start,this.end]}};e.$mM=W,e.$mM=W=s=Je([y],W);let P=n=class extends W{static isSelection(j){return j instanceof n?!0:j?W.isRange(j)&&T.isPosition(j.anchor)&&T.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,ie,De,Ge){let _e,ht;if(typeof j=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new T(j,ie),ht=new T(De,Ge)):T.isPosition(j)&&T.isPosition(ie)&&(_e=T.of(j),ht=T.of(ie)),!_e||!ht)throw new Error("Invalid arguments");super(_e,ht),this.f=_e,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$nM=P,e.$nM=P=n=Je([y],P);const L=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$7)("connectionToken")};class K{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ie,De){if(typeof j!="string"||j.length===0)throw(0,F.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,F.$7)("port");typeof De<"u"&&L(De),this.host=j,this.port=Math.round(ie),this.connectionToken=De}}e.$oM=K;class ne{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ie){this.makeConnection=j,this.connectionToken=ie,typeof ie<"u"&&L(ie)}}e.$pM=ne;class le extends Error{static NotAvailable(j,ie){return new le(j,b.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(j){return new le(j,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,ie=b.RemoteAuthorityResolverErrorCode.Unknown,De){super(j),this._message=j,this._code=ie,this._detail=De,Object.setPrototypeOf(this,le.prototype)}}e.$qM=le;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Se;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Se||(e.EnvironmentVariableMutatorType=Se={}));let he=i=class{static isTextEdit(j){return j instanceof i?!0:j?W.isRange(j)&&typeof j.newText=="string":!1}static replace(j,ie){return new i(j,ie)}static insert(j,ie){return i.replace(new W(j,j),ie)}static delete(j){return i.replace(j,"")}static setEndOfLine(j){const ie=new i(new W(new T(0,0),new T(0,0)),"");return ie.newEol=j,ie}get range(){return this.c}set range(j){if(j&&!W.isRange(j))throw(0,F.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,F.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,F.$7)("newEol");this.f=j}constructor(j,ie){this.c=j,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$rM=he,e.$rM=he=i=Je([y],he);let be=a=class{static isNotebookCellEdit(j){return j instanceof a?!0:j?Le.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,ie){return new a(j,ie)}static insertCells(j,ie){return new a(new Le(j,j),ie)}static deleteCells(j){return new a(j,[])}static updateCellMetadata(j,ie){const De=new a(new Le(j,j),[]);return De.newCellMetadata=ie,De}static updateNotebookMetadata(j){const ie=new a(new Le(0,0),[]);return ie.newNotebookMetadata=j,ie}constructor(j,ie){this.range=j,this.newCells=ie}};e.$sM=be,e.$sM=be=a=Je([y],be);class ee{static isSnippetTextEdit(j){return j instanceof ee?!0:j?W.isRange(j.range)&&fe.isSnippetString(j.snippet):!1}static replace(j,ie){return new ee(j,ie)}static insert(j,ie){return ee.replace(new W(j,j),ie)}constructor(j,ie){this.range=j,this.snippet=ie}}e.$tM=ee;var pe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,ie,De,Ge){this.c.push({_type:1,from:j,to:ie,options:De,metadata:Ge})}createFile(j,ie,De){this.c.push({_type:1,from:void 0,to:j,options:ie,metadata:De})}deleteFile(j,ie,De){this.c.push({_type:1,from:j,to:void 0,options:ie,metadata:De})}e(j,ie,De){this.c.push({_type:3,metadata:De,uri:j,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(j,ie,De,Ge){const _e=ie.start,ht=ie.end;(_e!==ht||De.length>0)&&this.c.push({_type:5,uri:j,index:_e,count:ht-_e,cells:De,metadata:Ge})}g(j,ie,De,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:ie,metadata:De}})}replace(j,ie,De,Ge){this.c.push({_type:2,uri:j,edit:new he(ie,De),metadata:Ge})}insert(j,ie,De,Ge){this.replace(j,new W(ie,ie),De,Ge)}delete(j,ie,De){this.replace(j,ie,"",De)}has(j){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===j.toString())}set(j,ie){if(ie)for(const De of ie){if(!De)continue;let Ge,_e;Array.isArray(De)?(Ge=De[0],_e=De[1]):Ge=De,be.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,_e):this.f(j,Ge.range,Ge.newCells,_e):ee.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:j,edit:Ge,metadata:_e})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(j){const ie=[];for(const De of this.c)De._type===2&&De.uri.toString()===j.toString()&&ie.push(De.edit);return ie}entries(){const j=new N.$Bc;for(const ie of this.c)if(ie._type===2){let De=j.get(ie.uri);De||(De=[ie.uri,[]],j.set(ie.uri,De)),De[1].push(ie.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$uM=re,e.$uM=re=Je([y],re);let fe=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,ie=this.e++){if(typeof j=="function"){const De=new h;De.e=this.e,j(De),this.e=De.e,j=De.value}else j=h.c(j);return this.value+="${",this.value+=ie,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,ie=this.e++){const De=j.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(j,ie){if(typeof ie=="function"){const De=new h;De.e=this.e,ie(De),this.e=De.e,ie=De.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$vM=fe,e.$vM=fe=h=Je([y],fe);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var te;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(te||(e.DiagnosticSeverity=te={}));let ke=t=class{static isLocation(j){return j instanceof t?!0:j?W.isRange(j.range)&&k.URI.isUri(j.uri):!1}constructor(j,ie){if(this.uri=j,ie)if(W.isRange(ie))this.range=W.of(ie);else if(T.isPosition(ie))this.range=new W(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$wM=ke,e.$wM=ke=t=Je([y],ke);let Te=class{static is(j){return j?typeof j.message=="string"&&j.location&&W.isRange(j.location.range)&&k.URI.isUri(j.location.uri):!1}constructor(j,ie){this.location=j,this.message=ie}static isEqual(j,ie){return j===ie?!0:!j||!ie?!1:j.message===ie.message&&j.location.range.isEqual(ie.location.range)&&j.location.uri.toString()===ie.location.uri.toString()}};e.$xM=Te,e.$xM=Te=Je([y],Te);let Ie=class{constructor(j,ie,De=te.Error){if(!W.isRange(j))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=j,this.message=ie,this.severity=De}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,ie){return j===ie?!0:!j||!ie?!1:j.message===ie.message&&j.severity===ie.severity&&j.code===ie.code&&j.severity===ie.severity&&j.source===ie.source&&j.range.isEqual(ie.range)&&(0,I.$ub)(j.tags,ie.tags)&&(0,I.$ub)(j.relatedInformation,ie.relatedInformation,Te.isEqual)}};e.$yM=Ie,e.$yM=Ie=Je([y],Ie);let ve=class{constructor(j,ie){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=ie}};e.$zM=ve,e.$zM=ve=Je([y],ve);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let J=class{constructor(j,ie=ge.Text){this.range=j,this.kind=ie}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$AM=J,e.$AM=J=Je([y],J);let Y=class{constructor(j,ie){this.uri=j,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$BM=Y,e.$BM=Y=Je([y],Y);var ce;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ce||(e.SymbolKind=ce={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ne=v=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,ie,De,Ge,_e){this.name=j,this.kind=ie,this.containerName=_e,typeof De=="string"&&(this.containerName=De),Ge instanceof ke?this.location=Ge:De instanceof W&&(this.location=new ke(Ge,De)),v.validate(this)}toJSON(){return{name:this.name,kind:ce[this.kind],location:this.location,containerName:this.containerName}}};e.$CM=Ne,e.$CM=Ne=v=Je([y],Ne);let ue=c=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(c.validate)}constructor(j,ie,De,Ge,_e){this.name=j,this.detail=ie,this.kind=De,this.range=Ge,this.selectionRange=_e,this.children=[],c.validate(this)}};e.$DM=ue,e.$DM=ue=c=Je([y],ue);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Re=class{constructor(j,ie){this.title=j,this.kind=ie}};e.$EM=Re,e.$EM=Re=Je([y],Re);let je=class{static{$=this}static{this.c="."}constructor(j){this.value=j}append(j){return new $(this.value?this.value+$.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+$.c)}};e.$FM=je,e.$FM=je=$=Je([y],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let U=class{constructor(j,ie){if(this.range=j,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$GM=U,e.$GM=U=Je([y],U);class z{constructor(j,ie,De,Ge,_e,ht){this.kind=j,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=ht}}e.$HM=z;class H{constructor(j,ie){this.fromRanges=ie,this.from=j}}e.$IM=H;class q{constructor(j,ie){this.fromRanges=ie,this.to=j}}e.$JM=q;var _;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(_||(e.LanguageStatusSeverity=_={}));let se=class{constructor(j,ie){this.range=j,this.command=ie}get isResolved(){return!!this.command}};e.$KM=se,e.$KM=se=Je([y],se);let Oe=w=class{#e;static isMarkdownString(j){return j instanceof w?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,ie=!1){this.#e=new M.$Ek(j,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,ie){return this.#e.appendCodeblock(ie??"",j),this}};e.$LM=Oe,e.$LM=Oe=w=Je([y],Oe);let We=class{constructor(j,ie){this.label=j,this.documentation=ie}};e.$MM=We,e.$MM=We=Je([y],We);let Qe=class{constructor(j,ie){this.label=j,this.documentation=ie,this.parameters=[]}};e.$NM=Qe,e.$NM=Qe=Je([y],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$OM=xe,e.$OM=xe=Je([y],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var at;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let nt=class{constructor(j){this.value=j}};e.$PM=nt,e.$PM=nt=Je([y],nt);let rt=class{constructor(j,ie,De){this.position=j,this.label=ie,this.kind=De}};e.$QM=rt,e.$QM=rt=Je([y],rt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var it;(function(B){B[B.Deprecated=1]="Deprecated"})(it||(e.CompletionItemTag=it={}));let Z=class{constructor(j,ie){this.label=j,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$RM=Z,e.$RM=Z=Je([y],Z);let X=class{constructor(j=[],ie=!1){this.items=j,this.isIncomplete=ie}};e.$SM=X,e.$SM=X=Je([y],X);let $e=class{constructor(j,ie,De){this.insertText=j,this.range=ie,this.command=De}};e.$TM=$e,e.$TM=$e=Je([y],$e);let Ve=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$UM=Ve,e.$UM=Ve=Je([y],Ve);var Ze;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Ze||(e.PartialAcceptTriggerKind=Ze={}));var ut;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ut||(e.ViewColumn=ut={}));var Ae;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ae||(e.StatusBarAlignment=Ae={}));function Dt(B,j){return`${E.$Cm.toKey(B)}.${j}`}var Jt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Jt||(e.TextEditorLineNumbersStyle=Jt={}));var zt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var hi;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(hi||(e.TextEditorRevealType=hi={}));var Tt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Et;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Qt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Qt||(e.DecorationRangeBehavior=Qt={})),function(B){function j(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ut;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ut||(e.SyntaxTokenType=Ut={})),function(B){function j(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Ut||(e.SyntaxTokenType=Ut={}));let oi=class{constructor(j,ie){if(ie&&!k.URI.isUri(ie))throw(0,F.$7)("target");if(!W.isRange(j)||j.isEmpty)throw(0,F.$7)("range");this.range=j,this.target=ie}};e.$WM=oi,e.$WM=oi=Je([y],oi);let ti=class{constructor(j,ie,De,Ge){this.red=j,this.green=ie,this.blue=De,this.alpha=Ge}};e.$XM=ti,e.$XM=ti=Je([y],ti);let Xe=class{constructor(j,ie){if(ie&&!(ie instanceof ti))throw(0,F.$7)("color");if(!W.isRange(j)||j.isEmpty)throw(0,F.$7)("range");this.range=j,this.color=ie}};e.$YM=Xe,e.$YM=Xe=Je([y],Xe);let xt=class{constructor(j){if(!j||typeof j!="string")throw(0,F.$7)("label");this.label=j}};e.$ZM=xt,e.$ZM=xt=Je([y],xt);var ii;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var dt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var pt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(pt||(e.TerminalExitReason=pt={}));class ni{constructor(j,ie,De){if(this.startIndex=j,this.length=ie,this.tooltip=De,typeof j!="number"||j<0)throw(0,F.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,F.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,F.$7)("tooltip")}}e.$1M=ni;class Bt{constructor(j){this.uri=j}}e.$2M=Bt;class Wt{constructor(j){this.terminalCommand=j}}e.$3M=Wt;var ft;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ft||(e.TerminalLocation=ft={}));class Mt{constructor(j){if(this.options=j,typeof j!="object")throw(0,F.$7)("options")}}e.$4M=Mt;var _t;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(_t||(e.TaskRevealKind=_t={}));var ri;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ri||(e.TaskPanelKind=ri={}));let He=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(j){switch(j){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(j,ie){if(this.label=ie,typeof j!="string"||typeof ie!="string")throw(0,F.$7)("name");this.c=j}get id(){return this.c}};e.$5M=He,e.$5M=He=p=Je([y],He);function Vt(B){let j="";for(let ie=0;ie<B.length;ie++)j+=B[ie].replace(/,/g,",,")+",";return j}let Zt=class{constructor(j,ie,De){if(typeof j!="string")throw(0,F.$7)("process");this.e=[],this.c=j,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=De):this.f=ie)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,F.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)j.push(ie);return Vt(j)}};e.$6M=Zt,e.$6M=Zt=Je([y],Zt);let qt=class{constructor(j,ie,De){if(this.f=[],Array.isArray(ie)){if(!j)throw(0,F.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,F.$7)("command");this.e=j,this.f=ie,this.g=De}else{if(typeof j!="string")throw(0,F.$7)("commandLine");this.c=j,this.g=ie}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,F.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,F.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)j.push(typeof ie=="string"?ie:ie.value);return Vt(j)}};e.$7M=qt,e.$7M=qt=Je([y],qt);var mt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(mt||(e.ShellQuoting=mt={}));var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(At||(e.TaskScope=At={}));class It{constructor(j){this.c=j}computeId(){return"customExecution"+(0,O.$Dg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$8M=It;let Ft=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,ie,De,Ge,_e,ht){this.k=!1,this.l=this.definition=j;let gt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=De,this.execution=Ge,gt=_e,this.k=!0):ie===At.Global||ie===At.Workspace?(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=ht):(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=ht),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Zt?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof qt?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof It?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,O.$Dg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=j}get scope(){return this.m}set target(j){this.B(),this.m=j}get name(){return this.o}set name(j){if(typeof j!="string")throw(0,F.$7)("name");this.B(),this.o=j}get execution(){return this.q}set execution(j){j===null&&(j=void 0),this.B(),this.q=j;const ie=this.l.type;(l.g===ie||l.e===ie||l.f===ie||l.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(j){if(Array.isArray(j))this.B(),this.r=j,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.B(),this.u=j}get source(){return this.w}set source(j){if(typeof j!="string"||j.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=j}get group(){return this.x}set group(j){j===null&&(j=void 0),this.B(),this.x=j}get detail(){return this.A}set detail(j){j===null&&(j=void 0),this.A=j}get presentationOptions(){return this.y}set presentationOptions(j){j==null&&(j=Object.create(null)),this.B(),this.y=j}get runOptions(){return this.z}set runOptions(j){j==null&&(j=Object.create(null)),this.B(),this.z=j}};e.$9M=Ft,e.$9M=Ft=l=Je([y],Ft);var si;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(si||(e.ProgressLocation=si={}));var Ht;(function(B){function j(ie){const De=ie;return(0,d.$Yf)(De.value)?De.tooltip&&!(0,d.$Uf)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=j})(Ht||(e.ViewBadge=Ht={}));let Xt=D=class{static isTreeItem(j,ie){const De=j;if(De.checkboxState!==void 0){const Ge=(0,d.$Yf)(De.checkboxState)?De.checkboxState:(0,d.$Wf)(De.checkboxState)&&(0,d.$Yf)(De.checkboxState.state)?De.checkboxState.state:void 0,_e=!(0,d.$Yf)(De.checkboxState)&&(0,d.$Wf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ot.Checked&&Ge!==Ot.Unchecked||_e!==void 0&&!(0,d.$Uf)(_e))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(j instanceof D)return!0;if(De.label!==void 0&&!(0,d.$Uf)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,d.$Uf)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,d.$Uf)(De.iconPath)&&!k.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,d.$Uf)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,d.$Uf)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,d.$Uf)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,d.$Uf)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!k.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,d.$Uf)(De.tooltip)&&!(De.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<bt.None&&De.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,d.$Uf)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(j,ie=bt.None){this.collapsibleState=ie,k.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$0M=Xt,e.$0M=Xt=D=Je([y],Xt);var bt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Ot;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ot||(e.TreeItemCheckboxState=Ot={}));let Lt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$$M=Lt,e.$$M=Lt=Je([y],Lt);class Nt extends Lt{}e.$_M=Nt;class yt extends Nt{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$aN=yt;class St{constructor(j,ie,De,Ge){this.name=j,this.uri=ie,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$bN=St;let kt=class{#e=new Map;constructor(j){for(const[ie,De]of j??[]){const Ge=this.#e.get(this.#t(ie));Ge?Ge.push(De):this.#e.set(this.#t(ie),[De])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,ie){this.#e.set(this.#t(j),[ie])}forEach(j,ie){for(const[De,Ge]of this.#e)for(const _e of Ge)j.call(ie,_e,De,this)}*[Symbol.iterator](){for(const[j,ie]of this.#e)for(const De of ie)yield[j,De]}#t(j){return j.toLowerCase()}};e.$cN=kt,e.$cN=kt=Je([y],kt);let ci=class{constructor(j,ie,De){this.insertText=j,this.title=ie,this.kind=De}};e.$dN=ci,e.$dN=ci=Je([y],ci);var ei;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(ei||(e.DocumentPasteTriggerKind=ei={}));class ui{static{this.c="."}constructor(j){this.value=j}append(...j){return new ui((this.value?[this.value,...j]:j).join(ui.c))}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+ui.c)}}e.$eN=ui,ui.Empty=new ui("");let di=class{constructor(j,ie,De){this.title=ie,this.insertText=j,this.kind=De}};e.$fN=di,e.$fN=di=Je([y],di);let Yt=class{constructor(j,ie){this.id=j,this.color=ie}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$gN=Yt,e.$gN=Yt=Je([y],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let Ct=class{constructor(j){this.id=j}};e.$hN=Ct,e.$hN=Ct=Je([y],Ct);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Fe=class{get base(){return this.c}set base(j){this.c=j,this.e=k.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,ie){if(typeof j!="string"&&(!j||!k.URI.isUri(j)&&!k.URI.isUri(j.uri)))throw(0,F.$7)("base");if(typeof ie!="string")throw(0,F.$7)("pattern");typeof j=="string"?this.baseUri=k.URI.file(j):k.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$iN=Fe,e.$iN=Fe=Je([y],Fe);const oe=new WeakMap;function Q(B,j){oe.set(B,j)}let Ee=class{constructor(j,ie,De,Ge,_e){this.enabled=typeof j=="boolean"?j:!0,typeof ie=="string"&&(this.condition=ie),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=oe.get(this)??(0,O.$Dg)()),this.c}};e.$kN=Ee,e.$kN=Ee=Je([y],Ee);let Ue=class extends Ee{constructor(j,ie,De,Ge,_e,ht){if(super(ie,De,Ge,_e,ht),j===null)throw(0,F.$7)("location");this.location=j}};e.$lN=Ue,e.$lN=Ue=Je([y],Ue);let Ye=class extends Ee{constructor(j,ie,De,Ge,_e,ht){super(ie,De,Ge,_e,ht),this.functionName=j}};e.$mN=Ye,e.$mN=Ye=Je([y],Ye);let Ke=class extends Ee{constructor(j,ie,De,Ge,_e,ht,gt,Gt){if(super(Ge,_e,ht,gt,Gt),!ie)throw(0,F.$7)("dataId");this.label=j,this.dataId=ie,this.canPersist=De}};e.$nN=Ke,e.$nN=Ke=Je([y],Ke);let st=class{constructor(j,ie,De){this.command=j,this.args=ie||[],this.options=De}};e.$oN=st,e.$oN=st=Je([y],st);let wt=class{constructor(j,ie){this.port=j,this.host=ie}};e.$pN=wt,e.$pN=wt=Je([y],wt);let Kt=class{constructor(j){this.path=j}};e.$qN=Kt,e.$qN=Kt=Je([y],Kt);let jt=class{constructor(j){this.implementation=j}};e.$rN=jt,e.$rN=jt=Je([y],jt);class Pt{constructor(j,ie,De){this.session=j,this.threadId=ie,this.frameId=De}}e.$sN=Pt;class lt{constructor(j,ie){this.session=j,this.threadId=ie}}e.$tN=lt;let Ci=class{constructor(j,ie){this.range=j,this.expression=ie}};e.$uN=Ci,e.$uN=Ci=Je([y],Ci);var gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=class{constructor(j,ie){this.range=j,this.text=ie}};e.$vN=$i,e.$vN=$i=Je([y],$i);let wi=class{constructor(j,ie,De=!0){this.range=j,this.variableName=ie,this.caseSensitiveLookup=De}};e.$wN=wi,e.$wN=wi=Je([y],wi);let Pi=class{constructor(j,ie){this.range=j,this.expression=ie}};e.$xN=Pi,e.$xN=Pi=Je([y],Pi);let Mi=class{constructor(j,ie){this.frameId=j,this.stoppedLocation=ie}};e.$yN=Mi,e.$yN=Mi=Je([y],Mi);var Wi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));class Vi{constructor(j,ie){this.newSymbolName=j,this.tags=ie}}e.$zN=Vi;var qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let yi=g=class extends Error{static FileExists(j){return new g(j,u.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(j){return new g(j,u.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(j){return new g(j,u.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(j){return new g(j,u.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(j){return new g(j,u.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(j){return new g(j,u.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(j,ie=u.FileSystemProviderErrorCode.Unknown,De){super(k.URI.isUri(j)?j.toString(!0):j),this.code=De?.name??"Unknown",(0,u.$3k)(this,ie),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$AN=yi,e.$AN=yi=g=Je([y],yi);let Ri=class{constructor(j,ie,De){this.start=j,this.end=ie,this.kind=De}};e.$BN=Ri,e.$BN=Ri=Je([y],Ri);var ki;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var Ei;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Ki;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ki||(e.CommentState=Ki={}));var vi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));var Gi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Gi||(e.CommentThreadApplicability=Gi={}));class gn{constructor(j,ie=[]){this.tokenTypes=j,this.tokenModifiers=ie}}e.$CN=gn;function mn(B){return typeof B>"u"||(0,d.$Vf)(B)}class Ai{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let ie=0,De=j.tokenTypes.length;ie<De;ie++)this.k.set(j.tokenTypes[ie],ie);for(let ie=0,De=j.tokenModifiers.length;ie<De;ie++)this.l.set(j.tokenModifiers[ie],ie)}}push(j,ie,De,Ge,_e){if(typeof j=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(j,ie,De,Ge,_e);if(W.isRange(j)&&typeof ie=="string"&&mn(De))return this.o(j,ie,De);throw(0,F.$7)()}o(j,ie,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,_e=j.start.character,ht=j.end.character-j.start.character,gt=this.k.get(ie);let Gt=0;if(De)for(const li of De){if(!this.l.has(li))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(li);Gt|=1<<fi>>>0}this.q(Ge,_e,ht,gt,Gt)}q(j,ie,De,Ge,_e){if(this.f&&(j<this.c||j===this.c&&ie<this.e)){this.f=!1;const Gt=this.g.length/5|0;let li=0,fi=0;for(let mi=0;mi<Gt;mi++){let pi=this.g[5*mi],Ui=this.g[5*mi+1];pi===0?(pi=li,Ui+=fi):pi+=li,this.g[5*mi]=pi,this.g[5*mi+1]=Ui,li=pi,fi=Ui}}let ht=j,gt=ie;this.f&&this.j>0&&(ht-=this.c,ht===0&&(gt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=j,this.e=ie}static r(j){const ie=[],De=j.length/5|0;for(let gt=0;gt<De;gt++)ie[gt]=gt;ie.sort((gt,Gt)=>{const li=j[5*gt],fi=j[5*Gt];if(li===fi){const mi=j[5*gt+1],pi=j[5*Gt+1];return mi-pi}return li-fi});const Ge=new Uint32Array(j.length);let _e=0,ht=0;for(let gt=0;gt<De;gt++){const Gt=5*ie[gt],li=j[Gt+0],fi=j[Gt+1],mi=j[Gt+2],pi=j[Gt+3],Ui=j[Gt+4],On=li-_e,rr=On===0?fi-ht:fi,Bi=5*gt;Ge[Bi+0]=On,Ge[Bi+1]=rr,Ge[Bi+2]=mi,Ge[Bi+3]=pi,Ge[Bi+4]=Ui,_e=li,ht=fi}return Ge}build(j){return this.f?new Fi(new Uint32Array(this.g),j):new Fi(Ai.r(this.g),j)}}e.$DN=Ai;class Fi{constructor(j,ie){this.resultId=ie,this.data=j}}e.$EN=Fi;class Ji{constructor(j,ie,De){this.start=j,this.deleteCount=ie,this.data=De}}e.$FN=Ji;class Qi{constructor(j,ie){this.resultId=ie,this.edits=j}}e.$GN=Qi;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class Xi{constructor(j){this.name=j}}e.$HN=Xi;let Di=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$IN=Di,e.$IN=Di=Je([y],Di);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var _i;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(j){if(typeof j.badge=="string"){let ie=(0,m.$vf)(j.badge,0);if(ie<j.badge.length&&(ie+=(0,m.$vf)(j.badge,ie)),j.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Yt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,ie,De){this.badge=j,this.tooltip=ie,this.color=De}}e.$JN=$n;let bi=class{constructor(j){this.kind=j}};e.$KN=bi,e.$KN=bi=Je([y],bi);var Oi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Oi||(e.ColorThemeKind=Oi={}));class Le{static isNotebookRange(j){return j instanceof Le?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,ie){if(j<0)throw(0,F.$7)("start must be positive");if(ie<0)throw(0,F.$7)("end must be positive");j<=ie?(this.c=j,this.e=ie):(this.c=ie,this.e=j)}with(j){let ie=this.c,De=this.e;return j.start!==void 0&&(ie=j.start),j.end!==void 0&&(De=j.end),ie===this.c&&De===this.e?this:new Le(ie,De)}}e.$LN=Le;class ai{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(ie=>ai.isNotebookCellData(ie))}static isNotebookCellData(j){return!0}constructor(j,ie,De,Ge,_e,ht,gt){this.kind=j,this.value=ie,this.languageId=De,this.mime=Ge,this.outputs=_e??[],this.metadata=ht,this.executionSummary=gt,ai.validate(this)}}e.$MN=ai;class en{constructor(j){this.cells=j}}e.$NN=en;class et{static isNotebookCellOutputItem(j){return j instanceof et?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const ie={name:j.name,message:j.message,stack:j.stack};return et.json(ie,"application/vnd.code.notebook.error")}static stdout(j){return et.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return et.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,ie="application/octet-stream"){return new et(j,ie)}static#e=new TextEncoder;static text(j,ie=R.$ys.text){const De=et.#e.encode(String(j));return new et(De,ie)}static json(j,ie="text/x-json"){const De=JSON.stringify(j,void 0,"	");return et.text(De,ie)}constructor(j,ie){this.data=j,this.mime=ie;const De=(0,R.$Cs)(ie,!0);if(!De)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$ON=et;class $t{static isNotebookCellOutput(j){return j instanceof $t?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,ie=!1){const De=new Set,Ge=new Set;for(let _e=0;_e<j.length;_e++){const ht=j[_e],gt=(0,R.$Cs)(ht.mime);if(!De.has(gt)||(0,f.$fK)(gt)){De.add(gt);continue}Ge.add(_e),ie&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ge.size===0?j:j.filter((_e,ht)=>!Ge.has(ht))}constructor(j,ie,De){this.items=$t.ensureUniqueMimeTypes(j,!0),typeof ie=="string"?(this.id=ie,this.metadata=De):(this.id=(0,O.$Dg)(),this.metadata=ie??De)}}e.$PN=$t;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Ni;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ni||(e.NotebookCellStatusBarAlignment=Ni={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class Si{constructor(j,ie){this.text=j,this.alignment=ie}}e.$QN=Si;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(j,ie=[]){this.uri=j,this.provides=(0,I.$3b)(ie)}}e.$RN=pn;class an{constructor(j){this.label=j}}e.$SN=an;var cn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ti=class{constructor(j,ie){this.label=j,this.timestamp=ie}};e.$TN=Ti,e.$TN=Ti=Je([y],Ti);var un;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class vn{constructor(j,ie){this.ranges=j,this.wordPattern=ie}}e.$UN=vn;class bn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$VN=bn;var dn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Li=class{constructor(j=void 0,ie=void 0,De=void 0,Ge=!1){this.include=j,this.exclude=ie,this.profile=De,this.continuous=Ge}};e.$WN=Li,e.$WN=Li=Je([y],Li);let ji=S=class{static diff(j,ie,De){const Ge=new S(j);return Ge.expectedOutput=ie,Ge.actualOutput=De,Ge}constructor(j){this.message=j}};e.$XN=ji,e.$XN=ji=S=Je([y],ji);let x=class{constructor(j){this.id=j}};e.$YN=x,e.$YN=x=Je([y],x);class ae{constructor(j,ie){this.covered=j,this.total=ie}}e.$ZN=ae;const ze=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class ot{static fromDetails(j,ie){const De=new ae(0,0),Ge=new ae(0,0),_e=new ae(0,0);for(const gt of ie)if("branches"in gt){De.total+=1,De.covered+=gt.executed?1:0;for(const Gt of gt.branches)Ge.total+=1,Ge.covered+=Gt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const ht=new ot(j,De,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return ht.detailedCoverage=ie,ht}constructor(j,ie,De,Ge){this.uri=j,this.statementCoverage=ie,this.branchCoverage=De,this.declarationCoverage=Ge,ze(ie),ze(De),ze(Ge)}}e.$1N=ot;class vt{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,De=[]){this.executed=j,this.location=ie,this.branches=De}}e.$2N=vt;class Rt{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,De){this.executed=j,this.location=ie,this.label=De}}e.$3N=Rt;class zi{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,De){this.name=j,this.executed=ie,this.location=De}}e.$4N=zi;var wn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Nn{constructor(j,ie,De,Ge,_e,ht){this.kind=j,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=ht}}e.$5N=Nn;class Tn{constructor(j){this.uri=j}}e.$6N=Tn;class Ln{constructor(j,ie){this.original=j,this.modified=ie}}e.$7N=Ln;class jn{constructor(j,ie,De,Ge){this.base=j,this.input1=ie,this.input2=De,this.result=Ge}}e.$8N=jn;class zn{constructor(j,ie){this.uri=j,this.viewType=ie}}e.$9N=zn;class Un{constructor(j){this.viewType=j}}e.$0N=Un;class Bn{constructor(j,ie){this.uri=j,this.notebookType=ie}}e.$$N=Bn;class Wn{constructor(j,ie,De){this.original=j,this.modified=ie,this.notebookType=De}}e.$_N=Wn;class Vn{constructor(){}}e.$aO=Vn;class qn{constructor(j,ie){this.uri=j,this.inputBoxUri=ie}}e.$bO=qn;class Hn{constructor(j){this.providerId=j}}e.$cO=Hn;var En;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Dn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var Sn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Kn{constructor(j,ie){this.label=j,this.values=ie}}e.$dO=Kn;var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Gn{constructor(j){this.value=typeof j=="string"?new Oe(j):j}}e.$eO=Gn;class Jn{constructor(j,ie){this.value=j,this.baseUri=ie}}e.$fO=Jn;class Qn{constructor(j,ie){this.value=j,this.title=ie}}e.$gO=Qn;class Zn{constructor(j){this.value=j}}e.$hO=Zn;class Xn{constructor(j){this.value=j}}e.$iO=Xn;class Yn{constructor(j){this.value=j}}e.$jO=Yn;class xn{constructor(j,ie,De,Ge){this.prompt=j,this.command=ie,this.variables=De,this.participant=Ge}}e.$kO=xn;class _n{constructor(j,ie,De,Ge){this.response=j,this.result=ie,this.participant=De,this.command=Ge}}e.$lO=_n;var Pn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook"})(Pn||(e.ChatLocation=Pn={}));class er{constructor(j){this.content=j}}e.$mO=er;class tr{constructor(j,ie){this.content=j,this.name=ie}}e.$nO=tr;class ir{constructor(j){this.content=j}}e.$oO=ir;class Ii extends Error{static NotFound(j){return new Ii(j,Ii.NotFound.name)}static NoPermissions(j){return new Ii(j,Ii.NoPermissions.name)}constructor(j,ie,De){super(j,{cause:De}),this.name="LanguageModelError",this.code=ie??""}}e.$pO=Ii;var Mn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Mn||(e.RelatedInformationType=Mn={}));var Rn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class nr{constructor(j,ie){this.text=j,this.range=ie}}e.$qO=nr;var Fn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(Pe[246],Me([1,0,4,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$iM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,d){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(m,d)??[]}getRelatedInformation(R,m,d){return this.c.$getAiRelatedInformation(m,d)}registerRelatedInformationProvider(R,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiRelatedInformationProvider(k,m),new F.$kM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Kic=M}),define(Pe[84],Me([1,0,5,4,7,20,106,3,17]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=void 0,e.$Vic=(0,m.$hi)("IExtHostAuthentication");let k=class{constructor(u){this.b=new Map,this.c=new I.$7d,this.onDidChangeSessions=this.c.event,this.d=new O,this.f=new O,this.a=u.getProxy(F.$iM.MainThreadAuthentication)}async getSession(u,b,f,r={}){const o=N.$Cm.toKey(u.identifier),s=[...f].sort().join(" ");return await this.d.getOrCreate(`${o} ${b} ${s}`,async()=>{await this.a.$ensureProvider(b);const n=u.displayName||u.name;return this.a.$getSession(b,f,o,n,r)})}async getSessions(u,b,f){const r=N.$Cm.toKey(u.identifier),o=[...f].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(b);const s=u.displayName||u.name;return this.a.$getSessions(b,f,r,s)})}async removeSession(u,b){const f=this.b.get(u);return f?f.provider.removeSession(b):this.a.$removeSession(u,b)}registerAuthenticationProvider(u,b,f,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:b,provider:f,options:r??{supportsMultipleAccounts:!1}});const o=f.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,b,r?.supportsMultipleAccounts??!1),new M.$kM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,b,f){const r=this.b.get(u);if(r)return Promise.resolve(r.provider.createSession(b,f));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,b){const f=this.b.get(u);if(f)return Promise.resolve(f.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,b){const f=this.b.get(u);if(f)return Promise.resolve(f.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,b){return u.startsWith(R.$kL)||this.c.fire({provider:{id:u,label:b}}),Promise.resolve()}};e.$Wic=k,e.$Wic=k=Je([qe(0,d.$CO)],k);class O{constructor(){this.a=new Map}getOrCreate(u,b){const f=this.a.get(u);if(f)return f;const r=b().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Pe[110],Me([1,0,2,4,7,3,17,13,18,15,19,22]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Wjc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(F.$iM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=u.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,d.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,k.$1e)(c.path,"/")})),t=(0,d.$zb)(h,(c,$)=>c.rank-$.rank||(0,k.$ef)(c.uri.path,$.uri.path)),v=[];e:for(const c of t){let $;for(const w of c){const p=(0,O.$nc)(w.uri.path);if($!==p&&($=p,v.push(w.uri)>=u.d))break e}}this.g.$onDidChange(s,v)});return new M.$kM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:t,id:v}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{M.$JN.validate(c),c.badge&&typeof c.badge!="string"&&(0,E.$7F)(a,"codiconDecoration"),n[v]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),n}};e.$Wjc=b,e.$Wjc=b=u=Je([qe(0,R.$CO),qe(1,m.$Nj)],b),e.$Xjc=(0,N.$hi)("IExtHostDecorations")}),define(Pe[247],Me([1,0,14,2,7,4,12,25,15]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class k{static{this.a=0}constructor(E,u,b){this.d=u,this.e=b,this.b=new Map,this.c=E.getProxy(N.$iM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(R.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const b=k.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,E);let f;if(typeof u.onDidChange=="function"){let r;f=u.onDidChange(async o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(b,o).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,d.$$e)(n);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new M.$kM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(E,u){const b=this.b.get(E);return b?Promise.resolve(b.provideTextDocumentContent(F.URI.revive(u),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Zjc=k}),define(Pe[111],Me([1,0,55,12,15,303,151,7,18]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0,e.$EO=O;const k=new Map;function O(f,r){r?k.set(f,r):k.delete(f)}function E(f){return k.get(f)}class u extends N.$Gv{constructor(r,o,s,n,i,a,h){super(o,s,n,i),this.c=r,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,d.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===F.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,i=o.end.line,a=[];a.push(this.f[n].substring(o.start.character));for(let h=n+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(r){let o;if(r instanceof m.$lM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new m.$lM(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof m.$mM))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new m.$mM(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof m.$lM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const i=this.f[o].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new m.$lM(o,s):r}y(r,o){const s=this.x(r);if(!o)o=E(this.m);else if((0,M.$0e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$Qs)(s.character+1,(0,R.$Os)(o),this.f[s.line],0);if(n)return new m.$mM(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$FO=u;class b{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$mM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$mM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$GO=b}),define(Pe[248],Me([1,0,4,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$iM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const O=await k.provideEmbeddingVector(m,d);if(!O)throw new Error("Embedding vector provider returned undefined");return O}registerEmbeddingVectorProvider(R,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiEmbeddingVectorProvider(m,k),new F.$kM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$2jc=M}),define(Pe[63],Me([1,0,4,43,7,23,3,17,44,6,11,24,12]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=void 0;let f=b=class{constructor(o,s){this.b=new Map,this.c=new O.$qh,this.a=o.getProxy(I.$iM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let a;const h=n.b.get(i.scheme);return h?(await n.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await n.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===F.FilePermission.Readonly?1:void 0}}catch(a){b.e(a)}},async readDirectory(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(a){return b.e(a)}},async createDirectory(i){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,i)):await n.a.$mkdir(i)}catch(a){return b.e(a)}},async readFile(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(a){return b.e(a)}},async writeFile(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$ue.wrap(a))}catch(h){return b.e(h)}},async delete(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await n.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return b.e(h)}},async rename(i,a,h){try{return await n.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},async copy(i,a,h){try{return await n.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&F.FileType.Directory))throw M.$AN.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(F.$4k(a)!==F.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(n)),n=s.dirname(n)}for(let a=i.length-1;a>=0;a--){n=s.joinPath(n,i[a]);try{await o.createDirectory(n)}catch(h){if(F.$4k(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof M.$AN)throw o;if(o instanceof F.$Zk)switch(o.code){case F.FileSystemProviderErrorCode.FileExists:throw M.$AN.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw M.$AN.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw M.$AN.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw M.$AN.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw M.$AN.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw M.$AN.Unavailable(o.message);default:throw new M.$AN(o.message,o.name)}if(!(o instanceof Error))throw new M.$AN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw M.$AN.Unavailable(o.message);switch(o.name){case F.FileSystemProviderErrorCode.FileExists:throw M.$AN.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw M.$AN.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw M.$AN.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw M.$AN.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw M.$AN.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw M.$AN.Unavailable(o.message);default:throw new M.$AN(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?E.$Kg:E.$Mg,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$Kg}};e.$cjc=f,e.$cjc=f=b=Je([qe(0,m.$CO),qe(1,d.$Pic)],f),e.$djc=(0,R.$hi)("IExtHostConsumerFileSystem")}),define(Pe[249],Me([1,0,4,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class M{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(I.$iM.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(R);if(!d)throw new Error("Issue request handler not found");const k=await d.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(R);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueData(m);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(R);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueTemplate(m);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(R,m){const d=R.identifier.value;return this.a.set(d,m),this.c.$registerIssueUriRequestHandler(d),new F.$kM(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(R,m){const d=R.identifier.value;return this.b.set(d,m),this.c.$registerIssueDataProvider(d),new F.$kM(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$gkc=M}),define(Pe[85],Me([1,0,3,27,13,63,2]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=e.$ejc=void 0,e.$ejc=(0,I.$hi)("IExtensionStoragePaths");let m=class{constructor(k,O,E){this.d=O,this.f=E,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fjc=m,e.$fjc=m=Je([qe(0,F.$SO),qe(1,M.$Nj),qe(2,N.$djc)],m)}),define(Pe[250],Me([1,0,7,17,5]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;let N=class{constructor(m){this.a=new I.$KN(I.ColorThemeKind.Dark),this.b=new M.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let d;switch(m){case"light":d=I.ColorThemeKind.Light;break;case"hcDark":d=I.ColorThemeKind.HighContrast;break;case"hcLight":d=I.ColorThemeKind.HighContrastLight;break;default:d=I.ColorThemeKind.Dark}this.a=new I.$KN(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jkc=N,e.$Jkc=N=Je([qe(0,F.$CO)],N)}),define(Pe[86],Me([1,0,25,5,6,173,3,13,202,4,27,17,7]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fBb=e.$eBb=e.TunnelDtoConverter=void 0;class b extends d.$6v{}var f;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==d.TunnelPrivacyId.ConstantPrivate&&i.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$eBb=(0,R.$hi)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(s,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(k.$iM.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,s.displayName);if(i){const a=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,i),new u.$kM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(n.map(async w=>{let p;try{p=await $.provider.providePortAttributes({port:w,pid:i,commandLine:a},h)}catch{p=await $.provider.providePortAttributes(w,i,a,h)}return{providedAttributes:p,port:w}})))}const v=t.filter(c=>!!c.providedAttributes);return v.length>0?v.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),f.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$fBb=r,e.$fBb=r=Je([qe(0,E.$CO),qe(1,O.$SO),qe(2,m.$Nj)],r)}),define(Pe[8],Me([1,0,18,23,131,251,53,28,123,52,69,26,126,24,16,2,29,87,100,105,104,212,83,49,60,223,22,7]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$zO=K,e.$AO=le,e.$BO=ye;var l;(function(we){function Fe(Q){const{selectionStartLineNumber:Ee,selectionStartColumn:Ue,positionLineNumber:Ye,positionColumn:Ke}=Q,st=new p.$lM(Ee-1,Ue-1),wt=new p.$lM(Ye-1,Ke-1);return new p.$nM(st,wt)}we.to=Fe;function oe(Q){const{anchor:Ee,active:Ue}=Q;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}we.from=oe})(l||(e.Selection=l={}));var D;(function(we){function Fe(Q){if(!Q)return;const{start:Ee,end:Ue}=Q;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}we.from=Fe;function oe(Q){if(!Q)return;const{startLineNumber:Ee,startColumn:Ue,endLineNumber:Ye,endColumn:Ke}=Q;return new p.$mM(Ee-1,Ue-1,Ye-1,Ke-1)}we.to=oe})(D||(e.Range=D={}));var g;(function(we){function Fe(Q){return{uri:Q.uri,range:D.from(Q.range)}}we.from=Fe;function oe(Q){return new p.$wM(r.URI.revive(Q.uri),D.to(Q.range))}we.to=oe})(g||(e.Location=g={}));var S;(function(we){function Fe(oe){switch(oe){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}we.to=Fe})(S||(e.TokenType=S={}));var y;(function(we){function Fe(Q){return new p.$lM(Q.lineNumber-1,Q.column-1)}we.to=Fe;function oe(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=oe})(y||(e.Position=y={}));var C;(function(we){function Fe(Ee,Ue,Ye){return(0,I.$Hb)((0,I.$3b)(Ee).map(Ke=>oe(Ke,Ue,Ye)))}we.from=Fe;function oe(Ee,Ue,Ye){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ye?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Q(Ee.scheme,Ue),pattern:Ve.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ye?.isBuiltin}}function Q(Ee,Ue){return Ue&&typeof Ee=="string"?Ue.transformOutgoingScheme(Ee):Ee}})(C||(e.DocumentSelector=C={}));var A;(function(we){function Fe(Q){switch(Q){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}we.from=Fe;function oe(Q){switch(Q){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}we.to=oe})(A||(e.DiagnosticTag=A={}));var G;(function(we){function Fe(Q){let Ee;return Q.code&&((0,f.$Uf)(Q.code)||(0,f.$Yf)(Q.code)?Ee=String(Q.code):Ee={value:String(Q.code.value),target:Q.code.target}),{...D.from(Q.range),message:Q.message,source:Q.source,code:Ee,severity:W.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(T.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(A.from)):void 0}}we.from=Fe;function oe(Q){const Ee=new p.$yM(D.to(Q),Q.message,W.to(Q.severity));return Ee.source=Q.source,Ee.code=(0,f.$Uf)(Q.code)?Q.code:Q.code?.value,Ee.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(T.to),Ee.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(A.to)),Ee}we.to=oe})(G||(e.Diagnostic=G={}));var T;(function(we){function Fe(Q){return{...D.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Fe;function oe(Q){return new p.$xM(new p.$wM(Q.resource,D.to(Q)),Q.message)}we.to=oe})(T||(e.DiagnosticRelatedInformation=T={}));var W;(function(we){function Fe(Q){switch(Q){case p.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=Fe;function oe(Q){switch(Q){case n.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}we.to=oe})(W||(e.DiagnosticSeverity=W={}));var P;(function(we){function Fe(Q){return typeof Q=="number"&&Q>=p.ViewColumn.One?Q-1:Q===p.ViewColumn.Beside?$.$AD:$.$zD}we.from=Fe;function oe(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(P||(e.ViewColumn=P={}));function L(we){return typeof we.range<"u"}function K(we){return we.length===0?!0:!!L(we[0])}var ne;(function(we){function Fe(Ke){return Ke.map(we.from)}we.fromMany=Fe;function oe(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let st;if(oe(Ke)){const{language:Pt,value:lt}=Ke;st={value:"```"+Pt+`
`+lt+"\n```\n"}}else p.$LM.isMarkdownString(Ke)?st={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?st={value:Ke}:st={value:""};const wt=Object.create(null);st.uris=wt;const Kt=Pt=>{try{let lt=r.URI.parse(Pt,!0);lt=lt.with({query:Ee(lt.query,wt)}),wt[Pt]=lt}catch{}return""},jt=new d.marked.Renderer;return jt.link=Kt,jt.image=Pt=>typeof Pt=="string"?Kt(R.$Mk(Pt).href):"",(0,d.marked)(st.value,{renderer:jt}),st}we.from=Q;function Ee(Ke,st){if(!Ke)return Ke;let wt;try{wt=(0,k.$Ph)(Ke)}catch{}if(!wt)return Ke;let Kt=!1;return wt=(0,E.$Pn)(wt,jt=>{if(r.URI.isUri(jt)){const Pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Pt]=jt,Kt=!0,Pt}else return}),Kt?JSON.stringify(wt):Ke}function Ue(Ke){const st=new p.$LM(Ke.value,Ke.supportThemeIcons);return st.isTrusted=Ke.isTrusted,st.supportHtml=Ke.supportHtml,st.baseUri=Ke.baseUri?r.URI.from(Ke.baseUri):void 0,st}we.to=Ue;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:we.from(Ke)}we.fromStrict=Ye})(ne||(e.MarkdownString=ne={}));function le(we){return K(we)?we.map(Fe=>({range:D.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?ne.fromMany(Fe.hoverMessage):Fe.hoverMessage?ne.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):we.map(Fe=>({range:D.from(Fe)}))}function ye(we){return typeof we>"u"?we:typeof we=="string"?r.URI.file(we):we}var Se;(function(we){function Fe(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ye(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=Fe})(Se||(e.ThemableDecorationAttachmentRenderOptions=Se={}));var he;(function(we){function Fe(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ye(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?Se.from(oe.before):void 0,after:oe.after?Se.from(oe.after):void 0}}we.from=Fe})(he||(e.ThemableDecorationRenderOptions=he={}));var be;(function(we){function Fe(oe){if(typeof oe>"u")return oe;switch(oe){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Fe})(be||(e.DecorationRangeBehavior=be={}));var ee;(function(we){function Fe(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?be.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?he.from(oe.light):void 0,dark:oe.dark?he.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ye(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?Se.from(oe.before):void 0,after:oe.after?Se.from(oe.after):void 0}}we.from=Fe})(ee||(e.DecorationRenderOptions=ee={}));var pe;(function(we){function Fe(Q){return{text:Q.newText,eol:Q.newEol&&Be.from(Q.newEol),range:D.from(Q.range)}}we.from=Fe;function oe(Q){const Ee=new p.$rM(D.to(Q.range),Q.text);return Ee.newEol=typeof Q.eol>"u"?void 0:Be.to(Q.eol),Ee}we.to=oe})(pe||(e.TextEdit=pe={}));var re;(function(we){function Fe(Q,Ee){const Ue={edits:[]};if(Q instanceof p.$uM){const Ye=new m.$Cc;for(const Ke of Q._allEntries())Ke._type===1&&r.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of Q._allEntries())if(Ke._type===1){let st;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?st={type:"base64",value:(0,F.$Oe)(F.$ue.wrap(Ke.options.contents))}:st={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ue.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:st},metadata:Ke.metadata})}else Ke._type===2?Ue.edits.push({resource:Ke.uri,textEdit:pe.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Ee?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ue.edits.push({resource:Ke.uri,textEdit:{range:D.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Ee?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Tt.from)}})}return Ue}we.from=Fe;function oe(Q){const Ee=new p.$uM,Ue=new m.$Bc;for(const Ye of Q.edits)if(Ye.textEdit){const Ke=Ye,st=r.URI.revive(Ke.resource),wt=D.to(Ke.textEdit.range),Kt=Ke.textEdit.text,jt=Ke.textEdit.insertAsSnippet;let Pt;jt?Pt=p.$tM.replace(wt,new p.$vM(Kt)):Pt=p.$rM.replace(wt,Kt);const lt=Ue.get(st);lt?lt.push(Pt):Ue.set(st,[Pt])}else Ee.renameFile(r.URI.revive(Ye.oldResource),r.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Ue)Ee.set(Ye,Ke);return Ee}we.to=oe})(re||(e.WorkspaceEdit=re={}));var fe;(function(we){const Fe=Object.create(null);Fe[p.SymbolKind.File]=0,Fe[p.SymbolKind.Module]=1,Fe[p.SymbolKind.Namespace]=2,Fe[p.SymbolKind.Package]=3,Fe[p.SymbolKind.Class]=4,Fe[p.SymbolKind.Method]=5,Fe[p.SymbolKind.Property]=6,Fe[p.SymbolKind.Field]=7,Fe[p.SymbolKind.Constructor]=8,Fe[p.SymbolKind.Enum]=9,Fe[p.SymbolKind.Interface]=10,Fe[p.SymbolKind.Function]=11,Fe[p.SymbolKind.Variable]=12,Fe[p.SymbolKind.Constant]=13,Fe[p.SymbolKind.String]=14,Fe[p.SymbolKind.Number]=15,Fe[p.SymbolKind.Boolean]=16,Fe[p.SymbolKind.Array]=17,Fe[p.SymbolKind.Object]=18,Fe[p.SymbolKind.Key]=19,Fe[p.SymbolKind.Null]=20,Fe[p.SymbolKind.EnumMember]=21,Fe[p.SymbolKind.Struct]=22,Fe[p.SymbolKind.Event]=23,Fe[p.SymbolKind.Operator]=24,Fe[p.SymbolKind.TypeParameter]=25;function oe(Ee){return typeof Fe[Ee]=="number"?Fe[Ee]:6}we.from=oe;function Q(Ee){for(const Ue in Fe)if(Fe[Ue]===Ee)return Number(Ue);return p.SymbolKind.Property}we.to=Q})(fe||(e.SymbolKind=fe={}));var V;(function(we){function Fe(Q){switch(Q){case p.SymbolTag.Deprecated:return 1}}we.from=Fe;function oe(Q){switch(Q){case 1:return p.SymbolTag.Deprecated}}we.to=oe})(V||(e.SymbolTag=V={}));var te;(function(we){function Fe(Q){return{name:Q.name,kind:fe.from(Q.kind),tags:Q.tags&&Q.tags.map(V.from),containerName:Q.containerName,location:ge.from(Q.location)}}we.from=Fe;function oe(Q){const Ee=new p.$CM(Q.name,fe.to(Q.kind),Q.containerName,ge.to(Q.location));return Ee.tags=Q.tags&&Q.tags.map(V.to),Ee}we.to=oe})(te||(e.WorkspaceSymbol=te={}));var ke;(function(we){function Fe(Q){const Ee={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),kind:fe.from(Q.kind),tags:Q.tags?.map(V.from)??[]};return Q.children&&(Ee.children=Q.children.map(Fe)),Ee}we.from=Fe;function oe(Q){const Ee=new p.$DM(Q.name,Q.detail,fe.to(Q.kind),D.to(Q.range),D.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(Ee.tags=Q.tags.map(V.to)),Q.children&&(Ee.children=Q.children.map(oe)),Ee}we.to=oe})(ke||(e.DocumentSymbol=ke={}));var Te;(function(we){function Fe(Q){const Ee=new p.$HM(fe.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}we.to=Fe;function oe(Q,Ee,Ue){if(Ee=Ee??Q._sessionId,Ue=Ue??Q._itemId,Ee===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ue,name:Q.name,detail:Q.detail,kind:fe.from(Q.kind),uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(V.from)}}we.from=oe})(Te||(e.CallHierarchyItem=Te={}));var Ie;(function(we){function Fe(oe){return new p.$IM(Te.to(oe.from),oe.fromRanges.map(Q=>D.to(Q)))}we.to=Fe})(Ie||(e.CallHierarchyIncomingCall=Ie={}));var ve;(function(we){function Fe(oe){return new p.$JM(Te.to(oe.to),oe.fromRanges.map(Q=>D.to(Q)))}we.to=Fe})(ve||(e.CallHierarchyOutgoingCall=ve={}));var ge;(function(we){function Fe(Q){return{range:Q.range&&D.from(Q.range),uri:Q.uri}}we.from=Fe;function oe(Q){return new p.$wM(r.URI.revive(Q.uri),D.to(Q.range))}we.to=oe})(ge||(e.location=ge={}));var J;(function(we){function Fe(Q){const Ee=Q,Ue=Q;return{originSelectionRange:Ee.originSelectionRange?D.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Ue.uri,range:D.from(Ee.targetRange?Ee.targetRange:Ue.range),targetSelectionRange:Ee.targetSelectionRange?D.from(Ee.targetSelectionRange):void 0}}we.from=Fe;function oe(Q){return{targetUri:r.URI.revive(Q.uri),targetRange:D.to(Q.range),targetSelectionRange:Q.targetSelectionRange?D.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?D.to(Q.originSelectionRange):void 0}}we.to=oe})(J||(e.DefinitionLink=J={}));var Y;(function(we){function Fe(Q){return{range:D.from(Q.range),contents:ne.fromMany(Q.contents)}}we.from=Fe;function oe(Q){return new p.$zM(Q.contents.map(ne.to),D.to(Q.range))}we.to=oe})(Y||(e.Hover=Y={}));var ce;(function(we){function Fe(Q){return{range:D.from(Q.range),expression:Q.expression}}we.from=Fe;function oe(Q){return new p.$uN(D.to(Q.range),Q.expression)}we.to=oe})(ce||(e.EvaluatableExpression=ce={}));var de;(function(we){function Fe(Q){if(Q instanceof p.$vN)return{type:"text",range:D.from(Q.range),text:Q.text};if(Q instanceof p.$wN)return{type:"variable",range:D.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof p.$xN)return{type:"expression",range:D.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Fe;function oe(Q){switch(Q.type){case"text":return{range:D.to(Q.range),text:Q.text};case"variable":return{range:D.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:D.to(Q.range),expression:Q.expression}}}we.to=oe})(de||(e.InlineValue=de={}));var Ne;(function(we){function Fe(Q){return{frameId:Q.frameId,stoppedLocation:D.from(Q.stoppedLocation)}}we.from=Fe;function oe(Q){return new p.$yN(Q.frameId,D.to(Q.stoppedLocation))}we.to=oe})(Ne||(e.InlineValueContext=Ne={}));var ue;(function(we){function Fe(Q){return{range:D.from(Q.range),kind:Q.kind}}we.from=Fe;function oe(Q){return new p.$AM(D.to(Q.range),Q.kind)}we.to=oe})(ue||(e.DocumentHighlight=ue={}));var Ce;(function(we){function Fe(Q){return{uri:Q.uri,highlights:Q.highlights.map(ue.from)}}we.from=Fe;function oe(Q){return new p.$BM(r.URI.revive(Q.uri),Q.highlights.map(ue.to))}we.to=oe})(Ce||(e.MultiDocumentHighlight=Ce={}));var Re;(function(we){function Fe(oe){switch(oe){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}we.to=Fe})(Re||(e.CompletionTriggerKind=Re={}));var je;(function(we){function Fe(oe){return{triggerKind:Re.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=Fe})(je||(e.CompletionContext=je={}));var U;(function(we){function Fe(Q){switch(Q){case p.CompletionItemTag.Deprecated:return 1}}we.from=Fe;function oe(Q){switch(Q){case 1:return p.CompletionItemTag.Deprecated}}we.to=oe})(U||(e.CompletionItemTag=U={}));var z;(function(we){const Fe=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function oe(Ue){return Fe.get(Ue)??9}we.from=oe;const Q=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Ee(Ue){return Q.get(Ue)??p.CompletionItemKind.Property}we.to=Ee})(z||(e.CompletionItemKind=z={}));var H;(function(we){function Fe(oe,Q){const Ee=new p.$RM(oe.label);return Ee.insertText=oe.insertText,Ee.kind=z.to(oe.kind),Ee.tags=oe.tags?.map(U.to),Ee.detail=oe.detail,Ee.documentation=R.$Gk(oe.documentation)?ne.to(oe.documentation):oe.documentation,Ee.sortText=oe.sortText,Ee.filterText=oe.filterText,Ee.preselect=oe.preselect,Ee.commitCharacters=oe.commitCharacters,o.$bt.isIRange(oe.range)?Ee.range=D.to(oe.range):typeof oe.range=="object"&&(Ee.range={inserting:D.to(oe.range.insert),replacing:D.to(oe.range.replace)}),Ee.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?Ee.insertText=new p.$vM(oe.insertText):(Ee.insertText=oe.insertText,Ee.textEdit=Ee.range instanceof p.$mM?new p.$rM(Ee.range,Ee.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Ee.additionalTextEdits=oe.additionalTextEdits.map(Ue=>pe.to(Ue))),Ee.command=Q&&oe.command?Q.fromInternal(oe.command):void 0,Ee}we.to=Fe})(H||(e.CompletionItem=H={}));var q;(function(we){function Fe(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ne.fromStrict(Q.documentation)}}we.from=Fe;function oe(Q){return{label:Q.label,documentation:R.$Gk(Q.documentation)?ne.to(Q.documentation):Q.documentation}}we.to=oe})(q||(e.ParameterInformation=q={}));var _;(function(we){function Fe(Q){return{label:Q.label,documentation:ne.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(q.from):[],activeParameter:Q.activeParameter}}we.from=Fe;function oe(Q){return{label:Q.label,documentation:R.$Gk(Q.documentation)?ne.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(q.to):[],activeParameter:Q.activeParameter}}we.to=oe})(_||(e.SignatureInformation=_={}));var se;(function(we){function Fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(_.from):[]}}we.from=Fe;function oe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(_.to):[]}}we.to=oe})(se||(e.SignatureHelp=se={}));var Oe;(function(we){function Fe(oe,Q){const Ee=new p.$QM(y.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(We.to.bind(void 0,oe)),Q.kind&&Qe.to(Q.kind));return Ee.textEdits=Q.textEdits&&Q.textEdits.map(pe.to),Ee.tooltip=R.$Gk(Q.tooltip)?ne.to(Q.tooltip):Q.tooltip,Ee.paddingLeft=Q.paddingLeft,Ee.paddingRight=Q.paddingRight,Ee}we.to=Fe})(Oe||(e.InlayHint=Oe={}));var We;(function(we){function Fe(oe,Q){const Ee=new p.$PM(Q.label);return Ee.tooltip=R.$Gk(Q.tooltip)?ne.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Ee.command=oe.fromInternal(Q.command)),Q.location&&(Ee.location=ge.to(Q.location)),Ee}we.to=Fe})(We||(e.InlayHintLabelPart=We={}));var Qe;(function(we){function Fe(Q){return Q}we.from=Fe;function oe(Q){return Q}we.to=oe})(Qe||(e.InlayHintKind=Qe={}));var xe;(function(we){function Fe(Q){return{range:D.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Fe;function oe(Q){let Ee;if(Q.url)try{Ee=typeof Q.url=="string"?r.URI.parse(Q.url,!0):r.URI.revive(Q.url)}catch{}return new p.$WM(D.to(Q.range),Ee)}we.to=oe})(xe||(e.DocumentLink=xe={}));var tt;(function(we){function Fe(Q){const Ee=new p.$ZM(Q.label);return Q.textEdit&&(Ee.textEdit=pe.to(Q.textEdit)),Q.additionalTextEdits&&(Ee.additionalTextEdits=Q.additionalTextEdits.map(Ue=>pe.to(Ue))),Ee}we.to=Fe;function oe(Q){return{label:Q.label,textEdit:Q.textEdit?pe.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ee=>pe.from(Ee)):void 0}}we.from=oe})(tt||(e.ColorPresentation=tt={}));var at;(function(we){function Fe(Q){return new p.$XM(Q[0],Q[1],Q[2],Q[3])}we.to=Fe;function oe(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=oe})(at||(e.Color=at={}));var nt;(function(we){function Fe(Q){return{range:D.from(Q.range)}}we.from=Fe;function oe(Q){return new p.$GM(D.to(Q.range))}we.to=oe})(nt||(e.SelectionRange=nt={}));var rt;(function(we){function Fe(oe){switch(oe){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}we.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var ct;(function(we){function Fe(Q){switch(Q){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Fe;function oe(Q){switch(Q){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}we.to=oe})(ct||(e.TextEditorLineNumbersStyle=ct={}));var Be;(function(we){function Fe(Q){if(Q===p.EndOfLine.CRLF)return 1;if(Q===p.EndOfLine.LF)return 0}we.from=Fe;function oe(Q){if(Q===1)return p.EndOfLine.CRLF;if(Q===0)return p.EndOfLine.LF}we.to=oe})(Be||(e.EndOfLine=Be={}));var it;(function(we){function Fe(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Fe})(it||(e.ProgressLocation=it={}));var Z;(function(we){function Fe(Q){const Ee={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ee.kind=X.from(Q.kind)),Ee}we.from=Fe;function oe(Q){const Ee={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ee.kind=X.to(Q.kind)),Ee}we.to=oe})(Z||(e.FoldingRange=Z={}));var X;(function(we){function Fe(Q){if(Q)switch(Q){case p.FoldingRangeKind.Comment:return s.$6t.Comment;case p.FoldingRangeKind.Imports:return s.$6t.Imports;case p.FoldingRangeKind.Region:return s.$6t.Region}}we.from=Fe;function oe(Q){if(Q)switch(Q.value){case s.$6t.Comment.value:return p.FoldingRangeKind.Comment;case s.$6t.Imports.value:return p.FoldingRangeKind.Imports;case s.$6t.Region.value:return p.FoldingRangeKind.Region}}we.to=oe})(X||(e.FoldingRangeKind=X={}));var $e;(function(we){function Fe(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?D.from(oe.selection):void 0,override:typeof oe.override=="boolean"?a.$3E.id:void 0}}we.from=Fe})($e||(e.TextEditorOpenOptions=$e={}));var Ve;(function(we){function Fe(Ue){return Ue instanceof p.$iN?Ue.toJSON():typeof Ue=="string"?Ue:oe(Ue)||Q(Ue)?new p.$iN(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}we.from=Fe;function oe(Ue){const Ye=Ue;return Ye?r.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Q(Ue){const Ye=Ue;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ee(Ue){return typeof Ue=="string"?Ue:new p.$iN(r.URI.revive(Ue.baseUri),Ue.pattern)}we.to=Ee})(Ve||(e.GlobPattern=Ve={}));var Ze;(function(we){function Fe(oe){if(oe){if(Array.isArray(oe))return oe.map(Fe);if(typeof oe=="string")return oe;{const Q=oe;return{language:Q.language,scheme:Q.scheme,pattern:Ve.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Fe})(Ze||(e.LanguageSelector=Ze={}));var ut;(function(we){function Fe(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&r.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ye=>Ye instanceof p.$mM)))}we.is=Fe;function oe(Q){return{documents:Q.documents.map(Ee=>Ee.map(Ue=>({uri:r.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ye=>D.from(Ye))})))}}we.from=oe})(ut||(e.MappedEditsContext=ut={}));var Ae;(function(we){function Fe(Q){return{start:Q.start,end:Q.end}}we.from=Fe;function oe(Q){return new p.$LN(Q.start,Q.end)}we.to=oe})(Ae||(e.NotebookRange=Ae={}));var Dt;(function(we){function Fe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Fe;function oe(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=oe})(Dt||(e.NotebookCellExecutionSummary=Dt={}));var Jt;(function(we){function Fe(oe){if(oe===t.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(oe===t.NotebookCellExecutionState.Pending)return;if(oe===t.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}we.to=Fe})(Jt||(e.NotebookCellExecutionState=Jt={}));var zt;(function(we){function Fe(Q){switch(Q){case p.NotebookCellKind.Markup:return t.CellKind.Markup;case p.NotebookCellKind.Code:default:return t.CellKind.Code}}we.from=Fe;function oe(Q){switch(Q){case t.CellKind.Markup:return p.NotebookCellKind.Markup;case t.CellKind.Code:default:return p.NotebookCellKind.Code}}we.to=oe})(zt||(e.NotebookCellKind=zt={}));var hi;(function(we){function Fe(Q){const Ee={metadata:Q.metadata??Object.create(null),cells:[]};for(const Ue of Q.cells)p.$MN.validate(Ue),Ee.cells.push(Tt.from(Ue));return Ee}we.from=Fe;function oe(Q){const Ee=new p.$NN(Q.cells.map(Tt.to));return(0,f.$8f)(Q.metadata)||(Ee.metadata=Q.metadata),Ee}we.to=oe})(hi||(e.NotebookData=hi={}));var Tt;(function(we){function Fe(Q){return{cellKind:zt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Dt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Qt.from):[]}}we.from=Fe;function oe(Q){return new p.$MN(zt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Qt.to):void 0,Q.metadata,Q.internalMetadata?Dt.to(Q.internalMetadata):void 0)}we.to=oe})(Tt||(e.NotebookCellData=Tt={}));var Et;(function(we){function Fe(Q){return{mime:Q.mime,valueBytes:F.$ue.wrap(Q.data)}}we.from=Fe;function oe(Q){return new p.$ON(Q.valueBytes.buffer,Q.mime)}we.to=oe})(Et||(e.NotebookCellOutputItem=Et={}));var Qt;(function(we){function Fe(Q){return{outputId:Q.id,items:Q.items.map(Et.from),metadata:Q.metadata}}we.from=Fe;function oe(Q){const Ee=Q.items.map(Et.to);return new p.$PN(Ee,Q.outputId,Q.metadata)}we.to=oe})(Qt||(e.NotebookCellOutput=Qt={}));var Ut;(function(we){function Fe(Ee){return Q(Ee)?{include:Ve.from(Ee.include)??void 0,exclude:Ve.from(Ee.exclude)??void 0}:Ve.from(Ee)??void 0}we.from=Fe;function oe(Ee){return Q(Ee)?{include:Ve.to(Ee.include),exclude:Ve.to(Ee.exclude)}:Ve.to(Ee)}we.to=oe;function Q(Ee){const Ue=Ee;return Ue?!(0,f.$4f)(Ue.include)&&!(0,f.$4f)(Ue.exclude):!1}})(Ut||(e.NotebookExclusiveDocumentPattern=Ut={}));var oi;(function(we){function Fe(oe,Q,Ee){const Ue=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Ue,Ee),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=Fe})(oi||(e.NotebookStatusBarItem=oi={}));var ti;(function(we){function Fe(oe,Q,Ee){const Ue=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:Q.toInternal(Ue,Ee),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}we.from=Fe})(ti||(e.NotebookKernelSourceAction=ti={}));var Xe;(function(we){function Fe(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}we.from=Fe})(Xe||(e.NotebookDocumentContentOptions=Xe={}));var xt;(function(we){function Fe(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Fe;function oe(Q){return new p.$RN(r.URI.revive(Q.uri),Q.provides)}we.to=oe})(xt||(e.NotebookRendererScript=xt={}));var ii;(function(we){function Fe(Q){return{message:ne.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:D.from(Q.location.range),uri:Q.location.uri}}}we.from=Fe;function oe(Q){const Ee=new p.$XN(typeof Q.message=="string"?Q.message:ne.to(Q.message));return Ee.actualOutput=Q.actual,Ee.expectedOutput=Q.expected,Ee.contextValue=Q.contextValue,Ee.location=Q.location?ge.to(Q.location):void 0,Ee}we.to=oe})(ii||(e.TestMessage=ii={}));var dt;(function(we){we.namespace=c.$_K,we.denamespace=c.$aL})(dt||(e.TestTag=dt={}));var pt;(function(we){function Fe(Q){const Ee=(0,i.$yO)(Q).controllerId;return{extId:v.$7K.fromExtHostTestItem(Q,Ee).toString(),label:Q.label,uri:r.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Ue=>dt.namespace(Ee,Ue.id)),range:o.$bt.lift(D.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ne.fromStrict(Q.error)||null}}we.from=Fe;function oe(Q){return{parent:void 0,error:void 0,id:v.$7K.fromString(Q.extId).localId,label:Q.label,uri:r.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ee=>{const{tagId:Ue}=dt.denamespace(Ee);return new p.$YN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=oe})(pt||(e.TestItem=pt={})),function(we){function Fe(Q){return{id:Q.id}}we.from=Fe;function oe(Q){return new p.$YN(Q.id)}we.to=oe}(dt||(e.TestTag=dt={}));var ni;(function(we){const Fe=(Q,Ee)=>{const Ue=Q.value;if(!Ue)return;const Ye={...pt.toPlain(Ue.item),parent:Ee,taskStates:Ue.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(st=>st.type===0).map(ii.to)})),children:[]};if(Q.children)for(const Ke of Q.children.values()){const st=Fe(Ke,Ye);st&&Ye.children.push(st)}return Ye};function oe(Q){const Ee=new u.$rO;for(const Ke of Q.items)Ee.insert(v.$7K.fromString(Ke.item.extId).path,Ke);const Ue=[Ee.nodes],Ye=[];for(;Ue.length;)for(const Ke of Ue.pop())Ke.value?Ye.push(Ke):Ke.children&&Ue.push(Ke.children.values());return{completedAt:Q.completedAt,results:Ye.map(Ke=>Fe(Ke)).filter(f.$3f)}}we.to=oe})(ni||(e.TestResults=ni={}));var Bt;(function(we){function Fe(Ue){return{covered:Ue.covered,total:Ue.total}}function oe(Ue){return"line"in Ue?y.from(Ue):D.from(Ue)}function Q(Ue){return"branches"in Ue?{count:Ue.executed,location:oe(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&oe(Ye.location),label:Ye.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:oe(Ue.location)}}we.fromDetailed=Q;function Ee(Ue){return{uri:Ue.uri,statement:Fe(Ue.statementCoverage),branch:Ue.branchCoverage&&Fe(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Fe(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(Q)}}we.fromFile=Ee})(Bt||(e.TestCoverage=Bt={}));var Wt;(function(we){function Fe(oe){switch(oe){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}we.to=Fe})(Wt||(e.CodeActionTriggerKind=Wt={}));var ft;(function(we){function Fe(Q){const Ee=new p.$5N(fe.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}we.to=Fe;function oe(Q,Ee,Ue){if(Ee=Ee??Q._sessionId,Ue=Ue??Q._itemId,Ee===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ue,kind:fe.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(V.from)}}we.from=oe})(ft||(e.TypeHierarchyItem=ft={}));var Mt;(function(we){function Fe(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}we.from=Fe})(Mt||(e.ViewBadge=Mt={}));var _t;(function(we){function Fe(Ue,Ye,Ke){const st=Ye.fileData;return st?new p.$aN(new p.$bN(st.name,r.URI.revive(st.uri),st.id,(0,N.$db)(()=>Ke(st.id)))):Ue===O.$ys.uriList&&Ye.uriListData?new p.$_M(Ee(Ye.uriListData)):new p.$_M(Ye.asString)}we.to=Fe;async function oe(Ue,Ye){const Ke=await Ye.asString();if(Ue===O.$ys.uriList)return{asString:Ke,fileData:void 0,uriListData:Q(Ke)};const st=Ye.asFile();return{asString:Ke,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}we.from=oe;function Q(Ue){return M.$Kt.split(Ue).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return r.URI.parse(Ye)}catch{}return Ye})}function Ee(Ue){return M.$Kt.create(Ue.map(Ye=>typeof Ye=="string"?Ye:r.URI.revive(Ye)))}})(_t||(e.DataTransferItem=_t={}));var ri;(function(we){function Fe(Q,Ee){const Ue=Q.items.map(([Ye,Ke])=>[Ye,_t.to(Ye,Ke,Ee)]);return new p.$cN(Ue)}we.toDataTransfer=Fe;async function oe(Q){const Ee={items:[]},Ue=[];for(const[Ye,Ke]of Q)Ue.push((async()=>{Ee.items.push([Ye,await _t.from(Ye,Ke)])})());return await Promise.all(Ue),Ee}we.from=oe})(ri||(e.DataTransfer=ri={}));var He;(function(we){function Fe(Q,Ee){return{kind:"reply",agentId:Q.participant??Ee?.agentId??"",subCommand:Q.command??Ee?.command,message:Q.prompt,title:Q.label}}we.from=Fe;function oe(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=oe})(He||(e.ChatFollowup=He={}));var Vt;(function(we){function Fe(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}we.from=Fe})(Vt||(e.ChatInlineFollowup=Vt={}));var Zt;(function(we){function Fe(Q){switch(Q.role){case 0:return new p.$mO(Q.content);case 1:return new p.$nO(Q.content);case 2:return new p.$oO(Q.content)}}we.to=Fe;function oe(Q){if(Q instanceof p.$mO)return{role:0,content:Q.content};if(Q instanceof p.$nO)return{role:1,content:Q.content};if(Q instanceof p.$oO)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=oe})(Zt||(e.LanguageModelMessage=Zt={}));var qt;(function(we){function Fe(Ee){const Ue={};for(const Ye of Object.keys(Ee))Ue[Ye]=Ee[Ye].map(we.to);return Ue}we.objectTo=Fe;function oe(Ee){return{level:mt.to(Ee.level),kind:Ee.kind,value:(0,r.$wc)(Ee.value)?r.URI.revive(Ee.value):Ee.value,description:Ee.description}}we.to=oe;function Q(Ee){return{level:mt.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}we.from=Q})(qt||(e.ChatVariable=qt={}));var mt;(function(we){function Fe(Q){switch(Q){case"short":return p.ChatVariableLevel.Short;case"medium":return p.ChatVariableLevel.Medium;case"full":default:return p.ChatVariableLevel.Full}}we.to=Fe;function oe(Q){switch(Q){case p.ChatVariableLevel.Short:return"short";case p.ChatVariableLevel.Medium:return"medium";case p.ChatVariableLevel.Full:default:return"full"}}we.from=oe})(mt||(e.ChatVariableLevel=mt={}));var At;(function(we){function Fe(oe){switch(oe){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Fe})(At||(e.InteractiveEditorResponseFeedbackKind=At={}));var It;(function(we){function Fe(Q){return{kind:"markdownContent",content:ne.from(Q.value)}}we.to=Fe;function oe(Q){return new p.$eO(ne.to(Q.content))}we.from=oe})(It||(e.ChatResponseMarkdownPart=It={}));var Ft;(function(we){function Fe(Q){const{value:Ee,baseUri:Ue}=Q;function Ye(Ke,st){return Ke.map(wt=>{const Kt=r.URI.joinPath(st,wt.name);return{label:wt.name,uri:Kt,children:wt.children&&Ye(wt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,b.$Rg)(Ue),uri:Ue,children:Ye(Ee,Ue)}}}we.to=Fe;function oe(Q){const Ee=(0,k.$Qh)(Q.treeData);function Ue(st){return st.map(wt=>({name:wt.label,children:wt.children&&Ue(wt.children)}))}const Ye=Ee.uri,Ke=Ee.children?Ue(Ee.children):[];return new p.$fO(Ke,Ye)}we.from=oe})(Ft||(e.ChatResponseFilesPart=Ft={}));var si;(function(we){function Fe(Q){return{kind:"inlineReference",name:Q.title,inlineReference:r.URI.isUri(Q.value)?Q.value:g.from(Q.value)}}we.to=Fe;function oe(Q){const Ee=(0,k.$Qh)(Q);return new p.$gO(r.URI.isUri(Ee.inlineReference)?Ee.inlineReference:g.to(Ee.inlineReference),Q.name)}we.from=oe})(si||(e.ChatResponseAnchorPart=si={}));var Ht;(function(we){function Fe(Q){return{kind:"progressMessage",content:ne.from(Q.value)}}we.to=Fe;function oe(Q){return new p.$hO(Q.content.value)}we.from=oe})(Ht||(e.ChatResponseProgressPart=Ht={}));var Xt;(function(we){function Fe(Q,Ee,Ue){return{kind:"command",command:Ee.toInternal(Q.value,Ue)??{command:Q.value.command,title:Q.value.title}}}we.to=Fe;function oe(Q,Ee){return new p.$iO(Ee.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.from=oe})(Xt||(e.ChatResponseCommandButtonPart=Xt={}));var bt;(function(we){function Fe(Q){return{kind:"reference",reference:r.URI.isUri(Q.value)?Q.value:g.from(Q.value)}}we.to=Fe;function oe(Q){const Ee=(0,k.$Qh)(Q);return new p.$jO(r.URI.isUri(Ee.reference)?Ee.reference:g.to(Ee.reference))}we.from=oe})(bt||(e.ChatResponseReferencePart=bt={}));var Ot;(function(we){function Fe(Ee){return Ee instanceof p.$eO?It.to(Ee):Ee instanceof p.$gO?si.to(Ee):Ee instanceof p.$jO?bt.to(Ee):Ee instanceof p.$hO?Ht.to(Ee):Ee instanceof p.$fO?Ft.to(Ee):{kind:"content",content:""}}we.to=Fe;function oe(Ee,Ue){switch(Ee.kind){case"reference":return bt.from(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ee,Ue)}}we.from=oe;function Q(Ee,Ue){switch(Ee.kind){case"markdownContent":return It.from(Ee);case"inlineReference":return si.from(Ee);case"progressMessage":return;case"treeData":return Ft.from(Ee);case"command":return Xt.from(Ee,Ue)}}we.fromContent=Q})(Ot||(e.ChatResponsePart=Ot={}));var Lt;(function(we){function Fe(Ee,Ue){return"markdownContent"in Ue?((0,w.$7F)(Ee,"chatParticipantAdditions"),{content:ne.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,w.$7F)(Ee,"chatParticipantAdditions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,w.$7F)(Ee,"chatParticipantAdditions"),{content:ne.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Ye=>({uri:Ye.uri,version:Ye.version,ranges:Ye.ranges.map(Ke=>D.from(Ke))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:D.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:D.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"participant"in Ue?((0,w.$7F)(Ee,"chatParticipantAdditions"),{agentName:Ue.participant,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:ne.from(Ue.message),kind:"progressMessage"}:void 0}we.from=Fe;function oe(Ee){switch(Ee.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(Ee);case"content":return{content:Ee.content};case"usedContext":return{documents:Ee.documents.map(Ue=>({uri:r.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ye=>D.to(Ye))}))};case"reference":return{reference:(0,r.$wc)(Ee.reference)?r.URI.revive(Ee.reference):g.to(Ee.reference)};case"agentDetection":return;case"progressMessage":return{message:Ee.content.value};case"vulnerability":return{content:Ee.content,vulnerabilities:Ee.vulnerabilities};default:return}}we.to=oe;function Q(Ee,Ue){switch(Ee.kind){case"markdownContent":return{content:Ee.content.value};case"inlineReference":return{inlineReference:(0,r.$wc)(Ee.inlineReference)?r.URI.revive(Ee.inlineReference):g.to(Ee.inlineReference),title:Ee.name};case"command":return{command:Ue.fromInternal(Ee.command)??{command:Ee.command.id,title:Ee.command.title}};default:return}}we.toProgressContent=Q})(Lt||(e.ChatResponseProgress=Lt={}));var Nt;(function(we){function Fe(oe){return{prompt:oe.message,command:oe.command,variables:oe.variables.variables.map(St.to),location:yt.to(oe.location)}}we.to=Fe})(Nt||(e.ChatAgentRequest=Nt={}));var yt;(function(we){function Fe(oe){switch(oe){case h.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return p.ChatLocation.Panel}}we.to=Fe})(yt||(e.ChatLocation=yt={}));var St;(function(we){function Fe(oe){return{name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],values:oe.values.map(qt.to)}}we.to=Fe})(St||(e.ChatAgentResolvedVariable=St={}));var kt;(function(we){function Fe(oe){return{label:oe.label,values:oe.values.map(qt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation}}we.from=Fe})(kt||(e.ChatAgentCompletionItem=kt={}));var ci;(function(we){function Fe(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}we.to=Fe})(ci||(e.ChatAgentResult=ci={}));var ei;(function(we){function Fe(oe,Q,Ee){if(Q.action.kind==="vote")return;const Ue=ci.to(oe);return Q.action.kind==="command"?{action:{kind:"command",commandButton:Lt.toProgressContent(Q.action.commandButton,Ee)},result:Ue}:Q.action.kind==="followUp"?{action:{kind:"followUp",followup:He.to(Q.action.followup)},result:Ue}:{action:Q.action,result:Ue}}we.to=Fe})(ei||(e.ChatAgentUserActionEvent=ei={}));var ui;(function(we){function Fe(oe,Q,Ee){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:Q.toInternal(oe,Ee)}we.from=Fe})(ui||(e.TerminalQuickFix=ui={}));var di;(function(we){function Fe(oe){return{kind:Yt.to(oe.kind)}}we.to=Fe})(di||(e.PartialAcceptInfo=di={}));var Yt;(function(we){function Fe(oe){switch(oe){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}we.to=Fe})(Yt||(e.PartialAcceptTriggerKind=Yt={}));var Ct;(function(we){function Fe(oe,Q){return{id:Q,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}we.from=Fe})(Ct||(e.DebugTreeItem=Ct={}))}),define(Pe[252],Me([1,0,4,17,8]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;let N=class{constructor(m,d){this.a=m.getProxy(I.$iM.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>d.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,d,k){const O=M.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};e.$Xic=N,e.$Xic=N=Je([qe(0,F.$CO)],N)}),define(Pe[253],Me([1,0,18,11,42,5,39,6,64,16,2,162,20,4,8,7,213,22]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class n{constructor(t,v,c,$,w,p){this.i=t,this.j=v,this.k=c,this.l=$,this.m=w,this.n=p,this.b=d.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let v=function($){if(t.c){const w=new Error("Response stream has been closed");throw Error.captureStackTrace(w,$),w}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){v(this.markdown);const w=new r.$eO($),p=f.ChatResponseMarkdownPart.to(w);return c(p),this},filetree($,w){v(this.filetree);const p=new r.$fO($,w),l=f.ChatResponseFilesPart.to(p);return c(l),this},anchor($,w){v(this.anchor);const p=new r.$gO($,w),l=f.ChatResponseAnchorPart.to(p);return c(l),this},button($){v(this.anchor);const w=new r.$iO($),p=f.ChatResponseCommandButtonPart.to(w,t.m,t.n);return c(p),this},progress($){v(this.progress);const w=new r.$hO($),p=f.ChatResponseProgressPart.to(w);return c(p),this},reference($){v(this.reference);const w=new r.$jO($),p=f.ChatResponseReferencePart.to(w);return c(p),this},push($){v(this.push);const w=f.ChatResponsePart.to($);return c(w),this},report($){if(v(this.report),"placeholder"in $&&"resolvedContent"in $)return;const w=f.ChatResponseProgress.from(t.i,$);if(!w){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(w),this}}}return this.g}}class i{static{this.b=0}constructor(t,v,c){this.i=v,this.j=c,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(b.$iM.MainThreadChatAgents2)}createChatAgent(t,v,c){const $=i.b++,w=new a(t,v,this.d,$,c);return this.c.set($,w),this.d.$registerAgent($,t.identifier,v,{},(0,s.$6F)(t,"chatParticipantAdditions")),w.apiAgent}async $invokeAgent(t,v,c,$){const w=this.c.get(t);if(!w)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.g.get(v.sessionId);p||(p=new m.$Tc,this.g.set(v.sessionId,p));const l=new n(w.extension,v,this.d,this.i,this.j.converter,p);try{const D=await this.k(v.agentId,c),g=w.invoke(f.ChatAgentRequest.to(v),{history:D},l.apiObject,$);return await(0,F.$8g)(Promise.resolve(g).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${w.extension.identifier.value}] [@${w.id}] ${C}`,w.extension),{errorDetails:{message:C},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,w.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,M.$5i)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,v){const c=[];for(const $ of v.history){const w=f.ChatAgentResult.to($.result),p=t===$.request.agentId?w:{...w,metadata:void 0};c.push(new r.$kO($.request.message,$.request.command,$.request.variables.variables.map(f.ChatAgentResolvedVariable.to),{extensionId:"",name:$.request.agentId}));const l=(0,I.$Hb)($.response.map(D=>f.ChatResponsePart.fromContent(D,this.j.converter)));c.push(new r.$lO(l,p,{extensionId:"",name:$.request.agentId},$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,v,c,$,w){const p=this.c.get(v);if(!p)return Promise.resolve([]);const l=await this.k(p.id,$),D=f.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:l},w)).filter(g=>{const S=!g.participant||R.Iterable.some(this.c.values(),y=>y.id===g.participant&&u.$Cm.equals(y.extension.identifier,p.extension.identifier));return S||this.i.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${g.participant}`),S}).map(g=>f.ChatFollowup.from(g,t))}$acceptFeedback(t,v,c,$){const w=this.c.get(t);if(!w)return;const p=f.ChatAgentResult.to(v);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=r.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=r.ChatResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze($?{result:p,kind:l,reportIssue:$}:{result:p,kind:l}))}$acceptAction(t,v,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const w=f.ChatAgentUserActionEvent.to(v,c,this.j.converter);w&&$.acceptAction(Object.freeze(w))}async $invokeCompletionProvider(t,v,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(v,c)).map(f.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,v){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(v)}async $provideSampleQuestions(t,v){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(v)).map($=>f.ChatFollowup.from($,void 0))}}e.$Zic=i;class a{constructor(t,v,c,$,w){this.extension=t,this.id=v,this.x=c,this.y=$,this.z=w,this.o=new N.$7d,this.p=new N.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,v){return this.s?await this.s.provider.provideCompletionItems(t,v)??[]:[]}async provideFollowups(t,v,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,v,c);return $?$.filter(w=>!(w&&"commandId"in w)).filter(w=>!(w&&"message"in w)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const v=await this.t.provideWelcomeMessage(t);return v?v.map(c=>typeof c=="string"?c:f.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const v=await this.t.provideSampleQuestions(t);return v||[]}get apiAgent(){let t=!1,v=!1;const c=()=>{t||v||(v=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof O.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof r.$gN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:f.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:f.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),v=!1}))},$=this;return{get name(){return $.id},get description(){return $.c??""},set description(w){$.c=w,c()},get fullName(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.d??$.extension.displayName??$.extension.name},set fullName(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.d=w,c()},get iconPath(){return $.g},set iconPath(w){$.g=w,c()},get requestHandler(){return $.z},set requestHandler(w){(0,k.$5f)(typeof w=="function","Invalid request handler"),$.z=w},get followupProvider(){return $.b},set followupProvider(w){$.b=w,c()},get isDefault(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.i},set isDefault(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.i=w,c()},get helpTextPrefix(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.j},set helpTextPrefix(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.j=w,c()},get helpTextVariablesPrefix(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.k},set helpTextVariablesPrefix(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.k=w,c()},get helpTextPostfix(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.l},set helpTextPostfix(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.l=w,c()},get isSecondary(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.n},set isSecondary(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.n=w,c()},get sampleRequest(){return $.m},set sampleRequest(w){$.m=w,c()},get supportIssueReporting(){return(0,s.$7F)($.extension,"chatParticipantAdditions"),$.q},set supportIssueReporting(w){(0,s.$7F)($.extension,"chatParticipantAdditions"),$.q=w,c()},get onDidReceiveFeedback(){return $.o.event},set participantVariableProvider(w){if((0,s.$7F)($.extension,"chatParticipantAdditions"),$.s=w,w){if(!w.triggerCharacters.length)throw new Error("triggerCharacters are required");$.x.$registerAgentCompletionsProvider($.y,w.triggerCharacters)}else $.x.$unregisterAgentCompletionsProvider($.y)},get participantVariableProvider(){return(0,s.$7F)($.extension,"chatParticipantAdditions"),$.s},set welcomeMessageProvider(w){(0,s.$7F)($.extension,"defaultChatParticipant"),$.t=w,c()},get welcomeMessageProvider(){return(0,s.$7F)($.extension,"defaultChatParticipant"),$.t},onDidPerformAction:(0,s.$6F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return $.u},set isSticky(w){$.u=w,c()},set requester(w){$.w=w,c()},get requester(){return $.w},dispose(){t=!0,$.b=void 0,$.o.dispose(),$.x.$unregisterAgent($.y)}}}invoke(t,v,c,$){return this.z(t,v,c,$)}}}),define(Pe[254],Me([1,0,14,6,4,8,7,22]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class d{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$iM.MainThreadChatVariables)}async $resolveVariable(E,u,b,f){const r=this.b.get(E);if(r)try{if(r.resolver.resolve2){(0,m.$7F)(r.extension,"chatParticipantAdditions");const o=new k(u,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:b},o.apiObject,f);if(s)return s.map(N.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:b},f);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(E,u,b,f){const r=d.a++;return this.b.set(r,{extension:E,data:{name:u,description:b},resolver:f}),this.c.$registerVariable(r,{name:u,description:b}),(0,F.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$3ic=d;class k{constructor(E,u){this.c=E,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(f){if(E.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,f),r}};const E=this,b=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){u(this.progress);const r=new R.$hO(f),o=N.ChatResponseProgressPart.to(r);return b(o),this},reference(f){u(this.reference);const r=new R.$jO(f),o=N.ChatResponseReferencePart.to(r);return b(o),this},push(f){u(this.push);const r=N.ChatResponsePart.to(f);return b(r),this}}}return this.b}}}),define(Pe[255],Me([1,0,11,68,5,6,2,87,20,8,7,4,22]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=b;function b(f,r,o){const s=f.getProxy(E.$iM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new d.$Em,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,g=this.b.get(D.commentControlHandle);if(!g)return D;const S=g.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);return g?l.$mid===8?g.value:{thread:g.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.commentUniqueId,y=g.getCommentByUniqueId(S);return y||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.text,y=l.commentUniqueId,C=g.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=S:C.body=new O.$LM(S),C):l}return l}})}createCommentController(l,D,g){const S=n.a++,y=new a(l,S,D,g);this.b.set(y.handle,y);const C=this.c.get(l.identifier)||[];return C.push(y),this.c.set(l.identifier,C),y.value}async $createCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,g)}async $setActiveComment(l,D){const g=this.b.get(l);g&&g.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,g)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,g){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(R.URI.revive(D));return(0,I.$_g)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(y.document,g);let A;return Array.isArray(C)?A={ranges:C,fileComments:!1}:C?A={ranges:C.ranges||[],fileComments:C.fileComments||!1}:A=C??void 0,A}).then(C=>{let A;return C&&(A={ranges:C.ranges.map(G=>k.Range.from(G)),fileComments:C.fileComments}),A})}$toggleReaction(l,D,g,S,y){const C=this.b.get(l);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$_g)(()=>{const A=C.getCommentThread(D);if(A){const G=A.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&G&&C.reactionHandler)return C.reactionHandler(G,v(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$7F)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,g,S,y,C,A,G){this.m=D,this.n=g,this.o=S,this.p=y,this.q=C,this.extensionDescription=A,this.r=G,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,k.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(W){T.range=W},get comments(){return T.comments},set comments(W){T.comments=W},get collapsibleState(){return T.collapsibleState},set collapsibleState(W){T.collapsibleState=W},get canReply(){return T.canReply},set canReply(W){T.canReply=W},get contextValue(){return T.contextValue},set contextValue(W){T.contextValue=W},get label(){return T.label},set label(W){T.label=W},get state(){return T.state},set state(W){T.state=W},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const l=g=>Object.prototype.hasOwnProperty.call(this.b,g),D={};l("range")&&(D.range=k.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(g=>h(this,g,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=w(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const g=D[0],S=D[1];if(l===S)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,F.$Mh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$7F)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$7F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$7F)(this.h,"activeComment"),this.f}constructor(l,D,g,S){this.h=l,this.i=D,this.j=g,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,g,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,A,G){return y.createCommentThread(C,A,G).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,g){D===void 0&&(0,u.$7F)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,g,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const g=new i(this.id,this.handle,void 0,R.URI.revive(l),k.Range.to(D),[],this.h,!0);return g.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(l,D){const g=this.a.get(l);g&&(g.range=k.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(p,l,D,g){let S=D.get(l);return S||(S=++p.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$7F)(g,"commentsDraftState"),l.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$7F)(g,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:k.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(y=>t(y)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?k.$BO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(l=>l.name):p.reactors}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?R.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(l=>({name:l}))}}function c(p){if(p!==void 0)switch(p){case O.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function $(p){let l;if(typeof p=="object"?l=p.resolved:l=p,l!==void 0)switch(l){case O.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function w(p){let l;if(typeof p=="object"&&(l=p.applicability),l!==void 0)switch(l){case O.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case O.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new n}}),define(Pe[256],Me([1,0,25,99,6,12,24,2,8,62,74,4,7]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class b{constructor(v,c){this.document=v,this.b=c,this.a=1,this.c=new O.$Jic("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,c){await this.f(v).undo(),c||this.disposeBackup()}async redo(v,c){await this.f(v).redo(),c||this.disposeBackup()}disposeEdits(v){for(const c of v)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=h(this.document.uri)+this.a++;return(0,R.$Ug)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const c=this.c.get(v,0);if(!c)throw new Error("No edit found");return c}}class f{constructor(){this.a=new Map}get(v,c){return this.a.get(this.b(v,c))}add(v,c,$){const w=this.b(v,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${v} resource:${c.uri}`);const p=new b(c,$);return this.a.set(w,p),p}delete(v,c){const $=this.b(v,c.uri);this.a.delete($)}b(v,c){return`${v}@@@${c}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(v,c,$){return this.b(0,v,c,$)}addCustomProvider(v,c,$){return this.b(1,v,c,$)}get(v){return this.a.get(v)}b(v,c,$,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:v,extension:$,provider:w}),new u.$kM(()=>this.a.delete(c))}}class s{constructor(v,c,$,w,p){this.d=c,this.f=$,this.g=w,this.h=p,this.b=new o,this.c=new f,this.a=v.getProxy(E.$iM.MainThreadCustomEditors)}registerCustomEditorProvider(v,c,$,w){const p=new M.$Tc;return i($)?(p.add(this.b.addTextProvider(c,v,$)),this.a.$registerTextEditorProvider((0,k.$jjc)(v),c,w.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,k.$hjc)(v))):(p.add(this.b.addCustomProvider(c,v,$)),n($)&&p.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const g=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,g,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,k.$jjc)(v),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,k.$hjc)(v))),u.$kM.from(p,new u.$kM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(v,c,$,w,p){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=m.URI.revive(v),g=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:w?.buffer},p);let S;return n(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,g,S),{editable:n(l.provider)}}async $disposeCustomDocument(v,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=m.URI.revive(v),{document:p}=this.i(c,w);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor(v,c,$,w,p,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const g=d.ViewColumn.to(p),S=this.g.createNewWebview(c,w.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,$,w.title,g,w.options,S,w.active),C=m.URI.revive(v);switch(D.type){case 1:{const{document:A}=this.i($,C);return D.provider.resolveCustomEditor(A,y,l)}case 0:{const A=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(A,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,c,$){this.i(c,v).disposeEdits($)}async $onMoveCustomEditor(v,c,$){const w=this.b.get($);if(!w)throw new Error(`No provider found for '${$}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const p=this.h.getWebviewPanel(v);if(!p)throw new Error("No webview found");const l=m.URI.revive(c),D=this.d.getDocument(l);await w.provider.moveCustomTextEditor(D,p,I.CancellationToken.None)}async $undo(v,c,$,w){return this.i(c,v).undo($,w)}async $redo(v,c,$,w){return this.i(c,v).redo($,w)}async $revert(v,c,$){const w=this.i(c,v);await this.j(c).revertCustomDocument(w.document,$),w.disposeBackup()}async $onSave(v,c,$){const w=this.i(c,v);await this.j(c).saveCustomDocument(w.document,$),w.disposeBackup()}async $onSaveAs(v,c,$,w){const p=this.i(c,v);return this.j(c).saveCustomDocumentAs(p.document,m.URI.revive($),w)}async $backup(v,c,$){const w=this.i(c,v),l=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},$);return w.updateBackup(l),l.id}i(v,c){const $=this.c.get(v,m.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(v){const $=this.b.get(v)?.provider;if(!$||!n($))throw new Error("Custom document is not editable");return $}}e.$mjc=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const v=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,F.$8i)(v)+""}}),define(Pe[257],Me([1,0,163,100,2,4,7,8,5,13,28,44]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=void 0;class b{#e;#t;#i;constructor(o,s,n,i,a,h,t,v){this.d=o,this.e=s,this.f=n,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,n),this.#i=new O.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(M.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(b.k);for(const t of o){const[v,c]=t;if((!h||v.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=v,n.push(v),this.#i.set(v,[])),c)this.#i.get(v)?.push(...c);else{const $=this.#i.get(v);$&&($.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let a=0;for(const h of n){let t=[];const v=this.#i.get(h);if(v)if(v.length>this.g){t=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const w of v)if(w.severity===c[$]&&t.push({...m.Diagnostic.from(w),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,v.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=v.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,i]of this)o.call(s,n,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$Qic=b;let f=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new O.$Bc;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,i){this.j=s,this.k=n,this.l=i,this.g=new Map,this.h=new d.$$d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,u._mapper),this.f=o.getProxy(N.$iM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:i,h:a,j:h,k:t,l:v}=this,c=new class{$changeMany(p,l){i.$changeMany(p,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,l.length===0?"CLEARING":l)}$clear(p){i.$clear(p),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!n.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(n.has($))}return new class extends b{constructor(){super(s,$,u.e,u.d,p=>v.getDocument(p)?.version,t.extUri,c,a),n.set($,this)}dispose(){super.dispose(),n.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=n.length,s.set(a.toString(),t),n.push([a,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new b(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(M.URI.revive(s),n.map(m.Diagnostic.to))}};e.$Ric=f,e.$Ric=f=u=Je([qe(1,k.$Nj),qe(2,E.$Pic)],f)}),define(Pe[258],Me([1,0,2,14,7,8,191]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class m{constructor(k,O,E,u={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=E,this.g=u,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,E,u)=>{const f={dispose:this.a.push([O,E,k])};return Array.isArray(u)&&u.push(f),f}}async $participateInSave(k,O){const E=I.URI.revive(k);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),f=[];try{for(const r of[...this.a]){if(u)break;const o=this.d.getDocument(E),s=await this.h(r,{document:o,reason:N.TextDocumentSaveReason.to(O)});f.push(s)}}finally{clearTimeout(b)}return f}h([k,O,E],u){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(E,k,O,u).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const r=this.b.get(k);this.b.set(k,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,E,u){const b=[],f=Date.now(),{document:r,reason:o}=u,{version:s}=r,n=Object.freeze({document:r,reason:o,waitUntil(i){if(Object.isFrozen(b))throw(0,F.$8)("waitUntil can not be called async");b.push(Promise.resolve(i))}});try{O.apply(E,[n])}catch(i){return Promise.reject(i)}return Object.freeze(b),new Promise((i,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(h),i(t)}).catch(t=>{clearTimeout(h),a(t)})}).then(i=>{const a={edits:[]};for(const h of i)if(Array.isArray(h)&&h.every(t=>t instanceof M.$rM))for(const{newText:t,newEol:v,range:c}of h)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:c&&N.Range.from(c),text:t,eol:v&&N.EndOfLine.from(v)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$1jc=m}),define(Pe[259],Me([1,0,5,6,2,4,111,8,16,26,7]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;class E{constructor(b,f){this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Tc,this.h=new Map,this.f=b.getProxy(N.$iM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const s=M.URI.revive(o);return(0,d.$6f)(this.g.getDocument(s))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>M.URI.revive(f))}$acceptModelLanguageChanged(b,f){const r=M.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(b){const f=M.URI.revive(b),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,f){const r=M.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,r){const o=M.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(f);let n;f.isUndoing?n=O.TextDocumentChangeReason.Undo:f.isRedoing&&(n=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.$On)({document:s.document,contentChanges:f.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(b,f){(0,R.$EO)(b,f)}}e.$Sic=E}),define(Pe[65],Me([1,0,260,5,16,2,3,4,17,8,7]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0,e.$njc=(0,R.$hi)("IExtHostEditorTabs");class E{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.$6N(N.URI.revive(this.b.input.uri));case 2:return new O.$7N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new O.$8N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new O.$9N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.$0N(this.b.input.viewType);case 4:return new O.$$N(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.$_N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.$aO;case 9:return new O.$bO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new O.$cO(this.b.input.providerId);default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new E(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new F.$7d,this.c=new F.$7d,this.e=[],this.a=o.getProxy(m.$iM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,M.$6f)(o.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,i)=>{const a=Array.isArray(n)?n:[n];return a.length?f(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),n=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,n),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const v=(0,M.$6f)(o.find(c=>c.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,s)}};e.$ojc=b,e.$ojc=b=Je([qe(0,d.$CO)],b);function f(r){return r.tabs!==void 0}}),define(Pe[261],Me([1,0,2,4,6,7,8,304,15,23,22,53]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;class u{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,n,i=14,a=14;for(const h of r){let t=s?(0,d.$nf)(s,h):0;for(t===0?n=1:n=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([n,h.toUpperCase().charCodeAt(t),a]),o.push([n,h.toLowerCase().charCodeAt(t),a]),n=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$k2(o)}}provideDocumentLinks(r){this.c();const o=[],s=m.$l2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const i=R.DocumentLink.to(n);i.target&&o.push(i)}return o}}class b{constructor(r,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(F.$iM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,n={}){if(b.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,O.$7F)(r,"fsChunks"),a+=4);let h;n.isReadonly&&(0,E.$Gk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(v=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(v)});const t=s.onDidChangeFile(v=>{const c=[];for(const $ of v){const{uri:w,type:p}=$;if(w.scheme!==o)continue;let l;switch(p){case N.FileChangeType.Changed:l=0;break;case N.FileChangeType.Created:l=1;break;case N.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:l})}this.a.$onFileSystemChange(i,c)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:n,size:i,permissions:a}=r;return{type:o,ctime:s,mtime:n,size:i,permissions:a}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>b.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>k.$ue.wrap(s))}$writeFile(r,o,s,n){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,n))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,n){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),n))}$copy(r,o,s,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,n){const i=this.l(r).watch(I.URI.revive(s),n);this.f.set(o,i)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=k.$ue.alloc(n);return Promise.resolve(i.read(o,s,a.buffer,0,n)).then(h=>a.slice(0,h))}$write(r,o,s,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$3jc=b}),define(Pe[262],Me([1,0,5,35,2,4,8,7,40]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,f,r,o,s,n){this.a=Math.random(),this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,F.$bk)(s),a=typeof s=="string",h=n?.correlate,t=o(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(h&&typeof v.session>"u")){if(!n?.ignoreCreateEvents)for(const c of v.created){const $=M.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const c of v.changed){const $=M.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const c of v.deleted){const $=M.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=m.$kM.from(this.i(b,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(b,f,r,o,s){const n=m.$kM.from();if(typeof r=="string")return n;const i=b.getProxy(N.$iM.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(F.$0j)||r.pattern.includes(F.$$j))&&(a=!0),i.$watch(f.identifier.value,this.a,r.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),m.$kM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class O{constructor(b){this.a=b,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(M.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class E{constructor(b,f,r){this.j=b,this.k=f,this.l=r,this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.g=new I.$9d,this.h=new I.$9d,this.i=new I.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,f,r,o){return new k(this.j,b,f,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(b){this.a.fire(new O(b))}$onDidRunFileOperation(b,f){switch(b){case 2:this.b.fire(Object.freeze({files:f.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,f){return(r,o,s)=>{const n=function(a){r.call(o,a)};return n.extension=b,f.event(n,void 0,s)}}async $onWillRunFileOperation(b,f,r,o){switch(b){case 2:return await this.n(this.g,{files:f.map(s=>({oldUri:M.URI.revive(s.source),newUri:M.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:f.map(s=>M.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:f.map(s=>M.URI.revive(s.target))},r,o)}}async n(b,f,r,o){const s=new Set,n=[];if(await b.fireAsync(f,o,async(a,h)=>{const t=Date.now(),v=await Promise.resolve(a);v instanceof m.$uM&&(n.push([h.extension,v]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,a]of n){const{edits:h}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$4jc=E}),define(Pe[263],Me([1,0,18,11,25,14,90,6,26,64,15,16,2,29,305,87,97,165,20,8,7,22,74,4]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;class c{constructor(U,z){this.d=U,this.e=z}async provideDocumentSymbols(U,z){const H=this.d.getDocument(U),q=await this.e.provideDocumentSymbols(H,z);if(!(0,I.$Kb)(q))return q[0]instanceof a.$DM?q.map(i.DocumentSymbol.from):c.f(q)}static f(U){U=U.slice(0).sort((q,_)=>{let se=q.location.range.start.compareTo(_.location.range.start);return se===0&&(se=_.location.range.end.compareTo(q.location.range.end)),se});const z=[],H=[];for(const q of U){const _={name:q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(q.kind),tags:q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:i.Range.from(q.location.range),selectionRange:i.Range.from(q.location.range),children:[]};for(;;){if(H.length===0){H.push(_),z.push(_);break}const se=H[H.length-1];if(b.$bt.containsRange(se.range,_.range)&&!b.$bt.equalsRange(se.range,_.range)){se.children?.push(_),H.push(_);break}H.pop()}}return z}}class ${constructor(U,z,H,q,_,se){this.f=U,this.g=z,this.h=H,this.j=q,this.k=_,this.l=se,this.d=new t.$Jic("CodeLens"),this.e=new Map}async provideCodeLenses(U,z){const H=this.f.getDocument(U),q=await this.h.provideCodeLenses(H,z);if(!q||z.isCancellationRequested)return;const _=this.d.add(q),se=new m.$Tc;this.e.set(_,se);const Oe={cacheId:_,lenses:[]};for(let We=0;We<q.length;We++)Oe.lenses.push({cacheId:[_,We],range:i.Range.from(q[We].range),command:this.g.toInternal(q[We].command,se)});return Oe}async resolveCodeLens(U,z){const H=U.cacheId&&this.d.get(...U.cacheId);if(!H)return;let q;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?q=H:q=await this.h.resolveCodeLens(H,z),q||(q=H),z.isCancellationRequested)return;const _=U.cacheId&&this.e.get(U.cacheId[0]);if(_){if(!q.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return U.command=this.g.toInternal(q.command,_),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function w(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class p{constructor(U,z){this.d=U,this.e=z}async provideDefinition(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideDefinition(q,_,H);return w(se)}}class l{constructor(U,z){this.d=U,this.e=z}async provideDeclaration(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideDeclaration(q,_,H);return w(se)}}class D{constructor(U,z){this.d=U,this.e=z}async provideImplementation(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideImplementation(q,_,H);return w(se)}}class g{constructor(U,z){this.d=U,this.e=z}async provideTypeDefinition(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideTypeDefinition(q,_,H);return w(se)}}class S{constructor(U,z){this.d=U,this.e=z}async provideHover(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideHover(q,_,H);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=q.getWordRangeAtPosition(_)),se.range||(se.range=new a.$mM(_,_)),i.Hover.from(se)}}class y{constructor(U,z){this.d=U,this.e=z}async provideEvaluatableExpression(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideEvaluatableExpression(q,_,H);if(se)return i.EvaluatableExpression.from(se)}}class C{constructor(U,z){this.d=U,this.e=z}async provideInlineValues(U,z,H,q){const _=this.d.getDocument(U),se=await this.e.provideInlineValues(_,i.Range.to(z),i.InlineValueContext.to(H),q);if(Array.isArray(se))return se.map(Oe=>i.InlineValue.from(Oe))}}class A{constructor(U,z){this.d=U,this.e=z}async provideDocumentHighlights(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideDocumentHighlights(q,_,H);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class G{constructor(U,z){this.d=U,this.e=z}async provideMultiDocumentHighlights(U,z,H,q){const _=this.d.getDocument(U),se=H.map(Qe=>this.d.getDocument(Qe)),Oe=i.Position.to(z),We=await this.e.provideMultiDocumentHighlights(_,Oe,se,q);if(Array.isArray(We))return We.map(i.MultiDocumentHighlight.from)}}class T{constructor(U,z){this.d=U,this.e=z}async provideLinkedEditingRanges(U,z,H){const q=this.d.getDocument(U),_=i.Position.to(z),se=await this.e.provideLinkedEditingRanges(q,_,H);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class W{constructor(U,z){this.d=U,this.e=z}async provideReferences(U,z,H,q){const _=this.d.getDocument(U),se=i.Position.to(z),Oe=await this.e.provideReferences(_,se,H,q);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class P{static{this.d=1e3}constructor(U,z,H,q,_,se,Oe){this.g=U,this.h=z,this.j=H,this.k=q,this.l=_,this.m=se,this.n=Oe,this.e=new t.$Jic("CodeAction"),this.f=new Map}async provideCodeActions(U,z,H,q){const _=this.g.getDocument(U),se=f.$dt.isISelection(z)?i.Selection.to(z):i.Range.to(z),Oe=[];for(const nt of this.j.getDiagnostics(U))if(se.intersection(nt.range)&&Oe.push(nt)>P.d)break;const We={diagnostics:Oe,only:H.only?new a.$FM(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Qe=await this.k.provideCodeActions(_,se,We,q);if(!(0,I.$Lb)(Qe)||q.isCancellationRequested)return;const xe=this.e.add(Qe),tt=new m.$Tc;this.f.set(xe,tt);const at=[];for(let nt=0;nt<Qe.length;nt++){const rt=Qe[nt];if(rt)if(P.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{We.only&&(rt.kind?We.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=rt.ranges??[];at.push({cacheId:[xe,nt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,h.$6F)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,h.$6F)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:xe,actions:at}}async resolveCodeAction(U,z){const[H,q]=U,_=this.e.get(H,q);if(!_||P.o(_))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(_,z)??_;let Oe;se.edit&&(Oe=i.WorkspaceEdit.from(se.edit,void 0));let We;if(se.command){const Qe=this.f.get(H);Qe&&(We=this.h.toInternal(se.command,Qe))}return{edit:Oe,command:We}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class L{constructor(U,z,H,q,_){this.e=U,this.f=z,this.g=H,this.h=q,this.j=_,this.d=new t.$Jic("DocumentPasteEdit")}async prepareDocumentPaste(U,z,H,q){if(!this.g.prepareDocumentPaste)return;const _=this.f.getDocument(U),se=z.map(Qe=>i.Range.to(Qe)),Oe=i.DataTransfer.toDataTransfer(H,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(_,se,Oe,q),q.isCancellationRequested)return;const We=Array.from(Oe).filter(([,Qe])=>!(Qe instanceof a.$_M));return i.DataTransfer.from(We)}async providePasteEdits(U,z,H,q,_,se){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(z),We=H.map(at=>i.Range.to(at)),Qe=i.DataTransfer.toDataTransfer(q,async at=>(await this.e.$resolvePasteFileData(this.h,U,at)).buffer),xe=await this.g.provideDocumentPasteEdits(Oe,We,Qe,{only:_.only?new a.$eN(_.only):void 0,triggerKind:_.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const tt=this.d.add(xe);return xe.map((at,nt)=>({_cacheId:[tt,nt],title:at.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(rt=>rt.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,z){const[H,q]=U,_=this.d.get(H,q);if(!_||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(_,z)??_;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,z){this.d=U,this.e=z}async provideDocumentFormattingEdits(U,z,H){const q=this.d.getDocument(U),_=await this.e.provideDocumentFormattingEdits(q,z,H);if(Array.isArray(_))return _.map(i.TextEdit.from)}}class ne{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeFormattingEdits(U,z,H,q){const _=this.d.getDocument(U),se=i.Range.to(z),Oe=await this.e.provideDocumentRangeFormattingEdits(_,se,H,q);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,z,H,q){(0,E.$5f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(U),se=z.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(_,se,H,q);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class le{constructor(U,z){this.d=U,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,z,H,q,_){const se=this.d.getDocument(U),Oe=i.Position.to(z),We=await this.e.provideOnTypeFormattingEdits(se,Oe,H,q,_);if(Array.isArray(We))return We.map(i.TextEdit.from)}}class ye{constructor(U,z){this.e=U,this.f=z,this.d=new t.$Jic("WorkspaceSymbols")}async provideWorkspaceSymbols(U,z){const H=await this.e.provideWorkspaceSymbols(U,z);if(!(0,I.$Lb)(H))return{symbols:[]};const q=this.d.add(H),_={cacheId:q,symbols:[]};for(let se=0;se<H.length;se++){const Oe=H[se];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}_.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[q,se]})}return _}async resolveWorkspaceSymbol(U,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const H=this.d.get(...U.cacheId);if(H){const q=await this.e.resolveWorkspaceSymbol(H,z);return q&&(0,d.$Qn)(U,i.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Se{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideRenameEdits(U,z,H,q){const _=this.d.getDocument(U),se=i.Position.to(z);try{const Oe=await this.e.provideRenameEdits(_,se,H,q);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const We=Se.g(Oe);return We?{rejectReason:We,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(U,z,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(U),_=i.Position.to(z);try{const se=await this.e.prepareRename(q,_,H);let Oe,We;if(a.$mM.isRange(se)?(Oe=se,We=q.getText(se)):(0,E.$Wf)(se)&&(Oe=se.range,We=se.placeholder),!Oe||!We)return;if(Oe.start.line>_.line||Oe.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:We}}catch(se){const Oe=Se.g(se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(se)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class he{constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideNewSymbolNames(U,z,H){const q=this.d.getDocument(U),_=i.Range.to(z);try{const se=await this.e.provideNewSymbolNames(q,_,H);return se?se.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(se){this.f.error(he.g(se)??JSON.stringify(se,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class be{constructor(U,z){this.resultId=U,this.tokens=z}}class ee{constructor(U,z){this.f=U,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,z,H){const q=this.f.getDocument(U),_=z!==0?this.d.get(z):null;let se=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,_.resultId,H):await this.g.provideDocumentSemanticTokens(q,H);return _&&this.d.delete(z),se?(se=ee.h(se),this.o(ee.n(_,se),se)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return ee.j(U)?ee.k(U)?U:new a.$EN(new Uint32Array(U.data),U.resultId):ee.l(U)?ee.m(U)?U:new a.$GN(U.edits.map(z=>new a.$FN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const z of U.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(U,z){if(!ee.j(z)||!U||!U.tokens)return z;const H=U.tokens,q=H.length,_=z.data,se=_.length;let Oe=0;const We=Math.min(q,se);for(;Oe<We&&H[Oe]===_[Oe];)Oe++;if(Oe===q&&Oe===se)return new a.$GN([],z.resultId);let Qe=0;const xe=We-Oe;for(;Qe<xe&&H[q-Qe-1]===_[se-Qe-1];)Qe++;return new a.$GN([{start:Oe,deleteCount:q-Oe-Qe,data:_.subarray(Oe,se-Qe)}],z.resultId)}o(U,z){if(ee.j(U)){const H=this.e++;return this.d.set(H,new be(U.resultId,U.data)),(0,o.$sab)({id:H,type:"full",data:U.data})}if(ee.l(U)){const H=this.e++;return ee.j(z)?this.d.set(H,new be(z.resultId,z.data)):this.d.set(H,new be(U.resultId)),(0,o.$sab)({id:H,type:"delta",deltas:(U.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class pe{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeSemanticTokens(U,z,H){const q=this.d.getDocument(U),_=await this.e.provideDocumentRangeSemanticTokens(q,i.Range.to(z),H);return _?this.f(_):null}f(U){return(0,o.$sab)({id:0,type:"full",data:U.data})}}class re{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,z,H,q,_){this.f=U,this.g=z,this.h=H,this.j=q,this.k=_,this.d=new t.$Jic("CompletionItem"),this.e=new Map}async provideCompletionItems(U,z,H,q){const _=this.f.getDocument(U),se=i.Position.to(z),Oe=_.getWordRangeAtPosition(se)||new a.$mM(se,se),We=Oe.with({end:se}),Qe=new k.$3d,xe=await this.h.provideCompletionItems(_,se,q,i.CompletionContext.to(H));if(!xe||q.isCancellationRequested)return;const tt=Array.isArray(xe)?new a.$SM(xe):xe,at=re.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),nt=new m.$Tc;this.e.set(at,nt);const rt=[],ct={x:at,b:rt,a:{replace:i.Range.from(Oe),insert:i.Range.from(We)},c:tt.isIncomplete||void 0,d:Qe.elapsed()};for(let Be=0;Be<tt.items.length;Be++){const it=tt.items[Be],Z=this.l(it,[at,Be],We,Oe);rt.push(Z)}return ct}async resolveCompletionItem(U,z){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...U);if(!H)return;const q=this.l(H,U),_=await this.h.resolveCompletionItem(H,z);if(!_)return;const se=this.l(_,U);return(q.h!==se.h||q.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==se.n||q.o!==se.o||!(0,d.$Rn)(q.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z,H,q){const _=this.e.get(z[0]);if(!_)throw Error("DisposableStore is missing...");const se=this.g.toInternal(U.command,_),Oe={x:z,a:U.label,b:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(i.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof a.$vM&&(Oe.h=U.insertText.value,Oe.i|=4);let We;return U.textEdit?We=U.textEdit.range:U.range&&(We=U.range),a.$mM.isRange(We)?Oe.j=i.Range.from(We):We&&(!H?.isEqual(We.inserting)||!q?.isEqual(We.replacing))&&(Oe.j={insert:i.Range.from(We.inserting),replace:i.Range.from(We.replacing)}),Oe}}class fe{async provideInlineCompletions(U,z,H,q){}disposeCompletions(U){}handleDidShowCompletionItem(U,z,H){}handlePartialAccept(U,z,H,q){}}class V extends fe{constructor(U,z,H,q){super(),this.f=U,this.g=z,this.h=H,this.j=q,this.d=new ke,this.e=(0,h.$6F)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$6F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,z,H,q){const _=this.g.getDocument(U),se=i.Position.to(z),Oe=await this.h.provideInlineCompletionItems(_,se,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},q);if(!Oe||q.isCancellationRequested)return;const We=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],xe=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:We}),items:We.map((nt,rt)=>{let ct;nt.command&&(tt||(tt=new m.$Tc),ct=this.j.toInternal(nt.command,tt));const Be=nt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:nt.filterText,range:nt.range?i.Range.from(nt.range):void 0,command:ct,idx:rt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Qe.map(nt=>(tt||(tt=new m.$Tc),this.j.toInternal(nt,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,z,H){const q=this.d.get(U)?.items[z];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q,H)}handlePartialAccept(U,z,H,q){const _=this.d.get(U)?.items[z];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(_,H),this.h.handleDidPartiallyAcceptCompletionItem(_,i.PartialAcceptInfo.to(q)))}}class te{async provideInlineEdits(U,z,H){const q=this.f.getDocument(U),_=await this.g.provideInlineEdit(q,{triggerKind:this.e[z.triggerKind]},H);if(!_||H.isCancellationRequested)return;let se;const Oe=this.d.createReferenceId({dispose(){se?.dispose()},item:_});let We;_.accepted&&(se||(se=new m.$Tc),We=this.h.toInternal(_.accepted,se));let Qe;return _.rejected&&(se||(se=new m.$Tc),Qe=this.h.toInternal(_.rejected,se)),{pid:Oe,text:_.text,range:i.Range.from(_.range),accepted:We,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,z,H,q){this.f=z,this.g=H,this.h=q,this.d=new ke,this.e={[r.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const z=this.e++;return this.d.set(z,U),z}disposeReferenceId(U){const z=this.d.get(U);return this.d.delete(U),z}get(U){return this.d.get(U)}}class Te{constructor(U,z){this.e=U,this.f=z,this.d=new t.$Jic("SignatureHelp")}async provideSignatureHelp(U,z,H,q){const _=this.e.getDocument(U),se=i.Position.to(z),Oe=this.g(H),We=await this.f.provideSignatureHelp(_,se,q,Oe);if(We){const Qe=this.d.add([We]);return{...i.SignatureHelp.from(We),id:Qe}}}g(U){let z;if(U.activeSignatureHelp){const H=i.SignatureHelp.to(U.activeSignatureHelp),q=this.d.get(U.activeSignatureHelp.id,0);q?(z=q,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...U,activeSignatureHelp:z}}releaseSignatureHelp(U){this.d.delete(U)}}class Ie{constructor(U,z,H,q,_){this.f=U,this.g=z,this.h=H,this.j=q,this.k=_,this.d=new t.$Jic("InlayHints"),this.e=new Map}async provideInlayHints(U,z,H){const q=this.f.getDocument(U),_=i.Range.to(z),se=await this.h.provideInlayHints(q,_,H);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(H.isCancellationRequested)return;const Oe=this.d.add(se);this.e.set(Oe,new m.$Tc);const We={hints:[],cacheId:Oe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],_)&&We.hints.push(this.m(se[Qe],[Oe,Qe]));return this.j.trace(`[InlayHints] ${We.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),We}async resolveInlayHint(U,z){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...U);if(!H)return;const q=await this.h.resolveInlayHint(H,z);if(q&&this.l(q))return this.m(q,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(z&&!z.contains(U.position))}m(U,z){const H=this.e.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const q={label:"",cacheId:z,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")q.label=U.label;else{const _=[];q.label=_;for(const se of U.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$wM.isLocation(se.location)&&(Oe.location=i.location.from(se.location)),se.command&&(Oe.command=this.g.toInternal(se.command,H)),_.push(Oe)}}return q}}class ve{constructor(U,z){this.e=U,this.f=z,this.d=new t.$Jic("DocumentLink")}async provideLinks(U,z){const H=this.e.getDocument(U),q=await this.f.provideDocumentLinks(H,z);if(!(!Array.isArray(q)||q.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(ve.g).map(i.DocumentLink.from)};{const _=this.d.add(q),se={links:[],cacheId:_};for(let Oe=0;Oe<q.length;Oe++){if(!ve.g(q[Oe]))continue;const We=i.DocumentLink.from(q[Oe]);We.cacheId=[_,Oe],se.links.push(We)}return se}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,z){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...U);if(!H)return;const q=await this.f.resolveDocumentLink(H,z);if(!(!q||!ve.g(q)))return i.DocumentLink.from(q)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,z){this.d=U,this.e=z}async provideColors(U,z){const H=this.d.getDocument(U),q=await this.e.provideDocumentColors(H,z);return Array.isArray(q)?q.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(U,z,H){const q=this.d.getDocument(U),_=i.Range.to(z.range),se=i.Color.to(z.color),Oe=await this.e.provideColorPresentations(se,{document:q,range:_},H);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class J{constructor(U,z){this.d=U,this.e=z}async provideFoldingRanges(U,z,H){const q=this.d.getDocument(U),_=await this.e.provideFoldingRanges(q,z,H);if(Array.isArray(_))return _.map(i.FoldingRange.from)}}class Y{constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideSelectionRanges(U,z,H){const q=this.d.getDocument(U),_=z.map(i.Position.to),se=await this.e.provideSelectionRanges(q,_,H);if(!(0,I.$Lb)(se))return[];if(se.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let We=0;We<_.length;We++){const Qe=[];Oe.push(Qe);let xe=_[We],tt=se[We];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Oe}}class ce{constructor(U,z){this.f=U,this.g=z,this.d=new R.$HO(""),this.e=new Map}async prepareSession(U,z,H){const q=this.f.getDocument(U),_=i.Position.to(z),se=await this.g.prepareCallHierarchy(q,_,H);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(We=>this.h(Oe,We)):[this.h(Oe,se)]}async provideCallsTo(U,z,H){const q=this.j(U,z);if(!q)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(q,H);if(_)return _.map(se=>({from:this.h(U,se.from),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(U,z,H){const q=this.j(U,z);if(!q)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(q,H);if(_)return _.map(se=>({to:this.h(U,se.to),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(U){this.e.delete(U)}h(U,z){const H=this.e.get(U),q=i.CallHierarchyItem.from(z,U,H.size.toString(36));return H.set(q._itemId,z),q}j(U,z){return this.e.get(U)?.get(z)}}class de{constructor(U,z){this.f=U,this.g=z,this.d=new R.$HO(""),this.e=new Map}async prepareSession(U,z,H){const q=this.f.getDocument(U),_=i.Position.to(z),se=await this.g.prepareTypeHierarchy(q,_,H);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(We=>this.h(Oe,We)):[this.h(Oe,se)]}async provideSupertypes(U,z,H){const q=this.j(U,z);if(!q)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(q,H);if(_)return _.map(se=>this.h(U,se))}async provideSubtypes(U,z,H){const q=this.j(U,z);if(!q)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(q,H);if(_)return _.map(se=>this.h(U,se))}releaseSession(U){this.e.delete(U)}h(U,z){const H=this.e.get(U),q=i.TypeHierarchyItem.from(z,U,H.size.toString(36));return H.set(q._itemId,z),q}j(U,z){return this.e.get(U)?.get(z)}}class Ne{constructor(U,z,H,q,_){this.d=U,this.e=z,this.f=H,this.g=q,this.h=_}async provideDocumentOnDropEdits(U,z,H,q,_){const se=this.e.getDocument(z),Oe=i.Position.to(H),We=i.DataTransfer.toDataTransfer(q,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,xe)).buffer),Qe=await this.f.provideDocumentDropEdits(se,Oe,We,_);if(Qe)return(0,I.$3b)(Qe).map(xe=>({title:xe.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:xe.kind?.value,yieldTo:xe.yieldTo?.map(tt=>tt.value),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?i.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}))}}class ue{constructor(U,z){this.d=U,this.e=z}async provideMappedEdits(U,z,H,q){const _=u.URI.revive(U),se=this.d.getDocument(_),Oe=H.documents.map(xe=>xe.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(at=>i.Range.to(at))}))),We={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,z,We,q);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ce{constructor(U,z){this.adapter=U,this.extension=z}}class Re{static{this.d=0}constructor(U,z,H,q,_,se,Oe,We){this.g=z,this.h=H,this.j=q,this.k=_,this.l=se,this.m=Oe,this.n=We,this.f=new Map,this.e=U.getProxy(v.$iM.MainThreadLanguageFeatures)}o(U,z){return i.DocumentSelector.from(U,this.g,z)}p(U){return new a.$kM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Re.d++}async s(U,z,H,q,_,se=!1){const Oe=this.f.get(U);if(!Oe||!(Oe.adapter instanceof z))return q;const We=Date.now();se||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Qe=H(Oe.adapter,Oe.extension);return Promise.resolve(Qe).catch(xe=>{(0,N.$4)(xe)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Oe.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-We}ms`)}),M.CancellationToken.isCancellationToken(_)?(0,F.$9g)(Qe,_):Qe}t(U,z){const H=this.q();return this.f.set(H,new Ce(U,z)),H}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,z,H,q){const _=this.t(new c(this.h,H),U),se=q&&q.label||Re.u(U);return this.e.$registerDocumentSymbolProvider(_,this.o(z,U),se),this.p(_)}$provideDocumentSymbols(U,z,H){return this.s(U,c,q=>q.provideDocumentSymbols(u.URI.revive(z),H),void 0,H)}registerCodeLensProvider(U,z,H){const q=this.q(),_=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new Ce(new $(this.h,this.j.converter,H,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(q,this.o(z,U),_);let se=this.p(q);if(_!==void 0){const Oe=H.onDidChangeCodeLenses(We=>this.e.$emitCodeLensEvent(_));se=a.$kM.from(se,Oe)}return se}$provideCodeLenses(U,z,H){return this.s(U,$,q=>q.provideCodeLenses(u.URI.revive(z),H),void 0,H)}$resolveCodeLens(U,z,H){return this.s(U,$,q=>q.resolveCodeLens(z,H),void 0,void 0)}$releaseCodeLenses(U,z){this.s(U,$,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(U,z,H){const q=this.t(new p(this.h,H),U);return this.e.$registerDefinitionSupport(q,this.o(z,U)),this.p(q)}$provideDefinition(U,z,H,q){return this.s(U,p,_=>_.provideDefinition(u.URI.revive(z),H,q),[],q)}registerDeclarationProvider(U,z,H){const q=this.t(new l(this.h,H),U);return this.e.$registerDeclarationSupport(q,this.o(z,U)),this.p(q)}$provideDeclaration(U,z,H,q){return this.s(U,l,_=>_.provideDeclaration(u.URI.revive(z),H,q),[],q)}registerImplementationProvider(U,z,H){const q=this.t(new D(this.h,H),U);return this.e.$registerImplementationSupport(q,this.o(z,U)),this.p(q)}$provideImplementation(U,z,H,q){return this.s(U,D,_=>_.provideImplementation(u.URI.revive(z),H,q),[],q)}registerTypeDefinitionProvider(U,z,H){const q=this.t(new g(this.h,H),U);return this.e.$registerTypeDefinitionSupport(q,this.o(z,U)),this.p(q)}$provideTypeDefinition(U,z,H,q){return this.s(U,g,_=>_.provideTypeDefinition(u.URI.revive(z),H,q),[],q)}registerHoverProvider(U,z,H,q){const _=this.t(new S(this.h,H),U);return this.e.$registerHoverProvider(_,this.o(z,U)),this.p(_)}$provideHover(U,z,H,q){return this.s(U,S,_=>_.provideHover(u.URI.revive(z),H,q),void 0,q)}registerEvaluatableExpressionProvider(U,z,H,q){const _=this.t(new y(this.h,H),U);return this.e.$registerEvaluatableExpressionProvider(_,this.o(z,U)),this.p(_)}$provideEvaluatableExpression(U,z,H,q){return this.s(U,y,_=>_.provideEvaluatableExpression(u.URI.revive(z),H,q),void 0,q)}registerInlineValuesProvider(U,z,H,q){const _=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new C(this.h,H),U);this.e.$registerInlineValuesProvider(se,this.o(z,U),_);let Oe=this.p(se);if(_!==void 0){const We=H.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(_));Oe=a.$kM.from(Oe,We)}return Oe}$provideInlineValues(U,z,H,q,_){return this.s(U,C,se=>se.provideInlineValues(u.URI.revive(z),H,q,_),void 0,_)}registerDocumentHighlightProvider(U,z,H){const q=this.t(new A(this.h,H),U);return this.e.$registerDocumentHighlightProvider(q,this.o(z,U)),this.p(q)}registerMultiDocumentHighlightProvider(U,z,H){const q=this.t(new G(this.h,H),U);return this.e.$registerMultiDocumentHighlightProvider(q,this.o(z,U)),this.p(q)}$provideDocumentHighlights(U,z,H,q){return this.s(U,A,_=>_.provideDocumentHighlights(u.URI.revive(z),H,q),void 0,q)}$provideMultiDocumentHighlights(U,z,H,q,_){return this.s(U,G,se=>se.provideMultiDocumentHighlights(u.URI.revive(z),H,q.map(Oe=>u.URI.revive(Oe)),_),void 0,_)}registerLinkedEditingRangeProvider(U,z,H){const q=this.t(new T(this.h,H),U);return this.e.$registerLinkedEditingRangeProvider(q,this.o(z,U)),this.p(q)}$provideLinkedEditingRanges(U,z,H,q){return this.s(U,T,async _=>{const se=await _.provideLinkedEditingRanges(u.URI.revive(z),H,q);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Re.w(se.wordPattern):void 0}},void 0,q)}registerReferenceProvider(U,z,H){const q=this.t(new W(this.h,H),U);return this.e.$registerReferenceSupport(q,this.o(z,U)),this.p(q)}$provideReferences(U,z,H,q,_){return this.s(U,W,se=>se.provideReferences(u.URI.revive(z),H,q,_),void 0,_)}registerCodeActionProvider(U,z,H,q){const _=new m.$Tc,se=this.t(new P(this.h,this.j.converter,this.k,H,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(se,this.o(z,U),{providedKinds:q?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:q?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,_)}))},Re.u(U),!!H.resolveCodeAction),_.add(this.p(se)),_}$provideCodeActions(U,z,H,q,_){return this.s(U,P,se=>se.provideCodeActions(u.URI.revive(z),H,q,_),void 0,_)}$resolveCodeAction(U,z,H){return this.s(U,P,q=>q.resolveCodeAction(z,H),{},void 0)}$releaseCodeActions(U,z){this.s(U,P,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,z,H){const q=this.t(new K(this.h,H),U);return this.e.$registerDocumentFormattingSupport(q,this.o(z,U),U.identifier,U.displayName||U.name),this.p(q)}$provideDocumentFormattingEdits(U,z,H,q){return this.s(U,K,_=>_.provideDocumentFormattingEdits(u.URI.revive(z),H,q),void 0,q)}registerDocumentRangeFormattingEditProvider(U,z,H){const q=typeof H.provideDocumentRangesFormattingEdits=="function",_=this.t(new ne(this.h,H),U);return this.e.$registerRangeFormattingSupport(_,this.o(z,U),U.identifier,U.displayName||U.name,q),this.p(_)}$provideDocumentRangeFormattingEdits(U,z,H,q,_){return this.s(U,ne,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(z),H,q,_),void 0,_)}$provideDocumentRangesFormattingEdits(U,z,H,q,_){return this.s(U,ne,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(z),H,q,_),void 0,_)}registerOnTypeFormattingEditProvider(U,z,H,q){const _=this.t(new le(this.h,H),U);return this.e.$registerOnTypeFormattingSupport(_,this.o(z,U),q,U.identifier),this.p(_)}$provideOnTypeFormattingEdits(U,z,H,q,_,se){return this.s(U,le,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(z),H,q,_,se),void 0,se)}registerWorkspaceSymbolProvider(U,z){const H=this.t(new ye(z,this.l),U);return this.e.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(U,z,H){return this.s(U,ye,q=>q.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(U,z,H){return this.s(U,ye,q=>q.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(U,z){this.s(U,ye,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(U,z,H){const q=this.t(new Se(this.h,H,this.l),U);return this.e.$registerRenameSupport(q,this.o(z,U),Se.supportsResolving(H)),this.p(q)}$provideRenameEdits(U,z,H,q,_){return this.s(U,Se,se=>se.provideRenameEdits(u.URI.revive(z),H,q,_),void 0,_)}$resolveRenameLocation(U,z,H,q){return this.s(U,Se,_=>_.resolveRenameLocation(u.URI.revive(z),H,q),void 0,q)}registerNewSymbolNamesProvider(U,z,H){const q=this.t(new he(this.h,H,this.l),U);return this.e.$registerNewSymbolNamesProvider(q,this.o(z,U)),this.p(q)}$provideNewSymbolNames(U,z,H,q){return this.s(U,he,_=>_.provideNewSymbolNames(u.URI.revive(z),H,q),void 0,q)}registerDocumentSemanticTokensProvider(U,z,H,q){const _=this.t(new ee(this.h,H),U),se=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(z,U),q,se);let Oe=this.p(_);if(se){const We=H.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Oe=a.$kM.from(Oe,We)}return Oe}$provideDocumentSemanticTokens(U,z,H,q){return this.s(U,ee,_=>_.provideDocumentSemanticTokens(u.URI.revive(z),H,q),null,q)}$releaseDocumentSemanticTokens(U,z){this.s(U,ee,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,z,H,q){const _=this.t(new pe(this.h,H),U);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(z,U),q),this.p(_)}$provideDocumentRangeSemanticTokens(U,z,H,q){return this.s(U,pe,_=>_.provideDocumentRangeSemanticTokens(u.URI.revive(z),H,q),null,q)}registerCompletionItemProvider(U,z,H,q){const _=this.t(new re(this.h,this.j.converter,H,this.m,U),U);return this.e.$registerCompletionsProvider(_,this.o(z,U),q,re.supportsResolving(H),U.identifier),this.p(_)}$provideCompletionItems(U,z,H,q,_){return this.s(U,re,se=>se.provideCompletionItems(u.URI.revive(z),H,q,_),void 0,_)}$resolveCompletionItem(U,z,H){return this.s(U,re,q=>q.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(U,z){this.s(U,re,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(U,z,H,q){const _=new V(U,this.h,H,this.j.converter),se=this.t(_,U);return this.e.$registerInlineCompletionsSupport(se,this.o(z,U),_.supportsHandleEvents,n.$Cm.toKey(U.identifier.value),q?.yieldTo?.map(Oe=>n.$Cm.toKey(Oe))||[]),this.p(se)}$provideInlineCompletions(U,z,H,q,_){return this.s(U,fe,se=>se.provideInlineCompletions(u.URI.revive(z),H,q,_),void 0,_)}$handleInlineCompletionDidShow(U,z,H,q){this.s(U,fe,async _=>{_.handleDidShowCompletionItem(z,H,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,z,H,q,_){this.s(U,fe,async se=>{se.handlePartialAccept(z,H,q,_)},void 0,void 0)}$freeInlineCompletionsList(U,z){this.s(U,fe,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(U,z,H){const q=new te(U,this.h,H,this.j.converter),_=this.t(q,U);return this.e.$registerInlineEditProvider(_,this.o(z,U),U.identifier),this.p(_)}$provideInlineEdit(U,z,H,q){return this.s(U,te,_=>_.provideInlineEdits(u.URI.revive(z),H,q),void 0,q)}$freeInlineEdit(U,z){this.s(U,te,async H=>{H.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(U,z,H,q){const _=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,se=this.t(new Te(this.h,H),U);return this.e.$registerSignatureHelpProvider(se,this.o(z,U),_),this.p(se)}$provideSignatureHelp(U,z,H,q,_){return this.s(U,Te,se=>se.provideSignatureHelp(u.URI.revive(z),H,q,_),void 0,_)}$releaseSignatureHelp(U,z){this.s(U,Te,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(U,z,H){const q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new Ie(this.h,this.j.converter,H,this.l,U),U);this.e.$registerInlayHintsProvider(_,this.o(z,U),typeof H.resolveInlayHint=="function",q,Re.u(U));let se=this.p(_);if(q!==void 0){const Oe=H.onDidChangeInlayHints(We=>this.e.$emitInlayHintsEvent(q));se=a.$kM.from(se,Oe)}return se}$provideInlayHints(U,z,H,q){return this.s(U,Ie,_=>_.provideInlayHints(u.URI.revive(z),H,q),void 0,q)}$resolveInlayHint(U,z,H){return this.s(U,Ie,q=>q.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(U,z){this.s(U,Ie,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(U,z,H){const q=this.t(new ve(this.h,H),U);return this.e.$registerDocumentLinkProvider(q,this.o(z,U),typeof H.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(U,z,H){return this.s(U,ve,q=>q.provideLinks(u.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(U,z,H){return this.s(U,ve,q=>q.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(U,z){this.s(U,ve,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(U,z,H){const q=this.t(new ge(this.h,H),U);return this.e.$registerDocumentColorProvider(q,this.o(z,U)),this.p(q)}$provideDocumentColors(U,z,H){return this.s(U,ge,q=>q.provideColors(u.URI.revive(z),H),[],H)}$provideColorPresentations(U,z,H,q){return this.s(U,ge,_=>_.provideColorPresentations(u.URI.revive(z),H,q),void 0,q)}registerFoldingRangeProvider(U,z,H){const q=this.q(),_=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new Ce(new J(this.h,H),U)),this.e.$registerFoldingRangeProvider(q,this.o(z,U),U.identifier,_);let se=this.p(q);if(_!==void 0){const Oe=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));se=a.$kM.from(se,Oe)}return se}$provideFoldingRanges(U,z,H,q){return this.s(U,J,_=>_.provideFoldingRanges(u.URI.revive(z),H,q),void 0,q)}registerSelectionRangeProvider(U,z,H){const q=this.t(new Y(this.h,H,this.l),U);return this.e.$registerSelectionRangeProvider(q,this.o(z,U)),this.p(q)}$provideSelectionRanges(U,z,H,q){return this.s(U,Y,_=>_.provideSelectionRanges(u.URI.revive(z),H,q),[],q)}registerCallHierarchyProvider(U,z,H){const q=this.t(new ce(this.h,H),U);return this.e.$registerCallHierarchyProvider(q,this.o(z,U)),this.p(q)}$prepareCallHierarchy(U,z,H,q){return this.s(U,ce,_=>Promise.resolve(_.prepareSession(u.URI.revive(z),H,q)),void 0,q)}$provideCallHierarchyIncomingCalls(U,z,H,q){return this.s(U,ce,_=>_.provideCallsTo(z,H,q),void 0,q)}$provideCallHierarchyOutgoingCalls(U,z,H,q){return this.s(U,ce,_=>_.provideCallsFrom(z,H,q),void 0,q)}$releaseCallHierarchy(U,z){this.s(U,ce,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(U,z,H){const q=this.t(new de(this.h,H),U);return this.e.$registerTypeHierarchyProvider(q,this.o(z,U)),this.p(q)}$prepareTypeHierarchy(U,z,H,q){return this.s(U,de,_=>Promise.resolve(_.prepareSession(u.URI.revive(z),H,q)),void 0,q)}$provideTypeHierarchySupertypes(U,z,H,q){return this.s(U,de,_=>_.provideSupertypes(z,H,q),void 0,q)}$provideTypeHierarchySubtypes(U,z,H,q){return this.s(U,de,_=>_.provideSubtypes(z,H,q),void 0,q)}$releaseTypeHierarchy(U,z){this.s(U,de,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,z,H,q){const _=this.q();return this.f.set(_,new Ce(new Ne(this.e,this.h,H,_,U),U)),this.e.$registerDocumentOnDropEditProvider(_,this.o(z,U),(0,h.$6F)(U,"dropMetadata")?q:void 0),this.p(_)}$provideDocumentOnDropEdits(U,z,H,q,_,se){return this.s(U,Ne,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(z,u.URI.revive(H),q,_,se)),void 0,void 0)}registerMappedEditsProvider(U,z,H){const q=this.t(new ue(this.h,H),U);return this.e.$registerMappedEditsProvider(q,this.o(z,U)),this.p(q)}$provideMappedEdits(U,z,H,q,_){return this.s(U,ue,se=>Promise.resolve(se.provideMappedEdits(z,H,q,_)),null,_)}registerDocumentPasteEditProvider(U,z,H,q){const _=this.q();return this.f.set(_,new Ce(new L(this.e,this.h,H,_,U),U)),this.e.$registerPasteEditProvider(_,this.o(z,U),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:q.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(U,z,H,q,_){return this.s(U,L,se=>se.prepareDocumentPaste(u.URI.revive(z),H,q,_),void 0,_)}$providePasteEdits(U,z,H,q,_,se,Oe){return this.s(U,L,We=>We.providePasteEdits(z,u.URI.revive(H),q,_,se,Oe),void 0,Oe)}$resolvePasteEdit(U,z,H){return this.s(U,L,q=>q.resolvePasteEdit(z,H),{},void 0)}$releasePasteEdits(U,z){this.s(U,L,H=>Promise.resolve(H.releasePasteEdits(z)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Re.w(U.decreaseIndentPattern),increaseIndentPattern:Re.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Re.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Re.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Re.w(U.beforeText),afterText:U.afterText?Re.w(U.afterText):void 0,previousLineText:U.previousLineText?Re.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Re.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(z=>a.SyntaxTokenType.toString(z)):void 0}}static D(U){return U.map(Re.C)}setLanguageConfiguration(U,z,H){const{wordPattern:q}=H;if(q&&(0,O.$0e)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(z,q):this.h.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const _=this.q(),se={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Re.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Re.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Re.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Re.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,z,se),this.p(_)}$setWordDefinitions(U){for(const z of U)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Tic=Re}),define(Pe[88],Me([1,0,6,4,8,7,101,20,11,5,166,106,14,3,17,84,13]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0,e.$1ic=(0,b.$hi)("IExtHostLanguageModels");class n{constructor(t,v){this.option=t,this.stream=new d.$Kh,this.stream=v??new d.$Kh}}class i{constructor(){this.a=new Map,this.b=new d.$Kh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let v=this.a.get(t.index);v||(this.a.size===0?v=new n(t.index,this.b):v=new n(t.index),this.a.set(t.index,v)),v.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const v of this.f())v.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,v,c){this.j=v,this.k=c,this.c=new k.$7d,this.d=new k.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Em,this.i=new Map,this.o=new Set,this.b=t.getProxy(F.$iM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,v,c,$){const w=s.a++;this.f.set(w,{extension:t.identifier,provider:c,languageModelId:v});let p;return $.auth&&(p={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(w,v,{extension:t.identifier,identifier:v,model:$.name??"",auth:p}),(0,I.$Sc)(()=>{this.f.delete(w),this.b.$unregisterProvider(w)})}async $provideLanguageModelResponse(t,v,c,$,w,p){const l=this.f.get(t);if(!l)return;const D=new R.$Qv(async g=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:g.index,part:g.part})});return l.provider.provideLanguageModelResponse2($.map(M.LanguageModelMessage.to),w,m.$Cm.toKey(c),D,p)}$updateLanguageModels(t){const v=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),v.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[w,p]of this.i)p.languageModelId===$&&(p.res.reject(new u.$5),this.i.delete(w))}this.d.fire(Object.freeze({added:Object.freeze(v),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const v=new Array;for(const{from:c,to:$,enabled:w}of t){const p=this.h.get(c)??new m.$Dm;if(p.has($)!==w){w?p.add($):p.delete($),this.h.set(c,p);const D={from:c,to:$};v.push(D),this.c.fire(D)}}}async sendChatRequest(t,v,c,$,w){const p=t.identifier,l=await this.b.$prepareChatAccess(p,v,$.justification);if(!l||!this.g.has(v))throw N.$pO.NotFound(`Language model '${v}' is unknown.`);if(this.m(p,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(p)?.has(l.extension)))throw N.$pO.NoPermissions(`Language model '${v}' cannot be used by '${p.value}'.`);const D=Math.random()*1e6|0,g=this.b.$fetchResponse(p,v,D,c.map(M.LanguageModelMessage.from),$.modelOptions??{},w),S=new d.$gh,y=new i;this.i.set(D,{languageModelId:v,res:y});let C;if(g.catch(A=>{S.isOpen()?y.reject(A):C=A}).finally(()=>{this.i.delete(D),y.resolve(),S.open()}),await S.wait(),C)throw new N.$pO(`Language model '${v}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,v){const c=this.i.get(t);c&&c.res.handleFragment(v)}async l(t,v,c,$){const w=E.$kL+v.identifier.value;if(await this.k.getSession(t,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,O.localize)(0,null,v.displayName,c):(0,O.localize)(1,null,v.displayName);return await this.k.getSession(t,w,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0}catch{return!1}}m(t,v){return!!v.auth&&!m.$Cm.equals(v.extension,t)}async n(t){for(const v of this.o)try{await this.l(v,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const v=this,c=k.Event.signal(k.Event.filter(this.c.event,w=>m.$Cm.equals(w.from,t.identifier))),$=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(c,$)},canSendRequest(w){const p=v.g.get(w);if(!p)return;if(!v.m(t.identifier,p))return!0;const l=v.h.get(t.identifier);if(l)return l.has(p.extension)}}}};e.$2ic=a,e.$2ic=a=s=Je([qe(0,f.$CO),qe(1,o.$Nj),qe(2,r.$Vic)],a)}),define(Pe[264],Me([1,0,4,8,7,32,11,6,22]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;class k{constructor(E,u,b,f){this.c=u,this.d=b,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(I.$iM.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const b=this.c.getDocumentData(E);if(!b)throw new Error(`document '${E.toString()}' NOT found`);return b.document}async tokenAtPosition(E,u){const b=E.version,f=F.Position.from(u),r=await this.a.$tokensAtPosition(E.uri,f),o={type:M.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new M.$mM(u.line,u.character,u.line,u.character)};if(!r)return o;const s={range:F.Range.to(r.range),type:F.TokenType.to(r.type)};return!s.range.contains(u)||b!==E.version?o:s}createLanguageStatusItem(E,u,b){const f=this.f++,r=this.a,o=this.g,s=`${E.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const n={selector:b,id:u,name:E.displayName??E.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$jh)(()=>{a.clear(),this.a.$setLanguageStatus(f,{id:s,name:n.name??E.displayName??E.name,source:E.displayName??E.name,selector:F.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?N.default.Error:n.severity===M.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),r.$removeLanguageStatus(f),o.delete(s)},get id(){return n.id},get name(){return n.name},set name(v){n.name=v,h()},get selector(){return n.selector},set selector(v){n.selector=v,h()},get text(){return n.text},set text(v){n.text=v,h()},set text2(v){(0,d.$7F)(E,"languageStatusText"),n.text=v,h()},get text2(){return(0,d.$7F)(E,"languageStatusText"),n.text},get detail(){return n.detail},set detail(v){n.detail=v,h()},get severity(){return n.severity},set severity(v){n.severity=v,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(v){n.accessibilityInformation=v,h()},get command(){return n.command},set command(v){n.command=v,h()},get busy(){return n.busy},set busy(v){n.busy=v,h()}};return h(),t}}e.$ikc=k}),define(Pe[265],Me([1,0,12,2,8,7,83]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0;class m{constructor(E,u,b,f){this.start=E,this.deletedCount=u,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new N.$LN(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,b){this.notebook=E,this.h=u,this.j=b,this.handle=b.handle,this.uri=F.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(M.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(f){E.g=f},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(b)}return this.f}setOutputs(E){this.a=E.map(M.NotebookCellOutput.to)}setOutputItems(E,u,b){const f=b.map(M.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===E);if(r&&(u||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(o=>R.$fK(o.mime)))){const o=new Map,s=[];r.items.forEach(n=>{let i;o.has(n.mime)?i=o.get(n.mime):(i=[],o.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=R.$gK(o.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$6jc=d;class k{static{this.a=0}constructor(E,u,b,f,r){this.k=E,this.l=u,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===I.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(b){return b=E.n(b),E.b[b].apiCell},getCells(b){return(b?E.p(b):E.b).map(r=>r.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,b){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const s of E.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,f.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,f.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=o.get(n.cell);if(i===void 0){const a=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,a-1)}else f.cellChanges[i]={...f.cellChanges[i],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,b=E.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),E.with({start:u,end:b})}p(E){E=this.o(E);const u=[];for(let b=E.start;b<E.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,b){if(this.j)return;const f=[],r=[],o=[];if(E.reverse().forEach(s=>{const i=s[2].map(t=>{const v=new d(this,this.l,t);return u||r.push(d.asModelAddData(t)),v}),a=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);f.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),b)for(const s of f)b.push(s.asApiEvent())}s(E,u,b,f){const r=this.b.splice(E,u);this.b.splice(b,0,...r);const o=[new m(E,u,r.map(s=>s.apiCell),[]),new m(b,0,[],r)];for(const s of o)f.push(s.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,b,f){this.b[E].setOutputItems(u,b,f)}v(E,u){const b=this.b[E];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(E,u){const b=this.b[E];b.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$7jc=k}),define(Pe[266],Me([1,0,5,2,8,7]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class R{constructor(d,k,O,E={timeout:1500,errors:3}){this.b=d,this.c=k,this.d=O,this.f=E,this.a=new I.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(k,O,E)=>{const u=function(f){k.call(O,f)};return u.extension=d,this.a.event(u,void 0,E)}}async $participateInSave(d,k,O){const E=F.URI.revive(d),u=this.c.getNotebookDocument(E);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:M.TextDocumentSaveReason.to(k)},O,async(r,o)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!O.isCancellationRequested&&n&&(n instanceof N.$uM?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(b.length===0)return!0;const f={edits:[]};for(const r of b){const{edits:o}=M.WorkspaceEdit.from(r);f.edits=f.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(f)}}e.$kkc=R}),define(Pe[112],Me([1,0,14,8,7]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,d,k,O,E,u){this.id=m,this.f=d,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=O,this.c=u}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(d){this.selections=[d]},get selections(){return m.a},set selections(d){if(!Array.isArray(d)||!d.every(M.$LN.isNotebookRange))throw(0,I.$7)("selections");m.a=d,m.g(d)},get visibleRanges(){return m.b},revealRange(d,k){m.f.$tryRevealRange(m.id,F.NotebookRange.from(d),k??M.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(F.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$8jc=N}),define(Pe[267],Me([1,0,5,13,8]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;let N=class{constructor(m,d){this.c=m,this.d=d,this.a=new I.$7d,this.b=new I.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,d);const k=this.d.getEditorById(m);d.visibleRanges&&k._acceptVisibleRanges(d.visibleRanges.ranges.map(M.NotebookRange.to)),d.selections&&k._acceptSelections(d.selections.selections.map(M.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const d in m)this.d.getEditorById(d)._acceptViewColumn(M.ViewColumn.to(m[d]))}};e.$mkc=N,e.$mkc=N=Je([qe(0,F.$Nj)],N)}),define(Pe[268],Me([1,0,5,4,112]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class N{constructor(m,d){this.c=d,this.a=new Map,this.b=m.getProxy(F.$iM.MainThreadNotebookRenderers)}$postRendererMessage(m,d,k){const O=this.c.getEditorById(m);this.a.get(d)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(m,d){if(!m.contributes?.notebookRenderer?.some(O=>O.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(O,E,u)=>this.d(d).event(O,E,u),postMessage:(O,E)=>{M.$8jc.apiEditorsToExtHost.has(O)&&([O,E]=[E,O]);const u=E&&M.$8jc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,d,O)}}}d(m){let d=this.a.get(m);return d||(d=new I.$7d({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(m)}}),this.a.set(m,d),d)}}e.$pkc=N}),define(Pe[269],Me([1,0,8,101,25,68,14]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class m{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,b){const f=this.b++,{title:r,location:o,cancellable:s}=u,n={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(f,{location:I.ProgressLocation.from(o),title:r,source:n,cancellable:s},E.isUnderDevelopment?void 0:E.identifier.value).catch(R.$2),this.d(f,b,!!s)}d(E,u,b){let f;b&&(f=new M.$ee,this.c.set(E,f));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),f?.dispose()};let o;try{o=u(new k(this.a,E),b&&f?f.token:M.CancellationToken.None)}catch(s){throw r(E),s}return o.then(s=>r(E),s=>r(E)),o}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$tkc=m;function d(O,E){return O.message=E.message,typeof E.increment=="number"&&(typeof O.increment=="number"?O.increment+=E.increment:O.increment=E.increment),O}class k extends F.$Qv{constructor(E,u){super(b=>this.throttledReport(b)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,N.$Nh)(100,(O,E)=>d(O,E),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Pe[270],Me([1,0,2,4,11,8]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class R{static{this.a=0}constructor(d,k){this.d=k,this.c=new Map,this.b=d.getProxy(F.$iM.MainThreadQuickDiff)}$provideOriginalResource(d,k,O){const E=I.URI.revive(k),u=this.c.get(d);return u?(0,M.$_g)(()=>u.provideOriginalResource(E,O)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(d,k,O,E){const u=R.a++;return this.c.set(u,k),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(d,this.d),O,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$ukc=R}),define(Pe[271],Me([1,0,25,5,6,4,2,7,14,18,32,41,22,8]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=f;function f(r,o,s){const n=r.getProxy(N.$iM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,g,S=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,A=n.$show(C,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},S),G={},T=A.then(()=>G);return Promise.race([T,y]).then(W=>{if(W===G)return;const P=(0,u.$6F)(l,"quickPickItemTooltip");return y.then(L=>{const K=[];for(let ne=0;ne<L.length;ne++){const le=L[ne];if(typeof le=="string")K.push({label:le,handle:ne});else if(le.kind===m.QuickPickItemKind.Separator)K.push({type:"separator",label:le.label});else{le.tooltip&&!P&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ye=le.iconPath?c(le.iconPath):void 0;K.push({label:le.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:P?b.MarkdownString.fromStrict(le.tooltip):void 0,handle:ne})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=ne=>{g.onDidSelectItem(L[ne])}),n.$setItems(C,K),A.then(ne=>{if(typeof ne=="number")return L[ne];if(Array.isArray(ne))return ne.map(le=>L[le])})})}).then(void 0,W=>{if(!(0,d.$4)(W))return n.$setError(C,W),Promise.reject(W)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,n.$input(l,typeof this.d=="function",D).then(void 0,g=>{if(!(0,d.$4)(g))return Promise.reject(g)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let g;switch(D.severity){case m.InputBoxValidationSeverity.Info:g=O.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=O.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=O.default.Error;break;default:g=D.message?O.default.Error:O.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!g)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new w(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,g){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,g)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$7d,this.q=new F.$7d,this.r=new F.$7d,this.s=new F.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,g)=>{const S=D===m.$IN.Back?-1:g;this.o.set(S,D)}),this.z({buttons:l.map((D,g)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===m.$IN.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const g=l[D];this.u[D]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(p){if(p instanceof m.$gN)return{id:p.id};const l=v(p),D=t(p);return{dark:typeof l=="string"?R.URI.file(l):l,light:typeof D=="string"?R.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function v(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const l=h(p);let D,g;return"id"in l?g=E.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:g}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$7d,this.L=[],this.M=new F.$7d,this.N=new F.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const D=(0,u.$6F)(this.O,"quickPickItemTooltip"),g=[];for(let S=0;S<l.length;S++){const y=l[S];if(y.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;g.push({handle:S,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?b.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((A,G)=>({...c(A.iconPath),tooltip:A.tooltip,handle:G}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,k.$Hb)(l.map(g=>this.C.get(g)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,k.$Hb)(l.map(g=>this.C.get(g)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const g=this.C.get(l);if(!g||!g.buttons||!g.buttons.length)return;const S=g.buttons[D];S&&this.N.fire({button:S,item:g})}}class w extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:O.default.Error}):this.z({validationMessage:l.message,severity:l.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new i(o,s)}}),define(Pe[272],Me([1,0,2,5,68,6,11,4,18,142,13,20,41,8,22,12,21]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=e.$wkc=void 0;function n(C){return C instanceof I.URI}function i(C,A){return C.scheme===r.Schemas.file&&A.scheme===r.Schemas.file&&o.$k?C.toString()===A.toString():C.toString().toLowerCase()===A.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const A=C.icon;return{light:A.light,dark:A.dark}}}else return}function t(C,A){if(!C.iconPath&&!A.iconPath)return 0;if(C.iconPath){if(!A.iconPath)return 1}else return-1;const G=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,T=typeof A.iconPath=="string"?A.iconPath:I.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id;return(0,k.$_q)(G,T)}function v(C,A){let G=0;if(C.strikeThrough!==A.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==A.faded)return C.faded?1:-1;if(C.tooltip!==A.tooltip)return(C.tooltip||"").localeCompare(A.tooltip||"");if(G=t(C,A),G!==0)return G;if(C.light&&A.light)G=t(C.light,A.light);else{if(C.light)return 1;if(A.light)return-1}if(G!==0)return G;if(C.dark&&A.dark)G=t(C.dark,A.dark);else{if(C.dark)return 1;if(A.dark)return-1}return G}function c(C,A){if(C.command!==A.command)return C.command<A.command?-1:1;if(C.title!==A.title)return C.title<A.title?-1:1;if(C.tooltip!==A.tooltip){if(C.tooltip!==void 0&&A.tooltip!==void 0)return C.tooltip<A.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(A.tooltip!==void 0)return-1}if(C.arguments===A.arguments)return 0;if(C.arguments)if(A.arguments){if(C.arguments.length!==A.arguments.length)return C.arguments.length-A.arguments.length}else return 1;else return-1;for(let G=0;G<C.arguments.length;G++){const T=C.arguments[G],W=A.arguments[G];if(T!==W&&!(n(T)&&n(W)&&i(T,W)))return T<W?-1:1}return 0}function $(C,A){let G=(0,k.$_q)(C.resourceUri.fsPath,A.resourceUri.fsPath,!0);if(G!==0)return G;if(C.command&&A.command)G=c(C.command,A.command);else{if(C.command)return 1;if(A.command)return-1}if(G!==0)return G;if(C.decorations&&A.decorations)G=v(C.decorations,A.decorations);else{if(C.decorations)return 1;if(A.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&A.multiFileDiffEditorModifiedUri)G=(0,k.$_q)(C.multiFileDiffEditorModifiedUri.fsPath,A.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(A.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&A.multiDiffEditorOriginalUri)G=(0,k.$_q)(C.multiDiffEditorOriginalUri.fsPath,A.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(A.multiDiffEditorOriginalUri)return-1}return G}function w(C,A){for(let G=0;G<C.length;G++)if(C[G]!==A[G])return!1;return!0}function p(C,A){return C.command===A.command&&C.title===A.title&&C.tooltip===A.tooltip&&(C.arguments&&A.arguments?w(C.arguments,A.arguments):C.arguments===A.arguments)}function l(C,A){return(0,d.$ub)(C,A,p)}class D{#e;#t;get value(){return this.d}set value(A){A=A??"",this.#e.$setInputBoxValue(this.l,A),this.n(A)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(A){this.#e.$setInputBoxPlaceholder(this.l,A),this.f=A}get validateInput(){return(0,f.$7F)(this.k,"scmValidation"),this.g}set validateInput(A){if((0,f.$7F)(this.k,"scmValidation"),A&&typeof A!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=A,this.#e.$setValidationProviderIsEnabled(this.l,!!A)}get enabled(){return this.h}set enabled(A){A=!!A,this.h!==A&&(this.h=A,this.#e.$setInputBoxEnablement(this.l,A))}get visible(){return this.j}set visible(A){A=!!A,this.j!==A&&(this.j=A,this.#e.$setInputBoxVisibility(this.l,A))}get document(){return(0,f.$7F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(A,G,T,W,P){this.k=A,this.l=W,this.m=P,this.d="",this.e=new F.$7d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=T}showValidationMessage(A,G){(0,f.$7F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,A,G)}$onInputBoxValueChange(A){this.n(A)}n(A){this.d=A,this.e.fire(A)}}e.$wkc=D;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(A){this.v=A,this.q.$updateGroupLabel(this.t,this.handle,A)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(A){this.p=A,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(A){this.f=[...A],this.k.fire()}constructor(A,G,T,W,P,L,K){this.q=A,this.s=G,this.t=T,this.u=W,this.v=P,this.multiDiffEditorEnableViewChanges=L,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(A){return this.g.get(A)}$executeResourceCommand(A,G){const T=this.h.get(A);return T?(0,R.$_g)(()=>this.s.executeCommand(T.command,...T.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const A=[...this.f].sort($),T=(0,d.$Db)(this.o,A,$).map(L=>{const K=L.toInsert.map(ne=>{const le=this.e++;this.g.set(le,ne);const ye=ne.resourceUri;let Se;if(ne.command)if(ne.command.command==="vscode.open"||ne.command.command==="vscode.diff"||ne.command.command==="vscode.changes"){const ge=new N.$Tc;Se=this.s.converter.toInternal(ne.command,ge),this.j.set(le,ge)}else this.h.set(le,ne.command);const he=(0,f.$6F)(this.w,"scmMultiDiffEditor"),be=he?ne.multiDiffEditorOriginalUri:void 0,ee=he?ne.multiFileDiffEditorModifiedUri:void 0,pe=a(ne.decorations),re=ne.decorations&&a(ne.decorations.light)||pe,fe=ne.decorations&&a(ne.decorations.dark)||pe,V=[re,fe],te=ne.decorations&&ne.decorations.tooltip||"",ke=ne.decorations&&!!ne.decorations.strikeThrough,Te=ne.decorations&&!!ne.decorations.faded,Ie=ne.contextValue||"";return{rawResource:[le,ye,V,te,ke,Te,Ie,Se,be,ee],handle:le}});return{start:L.start,deleteCount:L.deleteCount,toInsert:K}}),W=T.map(({start:L,deleteCount:K,toInsert:ne})=>[L,K,ne.map(le=>le.rawResource)]),P=T.reverse();for(const{start:L,deleteCount:K,toInsert:ne}of P){const le=ne.map(Se=>Se.handle),ye=this.n.splice(L,K,...le);for(const Se of ye)this.g.delete(Se),this.h.delete(Se),this.j.get(Se)?.dispose(),this.j.delete(Se)}return this.o=A,W}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(A){this.g!==A&&(this.g=A,this.#e.$updateSourceControl(this.w,{count:A}))}get quickDiffProvider(){return this.h}set quickDiffProvider(A){this.h=A;let G;(0,f.$6F)(this.x,"quickDiffProvider")&&(G=A?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!A,quickDiffLabel:G})}get historyProvider(){return(0,f.$7F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(A){(0,f.$7F)(this.x,"scmHistoryProvider"),this.j=A,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!A}),A&&this.k.value.add(A.onDidChangeCurrentHistoryItemGroup(()=>{this.l=A?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(A){A!==this.m&&(this.m=A,this.#e.$updateSourceControl(this.w,{commitTemplate:A}))}get acceptInputCommand(){return this.o}set acceptInputCommand(A){this.n.value=new N.$Tc,this.o=A;const G=this.y.converter.toInternal(A,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,f.$7F)(this.x,"scmActionButton"),this.q}set actionButton(A){(0,f.$7F)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=A;const G=A!==void 0?{command:this.y.converter.toInternal(A.command,this.p.value),secondaryCommands:A.secondaryCommands?.map(T=>T.map(W=>this.y.converter.toInternal(W,this.p.value))),description:A.description,enabled:A.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(A){if(this.t&&A&&l(this.t,A))return;this.s.value=new N.$Tc,this.t=A;const G=(A||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(A,G,T,W,P,L,K){this.x=A,this.y=W,this.z=P,this.A=L,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new F.$7d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=T;const ne=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(A,G,this.#e,this.w,ne),this.#e.$registerSourceControl(this.w,P,L,K,ne)}createResourceGroup(A,G,T){const W=(0,f.$6F)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,P=new g(this.#e,this.y,this.w,A,G,W,this.x),L=F.Event.once(P.onDidDispose)(()=>this.C.delete(P));return this.C.set(P,L),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const A=[],G=[];for(const[T,W]of this.C){W.dispose();const P=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});F.Event.once(T.onDidDispose)(()=>{this.D.delete(T),P.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),A.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const L=T._takeResourceStateSnapshot();L.length>0&&G.push([T.handle,L]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,A,G),this.C.clear()}eventuallyUpdateResourceStates(){const A=[];this.D.forEach(G=>{const T=G._takeResourceStateSnapshot();T.length!==0&&A.push([G.handle,T])}),A.length>0&&this.#e.$spliceResourceStates(this.w,A),this.D.clear()}getResourceGroup(A){return this.e.get(A)}setSelectionState(A){this.u=A,this.v.fire(A)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(A=>A.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Mh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Mh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(A,G,T,W){this.l=G,this.m=T,this.n=W,this.g=new Map,this.h=new E.$Em,this.j=new F.$7d,this.e=A.getProxy(m.$iM.MainThreadSCM),this.f=A.getProxy(m.$iM.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const L=this.g.get(P.sourceControlHandle);if(!L)return P;const K=L.getResourceGroup(P.groupHandle);return K?K.getResourceState(P.handle):P}else if(P&&P.$mid===4){const L=this.g.get(P.sourceControlHandle);return L?L.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const L=this.g.get(P.handle);return L||P}return P}})}createSourceControl(A,G,T,W){this.n.trace("ExtHostSCM#createSourceControl",A.identifier.value,G,T,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:A.identifier.value});const P=s.d++,L=new S(A,this.m,this.e,this.l,G,T,W);this.g.set(P,L);const K=this.h.get(A.identifier)||[];return K.push(L),this.h.set(A.identifier,K),L}getLastInputBox(A){this.n.trace("ExtHostSCM#getLastInputBox",A.identifier.value);const G=this.h.get(A.identifier),T=G&&G[G.length-1];return T&&T.inputBox}$provideOriginalResource(A,G,T){const W=I.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",A,W.toString());const P=this.g.get(A);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$_g)(()=>P.quickDiffProvider.provideOriginalResource(W,T)).then(L=>L||null)}$onInputBoxValueChange(A,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",A);const T=this.g.get(A);return T&&T.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(A,G,T,W){this.n.trace("ExtHostSCM#$executeResourceCommand",A,G,T);const P=this.g.get(A);if(!P)return Promise.resolve(void 0);const L=P.getResourceGroup(G);return L?L.$executeResourceCommand(T,W):Promise.resolve(void 0)}$validateInput(A,G,T){this.n.trace("ExtHostSCM#$validateInput",A);const W=this.g.get(A);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.$_g)(()=>W.inputBox.validateInput(G,T)).then(P=>{if(!P)return Promise.resolve(void 0);const L=b.MarkdownString.fromStrict(P.message);return L?Promise.resolve([L,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(A){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",A),A!==void 0&&this.g.get(A)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=A,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(A,G,T,W){return await this.g.get(A)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,T,W)??void 0}async $provideHistoryItems(A,G,T,W){return(await this.g.get(A)?.historyProvider?.provideHistoryItems(G,T,W))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(A,G,T,W){const P=this.g.get(A)?.historyProvider;if(typeof P?.provideHistoryItemSummary!="function")return;const L=await P.provideHistoryItemSummary(G,T,W);return L?{...L,icon:h(L)}:void 0}async $provideHistoryItemChanges(A,G,T,W){return await this.g.get(A)?.historyProvider?.provideHistoryItemChanges(G,T,W)??void 0}};e.$xkc=y,e.$xkc=y=s=Je([qe(3,O.$Nj)],y)}),define(Pe[273],Me([1,0,4,8,2]),function(me,e,I,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class N{static{this.a=0}constructor(m,d){this.d=d,this.c=new Map,this.b=m.getProxy(I.$iM.MainThreadShare)}async $provideShare(m,d,k){return await this.c.get(m)?.provideShare({selection:F.Range.to(d.selection),resourceUri:M.URI.revive(d.resourceUri)},k)??void 0}registerShareProvider(m,d){const k=N.a++;return this.c.set(k,d),this.b.$registerShareProvider(k,F.DocumentSelector.from(m,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$ykc=N}),define(Pe[274],Me([1,0,7,4,169,6,8,16]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0;class d{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$hN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$hN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,f,r,o,s=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=u,this.#t=b,o&&r){this.c=(0,I.$VM)(r.identifier,o);const i=f.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(d.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(n)}u(u){if((0,m.$Yf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!d.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,M.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=d.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,r,this.r?.internal,f,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Akc=d;class k{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new I.$kM(()=>{const f=this.b.indexOf(b);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class O{constructor(u,b){this.e=new Map,this.a=u.getProxy(F.$iM.MainThreadStatusBar),this.b=b,this.c=new k(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,f,r){return new d(this.a,this.b,this.e,u,b,f,r)}setStatusBarMessage(u,b){const f=this.c.setMessage(u);let r;return typeof b=="number"?r=setTimeout(()=>f.dispose(),b):typeof b<"u"&&b.then(()=>f.dispose(),()=>f.dispose()),new I.$kM(()=>{f.dispose(),clearTimeout(r)})}}e.$Bkc=O}),define(Pe[113],Me([1,0,29,105,49,75,60,8,2]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=e.$PO=e.$OO=void 0;const k=(i,a,h,t)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(c){if(!h(v,c)){const $=v;v=c,i.listener?.(t(c,$))}}}},O=(i,a)=>i===a,E={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),b=(i,a)=>({range:(()=>{let h;const t=u(v=>({range:I.$bt.lift(m.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return h},set(v){i.listener?.({op:6}),E.range(h,v)||(h=v,i.listener?.(t(v)))}}})(),label:k(i,a,E.label,u(h=>({label:h}))),description:k(i,void 0,E.description,u(h=>({description:h}))),sortText:k(i,void 0,E.sortText,u(h=>({sortText:h}))),canResolveChildren:k(i,!1,E.canResolveChildren,h=>({op:2,state:h})),busy:k(i,!1,E.busy,u(h=>({busy:h}))),error:k(i,void 0,E.error,u(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:k(i,[],E.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),f=i=>{const a=M.$7K.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,d.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,R.$aL)(t).tagId})),h},r=i=>{let a;for(const h of i.tests){const t=f(h.item);(0,F.$yO)(t).parent=a,a=t}return a};e.$OO=r;class o{constructor(a,h,t,v){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,F.$xO)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,N.$wO)(c,F.$yO,o),enumerable:!0,writable:!1},...b(c,t)})}}e.$PO=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$QO=s;class n extends N.$sO{constructor(a,h,t){super({controllerId:a,getDocumentVersion:v=>v&&t.getDocument(v)?.version,getApiFor:F.$yO,getChildren:v=>v.children,root:new s(a,h),toITestItem:m.TestItem.from})}}e.$RO=n}),define(Pe[31],Me([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,23,50,42,64,58,61,34]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=void 0;let c=class{#e;#t;#i;constructor(g,S,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(R.$iM.MainThreadCommands),this.d=S,this.#i=y,this.#t=g.getProxy(R.$iM.MainThreadTelemetry),this.converter=new $(this,C=>{const A=this.c.get(C);return A?.result===p.Void?A:void 0},S),this.f=[{processArgument(C){return(0,k.$Qh)(C)}},{processArgument(C){return(0,N.$Pn)(C,function(A){if(O.$bt.isIRange(A))return M.Range.to(A);if(E.$at.isIPosition(A))return M.Position.to(A);if(O.$bt.isIRange(A.range)&&u.URI.isUri(A.uri))return M.location.to(A);if(A instanceof s.$ue)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const S=this.registerCommand(!1,g.id,async(...y)=>{const C=g.args.map((G,T)=>{if(!G.validate(y[T]))throw new Error(`Invalid argument '${G.name}' when running '${g.id}', received: ${typeof y[T]=="object"?JSON.stringify(y[T],null,"	"):y[T]} `);return G.convert(y[T])}),A=await this.executeCommand(g.internalId,...C);return g.result.convert(A,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new F.$kM(()=>{S.dispose(),this.c.delete(g.id)})}registerCommand(g,S,y,C,A,G){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:C,metadata:A,extension:G}),g&&this.#e.$registerCommand(S),new F.$kM(()=>{this.b.delete(S)&&g&&this.#e.$unregisterCommand(S)})}executeCommand(g,...S){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,S,!0)}async g(g,S,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,S,!1);{let C=!1;const A=(0,N.$Pn)(S,function(G){if(G instanceof F.$lM)return M.Position.from(G);if(G instanceof F.$mM)return M.Range.from(G);if(G instanceof F.$wM)return M.location.from(G);if(F.$LN.isNotebookRange(G))return M.NotebookRange.from(G);if(G instanceof ArrayBuffer)return C=!0,s.$ue.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return C=!0,s.$ue.wrap(G);if(G instanceof s.$ue)return C=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(g,C?new n.$dw(A):A,y);return(0,k.$Qh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(g,S,!1);throw G}}}async h(g,S,y){const C=this.b.get(g);if(!C)throw new Error("Unknown command");const{callback:A,thisArg:G,metadata:T}=C;if(T?.args)for(let P=0;P<T.args.length;P++)try{(0,I.$_f)(S[P],T.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${T.args[P].name}' - ${T.args[P].description}`)}const W=a.$3d.create();try{return await A.apply(G,S)}catch(P){if(g===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...S);L&&(g=L.command)}if(this.d.error(P,g,C.extension?.identifier),!y)throw P;if(C.extension?.identifier){const L=this.#i.onExtensionError(C.extension.identifier,P);this.d.trace("forwarded error to extension?",L,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$5i)(P)),this.id=g,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,g,W.elapsed())}}j(g,S,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new h.$3o(S),duration:y})}$executeContributedCommand(g,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(S=S.map(C=>this.f.reduce((A,G)=>G.processArgument(A,y.extension?.identifier),C)),this.h(g,S,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(S=>(g&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[S,y]of this.b){const{metadata:C}=y;C&&(g[S]=C)}return Promise.resolve(g)}};e.$XO=c,e.$XO=c=Je([qe(0,r.$CO),qe(1,d.$Nj),qe(2,t.$WO)],c),e.$YO=(0,f.$hi)("IExtHostCommands");class ${constructor(g,S,y){this.d=g,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,v.$Dg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,S){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const C=this.f(g.command);if(C)y.id=C.internalId,y.arguments=C.args.map((A,G)=>A.convert(g.arguments&&g.arguments[G]));else if((0,m.$Lb)(g.arguments)){const A=`${g.command} /${++this.c}`;this.b.set(A,g),S.add((0,b.$Sc)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),y.$ident=A,y.id=this.delegatingCommandId,y.arguments=[A],this.g.trace("CommandsConverter#CREATE",g.command,A)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const S=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$ZO=$;class w{static{this.Uri=new w("uri","Uri of a text document",g=>u.URI.isUri(g),g=>g)}static{this.Position=new w("position","A position in a text document",g=>F.$lM.isPosition(g),M.Position.from)}static{this.Range=new w("range","A range in a text document",g=>F.$mM.isRange(g),M.Range.from)}static{this.Selection=new w("selection","A selection in a text document",g=>F.$nM.isSelection(g),M.Selection.from)}static{this.Number=new w("number","",g=>typeof g=="number",g=>g)}static{this.String=new w("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=w.Arr(w.String)}static Arr(g){return new w(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,S=>Array.isArray(S)&&S.every(y=>g.validate(y)),S=>S.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",g=>g instanceof F.$HM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",g=>g instanceof F.$5N,M.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",g=>g instanceof o.$PO,M.TestItem.from)}constructor(g,S,y,C){this.name=g,this.description=S,this.validate=y,this.convert=C}optional(){return new w(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,S){return new w(g??this.name,S??this.description,this.validate,this.convert)}}e.$1O=w;class p{static{this.Void=new p("no result",g=>g)}constructor(g,S){this.description=g,this.convert=S}}e.$2O=p;class l{constructor(g,S,y,C,A){this.id=g,this.internalId=S,this.description=y,this.args=C,this.result=A}}e.$3O=l}),define(Pe[275],Me([1,0,18,12,2,87,97,33,31,8,7]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;const E=[new d.$3O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of DocumentHighlight-instances.",b(k.DocumentHighlight.to))),new d.$3O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$1O.Uri],new d.$2O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends O.$CM{static to(i){const a=new s(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new O.$wM(o[0],k.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=k.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return r.map(s.to)})),new d.$3O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$1O.Uri,new d.$1O("options","Formatting options",r=>!0,r=>r)],new d.$2O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$3O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$1O.Uri,d.$1O.Range,new d.$1O("options","Formatting options",r=>!0,r=>r)],new d.$2O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$3O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$1O.Uri,d.$1O.Position,new d.$1O("ch","Trigger character",r=>typeof r=="string",r=>r),new d.$1O("options","Formatting options",r=>!0,r=>r)],new d.$2O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$3O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$3O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$3O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$3O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$3O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of Location-instances.",b(k.location.to))),new d.$3O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new d.$3O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$1O.Uri,new d.$1O("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>O.$lM.isPosition(o)),r=>r.map(k.Position.from))],new d.$2O("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const n of o.reverse())s=new O.$GM(k.Range.to(n),s);return s}))),new d.$3O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$1O.String.with("query","Search string")],new d.$2O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(k.WorkspaceSymbol.to))),new d.$3O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(k.CallHierarchyItem.to))),new d.$3O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$1O.CallHierarchyItem],new d.$2O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(k.CallHierarchyIncomingCall.to))),new d.$3O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$1O.CallHierarchyItem],new d.$2O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(k.CallHierarchyOutgoingCall.to))),new d.$3O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:k.Range.to(r.range),placeholder:r.text}})),new d.$3O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$1O.Uri,d.$1O.Position,d.$1O.String.with("newName","The new symbol name")],new d.$2O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new d.$3O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$1O.Uri,d.$1O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$2O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new d.$3O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$1O.Uri],new d.$2O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new O.$CN(r.tokenTypes,r.tokenModifiers)})),new d.$3O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$1O.Uri],new d.$2O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$tab)(r);if(o.type==="full")return new O.$EN(o.data,void 0)})),new d.$3O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$1O.Uri,d.$1O.Range.optional()],new d.$2O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new O.$CN(r.tokenTypes,r.tokenModifiers)})),new d.$3O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$1O.Uri,d.$1O.Range],new d.$2O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$tab)(r);if(o.type==="full")return new O.$EN(o.data,void 0)})),new d.$3O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$1O.Uri,d.$1O.Position,d.$1O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$1O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$2O("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new O.$SM([]);const n=r.suggestions.map(i=>k.CompletionItem.to(i,s));return new O.$SM(n,r.incomplete)})),new d.$3O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$1O.Uri,d.$1O.Position,d.$1O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$2O("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new d.$3O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$1O.Uri,d.$1O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$2O("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>b(n=>new O.$KM(k.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new d.$3O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$1O.Uri,new d.$1O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>O.$mM.isRange(r),r=>O.$nM.isSelection(r)?k.Selection.from(r):k.Range.from(r)),d.$1O.String.with("kind","Code action kind to return code actions for").optional(),d.$1O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$2O("A promise that resolves to an array of Command-instances.",(r,o,s)=>b(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new O.$EM(n.title,n.kind?new O.$FM(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new d.$3O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$1O.Uri],new d.$2O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new O.$YM(k.Range.to(o.range),k.Color.to(o.color))):[])),new d.$3O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$1O("color","The color to show and insert",r=>r instanceof O.$XM,k.Color.from),new d.$1O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new d.$2O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new d.$3O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$1O.Uri,d.$1O.Range],new d.$2O("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(k.InlayHint.to.bind(void 0,s)))),new d.$3O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$1O.Uri],new d.$2O("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(k.FoldingRange.to)})),new d.$3O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$2O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new d.$3O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$1O.Uri,d.$1O.Range,new d.$1O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof O.$mM,r=>k.InlineValueContext.from(r))],new d.$2O("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new d.$3O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$1O("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,F.$rg)(r,F.Schemas.http,F.Schemas.https),r=>r),new d.$1O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),d.$1O.String.with("label","").optional()],d.$2O.Void),new d.$3O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$1O.Uri.with("resource","Resource to open"),d.$1O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$1O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],d.$2O.Void),new d.$3O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$1O.Uri.with("left","Left-hand side resource of the diff editor"),d.$1O.Uri.with("right","Right-hand side resource of the diff editor"),d.$1O.String.with("title","Human readable title for the diff editor").optional(),new d.$1O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],d.$2O.Void),new d.$3O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$1O.String.with("title","Human readable title for the changes editor"),new d.$1O("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,n,i]=o;if(!M.URI.isUri(s)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],d.$2O.Void),new d.$3O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$1O.Uri,d.$1O.Position],new d.$2O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$3O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$1O.TypeHierarchyItem],new d.$2O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$3O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$1O.TypeHierarchyItem],new d.$2O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$3O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$1O.TestItem],d.$2O.Void),new d.$3O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$1O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$2O.Void),new d.$3O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$1O.String.with("name","The context key name"),new d.$1O("value","The context key value",()=>!0,r=>r)],d.$2O.Void),new d.$3O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$1O.Uri,d.$1O.StringArray,new d.$1O("MappedEditsContext","Mapped Edits Context",r=>k.MappedEditsContext.is(r),r=>k.MappedEditsContext.from(r))],new d.$2O("A promise that resolves to a workspace edit or null",r=>r?k.WorkspaceEdit.to(r):null))];class u{static register(o){E.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$gj)}}e.$Uic=u;function b(r){return o=>{if(Array.isArray(o))return o.map(r)}}function f(r){if(!Array.isArray(r))return;const o=[];for(const s of r)N.$2t(s)?o.push(k.DefinitionLink.to(s)):o.push(k.location.to(s));return o}}),define(Pe[276],Me([1,0,11,6,2,4,31,8,7]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=void 0;class k{static{this.a=0}constructor(b,f){this.extension=b,this.provider=f,this.handle=k.a++}}class O{constructor(b){this.session=b,this.responses=[]}}class E{static{this.a=0}constructor(b,f,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=b.getProxy(N.$iM.MainThreadInlineChat),f.registerApiCommand(new R.$3O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$1O("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:d.$nM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],R.$2O.Void))}registerProvider(b,f,r){const o=new k(b,f);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??b.displayName??b.name,b.identifier.value,typeof f.handleInteractiveEditorResponseFeedback=="function",typeof f.provideFollowups=="function",r?.supportReportIssue??!1),(0,F.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(b,f,r,o){const s=this.b.get(b);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(f)),i=m.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=E.a++;return this.d.set(h,new O(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(b,f,r,o){const s=this.b.get(b);if(!s)return;const n=this.d.get(f.id);if(!n)return;const i={prompt:r.prompt,selection:m.Selection.to(r.selection),wholeRange:m.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(M.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const h={report:async D=>{if(!r.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:D.message,edits:D.edits?.map(m.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:d.$LM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,h,o));let v;try{v=await(0,I.$8g)(t,o)}finally{a=!0}if(!v)return;const c=n.responses.push(v)-1,$={wholeRange:m.Range.from(v.wholeRange),placeholder:v.placeholder};if(!E.h(v))return{...$,id:c,type:"editorEdit",message:m.MarkdownString.from(v.contents),edits:[]};const{edits:w,contents:p}=v,l=p!==void 0?m.MarkdownString.from(p):void 0;return w instanceof d.$uM?{...$,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(w),message:l}:{...$,id:c,type:"editorEdit",edits:w.map(m.TextEdit.from),message:l}}async $provideFollowups(b,f,r,o){const s=this.b.get(b),n=this.d.get(f),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(n.session,i,o));return(await(0,I.$8g)(a,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(b,f,r,o){const s=this.b.get(b),n=this.d.get(f),i=n?.responses[r];if(s&&i){const a=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,a)}}$releaseSession(b,f){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$5jc=E}),define(Pe[277],Me([1,0,2,31]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class M{constructor(R,m,d,k,O){this.a=m,this.b=d,this.c=k;const E=new F.$3O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$1O("showOptions","Show Options",u=>!0,u=>u),new F.$1O("resource","Interactive resource Uri",u=>!0,u=>u),new F.$1O("controllerId","Notebook controller Id",u=>!0,u=>u),new F.$1O("title","Interactive editor title",u=>!0,u=>u)],new F.$2O("Notebook and input URI",u=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(R,m,d,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:d,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$fkc=M}),define(Pe[278],Me([1,0,18,11,25,5,6,28,2,20,13,4,31,8,7,76,217,22,50,218]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0,e.$okc=w;let a=class{constructor(l,D,g,S,y){this.m=D,this.n=g,this.o=S,this.q=y,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(E.$iM.MainThreadNotebookKernels);const C=new u.$3O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$1O("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const T=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:T}}else if(G&&"notebookEditor"in G){const T=this.n.getIdByEditor(G.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return G})],u.$2O.Void),A=new u.$3O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$1O.Uri],new u.$2O("A promise that resolves to an array of variables",(G,T)=>G.map(W=>({name:W.name,value:W.value,type:W.type,editable:!1}))));this.o.registerApiCommand(C),this.o.registerApiCommand(A)}createNotebookController(l,D,g,S,y,C){for(const pe of this.j.values())if(pe.controller.id===D&&k.$Cm.equals(l.identifier,pe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const A=this.k++,G=this;this.q.trace(`NotebookController[${A}], CREATED by ${l.identifier.value}, ${D}`);const T=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${l.identifier}'`);let W=!1;const P=new N.$7d,L=new N.$7d,K={id:w(l.identifier,D),notebookType:g,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:C?C.map(b.NotebookRendererScript.from):[]};let ne=y??T,le,ye;this.a.$addKernel(A,K).catch(pe=>{console.log(pe),W=!0});let Se=0;const he=()=>{if(W)return;const pe=++Se;Promise.resolve().then(()=>{pe===Se&&this.a.$updateKernel(A,K)})},be=new m.$Bc,ee={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:P.event,get label(){return K.label},set label(pe){K.label=pe??l.displayName??l.name,he()},get detail(){return K.detail??""},set detail(pe){K.detail=pe,he()},get description(){return K.description??""},set description(pe){K.description=pe,he()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(pe){K.supportedLanguages=pe,he()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){K.supportsExecutionOrder=pe,he()},get rendererScripts(){return K.preloads?K.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ne},set executeHandler(pe){ne=pe??T},get interruptHandler(){return le},set interruptHandler(pe){le=pe,K.supportsInterrupt=!!pe,he()},set variableProvider(pe){(0,s.$7F)(l,"notebookVariableProvider"),ye=pe,K.hasVariableProvider=!!pe,pe?.onDidChangeVariables(re=>G.a.$variablesUpdated(re.uri)),he()},get variableProvider(){return ye},createNotebookCellExecution(pe){if(W)throw new Error("notebook controller is DISPOSED");if(!be.has(pe.notebook.uri))throw G.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return G._createNotebookCellExecution(pe,w(l.identifier,this.id))},createNotebookExecution(pe){if((0,s.$7F)(l,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!be.has(pe.uri))throw G.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return G._createNotebookExecution(pe,w(l.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${A}], DISPOSED`),W=!0,this.j.delete(A),P.dispose(),L.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(pe,re){re===f.NotebookControllerAffinity2.Hidden&&(0,s.$7F)(l,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(A,pe.uri,re)},onDidReceiveMessage:L.event,postMessage(pe,re){return(0,s.$7F)(l,"notebookMessaging"),G.a.$postMessage(A,re&&G.n.getIdByEditor(re),pe)},asWebviewUri(pe){return(0,s.$7F)(l,"notebookMessaging"),(0,r.$Oyb)(pe,G.m.remote)}};return this.j.set(A,{extensionId:l.identifier,controller:ee,onDidReceiveMessage:L,onDidChangeSelection:P,associatedNotebooks:be}),ee}getIdByController(l){for(const[D,g]of this.j)if(g.controller===l)return w(g.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const g=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(g,D);const y={dispose:()=>{this.f.delete(g),S.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider(l,D,g){const S=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,g),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let A;return y!==void 0&&(A=g.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),A?.dispose()}}}async $provideKernelSourceActions(l,D){const g=this.h.get(l);if(g){const S=new R.$Tc;return(await g.provideNotebookKernelSourceActions(D)??[]).map(C=>b.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,g){const S=this.j.get(l);if(S){const y=this.n.getNotebookDocument(d.URI.revive(D));g?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,y.uri.toString(),g),S.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(d.URI.revive(D)),C=[];for(const A of g){const G=y.getCell(A);G&&C.push(G.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,y.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,y.apiNotebook,S.controller)}catch(A){this.q.error(`NotebookController[${l}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(d.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const C of g){const A=y.getCell(C);A&&this.b.get(A.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(y.uri);g.length&&Array.isArray(C)&&C.length&&C.forEach(A=>A.dispose())}}async $provideVariables(l,D,g,S,y,C,A){const G=this.j.get(l);if(!G)return;const T=this.n.getNotebookDocument(d.URI.revive(g)),W=G.controller.variableProvider;if(!W)return;let P;if(S!==void 0){if(P=this.s[S],!P)return}else this.s={};const L=y==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,K=W.provideVariables(T.apiNotebook,P,L,C,A);let ne=0;for await(const le of K){if(A.isCancellationRequested)return;const ye={id:this.r++,name:le.variable.name,value:le.variable.value,type:le.variable.type,language:le.variable.language,expression:le.variable.expression,hasNamedChildren:le.hasNamedChildren,indexedChildrenCount:le.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=le.variable,this.a.$receiveVariable(D,ye),ne++>=i.$phb)return}}$acceptKernelMessageFromRenderer(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged(l,D,g){const y=this.n.getNotebookDocument(d.URI.revive(l)).getCell(D);if(y){const C=g?b.NotebookCellExecutionState.to(g):f.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(D,S,this.a);this.b.set(S.uri,y);const C=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),C.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(l,D){const g=this.n.getNotebookDocument(l.uri),S=l.getCells().find(A=>{const G=g.getCellFromApiCell(A);return G&&this.b.has(G.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new c(D,g,this.a),C=y.onDidChangeState(()=>{y.state===v.Resolved&&(y.dispose(),C.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,C]),y.asApiObject()}};e.$nkc=a,e.$nkc=a=Je([qe(4,O.$Nj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.m=D,this.n=g,this.b=t.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new M.$ee),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new n.$dw(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const g=f.$PN.ensureUniqueMimeTypes(D.items,!0);return g===D.items?b.NotebookCellOutput.from(D):b.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async z(l,D,g){const S=this.w(D),y=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:g,outputs:y})}async C(l,D,g){return l=f.$PN.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(b.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(g){l.j=g,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(g){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,S,y){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;l.n.$completeExecution(l.b,new n.$dw({runEndTime:S,lastRunSuccess:g,error:C}))},clearOutput(g){return l.t(),l.z([],g,!1)},appendOutput(g,S){return l.t(),l.z(g,S,!0)},replaceOutput(g,S){return l.t(),l.z(g,S,!1)},appendOutputItems(g,S){return l.t(),l.C(g,S,!0)},replaceOutputItems(g,S){return l.t(),l.C(g,S,!1)}})}}var v;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(v||(v={}));class c extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.h=D,this.j=g,this.b=c.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new M.$ee),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new F.$Eh,this.b=Date.now(),(0,F.$ih)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function w(p,l){return`${p.value}/${l}`}}),define(Pe[66],Me([1,0,5,4,3,2,17,6,7,171,14,199,25,34,200,41,11,8,31]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=e.$Ajc=e.$zjc=void 0,e.$zjc=(0,M.$hi)("IExtHostTerminalService");class i{constructor(g,S,y,C){this.l=g,this._id=S,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const A=this;this.value={get name(){return A.n||""},get processId(){return A.b},get creationOptions(){return A.m},get exitStatus(){return A.h},get state(){return A.j},get selection(){return A.k},sendText(G,T=!0){A.q(),A.l.$sendText(A._id,G,T)},show(G){A.q(),A.l.$show(A._id,G)},hide(){A.q(),A.l.$hide(A._id)},dispose(){A.a||(A.a=!0,A.l.$dispose(A._id))},get dimensions(){if(!(A.d===void 0||A.g===void 0))return{columns:A.d,rows:A.g}}}}async create(g,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??S?.cwd??void 0,env:g.env??void 0,icon:w(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.o(g.location,S?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,S,y,C,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(A)?A.id:void 0,location:S?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,S){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,S){this.h=Object.freeze({code:g,reason:S})}setDimensions(g,S){return g===this.d&&S===this.g||g===0||S===0?!1:(this.d=g,this.g=S,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(S=>{S!==g&&(this.b=Promise.resolve(g))})}}e.$Ajc=i;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$7d,this.onProcessData=this.a.event,this.b=new I.$7d,this.d=new I.$7d,this.onDidChangeProperty=this.d.event,this.f=new I.$7d,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,S){this.g.setDimensions?.({columns:g,rows:S})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$7d,this.onDidCloseTerminal=this.H.event,this.I=new I.$7d,this.onDidOpenTerminal=this.I.event,this.J=new I.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$7d,this.onDidChangeShell=this.N.event,this.O=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(F.$iM.MainThreadTerminalService),this.y=new f.$hub(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:C=>{const A=G=>{const T=G;return this.W(T.instanceId)?.value};switch(C?.$mid){case 15:return A(C);default:{if(Array.isArray(C))for(let G=0;G<C.length&&C[G].$mid===15;G++)C[G]=A(C[G]);return C}}}}),this.B({dispose:()=>{for(const[C,A]of this.g)A.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,S){const y=new i(this.a,(0,b.$Dg)(),g,g.name),C=new a(g.pty);return y.createExtensionTerminal(g.location,S,this.R(g,S).resolvedExtHostIdentifier,w(g.iconPath),p(g.color)).then(A=>{const G=this.S(A,C);this.h[A]=G}),this.f.push(y),y.value}R(g,S){if(S=S||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const C=this.f.find(A=>A.value===y);C&&(S.resolvedExtHostIdentifier=C._id)}}else g.location&&typeof g.location!="object"?S.location=g.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(g,S){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const C=new a(S),A=this.S(g,C);this.h[g]=A}async $acceptActiveTerminalChanged(g){const S=this.b;if(g===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,S){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(g,S,y){const C=this.W(g);C&&C.setDimensions(S,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(g,S){const y=this.W(g);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(g,S,y){this.g.get(g)?.resize(S,y)}async $acceptTerminalTitleChange(g,S){const y=this.W(g);y&&(y.name=S)}async $acceptTerminalClosed(g,S,y){const C=this.Y(this.f,g);if(C!==null){const A=this.f.splice(C,1)[0];A.setExitStatus(S,y),this.H.fire(A.value)}}$acceptTerminalOpened(g,S,y,C){if(S){const T=this.Y(this.f,S);if(T!==null){this.f[T]._id=g,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const A={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:N.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},G=new i(this.a,g,A,y);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,S){this.W(g)?._setProcessId(S)}async $startExtensionTerminal(g,S){const y=this.W(g);if(!y)return{message:(0,k.localize)(0,null,g)};y.isOpen||await new Promise(A=>{const G=this.onDidOpenTerminal(async T=>{T===y.value&&(G.dispose(),A())})});const C=this.g.get(g);C?C.startSendingEvents(S):this.j[g]={initialDimensions:S}}S(g,S){const y=new m.$Tc;y.add(S.onProcessReady(A=>this.a.$sendProcessReady(g,A.pid,A.cwd,A.windowsPty))),y.add(S.onDidChangeProperty(A=>this.a.$sendProcessProperty(g,A))),this.y.startBuffering(g,S.onProcessData),y.add(S.onProcessExit(A=>this.U(g,A))),this.g.set(g,S);const C=this.j[g];return C&&S instanceof a&&(S.startSendingEvents(C.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,S){this.g.get(g)?.acknowledgeDataEvent(S)}$acceptProcessInput(g,S){this.g.get(g)?.input(S)}$acceptTerminalInteraction(g){const S=this.W(g);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(g,S){this.W(g)?.setSelection(S)}$acceptProcessResize(g,S,y){try{this.g.get(g)?.resize(S,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(g,S){this.g.get(g)?.shutdown(S)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(S=>this.a.$sendProcessProperty(g,{type:"cwd",value:S}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new d.$kM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,g.identifier.value),new d.$kM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(g,S,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,S),new d.$kM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,S){const y=new u.$ee().token;if(y.isCancellationRequested)return;const C=this.D.get(g);if(!C)return;const A=await C.provideTerminalQuickFixes(S,y);if(A===null||Array.isArray(A)&&A.length===0)return;const G=new m.$Tc;if(this.w.value=G,!Array.isArray(A))return A?s.TerminalQuickFix.from(A,this.Q.converter,G):void 0;const T=[];for(const W of A){const P=s.TerminalQuickFix.from(W,this.Q.converter,G);P&&T.push(P)}return T}async $createContributedProfileTerminal(g,S){const y=new u.$ee().token;let C=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(g,S){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const A=new u.$ee;this.G.set(g,A);const G=[],T={terminal:y.value,line:S},W=[];for(const K of this.z)W.push(o.Promises.withAsyncBody(async ne=>{A.token.onCancellationRequested(()=>ne({provider:K,links:[]}));const le=await K.provideTerminalLinks(T,A.token)||[];A.token.isCancellationRequested||ne({provider:K,links:le})}));const P=await Promise.all(W);if(A.token.isCancellationRequested)return[];const L=new Map;for(const K of P)K&&K.links.length>0&&G.push(...K.links.map(ne=>{const le={id:h++,startIndex:ne.startIndex,length:ne.length,label:ne.tooltip};return L.set(le.id,{provider:K.provider,link:ne}),le}));return this.F.set(g,L),G}$activateLink(g,S){const y=this.F.get(g)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(g,S){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,S)}W(g){return this.X(this.f,g)}X(g,S){const y=this.Y(g,S);return y!==null?g[y]:null}Y(g,S){const y=g.findIndex(C=>C._id===S);return y===-1?null:y}getEnvironmentVariableCollection(g){let S=this.n.get(g.identifier.value);return S||(S=new v,this.$(g.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Z(g,S){const y=(0,E.$6r)(S.map),C=(0,E.$7r)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(g,S.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(g){g.forEach(S=>{const y=S[0],C=new v(S[1]);this.$(y,C)})}$acceptDefaultProfile(g,S){const y=this.s;this.s=g,this.u=S,y?.path!==g.path&&this.N.fire(g.path)}$(g,S){this.n.set(g,S),S.onDidChangeCollection(()=>{this.Z(g,S)})}};e.$Bjc=t,e.$Bjc=t=Je([qe(1,n.$YO),qe(2,R.$CO)],t);class v{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$7d,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const S=this.h(g);let y=this.a.get(S);return y||(y=new c(this,g),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,S,y,C){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(g,S,y,C){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(g,S,y,C){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(g,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,S.scope),C=this.map.get(y),A=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==A.applyAtProcessCreation||C.options?.applyAtShellIntegration!==A.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const G=this.g(g,S.scope),T={variable:g,...S,options:A};this.map.set(G,T),this.d.fire()}}get(g,S){const y=this.g(g,S),C=this.map.get(y);return C?l(C):void 0}g(g,S){const y=this.h(S);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const S=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(g)&&S.set(C.variable,l(C));return S}delete(g,S){const y=this.g(g,S);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(S);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,S){const y=this.h(S),C=this.descriptionMap.get(y);if(!C||C.description!==g){let A;typeof g=="string"?A=g:A=g?.value.split(`

`)[0];const G={description:A,scope:S};this.descriptionMap.set(y,G),this.d.fire()}}getDescription(g){const S=this.h(g);return this.descriptionMap.get(S)?.description}k(g){const S=this.h(g);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,S){this.b=g,this.d=S,this.a=new I.$7d}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,S,y){this.b.replace(g,S,y,this.d)}append(g,S,y){this.b.append(g,S,y,this.d)}prepend(g,S,y){this.b.prepend(g,S,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,S){this.b.getVariableMap(this.d).forEach((y,C)=>g.call(S,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(g,S){super(!1,g,S)}createTerminal(g,S,y){throw new O.$_}createTerminalFromOptions(g,S){throw new O.$_}};e.$Cjc=$,e.$Cjc=$=Je([qe(0,n.$YO),qe(1,R.$CO)],$);function w(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return r.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Pe[279],Me([1,0,11,23,25,5,251,99,6,16,34,13,4,17,113,8,7,49,75,60,22]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=e.$Gkc=e.$Fkc=void 0;let h=class extends d.$Uc{constructor(T,W,P,L){super(),this.w=L,this.f=this.B(new N.$7d),this.g=new Map,this.s=this.B(new N.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(u.$iM.MainThreadTesting),this.m=new S(this.h),this.j=new $(this.h,W),P.registerArgumentProcessor({processArgument:K=>{switch(K?.$mid){case 16:{const ne=K,le=ne.tests[ne.tests.length-1].item.extId;return this.g.get(s.$7K.root(le))?.collection.tree.get(le)?.actual??(0,f.$OO)(K)}case 18:{const{test:ne,message:le}=K,ye=ne.item.extId;return{test:this.g.get(s.$7K.root(ye))?.collection.tree.get(ye)?.actual??(0,f.$OO)({$mid:16,tests:[ne]}),message:r.TestMessage.to(le)}}default:return K}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const K=await P.executeCommand("_testing.getExplorerSelection"),ne=le=>{const ye=this.g.get(s.$7K.root(le));if(ye)return s.$7K.isRoot(le)?ye.controller:ye.collection.tree.get(le)?.actual};return{include:K?.include.map(ne).filter(k.$3f)||[],exclude:K?.exclude.map(ne).filter(k.$3f)||[]}})}createTestController(T,W,P,L){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const K=new d.$Tc,ne=K.add(new f.$RO(W,P,this.w));ne.root.label=P;const le=new Map,ye=new Set,Se=this.h,he={items:ne.root.children,get label(){return P},set label(ee){P=ee,ne.root.label=ee,Se.$updateController(W,{label:P})},get refreshHandler(){return L},set refreshHandler(ee){L=ee,Se.$updateController(W,{canRefresh:!!ee})},get id(){return W},createRunProfile:(ee,pe,re,fe,V,te)=>{let ke=(0,m.$8i)(ee);for(;le.has(ke);)ke++;return new C(this.h,le,ye,this.s.event,W,ke,ee,pe,re,fe,V,te)},createTestItem(ee,pe,re){return new f.$PO(W,ee,pe,re)},createTestRun:(ee,pe,re=!0)=>this.j.createTestRun(T,W,ne,ee,pe,re),invalidateTestResults:ee=>{if(ee===void 0)this.h.$markTestRetired(void 0);else{const pe=ee instanceof Array?ee:[ee];this.h.$markTestRetired(pe.map(re=>s.$7K.fromExtHostTestItem(re,W).toString()))}},set resolveHandler(ee){ne.resolveHandler=ee},get resolveHandler(){return ne.resolveHandler},dispose:()=>{K.dispose()}};Se.$registerTestController(W,P,!!L),K.add((0,d.$Sc)(()=>Se.$unregisterTestController(W)));const be={controller:he,collection:ne,profiles:le,extension:T,activeProfiles:ye};return this.g.set(W,be),K.add((0,d.$Sc)(()=>this.g.delete(W))),K.add(ne.onDidGenerateDiff(ee=>Se.$publishDiff(W,ee.map(i.TestsDiffOp.serialize)))),he}createTestObserver(){return this.m.checkout()}async runTests(T,W=M.CancellationToken.None){const P=w(T);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.g.get(P.controllerId);if(!L)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(K=>s.$7K.fromExtHostTestItem(K,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:A[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:T.exclude?.map(K=>K.id)},W)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $provideFileCoverage(T,W,P){return await this.j.getCoverageReport(T,W)?.provideFileCoverage(P)??[]}async $resolveFileCoverage(T,W,P,L){return await this.j.getCoverageReport(T,W)?.resolveFileCoverage(P,L)??[]}$configureRunProfile(T,W){this.g.get(T)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(T){const W=new Map;for(const[P,L]of Object.entries(T)){const K=this.g.get(P);if(!K)continue;const ne=new Map,le=L.filter(Se=>!K.activeProfiles.has(Se)),ye=[...K.activeProfiles].filter(Se=>!L.includes(Se));for(const Se of le)ne.set(Se,!0),K.activeProfiles.add(Se);for(const Se of ye)ne.set(Se,!1),K.activeProfiles.delete(Se);ne.size&&W.set(P,ne)}this.s.fire(W)}async $refreshTests(T,W){await this.g.get(T)?.controller.refreshHandler?.(W)}$publishTestResults(T){this.results=Object.freeze(T.map(r.TestResults.to).concat(this.results).sort((W,P)=>P.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,W){const P=this.g.get(s.$7K.fromString(T).controllerId)?.collection;P&&(await P.expand(T,W<0?1/0:W),P.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:P=>P},W)))}async $runControllerTests(T,W){return Promise.all(T.map(P=>this.y(P,!1,W)))}async $startContinuousRun(T,W){const P=new M.$ee(W),L=await Promise.all(T.map(K=>this.y(K,!0,P.token)));return!W.isCancellationRequested&&!L.some(K=>K.error)&&await new Promise(K=>W.onCancellationRequested(K)),P.dispose(!0),L}async y(T,W,P){const L=this.g.get(T.controllerId);if(!L)return{};const{collection:K,profiles:ne,extension:le}=L,ye=ne.get(T.profileId);if(!ye)return{};const Se=T.testIds.map(pe=>K.tree.get(pe)).filter(k.$3f),he=T.excludeExtIds.map(pe=>L.collection.tree.get(pe)).filter(k.$3f).filter(pe=>Se.some(re=>re.fullId.compare(pe.fullId)===2));if(!Se.length)return{};const be=new o.$WN(Se.some(pe=>pe.actual instanceof f.$QO)?void 0:Se.map(pe=>pe.actual),he.map(pe=>pe.actual),ye,W),ee=(0,i.$0K)(T)&&this.j.prepareForMainThreadTestRun(be,p.fromInternal(T,L.collection),le,P);try{return await ye.runHandler(be,P),{}}catch(pe){return{error:String(pe)}}finally{ee&&(ee.hasRunningTasks&&!P.isCancellationRequested&&await N.Event.toPromise(ee.onEnd),ee.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$Fkc=h,e.$Fkc=h=Je([qe(0,b.$CO),qe(1,E.$Nj)],h);const t=1e4;var v;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(v||(v={}));class c extends d.$Uc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(T,W,P,L,K){super(),this.s=T,this.w=W,this.y=P,this.z=L,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new N.$7d),this.m=this.B(new N.$7d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new M.$ee(K));const ne=this.B(new I.$th(()=>this.C(),t));this.B(this.h.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(T){const W=this.s.id,P=this.s.controllerId,L=(0,O.$Dg)(),K=this.y,ne=this.m;let le;const ye=ee=>(pe,...re)=>{if(he){this.z.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(pe)&&(this.F(pe),ee(pe,...re))},Se=(ee,pe)=>{const re=pe instanceof Array?pe.map(r.TestMessage.from):[r.TestMessage.from(pe)];if(ee.uri&&ee.range){const fe={range:r.Range.from(ee.range),uri:ee.uri};for(const V of re)V.location=V.location||fe}this.w.$appendTestMessagesInRun(W,L,s.$7K.fromExtHostTestItem(ee,P).toString(),re)};let he=!1;const be={isPersisted:this.s.isPersisted,token:this.h.token,name:T,get coverageProvider(){return le?.provider},set coverageProvider(ee){(0,a.$7F)(K,"testCoverage"),le=ee&&new l(ee),ne.fire({taskId:L,runId:W,coverage:le})},enqueued:ye(ee=>{this.w.$updateTestStateInRun(W,L,s.$7K.fromExtHostTestItem(ee,P).toString(),1)}),skipped:ye(ee=>{this.w.$updateTestStateInRun(W,L,s.$7K.fromExtHostTestItem(ee,P).toString(),5)}),started:ye(ee=>{this.w.$updateTestStateInRun(W,L,s.$7K.fromExtHostTestItem(ee,P).toString(),2)}),errored:ye((ee,pe,re)=>{Se(ee,pe),this.w.$updateTestStateInRun(W,L,s.$7K.fromExtHostTestItem(ee,P).toString(),6,re)}),failed:ye((ee,pe,re)=>{Se(ee,pe),this.w.$updateTestStateInRun(W,L,s.$7K.fromExtHostTestItem(ee,P).toString(),4,re)}),passed:ye((ee,pe)=>{this.w.$updateTestStateInRun(W,L,s.$7K.fromExtHostTestItem(ee,this.s.controllerId).toString(),3,pe)}),appendOutput:(ee,pe,re)=>{he||(re&&(this.s.isIncluded(re)?this.F(re):re=void 0),this.w.$appendOutputToRun(W,L,F.$ue.fromString(ee),pe&&r.location.from(pe),re&&s.$7K.fromExtHostTestItem(re,P).toString()))},end:()=>{he||(he=!0,this.w.$finishedTestRunTask(W,L),this.f.delete(L),this.f.size||this.D())}};return this.f.set(L,{run:be}),this.w.$startedTestRunTask(W,{id:L,name:T,running:!0}),be}C(){for(const{run:T}of this.f.values())T.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(T){if(!(T instanceof f.$PO))throw new n.$uO(T.id);if(this.g.has(s.$7K.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const W=[],P=this.s.colllection.root;for(;;){const L=r.TestItem.from(T);if(W.unshift(L),this.g.has(L.extId)||(this.g.add(L.extId),T===P))break;T=T.parent||P}this.w.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.D(),super.dispose()}}class ${get trackers(){return this.c.values()}constructor(T,W){this.g=T,this.h=W,this.c=new Map,this.f=[]}getCoverageReport(T,W){return this.f.find(P=>P.runId===T)?.coverage.get(W)}prepareForMainThreadTestRun(T,W,P,L){return this.j(T,W,P,L)}cancelRunById(T){for(const W of this.c.values())if(W.id===T){W.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,W,P,L,K,ne){const le=this.c.get(L);if(le)return le.createRun(K);const ye=p.fromPublic(W,P,L,ne),Se=w(L);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!L.continuous,profile:Se&&{group:A[Se.kind],id:Se.profileId},exclude:L.exclude?.map(be=>s.$7K.fromExtHostTestItem(be,P.root.id).toString())??[],id:ye.id,include:L.include?.map(be=>s.$7K.fromExtHostTestItem(be,P.root.id).toString())??[P.root.id],persist:ne});const he=this.j(L,ye,T);return N.Event.once(he.onEnd)(()=>{this.g.$finishedExtensionTestRun(ye.id),he.dispose()}),he.createRun(K)}j(T,W,P,L){const K=new c(W,this.g,P,this.h,L);this.c.set(T,K);let ne;const le=K.onDidCoverage(({runId:ye,taskId:Se,coverage:he})=>{ne||(ne={runId:ye,coverage:new Map},this.f.unshift(ne),this.f.length>i.$cL&&this.f.pop()),ne.coverage.set(Se,he),this.g.$signalCoverageAvailable(ye,Se,!!he)});return N.Event.once(K.onEnd)(()=>{this.c.delete(T),le.dispose()}),K}}e.$Gkc=$;const w=G=>{if(G.profile){if(!(G.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class p{static fromPublic(T,W,P,L){return new p(T,(0,O.$Dg)(),P.include?.map(K=>s.$7K.fromExtHostTestItem(K,T).toString())??[T],P.exclude?.map(K=>s.$7K.fromExtHostTestItem(K,T).toString())??[],L,W)}static fromInternal(T,W){return new p(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,W)}constructor(T,W,P,L,K,ne){this.controllerId=T,this.id=W,this.isPersisted=K,this.colllection=ne,this.c=P.map(le=>le+"\0"),this.f=L.map(le=>le+"\0")}isIncluded(T){const W=s.$7K.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const P of this.f)if(W===P||W.startsWith(P))return!1;for(const P of this.c)if(W===P||W.startsWith(P))return!0;return!1}}e.$Hkc=p;class l{constructor(T){this.provider=T}async provideFileCoverage(T){this.c||(this.c=(async()=>this.provider.provideFileCoverage(T))());try{return(await this.c)?.map(r.TestCoverage.fromFile)??[]}catch(W){throw this.c=void 0,W}}async resolveFileCoverage(T,W){const P=await this.c;let L=P?.[T];return!this.provider||!P||!L?[]:(L.detailedCoverage||(L=P[T]=await this.provider.resolveFileCoverage?.(L,W)??L),L.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,r.TestItem.toPlain(T.item)),this.c.has(T)||this.f.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.f.delete(T);const W=s.$7K.parentId(T.item.extId);if(W&&this.h.has(W.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{c:T,f:W,g:P}=this;return{get added(){return[...T].map(L=>L.revived)},get updated(){return[...W].map(L=>L.revived)},get removed(){return[...P].map(L=>L.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends i.$dL{constructor(){super(...arguments),this.s=new N.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}w(T,W){return{...T,revived:r.TestItem.toPlain(T.item),depth:W?W.depth+1:0,children:new Set}}v(){return new D(this.s)}}class S{constructor(T){this.f=T}checkout(){this.c||(this.c=this.g());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}g(){const T=new g({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}const y=(G,T,W,P)=>{W?Object.assign(W,P):T.$updateTestRunConfig(G.controllerId,G.profileId,P)};class C{#e;#t;#i;#n;#s;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,y(this,this.#e,this.#n,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,y(this,this.#e,this.#n,{supportsContinuousRun:T}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?this.#t.add(this.profileId):this.#t.delete(this.profileId),y(this,this.#e,this.#n,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,y(this,this.#e,this.#n,{tag:T?r.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,y(this,this.#e,this.#n,{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return N.Event.chain(this.#i,T=>T.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(k.$3f))}constructor(T,W,P,L,K,ne,le,ye,Se,he=!1,be=void 0,ee=!1){this.controllerId=K,this.profileId=ne,this.f=le,this.kind=ye,this.runHandler=Se,this._tag=be,this.g=ee,this.#e=T,this.#s=W,this.#t=P,this.#i=L,W.set(ne,this);const pe=A[ye];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);he&&P.add(ne),this.#n={profileId:ne,controllerId:K,tag:be?r.TestTag.namespace(this.controllerId,be.id):null,label:le,group:pe,isDefault:he,hasConfigurationHandler:!1,supportsContinuousRun:ee},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ikc=C;const A={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[114],Me([1,0,55,14,90,8,7]),function(me,e,I,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=void 0;class m{static{this.c=new M.$HO("TextEditorDecorationType")}constructor(u,b,f){const r=m.c.nextId();u.$registerTextEditorDecorationType(b.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$JO=m;class d{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let f=null;if(u instanceof R.$lM)f=new R.$mM(u,u);else if(u instanceof R.$mM)f=u;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(u,b){this.k(),this.l(new R.$mM(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof R.$mM)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,f){const r=this.c.validateRange(u);this.g.push({range:r,text:b,forceMoveMarkers:f})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=u}}class k{constructor(u,b,f,r){this.c=u,this.d=b,this._accept(f),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}n(u){const b=this.m(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}p(u){const b=this.o(u);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const b=this.q(u);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let f=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(f=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,b.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(f=!0,b.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,b.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(f=!0,b.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,b.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,f=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,f=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(u,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(f)})}}e.$KO=k;class O{constructor(u,b,f,r,o,s,n,i){this.id=u,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,s,f),this.e=n,this.f=i;const a=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new F.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof R.$nM))throw(0,F.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof R.$nM)))throw(0,F.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new F.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new F.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new d(r.value,t);return h(v),a.m(v)},insertSnippet(h,t,v={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>N.Range.from($));else if(t instanceof R.$lM){const{lineNumber:$,column:w}=N.Position.from(t);c=[{startLineNumber:$,startColumn:w,endLineNumber:$,endColumn:w}]}else if(t instanceof R.$mM)c=[N.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof R.$mM)c.push(N.Range.from($));else{const{lineNumber:w,column:p}=N.Position.from($);c.push({startLineNumber:w,startColumn:p,endLineNumber:w,endColumn:p})}}return b.$tryInsertSnippet(u,r.value.version,h.value,c,v)},setDecorations(h,t){const v=t.length===0;v&&!a.h.has(h.key)||(v?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(N.$zO(t))return b.$trySetDecorations(u,h.key,N.$AO(t));{const c=new Array(4*t.length);for(let $=0,w=t.length;$<w;$++){const p=t[$];c[4*$]=p.start.line+1,c[4*$+1]=p.start.character+1,c[4*$+2]=p.end.line+1,c[4*$+3]=p.end.character+1}return b.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>b.$tryRevealRange(u,N.Range.from(h),t||R.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(u,N.ViewColumn.from(h))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(o=>o.range);f.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=f.length-1;o<s;o++){const n=f[o].end;if(f[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$LO=O}),define(Pe[67],Me([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,39,40]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new b.$Bc,this.d=new F.$7d,this.e=new F.$7d,this.f=new F.$7d,this.g=new F.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],v=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=N.URI.revive(c),w=this.c.get($);w?.unref()&&(this.c.delete($),h.push(w.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=N.URI.revive(c.uri);let w=this.c.get($);if(w&&$.scheme!==f.Schemas.vscodeNotebookCell&&$.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);w||(w=new s(new d.$FO(this.h.getProxy(m.$iM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,w),t.push(w.value)),w.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&v.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=N.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get($).value,p=new O.$LO(c.id,this.h.getProxy(m.$iM.MainThreadTextEditors),this.i,new o.$V(()=>w.document),c.selections.map(E.Selection.to),c.options,c.visibleRanges.map(l=>E.Range.to(l)),typeof c.editorPosition=="number"?E.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,M.$Pc)(h),(0,M.$Pc)(v),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$MO=n,e.$MO=n=Je([qe(0,k.$CO),qe(1,u.$Nj)],n),e.$NO=(0,R.$hi)("IExtHostDocumentsAndEditors")}),define(Pe[280],Me([1,0,18,5,4,114,8,7]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;class d{constructor(O,E){this.i=E,this.a=new F.$7d,this.b=new F.$7d,this.c=new F.$7d,this.d=new F.$7d,this.f=new F.$7d,this.g=new F.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(M.$iM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const E=this.i.allEditors();return O?E:E.map(u=>u.value)}async showTextDocument(O,E,u){let b;typeof E=="number"?b={position:R.ViewColumn.from(E),preserveFocus:u}:typeof E=="object"?b={position:R.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?R.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(O.uri,b),r=f&&this.i.getEditor(f);if(r)return r.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,E){return new N.$JO(this.h,O,E).value}$acceptEditorPropertiesChanged(O,E){const u=this.i.getEditor(O);if(!u)throw new Error("unknown text editor");if(E.options&&u._acceptOptions(E.options),E.selections){const b=E.selections.selections.map(R.Selection.to);u._acceptSelections(b)}if(E.visibleRanges){const b=I.$Hb(E.visibleRanges.map(R.Range.to));u._acceptVisibleRanges(b)}if(E.options&&this.b.fire({textEditor:u.value,options:{...E.options,lineNumbers:R.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const b=m.TextEditorSelectionChangeKind.fromValue(E.selections.source),f=E.selections.selections.map(R.Selection.to);this.a.fire({textEditor:u.value,selections:f,kind:b})}if(E.visibleRanges){const b=I.$Hb(E.visibleRanges.map(R.Range.to));this.c.fire({textEditor:u.value,visibleRanges:b})}}$acceptEditorPositionData(O){for(const E in O){const u=this.i.getEditor(E);if(!u)throw new Error("Unknown text editor");const b=R.ViewColumn.to(O[E]);u.value.viewColumn!==b&&(u._acceptViewColumn(b),this.d.fire({textEditor:u.value,viewColumn:b}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.$5ic=d}),define(Pe[281],Me([1,0,2,3,4,6,7,8,20,16]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0,e.$Kkc=(0,F.$hi)("IExtHostTimeline");class O{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(M.$iM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&d.$Cm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(E(s))?.get(r.handle)}else return;return r}})}async $getTimeline(b,f,r,o){return this.b.get(b)?.provider.provideTimeline(I.URI.revive(f),r,o)}registerTimelineProvider(b,f,r,o){const s=new N.$Tc,n=this.d(f.id,o,s).bind(this);let i;f.onDidChange&&(i=f.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:f.id}),this));const a=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(h,t,v){t?.resetCache&&(s.clear(),a.get(f.id)?.clear());const c=await f.provideTimeline(h,t,v);if(c==null)return;const $=n(h,t);return{...c,source:f.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(f.id)?.clear();i?.dispose(),s.dispose()}},r)}d(b,f,r){return(o,s)=>{let n;if(s?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const a=E(o);n=i.get(a),n===void 0&&(n=new Map,i.set(a,n))}return i=>{const{iconPath:a,...h}=i,t=`${b}|${i.id??i.timestamp}`;n?.set(t,i);let v,c,$;i.iconPath&&(a instanceof R.$gN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(v=a,c=a):{light:v,dark:c}=a);let w;return R.$LM.isMarkdownString(h.tooltip)?w=m.MarkdownString.from(h.tooltip):(0,k.$Uf)(h.tooltip)?w=h.tooltip:R.$LM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=m.MarkdownString.from(h.detail)):(0,k.$Uf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=h.detail),{...h,id:h.id??void 0,handle:t,source:b,command:i.command?f.toInternal(i.command,r):void 0,icon:v,iconDark:c,themeIcon:$,tooltip:w,accessibilityInformation:i.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Lkc=O;function E(u){return u?.toString()}}),define(Pe[282],Me([1,0,172,24,2,5,6,210,11,7,16,18,8,53,25,136,22]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;function s(a,h){if((0,O.$Uf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class n extends R.$Uc{constructor(h,t,v){super(),this.f=h,this.g=t,this.h=v,this.a=new Map,this.b=new r.$Y9;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(w=>c(w)?this.r(w):w):$})}registerTreeDataProvider(h,t,v){const c=this.createTreeView(h,{treeDataProvider:t},v);return{dispose:()=>c.dispose()}}createTreeView(h,t,v){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,v),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:w,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$7F)(v,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$7F)(v,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(y){(0,b.$Gk)(y)&&(0,o.$7F)(v,"treeViewMarkdownMessage"),l.message=y},get title(){return l.title},set title(y){l.title=y},get description(){return l.description},set description(y){l.description=y},get badge(){return l.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?l.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(l.badge=void 0)},reveal:(y,C)=>l.reveal(y,C),dispose:async()=>{await g,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const v=this.a.get(h);return v?v.getChildren(t):Promise.reject(new m.$yF(h))}async $handleDrop(h,t,v,c,$,w,p,l){const D=this.a.get(h);if(!D)return Promise.reject(new m.$yF(h));const g=u.DataTransfer.toDataTransfer(v,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return p===h&&l&&await this.j(g,D,l,$,w),D.onDrop(g,c,$)}async j(h,t,v,c,$){const w=this.b.removeDragOperationTransfer($);if(w)(await w)?.forEach((p,l)=>{p&&h.set(l,p)});else if($&&t.handleDrag){const p=t.handleDrag(v,h,c);this.b.addDragOperationTransfer($,p),await p}return h}async $handleDrag(h,t,v,c){const $=this.a.get(h);if(!$)return Promise.reject(new m.$yF(h));const w=await this.j(new k.$cN,$,t,c,v);if(!(!w||c.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$yF(h);return t.hasResolve}$resolve(h,t,v){const c=this.a.get(h);if(!c)throw new m.$yF(h);return c.resolveTreeItem(t,v)}$setExpanded(h,t,v){const c=this.a.get(h);if(!c)throw new m.$yF(h);c.setExpanded(t,v)}$setSelectionAndFocus(h,t,v){const c=this.a.get(h);if(!c)throw new m.$yF(h);c.setSelectionAndFocus(t,v)}$setVisible(h,t){const v=this.a.get(h);if(!v){if(!t)return;throw new m.$yF(h)}v.setVisible(t)}$changeCheckboxState(h,t){const v=this.a.get(h);if(!v)throw new m.$yF(h);v.setCheckboxState(t)}m(h,t,v){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,v));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Mkc=n;class i extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,O.$4f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,v,c,$,w){if(super(),this.I=h,this.J=v,this.L=c,this.M=$,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ee,w.contributes&&w.contributes.views)for(const g in w.contributes.views)for(const S of w.contributes.views[g])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let p,l;const D=N.Event.debounce(this.F.event,(g,S)=>(g||(g={message:!1,elements:[]}),S.element!==!1&&(p||(p=new Promise(y=>l=y),this.G=this.G.then(()=>p)),Array.isArray(S.element)?g.elements.push(...S.element):g.elements.push(S.element)),S.message&&(g.message=!0),g),200,!0);this.B(D(({message:g,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=l;return p=null,this.$(S).then(()=>y())})),g&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let v=this.X(h);return v||(v=await this.Y(t)),v?v.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const v=(0,O.$4f)(t.select)?!0:t.select,c=(0,O.$4f)(t.focus)?!1:t.focus,$=(0,O.$4f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(w=>this.W(h,w[w.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:w.map(l=>l.item)},{select:v,focus:c,expand:$})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:v,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const v=this.getExtensionElement(h);v&&(t?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(h,t){const v=!(0,E.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async v=>{const c=this.getExtensionElement(v.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:v.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);t.forEach(v=>{v.treeItem.checkboxState=v.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(v=>[v.extensionItem,v.newState])})}async handleDrag(h,t,v){const c=[];for(const $ of h){const w=this.getExtensionElement($);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,v),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,v){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,d.$_g)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const v=this.j.get(h);if(v){const c=this.m.get(v);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,v,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(v=>this.W(t,v[v.length-1]).then(c=>(v.push(c),v))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$_g)(()=>this.f.getParent(h))}W(h,t){const v=this.m.get(h);return v?Promise.resolve(v):(0,d.$_g)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const w=this.m.get($);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const v=this.getExtensionElement(h);t=v?this.m.get(v):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new f.$ee(this.Z.token);try{const v=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,E.$Hb)(c||[]),w=await Promise.all((0,E.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const p=w.map((l,D)=>l?this.db($[D],l,v):null);return(0,E.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some(v=>!v))return this.Z.dispose(!0),this.Z=new f.$ee,this.tb(),this.J.$refresh(this.I);{const v=this.ab(h);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(h){const t=new Set,v=h.map($=>this.m.get($));for(const $ of v)if($&&!t.has($.item.handle)){let w=$;for(;w&&w.parent&&v.findIndex(p=>w&&w.parent&&p&&p.item.handle===w.parent.item.handle)===-1;){const p=this.j.get(w.parent.item.handle);w=p?this.m.get(p):void 0}w&&!w.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const w=this.j.get($);if(w){const p=this.m.get(w);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(v=>this.cb(v).then(c=>{c&&(t[v]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const v=this.m.get(t);if(v)return this.rb(t),(0,d.$_g)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,v.parent);return this.pb(t,$,v,v.parent),v.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,v){const c=this.ib(h,t,v);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,v),c}eb(h){return k.$LM.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,v,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,v=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:c}}hb(h){if(!k.$0M.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,v){this.hb(t);const c=this.B(new R.$Tc),$=this.kb(h,t,v),w=this.lb(t);return{item:{handle:$,parentHandle:v?v.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,O.$4f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:v,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof k.$gN?h.iconPath:void 0}kb(h,{id:t,label:v,resourceUri:c},$,w){if(t)return`${i.b}/${t}`;const p=s(v,this.N),l=$?$.item.handle:i.a;let D=p?p.label:c?(0,F.$Rg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let y,C=0;do{if(y=`${l}/${C}:${D}`,w||!this.j.has(y)||g===y)break;C++}while(C<=S.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$gN))return typeof h.iconPath=="string"||M.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$gN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return M.URI.isUri(h)?h:M.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,v,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(h,t);const $=this.X(c)||[],w=$.filter(p=>p.item.handle===v.item.handle)[0];w&&$.splice($.indexOf(w),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[283],Me([1,0,5,6,2,34,8,62,4,7]),function(me,e,I,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class O extends F.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$7d),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,M.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:R.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class E extends F.$Uc{static c(){return(0,N.$Dg)()}constructor(f,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=f.getProxy(d.$iM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,o,s,n={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$hjc)(f),t=E.c();this.f.$createWebviewPanel((0,m.$jjc)(f),t,r,{title:o,panelOptions:u(n),webviewOptions:(0,m.$kjc)(f,this.m,n),serializeBuffersForPostMessage:h},a);const v=this.j.createNewWebview(t,n,f);return this.createNewWebviewPanel(t,r,o,i,n,v,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((o,s)=>{const n=f[o],i=f[s];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const n=f[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$hjc)(f)}),new k.$kM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,o,s){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:a}=n,h=this.j.createNewWebview(f,o.webviewOptions,a),t=this.createNewWebviewPanel(f,r,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(f,r,o,s,n,i,a){const h=new O(f,this.f,i,{viewType:r,title:o,viewColumn:s,panelOptions:n,active:a});return this.g.set(f,h),h}getWebviewPanel(f){return this.g.get(f)}}e.$ljc=E;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[284],Me([1,0,5,6,62,8,4,7]),function(me,e,I,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class d extends F.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,b,f,r,o){super(),this.#s=!1,this.#u=this.B(new I.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$7d),this.onDidDispose=this.#l.event,this.#i=b,this.#a=f,this.#e=E,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(R.$iM.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,b,f){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:E}),this.a.$registerWebviewViewProvider((0,M.$jjc)(E),u,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$hjc)(E)}),new m.$kM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,b,f,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:n}=o,i=this.d.createNewWebview(E,{},n),a=new d(E,this.a,u,b,i,!0);this.c.set(E,a),await s.resolveWebviewView(a,{state:f},r)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$Pkc=k}),define(Pe[285],Me([1,0,5,30,33,3]),function(me,e,I,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.OutputChannelUpdateMode=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=void 0,e.$qL="text/x-code-output",e.$rL="output",e.$sL="Log",e.$tL="text/x-code-log-output",e.$uL="log",e.$vL="workbench.panel.output",e.$wL=new M.$yj("inOutput",!1),e.$xL=new M.$yj("activeLogOutput",!1),e.$yL=new M.$yj("activeLogOutput.levelSettable",!1),e.$zL=new M.$yj("activeLogOutput.level",""),e.$AL=new M.$yj("activeLogOutput.levelIsDefault",!1),e.$BL=new M.$yj("outputView.scrollLock",!1),e.$CL=(0,N.$hi)("outputService");var R;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$DL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new I.$7d,this.onDidRegisterChannel=this.b.event,this.c=new I.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(O=>k.push(O)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}F.$Zn.add(e.$DL.OutputChannels,new m),e.$EL=new M.$yj("activeOutputChannel","")}),define(Pe[115],Me([1,0,4,3,17,20,13,285,63,27,44,140,23,16,43,5,6]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0;class s extends R.$Tj{get disposed(){return this.n}constructor(h,t,v,c,$){super(),this.id=h,this.name=t,this.r=v,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$ue.fromString(t).byteLength,(0,R.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,v,c,$,w){this.i=t,this.j=v,this.k=c,this.l=$,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$iM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,v]of this.g)v.visible=t===this.h}createOutputChannel(h,t,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,b.$Uf)(t)?t:void 0;if((0,b.$Uf)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const p=this.i.environment.extensionLogLevel?.find(([D])=>N.$Cm.equals(v.identifier,D))?.[1];p&&(w=(0,R.$5j)(p));const l=c?this.o(h,w,v):this.n(h,$,v);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,w??this.m.getLevel(),l):this.q(h,l)}async n(h,t,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,$,t,v.identifier.value);return new s(p,h,w,this.a,v)}async o(h,t,v){const c=await this.p(v),$=h.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${$}.log`),p=`${v.identifier.value}.${$}`,l=this.l.createLogger(w,{id:p,name:h,logLevel:t,extensionId:v.identifier.value});return new n(p,h,l,this.a,v)}p(h){let t=this.d.get(h.identifier.value);if(!t){const v=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(v)}catch(c){if((0,f.$4k)(c)!==f.FileSystemProviderErrorCode.FileExists)throw c}return v})())}return t}q(h,t){let v=!1;const c=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(w=>w.append($))},appendLine($){c(),t.then(w=>w.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(w=>w.replace($))},show($,w){c(),t.then(p=>p.show($,w))},hide(){c(),t.then($=>$.hide())},dispose(){v=!0,t.then($=>$.dispose())}}}r(h,t,v){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new r.$7d);function p(l){t=l,w.fire(l)}return v.then(l=>{c.add(l),l.logLevel!==t&&p(l.logLevel),c.add(l.onDidChangeLogLevel(D=>p(D)))}),{...this.q(h,v),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(l,...D){$(),v.then(g=>g.trace(l,...D))},debug(l,...D){$(),v.then(g=>g.debug(l,...D))},info(l,...D){$(),v.then(g=>g.info(l,...D))},warn(l,...D){$(),v.then(g=>g.warn(l,...D))},error(l,...D){$(),v.then(g=>g.error(l,...D))},dispose(){c.dispose()}}}};e.$qkc=i,e.$qkc=i=Je([qe(0,M.$CO),qe(1,k.$SO),qe(2,d.$djc),qe(3,O.$Pic),qe(4,R.$Oj),qe(5,R.$Nj)],i),e.$rkc=(0,F.$hi)("IExtHostOutputService")}),define(Pe[116],Me([1,0,3,11]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$4m=(0,I.$hi)("remoteAgentService"),e.$5m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const d=await M.getRoundTripTime();if(d===void 0)return;N=Math.min(N,d/2),await(0,F.$ih)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((m,d)=>m+d,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((m,d)=>m+d,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[286],Me([1,0,175,56,30,48,47,6,5,116,21,26,11]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=void 0,e.$VI=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$WI=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$XI=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$YI=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$ZI={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new d.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new b;M.$Zn.add(e.$ZI.ConfigurationMigration,f);let r=class extends m.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(a=>this.g(a,n?.uri))])}async g(n,i){const a=this.a.inspect(n.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,v]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const w=await this.h(n,t,c.value,i,void 0);for(const p of w??[])$.push([p,[]])}for(const{identifiers:w,value:p}of c.overrides??[])if(p!==void 0){const l=await this.h(n,t,p,i,w);for(const D of l??[])$.push([D,w])}$.length&&await Promise.allSettled($.map(async([[w,p],l])=>this.a.updateValue(w,p.value,{resource:i,overrideIdentifiers:l},v)))}}async h(n,i,a,h,t){const v=$=>{const p=this.a.inspect($,{resource:h})[i];if(p)return t?p.overrides?.find(({identifiers:l})=>(0,E.$Rn)(l,t))?.value:p.value},c=await n.migrateFn(a,v);return Array.isArray(c)?c:[[n.key,c]]}};e.$1I=r,e.$1I=r=Je([qe(0,R.$Ni),qe(1,N.$qi)],r);let o=class extends m.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Eh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!O.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$Zn.as(F.$5n.Configuration).registerConfiguration({...e.$XI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$2I=o,e.$2I=o=Je([qe(0,k.$4m)],o)}),define(Pe[287],Me([1,0,35,12,19,24,183,286,56,3,30]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$mfb=e.$lfb=void 0,e.$nfb=r,e.$ofb=o,e.$lfb=(0,k.$hi)("editorResolverService"),e.$mfb="workbench.editorAssociations";const E=O.$Zn.as(d.$5n.Configuration),u={...m.$WI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var b;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(b||(e.RegisteredEditorPriority=b={}));var f;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(s){switch(s){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(s,n){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(M.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$Rg)(n);return I.$ak(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Pe[288],Me([1,0,46,12,19,21,24,2,3,204,48,224,116]),function(me,e,I,F,M,N,R,m,d,k,O,E,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0,e.$WL=(0,d.$hi)("pathService");let f=b=class{constructor(o,s,n,i){this.d=o,this.e=s,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===F.Schemas.file||o.scheme===F.Schemas.vscodeRemote?(0,I.$fg)(n??(0,R.$Rg)(o),s===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return F.Schemas.vscodeRemote;const n=(0,k.$TL)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:F.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?M.$gc:M.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:F.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$XL=f,e.$XL=f=b=Je([qe(1,u.$4m),qe(2,E.$FL),qe(3,O.$qi)],f)}),define(Pe[117],Me([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$qK=e.$pK=void 0;class I{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new I(0,0)}with(R){return new I(0,0)}}e.$pK=I;class F{constructor(R,m,d,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,m),this.end=new I(d,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$qK=F;var M;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Pe[45],Me([1,0,18,35,26,46,15,3,19,14,117,11]),function(me,e,I,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$NK=e.$GK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$DK=e.$CK=e.$BK=e.$AK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TextSearchCompleteMessageType=void 0,e.$xK=s,e.$yK=n,e.$zK=i,e.$EK=l,e.$FK=D,e.$HK=y,e.$IK=C,e.$JK=A,e.$KK=G,e.$LK=T,e.$MK=W,e.$OK=L,e.$QK=le,e.$RK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.$rK="workbench.view.search",e.$sK="workbench.panel.search",e.$tK="workbench.view.search",e.$uK="search-result",e.$vK="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",f=(u.length+b.length+5)*2;e.$wK=(0,m.$hi)("searchService");var r;(function(he){he[he.file=0]="file",he[he.text=1]="text",he[he.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(he){he[he.File=1]="File",he[he.Text=2]="Text",he[he.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(he){return!!he.preview}function n(he){return!!he.resource}function i(he){return!!he.message}var a;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor(be){this.resource=be,this.results=[]}}e.$AK=h;class t{constructor(be,ee,pe,re){this.ranges=ee,this.webviewIndex=re;const fe=Array.isArray(ee)?ee:[ee];if(pe&&pe.matchLines===1&&v(fe)){be=(0,R.$Nf)(be,pe.matchLines);let V="",te=0,ke=0;const Te=Math.floor(pe.charsPerLine/5),Ie=[];for(const ve of fe){const ge=Math.max(ve.startColumn-Te,0),J=ve.startColumn+pe.charsPerLine;if(ge>ke+Te+f){const Y=u+(ge-ke)+b;V+=Y+be.slice(ge,J),te+=ge-(ke+Y.length)}else V+=be.slice(ke,J);Ie.push(new $(0,ve.startColumn-te,ve.endColumn-te)),ke=J}this.preview={text:V,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const V=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:be,matches:(0,I.$2b)(ee,te=>new c(te.startLineNumber-V,te.startColumn,te.endLineNumber-V,te.endColumn))}}}}e.$BK=t;function v(he){const be=he[0].startLineNumber;for(const ee of he)if(ee.startLineNumber!==be||ee.endLineNumber!==be)return!1;return!0}class c{constructor(be,ee,pe,re){this.startLineNumber=be,this.startColumn=ee,this.endLineNumber=pe,this.endColumn=re}}e.$CK=c;class $ extends c{constructor(be,ee,pe){super(be,ee,be,pe)}}e.$DK=$;var w;(function(he){he.List="list",he.Tree="tree"})(w||(e.ViewMode=w={}));var p;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function l(he,be=!0){const ee=he&&he.files&&he.files.exclude,pe=be&&he&&he.search&&he.search.exclude;if(!ee&&!pe)return;if(!ee||!pe)return ee||pe;let re=Object.create(null);return re=M.$Qn(re,M.$Nn(ee)),re=M.$Qn(re,M.$Nn(pe),!0),re}function D(he,be){return he.excludePattern&&F.$ak(he.excludePattern,be)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&F.$ak(he.includePattern,be)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(ee=>{const pe=ee.folder.fsPath;if(N.$hg(be,pe)){const re=d.$mc(pe,be);return!ee.includePattern||!!F.$ak(ee.includePattern,re)}else return!1}):!1:!0}var g;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class S extends Error{constructor(be,ee){super(be),this.code=ee}}e.$GK=S;function y(he){const be=he.message;if((0,k.$4)(he))return new S(be,g.canceled);try{const ee=JSON.parse(be);return new S(ee.message,ee.code)}catch{return new S(be,g.other)}}function C(he){const be={message:he.message,code:he.code};return new Error(JSON.stringify(be))}function A(he){return he.type==="error"?!0:he.type==="success"}function G(he){return he.type==="success"}function T(he){return!!he.path}function W(he,be,ee=!0){const pe=he.searchPath?he.searchPath:he.relativePath;return ee?(0,R.$Kf)(pe,be):F.$ak(be,pe)}class P{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$NK=P;function L(he,be){const ee={...he||{},...be||{}};return Object.keys(ee).filter(pe=>{const re=ee[pe];return typeof re=="boolean"&&re})}class K{constructor(be,ee){this.c=null,this.a={...be.excludePattern||{},...ee.excludePattern||{}},this.b=F.$bk(this.a);let pe=be.includePattern;ee.includePattern&&(pe?pe={...pe,...ee.includePattern}:pe=ee.includePattern),pe&&(this.c=F.$bk(pe))}matchesExcludesSync(be,ee,pe){return!!(this.b&&this.b(be,ee,pe))}includedInQuerySync(be,ee,pe){return!(this.b&&this.b(be,ee,pe)||this.c&&!this.c(be,ee,pe))}includedInQuery(be,ee,pe){const re=this.b(be,ee,pe),fe=()=>this.c?!!this.c(be,ee,pe):!0;return(0,E.$6g)(re)?re.then(V=>V?!1:fe()):fe()}hasSiblingExcludeClauses(){return ne(this.a)}}e.$PK=K;function ne(he){for(const be in he)if(typeof he[be]!="boolean")return!0;return!1}function le(he){if(!he)return;let be;return ee=>(be||(be=(he()||Promise.resolve([])).then(pe=>pe?Se(pe):{})),be.then(pe=>!!pe[ee]))}function ye(he){if(!he)return;let be;return ee=>{if(!be){const pe=he();be=pe?Se(pe):{}}return!!be[ee]}}function Se(he){const be={};for(const ee of he)be[ee]=!0;return be}}),define(Pe[36],Me([1,0,18,11,25,5,6,51,12,125,24,15,2,174,3,13,193,48,44,27,17,8,7,59,45,4,52]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=void 0;function p(G,T,W){return new O.$Jg(P=>S(P,W)).isEqual(G,T)}function l(G,T,W){return p(G.uri,T.uri,W)?0:(0,E.$ef)(G.uri.toString(),T.uri.toString())}function D(G,T,W){return G.index!==T.index?G.index<T.index?-1:1:p(G.uri,T.uri,W)?(0,E.$ef)(G.name,T.name):(0,E.$ef)(G.uri.toString(),T.uri.toString())}function g(G,T,W,P){const L=G.slice(0).sort((ne,le)=>W(ne,le,P)),K=T.slice(0).sort((ne,le)=>W(ne,le,P));return(0,I.$Eb)(L,K,(ne,le)=>W(ne,le,P))}function S(G,T){const W=T.getCapabilities(G.scheme);return!(W&&W&1024)}class y extends s.$Ai{static toExtHostWorkspace(T,W,P,L){if(!T)return{workspace:null,added:[],removed:[]};const{id:K,name:ne,folders:le,configuration:ye,transient:Se,isUntitled:he}=T,be=[],ee=W;W?le.forEach((V,te)=>{const ke=u.URI.revive(V.uri),Te=y.o(P||W,ke,L);Te?(Te.name=V.name,Te.index=V.index,be.push(Te)):be.push({uri:ke,name:V.name,index:te})}):be.push(...le.map(({uri:V,name:te,index:ke})=>({uri:u.URI.revive(V),name:te,index:ke}))),be.sort((V,te)=>V.index<te.index?-1:1);const pe=new y(K,ne,be,!!Se,ye?u.URI.revive(ye):null,!!he,V=>S(V,L)),{added:re,removed:fe}=g(ee?ee.workspaceFolders:[],pe.workspaceFolders,l,L);return{workspace:pe,added:re,removed:fe}}static o(T,W,P){for(let L=0;L<T.folders.length;L++){const K=T.workspaceFolders[L];if(p(K.uri,W,P))return K}}constructor(T,W,P,L,K,ne,le){super(T,P.map(ye=>new s.$Bi(ye)),L,K,le),this.t=W,this.u=ne,this.q=[],this.s=m.$ni.forUris(le),P.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,W){return W&&this.s.get(T)&&(T=(0,O.$Tg)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let C=class{constructor(T,W,P,L,K){this.c=new N.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$9d,this.C=new Map,this.h=L,this.s=P,this.t=K,this.j=new k.$om,this.k=new F.$gh,this.o=T.getProxy($.$iM.MainThreadWorkspace),this.q=T.getProxy($.$iM.MainThreadMessageService);const ne=W.workspace;this.l=ne?new y(ne.id,ne.name,[],!!ne.transient,ne.configuration?u.URI.revive(ne.configuration):null,!!ne.isUntitled,le=>S(le,P)):void 0}$initializeWorkspace(T,W){this.v=W,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:d.Schemas.untitled,path:(0,O.$Rg)((0,O.$Tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,W,P,...L){const K=[];if(Array.isArray(L)&&L.forEach(he=>{u.URI.isUri(he.uri)&&!K.some(be=>p(be.uri,he.uri,this.s))&&K.push({uri:he.uri,name:he.name||(0,O.$Qg)(he.uri)})}),this.n||[W,P].some(he=>typeof he!="number"||he<0)||P===0&&K.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(W+P>ne.length)return!1;const le=ne.slice(0);le.splice(W,P,...K.map(he=>({uri:he.uri,name:he.name||(0,O.$Qg)(he.uri),index:void 0})));for(let he=0;he<le.length;he++){const be=le[he];if(le.some((ee,pe)=>pe!==he&&p(be.uri,ee.uri,this.s)))return!1}le.forEach((he,be)=>he.index=be);const{added:ye,removed:Se}=g(ne,le,D,this.s);if(ye.length===0&&Se.length===0)return!1;if(this.o){const he=T.displayName||T.name;this.o.$updateWorkspaceFolders(he,W,P,K).then(void 0,be=>{this.n=void 0;const ee={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(o.Severity.Error,(0,b.localize)(0,null,he,be.toString()),ee,[])})}return this.y(le),!0}getWorkspaceFolder(T,W){if(this.x)return this.x.getWorkspaceFolder(T,W)}async getWorkspaceFolder2(T,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,W)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,W){let P,L="";if(typeof T=="string"?(P=u.URI.file(T),L=T):typeof T<"u"&&(P=T,L=T.fsPath),!P)return L;const K=this.getWorkspaceFolder(P,!0);if(!K)return L;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ne=(0,O.$Wg)(K.uri,P);return W&&K.name&&(ne=`${K.name}/${ne}`),ne}y(T){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:W,added:P,removed:L}=y.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:L}))}findFiles(T,W,P,L,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let ne="",le=!0;return W===null?le=!1:W!==void 0&&(typeof W=="string"?ne=W:ne=W.pattern),this.z(T,void 0,{exclude:ne,maxResults:P,useDefaultExcludes:le,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(T,W={},P,L=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${P.value}, entryPoint: findFiles2`),this.z(void 0,T,W,L)}async z(T,W,P,L=M.CancellationToken.None){if(L&&L.isCancellationRequested)return Promise.resolve([]);const K=typeof P.exclude=="string"?P.exclude:P.exclude?P.exclude.pattern:void 0,ne={ignoreSymlinks:typeof P.followSymlinks=="boolean"?!P.followSymlinks:void 0,disregardIgnoreFiles:typeof P.useIgnoreFiles=="boolean"?!P.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof P.useGlobalIgnoreFiles=="boolean"?!P.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof P.useParentIgnoreFiles=="boolean"?!P.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof P.useDefaultExcludes=="boolean"?!P.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof P.useDefaultSearchExcludes=="boolean"?!P.useDefaultSearchExcludes:!1,maxResults:P.maxResults,excludePattern:K,shouldGlobSearch:typeof P.fuzzy=="boolean"?!P.fuzzy:!0,_reason:"startFileSearch"};let le;if(T){const{includePattern:ye,folder:Se}=A(h.GlobPattern.from(T));le=Se,ne.includePattern=ye}else{const{includePattern:ye,folder:Se}=A(h.GlobPattern.from(W));le=Se,ne.filePattern=ye}return this.o.$startFileSearch(le??null,ne,L).then(ye=>Array.isArray(ye)?ye.map(Se=>u.URI.revive(Se)):[])}async findTextInFiles(T,W,P,L,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),le=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:ye,folder:Se}=A(h.GlobPattern.from(W.include)),he=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,be={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:le,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:ye,excludePattern:he},ee=!1;if(this.u[ne]=pe=>{if(ee)return;const re=u.URI.revive(pe.resource);pe.results.forEach(fe=>{const V=(0,w.$Qh)(fe);(0,c.$xK)(V)?P({uri:re,preview:{text:V.preview.text,matches:(0,I.$2b)(V.preview.matches,te=>new t.$mM(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,I.$2b)(V.ranges,te=>new t.$mM(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):P({uri:re,text:V.text,lineNumber:V.lineNumber})})},K.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(T,Se??null,be,ne,K);return delete this.u[ne],pe||{}}catch(pe){throw delete this.u[ne],pe}}$handleTextSearchResult(T,W){this.u[W]?.(T)}async save(T){const W=await this.o.$save(T,{saveAs:!1});return u.URI.revive(W)}async saveAs(T){const W=await this.o.$save(T,{saveAs:!0});return u.URI.revive(W)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,W){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,W);const P=this.t.transformOutgoingScheme(T),L=this.A++;return this.o.$registerEditSessionIdentityProvider(L,P),(0,R.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(T,W){this.h.info("Getting edit session identifier for workspaceFolder",T);const P=await this.resolveWorkspaceFolder(u.URI.revive(T));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const L=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!L),!L)return;const K=await L.provideEditSessionIdentity(P,W);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(T,W,P,L){this.h.info("Getting edit session identifier for workspaceFolder",T);const K=await this.resolveWorkspaceFolder(u.URI.revive(T));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ne=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ne),!ne)return;const le=await ne.provideEditSessionIdentityMatch?.(W,P,L);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(T){return(W,P,L)=>{const K=function(le){W.call(P,le)};return K.extension=T,this.B.event(K,void 0,L)}}async $onWillCreateEditSessionIdentity(T,W,P){const L=await this.resolveWorkspaceFolder(u.URI.revive(T));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:L},W,async(K,ne)=>{const le=Date.now();await Promise.resolve(K),Date.now()-le>P&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(T,W){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,W);const P=this.t.transformOutgoingScheme(T),L=this.A++;return this.o.$registerCanonicalUriProvider(L,P),(0,R.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(T,W,P){const L=this.C.get(T.scheme);if(!L)return;const K=await L.provideCanonicalUri?.(u.URI.revive(T),W,P);if(K)return K}async $provideCanonicalUri(T,W,P){return this.provideCanonicalUri(u.URI.revive(T),{targetScheme:W},P)}};e.$0ic=C,e.$0ic=C=Je([qe(0,a.$CO),qe(1,i.$SO),qe(2,n.$Pic),qe(3,r.$Nj),qe(4,v.$8ic)],C),e.$$ic=(0,f.$hi)("IExtHostWorkspace");function A(G){let T,W;return G&&(typeof G=="string"?T=G:(T=G.pattern,W=u.URI.revive(G.baseUri))),{includePattern:T,folder:W}}}),define(Pe[37],Me([1,0,26,5,36,4,7,195,56,16,11,3,17,13,2]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=e.$ajc=e.$_ic=void 0;function r(v,c){if(c){const $=c.split(".");let w=v;for(let p=0;w&&p<$.length;p++)w=w[$[p]];return w}}function o(v){return v instanceof f.URI}function s(v){return v&&v.uri instanceof f.URI&&v.languageId&&typeof v.languageId=="string"}function n(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&v.uri instanceof f.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(o(v))return{resource:v};if(s(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(n(v))return{overrideIdentifier:v.languageId};if(i(v))return{resource:v.uri};if(v===null)return{resource:null}}let h=class{constructor(c,$,w){this.a=c.getProxy(N.$iM.MainThreadConfiguration),this.c=$,this.b=w,this.d=new O.$gh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,$))}};e.$_ic=h,e.$_ic=h=Je([qe(0,u.$CO),qe(1,M.$$ic),qe(2,b.$Nj)],h);class t{constructor(c,$,w,p){this.a=new F.$7d,this.b=c,this.f=p,this.c=$,this.e=m.$lo.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$lo.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,w))}getConfiguration(c,$,w){const p=a($)||{},l=this.g(c?r(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,w?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(S){return typeof r(l,S)<"u"},get:(S,y)=>{this.h(c?`${c}.${S}`:S,p,w?.identifier);let C=r(l,S);if(typeof C>"u")C=y;else{let A;const G=(T,W)=>{if((0,k.$Wf)(T)){let P;const L=()=>{A=A||(0,I.$Nn)(l),P=P||r(A,W)};return new Proxy(T,{get:(K,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return L(),()=>P;if(A)return P=P||r(A,W),P[ne];const le=K[ne];return typeof ne=="string"?G(le,`${W}.${ne}`):le},set:(K,ne,le)=>(L(),P&&(P[ne]=le),!0),deleteProperty:(K,ne)=>(L(),P&&delete P[ne],!0),defineProperty:(K,ne,le)=>(L(),P&&Object.defineProperty(P,ne,le),!0)})}return Array.isArray(T)?(0,I.$Nn)(T):T};C=G(C,S)}return C},update:(S,y,C,A)=>{S=c?`${c}.${S}`:S;const G=D(C);return y!==void 0?this.b.$updateConfigurationOption(G,S,y,p,A):this.b.$removeConfigurationOption(G,S,p,A)},inspect:S=>{S=c?`${c}.${S}`:S;const y=this.e.inspect(S,p,this.c.workspace);if(y)return{key:S,defaultValue:(0,I.$Nn)(y.policy?.value??y.default?.value),globalValue:(0,I.$Nn)(y.user?.value??y.application?.value),workspaceValue:(0,I.$Nn)(y.workspace?.value),workspaceFolderValue:(0,I.$Nn)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$Nn)(y.default?.override),globalLanguageValue:(0,I.$Nn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$Nn)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$Nn)(y.workspaceFolder?.override),languageIds:(0,I.$Nn)(y.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Qn)(g,l,!1),Object.freeze(g)}g(c){const $=w=>(0,k.$Wf)(w)?new Proxy(w,{get:(p,l)=>$(p[l]),set:(p,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(p,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(p,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return $(c)}h(c,$,w){const p=d.$co.test(c)?4:this.d.get(c),l=w?`[${w.value}] `:"";if(p===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const w=new m.$no(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,l)=>w.affectsConfiguration(p,a(l))})}k(c){return c.reduce(($,w)=>($.set(w[0],w[1]),$),new Map)}}e.$ajc=t,e.$bjc=(0,E.$hi)("IExtHostConfiguration")}),define(Pe[118],Me([1,0,2,11,5,4,7,36,67,37,25,66,17,27,3,12,21,13,78,229,14]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=e.$Dkc=e.$Ckc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function T(P){if(P!=null)return P}G.from=T;function W(P){if(P!=null)return P}G.to=W})(h||(h={}));var t;(function(G){function T(P){if(P!=null)return P}G.from=T;function W(P){if(P!=null)return P}G.to=W})(t||(t={}));var v;(function(G){function T(P){if(P!=null)return P}G.from=T;function W(P){if(P!=null)return P}G.to=W})(v||(v={}));var c;(function(G){function T(L){if(L){const K=L;return K&&!!K.process}else return!1}G.is=T;function W(L){if(L==null)return;const K={process:L.process,args:L.args};return L.options&&(K.options=v.from(L.options)),K}G.from=W;function P(L){if(L!=null)return new R.$6M(L.process,L.args,L.options)}G.to=P})(c||(c={}));var $;(function(G){function T(P){if(P!=null)return P}G.from=T;function W(P){if(P!=null)return P}G.to=W})($||($={}));var w;(function(G){function T(L){if(L){const K=L;return K&&(!!K.commandLine||!!K.command)}else return!1}G.is=T;function W(L){if(L==null)return;const K={};return L.commandLine!==void 0?K.commandLine=L.commandLine:(K.command=L.command,K.args=L.args),L.options&&(K.options=$.from(L.options)),K}G.from=W;function P(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new R.$7M(L.commandLine,L.options):new R.$7M(L.command,L.args?L.args:[],L.options)}G.to=P})(w||(w={}));var p;(function(G){function T(L){if(L){const K=L;return K&&K.customExecution==="customExecution"}else return!1}G.is=T;function W(L){return{customExecution:"customExecution"}}G.from=W;function P(L,K){return K.get(L)}G.to=P})(p||(e.CustomExecutionDTO=p={}));var l;(function(G){function T(W,P){let L;return W.scope!==void 0&&typeof W.scope!="number"?L=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?L=P.workspaceFile:L=i.$qH),{id:W._id,workspaceFolder:L}}G.from=T})(l||(e.TaskHandleDTO=l={}));var D;(function(G){function T(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}G.from=T})(D||(D={}));var g;(function(G){function T(L,K){if(L==null)return[];const ne=[];for(const le of L){const ye=W(le,K);ye&&ne.push(ye)}return ne}G.fromMany=T;function W(L,K){if(L==null)return;let ne;L.execution instanceof R.$6M?ne=c.from(L.execution):L.execution instanceof R.$7M?ne=w.from(L.execution):L.execution&&L.execution instanceof R.$8M&&(ne=p.from(L.execution));const le=h.from(L.definition);let ye;return L.scope?typeof L.scope=="number"?ye=L.scope:ye=L.scope.uri:ye=R.TaskScope.Workspace,!le||!ye?void 0:{_id:L._id,definition:le,name:L.name,source:{extensionId:K.identifier.value,label:L.source,scope:ye},execution:ne,isBackground:L.isBackground,group:D.from(L.group),presentationOptions:t.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}G.from=W;async function P(L,K,ne){if(L==null)return;let le;c.is(L.execution)?le=c.to(L.execution):w.is(L.execution)?le=w.to(L.execution):p.is(L.execution)&&(le=p.to(L._id,ne));const ye=h.to(L.definition);let Se;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?Se=L.source.scope:Se=await K.resolveWorkspaceFolder(I.URI.revive(L.source.scope)):Se=R.TaskScope.Workspace),!ye||!Se)return;const he=new R.$9M(ye,Se,L.name,L.source.label,le,L.problemMatchers);return L.isBackground!==void 0&&(he.isBackground=L.isBackground),L.group!==void 0&&(he.group=R.$5M.from(L.group._id),he.group&&L.group.isDefault&&(he.group=new R.$5M(he.group.id,he.group.label),L.group.isDefault===!0&&(he.group.isDefault=L.group.isDefault))),L.presentationOptions&&(he.presentationOptions=t.to(L.presentationOptions)),L._id&&(he._id=L._id),L.detail&&(he.detail=L.detail),he}G.to=P})(g||(e.TaskDTO=g={}));var S;(function(G){function T(P){return P}G.from=T;function W(P){if(P)return Object.assign(Object.create(null),P)}G.to=W})(S||(S={}));class y{#e;constructor(T,W,P){this._id=W,this.a=P,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let C=class{constructor(T,W,P,L,K,ne,le,ye){this.q=new M.$7d,this.r=new M.$7d,this.s=new M.$7d,this.u=new M.$7d,this.a=T.getProxy(N.$iM.MainThreadTask),this.b=P,this.c=L,this.d=K,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,W,P){if(!P)return new R.$kM(()=>{});const L=this.x();return this.j.set(L,{type:W,provider:P,extension:T}),this.a.$registerTaskProvider(L,W),new R.$kM(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(T,W){this.a.$registerTaskSystem(T,W)}fetchTasks(T){return this.a.$fetchTasks(S.from(T)).then(async W=>{const P=[];for(const L of W){const K=await g.to(L,this.b,this.m);K&&P.push(K)}return P})}get taskExecutions(){const T=[];return this.k.forEach(W=>T.push(W)),T}terminateTask(T){if(!(T instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,W,P){const L=this.m.get(T.id);L&&(this.o.set(T.id,L),this.e.attachPtyToTerminal(W,await L.callback(P))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const W=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const W=await this.z(T.id);this.s.fire({execution:W,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const W=await this.z(T.id);this.u.fire({execution:W,exitCode:T.exitCode})}$provideTasks(T,W){const P=this.j.get(T);if(!P)return Promise.reject(new Error("no handler found"));const L=[],K=(0,F.$_g)(()=>P.provider.provideTasks(O.CancellationToken.None)).then(ne=>this.v(W,L,P,ne));return new Promise(ne=>{K.then(le=>{Promise.all(L).then(()=>{ne(le)})})})}async $resolveTask(T,W){const P=this.j.get(T);if(!P)return Promise.reject(new Error("no handler found"));if(W.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${P.type}].`);const L=await g.to(W,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const K=await P.provider.resolveTask(L,O.CancellationToken.None);if(!K)return;this.A(K,P);const ne=g.from(K,P.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ne.execution)&&await this.y(ne,K,!0),await this.w(ne)}x(){return this.h++}async y(T,W,P){const L=await this.a.$createTaskId(T);!P&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,W.execution)),this.m.set(L,W.execution)}async z(T,W){if(typeof T=="string"){const K=this.l.get(T);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const P=this.l.get(T.id);if(P)return P;let L;return W?L=Promise.resolve(new y(this,T.id,W)):L=g.to(T.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,T.id,K)}),this.l.set(T.id,L),L.then(K=>(this.k.set(T.id,K),K))}A(T,W){T._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const P=this.n.values();let L=P.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=P.next()}};e.$Ckc=C,e.$Ckc=C=Je([qe(0,u.$CO),qe(1,b.$SO),qe(2,m.$$ic),qe(3,d.$NO),qe(4,k.$bjc),qe(5,E.$zjc),qe(6,s.$Nj),qe(7,n.$Lic)],C);let A=class extends C{constructor(T,W,P,L,K,ne,le,ye){super(T,W,P,L,K,ne,le,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(T,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const P=g.from(W,T);if(P===void 0)throw new Error("Task is not valid");if(p.is(P.execution))await this.y(P,W,!1);else throw new a.$_;const L=await this.z(await this.a.$getTaskExecution(P),W);return this.a.$executeTask(P).catch(K=>{throw new Error(K)}),L}v(T,W,P,L){const K=[];if(L)for(const ne of L){if(this.A(ne,P),!ne.definition||!T[ne.definition.type]){const ye=ne.source?ne.source:"No task source";this.f.warn(`The task [${ye}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=g.from(ne,P.extension);le&&p.is(le.execution)?(K.push(le),W.push(this.y(le,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:P.extension}}async w(T){if(p.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,W,P){}};e.$Dkc=A,e.$Dkc=A=Je([qe(0,u.$CO),qe(1,b.$SO),qe(2,m.$$ic),qe(3,d.$NO),qe(4,k.$bjc),qe(5,E.$zjc),qe(6,s.$Nj),qe(7,n.$Lic)],A),e.$Ekc=(0,f.$hi)("IExtHostTask")}),define(Pe[289],Me([1,0,45,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=void 0,e.$XK=M,e.$ZK=N;function M(R){return"cellResults"in R}e.$YK="rawCell#";function N(R,m){let d=-1;const k=[];let O=[];return R.forEach(u=>{u.range.startLineNumber!==d&&O.length>0&&(k.push([...O]),O=[]),O.push(u),d=u.range.endLineNumber}),O.length>0&&k.push([...O]),k.map(u=>{const b=[],f=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=f;o<=r;o++)b.push(m.getLineContent(o));return new I.$BK(b.join(`
`)+`
`,u.map(o=>new F.$bt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[290],Me([1,0,168,23,5,6,28,15,16,2,43,74,4,31,8,7,50,265,112,26,12,219,289,287]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,p,l,D,g,S){this.q=l,this.r=D,this.s=g,this.t=S,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new M.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$Jic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(u.$iM.MainThreadNotebook),this.c=w.getProxy(u.$iM.MainThreadNotebookDocuments),this.d=w.getProxy(u.$iM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,A=y.cell.handle,T=this.g.get(C)?.getCell(A);if(T)return T.apiCell}if(y&&y.$mid===14){const C=y.uri,A=this.g.get(C);if(A)return A.apiNotebook}return y}}),c.B(p)}getEditorById(w){const p=this.h.get(w);if(!p)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(w){for(const[p,l]of this.h)if(l.apiEditor===w)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,p){const l=this.g.get(w);if(!l&&!p)throw new Error(`NO notebook document for '${w}'`);return l}static u(w,p){if(!p)return;const l=p.filenamePattern.map(D=>f.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:p.displayName,filenamePattern:l,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,p,l){const D=c.a++,g=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,g,p);let S;return g!==void 0&&(S=l.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new r.$kM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,g),S?.dispose()})}async createNotebookDocument(w){const p=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return k.URI.revive(p)}async openNotebookDocument(w){const p=this.g.get(w);if(p)return p.apiNotebook;const l=await this.c.$tryOpenNotebook(w),D=this.g.get(k.URI.revive(l));return(0,d.$6f)(D?.apiNotebook)}async showNotebookDocument(w,p){k.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let l;typeof p=="object"?l={position:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(f.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,l),g=D&&this.h.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,p,l,D){const g=this.f.get(w),S=k.URI.revive(p),y=this.g.get(S);if(!y||!g)return;const C=y.getCellFromIndex(l);if(!C)return;const A=await g.provideCellStatusBarItems(C.apiCell,D);if(!A)return;const G=new N.$Tc,T=this.p.add([G]),P=(Array.isArray(A)?A:[A]).map(L=>f.NotebookStatusBarItem.from(L,this.i,G));return{cacheId:T,items:P}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,p,l,D,g){if((0,m.$Ue)(p))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:p,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:w.identifier,location:w.extensionLocation},p,f.NotebookDocumentContentOptions.from(D),c.u(w,g)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(w,p,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(p.buffer,l);return new o.$dw(f.NotebookData.from(g))}async $notebookToData(w,p,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(f.NotebookData.to(p.value),l);return F.$ue.wrap(g)}async $saveNotebook(w,p,l,D,g){const S=k.URI.revive(p),y=this.x.get(w);if(!y)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new O.$9k((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const A={metadata:(0,i.$Vn)(C.apiNotebook.metadata,L=>!(y.options?.transientDocumentMetadata??{})[L]),cells:[]};for(const L of C.apiNotebook.getCells()){const K=new r.$MN(L.kind,L.document.getText(),L.document.languageId,L.mime,y.options?.transientOutputs?[]:[...L.outputs],L.metadata,L.executionSummary);K.metadata=(0,i.$Vn)(L.metadata,ne=>!(y.options?.transientCellMetadata??{})[ne]),A.cells.push(K)}const G=await y.serializer.serializeNotebook(A,g);await this.s.value.writeFile(S,G);const T=this.s.getFileSystemProviderExtUri(S.scheme),W=await this.s.value.stat(S);return{name:T.basename(S),isFile:(W.type&O.FileType.File)!==0,isDirectory:(W.type&O.FileType.Directory)!==0,isSymbolicLink:(W.type&O.FileType.SymbolicLink)!==0,mtime:W.mtime,ctime:W.ctime,size:W.size,readonly:!!((W.permissions??0)&O.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((W.permissions??0)&O.FilePermission.Locked),etag:O.$hl({mtime:W.mtime,size:W.size}),children:void 0}}async $searchInNotebooks(w,p,l,D,g){const S=this.x.get(w)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new R.$Cc;await(async(W,P,L)=>{await Promise.all(W.map(async K=>await Promise.all(K.filenamePatterns.map(ne=>{const le={_reason:L._reason,folderQueries:L.folderQueries,includePattern:L.includePattern,excludePattern:L.excludePattern,maxResults:L.maxResults,type:1,filePattern:ne};return this.t.doInternalFileSearchWithCustomCallback(le,P,ye=>{ye.forEach(Se=>{y.has(Se)||D.some(be=>K.isFromSettings&&!be.isFromSettings?!1:be.filenamePatterns.some(ee=>(0,v.$ofb)(ee,Se)))||y.add(Se)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(l,g,p);const A=new R.$Bc;let G=!1;const T=Array.from(y).map(async W=>{const P=[];try{if(g.isCancellationRequested)return;if(p.maxResults&&[...A.values()].reduce((le,ye)=>le+ye.cellResults.length,0)>p.maxResults){G=!0;return}const L=[],K=this.g.get(W);if(K)K.apiNotebook.getCells().forEach(ye=>L.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Se=>Se.items.map(he=>he.data.toString()))}));else{const le=await this.s.value.readFile(W),ye=F.$ue.fromString(le.toString()),Se=await S.deserializeNotebook(ye.buffer,g);if(g.isCancellationRequested)return;f.NotebookData.from(Se).cells.forEach(be=>L.push({input:be.source,outputs:be.outputs.flatMap(ee=>ee.items.map(pe=>pe.valueBytes.toString()))}))}if(g.isCancellationRequested)return;L.forEach((le,ye)=>{const Se=p.contentPattern.pattern,he=new h.$0Tb(le.input,void 0,le.outputs),be=he.findInInputs(Se),ee=he.findInOutputs(Se),pe=ee.flatMap(re=>(0,t.$ZK)(re.matches,re.textBuffer)).map((re,fe)=>(re.webviewIndex=fe,re));if(be.length>0||ee.length>0){const re={index:ye,contentResults:(0,t.$ZK)(be,he.inputTextBuffer),webviewResults:pe};P.push(re)}});const ne={resource:W,cellResults:P};A.set(W,ne);return}catch{return}});return await Promise.all(T),{limitHit:G,results:[...A.values()]}}async y(w,p){const l=await this.s.value.stat(w);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==O.$gl&&typeof l.mtime=="number"&&typeof l.size=="number"&&p.mtime<l.mtime&&p.etag!==O.$hl({mtime:p.mtime,size:l.size}))throw new O.$9k((0,I.localize)(1,null),3,p)}z(w){return w.scheme===a.Schemas.file?w.fsPath:w.toString()}A(w,p,l){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new n.$8jc(p,this.d,w,l.visibleRanges.map(f.NotebookRange.to),l.selections.map(f.NotebookRange.to),typeof l.viewColumn=="number"?f.ViewColumn.to(l.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const l of w.value.removedDocuments){const D=k.URI.revive(l),g=this.g.get(D);g&&(g.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(g.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(w.value.addedDocuments){const l=[];for(const D of w.value.addedDocuments){const g=k.URI.revive(D.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const S=new s.$7jc(this.c,this.q,this.r,g,D);l.push(...D.cells.map(y=>s.$6jc.asModelAddData(y))),this.g.get(g)?.dispose(),this.g.set(g,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(w.value.addedEditors)for(const l of w.value.addedEditors){if(this.h.has(l.id))return;const D=k.URI.revive(l.documentUri),g=this.g.get(D);g&&this.A(g,l.id,l)}const p=[];if(w.value.removedEditors)for(const l of w.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const g=l.has(D.id);D._acceptVisibility(g)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const p=b.$1O.String.with("notebookType","A notebook type"),l=new b.$3O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new b.$1O("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>F.$ue.wrap(g))],new b.$2O("Notebook Data",g=>f.NotebookData.to(g.value))),D=new b.$3O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new b.$1O("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$dw(f.NotebookData.from(g)))],new b.$2O("Bytes",g=>g.buffer));w.registerApiCommand(l),w.registerApiCommand(D)}}e.$ekc=c}),define(Pe[291],Me([1,0,19,25,42,35,24,64,45]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class k{constructor(u,b,f){this.k=u,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&N.$bk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&N.$bk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((f,r)=>{const o=s=>{this.f++,u(s)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),i=I.$oc(n);this.j&&this.j(n,i)||this.v(o,{base:s,basename:i})}),Promise.all(b.map(s=>this.p(s,o))).then(s=>{f({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,M.$5i)(s)))})})}async p(u,b){const f=new F.$ee,r=this.q(u),o=this.r(),s=new d.$PK(this.k,u),n=!s.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=m.$3d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,f.token),h=i.elapsed(),t=m.$3d.create();return this.g&&!this.e||(a&&a.forEach(v=>{const c=I.$hc.relative(u.folder.path,v.path);if(n){const $=I.$oc(v.path);this.v(b,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,b)}),this.g&&!this.e)?null:(this.u(o,s,b),{providerTime:h,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(u){const b=(0,d.$OK)(this.k.includePattern,u.includePattern),f=(0,d.$OK)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:f,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,f,r){if(f===this.a){const s=I.$oc(this.a);this.v(r,{base:b,relativePath:this.a,basename:s})}function o(s){const n=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:b,relativePath:s,basename:n})}o(f)}u({rootEntries:u,pathToEntries:b},f,r){const o=this,s=this.a;function n(i){const a=(0,d.$RK)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const v=i[h],{relativePath:c,basename:$}=v;if(f.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const w=b[c];if(w)n(w);else{if(c===s)continue;o.v(r,v)}if(o.e)break}}n(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class O{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,f,r){const o=this.c(u.cacheKey),s=new k(u,b,o&&o.token);let n=0;const i=a=>{n+=a.length,f(a.map(h=>this.d(h)))};return this.e(s,O.a,i,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new F.$ee),this.b.get(u)}d(u){return u.relativePath?{resource:R.$Ug(u.base,u.relativePath)}:{resource:u.base}}e(u,b,f,r){const o=r.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(n.push(i),b>0&&n.length>=b&&(f(n),n=[]))};let n=[];return u.search(s).then(i=>(n.length&&f(n),o.dispose(),i),i=>(n.length&&f(n),o.dispose(),Promise.reject(i)))}}e.$9jc=O}),define(Pe[292],Me([1,0,18,260,35,96,28,12,19,24,15,16,2,95,185,47,13,48,107,288,45]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=void 0,e.$ZL=D;let h=class{constructor(S,y,C,A,G){this.a=S,this.b=y,this.c=C,this.d=A,this.e=G}text(S,y,C={}){S=this.f(S,C);const A=this.a.getValue(),G=y&&y.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(y?.map(s.$Ci),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:A.search.usePCRE2||G||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,y){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const A={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,y)&&(A.isCaseSensitive=!0),this.k(S)&&(A.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),A}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(w):w(S),y?this.parseSearchPaths(S):{pattern:v(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),A=this.g(y.excludePattern,y.expandPatterns),G=S.length>1,T=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(L=>this.q(L,y,A)):S.map(L=>this.r(L,y,A,G))).filter(L=>!!L),W={_reason:y._reason,folderQueries:T,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:A.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const L=I.$Hb(I.$Rb(this.c.groups.map(le=>le.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const K=L.filter(le=>(0,a.$FK)(W,le.fsPath)),ne=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ne)),{...W,...ne}}const P=y.extraFileResources&&y.extraFileResources.filter(L=>(0,a.$FK)(W,L.fsPath));return W.extraFileResources=P&&P.length?P:void 0,W}i(S){const y=[],C=new R.$Bc,A={};let G=!1;return S.forEach(T=>{if(T.scheme===m.Schemas.walkThrough)return;if((0,k.$Yg)(T)){const P=this.b.getWorkspaceFolder(T)?.uri??T.with({path:d.$nc(T.fsPath)});let L=C.get(P);L||(G=!0,L={folder:P,includePattern:{}},y.push(L),C.set(P,L));const K=d.$mc(P.fsPath,T.fsPath);(0,E.$6f)(L.includePattern)[K.replace(/\\/g,"/")]=!0}else T.fsPath&&(G=!0,A[T.fsPath]=!0)}),{folderQueries:y,includePattern:A,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(O.$Lf(S.pattern,!0))return!0}else if(O.$Lf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,b.$nC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=ne=>d.$jc(ne)||/^\.\.?([\/\\]|$)/.test(ne),A=(Array.isArray(S)?S:c(S)).map(ne=>{const le=this.e.resolvedUserHome;return le?(0,N.$iw)(ne,le.scheme===m.Schemas.file?le.fsPath:le.path):ne}),G=F.$K(A,ne=>y(ne)?"searchPaths":"exprSegments"),T=(G.exprSegments||[]).map(ne=>O.$6e(ne,"/")).map(ne=>O.$6e(ne,"\\")).map(ne=>(ne[0]==="."&&(ne="*"+ne),$(ne))),W={},P=this.m(G.searchPaths||[]);P&&P.length&&(W.searchPaths=P);const L=I.$Rb(T),K=v(...L);return K&&(W.pattern=K),W}l(S,y){return y.disregardExcludeSettings?void 0:(0,a.$EK)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(A=>{let{pathPortion:G,globPortion:T}=t(A);return T&&(T=p(T)),this.n(G).flatMap(P=>this.o(P,T))}),C=new Map;return y.forEach(A=>{const G=A.searchPath.toString(),T=C.get(G);T?A.pattern&&(T.pattern=T.pattern||{},T.pattern[A.pattern]=!0):C.set(G,{searchPath:A.searchPath,pattern:A.pattern?v(A.pattern):void 0})}),Array.from(C.values())}n(S){if(d.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:u.URI.file(d.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=w(S),S.startsWith("../")||S===".."){const A=d.$hc.resolve(y.path,S);return[{searchPath:y.with({path:A})}]}const C=p(S);return[{searchPath:y,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),A=this.b.getWorkspace().folders.map(G=>{const T=y.match(new RegExp(`^${O.$Ze(G.name)}(?:/(.*)|$)`));return T?{match:T,folder:G}:null}).filter(E.$3f);if(A.length)return A.map(G=>{const T=G.match[1];return{searchPath:G.folder.uri,pattern:T&&p(T)}});{const G=S.match(/\.[\/\\](.+)[\/\\]?/),T=G?G[1]:S,W=f.localize(0,null,T);throw new Error(W)}}}}o(S,y){const C=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,A=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&A.push({searchPath:S.searchPath,pattern:C+"/**"}),A}q(S,y,C){const A=this.r((0,s.$Ci)(S.searchPath),y,C,!1);return A?{...A,includePattern:S.pattern}:null}r(S,y,C,A){let G;const T=u.URI.isUri(S)?S:S.uri;if(C.searchPaths){const ne=C.searchPaths.filter(le=>(0,k.$Ng)(le.searchPath,T))[0];if(ne&&!ne.pattern)return null;ne&&(G=ne.pattern)}const W=this.a.getValue({resource:T}),L={...this.l(W,y)||{},...G||{}},K=u.URI.isUri(S)?(0,k.$Rg)(S):S.name;return{folder:T,folderName:A?K:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!W.search.followSymlinks}}};e.$YL=h,e.$YL=h=Je([qe(0,r.$Ni),qe(1,s.$qi),qe(2,n.$uD),qe(3,o.$Nj),qe(4,i.$WL)],h);function t(g){const S=g.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,C=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let A=g.substr(0,C.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:g.substr((C.index||0)+1)}}}return{pathPortion:g}}function v(...g){return g.length?g.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function c(g){return M.$_j(g,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function w(g){return g.replace(/\\/g,"/")}function p(g){return w(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,S){g=I.$Mb(g,A=>A.toString());const y=[],C=S.getWorkspace();return g&&g.forEach(A=>{let G;if(S.getWorkbenchState()===2)G=(0,k.$Wg)(C.folders[0].uri,A),G&&G!=="."&&(G="./"+G);else{const T=S.getWorkspaceFolder(A);if(T){const W=T.name;if(C.folders.filter(L=>L.name===W).length===1){const L=(0,k.$Wg)(T.uri,A);L===""?G=`./${T.name}`:G=`./${T.name}/${L}`}else G=A.fsPath}}G&&y.push(l(G))}),y}}),define(Pe[293],Me([1,0,24,2,25,14,3,292,45,48,11]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zub=u,e.$1ub=r;const E=7e3;function u(o,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],a=[];for(const w of n)if(/^workspaceContains:/.test(w)){const p=w.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?a.push(p):i.push(p)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,O.$ah)(),v=w=>t({activationEvent:w}),c=Promise.all(i.map(w=>b(o,w,v))).then(()=>{}),$=f(o,s.identifier,a,v);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function b(o,s,n){for(const i of o.folders)if(await o.exists(I.$Ug(F.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function f(o,s,n,i){if(n.length===0)return Promise.resolve(void 0);const a=new M.$ee,h=o.checkExists(o.folders,n,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},E);let v=!1;try{v=await h}catch(c){N.$4(c)||N.$1(c)}a.dispose(),clearTimeout(t),v&&i(`workspaceContains:${n.join(",")}`)}function r(o,s,n,i){const a=o.get(R.$gi),h=o.get(d.$wK),v=a.createInstance(m.$YL).file(s.map(c=>(0,k.$Ci)(F.URI.revive(c))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(v,i).then(c=>!!c.limitHit,c=>N.$4(c)?!1:Promise.reject(c))}}),define(Pe[38],Me([1,0,164,19,89,24,11,6,51,2,13,4,37,225,82,36,22,108,14,20,23,206,7,102,3,27,85,17,71,86,66,88,5,293,81,208,12,79,64,21,80]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p,l,D,g,S,y,C,A,G,T,W,P,L,K){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=e.$Njc=e.$Mjc=e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,c.$hi)("IHostUtils");let le=ne=class extends m.$Uc{constructor(V,te,ke,Te,Ie,ve,ge,J,Y,ce,de,Ne,ue){super(),this.X=Ne,this.Y=ue,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=te,this.g=ke,this.f=ge,this.j=Te,this.m=Ie,this.s=ve,this.t=Y,this.u=ce,this.w=de,this.y=this.g.getProxy(E.$iM.MainThreadWorkspace),this.z=this.g.getProxy(E.$iM.MainThreadTelemetry),this.C=this.g.getProxy(E.$iM.MainThreadExtensionService),this.D=new R.$gh,this.F=new R.$gh,this.G=new R.$gh,this.H=new R.$gh,this.I=new re(this.f.extensions.activationEvents),this.L=new s.$E0b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Dm(this.f.extensions.myExtensions);this.J=new s.$E0b(this.I,ee(this.L,Ce)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${he(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${he(this.J)}`)),this.M=new f.$vjc(this.g,this.s),this.N=new A.$Djc(this.g),this.O=J,this.h=V.createChild(new l.$fi([f.$wjc,this.M],[A.$Ejc,this.N])),this.P=this.B(new b.$ujc(this.J,this.L,{onExtensionActivationError:(Re,je,U)=>{this.C.$onExtensionActivationError(Re,n.$3(je),U)},actualActivateExtension:async(Re,je)=>{if(s.$E0b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,je),new b.$tjc;const U=this.J.getExtensionDescription(Re);return this.eb(U,je)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(V){n.$1(V)}}async Z(){this.O.onWillDeactivateAll();let V=[];try{V=this.J.getAllExtensionDescriptions().map(Ie=>Ie.identifier).filter(Ie=>this.isActivated(Ie)).map(Ie=>this.db(Ie))}catch{}await Promise.all(V)}terminate(V,te=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${V}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const ke=this.Z();Promise.race([(0,R.$ih)(5e3),ke]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${te}`):this.s.info(`Extension host exiting with code ${te}`),this.s.flush(),this.s.dispose(),this.c.exit(te)})}isActivated(V){return this.G.isOpen()?this.P.isActivated(V):!1}async getExtension(V){const te=await this.C.$getExtension(V);return te&&{...te,identifier:new i.$Cm(te.identifier.value),extensionLocation:k.URI.revive(te.extensionLocation)}}$(V,te){return this.P.activateByEvent(V,te)}ab(V,te){return this.P.activateById(V,te)}activateByIdWithErrors(V,te){return this.ab(V,te).then(()=>{const ke=this.P.getActivatedExtension(V);if(ke.activationFailed)return Promise.reject(ke.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(V=>this.J)}getExtensionExports(V){if(this.G.isOpen())return this.P.getActivatedExtension(V).exports;try{return this.P.getActivatedExtension(V).exports}catch{return null}}async bb(V){if(V.scheme===T.Schemas.file&&this.c.fsRealpath){const te=await this.c.fsRealpath(V.fsPath);return k.URI.file(te)}return V}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(V=>new pe(V))),this.Q}async cb(V){const te=d.$ni.forUris(ke=>N.$Lg.ignorePathCasing(ke));return await Promise.all(V.map(async ke=>{if(this.vb(ke)){const Te=await this.bb(ke.extensionLocation);te.set(Te,ke)}})),te}db(V){let te=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(V))return te;const ke=this.P.getActivatedExtension(V);if(!ke)return te;try{typeof ke.module.deactivate=="function"&&(te=Promise.resolve(ke.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${V.value}':`),this.s.error(Te)}try{(0,m.$Pc)(ke.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this.s.error(Te)}return te}async eb(V,te){return this.f.remote.isRemote?this.C.$onWillActivateExtension(V.identifier):await this.C.$onWillActivateExtension(V.identifier),this.gb(V,te).then(ke=>{const Te=ke.activationTimes;return this.C.$onDidActivateExtension(V.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,te),this.fb(V,te,"success",Te),ke},ke=>{throw this.fb(V,te,"failure"),ke})}fb(V,te,ke,Te){const Ie=Se(V,te);this.z.$publicLog2("extensionActivationTimes",{...Ie,...Te||{},outcome:ke})}gb(V,te){const ke=Se(V,te);this.z.$publicLog2("activatePlugin",ke);const Te=this.vb(V);if(!Te)return Promise.resolve(new b.$sjc(b.$pjc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${te.startup}, activationEvent: '${te.activationEvent}'${V.identifier.value!==te.extensionId.value?`, root cause: ${te.extensionId.value}`:""}`),this.s.flush();const Ie=new b.$qjc(te.startup);return Promise.all([this.wb(V,(0,N.$Ug)(V.extensionLocation,Te),Ie),this.hb(V)]).then(ve=>(M.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),ne.ib(this.s,V.identifier,ve[0],ve[1],Ie))).then(ve=>(M.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),ve))}hb(V){const te=this.Y.createLanguageModelAccessInformation(V),ke=new h.$yjc(V,this.M),Te=new h.$xjc(V.identifier.value,!1,this.M),Ie=new G.$Fjc(V,this.N),ve=V.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([ke.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,ce;const de=(0,o.$6F)(V,"ipc")?this.f.messagePorts?.get(i.$Cm.toKey(V.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:Te,secrets:Ie,subscriptions:[],get languageModelAccessInformation(){return te},get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Ne){return F.$kc(V.extensionLocation.fsPath,Ne)},get storagePath(){return J.O.workspaceValue(V)?.fsPath},get globalStoragePath(){return J.O.globalValue(V).fsPath},get logPath(){return F.$kc(J.f.logsLocation.fsPath,V.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,V.identifier.value)},get storageUri(){return J.O.workspaceValue(V)},get globalStorageUri(){return J.O.globalValue(V)},get extensionMode(){return ve},get extension(){return Y===void 0&&(Y=new be(J,V.identifier,V,ge,!1)),Y},get extensionRuntime(){return(0,o.$7F)(V,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!ce){if(!de)return;const Ne=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",ue=>ue.data));de.start(),ce={onDidReceiveMessage:Ne,postMessage:de.postMessage.bind(de)}}return ce}})})}static ib(V,te,ke,Te,Ie){return ke=ke||{activate:void 0,deactivate:void 0},this.jb(V,te,ke,Te,Ie).then(ve=>new b.$rjc(!1,null,Ie.build(),ke,ve,Te.subscriptions))}static jb(V,te,ke,Te,Ie){if(typeof ke.activate=="function")try{Ie.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${te.value}`);const ve=typeof global=="object"?global:self,ge=ke.activate.apply(ve,[Te]);return Ie.activateCallStop(),Ie.activateResolveStart(),Promise.resolve(ge).then(J=>(Ie.activateResolveStop(),J))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(ke)}kb(V,te){this.ab(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:te}).then(void 0,ke=>{this.s.error(ke)})}lb(V,te=0){const Te=Date.now();(0,L.$B)(()=>{for(let Ie=te;Ie<V.length;Ie+=1){const ve=V[Ie];for(const ge of ve.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Te>50){this.lb(V,Ie);break}else this.kb(ve,ge)}})}mb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(V=>{const te=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ke=this.J.getAllExtensionDescriptions();if(te)this.lb(ke);else for(const Te of ke)if(Te.activationEvents)for(const Ie of Te.activationEvents)Ie==="onStartupFinished"&&this.kb(Te,Ie)})}nb(){const V=this.$("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.ob(ve.added)));const te=this.j.workspace?this.j.workspace.folders:[],ke=this.ob(te),Te=this.qb(),Ie=Promise.all([Te,V,ke]).then(()=>{});return Promise.race([Ie,(0,R.$ih)(1e4)]).then(()=>{this.mb()}),Ie}ob(V){return V.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(te=>this.pb(V,te))).then(()=>{})}async pb(V,te){if(this.isActivated(te.identifier))return;const ke=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:V.map(ve=>ve.uri),forceUsingSearch:ke||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,ge,J)=>this.y.$checkExists(ve,ge,J)},Ie=await(0,C.$Zub)(Te,te);if(Ie)return this.ab(te.identifier,{startup:!0,extensionId:te.identifier,activationEvent:Ie.activationEvent}).then(void 0,ve=>this.s.error(ve))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(V){throw console.error(V),V}}async rb(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:te}=this.f.environment;if(!V||!te)throw new Error(I.localize(0,null));const ke=await this.wb(null,te,new b.$qjc(!1));if(!ke||typeof ke.run!="function")throw new Error(I.localize(1,null,te.toString()));return new Promise((Te,Ie)=>{const ve=(Y,ce)=>{Y?(L.$t&&this.s.error("Test runner called back with error",Y),Ie(Y)):(L.$t&&(ce?this.s.info(`Test runner called back with ${ce} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof ce=="number"&&ce>0?1:0))},ge=(0,N.$Ig)(te),J=ke.run(ge,ve);J&&J.then&&J.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(Y=>{L.$t&&this.s.error("Test runner finished with error",Y),Ie(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$ih)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,te){return this.R[V]=te,(0,m.$Sc)(()=>{delete this.R[V]})}async getRemoteExecServer(V){const{resolver:te}=await this.tb(V);return te?.resolveExecServer?.(V,{resolveAttempt:0})}async tb(V){const te=V.indexOf("+");if(te===-1)throw new t.$qM("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ke=V.substr(0,te);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ke}`,!1),{authorityPrefix:ke,resolver:this.R[ke]}}async $resolveAuthority(V,te){const ke=P.$3d.create(!1),Te=()=>`[resolveAuthority(${(0,v.$wl)(V)},${te})][${ke.elapsed()}ms] `,Ie=z=>this.s.info(`${Te()}${z}`),ve=z=>this.s.warn(`${Te()}${z}`),ge=(z,H=void 0)=>this.s.error(`${Te()}${z}`,H),J=z=>{if(z instanceof t.$qM)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},Y=async z=>{Ie(`activating resolver for ${z}...`);const{resolver:H,authorityPrefix:q}=await this.tb(z);if(!H)throw ge(`no resolver for ${q}`),new t.$qM(`No remote extension installed to resolve ${q}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:q,remoteAuthority:z}},ce=V.split(/@|%40/g).reverse();Ie(`activating remote resolvers ${ce.join(" -> ")}`);let de;try{de=await Promise.all(ce.map(Y)).catch(async z=>{if(!(z instanceof t.$qM)||z._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return ve(`resolving nested authorities failed: ${z.message}`),[await Y(V)]})}catch(z){return J(z)}const Ne=new R.$sh;Ne.cancelAndSet(()=>Ie("waiting..."),1e3);let ue,Ce;for(const[z,{authorityPrefix:H,resolver:q,remoteAuthority:_}]of de.entries())try{if(z===de.length-1)Ie("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${H}`),ue=await q.resolve(_,{resolveAttempt:te,execServer:Ce}),M.mark(`code/extHost/didResolveAuthorityOK/${H}`),Ie("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(q,t.$pM.isManagedResolvedAuthority(ue)?ue:void 0));else{if(Ie(`invoking resolveExecServer() for ${_}`),M.mark(`code/extHost/willResolveExecServer/${H}`),Ce=await q.resolveExecServer?.(_,{resolveAttempt:te,execServer:Ce}),!Ce)throw new t.$qM(`Exec server was not available for ${_}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(se){return M.mark(`code/extHost/didResolveAuthorityError/${H}`),ge("returned an error",se),Ne.dispose(),J(se)}Ne.dispose();const Re={environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures?{elevation:ue.tunnelFeatures.elevation,privacyOptions:ue.tunnelFeatures.privacyOptions,protocol:ue.tunnelFeatures.protocol===void 0?!0:ue.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};Ie(`returned ${t.$pM.isManagedResolvedAuthority(ue)?"managed authority":`${ue.host}:${ue.port}`}`);let U;if(t.$pM.isManagedResolvedAuthority(ue)){const z=te;this.X.setFactory(z,ue.makeConnection),U={authority:V,connectTo:new v.$tl(z),connectionToken:ue.connectionToken}}else U={authority:V,connectTo:new v.$ul(ue.host,ue.port),connectionToken:ue.connectionToken};return{type:"ok",value:{authority:U,options:je,tunnelInformation:Re}}}async $getCanonicalURI(V,te){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$wl)(V)})`);const{resolver:ke}=await this.tb(V);if(!ke)return null;const Te=k.URI.revive(te);if(typeof ke.getCanonicalURI>"u")return Te;const Ie=await(0,R.$_g)(()=>ke.getCanonicalURI(Te));return Ie||Te}$startExtensionHost(V){V.toAdd.forEach(Te=>Te.extensionLocation=k.URI.revive(Te.extensionLocation));const{globalRegistry:te,myExtensions:ke}=ye(this.I,this.L,this.J,V);return this.L.set(te.getAllExtensionDescriptions()),this.J.set(ke),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${he(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${he(this.J)}`)),this.sb()}$activateByEvent(V,te){return te===1?this.D.wait().then(ke=>this.$(V,!1)):this.G.wait().then(ke=>this.$(V,!1))}async $activate(V,te){return await this.G.wait(),this.J.getExtensionDescription(V)?(await this.ab(V,te),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const{globalRegistry:te,myExtensions:ke}=ye(this.I,this.L,this.J,V),Te=await this.cb(ke);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(te.getAllExtensionDescriptions()),this.J.set(ke),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${he(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${he(this.J)}`)),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const te=a.$ue.alloc(V),ke=Math.random()%256;for(let Te=0;Te<V;Te++)te.writeUInt8(ke,Te);return te}async $updateRemoteConnectionData(V){this.W=V,this.a.fire()}};e.$Ljc=le,e.$Ljc=le=ne=Je([qe(0,c.$gi),qe(1,e.$Kjc),qe(2,p.$CO),qe(3,r.$$ic),qe(4,u.$bjc),qe(5,O.$Nj),qe(6,$.$SO),qe(7,w.$ejc),qe(8,D.$eBb),qe(9,g.$zjc),qe(10,W.$Hjc),qe(11,K.$Ijc),qe(12,S.$1ic)],le);function ye(fe,V,te,ke){fe.addActivationEvents(ke.addActivationEvents);const Te=new s.$E0b(fe,V.getAllExtensionDescriptions());Te.deltaExtensions(ke.toAdd,ke.toRemove);const Ie=new i.$Dm(te.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ke.myToRemove)Ie.delete(ge);for(const ge of ke.myToAdd)Ie.add(ge);const ve=ee(Te,Ie);return{globalRegistry:Te,myExtensions:ve}}function Se(fe,V){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}function he(fe){return fe.getAllExtensionDescriptions().map(V=>V.identifier.value).join(",")}e.$Mjc=(0,c.$hi)("IExtHostExtensionService");class be{#e;#t;#i;constructor(V,te,ke,Te,Ie){this.#e=V,this.#t=te,this.#i=ke.identifier,this.id=ke.identifier.value,this.extensionUri=ke.extensionLocation,this.extensionPath=F.$ic((0,N.$Ig)(ke.extensionLocation)),this.packageJSON=ke,this.extensionKind=Te,this.isFromDifferentExtensionHost=Ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Njc=be;function ee(fe,V){return fe.getAllExtensionDescriptions().filter(te=>V.has(te.identifier))}class pe{constructor(V){this.a=V}setSearchTree(V){this.a=V}findSubstr(V){return this.a.findSubstr(V)}forEach(V){return this.a.forEach(V)}}e.$Ojc=pe;class re{constructor(V){this.a=new i.$Em,this.addActivationEvents(V)}readActivationEvents(V){return this.a.get(V.identifier)??[]}addActivationEvents(V){for(const te of Object.keys(V))this.a.set(te,V[te])}}}),define(Pe[294],Me([1,0,89,2,4,37,22,20,17,27,3,38,13,15]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;let r=class{constructor(a,h,t,v,c,$,w){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.h=$,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$Wkc=r,e.$Wkc=r=Je([qe(2,O.$gi),qe(3,N.$bjc),qe(4,E.$Mjc),qe(5,k.$SO),qe(6,u.$Nj)],r);let o=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&f.a.size){const h=(0,b.$Ze)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",v=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,v,c]=h,$=f.a.get(v);if($!==void 0)return console.warn(`${v} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=f=Je([qe(0,k.$SO)],o);class s{constructor(a,h,t,v,c){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.nodeModuleName="vscode",this.a=new m.$Em}load(a,h){const t=this.d.findSubstr(h);if(t){let v=this.a.get(t.identifier);return v||(v=this.c(t,this.e,this.f),this.a.set(t.identifier,v)),v}if(!this.b){let v="";this.d.forEach((c,$)=>v+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${v}`),this.b=this.c(R.$1F,this.e,this.f)}return this.b}}let n=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$iM.MainThreadTelemetry);const v=t.getProxy(M.$iM.MainThreadWindow);this.c=(c,$)=>{const w=F.URI.parse(c);return $?this.g(c,$):w.scheme==="http"||w.scheme==="https"?v.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?v.$openUri(w,c,{}):this.g(c,$)}}load(a,h,t){const v=this.e.findSubstr(h);return v&&(this.a=v.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,d.$CO)],n)}),define(Pe[119],Me([1,0,40,6,19,73,3,67,65,38,7,36,222,37]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=void 0,e.$Pjc=(0,R.$hi)("IExtHostVariableResolverProvider");class f extends u.$EP{constructor(s,n,i,a,h,t,v){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const w=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof O.$7N||w.input instanceof O.$_N)return w.input.modified;if(w.input instanceof O.$6N||w.input instanceof O.$$N||w.input instanceof O.$9N)return w.input.uri}}}super({getFolderUri:$=>{const w=t.folders.filter(p=>p.name===$);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,w)=>h.getConfiguration(void 0,$).get(w),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return M.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const $=c();if($){const w=n.getWorkspaceFolder($);if(w)return M.$ic(w.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(N.env))}}let r=class extends F.$Uc{constructor(s,n,i,a,h){super(),this.b=s,this.c=n,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Qjc=r,e.$Qjc=r=Je([qe(0,k.$Mjc),qe(1,E.$$ic),qe(2,m.$NO),qe(3,b.$bjc),qe(4,d.$njc)],r)}),define(Pe[120],Me([1,0,11,5,2,20,3,4,65,38,17,7,36,214,216,37,119,6,41,31,8]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=e.$Tjc=e.$Sjc=e.$Rjc=void 0,e.$Rjc=(0,R.$hi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,g,S,y,C,A){this.N=D,this.O=g,this.P=S,this.Q=y,this.R=C,this.S=A,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$7d,this.o=new F.$7d,this.q=new F.$7d,this.w=new F.$7d,this.l=l.getProxy(m.$iM.MainThreadDebugService),this.A=new F.$7d,this.C=new F.$7d,this.y=new v(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(T=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem(l,D){const g=this.W(D);if(!g)return;const S=await this.H.get(l)?.getTreeItem?.(g);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,g){const S=N.$Cm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,g),this.l.$registerDebugVisualizerTree(y,!!g.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const g=this.J.get(D)?.item;return g?(await this.H.get(l)?.getChildren?.(g))?.map(y=>this.U(l,y))||[]:[]}async $editVisualizerTreeItem(l,D){const g=this.J.get(l);if(!g)return;const S=await this.H.get(g.provider)?.editItem?.(g.item,D);return this.U(g.provider,S||g.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const g=[D.children];for(const S of g)if(S)for(const y of S)g.push(this.J.get(y)?.children),this.J.delete(y)}U(l,D){let g=this.I.get(D);return g||(g=this.F++,this.I.set(D,g),this.J.set(g,{provider:l,item:D})),a.DebugTreeItem.from(D,g)}asDebugSourceUri(l,D){const g=l;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let S=`debug:${encodeURIComponent(g.path||"")}`,y="?";return D&&(S+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),S+=`${y}ref=${g.sourceReference}`,M.URI.parse(S)}else{if(g.path)return M.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const g of l.getAllExtensionDescriptions())if(g.contributes){const S=g.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,f.$GG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const g=this.L.get(l);if(!g)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:y,extensionId:C}=g;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,D)||S,g.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const g=D.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,g,S){const y=this.W(g),C=this.jb(l,D),A=this.G.get(C);if(!y||!A)return[];const G=await A.provideDebugVisualization(y,S);return G?G.map(T=>{const W=++this.M;this.L.set(W,{v:T,provider:A,extensionId:l});const P=T.iconPath?this.lb(T.iconPath):void 0;return{id:W,name:T.name,iconClass:P?.iconClass,iconPath:P?.iconPath,visualization:this.kb(l,T.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,g){if(!l.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=N.$Cm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,g),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const g=[],S=new Map;for(const y of D)if(y instanceof E.$lN){let C=S.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),C),g.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof E.$mN&&g.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(l){const D=l.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const g=D.filter(C=>C instanceof E.$lN).map(C=>C.id),S=D.filter(C=>C instanceof E.$mN).map(C=>C.id),y=D.filter(C=>C instanceof E.$nN).map(C=>C.id);return this.l.$unregisterBreakpoints(g,S,y)}startDebugging(l,D,g){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,g){if(!D)return new E.$kM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new E.$kM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,g){if(!g)return new E.$kM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new E.$kM(()=>{this.h=this.h.filter(y=>y.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new E.$kM(()=>{});const g=this.j++;return this.k.push({type:l,handle:g,factory:D}),new E.$kM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let g;const S=await this.ib(l);return S&&(g={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const g=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(y),A=this.X(C,S);if(!A)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const G=A;return this.D.set(l,G),this.db(S).then(T=>(T&&this.E.set(l,T),G.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const P=W,L={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(P.arguments.value);L.body={signature:K},G.sendResponse(L)}else throw new Error("no signer")}catch(K){L.success=!1,L.message=K.message,G.sendResponse(L)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(W),W=(0,f.$LG)(W,!0),g.l.$acceptDAMessage(l,W)}),G.onError(W=>{T&&T.onError&&T.onError(W),this.l.$acceptDAError(l,W.name,W.message,W.stack)}),G.onExit(W=>{T&&T.onExit&&T.onExit(W??void 0,void 0),this.l.$acceptDAExit(l,W??void 0,void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),G.startSession()))})}$sendDAMessage(l,D){D=(0,f.$KG)(D,!1);const g=this.E.get(l);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const g=this.D.get(l);return this.D.delete(l),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],g=[],S=[];if(l.added)for(const y of l.added){const C=y.id;if(C&&!this.z.has(C)){let A;if(y.type==="function")A=new E.$mN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")A=new E.$nN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const G=M.URI.revive(y.uri);A=new E.$lN(new E.$wM(G,new E.$lM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,E.$jN)(A,C),this.z.set(C,A),D.push(A)}}if(l.removed)for(const y of l.removed){const C=this.z.get(y);C&&(this.z.delete(y),g.push(C))}if(l.changed){for(const y of l.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof E.$mN&&y.type==="function"){const A=C;A.enabled=y.enabled,A.condition=y.condition,A.hitCondition=y.hitCondition,A.logMessage=y.logMessage,A.functionName=y.functionName}else if(C instanceof E.$lN&&y.type==="source"){const A=C;A.enabled=y.enabled,A.condition=y.condition,A.hitCondition=y.hitCondition,A.logMessage=y.logMessage,A.location=new E.$wM(M.URI.revive(y.uri),new E.$lM(y.line,y.character))}S.push(C)}}}this.gb(D,g,S)}async $acceptStackFrameFocus(l){let D;if(l){const g=await this.hb(l.sessionId);l.kind==="thread"?D=new E.$tN(g.api,l.threadId):D=new E.$sN(g.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,g){return(0,I.$_g)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return S.provideDebugConfigurations(y,g)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,g,S){return(0,I.$_g)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,g,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,g,S){return(0,I.$_g)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,g,S)})}async $provideDebugAdapter(l,D){const g=this.ab(l);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(g,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof E.$oN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof E.$pN)return{type:"server",port:l.port,host:l.host};if(l instanceof E.$qN)return{type:"pipeServer",path:l.path};if(l instanceof E.$rN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(g=>g.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(g=>g.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(g=>g.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const g=l.contributes.debuggers;if(g&&g.length>0){for(const S of g)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const g=l.configuration.type,S=this.k.filter(y=>y.type===g||y.type==="*").map(y=>(0,I.$_g)(()=>y.factory.createDebugAdapterTracker(l.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(y=>{const C=y.filter(A=>!!A);if(C.length>0)return new c(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(l,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new E.$pN(g));if(l){const y=await this.O.getExtensionRegistry();return(0,I.$_g)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,g){(l.length>0||D.length>0||g.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:g}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const g=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,g,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=M.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let g,S;return"id"in D?S=n.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:S}}mb(l){if(l instanceof E.$gN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,g=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?M.URI.file(D):D,light:typeof g=="string"?M.URI.file(g):g}}};e.$Sjc=h,e.$Sjc=h=Je([qe(0,O.$CO),qe(1,u.$$ic),qe(2,k.$Mjc),qe(3,r.$bjc),qe(4,d.$njc),qe(5,o.$Pjc),qe(6,i.$YO)],h);class t{constructor(l,D,g,S,y,C,A){this.f=l,this.g=D,this.h=g,this.j=S,this.k=y,this.l=C,this.m=A}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,g){return l.f.$customDebugAdapterRequest(l.g,D,g)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$Tjc=t;class v{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Ujc=v;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(g=>g.onExit?g.onExit(l,D):void 0)}}class $ extends b.$fob{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends h{constructor(l,D,g,S,y,C,A){super(l,D,g,S,y,C,A)}};e.$Vjc=w,e.$Vjc=w=Je([qe(0,O.$CO),qe(1,u.$$ic),qe(2,k.$Mjc),qe(3,r.$bjc),qe(4,d.$njc),qe(5,o.$Pjc),qe(6,i.$YO)],w)}),define(Pe[295],Me([1,0,14,89,2,4,243,13,54,71,27,190,17,59,38,61]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(m.$Nj),t=i.get(u.$CO).getProxy(N.$iM.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{a.error(v);const c=I.$3(v);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(m.$Nj),h=i.get(u.$CO),t=i.get(f.$Mjc),v=i.get(r.$WO),c=h.getProxy(N.$iM.MainThreadExtensionService),$=h.getProxy(N.$iM.MainThreadErrors),w=await t.getExtensionPathIndex(),p=new WeakMap;function l(S,y){if(p.has(S))return p.get(S).stack;let C="",A,G;for(const W of y)C+=`
	at ${W.toString()}`,G=W.getFileName(),!A&&G&&(A=w.findSubstr(M.URI.file(G)));const T=`${S.name||"Error"}: ${S.message||""}${C}`;return p.set(S,{extensionIdentifier:A?.identifier,stack:T}),T}const D=Symbol("prepareStackTrace wrapped");let g=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(S){if(S===l||!S||S[D]){g=S||l;return}g=function(y,C){return l(y,C),S.call(Error,y,C)},Object.assign(g,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const y=I.$3(S),C=p.get(S);if(!C?.extensionIdentifier){$.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const A=v.onExtensionError(C.extensionIdentifier,S);a.trace("forwarded error to extension?",A,C)})}}e.$Xkc=o;class s{constructor(i,a,h,t,v){this.a=h,this.b=new R.$M0b(i,null,t),a=s.e(a,this.b);const c=new k.$fi(...(0,d.$gs)());c.set(O.$SO,{_serviceBrand:void 0,...a,messagePorts:v}),c.set(u.$CO,new u.$DO(this.b)),c.set(b.$8ic,new b.$9ic(t)),c.set(f.$Kjc,h);const $=new E.$Xq(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(w=>w.get(m.$Nj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(w=>w.get(f.$Mjc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(N.$iM.MainThreadExtensionService);return M.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>M.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$Ykc=s}),define(Pe[296],Me([1,0,18,11,25,42,12,19,24,2,45]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=e.$$jc=e.$0jc=void 0,e.$_jc=r;class E{constructor(n,i,a){this.d=n,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const a=this.g.folderQueries||[],h=new M.$ee(i);return new Promise((t,v)=>{this.a=new b(n);let c=!1;const $=(w,p)=>{if(!c&&!this.b){const l=this.h(w);r(w)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),w=this.j(w,this.g.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!r(w))&&this.a.add(w,p)}};Promise.all(a.map((w,p)=>this.k(w,l=>$(l,p),h.token))).then(w=>{h.dispose(),this.a.flush();const p=w.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||p,messages:(0,I.$Rb)(w.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},w=>{h.dispose();const p=(0,N.$5i)(w);v(new Error(p))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,a){const h=new O.$PK(this.g,n),t=[],v={report:w=>{if(!this.l(w))return;const p=n.folder.scheme===R.Schemas.file?(0,O.$QK)(()=>this.e.readdir(d.$Tg(w.uri))):void 0,l=d.$Wg(n.folder,w.uri);if(l){const D=h.includedInQuery(l,m.$oc(l),p);(0,F.$6g)(D)?t.push(D.then(g=>{g&&i(w)})):D&&i(w)}}},c=this.n(n);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,v,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,v,a),t.length&&await Promise.all(t),$}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,O.$OK)(this.g.includePattern,n.includePattern),a=(0,O.$OK)(this.g.excludePattern,n.excludePattern),h={folder:k.URI.from(n.folder),excludes:a,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$0jc=E;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class b{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!d.$Ng(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$$jc=b;function f(s){return r(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$akc=o}),define(Pe[121],Me([1,0,6,4,3,291,17,59,13,2,296]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$dkc=u,e.$bkc=(0,M.$hi)("IExtHostSearch");let E=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(F.$iM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$9jc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,n){const i=u(s),a=this.j.get(r);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(r,o,h.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$provideAITextSearchResults(r,o,s,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$enableExtensionHostSearch(){}t(r,o){return new O.$0jc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new O.$0jc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$ckc=E,e.$ckc=E=Je([qe(0,R.$CO),qe(1,m.$8ic),qe(2,d.$Nj)],E);function u(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(r=>k.URI.revive(r))}}function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Pe[297],Me([1,0,25,14,5,6,12,32,2,150,146,134,94,20,43,13,57,58,203,4,246,275,78,84,252,231,253,88,254,232,220,31,255,37,256,120,110,257,234,247,258,259,67,65,248,38,261,63,262,44,27,276,277,249,235,263,264,79,80,237,290,266,207,267,278,268,115,238,269,270,271,17,272,121,81,273,239,274,82,85,118,61,66,279,280,250,281,282,86,8,7,240,59,241,62,283,284,109,36,215,77,22,117]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p,l,D,g,S,y,C,A,G,T,W,P,L,K,ne,le,ye,Se,he,be,ee,pe,re,fe,V,te,ke,Te,Ie,ve,ge,J,Y,ce,de,Ne,ue,Ce,Re,je,U,z,H,q,_,se,Oe,We,Qe,xe,tt,at,nt,rt,ct,Be,it,Z,X,$e,Ve,Ze,ut,Ae,Dt,Jt,zt,hi,Tt,Et,Qt,Ut,oi,ti,Xe,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=ii;function ii(dt){const pt=dt.get(fe.$SO),ni=dt.get(re.$Pic),Bt=dt.get(ee.$djc),Wt=dt.get(he.$Mjc),ft=dt.get(Ut.$$ic),Mt=dt.get(ct.$WO),_t=dt.get(C.$bjc),ri=dt.get(Jt.$8ic),He=dt.get(_.$CO),Vt=dt.get(at.$wjc),Zt=dt.get(nt.$ejc),qt=dt.get(r.$Oj),mt=dt.get(r.$Nj),At=dt.get(Ze.$eBb),It=dt.get(t.$Lic),Ft=dt.get(Qt.$Rkc),si=dt.get(We.$Ejc),Ht=dt.get(ye.$njc),Xt=dt.get(J.$Ijc),bt=dt.get(v.$Vic),Ot=dt.get(p.$1ic);He.set(i.$jM.ExtHostFileSystemInfo,ni),He.set(i.$jM.ExtHostLogLevelServiceShape,qt),He.set(i.$jM.ExtHostWorkspace,ft),He.set(i.$jM.ExtHostConfiguration,_t),He.set(i.$jM.ExtHostExtensionService,Wt),He.set(i.$jM.ExtHostStorage,Vt),He.set(i.$jM.ExtHostTunnelService,At),He.set(i.$jM.ExtHostWindow,Ft),He.set(i.$jM.ExtHostSecretState,si),He.set(i.$jM.ExtHostTelemetry,Mt),He.set(i.$jM.ExtHostEditorTabs,Ht),He.set(i.$jM.ExtHostManagedSockets,Xt),He.set(i.$jM.ExtHostAuthentication,bt),He.set(i.$jM.ExtHostChatProvider,Ot);const Lt=He.set(i.$jM.ExtHostDecorations,dt.get(T.$Xjc)),Nt=He.set(i.$jM.ExtHostDocumentsAndEditors,dt.get(le.$NO)),yt=He.set(i.$jM.ExtHostCommands,dt.get(S.$YO)),St=He.set(i.$jM.ExtHostTerminalService,dt.get(Be.$zjc)),kt=He.set(i.$jM.ExtHostDebugService,dt.get(G.$Rjc)),ci=He.set(i.$jM.ExtHostSearch,dt.get(Oe.$bkc)),ei=He.set(i.$jM.ExtHostTask,dt.get(rt.$Ekc)),ui=He.set(i.$jM.ExtHostOutputService,dt.get(je.$rkc)),di=He.set(i.$jM.ExtHostLocalization,dt.get(ge.$Hjc)),Yt=He.set(i.$jM.ExtHostUrls,new zt.$Okc(He)),Ct=He.set(i.$jM.ExtHostDocuments,new ne.$Sic(He,Nt)),we=He.set(i.$jM.ExtHostDocumentContentProviders,new L.$Zjc(He,Nt,mt)),Fe=He.set(i.$jM.ExtHostDocumentSaveParticipant,new K.$1jc(mt,Ct,He.getProxy(i.$iM.MainThreadBulkEdits))),oe=He.set(i.$jM.ExtHostNotebook,new ce.$ekc(He,yt,Nt,Ct,Bt,ci)),Q=He.set(i.$jM.ExtHostNotebookDocuments,new Ne.$lkc(oe)),Ee=He.set(i.$jM.ExtHostNotebookEditors,new ue.$mkc(mt,oe)),Ue=He.set(i.$jM.ExtHostNotebookKernels,new Ce.$nkc(He,pt,oe,yt,mt)),Ye=He.set(i.$jM.ExtHostNotebookRenderers,new Re.$pkc(He,oe)),Ke=He.set(i.$jM.ExtHostNotebookDocumentSaveParticipant,new de.$kkc(mt,oe,He.getProxy(i.$iM.MainThreadBulkEdits))),st=He.set(i.$jM.ExtHostEditors,new Z.$5ic(He,Nt)),wt=He.set(i.$jM.ExtHostTreeViews,new Ve.$Mkc(He.getProxy(i.$iM.MainThreadTreeViews),yt,mt)),Kt=He.set(i.$jM.ExtHostEditorInsets,new g.$6ic(He.getProxy(i.$iM.MainThreadEditorInsets),st,pt.remote)),jt=He.set(i.$jM.ExtHostDiagnostics,new W.$Ric(He,mt,ni,Nt)),Pt=He.set(i.$jM.ExtHostLanguages,new ve.$ikc(He,Ct,yt.converter,ri)),lt=He.set(i.$jM.ExtHostLanguageFeatures,new Ie.$Tic(He,ri,Ct,yt,jt,mt,It,Mt)),Ci=He.set(i.$jM.ExtHostFileSystem,new be.$3jc(He,lt)),gi=He.set(i.$jM.ExtHostFileSystemEventService,new pe.$4jc(He,mt,Nt)),$i=He.set(i.$jM.ExtHostQuickOpen,(0,q.$vkc)(He,ft,yt)),wi=He.set(i.$jM.ExtHostSCM,new se.$xkc(He,yt,Ct,mt)),Pi=He.set(i.$jM.ExtHostQuickDiff,new H.$ukc(He,ri)),Mi=He.set(i.$jM.ExtHostShare,new Qe.$ykc(He,ri)),Wi=He.set(i.$jM.ExtHostComments,(0,y.$7ic)(He,yt,Ct)),Vi=He.set(i.$jM.ExtHostProgress,new z.$tkc(He.getProxy(i.$iM.MainThreadProgress))),qi=He.set(i.$jM.ExtHostLabelService,new Te.$hkc(He)),yi=He.set(i.$jM.ExtHostTheming,new X.$Jkc(He)),Ri=He.set(i.$jM.ExtHostTimeline,new $e.$Lkc(He,yt)),ki=He.set(i.$jM.ExtHostWebviews,new hi.$ijc(He,pt.remote,ft,mt,It)),Ei=He.set(i.$jM.ExtHostWebviewPanels,new Tt.$ljc(He,ki,ft)),Hi=He.set(i.$jM.ExtHostCustomEditors,new A.$mjc(He,Ct,Zt,ki,Ei)),Ki=He.set(i.$jM.ExtHostWebviewViews,new Et.$Pkc(He,ki)),vi=He.set(i.$jM.ExtHostTesting,new it.$Fkc(He,mt,yt,Nt)),Gi=He.set(i.$jM.ExtHostUriOpeners,new Dt.$Nkc(He)),gn=He.set(i.$jM.ExtHostProfileContentHandlers,new U.$skc(He));He.set(i.$jM.ExtHostInteractive,new te.$fkc(He,oe,Nt,yt,mt));const mn=He.set(i.$jM.ExtHostInlineChat,new V.$5jc(He,yt,Ct,mt)),Ai=He.set(i.$jM.ExtHostChatAgents2,new w.$Zic(He,mt,yt)),Fi=He.set(i.$jM.ExtHostChatVariables,new l.$3ic(He)),Ji=He.set(i.$jM.ExtHostChat,new $.$Yic(He)),Qi=He.set(i.$jM.ExtHostAiRelatedInformation,new a.$Kic(He)),Zi=He.set(i.$jM.ExtHostAiEmbeddingVector,new Se.$2jc(He)),Xi=He.set(i.$jM.ExtHostIssueReporter,new ke.$gkc(He)),Di=He.set(i.$jM.ExtHostStatusBar,new tt.$Bkc(He,yt.converter)),Yi=He.set(i.$jM.ExtHostSpeech,new xe.$zkc(He)),xi=Object.values(i.$jM);He.assertRegistered(xi);const _i=new c.$Xic(He,Nt),$n=new D.$4ic(He),bi=new Y.$jkc(He,mt),Oi=new P.$Yjc(He);return h.$Uic.register(yt),function(Le,ai,en){function et(x){return(ae,ze,ot)=>{const vt=x(Rt=>{try{ae.call(ze,Rt)}catch(zi){F.$2(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${zi.toString()}`,{cause:zi})),Mt.onExtensionError(Le.identifier,zi)}});return ot?.push(vt),vt}}const $t=function(){let x=!Le.isUnderDevelopment;function ae(){x||(mt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function ze(ot){if(Array.isArray(ot))ot.forEach(ze);else if(typeof ot=="string")ae();else{const vt=ot;typeof vt.scheme>"u"&&ae(),typeof vt.exclusive=="boolean"&&(0,Xe.$7F)(Le,"documentFiltersExclusive")}return ot}}(),tn={getSession(x,ae,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,Xe.$7F)(Le,"authLearnMore"),bt.getSession(Le,x,ae,ze)},getSessions(x,ae){return(0,Xe.$7F)(Le,"authGetSessions"),bt.getSessions(Le,x,ae)},async hasSession(x,ae){return(0,Xe.$7F)(Le,"authSession"),!!await bt.getSession(Le,x,ae,{silent:!0})},get onDidChangeSessions(){return et(bt.onDidChangeSessions)},registerAuthenticationProvider(x,ae,ze,ot){return bt.registerAuthenticationProvider(x,ae,ze,ot)}},nn={registerCommand(x,ae,ze){return yt.registerCommand(!0,x,ae,ze,void 0,Le)},registerTextEditorCommand(x,ae,ze){return yt.registerCommand(!0,x,(...ot)=>{const vt=st.getActiveTextEditor();if(!vt){mt.warn("Cannot execute "+x+" because there is no active text editor.");return}return vt.edit(Rt=>{ae.apply(ze,[vt,Rt,...ot])}).then(Rt=>{Rt||mt.warn("Edits from command "+x+" were not applied.")},Rt=>{mt.warn("An error occurred while running command "+x,Rt)})},void 0,void 0,Le)},registerDiffInformationCommand:(x,ae,ze)=>((0,Xe.$7F)(Le,"diffCommand"),yt.registerCommand(!0,x,async(...ot)=>{const vt=Nt.activeEditor(!0);if(!vt){mt.warn("Cannot execute "+x+" because there is no active text editor.");return}const Rt=await st.getDiffInformation(vt.id);ae.apply(ze,[Rt,...ot])},void 0,void 0,Le)),executeCommand(x,...ae){return yt.executeCommand(x,...ae)},getCommands(x=!1){return yt.getCommands(x)}},Ni={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return et(St.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$7F)(Le,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$7F)(Le,"telemetry"),et(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ct.$VO)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,ae){return ct.$UO.validateSender(x),Mt.instantiateLogger(Le,x,ae)},openExternal(x,ae){return Ft.openUri(x,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===pt.environment.appUriScheme)return Yt.createAppUri(x);try{return await Ft.asExternalUri(x,{allowTunneling:!!pt.remote.authority})}catch(ae){if((0,R.$qg)(x,R.Schemas.http)||(0,R.$qg)(x,R.Schemas.https))return x;throw ae}},get remoteName(){return(0,o.$tm)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.$7F)(Le,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return et(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Xe.$7F)(Le,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Le,x)},registerIssueDataProvider(x){return(0,Xe.$7F)(Le,"handleIssueUri"),Xi.registerIssueDataProvider(Le,x)},get appQuality(){return(0,Xe.$7F)(Le,"resolvers"),pt.quality},get appCommit(){return(0,Xe.$7F)(Le,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ni);const rn={createTestController(x,ae,ze){return vi.createTestController(Le,x,ae,ze)},createTestObserver(){return(0,Xe.$7F)(Le,"testObserver"),vi.createTestObserver()},runTests(x){return(0,Xe.$7F)(Le,"testObserver"),vi.runTests(x)},get onDidChangeTestResults(){return(0,Xe.$7F)(Le,"testObserver"),et(vi.onResultsChanged)},get testResults(){return(0,Xe.$7F)(Le,"testObserver"),vi.results}},Si=pt.remote.isRemote?Ae.ExtensionKind.Workspace:Ae.ExtensionKind.UI,sn={getExtension(x,ae){(0,Xe.$6F)(Le,"extensionsAny")||(ae=!1);const ze=ai.mine.getExtensionDescription(x);if(ze)return new he.$Njc(Wt,Le.identifier,ze,Si,!1);if(ae){const ot=ai.all.getExtensionDescription(x);if(ot)return new he.$Njc(Wt,Le.identifier,ot,Si,!0)}},get all(){const x=[];for(const ae of ai.mine.getAllExtensionDescriptions())x.push(new he.$Njc(Wt,Le.identifier,ae,Si,!1));return x},get allAcrossExtensionHosts(){(0,Xe.$7F)(Le,"extensionsAny");const x=new b.$Dm(ai.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ae=[];for(const ze of ai.all.getAllExtensionDescriptions()){const ot=!x.has(ze.identifier);ae.push(new he.$Njc(Wt,Le.identifier,ze,Si,ot))}return ae},get onDidChange(){return(0,Xe.$6F)(Le,"extensionsAny")?et(M.Event.any(ai.mine.onDidChange,ai.all.onDidChange)):et(ai.mine.onDidChange)}},on={createDiagnosticCollection(x){return jt.createDiagnosticCollection(Le.identifier,x)},get onDidChangeDiagnostics(){return et(jt.onDidChangeDiagnostics)},getDiagnostics:x=>jt.getDiagnostics(x),getLanguages(){return Pt.getLanguages()},setTextDocumentLanguage(x,ae){return Pt.changeLanguage(x.uri,ae)},match(x,ae){const ze=ut.LanguageSelector.from(x);let ot;return(0,O.$Vt)(ze)&&(ot=oe.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Rt=>Rt.document===ae))?.apiNotebook),(0,O.$Ut)(ze,ae.uri,ae.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(x,ae,ze){return lt.registerCodeActionProvider(Le,$t(x),ae,ze)},registerDocumentPasteEditProvider(x,ae,ze){return(0,Xe.$7F)(Le,"documentPaste"),lt.registerDocumentPasteEditProvider(Le,$t(x),ae,ze)},registerCodeLensProvider(x,ae){return lt.registerCodeLensProvider(Le,$t(x),ae)},registerDefinitionProvider(x,ae){return lt.registerDefinitionProvider(Le,$t(x),ae)},registerDeclarationProvider(x,ae){return lt.registerDeclarationProvider(Le,$t(x),ae)},registerImplementationProvider(x,ae){return lt.registerImplementationProvider(Le,$t(x),ae)},registerTypeDefinitionProvider(x,ae){return lt.registerTypeDefinitionProvider(Le,$t(x),ae)},registerHoverProvider(x,ae){return lt.registerHoverProvider(Le,$t(x),ae,Le.identifier)},registerEvaluatableExpressionProvider(x,ae){return lt.registerEvaluatableExpressionProvider(Le,$t(x),ae,Le.identifier)},registerInlineValuesProvider(x,ae){return lt.registerInlineValuesProvider(Le,$t(x),ae,Le.identifier)},registerDocumentHighlightProvider(x,ae){return lt.registerDocumentHighlightProvider(Le,$t(x),ae)},registerMultiDocumentHighlightProvider(x,ae){return lt.registerMultiDocumentHighlightProvider(Le,$t(x),ae)},registerLinkedEditingRangeProvider(x,ae){return lt.registerLinkedEditingRangeProvider(Le,$t(x),ae)},registerReferenceProvider(x,ae){return lt.registerReferenceProvider(Le,$t(x),ae)},registerRenameProvider(x,ae){return lt.registerRenameProvider(Le,$t(x),ae)},registerNewSymbolNamesProvider(x,ae){return(0,Xe.$7F)(Le,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Le,$t(x),ae)},registerDocumentSymbolProvider(x,ae,ze){return lt.registerDocumentSymbolProvider(Le,$t(x),ae,ze)},registerWorkspaceSymbolProvider(x){return lt.registerWorkspaceSymbolProvider(Le,x)},registerDocumentFormattingEditProvider(x,ae){return lt.registerDocumentFormattingEditProvider(Le,$t(x),ae)},registerDocumentRangeFormattingEditProvider(x,ae){return lt.registerDocumentRangeFormattingEditProvider(Le,$t(x),ae)},registerOnTypeFormattingEditProvider(x,ae,ze,...ot){return lt.registerOnTypeFormattingEditProvider(Le,$t(x),ae,[ze].concat(ot))},registerDocumentSemanticTokensProvider(x,ae,ze){return lt.registerDocumentSemanticTokensProvider(Le,$t(x),ae,ze)},registerDocumentRangeSemanticTokensProvider(x,ae,ze){return lt.registerDocumentRangeSemanticTokensProvider(Le,$t(x),ae,ze)},registerSignatureHelpProvider(x,ae,ze,...ot){return typeof ze=="object"?lt.registerSignatureHelpProvider(Le,$t(x),ae,ze):lt.registerSignatureHelpProvider(Le,$t(x),ae,typeof ze>"u"?[]:[ze,...ot])},registerCompletionItemProvider(x,ae,...ze){return lt.registerCompletionItemProvider(Le,$t(x),ae,ze)},registerInlineCompletionItemProvider(x,ae,ze){return ae.handleDidShowCompletionItem&&(0,Xe.$7F)(Le,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$7F)(Le,"inlineCompletionsAdditions"),ze&&(0,Xe.$7F)(Le,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Le,$t(x),ae,ze)},registerInlineEditProvider(x,ae){return(0,Xe.$7F)(Le,"inlineEdit"),lt.registerInlineEditProvider(Le,$t(x),ae)},registerDocumentLinkProvider(x,ae){return lt.registerDocumentLinkProvider(Le,$t(x),ae)},registerColorProvider(x,ae){return lt.registerColorProvider(Le,$t(x),ae)},registerFoldingRangeProvider(x,ae){return lt.registerFoldingRangeProvider(Le,$t(x),ae)},registerSelectionRangeProvider(x,ae){return lt.registerSelectionRangeProvider(Le,x,ae)},registerCallHierarchyProvider(x,ae){return lt.registerCallHierarchyProvider(Le,x,ae)},registerTypeHierarchyProvider(x,ae){return lt.registerTypeHierarchyProvider(Le,x,ae)},setLanguageConfiguration:(x,ae)=>lt.setLanguageConfiguration(Le,x,ae),getTokenInformationAtPosition(x,ae){return(0,Xe.$7F)(Le,"tokenInformation"),Pt.tokenAtPosition(x,ae)},registerInlayHintsProvider(x,ae){return lt.registerInlayHintsProvider(Le,x,ae)},createLanguageStatusItem(x,ae){return Pt.createLanguageStatusItem(Le,x,ae)},registerDocumentDropEditProvider(x,ae,ze){return lt.registerDocumentOnDropEditProvider(Le,x,ae,(0,Xe.$6F)(Le,"dropMetadata")?ze:void 0)}},pn={get activeTextEditor(){return st.getActiveTextEditor()},get visibleTextEditors(){return st.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(x,ae,ze){d.URI.isUri(x)&&x.scheme===R.Schemas.vscodeRemote&&!x.authority&&It.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(d.URI.isUri(x)?Promise.resolve(an.openTextDocument(x)):Promise.resolve(x));return st.showTextDocument(ot,ae,ze)},createTextEditorDecorationType(x){return st.createTextEditorDecorationType(Le,x)},onDidChangeActiveTextEditor(x,ae,ze){return et(st.onDidChangeActiveTextEditor)(x,ae,ze)},onDidChangeVisibleTextEditors(x,ae,ze){return et(st.onDidChangeVisibleTextEditors)(x,ae,ze)},onDidChangeTextEditorSelection(x,ae,ze){return et(st.onDidChangeTextEditorSelection)(x,ae,ze)},onDidChangeTextEditorOptions(x,ae,ze){return et(st.onDidChangeTextEditorOptions)(x,ae,ze)},onDidChangeTextEditorVisibleRanges(x,ae,ze){return et(st.onDidChangeTextEditorVisibleRanges)(x,ae,ze)},onDidChangeTextEditorViewColumn(x,ae,ze){return et(st.onDidChangeTextEditorViewColumn)(x,ae,ze)},onDidCloseTerminal(x,ae,ze){return et(St.onDidCloseTerminal)(x,ae,ze)},onDidOpenTerminal(x,ae,ze){return et(St.onDidOpenTerminal)(x,ae,ze)},onDidChangeActiveTerminal(x,ae,ze){return et(St.onDidChangeActiveTerminal)(x,ae,ze)},onDidChangeTerminalDimensions(x,ae,ze){return(0,Xe.$7F)(Le,"terminalDimensions"),et(St.onDidChangeTerminalDimensions)(x,ae,ze)},onDidChangeTerminalState(x,ae,ze){return et(St.onDidChangeTerminalState)(x,ae,ze)},onDidWriteTerminalData(x,ae,ze){return(0,Xe.$7F)(Le,"terminalDataWriteEvent"),et(St.onDidWriteTerminalData)(x,ae,ze)},onDidExecuteTerminalCommand(x,ae,ze){return(0,Xe.$7F)(Le,"terminalExecuteCommandEvent"),et(St.onDidExecuteTerminalCommand)(x,ae,ze)},get state(){return Ft.getState(Le)},onDidChangeWindowState(x,ae,ze){return et(Ft.onDidChangeWindowState)(x,ae,ze)},showInformationMessage(x,...ae){return bi.showMessage(Le,m.default.Info,x,ae[0],ae.slice(1))},showWarningMessage(x,...ae){return bi.showMessage(Le,m.default.Warning,x,ae[0],ae.slice(1))},showErrorMessage(x,...ae){return bi.showMessage(Le,m.default.Error,x,ae[0],ae.slice(1))},showQuickPick(x,ae,ze){return $i.showQuickPick(Le,x,ae,ze)},showWorkspaceFolderPick(x){return $i.showWorkspaceFolderPick(x)},showInputBox(x,ae){return $i.showInput(x,ae)},showOpenDialog(x){return Oi.showOpenDialog(Le,x)},showSaveDialog(x){return Oi.showSaveDialog(x)},createStatusBarItem(x,ae,ze){let ot,vt,Rt;return typeof x=="string"?(ot=x,vt=ae,Rt=ze):(vt=x,Rt=ae),Di.createStatusBarEntry(Le,ot,vt,Rt)},setStatusBarMessage(x,ae){return Di.setStatusBarMessage(x,ae)},withScmProgress(x){return It.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Vi.withProgress(Le,{location:Ae.ProgressLocation.SourceControl},(ae,ze)=>x({report(ot){}}))},withProgress(x,ae){return Vi.withProgress(Le,x,ae)},createOutputChannel(x,ae){return ui.createOutputChannel(x,ae,Le)},createWebviewPanel(x,ae,ze,ot){return Ei.createWebviewPanel(Le,x,ae,ze,ot)},createWebviewTextEditorInset(x,ae,ze,ot){return(0,Xe.$7F)(Le,"editorInsets"),Kt.createWebviewEditorInset(x,ae,ze,ot,Le)},createTerminal(x,ae,ze){return typeof x=="object"?"pty"in x?St.createExtensionTerminal(x):St.createTerminalFromOptions(x):St.createTerminal(x,ae,ze)},registerTerminalLinkProvider(x){return St.registerLinkProvider(x)},registerTerminalProfileProvider(x,ae){return St.registerProfileProvider(Le,x,ae)},registerTerminalQuickFixProvider(x,ae){return(0,Xe.$7F)(Le,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(x,Le.identifier.value,ae)},registerTreeDataProvider(x,ae){return wt.registerTreeDataProvider(x,ae,Le)},createTreeView(x,ae){return wt.createTreeView(x,ae,Le)},registerWebviewPanelSerializer:(x,ae)=>Ei.registerWebviewPanelSerializer(Le,x,ae),registerCustomEditorProvider:(x,ae,ze={})=>Hi.registerCustomEditorProvider(Le,x,ae,ze),registerFileDecorationProvider(x){return Lt.registerFileDecorationProvider(x,Le)},registerUriHandler(x){return Yt.registerUriHandler(Le,x)},createQuickPick(){return $i.createQuickPick(Le)},createInputBox(){return $i.createInputBox(Le)},get activeColorTheme(){return yi.activeColorTheme},onDidChangeActiveColorTheme(x,ae,ze){return et(yi.onDidChangeActiveColorTheme)(x,ae,ze)},registerWebviewViewProvider(x,ae,ze){return Ki.registerWebviewViewProvider(Le,x,ae,ze?.webviewOptions)},get activeNotebookEditor(){return oe.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,ae,ze){return et(oe.onDidChangeActiveNotebookEditor)(x,ae,ze)},get visibleNotebookEditors(){return oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,ae,ze){return et(Ee.onDidChangeNotebookEditorSelection)(x,ae,ze)},onDidChangeNotebookEditorVisibleRanges(x,ae,ze){return et(Ee.onDidChangeNotebookEditorVisibleRanges)(x,ae,ze)},showNotebookDocument(x,ae){return oe.showNotebookDocument(x,ae)},registerExternalUriOpener(x,ae,ze){return(0,Xe.$7F)(Le,"externalUriOpener"),Gi.registerExternalUriOpener(Le.identifier,x,ae,ze)},registerProfileContentHandler(x,ae){return(0,Xe.$7F)(Le,"profileContentHandlers"),gn.registerProfileContentHandler(Le,x,ae)},registerQuickDiffProvider(x,ae,ze,ot){return(0,Xe.$7F)(Le,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(x),ae,ze,ot)},get tabGroups(){return Ht.tabGroups},registerShareProvider(x,ae){return(0,Xe.$7F)(Le,"shareProvider"),Mi.registerShareProvider($t(x),ae)}},an={get rootPath(){return It.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(x){throw new F.$9("rootPath")},getWorkspaceFolder(x){return ft.getWorkspaceFolder(x)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(x){throw new F.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(x){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(x,ae,...ze)=>ft.updateWorkspaceFolders(Le,x,ae||0,...ze),onDidChangeWorkspaceFolders:function(x,ae,ze){return et(ft.onDidChangeWorkspace)(x,ae,ze)},asRelativePath:(x,ae)=>ft.getRelativePath(x,ae),findFiles:(x,ae,ze,ot)=>ft.findFiles(x,ae,ze,Le.identifier,ot),findFiles2:(x,ae,ze)=>((0,Xe.$7F)(Le,"findFiles2"),ft.findFiles2(x,ae,Le.identifier,ze)),findTextInFiles:(x,ae,ze,ot)=>{(0,Xe.$7F)(Le,"findTextInFiles");let vt,Rt;return typeof ae=="object"?(vt=ae,Rt=ze):(vt={},Rt=ae,ot=ze),ft.findTextInFiles(x,vt||{},Rt,Le.identifier,ot)},save:x=>ft.save(x),saveAs:x=>ft.saveAs(x),saveAll:x=>ft.saveAll(x),applyEdit(x,ae){return _i.applyWorkspaceEdit(x,Le,ae)},createFileSystemWatcher:(x,ae,ze,ot)=>{let vt;return typeof ae=="boolean"?vt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ot,correlate:!1}:ae&&((0,Xe.$7F)(Le,"createFileSystemWatcher"),vt={...ae,correlate:!0}),gi.createFileSystemWatcher(ft,Le,x,vt)},get textDocuments(){return Ct.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new F.$9("textDocuments")},openTextDocument(x){let ae;const ze=x;if(typeof x=="string")ae=Promise.resolve(d.URI.file(x));else if(d.URI.isUri(x))ae=Promise.resolve(x);else if(!ze||typeof ze=="object")ae=Ct.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(ot=>(ot.scheme===R.Schemas.vscodeRemote&&!ot.authority&&It.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Ct.ensureDocumentData(ot).then(vt=>vt.document)))},onDidOpenTextDocument:(x,ae,ze)=>et(Ct.onDidAddDocument)(x,ae,ze),onDidCloseTextDocument:(x,ae,ze)=>et(Ct.onDidRemoveDocument)(x,ae,ze),onDidChangeTextDocument:(x,ae,ze)=>et(Ct.onDidChangeDocument)(x,ae,ze),onDidSaveTextDocument:(x,ae,ze)=>et(Ct.onDidSaveDocument)(x,ae,ze),onWillSaveTextDocument:(x,ae,ze)=>et(Fe.getOnWillSaveTextDocumentEvent(Le))(x,ae,ze),get notebookDocuments(){return oe.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,ae){let ze;if(d.URI.isUri(x))ze=x,await oe.openNotebookDocument(x);else if(typeof x=="string")ze=d.URI.revive(await oe.createNotebookDocument({viewType:x,content:ae}));else throw new Error("Invalid arguments");return oe.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(x,ae,ze){return et(Q.onDidSaveNotebookDocument)(x,ae,ze)},onDidChangeNotebookDocument(x,ae,ze){return et(Q.onDidChangeNotebookDocument)(x,ae,ze)},onWillSaveNotebookDocument(x,ae,ze){return et(Ke.getOnWillSaveNotebookDocumentEvent(Le))(x,ae,ze)},get onDidOpenNotebookDocument(){return et(oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(oe.onDidCloseNotebookDocument)},registerNotebookSerializer(x,ae,ze,ot){return oe.registerNotebookSerializer(Le,x,ae,ze,(0,Xe.$6F)(Le,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(x,ae,ze)=>et(en.onDidChangeConfiguration)(x,ae,ze),getConfiguration(x,ae){return ae=arguments.length===1?void 0:ae,en.getConfiguration(x,ae,Le)},registerTextDocumentContentProvider(x,ae){return we.registerTextDocumentContentProvider(x,ae)},registerTaskProvider:(x,ae)=>(It.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),ei.registerTaskProvider(Le,x,ae)),registerFileSystemProvider(x,ae,ze){return(0,N.$Rc)(Ci.registerFileSystemProvider(Le,x,ae,ze),Bt.addFileSystemProvider(x,ae,ze))},get fs(){return Bt.value},registerFileSearchProvider:(x,ae)=>((0,Xe.$7F)(Le,"fileSearchProvider"),ci.registerFileSearchProvider(x,ae)),registerTextSearchProvider:(x,ae)=>((0,Xe.$7F)(Le,"textSearchProvider"),ci.registerTextSearchProvider(x,ae)),registerAITextSearchProvider:(x,ae)=>((0,Xe.$7F)(Le,"aiTextSearchProvider"),(0,Xe.$7F)(Le,"textSearchProvider"),ci.registerAITextSearchProvider(x,ae)),registerRemoteAuthorityResolver:(x,ae)=>((0,Xe.$7F)(Le,"resolvers"),Wt.registerRemoteAuthorityResolver(x,ae)),registerResourceLabelFormatter:x=>((0,Xe.$7F)(Le,"resolvers"),qi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Xe.$7F)(Le,"resolvers"),Wt.getRemoteExecServer(x)),onDidCreateFiles:(x,ae,ze)=>et(gi.onDidCreateFile)(x,ae,ze),onDidDeleteFiles:(x,ae,ze)=>et(gi.onDidDeleteFile)(x,ae,ze),onDidRenameFiles:(x,ae,ze)=>et(gi.onDidRenameFile)(x,ae,ze),onWillCreateFiles:(x,ae,ze)=>et(gi.getOnWillCreateFileEvent(Le))(x,ae,ze),onWillDeleteFiles:(x,ae,ze)=>et(gi.getOnWillDeleteFileEvent(Le))(x,ae,ze),onWillRenameFiles:(x,ae,ze)=>et(gi.getOnWillRenameFileEvent(Le))(x,ae,ze),openTunnel:x=>((0,Xe.$7F)(Le,"tunnels"),At.openTunnel(Le,x).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Xe.$7F)(Le,"tunnels"),At.getTunnels()},onDidChangeTunnels:(x,ae,ze)=>((0,Xe.$7F)(Le,"tunnels"),et(At.onDidChangeTunnels)(x,ae,ze)),registerPortAttributesProvider:(x,ae)=>((0,Xe.$7F)(Le,"portsAttributes"),At.registerPortsAttributesProvider(x,ae)),registerTunnelProvider:(x,ae)=>((0,Xe.$7F)(Le,"tunnelFactory"),At.registerTunnelProvider(x,ae)),registerTimelineProvider:(x,ae)=>((0,Xe.$7F)(Le,"timeline"),Ri.registerTimelineProvider(x,ae,Le.identifier,yt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:x=>((0,Xe.$7F)(Le,"workspaceTrust"),ft.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,ae,ze)=>et(ft.onDidGrantWorkspaceTrust)(x,ae,ze),registerEditSessionIdentityProvider:(x,ae)=>((0,Xe.$7F)(Le,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(x,ae)),onWillCreateEditSessionIdentity:(x,ae,ze)=>((0,Xe.$7F)(Le,"editSessionIdentityProvider"),et(ft.getOnWillCreateEditSessionIdentityEvent(Le))(x,ae,ze)),registerCanonicalUriProvider:(x,ae)=>((0,Xe.$7F)(Le,"canonicalUriProvider"),ft.registerCanonicalUriProvider(x,ae)),getCanonicalUri:(x,ae,ze)=>((0,Xe.$7F)(Le,"canonicalUriProvider"),ft.provideCanonicalUri(x,ae,ze))},cn={get inputBox(){return It.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Le)},createSourceControl(x,ae,ze){return wi.createSourceControl(Le,x,ae,ze)}},Ti={createCommentController(x,ae){return Wi.createCommentController(Le,x,ae)}},un={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Xe.$6F)(Le,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(x,ae){return(0,Xe.$7F)(Le,"debugVisualization"),kt.registerDebugVisualizationProvider(Le,x,ae)},registerDebugVisualizationTreeProvider(x,ae){return(0,Xe.$7F)(Le,"debugVisualization"),kt.registerDebugVisualizationTree(Le,x,ae)},onDidStartDebugSession(x,ae,ze){return et(kt.onDidStartDebugSession)(x,ae,ze)},onDidTerminateDebugSession(x,ae,ze){return et(kt.onDidTerminateDebugSession)(x,ae,ze)},onDidChangeActiveDebugSession(x,ae,ze){return et(kt.onDidChangeActiveDebugSession)(x,ae,ze)},onDidReceiveDebugSessionCustomEvent(x,ae,ze){return et(kt.onDidReceiveDebugSessionCustomEvent)(x,ae,ze)},onDidChangeBreakpoints(x,ae,ze){return et(kt.onDidChangeBreakpoints)(x,ae,ze)},onDidChangeActiveStackItem(x,ae,ze){return(0,Xe.$7F)(Le,"debugFocus"),et(kt.onDidChangeActiveStackItem)(x,ae,ze)},registerDebugConfigurationProvider(x,ae,ze){return kt.registerDebugConfigurationProvider(x,ae,ze||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,ae){return kt.registerDebugAdapterDescriptorFactory(Le,x,ae)},registerDebugAdapterTrackerFactory(x,ae){return kt.registerDebugAdapterTrackerFactory(x,ae)},startDebugging(x,ae,ze){return!ze||typeof ze=="object"&&"configuration"in ze?kt.startDebugging(x,ae,{parentSession:ze}):kt.startDebugging(x,ae,ze||{})},stopDebugging(x){return kt.stopDebugging(x)},addBreakpoints(x){return kt.addBreakpoints(x)},removeBreakpoints(x){return kt.removeBreakpoints(x)},asDebugSourceUri(x,ae){return kt.asDebugSourceUri(x,ae)}},ln={registerTaskProvider:(x,ae)=>ei.registerTaskProvider(Le,x,ae),fetchTasks:x=>ei.fetchTasks(x),executeTask:x=>ei.executeTask(Le,x),get taskExecutions(){return ei.taskExecutions},onDidStartTask:(x,ae,ze)=>et(ei.onDidStartTask)(x,ae,ze),onDidEndTask:(x,ae,ze)=>et(ei.onDidEndTask)(x,ae,ze),onDidStartTaskProcess:(x,ae,ze)=>et(ei.onDidStartTaskProcess)(x,ae,ze),onDidEndTaskProcess:(x,ae,ze)=>et(ei.onDidEndTaskProcess)(x,ae,ze)},hn={createNotebookController(x,ae,ze,ot,vt){return Ue.createNotebookController(Le,x,ae,ze,ot,(0,Xe.$6F)(Le,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(x,ae)=>oe.registerNotebookCellStatusBarItemProvider(Le,x,ae),createRendererMessaging(x){return Ye.createRendererMessaging(Le,x)},createNotebookControllerDetectionTask(x){return(0,Xe.$7F)(Le,"notebookKernelSource"),Ue.createNotebookControllerDetectionTask(Le,x)},registerKernelSourceActionProvider(x,ae){return(0,Xe.$7F)(Le,"notebookKernelSource"),Ue.registerKernelSourceActionProvider(Le,x,ae)},onDidChangeNotebookCellExecutionState(x,ae,ze){return(0,Xe.$7F)(Le,"notebookCellExecutionState"),et(Ue.onDidChangeNotebookCellExecutionState)(x,ae,ze)}},vn={t(...x){if(typeof x[0]=="string"){const ae=x.shift(),ze=!x||typeof x[0]!="object"?x:x[0];return di.getMessage(Le.identifier.value,{message:ae,args:ze})}return di.getMessage(Le.identifier.value,x[0])},get bundle(){return di.getBundle(Le.identifier.value)},get uri(){return di.getBundleUri(Le.identifier.value)}},bn={_version:1,registerInteractiveEditorSessionProvider(x,ae){return(0,Xe.$7F)(Le,"interactive"),mn.registerProvider(Le,x,ae)},registerInteractiveSessionProvider(x,ae){return(0,Xe.$7F)(Le,"interactive"),Ji.registerChatProvider(Le,x,ae)},transferChatSession(x,ae){return(0,Xe.$7F)(Le,"interactive"),Ji.transferChatSession(x,ae)}},dn={getRelatedInformation(x,ae){return(0,Xe.$7F)(Le,"aiRelatedInformation"),Qi.getRelatedInformation(Le,x,ae)},registerRelatedInformationProvider(x,ae){return(0,Xe.$7F)(Le,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Le,x,ae)},registerEmbeddingVectorProvider(x,ae){return(0,Xe.$7F)(Le,"aiRelatedInformation"),Zi.registerEmbeddingVectorProvider(Le,x,ae)}},fn={registerChatResponseProvider(x,ae,ze){return(0,Xe.$7F)(Le,"chatProvider"),Ot.registerLanguageModel(Le,x,ae,ze)},registerChatVariableResolver(x,ae,ze){return(0,Xe.$7F)(Le,"chatVariableResolver"),Fi.registerVariableResolver(Le,x,ae,ze)},registerMappedEditsProvider(x,ae){return(0,Xe.$7F)(Le,"mappedEditsProvider"),lt.registerMappedEditsProvider(Le,x,ae)},createChatParticipant(x,ae){return(0,Xe.$7F)(Le,"chatParticipant"),Ai.createChatAgent(Le,x,ae)}},Li={get languageModels(){return(0,Xe.$7F)(Le,"languageModels"),Ot.getLanguageModelIds()},onDidChangeLanguageModels:(x,ae,ze)=>((0,Xe.$7F)(Le,"languageModels"),Ot.onDidChangeProviders(x,ae,ze)),sendChatRequest(x,ae,ze,ot){return(0,Xe.$7F)(Le,"languageModels"),Ot.sendChatRequest(Le,x,ae,ze,ot)}},ji={registerSpeechProvider(x,ae){return(0,Xe.$7F)(Le,"speech"),Yi.registerProvider(Le.identifier,x,ae)}};return{version:pt.version,ai:dn,authentication:tn,commands:nn,comments:Ti,chat:fn,debug:un,env:Ni,extensions:sn,interactive:bn,l10n:vn,languages:on,lm:Li,notebooks:hn,scm:cn,speech:ji,tasks:ln,tests:rn,window:pn,workspace:an,Breakpoint:Ae.$kN,TerminalOutputAnchor:Ae.TerminalOutputAnchor,ChatResultFeedbackKind:Ae.ChatResultFeedbackKind,ChatVariableLevel:Ae.ChatVariableLevel,ChatCompletionItem:Ae.$dO,CallHierarchyIncomingCall:Ae.$IM,CallHierarchyItem:Ae.$HM,CallHierarchyOutgoingCall:Ae.$JM,CancellationError:F.$5,CancellationTokenSource:I.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Ae.$EM,CodeActionKind:Ae.$FM,CodeActionTriggerKind:Ae.CodeActionTriggerKind,CodeLens:Ae.$KM,Color:Ae.$XM,ColorInformation:Ae.$YM,ColorPresentation:Ae.$ZM,ColorThemeKind:Ae.ColorThemeKind,CommentMode:Ae.CommentMode,CommentState:Ae.CommentState,CommentThreadCollapsibleState:Ae.CommentThreadCollapsibleState,CommentThreadState:Ae.CommentThreadState,CommentThreadApplicability:Ae.CommentThreadApplicability,CompletionItem:Ae.$RM,CompletionItemKind:Ae.CompletionItemKind,CompletionItemTag:Ae.CompletionItemTag,CompletionList:Ae.$SM,CompletionTriggerKind:Ae.CompletionTriggerKind,ConfigurationTarget:Ae.ConfigurationTarget,CustomExecution:Ae.$8M,DebugAdapterExecutable:Ae.$oN,DebugAdapterInlineImplementation:Ae.$rN,DebugAdapterNamedPipeServer:Ae.$qN,DebugAdapterServer:Ae.$pN,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ae.DebugConsoleMode,DebugVisualization:Ae.$HN,DecorationRangeBehavior:Ae.DecorationRangeBehavior,Diagnostic:Ae.$yM,DiagnosticRelatedInformation:Ae.$xM,DiagnosticSeverity:Ae.DiagnosticSeverity,DiagnosticTag:Ae.DiagnosticTag,Disposable:Ae.$kM,DocumentHighlight:Ae.$AM,DocumentHighlightKind:Ae.DocumentHighlightKind,MultiDocumentHighlight:Ae.$BM,DocumentLink:Ae.$WM,DocumentSymbol:Ae.$DM,EndOfLine:Ae.EndOfLine,EnvironmentVariableMutatorType:Ae.EnvironmentVariableMutatorType,EvaluatableExpression:Ae.$uN,InlineValueText:Ae.$vN,InlineValueVariableLookup:Ae.$wN,InlineValueEvaluatableExpression:Ae.$xN,InlineCompletionTriggerKind:Ae.InlineCompletionTriggerKind,EventEmitter:M.$7d,ExtensionKind:Ae.ExtensionKind,ExtensionMode:Ae.ExtensionMode,ExternalUriOpenerPriority:Ae.ExternalUriOpenerPriority,FileChangeType:Ae.FileChangeType,FileDecoration:Ae.$JN,FileDecoration2:Ae.$JN,FileSystemError:Ae.$AN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:Ae.$BN,FoldingRangeKind:Ae.FoldingRangeKind,FunctionBreakpoint:Ae.$mN,InlineCompletionItem:Ae.$TM,InlineCompletionList:Ae.$UM,Hover:Ae.$zM,IndentAction:E.IndentAction,Location:Ae.$wM,MarkdownString:Ae.$LM,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Ae.$MM,PortAutoForwardAction:Ae.PortAutoForwardAction,Position:Ae.$lM,ProcessExecution:Ae.$6M,ProgressLocation:Ae.ProgressLocation,QuickInputButtons:Ae.$IN,Range:Ae.$mM,RelativePattern:Ae.$iN,Selection:Ae.$nM,SelectionRange:Ae.$GM,SemanticTokens:Ae.$EN,SemanticTokensBuilder:Ae.$DN,SemanticTokensEdit:Ae.$FN,SemanticTokensEdits:Ae.$GN,SemanticTokensLegend:Ae.$CN,ShellExecution:Ae.$7M,ShellQuoting:Ae.ShellQuoting,SignatureHelp:Ae.$OM,SignatureHelpTriggerKind:Ae.SignatureHelpTriggerKind,SignatureInformation:Ae.$NM,SnippetString:Ae.$vM,SourceBreakpoint:Ae.$lN,StandardTokenType:Ae.StandardTokenType,StatusBarAlignment:Ae.StatusBarAlignment,SymbolInformation:Ae.$CM,SymbolKind:Ae.SymbolKind,SymbolTag:Ae.SymbolTag,Task:Ae.$9M,TaskGroup:Ae.$5M,TaskPanelKind:Ae.TaskPanelKind,TaskRevealKind:Ae.TaskRevealKind,TaskScope:Ae.TaskScope,TerminalLink:Ae.$1M,TerminalQuickFixTerminalCommand:Ae.$3M,TerminalQuickFixOpener:Ae.$2M,TerminalLocation:Ae.TerminalLocation,TerminalProfile:Ae.$4M,TerminalExitReason:Ae.TerminalExitReason,TextDocumentSaveReason:Ae.TextDocumentSaveReason,TextEdit:Ae.$rM,SnippetTextEdit:Ae.$tM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ae.TextEditorLineNumbersStyle,TextEditorRevealType:Ae.TextEditorRevealType,TextEditorSelectionChangeKind:Ae.TextEditorSelectionChangeKind,SyntaxTokenType:Ae.SyntaxTokenType,TextDocumentChangeReason:Ae.TextDocumentChangeReason,ThemeColor:Ae.$hN,ThemeIcon:Ae.$gN,TreeItem:Ae.$0M,TreeItemCheckboxState:Ae.TreeItemCheckboxState,TreeItemCollapsibleState:Ae.TreeItemCollapsibleState,TypeHierarchyItem:Ae.$5N,UIKind:ti.UIKind,Uri:d.URI,ViewColumn:Ae.ViewColumn,WorkspaceEdit:Ae.$uM,DocumentPasteTriggerKind:Ae.DocumentPasteTriggerKind,DocumentDropEdit:Ae.$dN,DocumentPasteEditKind:Ae.$eN,DocumentPasteEdit:Ae.$fN,InlayHint:Ae.$QM,InlayHintLabelPart:Ae.$PM,InlayHintKind:Ae.InlayHintKind,RemoteAuthorityResolverError:Ae.$qM,ResolvedAuthority:Ae.$oM,ManagedResolvedAuthority:Ae.$pM,SourceControlInputBoxValidationType:Ae.SourceControlInputBoxValidationType,ExtensionRuntime:Ae.ExtensionRuntime,TimelineItem:Ae.$TN,NotebookRange:Ae.$LN,NotebookCellKind:Ae.NotebookCellKind,NotebookCellExecutionState:Ae.NotebookCellExecutionState,NotebookCellData:Ae.$MN,NotebookData:Ae.$NN,NotebookRendererScript:Ae.$RN,NotebookCellStatusBarAlignment:Ae.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ae.NotebookEditorRevealType,NotebookCellOutput:Ae.$PN,NotebookCellOutputItem:Ae.$ON,NotebookCellStatusBarItem:Ae.$QN,NotebookControllerAffinity:Ae.NotebookControllerAffinity,NotebookControllerAffinity2:Ae.NotebookControllerAffinity2,NotebookEdit:Ae.$sM,NotebookKernelSourceAction:Ae.$SN,NotebookVariablesRequestKind:Ae.NotebookVariablesRequestKind,PortAttributes:Ae.$VN,LinkedEditingRanges:Ae.$UN,TestResultState:Ae.TestResultState,TestRunRequest:Ae.$WN,TestMessage:Ae.$XN,TestTag:Ae.$YN,TestRunProfileKind:Ae.TestRunProfileKind,TextSearchCompleteMessageType:xt.TextSearchCompleteMessageType,DataTransfer:Ae.$cN,DataTransferItem:Ae.$$M,CoveredCount:Ae.$ZN,FileCoverage:Ae.$1N,StatementCoverage:Ae.$2N,BranchCoverage:Ae.$3N,DeclarationCoverage:Ae.$4N,FunctionCoverage:Ae.$4N,WorkspaceTrustState:Ae.WorkspaceTrustState,LanguageStatusSeverity:Ae.LanguageStatusSeverity,QuickPickItemKind:Ae.QuickPickItemKind,InputBoxValidationSeverity:Ae.InputBoxValidationSeverity,TabInputText:Ae.$6N,TabInputTextDiff:Ae.$7N,TabInputTextMerge:Ae.$8N,TabInputCustom:Ae.$9N,TabInputNotebook:Ae.$$N,TabInputNotebookDiff:Ae.$_N,TabInputWebview:Ae.$0N,TabInputTerminal:Ae.$aO,TabInputInteractiveWindow:Ae.$bO,TabInputChat:Ae.$cO,TelemetryTrustedValue:s.$3o,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ae.InteractiveSessionVoteDirection,ChatCopyKind:Ae.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ae.InteractiveEditorResponseFeedbackKind,StackFrame:Ae.$sN,Thread:Ae.$tN,RelatedInformationType:Ae.RelatedInformationType,SpeechToTextStatus:Ae.SpeechToTextStatus,PartialAcceptTriggerKind:Ae.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ae.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ae.$eO,ChatResponseFileTreePart:Ae.$fO,ChatResponseAnchorPart:Ae.$gO,ChatResponseProgressPart:Ae.$hO,ChatResponseReferencePart:Ae.$jO,ChatResponseCommandButtonPart:Ae.$iO,ChatRequestTurn:Ae.$kO,ChatResponseTurn:Ae.$lO,ChatLocation:Ae.ChatLocation,LanguageModelChatSystemMessage:Ae.$mO,LanguageModelChatUserMessage:Ae.$nO,LanguageModelChatAssistantMessage:Ae.$oO,LanguageModelSystemMessage:Ae.$mO,LanguageModelUserMessage:Ae.$nO,LanguageModelAssistantMessage:Ae.$oO,LanguageModelError:Ae.$pO,NewSymbolName:Ae.$zN,NewSymbolNameTag:Ae.NewSymbolNameTag,InlineEdit:Ae.$qO,InlineEditTriggerKind:Ae.InlineEditTriggerKind}}}}),define(Pe[298],Me([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,44,81,61,65,236,13,119,79,80,84,88]),function(me,e,I,F,M,N,R,m,d,k,O,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$fs)($.$Hjc,$.$Gjc,1),(0,I.$fs)(v.$Oj,t.$Tkc,1),(0,I.$fs)(r.$Lic,r.$Mic,1),(0,I.$fs)(m.$YO,m.$XO,0),(0,I.$fs)(p.$Vic,p.$Wic,0),(0,I.$fs)(l.$1ic,l.$2ic,0),(0,I.$fs)(R.$bjc,R.$_ic,0),(0,I.$fs)(s.$djc,s.$cjc,0),(0,I.$fs)(E.$Rjc,E.$Vjc,0),(0,I.$fs)(N.$Xjc,N.$Wjc,0),(0,I.$fs)(d.$NO,d.$MO,0),(0,I.$fs)(w.$Ijc,w.$Jjc,0),(0,I.$fs)(n.$Pic,n.$Oic,0),(0,I.$fs)(F.$rkc,F.$qkc,1),(0,I.$fs)(u.$bkc,u.$ckc,0),(0,I.$fs)(b.$wjc,b.$vjc,0),(0,I.$fs)(O.$Ekc,O.$Dkc,0),(0,I.$fs)(k.$zjc,k.$Cjc,0),(0,I.$fs)(f.$eBb,f.$fBb,0),(0,I.$fs)(o.$Rkc,o.$Qkc,0),(0,I.$fs)(M.$$ic,M.$0ic,0),(0,I.$fs)(i.$Ejc,i.$Djc,0),(0,I.$fs)(a.$WO,a.$TO,0),(0,I.$fs)(h.$njc,h.$ojc,0),(0,I.$fs)(c.$Pjc,c.$Qjc,0)}),define(Pe[299],Me([1,0,297,38,2,294,7,11,242]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;class k extends N.$Wkc{j(){}getModule(b,f){for(const r of this.b){const o=r(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends F.$Ljc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async ub(){this.h.createInstance(d.$3mc);const b=this.h.invokeFunction(I.$Skc);this.r=this.h.createInstance(k,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Ab()}vb(b){return b.browser}async wb(b,f,r){f=f.with({path:E(f.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=M.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),a=`${f.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(w){throw console.error(o?`Loading code for extension ${o} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${f.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const v={},c={exports:v},$=w=>{const p=this.r.getModule(w,f);if(p===void 0)throw new Error(`Cannot load module '${w}'`);return p};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,v,$),c.exports!==v?c.exports:v}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Ab(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,m.$ih)(10)}}e.$4mc=O;function E(u,b){return u.endsWith(b)?u:u+b}}),define(Pe[300],Me([1,0,70,54,13,38,205,85,299]),function(me,e,I,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$fs)(M.$Nj,new I.$ei(R.$Vkc,[!0],!0)),(0,F.$fs)(N.$Mjc,d.$4mc,0),(0,F.$fs)(m.$ejc,m.$fjc,0)}),define(Pe[306],Me([1,0,23,5,77,295,244,19,89,12,2,298,300]),function(me,e,I,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function r(t){self.fetch=async function(v,c){return v instanceof Request||b(String(v))&&(v=(await t(O.URI.parse(String(v)))).toString(!0)),f(v,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,c,$,w,p){(async()=>(b(c.toString())&&(c=(await t(O.URI.parse(c.toString()))).toString(!0)),super.open(v,c,$??!0,w,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(v,c){if(/^file:/i.test(v.toString()))v=k.$Bg.uriToBrowserUri(O.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(g){function S(A){return typeof A=="string"||A instanceof URL?String(A).replace(/^file:\/\//i,"vscode-file://vscode-app"):A}const y=fetch.bind(self);self.fetch=function(A,G){return A instanceof Request?y(A,G):y(S(A),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(A,G,T,W,P){return super.open(A,S(G),T??!0,W,P)}};const C=importScripts.bind(self);self.importScripts=(...A)=>{C(...A.map(S))},C(g)}.toString()}('${v}'))`;c=c||{},c.name=`${name} -> ${c.name||m.$oc(v.toString())}`;const p=new Blob([w],{type:"application/javascript"}),l=URL.createObjectURL(p);return new t(l,c)}}else self.Worker=class extends R.$5mc{constructor(t,v){super(u,t,{name:m.$oc(t.toString()),...v})}};const o=new class{constructor(){this.pid=void 0}exit(t){E()}};class s{constructor(){const v=new MessageChannel,c=new F.$7d;let $=!1;u(v.port2,[v.port2]),v.port1.onmessage=w=>{const{data:p}=w;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const l=I.$ue.wrap(new Uint8Array(p,0,p.byteLength));if((0,M.$Lm)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:w=>{if(!$){const p=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);v.port1.postMessage(p,[p])}}}}}function n(t){return new Promise(v=>{const c=t.onMessage($=>{c.dispose();const w=JSON.parse($.toString());t.send((0,M.$Km)(0)),v({protocol:t,initData:w})});t.send((0,M.$Km)(1))})}let i=t=>E();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(v){a(v)&&n(t.protocol).then(c=>{d.mark("code/extHost/didWaitForInitData");const $=new N.$Ykc(c.protocol,c.initData,o,null,v.data);r(w=>$.asBrowserUri(w)),i=w=>$.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/99a19815253d91900be5ec1016e0ecc7cc9a6950/core/vs/workbench/api/worker/extensionHostWorker.js.map
